/*
 * HISTORY
 * $Log: UCS_zb_data.c,v $
 * Revision 1.1.4.1  2001/12/07  15:36:18
 *  * Initial submission of traditional Chinese (BIG-5 & HKSCS)
 *  * conversion tables.
 *
 * $EndLog$
 */

/**********************************************************************
// @@@ START COPYRIGHT @@@
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//
// @@@ END COPYRIGHT @@@
**********************************************************************/

#ifndef USE_OUR_MB_WC_DATA_TABLES

/********************************************************************
 * Data for mapping between BChinese code sets and Unicode
 * This file is software-generated.  Do not manually edit it.
 ********************************************************************/

#include "fcconv.h"

#define _big5_to_ucs_cell2	_zb_to_ucs_cell2
#define _big5_to_ucs_cell4	NULL
#define _hkscs_to_ucs_cell2	_zb_to_ucs_cell2
#define _hkscs_to_ucs_cell4	_zb_to_ucs_cell4

#define _ucs_to_big5_cell2	_ucs_to_zb_cell2
#define _ucs_to_big5_cell4	NULL
#define _ucs_to_hkscs_cell2	_ucs_to_zb_cell2
#define _ucs_to_hkscs_cell4	NULL

/* Row table for mapping big5 to Unicode */

#define	big5_to_ucs_DMAP	1
static row_t _big5_to_ucs_row[] = {
/* 000 */  0x000,  0x001,  0x002,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 008 */  0x003,  0x004,  0x005,  0x006,  0x007,  0x008,  0x009,  0x00a,
/* 010 */  0x00b,  0x00c,  0x00d,  0x00e,  0x00f,  0x010,  0x011,  0x012,
/* 018 */  0x013,  0x014,  0x015,  0x016,  0x017,  0x018,  0x019,  0x01a,
/* 020 */  0x01b,  0x01c,  0x01d,  0x01e,  0x01f,  0x020,  0x021,  0x022,
/* 028 */  0x023,  0x024,  0x025,  0x026,  0x027,  0x028,  0x029,  0x02a,
/* 030 */  0x02b,  0x02c,  0x02d,  0x02e,  0x02f,  0x030,  0x031,  0x032,
/* 038 */  0x033,  0x034,  0x035,  0x036,  0x037,  0x038,  0x039,  0x03a,
/* 040 */  0x03b,  0x03c,  0x03d,  0x03e,  0x03f,  0x040,  0x041,  0x042,
/* 048 */  0x043,  0x044,  0x045,  0x046,  0x047,  0x048,  0x049,  0x04a,
/* 050 */  0x04b,  0x04c,  0x04d,  0x04e,  0x04f,  0x050,  0x051,  0x052,
/* 058 */  0x053,  0x054,  0x055,  0x056,  0x057,  0x058,  0x059,  0x05a,
/* 060 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 068 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 070 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 078 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 080 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 088 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 090 */    BAD,    BAD,    BAD,    BAD,  0x05b,  0x05c,  0x05d,  0x05e,
/* 098 */  0x05f,  0x060,  0x061,  0x062,  0x063,  0x064,  0x065,  0x066,
/* 0a0 */  0x067,  0x068,  0x069,  0x06a,  0x06b,  0x06c,  0x06d,  0x06e,
/* 0a8 */  0x06f,  0x070,  0x071,  0x072,  0x073,  0x074,  0x075,  0x076,
/* 0b0 */  0x077,  0x078,  0x079,  0x07a,  0x07b,  0x07c,  0x07d,  0x07e,
/* 0b8 */  0x07f,  0x080,  0x081,  0x082,  0x083,  0x084,  0x085,  0x086,
/* 0c0 */  0x087,  0x088,  0x089,  0x08a,  0x08b,  0x08c,  0x08d,  0x08e,
/* 0c8 */  0x08f,  0x090,  0x091,  0x092,  0x093,  0x094,  0x095,  0x096,
/* 0d0 */  0x097,  0x098,  0x099,  0x09a,  0x09b,  0x09c,  0x09d,  0x09e,
/* 0d8 */  0x09f,  0x0a0,  0x0a1,  0x0a2,  0x0a3,  0x0a4,  0x0a5,  0x0a6,
/* 0e0 */  0x0a7,  0x0a8,  0x0a9,  0x0aa,  0x0ab,  0x0ac,  0x0ad,  0x0ae,
/* 0e8 */  0x0af,  0x0b0,  0x0b1,  0x0b2,  0x0b3,  0x0b4,  0x0b5,  0x0b6,
/* 0f0 */  0x0b7,  0x0b8,  0x0b9,  0x0ba,  0x0bb,  0x0bc,  0x0bd,  0x0be,
/* 0f8 */  0x0bf,  0x0c0,  0x0c1,  0x0c2,  0x0c3,  0x0c4,  0x0c5,  0x0c6,
/* 100 */  0x0c7,  0x0c8,  0x0c9,  0x0ca,  0x0cb,  0x0cc,  0x0cd,  0x0ce,
/* 108 */  0x0cf,  0x0d0,  0x0d1,  0x0d2,  0x0d3,  0x0d4,  0x0d5,  0x0d6,
/* 110 */  0x0d7,  0x0d8,  0x0d9,  0x0da,  0x0db,  0x0dc,  0x0dd
};

/* Row table for mapping hkscs to Unicode */

#define	hkscs_to_ucs_DMAP	1
static row_t _hkscs_to_ucs_row[] = {
/* 000 */  0x000,  0x001,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 008 */  0x0de,  0x0df,  0x005,  0x006,  0x007,  0x008,  0x009,  0x00a,
/* 010 */  0x00b,  0x00c,  0x00d,  0x00e,  0x00f,  0x010,  0x011,  0x012,
/* 018 */  0x013,  0x014,  0x015,  0x016,  0x017,  0x018,  0x019,  0x01a,
/* 020 */  0x01b,  0x01c,  0x01d,  0x01e,  0x01f,  0x020,  0x021,  0x0e0,
/* 028 */  0x023,  0x024,  0x025,  0x026,  0x027,  0x0e1,  0x0e2,  0x0e3,
/* 030 */  0x02b,  0x02c,  0x02d,  0x02e,  0x02f,  0x030,  0x031,  0x032,
/* 038 */  0x033,  0x034,  0x035,  0x036,  0x037,  0x038,  0x039,  0x03a,
/* 040 */  0x03b,  0x03c,  0x03d,  0x03e,  0x03f,  0x040,  0x041,  0x042,
/* 048 */  0x043,  0x044,  0x045,  0x046,  0x047,  0x048,  0x049,  0x04a,
/* 050 */  0x04b,  0x04c,  0x04d,  0x04e,  0x04f,  0x050,  0x051,  0x052,
/* 058 */  0x053,  0x054,  0x055,  0x056,  0x057,  0x058,  0x059,  0x800,
/* 060 */  0x801,  0x802,  0x803,  0x804,  0x805,    BAD,    BAD,    BAD,
/* 068 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 070 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 078 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 080 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 088 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 090 */    BAD,    BAD,    BAD,    BAD,  0x0e4,  0x0e5,  0x0e6,  0x0e7,
/* 098 */  0x0e8,  0x060,  0x061,  0x062,  0x063,  0x064,  0x065,  0x066,
/* 0a0 */  0x067,  0x068,  0x069,  0x06a,  0x06b,  0x06c,  0x06d,  0x06e,
/* 0a8 */  0x06f,  0x070,  0x071,  0x072,  0x073,  0x074,  0x075,  0x076,
/* 0b0 */  0x077,  0x078,  0x079,  0x07a,  0x07b,  0x07c,  0x07d,  0x07e,
/* 0b8 */  0x07f,  0x080,  0x081,  0x082,  0x083,  0x084,  0x085,  0x086,
/* 0c0 */  0x087,  0x088,  0x089,  0x08a,  0x08b,  0x08c,  0x08d,  0x08e,
/* 0c8 */  0x08f,  0x090,  0x0e9,  0x0ea,  0x0eb,  0x0ec,  0x0ed,  0x096,
/* 0d0 */  0x097,  0x098,  0x099,  0x09a,  0x09b,  0x09c,  0x09d,  0x09e,
/* 0d8 */  0x09f,  0x0a0,  0x0a1,  0x0a2,  0x0a3,  0x0a4,  0x0a5,  0x0a6,
/* 0e0 */  0x0a7,  0x0a8,  0x0a9,  0x0aa,  0x0ab,  0x0ac,  0x0ad,  0x0ae,
/* 0e8 */  0x0af,  0x0b0,  0x0b1,  0x0b2,  0x0b3,  0x0b4,  0x0b5,  0x0b6,
/* 0f0 */  0x0b7,  0x0b8,  0x0b9,  0x0ba,  0x0bb,  0x0ee,  0x0bd,  0x0be,
/* 0f8 */  0x0bf,  0x0c0,  0x0c1,  0x0c2,  0x0c3,  0x0c4,  0x0c5,  0x0c6,
/* 100 */  0x0c7,  0x0c8,  0x0c9,  0x0ca,  0x0cb,  0x0cc,  0x0cd,  0x0ce,
/* 108 */  0x0cf,  0x0d0,  0x0d1,  0x0d2,  0x0d3,  0x0d4,  0x0d5,  0x0d6,
/* 110 */  0x0d7,  0x0d8,  0x0d9,  0x0da,  0x0db,  0x0dc,  0x806,  0x807,
/* 118 */  0x808,  0x809,  0x80a,  0x80b,  0x80c,  0x80d,  0x80e,    BAD,
/* 120 */  0x0ef,  0x0f0,  0x80f,  0x810,  0x811,  0x812,  0x813,  0x814,
/* 128 */  0x815,  0x0f1,    BAD,    BAD,  0x0f2,  0x0f3,  0x816,  0x817,
/* 130 */  0x818,  0x819,  0x81a,  0x81b,  0x81c,  0x81d,  0x81e,  0x81f,
/* 138 */  0x820,  0x821,  0x822,  0x823,  0x824,  0x825,  0x826,  0x827,
/* 140 */  0x828,  0x829,  0x82a,  0x82b,  0x82c,  0x82d,  0x82e,  0x82f,
/* 148 */  0x830,  0x831,  0x832,  0x833,  0x0f4,  0x834,  0x835,  0x836,
/* 150 */  0x837,  0x838,  0x839,  0x83a,  0x83b,  0x83c,  0x83d,  0x83e,
/* 158 */  0x83f,  0x840,  0x841,  0x842,  0x843,  0x844
};

/* Mapping table from BChinese to Unicode */

static cell2_t _zb_to_ucs_cell2[] = {
/* Row 0x000 */
{
/* 00 */ 0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0007,
/* 08 */ 0x0008, 0x0009, 0x000a, 0x000b, 0x000c, 0x000d, 0x000e, 0x000f,
/* 10 */ 0x0010, 0x0011, 0x0012, 0x0013, 0x0014, 0x0015, 0x0016, 0x0017,
/* 18 */ 0x0018, 0x0019, 0x001a, 0x001b, 0x001c, 0x001d, 0x001e, 0x001f,
/* 20 */ 0x0020, 0x0021, 0x0022, 0x0023, 0x0024, 0x0025, 0x0026, 0x0027,
/* 28 */ 0x0028, 0x0029, 0x002a, 0x002b, 0x002c, 0x002d, 0x002e, 0x002f,
/* 30 */ 0x0030, 0x0031, 0x0032, 0x0033, 0x0034, 0x0035, 0x0036, 0x0037,
/* 38 */ 0x0038, 0x0039, 0x003a, 0x003b, 0x003c, 0x003d, 0x003e, 0x003f
},

/* Row 0x001 */
{
/* 00 */ 0x0040, 0x0041, 0x0042, 0x0043, 0x0044, 0x0045, 0x0046, 0x0047,
/* 08 */ 0x0048, 0x0049, 0x004a, 0x004b, 0x004c, 0x004d, 0x004e, 0x004f,
/* 10 */ 0x0050, 0x0051, 0x0052, 0x0053, 0x0054, 0x0055, 0x0056, 0x0057,
/* 18 */ 0x0058, 0x0059, 0x005a, 0x005b, 0x005c, 0x005d, 0x005e, 0x005f,
/* 20 */ 0x0060, 0x0061, 0x0062, 0x0063, 0x0064, 0x0065, 0x0066, 0x0067,
/* 28 */ 0x0068, 0x0069, 0x006a, 0x006b, 0x006c, 0x006d, 0x006e, 0x006f,
/* 30 */ 0x0070, 0x0071, 0x0072, 0x0073, 0x0074, 0x0075, 0x0076, 0x0077,
/* 38 */ 0x0078, 0x0079, 0x007a, 0x007b, 0x007c, 0x007d, 0x007e, 0x007f
},

/* Row 0x002 */
{
/* 00 */ 0x0080,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x003 */
{
/* 00 */ 0x3000, 0xff0c, 0x3001, 0x3002, 0xff0e, 0x2022, 0xff1b, 0xff1a,
/* 08 */ 0xff1f, 0xff01, 0xfe30, 0x2026, 0x2025, 0xfe50, 0xff64, 0xfe52,
/* 10 */ 0x00b7, 0xfe54, 0xfe55, 0xfe56, 0xfe57, 0xff5c, 0x2013, 0xfe31,
/* 18 */ 0x2014, 0xfe33, 0xf8ff, 0xfe34, 0xfe4f, 0xff08, 0xff09, 0xfe35,
/* 20 */ 0xfe36, 0xff5b, 0xff5d, 0xfe37, 0xfe38, 0x3014, 0x3015, 0xfe39,
/* 28 */ 0xfe3a, 0x3010, 0x3011, 0xfe3b, 0xfe3c, 0x300a, 0x300b, 0xfe3d,
/* 30 */ 0xfe3e, 0x3008, 0x3009, 0xfe3f, 0xfe40, 0x300c, 0x300d, 0xfe41,
/* 38 */ 0xfe42, 0x300e, 0x300f, 0xfe43, 0xfe44, 0xfe59, 0xfe5a, 0xf8fb
},

/* Row 0x004 */
{
/* 00 */ 0xff0f, 0xff3c, 0xff04, 0x00a5, 0x3012, 0x00a2, 0x00a3, 0xff05,
/* 08 */ 0xff20, 0x2103, 0x2109, 0xfe69, 0xfe6a, 0xfe6b, 0x33d5, 0x339c,
/* 10 */ 0x339d, 0x339e, 0x33ce, 0x33a1, 0x338e, 0x338f, 0x33c4, 0x00b0,
/* 18 */ 0x5159, 0x515b, 0x515e, 0x515d, 0x5161, 0x5163, 0x55e7, 0x74e9,
/* 20 */ 0x7cce, 0x2581, 0x2582, 0x2583, 0x2584, 0x2585, 0x2586, 0x2587,
/* 28 */ 0x2588, 0x258f, 0x258e, 0x258d, 0x258c, 0x258b, 0x258a, 0x2589,
/* 30 */ 0x253c, 0x2534, 0x252c, 0x2524, 0x251c, 0x2594, 0x2500, 0x2502,
/* 38 */ 0x2595, 0x250c, 0x2510, 0x2514, 0x2518, 0x256d, 0xff57, 0xff58
},

/* Row 0x005 */
{
/* 00 */ 0xff59, 0xff5a, 0x0391, 0x0392, 0x0393, 0x0394, 0x0395, 0x0396,
/* 08 */ 0x0397, 0x0398, 0x0399, 0x039a, 0x039b, 0x039c, 0x039d, 0x039e,
/* 10 */ 0x039f, 0x03a0, 0x03a1, 0x03a3, 0x03a4, 0x03a5, 0x03a6, 0x03a7,
/* 18 */ 0x03a8, 0x03a9, 0x03b1, 0x03b2, 0x03b3, 0x03b4, 0x03b5, 0x03b6,
/* 20 */ 0x03b7, 0x03b8, 0x03b9, 0x03ba, 0x03bb, 0x03bc, 0x03bd, 0x03be,
/* 28 */ 0x03bf, 0x03c0, 0x03c1, 0x03c3, 0x03c4, 0x03c5, 0x03c6, 0x03c7,
/* 30 */ 0x03c8, 0x03c9, 0x3105, 0x3106, 0x3107, 0x3108, 0x3109, 0x310a,
/* 38 */ 0x310b, 0x310c, 0x310d, 0x310e, 0x310f, 0x4e00, 0x4e59, 0x4e01
},

/* Row 0x006 */
{
/* 00 */ 0x4e03, 0x4e43, 0x4e5d, 0x4e86, 0x4e8c, 0x4eba, 0x513f, 0x5165,
/* 08 */ 0x516b, 0x51e0, 0x5200, 0x5201, 0x529b, 0x5315, 0x5341, 0x535c,
/* 10 */ 0x53c8, 0x4e09, 0x4e0b, 0x4e08, 0x4e0a, 0x4e2b, 0x4e38, 0x51e1,
/* 18 */ 0x4e45, 0x4e48, 0x4e5f, 0x4e5e, 0x4e8e, 0x4ea1, 0x5140, 0x5203,
/* 20 */ 0x52fa, 0x5343, 0x53c9, 0x53e3, 0x571f, 0x58eb, 0x5915, 0x5927,
/* 28 */ 0x5973, 0x5b50, 0x5b51, 0x5b53, 0x5bf8, 0x5c0f, 0x5c22, 0x5c38,
/* 30 */ 0x5c71, 0x5ddd, 0x5de5, 0x5df1, 0x5df2, 0x5df3, 0x5dfe, 0x5e72,
/* 38 */ 0x5efe, 0x5f0b, 0x5f13, 0x624d, 0x4e16, 0x4e15, 0x4e14, 0x4e18
},

/* Row 0x007 */
{
/* 00 */ 0x4e3b, 0x4e4d, 0x4e4f, 0x4e4e, 0x4ee5, 0x4ed8, 0x4ed4, 0x4ed5,
/* 08 */ 0x4ed6, 0x4ed7, 0x4ee3, 0x4ee4, 0x4ed9, 0x4ede, 0x5145, 0x5144,
/* 10 */ 0x5189, 0x518a, 0x51ac, 0x51f9, 0x51fa, 0x51f8, 0x520a, 0x52a0,
/* 18 */ 0x529f, 0x5305, 0x5306, 0x5317, 0x531d, 0x4edf, 0x534a, 0x5349,
/* 20 */ 0x5361, 0x5360, 0x536f, 0x536e, 0x53bb, 0x53ef, 0x53e4, 0x53f3,
/* 28 */ 0x53ec, 0x53ee, 0x53e9, 0x53e8, 0x53fc, 0x53f8, 0x53f5, 0x53eb,
/* 30 */ 0x53e6, 0x53ea, 0x53f2, 0x53f1, 0x53f0, 0x53e5, 0x53ed, 0x53fb,
/* 38 */ 0x56db, 0x56da, 0x5916, 0x5171, 0x518d, 0x51b0, 0x5217, 0x5211
},

/* Row 0x008 */
{
/* 00 */ 0x5212, 0x520e, 0x5216, 0x52a3, 0x5308, 0x5321, 0x5320, 0x5370,
/* 08 */ 0x5371, 0x5409, 0x540f, 0x540c, 0x540a, 0x5410, 0x5401, 0x540b,
/* 10 */ 0x5404, 0x5411, 0x540d, 0x5408, 0x5403, 0x540e, 0x5406, 0x5412,
/* 18 */ 0x56e0, 0x56de, 0x56dd, 0x5733, 0x5730, 0x5728, 0x572d, 0x572c,
/* 20 */ 0x572f, 0x5729, 0x5919, 0x591a, 0x5937, 0x5938, 0x5984, 0x5978,
/* 28 */ 0x5983, 0x597d, 0x5979, 0x5982, 0x5981, 0x5b57, 0x5b58, 0x5b87,
/* 30 */ 0x5b88, 0x5b85, 0x5b89, 0x5bfa, 0x5c16, 0x5c79, 0x5dde, 0x5e06,
/* 38 */ 0x5e76, 0x5e74, 0x4f5c, 0x4f60, 0x4f2f, 0x4f4e, 0x4f36, 0x4f59
},

/* Row 0x009 */
{
/* 00 */ 0x4f5d, 0x4f48, 0x4f5a, 0x514c, 0x514b, 0x514d, 0x5175, 0x51b6,
/* 08 */ 0x51b7, 0x5225, 0x5224, 0x5229, 0x522a, 0x5228, 0x52ab, 0x52a9,
/* 10 */ 0x52aa, 0x52ac, 0x5323, 0x5373, 0x5375, 0x541d, 0x542d, 0x541e,
/* 18 */ 0x543e, 0x5426, 0x544e, 0x5427, 0x5446, 0x5443, 0x5433, 0x5448,
/* 20 */ 0x5442, 0x541b, 0x5429, 0x544a, 0x5439, 0x543b, 0x5438, 0x542e,
/* 28 */ 0x5435, 0x5436, 0x5420, 0x543c, 0x5440, 0x5431, 0x542b, 0x541f,
/* 30 */ 0x542c, 0x56ea, 0x56f0, 0x56e4, 0x56eb, 0x574a, 0x5751, 0x5740,
/* 38 */ 0x574d, 0x6753, 0x6757, 0x6b65, 0x6bcf, 0x6c42, 0x6c5e, 0x6c99
},

/* Row 0x00a */
{
/* 00 */ 0x6c81, 0x6c88, 0x6c89, 0x6c85, 0x6c9b, 0x6c6a, 0x6c7a, 0x6c90,
/* 08 */ 0x6c70, 0x6c8c, 0x6c68, 0x6c96, 0x6c92, 0x6c7d, 0x6c83, 0x6c72,
/* 10 */ 0x6c7e, 0x6c74, 0x6c86, 0x6c76, 0x6c8d, 0x6c94, 0x6c98, 0x6c82,
/* 18 */ 0x7076, 0x707c, 0x707d, 0x7078, 0x7262, 0x7261, 0x7260, 0x72c4,
/* 20 */ 0x72c2, 0x7396, 0x752c, 0x752b, 0x7537, 0x7538, 0x7682, 0x76ef,
/* 28 */ 0x77e3, 0x79c1, 0x79c0, 0x79bf, 0x7a76, 0x7cfb, 0x7f55, 0x8096,
/* 30 */ 0x8093, 0x809d, 0x8098, 0x809b, 0x809a, 0x80b2, 0x826f, 0x8292,
/* 38 */ 0x5496, 0x5478, 0x5495, 0x5480, 0x547b, 0x5477, 0x5484, 0x5492
},

/* Row 0x00b */
{
/* 00 */ 0x5486, 0x547c, 0x5490, 0x5471, 0x5476, 0x548c, 0x549a, 0x5462,
/* 08 */ 0x5468, 0x548b, 0x547d, 0x548e, 0x56fa, 0x5783, 0x5777, 0x576a,
/* 10 */ 0x5769, 0x5761, 0x5766, 0x5764, 0x577c, 0x591c, 0x5949, 0x5947,
/* 18 */ 0x5948, 0x5944, 0x5954, 0x59be, 0x59bb, 0x59d4, 0x59b9, 0x59ae,
/* 20 */ 0x59d1, 0x59c6, 0x59d0, 0x59cd, 0x59cb, 0x59d3, 0x59ca, 0x59af,
/* 28 */ 0x59b3, 0x59d2, 0x59c5, 0x5b5f, 0x5b64, 0x5b63, 0x5b97, 0x5b9a,
/* 30 */ 0x5b98, 0x5b9c, 0x5b99, 0x5b9b, 0x5c1a, 0x5c48, 0x5c45, 0x6607,
/* 38 */ 0x670d, 0x670b, 0x676d, 0x678b, 0x6795, 0x6771, 0x679c, 0x6773
},

/* Row 0x00c */
{
/* 00 */ 0x6777, 0x6787, 0x679d, 0x6797, 0x676f, 0x6770, 0x677f, 0x6789,
/* 08 */ 0x677e, 0x6790, 0x6775, 0x679a, 0x6793, 0x677c, 0x676a, 0x6772,
/* 10 */ 0x6b23, 0x6b66, 0x6b67, 0x6b7f, 0x6c13, 0x6c1b, 0x6ce3, 0x6ce8,
/* 18 */ 0x6cf3, 0x6cb1, 0x6ccc, 0x6ce5, 0x6cb3, 0x6cbd, 0x6cbe, 0x6cbc,
/* 20 */ 0x6ce2, 0x6cab, 0x6cd5, 0x6cd3, 0x6cb8, 0x6cc4, 0x6cb9, 0x6cc1,
/* 28 */ 0x6cae, 0x6cd7, 0x6cc5, 0x6cf1, 0x6cbf, 0x6cbb, 0x6ce1, 0x6cdb,
/* 30 */ 0x6cca, 0x6cac, 0x6cef, 0x6cdc, 0x6cd6, 0x6ce0, 0x9642, 0x96b9,
/* 38 */ 0x96e8, 0x9752, 0x975e, 0x4e9f, 0x4ead, 0x4eae, 0x4fe1, 0x4fb5
},

/* Row 0x00d */
{
/* 00 */ 0x4faf, 0x4fbf, 0x4fe0, 0x4fd1, 0x4fcf, 0x4fdd, 0x4fc3, 0x4fb6,
/* 08 */ 0x4fd8, 0x4fdf, 0x4fca, 0x4fd7, 0x4fae, 0x4fd0, 0x4fc4, 0x4fc2,
/* 10 */ 0x4fda, 0x4fce, 0x4fde, 0x4fb7, 0x5157, 0x5192, 0x5191, 0x51a0,
/* 18 */ 0x524e, 0x5243, 0x524a, 0x524d, 0x524c, 0x524b, 0x5247, 0x52c7,
/* 20 */ 0x52c9, 0x52c3, 0x52c1, 0x530d, 0x5357, 0x537b, 0x539a, 0x53db,
/* 28 */ 0x54ac, 0x54c0, 0x54a8, 0x54ce, 0x54c9, 0x54b8, 0x54a6, 0x54b3,
/* 30 */ 0x54c7, 0x54c2, 0x54bd, 0x54aa, 0x54c1, 0x62ef, 0x62ec, 0x62fe,
/* 38 */ 0x62f4, 0x6311, 0x6302, 0x653f, 0x6545, 0x65ab, 0x65bd, 0x65e2
},

/* Row 0x00e */
{
/* 00 */ 0x6625, 0x662d, 0x6620, 0x6627, 0x662f, 0x661f, 0x6628, 0x6631,
/* 08 */ 0x6624, 0x66f7, 0x67ff, 0x67d3, 0x67f1, 0x67d4, 0x67d0, 0x67ec,
/* 10 */ 0x67b6, 0x67af, 0x67f5, 0x67e9, 0x67ef, 0x67c4, 0x67d1, 0x67b4,
/* 18 */ 0x67da, 0x67e5, 0x67b8, 0x67cf, 0x67de, 0x67f3, 0x67b0, 0x67d9,
/* 20 */ 0x67e2, 0x67dd, 0x67d2, 0x6b6a, 0x6b83, 0x6b86, 0x6bb5, 0x6bd2,
/* 28 */ 0x6bd7, 0x6c1f, 0x6cc9, 0x6d0b, 0x6d32, 0x6d2a, 0x6d41, 0x6d25,
/* 30 */ 0x6d0c, 0x6d31, 0x6d1e, 0x6d17, 0x8010, 0x800d, 0x8011, 0x8036,
/* 38 */ 0x80d6, 0x80e5, 0x80da, 0x80c3, 0x80c4, 0x80cc, 0x80e1, 0x80db
},

/* Row 0x00f */
{
/* 00 */ 0x80ce, 0x80de, 0x80e4, 0x80dd, 0x81f4, 0x8222, 0x82e7, 0x8303,
/* 08 */ 0x8305, 0x82e3, 0x82db, 0x82e6, 0x8304, 0x82e5, 0x8302, 0x8309,
/* 10 */ 0x82d2, 0x82d7, 0x82f1, 0x8301, 0x82dc, 0x82d4, 0x82d1, 0x82de,
/* 18 */ 0x82d3, 0x82df, 0x82ef, 0x8306, 0x8650, 0x8679, 0x867b, 0x867a,
/* 20 */ 0x884d, 0x886b, 0x8981, 0x89d4, 0x8a08, 0x8a02, 0x8a03, 0x8c9e,
/* 28 */ 0x8ca0, 0x8d74, 0x8d73, 0x8db4, 0x8ecd, 0x8ecc, 0x8ff0, 0x8fe6,
/* 30 */ 0x8fe2, 0x8fea, 0x8fe5, 0x54e6, 0x5527, 0x5507, 0x54fd, 0x550f,
/* 38 */ 0x5703, 0x5704, 0x57c2, 0x57d4, 0x57cb, 0x57c3, 0x5809, 0x590f
},

/* Row 0x010 */
{
/* 00 */ 0x5957, 0x5958, 0x595a, 0x5a11, 0x5a18, 0x5a1c, 0x5a1f, 0x5a1b,
/* 08 */ 0x5a13, 0x59ec, 0x5a20, 0x5a23, 0x5a29, 0x5a25, 0x5a0c, 0x5a09,
/* 10 */ 0x5b6b, 0x5c58, 0x5bb0, 0x5bb3, 0x5bb6, 0x5bb4, 0x5bae, 0x5bb5,
/* 18 */ 0x5bb9, 0x5bb8, 0x5c04, 0x5c51, 0x5c55, 0x5c50, 0x5ced, 0x5cfd,
/* 20 */ 0x5cfb, 0x5cea, 0x5ce8, 0x5cf0, 0x5cf6, 0x5d01, 0x5cf4, 0x5dee,
/* 28 */ 0x5e2d, 0x5e2b, 0x5eab, 0x5ead, 0x5ea7, 0x5f31, 0x5f92, 0x5f91,
/* 30 */ 0x5f90, 0x6059, 0x6d6c, 0x6d89, 0x6d6e, 0x6d5a, 0x6d74, 0x6d69,
/* 38 */ 0x6d8c, 0x6d8a, 0x6d79, 0x6d85, 0x6d65, 0x6d94, 0x70ca, 0x70d8
},

/* Row 0x011 */
{
/* 00 */ 0x70e4, 0x70d9, 0x70c8, 0x70cf, 0x7239, 0x7279, 0x72fc, 0x72f9,
/* 08 */ 0x72fd, 0x72f8, 0x72f7, 0x7386, 0x73ed, 0x7409, 0x73ee, 0x73e0,
/* 10 */ 0x73ea, 0x73de, 0x7554, 0x755d, 0x755c, 0x755a, 0x7559, 0x75be,
/* 18 */ 0x75c5, 0x75c7, 0x75b2, 0x75b3, 0x75bd, 0x75bc, 0x75b9, 0x75c2,
/* 20 */ 0x75b8, 0x768b, 0x76b0, 0x76ca, 0x76cd, 0x76ce, 0x7729, 0x771f,
/* 28 */ 0x7720, 0x7728, 0x77e9, 0x7830, 0x7827, 0x7838, 0x781d, 0x7834,
/* 30 */ 0x7837, 0x8654, 0x868a, 0x86aa, 0x8693, 0x86a4, 0x86a9, 0x868c,
/* 38 */ 0x86a3, 0x869c, 0x8870, 0x8877, 0x8881, 0x8882, 0x887d, 0x8879
},

/* Row 0x012 */
{
/* 00 */ 0x8a18, 0x8a10, 0x8a0e, 0x8a0c, 0x8a15, 0x8a0a, 0x8a17, 0x8a13,
/* 08 */ 0x8a16, 0x8a0f, 0x8a11, 0x8c48, 0x8c7a, 0x8c79, 0x8ca1, 0x8ca2,
/* 10 */ 0x8d77, 0x8eac, 0x8ed2, 0x8ed4, 0x8ecf, 0x8fb1, 0x9001, 0x9006,
/* 18 */ 0x8ff7, 0x9000, 0x8ffa, 0x8ff4, 0x9003, 0x8ffd, 0x9005, 0x8ff8,
/* 20 */ 0x9095, 0x90e1, 0x90dd, 0x90e2, 0x9152, 0x914d, 0x914c, 0x91d8,
/* 28 */ 0x91dd, 0x91d7, 0x91dc, 0x91d9, 0x9583, 0x9662, 0x9663, 0x9661,
/* 30 */ 0x5a3c, 0x5a62, 0x5a5a, 0x5a46, 0x5a4a, 0x5b70, 0x5bc7, 0x5bc5,
/* 38 */ 0x5bc4, 0x5bc2, 0x5bbf, 0x5bc6, 0x5c09, 0x5c08, 0x5c07, 0x5c60
},

/* Row 0x013 */
{
/* 00 */ 0x5c5c, 0x5c5d, 0x5d07, 0x5d06, 0x5d0e, 0x5d1b, 0x5d16, 0x5d22,
/* 08 */ 0x5d11, 0x5d29, 0x5d14, 0x5d19, 0x5d24, 0x5d27, 0x5d17, 0x5de2,
/* 10 */ 0x5e38, 0x5e36, 0x5e33, 0x5e37, 0x5eb7, 0x5eb8, 0x5eb6, 0x5eb5,
/* 18 */ 0x5ebe, 0x5f35, 0x5f37, 0x5f57, 0x5f6c, 0x5f69, 0x5f6b, 0x5f97,
/* 20 */ 0x5f99, 0x5f9e, 0x5f98, 0x5fa1, 0x5fa0, 0x5f9c, 0x607f, 0x60a3,
/* 28 */ 0x6089, 0x60a0, 0x60a8, 0x60cb, 0x60b4, 0x60e6, 0x60bd, 0x6beb,
/* 30 */ 0x6bec, 0x6c2b, 0x6d8e, 0x6dbc, 0x6df3, 0x6dd9, 0x6db2, 0x6de1,
/* 38 */ 0x6dcc, 0x6de4, 0x6dfb, 0x6dfa, 0x6e05, 0x6dc7, 0x6dcb, 0x6daf
},

/* Row 0x014 */
{
/* 00 */ 0x6dd1, 0x6dae, 0x6dde, 0x6df9, 0x6db8, 0x6df7, 0x6df5, 0x6dc5,
/* 08 */ 0x6dd2, 0x6e1a, 0x6db5, 0x6dda, 0x6deb, 0x6dd8, 0x6dea, 0x6df1,
/* 10 */ 0x6dee, 0x6de8, 0x6dc6, 0x6dc4, 0x6daa, 0x6dec, 0x6dbf, 0x6de6,
/* 18 */ 0x70f9, 0x7109, 0x710a, 0x70fd, 0x70ef, 0x723d, 0x727d, 0x7281,
/* 20 */ 0x731c, 0x731b, 0x7316, 0x7313, 0x7319, 0x7387, 0x7405, 0x740a,
/* 28 */ 0x7403, 0x7406, 0x73fe, 0x740d, 0x74e0, 0x74f6, 0x8386, 0x83a7,
/* 30 */ 0x8655, 0x5f6a, 0x86c7, 0x86c0, 0x86b6, 0x86c4, 0x86b5, 0x86c6,
/* 38 */ 0x86cb, 0x86b1, 0x86af, 0x86c9, 0x8853, 0x889e, 0x8888, 0x88ab
},

/* Row 0x015 */
{
/* 00 */ 0x8892, 0x8896, 0x888d, 0x888b, 0x8993, 0x898f, 0x8a2a, 0x8a1d,
/* 08 */ 0x8a23, 0x8a25, 0x8a31, 0x8a2d, 0x8a1f, 0x8a1b, 0x8a22, 0x8c49,
/* 10 */ 0x8c5a, 0x8ca9, 0x8cac, 0x8cab, 0x8ca8, 0x8caa, 0x8ca7, 0x8d67,
/* 18 */ 0x8d66, 0x8dbe, 0x8dba, 0x8edb, 0x8edf, 0x9019, 0x900d, 0x901a,
/* 20 */ 0x9017, 0x9023, 0x901f, 0x901d, 0x9010, 0x9015, 0x901e, 0x9020,
/* 28 */ 0x900f, 0x9022, 0x9016, 0x901b, 0x9014, 0x5a77, 0x5a9a, 0x5a7f,
/* 30 */ 0x5a92, 0x5a9b, 0x5aa7, 0x5b73, 0x5b71, 0x5bd2, 0x5bcc, 0x5bd3,
/* 38 */ 0x5bd0, 0x5c0a, 0x5c0b, 0x5c31, 0x5d4c, 0x5d50, 0x5d34, 0x5d47
},

/* Row 0x016 */
{
/* 00 */ 0x5dfd, 0x5e45, 0x5e3d, 0x5e40, 0x5e43, 0x5e7e, 0x5eca, 0x5ec1,
/* 08 */ 0x5ec2, 0x5ec4, 0x5f3c, 0x5f6d, 0x5fa9, 0x5faa, 0x5fa8, 0x60d1,
/* 10 */ 0x60e1, 0x60b2, 0x60b6, 0x60e0, 0x611c, 0x6123, 0x60fa, 0x6115,
/* 18 */ 0x60f0, 0x60fb, 0x60f4, 0x6168, 0x60f1, 0x610e, 0x60f6, 0x6109,
/* 20 */ 0x6100, 0x6112, 0x621f, 0x6249, 0x63a3, 0x638c, 0x63cf, 0x63c0,
/* 28 */ 0x63e9, 0x63c9, 0x63c6, 0x63cd, 0x6e89, 0x6e19, 0x6e4e, 0x6e63,
/* 30 */ 0x6e44, 0x6e72, 0x6e69, 0x6e5f, 0x7119, 0x711a, 0x7126, 0x7130,
/* 38 */ 0x7121, 0x7136, 0x716e, 0x711c, 0x724c, 0x7284, 0x7280, 0x7336
},

/* Row 0x017 */
{
/* 00 */ 0x7325, 0x7334, 0x7329, 0x743a, 0x742a, 0x7433, 0x7422, 0x7425,
/* 08 */ 0x7435, 0x7436, 0x7434, 0x742f, 0x741b, 0x7426, 0x7428, 0x7525,
/* 10 */ 0x7526, 0x756b, 0x756a, 0x75e2, 0x75db, 0x75e3, 0x75d9, 0x75d8,
/* 18 */ 0x75de, 0x75e0, 0x767b, 0x767c, 0x7696, 0x7693, 0x76b4, 0x76dc,
/* 20 */ 0x774f, 0x77ed, 0x785d, 0x786c, 0x786f, 0x7a0d, 0x7a08, 0x7a0b,
/* 28 */ 0x7a05, 0x7a00, 0x7a98, 0x8a54, 0x8a5b, 0x8a50, 0x8a46, 0x8a34,
/* 30 */ 0x8a3a, 0x8a36, 0x8a56, 0x8c61, 0x8c82, 0x8caf, 0x8cbc, 0x8cb3,
/* 38 */ 0x8cbd, 0x8cc1, 0x8cbb, 0x8cc0, 0x8cb4, 0x8cb7, 0x8cb6, 0x8cbf
},

/* Row 0x018 */
{
/* 00 */ 0x8cb8, 0x8d8a, 0x8d85, 0x8d81, 0x8dce, 0x8ddd, 0x8dcb, 0x8dda,
/* 08 */ 0x8dd1, 0x8dcc, 0x8ddb, 0x8dc6, 0x8efb, 0x8ef8, 0x8efc, 0x8f9c,
/* 10 */ 0x902e, 0x9035, 0x9031, 0x9038, 0x9032, 0x9036, 0x9102, 0x90f5,
/* 18 */ 0x9109, 0x90fe, 0x9163, 0x9165, 0x91cf, 0x9214, 0x9215, 0x9223,
/* 20 */ 0x9209, 0x921e, 0x920d, 0x9210, 0x9207, 0x9211, 0x9594, 0x958f,
/* 28 */ 0x958b, 0x9591, 0x5ab3, 0x5ac2, 0x5ab2, 0x5d69, 0x5d6f, 0x5e4c,
/* 30 */ 0x5e79, 0x5ec9, 0x5ec8, 0x5f12, 0x5f59, 0x5fac, 0x5fae, 0x611a,
/* 38 */ 0x610f, 0x6148, 0x611f, 0x60f3, 0x611b, 0x60f9, 0x6101, 0x6108
},

/* Row 0x019 */
{
/* 00 */ 0x614e, 0x614c, 0x6144, 0x614d, 0x613e, 0x6134, 0x6127, 0x610d,
/* 08 */ 0x6106, 0x6137, 0x6221, 0x6222, 0x6413, 0x643e, 0x641e, 0x642a,
/* 10 */ 0x642d, 0x643d, 0x642c, 0x640f, 0x641c, 0x6414, 0x640d, 0x6436,
/* 18 */ 0x6416, 0x6417, 0x6406, 0x656c, 0x659f, 0x65b0, 0x6697, 0x6689,
/* 20 */ 0x6687, 0x6688, 0x6696, 0x6684, 0x6698, 0x668d, 0x6703, 0x6994,
/* 28 */ 0x696d, 0x7779, 0x776a, 0x776c, 0x775c, 0x7765, 0x7768, 0x7762,
/* 30 */ 0x77ee, 0x788e, 0x78b0, 0x7897, 0x7898, 0x788c, 0x7889, 0x787c,
/* 38 */ 0x7891, 0x7893, 0x787f, 0x797a, 0x797f, 0x7981, 0x842c, 0x79bd
},

/* Row 0x01a */
{
/* 00 */ 0x7a1c, 0x7a1a, 0x7a20, 0x7a14, 0x7a1f, 0x7a1e, 0x7a9f, 0x7aa0,
/* 08 */ 0x7b77, 0x7bc0, 0x7b60, 0x7b6e, 0x7b67, 0x7cb1, 0x7cb3, 0x7cb5,
/* 10 */ 0x7d93, 0x7d79, 0x7d91, 0x7d81, 0x7d8f, 0x7d5b, 0x7f6e, 0x7f69,
/* 18 */ 0x7f6a, 0x7f72, 0x7fa9, 0x7fa8, 0x7fa4, 0x8056, 0x8058, 0x8086,
/* 20 */ 0x8084, 0x8171, 0x8170, 0x8178, 0x8165, 0x816e, 0x8173, 0x816b,
/* 28 */ 0x8f9f, 0x8fb2, 0x904b, 0x904a, 0x9053, 0x9042, 0x9054, 0x903c,
/* 30 */ 0x9055, 0x9050, 0x9047, 0x904f, 0x904e, 0x904d, 0x9051, 0x903e,
/* 38 */ 0x9041, 0x9112, 0x9117, 0x916c, 0x916a, 0x9169, 0x91c9, 0x9237
},

/* Row 0x01b */
{
/* 00 */ 0x9257, 0x9238, 0x923d, 0x9240, 0x923e, 0x925b, 0x924b, 0x9264,
/* 08 */ 0x9251, 0x9234, 0x9249, 0x924d, 0x9245, 0x9239, 0x923f, 0x925a,
/* 10 */ 0x9598, 0x9698, 0x9694, 0x9695, 0x96cd, 0x96cb, 0x96c9, 0x96ca,
/* 18 */ 0x96f7, 0x96fb, 0x96f9, 0x96f6, 0x9756, 0x9774, 0x9776, 0x9810,
/* 20 */ 0x9811, 0x9813, 0x980a, 0x9812, 0x980c, 0x98fc, 0x98f4, 0x613f,
/* 28 */ 0x614b, 0x6177, 0x6162, 0x6163, 0x615f, 0x615a, 0x6158, 0x6175,
/* 30 */ 0x622a, 0x6487, 0x6458, 0x6454, 0x64a4, 0x6478, 0x645f, 0x647a,
/* 38 */ 0x6451, 0x6467, 0x6434, 0x646d, 0x647b, 0x6572, 0x65a1, 0x65d7
},

/* Row 0x01c */
{
/* 00 */ 0x65d6, 0x66a2, 0x66a8, 0x669d, 0x699c, 0x69a8, 0x6995, 0x69c1,
/* 08 */ 0x69ae, 0x69d3, 0x69cb, 0x699b, 0x69b7, 0x69bb, 0x69ab, 0x69b4,
/* 10 */ 0x69d0, 0x69cd, 0x69ad, 0x69cc, 0x69a6, 0x69c3, 0x69a3, 0x6b49,
/* 18 */ 0x6b4c, 0x6c33, 0x6f33, 0x6f14, 0x6efe, 0x6f13, 0x6ef4, 0x6f29,
/* 20 */ 0x6f3e, 0x6f20, 0x6f2c, 0x6f0f, 0x6f02, 0x6f22, 0x7f70, 0x7fe0,
/* 28 */ 0x7fe1, 0x7fdf, 0x805e, 0x805a, 0x8087, 0x8150, 0x8180, 0x818f,
/* 30 */ 0x8188, 0x818a, 0x817f, 0x8182, 0x81e7, 0x81fa, 0x8207, 0x8214,
/* 38 */ 0x821e, 0x824b, 0x84c9, 0x84bf, 0x84c6, 0x84c4, 0x8499, 0x849e
},

/* Row 0x01d */
{
/* 00 */ 0x84b2, 0x849c, 0x84cb, 0x84b8, 0x84c0, 0x84d3, 0x8490, 0x84bc,
/* 08 */ 0x84d1, 0x84ca, 0x873f, 0x871c, 0x873b, 0x8722, 0x8725, 0x8734,
/* 10 */ 0x8718, 0x8755, 0x8737, 0x8729, 0x88f3, 0x8902, 0x88f4, 0x88f9,
/* 18 */ 0x88f8, 0x88fd, 0x88e8, 0x891a, 0x88ef, 0x8aa6, 0x8a8c, 0x8a9e,
/* 20 */ 0x8aa3, 0x8a8d, 0x8aa1, 0x8a93, 0x8aa4, 0x5287, 0x5288, 0x5289,
/* 28 */ 0x528d, 0x528a, 0x52f0, 0x53b2, 0x562e, 0x563b, 0x5639, 0x5632,
/* 30 */ 0x563f, 0x5634, 0x5629, 0x5653, 0x564e, 0x5657, 0x5674, 0x5636,
/* 38 */ 0x562f, 0x5630, 0x5880, 0x589f, 0x589e, 0x58b3, 0x589c, 0x58ae
},

/* Row 0x01e */
{
/* 00 */ 0x58a9, 0x58a6, 0x596d, 0x5b09, 0x5afb, 0x5b0b, 0x5af5, 0x5b0c,
/* 08 */ 0x5b08, 0x5bee, 0x5bec, 0x5be9, 0x5beb, 0x5c64, 0x5c65, 0x5d9d,
/* 10 */ 0x5d94, 0x5e62, 0x5e5f, 0x5e61, 0x5ee2, 0x5eda, 0x5edf, 0x5edd,
/* 18 */ 0x5ee3, 0x5ee0, 0x5f48, 0x5f71, 0x5fb7, 0x5fb5, 0x6176, 0x6167,
/* 20 */ 0x616e, 0x615d, 0x6155, 0x6182, 0x747e, 0x7480, 0x757f, 0x7620,
/* 28 */ 0x7629, 0x761f, 0x7624, 0x7626, 0x7621, 0x7622, 0x769a, 0x76ba,
/* 30 */ 0x76e4, 0x778e, 0x7787, 0x778c, 0x7791, 0x778b, 0x78cb, 0x78c5,
/* 38 */ 0x78ba, 0x78ca, 0x78be, 0x78d5, 0x78bc, 0x78d0, 0x7a3f, 0x7a3c
},

/* Row 0x01f */
{
/* 00 */ 0x7a40, 0x7a3d, 0x7a37, 0x7a3b, 0x7aaf, 0x7aae, 0x7bad, 0x7bb1,
/* 08 */ 0x7bc4, 0x7bb4, 0x7bc6, 0x7bc7, 0x7bc1, 0x7ba0, 0x7bcc, 0x7cca,
/* 10 */ 0x7de0, 0x7df4, 0x7def, 0x7dfb, 0x7dd8, 0x7dec, 0x7ddd, 0x7de8,
/* 18 */ 0x7de3, 0x7dda, 0x7dde, 0x7de9, 0x7d9e, 0x7dd9, 0x7df2, 0x7df9,
/* 20 */ 0x7f75, 0x7f77, 0x7faf, 0x8f25, 0x9069, 0x906e, 0x9068, 0x906d,
/* 28 */ 0x9077, 0x9130, 0x912d, 0x9127, 0x9131, 0x9187, 0x9189, 0x918b,
/* 30 */ 0x9183, 0x92c5, 0x92bb, 0x92b7, 0x92ea, 0x92ac, 0x92e4, 0x92c1,
/* 38 */ 0x92b3, 0x92bc, 0x92d2, 0x92c7, 0x92f0, 0x92b2, 0x95ad, 0x95b1
},

/* Row 0x020 */
{
/* 00 */ 0x9704, 0x9706, 0x9707, 0x9709, 0x9760, 0x978d, 0x978b, 0x978f,
/* 08 */ 0x9821, 0x982b, 0x981c, 0x98b3, 0x990a, 0x9913, 0x9912, 0x9918,
/* 10 */ 0x99dd, 0x99d0, 0x99df, 0x99db, 0x99d1, 0x99d5, 0x99d2, 0x99d9,
/* 18 */ 0x9ab7, 0x9aee, 0x9aef, 0x9b27, 0x9b45, 0x9b44, 0x9b77, 0x9b6f,
/* 20 */ 0x9d06, 0x9d09, 0x6fc3, 0x6fa4, 0x6fc1, 0x6fa7, 0x6fb3, 0x6fc0,
/* 28 */ 0x6fb9, 0x6fb6, 0x6fa6, 0x6fa0, 0x6fb4, 0x71be, 0x71c9, 0x71d0,
/* 30 */ 0x71d2, 0x71c8, 0x71d5, 0x71b9, 0x71ce, 0x71d9, 0x71dc, 0x71c3,
/* 38 */ 0x71c4, 0x7368, 0x749c, 0x74a3, 0x7498, 0x749f, 0x749e, 0x74e2
},

/* Row 0x021 */
{
/* 00 */ 0x750c, 0x750d, 0x7634, 0x7638, 0x763a, 0x76e7, 0x76e5, 0x77a0,
/* 08 */ 0x779e, 0x779f, 0x77a5, 0x78e8, 0x78da, 0x78ec, 0x78e7, 0x79a6,
/* 10 */ 0x7a4d, 0x7a4e, 0x7a46, 0x7a4c, 0x7a4b, 0x7aba, 0x7bd9, 0x7c11,
/* 18 */ 0x7bc9, 0x7be4, 0x7bdb, 0x7be1, 0x7be9, 0x7be6, 0x7cd5, 0x7cd6,
/* 20 */ 0x7e0a, 0x9310, 0x9326, 0x9321, 0x9315, 0x932e, 0x9319, 0x95bb,
/* 28 */ 0x96a7, 0x96a8, 0x96aa, 0x96d5, 0x970e, 0x9711, 0x9716, 0x970d,
/* 30 */ 0x9713, 0x970f, 0x975b, 0x975c, 0x9766, 0x9798, 0x9830, 0x9838,
/* 38 */ 0x983b, 0x9837, 0x982d, 0x9839, 0x9824, 0x9910, 0x9928, 0x991e
},

/* Row 0x022 */
{
/* 00 */ 0x991b, 0x9921, 0x991a, 0x99ed, 0x99e2, 0x99f1, 0x9ab8, 0x9abc,
/* 08 */ 0x9afb, 0x9aed, 0x9b28, 0x9b91, 0x9d15, 0x9d23, 0x9d26, 0x9d28,
/* 10 */ 0x9d12, 0x9d1b, 0x9ed8, 0x9ed4, 0x9f8d, 0x9f9c, 0x512a, 0x511f,
/* 18 */ 0x5121, 0x5132, 0x52f5, 0x568e, 0x5680, 0x5690, 0x5685, 0x5687,
/* 20 */ 0x77a7, 0x77ad, 0x77ef, 0x78f7, 0x78fa, 0x78f4, 0x78ef, 0x7901,
/* 28 */ 0x79a7, 0x79aa, 0x7a57, 0x7abf, 0x7c07, 0x7c0d, 0x7bfe, 0x7bf7,
/* 30 */ 0x7c0c, 0x7be0, 0x7ce0, 0x7cdc, 0x7cde, 0x7ce2, 0x7cdf, 0x7cd9,
/* 38 */ 0x7cdd, 0x7e2e, 0x7e3e, 0x7e46, 0x7e37, 0x7e32, 0x7e43, 0x7e2b
},

/* Row 0x023 */
{
/* 00 */ 0x7e3d, 0x7e31, 0x7e45, 0x7e41, 0x7e34, 0x7e39, 0x7e48, 0x7e35,
/* 08 */ 0x7e3f, 0x7e2f, 0x7f44, 0x7ff3, 0x7ffc, 0x8071, 0x8072, 0x8070,
/* 10 */ 0x806f, 0x8073, 0x81c6, 0x81c3, 0x81ba, 0x81c2, 0x81c0, 0x81bf,
/* 18 */ 0x81bd, 0x81c9, 0x81be, 0x81e8, 0x8209, 0x8271, 0x85aa, 0x99ff,
/* 20 */ 0x9bae, 0x9bab, 0x9baa, 0x9bad, 0x9d3b, 0x9d3f, 0x9e8b, 0x9ecf,
/* 28 */ 0x9ede, 0x9edc, 0x9edd, 0x9edb, 0x9f3e, 0x9f4b, 0x53e2, 0x5695,
/* 30 */ 0x56ae, 0x58d9, 0x58d8, 0x5b38, 0x5f5d, 0x61e3, 0x6233, 0x64f4,
/* 38 */ 0x64f2, 0x64fe, 0x6506, 0x64fa, 0x64fb, 0x64f7, 0x65b7, 0x66dc
},

/* Row 0x024 */
{
/* 00 */ 0x6726, 0x6ab3, 0x6aac, 0x6ac3, 0x6abb, 0x6ab8, 0x6ac2, 0x6aae,
/* 08 */ 0x6aaf, 0x6b5f, 0x6b78, 0x6baf, 0x7009, 0x700b, 0x6ffe, 0x7006,
/* 10 */ 0x6ffa, 0x7011, 0x700f, 0x71fb, 0x71fc, 0x71fe, 0x71f8, 0x7377,
/* 18 */ 0x7375, 0x74a7, 0x74bf, 0x7515, 0x7656, 0x7658, 0x97ad, 0x97f9,
/* 20 */ 0x984d, 0x984f, 0x984c, 0x984e, 0x9853, 0x98ba, 0x993e, 0x993f,
/* 28 */ 0x993d, 0x992e, 0x99a5, 0x9a0e, 0x9ac1, 0x9b03, 0x9b06, 0x9b4f,
/* 30 */ 0x9b4e, 0x9b4d, 0x9bca, 0x9bc9, 0x9bfd, 0x9bc8, 0x9bc0, 0x9d51,
/* 38 */ 0x9d5d, 0x9d60, 0x9ee0, 0x9f15, 0x9f2c, 0x5133, 0x56a5, 0x58de
},

/* Row 0x025 */
{
/* 00 */ 0x58df, 0x58e2, 0x5bf5, 0x9f90, 0x5eec, 0x61f2, 0x61f7, 0x61f6,
/* 08 */ 0x61f5, 0x6500, 0x650f, 0x66e0, 0x66dd, 0x6ae5, 0x6add, 0x6ada,
/* 10 */ 0x6ad3, 0x701b, 0x701f, 0x7028, 0x701a, 0x701d, 0x7015, 0x7018,
/* 18 */ 0x7206, 0x720d, 0x7258, 0x72a2, 0x7378, 0x9858, 0x985b, 0x98bc,
/* 20 */ 0x9945, 0x9949, 0x9a16, 0x9a19, 0x9b0d, 0x9be8, 0x9be7, 0x9bd6,
/* 28 */ 0x9bdb, 0x9d89, 0x9d61, 0x9d72, 0x9d6a, 0x9d6c, 0x9e92, 0x9e97,
/* 30 */ 0x9e93, 0x9eb4, 0x52f8, 0x56a8, 0x56b7, 0x56b6, 0x56b4, 0x56bc,
/* 38 */ 0x58e4, 0x5b40, 0x5b43, 0x5b7d, 0x5bf6, 0x5dc9, 0x61f8, 0x61fa
},

/* Row 0x026 */
{
/* 00 */ 0x6518, 0x6514, 0x6519, 0x66e6, 0x6727, 0x6aec, 0x703e, 0x7030,
/* 08 */ 0x7032, 0x7210, 0x737b, 0x74cf, 0x7662, 0x7665, 0x7926, 0x792a,
/* 10 */ 0x792c, 0x792b, 0x7ac7, 0x7af6, 0x7c4c, 0x7c43, 0x7c4d, 0x7cef,
/* 18 */ 0x7cf0, 0x8fae, 0x7e7d, 0x7e7c, 0x8b77, 0x8b7d, 0x8d13, 0x8e8a,
/* 20 */ 0x8e8d, 0x8e8b, 0x8f5f, 0x8faf, 0x91ba, 0x942e, 0x9433, 0x9435,
/* 28 */ 0x943a, 0x9438, 0x9432, 0x942b, 0x95e2, 0x9738, 0x9739, 0x9732,
/* 30 */ 0x97ff, 0x9867, 0x9865, 0x9957, 0x9a45, 0x9a43, 0x9a40, 0x9a3e,
/* 38 */ 0x9acf, 0x9b54, 0x9b51, 0x9c2d, 0x9c25, 0x9daf, 0x9db4, 0x9dc2
},

/* Row 0x027 */
{
/* 00 */ 0x9db8, 0x9e9d, 0x9eef, 0x9f19, 0x9f5c, 0x9f66, 0x9f67, 0x513c,
/* 08 */ 0x513b, 0x56c8, 0x56ca, 0x56c9, 0x5b7f, 0x5dd4, 0x5dd2, 0x5f4e,
/* 10 */ 0x61ff, 0x6524, 0x6b0a, 0x6b61, 0x7051, 0x7058, 0x7380, 0x74e4,
/* 18 */ 0x758a, 0x766e, 0x766c, 0x8b96, 0x8277, 0x8d1b, 0x91c0, 0x946a,
/* 20 */ 0x9742, 0x9748, 0x9744, 0x97c6, 0x9870, 0x9a5f, 0x9b22, 0x9b58,
/* 28 */ 0x9c5f, 0x9df9, 0x9dfa, 0x9e7c, 0x9e7d, 0x9f07, 0x9f77, 0x9f72,
/* 30 */ 0x5ef3, 0x6b16, 0x7063, 0x7c6c, 0x7c6e, 0x883b, 0x89c0, 0x8ea1,
/* 38 */ 0x91c1, 0x9472, 0x9470, 0x9871, 0x995e, 0x9ad6, 0x9b23, 0x9ecc
},

/* Row 0x028 */
{
/* 00 */ 0x7064, 0x77da, 0x8b9a, 0x9477, 0x97c9, 0x9a62, 0x9a65, 0x7e9c,
/* 08 */ 0x8b9c, 0x8eaa, 0x91c5, 0x947d, 0x947e, 0x947c, 0x9c77, 0x9c78,
/* 10 */ 0x9ef7, 0x8c54, 0x947f, 0x9e1a, 0x7228, 0x9a6a, 0x9b31, 0x9e1b,
/* 18 */ 0x9e1e, 0x7c72, 0x30a8, 0x30a9, 0x30aa, 0x30ab, 0x30ac, 0x30ad,
/* 20 */ 0x30ae, 0x30af, 0x30b0, 0x30b1, 0x30b2, 0x30b3, 0x30b4, 0x30b5,
/* 28 */ 0x30b6, 0x30b7, 0x30b8, 0x30b9, 0x30ba, 0x30bb, 0x30bc, 0x30bd,
/* 30 */ 0x30be, 0x30bf, 0x30c0, 0x30c1, 0x30c2, 0x30c3, 0x30c4, 0x30c5,
/* 38 */ 0x30c6, 0x30c7, 0x30c8, 0x30c9, 0x30ca, 0x30cb, 0x30cc, 0x30cd
},

/* Row 0x029 */
{
/* 00 */ 0x30ce, 0x30cf, 0x30d0, 0x30d1, 0x30d2, 0x30d3, 0x30d4, 0x30d5,
/* 08 */ 0x30d6, 0x30d7, 0x30d8, 0x30d9, 0x30da, 0x30db, 0x30dc, 0x30dd,
/* 10 */ 0x30de, 0x30df, 0x30e0, 0x30e1, 0x30e2, 0x30e3, 0x30e4, 0x30e5,
/* 18 */ 0x30e6, 0xf6f2, 0xf6f3, 0xf6f4, 0xf6f5, 0xf6f6, 0xf6f7, 0xf6f8,
/* 20 */ 0xf6f9, 0xf6fa, 0xf6fb, 0xf6fc, 0xf6fd, 0xf6fe, 0xf6ff, 0xf700,
/* 28 */ 0xf701, 0xf702, 0xf703, 0xf704, 0xf705, 0xf706, 0xf707, 0xf708,
/* 30 */ 0xf709, 0xf70a, 0xf70b, 0xf70c, 0xf70d, 0xf70e, 0xf70f, 0xf710,
/* 38 */ 0xf711, 0xf712, 0xf713, 0xf714, 0xf715, 0xf716, 0xf717, 0xf718
},

/* Row 0x02a */
{
/* 00 */ 0xf719, 0xf71a, 0xf71b, 0xf71c, 0xf71d, 0xf71e, 0xf71f, 0xf720,
/* 08 */ 0xf721, 0xf722, 0xf723, 0xf724, 0xf725, 0xf726, 0xf727, 0xf728,
/* 10 */ 0xf729, 0xf72a, 0xf72b, 0xf72c, 0xf72d, 0xf72e, 0xf72f, 0xf730,
/* 18 */ 0x4e42, 0x4e5c, 0x51f5, 0x531a, 0x5382, 0x4e07, 0x4e0c, 0x4e47,
/* 20 */ 0x4e8d, 0x56d7, 0xfa0c, 0x5c6e, 0x5f73, 0x4e0f, 0x5187, 0x4e0e,
/* 28 */ 0x4e2e, 0x4e93, 0x4ec2, 0x4ec9, 0x4ec8, 0x5198, 0x52fc, 0x536c,
/* 30 */ 0x53b9, 0x5720, 0x5903, 0x592c, 0x5c10, 0x5dff, 0x65e1, 0x6bb3,
/* 38 */ 0x6bcc, 0x6c14, 0x723f, 0x4e31, 0x4e3c, 0x4ee8, 0x4edc, 0x4ee9
},

/* Row 0x02b */
{
/* 00 */ 0x4ee1, 0x4edd, 0x4eda, 0x520c, 0x531c, 0x534c, 0x5722, 0x5723,
/* 08 */ 0x5917, 0x592f, 0x5b81, 0x5b84, 0x5c12, 0x5c3b, 0x5c74, 0x5c73,
/* 10 */ 0x5e04, 0x5e80, 0x5e82, 0x5fc9, 0x6209, 0x6250, 0x6c15, 0x6c4c,
/* 18 */ 0x7071, 0x725e, 0x72b4, 0x72b5, 0x738e, 0x752a, 0x767f, 0x7a75,
/* 20 */ 0x7f51, 0x8278, 0x827c, 0x8280, 0x827d, 0x827f, 0x864d, 0x897e,
/* 28 */ 0x9099, 0x9097, 0x9098, 0x909b, 0x9094, 0x9622, 0x9624, 0x9620,
/* 30 */ 0x9623, 0x4f56, 0x4f3b, 0x4f62, 0x4f49, 0x4f53, 0x4f64, 0x4f3e,
/* 38 */ 0x4f67, 0x4f52, 0x4f5f, 0x4f41, 0x4f58, 0x4f2d, 0x4f33, 0x4f3f
},

/* Row 0x02c */
{
/* 00 */ 0x4f61, 0x518f, 0x51b9, 0x521c, 0x521e, 0x5221, 0x52ad, 0x52ae,
/* 08 */ 0x5309, 0x5363, 0x5372, 0x538e, 0x538f, 0x5430, 0x5437, 0x542a,
/* 10 */ 0x5454, 0x5445, 0x5419, 0x541c, 0x5425, 0x5418, 0x6759, 0x6755,
/* 18 */ 0x674c, 0x6748, 0x675d, 0x674d, 0x675a, 0x674b, 0x6bd0, 0x6c19,
/* 20 */ 0x6c1a, 0x6c78, 0x6c67, 0x6c6b, 0x6c84, 0x6c8b, 0x6c8f, 0x6c71,
/* 28 */ 0x6c6f, 0x6c69, 0x6c9a, 0x6c6d, 0x6c87, 0x6c95, 0x6c9c, 0x6c66,
/* 30 */ 0x6c73, 0x6c65, 0x6c7b, 0x6c8e, 0x7074, 0x707a, 0x7263, 0x72bf,
/* 38 */ 0x72bd, 0x72c3, 0x72c6, 0x72c1, 0x72ba, 0x72c5, 0x7395, 0x7397
},

/* Row 0x02d */
{
/* 00 */ 0x7393, 0x7394, 0x7392, 0x753a, 0x7539, 0x7594, 0x7595, 0x7681,
/* 08 */ 0x793d, 0x8034, 0x8095, 0x8099, 0x8090, 0x8092, 0x809c, 0x8290,
/* 10 */ 0x828f, 0x8285, 0x828e, 0x8291, 0x8293, 0x5768, 0x577d, 0x590c,
/* 18 */ 0x5945, 0x59b5, 0x59ba, 0x59cf, 0x59ce, 0x59b2, 0x59cc, 0x59c1,
/* 20 */ 0x59b6, 0x59bc, 0x59c3, 0x59d6, 0x59b1, 0x59bd, 0x59c0, 0x59c8,
/* 28 */ 0x59b4, 0x59c7, 0x5b62, 0x5b65, 0x5b93, 0x5b95, 0x5c44, 0x5c47,
/* 30 */ 0x5cae, 0x5ca4, 0x5ca0, 0x5cb5, 0x5caf, 0x5ca8, 0x5cac, 0x5c9f,
/* 38 */ 0x5ca3, 0x5cad, 0x5ca2, 0x5caa, 0x5ca7, 0x5c9d, 0x5ca5, 0x5cb6
},

/* Row 0x02e */
{
/* 00 */ 0x5cb0, 0x5ca6, 0x5e17, 0x5e14, 0x5e19, 0x5f28, 0x5f22, 0x5f23,
/* 08 */ 0x5f24, 0x5f54, 0x5f82, 0x5f7e, 0x5f7d, 0x5fde, 0x5fe5, 0x602d,
/* 10 */ 0x6026, 0x6019, 0x6032, 0x600b, 0x6cd2, 0x6cdd, 0x6cb4, 0x6c8a,
/* 18 */ 0x6c9d, 0x6c80, 0x6cde, 0x6cc0, 0x6d30, 0x6ccd, 0x6cc7, 0x6cb0,
/* 20 */ 0x6cf9, 0x6ccf, 0x6ce9, 0x6cd1, 0x7094, 0x7098, 0x7085, 0x7093,
/* 28 */ 0x7086, 0x7084, 0x7091, 0x7096, 0x7082, 0x709a, 0x7083, 0x726a,
/* 30 */ 0x72d6, 0x72cb, 0x72d8, 0x72c9, 0x72dc, 0x72d2, 0x72d4, 0x72da,
/* 38 */ 0x72cc, 0x72d1, 0x73a4, 0x73a1, 0x73ad, 0x73a6, 0x73a2, 0x73a0
},

/* Row 0x02f */
{
/* 00 */ 0x73ac, 0x739d, 0x74dd, 0x74e8, 0x753f, 0x7540, 0x753e, 0x758c,
/* 08 */ 0x7598, 0x76af, 0x76f3, 0x76f1, 0x76f0, 0x76f5, 0x77f8, 0x77fc,
/* 10 */ 0x77f9, 0x77fb, 0x77fa, 0x54c3, 0x830d, 0x54b7, 0x54ae, 0x54d6,
/* 18 */ 0x54b6, 0x54c5, 0x54c6, 0x54a0, 0x5470, 0x54bc, 0x54a2, 0x54be,
/* 20 */ 0x5472, 0x54de, 0x54b0, 0x57b5, 0x579e, 0x579f, 0x57a4, 0x578c,
/* 28 */ 0x5797, 0x579d, 0x579b, 0x5794, 0x5798, 0x578f, 0x5799, 0x57a5,
/* 30 */ 0x579a, 0x5795, 0x58f4, 0x590d, 0x5953, 0x59e1, 0x59de, 0x59ee,
/* 38 */ 0x5a00, 0x59f1, 0x59dd, 0x59fa, 0x59fd, 0x59fc, 0x59f6, 0x59e4
},

/* Row 0x030 */
{
/* 00 */ 0x59f2, 0x59f7, 0x59db, 0x59e9, 0x59f3, 0x59f5, 0x59e0, 0x59fe,
/* 08 */ 0x59f4, 0x59ed, 0x5ba8, 0x5c4c, 0x5cd0, 0x5cd8, 0x5ccc, 0x5cd7,
/* 10 */ 0x5ccb, 0x5cdb, 0x67dc, 0x67bb, 0x67f8, 0x67d8, 0x67c0, 0x67b7,
/* 18 */ 0x67c5, 0x67eb, 0x67e4, 0x67df, 0x67b5, 0x67cd, 0x67b3, 0x67f7,
/* 20 */ 0x67f6, 0x67ee, 0x67e3, 0x67c2, 0x67b9, 0x67ce, 0x67e7, 0x67f0,
/* 28 */ 0x67b2, 0x67fc, 0x67c6, 0x67ed, 0x67cc, 0x67ae, 0x67e6, 0x67db,
/* 30 */ 0x67fa, 0x67c9, 0x67ca, 0x67c3, 0x67ea, 0x67cb, 0x6b28, 0x6b82,
/* 38 */ 0x6b84, 0x6bb6, 0x6bd6, 0x6bd8, 0x6be0, 0x6c20, 0x6c21, 0x6d28
},

/* Row 0x031 */
{
/* 00 */ 0x6d34, 0x6d2d, 0x6d1f, 0x6d3c, 0x6d3f, 0x6d12, 0x6d0a, 0x6cda,
/* 08 */ 0x6d33, 0x6d04, 0x6d19, 0x6d3a, 0x6d1a, 0x6d11, 0x6d00, 0x6d1d,
/* 10 */ 0x6d42, 0x7a7e, 0x7ad1, 0x7b00, 0x7b01, 0x7c7a, 0x7c78, 0x7c79,
/* 18 */ 0x7c7f, 0x7c80, 0x7c81, 0x7d03, 0x7d08, 0x7d01, 0x7f58, 0x7f91,
/* 20 */ 0x7f8d, 0x7fbe, 0x8007, 0x800e, 0x800f, 0x8014, 0x8037, 0x80d8,
/* 28 */ 0x80c7, 0x80e0, 0x80d1, 0x80c8, 0x80c2, 0x80d0, 0x80c5, 0x80e3,
/* 30 */ 0x80d9, 0x80dc, 0x80ca, 0x80d5, 0x80c9, 0x80cf, 0x80d7, 0x80e6,
/* 38 */ 0x80cd, 0x81ff, 0x8221, 0x8294, 0x82d9, 0x82fe, 0x82f9, 0x8307
},

/* Row 0x032 */
{
/* 00 */ 0x82e8, 0x8300, 0x82d5, 0x833a, 0x82eb, 0x82d6, 0x82f4, 0x82ec,
/* 08 */ 0x82e1, 0x82f2, 0x82f5, 0x830c, 0x82fb, 0x82f6, 0x82f0, 0x82ea,
/* 10 */ 0x550a, 0x54fb, 0x54f7, 0x54f8, 0x54e0, 0x550e, 0x5503, 0x550b,
/* 18 */ 0x5701, 0x5702, 0x57cc, 0x5832, 0x57d5, 0x57d2, 0x57ba, 0x57c6,
/* 20 */ 0x57bd, 0x57bc, 0x57b8, 0x57b6, 0x57bf, 0x57c7, 0x57d0, 0x57b9,
/* 28 */ 0x57c1, 0x590e, 0x594a, 0x5a19, 0x5a16, 0x5a2d, 0x5a2e, 0x5a15,
/* 30 */ 0x5a0f, 0x5a17, 0x5a0a, 0x5a1e, 0x5a33, 0x5b6c, 0x5ba7, 0x5bad,
/* 38 */ 0x5bac, 0x5c03, 0x5c56, 0x5c54, 0x5cec, 0x5cff, 0x5cee, 0x5cf1
},

/* Row 0x033 */
{
/* 00 */ 0x5cf7, 0x5d00, 0x5cf9, 0x5e29, 0x5e28, 0x5ea8, 0x5eae, 0x5eaa,
/* 08 */ 0x5eac, 0x5f33, 0x5f30, 0x5f67, 0x605d, 0x605a, 0x6067, 0x6be8,
/* 10 */ 0x6be3, 0x6be2, 0x6be7, 0x6c25, 0x6d7a, 0x6d63, 0x6d64, 0x6d76,
/* 18 */ 0x6d0d, 0x6d61, 0x6d92, 0x6d58, 0x6d62, 0x6d6d, 0x6d6f, 0x6d91,
/* 20 */ 0x6d8d, 0x6def, 0x6d7f, 0x6d86, 0x6d5e, 0x6d67, 0x6d60, 0x6d97,
/* 28 */ 0x6d70, 0x6d7c, 0x6d5f, 0x6d82, 0x6d98, 0x6d2f, 0x6d68, 0x6d8b,
/* 30 */ 0x6d7e, 0x6d80, 0x6d84, 0x6d16, 0x6d83, 0x6d7b, 0x6d7d, 0x6d75,
/* 38 */ 0x6d90, 0x70dc, 0x70d3, 0x70d1, 0x70dd, 0x70cb, 0x7f39, 0x70e2
},

/* Row 0x034 */
{
/* 00 */ 0x70d7, 0x70d2, 0x70de, 0x70e0, 0x70d4, 0x70cd, 0x70c5, 0x70c6,
/* 08 */ 0x70c7, 0x70da, 0x70ce, 0x70e1, 0x7242, 0x7278, 0x7b04, 0x7b13,
/* 10 */ 0x7b05, 0x7b0f, 0x7b08, 0x7b0a, 0x7b0e, 0x7b09, 0x7b12, 0x7c84,
/* 18 */ 0x7c91, 0x7c8a, 0x7c8c, 0x7c88, 0x7c8d, 0x7c85, 0x7d1e, 0x7d1d,
/* 20 */ 0x7d11, 0x7d0e, 0x7d18, 0x7d16, 0x7d13, 0x7d1f, 0x7d12, 0x7d0f,
/* 28 */ 0x7d0c, 0x7f5c, 0x7f61, 0x7f5e, 0x7f60, 0x7f5d, 0x7f5b, 0x7f96,
/* 30 */ 0x7f92, 0x7fc3, 0x7fc2, 0x7fc0, 0x8016, 0x803e, 0x8039, 0x80fa,
/* 38 */ 0x80f2, 0x80f9, 0x80f5, 0x8101, 0x80fb, 0x8100, 0x8201, 0x822f
},

/* Row 0x035 */
{
/* 00 */ 0x8225, 0x8333, 0x832d, 0x8344, 0x8319, 0x8351, 0x8325, 0x8356,
/* 08 */ 0x833f, 0x8341, 0x8326, 0x831c, 0x8322, 0x914e, 0x914f, 0x91d5,
/* 10 */ 0x91e2, 0x91da, 0x965c, 0x965f, 0x96bc, 0x98e3, 0x9adf, 0x9b2f,
/* 18 */ 0x4e7f, 0x5070, 0x506a, 0x5061, 0x505e, 0x5060, 0x5053, 0x504b,
/* 20 */ 0x505d, 0x5072, 0x5048, 0x504d, 0x5041, 0x505b, 0x504a, 0x5062,
/* 28 */ 0x5015, 0x5045, 0x505f, 0x5069, 0x506b, 0x5063, 0x5064, 0x5046,
/* 30 */ 0x5040, 0x506e, 0x5073, 0x5057, 0x5051, 0x51d0, 0x526b, 0x526d,
/* 38 */ 0x526c, 0x526e, 0x52d6, 0x52d3, 0x532d, 0x539c, 0x5575, 0x5576
},

/* Row 0x036 */
{
/* 00 */ 0x553c, 0x554d, 0x5550, 0x5534, 0x552a, 0x5551, 0x5562, 0x5536,
/* 08 */ 0x5535, 0x5530, 0x5552, 0x5545, 0x5d30, 0x5d12, 0x5d23, 0x5d1f,
/* 10 */ 0x5d2e, 0x5e3e, 0x5e34, 0x5eb1, 0x5eb4, 0x5eb9, 0x5eb2, 0x5eb3,
/* 18 */ 0x5f36, 0x5f38, 0x5f9b, 0x5f96, 0x5f9f, 0x608a, 0x6090, 0x6086,
/* 20 */ 0x60be, 0x60b0, 0x60ba, 0x60d3, 0x60d4, 0x60cf, 0x60e4, 0x60d9,
/* 28 */ 0x60dd, 0x60c8, 0x60b1, 0x60db, 0x60b7, 0x60ca, 0x60bf, 0x60c3,
/* 30 */ 0x60cd, 0x60c0, 0x6332, 0x6365, 0x638a, 0x6382, 0x637d, 0x63bd,
/* 38 */ 0x639e, 0x63ad, 0x639d, 0x6397, 0x63ab, 0x638e, 0x636f, 0x6387
},

/* Row 0x037 */
{
/* 00 */ 0x6390, 0x636e, 0x63af, 0x6375, 0x639c, 0x636d, 0x63ae, 0x637c,
/* 08 */ 0x63a4, 0x633b, 0x639f, 0x6dd0, 0x6df2, 0x6dd3, 0x6dfd, 0x6dd7,
/* 10 */ 0x6dcd, 0x6de3, 0x6dbb, 0x70fa, 0x710d, 0x70f7, 0x7117, 0x70f4,
/* 18 */ 0x710c, 0x70f0, 0x7104, 0x70f3, 0x7110, 0x70fc, 0x70ff, 0x7106,
/* 20 */ 0x7113, 0x7100, 0x70f8, 0x70f6, 0x710b, 0x7102, 0x710e, 0x727e,
/* 28 */ 0x727b, 0x727c, 0x727f, 0x731d, 0x7317, 0x7307, 0x7311, 0x7318,
/* 30 */ 0x730a, 0x7308, 0x72ff, 0x730f, 0x731e, 0x7388, 0x73f6, 0x73f8,
/* 38 */ 0x73f5, 0x7404, 0x7401, 0x73fd, 0x7407, 0x7400, 0x73fa, 0x73fc
},

/* Row 0x038 */
{
/* 00 */ 0x73ff, 0x740c, 0x740b, 0x73f4, 0x7408, 0x7564, 0x7563, 0x75ce,
/* 08 */ 0x75d2, 0x75cf, 0x801e, 0x801b, 0x8047, 0x8043, 0x8048, 0x8118,
/* 10 */ 0x8125, 0x8119, 0x811b, 0x812d, 0x811f, 0x812c, 0x811e, 0x8121,
/* 18 */ 0x8115, 0x8127, 0x811d, 0x8122, 0x8211, 0x8238, 0x8233, 0x823a,
/* 20 */ 0x8234, 0x8232, 0x8274, 0x8390, 0x83a3, 0x83a8, 0x838d, 0x837a,
/* 28 */ 0x8373, 0x83a4, 0x8374, 0x838f, 0x8381, 0x8395, 0x8399, 0x8375,
/* 30 */ 0x8394, 0x83a9, 0x837d, 0x8383, 0x838c, 0x839d, 0x839b, 0x83aa,
/* 38 */ 0x838b, 0x837e, 0x83a5, 0x83af, 0x8388, 0x8397, 0x83b0, 0x837f
},

/* Row 0x039 */
{
/* 00 */ 0x83a6, 0x8387, 0x83ae, 0x8376, 0x839a, 0x8659, 0x8656, 0x86bf,
/* 08 */ 0x86b7, 0x91eb, 0x91f7, 0x91e8, 0x91ee, 0x957a, 0x9586, 0x9588,
/* 10 */ 0x967c, 0x966d, 0x966b, 0x9671, 0x966f, 0x96bf, 0x976a, 0x9804,
/* 18 */ 0x98e5, 0x9997, 0x509b, 0x5095, 0x5094, 0x509e, 0x508b, 0x50a3,
/* 20 */ 0x5083, 0x508c, 0x508e, 0x509d, 0x5068, 0x509c, 0x5092, 0x5082,
/* 28 */ 0x5087, 0x515f, 0x51d4, 0x5312, 0x5311, 0x53a4, 0x53a7, 0x5591,
/* 30 */ 0x55a8, 0x55a5, 0x55ad, 0x5577, 0x5645, 0x55a2, 0x5593, 0x5588,
/* 38 */ 0x558f, 0x55b5, 0x5581, 0x55a3, 0x5592, 0x55a4, 0x557d, 0x558c
},

/* Row 0x03a */
{
/* 00 */ 0x55a6, 0x557f, 0x5595, 0x55a1, 0x558e, 0x570c, 0x5829, 0x5837,
/* 08 */ 0x60f2, 0x610a, 0x6116, 0x6105, 0x60f5, 0x6113, 0x60f8, 0x60fc,
/* 10 */ 0x60fe, 0x60c1, 0x6103, 0x6118, 0x611d, 0x6110, 0x60ff, 0x6104,
/* 18 */ 0x610b, 0x624a, 0x6394, 0x63b1, 0x63b0, 0x63ce, 0x63e5, 0x63e8,
/* 20 */ 0x63ef, 0x63c3, 0x649d, 0x63f3, 0x63ca, 0x63e0, 0x63f6, 0x63d5,
/* 28 */ 0x63f2, 0x63f5, 0x6461, 0x63df, 0x63be, 0x63dd, 0x63dc, 0x63c4,
/* 30 */ 0x63d8, 0x63d3, 0x63c2, 0x63c7, 0x63cc, 0x63cb, 0x63c8, 0x63f0,
/* 38 */ 0x63d7, 0x63d9, 0x6532, 0x6567, 0x656a, 0x6564, 0x655c, 0x6568
},

/* Row 0x03b */
{
/* 00 */ 0x6565, 0x658c, 0x659d, 0x659e, 0x65ae, 0x65d0, 0x65d2, 0x6e68,
/* 08 */ 0x6e5c, 0x6e61, 0x6e31, 0x6e28, 0x6e60, 0x6e71, 0x6e6b, 0x6e39,
/* 10 */ 0x6e22, 0x6e30, 0x6e53, 0x6e65, 0x6e27, 0x6e78, 0x6e64, 0x6e77,
/* 18 */ 0x6e55, 0x6e79, 0x6e52, 0x6e66, 0x6e35, 0x6e36, 0x6e5a, 0x7120,
/* 20 */ 0x711e, 0x712f, 0x70fb, 0x712e, 0x7131, 0x7123, 0x7125, 0x7122,
/* 28 */ 0x7132, 0x711f, 0x7128, 0x713a, 0x711b, 0x724b, 0x725a, 0x7288,
/* 30 */ 0x7289, 0x7286, 0x7285, 0x728b, 0x7312, 0x730b, 0x7330, 0x7322,
/* 38 */ 0x7331, 0x7333, 0x7327, 0x7332, 0x732d, 0x7326, 0x7323, 0x7335
},

/* Row 0x03c */
{
/* 00 */ 0x730c, 0x742e, 0x742c, 0x7430, 0x742b, 0x7416, 0x7f66, 0x7fa2,
/* 08 */ 0x7fa0, 0x7fa1, 0x7fd7, 0x8051, 0x804f, 0x8050, 0x80fe, 0x80d4,
/* 10 */ 0x8143, 0x814a, 0x8152, 0x814f, 0x8147, 0x813d, 0x814d, 0x813a,
/* 18 */ 0x81e6, 0x81ee, 0x81f7, 0x81f8, 0x81f9, 0x8204, 0x823c, 0x823d,
/* 20 */ 0x823f, 0x8275, 0x833b, 0x83cf, 0x83f9, 0x8423, 0x83c0, 0x83e8,
/* 28 */ 0x8412, 0x83e7, 0x83e4, 0x83fc, 0x83f6, 0x8410, 0x83c6, 0x83c8,
/* 30 */ 0x83eb, 0x83e3, 0x83bf, 0x8401, 0x83dd, 0x83e5, 0x83d8, 0x83ff,
/* 38 */ 0x83e1, 0x83cb, 0x83ce, 0x83d6, 0x83f5, 0x83c9, 0x8409, 0x840f
},

/* Row 0x03d */
{
/* 00 */ 0x83de, 0x8411, 0x8406, 0x83c2, 0x83f3, 0x8ef9, 0x8ee6, 0x8eee,
/* 08 */ 0x8ee5, 0x8ef5, 0x8ee7, 0x8ee8, 0x8ef6, 0x8eeb, 0x8ef1, 0x8eec,
/* 10 */ 0x8ef4, 0x8ee9, 0x902d, 0x9034, 0x902f, 0x9106, 0x912c, 0x9104,
/* 18 */ 0x90ff, 0x90fc, 0x9108, 0x90f9, 0x90fb, 0x9101, 0x9100, 0x9107,
/* 20 */ 0x9105, 0x9103, 0x9161, 0x9164, 0x915f, 0x9162, 0x9160, 0x9201,
/* 28 */ 0x920a, 0x9225, 0x9203, 0x921a, 0x9226, 0x920f, 0x920c, 0x9200,
/* 30 */ 0x9212, 0x91ff, 0x91fd, 0x9206, 0x9204, 0x9227, 0x9202, 0x921c,
/* 38 */ 0x9224, 0x9219, 0x9217, 0x9205, 0x9216, 0x957b, 0x958d, 0x958c
},

/* Row 0x03e */
{
/* 00 */ 0x9590, 0x9687, 0x967e, 0x9688, 0x5ab7, 0x5ac0, 0x5aca, 0x5ab4,
/* 08 */ 0x5ab6, 0x5acd, 0x5ab9, 0x5a90, 0x5bd6, 0x5bd8, 0x5bd9, 0x5c1f,
/* 10 */ 0x5c33, 0x5d71, 0x5d63, 0x5d4a, 0x5d65, 0x5d72, 0x5d6c, 0x5d5e,
/* 18 */ 0x5d68, 0x5d67, 0x5d62, 0x5df0, 0x5e4f, 0x5e4e, 0x5e4a, 0x5e4d,
/* 20 */ 0x5e4b, 0x5ec5, 0x5ecc, 0x5ec6, 0x5ecb, 0x5ec7, 0x5f40, 0x5faf,
/* 28 */ 0x5fad, 0x60f7, 0x6149, 0x614a, 0x612b, 0x6145, 0x6136, 0x6132,
/* 30 */ 0x612e, 0x6146, 0x612f, 0x614f, 0x6129, 0x6140, 0x6220, 0x9168,
/* 38 */ 0x6223, 0x6225, 0x6224, 0x63c5, 0x63f1, 0x63eb, 0x6410, 0x6412
},

/* Row 0x03f */
{
/* 00 */ 0x6409, 0x6420, 0x6424, 0x6bf9, 0x6bf7, 0x6bf8, 0x6e9b, 0x6ed6,
/* 08 */ 0x6ec8, 0x6e8f, 0x6ec0, 0x6e9f, 0x6e93, 0x6e94, 0x6ea0, 0x6eb1,
/* 10 */ 0x6eb9, 0x6ec6, 0x6ed2, 0x6ebd, 0x6ec1, 0x6e9e, 0x6ec9, 0x6eb7,
/* 18 */ 0x6eb0, 0x6ecd, 0x6ea6, 0x6ecf, 0x6eb2, 0x6ebe, 0x6ec3, 0x6edc,
/* 20 */ 0x6ed8, 0x6e99, 0x6e92, 0x6e8e, 0x6e8d, 0x6ea4, 0x6ea1, 0x6ebf,
/* 28 */ 0x6eb3, 0x6ed0, 0x6eca, 0x6e97, 0x6eae, 0x6ea3, 0x7147, 0x7154,
/* 30 */ 0x7152, 0x7163, 0x7160, 0x7141, 0x715d, 0x7162, 0x7172, 0x7178,
/* 38 */ 0x716a, 0x7161, 0x7142, 0x7158, 0x7143, 0x714b, 0x7170, 0x715f
},

/* Row 0x040 */
{
/* 00 */ 0x7150, 0x7153, 0x7a1b, 0x7a10, 0x7aa3, 0x7aa2, 0x7a9e, 0x7aeb,
/* 08 */ 0x7b66, 0x7b64, 0x7b6d, 0x7b74, 0x7b69, 0x7b72, 0x7b65, 0x7b73,
/* 10 */ 0x7b71, 0x7b70, 0x7b61, 0x7b78, 0x7b76, 0x7b63, 0x7cb2, 0x7cb4,
/* 18 */ 0x7caf, 0x7d88, 0x7d86, 0x7d80, 0x7d8d, 0x7d7f, 0x7d85, 0x7d7a,
/* 20 */ 0x7d8e, 0x7d7b, 0x7d83, 0x7d7c, 0x7d8c, 0x7d94, 0x7d84, 0x7d7d,
/* 28 */ 0x7d92, 0x7f6d, 0x7f6b, 0x7f67, 0x7f68, 0x7f6c, 0x7fa6, 0x7fa5,
/* 30 */ 0x7fa7, 0x7fdb, 0x7fdc, 0x8021, 0x8164, 0x8160, 0x8177, 0x815c,
/* 38 */ 0x8169, 0x815b, 0x8162, 0x8172, 0x6721, 0x815e, 0x8176, 0x8167
},

/* Row 0x041 */
{
/* 00 */ 0x816f, 0x89e1, 0x89e0, 0x89e2, 0x89dc, 0x89e6, 0x8a76, 0x8a86,
/* 08 */ 0x8a7f, 0x8a61, 0x8a3f, 0x8a77, 0x8a82, 0x8a84, 0x8a75, 0x8a83,
/* 10 */ 0x8a81, 0x8a74, 0x8a7a, 0x8c3c, 0x8c4b, 0x8c4a, 0x8c65, 0x8c64,
/* 18 */ 0x8c66, 0x8c86, 0x8c84, 0x8c85, 0x8ccc, 0x8d68, 0x8d69, 0x8d91,
/* 20 */ 0x8d8c, 0x8d8e, 0x8d8f, 0x8d8d, 0x8d93, 0x8d94, 0x8d90, 0x8d92,
/* 28 */ 0x8df0, 0x8de0, 0x8dec, 0x8df1, 0x8dee, 0x8dd0, 0x8de9, 0x8de3,
/* 30 */ 0x8de2, 0x8de7, 0x8df2, 0x8deb, 0x8df4, 0x8f06, 0x8eff, 0x8f01,
/* 38 */ 0x8f00, 0x8f05, 0x8f07, 0x8f08, 0x8f02, 0x8f0b, 0x9052, 0x903f
},

/* Row 0x042 */
{
/* 00 */ 0x51d8, 0x5280, 0x5281, 0x52e9, 0x52eb, 0x5330, 0x53ac, 0x5627,
/* 08 */ 0x5615, 0x560c, 0x5612, 0x55fc, 0x560f, 0x561c, 0x5601, 0x5613,
/* 10 */ 0x5602, 0x55fa, 0x561d, 0x5604, 0x55ff, 0x55f9, 0x5889, 0x587c,
/* 18 */ 0x5890, 0x5898, 0x5886, 0x5881, 0x587f, 0x5874, 0x588b, 0x587a,
/* 20 */ 0x5887, 0x5891, 0x588e, 0x5876, 0x5882, 0x5888, 0x587b, 0x5894,
/* 28 */ 0x588f, 0x58fe, 0x596b, 0x5adc, 0x5aee, 0x5ae5, 0x5ad5, 0x5aea,
/* 30 */ 0x5ada, 0x5aed, 0x5aeb, 0x5af3, 0x5ae2, 0x5ae0, 0x5adb, 0x5aec,
/* 38 */ 0x5ade, 0x5add, 0x5ad9, 0x5ae8, 0x5adf, 0x5b77, 0x5be0, 0x69a0
},

/* Row 0x043 */
{
/* 00 */ 0x69ce, 0x6996, 0x69b0, 0x69ac, 0x69bc, 0x6991, 0x6999, 0x698e,
/* 08 */ 0x69a7, 0x698d, 0x69a9, 0x69be, 0x69af, 0x69bf, 0x69c4, 0x69bd,
/* 10 */ 0x69a4, 0x69d4, 0x69b9, 0x69ca, 0x699a, 0x69cf, 0x69b3, 0x6993,
/* 18 */ 0x69aa, 0x69a1, 0x699e, 0x69d9, 0x6997, 0x6990, 0x69c2, 0x69b5,
/* 20 */ 0x69a5, 0x69c6, 0x6b4a, 0x6b4d, 0x6b4b, 0x6b9e, 0x6b9f, 0x6ba0,
/* 28 */ 0x6bc3, 0x6bc4, 0x6bfe, 0x6ece, 0x6ef5, 0x6ef1, 0x6f03, 0x6f25,
/* 30 */ 0x6ef8, 0x6f37, 0x6efb, 0x6f2e, 0x6f09, 0x6f4e, 0x6f19, 0x6f1a,
/* 38 */ 0x6f27, 0x6f18, 0x6f3b, 0x6f12, 0x6eed, 0x6f0a, 0x7997, 0x7988
},

/* Row 0x044 */
{
/* 00 */ 0x7992, 0x7990, 0x7a2b, 0x7a4a, 0x7a30, 0x7a2f, 0x7a28, 0x7a26,
/* 08 */ 0x7aa8, 0x7aab, 0x7aac, 0x7aee, 0x7b88, 0x7b9c, 0x7b8a, 0x7b91,
/* 10 */ 0x7b90, 0x7b96, 0x7b8d, 0x7b8c, 0x7b9b, 0x7b8e, 0x7b85, 0x7b98,
/* 18 */ 0x5284, 0x7b99, 0x7ba4, 0x7b82, 0x7cbb, 0x7cbf, 0x7cbc, 0x7cba,
/* 20 */ 0x7da7, 0x7db7, 0x7dc2, 0x7da3, 0x7daa, 0x7dc1, 0x7dc0, 0x7dc5,
/* 28 */ 0x7d9d, 0x7dce, 0x7dc4, 0x7dc6, 0x7dcb, 0x7dcc, 0x7daf, 0x7db9,
/* 30 */ 0x7d96, 0x7dbc, 0x7d9f, 0x7da6, 0x7dae, 0x7da9, 0x7da1, 0x7dc9,
/* 38 */ 0x7f73, 0x7fe2, 0x7fe3, 0x7fe5, 0x7fde, 0x88f0, 0x88ec, 0x88eb
},

/* Row 0x045 */
{
/* 00 */ 0x899d, 0x89a1, 0x899f, 0x899e, 0x89e9, 0x89eb, 0x89e8, 0x8aab,
/* 08 */ 0x8a99, 0x8a8b, 0x8a92, 0x8a8f, 0x8a96, 0x8c3d, 0x8c68, 0x8c69,
/* 10 */ 0x8cd5, 0x8ccf, 0x8cd7, 0x8d96, 0x8e09, 0x8e02, 0x8dff, 0x8e0d,
/* 18 */ 0x8dfd, 0x8e0a, 0x8e03, 0x8e07, 0x8e06, 0x8e05, 0x8dfe, 0x8e00,
/* 20 */ 0x8e04, 0x8f10, 0x8f11, 0x8f0e, 0x8f0d, 0x9123, 0x911c, 0x9120,
/* 28 */ 0x9122, 0x911f, 0x911d, 0x911a, 0x9124, 0x9121, 0x911b, 0x917a,
/* 30 */ 0x9172, 0x9179, 0x9173, 0x92a5, 0x92a4, 0x9276, 0x929b, 0x927a,
/* 38 */ 0x92a0, 0x9294, 0x92aa, 0x928d, 0x565a, 0x5640, 0x5633, 0x563d
},

/* Row 0x046 */
{
/* 00 */ 0x562c, 0x563e, 0x5638, 0x562a, 0x563a, 0x571a, 0x58ab, 0x589d,
/* 08 */ 0x58b1, 0x58a0, 0x58a3, 0x58af, 0x58ac, 0x58a5, 0x58a1, 0x58ff,
/* 10 */ 0x5aff, 0x5af4, 0x5afd, 0x5af7, 0x5af6, 0x5b03, 0x5af8, 0x5b02,
/* 18 */ 0x5af9, 0x5b01, 0x5b07, 0x5b05, 0x5b0f, 0x5c67, 0x5d99, 0x5d97,
/* 20 */ 0x5d9f, 0x5d92, 0x5da2, 0x5d93, 0x5d95, 0x5da0, 0x5d9c, 0x5da1,
/* 28 */ 0x5d9a, 0x5d9e, 0x5e69, 0x5e5d, 0x5e60, 0x5e5c, 0x7df3, 0x5edb,
/* 30 */ 0x5ede, 0x5ee1, 0x5f49, 0x5fb2, 0x618b, 0x6183, 0x6179, 0x61b1,
/* 38 */ 0x61b0, 0x61a2, 0x6189, 0x6f8d, 0x6f89, 0x6f8c, 0x6f62, 0x6f4f
},

/* Row 0x047 */
{
/* 00 */ 0x6f85, 0x6f5a, 0x6f96, 0x6f76, 0x6f6c, 0x6f82, 0x6f55, 0x6f72,
/* 08 */ 0x6f52, 0x6f50, 0x6f57, 0x6f94, 0x6f93, 0x6f5d, 0x6f00, 0x6f61,
/* 10 */ 0x6f6b, 0x6f7d, 0x6f67, 0x6f90, 0x6f53, 0x6f8b, 0x6f69, 0x6f7f,
/* 18 */ 0x6f95, 0x6f63, 0x6f77, 0x6f6a, 0x6f7b, 0x71b2, 0x71af, 0x719b,
/* 20 */ 0x71b0, 0x71a0, 0x719a, 0x71a9, 0x71b5, 0x719d, 0x71a5, 0x719e,
/* 28 */ 0x71a4, 0x71a1, 0x71aa, 0x719c, 0x71a7, 0x71b3, 0x7298, 0x729a,
/* 30 */ 0x7358, 0x7352, 0x735e, 0x735f, 0x7360, 0x735d, 0x735b, 0x7361,
/* 38 */ 0x735a, 0x7359, 0x819e, 0x8195, 0x81a2, 0x8199, 0x8197, 0x8216
},

/* Row 0x048 */
{
/* 00 */ 0x824f, 0x8253, 0x8252, 0x8250, 0x824e, 0x8251, 0x8524, 0x853b,
/* 08 */ 0x850f, 0x8500, 0x8529, 0x850e, 0x8509, 0x850d, 0x851f, 0x850a,
/* 10 */ 0x8527, 0x851c, 0x84fb, 0x852b, 0x84fa, 0x8508, 0x850c, 0x84f4,
/* 18 */ 0x852a, 0x84f2, 0x8515, 0x84f7, 0x84eb, 0x84f3, 0x84fc, 0x8512,
/* 20 */ 0x84ea, 0x84e9, 0x8516, 0x84fe, 0x8528, 0x851d, 0x852e, 0x8502,
/* 28 */ 0x84fd, 0x851e, 0x84f6, 0x8531, 0x8526, 0x84e7, 0x84e8, 0x84f0,
/* 30 */ 0x84ef, 0x84f9, 0x8518, 0x8520, 0x8530, 0x850b, 0x8519, 0x852f,
/* 38 */ 0x8662, 0x8e14, 0x8e12, 0x8e18, 0x8e13, 0x8e1c, 0x8e17, 0x8e1a
},

/* Row 0x049 */
{
/* 00 */ 0x8f2c, 0x8f24, 0x8f18, 0x8f1a, 0x8f20, 0x8f23, 0x8f16, 0x8f17,
/* 08 */ 0x9073, 0x9070, 0x906f, 0x9067, 0x906b, 0x912f, 0x912b, 0x9129,
/* 10 */ 0x912a, 0x9132, 0x9126, 0x912e, 0x9185, 0x9186, 0x918a, 0x9181,
/* 18 */ 0x9182, 0x9184, 0x9180, 0x92d0, 0x92c3, 0x92c4, 0x92c0, 0x92d9,
/* 20 */ 0x92b6, 0x92cf, 0x92f1, 0x92df, 0x92d8, 0x92e9, 0x92d7, 0x92dd,
/* 28 */ 0x92cc, 0x92ef, 0x92c2, 0x92e8, 0x92ca, 0x92c8, 0x92ce, 0x92e6,
/* 30 */ 0x92cd, 0x92d5, 0x92c9, 0x92e0, 0x92de, 0x92e7, 0x92d1, 0x92d3,
/* 38 */ 0x5673, 0x5666, 0x5663, 0x566d, 0x5672, 0x565e, 0x5677, 0x571c
},

/* Row 0x04a */
{
/* 00 */ 0x571b, 0x58c8, 0x58bd, 0x58c9, 0x58bf, 0x58ba, 0x58c2, 0x58bc,
/* 08 */ 0x58c6, 0x5b17, 0x5b19, 0x5b1b, 0x5b21, 0x5b14, 0x5b13, 0x5b10,
/* 10 */ 0x5b16, 0x5b28, 0x5b1a, 0x5b20, 0x5b1e, 0x5bef, 0x5dac, 0x5db1,
/* 18 */ 0x5da9, 0x5da7, 0x5db5, 0x5db0, 0x5dae, 0x5daa, 0x5da8, 0x5db2,
/* 20 */ 0x5dad, 0x5daf, 0x5db4, 0x5e67, 0x5e68, 0x5e66, 0x5e6f, 0x5ee9,
/* 28 */ 0x5ee7, 0x5ee6, 0x5ee8, 0x5ee5, 0x5f4b, 0x5fbc, 0x619d, 0x61a8,
/* 30 */ 0x6196, 0x61c5, 0x61b4, 0x61c6, 0x61c1, 0x61cc, 0x61ba, 0x6fa2,
/* 38 */ 0x6fc9, 0x6fab, 0x6fcd, 0x6faf, 0x6fb2, 0x6fb0, 0x71c5, 0x71c2
},

/* Row 0x04b */
{
/* 00 */ 0x71bf, 0x71b8, 0x71d6, 0x71c0, 0x71c1, 0x71cb, 0x71d4, 0x71ca,
/* 08 */ 0x71c7, 0x71cf, 0x71bd, 0x71d8, 0x71bc, 0x71c6, 0x71da, 0x71db,
/* 10 */ 0x729d, 0x729e, 0x7369, 0x7366, 0x7367, 0x736c, 0x7365, 0x736b,
/* 18 */ 0x736a, 0x747f, 0x749a, 0x74a0, 0x7494, 0x7492, 0x7495, 0x74a1,
/* 20 */ 0x750b, 0x7580, 0x762f, 0x762d, 0x7631, 0x763d, 0x7633, 0x763c,
/* 28 */ 0x7635, 0x7632, 0x7630, 0x76bb, 0x76e6, 0x779a, 0x779d, 0x77a1,
/* 30 */ 0x779c, 0x779b, 0x77a2, 0x77a3, 0x7795, 0x7799, 0x8540, 0x8546,
/* 38 */ 0x8564, 0x8541, 0x8562, 0x8544, 0x8551, 0x8547, 0x8563, 0x853e
},

/* Row 0x04c */
{
/* 00 */ 0x855b, 0x8571, 0x854e, 0x856e, 0x8575, 0x8555, 0x8567, 0x8560,
/* 08 */ 0x858c, 0x8566, 0x855d, 0x8554, 0x8565, 0x856c, 0x8663, 0x8665,
/* 10 */ 0x8664, 0x879b, 0x878f, 0x8797, 0x8793, 0x8792, 0x8788, 0x8781,
/* 18 */ 0x8796, 0x8798, 0x8779, 0x8787, 0x87a3, 0x8785, 0x8790, 0x8791,
/* 20 */ 0x879d, 0x8784, 0x8794, 0x879c, 0x879a, 0x8789, 0x891e, 0x8926,
/* 28 */ 0x8930, 0x892d, 0x892e, 0x8927, 0x8931, 0x8922, 0x8929, 0x8923,
/* 30 */ 0x892f, 0x892c, 0x891f, 0x89f1, 0x8ae0, 0x930b, 0x92fe, 0x9309,
/* 38 */ 0x9300, 0x92fb, 0x9316, 0x95bc, 0x95cd, 0x95be, 0x95b9, 0x95ba
},

/* Row 0x04d */
{
/* 00 */ 0x95b6, 0x95bf, 0x95b5, 0x95bd, 0x96a9, 0x96d4, 0x970b, 0x9712,
/* 08 */ 0x9710, 0x9799, 0x9797, 0x9794, 0x97f0, 0x97f8, 0x9835, 0x982f,
/* 10 */ 0x9832, 0x9924, 0x991f, 0x9927, 0x9929, 0x999e, 0x99ee, 0x99ec,
/* 18 */ 0x99e5, 0x99e4, 0x99f0, 0x99e3, 0x99ea, 0x99e9, 0x99e7, 0x9ab9,
/* 20 */ 0x9abf, 0x9ab4, 0x9abb, 0x9af6, 0x9afa, 0x9af9, 0x9af7, 0x9b33,
/* 28 */ 0x9b80, 0x9b85, 0x9b87, 0x9b7c, 0x9b7e, 0x9b7b, 0x9b82, 0x9b93,
/* 30 */ 0x9b92, 0x9b90, 0x9b7a, 0x9b95, 0x6a95, 0x6a83, 0x6aa8, 0x6aa4,
/* 38 */ 0x6a91, 0x6a7f, 0x6aa6, 0x6a9a, 0x6a85, 0x6a8c, 0x6a92, 0x6b5b
},

/* Row 0x04e */
{
/* 00 */ 0x6bad, 0x6c09, 0x6fcc, 0x6fa9, 0x6ff4, 0x6fd4, 0x6fe3, 0x6fdc,
/* 08 */ 0x6fed, 0x6fe7, 0x6fe6, 0x6fde, 0x6ff2, 0x6fdd, 0x6fe2, 0x6fe8,
/* 10 */ 0x71e1, 0x71f1, 0x71e8, 0x71f2, 0x71e4, 0x71f0, 0x71e2, 0x7373,
/* 18 */ 0x736e, 0x736f, 0x7497, 0x74b2, 0x74ab, 0x7490, 0x74aa, 0x74ad,
/* 20 */ 0x74b1, 0x74a5, 0x74af, 0x7510, 0x7511, 0x7512, 0x750f, 0x7584,
/* 28 */ 0x7643, 0x7648, 0x7649, 0x7647, 0x76a4, 0x76e9, 0x77b5, 0x77ab,
/* 30 */ 0x77b2, 0x77b7, 0x77b6, 0x8577, 0x857c, 0x8589, 0x85a1, 0x857a,
/* 38 */ 0x8578, 0x8557, 0x858e, 0x8596, 0x8586, 0x858d, 0x8599, 0x859d
},

/* Row 0x04f */
{
/* 00 */ 0x8581, 0x85a2, 0x8582, 0x8588, 0x8585, 0x8579, 0x8576, 0x8598,
/* 08 */ 0x8590, 0x859f, 0x8668, 0x87be, 0x87aa, 0x87ad, 0x87c5, 0x87b0,
/* 10 */ 0x87ac, 0x87b9, 0x87b5, 0x87bc, 0x87ae, 0x87c9, 0x87c3, 0x87c2,
/* 18 */ 0x87cc, 0x87b7, 0x87af, 0x87c4, 0x87ca, 0x87b4, 0x87b6, 0x87bf,
/* 20 */ 0x87b8, 0x87bd, 0x87de, 0x87b2, 0x8935, 0x8933, 0x893c, 0x893e,
/* 28 */ 0x8941, 0x8952, 0x8937, 0x8942, 0x89ad, 0x89af, 0x89ae, 0x89f2,
/* 30 */ 0x89f3, 0x8b1e, 0x979e, 0x979d, 0x97d5, 0x97d4, 0x97f1, 0x9841,
/* 38 */ 0x9844, 0x984a, 0x9849, 0x9845, 0x9843, 0x9925, 0x992b, 0x992c
},

/* Row 0x050 */
{
/* 00 */ 0x992a, 0x9933, 0x9932, 0x992f, 0x992d, 0x9931, 0x9930, 0x9998,
/* 08 */ 0x99a3, 0x99a1, 0x9a02, 0x99fa, 0x99f4, 0x99f7, 0x99f9, 0x99f8,
/* 10 */ 0x99f6, 0x99fb, 0x99fd, 0x99fe, 0x99fc, 0x9a03, 0x9abe, 0x9afe,
/* 18 */ 0x9afd, 0x9b01, 0x9afc, 0x9b48, 0x9b9a, 0x9ba8, 0x9b9e, 0x9b9b,
/* 20 */ 0x9ba6, 0x9ba1, 0x9ba5, 0x9ba4, 0x9b86, 0x9ba2, 0x9ba0, 0x9baf,
/* 28 */ 0x9d33, 0x9d41, 0x9d67, 0x9d36, 0x9d2e, 0x9d2f, 0x9d31, 0x9d38,
/* 30 */ 0x9d30, 0x74b8, 0x74c0, 0x74b5, 0x74c1, 0x74be, 0x74b6, 0x74bb,
/* 38 */ 0x74c2, 0x7514, 0x7513, 0x765c, 0x7664, 0x7659, 0x7650, 0x7653
},

/* Row 0x051 */
{
/* 00 */ 0x7657, 0x765a, 0x76a6, 0x76bd, 0x76ec, 0x77c2, 0x77ba, 0x78ff,
/* 08 */ 0x790c, 0x7913, 0x7914, 0x7909, 0x7910, 0x7912, 0x7911, 0x79ad,
/* 10 */ 0x79ac, 0x7a5f, 0x7c1c, 0x7c29, 0x7c19, 0x7c20, 0x7c1f, 0x7c2d,
/* 18 */ 0x7c1d, 0x7c26, 0x7c28, 0x7c22, 0x7c25, 0x7c30, 0x7e5c, 0x7e50,
/* 20 */ 0x7e56, 0x7e63, 0x7e58, 0x7e62, 0x7e5f, 0x7e51, 0x7e60, 0x7e57,
/* 28 */ 0x7e53, 0x7fb5, 0x7fb3, 0x7ff7, 0x7ff8, 0x8075, 0x81d1, 0x81d2,
/* 30 */ 0x8e5b, 0x8e5a, 0x8e61, 0x8e5d, 0x8e69, 0x8e54, 0x8f46, 0x8f47,
/* 38 */ 0x8f48, 0x8f4b, 0x9128, 0x913a, 0x913b, 0x913e, 0x91a8, 0x91a5
},

/* Row 0x052 */
{
/* 00 */ 0x91a7, 0x91af, 0x91aa, 0x93b5, 0x938c, 0x9392, 0x93b7, 0x939b,
/* 08 */ 0x939d, 0x9389, 0x93a7, 0x938e, 0x93aa, 0x939e, 0x93a6, 0x9395,
/* 10 */ 0x9388, 0x9399, 0x939f, 0x938d, 0x93b1, 0x9391, 0x93b2, 0x93a4,
/* 18 */ 0x93a8, 0x93b4, 0x93a3, 0x93a5, 0x95d2, 0x95d3, 0x95d1, 0x96b3,
/* 20 */ 0x96d7, 0x96da, 0x5dc2, 0x96df, 0x96d8, 0x96dd, 0x9723, 0x9722,
/* 28 */ 0x9725, 0x97ac, 0x97ae, 0x97a8, 0x97ab, 0x97a4, 0x97aa, 0x5fbf,
/* 30 */ 0x61fb, 0x6507, 0x6510, 0x650d, 0x6509, 0x650c, 0x650e, 0x6584,
/* 38 */ 0x65de, 0x65dd, 0x66de, 0x6ae7, 0x6ae0, 0x6acc, 0x6ad1, 0x6ad9
},

/* Row 0x053 */
{
/* 00 */ 0x6acb, 0x6adf, 0x6adc, 0x6ad0, 0x6aeb, 0x6acf, 0x6acd, 0x6ade,
/* 08 */ 0x6b60, 0x6bb0, 0x6c0c, 0x7019, 0x7027, 0x7020, 0x7016, 0x702b,
/* 10 */ 0x7021, 0x7022, 0x7023, 0x7029, 0x7017, 0x7024, 0x701c, 0x702a,
/* 18 */ 0x720c, 0x720a, 0x7207, 0x7202, 0x7205, 0x72a5, 0x72a6, 0x72a4,
/* 20 */ 0x72a3, 0x72a1, 0x74cb, 0x74c5, 0x74b7, 0x74c3, 0x7516, 0x7660,
/* 28 */ 0x77c9, 0x77ca, 0x77c4, 0x77f1, 0x791d, 0x791b, 0x8b51, 0x8b42,
/* 30 */ 0x8b52, 0x8b57, 0x8c43, 0x8c77, 0x8c76, 0x8c9a, 0x8d06, 0x8d07,
/* 38 */ 0x8d09, 0x8dac, 0x8daa, 0x8dad, 0x8dab, 0x8e6d, 0x8e78, 0x8e73
},

/* Row 0x054 */
{
/* 00 */ 0x8e6a, 0x8e6f, 0x8e7b, 0x8ec2, 0x8f52, 0x8f51, 0x8f4f, 0x8f50,
/* 08 */ 0x8f53, 0x8fb4, 0x9140, 0x913f, 0x91b0, 0x91ad, 0x93de, 0x93c7,
/* 10 */ 0x93cf, 0x93c2, 0x93da, 0x93d0, 0x93f9, 0x93ec, 0x93cc, 0x93d9,
/* 18 */ 0x93a9, 0x93e6, 0x93ca, 0x93d4, 0x93ee, 0x93e3, 0x93d5, 0x93c4,
/* 20 */ 0x93ce, 0x93c0, 0x93d2, 0x93e7, 0x957d, 0x95da, 0x95db, 0x96e1,
/* 28 */ 0x9729, 0x972b, 0x972c, 0x9728, 0x9726, 0x56b5, 0x56b3, 0x58e3,
/* 30 */ 0x5b45, 0x5dc6, 0x5dc7, 0x5eee, 0x5eef, 0x5fc0, 0x5fc1, 0x61f9,
/* 38 */ 0x6517, 0x6516, 0x6515, 0x6513, 0x65df, 0x66e8, 0x66e3, 0x66e4
},

/* Row 0x055 */
{
/* 00 */ 0x6af3, 0x6af0, 0x6aea, 0x6ae8, 0x6af9, 0x6af1, 0x6aee, 0x6aef,
/* 08 */ 0x703c, 0x7035, 0x702f, 0x7037, 0x7034, 0x7031, 0x7042, 0x7038,
/* 10 */ 0x703f, 0x703a, 0x7039, 0x7040, 0x703b, 0x7033, 0x7041, 0x7213,
/* 18 */ 0x7214, 0x72a8, 0x737d, 0x737c, 0x74ba, 0x76ab, 0x76aa, 0x76be,
/* 20 */ 0x76ed, 0x77cc, 0x77ce, 0x77cf, 0x77cd, 0x77f2, 0x7925, 0x7923,
/* 28 */ 0x7927, 0x7928, 0x7924, 0x7929, 0x93fc, 0x940c, 0x93f6, 0x9411,
/* 30 */ 0x9406, 0x95de, 0x95e0, 0x95df, 0x972e, 0x972f, 0x97b9, 0x97bb,
/* 38 */ 0x97fd, 0x97fe, 0x9860, 0x9862, 0x9863, 0x985f, 0x98c1, 0x98c2
},

/* Row 0x056 */
{
/* 00 */ 0x9950, 0x994e, 0x9959, 0x994c, 0x994b, 0x9953, 0x9a32, 0x9a34,
/* 08 */ 0x9a31, 0x9a2c, 0x9a2a, 0x9a36, 0x9a29, 0x9a2e, 0x9a38, 0x9a2d,
/* 10 */ 0x9ac7, 0x9aca, 0x9ac6, 0x9b10, 0x9b12, 0x9b11, 0x9c0b, 0x9c08,
/* 18 */ 0x9bf7, 0x9c05, 0x9c12, 0x9bf8, 0x9c40, 0x9c07, 0x9c0e, 0x9c06,
/* 20 */ 0x9c17, 0x9c14, 0x9c09, 0x9d9f, 0x9d99, 0x9da4, 0x9d9d, 0x9d92,
/* 28 */ 0x9d98, 0x9d90, 0x9d9b, 0x8829, 0x881d, 0x881b, 0x8820, 0x8824,
/* 30 */ 0x881c, 0x882b, 0x884a, 0x896d, 0x8969, 0x896e, 0x896b, 0x89fa,
/* 38 */ 0x8b79, 0x8b78, 0x8b45, 0x8b7a, 0x8b7b, 0x8d10, 0x8d14, 0x8daf
},

/* Row 0x057 */
{
/* 00 */ 0x8e8e, 0x8e8c, 0x8f5e, 0x8f5b, 0x8f5d, 0x9146, 0x9144, 0x9145,
/* 08 */ 0x91b9, 0x943f, 0x943b, 0x9436, 0x9429, 0x943d, 0x943c, 0x9430,
/* 10 */ 0x9439, 0x942a, 0x9437, 0x942c, 0x9440, 0x9431, 0x95e5, 0x95e4,
/* 18 */ 0x95e3, 0x9735, 0x973a, 0x97bf, 0x97e1, 0x9864, 0x98c9, 0x98c6,
/* 20 */ 0x98c0, 0x9958, 0x9956, 0x9a39, 0x9a3d, 0x9a46, 0x9a44, 0x9a42,
/* 28 */ 0x9a41, 0x9a3a, 0x7cf4, 0x7cf1, 0x7e91, 0x7f4f, 0x7f87, 0x81de,
/* 30 */ 0x826b, 0x8634, 0x8635, 0x8633, 0x862c, 0x8632, 0x8636, 0x882c,
/* 38 */ 0x8828, 0x8826, 0x882a, 0x8825, 0x8971, 0x89bf, 0x89be, 0x89fb
},

/* Row 0x058 */
{
/* 00 */ 0x8b7e, 0x8b84, 0x8b82, 0x8b86, 0x8b85, 0x8b7f, 0x8d15, 0x8e95,
/* 08 */ 0x8e94, 0x8e9a, 0x8e92, 0x8e90, 0x8e96, 0x8e97, 0x8f60, 0x8f62,
/* 10 */ 0x9147, 0x944c, 0x9450, 0x944a, 0x944b, 0x944f, 0x9447, 0x9445,
/* 18 */ 0x9448, 0x9449, 0x9446, 0x973f, 0x97e3, 0x986a, 0x9869, 0x98cb,
/* 20 */ 0x9954, 0x995b, 0x9a4e, 0x9a53, 0x9a54, 0x9a4c, 0x9a4f, 0x9a48,
/* 28 */ 0x9a4a, 0x8b8c, 0x8b8e, 0x8b8b, 0x8b88, 0x8c45, 0x8d19, 0x8e98,
/* 30 */ 0x8f64, 0x8f63, 0x91bc, 0x9462, 0x9455, 0x945d, 0x9457, 0x945e,
/* 38 */ 0x97c4, 0x97c5, 0x9800, 0x9a56, 0x9a59, 0x9b1e, 0x9b1f, 0x9b20
},

/* Row 0x059 */
{
/* 00 */ 0x9c52, 0x9c58, 0x9c50, 0x9c4a, 0x9c4d, 0x9c4b, 0x9c55, 0x9c59,
/* 08 */ 0x9c4c, 0x9c4e, 0x9dfb, 0x9df7, 0x9def, 0x9de3, 0x9deb, 0x9df8,
/* 10 */ 0x9de4, 0x9df6, 0x9de1, 0x9dee, 0x9de6, 0x9df2, 0x9df0, 0x9de2,
/* 18 */ 0x9dec, 0x9df4, 0x9df3, 0x9de8, 0x9ded, 0x9ec2, 0x9ed0, 0x9ef2,
/* 20 */ 0x9ef3, 0x9f06, 0x9f1c, 0x9f38, 0x9f37, 0x9f36, 0x9f43, 0x9f4f,
/* 28 */ 0x7e98, 0x7e9b, 0x7e99, 0x81e0, 0x81e1, 0x8646, 0x8647, 0x8648,
/* 30 */ 0x8979, 0x897a, 0x897c, 0x897b, 0x89ff, 0x8b98, 0x8b99, 0x8ea5,
/* 38 */ 0x8ea4, 0x8ea3, 0x946e, 0x946d, 0x946f, 0x9471, 0x9473, 0x9749
},

/* Row 0x05a */
{
/* 00 */ 0x9872, 0x995f, 0x9c68, 0x9c6e, 0x9c6d, 0x9e0b, 0x9e0d, 0x9e10,
/* 08 */ 0x9e0f, 0x9e12, 0x9e11, 0x9ea1, 0x9ef5, 0x9f09, 0x9f47, 0x9f78,
/* 10 */ 0x9f7b, 0x9f7a, 0x9f79, 0x571e, 0x7066, 0x7c6f, 0x883c, 0x8db2,
/* 18 */ 0x8ea6, 0x91c3, 0x9474, 0x9478, 0x9476, 0x9475, 0x9a60, 0x9c74,
/* 20 */ 0x9c73, 0x9c71, 0x9c75, 0x9e14, 0x9e13, 0x9ef6, 0x9f0a,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x05b */
{
/* 00 */ 0xfe5b, 0xfe5c, 0xfe5d, 0xfe5e, 0x2018, 0x2019, 0x201c, 0x201d,
/* 08 */ 0x301d, 0x301e, 0x2035, 0x2032, 0xff03, 0xff06, 0xff0a, 0x203b,
/* 10 */ 0x00a7, 0x3003, 0x25cb, 0x25cf, 0x25b3, 0x25b2, 0x25ce, 0x2606,
/* 18 */ 0x2605, 0x25c7, 0x25c6, 0x25a1, 0x25a0, 0x25bd, 0x25bc, 0x32a3,
/* 20 */ 0x2105, 0x203e, 0xf8fe, 0xff3f, 0xf8fd, 0xfe49, 0xfe4a, 0xfe4d,
/* 28 */ 0xfe4e, 0xfe4b, 0xfe4c, 0xfe5f, 0xfe60, 0xfe61, 0xff0b, 0xff0d,
/* 30 */ 0x00d7, 0x00f7, 0x00b1, 0x221a, 0xff1c, 0xff1e, 0xff1d, 0x2266,
/* 38 */ 0x2267, 0x2260, 0x221e, 0x2252, 0x2261, 0xfe62, 0xfe63, 0xfe64
},

/* Row 0x05c */
{
/* 00 */ 0xfe65, 0xfe66, 0x223c, 0x2229, 0x222a, 0x22a5, 0x2220, 0x221f,
/* 08 */ 0x22bf, 0x33d2, 0x33d1, 0x222b, 0x222e, 0x2235, 0x2234, 0x2640,
/* 10 */ 0x2642, 0x2641, 0x2609, 0x2191, 0x2193, 0x2190, 0x2192, 0x2196,
/* 18 */ 0x2197, 0x2199, 0x2198, 0x2225, 0x2223, 0xf8fc, 0x256e, 0x2570,
/* 20 */ 0x256f, 0x2550, 0x255e, 0x256a, 0x2561, 0x25e2, 0x25e3, 0x25e5,
/* 28 */ 0x25e4, 0x2571, 0x2572, 0x2573, 0xff10, 0xff11, 0xff12, 0xff13,
/* 30 */ 0xff14, 0xff15, 0xff16, 0xff17, 0xff18, 0xff19, 0x2160, 0x2161,
/* 38 */ 0x2162, 0x2163, 0x2164, 0x2165, 0x2166, 0x2167, 0x2168, 0x2169
},

/* Row 0x05d */
{
/* 00 */ 0x3021, 0x3022, 0x3023, 0x3024, 0x3025, 0x3026, 0x3027, 0x3028,
/* 08 */ 0x3029, 0xf8fa, 0x5344, 0xf8f9, 0xff21, 0xff22, 0xff23, 0xff24,
/* 10 */ 0xff25, 0xff26, 0xff27, 0xff28, 0xff29, 0xff2a, 0xff2b, 0xff2c,
/* 18 */ 0xff2d, 0xff2e, 0xff2f, 0xff30, 0xff31, 0xff32, 0xff33, 0xff34,
/* 20 */ 0xff35, 0xff36, 0xff37, 0xff38, 0xff39, 0xff3a, 0xff41, 0xff42,
/* 28 */ 0xff43, 0xff44, 0xff45, 0xff46, 0xff47, 0xff48, 0xff49, 0xff4a,
/* 30 */ 0xff4b, 0xff4c, 0xff4d, 0xff4e, 0xff4f, 0xff50, 0xff51, 0xff52,
/* 38 */ 0xff53, 0xff54, 0xff55, 0xff56, 0x3110, 0x3111, 0x3112, 0x3113
},

/* Row 0x05e */
{
/* 00 */ 0x3114, 0x3115, 0x3116, 0x3117, 0x3118, 0x3119, 0x311a, 0x311b,
/* 08 */ 0x311c, 0x311d, 0x311e, 0x311f, 0x3120, 0x3121, 0x3122, 0x3123,
/* 10 */ 0x3124, 0x3125, 0x3126, 0x3127, 0x3128, 0x3129, 0x02d9, 0x02c9,
/* 18 */ 0x02ca, 0x02c7, 0x02cb, 0xf6b1, 0xf6b2, 0xf6b3, 0xf6b4, 0xf6b5,
/* 20 */ 0xf6b6, 0xf6b7, 0xf6b8, 0xf6b9, 0xf6ba, 0xf6bb, 0xf6bc, 0xf6bd,
/* 28 */ 0xf6be, 0xf6bf, 0xf6c0, 0xf6c1, 0xf6c2, 0xf6c3, 0xf6c4, 0xf6c5,
/* 30 */ 0xf6c6, 0xf6c7, 0xf6c8, 0xf6c9, 0xf6ca, 0xf6cb, 0xf6cc, 0xf6cd,
/* 38 */ 0xf6ce, 0xf6cf, 0xf6d0, 0xf6d1, 0xf6d2, 0xf6d3, 0xf6d4, 0xf6d5
},

/* Row 0x05f */
{
/* 00 */ 0xf6d6, 0xf6d7, 0xf6d8, 0xf6d9, 0xf6da, 0xf6db, 0xf6dc, 0xf6dd,
/* 08 */ 0xf6de, 0xf6df, 0xf6e0, 0xf6e1, 0xf6e2, 0xf6e3, 0xf6e4, 0xf6e5,
/* 10 */ 0xf6e6, 0xf6e7, 0xf6e8, 0xf6e9, 0xf6ea, 0xf6eb, 0xf6ec, 0xf6ed,
/* 18 */ 0xf6ee, 0xf6ef, 0x4e11, 0x4e10, 0x4e0d, 0x4e2d, 0x4e30, 0x4e39,
/* 20 */ 0x4e4b, 0x5c39, 0x4e88, 0x4e91, 0x4e95, 0x4e92, 0x4e94, 0x4ea2,
/* 28 */ 0x4ec1, 0x4ec0, 0x4ec3, 0x4ec6, 0x4ec7, 0x4ecd, 0x4eca, 0x4ecb,
/* 30 */ 0x4ec4, 0x5143, 0x5141, 0x5167, 0x516d, 0x516e, 0x516c, 0x5197,
/* 38 */ 0x51f6, 0x5206, 0x5207, 0x5208, 0x52fb, 0x52fe, 0x52ff, 0x5316
},

/* Row 0x060 */
{
/* 00 */ 0x5339, 0x5348, 0x5347, 0x5345, 0x535e, 0x5384, 0x53cb, 0x53ca,
/* 08 */ 0x53cd, 0x58ec, 0x5929, 0x592b, 0x592a, 0x592d, 0x5b54, 0x5c11,
/* 10 */ 0x5c24, 0x5c3a, 0x5c6f, 0x5df4, 0x5e7b, 0x5eff, 0x5f14, 0x5f15,
/* 18 */ 0x5fc3, 0x6208, 0x6236, 0x624b, 0x624e, 0x652f, 0x6587, 0x6597,
/* 20 */ 0x65a4, 0x65b9, 0x65e5, 0x66f0, 0x6708, 0x6728, 0x6b20, 0x6b62,
/* 28 */ 0x6b79, 0x6bcb, 0x6bd4, 0x6bdb, 0x6c0f, 0x6c34, 0x706b, 0x722a,
/* 30 */ 0x7236, 0x723b, 0x7247, 0x7259, 0x725b, 0x72ac, 0x738b, 0x4e19,
/* 38 */ 0x592e, 0x5931, 0x5974, 0x5976, 0x5b55, 0x5b83, 0x5c3c, 0x5de8
},

/* Row 0x061 */
{
/* 00 */ 0x5de7, 0x5de6, 0x5e02, 0x5e03, 0x5e73, 0x5e7c, 0x5f01, 0x5f18,
/* 08 */ 0x5f17, 0x5fc5, 0x620a, 0x6253, 0x6254, 0x6252, 0x6251, 0x65a5,
/* 10 */ 0x65e6, 0x672e, 0x672c, 0x672a, 0x672b, 0x672d, 0x6b63, 0x6bcd,
/* 18 */ 0x6c11, 0x6c10, 0x6c38, 0x6c41, 0x6c40, 0x6c3e, 0x72af, 0x7384,
/* 20 */ 0x7389, 0x74dc, 0x74e6, 0x7518, 0x751f, 0x7528, 0x7529, 0x7530,
/* 28 */ 0x7531, 0x7532, 0x7533, 0x758b, 0x767d, 0x76ae, 0x76bf, 0x76ee,
/* 30 */ 0x77db, 0x77e2, 0x77f3, 0x793a, 0x79be, 0x7a74, 0x7acb, 0x4e1e,
/* 38 */ 0x4e1f, 0x4e52, 0x4e53, 0x4e69, 0x4e99, 0x4ea4, 0x4ea6, 0x4ea5
},

/* Row 0x062 */
{
/* 00 */ 0x4eff, 0x4f09, 0x4f19, 0x4f0a, 0x4f15, 0x4f0d, 0x4f10, 0x4f11,
/* 08 */ 0x4f0f, 0x4ef2, 0x4ef6, 0x4efb, 0x4ef0, 0x4ef3, 0x4efd, 0x4f01,
/* 10 */ 0x4f0b, 0x5149, 0x5147, 0x5146, 0x5148, 0x5168, 0x5f0f, 0x5f1b,
/* 18 */ 0x5fd9, 0x5fd6, 0x620e, 0x620c, 0x620d, 0x6210, 0x6263, 0x625b,
/* 20 */ 0x6258, 0x6536, 0x65e9, 0x65e8, 0x65ec, 0x65ed, 0x66f2, 0x66f3,
/* 28 */ 0x6709, 0x673d, 0x6734, 0x6731, 0x6735, 0x6b21, 0x6b64, 0x6b7b,
/* 30 */ 0x6c16, 0x6c5d, 0x6c57, 0x6c59, 0x6c5f, 0x6c60, 0x6c50, 0x6c55,
/* 38 */ 0x6c61, 0x6c5b, 0x6c4d, 0x6c4e, 0x7070, 0x725f, 0x725d, 0x767e
},

/* Row 0x063 */
{
/* 00 */ 0x7af9, 0x7c73, 0x7cf8, 0x7f36, 0x7f8a, 0x7fbd, 0x8001, 0x8003,
/* 08 */ 0x800c, 0x8012, 0x8033, 0x807f, 0x8089, 0x808b, 0x808c, 0x81e3,
/* 10 */ 0x81ea, 0x81f3, 0x81fc, 0x820c, 0x821b, 0x821f, 0x826e, 0x8272,
/* 18 */ 0x827e, 0x866b, 0x8840, 0x884c, 0x8863, 0x897f, 0x9621, 0x4e32,
/* 20 */ 0x4ea8, 0x4f4d, 0x4f4f, 0x4f47, 0x4f57, 0x4f5e, 0x4f34, 0x4f5b,
/* 28 */ 0x4f55, 0x4f30, 0x4f50, 0x4f51, 0x4f3d, 0x4f3a, 0x4f38, 0x4f43,
/* 30 */ 0x4f54, 0x4f3c, 0x4f46, 0x4f63, 0x5747, 0x574e, 0x573e, 0x5750,
/* 38 */ 0x574f, 0x573b, 0x58ef, 0x593e, 0x599d, 0x5992, 0x59a8, 0x599e
},

/* Row 0x064 */
{
/* 00 */ 0x59a3, 0x5999, 0x5996, 0x598d, 0x59a4, 0x5993, 0x598a, 0x59a5,
/* 08 */ 0x5b5d, 0x5b5c, 0x5b5a, 0x5b5b, 0x5b8c, 0x5b8b, 0x5b8f, 0x5c2c,
/* 10 */ 0x5c40, 0x5c41, 0x5c3f, 0x5c3e, 0x5c90, 0x5c91, 0x5c94, 0x5c8c,
/* 18 */ 0x5deb, 0x5e0c, 0x5e8f, 0x5e87, 0x5e8a, 0x5ef7, 0x5f04, 0x5f1f,
/* 20 */ 0x5f64, 0x5f62, 0x5f77, 0x5f79, 0x5fd8, 0x5fcc, 0x5fd7, 0x5fcd,
/* 28 */ 0x5ff1, 0x5feb, 0x5ff8, 0x5fea, 0x6212, 0x6211, 0x6284, 0x6297,
/* 30 */ 0x6296, 0x6280, 0x6276, 0x6289, 0x626d, 0x628a, 0x627c, 0x627e,
/* 38 */ 0x6279, 0x6273, 0x6292, 0x626f, 0x6298, 0x626e, 0x6295, 0x6293
},

/* Row 0x065 */
{
/* 00 */ 0x6291, 0x6286, 0x6539, 0x653b, 0x6538, 0x65f1, 0x66f4, 0x675f,
/* 08 */ 0x674e, 0x674f, 0x6750, 0x6751, 0x675c, 0x6756, 0x675e, 0x6749,
/* 10 */ 0x6746, 0x6760, 0x828b, 0x828d, 0x898b, 0x89d2, 0x8a00, 0x8c37,
/* 18 */ 0x8c46, 0x8c55, 0x8c9d, 0x8d64, 0x8d70, 0x8db3, 0x8eab, 0x8eca,
/* 20 */ 0x8f9b, 0x8fb0, 0x8fc2, 0x8fc6, 0x8fc5, 0x8fc4, 0x5de1, 0x9091,
/* 28 */ 0x90a2, 0x90aa, 0x90a6, 0x90a3, 0x9149, 0x91c6, 0x91cc, 0x9632,
/* 30 */ 0x962e, 0x9631, 0x962a, 0x962c, 0x4e26, 0x4e56, 0x4e73, 0x4e8b,
/* 38 */ 0x4e9b, 0x4e9e, 0x4eab, 0x4eac, 0x4f6f, 0x4f9d, 0x4f8d, 0x4f73
},

/* Row 0x066 */
{
/* 00 */ 0x4f7f, 0x4f6c, 0x4f9b, 0x4f8b, 0x4f86, 0x4f83, 0x4f70, 0x4f75,
/* 08 */ 0x4f88, 0x4f69, 0x4f7b, 0x4f96, 0x4f7e, 0x4f8f, 0x4f91, 0x4f7a,
/* 10 */ 0x5154, 0x5152, 0x5155, 0x5169, 0x5177, 0x5176, 0x5178, 0x51bd,
/* 18 */ 0x51fd, 0x523b, 0x5238, 0x5237, 0x523a, 0x5230, 0x522e, 0x5236,
/* 20 */ 0x5241, 0x52be, 0x52bb, 0x5352, 0x5354, 0x5353, 0x5351, 0x5366,
/* 28 */ 0x5377, 0x5378, 0x5379, 0x53d6, 0x53d4, 0x53d7, 0x5473, 0x5475,
/* 30 */ 0x5c46, 0x5cb7, 0x5ca1, 0x5cb8, 0x5ca9, 0x5cab, 0x5cb1, 0x5cb3,
/* 38 */ 0x5e18, 0x5e1a, 0x5e16, 0x5e15, 0x5e1b, 0x5e11, 0x5e78, 0x5e9a
},

/* Row 0x067 */
{
/* 00 */ 0x5e97, 0x5e9c, 0x5e95, 0x5e96, 0x5ef6, 0x5f26, 0x5f27, 0x5f29,
/* 08 */ 0x5f80, 0x5f81, 0x5f7f, 0x5f7c, 0x5fdd, 0x5fe0, 0x5ffd, 0x5ff5,
/* 10 */ 0x5fff, 0x600f, 0x6014, 0x602f, 0x6035, 0x6016, 0x602a, 0x6015,
/* 18 */ 0x6021, 0x6027, 0x6029, 0x602b, 0x601b, 0x6216, 0x6215, 0x623f,
/* 20 */ 0x623e, 0x6240, 0x627f, 0x62c9, 0x62cc, 0x62c4, 0x62bf, 0x62c2,
/* 28 */ 0x62b9, 0x62d2, 0x62db, 0x62ab, 0x62d3, 0x62d4, 0x62cb, 0x62c8,
/* 30 */ 0x62a8, 0x62bd, 0x62bc, 0x62d0, 0x62d9, 0x62c7, 0x62cd, 0x62b5,
/* 38 */ 0x62da, 0x62b1, 0x62d8, 0x62d6, 0x62d7, 0x62c6, 0x62ac, 0x62ce
},

/* Row 0x068 */
{
/* 00 */ 0x653e, 0x65a7, 0x65bc, 0x65fa, 0x6614, 0x6613, 0x660c, 0x6606,
/* 08 */ 0x6602, 0x660e, 0x6600, 0x660f, 0x6615, 0x660a, 0x7095, 0x708e,
/* 10 */ 0x7092, 0x708a, 0x7099, 0x722c, 0x722d, 0x7238, 0x7248, 0x7267,
/* 18 */ 0x7269, 0x72c0, 0x72ce, 0x72d9, 0x72d7, 0x72d0, 0x73a9, 0x73a8,
/* 20 */ 0x739f, 0x73ab, 0x73a5, 0x753d, 0x759d, 0x7599, 0x759a, 0x7684,
/* 28 */ 0x76c2, 0x76f2, 0x76f4, 0x77e5, 0x77fd, 0x793e, 0x7940, 0x7941,
/* 30 */ 0x79c9, 0x79c8, 0x7a7a, 0x7a79, 0x7afa, 0x7cfe, 0x7f54, 0x7f8c,
/* 38 */ 0x7f8b, 0x8005, 0x80ba, 0x80a5, 0x80a2, 0x80b1, 0x80a1, 0x80ab
},

/* Row 0x069 */
{
/* 00 */ 0x80a9, 0x80b4, 0x80aa, 0x80af, 0x81e5, 0x81fe, 0x820d, 0x82b3,
/* 08 */ 0x829d, 0x8299, 0x82ad, 0x82bd, 0x829f, 0x82b9, 0x82b1, 0x82ac,
/* 10 */ 0x82a5, 0x82af, 0x82b8, 0x82a3, 0x82b0, 0x82be, 0x82b7, 0x864e,
/* 18 */ 0x8671, 0x521d, 0x8868, 0x8ecb, 0x8fce, 0x8fd4, 0x8fd1, 0x90b5,
/* 20 */ 0x90b8, 0x90b1, 0x90b6, 0x91c7, 0x91d1, 0x9577, 0x9580, 0x961c,
/* 28 */ 0x9640, 0x963f, 0x963b, 0x9644, 0x54c4, 0x54c8, 0x54af, 0x54ab,
/* 30 */ 0x54b1, 0x54bb, 0x54a9, 0x54a7, 0x54bf, 0x56ff, 0x5782, 0x578b,
/* 38 */ 0x57a0, 0x57a3, 0x57a2, 0x57ce, 0x57ae, 0x5793, 0x5955, 0x5951
},

/* Row 0x06a */
{
/* 00 */ 0x594f, 0x594e, 0x5950, 0x59dc, 0x59d8, 0x59ff, 0x59e3, 0x59e8,
/* 08 */ 0x5a03, 0x59e5, 0x59ea, 0x59da, 0x59e6, 0x5a01, 0x59fb, 0x5b69,
/* 10 */ 0x5ba3, 0x5ba6, 0x5ba4, 0x5ba2, 0x5ba5, 0x5c01, 0x5c4e, 0x5c4f,
/* 18 */ 0x5c4d, 0x5c4b, 0x5cd9, 0x5cd2, 0x5df7, 0x5e1d, 0x5e25, 0x5e1f,
/* 20 */ 0x5e7d, 0x5ea0, 0x5ea6, 0x5efa, 0x5f08, 0x5f2d, 0x5f65, 0x5f88,
/* 28 */ 0x5f85, 0x5f8a, 0x5f8b, 0x5f87, 0x5f8c, 0x5f89, 0x6012, 0x601d,
/* 30 */ 0x6020, 0x6025, 0x600e, 0x6028, 0x604d, 0x6070, 0x6068, 0x6062,
/* 38 */ 0x6046, 0x6043, 0x606c, 0x606b, 0x606a, 0x6064, 0x6241, 0x62dc
},

/* Row 0x06b */
{
/* 00 */ 0x6316, 0x6309, 0x62fc, 0x62ed, 0x6301, 0x62ee, 0x62fd, 0x6307,
/* 08 */ 0x62f1, 0x62f7, 0x6d3b, 0x6d3d, 0x6d3e, 0x6d36, 0x6d1b, 0x6cf5,
/* 10 */ 0x6d39, 0x6d27, 0x6d38, 0x6d29, 0x6d2e, 0x6d35, 0x6d0e, 0x6d2b,
/* 18 */ 0x70ab, 0x70ba, 0x70b3, 0x70ac, 0x70af, 0x70ad, 0x70b8, 0x70ae,
/* 20 */ 0x70a4, 0x7230, 0x7272, 0x726f, 0x7274, 0x72e9, 0x72e0, 0x72e1,
/* 28 */ 0x73b7, 0x73ca, 0x73bb, 0x73b2, 0x73cd, 0x73c0, 0x73b3, 0x751a,
/* 30 */ 0x752d, 0x754f, 0x754c, 0x754e, 0x754b, 0x75ab, 0x75a4, 0x75a5,
/* 38 */ 0x75a2, 0x75a3, 0x7678, 0x7686, 0x7687, 0x7688, 0x76c8, 0x76c6
},

/* Row 0x06c */
{
/* 00 */ 0x76c3, 0x76c5, 0x7701, 0x76f9, 0x76f8, 0x7709, 0x770b, 0x76fe,
/* 08 */ 0x76fc, 0x7707, 0x77dc, 0x7802, 0x7814, 0x780c, 0x780d, 0x7946,
/* 10 */ 0x7949, 0x7948, 0x7947, 0x79b9, 0x79ba, 0x79d1, 0x79d2, 0x79cb,
/* 18 */ 0x7a7f, 0x7a81, 0x7aff, 0x7afd, 0x7c7d, 0x7d02, 0x7d05, 0x7d00,
/* 20 */ 0x7d09, 0x7d07, 0x7d04, 0x7d06, 0x7f38, 0x7f8e, 0x7fbf, 0x8004,
/* 28 */ 0x8fed, 0x8feb, 0x8fe4, 0x8fe8, 0x90ca, 0x90ce, 0x90c1, 0x90c3,
/* 30 */ 0x914b, 0x914a, 0x91cd, 0x9582, 0x9650, 0x964b, 0x964c, 0x964d,
/* 38 */ 0x9762, 0x9769, 0x97cb, 0x97ed, 0x97f3, 0x9801, 0x98a8, 0x98db
},

/* Row 0x06d */
{
/* 00 */ 0x98df, 0x9996, 0x9999, 0x4e58, 0x4eb3, 0x500c, 0x500d, 0x5023,
/* 08 */ 0x4fef, 0x5026, 0x5025, 0x4ff8, 0x5029, 0x5016, 0x5006, 0x503c,
/* 10 */ 0x501f, 0x501a, 0x5012, 0x5011, 0x4ffa, 0x5000, 0x5014, 0x5028,
/* 18 */ 0x4ff1, 0x5021, 0x500b, 0x5019, 0x5018, 0x4ff3, 0x4fee, 0x502d,
/* 20 */ 0x502a, 0x4ffe, 0x502b, 0x5009, 0x517c, 0x51a4, 0x51a5, 0x51a2,
/* 28 */ 0x51cd, 0x51cc, 0x51c6, 0x51cb, 0x5256, 0x525c, 0x5254, 0x525b,
/* 30 */ 0x525d, 0x532a, 0x537f, 0x539f, 0x539d, 0x53df, 0x54e8, 0x5510,
/* 38 */ 0x5501, 0x5537, 0x54fc, 0x54e5, 0x54f2, 0x5506, 0x54fa, 0x5514
},

/* Row 0x06e */
{
/* 00 */ 0x54e9, 0x54ed, 0x54e1, 0x5509, 0x54ee, 0x54ea, 0x6063, 0x6065,
/* 08 */ 0x6050, 0x6055, 0x606d, 0x6069, 0x606f, 0x6084, 0x609f, 0x609a,
/* 10 */ 0x608d, 0x6094, 0x608c, 0x6085, 0x6096, 0x6247, 0x62f3, 0x6308,
/* 18 */ 0x62ff, 0x634e, 0x633e, 0x632f, 0x6355, 0x6342, 0x6346, 0x634f,
/* 20 */ 0x6349, 0x633a, 0x6350, 0x633d, 0x632a, 0x632b, 0x6328, 0x634d,
/* 28 */ 0x634c, 0x6548, 0x6549, 0x6599, 0x65c1, 0x65c5, 0x6642, 0x6649,
/* 30 */ 0x664f, 0x6643, 0x6652, 0x664c, 0x6645, 0x6641, 0x66f8, 0x6714,
/* 38 */ 0x6715, 0x6717, 0x6821, 0x6838, 0x6848, 0x6846, 0x6853, 0x6839
},

/* Row 0x06f */
{
/* 00 */ 0x6842, 0x6854, 0x6829, 0x68b3, 0x6817, 0x684c, 0x6851, 0x683d,
/* 08 */ 0x67f4, 0x6850, 0x6840, 0x683c, 0x6843, 0x682a, 0x6845, 0x6813,
/* 10 */ 0x6818, 0x6841, 0x6b8a, 0x6b89, 0x6bb7, 0x6c23, 0x6c27, 0x6c28,
/* 18 */ 0x6c26, 0x6c24, 0x6cf0, 0x6d6a, 0x6d95, 0x6d88, 0x6d87, 0x6d66,
/* 20 */ 0x6d78, 0x6d77, 0x6d59, 0x6d93, 0x7825, 0x782d, 0x7820, 0x781f,
/* 28 */ 0x7832, 0x7955, 0x7950, 0x7960, 0x795f, 0x7956, 0x795e, 0x795d,
/* 30 */ 0x7957, 0x795a, 0x79e4, 0x79e3, 0x79e7, 0x79df, 0x79e6, 0x79e9,
/* 38 */ 0x79d8, 0x7a84, 0x7a88, 0x7ad9, 0x7b06, 0x7b11, 0x7c89, 0x7d21
},

/* Row 0x070 */
{
/* 00 */ 0x7d17, 0x7d0b, 0x7d0a, 0x7d20, 0x7d22, 0x7d14, 0x7d10, 0x7d15,
/* 08 */ 0x7d1a, 0x7d1c, 0x7d0d, 0x7d19, 0x7d1b, 0x7f3a, 0x7f5f, 0x7f94,
/* 10 */ 0x7fc5, 0x7fc1, 0x8006, 0x8018, 0x8015, 0x8019, 0x8017, 0x803d,
/* 18 */ 0x803f, 0x80f1, 0x8102, 0x80f0, 0x8105, 0x80ed, 0x80f4, 0x8106,
/* 20 */ 0x80f8, 0x80f3, 0x8108, 0x80fd, 0x810a, 0x80fc, 0x80ef, 0x81ed,
/* 28 */ 0x81ec, 0x8200, 0x8210, 0x822a, 0x822b, 0x8228, 0x822c, 0x82bb,
/* 30 */ 0x832b, 0x8352, 0x8354, 0x834a, 0x8338, 0x8350, 0x8349, 0x8335,
/* 38 */ 0x8334, 0x834f, 0x8332, 0x8339, 0x8336, 0x8317, 0x8340, 0x8331
},

/* Row 0x071 */
{
/* 00 */ 0x8328, 0x8343, 0x965b, 0x965d, 0x9664, 0x9658, 0x965e, 0x96bb,
/* 08 */ 0x98e2, 0x99ac, 0x9aa8, 0x9ad8, 0x9b25, 0x9b32, 0x9b3c, 0x4e7e,
/* 10 */ 0x507a, 0x507d, 0x505c, 0x5047, 0x5043, 0x504c, 0x505a, 0x5049,
/* 18 */ 0x5065, 0x5076, 0x504e, 0x5055, 0x5075, 0x5074, 0x5077, 0x504f,
/* 20 */ 0x500f, 0x506f, 0x506d, 0x515c, 0x5195, 0x51f0, 0x526a, 0x526f,
/* 28 */ 0x52d2, 0x52d9, 0x52d8, 0x52d5, 0x5310, 0x530f, 0x5319, 0x533f,
/* 30 */ 0x5340, 0x533e, 0x53c3, 0x66fc, 0x5546, 0x556a, 0x5566, 0x5544,
/* 38 */ 0x555e, 0x5561, 0x5543, 0x554a, 0x5531, 0x5556, 0x554f, 0x5555
},

/* Row 0x072 */
{
/* 00 */ 0x552f, 0x5564, 0x5538, 0x552e, 0x555c, 0x552c, 0x5563, 0x5533,
/* 08 */ 0x5541, 0x5557, 0x5708, 0x570b, 0x5709, 0x57df, 0x5805, 0x580a,
/* 10 */ 0x5806, 0x57e0, 0x57e4, 0x57fa, 0x5802, 0x5835, 0x57f7, 0x57f9,
/* 18 */ 0x5920, 0x5962, 0x5a36, 0x5a41, 0x5a49, 0x5a66, 0x5a6a, 0x5a40,
/* 20 */ 0x60c5, 0x60bb, 0x60b5, 0x60dc, 0x60bc, 0x60d8, 0x60d5, 0x60c6,
/* 28 */ 0x60df, 0x60b8, 0x60da, 0x60c7, 0x621a, 0x621b, 0x6248, 0x63a0,
/* 30 */ 0x63a7, 0x6372, 0x6396, 0x63a2, 0x63a5, 0x6377, 0x6367, 0x6398,
/* 38 */ 0x63aa, 0x6371, 0x63a9, 0x6389, 0x6383, 0x639b, 0x636b, 0x63a8
},

/* Row 0x073 */
{
/* 00 */ 0x6384, 0x6388, 0x6399, 0x63a1, 0x63ac, 0x6392, 0x638f, 0x6380,
/* 08 */ 0x637b, 0x6369, 0x6368, 0x637a, 0x655d, 0x6556, 0x6551, 0x6559,
/* 10 */ 0x6557, 0x555f, 0x654f, 0x6558, 0x6555, 0x6554, 0x659c, 0x659b,
/* 18 */ 0x65ac, 0x65cf, 0x65cb, 0x65cc, 0x65ce, 0x665d, 0x665a, 0x6664,
/* 20 */ 0x6668, 0x6666, 0x665e, 0x66f9, 0x52d7, 0x671b, 0x6881, 0x68af,
/* 28 */ 0x68a2, 0x6893, 0x68b5, 0x687f, 0x6876, 0x68b1, 0x68a7, 0x6897,
/* 30 */ 0x68b0, 0x6883, 0x68c4, 0x68ad, 0x6886, 0x6885, 0x6894, 0x689d,
/* 38 */ 0x68a8, 0x689f, 0x68a1, 0x6882, 0x6b32, 0x6bba, 0x74f7, 0x751c
},

/* Row 0x074 */
{
/* 00 */ 0x7522, 0x7565, 0x7566, 0x7562, 0x7570, 0x758f, 0x75d4, 0x75d5,
/* 08 */ 0x75b5, 0x75ca, 0x75cd, 0x768e, 0x76d4, 0x76d2, 0x76db, 0x7737,
/* 10 */ 0x773e, 0x773c, 0x7736, 0x7738, 0x773a, 0x786b, 0x7843, 0x784e,
/* 18 */ 0x7965, 0x7968, 0x796d, 0x79fb, 0x7a92, 0x7a95, 0x7b20, 0x7b28,
/* 20 */ 0x7b1b, 0x7b2c, 0x7b26, 0x7b19, 0x7b1e, 0x7b2e, 0x7c92, 0x7c97,
/* 28 */ 0x7c95, 0x7d46, 0x7d43, 0x7d71, 0x7d2e, 0x7d39, 0x7d3c, 0x7d40,
/* 30 */ 0x7d30, 0x7d33, 0x7d44, 0x7d2f, 0x7d42, 0x7d32, 0x7d31, 0x7f3d,
/* 38 */ 0x7f9e, 0x7f9a, 0x7fcc, 0x7fce, 0x7fd2, 0x801c, 0x804a, 0x8046
},

/* Row 0x075 */
{
/* 00 */ 0x812f, 0x8116, 0x8123, 0x812b, 0x8129, 0x8130, 0x8124, 0x8202,
/* 08 */ 0x8235, 0x8237, 0x8236, 0x8239, 0x838e, 0x839e, 0x8398, 0x8378,
/* 10 */ 0x83a2, 0x8396, 0x83bd, 0x83ab, 0x8392, 0x838a, 0x8393, 0x8389,
/* 18 */ 0x83a0, 0x8377, 0x837b, 0x837c, 0x90e8, 0x90ed, 0x90fd, 0x9157,
/* 20 */ 0x91ce, 0x91f5, 0x91e6, 0x91e3, 0x91e7, 0x91ed, 0x91e9, 0x9589,
/* 28 */ 0x966a, 0x9675, 0x9673, 0x9678, 0x9670, 0x9674, 0x9676, 0x9677,
/* 30 */ 0x966c, 0x96c0, 0x96ea, 0x96e9, 0x7ae0, 0x7adf, 0x9802, 0x9803,
/* 38 */ 0x9b5a, 0x9ce5, 0x9e75, 0x9e7f, 0x9ea5, 0x9ebb, 0x50a2, 0x508d
},

/* Row 0x076 */
{
/* 00 */ 0x5085, 0x5099, 0x5091, 0x5080, 0x5096, 0x5098, 0x509a, 0x6700,
/* 08 */ 0x51f1, 0x5272, 0x5274, 0x5275, 0x5269, 0x52de, 0x52dd, 0x52db,
/* 10 */ 0x535a, 0x53a5, 0x557b, 0x5580, 0x55a7, 0x557c, 0x558a, 0x559d,
/* 18 */ 0x5598, 0x5582, 0x559c, 0x55aa, 0x5594, 0x5587, 0x558b, 0x5583,
/* 20 */ 0x55b3, 0x55ae, 0x559f, 0x553e, 0x55b2, 0x559a, 0x55bb, 0x55ac,
/* 28 */ 0x55b1, 0x557e, 0x5589, 0x55ab, 0x5599, 0x570d, 0x582f, 0x582a,
/* 30 */ 0x5834, 0x5824, 0x5830, 0x5831, 0x5821, 0x581d, 0x5820, 0x58f9,
/* 38 */ 0x58fa, 0x5960, 0x63d2, 0x63e3, 0x63d0, 0x63e1, 0x63d6, 0x63ed
},

/* Row 0x077 */
{
/* 00 */ 0x63ee, 0x6376, 0x63f4, 0x63ea, 0x63db, 0x6452, 0x63da, 0x63f9,
/* 08 */ 0x655e, 0x6566, 0x6562, 0x6563, 0x6591, 0x6590, 0x65af, 0x666e,
/* 10 */ 0x6670, 0x6674, 0x6676, 0x666f, 0x6691, 0x667a, 0x667e, 0x6677,
/* 18 */ 0x66fe, 0x66ff, 0x671f, 0x671d, 0x68fa, 0x68d5, 0x68e0, 0x68d8,
/* 20 */ 0x68d7, 0x6905, 0x68df, 0x68f5, 0x68ee, 0x68e7, 0x68f9, 0x68d2,
/* 28 */ 0x68f2, 0x68e3, 0x68cb, 0x68cd, 0x690d, 0x6912, 0x690e, 0x68c9,
/* 30 */ 0x68da, 0x696e, 0x68fb, 0x6b3e, 0x6b3a, 0x6b3d, 0x6b98, 0x6b96,
/* 38 */ 0x6bbc, 0x6bef, 0x6c2e, 0x6c2f, 0x6c2c, 0x6e2f, 0x6e38, 0x6e54
},

/* Row 0x078 */
{
/* 00 */ 0x6e21, 0x6e32, 0x6e67, 0x6e4a, 0x6e20, 0x6e25, 0x6e23, 0x6e1b,
/* 08 */ 0x6e5b, 0x6e58, 0x6e24, 0x6e56, 0x6e6e, 0x6e2d, 0x6e26, 0x6e6f,
/* 10 */ 0x6e34, 0x6e4d, 0x6e3a, 0x6e2c, 0x6e43, 0x6e1d, 0x6e3e, 0x6ecb,
/* 18 */ 0x7a97, 0x7a96, 0x7ae5, 0x7ae3, 0x7b49, 0x7b56, 0x7b46, 0x7b50,
/* 20 */ 0x7b52, 0x7b54, 0x7b4d, 0x7b4b, 0x7b4f, 0x7b51, 0x7c9f, 0x7ca5,
/* 28 */ 0x7d5e, 0x7d50, 0x7d68, 0x7d55, 0x7d2b, 0x7d6e, 0x7d72, 0x7d61,
/* 30 */ 0x7d66, 0x7d62, 0x7d70, 0x7d73, 0x5584, 0x7fd4, 0x7fd5, 0x800b,
/* 38 */ 0x8052, 0x8085, 0x8155, 0x8154, 0x814b, 0x8151, 0x814e, 0x8139
},

/* Row 0x079 */
{
/* 00 */ 0x8146, 0x813e, 0x814c, 0x8153, 0x8174, 0x8212, 0x821c, 0x83e9,
/* 08 */ 0x8403, 0x83f8, 0x840d, 0x83e0, 0x83c5, 0x840b, 0x83c1, 0x83ef,
/* 10 */ 0x83f1, 0x83f4, 0x8457, 0x840a, 0x83f0, 0x840c, 0x83cc, 0x83fd,
/* 18 */ 0x83f2, 0x83ca, 0x8438, 0x840e, 0x8404, 0x83dc, 0x8407, 0x83d4,
/* 20 */ 0x83df, 0x865b, 0x86df, 0x86d9, 0x86ed, 0x86d4, 0x86db, 0x86e4,
/* 28 */ 0x86d0, 0x86de, 0x8857, 0x88c1, 0x88c2, 0x88b1, 0x8983, 0x8996,
/* 30 */ 0x8a3b, 0x8a60, 0x8a55, 0x8a5e, 0x8a3c, 0x8a41, 0x9593, 0x9592,
/* 38 */ 0x958e, 0x968a, 0x968e, 0x968b, 0x967d, 0x9685, 0x9686, 0x968d
},

/* Row 0x07a */
{
/* 00 */ 0x9672, 0x9684, 0x96c1, 0x96c5, 0x96c4, 0x96c6, 0x96c7, 0x96ef,
/* 08 */ 0x96f2, 0x97cc, 0x9805, 0x9806, 0x9808, 0x98e7, 0x98ea, 0x98ef,
/* 10 */ 0x98e9, 0x98f2, 0x98ed, 0x99ae, 0x99ad, 0x9ec3, 0x9ecd, 0x9ed1,
/* 18 */ 0x4e82, 0x50ad, 0x50b5, 0x50b2, 0x50b3, 0x50c5, 0x50be, 0x50ac,
/* 20 */ 0x50b7, 0x50bb, 0x50af, 0x50c7, 0x527f, 0x5277, 0x527d, 0x52df,
/* 28 */ 0x52e6, 0x52e4, 0x52e2, 0x52e3, 0x532f, 0x55df, 0x55e8, 0x55d3,
/* 30 */ 0x55e6, 0x55ce, 0x55dc, 0x55c7, 0x55d1, 0x55e3, 0x55e4, 0x55ef,
/* 38 */ 0x55da, 0x55e1, 0x55c5, 0x55c6, 0x55e5, 0x55c9, 0x5712, 0x5713
},

/* Row 0x07b */
{
/* 00 */ 0x585e, 0x5851, 0x5858, 0x5857, 0x585a, 0x5854, 0x586b, 0x584c,
/* 08 */ 0x586d, 0x584a, 0x5862, 0x5852, 0x584b, 0x5967, 0x5ac1, 0x5ac9,
/* 10 */ 0x5acc, 0x5abe, 0x5abd, 0x5abc, 0x695a, 0x6977, 0x6960, 0x6954,
/* 18 */ 0x6975, 0x6930, 0x6982, 0x694a, 0x6968, 0x696b, 0x695e, 0x6953,
/* 20 */ 0x6979, 0x6986, 0x695d, 0x6963, 0x695b, 0x6b47, 0x6b72, 0x6bc0,
/* 28 */ 0x6bbf, 0x6bd3, 0x6bfd, 0x6ea2, 0x6eaf, 0x6ed3, 0x6eb6, 0x6ec2,
/* 30 */ 0x6e90, 0x6e9d, 0x6ec7, 0x6ec5, 0x6ea5, 0x6e98, 0x6ebc, 0x6eba,
/* 38 */ 0x6eab, 0x6ed1, 0x6e96, 0x6e9c, 0x6ec4, 0x6ed4, 0x6eaa, 0x6ea7
},

/* Row 0x07c */
{
/* 00 */ 0x6eb4, 0x714e, 0x7159, 0x7169, 0x7164, 0x7149, 0x7167, 0x715c,
/* 08 */ 0x716c, 0x7166, 0x714c, 0x7165, 0x715e, 0x7146, 0x7168, 0x7156,
/* 10 */ 0x723a, 0x7252, 0x7337, 0x7345, 0x733f, 0x733e, 0x746f, 0x745a,
/* 18 */ 0x7455, 0x745f, 0x745e, 0x7441, 0x743f, 0x7459, 0x745b, 0x745c,
/* 20 */ 0x7576, 0x7578, 0x7600, 0x75f0, 0x7601, 0x75f2, 0x75f1, 0x75fa,
/* 28 */ 0x75ff, 0x75f4, 0x75f3, 0x76de, 0x76df, 0x775b, 0x776b, 0x7766,
/* 30 */ 0x775e, 0x7763, 0x8179, 0x817a, 0x8166, 0x8205, 0x8247, 0x8482,
/* 38 */ 0x8477, 0x843d, 0x8431, 0x8475, 0x8466, 0x846b, 0x8449, 0x846c
},

/* Row 0x07d */
{
/* 00 */ 0x845b, 0x843c, 0x8435, 0x8461, 0x8463, 0x8469, 0x846d, 0x8446,
/* 08 */ 0x865e, 0x865c, 0x865f, 0x86f9, 0x8713, 0x8708, 0x8707, 0x8700,
/* 10 */ 0x86fe, 0x86fb, 0x8702, 0x8703, 0x8706, 0x870a, 0x8859, 0x88df,
/* 18 */ 0x88d4, 0x88d9, 0x88dc, 0x88d8, 0x88dd, 0x88e1, 0x88ca, 0x88d5,
/* 20 */ 0x88d2, 0x899c, 0x89e3, 0x8a6b, 0x8a72, 0x8a73, 0x8a66, 0x8a69,
/* 28 */ 0x8a70, 0x8a87, 0x8a7c, 0x8a63, 0x8aa0, 0x8a71, 0x8a85, 0x8a6d,
/* 30 */ 0x8a62, 0x8a6e, 0x8a6c, 0x8a79, 0x8a7b, 0x8a3e, 0x8a68, 0x8c62,
/* 38 */ 0x8c8a, 0x8c89, 0x8cca, 0x8cc7, 0x8cc8, 0x8cc4, 0x8cb2, 0x8cc3
},

/* Row 0x07e */
{
/* 00 */ 0x8cc2, 0x8cc5, 0x8de1, 0x8ddf, 0x8de8, 0x8def, 0x8df3, 0x8dfa,
/* 08 */ 0x8dea, 0x8de4, 0x8de6, 0x8eb2, 0x8f03, 0x8f09, 0x8efe, 0x8f0a,
/* 10 */ 0x98fd, 0x98fe, 0x99b3, 0x99b1, 0x99b4, 0x9ae1, 0x9ce9, 0x9e82,
/* 18 */ 0x9f0e, 0x9f13, 0x9f20, 0x50e7, 0x50ee, 0x50e5, 0x50d6, 0x50ed,
/* 20 */ 0x50da, 0x50d5, 0x50cf, 0x50d1, 0x50f1, 0x50ce, 0x50e9, 0x5162,
/* 28 */ 0x51f3, 0x5283, 0x5282, 0x5331, 0x53ad, 0x55fe, 0x5600, 0x561b,
/* 30 */ 0x5617, 0x55fd, 0x5614, 0x5606, 0x5609, 0x560d, 0x560e, 0x55f7,
/* 38 */ 0x5616, 0x561f, 0x5608, 0x5610, 0x55f6, 0x5718, 0x5716, 0x5875
},

/* Row 0x07f */
{
/* 00 */ 0x587e, 0x5883, 0x5893, 0x588a, 0x5879, 0x5885, 0x587d, 0x58fd,
/* 08 */ 0x5925, 0x5922, 0x5924, 0x596a, 0x5969, 0x5ae1, 0x5ae6, 0x5ae9,
/* 10 */ 0x5ad7, 0x5ad6, 0x5ad8, 0x5ae3, 0x5b75, 0x5bde, 0x5be7, 0x5be1,
/* 18 */ 0x5be5, 0x5be6, 0x5be8, 0x5be2, 0x5be4, 0x5bdf, 0x5c0d, 0x5c62,
/* 20 */ 0x5d84, 0x5d87, 0x5e5b, 0x5e63, 0x5e55, 0x5e57, 0x5e54, 0x5ed3,
/* 28 */ 0x5ed6, 0x5f0a, 0x5f46, 0x5f70, 0x5fb9, 0x6147, 0x6eff, 0x6eef,
/* 30 */ 0x6f06, 0x6f31, 0x6f38, 0x6f32, 0x6f23, 0x6f15, 0x6f2b, 0x6f2f,
/* 38 */ 0x6f88, 0x6f2a, 0x6eec, 0x6f01, 0x6ef2, 0x6ecc, 0x6ef7, 0x7194
},

/* Row 0x080 */
{
/* 00 */ 0x7199, 0x717d, 0x718a, 0x7184, 0x7192, 0x723e, 0x7292, 0x7296,
/* 08 */ 0x7344, 0x7350, 0x7464, 0x7463, 0x746a, 0x7470, 0x746d, 0x7504,
/* 10 */ 0x7591, 0x7627, 0x760d, 0x760b, 0x7609, 0x7613, 0x76e1, 0x76e3,
/* 18 */ 0x7784, 0x777d, 0x777f, 0x7761, 0x78c1, 0x789f, 0x78a7, 0x78b3,
/* 20 */ 0x78a9, 0x78a3, 0x798e, 0x798f, 0x798d, 0x7a2e, 0x7a31, 0x7aaa,
/* 28 */ 0x7aa9, 0x7aed, 0x7aef, 0x7ba1, 0x7b95, 0x7b8b, 0x7b75, 0x7b97,
/* 30 */ 0x7b9d, 0x7b94, 0x7b8f, 0x7bb8, 0x7b87, 0x7b84, 0x7cb9, 0x7cbd,
/* 38 */ 0x7cbe, 0x7dbb, 0x7db0, 0x7d9c, 0x7dbd, 0x7dbe, 0x7da0, 0x7dca
},

/* Row 0x081 */
{
/* 00 */ 0x7db4, 0x7db2, 0x7db1, 0x7dba, 0x7da2, 0x7dbf, 0x7db5, 0x7db8,
/* 08 */ 0x7dad, 0x7dd2, 0x7dc7, 0x7dac, 0x8aaa, 0x8aa5, 0x8aa8, 0x8a98,
/* 10 */ 0x8a91, 0x8a9a, 0x8aa7, 0x8c6a, 0x8c8d, 0x8c8c, 0x8cd3, 0x8cd1,
/* 18 */ 0x8cd2, 0x8d6b, 0x8d99, 0x8d95, 0x8dfc, 0x8f14, 0x8f12, 0x8f15,
/* 20 */ 0x8f13, 0x8fa3, 0x9060, 0x9058, 0x905c, 0x9063, 0x9059, 0x905e,
/* 28 */ 0x9062, 0x905d, 0x905b, 0x9119, 0x9118, 0x911e, 0x9175, 0x9178,
/* 30 */ 0x9177, 0x9174, 0x9278, 0x9280, 0x9285, 0x9298, 0x9296, 0x927b,
/* 38 */ 0x9293, 0x929c, 0x92a8, 0x927c, 0x9291, 0x95a1, 0x95a8, 0x95a9
},

/* Row 0x082 */
{
/* 00 */ 0x95a3, 0x95a5, 0x95a4, 0x9699, 0x969c, 0x969b, 0x96cc, 0x96d2,
/* 08 */ 0x9700, 0x977c, 0x9785, 0x97f6, 0x9817, 0x9818, 0x98af, 0x98b1,
/* 10 */ 0x9903, 0x9905, 0x990c, 0x9909, 0x99c1, 0x9aaf, 0x9ab0, 0x9ae6,
/* 18 */ 0x9b41, 0x9b42, 0x9cf4, 0x9cf6, 0x9cf3, 0x9ebc, 0x9f3b, 0x9f4a,
/* 20 */ 0x5104, 0x5100, 0x50fb, 0x50f5, 0x50f9, 0x5102, 0x5108, 0x5109,
/* 28 */ 0x5105, 0x51dc, 0x617c, 0x6170, 0x616b, 0x617e, 0x61a7, 0x6190,
/* 30 */ 0x61ab, 0x618e, 0x61ac, 0x619a, 0x61a4, 0x6194, 0x61ae, 0x622e,
/* 38 */ 0x6469, 0x646f, 0x6479, 0x649e, 0x64b2, 0x6488, 0x6490, 0x64b0
},

/* Row 0x083 */
{
/* 00 */ 0x64a5, 0x6493, 0x6495, 0x64a9, 0x6492, 0x64ae, 0x64ad, 0x64ab,
/* 08 */ 0x649a, 0x64ac, 0x6499, 0x64a2, 0x64b3, 0x6575, 0x6577, 0x6578,
/* 10 */ 0x66ae, 0x66ab, 0x66b4, 0x66b1, 0x6a23, 0x6a1f, 0x69e8, 0x6a01,
/* 18 */ 0x6a1e, 0x6a19, 0x69fd, 0x6a21, 0x6a13, 0x6a0a, 0x69f3, 0x6a02,
/* 20 */ 0x6a05, 0x69ed, 0x6a11, 0x6b50, 0x6b4e, 0x6ba4, 0x6bc5, 0x6bc6,
/* 28 */ 0x6f3f, 0x6f7c, 0x6f84, 0x6f51, 0x6f66, 0x6f54, 0x6f86, 0x6f6d,
/* 30 */ 0x6f5b, 0x6f78, 0x6f6e, 0x6f8e, 0x6f7a, 0x6f70, 0x6f64, 0x6f97,
/* 38 */ 0x6f58, 0x6ed5, 0x6f6f, 0x6f60, 0x6f5f, 0x719f, 0x71ac, 0x71b1
},

/* Row 0x084 */
{
/* 00 */ 0x71a8, 0x7256, 0x729b, 0x734e, 0x7357, 0x7469, 0x748b, 0x7483,
/* 08 */ 0x7fe9, 0x8026, 0x819b, 0x819c, 0x819d, 0x81a0, 0x819a, 0x8198,
/* 10 */ 0x8517, 0x853d, 0x851a, 0x84ee, 0x852c, 0x852d, 0x8513, 0x8511,
/* 18 */ 0x8523, 0x8521, 0x8514, 0x84ec, 0x8525, 0x84ff, 0x8506, 0x8782,
/* 20 */ 0x8774, 0x8776, 0x8760, 0x8766, 0x8778, 0x8768, 0x8759, 0x8757,
/* 28 */ 0x874c, 0x8753, 0x885b, 0x885d, 0x8910, 0x8907, 0x8912, 0x8913,
/* 30 */ 0x8915, 0x890a, 0x8abc, 0x8ad2, 0x8ac7, 0x8ac4, 0x8a95, 0x8acb,
/* 38 */ 0x8af8, 0x8ab2, 0x8ac9, 0x8ac2, 0x8abf, 0x8ab0, 0x8ad6, 0x8acd
},

/* Row 0x085 */
{
/* 00 */ 0x8ab6, 0x8ab9, 0x8adb, 0x8c4c, 0x8c4e, 0x8c6c, 0x8ce0, 0x8cde,
/* 08 */ 0x8ce6, 0x8ce4, 0x8cec, 0x8ced, 0x8ce2, 0x8ce3, 0x8cdc, 0x8cea,
/* 10 */ 0x8ce1, 0x8d6d, 0x8d9f, 0x8da3, 0x8e2b, 0x8e10, 0x8e1d, 0x8e22,
/* 18 */ 0x8e0f, 0x8e29, 0x8e1f, 0x8e21, 0x8e1e, 0x8eba, 0x8f1d, 0x8f1b,
/* 20 */ 0x8f1f, 0x8f29, 0x8f26, 0x8f2a, 0x8f1c, 0x8f1e, 0x9d03, 0x9ea9,
/* 28 */ 0x9ebe, 0x9ece, 0x58a8, 0x9f52, 0x5112, 0x5118, 0x5114, 0x5110,
/* 30 */ 0x5115, 0x5180, 0x51aa, 0x51dd, 0x5291, 0x5293, 0x52f3, 0x5659,
/* 38 */ 0x566b, 0x5679, 0x5669, 0x5664, 0x5678, 0x566a, 0x5668, 0x5665
},

/* Row 0x086 */
{
/* 00 */ 0x5671, 0x566f, 0x566c, 0x5662, 0x5676, 0x58c1, 0x58be, 0x58c7,
/* 08 */ 0x58c5, 0x596e, 0x5b1d, 0x5b34, 0x5b78, 0x5bf0, 0x5c0e, 0x5f4a,
/* 10 */ 0x61b2, 0x6191, 0x61a9, 0x618a, 0x61cd, 0x61b6, 0x61be, 0x61ca,
/* 18 */ 0x61c8, 0x6230, 0x64c5, 0x64c1, 0x64cb, 0x64bb, 0x64bc, 0x64da,
/* 20 */ 0x64c4, 0x64c7, 0x64c2, 0x64cd, 0x64bf, 0x64d2, 0x64d4, 0x64be,
/* 28 */ 0x6574, 0x66c6, 0x66c9, 0x66b9, 0x66c4, 0x66c7, 0x66b8, 0x6a3d,
/* 30 */ 0x6a38, 0x6a3a, 0x6a59, 0x6a6b, 0x6a58, 0x6a39, 0x6a44, 0x6a62,
/* 38 */ 0x6a61, 0x6a4b, 0x6a47, 0x6a35, 0x6a5f, 0x6a48, 0x6b59, 0x6b77
},

/* Row 0x087 */
{
/* 00 */ 0x6c05, 0x6fc2, 0x6fb1, 0x6fa1, 0x7e11, 0x7e08, 0x7e1b, 0x7e23,
/* 08 */ 0x7e1e, 0x7e1d, 0x7e09, 0x7e10, 0x7f79, 0x7fb2, 0x7ff0, 0x7ff1,
/* 10 */ 0x7fee, 0x8028, 0x81b3, 0x81a9, 0x81a8, 0x81fb, 0x8208, 0x8258,
/* 18 */ 0x8259, 0x854a, 0x8559, 0x8548, 0x8568, 0x8569, 0x8543, 0x8549,
/* 20 */ 0x856d, 0x856a, 0x855e, 0x8783, 0x879f, 0x879e, 0x87a2, 0x878d,
/* 28 */ 0x8861, 0x892a, 0x8932, 0x8925, 0x892b, 0x8921, 0x89aa, 0x89a6,
/* 30 */ 0x8ae6, 0x8afa, 0x8aeb, 0x8af1, 0x8b00, 0x8adc, 0x8ae7, 0x8aee,
/* 38 */ 0x8afe, 0x8b01, 0x8b02, 0x8af7, 0x8aed, 0x8af3, 0x8af6, 0x8afc
},

/* Row 0x088 */
{
/* 00 */ 0x8c6b, 0x8c6d, 0x8c93, 0x8cf4, 0x8e44, 0x8e31, 0x8e34, 0x8e42,
/* 08 */ 0x8e39, 0x8e35, 0x8f3b, 0x8f2f, 0x8f38, 0x8f33, 0x8fa8, 0x8fa6,
/* 10 */ 0x9075, 0x9074, 0x9078, 0x9072, 0x907c, 0x907a, 0x9134, 0x9192,
/* 18 */ 0x9320, 0x9336, 0x92f8, 0x9333, 0x932f, 0x9322, 0x92fc, 0x932b,
/* 20 */ 0x9304, 0x931a, 0x568f, 0x58d5, 0x58d3, 0x58d1, 0x58ce, 0x5b30,
/* 28 */ 0x5b2a, 0x5b24, 0x5b7a, 0x5c37, 0x5c68, 0x5dbc, 0x5dba, 0x5dbd,
/* 30 */ 0x5db8, 0x5e6b, 0x5f4c, 0x5fbd, 0x61c9, 0x61c2, 0x61c7, 0x61e6,
/* 38 */ 0x61cb, 0x6232, 0x6234, 0x64ce, 0x64ca, 0x64d8, 0x64e0, 0x64f0
},

/* Row 0x089 */
{
/* 00 */ 0x64e6, 0x64ec, 0x64f1, 0x64e2, 0x64ed, 0x6582, 0x6583, 0x66d9,
/* 08 */ 0x66d6, 0x6a80, 0x6a94, 0x6a84, 0x6aa2, 0x6a9c, 0x6adb, 0x6aa3,
/* 10 */ 0x6a7e, 0x6a97, 0x6a90, 0x6aa0, 0x6b5c, 0x6bae, 0x6bda, 0x6c08,
/* 18 */ 0x6fd8, 0x6ff1, 0x6fdf, 0x6fe0, 0x6fdb, 0x6fe4, 0x6feb, 0x6fef,
/* 20 */ 0x6f80, 0x6fec, 0x6fe1, 0x6fe9, 0x6fd5, 0x6fee, 0x6ff0, 0x71e7,
/* 28 */ 0x71df, 0x71ee, 0x71e6, 0x71e5, 0x71ed, 0x71ec, 0x71f4, 0x71e0,
/* 30 */ 0x7235, 0x7246, 0x7370, 0x7372, 0x74a9, 0x74b0, 0x74a6, 0x74a8,
/* 38 */ 0x7646, 0x7642, 0x764c, 0x76ea, 0x77b3, 0x77aa, 0x77b0, 0x77ac
},

/* Row 0x08a */
{
/* 00 */ 0x8584, 0x857e, 0x859c, 0x8591, 0x8594, 0x85af, 0x859b, 0x8587,
/* 08 */ 0x85a8, 0x858a, 0x8667, 0x87c0, 0x87d1, 0x87b3, 0x87d2, 0x87c6,
/* 10 */ 0x87ab, 0x87bb, 0x87ba, 0x87c8, 0x87cb, 0x893b, 0x8936, 0x8944,
/* 18 */ 0x8938, 0x893d, 0x89ac, 0x8b0e, 0x8b17, 0x8b19, 0x8b1b, 0x8b0a,
/* 20 */ 0x8b20, 0x8b1d, 0x8b04, 0x8b10, 0x8c41, 0x8c3f, 0x8c73, 0x8cfa,
/* 28 */ 0x8cfd, 0x8cfc, 0x8cf8, 0x8cfb, 0x8da8, 0x8e49, 0x8e4b, 0x8e48,
/* 30 */ 0x8e4a, 0x8f44, 0x8f3e, 0x8f42, 0x8f45, 0x8f3f, 0x907f, 0x907d,
/* 38 */ 0x9084, 0x9081, 0x9082, 0x9080, 0x9139, 0x91a3, 0x919e, 0x919c
},

/* Row 0x08b */
{
/* 00 */ 0x934d, 0x9382, 0x9328, 0x9375, 0x934a, 0x9365, 0x934b, 0x9318,
/* 08 */ 0x937e, 0x936c, 0x935b, 0x9370, 0x935a, 0x9354, 0x95ca, 0x95cb,
/* 10 */ 0x95cc, 0x95c8, 0x95c6, 0x96b1, 0x96b8, 0x96d6, 0x971c, 0x971e,
/* 18 */ 0x97a0, 0x97d3, 0x9846, 0x98b6, 0x9935, 0x9a01, 0x7652, 0x77bd,
/* 20 */ 0x77bf, 0x77bb, 0x77bc, 0x790e, 0x79ae, 0x7a61, 0x7a62, 0x7a60,
/* 28 */ 0x7ac4, 0x7ac5, 0x7c2b, 0x7c27, 0x7c2a, 0x7c1e, 0x7c23, 0x7c21,
/* 30 */ 0x7ce7, 0x7e54, 0x7e55, 0x7e5e, 0x7e5a, 0x7e61, 0x7e52, 0x7e59,
/* 38 */ 0x7f48, 0x7ff9, 0x7ffb, 0x8077, 0x8076, 0x81cd, 0x81cf, 0x820a
},

/* Row 0x08c */
{
/* 00 */ 0x85cf, 0x85a9, 0x85cd, 0x85d0, 0x85c9, 0x85b0, 0x85ba, 0x85b9,
/* 08 */ 0x85a6, 0x87ef, 0x87ec, 0x87f2, 0x87e0, 0x8986, 0x89b2, 0x89f4,
/* 10 */ 0x8b28, 0x8b39, 0x8b2c, 0x8b2b, 0x8c50, 0x8d05, 0x8e59, 0x8e63,
/* 18 */ 0x8e66, 0x8e64, 0x8e5f, 0x8e55, 0x8ec0, 0x8f49, 0x8f4d, 0x9087,
/* 20 */ 0x9083, 0x9088, 0x91ab, 0x91ac, 0x91d0, 0x9394, 0x938a, 0x9396,
/* 28 */ 0x93a2, 0x93b3, 0x93ae, 0x93ac, 0x93b0, 0x9398, 0x939a, 0x9397,
/* 30 */ 0x95d4, 0x95d6, 0x95d0, 0x95d5, 0x96e2, 0x96dc, 0x96d9, 0x96db,
/* 38 */ 0x96de, 0x9724, 0x97a3, 0x97a6, 0x737a, 0x74bd, 0x74ca, 0x74e3
},

/* Row 0x08d */
{
/* 00 */ 0x7587, 0x7586, 0x765f, 0x7661, 0x77c7, 0x7919, 0x79b1, 0x7a6b,
/* 08 */ 0x7a69, 0x7c3e, 0x7c3f, 0x7c38, 0x7c3d, 0x7c37, 0x7c40, 0x7e6b,
/* 10 */ 0x7e6d, 0x7e79, 0x7e69, 0x7e6a, 0x7f85, 0x7e73, 0x7fb6, 0x7fb9,
/* 18 */ 0x7fb8, 0x81d8, 0x85e9, 0x85dd, 0x85ea, 0x85d5, 0x85e4, 0x85e5,
/* 20 */ 0x85f7, 0x87fb, 0x8805, 0x880d, 0x87f9, 0x87fe, 0x8960, 0x895f,
/* 28 */ 0x8956, 0x895e, 0x8b41, 0x8b5c, 0x8b58, 0x8b49, 0x8b5a, 0x8b4e,
/* 30 */ 0x8b4f, 0x8b46, 0x8b59, 0x8d08, 0x8d0a, 0x8e7c, 0x8e72, 0x8e87,
/* 38 */ 0x8e76, 0x8e6c, 0x8e7a, 0x8e74, 0x8f54, 0x8f4e, 0x8fad, 0x908a
},

/* Row 0x08e */
{
/* 00 */ 0x908b, 0x91b1, 0x91ae, 0x93e1, 0x93d1, 0x93df, 0x93c3, 0x93c8,
/* 08 */ 0x93dc, 0x93dd, 0x93d6, 0x93e2, 0x93cd, 0x93d8, 0x93e4, 0x93d7,
/* 10 */ 0x93e8, 0x95dc, 0x96b4, 0x96e3, 0x972a, 0x9727, 0x9761, 0x97dc,
/* 18 */ 0x97fb, 0x985e, 0x7e82, 0x7f4c, 0x8000, 0x81da, 0x8266, 0x85fb,
/* 20 */ 0x85f9, 0x8611, 0x85fa, 0x8606, 0x860b, 0x8607, 0x860a, 0x8814,
/* 28 */ 0x8815, 0x8964, 0x89ba, 0x89f8, 0x8b70, 0x8b6c, 0x8b66, 0x8b6f,
/* 30 */ 0x8b5f, 0x8b6b, 0x8d0f, 0x8d0d, 0x8e89, 0x8e81, 0x8e85, 0x8e82,
/* 38 */ 0x91b4, 0x91cb, 0x9418, 0x9403, 0x93fd, 0x95e1, 0x9730, 0x98c4
},

/* Row 0x08f */
{
/* 00 */ 0x9952, 0x9951, 0x99a8, 0x9a2b, 0x9a30, 0x9a37, 0x9a35, 0x9c13,
/* 08 */ 0x9c0d, 0x9e79, 0x9eb5, 0x9ee8, 0x9f2f, 0x9f5f, 0x9f63, 0x9f61,
/* 10 */ 0x5137, 0x5138, 0x56c1, 0x56c0, 0x56c2, 0x5914, 0x5c6c, 0x5dcd,
/* 18 */ 0x61fc, 0x61fe, 0x651d, 0x651c, 0x6595, 0x66e9, 0x6afb, 0x6b04,
/* 20 */ 0x6afa, 0x6bb2, 0x704c, 0x721b, 0x72a7, 0x74d6, 0x74d4, 0x7669,
/* 28 */ 0x77d3, 0x7c50, 0x7e8f, 0x7e8c, 0x7fbc, 0x8617, 0x862d, 0x861a,
/* 30 */ 0x8823, 0x8822, 0x8821, 0x881f, 0x896a, 0x896c, 0x89bd, 0x8b74,
/* 38 */ 0x79b3, 0x7c60, 0x7c5f, 0x807e, 0x807d, 0x81df, 0x8972, 0x896f
},

/* Row 0x090 */
{
/* 00 */ 0x89fc, 0x8b80, 0x8d16, 0x8d17, 0x8e91, 0x8e93, 0x8f61, 0x9148,
/* 08 */ 0x9444, 0x9451, 0x9452, 0x973d, 0x973e, 0x97c3, 0x97c1, 0x986b,
/* 10 */ 0x9955, 0x9a55, 0x9a4d, 0x9ad2, 0x9b1a, 0x9c49, 0x9c31, 0x9c3e,
/* 18 */ 0x9c3b, 0x9dd3, 0x9dd7, 0x9f34, 0x9f6c, 0x9f6a, 0x9f94, 0x56cc,
/* 20 */ 0x5dd6, 0x6200, 0x6523, 0x652b, 0x652a, 0x66ec, 0x6b10, 0x74da,
/* 28 */ 0x7aca, 0x7c64, 0x7c63, 0x7c65, 0x7e93, 0x7e96, 0x7e94, 0x81e2,
/* 30 */ 0x8638, 0x863f, 0x8831, 0x8b8a, 0x9090, 0x908f, 0x9463, 0x9460,
/* 38 */ 0x9464, 0x9768, 0x986f, 0x995c, 0x9a5a, 0x9a5b, 0x9a57, 0x9ad3
},

/* Row 0x091 */
{
/* 00 */ 0x9ad4, 0x9ad1, 0x9c54, 0x9c57, 0x9c56, 0x9de5, 0x9e9f, 0x9ef4,
/* 08 */ 0x56d1, 0x58e9, 0x652c, 0x705e, 0x7671, 0x7672, 0x77d7, 0x7f50,
/* 10 */ 0x7f88, 0x8836, 0x8839, 0x8862, 0x8b93, 0x8b92, 0x30fe, 0x309d,
/* 18 */ 0x309e, 0x3005, 0x3041, 0x3042, 0x3043, 0x3044, 0x3045, 0x3046,
/* 20 */ 0x3047, 0x3048, 0x3049, 0x304a, 0x304b, 0x304c, 0x304d, 0x304e,
/* 28 */ 0x304f, 0x3050, 0x3051, 0x3052, 0x3053, 0x3054, 0x3055, 0x3056,
/* 30 */ 0x3057, 0x3058, 0x3059, 0x305a, 0x305b, 0x305c, 0x305d, 0x305e,
/* 38 */ 0x305f, 0x3060, 0x3061, 0x3062, 0x3063, 0x3064, 0x3065, 0x3066
},

/* Row 0x092 */
{
/* 00 */ 0x3067, 0x3068, 0x3069, 0x306a, 0x306b, 0x306c, 0x306d, 0x306e,
/* 08 */ 0x306f, 0x3070, 0x3071, 0x3072, 0x3073, 0x3074, 0x3075, 0x3076,
/* 10 */ 0x3077, 0x3078, 0x3079, 0x307a, 0x307b, 0x307c, 0x307d, 0x307e,
/* 18 */ 0x307f, 0x3080, 0x3081, 0x3082, 0x3083, 0x3084, 0x3085, 0x3086,
/* 20 */ 0x3087, 0x3088, 0x3089, 0x308a, 0x308b, 0x308c, 0x308d, 0x308e,
/* 28 */ 0x308f, 0x3090, 0x3091, 0x3092, 0x3093, 0x30a1, 0x30a2, 0x30a3,
/* 30 */ 0x30a4, 0x30a5, 0x30a6, 0x30a7, 0x30e7, 0x30e8, 0x30e9, 0x30ea,
/* 38 */ 0x30eb, 0x30ec, 0x30ed, 0x30ee, 0x30ef, 0x30f0, 0x30f1, 0x30f2
},

/* Row 0x093 */
{
/* 00 */ 0x30f3, 0x30f4, 0x30f5, 0x30f6, 0x0414, 0x0415, 0x0401, 0x0416,
/* 08 */ 0x0417, 0x0418, 0x0419, 0x041a, 0x041b, 0x041c, 0x0423, 0x0424,
/* 10 */ 0x0425, 0x0426, 0x0427, 0x0428, 0x0429, 0x042a, 0x042b, 0x042c,
/* 18 */ 0x042d, 0x042e, 0x042f, 0x0430, 0x0431, 0x0432, 0x0433, 0x0434,
/* 20 */ 0x0435, 0x0451, 0x0436, 0x0437, 0x0438, 0x0439, 0x043a, 0x043b,
/* 28 */ 0x043c, 0x043d, 0x043e, 0x043f, 0x0440, 0x0441, 0x0442, 0x0443,
/* 30 */ 0x0444, 0x0445, 0x0446, 0x0447, 0x0448, 0x0449, 0x044a, 0x044b,
/* 38 */ 0x044c, 0x044d, 0x044e, 0x044f, 0x2460, 0x2461, 0x2462, 0x2463
},

/* Row 0x094 */
{
/* 00 */ 0x2464, 0x2465, 0x2466, 0x2467, 0x2468, 0x2469, 0x2474, 0x2475,
/* 08 */ 0x2476, 0x2477, 0x2478, 0x2479, 0x247a, 0x247b, 0x247c, 0x247d,
/* 10 */ 0xf6f0, 0xf6f1, 0xf731, 0xf732, 0xf733, 0xf734, 0xf735, 0xf736,
/* 18 */ 0xf737, 0xf738, 0xf739, 0xf73a, 0xf73b, 0xf73c, 0xf73d, 0xf73e,
/* 20 */ 0xf73f, 0xf740, 0xf741, 0xf742, 0xf743, 0xf744, 0xf745, 0xf746,
/* 28 */ 0xf747, 0xf748, 0xf749, 0xf74a, 0xf74b, 0xf74c, 0xf74d, 0xf74e,
/* 30 */ 0xf74f, 0xf750, 0xf751, 0xf752, 0xf753, 0xf754, 0xf755, 0xf756,
/* 38 */ 0xf757, 0xf758, 0xf759, 0xf75a, 0xf75b, 0xf75c, 0xf75d, 0xf75e
},

/* Row 0x095 */
{
/* 00 */ 0xf75f, 0xf760, 0xf761, 0xf762, 0xf763, 0xf764, 0xf765, 0xf766,
/* 08 */ 0xf767, 0xf768, 0xf769, 0xf76a, 0xf76b, 0xf76c, 0xf76d, 0xf76e,
/* 10 */ 0xf76f, 0xf770, 0xf771, 0xf772, 0xf773, 0xf774, 0xf775, 0xf776,
/* 18 */ 0xf777, 0xf778, 0xf779, 0xf77a, 0xf77b, 0xf77c, 0xf77d, 0xf77e,
/* 20 */ 0xf77f, 0xf780, 0xf781, 0xf782, 0xf783, 0xf784, 0xf785, 0xf786,
/* 28 */ 0xf787, 0xf788, 0xf789, 0xf78a, 0xf78b, 0xf78c, 0xf78d, 0xf78e,
/* 30 */ 0x6c36, 0x6c43, 0x6c3f, 0x6c3b, 0x72ae, 0x72b0, 0x738a, 0x79b8,
/* 38 */ 0x808a, 0x961e, 0x4f0e, 0x4f18, 0x4f2c, 0x4ef5, 0x4f14, 0x4ef1
},

/* Row 0x096 */
{
/* 00 */ 0x4f00, 0x4ef7, 0x4f08, 0x4f1d, 0x4f02, 0x4f05, 0x4f22, 0x4f13,
/* 08 */ 0x4f04, 0x4ef4, 0x4f12, 0x51b1, 0x5213, 0x5209, 0x5210, 0x52a6,
/* 10 */ 0x5322, 0x531f, 0x534d, 0x538a, 0x5407, 0x56e1, 0x56df, 0x572e,
/* 18 */ 0x572a, 0x5734, 0x593c, 0x5980, 0x597c, 0x5985, 0x597b, 0x597e,
/* 20 */ 0x5977, 0x597f, 0x5b56, 0x5c15, 0x5c25, 0x5c7c, 0x5c7a, 0x5c7b,
/* 28 */ 0x5c7e, 0x5ddf, 0x5e75, 0x5e84, 0x5f02, 0x5f1a, 0x5f74, 0x5fd5,
/* 30 */ 0x5fd4, 0x5fcf, 0x625c, 0x625e, 0x6264, 0x6261, 0x6266, 0x6262,
/* 38 */ 0x6259, 0x6260, 0x625a, 0x6265, 0x65ef, 0x65ee, 0x673e, 0x6739
},

/* Row 0x097 */
{
/* 00 */ 0x6738, 0x673b, 0x673a, 0x673f, 0x673c, 0x6733, 0x6c18, 0x6c46,
/* 08 */ 0x6c52, 0x6c5c, 0x6c4f, 0x6c4a, 0x6c54, 0x6c4b, 0x543d, 0x544f,
/* 10 */ 0x5441, 0x5428, 0x5424, 0x5447, 0x56ee, 0x56e7, 0x56e5, 0x5741,
/* 18 */ 0x5745, 0x574c, 0x5749, 0x574b, 0x5752, 0x5906, 0x5940, 0x59a6,
/* 20 */ 0x5998, 0x59a0, 0x5997, 0x598e, 0x59a2, 0x5990, 0x598f, 0x59a7,
/* 28 */ 0x59a1, 0x5b8e, 0x5b92, 0x5c28, 0x5c2a, 0x5c8d, 0x5c8f, 0x5c88,
/* 30 */ 0x5c8b, 0x5c89, 0x5c92, 0x5c8a, 0x5c86, 0x5c93, 0x5c95, 0x5de0,
/* 38 */ 0x5e0a, 0x5e0e, 0x5e8b, 0x5e89, 0x5e8c, 0x5e88, 0x5e8d, 0x5f05
},

/* Row 0x098 */
{
/* 00 */ 0x5f1d, 0x5f78, 0x5f76, 0x5fd2, 0x5fd1, 0x5fd0, 0x5fed, 0x5fe8,
/* 08 */ 0x5fee, 0x5ff3, 0x5fe1, 0x5fe4, 0x5fe3, 0x5ffa, 0x5fef, 0x5ff7,
/* 10 */ 0x5ffb, 0x6000, 0x5ff4, 0x623a, 0x6283, 0x628c, 0x628e, 0x628f,
/* 18 */ 0x6294, 0x6287, 0x6271, 0x627b, 0x627a, 0x6270, 0x6281, 0x6288,
/* 20 */ 0x6277, 0x627d, 0x6272, 0x6274, 0x6537, 0x65f0, 0x65f4, 0x65f3,
/* 28 */ 0x65f2, 0x65f5, 0x6745, 0x6747, 0x828a, 0x8283, 0x8284, 0x8c78,
/* 30 */ 0x8fc9, 0x8fbf, 0x909f, 0x90a1, 0x90a5, 0x909e, 0x90a7, 0x90a0,
/* 38 */ 0x9630, 0x9628, 0x962f, 0x962d, 0x4e33, 0x4f98, 0x4f7c, 0x4f85
},

/* Row 0x099 */
{
/* 00 */ 0x4f7d, 0x4f80, 0x4f87, 0x4f76, 0x4f74, 0x4f89, 0x4f84, 0x4f77,
/* 08 */ 0x4f4c, 0x4f97, 0x4f6a, 0x4f9a, 0x4f79, 0x4f81, 0x4f78, 0x4f90,
/* 10 */ 0x4f9c, 0x4f94, 0x4f9e, 0x4f92, 0x4f82, 0x4f95, 0x4f6b, 0x4f6e,
/* 18 */ 0x519e, 0x51bc, 0x51be, 0x5235, 0x5232, 0x5233, 0x5246, 0x5231,
/* 20 */ 0x52bc, 0x530a, 0x530b, 0x533c, 0x5392, 0x5394, 0x5487, 0x547f,
/* 28 */ 0x5481, 0x5491, 0x5482, 0x5488, 0x546b, 0x547a, 0x547e, 0x5465,
/* 30 */ 0x546c, 0x5474, 0x5466, 0x548d, 0x546f, 0x5461, 0x5460, 0x5498,
/* 38 */ 0x5463, 0x5467, 0x5464, 0x56f7, 0x56f9, 0x576f, 0x5772, 0x576d
},

/* Row 0x09a */
{
/* 00 */ 0x576b, 0x5771, 0x5770, 0x5776, 0x5780, 0x5775, 0x577b, 0x5773,
/* 08 */ 0x5774, 0x5762, 0x6034, 0x600a, 0x6017, 0x6033, 0x601a, 0x601e,
/* 10 */ 0x602c, 0x6022, 0x600d, 0x6010, 0x602e, 0x6013, 0x6011, 0x600c,
/* 18 */ 0x6009, 0x601c, 0x6214, 0x623d, 0x62ad, 0x62b4, 0x62d1, 0x62be,
/* 20 */ 0x62aa, 0x62b6, 0x62ca, 0x62ae, 0x62b3, 0x62af, 0x62bb, 0x62a9,
/* 28 */ 0x62b0, 0x62b8, 0x653d, 0x65a8, 0x65bb, 0x6609, 0x65fc, 0x6604,
/* 30 */ 0x6612, 0x6608, 0x65fb, 0x6603, 0x660b, 0x660d, 0x6605, 0x65fd,
/* 38 */ 0x6611, 0x6610, 0x66f6, 0x670a, 0x6785, 0x676c, 0x678e, 0x6792
},

/* Row 0x09b */
{
/* 00 */ 0x6776, 0x677b, 0x6798, 0x6786, 0x6784, 0x6774, 0x678d, 0x678c,
/* 08 */ 0x677a, 0x679f, 0x6791, 0x6799, 0x6783, 0x677d, 0x6781, 0x6778,
/* 10 */ 0x6779, 0x6794, 0x6b25, 0x6b80, 0x6b7e, 0x6bde, 0x6c1d, 0x6c93,
/* 18 */ 0x6cec, 0x6ceb, 0x6cee, 0x6cd9, 0x6cb6, 0x6cd4, 0x6cad, 0x6ce7,
/* 20 */ 0x6cb7, 0x6cd0, 0x6cc2, 0x6cba, 0x6cc3, 0x6cc6, 0x6ced, 0x6cf2,
/* 28 */ 0x77f7, 0x7942, 0x793f, 0x79c5, 0x7a78, 0x7a7b, 0x7afb, 0x7c75,
/* 30 */ 0x7cfd, 0x8035, 0x808f, 0x80ae, 0x80a3, 0x80b8, 0x80b5, 0x80ad,
/* 38 */ 0x8220, 0x82a0, 0x82c0, 0x82ab, 0x829a, 0x8298, 0x829b, 0x82b5
},

/* Row 0x09c */
{
/* 00 */ 0x82a7, 0x82ae, 0x82bc, 0x829e, 0x82ba, 0x82b4, 0x82a8, 0x82a1,
/* 08 */ 0x82a9, 0x82c2, 0x82a4, 0x82c3, 0x82b6, 0x82a2, 0x8670, 0x866f,
/* 10 */ 0x866d, 0x866e, 0x8c56, 0x8fd2, 0x8fcb, 0x8fd3, 0x8fcd, 0x8fd6,
/* 18 */ 0x8fd5, 0x8fd7, 0x90b2, 0x90b4, 0x90af, 0x90b3, 0x90b0, 0x9639,
/* 20 */ 0x963d, 0x963c, 0x963a, 0x9643, 0x4fcd, 0x4fc5, 0x4fd3, 0x4fb2,
/* 28 */ 0x4fc9, 0x4fcb, 0x4fc1, 0x4fd4, 0x4fdc, 0x4fd9, 0x4fbb, 0x4fb3,
/* 30 */ 0x4fdb, 0x4fc7, 0x4fd6, 0x4fba, 0x4fc0, 0x4fb9, 0x4fec, 0x5244,
/* 38 */ 0x5249, 0x52c0, 0x52c2, 0x533d, 0x537c, 0x5397, 0x5396, 0x5399
},

/* Row 0x09d */
{
/* 00 */ 0x5398, 0x54ba, 0x54a1, 0x54ad, 0x54a5, 0x54cf, 0x5cde, 0x5cda,
/* 08 */ 0x5cc9, 0x5cc7, 0x5cca, 0x5cd6, 0x5cd3, 0x5cd4, 0x5ccf, 0x5cc8,
/* 10 */ 0x5cc6, 0x5cce, 0x5cdf, 0x5cf8, 0x5df9, 0x5e21, 0x5e22, 0x5e23,
/* 18 */ 0x5e20, 0x5e24, 0x5eb0, 0x5ea4, 0x5ea2, 0x5e9b, 0x5ea3, 0x5ea5,
/* 20 */ 0x5f07, 0x5f2e, 0x5f56, 0x5f86, 0x6037, 0x6039, 0x6054, 0x6072,
/* 28 */ 0x605e, 0x6045, 0x6053, 0x6047, 0x6049, 0x605b, 0x604c, 0x6040,
/* 30 */ 0x6042, 0x605f, 0x6024, 0x6044, 0x6058, 0x6066, 0x606e, 0x6242,
/* 38 */ 0x6243, 0x62cf, 0x630d, 0x630b, 0x62f5, 0x630e, 0x6303, 0x62eb
},

/* Row 0x09e */
{
/* 00 */ 0x62f9, 0x630f, 0x630c, 0x62f8, 0x62f6, 0x6300, 0x6313, 0x6314,
/* 08 */ 0x62fa, 0x6315, 0x62fb, 0x62f0, 0x6541, 0x6543, 0x65aa, 0x65bf,
/* 10 */ 0x6636, 0x6621, 0x6632, 0x6635, 0x661c, 0x6626, 0x6622, 0x6633,
/* 18 */ 0x662b, 0x663a, 0x661d, 0x6634, 0x6639, 0x662e, 0x670f, 0x6710,
/* 20 */ 0x67c1, 0x67f2, 0x67c8, 0x67ba, 0x6d01, 0x6d18, 0x6d37, 0x6d03,
/* 28 */ 0x6d0f, 0x6d40, 0x6d07, 0x6d20, 0x6d2c, 0x6d08, 0x6d22, 0x6d09,
/* 30 */ 0x6d10, 0x70b7, 0x709f, 0x70be, 0x70b1, 0x70b0, 0x70a1, 0x70b4,
/* 38 */ 0x70b5, 0x70a9, 0x7241, 0x7249, 0x724a, 0x726c, 0x7270, 0x7273
},

/* Row 0x09f */
{
/* 00 */ 0x726e, 0x72ca, 0x72e4, 0x72e8, 0x72eb, 0x72df, 0x72ea, 0x72e6,
/* 08 */ 0x72e3, 0x7385, 0x73cc, 0x73c2, 0x73c8, 0x73c5, 0x73b9, 0x73b6,
/* 10 */ 0x73b5, 0x73b4, 0x73eb, 0x73bf, 0x73c7, 0x73be, 0x73c3, 0x73c6,
/* 18 */ 0x73b8, 0x73cb, 0x74ec, 0x74ee, 0x752e, 0x7547, 0x7548, 0x75a7,
/* 20 */ 0x75aa, 0x7679, 0x76c4, 0x7708, 0x7703, 0x7704, 0x7705, 0x770a,
/* 28 */ 0x76f7, 0x76fb, 0x76fa, 0x77e7, 0x77e8, 0x7806, 0x7811, 0x7812,
/* 30 */ 0x7805, 0x7810, 0x780f, 0x780e, 0x7809, 0x7803, 0x7813, 0x794a,
/* 38 */ 0x794c, 0x794b, 0x7945, 0x7944, 0x79d5, 0x79cd, 0x79cf, 0x79d6
},

/* Row 0x0a0 */
{
/* 00 */ 0x79ce, 0x7a80, 0x82e4, 0x82e0, 0x82fa, 0x82f3, 0x82ed, 0x8677,
/* 08 */ 0x8674, 0x867c, 0x8673, 0x8841, 0x884e, 0x8867, 0x886a, 0x8869,
/* 10 */ 0x89d3, 0x8a04, 0x8a07, 0x8d72, 0x8fe3, 0x8fe1, 0x8fee, 0x8fe0,
/* 18 */ 0x90f1, 0x90bd, 0x90bf, 0x90d5, 0x90c5, 0x90be, 0x90c7, 0x90cb,
/* 20 */ 0x90c8, 0x91d4, 0x91d3, 0x9654, 0x964f, 0x9651, 0x9653, 0x964a,
/* 28 */ 0x964e, 0x501e, 0x5005, 0x5007, 0x5013, 0x5022, 0x5030, 0x501b,
/* 30 */ 0x4ff5, 0x4ff4, 0x5033, 0x5037, 0x502c, 0x4ff6, 0x4ff7, 0x5017,
/* 38 */ 0x501c, 0x5020, 0x5027, 0x5035, 0x502f, 0x5031, 0x500e, 0x515a
},

/* Row 0x0a1 */
{
/* 00 */ 0x5194, 0x5193, 0x51ca, 0x51c4, 0x51c5, 0x51c8, 0x51ce, 0x5261,
/* 08 */ 0x525a, 0x5252, 0x525e, 0x525f, 0x5255, 0x5262, 0x52cd, 0x530e,
/* 10 */ 0x539e, 0x5526, 0x54e2, 0x5517, 0x5512, 0x54e7, 0x54f3, 0x54e4,
/* 18 */ 0x551a, 0x54ff, 0x5504, 0x5508, 0x54eb, 0x5511, 0x5505, 0x54f1,
/* 20 */ 0x6041, 0x60a2, 0x6088, 0x6080, 0x6092, 0x6081, 0x609d, 0x6083,
/* 28 */ 0x6095, 0x609b, 0x6097, 0x6087, 0x609c, 0x608e, 0x6219, 0x6246,
/* 30 */ 0x62f2, 0x6310, 0x6356, 0x632c, 0x6344, 0x6345, 0x6336, 0x6343,
/* 38 */ 0x63e4, 0x6339, 0x634b, 0x634a, 0x633c, 0x6329, 0x6341, 0x6334
},

/* Row 0x0a2 */
{
/* 00 */ 0x6358, 0x6354, 0x6359, 0x632d, 0x6347, 0x6333, 0x635a, 0x6351,
/* 08 */ 0x6338, 0x6357, 0x6340, 0x6348, 0x654a, 0x6546, 0x65c6, 0x65c3,
/* 10 */ 0x65c4, 0x65c2, 0x664a, 0x665f, 0x6647, 0x6651, 0x6712, 0x6713,
/* 18 */ 0x681f, 0x681a, 0x6849, 0x6832, 0x6833, 0x683b, 0x684b, 0x684f,
/* 20 */ 0x6816, 0x6831, 0x681c, 0x6835, 0x682b, 0x682d, 0x682f, 0x684e,
/* 28 */ 0x6844, 0x6834, 0x681d, 0x6812, 0x6814, 0x6826, 0x6828, 0x682e,
/* 30 */ 0x684d, 0x683a, 0x6825, 0x6820, 0x6b2c, 0x6b2f, 0x6b2d, 0x6b31,
/* 38 */ 0x6b34, 0x6b6d, 0x8082, 0x6b88, 0x6be6, 0x6be4, 0x7277, 0x7276
},

/* Row 0x0a3 */
{
/* 00 */ 0x7300, 0x72fa, 0x72f4, 0x72fe, 0x72f6, 0x72f3, 0x72fb, 0x7301,
/* 08 */ 0x73d3, 0x73d9, 0x73e5, 0x73d6, 0x73bc, 0x73e7, 0x73e3, 0x73e9,
/* 10 */ 0x73dc, 0x73d2, 0x73db, 0x73d4, 0x73dd, 0x73da, 0x73d7, 0x73d8,
/* 18 */ 0x73e8, 0x74de, 0x74df, 0x74f4, 0x74f5, 0x7521, 0x755b, 0x755f,
/* 20 */ 0x75b0, 0x75c1, 0x75bb, 0x75c4, 0x75c0, 0x75bf, 0x75b6, 0x75ba,
/* 28 */ 0x768a, 0x76c9, 0x771d, 0x771b, 0x7710, 0x7713, 0x7712, 0x7723,
/* 30 */ 0x7711, 0x7715, 0x7719, 0x771a, 0x7722, 0x7727, 0x7823, 0x782c,
/* 38 */ 0x7822, 0x7835, 0x782f, 0x7828, 0x782e, 0x782b, 0x7821, 0x7829
},

/* Row 0x0a4 */
{
/* 00 */ 0x7833, 0x782a, 0x7831, 0x7954, 0x795b, 0x794f, 0x795c, 0x7953,
/* 08 */ 0x7952, 0x7951, 0x79eb, 0x79ec, 0x79e0, 0x79ee, 0x79ed, 0x79ea,
/* 10 */ 0x79dc, 0x79de, 0x79dd, 0x7a86, 0x7a89, 0x7a85, 0x7a8b, 0x7a8c,
/* 18 */ 0x7a8a, 0x7a87, 0x7ad8, 0x7b10, 0x8342, 0x834e, 0x831b, 0x832a,
/* 20 */ 0x8308, 0x833c, 0x834d, 0x8316, 0x8324, 0x8320, 0x8337, 0x832f,
/* 28 */ 0x8329, 0x8347, 0x8345, 0x834c, 0x8353, 0x831e, 0x832c, 0x834b,
/* 30 */ 0x8327, 0x8348, 0x8653, 0x8652, 0x86a2, 0x86a8, 0x8696, 0x868d,
/* 38 */ 0x8691, 0x869e, 0x8687, 0x8697, 0x8686, 0x868b, 0x869a, 0x8685
},

/* Row 0x0a5 */
{
/* 00 */ 0x86a5, 0x8699, 0x86a1, 0x86a7, 0x8695, 0x8698, 0x868e, 0x869d,
/* 08 */ 0x8690, 0x8694, 0x8843, 0x8844, 0x886d, 0x8875, 0x8876, 0x8872,
/* 10 */ 0x8880, 0x8871, 0x887f, 0x886f, 0x8883, 0x887e, 0x8874, 0x887c,
/* 18 */ 0x8a12, 0x8c47, 0x8c57, 0x8c7b, 0x8ca4, 0x8ca3, 0x8d76, 0x8d78,
/* 20 */ 0x8db5, 0x8db7, 0x8db6, 0x8ed1, 0x8ed3, 0x8ffe, 0x8ff5, 0x9002,
/* 28 */ 0x8fff, 0x8ffb, 0x9004, 0x8ffc, 0x8ff6, 0x90d6, 0x90e0, 0x90d9,
/* 30 */ 0x90da, 0x90e3, 0x90df, 0x90e5, 0x90d8, 0x90db, 0x90d7, 0x90dc,
/* 38 */ 0x90e4, 0x9150, 0x550c, 0x5532, 0x5565, 0x554e, 0x5539, 0x5548
},

/* Row 0x0a6 */
{
/* 00 */ 0x552d, 0x553b, 0x5540, 0x554b, 0x570a, 0x5707, 0x57fb, 0x5814,
/* 08 */ 0x57e2, 0x57f6, 0x57dc, 0x57f4, 0x5800, 0x57ed, 0x57fd, 0x5808,
/* 10 */ 0x57f8, 0x580b, 0x57f3, 0x57cf, 0x5807, 0x57ee, 0x57e3, 0x57f2,
/* 18 */ 0x57e5, 0x57ec, 0x57e1, 0x580e, 0x57fc, 0x5810, 0x57e7, 0x5801,
/* 20 */ 0x580c, 0x57f1, 0x57e9, 0x57f0, 0x580d, 0x5804, 0x595c, 0x5a60,
/* 28 */ 0x5a58, 0x5a55, 0x5a67, 0x5a5e, 0x5a38, 0x5a35, 0x5a6d, 0x5a50,
/* 30 */ 0x5a5f, 0x5a65, 0x5a6c, 0x5a53, 0x5a64, 0x5a57, 0x5a43, 0x5a5d,
/* 38 */ 0x5a52, 0x5a44, 0x5a5b, 0x5a48, 0x5a8e, 0x5a3e, 0x5a4d, 0x5a39
},

/* Row 0x0a7 */
{
/* 00 */ 0x5a4c, 0x5a70, 0x5a69, 0x5a47, 0x5a51, 0x5a56, 0x5a42, 0x5a5c,
/* 08 */ 0x5b72, 0x5b6e, 0x5bc1, 0x5bc0, 0x5c59, 0x5d1e, 0x5d0b, 0x5d1d,
/* 10 */ 0x5d1a, 0x5d20, 0x5d0c, 0x5d28, 0x5d0d, 0x5d26, 0x5d25, 0x5d0f,
/* 18 */ 0x6378, 0x6385, 0x6381, 0x6391, 0x638d, 0x6370, 0x6553, 0x65cd,
/* 20 */ 0x6665, 0x6661, 0x665b, 0x6659, 0x665c, 0x6662, 0x6718, 0x6879,
/* 28 */ 0x6887, 0x6890, 0x689c, 0x686d, 0x686e, 0x68ae, 0x68ab, 0x6956,
/* 30 */ 0x686f, 0x68a3, 0x68ac, 0x68a9, 0x6875, 0x6874, 0x68b2, 0x688f,
/* 38 */ 0x6877, 0x6892, 0x687c, 0x686b, 0x6872, 0x68aa, 0x6880, 0x6871
},

/* Row 0x0a8 */
{
/* 00 */ 0x687e, 0x689b, 0x6896, 0x688b, 0x68a0, 0x6889, 0x68a4, 0x6878,
/* 08 */ 0x687b, 0x6891, 0x688c, 0x688a, 0x687d, 0x6b36, 0x6b33, 0x6b37,
/* 10 */ 0x6b38, 0x6b91, 0x6b8f, 0x6b8d, 0x6b8e, 0x6b8c, 0x6c2a, 0x6dc0,
/* 18 */ 0x6dab, 0x6db4, 0x6db3, 0x6e74, 0x6dac, 0x6de9, 0x6de2, 0x6db7,
/* 20 */ 0x6df6, 0x6dd4, 0x6e00, 0x6dc8, 0x6de0, 0x6ddf, 0x6dd6, 0x6dbe,
/* 28 */ 0x6de5, 0x6ddc, 0x6ddd, 0x6ddb, 0x6df4, 0x6dca, 0x6dbd, 0x6ded,
/* 30 */ 0x6df0, 0x6dba, 0x6dd5, 0x6dc2, 0x6dcf, 0x6dc9, 0x75cb, 0x75cc,
/* 38 */ 0x75d1, 0x75d0, 0x768f, 0x7689, 0x76d3, 0x7739, 0x772f, 0x772d
},

/* Row 0x0a9 */
{
/* 00 */ 0x7731, 0x7732, 0x7734, 0x7733, 0x773d, 0x7725, 0x773b, 0x7735,
/* 08 */ 0x7848, 0x7852, 0x7849, 0x784d, 0x784a, 0x784c, 0x7826, 0x7845,
/* 10 */ 0x7850, 0x7964, 0x7967, 0x7969, 0x796a, 0x7963, 0x796b, 0x7961,
/* 18 */ 0x79bb, 0x79fa, 0x79f8, 0x79f6, 0x79f7, 0x7a8f, 0x7a94, 0x7a90,
/* 20 */ 0x7b35, 0x7b47, 0x7b34, 0x7b25, 0x7b30, 0x7b22, 0x7b24, 0x7b33,
/* 28 */ 0x7b18, 0x7b2a, 0x7b1d, 0x7b31, 0x7b2b, 0x7b2d, 0x7b2f, 0x7b32,
/* 30 */ 0x7b38, 0x7b1a, 0x7b23, 0x7c94, 0x7c98, 0x7c96, 0x7ca3, 0x7d35,
/* 38 */ 0x7d3d, 0x7d38, 0x7d36, 0x7d3a, 0x7d45, 0x7d2c, 0x7d29, 0x7d41
},

/* Row 0x0aa */
{
/* 00 */ 0x7d47, 0x7d3e, 0x7d3f, 0x7d4a, 0x7d3b, 0x7d28, 0x7f63, 0x7f95,
/* 08 */ 0x7f9c, 0x7f9d, 0x7f9b, 0x7fca, 0x7fcb, 0x7fcd, 0x7fd0, 0x7fd1,
/* 10 */ 0x7fc7, 0x7fcf, 0x7fc9, 0x801f, 0x86c2, 0x86c1, 0x86c5, 0x86ba,
/* 18 */ 0x86b0, 0x86c8, 0x86b9, 0x86b3, 0x86b8, 0x86cc, 0x86b4, 0x86bb,
/* 20 */ 0x86bc, 0x86c3, 0x86bd, 0x86be, 0x8852, 0x8889, 0x8895, 0x88a8,
/* 28 */ 0x88a2, 0x88aa, 0x889a, 0x8891, 0x88a1, 0x889f, 0x8898, 0x88a7,
/* 30 */ 0x8899, 0x889b, 0x8897, 0x88a4, 0x88ac, 0x888c, 0x8893, 0x888e,
/* 38 */ 0x8982, 0x89d6, 0x89d9, 0x89d5, 0x8a30, 0x8a27, 0x8a2c, 0x8a1e
},

/* Row 0x0ab */
{
/* 00 */ 0x8c39, 0x8c3b, 0x8c5c, 0x8c5d, 0x8c7d, 0x8ca5, 0x8d7d, 0x8d7b,
/* 08 */ 0x8d79, 0x8dbc, 0x8dc2, 0x8db9, 0x8dbf, 0x8dc1, 0x8ed8, 0x8ede,
/* 10 */ 0x8edd, 0x8edc, 0x8ed7, 0x8ee0, 0x8ee1, 0x9024, 0x900b, 0x9011,
/* 18 */ 0x901c, 0x900c, 0x9021, 0x90ef, 0x90ea, 0x90f0, 0x90f4, 0x90f2,
/* 20 */ 0x90f3, 0x90d4, 0x90eb, 0x90ec, 0x90e9, 0x9156, 0x9158, 0x915a,
/* 28 */ 0x9153, 0x9155, 0x91ec, 0x91f4, 0x91f1, 0x91f3, 0x91f8, 0x91e4,
/* 30 */ 0x91f9, 0x91ea, 0x5819, 0x581e, 0x5827, 0x5823, 0x5828, 0x57f5,
/* 38 */ 0x5848, 0x5825, 0x581c, 0x581b, 0x5833, 0x583f, 0x5836, 0x582e
},

/* Row 0x0ac */
{
/* 00 */ 0x5839, 0x5838, 0x582d, 0x582c, 0x583b, 0x5961, 0x5aaf, 0x5a94,
/* 08 */ 0x5a9f, 0x5a7a, 0x5aa2, 0x5a9e, 0x5a78, 0x5aa6, 0x5a7c, 0x5aa5,
/* 10 */ 0x5aac, 0x5a95, 0x5aae, 0x5a37, 0x5a84, 0x5a8a, 0x5a97, 0x5a83,
/* 18 */ 0x5a8b, 0x5aa9, 0x5a7b, 0x5a7d, 0x5a8c, 0x5a9c, 0x5a8f, 0x5a93,
/* 20 */ 0x5a9d, 0x5bea, 0x5bcd, 0x5bcb, 0x5bd4, 0x5bd1, 0x5bca, 0x5bce,
/* 28 */ 0x5c0c, 0x5c30, 0x5d37, 0x5d43, 0x5d6b, 0x5d41, 0x5d4b, 0x5d3f,
/* 30 */ 0x5d35, 0x5d51, 0x5d4e, 0x5d55, 0x5d33, 0x5d3a, 0x5d52, 0x5d3d,
/* 38 */ 0x5d31, 0x5d59, 0x5d42, 0x5d39, 0x5d49, 0x5d38, 0x5d3c, 0x5d32
},

/* Row 0x0ad */
{
/* 00 */ 0x5d36, 0x5d40, 0x5d45, 0x5e44, 0x5e41, 0x5f58, 0x5fa6, 0x5fa5,
/* 08 */ 0x5fab, 0x60c9, 0x60b9, 0x60cc, 0x60e2, 0x60ce, 0x60c4, 0x6114,
/* 10 */ 0x667c, 0x666c, 0x667b, 0x6680, 0x6671, 0x6679, 0x666a, 0x6672,
/* 18 */ 0x6701, 0x690c, 0x68d3, 0x6904, 0x68dc, 0x692a, 0x68ec, 0x68ea,
/* 20 */ 0x68f1, 0x690f, 0x68d6, 0x68f7, 0x68eb, 0x68e4, 0x68f6, 0x6913,
/* 28 */ 0x6910, 0x68f3, 0x68e1, 0x6907, 0x68cc, 0x6908, 0x6970, 0x68b4,
/* 30 */ 0x6911, 0x68ef, 0x68c6, 0x6914, 0x68f8, 0x68d0, 0x68fd, 0x68fc,
/* 38 */ 0x68e8, 0x690b, 0x690a, 0x6917, 0x68ce, 0x68c8, 0x68dd, 0x68de
},

/* Row 0x0ae */
{
/* 00 */ 0x68e6, 0x68f4, 0x68d1, 0x6906, 0x68d4, 0x68e9, 0x6915, 0x6925,
/* 08 */ 0x68c7, 0x6b39, 0x6b3b, 0x6b3f, 0x6b3c, 0x6b94, 0x6b97, 0x6b99,
/* 10 */ 0x6b95, 0x6bbd, 0x6bf0, 0x6bf2, 0x6bf3, 0x6c30, 0x6dfc, 0x6e46,
/* 18 */ 0x6e47, 0x6e1f, 0x6e49, 0x6e88, 0x6e3c, 0x6e3d, 0x6e45, 0x6e62,
/* 20 */ 0x6e2b, 0x6e3f, 0x6e41, 0x6e5d, 0x6e73, 0x6e1c, 0x6e33, 0x6e4b,
/* 28 */ 0x6e40, 0x6e51, 0x6e3b, 0x6e03, 0x6e2e, 0x6e5e, 0x741a, 0x7421,
/* 30 */ 0x742d, 0x7431, 0x7424, 0x7423, 0x741d, 0x7429, 0x7420, 0x7432,
/* 38 */ 0x74fb, 0x752f, 0x756f, 0x756c, 0x75e7, 0x75da, 0x75e1, 0x75e6
},

/* Row 0x0af */
{
/* 00 */ 0x75dd, 0x75df, 0x75e4, 0x75d7, 0x7695, 0x7692, 0x76da, 0x7746,
/* 08 */ 0x7747, 0x7744, 0x774d, 0x7745, 0x774a, 0x774e, 0x774b, 0x774c,
/* 10 */ 0x77de, 0x77ec, 0x7860, 0x7864, 0x7865, 0x785c, 0x786d, 0x7871,
/* 18 */ 0x786a, 0x786e, 0x7870, 0x7869, 0x7868, 0x785e, 0x7862, 0x7974,
/* 20 */ 0x7973, 0x7972, 0x7970, 0x7a02, 0x7a0a, 0x7a03, 0x7a0c, 0x7a04,
/* 28 */ 0x7a99, 0x7ae6, 0x7ae4, 0x7b4a, 0x7b3b, 0x7b44, 0x7b48, 0x7b4c,
/* 30 */ 0x7b4e, 0x7b40, 0x7b58, 0x7b45, 0x7ca2, 0x7c9e, 0x7ca8, 0x7ca1,
/* 38 */ 0x7d58, 0x7d6f, 0x7d63, 0x7d53, 0x7d56, 0x7d67, 0x7d6a, 0x7d4f
},

/* Row 0x0b0 */
{
/* 00 */ 0x7d6d, 0x7d5c, 0x7d6b, 0x7d52, 0x7d54, 0x7d69, 0x7d51, 0x7d5f,
/* 08 */ 0x7d4e, 0x7f3e, 0x7f3f, 0x7f65, 0x83d5, 0x83fa, 0x83c7, 0x83d1,
/* 10 */ 0x83ea, 0x8413, 0x83c3, 0x83ec, 0x83ee, 0x83c4, 0x83fb, 0x83d7,
/* 18 */ 0x83e2, 0x841b, 0x83db, 0x83fe, 0x86d8, 0x86e2, 0x86e6, 0x86d3,
/* 20 */ 0x86e3, 0x86da, 0x86ea, 0x86dd, 0x86eb, 0x86dc, 0x86ec, 0x86e9,
/* 28 */ 0x86d7, 0x86e8, 0x86d1, 0x8848, 0x8856, 0x8855, 0x88ba, 0x88d7,
/* 30 */ 0x88b9, 0x88b8, 0x88c0, 0x88be, 0x88b6, 0x88bc, 0x88b7, 0x88bd,
/* 38 */ 0x88b2, 0x8901, 0x88c9, 0x8995, 0x8998, 0x8997, 0x89dd, 0x89da
},

/* Row 0x0b1 */
{
/* 00 */ 0x89db, 0x8a4e, 0x8a4d, 0x8a39, 0x8a59, 0x8a40, 0x8a57, 0x8a58,
/* 08 */ 0x8a44, 0x8a45, 0x8a52, 0x8a48, 0x8a51, 0x8a4a, 0x8a4c, 0x8a4f,
/* 10 */ 0x8c5f, 0x8c81, 0x8c80, 0x8cba, 0x8cbe, 0x8cb0, 0x8cb9, 0x8cb5,
/* 18 */ 0x8d84, 0x8d80, 0x8d89, 0x8dd8, 0x8dd3, 0x8dcd, 0x8dc7, 0x8dd6,
/* 20 */ 0x8ddc, 0x8dcf, 0x8dd5, 0x8dd9, 0x8dc8, 0x8dd7, 0x8dc5, 0x8eef,
/* 28 */ 0x8ef7, 0x8efa, 0x9689, 0x9683, 0x9680, 0x96c2, 0x96c8, 0x96c3,
/* 30 */ 0x96f1, 0x96f0, 0x976c, 0x9770, 0x976e, 0x9807, 0x98a9, 0x98eb,
/* 38 */ 0x9ce6, 0x9ef9, 0x4e83, 0x4e84, 0x4eb6, 0x50bd, 0x50bf, 0x50c6
},

/* Row 0x0b2 */
{
/* 00 */ 0x50ae, 0x50c4, 0x50ca, 0x50b4, 0x50c8, 0x50c2, 0x50b0, 0x50c1,
/* 08 */ 0x50ba, 0x50b1, 0x50cb, 0x50c9, 0x50b6, 0x50b8, 0x51d7, 0x527a,
/* 10 */ 0x5278, 0x527b, 0x527c, 0x55c3, 0x55db, 0x55cc, 0x55d0, 0x55cb,
/* 18 */ 0x55ca, 0x55dd, 0x55c0, 0x55d4, 0x55c4, 0x55e9, 0x55bf, 0x55d2,
/* 20 */ 0x558d, 0x55cf, 0x55d5, 0x55e2, 0x55d6, 0x55c8, 0x55f2, 0x55cd,
/* 28 */ 0x55d9, 0x55c2, 0x5714, 0x5853, 0x5868, 0x5864, 0x584f, 0x584d,
/* 30 */ 0x5849, 0x586f, 0x5855, 0x584e, 0x585d, 0x5859, 0x5865, 0x585b,
/* 38 */ 0x583d, 0x5863, 0x5871, 0x58fc, 0x5ac7, 0x5ac4, 0x5acb, 0x5aba
},

/* Row 0x0b3 */
{
/* 00 */ 0x5ab8, 0x5ab1, 0x5ab5, 0x5ab0, 0x5abf, 0x5ac8, 0x5abb, 0x5ac6,
/* 08 */ 0x6433, 0x6443, 0x641f, 0x6415, 0x6418, 0x6439, 0x6437, 0x6422,
/* 10 */ 0x6423, 0x640c, 0x6426, 0x6430, 0x6428, 0x6441, 0x6435, 0x642f,
/* 18 */ 0x640a, 0x641a, 0x6440, 0x6425, 0x6427, 0x640b, 0x63e7, 0x641b,
/* 20 */ 0x642e, 0x6421, 0x640e, 0x656f, 0x6592, 0x65d3, 0x6686, 0x668c,
/* 28 */ 0x6695, 0x6690, 0x668b, 0x668a, 0x6699, 0x6694, 0x6678, 0x6720,
/* 30 */ 0x6966, 0x695f, 0x6938, 0x694e, 0x6962, 0x6971, 0x693f, 0x6945,
/* 38 */ 0x696a, 0x6939, 0x6942, 0x6957, 0x6959, 0x697a, 0x6948, 0x6949
},

/* Row 0x0b4 */
{
/* 00 */ 0x6935, 0x696c, 0x6933, 0x693d, 0x6965, 0x68f0, 0x6978, 0x6934,
/* 08 */ 0x6969, 0x6940, 0x696f, 0x6944, 0x6976, 0x6958, 0x6941, 0x6974,
/* 10 */ 0x694c, 0x693b, 0x694b, 0x6937, 0x695c, 0x694f, 0x6951, 0x6932,
/* 18 */ 0x6952, 0x692f, 0x697b, 0x693c, 0x6b46, 0x6b45, 0x6b43, 0x6b42,
/* 20 */ 0x6b48, 0x6b41, 0x6b9b, 0xfa0d, 0x6bfb, 0x6bfc, 0x7144, 0x714d,
/* 28 */ 0x715a, 0x724f, 0x728d, 0x728c, 0x7291, 0x7290, 0x728e, 0x733c,
/* 30 */ 0x7342, 0x733b, 0x733a, 0x7340, 0x734a, 0x7349, 0x7444, 0x744a,
/* 38 */ 0x744b, 0x7452, 0x7451, 0x7457, 0x7440, 0x744f, 0x7450, 0x744e
},

/* Row 0x0b5 */
{
/* 00 */ 0x7442, 0x7446, 0x744d, 0x7454, 0x74e1, 0x74ff, 0x74fe, 0x74fd,
/* 08 */ 0x751d, 0x7579, 0x7577, 0x6983, 0x75ef, 0x760f, 0x7603, 0x75f7,
/* 10 */ 0x75fe, 0x75fc, 0x75f9, 0x75f8, 0x7610, 0x75fb, 0x75f6, 0x75ed,
/* 18 */ 0x75f5, 0x75fd, 0x7699, 0x76b5, 0x76dd, 0x7755, 0x775f, 0x7760,
/* 20 */ 0x7752, 0x7756, 0x775a, 0x7769, 0x7767, 0x7754, 0x7759, 0x776d,
/* 28 */ 0x77e0, 0x7887, 0x789a, 0x7894, 0x788f, 0x7884, 0x7895, 0x7885,
/* 30 */ 0x7886, 0x78a1, 0x7883, 0x7879, 0x7899, 0x7880, 0x7896, 0x787b,
/* 38 */ 0x797c, 0x7982, 0x797d, 0x7979, 0x7a11, 0x7a18, 0x7a19, 0x7a12
},

/* Row 0x0b6 */
{
/* 00 */ 0x7a17, 0x7a15, 0x7a22, 0x7a13, 0x8144, 0x8161, 0x821d, 0x8249,
/* 08 */ 0x8244, 0x8240, 0x8242, 0x8245, 0x84f1, 0x843f, 0x8456, 0x8476,
/* 10 */ 0x8479, 0x848f, 0x848d, 0x8465, 0x8451, 0x8440, 0x8486, 0x8467,
/* 18 */ 0x8430, 0x844d, 0x847d, 0x845a, 0x8459, 0x8474, 0x8473, 0x845d,
/* 20 */ 0x8507, 0x845e, 0x8437, 0x843a, 0x8434, 0x847a, 0x8443, 0x8478,
/* 28 */ 0x8432, 0x8445, 0x8429, 0x83d9, 0x844b, 0x842f, 0x8442, 0x842d,
/* 30 */ 0x845f, 0x8470, 0x8439, 0x844e, 0x844c, 0x8452, 0x846f, 0x84c5,
/* 38 */ 0x848e, 0x843b, 0x8447, 0x8436, 0x8433, 0x8468, 0x847e, 0x8444
},

/* Row 0x0b7 */
{
/* 00 */ 0x842b, 0x8460, 0x8454, 0x846e, 0x8450, 0x870b, 0x8704, 0x86f7,
/* 08 */ 0x870c, 0x86fa, 0x86d6, 0x86f5, 0x874d, 0x86f8, 0x870e, 0x8709,
/* 10 */ 0x8701, 0x86f6, 0x870d, 0x8705, 0x88d6, 0x88cb, 0x88cd, 0x88ce,
/* 18 */ 0x88de, 0x88db, 0x88da, 0x88cc, 0x88d0, 0x8985, 0x899b, 0x89df,
/* 20 */ 0x89e5, 0x89e4, 0x9044, 0x9049, 0x903d, 0x9110, 0x910d, 0x910f,
/* 28 */ 0x9111, 0x9116, 0x9114, 0x910b, 0x910e, 0x916e, 0x916f, 0x9248,
/* 30 */ 0x9252, 0x9230, 0x923a, 0x9266, 0x9233, 0x9265, 0x925e, 0x9283,
/* 38 */ 0x922e, 0x924a, 0x9246, 0x926d, 0x926c, 0x924f, 0x9260, 0x9267
},

/* Row 0x0b8 */
{
/* 00 */ 0x926f, 0x9236, 0x9261, 0x9270, 0x9231, 0x9254, 0x9263, 0x9250,
/* 08 */ 0x9272, 0x924e, 0x9253, 0x924c, 0x9256, 0x9232, 0x959f, 0x959c,
/* 10 */ 0x959e, 0x959b, 0x9692, 0x9693, 0x9691, 0x9697, 0x96ce, 0x96fa,
/* 18 */ 0x96fd, 0x96f8, 0x96f5, 0x9773, 0x9777, 0x9778, 0x9772, 0x980f,
/* 20 */ 0x980d, 0x980e, 0x98ac, 0x98f6, 0x98f9, 0x99af, 0x99b2, 0x99b0,
/* 28 */ 0x99b5, 0x9aad, 0x9aab, 0x9b5b, 0x9cea, 0x9ced, 0x9ce7, 0x9e80,
/* 30 */ 0x9efd, 0x50e6, 0x50d4, 0x50d7, 0x50e8, 0x50f3, 0x50db, 0x50ea,
/* 38 */ 0x50dd, 0x50e4, 0x50d3, 0x50ec, 0x50f0, 0x50ef, 0x50e3, 0x50e0
},

/* Row 0x0b9 */
{
/* 00 */ 0x5be3, 0x5c63, 0x5d82, 0x5d80, 0x5d7d, 0x5d86, 0x5d7a, 0x5d81,
/* 08 */ 0x5d77, 0x5d8a, 0x5d89, 0x5d88, 0x5d7e, 0x5d7c, 0x5d8d, 0x5d79,
/* 10 */ 0x5d7f, 0x5e58, 0x5e59, 0x5e53, 0x5ed8, 0x5ed1, 0x5ed7, 0x5ece,
/* 18 */ 0x5edc, 0x5ed5, 0x5ed9, 0x5ed2, 0x5ed4, 0x5f44, 0x5f43, 0x5f6f,
/* 20 */ 0x5fb6, 0x612c, 0x6128, 0x6141, 0x615e, 0x6171, 0x6173, 0x6152,
/* 28 */ 0x6153, 0x6172, 0x616c, 0x6180, 0x6174, 0x6154, 0x617a, 0x615b,
/* 30 */ 0x6165, 0x613b, 0x616a, 0x6161, 0x6156, 0x6229, 0x6227, 0x622b,
/* 38 */ 0x642b, 0x644d, 0x645b, 0x645d, 0x6474, 0x6476, 0x6472, 0x6473
},

/* Row 0x0ba */
{
/* 00 */ 0x647d, 0x6475, 0x6466, 0x64a6, 0x644e, 0x6482, 0x645e, 0x645c,
/* 08 */ 0x644b, 0x6453, 0x6460, 0x6450, 0x647f, 0x643f, 0x646c, 0x646b,
/* 10 */ 0x6459, 0x6465, 0x6477, 0x6573, 0x65a0, 0x66a1, 0x66a0, 0x669f,
/* 18 */ 0x6705, 0x6704, 0x6722, 0x69b1, 0x69b6, 0x69c9, 0x6f36, 0x6f73,
/* 20 */ 0x6ef9, 0x6eee, 0x6f2d, 0x6f40, 0x6f30, 0x6f3c, 0x6f35, 0x6eeb,
/* 28 */ 0x6f07, 0x6f0e, 0x6f43, 0x6f05, 0x6efd, 0x6ef6, 0x6f39, 0x6f1c,
/* 30 */ 0x6efc, 0x6f3a, 0x6f1f, 0x6f0d, 0x6f1e, 0x6f08, 0x6f21, 0x7187,
/* 38 */ 0x7190, 0x7189, 0x7180, 0x7185, 0x7182, 0x718f, 0x717b, 0x7186
},

/* Row 0x0bb */
{
/* 00 */ 0x7181, 0x7197, 0x7244, 0x7253, 0x7297, 0x7295, 0x7293, 0x7343,
/* 08 */ 0x734d, 0x7351, 0x734c, 0x7462, 0x7473, 0x7471, 0x7475, 0x7472,
/* 10 */ 0x7467, 0x746e, 0x7500, 0x7502, 0x7503, 0x757d, 0x7590, 0x7616,
/* 18 */ 0x7608, 0x760c, 0x7615, 0x7611, 0x760a, 0x7614, 0x76b8, 0x7781,
/* 20 */ 0x777c, 0x7785, 0x7782, 0x776e, 0x7780, 0x776f, 0x777e, 0x7783,
/* 28 */ 0x78b2, 0x78aa, 0x78b4, 0x78ad, 0x78a8, 0x787e, 0x78ab, 0x789e,
/* 30 */ 0x78a5, 0x78a0, 0x78ac, 0x78a2, 0x78a4, 0x7998, 0x798a, 0x798b,
/* 38 */ 0x7996, 0x7995, 0x7994, 0x7993, 0x8024, 0x805d, 0x805c, 0x8189
},

/* Row 0x0bc */
{
/* 00 */ 0x8186, 0x8183, 0x8187, 0x818d, 0x818c, 0x818b, 0x8215, 0x8497,
/* 08 */ 0x84a4, 0x84a1, 0x849f, 0x84ba, 0x84ce, 0x84c2, 0x84ac, 0x84ae,
/* 10 */ 0x84ab, 0x84b9, 0x84b4, 0x84c1, 0x84cd, 0x84aa, 0x849a, 0x84b1,
/* 18 */ 0x84d0, 0x849d, 0x84a7, 0x84bb, 0x84a2, 0x8494, 0x84c7, 0x84cc,
/* 20 */ 0x849b, 0x84a9, 0x84af, 0x84a8, 0x84d6, 0x8498, 0x84b6, 0x84cf,
/* 28 */ 0x84a0, 0x84d7, 0x84d4, 0x84d2, 0x84db, 0x84b0, 0x8491, 0x8661,
/* 30 */ 0x8733, 0x8723, 0x8728, 0x876b, 0x8740, 0x872e, 0x871e, 0x8721,
/* 38 */ 0x8719, 0x871b, 0x8743, 0x872c, 0x8741, 0x873e, 0x8746, 0x8720
},

/* Row 0x0bd */
{
/* 00 */ 0x8732, 0x872a, 0x872d, 0x873c, 0x8712, 0x873a, 0x8731, 0x8735,
/* 08 */ 0x8742, 0x8726, 0x8727, 0x8738, 0x8724, 0x871a, 0x8730, 0x8711,
/* 10 */ 0x88f7, 0x88e7, 0x88f1, 0x88f2, 0x88fa, 0x88fe, 0x88ee, 0x88fc,
/* 18 */ 0x88f6, 0x88fb, 0x92a6, 0x929a, 0x92ab, 0x9279, 0x9297, 0x927f,
/* 20 */ 0x92a3, 0x92ee, 0x928e, 0x9282, 0x9295, 0x92a2, 0x927d, 0x9288,
/* 28 */ 0x92a1, 0x928a, 0x9286, 0x928c, 0x9299, 0x92a7, 0x927e, 0x9287,
/* 30 */ 0x92a9, 0x929d, 0x928b, 0x922d, 0x969e, 0x96a1, 0x96ff, 0x9758,
/* 38 */ 0x977d, 0x977a, 0x977e, 0x9783, 0x9780, 0x9782, 0x977b, 0x9784
},

/* Row 0x0be */
{
/* 00 */ 0x9781, 0x977f, 0x97ce, 0x97cd, 0x9816, 0x98ad, 0x98ae, 0x9902,
/* 08 */ 0x9900, 0x9907, 0x999d, 0x999c, 0x99c3, 0x99b9, 0x99bb, 0x99ba,
/* 10 */ 0x99c2, 0x99bd, 0x99c7, 0x9ab1, 0x9ae3, 0x9ae7, 0x9b3e, 0x9b3f,
/* 18 */ 0x9b60, 0x9b61, 0x9b5f, 0x9cf1, 0x9cf2, 0x9cf5, 0x9ea7, 0x50ff,
/* 20 */ 0x5103, 0x5130, 0x50f8, 0x5106, 0x5107, 0x50f6, 0x50fe, 0x510b,
/* 28 */ 0x510c, 0x50fd, 0x510a, 0x528b, 0x528c, 0x52f1, 0x52ef, 0x5648,
/* 30 */ 0x5642, 0x564c, 0x5635, 0x5641, 0x564a, 0x5649, 0x5646, 0x5658,
/* 38 */ 0x619b, 0x6193, 0x61af, 0x61ad, 0x619f, 0x6192, 0x61aa, 0x61a1
},

/* Row 0x0bf */
{
/* 00 */ 0x618d, 0x6166, 0x61b3, 0x622d, 0x646e, 0x6470, 0x6496, 0x64a0,
/* 08 */ 0x6485, 0x6497, 0x649c, 0x648f, 0x648b, 0x648a, 0x648c, 0x64a3,
/* 10 */ 0x649f, 0x6468, 0x64b1, 0x6498, 0x6576, 0x657a, 0x6579, 0x657b,
/* 18 */ 0x65b2, 0x65b3, 0x66b5, 0x66b0, 0x66a9, 0x66b2, 0x66b7, 0x66aa,
/* 20 */ 0x66af, 0x6a00, 0x6a06, 0x6a17, 0x69e5, 0x69f8, 0x6a15, 0x69f1,
/* 28 */ 0x69e4, 0x6a20, 0x69ff, 0x69ec, 0x69e2, 0x6a1b, 0x6a1d, 0x69fe,
/* 30 */ 0x6a27, 0x69f2, 0x69ee, 0x6a14, 0x69f7, 0x69e7, 0x6a40, 0x6a08,
/* 38 */ 0x69e6, 0x69fb, 0x6a0d, 0x69fc, 0x69eb, 0x6a09, 0x6a04, 0x6a18
},

/* Row 0x0c0 */
{
/* 00 */ 0x6a25, 0x6a0f, 0x69f6, 0x6a26, 0x6a07, 0x69f4, 0x6a16, 0x6b51,
/* 08 */ 0x6ba5, 0x6ba3, 0x6ba2, 0x6ba6, 0x6c01, 0x6c00, 0x6bff, 0x6c02,
/* 10 */ 0x6f41, 0x6f26, 0x6f7e, 0x6f87, 0x6fc6, 0x6f92, 0x7362, 0x7487,
/* 18 */ 0x7489, 0x748a, 0x7486, 0x7481, 0x747d, 0x7485, 0x7488, 0x747c,
/* 20 */ 0x7479, 0x7508, 0x7507, 0x757e, 0x7625, 0x761e, 0x7619, 0x761d,
/* 28 */ 0x761c, 0x7623, 0x761a, 0x7628, 0x761b, 0x769c, 0x769d, 0x769e,
/* 30 */ 0x769b, 0x778d, 0x778f, 0x7789, 0x7788, 0x78cd, 0x78bb, 0x78cf,
/* 38 */ 0x78cc, 0x78d1, 0x78ce, 0x78d4, 0x78c8, 0x78c3, 0x78c4, 0x78c9
},

/* Row 0x0c1 */
{
/* 00 */ 0x799a, 0x79a1, 0x79a0, 0x799c, 0x79a2, 0x799b, 0x6b76, 0x7a39,
/* 08 */ 0x7ab2, 0x7ab4, 0x7ab3, 0x7bb7, 0x7bcb, 0x7bbe, 0x7bac, 0x7bce,
/* 10 */ 0x7baf, 0x7bb9, 0x7bca, 0x7bb5, 0x7cc5, 0x7cc8, 0x7ccc, 0x7ccb,
/* 18 */ 0x7df7, 0x7ddb, 0x7dea, 0x7de7, 0x7dd7, 0x7de1, 0x7e03, 0x7dfa,
/* 20 */ 0x7de6, 0x7df6, 0x7df1, 0x7df0, 0x7dee, 0x7ddf, 0x7f76, 0x7fac,
/* 28 */ 0x7fb0, 0x7fad, 0x7fed, 0x7feb, 0x7fea, 0x7fec, 0x7fe6, 0x7fe8,
/* 30 */ 0x8064, 0x8067, 0x81a3, 0x819f, 0x8756, 0x8763, 0x8764, 0x8777,
/* 38 */ 0x87e1, 0x8773, 0x8758, 0x8754, 0x875b, 0x8752, 0x8761, 0x875a
},

/* Row 0x0c2 */
{
/* 00 */ 0x8751, 0x875e, 0x876d, 0x876a, 0x8750, 0x874e, 0x875f, 0x875d,
/* 08 */ 0x876f, 0x876c, 0x877a, 0x876e, 0x875c, 0x8765, 0x874f, 0x877b,
/* 10 */ 0x8775, 0x8762, 0x8767, 0x8769, 0x885a, 0x8905, 0x890c, 0x8914,
/* 18 */ 0x890b, 0x8917, 0x8918, 0x8919, 0x8906, 0x8916, 0x8911, 0x890e,
/* 20 */ 0x8909, 0x89a2, 0x89a4, 0x89a3, 0x89ed, 0x89f0, 0x89ec, 0x8acf,
/* 28 */ 0x8ac6, 0x8ab8, 0x8ad3, 0x8ad1, 0x8ad4, 0x8ad5, 0x8abb, 0x8ad7,
/* 30 */ 0x8abe, 0x8ac0, 0x8ac5, 0x8ad8, 0x8ac3, 0x8aba, 0x8abd, 0x8ad9,
/* 38 */ 0x8c3e, 0x8c4d, 0x8c8f, 0x8ce5, 0x8cdf, 0x8cd9, 0x8ce8, 0x8cda
},

/* Row 0x0c3 */
{
/* 00 */ 0x8cdd, 0x8ce7, 0x8da0, 0x8d9c, 0x8da1, 0x8d9b, 0x8e20, 0x8e23,
/* 08 */ 0x8e25, 0x8e24, 0x8e2e, 0x8e15, 0x8e1b, 0x8e16, 0x8e11, 0x8e19,
/* 10 */ 0x8e26, 0x8e27, 0x92b5, 0x92e1, 0x92c6, 0x92b4, 0x957c, 0x95ac,
/* 18 */ 0x95ab, 0x95ae, 0x95b0, 0x96a4, 0x96a2, 0x96d3, 0x9705, 0x9708,
/* 20 */ 0x9702, 0x975a, 0x978a, 0x978e, 0x9788, 0x97d0, 0x97cf, 0x981e,
/* 28 */ 0x981d, 0x9826, 0x9829, 0x9828, 0x9820, 0x981b, 0x9827, 0x98b2,
/* 30 */ 0x9908, 0x98fa, 0x9911, 0x9914, 0x9916, 0x9917, 0x9915, 0x99dc,
/* 38 */ 0x99cd, 0x99cf, 0x99d3, 0x99d4, 0x99ce, 0x99c9, 0x99d6, 0x99d8
},

/* Row 0x0c4 */
{
/* 00 */ 0x99cb, 0x99d7, 0x99cc, 0x9ab3, 0x9aec, 0x9aeb, 0x9af3, 0x9af2,
/* 08 */ 0x9af1, 0x9b46, 0x9b43, 0x9b67, 0x9b74, 0x9b71, 0x9b66, 0x9b76,
/* 10 */ 0x9b75, 0x9b70, 0x9b68, 0x9b64, 0x9b6c, 0x9cfc, 0x9cfa, 0x9cfd,
/* 18 */ 0x9cff, 0x9cf7, 0x9d07, 0x9d00, 0x9cf9, 0x9cfb, 0x9d08, 0x9d05,
/* 20 */ 0x9d04, 0x9e83, 0x9ed3, 0x9f0f, 0x9f10, 0x511c, 0x5113, 0x5117,
/* 28 */ 0x511a, 0x5111, 0x51de, 0x5334, 0x53e1, 0x5670, 0x5660, 0x566e,
/* 30 */ 0x61bf, 0x61b8, 0x618c, 0x64d7, 0x64d6, 0x64d0, 0x64cf, 0x64c9,
/* 38 */ 0x64bd, 0x6489, 0x64c3, 0x64db, 0x64f3, 0x64d9, 0x6533, 0x657f
},

/* Row 0x0c5 */
{
/* 00 */ 0x657c, 0x65a2, 0x66c8, 0x66be, 0x66c0, 0x66ca, 0x66cb, 0x66cf,
/* 08 */ 0x66bd, 0x66bb, 0x66ba, 0x66cc, 0x6723, 0x6a34, 0x6a66, 0x6a49,
/* 10 */ 0x6a67, 0x6a32, 0x6a68, 0x6a3e, 0x6a5d, 0x6a6d, 0x6a76, 0x6a5b,
/* 18 */ 0x6a51, 0x6a28, 0x6a5a, 0x6a3b, 0x6a3f, 0x6a41, 0x6a6a, 0x6a64,
/* 20 */ 0x6a50, 0x6a4f, 0x6a54, 0x6a6f, 0x6a69, 0x6a60, 0x6a3c, 0x6a5e,
/* 28 */ 0x6a56, 0x6a55, 0x6a4d, 0x6a4e, 0x6a46, 0x6b55, 0x6b54, 0x6b56,
/* 30 */ 0x6ba7, 0x6baa, 0x6bab, 0x6bc8, 0x6bc7, 0x6c04, 0x6c03, 0x6c06,
/* 38 */ 0x6fad, 0x6fcb, 0x6fa3, 0x6fc7, 0x6fbc, 0x6fce, 0x6fc8, 0x6f5e
},

/* Row 0x0c6 */
{
/* 00 */ 0x6fc4, 0x6fbd, 0x6f9e, 0x6fca, 0x6fa8, 0x7004, 0x6fa5, 0x6fae,
/* 08 */ 0x6fba, 0x6fac, 0x6faa, 0x6fcf, 0x6fbf, 0x6fb8, 0x7797, 0x78dd,
/* 10 */ 0x78e9, 0x78e5, 0x78ea, 0x78de, 0x78e3, 0x78db, 0x78e1, 0x78e2,
/* 18 */ 0x78ed, 0x78df, 0x78e0, 0x79a4, 0x7a44, 0x7a48, 0x7a47, 0x7ab6,
/* 20 */ 0x7ab8, 0x7ab5, 0x7ab1, 0x7ab7, 0x7bde, 0x7be3, 0x7be7, 0x7bdd,
/* 28 */ 0x7bd5, 0x7be5, 0x7bda, 0x7be8, 0x7bf9, 0x7bd4, 0x7bea, 0x7be2,
/* 30 */ 0x7bdc, 0x7beb, 0x7bd8, 0x7bdf, 0x7cd2, 0x7cd4, 0x7cd7, 0x7cd0,
/* 38 */ 0x7cd1, 0x7e12, 0x7e21, 0x7e17, 0x7e0c, 0x7e1f, 0x7e20, 0x7e13
},

/* Row 0x0c7 */
{
/* 00 */ 0x7e0e, 0x7e1c, 0x7e15, 0x7e1a, 0x7e22, 0x7e0b, 0x7e0f, 0x7e16,
/* 08 */ 0x7e0d, 0x7e14, 0x7e25, 0x7e24, 0x7f43, 0x7f7b, 0x7f7c, 0x7f7a,
/* 10 */ 0x7fb1, 0x7fef, 0x802a, 0x8029, 0x806c, 0x81b1, 0x81a6, 0x81ae,
/* 18 */ 0x81b9, 0x81b5, 0x81ab, 0x81b0, 0x81ac, 0x81b4, 0x81b2, 0x81b7,
/* 20 */ 0x81a7, 0x81f2, 0x8255, 0x8256, 0x8257, 0x8556, 0x8545, 0x856b,
/* 28 */ 0x854d, 0x8553, 0x8561, 0x8558, 0x8ae2, 0x8af2, 0x8af4, 0x8af5,
/* 30 */ 0x8add, 0x8b14, 0x8ae4, 0x8adf, 0x8af0, 0x8ac8, 0x8ade, 0x8ae1,
/* 38 */ 0x8ae8, 0x8aff, 0x8aef, 0x8afb, 0x8c91, 0x8c92, 0x8c90, 0x8cf5
},

/* Row 0x0c8 */
{
/* 00 */ 0x8cee, 0x8cf1, 0x8cf0, 0x8cf3, 0x8d6c, 0x8d6e, 0x8da5, 0x8da7,
/* 08 */ 0x8e33, 0x8e3e, 0x8e38, 0x8e40, 0x8e45, 0x8e36, 0x8e3c, 0x8e3d,
/* 10 */ 0x8e41, 0x8e30, 0x8e3f, 0x8ebd, 0x8f36, 0x8f2e, 0x8f35, 0x8f32,
/* 18 */ 0x8f39, 0x8f37, 0x8f34, 0x9076, 0x9079, 0x907b, 0x9086, 0x90fa,
/* 20 */ 0x9133, 0x9135, 0x9136, 0x9193, 0x9190, 0x9191, 0x918d, 0x918f,
/* 28 */ 0x9327, 0x931e, 0x9308, 0x931f, 0x9306, 0x930f, 0x937a, 0x9338,
/* 30 */ 0x933c, 0x931b, 0x9323, 0x9312, 0x9301, 0x9346, 0x932d, 0x930e,
/* 38 */ 0x930d, 0x92cb, 0x931d, 0x92fa, 0x9325, 0x9313, 0x92f9, 0x92f7
},

/* Row 0x0c9 */
{
/* 00 */ 0x9334, 0x9302, 0x9324, 0x92ff, 0x9329, 0x9339, 0x9335, 0x932a,
/* 08 */ 0x9314, 0x930c, 0x9b7d, 0x9b88, 0x9d25, 0x9d17, 0x9d20, 0x9d1e,
/* 10 */ 0x9d14, 0x9d29, 0x9d1d, 0x9d18, 0x9d22, 0x9d10, 0x9d19, 0x9d1f,
/* 18 */ 0x9e88, 0x9e86, 0x9e87, 0x9eae, 0x9ead, 0x9ed5, 0x9ed6, 0x9efa,
/* 20 */ 0x9f12, 0x9f3d, 0x5126, 0x5125, 0x5122, 0x5124, 0x5120, 0x5129,
/* 28 */ 0x52f4, 0x5693, 0x568c, 0x568d, 0x5686, 0x5684, 0x5683, 0x567e,
/* 30 */ 0x5682, 0x567f, 0x5681, 0x58d6, 0x58d4, 0x58cf, 0x58d2, 0x5b2d,
/* 38 */ 0x5b25, 0x5b32, 0x5b23, 0x5b2c, 0x5b27, 0x5b26, 0x5b2f, 0x5b2e
},

/* Row 0x0ca */
{
/* 00 */ 0x5b7b, 0x5bf1, 0x5bf2, 0x5db7, 0x5e6c, 0x5e6a, 0x5fbe, 0x5fbb,
/* 08 */ 0x61c3, 0x61b5, 0x61bc, 0x61e7, 0x61e0, 0x61e5, 0x61e4, 0x61e8,
/* 10 */ 0x61de, 0x64ef, 0x64e9, 0x64e3, 0x64eb, 0x64e4, 0x64e8, 0x6581,
/* 18 */ 0x6580, 0x65b6, 0x65da, 0x66d2, 0x6a8d, 0x6a96, 0x6a81, 0x6aa5,
/* 20 */ 0x6a89, 0x6a9f, 0x6a9b, 0x6aa1, 0x6a9e, 0x6a87, 0x6a93, 0x6a8e,
/* 28 */ 0x77b4, 0x77b1, 0x77a8, 0x77f0, 0x78f3, 0x78fd, 0x7902, 0x78fb,
/* 30 */ 0x78fc, 0x78f2, 0x7905, 0x78f9, 0x78fe, 0x7904, 0x79ab, 0x79a8,
/* 38 */ 0x7a5c, 0x7a5b, 0x7a56, 0x7a58, 0x7a54, 0x7a5a, 0x7abe, 0x7ac0
},

/* Row 0x0cb */
{
/* 00 */ 0x7ac1, 0x7c05, 0x7c0f, 0x7bf2, 0x7c00, 0x7bff, 0x7bfb, 0x7c0e,
/* 08 */ 0x7bf4, 0x7c0b, 0x7bf3, 0x7c02, 0x7c09, 0x7c03, 0x7c01, 0x7bf8,
/* 10 */ 0x7bfd, 0x7c06, 0x7bf0, 0x7bf1, 0x7c10, 0x7c0a, 0x7ce8, 0x7e2d,
/* 18 */ 0x7e3c, 0x7e42, 0x7e33, 0x9848, 0x7e38, 0x7e2a, 0x7e49, 0x7e40,
/* 20 */ 0x7e47, 0x7e29, 0x7e4c, 0x7e30, 0x7e3b, 0x7e36, 0x7e44, 0x7e3a,
/* 28 */ 0x7f45, 0x7f7f, 0x7f7e, 0x7f7d, 0x7ff4, 0x7ff2, 0x802c, 0x81bb,
/* 30 */ 0x81c4, 0x81cc, 0x81ca, 0x81c5, 0x81c7, 0x81bc, 0x81e9, 0x825b,
/* 38 */ 0x825a, 0x825c, 0x8583, 0x8580, 0x858f, 0x85a7, 0x8595, 0x85a0
},

/* Row 0x0cc */
{
/* 00 */ 0x858b, 0x85a3, 0x857b, 0x85a4, 0x859a, 0x859e, 0x8b18, 0x8b16,
/* 08 */ 0x8b11, 0x8b05, 0x8b0b, 0x8b22, 0x8b0f, 0x8b12, 0x8b15, 0x8b07,
/* 10 */ 0x8b0d, 0x8b08, 0x8b06, 0x8b1c, 0x8b13, 0x8b1a, 0x8c4f, 0x8c70,
/* 18 */ 0x8c72, 0x8c71, 0x8c6f, 0x8c95, 0x8c94, 0x8cf9, 0x8d6f, 0x8e4e,
/* 20 */ 0x8e4d, 0x8e53, 0x8e50, 0x8e4c, 0x8e47, 0x8f43, 0x8f40, 0x9085,
/* 28 */ 0x907e, 0x9138, 0x919a, 0x91a2, 0x919b, 0x9199, 0x919f, 0x91a1,
/* 30 */ 0x919d, 0x91a0, 0x93a1, 0x9383, 0x93af, 0x9364, 0x9356, 0x9347,
/* 38 */ 0x937c, 0x9358, 0x935c, 0x9376, 0x9349, 0x9350, 0x9351, 0x9360
},

/* Row 0x0cd */
{
/* 00 */ 0x936d, 0x938f, 0x934c, 0x936a, 0x9379, 0x9357, 0x9355, 0x9352,
/* 08 */ 0x934f, 0x9371, 0x9377, 0x937b, 0x9361, 0x935e, 0x9363, 0x9367,
/* 10 */ 0x9380, 0x934e, 0x9359, 0x95c7, 0x95c0, 0x95c9, 0x95c3, 0x95c5,
/* 18 */ 0x95b7, 0x96ae, 0x96b0, 0x96ac, 0x9720, 0x971f, 0x9718, 0x971d,
/* 20 */ 0x9719, 0x979a, 0x97a1, 0x979c, 0x9d45, 0x9d42, 0x9d43, 0x9d3e,
/* 28 */ 0x9d37, 0x9d40, 0x9d3d, 0x7ff5, 0x9d2d, 0x9e8a, 0x9e89, 0x9e8d,
/* 30 */ 0x9eb0, 0x9ec8, 0x9eda, 0x9efb, 0x9eff, 0x9f24, 0x9f23, 0x9f22,
/* 38 */ 0x9f54, 0x9fa0, 0x5131, 0x512d, 0x512e, 0x5698, 0x569c, 0x5697
},

/* Row 0x0ce */
{
/* 00 */ 0x569a, 0x569d, 0x5699, 0x5970, 0x5b3c, 0x5c69, 0x5c6a, 0x5dc0,
/* 08 */ 0x5e6d, 0x5e6e, 0x61d8, 0x61df, 0x61ed, 0x61ee, 0x61f1, 0x61ea,
/* 10 */ 0x61f0, 0x61eb, 0x61d6, 0x61e9, 0x64ff, 0x6504, 0x64fd, 0x64f8,
/* 18 */ 0x6501, 0x6503, 0x64fc, 0x6594, 0x65db, 0x66da, 0x66db, 0x66d8,
/* 20 */ 0x6ac5, 0x6ab9, 0x6abd, 0x6ae1, 0x6ac6, 0x6aba, 0x6ab6, 0x6ab7,
/* 28 */ 0x6ac7, 0x6ab4, 0x6aad, 0x6b5e, 0x6bc9, 0x6c0b, 0x7007, 0x700c,
/* 30 */ 0x700d, 0x7001, 0x7005, 0x7014, 0x700e, 0x6fff, 0x7000, 0x6ffb,
/* 38 */ 0x7026, 0x6ffc, 0x6ff7, 0x700a, 0x7201, 0x71ff, 0x71f9, 0x7203
},

/* Row 0x0cf */
{
/* 00 */ 0x71fd, 0x7376, 0x81d0, 0x825f, 0x825e, 0x85b4, 0x85c6, 0x85c0,
/* 08 */ 0x85c3, 0x85c2, 0x85b3, 0x85b5, 0x85bd, 0x85c7, 0x85c4, 0x85bf,
/* 10 */ 0x85cb, 0x85ce, 0x85c8, 0x85c5, 0x85b1, 0x85b6, 0x85d2, 0x8624,
/* 18 */ 0x85b8, 0x85b7, 0x85be, 0x8669, 0x87e7, 0x87e6, 0x87e2, 0x87db,
/* 20 */ 0x87eb, 0x87ea, 0x87e5, 0x87df, 0x87f3, 0x87e4, 0x87d4, 0x87dc,
/* 28 */ 0x87d3, 0x87ed, 0x87d8, 0x87e3, 0x87a4, 0x87d7, 0x87d9, 0x8801,
/* 30 */ 0x87f4, 0x87e8, 0x87dd, 0x8953, 0x894b, 0x894f, 0x894c, 0x8946,
/* 38 */ 0x8950, 0x8951, 0x8949, 0x8b2a, 0x8b27, 0x8b23, 0x8b33, 0x8b30
},

/* Row 0x0d0 */
{
/* 00 */ 0x8b35, 0x8b47, 0x8b2f, 0x8b3c, 0x8b3e, 0x8b31, 0x8b25, 0x8b37,
/* 08 */ 0x8b26, 0x8b36, 0x8b2e, 0x8b24, 0x8b3b, 0x8b3d, 0x8b3a, 0x8c42,
/* 10 */ 0x8c75, 0x8c99, 0x8c98, 0x8c97, 0x8cfe, 0x8d04, 0x8d02, 0x8d00,
/* 18 */ 0x8e5c, 0x8e62, 0x8e60, 0x8e57, 0x8e56, 0x8e5e, 0x8e65, 0x8e67,
/* 20 */ 0x97a2, 0x97a5, 0x97d7, 0x97d9, 0x97d6, 0x97d8, 0x97fa, 0x9850,
/* 28 */ 0x9851, 0x9852, 0x98b8, 0x9941, 0x993c, 0x993a, 0x9a0f, 0x9a0b,
/* 30 */ 0x9a09, 0x9a0d, 0x9a04, 0x9a11, 0x9a0a, 0x9a05, 0x9a07, 0x9a06,
/* 38 */ 0x9ac0, 0x9adc, 0x9b08, 0x9b04, 0x9b05, 0x9b29, 0x9b35, 0x9b4a
},

/* Row 0x0d1 */
{
/* 00 */ 0x9b4c, 0x9b4b, 0x9bc7, 0x9bc6, 0x9bc3, 0x9bbf, 0x9bc1, 0x9bb5,
/* 08 */ 0x9bb8, 0x9bd3, 0x9bb6, 0x9bc4, 0x9bb9, 0x9bbd, 0x9d5c, 0x9d53,
/* 10 */ 0x9d4f, 0x9d4a, 0x9d5b, 0x9d4b, 0x9d59, 0x9d56, 0x9d4c, 0x9d57,
/* 18 */ 0x9d52, 0x9d54, 0x9d5f, 0x9d58, 0x9d5a, 0x9e8e, 0x9e8c, 0x9edf,
/* 20 */ 0x9f01, 0x9f00, 0x9f16, 0x9f25, 0x9f2b, 0x9f2a, 0x9f29, 0x9f28,
/* 28 */ 0x9f4c, 0x9f55, 0x5134, 0x5135, 0x5296, 0x52f7, 0x53b4, 0x56ab,
/* 30 */ 0x56ad, 0x56a6, 0x56a7, 0x56aa, 0x56ac, 0x58da, 0x58dd, 0x58db,
/* 38 */ 0x5912, 0x5b3d, 0x5b3e, 0x5b3f, 0x5dc3, 0x5e70, 0x7921, 0x791c
},

/* Row 0x0d2 */
{
/* 00 */ 0x7917, 0x791e, 0x79b0, 0x7a67, 0x7a68, 0x7c33, 0x7c3c, 0x7c39,
/* 08 */ 0x7c2c, 0x7c3b, 0x7cec, 0x7cea, 0x7e76, 0x7e75, 0x7e78, 0x7e70,
/* 10 */ 0x7e77, 0x7e6f, 0x7e7a, 0x7e72, 0x7e74, 0x7e68, 0x7f4b, 0x7f4a,
/* 18 */ 0x7f83, 0x7f86, 0x7fb7, 0x7ffd, 0x7ffe, 0x8078, 0x81d7, 0x81d5,
/* 20 */ 0x8264, 0x8261, 0x8263, 0x85eb, 0x85f1, 0x85ed, 0x85d9, 0x85e1,
/* 28 */ 0x85e8, 0x85da, 0x85d7, 0x85ec, 0x85f2, 0x85f8, 0x85d8, 0x85df,
/* 30 */ 0x85e3, 0x85dc, 0x85d1, 0x85f0, 0x85e6, 0x85ef, 0x85de, 0x85e2,
/* 38 */ 0x8800, 0x87fa, 0x8803, 0x87f6, 0x87f7, 0x8809, 0x880c, 0x880b
},

/* Row 0x0d3 */
{
/* 00 */ 0x8806, 0x87fc, 0x8808, 0x87ff, 0x880a, 0x8802, 0x8962, 0x895a,
/* 08 */ 0x895b, 0x8957, 0x8961, 0x895c, 0x8958, 0x895d, 0x8959, 0x8988,
/* 10 */ 0x89b7, 0x89b6, 0x89f6, 0x8b50, 0x8b48, 0x8b4a, 0x8b40, 0x8b53,
/* 18 */ 0x8b56, 0x8b54, 0x8b4b, 0x8b55, 0x97b3, 0x97b7, 0x97b6, 0x97dd,
/* 20 */ 0x97de, 0x97df, 0x985c, 0x9859, 0x985d, 0x9857, 0x98bf, 0x98bd,
/* 28 */ 0x98bb, 0x98be, 0x9948, 0x9947, 0x9943, 0x99a6, 0x99a7, 0x9a1a,
/* 30 */ 0x9a15, 0x9a25, 0x9a1d, 0x9a24, 0x9a1b, 0x9a22, 0x9a20, 0x9a27,
/* 38 */ 0x9a23, 0x9a1e, 0x9a1c, 0x9a14, 0x9ac2, 0x9b0b, 0x9b0a, 0x9b0e
},

/* Row 0x0d4 */
{
/* 00 */ 0x9b0c, 0x9b37, 0x9bea, 0x9beb, 0x9be0, 0x9bde, 0x9be4, 0x9be6,
/* 08 */ 0x9be2, 0x9bf0, 0x9bd4, 0x9bd7, 0x9bec, 0x9bdc, 0x9bd9, 0x9be5,
/* 10 */ 0x9bd5, 0x9be1, 0x9bda, 0x9d77, 0x9d81, 0x9d8a, 0x9d84, 0x9d88,
/* 18 */ 0x9d71, 0x9d80, 0x9d78, 0x9d86, 0x9d8b, 0x9d8c, 0x9d7d, 0x9d6b,
/* 20 */ 0x9d74, 0x9d75, 0x9d70, 0x9d69, 0x9d85, 0x9d73, 0x9d7b, 0x9d82,
/* 28 */ 0x9d6f, 0x9d79, 0x9d7f, 0x9d87, 0x9d68, 0x9e94, 0x9e91, 0x9ec0,
/* 30 */ 0x9efc, 0x9f2d, 0x9f40, 0x9f41, 0x9f4d, 0x9f56, 0x9f57, 0x9f58,
/* 38 */ 0x5337, 0x56b2, 0x79b2, 0x7a6e, 0x7a6c, 0x7a6d, 0x7af7, 0x7c49
},

/* Row 0x0d5 */
{
/* 00 */ 0x7c48, 0x7c4a, 0x7c47, 0x7c45, 0x7cee, 0x7e7b, 0x7e7e, 0x7e81,
/* 08 */ 0x7e80, 0x7fba, 0x7fff, 0x8079, 0x81db, 0x81d9, 0x820b, 0x8268,
/* 10 */ 0x8269, 0x8622, 0x85ff, 0x8601, 0x85fe, 0x861b, 0x8600, 0x85f6,
/* 18 */ 0x8604, 0x8609, 0x8605, 0x860c, 0x85fd, 0x8819, 0x8810, 0x8811,
/* 20 */ 0x8817, 0x8813, 0x8816, 0x8963, 0x8966, 0x89b9, 0x89f7, 0x8b60,
/* 28 */ 0x8b6a, 0x8b5d, 0x8b68, 0x8b63, 0x8b65, 0x8b67, 0x8b6d, 0x8dae,
/* 30 */ 0x8e86, 0x8e88, 0x8e84, 0x8f59, 0x8f56, 0x8f57, 0x8f55, 0x8f58,
/* 38 */ 0x8f5a, 0x908d, 0x9143, 0x9141, 0x91b7, 0x91b5, 0x91b2, 0x91b3
},

/* Row 0x0d6 */
{
/* 00 */ 0x940b, 0x9413, 0x93fb, 0x9420, 0x940f, 0x9414, 0x93fe, 0x9415,
/* 08 */ 0x9410, 0x9428, 0x9419, 0x940d, 0x93f5, 0x9400, 0x93f7, 0x9407,
/* 10 */ 0x940e, 0x9416, 0x9412, 0x93fa, 0x9409, 0x93f8, 0x940a, 0x93ff,
/* 18 */ 0x9da0, 0x9d94, 0x9d9c, 0x9daa, 0x9d97, 0x9da1, 0x9d9a, 0x9da2,
/* 20 */ 0x9da8, 0x9d9e, 0x9da3, 0x9dbf, 0x9da9, 0x9d96, 0x9da6, 0x9da7,
/* 28 */ 0x9e99, 0x9e9b, 0x9e9a, 0x9ee5, 0x9ee4, 0x9ee7, 0x9ee6, 0x9f30,
/* 30 */ 0x9f2e, 0x9f5b, 0x9f60, 0x9f5e, 0x9f5d, 0x9f59, 0x9f91, 0x513a,
/* 38 */ 0x5139, 0x5298, 0x5297, 0x56c3, 0x56bd, 0x56be, 0x5b48, 0x5b47
},

/* Row 0x0d7 */
{
/* 00 */ 0x5dcb, 0x5dcf, 0x5ef1, 0x61fd, 0x651b, 0x6b02, 0x6afc, 0x6b03,
/* 08 */ 0x6af8, 0x6b00, 0x7043, 0x7044, 0x704a, 0x7048, 0x7049, 0x7045,
/* 10 */ 0x7046, 0x721d, 0x721a, 0x7219, 0x737e, 0x7517, 0x766a, 0x77d0,
/* 18 */ 0x792d, 0x7931, 0x792f, 0x7c54, 0x7c53, 0x7cf2, 0x7e8a, 0x7e87,
/* 20 */ 0x7e88, 0x7e8b, 0x7e86, 0x7e8d, 0x7f4d, 0x7fbb, 0x8030, 0x81dd,
/* 28 */ 0x8618, 0x862a, 0x8626, 0x861f, 0x8623, 0x861c, 0x8619, 0x8627,
/* 30 */ 0x862e, 0x8621, 0x8620, 0x8629, 0x861e, 0x8625, 0x9a3f, 0x9acd,
/* 38 */ 0x9b15, 0x9b17, 0x9b18, 0x9b16, 0x9b3a, 0x9b52, 0x9c2b, 0x9c1d
},

/* Row 0x0d8 */
{
/* 00 */ 0x9c1c, 0x9c2c, 0x9c23, 0x9c28, 0x9c29, 0x9c24, 0x9c21, 0x9db7,
/* 08 */ 0x9db6, 0x9dbc, 0x9dc1, 0x9dc7, 0x9dca, 0x9dcf, 0x9dbe, 0x9dc5,
/* 10 */ 0x9dc3, 0x9dbb, 0x9db5, 0x9dce, 0x9db9, 0x9dba, 0x9dac, 0x9dc8,
/* 18 */ 0x9db1, 0x9dad, 0x9dcc, 0x9db3, 0x9dcd, 0x9db2, 0x9e7a, 0x9e9c,
/* 20 */ 0x9eeb, 0x9eee, 0x9eed, 0x9f1b, 0x9f18, 0x9f1a, 0x9f31, 0x9f4e,
/* 28 */ 0x9f65, 0x9f64, 0x9f92, 0x4eb9, 0x56c6, 0x56c5, 0x56cb, 0x5971,
/* 30 */ 0x5b4b, 0x5b4c, 0x5dd5, 0x5dd1, 0x5ef2, 0x6521, 0x6520, 0x6526,
/* 38 */ 0x6522, 0x6b0b, 0x6b08, 0x6b09, 0x6c0d, 0x7055, 0x7056, 0x7057
},

/* Row 0x0d9 */
{
/* 00 */ 0x7052, 0x721e, 0x721f, 0x72a9, 0x737f, 0x74d8, 0x74d5, 0x74d9,
/* 08 */ 0x74d7, 0x766d, 0x76ad, 0x7935, 0x79b4, 0x7a70, 0x7a71, 0x7c57,
/* 10 */ 0x7c5c, 0x7c59, 0x7c5b, 0x7c5a, 0x9a49, 0x9a52, 0x9a50, 0x9ad0,
/* 18 */ 0x9b19, 0x9b2b, 0x9b3b, 0x9b56, 0x9b55, 0x9c46, 0x9c48, 0x9c3f,
/* 20 */ 0x9c44, 0x9c39, 0x9c33, 0x9c41, 0x9c3c, 0x9c37, 0x9c34, 0x9c32,
/* 28 */ 0x9c3d, 0x9c36, 0x9ddb, 0x9dd2, 0x9dde, 0x9dda, 0x9dcb, 0x9dd0,
/* 30 */ 0x9ddc, 0x9dd1, 0x9ddf, 0x9de9, 0x9dd9, 0x9dd8, 0x9dd6, 0x9df5,
/* 38 */ 0x9dd5, 0x9ddd, 0x9eb6, 0x9ef0, 0x9f35, 0x9f33, 0x9f32, 0x9f42
},

/* Row 0x0da */
{
/* 00 */ 0x9f6b, 0x9f95, 0x9fa2, 0x513d, 0x5299, 0x58e8, 0x58e7, 0x5972,
/* 08 */ 0x5b4d, 0x5dd8, 0x882f, 0x5f4f, 0x6201, 0x6203, 0x6204, 0x6529,
/* 10 */ 0x6525, 0x6596, 0x66eb, 0x6b11, 0x6b12, 0x6b0f, 0x6bca, 0x705b,
/* 18 */ 0x705a, 0x7222, 0x7382, 0x7381, 0x7383, 0x7670, 0x77d4, 0x7c67,
/* 20 */ 0x7c66, 0x7e95, 0x826c, 0x863a, 0x8640, 0x8639, 0x863c, 0x8631,
/* 28 */ 0x863b, 0x863e, 0x8830, 0x8832, 0x882e, 0x8833, 0x8976, 0x8974,
/* 30 */ 0x8973, 0x89fe, 0x9f71, 0x9f70, 0x9f6e, 0x9f6f, 0x56d3, 0x56cd,
/* 38 */ 0x5b4e, 0x5c6d, 0x652d, 0x66ed, 0x66ee, 0x6b13, 0x705f, 0x7061
},

/* Row 0x0db */
{
/* 00 */ 0x705d, 0x7060, 0x7223, 0x74db, 0x74e5, 0x77d5, 0x7938, 0x79b7,
/* 08 */ 0x79b6, 0x7c6a, 0x7e97, 0x7f89, 0x826d, 0x8643, 0x8838, 0x8837,
/* 10 */ 0x8835, 0x884b, 0x8b94, 0x8b95, 0x8e9e, 0x8e9f, 0x8ea0, 0x8e9d,
/* 18 */ 0x91be, 0x91bd, 0x91c2, 0x946b, 0x9468, 0x9469, 0x96e5, 0x9746,
/* 20 */ 0x9743, 0x9747, 0x97c7, 0x97e5, 0x9a5e, 0x9ad5, 0x9b59, 0x9c63,
/* 28 */ 0x9c67, 0x9c66, 0x9c62, 0x9c5e, 0x9c60, 0x9e02, 0x9dfe, 0x9e07,
/* 30 */ 0x9e03, 0x9e06, 0x9e05, 0x9e00, 0x9e01, 0x9e09, 0x9dff, 0x9dfd,
/* 38 */ 0x9e04, 0x9ea0, 0x9f1e, 0x9f46, 0x9f74, 0x9f75, 0x9f76, 0x56d4
},

/* Row 0x0dc */
{
/* 00 */ 0x652e, 0x65b8, 0x6b18, 0x6b19, 0x6b17, 0x6b1a, 0x7062, 0x7226,
/* 08 */ 0x72aa, 0x77d8, 0x77d9, 0x7939, 0x7c69, 0x7c6b, 0x7cf6, 0x7e9a,
/* 10 */ 0x9fa4, 0x7068, 0x7065, 0x7cf7, 0x866a, 0x883e, 0x883d, 0x883f,
/* 18 */ 0x8b9e, 0x8c9c, 0x8ea9, 0x8ec9, 0x974b, 0x9873, 0x9874, 0x98cc,
/* 20 */ 0x9961, 0x99ab, 0x9a64, 0x9a66, 0x9a67, 0x9b24, 0x9e15, 0x9e17,
/* 28 */ 0x9f48, 0x6207, 0x6b1e, 0x7227, 0x864c, 0x8ea8, 0x9482, 0x9480,
/* 30 */ 0x9481, 0x9a69, 0x9a68, 0x9b2e, 0x9e19, 0x7229, 0x864b, 0x8b9f,
/* 38 */ 0x9483, 0x9c79, 0x9eb7, 0x7675, 0x9a6b, 0x9c7a, 0x9e1d, 0x7069
},

/* Row 0x0dd */
{
/* 00 */ 0x706a, 0x9ea4, 0x9f7e, 0x9f49, 0x9f98, 0xf78f, 0xf790, 0xf791,
/* 08 */ 0xf792, 0xf793, 0xf794, 0xf795, 0xf796, 0xf797, 0xf798, 0xf799,
/* 10 */ 0xf79a, 0xf79b, 0xf79c, 0xf79d, 0xf79e, 0xf79f, 0xf7a0, 0xf7a1,
/* 18 */ 0xf7a2, 0xf7a3, 0xf7a4, 0xf7a5, 0xf7a6, 0xf7a7, 0xf7a8, 0xf7a9,
/* 20 */ 0xf7aa, 0xf7ab, 0xf7ac, 0xf7ad, 0xf7ae, 0xf7af, 0xf7b0, 0xf7b1,
/* 28 */ 0xf7b2, 0xf7b3, 0xf7b4, 0xf7b5, 0xf7b6, 0xf7b7,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0de */
{
/* 00 */ 0x3000, 0xff0c, 0x3001, 0x3002, 0xff0e, 0x2022, 0xff1b, 0xff1a,
/* 08 */ 0xff1f, 0xff01, 0xfe30, 0x2026, 0x2025, 0xfe50, 0xff64, 0xfe52,
/* 10 */ 0x00b7, 0xfe54, 0xfe55, 0xfe56, 0xfe57, 0xff5c, 0x2013, 0xfe31,
/* 18 */ 0x2014, 0xfe33,    BAD, 0xfe34, 0xfe4f, 0xff08, 0xff09, 0xfe35,
/* 20 */ 0xfe36, 0xff5b, 0xff5d, 0xfe37, 0xfe38, 0x3014, 0x3015, 0xfe39,
/* 28 */ 0xfe3a, 0x3010, 0x3011, 0xfe3b, 0xfe3c, 0x300a, 0x300b, 0xfe3d,
/* 30 */ 0xfe3e, 0x3008, 0x3009, 0xfe3f, 0xfe40, 0x300c, 0x300d, 0xfe41,
/* 38 */ 0xfe42, 0x300e, 0x300f, 0xfe43, 0xfe44, 0xfe59, 0xfe5a,    BAD
},

/* Row 0x0df */
{
/* 00 */ 0xff0f, 0xff3c, 0xff04, 0x00a5, 0x3012, 0x00a2, 0x00a3, 0xff05,
/* 08 */ 0xff20, 0x2103, 0x2109, 0xfe69, 0xfe6a, 0xfe6b, 0x33d5, 0x339c,
/* 10 */ 0x339d, 0x339e, 0x33ce, 0x33a1, 0x338e, 0x338f, 0x33c4, 0x00b0,
/* 18 */ 0x5159, 0x515b, 0x515e, 0x515d, 0x5161, 0x5163, 0x55e7, 0x74e9,
/* 20 */ 0x7cce, 0x2581, 0x2582, 0x2583, 0x2584, 0x2585, 0x2586, 0x2587,
/* 28 */ 0x2588, 0x258f, 0x258e, 0x258d, 0x258c, 0x258b, 0x258a, 0x2589,
/* 30 */ 0x253c, 0x2534, 0x252c, 0x2524, 0x251c, 0x2594, 0x2500, 0x2502,
/* 38 */ 0x2595, 0x250c, 0x2510, 0x2514, 0x2518,    BAD, 0xff57, 0xff58
},

/* Row 0x0e0 */
{
/* 00 */ 0x991b, 0x9921, 0x991a, 0x99ed, 0x99e2, 0x99f1, 0x9ab8, 0x9abc,
/* 08 */ 0x9afb, 0x9aed, 0x9b28, 0x9b91, 0x9d15, 0x9d23, 0x9d26, 0x9d28,
/* 10 */ 0x9d12, 0x9d1b, 0x9ed8, 0x9ed4, 0x9f8d,    BAD, 0x512a, 0x511f,
/* 18 */ 0x5121, 0x5132, 0x52f5, 0x568e, 0x5680, 0x5690, 0x5685, 0x5687,
/* 20 */ 0x77a7, 0x77ad, 0x77ef, 0x78f7, 0x78fa, 0x78f4, 0x78ef, 0x7901,
/* 28 */ 0x79a7, 0x79aa, 0x7a57, 0x7abf, 0x7c07, 0x7c0d, 0x7bfe, 0x7bf7,
/* 30 */ 0x7c0c, 0x7be0, 0x7ce0, 0x7cdc, 0x7cde, 0x7ce2, 0x7cdf, 0x7cd9,
/* 38 */ 0x7cdd, 0x7e2e, 0x7e3e, 0x7e46, 0x7e37, 0x7e32, 0x7e43, 0x7e2b
},

/* Row 0x0e1 */
{
/* 00 */ 0x7064, 0x77da, 0x8b9a, 0x9477, 0x97c9, 0x9a62, 0x9a65, 0x7e9c,
/* 08 */ 0x8b9c, 0x8eaa, 0x91c5, 0x947d, 0x947e, 0x947c, 0x9c77, 0x9c78,
/* 10 */ 0x9ef7, 0x8c54, 0x947f, 0x9e1a, 0x7228, 0x9a6a, 0x9b31, 0x9e1b,
/* 18 */ 0x9e1e, 0x7c72, 0x3059, 0x305a, 0x305b, 0x305c, 0x305d, 0x305e,
/* 20 */ 0x305f, 0x3060, 0x3061, 0x3062, 0x3063, 0x3064, 0x3065, 0x3066,
/* 28 */ 0x3067, 0x3068, 0x3069, 0x306a, 0x306b, 0x306c, 0x306d, 0x306e,
/* 30 */ 0x306f, 0x3070, 0x3071, 0x3072, 0x3073, 0x3074, 0x3075, 0x3076,
/* 38 */ 0x3077, 0x3078, 0x3079, 0x307a, 0x307b, 0x307c, 0x307d, 0x307e
},

/* Row 0x0e2 */
{
/* 00 */ 0x307f, 0x3080, 0x3081, 0x3082, 0x3083, 0x3084, 0x3085, 0x3086,
/* 08 */ 0x3087, 0x3088, 0x3089, 0x308a, 0x308b, 0x308c, 0x308d, 0x308e,
/* 10 */ 0x308f, 0x3090, 0x3091, 0x3092, 0x3093, 0x30a1, 0x30a2, 0x30a3,
/* 18 */ 0x30a4, 0x041b, 0x041c, 0x041d, 0x041e, 0x041f, 0x0420, 0x0421,
/* 20 */ 0x0422, 0x0423, 0x0424, 0x0425, 0x0426, 0x0427, 0x0428, 0x0429,
/* 28 */ 0x042a, 0x042b, 0x042c, 0x042d, 0x042e, 0x042f, 0x0430, 0x0431,
/* 30 */ 0x0432, 0x0433, 0x0434, 0x0435, 0x0451, 0x0436, 0x0437, 0x0438,
/* 38 */ 0x0439, 0x043a, 0x043b, 0x043c, 0x043d, 0x043e, 0x043f, 0x0440
},

/* Row 0x0e3 */
{
/* 00 */ 0x0441, 0x0442, 0x0443, 0x0444, 0x0445, 0x0446, 0x0447, 0x0448,
/* 08 */ 0x0449, 0x044a, 0x044b, 0x044c, 0x044d, 0x044e, 0x044f, 0x21e7,
/* 10 */ 0x21b8, 0x21b9, 0xf7e5, 0xf7e6, 0x4e5a, 0xf7e8, 0x5202, 0xf7ea,
/* 18 */ 0x4e42, 0x4e5c, 0x51f5, 0x531a, 0x5382, 0x4e07, 0x4e0c, 0x4e47,
/* 20 */ 0x4e8d, 0x56d7, 0xfa0c, 0x5c6e, 0x5f73, 0x4e0f, 0x5187, 0x4e0e,
/* 28 */ 0x4e2e, 0x4e93, 0x4ec2, 0x4ec9, 0x4ec8, 0x5198, 0x52fc, 0x536c,
/* 30 */ 0x53b9, 0x5720, 0x5903, 0x592c, 0x5c10, 0x5dff, 0x65e1, 0x6bb3,
/* 38 */ 0x6bcc, 0x6c14, 0x723f, 0x4e31, 0x4e3c, 0x4ee8, 0x4edc, 0x4ee9
},

/* Row 0x0e4 */
{
/* 00 */ 0xfe5b, 0xfe5c, 0xfe5d, 0xfe5e, 0x2018, 0x2019, 0x201c, 0x201d,
/* 08 */ 0x301d, 0x301e, 0x2035, 0x2032, 0xff03, 0xff06, 0xff0a, 0x203b,
/* 10 */ 0x00a7, 0x3003, 0x25cb, 0x25cf, 0x25b3, 0x25b2, 0x25ce, 0x2606,
/* 18 */ 0x2605, 0x25c7, 0x25c6, 0x25a1, 0x25a0, 0x25bd, 0x25bc, 0x32a3,
/* 20 */ 0x2105, 0x203e,    BAD, 0xff3f,    BAD, 0xfe49, 0xfe4a, 0xfe4d,
/* 28 */ 0xfe4e, 0xfe4b, 0xfe4c, 0xfe5f, 0xfe60, 0xfe61, 0xff0b, 0xff0d,
/* 30 */ 0x00d7, 0x00f7, 0x00b1, 0x221a, 0xff1c, 0xff1e, 0xff1d, 0x2266,
/* 38 */ 0x2267, 0x2260, 0x221e, 0x2252, 0x2261, 0xfe62, 0xfe63, 0xfe64
},

/* Row 0x0e5 */
{
/* 00 */ 0xfe65, 0xfe66, 0x223c, 0x2229, 0x222a, 0x22a5, 0x2220, 0x221f,
/* 08 */ 0x22bf, 0x33d2, 0x33d1, 0x222b, 0x222e, 0x2235, 0x2234, 0x2640,
/* 10 */ 0x2642, 0x2641, 0x2609, 0x2191, 0x2193, 0x2190, 0x2192, 0x2196,
/* 18 */ 0x2197, 0x2199, 0x2198, 0x2225, 0x2223,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x25e2, 0x25e3, 0x25e5,
/* 28 */ 0x25e4, 0x2571, 0x2572, 0x2573, 0xff10, 0xff11, 0xff12, 0xff13,
/* 30 */ 0xff14, 0xff15, 0xff16, 0xff17, 0xff18, 0xff19, 0x2160, 0x2161,
/* 38 */ 0x2162, 0x2163, 0x2164, 0x2165, 0x2166, 0x2167, 0x2168, 0x2169
},

/* Row 0x0e6 */
{
/* 00 */ 0x3021, 0x3022, 0x3023, 0x3024, 0x3025, 0x3026, 0x3027, 0x3028,
/* 08 */ 0x3029,    BAD, 0x5344,    BAD, 0xff21, 0xff22, 0xff23, 0xff24,
/* 10 */ 0xff25, 0xff26, 0xff27, 0xff28, 0xff29, 0xff2a, 0xff2b, 0xff2c,
/* 18 */ 0xff2d, 0xff2e, 0xff2f, 0xff30, 0xff31, 0xff32, 0xff33, 0xff34,
/* 20 */ 0xff35, 0xff36, 0xff37, 0xff38, 0xff39, 0xff3a, 0xff41, 0xff42,
/* 28 */ 0xff43, 0xff44, 0xff45, 0xff46, 0xff47, 0xff48, 0xff49, 0xff4a,
/* 30 */ 0xff4b, 0xff4c, 0xff4d, 0xff4e, 0xff4f, 0xff50, 0xff51, 0xff52,
/* 38 */ 0xff53, 0xff54, 0xff55, 0xff56, 0x3110, 0x3111, 0x3112, 0x3113
},

/* Row 0x0e7 */
{
/* 00 */ 0x3114, 0x3115, 0x3116, 0x3117, 0x3118, 0x3119, 0x311a, 0x311b,
/* 08 */ 0x311c, 0x311d, 0x311e, 0x311f, 0x3120, 0x3121, 0x3122, 0x3123,
/* 10 */ 0x3124, 0x3125, 0x3126, 0x3127, 0x3128, 0x3129, 0x02d9, 0x02c9,
/* 18 */ 0x02ca, 0x02c7, 0x02cb,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0e8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x4e11, 0x4e10, 0x4e0d, 0x4e2d, 0x4e30, 0x4e39,
/* 20 */ 0x4e4b, 0x5c39, 0x4e88, 0x4e91, 0x4e95, 0x4e92, 0x4e94, 0x4ea2,
/* 28 */ 0x4ec1, 0x4ec0, 0x4ec3, 0x4ec6, 0x4ec7, 0x4ecd, 0x4eca, 0x4ecb,
/* 30 */ 0x4ec4, 0x5143, 0x5141, 0x5167, 0x516d, 0x516e, 0x516c, 0x5197,
/* 38 */ 0x51f6, 0x5206, 0x5207, 0x5208, 0x52fb, 0x52fe, 0x52ff, 0x5316
},

/* Row 0x0e9 */
{
/* 00 */ 0x9ad4, 0x9ad1, 0x9c54, 0x9c57, 0x9c56, 0x9de5, 0x9e9f, 0x9ef4,
/* 08 */ 0x56d1, 0x58e9, 0x652c, 0x705e, 0x7671, 0x7672, 0x77d7, 0x7f50,
/* 10 */ 0x7f88, 0x8836, 0x8839, 0x8862, 0x8b93, 0x8b92, 0x2460, 0x2461,
/* 18 */ 0x2462, 0x2463, 0x2464, 0x2465, 0x2466, 0x2467, 0x2468, 0x2469,
/* 20 */ 0x2474, 0x2475, 0x2476, 0x2477, 0x2478, 0x2479, 0x247a, 0x247b,
/* 28 */ 0x247c, 0x247d, 0x2170, 0x2171, 0x2172, 0x2173, 0x2174, 0x2175,
/* 30 */ 0x2176, 0x2177, 0x2178, 0x2179, 0x4e36, 0x4e3f, 0x4e85, 0x4ea0,
/* 38 */ 0x5182, 0x5196, 0x51ab, 0x52f9, 0x5338, 0x5369, 0x53b6, 0x590a
},

/* Row 0x0ea */
{
/* 00 */ 0x5b80, 0x5ddb, 0x2f33, 0x5e7f,    BAD, 0x5f50, 0x5f61, 0x6534,
/* 08 */    BAD, 0x7592,    BAD, 0x8fb5,    BAD, 0x00a8, 0x02c6, 0x30fd,
/* 10 */ 0x30fe, 0x309d, 0x309e,    BAD,    BAD, 0x3005, 0x3006, 0x3007,
/* 18 */ 0x30fc, 0xff3b, 0xff3d, 0x273d, 0x3041, 0x3042, 0x3043, 0x3044,
/* 20 */ 0x3045, 0x3046, 0x3047, 0x3048, 0x3049, 0x304a, 0x304b, 0x304c,
/* 28 */ 0x304d, 0x304e, 0x304f, 0x3050, 0x3051, 0x3052, 0x3053, 0x3054,
/* 30 */ 0x3055, 0x3056, 0x3057, 0x3058, 0x30a5, 0x30a6, 0x30a7, 0x30a8,
/* 38 */ 0x30a9, 0x30aa, 0x30ab, 0x30ac, 0x30ad, 0x30ae, 0x30af, 0x30b0
},

/* Row 0x0eb */
{
/* 00 */ 0x30b1, 0x30b2, 0x30b3, 0x30b4, 0x30b5, 0x30b6, 0x30b7, 0x30b8,
/* 08 */ 0x30b9, 0x30ba, 0x30bb, 0x30bc, 0x30bd, 0x30be, 0x30bf, 0x30c0,
/* 10 */ 0x30c1, 0x30c2, 0x30c3, 0x30c4, 0x30c5, 0x30c6, 0x30c7, 0x30c8,
/* 18 */ 0x30c9, 0x30ca, 0x30cb, 0x30cc, 0x30cd, 0x30ce, 0x30cf, 0x30d0,
/* 20 */ 0x30d1, 0x30d2, 0x30d3, 0x30d4, 0x30d5, 0x30d6, 0x30d7, 0x30d8,
/* 28 */ 0x30d9, 0x30da, 0x30db, 0x30dc, 0x30dd, 0x30de, 0x30df, 0x30e0,
/* 30 */ 0x30e1, 0x30e2, 0x30e3, 0x30e4, 0x30e5, 0x30e6, 0x30e7, 0x30e8,
/* 38 */ 0x30e9, 0x30ea, 0x30eb, 0x30ec, 0x30ed, 0x30ee, 0x30ef, 0x30f0
},

/* Row 0x0ec */
{
/* 00 */ 0x30f1, 0x30f2, 0x30f3, 0x30f4, 0x30f5, 0x30f6, 0x0410, 0x0411,
/* 08 */ 0x0412, 0x0413, 0x0414, 0x0415, 0x0401, 0x0416, 0x0417, 0x0418,
/* 10 */ 0x0419, 0x041a, 0xf7eb, 0x5188, 0xf7ed, 0xf7ee,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xffe2, 0xffe4
},

/* Row 0x0ed */
{
/* 00 */ 0xff07, 0xff02, 0x3231, 0x2116, 0x2121, 0x309b, 0x309c, 0x2e80,
/* 08 */ 0x2e84, 0x2e86, 0x2e87, 0x2e88, 0x2e8a, 0x2e8c, 0x2e8d, 0x2e95,
/* 10 */ 0x2e9c, 0x2e9d, 0x2ea5, 0x2ea7, 0x2eaa, 0x2eac, 0x2eae, 0x2eb6,
/* 18 */ 0x2ebc, 0x2ebe, 0x2ec6, 0x2eca, 0x2ecc, 0x2ecd, 0x2ecf, 0x2ed6,
/* 20 */ 0x2ed7, 0x2ede, 0x2ee3,    BAD,    BAD,    BAD, 0x0283, 0x0250,
/* 28 */ 0x025b, 0x0254, 0x0275, 0x0153, 0x00f8, 0x014b, 0x028a, 0x026a,
/* 30 */ 0x6c36, 0x6c43, 0x6c3f, 0x6c3b, 0x72ae, 0x72b0, 0x738a, 0x79b8,
/* 38 */ 0x808a, 0x961e, 0x4f0e, 0x4f18, 0x4f2c, 0x4ef5, 0x4f14, 0x4ef1
},

/* Row 0x0ee */
{
/* 00 */ 0x8186, 0x8183, 0x8187, 0x818d, 0x818c, 0x818b, 0x8215, 0x8497,
/* 08 */ 0x84a4, 0x84a1, 0x849f, 0x84ba, 0x84ce, 0x84c2, 0x84ac, 0x84ae,
/* 10 */ 0x84ab, 0x84b9, 0x84b4, 0x84c1, 0x84cd, 0x84aa, 0x849a, 0x84b1,
/* 18 */ 0x84d0, 0x849d, 0x84a7, 0x84bb, 0x84a2, 0x8494, 0x84c7, 0x84cc,
/* 20 */ 0x849b, 0x84a9, 0x84af, 0x84a8, 0x84d6, 0x8498, 0x84b6, 0x84cf,
/* 28 */ 0x84a0, 0x84d7, 0x84d4, 0x84d2, 0x84db, 0x84b0, 0x8491, 0x8661,
/* 30 */ 0x8733, 0x8723,    BAD, 0x876b, 0x8740, 0x872e, 0x871e, 0x8721,
/* 38 */ 0x8719, 0x871b, 0x8743, 0x872c, 0x8741, 0x873e, 0x8746, 0x8720
},

/* Row 0x0ef */
{
/* 00 */ 0xf303, 0xf304, 0xf305, 0xf306, 0xf307, 0xf308, 0xf309, 0xf30a,
/* 08 */ 0xf30b, 0xf30c, 0xf30d, 0xf30e, 0xf30f, 0xf310, 0xf311, 0xf312,
/* 10 */ 0xf313, 0xf314, 0xf315, 0xf316, 0xf317, 0xf318, 0x0100, 0x00c1,
/* 18 */ 0x01cd, 0x00c0, 0x0112, 0x00c9, 0x011a, 0x00c8, 0x014c, 0x00d3,
/* 20 */ 0x01d1, 0x00d2, 0xf325, 0x1ebe, 0xf327, 0x1ec0, 0x00ca, 0x0101,
/* 28 */ 0x00e1, 0x01ce, 0x00e0, 0x0251, 0x0113, 0x00e9, 0x011b, 0x00e8,
/* 30 */ 0x012b, 0x00ed, 0x01d0, 0x00ec, 0x014d, 0x00f3, 0x01d2, 0x00f2,
/* 38 */ 0x016b, 0x00fa, 0x01d4, 0x00f9, 0x01d6, 0x01d8, 0x01da, 0x01dc
},

/* Row 0x0f0 */
{
/* 00 */ 0x00fc, 0xf344, 0x1ebf, 0xf346, 0x1ec1, 0x00ea, 0x0261, 0xf34a,
/* 08 */ 0xf34b,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0f1 */
{
/* 00 */ 0x5fc4, 0x38fa, 0x624c, 0x6535, 0x6b7a, 0x6c35, 0x6c3a, 0x706c,
/* 08 */ 0x722b, 0x4e2c, 0x72ad, 0xf54e, 0x7f52, 0x793b, 0x7cf9, 0x7f53,
/* 10 */ 0xf553, 0x34c1,    BAD, 0xf556, 0x8002, 0x8080, 0xf559, 0xf55a,
/* 18 */ 0x535d, 0x8864, 0x89c1, 0xf55e, 0x8ba0, 0x8d1d, 0x9485, 0x9578,
/* 20 */ 0x957f, 0x95e8, 0xf565, 0x97e6, 0x9875, 0x98ce, 0x98de, 0x9963,
/* 28 */ 0xf56b, 0x9c7c, 0x9e1f, 0x9ec4, 0x6b6f, 0x9f9c, 0x4e37, 0xf572,
/* 30 */ 0x961d, 0x6237, 0x94a2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0f2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x5d3e, 0x5d48, 0x5d56, 0x3dfc, 0x380f, 0x5da4, 0x5db9,
/* 38 */ 0x3820, 0x3838, 0x5e42, 0x5ebd, 0x5f25, 0x5f83, 0x3908, 0x3914
},

/* Row 0x0f3 */
{
/* 00 */ 0x393f, 0x394d, 0x60d7, 0x613d, 0x5ce5, 0x3989, 0x61b7, 0x61b9,
/* 08 */ 0x61cf, 0x39b8, 0x622c, 0x6290, 0x62e5, 0x6318, 0x39f8, 0x56b1,
/* 10 */ 0x3a03, 0x63e2, 0x63fb, 0x6407, 0x645a, 0x3a4b, 0x64c0, 0x5d15,
/* 18 */ 0x5621, 0x9f9f, 0x3a97, 0x6586, 0x3abd, 0x65ff, 0x6653, 0x3af2,
/* 20 */ 0x6692, 0x3b22, 0x6716, 0x3b42, 0x67a4, 0x6800, 0x3b58, 0x684a,
/* 28 */ 0x6884, 0x3b72, 0x3b71, 0x3b7b, 0x6909, 0x6943, 0x725c, 0x6964,
/* 30 */ 0x699f, 0x6985, 0x3bbc, 0x69d6, 0x3bdd, 0x6a65, 0x6a74, 0x6a71,
/* 38 */ 0x6a82, 0x3bec, 0x6a99, 0x3bf2, 0x6aab, 0x6ab5, 0x6ad4, 0x6af6
},

/* Row 0x0f4 */
{
/* 00 */ 0x48ad, 0x98e0, 0x9213, 0x491e, 0x9228, 0x9258, 0x926b, 0x92b1,
/* 08 */ 0x92ae, 0x92bf, 0x92e3, 0x92eb, 0x92f3, 0x92f4, 0x92fd, 0x9343,
/* 10 */ 0x9384, 0x93ad, 0x4945, 0x4951, 0x9ebf, 0x9417, 0x5301, 0x941d,
/* 18 */ 0x942d, 0x943e, 0x496a, 0x9454, 0x9479, 0x952d, 0x95a2, 0x49a7,
/* 20 */ 0x95f4, 0x9633, 0x49e5, 0x67a0, 0x4a24, 0x9740, 0x4a35, 0x97b2,
/* 28 */ 0x97c2, 0x5654, 0x4ae4, 0x60e8, 0x98b9, 0x4b19, 0x98f1, 0x5844,
/* 30 */ 0x990e, 0x9919, 0x51b4, 0x991c, 0x9937, 0x9942, 0x995d, 0x9962,
/* 38 */ 0x4b70, 0x99c5, 0x4b9d, 0x9a3c, 0x9b0f, 0x7a83, 0x9b69, 0x9b81
}
};

/* Mapping table from BChinese to Unicode */

static cell4_t _zb_to_ucs_cell4[] = {
/* Row 0x800 */
{
/* 00 */ 0x9872, 0x995f, 0x9c68, 0x9c6e, 0x9c6d, 0x9e0b, 0x9e0d, 0x9e10,
/* 08 */ 0x9e0f, 0x9e12, 0x9e11, 0x9ea1, 0x9ef5, 0x9f09, 0x9f47, 0x9f78,
/* 10 */ 0x9f7b, 0x9f7a, 0x9f79, 0x571e, 0x7066, 0x7c6f, 0x883c, 0x8db2,
/* 18 */ 0x8ea6, 0x91c3, 0x9474, 0x9478, 0x9476, 0x9475, 0x9a60, 0x9c74,
/* 20 */ 0x9c73, 0x9c71, 0x9c75, 0x9e14, 0x9e13, 0x9ef6, 0x9f0a, 0x20547,
/* 28 */ 0x92db, 0x205df, 0xe003, 0x854c, 0x42b5, 0x73ef, 0x51b5, 0x3649,
/* 30 */ 0x24942, 0x289e4, 0x9344, 0x219db, 0x82ee, 0x23cc8, 0x783c, 0x6744,
/* 38 */ 0x62df, 0x24933, 0x289aa, 0x202a0, 0x26bb3, 0x21305, 0x4fab, 0xe018
},

/* Row 0x801 */
{
/* 00 */ 0x5008, 0x26d29, 0xe01b, 0x23600, 0x24ab1, 0x22513,    BAD, 0x2037e,
/* 08 */ 0x5fa4, 0x20380, 0x20347, 0x6edb, 0x2041f,    BAD, 0x5101, 0x347a,
/* 10 */ 0x510e, 0x986c, 0x3743, 0x8416, 0xe02d, 0x20487, 0x5160, 0x233b4,
/* 18 */ 0x516a, 0x20bff, 0x220fc, 0x202e5, 0x22530, 0x2058e, 0x23233, 0xe038,
/* 20 */ 0x5b82, 0x877d, 0x205b3, 0x23c99, 0x51b2, 0x51b8, 0x289bc, 0x22698,
/* 28 */ 0x5547, 0x4ced, 0x542f, 0x7417, 0x5586, 0x55a9,    BAD, 0x218d7,
/* 30 */ 0x2403a, 0x4552, 0x24435, 0x66b3, 0x210b4, 0x5637, 0x66cd, 0x2328a,
/* 38 */ 0x66a4, 0x66ad, 0x564d, 0x564f, 0x78f1, 0x56f1, 0x9787, 0x53fe
},

/* Row 0x802 */
{
/* 00 */ 0x5700, 0x56ef, 0x56ed, 0x28b66, 0x3623, 0x2124f, 0x5746, 0x241a5,
/* 08 */ 0x6c6e, 0x708b, 0x5742, 0x36b1, 0x26c7e, 0x57e6, 0xe0c5, 0x5803,
/* 10 */ 0x21454, 0x24363, 0x5826, 0x24bf5, 0x585c, 0x58aa, 0x3561, 0x58e0,
/* 18 */ 0x58dc, 0xe0d0, 0x58fb, 0x5bff, 0x5743, 0x2a150, 0x24278, 0x93d3,
/* 20 */ 0x35a1, 0x591f, 0x68a6, 0x36c3, 0x6e59, 0x5ef9, 0x5efb, 0x38a0,
/* 28 */ 0x5efc, 0x683e, 0x941b, 0x5f0d, 0x201c1, 0x2f894, 0x3ade, 0x48ae,
/* 30 */ 0x2133a, 0x5f3a, 0x26888, 0x223d0,    BAD, 0x22471, 0x5f63, 0x97bd,
/* 38 */ 0x26e6e, 0x5f72, 0x9340, 0xe150, 0x5fa7, 0x5db6, 0x3d5f, 0xe154
},

/* Row 0x803 */
{
/* 00 */ 0x21f6a, 0x270f8, 0x22668, 0x91d6, 0x2029e, 0x28a29, 0x6031, 0x6685,
/* 08 */ 0xe15d, 0x3963, 0x3dc7, 0x3639, 0x5790, 0x227b4, 0x7971, 0x3e40,
/* 10 */ 0x609e,    BAD, 0x60b3, 0xe168, 0x2498f, 0xe16a, 0x74a4, 0x50e1,
/* 18 */ 0x5aa0, 0x6164, 0x8424, 0x6142, 0xe171, 0x26ed2, 0x6181, 0x51f4,
/* 20 */ 0xe175, 0x6187, 0x5baa, 0x23fb7, 0xe1d7, 0x69e1, 0x6a0b, 0x28adf,
/* 28 */ 0x6973, 0x68c3, 0x235cd, 0x6901, 0x6900, 0x3d32, 0x3a01, 0x2363c,
/* 30 */ 0x3b80, 0x67ac, 0x6961, 0x28a4a, 0x42fc, 0x6936, 0x6998, 0x3ba1,
/* 38 */ 0x203c9, 0x8363, 0x5090, 0x69f9, 0xe1ef, 0x2212a, 0x6a45, 0xe1f2
},

/* Row 0x804 */
{
/* 00 */ 0x6a9d, 0x3bf3, 0x67b1, 0x6ac8, 0x2919c, 0x3c0d, 0x6b1d, 0xe1fa,
/* 08 */ 0x60de, 0x6b35, 0x6b74, 0xe1fe, 0x6eb5, 0x23adb, 0x203b5, 0xe202,
/* 10 */ 0x3740, 0x5421, 0x23b5a, 0x6be1, 0x23efc, 0x6bdc, 0x6c37, 0x2248b,
/* 18 */ 0xe20b, 0x26b51, 0x6c5a, 0x8226, 0x6c79, 0x23dbc, 0x44c5, 0x23dbd,
/* 20 */ 0x241a4, 0x2490c, 0x24900, 0x9442, 0x7215, 0x5911, 0x9443, 0x7224,
/* 28 */ 0x9341, 0xe27a, 0x722e, 0x7240, 0x24974, 0x68bd, 0x7255, 0x7257,
/* 30 */ 0x3e55, 0xe282, 0x680d, 0x6f3d, 0x7282,    BAD, 0x732b, 0x24823,
/* 38 */ 0x2882b, 0x48ed, 0x28804, 0x7328, 0x732e, 0x73cf, 0x73aa, 0xe290
},

/* Row 0x805 */
{
/* 00 */ 0x26a2e, 0x73c9, 0x7449, 0x241e2, 0x216e7, 0x24a24, 0x6623, 0x36c5,
/* 08 */ 0x249b7, 0x2498d, 0xe29b, 0x73f7, 0x7415, 0x6903, 0x24a26, 0x7439,
/* 10 */ 0xe2a1, 0x3ed7,    BAD, 0x228ad, 0x7460, 0x28eb2, 0x7447, 0x73e4,
/* 18 */ 0x7476, 0x83b9, 0x746c, 0x3730, 0x7474, 0x93f1, 0x6a2c, 0x7482,
/* 20 */ 0x4953, 0xe2b2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x806 */
{
/* 00 */ 0x706a, 0x9ea4, 0x9f7e, 0x9f49, 0x9f98, 0x7881, 0x92b9, 0x88cf,
/* 08 */ 0x58bb, 0x6052, 0x7ca7, 0x5afa, 0x2554, 0x2566, 0x2557, 0x2560,
/* 10 */ 0x256c, 0x2563, 0x255a, 0x2569, 0x255d, 0x2552, 0x2564, 0x2555,
/* 18 */ 0x255e, 0x256a, 0x2561, 0x2558, 0x2567, 0x255b, 0x2553, 0x2565,
/* 20 */ 0x2556, 0x255f, 0x256b, 0x2562, 0x2559, 0x2568, 0x255c, 0x2551,
/* 28 */ 0x2550, 0x256d, 0x256e, 0x2570, 0x256f, 0xffed, 0x9d34, 0x51c9,
/* 30 */ 0x51cf, 0x51d1, 0x3cdc, 0x51d3, 0x24aa6, 0x51b3, 0x51e2, 0x5342,
/* 38 */ 0x51ed, 0x83cd, 0x693e, 0xe04c, 0x5f7b, 0x520b, 0x5226, 0x523c
},

/* Row 0x807 */
{
/* 00 */ 0x52b5, 0x5257, 0x5294, 0x52b9, 0x52c5, 0x7c15, 0x8542, 0x52e0,
/* 08 */ 0x860d, 0xe05a,    BAD, 0x28ade, 0x5549, 0x6ed9, 0x23f80, 0x20954,
/* 10 */ 0x23fec, 0x5333,    BAD, 0x20be2, 0x6ccb, 0x21726, 0x681b, 0x73d5,
/* 18 */ 0x604a, 0x3eaa, 0x38cc, 0x216e8, 0x71dd, 0x44a2, 0x536d, 0x5374,
/* 20 */ 0x286ab, 0x537e,    BAD, 0x21596, 0x21613, 0x77e6, 0x5393, 0x28a9b,
/* 28 */ 0x53a0, 0x53ab, 0x53ae, 0x73a7, 0x25772, 0x3f59, 0x739c, 0x53c1,
/* 30 */ 0x53c5, 0x6c49, 0x4e49, 0x57fe, 0x53d9, 0x3aab, 0x20b8f, 0x53e0,
/* 38 */ 0x23feb, 0x22da3, 0x53f6, 0x20c77, 0x5413, 0x7079, 0x552b, 0x6657
},

/* Row 0x808 */
{
/* 00 */ 0x6d5b, 0x546d, 0x26b53, 0xe094, 0x555d, 0x548f, 0x54a4, 0x47a6,
/* 08 */ 0xe099, 0xe09a, 0x3db4, 0x20d4d, 0x2163e, 0x5a24, 0x5553, 0x21692,
/* 10 */ 0x8505, 0x59c9, 0x20d4e, 0x26c81, 0x26d2a, 0x217dc, 0x59d9, 0x217fb,
/* 18 */ 0x217b2, 0x26da6, 0x6d71, 0x21828, 0x216d5, 0x59f9, 0x26e45, 0x5aab,
/* 20 */ 0x5a63, 0x36e6, 0xe0f2,    BAD, 0x3708, 0x5a96, 0x7465, 0x5ad3,
/* 28 */ 0x26fa1, 0xe0f9, 0x3d85, 0x21911, 0x3732, 0xe0fd, 0x5e83, 0x52d0,
/* 30 */ 0x5b76, 0x6588, 0x5b7c, 0x27a0e, 0x4004, 0x485d, 0xe106, 0x5bd5,
/* 38 */ 0x6160, 0xe109, 0xe10a, 0x205a5, 0x5bf3, 0x5b9d, 0x4d10, 0x5c05
},

/* Row 0x809 */
{
/* 00 */ 0x21b44, 0x5c13, 0x73ce, 0x5c14, 0x21ca5, 0x26b28, 0x5c49, 0x48dd,
/* 08 */ 0x5c85, 0x5ce9, 0x5cef, 0x5d8b, 0x21df9, 0x21e37, 0x5d10, 0x5d18,
/* 10 */ 0x5d46, 0x21ea4, 0x5cba, 0x5dd7, 0x82fc, 0x382d, 0x24901, 0x22049,
/* 18 */ 0x22173, 0x8287, 0x3836, 0x3bc2, 0x5e2e, 0x6a8a,    BAD, 0x5e7a,
/* 20 */ 0xe130, 0x20cd3, 0x53a6, 0x4eb7,    BAD, 0x53a8, 0x21771, 0x5e09,
/* 28 */ 0x5ef4, 0x28482, 0x2285f, 0x61d3, 0x28b9d, 0x2995d, 0x61d0, 0x3932,
/* 30 */ 0x22980, 0x228c1, 0x6023, 0x615c, 0x651e, 0x638b, 0x20118, 0x62c5,
/* 38 */ 0x21770, 0x62d5, 0x22e0d, 0x636c, 0x249df, 0x3a17, 0x6438, 0x63f8
},

/* Row 0x80a */
{
/* 00 */ 0xe18f, 0x217fc,    BAD, 0x6f8a, 0x22e36, 0x9814, 0x2408c, 0x2571d,
/* 08 */ 0x64e1, 0x64e5, 0x947b, 0x3a66, 0x643a, 0x3a57, 0x654d, 0x6f16,
/* 10 */ 0x24a28, 0x24a23, 0x6585, 0x656d, 0x655f, 0x2307e, 0x65b5, 0x24940,
/* 18 */ 0x4b37, 0x65d1, 0x40d8, 0x21829, 0x65e0, 0x65e3, 0x5fdf, 0x23400,
/* 20 */ 0x6618, 0x231f7, 0x231f8, 0x6644, 0x231a4, 0x231a5, 0x664b, 0x20e75,
/* 28 */ 0x6667, 0x251e6, 0x6673,    BAD, 0xe1bb, 0x23231, 0x285f4, 0x231c8,
/* 30 */ 0x25313, 0x77c5, 0x228f7, 0x99a4, 0x6702, 0x2439c, 0x24a21, 0x3b2b,
/* 38 */ 0x69fa, 0x237c2,    BAD, 0x6767, 0x6762, 0xe1cc, 0xe1cd, 0x67d7
},

/* Row 0x80b */
{
/* 00 */ 0x44e9, 0x6822, 0x6e50, 0x923c, 0x6801, 0x233e6, 0x26da0, 0x685d,
/* 08 */ 0x23cc9, 0x36e5, 0x3ceb, 0xe219, 0x9b83, 0x231f9, 0xe21c, 0x7f8f,
/* 10 */ 0x6837, 0x26d25, 0x26da1, 0x26deb, 0x6d96, 0x6d5c, 0x6e7c, 0x6f04,
/* 18 */ 0x2497f, 0xe227, 0x26e72, 0x8533, 0x26f74, 0x51c7,    BAD,    BAD,
/* 20 */ 0x842e, 0x28b21,    BAD, 0x23e2f, 0x7453, 0x23f82, 0x79cc, 0x6e4f,
/* 28 */ 0x5a91, 0x2304b, 0x6ff8, 0x370d, 0x6f9d, 0x23e30, 0x6efa, 0x21497,
/* 30 */ 0x2403d, 0x4555, 0x93f0, 0x6f44, 0x6f5c, 0x3d4e, 0x6f74, 0xe245,
/* 38 */ 0x3d3b, 0x6f9f, 0x24144, 0x6fd3, 0xe24a, 0x24155, 0x24039, 0x25d20
},

/* Row 0x80c */
{
/* 00 */ 0xe24e, 0x2413f, 0x51df, 0x24156, 0x24157, 0x24140, 0x261dd, 0x704b,
/* 08 */ 0x707e, 0x70a7, 0x7081, 0x70cc, 0x70d5, 0x70d6, 0x70df, 0x4104,
/* 10 */ 0x3de8, 0x71b4, 0x7196, 0x24277, 0x712b, 0x7145, 0x5a88, 0x714a,
/* 18 */    BAD, 0x5c9c, 0x24365, 0x714f, 0x9362, 0xe26b, 0x712c, 0x2445a,
/* 20 */ 0x24a27, 0x24a22, 0x71ba, 0x28be8, 0x70bd, 0x720e, 0x2415f, 0x24a79,
/* 28 */ 0x28b8f, 0x5b46, 0xe2b7, 0x2189e, 0x74c8, 0x21988, 0x750e,    BAD,
/* 30 */ 0x751e, 0x28ed9, 0x21a4b, 0x5bd7, 0xe2c1, 0x9385, 0x754d, 0x754a,
/* 38 */ 0x7567, 0x756e, 0x24f82, 0x3f04, 0xe2c9, 0x758e, 0x745d, 0x759e
},

/* Row 0x80d */
{
/* 00 */ 0x75b4, 0x7602, 0x762c, 0x7651, 0x764f, 0x766f, 0x7676, 0xe2d4,
/* 08 */ 0x7690, 0x81ef, 0x37f8, 0x26911, 0x2690e, 0x76a1, 0x76a5, 0x76b7,
/* 10 */ 0x76cc, 0x26f9f, 0x8462, 0x2509d, 0x2517d, 0xe2e2, 0x771e, 0x7726,
/* 18 */ 0x7740, 0x64af, 0x25220, 0x7758, 0x232ac, 0x77af, 0xe2eb, 0xe2ec,
/* 20 */ 0x216c1, 0x77f4,    BAD, 0xe2f0, 0xe2f1, 0x68ca, 0x78af, 0x78c7,
/* 28 */ 0x78d3, 0x96a5, 0x792e, 0x255e0, 0x78d7, 0x7934, 0x78b1, 0x2760c,
/* 30 */ 0x8fb8, 0x8884, 0x28b2b, 0xe300, 0x2261c, 0x7986, 0x8900, 0x6902,
/* 38 */ 0x7980, 0x25857, 0x799d, 0x27b39, 0x793c, 0x79a9, 0x6e2a, 0x27126
},

/* Row 0x80e */
{
/* 00 */ 0x3ea8, 0x79c6, 0x2910d, 0x79d4,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x80f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x2a3a9, 0xf3a1,    BAD,
/* 20 */ 0x650a,    BAD,    BAD, 0x4e3d, 0x6edd, 0x9d4e, 0x91df,    BAD,
/* 28 */    BAD, 0x27735, 0x6491, 0x4f1a, 0x4f28, 0x4fa8, 0x5156, 0x5174,
/* 30 */ 0x519c, 0x51e4, 0x52a1, 0x52a8, 0x533b, 0x534e, 0x53d1, 0x53d8,
/* 38 */ 0x56e2, 0x58f0, 0x5904, 0x5907, 0x5932, 0x5934, 0x5b66, 0x5b9e
},

/* Row 0x810 */
{
/* 00 */ 0x5b9f, 0x5c9a, 0x5e86, 0x603b, 0x6589, 0x67fe, 0x6804, 0x6865,
/* 08 */ 0x6d4e, 0x70bc, 0x7535, 0x7ea4, 0x7eac, 0x7eba, 0x7ec7, 0x7ecf,
/* 10 */ 0x7edf, 0x7f06, 0x7f37, 0x827a, 0x82cf, 0x836f, 0x89c6, 0x8bbe,
/* 18 */ 0x8be2, 0x8f66, 0x8f67, 0x8f6e, 0x7411, 0x7cfc, 0x7dcd, 0x6946,
/* 20 */ 0x7ac9, 0x5227,    BAD,    BAD,    BAD,    BAD, 0x918c, 0x78b8,
/* 28 */ 0x915e, 0x80bc,    BAD, 0x8d0b, 0x80f6, 0xf3f0,    BAD,    BAD,
/* 30 */ 0x809f, 0x9ec7, 0x4ccd, 0x9dc9, 0x9e0c, 0x4c3e, 0xf3f9, 0x2700e,
/* 38 */ 0x9e0a, 0xf3fc, 0x35c1,    BAD, 0x6e9a, 0x823e, 0x7519,    BAD
},

/* Row 0x811 */
{
/* 00 */ 0x4911, 0x9a6c, 0x9a8f, 0x9f99, 0x7987, 0xf408, 0x21dca, 0x205d0,
/* 08 */ 0xf40b, 0x4e24, 0x4e81, 0x4e80, 0x4e87, 0x4ebf, 0x4eeb, 0x4f37,
/* 10 */ 0x344c, 0x4fbd, 0x3e48, 0x5003, 0x5088, 0x347d, 0x3493, 0x34a5,
/* 18 */ 0x5186, 0x5905, 0x51db, 0x51fc, 0x5205, 0x4e89, 0x5279, 0x5290,
/* 20 */ 0x5327, 0x35c7, 0x53a9, 0x3551, 0x53b0, 0x3553, 0x53c2, 0x5423,
/* 28 */ 0x356d, 0x3572, 0x3681, 0x5493, 0x54a3, 0x54b4, 0x54b9, 0x54d0,
/* 30 */ 0x54ef, 0x5518, 0x5523, 0x5528, 0x3598, 0x553f, 0x35a5, 0x35bf,
/* 38 */ 0x55d7, 0x35c5, 0xf43d, 0x5525,    BAD, 0x20c42, 0xf441, 0xf442
},

/* Row 0x812 */
{
/* 00 */ 0x5590, 0x22cc6, 0x39ec, 0x20341, 0x8e46, 0x24db8, 0xf449, 0x4053,
/* 08 */ 0x280be, 0x777a, 0xf44d, 0x3a34, 0x47d5, 0xf450, 0x269f2, 0x24dea,
/* 10 */ 0x64dd, 0xf454, 0x20fb4, 0x20cd5, 0x210f4, 0x648d, 0x8e7e, 0xf45a,
/* 18 */ 0xf45b, 0xf45c, 0xf45d, 0x28256, 0x244d3,    BAD, 0x20d46, 0xf462,
/* 20 */ 0x280e9, 0x47f4, 0xf465, 0xf466, 0x9ab2, 0x3a67, 0xf469, 0x3fed,
/* 28 */ 0x3506, 0x252c7, 0xf46d, 0xf46e, 0xf46f, 0x9d6e, 0x9815,    BAD,
/* 30 */ 0x43d9, 0x260a5, 0x64b4, 0x54e3, 0xf477, 0xf478, 0x21077, 0x39fb,
/* 38 */ 0x2106f, 0xf47c, 0xf47d, 0xf47e, 0x64ea, 0xf480, 0x20c43, 0x8e68
},

/* Row 0x813 */
{
/* 00 */ 0x221a1, 0x28b4c, 0xf485,    BAD, 0x480b, 0xf488, 0x3ffa, 0x5873,
/* 08 */ 0xf48b,    BAD, 0xf48d, 0x204fc, 0xf48f, 0xf490, 0xf491, 0x5579,
/* 10 */ 0x40bb, 0x43ba,    BAD, 0x4ab4, 0xf497, 0xf498, 0x81aa, 0x98f5,
/* 18 */ 0xf49b, 0x6379, 0x39fe, 0x22775, 0x8dc0, 0x56a1, 0x647c, 0x3e43,
/* 20 */    BAD, 0xf4a4, 0x20e09, 0x22acf, 0xf4a7,    BAD, 0x210c8, 0xf4aa,
/* 28 */ 0x3992, 0x3a06, 0xf4ad, 0x3578, 0xf4af, 0x220c7, 0x5652, 0x20f31,
/* 30 */ 0xf4b3, 0xf4b4, 0x34bc, 0x6c3d, 0xf4b7,    BAD,    BAD, 0xf4ba,
/* 38 */ 0xf4bb, 0xf4bc, 0xf4bd, 0x28ccd, 0x20e7a, 0xf4c0, 0xf4c1, 0x7f93
},

/* Row 0x814 */
{
/* 00 */ 0xf4c3, 0x22803, 0x22939, 0x35fb, 0x251e3, 0xf4c8, 0x20f8d, 0x20eaa,
/* 08 */ 0x3f93, 0x20f30, 0x20d47, 0xf4ce, 0xf4cf,    BAD, 0x20eab, 0xf4d2,
/* 10 */ 0x20d48, 0x210c0, 0x2113d, 0x3ff9, 0x22696, 0x6432, 0x20fad, 0x233f4,
/* 18 */ 0x27639, 0x22bce, 0x20d7e, 0x20d7f, 0x22c51, 0x22c55, 0x3a18, 0xf4e2,
/* 20 */ 0x210c7, 0x20f2e, 0xf4e5, 0x26b50, 0xf4e7, 0xf4e8, 0xf4e9, 0x95aa,
/* 28 */ 0x54cc, 0x82c4, 0x55b9,    BAD, 0x29ec3, 0x9c26, 0x9ab6, 0x2775e,
/* 30 */ 0xf4f3, 0x7140, 0x816d, 0x80ec, 0x5c1c, 0x26572, 0x8134, 0x3797,
/* 38 */ 0x535f, 0x280bd, 0x91b6, 0x20efa, 0x20e0f, 0x20e77, 0x20efb, 0x35dd
},

/* Row 0x815 */
{
/* 00 */ 0x24deb, 0x3609, 0x20cd6, 0x56af, 0x227b5, 0x210c9, 0x20e10, 0x20e78,
/* 08 */ 0x21078, 0x21148, 0x28207, 0x21455, 0x20e79, 0x24e50, 0x22da4, 0x5a54,
/* 10 */ 0x2101d, 0x2101e, 0x210f5, 0x210f6, 0x579c, 0x20e11, 0x27694, 0x282cd,
/* 18 */ 0x20fb5, 0x20e7b, 0x2517e, 0x3703, 0x20fb6, 0x21180, 0x252d8, 0xf522,
/* 20 */ 0xf523, 0x2183a, 0xf525, 0xf526, 0x5899, 0x5268, 0x361a, 0xf52a,
/* 28 */ 0x7bb2, 0x5b68, 0x4800, 0x4b2c, 0x9f27, 0x49e7, 0x9c1f, 0x9b8d,
/* 30 */ 0x25b74, 0x2313d, 0x55fb, 0x35f2, 0x5689, 0x4e28, 0x5902, 0xf53a,
/* 38 */ 0xf53b, 0x9751, 0xf53d, 0x4e5b, 0x4ebb, 0x353e, 0x5c23, 0x5f51
},

/* Row 0x816 */
{
/* 00 */ 0x6b81, 0x6bc1, 0x6bea, 0x6c75, 0x6caa, 0x3ccb, 0x6d02, 0x6d06,
/* 08 */ 0x6d26, 0x6d81, 0x3cef, 0x6da4, 0x6db1, 0x6e15, 0x6e18, 0x6e29,
/* 10 */ 0x6e86, 0x289c0, 0x6ebb, 0x6ee2, 0x6eda, 0x9f7f, 0x6ee8, 0x6ee9,
/* 18 */ 0x6f24, 0x6f34, 0x3d46, 0x23f41, 0x6f81, 0x6fbe, 0x3d6a, 0x3d75,
/* 20 */ 0x71b7, 0x5c99, 0x3d8a, 0x702c, 0x3d91, 0x7050, 0x7054, 0x706f,
/* 28 */ 0x707f, 0x7089, 0x20325, 0x43c1, 0x35f1, 0xf6b0, 0xe311, 0x57be,
/* 30 */ 0x26ed3, 0x713e, 0x257e0, 0x364e, 0x69a2, 0x28be9, 0x5b74, 0x7a49,
/* 38 */ 0x258e1, 0x294d9, 0x7a65, 0x7a7d, 0x259ac, 0x7abb, 0x7ab0, 0x7ac2
},

/* Row 0x817 */
{
/* 00 */ 0x7ac3, 0x71d1, 0xe325, 0x41ca, 0x7ada, 0x7add, 0x7aea, 0x41ef,
/* 08 */ 0x54b2, 0x25c01, 0x7b0b, 0x7b55, 0x7b29, 0xe330, 0x25cfe, 0x7ba2,
/* 10 */ 0x7b6f, 0x839c, 0x25bb4, 0x26c7f, 0x7bd0, 0x8421, 0x7b92,    BAD,
/* 18 */ 0x23ff0, 0x3dad, 0x25c65, 0x8492, 0x7bfa,    BAD, 0x7c35, 0x25cc1,
/* 20 */ 0x7c44, 0x7c83, 0xe345, 0x7ca6, 0x667d, 0x24578, 0x7cc9, 0x7cc7,
/* 28 */ 0x7ce6, 0x7c74, 0x7cf3, 0x7cf5,    BAD, 0x7e67, 0x451d, 0x26e44,
/* 30 */ 0x7d5d, 0x26ed6, 0x748d, 0x7d89, 0x7dab, 0x7135, 0x7db3,    BAD,
/* 38 */ 0x24057, 0x26029, 0x7de4, 0x3d13, 0x7df5, 0x217f9, 0x7de5, 0xe362
},

/* Row 0x818 */
{
/* 00 */    BAD, 0x26121, 0x2615a, 0x7e6e, 0x7e92, 0x432b, 0x946c, 0x7e27,
/* 08 */ 0x7f40, 0x7f41, 0x7f47, 0x7936, 0x262d0, 0x99e1, 0x7f97, 0x26351,
/* 10 */ 0x7fa3, 0x21661, 0x20068, 0x455c, 0x23766, 0x4503, 0x2833a, 0x7ffa,
/* 18 */ 0x26489,    BAD, 0x8008, 0x801d,    BAD, 0x802f, 0xe381, 0xe382,
/* 20 */ 0x803b, 0x803c, 0x8061, 0xe386, 0x4989, 0x26626, 0xe389, 0x266e8,
/* 28 */ 0x6725, 0x80a7, 0x28a48, 0x8107, 0x811a, 0x58b0, 0x226f6, 0x6c7f,
/* 30 */ 0x26498, 0xe394, 0x64e7, 0xe396, 0x8218, 0x2185e, 0x6a53, 0x24a65,
/* 38 */ 0x24a95, 0x447a, 0x8229, 0xe39e, 0x26a52, 0xe3a0, 0x4ff9, 0x214fd
},

/* Row 0x819 */
{
/* 00 */ 0x84e2, 0x8362, 0x26b0a, 0x249a7, 0x23530, 0x21773, 0x23df8, 0x82aa,
/* 08 */ 0x691b, 0x2f994, 0x41db, 0x854b, 0x82d0, 0x831a, 0x20e16, 0x217b4,
/* 10 */ 0x36c1, 0xe3b4, 0x2355a, 0x827b, 0x82e2, 0x8318, 0x23e8b, 0x26da3,
/* 18 */ 0xe3bb, 0x26b97, 0x235ce, 0x3dbf, 0x831d, 0x55ec, 0x8385, 0x450b,
/* 20 */ 0x26da5, 0x83ac,    BAD, 0x83d3, 0x347e, 0x26ed4, 0x6a57, 0x855a,
/* 28 */ 0x3496, 0x26e42, 0xe3cd, 0x8458, 0xe3cf, 0x8471, 0x3dd3, 0x44e4,
/* 30 */ 0x6aa7, 0x844a, 0xe3d5, 0x7958,    BAD, 0x26b96, 0x26e77, 0x26e43,
/* 38 */ 0x84de,    BAD, 0x8391, 0x44a0, 0x8493, 0x84e4, 0xe3e1, 0x4240
},

/* Row 0x81a */
{
/* 00 */ 0x25cc0, 0x4543, 0x8534, 0x5af2, 0xe3e7, 0x4527, 0x8573, 0x4516,
/* 08 */ 0x67bf, 0x8616, 0x28625, 0x2863b, 0x85c1, 0xe3f0, 0x8602, 0xe3f2,
/* 10 */ 0x270cd, 0xe3f4, 0x456a, 0x8628, 0x3648, 0x218a2, 0x53f7, 0x2739a,
/* 18 */ 0x867e, 0x8771, 0x2a0f8, 0x87ee, 0x22c27, 0x87b1, 0x87da, 0x880f,
/* 20 */ 0x5661, 0x866c, 0x6856, 0x460f, 0x8845, 0x8846, 0x275e0, 0x23db9,
/* 28 */ 0x275e4, 0x885e, 0x889c, 0x465b, 0x88b4, 0x88b5, 0x63c1, 0x88c5,
/* 30 */ 0x7777, 0x2770f, 0x8987, 0x898a,    BAD,    BAD, 0x89a7, 0x89bc,
/* 38 */ 0x28a25, 0x89e7, 0x27924, 0x27abd, 0x8a9c, 0x7793, 0x91fe, 0x8a90
},

/* Row 0x81b */
{
/* 00 */ 0x27a59, 0x7ae9, 0x27b3a, 0xe426, 0x4713, 0x27b38, 0x717c, 0x8b0c,
/* 08 */ 0x8b1f, 0x25430, 0x25565, 0x8b3f, 0x8b4c, 0x8b4d, 0x8aa9, 0x24a7a,
/* 10 */ 0x8b90, 0x8b9b, 0x8aaf, 0xe436, 0x4615, 0x884f, 0x8c9b, 0x27d54,
/* 18 */ 0x27d8f, 0x2f9d4, 0x3725, 0x27d53, 0x8cd6, 0x27d98, 0x27dbd, 0x8d12,
/* 20 */ 0x8d03, 0x21910, 0x8cdb, 0x705c, 0x8d11, 0xe448, 0x3ed0,    BAD,
/* 28 */ 0x8da9, 0x28002, 0xe44d, 0x2498a, 0x3b7c, 0xe450, 0x2710c, 0x7ae7,
/* 30 */ 0x8ead, 0x8eb6, 0x8ec3, 0x92d4, 0x8f19, 0x8f2d, 0x28365, 0x28412,
/* 38 */ 0x8fa5, 0x9303, 0x2a29f, 0x20a50, 0x8fb3, 0x492a, 0x289de, 0x2853d
},

/* Row 0x81c */
{
/* 00 */ 0x23dbb, 0x5ef8, 0x23262, 0x8ff9, 0xe467, 0xe468, 0xe469, 0x22325,
/* 08 */ 0x3980, 0x26ed7, 0x9037, 0x2853c, 0x27abe, 0x9061, 0x2856c, 0x2860b,
/* 10 */ 0x90a8, 0xe474, 0x90c4, 0x286e6, 0x90ae,    BAD, 0x9167, 0x3af0,
/* 18 */ 0x91a9, 0x91c4, 0x7cac, 0x28933, 0x21e89, 0x920e, 0x6c9f, 0x9241,
/* 20 */ 0x9262, 0x255b9,    BAD, 0x28ac6, 0x23c9b, 0x28b0c, 0x255db, 0xe48a,
/* 28 */ 0x932c, 0x936b, 0x28ae1, 0x28beb, 0x708f, 0x5ac3, 0x28ae2, 0x28ae5,
/* 30 */ 0x4965, 0x9244, 0x28bec, 0x28c39, 0x28bff, 0x9373, 0x945b, 0x8ebc,
/* 38 */ 0x9585, 0x95a6, 0x9426, 0x95a0, 0x6ff6, 0x42b9, 0xe4a1, 0x286d8
},

/* Row 0x81d */
{
/* 00 */ 0x2127c, 0x23e2e, 0x49df, 0x6c1c, 0x967b, 0x9696, 0x416c, 0x96a3,
/* 08 */ 0x26ed5, 0x61da, 0x96b6, 0x78f5, 0x28ae0, 0x96bd, 0x53cc, 0x49a1,
/* 10 */ 0x26cb8, 0x20274, 0x26410, 0x290af, 0x290e5, 0x24ad1, 0x21915, 0x2330a,
/* 18 */ 0x9731, 0x8642, 0x9736, 0x4a0f, 0x453d, 0x4585, 0xe4c1, 0x7075,
/* 20 */ 0x5b41, 0x971b,    BAD, 0xe4c6, 0x9757, 0x5b4a, 0x291eb, 0x975f,
/* 28 */ 0x9425, 0x50d0, 0x230b7, 0x230bc, 0x9789, 0x979f, 0x97b1, 0x97be,
/* 30 */ 0x97c0, 0x97d2, 0x97e0, 0x2546c, 0x97ee, 0x741c, 0x29433,    BAD,
/* 38 */ 0x97f5, 0x2941d, 0xe4dd, 0x4ad1, 0x9834, 0x9833, 0x984b, 0x9866
},

/* Row 0x81e */
{
/* 00 */ 0x3b0e, 0x27175, 0x3d51, 0x20630, 0x2415c, 0x25706, 0x98ca, 0x98b7,
/* 08 */ 0x98c8, 0x98c7, 0x4aff, 0x26d27, 0x216d3, 0x55b0, 0x98e1, 0x98e6,
/* 10 */ 0x98ec, 0x9378, 0x9939, 0x24a29, 0x4b72, 0x29857, 0x29905, 0x99f5,
/* 18 */ 0x9a0c, 0x9a3b, 0x9a10, 0x9a58, 0x25725, 0x36c4, 0x290b1, 0x29bd5,
/* 20 */ 0x9ae0, 0x9ae2, 0x29b05, 0x9af4, 0x4c0e, 0x9b14, 0x9b2d, 0x28600,
/* 28 */ 0x5034, 0x9b34, 0x269a8, 0x38c3, 0x2307d, 0x9b50, 0x9b40, 0x29d3e,
/* 30 */ 0x5a45, 0x21863, 0x9b8e, 0x2424b, 0x9c02, 0x9bff, 0x9c0c, 0x29e68,
/* 38 */ 0x9dd4, 0x29fb7, 0x2a192, 0xe51e, 0x2a0e1, 0x2a123, 0x2a1df, 0x9d7e
},

/* Row 0x81f */
{
/* 00 */ 0x9d83, 0xe524, 0x9e0e, 0x6888, 0x9dc4, 0xe528, 0x2a193, 0x2a220,
/* 08 */ 0x2193b, 0x2a233, 0x9d39, 0xe52e, 0xe52f, 0x9e90, 0x9e95, 0x9e9e,
/* 10 */ 0x9ea2, 0x4d34, 0x9eaa, 0x9eaf, 0x24364, 0x9ec1, 0x3b60, 0x39e5,
/* 18 */ 0x3d1d, 0x4f32, 0x37be, 0x28c2b, 0x9f02, 0x9f08, 0x4b96, 0x9424,
/* 20 */ 0x26da2, 0x9f17,    BAD, 0x9f39, 0x569f, 0x568a, 0x9f45, 0x99b8,
/* 28 */ 0x2908b, 0x97f2, 0x847f, 0x9f62, 0x9f69, 0x7adc, 0x9f8e, 0x7216,
/* 30 */ 0x4bbe, 0x24975, 0x249bb, 0x7177, 0x249f8, 0x24348, 0x24a51, 0x739e,
/* 38 */ 0x28bda, 0x218fa, 0x799f, 0x2897e, 0x28e36, 0x9369, 0x93f3, 0x28a44
},

/* Row 0x820 */
{
/* 00 */ 0x92ec, 0x9381, 0x93cb, 0x2896c, 0x244b9, 0x7217, 0x3eeb, 0x7772,
/* 08 */ 0x7a43, 0x70d0, 0xe56d, 0x243f8, 0x717e, 0xe570, 0x70a3, 0x218be,
/* 10 */ 0x23599, 0x3ec7, 0x21885, 0x2542f, 0x217f8, 0x3722, 0x216fb, 0xe57a,
/* 18 */ 0x36e1, 0x21774, 0xe57d, 0x25f4b, 0x3723, 0x216c0, 0x575b, 0x24a25,
/* 20 */ 0x213fe, 0xe584, 0x213c6, 0x214b6, 0x8503, 0x236a6,    BAD, 0x8455,
/* 28 */ 0xe58b, 0x27165, 0x23e31, 0x2555c, 0x23efb, 0x27052, 0x44f4, 0x236ee,
/* 30 */ 0x2999d, 0x26f26, 0x67f9, 0x3733, 0x3c15, 0x3de7, 0x586c, 0xe59a,
/* 38 */ 0x6810, 0x4057, 0x2373f, 0xe59e, 0x2408b, 0xe5a0, 0x26c21, 0x54cb
},

/* Row 0x821 */
{
/* 00 */ 0x569e, 0x266b1, 0x5692, 0xe5a6, 0x20ba8, 0x20e0d, 0x93c6, 0xe5aa,
/* 08 */ 0x939c, 0x4ef8, 0x512b, 0x3819, 0x24436, 0x4ebc, 0x20465, 0x2037f,
/* 10 */ 0x4f4b, 0x4f8a, 0x25651, 0x5a68, 0x201ab, 0x203cb, 0x3999, 0x2030a,
/* 18 */ 0x20414, 0x3435, 0x4f29, 0x202c0, 0x28eb3, 0x20275, 0x8ada, 0xe5c2,
/* 20 */ 0x4e98, 0x50cd, 0x510d, 0x4fa2, 0x4f03, 0xe5c8, 0x23e8a, 0x4f42,
/* 28 */ 0x502e, 0x506c, 0x5081, 0x4fcc, 0x4fe5, 0x5058, 0x50fc,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x6e76, 0x23595, 0xe5d8, 0x23ebf, 0x6d72,
/* 38 */ 0x21884, 0x23e89, 0x51a8, 0x51c3, 0x205e0, 0x44dd, 0x204a3, 0x20492
},

/* Row 0x822 */
{
/* 00 */ 0x20491, 0x8d7a, 0x28a9c, 0x2070e, 0x5259, 0x52a4, 0x20873, 0x52e1,
/* 08 */    BAD, 0x467a, 0x718c, 0x2438c, 0x20c20, 0x249ac, 0xe5f1, 0x69d1,
/* 10 */ 0x20e1d,    BAD, 0x3ede, 0x7499, 0x7414, 0x7456, 0x7398, 0x4b8e,
/* 18 */ 0x24abc, 0x2408d, 0x53d0, 0x3584, 0x720f, 0x240c9, 0x55b4, 0x20345,
/* 20 */ 0x54cd, 0x20bc6, 0x571d, 0x925d, 0x96f4, 0x9366, 0x57dd, 0x578d,
/* 28 */ 0x577f, 0x363e, 0x58cb, 0x5a99, 0x28a46, 0x216fa, 0x2176f, 0x21710,
/* 30 */ 0x5a2c, 0x59b8, 0x928f, 0x5a7e, 0x5acf, 0x5a12, 0xe619, 0x219f3,
/* 38 */ 0x21861, 0xe61c, 0x36f5, 0x6d05, 0x7443, 0x5a21, 0x25e83, 0x5a81
},

/* Row 0x823 */
{
/* 00 */ 0x28bd7, 0x20413, 0x93e0, 0x748c, 0x21303, 0x7105, 0x4972, 0x9408,
/* 08 */ 0x289fb, 0x93bd, 0x37a0, 0x5c1e, 0x5c9e, 0x5e5e, 0x5e48, 0x21996,
/* 10 */ 0x2197c, 0x23aee, 0x5ecd, 0x5b4f, 0x21903, 0x21904, 0x3701, 0x218a0,
/* 18 */ 0x36dd, 0x216fe, 0x36d3, 0x812a, 0x28a47, 0x21dba, 0x23472, 0x289a8,
/* 20 */ 0x5f0c, 0x5f0e, 0x21927, 0xe646, 0x5a6b, 0x2173b, 0x5b44, 0x8614,
/* 28 */ 0x275fd, 0x8860, 0x607e, 0x22860, 0x2262b, 0x5fdb, 0x3eb8, 0x225af,
/* 30 */ 0x225be, 0xe654, 0x26f73, 0x61c0, 0x2003e, 0x20046, 0x2261b, 0x6199,
/* 38 */ 0x6198, 0x6075, 0x22c9b, 0x22d07, 0x246d4, 0xe660, 0x6471, 0x24665
},

/* Row 0x824 */
{
/* 00 */ 0x22b6a, 0x3a29, 0x22b22, 0x23450, 0x298ea, 0x22e78, 0x6337, 0xe66a,
/* 08 */ 0x64b6, 0x6331, 0x63d1, 0x249e3, 0x22d67, 0x62a4, 0x22ca1, 0x643b,
/* 10 */ 0x656b, 0x6972, 0x3bf4, 0x2308e, 0x232ad, 0x24989, 0x232ab, 0x550d,
/* 18 */ 0x232e0, 0x218d9, 0xe67d, 0x66ce, 0x23289, 0xe680, 0x3ae0, 0x4190,
/* 20 */ 0x25584, 0x28b22, 0x2558f, 0x216fc, 0x2555b, 0x25425, 0x78ee, 0x23103,
/* 28 */ 0x2182a, 0x23234, 0x3464, 0xe68e, 0x23182, 0x242c9, 0x668e, 0x26d24,
/* 30 */ 0x666b, 0x4b93, 0x6630, 0x27870, 0xe697, 0x6663, 0x232d2, 0x232e1,
/* 38 */ 0x661e, 0x25872, 0x38d1, 0xe69e, 0x237bc, 0x3b99, 0x237a2, 0x233fe
},

/* Row 0x825 */
{
/* 00 */ 0x74d0, 0x3b96, 0x678f, 0x2462a, 0x68b6, 0x681e, 0x3bc4, 0x6abe,
/* 08 */ 0x3863, 0x237d5, 0x24487, 0x6a33, 0x6a52, 0x6ac9, 0x6b05, 0x21912,
/* 10 */ 0x6511, 0x6898, 0x6a4c, 0x3bd7, 0x6a7a, 0x6b57, 0x23fc0, 0x23c9a,
/* 18 */ 0x93a0, 0x92f2, 0x28bea, 0x28acb, 0x9289, 0xe6c0, 0x289dc, 0x9467,
/* 20 */ 0x6da5, 0x6f0b, 0xe6c5,    BAD, 0x23f7f, 0x3d8f, 0x6e04, 0x2403c,
/* 28 */ 0x5a3d, 0x6e0a, 0x5847, 0x6d24, 0x7842, 0x713b, 0x2431a, 0x24276,
/* 30 */ 0x70f1, 0x7250, 0x7287, 0x7294, 0x2478f, 0x24725, 0x5179, 0x24aa4,
/* 38 */ 0x205eb, 0x747a, 0x23ef8, 0xe6de, 0xe6df, 0x24917, 0x25fe1, 0x3f06
},

/* Row 0x826 */
{
/* 00 */ 0x3eb1, 0x24adf, 0x28c23, 0x23f35, 0x60a7, 0x3ef3, 0x74cc, 0x743c,
/* 08 */ 0x9387, 0x7437, 0x449f, 0x26dea, 0x4551, 0x7583, 0x3f63, 0x24cd9,
/* 10 */ 0x24d06, 0x3f58, 0x7555, 0x7673, 0x2a5c6, 0x3b19, 0x7468, 0x28acc,
/* 18 */ 0x249ab, 0x2498e, 0x3afb, 0x3dcd, 0x24a4e, 0x3eff, 0xe701, 0x248f3,
/* 20 */ 0x91fa, 0x5732, 0x9342, 0x28ae3, 0x21864, 0x50df, 0x25221, 0x251e7,
/* 28 */ 0x7778, 0x23232, 0x770e, 0x770f, 0x777b, 0x24697, 0x23781, 0x3a5e,
/* 30 */ 0xe713, 0x7438, 0x749b, 0x3ebf, 0x24aba, 0x24ac7, 0x40c8, 0x24a96,
/* 38 */ 0x261ae, 0x9307, 0x25581, 0x781e, 0x788d, 0x7888, 0x78d2, 0x73d0
},

/* Row 0x827 */
{
/* 00 */ 0x7959, 0x27741, 0xe725, 0x410e,    BAD, 0x8496, 0x79a5, 0x6a2d,
/* 08 */ 0x23efa, 0x7a3a, 0x79f4, 0x416e, 0x216e6, 0x4132, 0x9235, 0x79f1,
/* 10 */ 0x20d4c, 0x2498c, 0x20299, 0x23dba, 0x2176e, 0x3597, 0x556b, 0x3570,
/* 18 */ 0x36aa, 0x201d4, 0xe73d, 0x7ae2, 0x5a59, 0x226f5, 0xe741, 0x25a9c,
/* 20 */ 0x5a0d, 0x2025b, 0x78f0, 0x5a2a, 0x25bc6, 0x7afe, 0x41f9, 0x7c5d,
/* 28 */ 0x7c6d, 0x4211, 0x25bb3, 0x25ebc, 0x25ea6, 0x7ccd, 0x249f9, 0xe752,
/* 30 */ 0x7c8e, 0x7c7c, 0x7cae, 0x6ab2, 0x7ddc, 0x7e07, 0x7dd3, 0x7f4e,
/* 38 */ 0x26261, 0x2615c, 0xe75d, 0x7d97, 0x25e82, 0x426a, 0xe761, 0x20916
},

/* Row 0x828 */
{
/* 00 */ 0x67d6, 0x2004e, 0x235cf, 0x57c4, 0x26412, 0xe768, 0x24962, 0x7fdd,
/* 08 */ 0x7b27, 0x2082c, 0x25ae9, 0x25d43, 0x7b0c, 0x25e0e, 0x99e6, 0x8645,
/* 10 */ 0x9a63, 0x6a1c, 0xe775, 0x39e2, 0x249f7, 0x265ad, 0x9a1f, 0xe77a,
/* 18 */ 0x8480, 0x27127, 0xe77d, 0x44ea, 0x8137, 0x4402, 0x80c6, 0x8109,
/* 20 */ 0x8142, 0x267b4, 0x98c3, 0x26a42, 0x8262, 0x8265, 0x26a51, 0x8453,
/* 28 */ 0x26da7, 0x8610, 0x2721b, 0x5a86, 0x417f, 0xe790, 0x5b2b, 0x218a1,
/* 30 */ 0x5ae4, 0x218d8, 0x86a0, 0x8728, 0xe797, 0x882d, 0x27422, 0x5a02,
/* 38 */ 0x886e, 0x4f45, 0x8887, 0x88bf, 0x88e6, 0x8965, 0x894d, 0x25683
},

/* Row 0x829 */
{
/* 00 */ 0x8954, 0x27785, 0x27784, 0xe7a6, 0x28bd9, 0x28b9c, 0x289f9, 0x3ead,
/* 08 */ 0x84a3, 0x46f5, 0x46cf, 0x37f2, 0x8a3d, 0x8a1c, 0x29448, 0x5f4d,
/* 10 */ 0x922b, 0xe7b4, 0x65d4, 0x7129, 0x70c4, 0x21845, 0x9d6d, 0x8c9f,
/* 18 */ 0x8ce9, 0x27ddc, 0x599a, 0x77c3, 0x59f0, 0x436e, 0x36d4, 0x8e2a,
/* 20 */ 0x8ea7, 0x24c09, 0x8f30, 0x8f4a, 0x42f4, 0x6c58, 0x6fbb, 0x22321,
/* 28 */ 0x489b, 0x6f79, 0x6e8b, 0x217da, 0x9be9, 0x36b5, 0x2492f, 0x90bb,
/* 30 */    BAD, 0x5571, 0x4906, 0x91bb, 0x9404, 0x28a4b, 0x4062, 0xe7da,
/* 38 */ 0x9427, 0x28c1d, 0xe7dd, 0x84e5, 0x8a2b, 0x9599, 0x95a7, 0x9597
},

/* Row 0x82a */
{
/* 00 */ 0x9596, 0x28d34, 0x7445, 0x3ec2, 0x248ff, 0xe7e8, 0xe7e9, 0x3ee7,
/* 08 */ 0x23225, 0x968f, 0xe7ed, 0x28e66, 0x28e65, 0x3ecc, 0xe7f1, 0x24a78,
/* 10 */ 0x23fee, 0x7412, 0x746b, 0x3efc, 0x9741, 0x290b0, 0x6847, 0x4a1d,
/* 18 */ 0xe7fb, 0xe7fc,    BAD, 0x9368, 0x28989, 0xe800, 0x28b2f, 0x263be,
/* 20 */ 0x92ba, 0x5b11, 0x8b69, 0x493c, 0x73f9, 0x2421b, 0x979b, 0x9771,
/* 28 */ 0x9938, 0xe80c, 0x5dc1, 0x28bc5, 0x24ab2, 0x981f, 0x294da, 0x92f6,
/* 30 */ 0xe813, 0x91e5, 0x44c0, 0x28b50, 0x24a67, 0x28b64, 0x98dc, 0x28a45,
/* 38 */ 0x3f00, 0x922a, 0x4925, 0x8414, 0x993b, 0x994d, 0xe821, 0x3dfd
},

/* Row 0x82b */
{
/* 00 */ 0x999b, 0x4b6f, 0x99aa, 0x9a5c, 0x28b65, 0xe828, 0x6a8f, 0x9a21,
/* 08 */ 0x5afe, 0x9a2f, 0xe82d, 0x4b90, 0xe82f, 0x99bc, 0x4bbd, 0x4b97,
/* 10 */ 0x937d, 0x5872, 0x21302, 0x5822, 0x249b8, 0x214e8, 0x7844, 0x2271f,
/* 18 */ 0x23db8, 0x68c5, 0x3d7d, 0x9458, 0x3927, 0x6150, 0x22781, 0x2296b,
/* 20 */ 0x6107, 0x9c4f, 0x9c53, 0x9c7b, 0x9c35, 0x9c10, 0x9b7f, 0x9bcf,
/* 28 */ 0x29e2d, 0x9b9f, 0xe84d, 0x2a0fe, 0x9d21, 0x4cae, 0x24104, 0x9e18,
/* 30 */ 0x4cb0, 0x9d0c, 0xe855, 0xe856, 0x2a0f3, 0x2992f, 0x9da5, 0x84bd,
/* 38 */ 0xe85b, 0x26fdf, 0xe85d, 0x85fc, 0x4533, 0x26da4, 0x26e84, 0x26df0
},

/* Row 0x82c */
{
/* 00 */ 0x8420, 0x85ee, 0xe865, 0x237d7, 0x26064, 0x79e2, 0x2359c, 0x23640,
/* 08 */ 0x492d, 0x249de, 0x3d62, 0x93db, 0x92be, 0x9348, 0x202bf, 0x78b9,
/* 10 */ 0x9277, 0x944d, 0x4fe4, 0x3440, 0x9064, 0x2555d, 0x783d, 0x7854,
/* 18 */ 0x78b6, 0x784b, 0x21757, 0x231c9, 0x24941, 0x369a, 0x4f72, 0x6fda,
/* 20 */ 0x6fd9,    BAD, 0x701e, 0x5414, 0xe887, 0x57bb, 0x58f3, 0x578a,
/* 28 */ 0x9d16, 0x57d7, 0x7134, 0x34af, 0xe88f, 0x71eb, 0xe891, 0x24f97,
/* 30 */    BAD, 0x217b5, 0x28a49, 0x610c, 0x5ace, 0x5a0b, 0x42bc, 0x24488,
/* 38 */ 0x372c, 0x4b7b, 0x289fc, 0x93bb, 0x93b8, 0x218d6, 0xe8a1, 0x8472
},

/* Row 0x82d */
{
/* 00 */ 0x26cc0, 0xe8a4, 0x242fa, 0x22c26, 0x243c1, 0x5994, 0x23db7, 0x26741,
/* 08 */ 0x7da8, 0x2615b, 0x260a4, 0x249b9, 0x2498b, 0x289fa, 0x92e5, 0x73e2,
/* 10 */ 0x3ee9, 0x74b4, 0x28b63, 0x2189f, 0x3ee1, 0x24ab3, 0x6ad8, 0x73f3,
/* 18 */ 0x73fb, 0x3ed6, 0x24a3e, 0x24a94, 0x217d9, 0x24a66, 0x203a7, 0xe8c2,
/* 20 */ 0xe8c3, 0x7448, 0x24916, 0x70a5, 0x24976, 0x9284, 0x73e6, 0x935f,
/* 28 */ 0x204fe, 0x9331, 0xe8cd, 0x28a16, 0x9386, 0x28be7, 0x255d5, 0x4935,
/* 30 */ 0x28a82, 0x716b, 0xe8d5, 0xe8d6, 0x56a4, 0x2061a, 0xe8d9, 0xe8da,
/* 38 */ 0x5502, 0x79c4, 0x217fa, 0x7dfe, 0x216c2, 0x24a50, 0xe8e1, 0x452e
},

/* Row 0x82e */
{
/* 00 */ 0x9401, 0x370a, 0xe8e5, 0x249ad, 0x59b0, 0x218bf, 0x21883, 0x27484,
/* 08 */ 0x5aa1, 0x36e2, 0x23d5b, 0x36b0, 0x925f, 0x5a79, 0x28a81, 0x21862,
/* 10 */ 0x9374, 0x3ccd, 0x20ab4, 0x4a96, 0x398a, 0x50f4, 0x3d69, 0x3d4c,
/* 18 */ 0x2139c, 0x7175, 0x42fb, 0xe8fe, 0x6e0f, 0x290e4, 0x44eb, 0x6d57,
/* 20 */ 0x27e4f, 0x7067, 0x6caf, 0x3cd6, 0x23fed, 0x23e2d, 0x6e02, 0x6f0c,
/* 28 */ 0x3d6f, 0x203f5, 0x7551, 0x36bc, 0x34c8, 0x4680, 0x3eda, 0x4871,
/* 30 */ 0x59c4, 0x926e, 0x493e, 0x8f41, 0xe917, 0xe918, 0x5812, 0x57c8,
/* 38 */ 0x36d6, 0x21452, 0x70fe, 0x24362, 0xe91f, 0x22fe3, 0x212b0, 0x223bd
},

/* Row 0x82f */
{
/* 00 */ 0x68b9, 0x6967, 0xe925, 0x234e5, 0x27bf4, 0x236df, 0x28a83, 0x237d6,
/* 08 */ 0xe92b, 0x24c9f, 0x6a1a, 0x236ad, 0x26cb7, 0x843e, 0x44df, 0x44ce,
/* 10 */ 0x26d26, 0xe934, 0x26c82, 0x26fde, 0x6f17, 0x27109, 0x833d, 0x2173a,
/* 18 */ 0x83ed, 0x26c80, 0x27053, 0x217db, 0x5989, 0x5a82, 0x217b3, 0x5a61,
/* 20 */ 0x5a71, 0x21905, 0x241fc, 0x372d, 0x59ef, 0x2173c, 0x36c7, 0x718e,
/* 28 */ 0x9390, 0x669a, 0x242a5, 0x5a6e, 0x5a2b, 0xe950, 0x6a2b, 0x23ef9,
/* 30 */ 0x27736, 0x2445b, 0x242ca, 0x711d, 0x24259, 0x289e1, 0x4fb0, 0x26d28,
/* 38 */ 0x5cc2, 0x244ce, 0x27e4d, 0x243bd, 0x6a0c, 0x24256, 0x21304, 0x70a6
},

/* Row 0x830 */
{
/* 00 */ 0x7133, 0x243e9, 0x3da5, 0x6cdf, 0xe967, 0x24a4f, 0x7e65, 0x59eb,
/* 08 */ 0x5d2f, 0x3df3, 0x5f5c, 0xe96e, 0xe96f, 0x7da4, 0x8426, 0x5485,
/* 10 */ 0xe973, 0x23300, 0x20214, 0x577e, 0xe977, 0x20619, 0x3fe5, 0xe97a,
/* 18 */ 0xe97b, 0x7003, 0xe97d, 0x5d70, 0x738f, 0x7cd3, 0x28a59, 0xe982,
/* 20 */ 0x4fc8, 0x7fe7, 0x72cd, 0x7310, 0x27af4, 0x7338, 0x7339, 0x256f6,
/* 28 */ 0x7341, 0x7348, 0x3ea9, 0x27b18, 0x906c, 0x71f5, 0xe991, 0x73e1,
/* 30 */ 0x81f6, 0x3eca, 0x770c, 0x3ed1, 0x6ca2, 0x56fd, 0x7419, 0x741e,
/* 38 */ 0x741f, 0x3ee2, 0x3ef0, 0x3ef4, 0x3efa, 0x74d3, 0x3f0e, 0x3f53
},

/* Row 0x831 */
{
/* 00 */ 0x7542, 0x756d, 0x7572, 0x758d, 0x3f7c, 0x75c8, 0x75dc, 0x3fc0,
/* 08 */ 0x764d, 0x3fd7, 0x7674, 0x3fdc, 0x767a, 0x24f5c, 0x7188, 0x5623,
/* 10 */ 0x8980, 0x5869, 0x401d, 0x7743, 0x4039, 0x6761, 0x4045, 0x35db,
/* 18 */ 0x7798, 0x406a, 0x406f, 0x5c5e, 0x77be, 0x77cb, 0x58f2, 0x7818,
/* 20 */ 0x70b9, 0x781c, 0x40a8, 0x7839, 0x7847, 0x7851, 0x7866, 0x8448,
/* 28 */ 0xe9cb, 0x7933, 0x6803, 0x7932, 0x4103, 0x4109, 0x7991, 0x7999,
/* 30 */ 0x8fbb, 0x7a06, 0x8fbc, 0x4167, 0x7a91, 0x41b2, 0x7abc, 0x8279,
/* 38 */ 0x41c4, 0x7acf, 0x7adb, 0x41cf, 0x4e21, 0x7b62, 0x7b6c, 0x7b7b
},

/* Row 0x832 */
{
/* 00 */ 0x7c12, 0x7c1b, 0x4260, 0x427a, 0x7c7b, 0x7c9c, 0x428c, 0x7cb8,
/* 08 */ 0x4294, 0x7ced, 0x8f93, 0x70c0, 0x20ccf, 0x7dcf, 0x7dd4, 0x7dd0,
/* 10 */ 0x7dfd, 0x7fae, 0x7fb4, 0x729f, 0x4397, 0x8020, 0x8025, 0x7b39,
/* 18 */ 0x802e, 0x8031, 0x8054, 0x3dcc, 0x57b4, 0x70a0, 0x80b7, 0x80e9,
/* 20 */ 0x43ed, 0x810c, 0x732a, 0x810e, 0x8112, 0x7560, 0x8114, 0x4401,
/* 28 */ 0x3b39, 0x8156, 0x8159, 0x815a, 0x4413, 0x583a, 0x817c, 0x8184,
/* 30 */ 0x4425, 0x8193, 0x442d, 0x81a5, 0x57ef, 0x81c1, 0x81e4, 0x8254,
/* 38 */ 0x448f, 0x82a6, 0x8276, 0x82ca, 0x82d8, 0x82ff, 0x44b0, 0x8357
},

/* Row 0x833 */
{
/* 00 */ 0x9669, 0x698a, 0x8405, 0x70f5, 0x8464, 0x60e3, 0x8488, 0x4504,
/* 08 */ 0x84be, 0x84e1, 0x84f8, 0x8510, 0x8538, 0x8552, 0x453b, 0x856f,
/* 10 */ 0x8570, 0x85e0, 0x4577, 0x8672, 0x8692, 0x86b2, 0x86ef, 0x9645,
/* 18 */ 0x878b, 0x4606, 0x4617, 0x88ae, 0x88ff, 0x8924, 0x8947, 0x8991,
/* 20 */ 0x27967, 0x8a29, 0x8a38, 0x8a94, 0x8ab4, 0x8c51, 0x8cd4, 0x8cf2,
/* 28 */ 0x8d1c, 0x4798, 0x585f, 0x8dc3, 0x47ed, 0x4eee, 0x8e3a, 0x55d8,
/* 30 */ 0x5754, 0x8e71, 0x55f5, 0x8eb0, 0x4837, 0x8ece, 0x8ee2, 0x8ee4,
/* 38 */ 0x8eed, 0x8ef2, 0x8fb7, 0x8fc1, 0x8fca, 0x8fcc, 0x9033, 0x99c4
},

/* Row 0x834 */
{
/* 00 */ 0x9bdd, 0x9bf1, 0x9bf4, 0x4c6d, 0x9c20, 0x376f, 0xeaa9, 0x9d49,
/* 08 */ 0x9c3a, 0x9efe, 0x5650, 0x9d93, 0x9dbd, 0x9dc0, 0x9dfc, 0x94f6,
/* 10 */ 0x8fb6, 0x9e7b, 0x9eac, 0x9eb1, 0x9ebd, 0x9ec6, 0x94dc, 0x9ee2,
/* 18 */ 0x9ef1, 0x9ef8, 0x7ac8, 0x9f44, 0xeabf, 0xeac0, 0xeac1, 0x691a,
/* 20 */ 0x94c3, 0x59ac, 0xeac5, 0x5840, 0x94c1, 0x37b9, 0xeac9, 0xeaca,
/* 28 */ 0xeacb, 0xeacc, 0x5757, 0x7173, 0xeacf, 0xead0, 0xead1, 0x546a,
/* 30 */ 0xead3, 0xead4, 0x549e, 0xead6, 0xead7, 0x20c53, 0xead9, 0xeada,
/* 38 */ 0x60e7, 0xeadc, 0x567a, 0xeade, 0xeadf, 0xeae0, 0xeae1, 0xeae2
},

/* Row 0x835 */
{
/* 00 */ 0xeae3, 0x6955, 0x9c2f, 0x87a5, 0xeae7, 0x20e0e, 0xeae9, 0xeaea,
/* 08 */ 0x20f2d, 0xeaec, 0x5c20, 0xeaee, 0x5e0b, 0xeaf0, 0xeaf1, 0x21076,
/* 10 */ 0x671e, 0x2107b, 0xeaf5, 0xeaf6, 0x3647, 0xeaf8, 0xeaf9, 0xeafa,
/* 18 */ 0xeafb, 0x5364, 0x84ad, 0x212e3, 0xeaff, 0xeb00, 0x8b81, 0xeb02,
/* 20 */ 0xeb03, 0xeb04, 0xeb05, 0x4e78, 0x70bb, 0xeb08, 0xeb09, 0xeb0a,
/* 28 */ 0xeb0b, 0xeb0c, 0xeb0d, 0xeb0e, 0xeb0f, 0x62c3, 0x21ed5, 0xeb12,
/* 30 */ 0x7198, 0x6855, 0xeb15, 0x69e9, 0x36c8, 0x2227c, 0xeb19, 0xeb1a,
/* 38 */ 0xeb1b, 0xeb1c, 0xeb1d, 0x82fd, 0xeb1f, 0xeb20, 0x22ad5, 0x89a5
},

/* Row 0x836 */
{
/* 00 */ 0xeb23, 0x8fa0, 0xeb25, 0x97b8, 0xeb27, 0x9847, 0x9abd, 0xeb2a,
/* 08 */    BAD, 0xeb2c, 0xeb2d, 0xeb2e, 0x22d08, 0xeb30, 0xeb31, 0xeb32,
/* 10 */ 0xeb33, 0xeb34, 0xeb35, 0xeb36, 0xeb37, 0xeb38, 0xeb39, 0x5fb1,
/* 18 */ 0x6648, 0x66bf, 0xeb3d, 0xeb3e, 0xeb3f,    BAD, 0x249ba,    BAD,
/* 20 */ 0xeb43, 0xeb44,    BAD, 0x20346, 0x58b5, 0x670e, 0x6918, 0xeb4a,
/* 28 */ 0x27657, 0x25fe2, 0xeb4d, 0xeb4e, 0x275fe, 0x2209a, 0x48d0, 0x4ab8,
/* 30 */ 0xeb53, 0x28a9a, 0xeb55, 0xeb56, 0x2403b, 0xeb58, 0x24396, 0xeb5a,
/* 38 */ 0xeb5b, 0x51d2, 0x20611, 0x599f, 0x21ea8, 0x3bbe, 0x23cff, 0xeb62
},

/* Row 0x837 */
{
/* 00 */ 0xeb63, 0x5788, 0xeb65, 0x399b, 0xeb67, 0xeb68, 0xeb69, 0x3762,
/* 08 */ 0x221c3, 0x8b5e, 0x28b4e,    BAD, 0xeb6f, 0xeb70, 0xeb71, 0x7209,
/* 10 */ 0xeb73, 0x20c78, 0x5965, 0xeb76, 0xeb77, 0x20779, 0x8eda, 0xeb7a,
/* 18 */ 0x528f, 0x573f, 0x7171, 0xeb7e, 0xeb7f, 0xeb80, 0x24aa7, 0x55bc,
/* 20 */ 0xeb83, 0x2546e, 0x26b52,    BAD, 0x3473, 0xeb88, 0x27632, 0xeb8a,
/* 28 */ 0x4718, 0xeb8c, 0x25566, 0x257c7, 0x2493f, 0xeb90, 0x5066, 0x34fb,
/* 30 */ 0xeb93,    BAD, 0xeb95, 0x477c, 0x28948, 0x25aae, 0xeb99, 0x25c06,
/* 38 */ 0xeb9b, 0x57a1, 0x7151,    BAD, 0xeb9f, 0x27c12, 0x9056, 0xeba2
},

/* Row 0x838 */
{
/* 00 */ 0x24f9a, 0x8b62, 0xeba5, 0xeba6, 0x5d5b, 0x26bf7,    BAD, 0xebaa,
/* 08 */ 0xebab, 0x8aea, 0x249f6, 0xebae, 0x23fef, 0x26512, 0x4bc0, 0xebb2,
/* 10 */ 0xebb3, 0x2271b, 0x9465, 0x257e1, 0x6195, 0x5a27, 0x2f8cd,    BAD,
/* 18 */ 0x56b9, 0x24521, 0xebbd, 0x4e6a, 0xebbf, 0x9656, 0x6d8f, 0x26cbd,
/* 20 */ 0x3618, 0x8977, 0xebc5, 0x2686e, 0x26411, 0x2685e,    BAD, 0xebca,
/* 28 */ 0x7b42, 0xebcc, 0x20a11, 0xebce,    BAD, 0xebd0, 0x7a45,    BAD,
/* 30 */ 0x269fa, 0x9a26, 0xebd5, 0x365f, 0xebd7, 0xebd8, 0x7983, 0xebda,
/* 38 */ 0xebdb, 0x5d2c, 0xebdd,    BAD, 0xebdf, 0x46d0, 0xebe1, 0x753b
},

/* Row 0x839 */
{
/* 00 */ 0x8865, 0xebe4, 0x58b6, 0x371c, 0x2258d, 0xebe8, 0xebe9, 0x3c54,
/* 08 */ 0xebeb, 0xebec, 0x9281, 0x2217a, 0xebef, 0x9330, 0x272e6, 0xebf2,
/* 10 */ 0x6c39, 0x949f, 0xebf5, 0x20ef8, 0x8827, 0x88f5, 0xebf9, 0xebfa,
/* 18 */ 0x217b1, 0x6eb8, 0x24a2a, 0xebfe, 0x39a4, 0x36b9,    BAD,    BAD,
/* 20 */ 0x453f, 0x66b6, 0x29cad, 0x298a4, 0x8943, 0xec08, 0xec09, 0x56d6,
/* 28 */ 0x40df, 0x2160a, 0x39a1, 0x2372f, 0xec0f, 0x213c5, 0x71ad, 0x8366,
/* 30 */ 0xec13, 0x291a8,    BAD, 0x4cb7, 0x270af, 0x289ab, 0xec19, 0xec1a,
/* 38 */ 0xec1b, 0xec1c, 0x2417a, 0x7b43, 0x797e, 0x28009, 0x6fb5, 0x2a2df
},

/* Row 0x83a */
{
/* 00 */ 0x6a03, 0xec24, 0x53a2, 0xec26, 0x93bf, 0x6836, 0x975d, 0x2816f,
/* 08 */ 0xec2b, 0x269b5, 0x213ed, 0x2322f, 0xec2f, 0x5d85, 0x28c30, 0xec32,
/* 10 */ 0x5715, 0x9823, 0x28949, 0x5dab, 0x24988, 0x65be, 0x69d5, 0x53d2,
/* 18 */ 0x24aa5, 0x23f81, 0x3c11, 0x6736, 0xec3f, 0x280f4, 0x2812e, 0x21fa1,
/* 20 */ 0xec43, 0xec44, 0xec45, 0xec46, 0xec47, 0xec48, 0xec49, 0x35ca,
/* 28 */ 0xec4b, 0x286aa, 0x48fa, 0x63e6, 0xec4f, 0x7808, 0x9255, 0xec52,
/* 30 */ 0x43f2, 0xec54, 0x43df, 0xec56, 0xec57, 0xec58, 0x59f8, 0xec5a,
/* 38 */    BAD, 0xec5c, 0xec5d,    BAD, 0x29110, 0xec60, 0x3df7, 0xec62
},

/* Row 0x83b */
{
/* 00 */ 0xec63, 0x8fd0, 0x728f, 0x568b, 0xec67, 0x295e9, 0xec69, 0xec6a,
/* 08 */ 0xec6b, 0xec6c, 0xec6d, 0x2996a, 0xec6f, 0xec70, 0x29b0e, 0xec72,
/* 10 */ 0xec73, 0x7e9f, 0xec75, 0x29f23, 0x4ca4, 0x9547, 0xec79, 0x71a2,
/* 18 */ 0xec7b, 0x4d91, 0x9012, 0xec7e, 0x4d9c, 0x20c9c, 0x8fbe, 0x55c1,
/* 20 */ 0x8fba, 0xec84, 0x8fb9, 0x24a93, 0x4509, 0x7e7f, 0x6f56, 0x6ab1,
/* 28 */ 0x4eea, 0x34e4, 0x28b2c, 0xec8e, 0x373a, 0x8e80, 0x217f5, 0xec92,
/* 30 */ 0x28b6c, 0x28b99, 0xec95, 0x266af, 0x3deb, 0x27655, 0x23cb7, 0x25635,
/* 38 */ 0x25956, 0x4e9a, 0x25e81, 0x26258, 0x56bf, 0x20e6d, 0x8e0e, 0x5b6d
},

/* Row 0x83c */
{
/* 00 */ 0x23e88, 0x24c9e, 0x63de,    BAD, 0x217f6, 0x2187b, 0x6530, 0x562d,
/* 08 */ 0x25c4a, 0x541a, 0x25311, 0x3dc6, 0xecaf, 0x4c7d, 0x5622, 0x561e,
/* 10 */ 0x7f49, 0x25ed8, 0x5975, 0xecb6, 0x8770, 0x4e1c, 0x20fea, 0x20d49,
/* 18 */ 0x236ba, 0x8117, 0x9d5e, 0x8d18, 0x763b, 0x9c45, 0x764e, 0x77b9,
/* 20 */ 0x9345, 0x5432, 0x8148, 0x82f7, 0x5625, 0x8132, 0x8418, 0x80bd,
/* 28 */ 0x55ea, 0x7962, 0x5643, 0x5416, 0xeccf, 0x35ce, 0x5605, 0x55f1,
/* 30 */ 0x66f1, 0x282e2, 0x362d, 0x7534, 0x55f0, 0x55ba, 0x5497, 0x5572,
/* 38 */ 0x20c41, 0xecdc, 0x5ed0, 0x25148, 0x20e76, 0xece0, 0xece1, 0x9eab
},

/* Row 0x83d */
{
/* 00 */ 0x7d5a, 0x55de, 0x21075, 0x629d, 0x976d, 0x5494, 0x8ccd, 0x71f6,
/* 08 */ 0x9176, 0x63fc, 0x63b9, 0x63fe, 0x5569, 0xecf0, 0x9c72, 0xecf2,
/* 10 */ 0x519a, 0x34df, 0x20da7, 0x51a7, 0x544d, 0x551e, 0x5513, 0x7666,
/* 18 */ 0x8e2d, 0xecfc, 0x75b1, 0x80b6, 0x8804, 0x8786, 0x88c7, 0x81b6,
/* 20 */ 0x841c, 0x210c1, 0x44ec, 0x7304, 0x24706, 0x5b90, 0x830b, 0x26893,
/* 28 */ 0x567b, 0x226f4, 0x27d2f, 0x241a3, 0x27d73, 0x26ed0, 0xed11, 0x9170,
/* 30 */ 0x211d9, 0x9208, 0x23cfc, 0x2a6a9, 0x20eac, 0x20ef9, 0x7266, 0x21ca2,
/* 38 */ 0x474e, 0x24fc2, 0xed1d, 0x20feb, 0x40fa, 0x9c5d, 0x651f, 0x22da0
},

/* Row 0x83e */
{
/* 00 */ 0x48f3, 0xed24, 0x29d7c, 0x20fec, 0x20e0a,    BAD, 0xed29, 0x20fed,
/* 08 */    BAD, 0xed2c, 0x21187, 0x71a3, 0x7e8e, 0x9d50, 0x4e1a, 0x4e04,
/* 10 */ 0x3577, 0x5b0d, 0x6cb2, 0x5367, 0x36ac, 0x39dc, 0x537d, 0x36a5,
/* 18 */ 0xed3b, 0x589a, 0x24b6e, 0x822d, 0x544b, 0x57aa, 0xed41, 0x20979,
/* 20 */    BAD, 0x3a52, 0x22465, 0x7374, 0x29eac, 0x4d09, 0x9bed, 0x23cfe,
/* 28 */ 0x29f30, 0x4c5b, 0x24fa9, 0x2959e, 0xed4f, 0x845c, 0x23db6, 0xed52,
/* 30 */ 0x267b3, 0x23720, 0x632e, 0x7d25, 0x23ef7, 0x23e2c, 0x3a2a, 0x9008,
/* 38 */ 0x52cc, 0x3e74, 0x367a, 0x45e9, 0xed5f, 0x7640, 0x5af0, 0x20eb6
},

/* Row 0x83f */
{
/* 00 */ 0x787a, 0x47b6, 0x58a7, 0x40bf, 0x567c, 0x9b8b, 0x5d74, 0x7654,
/* 08 */ 0xed6b, 0x9e85, 0x4ce1,    BAD, 0x37fb, 0x6119, 0x230da, 0x243f2,
/* 10 */    BAD, 0x565d, 0x212a9, 0x57a7, 0x24963, 0xed78, 0x5234, 0x270ae,
/* 18 */ 0x35ad,    BAD, 0x9d7c, 0x7c56, 0x9b39, 0x57de, 0x2176c, 0x5c53,
/* 20 */ 0x64d3, 0xed84, 0xed85, 0x27164, 0x86ad, 0xed88, 0x26d22, 0x24ae2,
/* 28 */ 0xed8b,    BAD, 0x51fe, 0xed8e, 0x5d8e, 0x9703, 0x21dd1, 0x9e81,
/* 30 */ 0x904c, 0x7b1f, 0x9b02, 0x5cd1, 0x7ba3, 0x6268, 0x6335, 0x9aff,
/* 38 */ 0x7bcf, 0x9b2a, 0x7c7e,    BAD, 0x7c42, 0x7c86, 0x9c15, 0x7bfc
},

/* Row 0x840 */
{
/* 00 */ 0x9b09,    BAD, 0x9c1b, 0x2493e, 0x9f5a, 0x5573, 0x5bc3, 0x4ffd,
/* 08 */ 0x9e98, 0x4ff2, 0x5260, 0x3e06, 0x52d1, 0x5767, 0x5056, 0x59b7,
/* 10 */ 0x5e12, 0x97c8, 0x9dab, 0x8f5c, 0x5469, 0x97b4, 0x9940, 0x97ba,
/* 18 */ 0x532c, 0x6130, 0x692c, 0x53da, 0x9c0a, 0x9d02, 0x4c3b, 0x9641,
/* 20 */ 0x6980, 0x50a6, 0x7546, 0x2176d, 0x99da, 0x5273,    BAD, 0x9159,
/* 28 */ 0x9681, 0x915c,    BAD, 0x9151, 0xedcf, 0x637f, 0x26d23, 0x6aca,
/* 30 */ 0x5611, 0x918e, 0x757a, 0x6285, 0x203fc, 0x734f, 0x7c70, 0xedda,
/* 38 */ 0x23cfd,    BAD, 0x24919, 0x76d6, 0x9b9d, 0x4e2a, 0x20cd4, 0x83be
},

/* Row 0x841 */
{
/* 00 */ 0x8842,    BAD, 0x5c4a, 0x69c0,    BAD, 0x577a, 0x521f, 0x5df5,
/* 08 */ 0x4ece, 0x6c31, 0xeded, 0x4f39, 0x549c, 0x54da, 0x529a, 0x8d82,
/* 10 */ 0x35fe,    BAD, 0x35f3,    BAD, 0x6b52, 0x917c, 0x9fa5, 0x9b97,
/* 18 */ 0x982e, 0x98b4, 0x9aba, 0x9ea8, 0x9e84, 0x717a, 0x7b14,    BAD,
/* 20 */ 0x6bfa, 0x8818, 0x7f78,    BAD, 0x5620, 0xee08, 0x8e77, 0x9f53,
/* 28 */    BAD, 0x8dd4, 0x8e4f, 0x9e1c, 0x8e01, 0x6282, 0x2837d, 0x8e28,
/* 30 */ 0x8e75, 0x7ad3, 0x24a77, 0x7a3e, 0x78d8, 0x6cea, 0x8a67, 0x7607,
/* 38 */ 0x28a5a, 0x9f26, 0x6cce, 0x87d6, 0x75c3, 0x2a2b2, 0x7853, 0x2f840
},

/* Row 0x842 */
{
/* 00 */ 0x8d0c, 0x72e2, 0x7371, 0x8b2d, 0x7302, 0x74f1, 0x8ceb, 0x24abb,
/* 08 */ 0x862f, 0x5fba, 0x88a0, 0x44b7,    BAD, 0x2183b, 0x26e05,    BAD,
/* 10 */ 0x8a7e, 0x2251b,    BAD, 0x60fd, 0x7667, 0x9ad7, 0x9d44, 0x936e,
/* 18 */ 0x9b8f, 0x87f5,    BAD,    BAD, 0x8cf7, 0x732c, 0x9721, 0x9bb0,
/* 20 */ 0x35d6, 0x72b2, 0x4c07, 0x7c51, 0x994a, 0x26159, 0x6159, 0x4c04,
/* 28 */ 0x9e96, 0x617d,    BAD, 0x575f, 0x616f, 0x62a6, 0x6239,    BAD,
/* 30 */ 0x3a5c, 0x61e2, 0x53aa, 0x233f5, 0x6364, 0x6802, 0x35d2, 0x5d57,
/* 38 */ 0x28bc2, 0x8fda, 0xee5d,    BAD, 0x50d9, 0x21d46, 0x7906, 0x5332
},

/* Row 0x843 */
{
/* 00 */ 0x9638, 0x20f3b, 0x4065,    BAD, 0x77fe,    BAD, 0x7cc2, 0xee6a,
/* 08 */ 0x7cda, 0x7a2d, 0x8066, 0x8063, 0x7d4d, 0x7505, 0x74f2, 0x8994,
/* 10 */ 0x821a, 0x670c, 0x8062, 0x27486, 0x805b, 0x74f0, 0x8103, 0x7724,
/* 18 */ 0x8989, 0x267cc, 0x7553, 0x26ed1, 0x87a9, 0x87ce, 0x81c8, 0x878c,
/* 20 */ 0x8a49, 0x8cad, 0x8b43, 0x772b, 0x74f8, 0x84da, 0x3635, 0x69b2,
/* 28 */ 0x8da6,    BAD, 0x89a9,    BAD, 0x6db9, 0x87c1, 0x24011, 0x74e7,
/* 30 */ 0x3ddb, 0x7176, 0x60a4, 0x619c, 0x3cd1,    BAD, 0x6077,    BAD,
/* 38 */ 0x7f71, 0x28b2d,    BAD, 0x60e9, 0x4b7e, 0x5220, 0x3c18, 0x23cc7
},

/* Row 0x844 */
{
/* 00 */ 0x25ed7, 0x27656, 0xeea5, 0x21944, 0x212fe, 0x29903, 0x26ddc, 0x270ad,
/* 08 */ 0x5cc1, 0x261ad, 0x28a0f, 0x23677, 0x200ee, 0xeeb0, 0x24f0e, 0x4562,
/* 10 */ 0x5b1f, 0xeeb4, 0x9f50, 0x9ea6, 0xeeb7,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
}
};

/* Row table for mapping Unicode to big5 */

#define	ucs_to_big5_DMAP	1
static row_t _ucs_to_big5_row[] = {
/* 000 */  0x000,  0x001,  0x002,  0x003,    BAD,    BAD,    BAD,    BAD,
/* 008 */    BAD,    BAD,    BAD,  0x004,  0x005,    BAD,  0x006,  0x007,
/* 010 */  0x008,  0x009,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 018 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 020 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 028 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 030 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 038 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 040 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 048 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 050 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 058 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 060 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 068 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 070 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 078 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 080 */  0x00a,    BAD,    BAD,    BAD,  0x00b,  0x00c,  0x00d,    BAD,
/* 088 */  0x00e,  0x00f,  0x010,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 090 */    BAD,  0x011,    BAD,    BAD,  0x012,  0x013,  0x014,  0x015,
/* 098 */  0x016,  0x017,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0c0 */  0x018,  0x019,  0x01a,  0x01b,  0x01c,    BAD,    BAD,    BAD,
/* 0c8 */    BAD,    BAD,  0x01d,    BAD,    BAD,    BAD,  0x01e,  0x01f,
/* 0d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 100 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 108 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 110 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 118 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 120 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 128 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 130 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 138 */  0x020,  0x021,  0x022,  0x023,  0x024,  0x025,  0x026,  0x027,
/* 140 */  0x028,  0x029,  0x02a,  0x02b,  0x02c,  0x02d,  0x02e,  0x02f,
/* 148 */  0x030,  0x031,  0x032,  0x033,  0x034,  0x035,  0x036,  0x037,
/* 150 */  0x038,  0x039,  0x03a,  0x03b,  0x03c,  0x03d,  0x03e,  0x03f,
/* 158 */  0x040,  0x041,  0x042,  0x043,  0x044,  0x045,  0x046,  0x047,
/* 160 */  0x048,  0x049,  0x04a,  0x04b,  0x04c,  0x04d,  0x04e,  0x04f,
/* 168 */  0x050,  0x051,  0x052,  0x053,  0x054,  0x055,  0x056,  0x057,
/* 170 */  0x058,  0x059,  0x05a,  0x05b,  0x05c,  0x05d,  0x05e,  0x05f,
/* 178 */  0x060,  0x061,  0x062,  0x063,  0x064,  0x065,  0x066,  0x067,
/* 180 */  0x068,  0x069,  0x06a,  0x06b,  0x06c,  0x06d,  0x06e,  0x06f,
/* 188 */  0x070,  0x071,  0x072,  0x073,  0x074,  0x075,  0x076,  0x077,
/* 190 */  0x078,  0x079,  0x07a,  0x07b,  0x07c,  0x07d,  0x07e,  0x07f,
/* 198 */  0x080,  0x081,  0x082,  0x083,  0x084,  0x085,  0x086,  0x087,
/* 1a0 */  0x088,  0x089,  0x08a,  0x08b,  0x08c,  0x08d,  0x08e,  0x08f,
/* 1a8 */  0x090,  0x091,  0x092,  0x093,  0x094,  0x095,  0x096,  0x097,
/* 1b0 */  0x098,  0x099,  0x09a,  0x09b,  0x09c,  0x09d,  0x09e,  0x09f,
/* 1b8 */  0x0a0,  0x0a1,  0x0a2,  0x0a3,  0x0a4,  0x0a5,  0x0a6,  0x0a7,
/* 1c0 */  0x0a8,  0x0a9,  0x0aa,  0x0ab,  0x0ac,  0x0ad,  0x0ae,  0x0af,
/* 1c8 */  0x0b0,  0x0b1,  0x0b2,  0x0b3,  0x0b4,  0x0b5,  0x0b6,  0x0b7,
/* 1d0 */  0x0b8,  0x0b9,  0x0ba,  0x0bb,  0x0bc,  0x0bd,  0x0be,  0x0bf,
/* 1d8 */  0x0c0,  0x0c1,  0x0c2,  0x0c3,  0x0c4,  0x0c5,  0x0c6,  0x0c7,
/* 1e0 */  0x0c8,  0x0c9,  0x0ca,  0x0cb,  0x0cc,  0x0cd,  0x0ce,  0x0cf,
/* 1e8 */  0x0d0,  0x0d1,  0x0d2,  0x0d3,  0x0d4,  0x0d5,  0x0d6,  0x0d7,
/* 1f0 */  0x0d8,  0x0d9,  0x0da,  0x0db,  0x0dc,  0x0dd,  0x0de,  0x0df,
/* 1f8 */  0x0e0,  0x0e1,  0x0e2,    BAD,  0x0e3,  0x0e4,  0x0e5,  0x0e6,
/* 200 */  0x0e7,  0x0e8,  0x0e9,  0x0ea,  0x0eb,  0x0ec,  0x0ed,  0x0ee,
/* 208 */  0x0ef,  0x0f0,  0x0f1,  0x0f2,  0x0f3,  0x0f4,  0x0f5,  0x0f6,
/* 210 */  0x0f7,  0x0f8,  0x0f9,  0x0fa,  0x0fb,  0x0fc,  0x0fd,  0x0fe,
/* 218 */  0x0ff,  0x100,  0x101,  0x102,  0x103,  0x104,  0x105,  0x106,
/* 220 */  0x107,  0x108,  0x109,  0x10a,  0x10b,  0x10c,  0x10d,  0x10e,
/* 228 */  0x10f,  0x110,  0x111,  0x112,  0x113,  0x114,  0x115,    BAD,
/* 230 */  0x116,  0x117,  0x118,  0x119,  0x11a,  0x11b,  0x11c,  0x11d,
/* 238 */  0x11e,  0x11f,  0x120,  0x121,  0x122,  0x123,  0x124,  0x125,
/* 240 */  0x126,  0x127,  0x128,  0x129,  0x12a,  0x12b,  0x12c,  0x12d,
/* 248 */  0x12e,  0x12f,  0x130,  0x131,  0x132,  0x133,  0x134,  0x135,
/* 250 */  0x136,  0x137,  0x138,    BAD,    BAD,  0x139,  0x13a,  0x13b,
/* 258 */  0x13c,  0x13d,  0x13e,  0x13f,  0x140,  0x141,  0x142,  0x143,
/* 260 */  0x144,  0x145,  0x146,  0x147,  0x148,  0x149,  0x14a,  0x14b,
/* 268 */  0x14c,  0x14d,  0x14e,  0x14f,  0x150,  0x151,  0x152,  0x153,
/* 270 */  0x154,  0x155,    BAD,  0x156,  0x157,  0x158,  0x159,  0x15a,
/* 278 */  0x15b,  0x15c,  0x15d,  0x15e,  0x15f,  0x160,  0x161,    BAD,
/* 280 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 288 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 290 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 298 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2c0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 300 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 308 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 310 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 318 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 320 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 328 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 330 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 338 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 340 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 348 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 350 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 358 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 360 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 368 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 370 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 378 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 380 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 388 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 390 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 398 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3c0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3d8 */    BAD,    BAD,  0x162,  0x163,  0x164,  0x165,  0x166,    BAD,
/* 3e0 */    BAD,    BAD,    BAD,  0x167,    BAD,    BAD,    BAD,    BAD,
/* 3e8 */  0x168,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3f8 */  0x169,  0x16a,    BAD,    BAD,  0x16b,  0x16c
};

/* Row table for mapping Unicode to hkscs */

#define	ucs_to_hkscs_DMAP	1
static row_t _ucs_to_hkscs_row[] = {
/* 000 */  0x000,  0x001,  0x16d,  0x16e,  0x16f,  0x170,    BAD,  0x171,
/* 008 */    BAD,  0x172,  0x173,  0x174,  0x175,    BAD,  0x006,  0x007,
/* 010 */  0x176,  0x177,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 018 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 020 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 028 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 030 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 038 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 040 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 048 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 050 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 058 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 060 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 068 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 070 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 078 */    BAD,    BAD,  0x178,  0x179,    BAD,    BAD,    BAD,    BAD,
/* 080 */  0x00a,    BAD,    BAD,    BAD,  0x17a,  0x17b,  0x17c,  0x17d,
/* 088 */  0x00e,  0x00f,  0x010,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 090 */    BAD,  0x17e,    BAD,    BAD,  0x012,  0x17f,  0x014,  0x015,
/* 098 */  0x016,  0x017,    BAD,    BAD,  0x180,    BAD,    BAD,    BAD,
/* 0a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 0b8 */    BAD,    BAD,  0x181,  0x182,  0x183,    BAD,    BAD,    BAD,
/* 0c0 */  0x184,  0x185,  0x186,  0x187,  0x01c,    BAD,    BAD,    BAD,
/* 0c8 */  0x188,    BAD,  0x01d,    BAD,    BAD,    BAD,  0x01e,  0x01f,
/* 0d0 */  0x189,  0x18a,  0x18b,  0x18c,  0x18d,  0x18e,  0x18f,  0x190,
/* 0d8 */  0x191,  0x192,  0x193,  0x194,  0x195,  0x196,  0x197,  0x198,
/* 0e0 */  0x199,  0x19a,  0x19b,  0x19c,  0x19d,  0x19e,  0x19f,  0x1a0,
/* 0e8 */  0x1a1,  0x1a2,  0x1a3,  0x1a4,  0x1a5,  0x1a6,  0x1a7,  0x1a8,
/* 0f0 */  0x1a9,  0x1aa,    BAD,  0x1ab,  0x1ac,  0x1ad,  0x1ae,  0x1af,
/* 0f8 */  0x1b0,  0x1b1,  0x1b2,  0x1b3,  0x1b4,  0x1b5,  0x1b6,  0x1b7,
/* 100 */  0x1b8,  0x1b9,  0x1ba,  0x1bb,  0x1bc,  0x1bd,  0x1be,  0x1bf,
/* 108 */  0x1c0,  0x1c1,  0x1c2,  0x1c3,  0x1c4,  0x1c5,  0x1c6,  0x1c7,
/* 110 */  0x1c8,  0x1c9,  0x1ca,  0x1cb,  0x1cc,  0x1cd,  0x1ce,  0x1cf,
/* 118 */  0x1d0,  0x1d1,  0x1d2,  0x1d3,  0x1d4,  0x1d5,  0x1d6,  0x1d7,
/* 120 */  0x1d8,  0x1d9,  0x1da,  0x1db,  0x1dc,  0x1dd,  0x1de,  0x1df,
/* 128 */  0x1e0,    BAD,  0x1e1,  0x1e2,  0x1e3,  0x1e4,  0x1e5,  0x1e6,
/* 130 */  0x1e7,  0x1e8,  0x1e9,  0x1ea,  0x1eb,    BAD,  0x1ec,    BAD,
/* 138 */  0x1ed,  0x1ee,  0x1ef,  0x1f0,  0x1f1,  0x1f2,  0x1f3,  0x1f4,
/* 140 */  0x1f5,  0x1f6,  0x1f7,  0x1f8,  0x1f9,  0x1fa,  0x1fb,  0x1fc,
/* 148 */  0x1fd,  0x1fe,  0x1ff,  0x200,  0x201,  0x202,  0x203,  0x204,
/* 150 */  0x205,  0x206,  0x207,  0x208,  0x209,  0x20a,  0x20b,  0x20c,
/* 158 */  0x20d,  0x20e,  0x20f,  0x210,  0x211,  0x212,  0x213,  0x214,
/* 160 */  0x215,  0x216,  0x217,  0x218,  0x219,  0x21a,  0x21b,  0x21c,
/* 168 */  0x21d,  0x21e,  0x21f,  0x220,  0x221,  0x222,  0x223,  0x224,
/* 170 */  0x225,  0x226,  0x227,  0x228,  0x229,  0x22a,  0x22b,  0x22c,
/* 178 */  0x22d,  0x22e,  0x22f,  0x230,  0x231,  0x232,  0x233,  0x234,
/* 180 */  0x235,  0x236,  0x237,  0x238,  0x239,  0x23a,  0x23b,  0x23c,
/* 188 */  0x23d,  0x23e,  0x23f,  0x240,  0x241,  0x242,  0x243,  0x244,
/* 190 */  0x245,  0x246,  0x247,  0x248,  0x249,  0x24a,  0x24b,  0x24c,
/* 198 */  0x24d,  0x24e,  0x24f,  0x250,  0x251,  0x252,  0x253,  0x254,
/* 1a0 */  0x255,  0x256,  0x257,  0x258,  0x259,  0x25a,  0x25b,  0x25c,
/* 1a8 */  0x25d,  0x25e,  0x25f,  0x260,  0x261,  0x262,  0x263,  0x264,
/* 1b0 */  0x265,  0x266,  0x267,  0x268,  0x269,  0x26a,  0x26b,  0x09f,
/* 1b8 */  0x26c,  0x26d,  0x26e,  0x26f,  0x270,  0x271,  0x272,  0x273,
/* 1c0 */  0x274,  0x275,  0x276,  0x277,  0x278,  0x279,  0x27a,  0x27b,
/* 1c8 */  0x27c,  0x27d,  0x27e,  0x27f,  0x280,  0x281,  0x282,  0x283,
/* 1d0 */  0x284,  0x285,  0x286,  0x287,  0x288,  0x289,  0x28a,  0x28b,
/* 1d8 */  0x28c,  0x28d,  0x28e,  0x28f,  0x290,  0x291,  0x292,  0x293,
/* 1e0 */  0x294,  0x295,  0x296,  0x297,  0x298,  0x299,  0x29a,  0x29b,
/* 1e8 */  0x29c,  0x29d,  0x29e,  0x29f,  0x2a0,  0x2a1,  0x2a2,  0x2a3,
/* 1f0 */  0x2a4,  0x2a5,  0x2a6,  0x2a7,  0x2a8,  0x2a9,  0x2aa,  0x2ab,
/* 1f8 */  0x2ac,  0x2ad,  0x2ae,  0x2af,  0x2b0,  0x2b1,  0x2b2,  0x2b3,
/* 200 */  0x2b4,  0x2b5,  0x2b6,  0x2b7,  0x2b8,  0x2b9,  0x2ba,  0x2bb,
/* 208 */  0x2bc,  0x2bd,  0x2be,  0x2bf,  0x2c0,  0x2c1,  0x2c2,  0x2c3,
/* 210 */  0x2c4,  0x2c5,  0x2c6,  0x2c7,  0x2c8,  0x2c9,  0x0fd,  0x2ca,
/* 218 */  0x2cb,  0x2cc,  0x2cd,  0x2ce,  0x2cf,  0x2d0,  0x2d1,  0x2d2,
/* 220 */  0x2d3,  0x2d4,  0x2d5,  0x2d6,  0x2d7,  0x2d8,  0x2d9,  0x2da,
/* 228 */  0x2db,  0x2dc,  0x2dd,  0x2de,  0x2df,  0x2e0,  0x2e1,  0x2e2,
/* 230 */  0x116,  0x2e3,  0x2e4,  0x2e5,  0x2e6,  0x2e7,  0x2e8,  0x2e9,
/* 238 */  0x2ea,  0x2eb,  0x2ec,  0x2ed,  0x2ee,  0x2ef,  0x2f0,  0x2f1,
/* 240 */  0x2f2,  0x2f3,  0x2f4,  0x2f5,  0x12a,  0x2f6,  0x2f7,  0x2f8,
/* 248 */  0x2f9,  0x2fa,  0x2fb,  0x2fc,  0x2fd,  0x2fe,  0x2ff,  0x300,
/* 250 */  0x301,  0x302,  0x303,  0x304,  0x305,  0x306,  0x307,  0x308,
/* 258 */  0x309,  0x30a,  0x30b,  0x30c,  0x30d,  0x30e,  0x30f,  0x310,
/* 260 */  0x311,  0x312,  0x313,  0x314,  0x315,  0x316,  0x317,  0x318,
/* 268 */  0x319,  0x31a,  0x31b,  0x31c,  0x31d,  0x31e,  0x31f,  0x320,
/* 270 */  0x321,  0x322,    BAD,  0x156,  0x323,  0x324,  0x325,  0x326,
/* 278 */  0x327,  0x328,  0x329,  0x32a,  0x32b,  0x32c,  0x32d,    BAD,
/* 280 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 288 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 290 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 298 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2c0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 2f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 300 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 308 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 310 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 318 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 320 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 328 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 330 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 338 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 340 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 348 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 350 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 358 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 360 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 368 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 370 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 378 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 380 */  0x32e,  0x32f,  0x330,  0x331,  0x332,  0x333,  0x334,  0x335,
/* 388 */  0x336,  0x337,  0x338,  0x339,  0x33a,  0x33b,  0x33c,  0x33d,
/* 390 */  0x33e,  0x33f,  0x340,  0x341,  0x342,  0x343,  0x344,  0x345,
/* 398 */  0x346,  0x347,  0x348,  0x349,  0x34a,  0x34b,  0x34c,  0x34d,
/* 3a0 */  0x34e,  0x34f,  0x350,  0x351,  0x352,  0x353,  0x354,  0x355,
/* 3a8 */    BAD,    BAD,  0x356,  0x357,  0x358,  0x359,  0x35a,  0x35b,
/* 3b0 */  0x35c,  0x35d,  0x35e,  0x35f,  0x360,  0x361,  0x362,  0x363,
/* 3b8 */  0x364,  0x365,  0x366,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3c0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3c8 */    BAD,    BAD,    BAD,    BAD,  0x367,  0x368,  0x369,  0x36a,
/* 3d0 */  0x36b,  0x36c,  0x36d,  0x36e,  0x36f,  0x370,    BAD,    BAD,
/* 3d8 */    BAD,    BAD,  0x371,    BAD,    BAD,    BAD,    BAD,  0x372,
/* 3e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3e8 */  0x168,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 3f8 */  0x169,  0x16a,    BAD,    BAD,  0x373,  0x16c,    BAD,  0x374,
/* 400 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 408 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 410 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 418 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 420 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 428 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 430 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 438 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 440 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 448 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 450 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 458 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 460 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 468 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 470 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 478 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 480 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 488 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 490 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 498 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 4a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 4a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 4b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 4b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 4c0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 4c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 4d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 4d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 4e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 4e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 4f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 4f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 500 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 508 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 510 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 518 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 520 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 528 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 530 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 538 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 540 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 548 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 550 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 558 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 560 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 568 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 570 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 578 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 580 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 588 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 590 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 598 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 5a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 5a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 5b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 5b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 5c0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 5c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 5d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 5d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 5e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 5e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 5f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 5f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 600 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 608 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 610 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 618 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 620 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 628 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 630 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 638 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 640 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 648 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 650 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 658 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 660 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 668 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 670 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 678 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 680 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 688 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 690 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 698 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 6a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 6a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 6b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 6b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 6c0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 6c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 6d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 6d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 6e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 6e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 6f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 6f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 700 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 708 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 710 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 718 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 720 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 728 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 730 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 738 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 740 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 748 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 750 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 758 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 760 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 768 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 770 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 778 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 780 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 788 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 790 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 798 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 7a0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 7a8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 7b0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 7b8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 7c0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 7c8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 7d0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 7d8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 7e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 7e8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 7f0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 7f8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 800 */  0x375,  0x376,    BAD,  0x377,  0x378,    BAD,  0x379,  0x37a,
/* 808 */  0x37b,  0x37c,  0x37d,  0x37e,  0x37f,  0x380,  0x381,  0x382,
/* 810 */  0x383,  0x384,  0x385,  0x386,    BAD,  0x387,  0x388,  0x389,
/* 818 */  0x38a,    BAD,    BAD,    BAD,  0x38b,  0x38c,    BAD,    BAD,
/* 820 */  0x38d,  0x38e,    BAD,    BAD,  0x38f,  0x390,    BAD,    BAD,
/* 828 */  0x391,  0x392,  0x393,    BAD,    BAD,    BAD,  0x394,  0x395,
/* 830 */  0x396,  0x397,  0x398,  0x399,    BAD,  0x39a,  0x39b,    BAD,
/* 838 */  0x39c,  0x39d,  0x39e,  0x39f,  0x3a0,    BAD,  0x3a1,  0x3a2,
/* 840 */  0x3a3,  0x3a4,  0x3a5,  0x3a6,  0x3a7,  0x3a8,  0x3a9,  0x3aa,
/* 848 */    BAD,  0x3ab,  0x3ac,  0x3ad,  0x3ae,    BAD,  0x3af,  0x3b0,
/* 850 */    BAD,  0x3b1,  0x3b2,  0x3b3,    BAD,    BAD,  0x3b4,    BAD,
/* 858 */  0x3b5,  0x3b6,  0x3b7,  0x3b8,  0x3b9,  0x3ba,  0x3bb,  0x3bc,
/* 860 */  0x3bd,  0x3be,  0x3bf,  0x3c0,  0x3c1,  0x3c2,  0x3c3,  0x3c4,
/* 868 */    BAD,  0x3c5,    BAD,    BAD,    BAD,  0x3c6,    BAD,    BAD,
/* 870 */    BAD,    BAD,  0x3c7,    BAD,    BAD,  0x3c8,  0x3c9,  0x3ca,
/* 878 */  0x3cb,    BAD,  0x3cc,  0x3cd,    BAD,  0x3ce,  0x3cf,    BAD,
/* 880 */    BAD,  0x3d0,  0x3d1,  0x3d2,  0x3d3,  0x3d4,  0x3d5,  0x3d6,
/* 888 */    BAD,  0x3d7,    BAD,    BAD,  0x3d8,    BAD,  0x3d9,  0x3da,
/* 890 */    BAD,  0x3db,  0x3dc,    BAD,  0x3dd,    BAD,  0x3de,    BAD,
/* 898 */  0x3df,  0x3e0,  0x3e1,  0x3e2,  0x3e3,  0x3e4,  0x3e5,    BAD,
/* 8a0 */  0x3e6,  0x3e7,  0x3e8,  0x3e9,  0x3ea,  0x3eb,  0x3ec,    BAD,
/* 8a8 */    BAD,    BAD,    BAD,  0x3ed,  0x3ee,  0x3ef,    BAD,  0x3f0,
/* 8b0 */  0x3f1,  0x3f2,  0x3f3,  0x3f4,  0x3f5,  0x3f6,  0x3f7,    BAD,
/* 8b8 */  0x3f8,  0x3f9,    BAD,    BAD,    BAD,    BAD,    BAD,  0x3fa,
/* 8c0 */    BAD,  0x3fb,  0x3fc,  0x3fd,  0x3fe,    BAD,  0x3ff,  0x400,
/* 8c8 */  0x401,  0x402,  0x403,  0x404,  0x405,    BAD,  0x406,  0x407,
/* 8d0 */  0x408,  0x409,    BAD,  0x40a,  0x40b,  0x40c,  0x40d,  0x40e,
/* 8d8 */  0x40f,  0x410,  0x411,  0x412,  0x413,  0x414,  0x415,  0x416,
/* 8e0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 8e8 */    BAD,    BAD,    BAD,  0x417,    BAD,  0x418,    BAD,    BAD,
/* 8f0 */    BAD,    BAD,  0x419,  0x41a,    BAD,  0x41b,  0x41c,  0x41d,
/* 8f8 */  0x41e,    BAD,  0x41f,  0x420,  0x421,  0x422,  0x423,  0x424,
/* 900 */  0x425,  0x426,  0x427,  0x428,  0x429,  0x42a,  0x42b,  0x42c,
/* 908 */  0x42d,  0x42e,  0x42f,  0x430,  0x431,  0x432,  0x433,  0x434,
/* 910 */  0x435,  0x436,  0x437,  0x438,  0x439,  0x43a,    BAD,    BAD,
/* 918 */  0x43b,  0x43c,  0x43d,  0x43e,  0x43f,    BAD,  0x440,    BAD,
/* 920 */  0x441,    BAD,    BAD,  0x442,  0x443,  0x444,  0x445,  0x446,
/* 928 */  0x447,  0x448,  0x449,  0x44a,    BAD,  0x44b,    BAD,  0x44c,
/* 930 */  0x44d,    BAD,  0x44e,  0x44f,  0x450,    BAD,  0x451,  0x452,
/* 938 */    BAD,  0x453,    BAD,    BAD,  0x454,  0x455,  0x456,  0x457,
/* 940 */    BAD,    BAD,  0x458,    BAD,    BAD,  0x459,    BAD,  0x45a,
/* 948 */  0x45b,    BAD,    BAD,  0x45c,  0x45d,    BAD,    BAD,    BAD,
/* 950 */  0x45e,  0x45f,    BAD,    BAD,    BAD,  0x460,  0x461,  0x462,
/* 958 */  0x463,  0x464,  0x465,  0x466,  0x467,  0x468,    BAD,  0x469,
/* 960 */    BAD,  0x46a,    BAD,  0x46b,    BAD,  0x46c,  0x46d,    BAD,
/* 968 */    BAD,    BAD,  0x46e,  0x46f,    BAD,  0x470,  0x471,  0x472,
/* 970 */  0x473,  0x474,    BAD,  0x475,  0x476,  0x477,    BAD,    BAD,
/* 978 */  0x478,    BAD,  0x479,  0x47a,    BAD,  0x47b,    BAD,  0x47c,
/* 980 */  0x47d,  0x47e,  0x47f,    BAD,  0x480,  0x481,  0x482,  0x483,
/* 988 */    BAD,  0x484,    BAD,  0x485,    BAD,  0x486,  0x487,    BAD,
/* 990 */  0x488,    BAD,  0x489,    BAD,  0x48a,  0x48b,  0x48c,    BAD,
/* 998 */  0x48d,    BAD,  0x48e,  0x48f,    BAD,  0x490,  0x491,  0x492,
/* 9a0 */    BAD,  0x493,  0x494,    BAD,  0x495,    BAD,  0x496,  0x497,
/* 9a8 */  0x498,  0x499,    BAD,    BAD,  0x49a,  0x49b,  0x49c,  0x49d,
/* 9b0 */  0x49e,  0x49f,  0x4a0,  0x4a1,  0x4a2,    BAD,  0x4a3,  0x4a4,
/* 9b8 */  0x4a5,  0x4a6,  0x4a7,  0x4a8,  0x4a9,  0x4aa,  0x4ab,  0x4ac,
/* 9c0 */  0x4ad,  0x4ae,  0x4af,  0x4b0,  0x4b1,  0x4b2,    BAD,    BAD,
/* 9c8 */  0x4b3,    BAD,    BAD,  0x4b4,    BAD,    BAD,  0x4b5,    BAD,
/* 9d0 */  0x4b6,    BAD,  0x4b7,    BAD,    BAD,    BAD,    BAD,  0x4b8,
/* 9d8 */  0x4b9,  0x4ba,  0x4bb,    BAD,  0x4bc,  0x4bd,  0x4be,    BAD,
/* 9e0 */    BAD,  0x4bf,    BAD,    BAD,  0x4c0,  0x4c1,    BAD,    BAD,
/* 9e8 */  0x4c2,  0x4c3,  0x4c4,  0x4c5,  0x4c6,    BAD,    BAD,  0x4c7,
/* 9f0 */  0x4c8,    BAD,    BAD,    BAD,  0x4c9,  0x4ca,  0x4cb,  0x4cc,
/* 9f8 */    BAD,  0x4cd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* a00 */  0x4ce,    BAD,  0x4cf,  0x4d0,  0x4d1,  0x4d2,    BAD,    BAD,
/* a08 */  0x4d3,  0x4d4,    BAD,  0x4d5,  0x4d6,  0x4d7,    BAD,    BAD,
/* a10 */  0x4d8,    BAD,  0x4d9,    BAD,  0x4da,  0x4db,    BAD,  0x4dc,
/* a18 */  0x4dd,    BAD,  0x4de,  0x4df,    BAD,    BAD,    BAD,    BAD,
/* a20 */  0x4e0,    BAD,    BAD,    BAD,  0x4e1,  0x4e2,  0x4e3,  0x4e4,
/* a28 */  0x4e5,  0x4e6,  0x4e7,  0x4e8,  0x4e9,  0x4ea,  0x4eb,  0x4ec,
/* a30 */  0x4ed,    BAD,    BAD,  0x4ee,  0x4ef,    BAD,    BAD,    BAD,
/* a38 */  0x4f0,  0x4f1,  0x4f2,  0x4f3,    BAD,    BAD,    BAD,    BAD,
/* a40 */    BAD,    BAD,  0x4f4,  0x4f5,  0x4f6,    BAD,  0x4f7,  0x4f8,
/* a48 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* a50 */  0x4f9,  0x4fa,    BAD,  0x4fb,    BAD,    BAD,  0x4fc,  0x4fd,
/* a58 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* a60 */    BAD,  0x4fe,  0x4ff,  0x500,  0x501,  0x502,  0x503,    BAD,
/* a68 */    BAD,    BAD,    BAD,    BAD,  0x504,    BAD,    BAD,  0x505,
/* a70 */    BAD,    BAD,  0x506,    BAD,  0x507,  0x508,    BAD,    BAD,
/* a78 */  0x509,  0x50a,  0x50b,  0x50c,  0x50d,    BAD,  0x50e,    BAD,
/* a80 */    BAD,    BAD,    BAD,  0x50f,  0x510,  0x511,  0x512,  0x513,
/* a88 */  0x514,    BAD,  0x515,  0x516,    BAD,    BAD,  0x517,    BAD,
/* a90 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,  0x518,
/* a98 */    BAD,    BAD,  0x519,    BAD,    BAD,    BAD,    BAD,    BAD,
/* aa0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* aa8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* ab0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* ab8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* ac0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* ac8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* ad0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* ad8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* ae0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* ae8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* af0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* af8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b40 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b48 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b50 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b58 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b60 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b68 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b70 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b78 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b80 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b88 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b90 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* b98 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* ba0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* ba8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* bb0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* bb8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* bc0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* bc8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* bd0 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* bd8 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* be0 */    BAD,  0x51a,  0x51b,  0x51c,    BAD,    BAD,  0x51d,  0x51e
};

/* Mapping table from Unicode to BChinese */

static cell2_t _ucs_to_zb_cell2[] = {
/* Row 0x000 */
{
/* 00 */ 0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0007,
/* 08 */ 0x0008, 0x0009, 0x000a, 0x000b, 0x000c, 0x000d, 0x000e, 0x000f,
/* 10 */ 0x0010, 0x0011, 0x0012, 0x0013, 0x0014, 0x0015, 0x0016, 0x0017,
/* 18 */ 0x0018, 0x0019, 0x001a, 0x001b, 0x001c, 0x001d, 0x001e, 0x001f,
/* 20 */ 0x0020, 0x0021, 0x0022, 0x0023, 0x0024, 0x0025, 0x0026, 0x0027,
/* 28 */ 0x0028, 0x0029, 0x002a, 0x002b, 0x002c, 0x002d, 0x002e, 0x002f,
/* 30 */ 0x0030, 0x0031, 0x0032, 0x0033, 0x0034, 0x0035, 0x0036, 0x0037,
/* 38 */ 0x0038, 0x0039, 0x003a, 0x003b, 0x003c, 0x003d, 0x003e, 0x003f
},

/* Row 0x001 */
{
/* 00 */ 0x0040, 0x0041, 0x0042, 0x0043, 0x0044, 0x0045, 0x0046, 0x0047,
/* 08 */ 0x0048, 0x0049, 0x004a, 0x004b, 0x004c, 0x004d, 0x004e, 0x004f,
/* 10 */ 0x0050, 0x0051, 0x0052, 0x0053, 0x0054, 0x0055, 0x0056, 0x0057,
/* 18 */ 0x0058, 0x0059, 0x005a, 0x005b, 0x005c, 0x005d, 0x005e, 0x005f,
/* 20 */ 0x0060, 0x0061, 0x0062, 0x0063, 0x0064, 0x0065, 0x0066, 0x0067,
/* 28 */ 0x0068, 0x0069, 0x006a, 0x006b, 0x006c, 0x006d, 0x006e, 0x006f,
/* 30 */ 0x0070, 0x0071, 0x0072, 0x0073, 0x0074, 0x0075, 0x0076, 0x0077,
/* 38 */ 0x0078, 0x0079, 0x007a, 0x007b, 0x007c, 0x007d, 0x007e, 0x007f
},

/* Row 0x002 */
{
/* 00 */ 0x0080,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xa246, 0xa247,    BAD, 0xa244,    BAD, 0xa1b1,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xa258, 0xa1d3,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa150,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x003 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa1d1,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa1d2,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x004 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa3be,
/* 08 */    BAD, 0xa3bc, 0xa3bd, 0xa3bf,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xa3bb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x005 */
{
/* 00 */ 0x0060, 0xa3bd, 0x005e,    BAD,    BAD, 0xa1c2,    BAD, 0xa3bb,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xa3be,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x005f,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x006 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xa344, 0xa345, 0xa346, 0xa347, 0xa348, 0xa349, 0xa34a,
/* 18 */ 0xa34b, 0xa34c, 0xa34d, 0xa34e, 0xa34f, 0xa350, 0xa351, 0xa352,
/* 20 */ 0xa353, 0xa354,    BAD, 0xa355, 0xa356, 0xa357, 0xa358, 0xa359,
/* 28 */ 0xa35a, 0xa35b,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xa35c, 0xa35d, 0xa35e, 0xa35f, 0xa360, 0xa361, 0xa362,
/* 38 */ 0xa363, 0xa364, 0xa365, 0xa366, 0xa367, 0xa368, 0xa369, 0xa36a
},

/* Row 0x007 */
{
/* 00 */ 0xa36b, 0xa36c,    BAD, 0xa36d, 0xa36e, 0xa36f, 0xa370, 0xa371,
/* 08 */ 0xa372, 0xa373,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x008 */
{
/* 00 */    BAD, 0xc7b3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xc7b1, 0xc7b2, 0xc7b4, 0xc7b5,
/* 18 */ 0xc7b6, 0xc7b7, 0xc7b8, 0xc7b9, 0xc7ba,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xc7bb, 0xc7bc, 0xc7bd, 0xc7be, 0xc7bf,
/* 28 */ 0xc7c0, 0xc7c1, 0xc7c2, 0xc7c3, 0xc7c4, 0xc7c5, 0xc7c6, 0xc7c7,
/* 30 */ 0xc7c8, 0xc7c9, 0xc7ca, 0xc7cb, 0xc7cc, 0xc7cd, 0xc7cf, 0xc7d0,
/* 38 */ 0xc7d1, 0xc7d2, 0xc7d3, 0xc7d4, 0xc7d5, 0xc7d6, 0xc7d7, 0xc7d8
},

/* Row 0x009 */
{
/* 00 */ 0xc7d9, 0xc7da, 0xc7db, 0xc7dc, 0xc7dd, 0xc7de, 0xc7df, 0xc7e0,
/* 08 */ 0xc7e1, 0xc7e2, 0xc7e3, 0xc7e4, 0xc7e5, 0xc7e6, 0xc7e7, 0xc7e8,
/* 10 */    BAD, 0xc7ce,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x00a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xa156, 0xa158,    BAD,    BAD,    BAD,
/* 18 */ 0xa1a5, 0xa1a6,    BAD,    BAD, 0xa1a7, 0xa1a8,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xa145,    BAD,    BAD, 0xa14c, 0xa14b,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xa1ac,    BAD,    BAD, 0xa1ab,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xa1b0,    BAD,    BAD, 0xa1c2,    BAD
},

/* Row 0x00b */
{
/* 00 */    BAD,    BAD,    BAD, 0xa24a,    BAD, 0xa1c1,    BAD,    BAD,
/* 08 */    BAD, 0xa24b,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x00c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xa2b9, 0xa2ba, 0xa2bb, 0xa2bc, 0xa2bd, 0xa2be, 0xa2bf, 0xa2c0,
/* 28 */ 0xa2c1, 0xa2c2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x00d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xa1f6, 0xa1f4, 0xa1f7, 0xa1f5,    BAD,    BAD, 0xa1f8, 0xa1f9,
/* 18 */ 0xa1fb, 0xa1fa,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x00e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xa1d4,    BAD,    BAD,    BAD, 0xa1db, 0xa1e8,
/* 20 */ 0xa1e7,    BAD,    BAD, 0xa1fd,    BAD, 0xa1fc,    BAD,    BAD,
/* 28 */    BAD, 0xa1e4, 0xa1e5, 0xa1ec,    BAD,    BAD, 0xa1ed,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xa1ef, 0xa1ee,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xa1e3,    BAD,    BAD,    BAD
},

/* Row 0x00f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xa1dc,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xa1da, 0xa1dd,    BAD,    BAD,    BAD,    BAD, 0xa1d8, 0xa1d9,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x010 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa1e6,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa1e9
},

/* Row 0x011 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xc7e9, 0xc7ea, 0xc7eb, 0xc7ec, 0xc7ed, 0xc7ee, 0xc7ef, 0xc7f0,
/* 28 */ 0xc7f1, 0xc7f2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xc7f3, 0xc7f4, 0xc7f5, 0xc7f6,
/* 38 */ 0xc7f7, 0xc7f8, 0xc7f9, 0xc7fa, 0xc7fb, 0xc7fc,    BAD,    BAD
},

/* Row 0x012 */
{
/* 00 */ 0xa277,    BAD, 0xa278,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xa27a,    BAD,    BAD,    BAD,
/* 10 */ 0xa27b,    BAD,    BAD,    BAD, 0xa27c,    BAD,    BAD,    BAD,
/* 18 */ 0xa27d,    BAD,    BAD,    BAD, 0xa275,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xa274,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xa273,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xa272,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xa271,    BAD,    BAD,    BAD
},

/* Row 0x013 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xa2a4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa2a5,    BAD,
/* 20 */    BAD, 0xa2a7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xa2a6,    BAD,    BAD, 0xa27e, 0xa2a1, 0xa2a3,
/* 30 */ 0xa2a2, 0xa2ac, 0xa2ad, 0xa2ae,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x014 */
{
/* 00 */    BAD, 0xa262, 0xa263, 0xa264, 0xa265, 0xa266, 0xa267, 0xa268,
/* 08 */ 0xa269, 0xa270, 0xa26f, 0xa26e, 0xa26d, 0xa26c, 0xa26b, 0xa26a,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xa276, 0xa279,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xa1bd, 0xa1bc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xa1b6, 0xa1b5,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xa1bf, 0xa1be,    BAD,    BAD
},

/* Row 0x015 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa1bb, 0xa1ba,
/* 08 */    BAD,    BAD,    BAD, 0xa1b3,    BAD,    BAD, 0xa1b7, 0xa1b4,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xa2a8, 0xa2a9, 0xa2ab, 0xa2aa,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x016 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa1b9, 0xa1b8,    BAD,
/* 08 */    BAD, 0xa1f3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x017 */
{
/* 00 */ 0xa1f0, 0xa1f2, 0xa1f1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x018 */
{
/* 00 */ 0xa140, 0xa142, 0xa143, 0xa1b2,    BAD, 0xc6a4,    BAD,    BAD,
/* 08 */ 0xa171, 0xa172, 0xa16d, 0xa16e, 0xa175, 0xa176, 0xa179, 0xa17a,
/* 10 */ 0xa169, 0xa16a, 0xa245,    BAD, 0xa165, 0xa166,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa1a9, 0xa1aa,    BAD,
/* 20 */    BAD, 0xa2c3, 0xa2c4, 0xa2c5, 0xa2c6, 0xa2c7, 0xa2c8, 0xa2c9,
/* 28 */ 0xa2ca, 0xa2cb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x019 */
{
/* 00 */    BAD, 0xc6a5, 0xc6a6, 0xc6a7, 0xc6a8, 0xc6a9, 0xc6aa, 0xc6ab,
/* 08 */ 0xc6ac, 0xc6ad, 0xc6ae, 0xc6af, 0xc6b0, 0xc6b1, 0xc6b2, 0xc6b3,
/* 10 */ 0xc6b4, 0xc6b5, 0xc6b6, 0xc6b7, 0xc6b8, 0xc6b9, 0xc6ba, 0xc6bb,
/* 18 */ 0xc6bc, 0xc6bd, 0xc6be, 0xc6bf, 0xc6c0, 0xc6c1, 0xc6c2, 0xc6c3,
/* 20 */ 0xc6c4, 0xc6c5, 0xc6c6, 0xc6c7, 0xc6c8, 0xc6c9, 0xc6ca, 0xc6cb,
/* 28 */ 0xc6cc, 0xc6cd, 0xc6ce, 0xc6cf, 0xc6d0, 0xc6d1, 0xc6d2, 0xc6d3,
/* 30 */ 0xc6d4, 0xc6d5, 0xc6d6, 0xc6d7, 0xc6d8, 0xc6d9, 0xc6da, 0xc6db,
/* 38 */ 0xc6dc, 0xc6dd, 0xc6de, 0xc6df, 0xc6e0, 0xc6e1, 0xc6e2, 0xc6e3
},

/* Row 0x01a */
{
/* 00 */ 0xc6e4, 0xc6e5, 0xc6e6, 0xc6e7, 0xc6e8, 0xc6e9, 0xc6ea, 0xc6eb,
/* 08 */ 0xc6ec, 0xc6ed, 0xc6ee, 0xc6ef, 0xc6f0, 0xc6f1, 0xc6f2, 0xc6f3,
/* 10 */ 0xc6f4, 0xc6f5, 0xc6f6, 0xc6f7,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc6a2, 0xc6a3,    BAD,
/* 20 */    BAD, 0xc6f8, 0xc6f9, 0xc6fa, 0xc6fb, 0xc6fc, 0xc6fd, 0xc6fe,
/* 28 */ 0xc740, 0xc741, 0xc742, 0xc743, 0xc744, 0xc745, 0xc746, 0xc747,
/* 30 */ 0xc748, 0xc749, 0xc74a, 0xc74b, 0xc74c, 0xc74d, 0xc74e, 0xc74f,
/* 38 */ 0xc750, 0xc751, 0xc752, 0xc753, 0xc754, 0xc755, 0xc756, 0xc757
},

/* Row 0x01b */
{
/* 00 */ 0xc758, 0xc759, 0xc75a, 0xc75b, 0xc75c, 0xc75d, 0xc75e, 0xc75f,
/* 08 */ 0xc760, 0xc761, 0xc762, 0xc763, 0xc764, 0xc765, 0xc766, 0xc767,
/* 10 */ 0xc768, 0xc769, 0xc76a, 0xc76b, 0xc76c, 0xc76d, 0xc76e, 0xc76f,
/* 18 */ 0xc770, 0xc771, 0xc772, 0xc773, 0xc774, 0xc775, 0xc776, 0xc777,
/* 20 */ 0xc778, 0xc779, 0xc77a, 0xc77b, 0xc77c, 0xc77d, 0xc77e, 0xc7a1,
/* 28 */ 0xc7a2, 0xc7a3, 0xc7a4, 0xc7a5, 0xc7a6, 0xc7a7, 0xc7a8, 0xc7a9,
/* 30 */ 0xc7aa, 0xc7ab, 0xc7ac, 0xc7ad, 0xc7ae, 0xc7af, 0xc7b0,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc6a1,    BAD
},

/* Row 0x01c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa374, 0xa375, 0xa376,
/* 08 */ 0xa377, 0xa378, 0xa379, 0xa37a, 0xa37b, 0xa37c, 0xa37d, 0xa37e,
/* 10 */ 0xa3a1, 0xa3a2, 0xa3a3, 0xa3a4, 0xa3a5, 0xa3a6, 0xa3a7, 0xa3a8,
/* 18 */ 0xa3a9, 0xa3aa, 0xa3ab, 0xa3ac, 0xa3ad, 0xa3ae, 0xa3af, 0xa3b0,
/* 20 */ 0xa3b1, 0xa3b2, 0xa3b3, 0xa3b4, 0xa3b5, 0xa3b6, 0xa3b7, 0xa3b8,
/* 28 */ 0xa3b9, 0xa3ba,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x01d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xa1c0,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x01e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa255, 0xa256,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xa250, 0xa251, 0xa252,    BAD,
/* 20 */    BAD, 0xa254,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x01f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xa257,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa253,    BAD,
/* 10 */    BAD, 0xa1eb, 0xa1ea,    BAD,    BAD, 0xa24f,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x020 */
{
/* 00 */ 0xa440, 0xa442,    BAD, 0xa443,    BAD,    BAD,    BAD, 0xc945,
/* 08 */ 0xa456, 0xa454, 0xa457, 0xa455, 0xc946, 0xa4a3, 0xc94f, 0xc94d,
/* 10 */ 0xa4a2, 0xa4a1,    BAD,    BAD, 0xa542, 0xa541, 0xa540,    BAD,
/* 18 */ 0xa543, 0xa4fe,    BAD,    BAD,    BAD,    BAD, 0xa5e0, 0xa5e1,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa8c3,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xa458,    BAD, 0xa4a4, 0xc950,    BAD,
/* 30 */ 0xa4a5, 0xc963, 0xa6ea, 0xcbb1,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xa459, 0xa4a6,    BAD, 0xa544, 0xc964,    BAD,    BAD,    BAD
},

/* Row 0x021 */
{
/* 00 */    BAD,    BAD, 0xc940, 0xa444,    BAD, 0xa45b,    BAD, 0xc947,
/* 08 */ 0xa45c,    BAD,    BAD, 0xa4a7,    BAD, 0xa545, 0xa547, 0xa546,
/* 10 */    BAD,    BAD, 0xa5e2, 0xa5e3,    BAD,    BAD, 0xa8c4,    BAD,
/* 18 */ 0xadbc, 0xa441,    BAD,    BAD, 0xc941, 0xa445, 0xa45e, 0xa45d,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xa5e4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xa8c5,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb0ae, 0xd44b
},

/* Row 0x022 */
{
/* 00 */    BAD,    BAD, 0xb6c3, 0xdcb1, 0xdcb2,    BAD, 0xa446,    BAD,
/* 08 */ 0xa4a9,    BAD,    BAD, 0xa8c6, 0xa447, 0xc948, 0xa45f,    BAD,
/* 10 */    BAD, 0xa4aa, 0xa4ac, 0xc951, 0xa4ad, 0xa4ab,    BAD,    BAD,
/* 18 */    BAD, 0xa5e5,    BAD, 0xa8c7,    BAD,    BAD, 0xa8c8, 0xab45,
/* 20 */    BAD, 0xa460, 0xa4ae,    BAD, 0xa5e6, 0xa5e8, 0xa5e7,    BAD,
/* 28 */ 0xa6eb,    BAD,    BAD, 0xa8c9, 0xa8ca, 0xab46, 0xab47,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xadbd,    BAD,    BAD, 0xdcb3,    BAD,
/* 38 */    BAD, 0xf6d6, 0xa448,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x023 */
{
/* 00 */ 0xa4b0, 0xa4af, 0xc952, 0xa4b1, 0xa4b7,    BAD, 0xa4b2, 0xa4b3,
/* 08 */ 0xc954, 0xc953, 0xa4b5, 0xa4b6,    BAD, 0xa4b4,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xa54a, 0xa54b, 0xa54c, 0xa54d,
/* 18 */ 0xa549, 0xa550, 0xc96a,    BAD, 0xc966, 0xc969, 0xa551, 0xa561,
/* 20 */    BAD, 0xc968,    BAD, 0xa54e, 0xa54f, 0xa548,    BAD,    BAD,
/* 28 */ 0xc965, 0xc967,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xa5f5, 0xc9b0, 0xa5f2, 0xa5f6, 0xc9ba, 0xc9ae, 0xa5f3, 0xc9b2,
/* 38 */    BAD,    BAD,    BAD, 0xa5f4,    BAD, 0xa5f7,    BAD, 0xa5e9
},

/* Row 0x024 */
{
/* 00 */ 0xc9b1, 0xa5f8, 0xc9b5,    BAD, 0xc9b9, 0xc9b6,    BAD,    BAD,
/* 08 */ 0xc9b3, 0xa5ea, 0xa5ec, 0xa5f9,    BAD, 0xa5ee, 0xc9ab, 0xa5f1,
/* 10 */ 0xa5ef, 0xa5f0, 0xc9bb, 0xc9b8, 0xc9af, 0xa5ed,    BAD,    BAD,
/* 18 */ 0xc9ac, 0xa5eb,    BAD,    BAD,    BAD, 0xc9b4,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xc9b7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xc9ad, 0xca66,    BAD, 0xa742,
/* 30 */ 0xa6f4,    BAD,    BAD, 0xca67, 0xa6f1,    BAD, 0xa744,    BAD,
/* 38 */ 0xa6f9,    BAD, 0xa6f8, 0xca5b, 0xa6fc, 0xa6f7, 0xca60, 0xca68
},

/* Row 0x025 */
{
/* 00 */    BAD, 0xca64,    BAD, 0xa6fa,    BAD,    BAD, 0xa6fd, 0xa6ee,
/* 08 */ 0xa747, 0xca5d,    BAD,    BAD, 0xcbbd, 0xa6ec, 0xa743, 0xa6ed,
/* 10 */ 0xa6f5, 0xa6f6, 0xca62, 0xca5e, 0xa6fb, 0xa6f3, 0xca5a, 0xa6ef,
/* 18 */ 0xca65, 0xa745, 0xa748, 0xa6f2, 0xa740, 0xa746, 0xa6f0, 0xca63,
/* 20 */ 0xa741, 0xca69, 0xca5c, 0xa6fe, 0xca5f,    BAD,    BAD, 0xca61,
/* 28 */    BAD, 0xa8d8, 0xcbbf, 0xcbcb, 0xa8d0,    BAD, 0xcbcc, 0xa8cb,
/* 30 */ 0xa8d5,    BAD,    BAD, 0xa8ce, 0xcbb9, 0xa8d6, 0xcbb8, 0xcbbc,
/* 38 */ 0xcbc3, 0xcbc1, 0xa8de, 0xa8d9, 0xcbb3, 0xcbb5, 0xa8db, 0xa8cf
},

/* Row 0x026 */
{
/* 00 */ 0xcbb6, 0xcbc2, 0xcbc9, 0xa8d4, 0xcbbb, 0xcbb4, 0xa8d3, 0xcbb7,
/* 08 */ 0xa8d7, 0xcbba,    BAD, 0xa8d2,    BAD, 0xa8cd,    BAD, 0xa8dc,
/* 10 */ 0xcbc4, 0xa8dd, 0xcbc8,    BAD, 0xcbc6, 0xcbca, 0xa8da, 0xcbbe,
/* 18 */ 0xcbb2,    BAD, 0xcbc0, 0xa8d1, 0xcbc5, 0xa8cc, 0xcbc7,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xab56, 0xab4a,
/* 30 */    BAD,    BAD, 0xcde0, 0xcde8,    BAD, 0xab49, 0xab51, 0xab5d,
/* 38 */    BAD, 0xcdee, 0xcdec, 0xcde7,    BAD,    BAD,    BAD, 0xab4b
},

/* Row 0x027 */
{
/* 00 */ 0xcded, 0xcde3, 0xab59, 0xab50, 0xab58, 0xcdde,    BAD, 0xcdea,
/* 08 */    BAD, 0xcde1, 0xab54, 0xcde2,    BAD, 0xcddd, 0xab5b, 0xab4e,
/* 10 */ 0xab57, 0xab4d,    BAD, 0xcddf, 0xcde4,    BAD, 0xcdeb, 0xab55,
/* 18 */ 0xab52, 0xcde6, 0xab5a, 0xcde9, 0xcde5, 0xab4f, 0xab5c, 0xab53,
/* 20 */ 0xab4c, 0xab48,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xcdef,    BAD, 0xadd7, 0xadc1,
/* 30 */    BAD, 0xadd1,    BAD, 0xadd6, 0xd0d0, 0xd0cf, 0xd0d4, 0xd0d5,
/* 38 */ 0xadc4,    BAD, 0xadcd,    BAD,    BAD,    BAD, 0xadda,    BAD
},

/* Row 0x028 */
{
/* 00 */ 0xadce,    BAD,    BAD,    BAD,    BAD, 0xd0c9, 0xadc7, 0xd0ca,
/* 08 */    BAD, 0xaddc,    BAD, 0xadd3, 0xadbe, 0xadbf, 0xd0dd, 0xb0bf,
/* 10 */    BAD, 0xadcc, 0xadcb, 0xd0cb, 0xadcf, 0xd45b, 0xadc6, 0xd0d6,
/* 18 */ 0xadd5, 0xadd4, 0xadca, 0xd0ce, 0xd0d7,    BAD, 0xd0c8, 0xadc9,
/* 20 */ 0xd0d8, 0xadd2, 0xd0cc, 0xadc0,    BAD, 0xadc3, 0xadc2, 0xd0d9,
/* 28 */ 0xadd0, 0xadc5, 0xadd9, 0xaddb, 0xd0d3, 0xadd8,    BAD, 0xd0db,
/* 30 */ 0xd0cd, 0xd0dc,    BAD, 0xd0d1,    BAD, 0xd0da,    BAD, 0xd0d2,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xadc8,    BAD,    BAD,    BAD
},

/* Row 0x029 */
{
/* 00 */ 0xd463, 0xd457,    BAD, 0xb0b3,    BAD, 0xd45c, 0xd462, 0xb0b2,
/* 08 */ 0xd455, 0xb0b6, 0xd459, 0xd452, 0xb0b4, 0xd456, 0xb0b9, 0xb0be,
/* 10 */    BAD, 0xd467,    BAD, 0xd451,    BAD, 0xb0ba,    BAD, 0xd466,
/* 18 */    BAD,    BAD, 0xb0b5, 0xd458, 0xb0b1, 0xd453, 0xd44f, 0xd45d,
/* 20 */ 0xd450, 0xd44e, 0xd45a, 0xd460, 0xd461, 0xb0b7,    BAD,    BAD,
/* 28 */ 0xd85b, 0xd45e, 0xd44d, 0xd45f,    BAD, 0xb0c1, 0xd464, 0xb0c0,
/* 30 */ 0xd44c,    BAD, 0xd454, 0xd465, 0xb0bc, 0xb0bb, 0xb0b8, 0xb0bd,
/* 38 */    BAD,    BAD, 0xb0af,    BAD,    BAD, 0xb0b0,    BAD,    BAD
},

/* Row 0x02a */
{
/* 00 */ 0xb3c8,    BAD, 0xd85e, 0xd857,    BAD, 0xb3c5,    BAD, 0xd85f,
/* 08 */    BAD,    BAD,    BAD, 0xd855, 0xd858, 0xb3c4, 0xd859,    BAD,
/* 10 */    BAD, 0xb3c7, 0xd85d,    BAD, 0xd853, 0xd852, 0xb3c9,    BAD,
/* 18 */ 0xb3ca, 0xb3c6, 0xb3cb, 0xd851, 0xd85c, 0xd85a, 0xd854,    BAD,
/* 20 */    BAD,    BAD, 0xb3c3, 0xd856,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xb6ca, 0xb6c4, 0xdcb7, 0xb6cd,
/* 30 */ 0xdcbd, 0xdcc0, 0xb6c6, 0xb6c7, 0xdcba, 0xb6c5, 0xdcc3, 0xb6cb,
/* 38 */ 0xdcc4,    BAD, 0xdcbf, 0xb6cc,    BAD, 0xdcb4, 0xb6c9, 0xdcb5
},

/* Row 0x02b */
{
/* 00 */    BAD, 0xdcbe, 0xdcbc,    BAD, 0xdcb8, 0xb6c8, 0xdcb6, 0xb6ce,
/* 08 */ 0xdcbb, 0xdcc2, 0xdcb9, 0xdcc1,    BAD,    BAD, 0xb9b6, 0xb9b3,
/* 10 */    BAD, 0xb9b4,    BAD, 0xe0f9, 0xe0f1, 0xb9b2, 0xb9af, 0xe0f2,
/* 18 */    BAD,    BAD, 0xb9b1, 0xe0f5,    BAD, 0xe0f7,    BAD,    BAD,
/* 20 */ 0xe0fe,    BAD,    BAD, 0xe0fd, 0xe0f8, 0xb9ae, 0xe0f0, 0xb9ac,
/* 28 */ 0xe0f3, 0xb9b7, 0xe0f6,    BAD, 0xe0fa, 0xb9b0, 0xb9ad, 0xe0fc,
/* 30 */ 0xe0fb, 0xb9b5,    BAD, 0xe0f4,    BAD, 0xbbf8, 0xe4ec,    BAD,
/* 38 */ 0xe4e9, 0xbbf9,    BAD, 0xbbf7,    BAD, 0xe4f0, 0xe4ed, 0xe4e6
},

/* Row 0x02c */
{
/* 00 */ 0xbbf6,    BAD, 0xbbfa, 0xe4e7, 0xbbf5, 0xbbfd, 0xe4ea, 0xe4eb,
/* 08 */ 0xbbfb, 0xbbfc, 0xe4f1, 0xe4ee, 0xe4ef,    BAD,    BAD,    BAD,
/* 10 */ 0xbeaa, 0xe8f8, 0xbea7, 0xe8f5, 0xbea9, 0xbeab,    BAD, 0xe8f6,
/* 18 */ 0xbea8,    BAD, 0xe8f7,    BAD, 0xe8f4,    BAD,    BAD, 0xc076,
/* 20 */ 0xecbd, 0xc077, 0xecbb,    BAD, 0xecbc, 0xecba, 0xecb9,    BAD,
/* 28 */    BAD, 0xecbe, 0xc075,    BAD,    BAD, 0xefb8, 0xefb9,    BAD,
/* 30 */ 0xe4e8, 0xefb7, 0xc078, 0xc35f, 0xf1eb, 0xf1ec,    BAD, 0xc4d7,
/* 38 */ 0xc4d8, 0xf5c1, 0xf5c0, 0xc56c, 0xc56b, 0xf7d0,    BAD, 0xa449
},

/* Row 0x02d */
{
/* 00 */ 0xa461, 0xa4b9,    BAD, 0xa4b8, 0xa553, 0xa552, 0xa5fc, 0xa5fb,
/* 08 */ 0xa5fd, 0xa5fa,    BAD, 0xa74a, 0xa749, 0xa74b,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xa8e0,    BAD, 0xa8df, 0xa8e1,    BAD, 0xab5e,
/* 18 */    BAD, 0xa259, 0xd0de, 0xa25a, 0xb0c2, 0xa25c, 0xa25b, 0xd860,
/* 20 */    BAD, 0xa25d, 0xb9b8, 0xa25e,    BAD, 0xa44a,    BAD, 0xa4ba,
/* 28 */ 0xa5fe, 0xa8e2,    BAD, 0xa44b, 0xa4bd, 0xa4bb, 0xa4bc,    BAD,
/* 30 */    BAD, 0xa640,    BAD,    BAD,    BAD, 0xa74c, 0xa8e4, 0xa8e3,
/* 38 */ 0xa8e5,    BAD,    BAD,    BAD, 0xaddd,    BAD,    BAD,    BAD
},

/* Row 0x02e */
{
/* 00 */ 0xbeac,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc94e,
/* 08 */    BAD, 0xa554, 0xa555,    BAD,    BAD, 0xa641,    BAD, 0xca6a,
/* 10 */    BAD, 0xab60, 0xab5f, 0xd0e0, 0xd0df, 0xb0c3,    BAD, 0xa4be,
/* 18 */ 0xc955,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcbcd,    BAD,
/* 20 */ 0xab61,    BAD, 0xade0,    BAD, 0xadde, 0xaddf,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xbead,    BAD, 0xa556,    BAD,    BAD,    BAD,
/* 30 */ 0xa642, 0xc9bc,    BAD,    BAD,    BAD,    BAD, 0xa74d, 0xa74e,
/* 38 */    BAD, 0xca6b,    BAD,    BAD, 0xcbce, 0xa8e6, 0xcbcf,    BAD
},

/* Row 0x02f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xd0e2, 0xd0e3, 0xade3,    BAD,
/* 08 */ 0xd0e4,    BAD, 0xd0e1, 0xade4, 0xade2, 0xade1, 0xd0e5,    BAD,
/* 10 */ 0xd468,    BAD,    BAD,    BAD, 0xd861,    BAD,    BAD, 0xdcc5,
/* 18 */ 0xe140,    BAD,    BAD,    BAD, 0xbbfe, 0xbeae, 0xe8f9,    BAD,
/* 20 */ 0xa44c, 0xa45a,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xb0c4, 0xb3cd,    BAD, 0xb9b9,    BAD, 0xc942, 0xa4bf,    BAD,
/* 38 */ 0xa559, 0xa557, 0xa558,    BAD,    BAD, 0xa8e7,    BAD,    BAD
},

/* Row 0x030 */
{
/* 00 */ 0xa44d, 0xa44e,    BAD, 0xa462,    BAD,    BAD, 0xa4c0, 0xa4c1,
/* 08 */ 0xa4c2, 0xc9be, 0xa55a,    BAD, 0xc96b,    BAD, 0xa646,    BAD,
/* 10 */ 0xc9bf, 0xa644, 0xa645, 0xc9bd,    BAD,    BAD, 0xa647, 0xa643,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xca6c, 0xaaec, 0xca6d,    BAD,
/* 20 */    BAD, 0xca6e,    BAD,    BAD, 0xa750, 0xa74f,    BAD,    BAD,
/* 28 */ 0xa753, 0xa751, 0xa752,    BAD,    BAD,    BAD, 0xa8ed,    BAD,
/* 30 */ 0xa8ec, 0xcbd4, 0xcbd1, 0xcbd2,    BAD, 0xcbd0, 0xa8ee, 0xa8ea,
/* 38 */ 0xa8e9,    BAD, 0xa8eb, 0xa8e8,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x031 */
{
/* 00 */    BAD, 0xa8ef,    BAD, 0xab63, 0xcdf0,    BAD, 0xcbd3, 0xab68,
/* 08 */    BAD, 0xcdf1, 0xab64, 0xab67, 0xab66, 0xab65, 0xab62,    BAD,
/* 10 */    BAD,    BAD, 0xd0e8,    BAD, 0xade7, 0xd0eb, 0xade5,    BAD,
/* 18 */    BAD,    BAD, 0xd0e7, 0xade8, 0xade6, 0xade9, 0xd0e9, 0xd0ea,
/* 20 */    BAD, 0xd0e6, 0xd0ec,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xb3d1, 0xb0c5, 0xd469, 0xd46b, 0xd46a, 0xd46c, 0xb0c6,
/* 30 */    BAD,    BAD, 0xb3ce,    BAD, 0xb3cf, 0xb3d0,    BAD, 0xb6d0,
/* 38 */ 0xdcc7,    BAD, 0xdcc6, 0xdcc8, 0xdcc9, 0xb6d1,    BAD, 0xb6cf
},

/* Row 0x032 */
{
/* 00 */ 0xe141, 0xe142, 0xb9bb, 0xb9ba, 0xe35a,    BAD,    BAD, 0xbc40,
/* 08 */ 0xbc41, 0xbc42, 0xbc44, 0xe4f2, 0xe4f3, 0xbc43,    BAD,    BAD,
/* 10 */    BAD, 0xbeaf,    BAD, 0xbeb0,    BAD,    BAD, 0xf1ed, 0xf5c3,
/* 18 */ 0xf5c2, 0xf7d1,    BAD, 0xa44f,    BAD,    BAD,    BAD, 0xa55c,
/* 20 */ 0xa55b,    BAD,    BAD, 0xa648,    BAD,    BAD, 0xc9c0,    BAD,
/* 28 */    BAD, 0xa755, 0xa756, 0xa754, 0xa757, 0xca6f, 0xca70,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xa8f1, 0xcbd5,    BAD, 0xa8f0,    BAD
},

/* Row 0x033 */
{
/* 00 */ 0xcdf2, 0xab6c, 0xcdf3, 0xab6b,    BAD,    BAD,    BAD, 0xab69,
/* 08 */    BAD, 0xab6a,    BAD,    BAD,    BAD, 0xd0ed,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xb0c7, 0xd46e,    BAD, 0xb0ca, 0xd46d, 0xb1e5,
/* 18 */ 0xb0c9, 0xb0c8,    BAD, 0xb3d4,    BAD, 0xb3d3, 0xb3d2, 0xb6d2,
/* 20 */    BAD,    BAD, 0xb6d5, 0xb6d6, 0xb6d4,    BAD, 0xb6d3,    BAD,
/* 28 */    BAD, 0xe143,    BAD, 0xe144,    BAD,    BAD,    BAD, 0xe4f5,
/* 30 */ 0xbc45, 0xe4f4,    BAD, 0xbeb1, 0xecbf, 0xc079,    BAD, 0xf1ee,
/* 38 */ 0xc455,    BAD, 0xa463, 0xa4c3, 0xc956,    BAD, 0xa4c4, 0xa4c5
},

/* Row 0x034 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa55d, 0xa55e,    BAD,
/* 08 */ 0xa649, 0xca71, 0xcbd6, 0xcbd7,    BAD, 0xab6d, 0xd0ee, 0xb0cc,
/* 10 */ 0xb0cb, 0xd863, 0xd862,    BAD,    BAD, 0xa450, 0xa4c6, 0xa55f,
/* 18 */    BAD, 0xb0cd, 0xc943,    BAD, 0xc96c, 0xa560,    BAD, 0xc9c2,
/* 20 */ 0xa64b, 0xa64a, 0xc9c1, 0xa758,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xadea,    BAD,    BAD, 0xd46f,    BAD, 0xb6d7,
/* 30 */ 0xe145, 0xb9bc,    BAD,    BAD, 0xe8fa,    BAD,    BAD, 0xf3fd,
/* 38 */    BAD, 0xa4c7,    BAD,    BAD, 0xcbd8, 0xcdf4, 0xb0d0, 0xb0ce
},

/* Row 0x035 */
{
/* 00 */ 0xb0cf, 0xa451,    BAD, 0xa464, 0xa2cd, 0xa4ca,    BAD, 0xa4c9,
/* 08 */ 0xa4c8, 0xa563, 0xa562,    BAD, 0xc96d, 0xc9c3,    BAD,    BAD,
/* 10 */    BAD, 0xa8f5, 0xa8f2, 0xa8f4, 0xa8f3,    BAD,    BAD, 0xab6e,
/* 18 */    BAD,    BAD, 0xb3d5,    BAD, 0xa452,    BAD, 0xa4cb,    BAD,
/* 20 */ 0xa565, 0xa564,    BAD, 0xca72,    BAD,    BAD, 0xa8f6,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xc957,    BAD, 0xa567, 0xa566,
/* 30 */ 0xa64c, 0xa64d, 0xca73, 0xa759,    BAD, 0xa75a,    BAD, 0xa8f7,
/* 38 */ 0xa8f8, 0xa8f9,    BAD, 0xab6f, 0xcdf5,    BAD,    BAD, 0xadeb
},

/* Row 0x036 */
{
/* 00 */    BAD,    BAD, 0xc944,    BAD, 0xa4cc,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xc9c4,    BAD,    BAD,    BAD, 0xca74, 0xca75,
/* 10 */    BAD,    BAD, 0xcbd9,    BAD, 0xcbda,    BAD, 0xcdf7, 0xcdf6,
/* 18 */ 0xcdf9, 0xcdf8, 0xab70,    BAD, 0xd470, 0xaded, 0xd0ef, 0xadec,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xd864, 0xb3d6,    BAD, 0xd865,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe146, 0xb9bd,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xbc46,    BAD, 0xf1ef,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xc958,    BAD, 0xa568,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x037 */
{
/* 00 */    BAD,    BAD,    BAD, 0xb0d1,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xa453, 0xa465, 0xa4ce, 0xa4cd,    BAD, 0xa4cf,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xa8fb,    BAD, 0xa8fa, 0xa8fc,
/* 18 */    BAD,    BAD,    BAD, 0xab71,    BAD,    BAD,    BAD, 0xadee,
/* 20 */    BAD, 0xe8fb, 0xc24f, 0xa466, 0xa56a, 0xa579, 0xa574,    BAD,
/* 28 */ 0xa56f, 0xa56e, 0xa575, 0xa573, 0xa56c, 0xa57a, 0xa56d, 0xa569,
/* 30 */ 0xa578, 0xa577, 0xa576, 0xa56b,    BAD, 0xa572,    BAD,    BAD,
/* 38 */ 0xa571,    BAD,    BAD, 0xa57b, 0xa570,    BAD,    BAD,    BAD
},

/* Row 0x038 */
{
/* 00 */    BAD, 0xa653,    BAD, 0xa659, 0xa655,    BAD, 0xa65b, 0xc9c5,
/* 08 */ 0xa658, 0xa64e, 0xa651, 0xa654, 0xa650, 0xa657, 0xa65a, 0xa64f,
/* 10 */ 0xa652, 0xa656, 0xa65c,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xca7e, 0xca7b,    BAD, 0xa767, 0xca7c, 0xa75b, 0xa75d, 0xa775,
/* 20 */ 0xa770,    BAD,    BAD,    BAD, 0xcaa5, 0xca7d, 0xa75f, 0xa761,
/* 28 */ 0xcaa4, 0xa768, 0xca78, 0xa774, 0xa776, 0xa75c, 0xa76d,    BAD,
/* 30 */ 0xca76, 0xa773,    BAD, 0xa764,    BAD, 0xa76e, 0xa76f, 0xca77,
/* 38 */ 0xa76c, 0xa76a,    BAD, 0xa76b, 0xa771, 0xcaa1, 0xa75e,    BAD
},

/* Row 0x039 */
{
/* 00 */ 0xa772, 0xcaa3, 0xa766, 0xa763,    BAD, 0xca7a, 0xa762, 0xcaa6,
/* 08 */ 0xa765,    BAD, 0xa769,    BAD,    BAD,    BAD, 0xa760, 0xcaa2,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xca79,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xcbeb, 0xcbea, 0xa94f, 0xcbed, 0xcbef, 0xcbe4, 0xcbe7, 0xcbee,
/* 28 */ 0xa950,    BAD,    BAD, 0xcbe1, 0xcbe5,    BAD,    BAD, 0xcbe9,
/* 30 */ 0xce49, 0xa94b, 0xce4d, 0xa8fd, 0xcbe6, 0xa8fe, 0xa94c, 0xa945,
/* 38 */ 0xa941,    BAD, 0xcbe2, 0xa944, 0xa949, 0xa952, 0xcbe3, 0xcbdc
},

/* Row 0x03a */
{
/* 00 */ 0xa943, 0xcbdd, 0xcbdf,    BAD, 0xa946,    BAD, 0xa948, 0xcbdb,
/* 08 */ 0xcbe0,    BAD,    BAD, 0xa951, 0xa94d, 0xcbe8, 0xa953,    BAD,
/* 10 */ 0xa94a, 0xcbde, 0xa947,    BAD,    BAD, 0xa942, 0xa940,    BAD,
/* 18 */ 0xcbec,    BAD, 0xa94e,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xce48, 0xcdfb, 0xce4b,    BAD,    BAD, 0xcdfd, 0xab78, 0xaba8,
/* 28 */ 0xab74, 0xaba7, 0xab7d, 0xaba4, 0xab72, 0xcdfc, 0xce43, 0xaba3,
/* 30 */ 0xce4f, 0xaba5,    BAD, 0xab79,    BAD,    BAD, 0xce45, 0xce42,
/* 38 */ 0xab77,    BAD, 0xcdfa, 0xaba6, 0xce4a, 0xab7c, 0xce4c, 0xaba9
},

/* Row 0x03b */
{
/* 00 */ 0xab73, 0xab7e, 0xab7b, 0xce40, 0xaba1, 0xce46, 0xce47, 0xab7a,
/* 08 */ 0xaba2, 0xab76,    BAD,    BAD,    BAD,    BAD, 0xab75, 0xcdfe,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xce44,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xce4e,    BAD,
/* 20 */ 0xd144, 0xadfb, 0xd0f1,    BAD, 0xd0f6, 0xadf4, 0xae40, 0xd0f4,
/* 28 */ 0xadef, 0xadf9, 0xadfe, 0xd0fb,    BAD, 0xadfa, 0xadfd,    BAD,
/* 30 */    BAD, 0xd0fe, 0xadf5, 0xd0f5,    BAD,    BAD,    BAD, 0xd142,
/* 38 */ 0xd143,    BAD, 0xadf7, 0xd141, 0xadf3, 0xae43,    BAD, 0xd0f8
},

/* Row 0x03c */
{
/* 00 */    BAD, 0xadf1,    BAD, 0xd146, 0xd0f9, 0xd0fd, 0xadf6, 0xae42,
/* 08 */ 0xd0fa, 0xadfc, 0xd140, 0xd147, 0xd4a1,    BAD, 0xd145, 0xae44,
/* 10 */ 0xadf0, 0xd0fc, 0xd0f3,    BAD, 0xadf8,    BAD,    BAD, 0xd0f2,
/* 18 */    BAD,    BAD, 0xd0f7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd0f0, 0xae41,
/* 28 */    BAD,    BAD, 0xd477,    BAD, 0xb0e4, 0xd4a7, 0xb0e2, 0xb0df,
/* 30 */ 0xd47c, 0xb0db, 0xd4a2, 0xb0e6, 0xd476, 0xd47b, 0xd47a, 0xadf2,
/* 38 */ 0xb0e1, 0xd4a5,    BAD, 0xd4a8, 0xd473,    BAD, 0xb3e8,    BAD
},

/* Row 0x03d */
{
/* 00 */ 0xd4a9, 0xb0e7,    BAD, 0xb0d9, 0xb0d6, 0xd47e, 0xb0d3,    BAD,
/* 08 */ 0xd4a6,    BAD, 0xb0da, 0xd4aa,    BAD, 0xd474, 0xd4a4, 0xb0dd,
/* 10 */ 0xd475, 0xd478, 0xd47d,    BAD,    BAD, 0xb0de, 0xb0dc, 0xb0e8,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xb0e3,    BAD, 0xb0d7, 0xb1d2,
/* 20 */    BAD, 0xb0d8, 0xd479, 0xb0e5, 0xb0e0, 0xd4a3, 0xb0d5,    BAD,
/* 28 */    BAD,    BAD, 0xb0d4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd471, 0xd472, 0xd86a,
/* 38 */    BAD,    BAD,    BAD, 0xb3d7, 0xb3da, 0xd875, 0xb3ee, 0xd878
},

/* Row 0x03e */
{
/* 00 */ 0xb3d8, 0xd871, 0xb3de, 0xb3e4, 0xb5bd,    BAD,    BAD, 0xb3e2,
/* 08 */ 0xd86e, 0xb3ef, 0xb3db, 0xb3e3, 0xd876, 0xdcd7, 0xd87b, 0xd86f,
/* 10 */    BAD, 0xd866, 0xd873, 0xd86d, 0xb3e1, 0xd879,    BAD,    BAD,
/* 18 */ 0xb3dd, 0xb3f1, 0xb3ea,    BAD, 0xb3df, 0xb3dc,    BAD, 0xb3e7,
/* 20 */    BAD, 0xd87a, 0xd86c, 0xd872, 0xd874, 0xd868, 0xd877, 0xb3d9,
/* 28 */ 0xd867,    BAD, 0xb3e0, 0xb3f0, 0xb3ec, 0xd869, 0xb3e6,    BAD,
/* 30 */    BAD, 0xb3ed, 0xb3e9, 0xb3e5,    BAD, 0xd870,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xb3eb,    BAD,    BAD,    BAD, 0xdcd5
},

/* Row 0x03f */
{
/* 00 */ 0xdcd1,    BAD, 0xdce0, 0xdcca, 0xdcd3, 0xb6e5, 0xb6e6, 0xb6de,
/* 08 */ 0xdcdc, 0xb6e8, 0xdccf, 0xdcce, 0xdccc, 0xdcde, 0xb6dc, 0xdcd8,
/* 10 */ 0xdccd, 0xb6df, 0xdcd6, 0xb6da, 0xdcd2, 0xdcd9, 0xdcdb,    BAD,
/* 18 */    BAD, 0xdcdf, 0xb6e3, 0xdccb, 0xb6dd, 0xdcd0,    BAD, 0xb6d8,
/* 20 */    BAD, 0xb6e4, 0xdcda, 0xb6e0, 0xb6e1, 0xb6e7, 0xb6db, 0xa25f,
/* 28 */ 0xb6d9, 0xdcd4,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb6e2,
/* 30 */    BAD,    BAD, 0xdcdd,    BAD,    BAD,    BAD, 0xb9cd, 0xb9c8,
/* 38 */    BAD, 0xe155, 0xe151,    BAD, 0xe14b, 0xb9c2, 0xb9be, 0xe154
},

/* Row 0x040 */
{
/* 00 */ 0xb9bf, 0xe14e, 0xe150,    BAD, 0xe153,    BAD, 0xb9c4,    BAD,
/* 08 */ 0xb9cb, 0xb9c5,    BAD,    BAD, 0xe149, 0xb9c6, 0xb9c7, 0xe14c,
/* 10 */ 0xb9cc,    BAD, 0xe14a, 0xe14f, 0xb9c3, 0xe148, 0xb9c9, 0xb9c1,
/* 18 */    BAD,    BAD,    BAD, 0xb9c0, 0xe14d, 0xe152,    BAD, 0xb9ca,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe147,
/* 28 */    BAD, 0xbc4d, 0xe547,    BAD, 0xe544,    BAD, 0xbc47, 0xbc53,
/* 30 */ 0xbc54,    BAD, 0xbc4a, 0xe542, 0xbc4c, 0xe4f9, 0xbc52,    BAD,
/* 38 */ 0xe546, 0xbc49, 0xe548, 0xbc48,    BAD, 0xe543, 0xe545, 0xbc4b
},

/* Row 0x041 */
{
/* 00 */ 0xe541, 0xe4fa, 0xe4f7,    BAD,    BAD, 0xd86b, 0xe4fd,    BAD,
/* 08 */ 0xe4f6, 0xe4fc, 0xe4fb,    BAD, 0xe4f8,    BAD, 0xbc4f,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xbc4e,    BAD,    BAD,    BAD, 0xbc50,
/* 18 */ 0xe4fe, 0xbeb2, 0xe540,    BAD,    BAD,    BAD, 0xe945,    BAD,
/* 20 */ 0xe8fd,    BAD, 0xbebe, 0xe942, 0xbeb6, 0xbeba, 0xe941,    BAD,
/* 28 */ 0xbeb9, 0xbeb5, 0xbeb8, 0xbeb3, 0xbebd, 0xe943, 0xe8fe, 0xbebc,
/* 30 */ 0xe8fc, 0xbebb, 0xe944, 0xe940, 0xbc51,    BAD, 0xbebf, 0xe946,
/* 38 */ 0xbeb7, 0xbeb4,    BAD,    BAD,    BAD,    BAD, 0xecc6, 0xecc8
},

/* Row 0x042 */
{
/* 00 */ 0xc07b, 0xecc9, 0xecc7, 0xecc5, 0xecc4, 0xc07d, 0xecc3, 0xc07e,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xecc1, 0xecc2, 0xc07a, 0xc0a1,
/* 10 */ 0xc07c,    BAD,    BAD, 0xecc0,    BAD, 0xc250,    BAD, 0xefbc,
/* 18 */ 0xefba, 0xefbf, 0xefbd,    BAD, 0xefbb, 0xefbe,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc360, 0xf1f2, 0xf1f3,
/* 28 */ 0xc456,    BAD, 0xf1f4, 0xf1f0, 0xf1f5, 0xf1f1, 0xc251,    BAD,
/* 30 */    BAD,    BAD, 0xf3fe, 0xf441, 0xc459, 0xf440, 0xc458, 0xc457,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xc45a, 0xf5c5, 0xf5c6,    BAD
},

/* Row 0x043 */
{
/* 00 */ 0xc4da, 0xc4d9, 0xc4db, 0xf5c4,    BAD, 0xf6d8, 0xf6d7,    BAD,
/* 08 */ 0xc56d, 0xc56f, 0xc56e, 0xf6d9, 0xc5c8, 0xf8a6,    BAD,    BAD,
/* 10 */    BAD, 0xc5f1,    BAD, 0xf8a5, 0xf8ee,    BAD,    BAD, 0xc949,
/* 18 */    BAD,    BAD, 0xa57d, 0xa57c,    BAD, 0xa65f, 0xa65e, 0xc9c7,
/* 20 */ 0xa65d, 0xc9c6,    BAD,    BAD, 0xa779, 0xcaa9,    BAD, 0xcaa8,
/* 28 */    BAD,    BAD, 0xa777, 0xa77a,    BAD,    BAD, 0xcaa7,    BAD,
/* 30 */ 0xa778,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcbf0,
/* 38 */    BAD, 0xcbf1, 0xa954,    BAD,    BAD,    BAD,    BAD, 0xabaa
},

/* Row 0x044 */
{
/* 00 */    BAD, 0xd148, 0xd149, 0xae45, 0xae46,    BAD,    BAD, 0xd4ac,
/* 08 */ 0xb0e9, 0xb0eb, 0xd4ab, 0xb0ea, 0xd87c, 0xb3f2,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xb6e9, 0xb6ea, 0xdce1,    BAD, 0xb9cf,    BAD,
/* 18 */ 0xb9ce,    BAD, 0xe549, 0xe948, 0xe947,    BAD, 0xf96b, 0xa467,
/* 20 */ 0xc959,    BAD, 0xc96e, 0xc96f,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xa662, 0xa666, 0xc9c9,    BAD, 0xa664, 0xa663, 0xc9c8, 0xa665,
/* 30 */ 0xa661,    BAD,    BAD, 0xa660, 0xc9ca,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xa7a6,    BAD,    BAD, 0xa7a3,    BAD
},

/* Row 0x045 */
{
/* 00 */ 0xa77d, 0xcaaa,    BAD,    BAD,    BAD, 0xcaab,    BAD, 0xa7a1,
/* 08 */    BAD, 0xcaad, 0xa77b, 0xcaae, 0xcaac, 0xa77e, 0xa7a2, 0xa7a5,
/* 10 */ 0xa7a4, 0xa77c, 0xcaaf,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xa959, 0xcbfe,    BAD, 0xa95b,    BAD, 0xa95a,    BAD,
/* 28 */ 0xcc40, 0xa958, 0xa957, 0xcbf5,    BAD, 0xcbf4,    BAD, 0xcbf2,
/* 30 */ 0xcbf7, 0xcbf6, 0xcbf3, 0xcbfc, 0xcbfd, 0xcbfa, 0xcbf8, 0xa956,
/* 38 */    BAD,    BAD,    BAD, 0xcbfb, 0xa95c, 0xcc41,    BAD,    BAD
},

/* Row 0x046 */
{
/* 00 */ 0xcbf9,    BAD, 0xabab, 0xa955,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xabac, 0xce54,    BAD,    BAD, 0xce5a,
/* 10 */    BAD,    BAD,    BAD, 0xabb2, 0xce58, 0xce5e,    BAD, 0xce55,
/* 18 */ 0xce59, 0xce5b, 0xce5d, 0xce57,    BAD, 0xce56, 0xce51, 0xce52,
/* 20 */ 0xabad,    BAD, 0xabaf, 0xabae, 0xce53, 0xce5c,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xabb1,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xce50, 0xd153,    BAD,
/* 38 */ 0xd152, 0xd157, 0xd14e,    BAD, 0xd151, 0xd150,    BAD, 0xd154
},

/* Row 0x047 */
{
/* 00 */    BAD, 0xd158, 0xae47, 0xae4a,    BAD,    BAD, 0xd14f, 0xd155,
/* 08 */    BAD,    BAD,    BAD, 0xae49, 0xd14a,    BAD, 0xabb0, 0xd4ba,
/* 10 */ 0xd156,    BAD, 0xd14d,    BAD, 0xae48, 0xd14c,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xd4b1,    BAD,    BAD, 0xb0ec,
/* 20 */ 0xb0f0, 0xd4c1, 0xd4af, 0xd4bd, 0xb0f1, 0xd4bf,    BAD, 0xd4c5,
/* 28 */    BAD, 0xd4c9,    BAD,    BAD, 0xd4c0, 0xd4b4, 0xd4bc,    BAD,
/* 30 */ 0xd4ca, 0xd4c8, 0xd4be, 0xd4b9, 0xd4b2, 0xd8a6, 0xd4b0, 0xb0f5,
/* 38 */ 0xd4b7, 0xb0f6, 0xb0f2, 0xd4ad, 0xd4c3, 0xd4b5,    BAD,    BAD
},

/* Row 0x048 */
{
/* 00 */ 0xd4b3, 0xd4c6, 0xb0f3,    BAD, 0xd4cc, 0xb0ed, 0xb0ef, 0xd4bb,
/* 08 */ 0xd4b6, 0xae4b, 0xb0ee, 0xd4b8, 0xd4c7, 0xd4cb, 0xd4c2,    BAD,
/* 10 */ 0xd4c4,    BAD,    BAD,    BAD, 0xd4ae,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xd8a1,    BAD, 0xd8aa, 0xd8a9, 0xb3fa, 0xd8a2,    BAD,
/* 20 */ 0xb3fb, 0xb3f9,    BAD, 0xd8a4, 0xb3f6, 0xd8a8,    BAD, 0xd8a3,
/* 28 */ 0xd8a5, 0xd87d, 0xb3f4,    BAD, 0xd8b2, 0xd8b1, 0xd8ae, 0xb3f3,
/* 30 */ 0xb3f7, 0xb3f8, 0xd14b, 0xd8ab, 0xb3f5, 0xb0f4, 0xd8ad, 0xd87e,
/* 38 */ 0xd8b0, 0xd8af,    BAD, 0xd8b3,    BAD, 0xdcef,    BAD, 0xd8ac
},

/* Row 0x049 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xd8a7, 0xdce7, 0xb6f4, 0xb6f7, 0xb6f2, 0xdce6, 0xdcea, 0xdce5,
/* 10 */    BAD, 0xb6ec, 0xb6f6, 0xdce2, 0xb6f0, 0xdce9,    BAD, 0xb6ee,
/* 18 */ 0xb6ed, 0xdcec, 0xb6ef, 0xdcee,    BAD, 0xdceb, 0xb6eb,    BAD,
/* 20 */    BAD,    BAD, 0xb6f5, 0xdcf0, 0xdce4, 0xdced,    BAD,    BAD,
/* 28 */ 0xdce3,    BAD,    BAD, 0xb6f1,    BAD, 0xb6f3,    BAD, 0xdce8,
/* 30 */    BAD, 0xdcf1,    BAD,    BAD, 0xe15d, 0xb9d0, 0xe163,    BAD,
/* 38 */    BAD, 0xb9d5, 0xe15f, 0xe166, 0xe157, 0xb9d7, 0xb9d1, 0xe15c
},

/* Row 0x04a */
{
/* 00 */ 0xbc55, 0xe15b, 0xe164, 0xb9d2,    BAD, 0xb9d6, 0xe15a, 0xe160,
/* 08 */ 0xe165, 0xe156, 0xb9d4, 0xe15e,    BAD,    BAD, 0xe162, 0xe168,
/* 10 */ 0xe158, 0xe161,    BAD, 0xb9d3, 0xe167,    BAD,    BAD,    BAD,
/* 18 */ 0xe159,    BAD,    BAD,    BAD, 0xbc59, 0xe54b, 0xbc57, 0xbc56,
/* 20 */ 0xe54d, 0xe552,    BAD, 0xe54e,    BAD, 0xe551, 0xbc5c,    BAD,
/* 28 */ 0xbea5, 0xbc5b,    BAD, 0xe54a, 0xe550,    BAD, 0xbc5a, 0xe54f,
/* 30 */    BAD, 0xe54c,    BAD, 0xbc58,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xe94d,    BAD, 0xe94f, 0xe94a, 0xbec1, 0xe94c
},

/* Row 0x04b */
{
/* 00 */    BAD, 0xbec0, 0xe94e,    BAD,    BAD, 0xbec3, 0xe950, 0xbec2,
/* 08 */ 0xe949, 0xe94b,    BAD,    BAD,    BAD,    BAD, 0xc0a5, 0xeccc,
/* 10 */    BAD, 0xc0a4, 0xeccd, 0xc0a3, 0xeccb, 0xc0a2, 0xecca,    BAD,
/* 18 */ 0xc253, 0xc252, 0xf1f6, 0xf1f8,    BAD, 0xf1f7, 0xc361, 0xc362,
/* 20 */    BAD,    BAD, 0xc363, 0xf442, 0xc45b,    BAD,    BAD, 0xf7d3,
/* 28 */ 0xf7d2, 0xc5f2,    BAD, 0xa468, 0xa4d0,    BAD,    BAD, 0xa7a7,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xce5f,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xb3fc, 0xb3fd,    BAD, 0xdcf2, 0xb9d8, 0xe169, 0xe553
},

/* Row 0x04c */
{
/* 00 */    BAD,    BAD,    BAD, 0xc95a,    BAD,    BAD, 0xcab0,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xcc42, 0xce60, 0xd159, 0xae4c,
/* 10 */    BAD,    BAD, 0xf1f9,    BAD, 0xc4dc, 0xa469, 0xa57e, 0xc970,
/* 18 */    BAD, 0xa667, 0xa668,    BAD, 0xa95d,    BAD,    BAD,    BAD,
/* 20 */ 0xb0f7,    BAD, 0xb9da,    BAD, 0xb9db, 0xb9d9,    BAD, 0xa46a,
/* 28 */    BAD, 0xa4d1, 0xa4d3, 0xa4d2, 0xc95b, 0xa4d4, 0xa5a1, 0xc971,
/* 30 */    BAD, 0xa5a2,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa669,
/* 38 */ 0xa66a,    BAD,    BAD,    BAD, 0xc9cb,    BAD, 0xa7a8,    BAD
},

/* Row 0x04d */
{
/* 00 */ 0xcab1,    BAD,    BAD,    BAD, 0xa961, 0xcc43,    BAD, 0xa95f,
/* 08 */ 0xa960, 0xa95e, 0xd15a,    BAD,    BAD,    BAD, 0xabb6, 0xabb5,
/* 10 */ 0xabb7, 0xabb4,    BAD, 0xce61, 0xa962, 0xabb3,    BAD, 0xae4d,
/* 18 */ 0xae4e,    BAD, 0xae4f,    BAD, 0xd4cd,    BAD,    BAD,    BAD,
/* 20 */ 0xb3fe, 0xd8b4, 0xb0f8,    BAD,    BAD,    BAD,    BAD, 0xb6f8,
/* 28 */    BAD, 0xb9dd, 0xb9dc, 0xe16a,    BAD, 0xbc5d, 0xbec4,    BAD,
/* 30 */ 0xefc0, 0xf6da, 0xf7d4, 0xa46b, 0xa5a3,    BAD, 0xa5a4, 0xc9d1,
/* 38 */ 0xa66c, 0xa66f,    BAD, 0xc9cf, 0xc9cd, 0xa66e, 0xc9d0, 0xc9d2
},

/* Row 0x04e */
{
/* 00 */ 0xc9cc, 0xa671, 0xa670, 0xa66d, 0xa66b, 0xc9ce,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xa7b3,    BAD,    BAD, 0xa7b0, 0xcab6, 0xcab9,
/* 10 */ 0xcab8,    BAD, 0xa7aa, 0xa7b2,    BAD,    BAD, 0xa7af, 0xcab5,
/* 18 */ 0xcab3, 0xa7ae,    BAD,    BAD,    BAD, 0xa7a9, 0xa7ac,    BAD,
/* 20 */ 0xcab4, 0xcabb, 0xcab7, 0xa7ad, 0xa7b1, 0xa7b4, 0xcab2, 0xcaba,
/* 28 */ 0xa7ab,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa967, 0xa96f,
/* 30 */    BAD, 0xcc4f, 0xcc48, 0xa970, 0xcc53, 0xcc44, 0xcc4b,    BAD,
/* 38 */    BAD, 0xa966, 0xcc45, 0xa964, 0xcc4c, 0xcc50, 0xa963,    BAD
},

/* Row 0x04f */
{
/* 00 */ 0xcc51, 0xcc4a,    BAD, 0xcc4d,    BAD, 0xa972, 0xa969, 0xcc54,
/* 08 */ 0xcc52,    BAD, 0xa96e, 0xa96c, 0xcc49, 0xa96b, 0xcc47, 0xcc46,
/* 10 */ 0xa96a, 0xa968, 0xa971, 0xa96d, 0xa965,    BAD, 0xcc4e,    BAD,
/* 18 */ 0xabb9,    BAD, 0xabc0, 0xce6f, 0xabb8, 0xce67, 0xce63,    BAD,
/* 20 */ 0xce73, 0xce62,    BAD, 0xabbb, 0xce6c, 0xabbe, 0xabc1,    BAD,
/* 28 */ 0xabbc, 0xce70, 0xabbf,    BAD, 0xae56, 0xce76, 0xce64,    BAD,
/* 30 */    BAD, 0xce66, 0xce6d, 0xce71, 0xce75, 0xce72, 0xce6b, 0xce6e,
/* 38 */    BAD,    BAD, 0xce68, 0xabc3, 0xce6a, 0xce69, 0xce74, 0xabba
},

/* Row 0x050 */
{
/* 00 */ 0xce65, 0xabc2,    BAD, 0xabbd,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xae5c, 0xd162,    BAD, 0xae5b,    BAD,    BAD, 0xd160,
/* 10 */    BAD, 0xae50,    BAD, 0xae55,    BAD, 0xd15f, 0xd15c, 0xd161,
/* 18 */ 0xae51, 0xd15b,    BAD, 0xae54, 0xae52,    BAD, 0xd163, 0xae53,
/* 20 */ 0xae57,    BAD,    BAD, 0xae58,    BAD, 0xae5a,    BAD,    BAD,
/* 28 */    BAD, 0xae59,    BAD,    BAD,    BAD, 0xd15d, 0xd15e,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xd164,    BAD, 0xd4d4, 0xb0f9, 0xd8c2,
/* 38 */ 0xd4d3, 0xd4e6,    BAD,    BAD, 0xb140,    BAD, 0xd4e4,    BAD
},

/* Row 0x051 */
{
/* 00 */ 0xb0fe, 0xb0fa, 0xd4ed, 0xd4dd, 0xd4e0,    BAD, 0xb143, 0xd4ea,
/* 08 */ 0xd4e2, 0xb0fb, 0xb144,    BAD, 0xd4e7, 0xd4e5,    BAD,    BAD,
/* 10 */ 0xd4d6, 0xd4eb, 0xd4df, 0xd4da,    BAD, 0xd4d0, 0xd4ec, 0xd4dc,
/* 18 */ 0xd4cf,    BAD, 0xb142, 0xd4e1, 0xd4ee, 0xd4de, 0xd4d2, 0xd4d7,
/* 20 */ 0xd4ce,    BAD, 0xb141,    BAD, 0xd4db, 0xd4d8, 0xb0fc, 0xd4d1,
/* 28 */    BAD, 0xd4e9, 0xb0fd,    BAD, 0xd4d9, 0xd4d5,    BAD,    BAD,
/* 30 */ 0xd4e8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb440,
/* 38 */ 0xd8bb,    BAD, 0xd8b8, 0xd8c9, 0xd8bd, 0xd8ca,    BAD, 0xb442
},

/* Row 0x052 */
{
/* 00 */    BAD,    BAD,    BAD, 0xd8c6, 0xd8c3,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xd8c4, 0xd8c7, 0xd8cb,    BAD, 0xd4e3, 0xd8cd,
/* 10 */ 0xdd47,    BAD, 0xb443, 0xd8ce, 0xd8b6, 0xd8c0,    BAD, 0xd8c5,
/* 18 */    BAD,    BAD, 0xb441, 0xb444, 0xd8cc, 0xd8cf, 0xd8ba, 0xd8b7,
/* 20 */    BAD,    BAD, 0xd8b9,    BAD,    BAD, 0xd8be, 0xd8bc, 0xb445,
/* 28 */    BAD, 0xd8c8,    BAD,    BAD, 0xd8bf,    BAD, 0xd8c1, 0xd8b5,
/* 30 */ 0xdcfa, 0xdcf8, 0xb742, 0xb740, 0xdd43, 0xdcf9, 0xdd44, 0xdd40,
/* 38 */ 0xdcf7, 0xdd46, 0xdcf6, 0xdcfd, 0xb6fe, 0xb6fd, 0xb6fc, 0xdcfb
},

/* Row 0x053 */
{
/* 00 */ 0xdd41, 0xb6f9, 0xb741,    BAD, 0xdcf4,    BAD, 0xdcfe, 0xdcf3,
/* 08 */ 0xdcfc, 0xb6fa, 0xdd42, 0xdcf5, 0xb6fb, 0xdd45,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe16e, 0xb9e2, 0xb9e1,
/* 18 */ 0xb9e3, 0xe17a, 0xe170, 0xe176, 0xe16b, 0xe179, 0xe178, 0xe17c,
/* 20 */ 0xe175, 0xb9de, 0xe174, 0xb9e4,    BAD, 0xe16d, 0xb9df,    BAD,
/* 28 */ 0xe17b, 0xb9e0, 0xe16f, 0xe172, 0xe177, 0xe171, 0xe16c,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xe173, 0xe555, 0xbc61, 0xe558, 0xe557,
/* 38 */ 0xe55a, 0xe55c,    BAD, 0xbc5f,    BAD, 0xe556,    BAD, 0xe554
},

/* Row 0x054 */
{
/* 00 */    BAD, 0xe55d, 0xe55b, 0xe559,    BAD, 0xe55f,    BAD, 0xe55e,
/* 08 */ 0xbc63, 0xbc5e,    BAD, 0xbc60, 0xbc62,    BAD,    BAD, 0xe560,
/* 10 */ 0xe957,    BAD,    BAD, 0xe956, 0xe955,    BAD, 0xe958, 0xe951,
/* 18 */    BAD, 0xe952, 0xe95a, 0xe953,    BAD, 0xbec5, 0xe95c,    BAD,
/* 20 */ 0xe95b, 0xe954,    BAD, 0xecd1, 0xc0a8, 0xeccf, 0xecd4, 0xecd3,
/* 28 */ 0xe959,    BAD, 0xc0a7,    BAD, 0xecd2, 0xecce, 0xecd6, 0xecd5,
/* 30 */ 0xc0a6,    BAD, 0xecd0,    BAD, 0xbec6,    BAD,    BAD,    BAD,
/* 38 */ 0xc254,    BAD,    BAD,    BAD, 0xefc1, 0xf1fa, 0xf1fb, 0xf1fc
},

/* Row 0x055 */
{
/* 00 */ 0xc45c,    BAD,    BAD, 0xc45d,    BAD, 0xf443,    BAD, 0xf5c8,
/* 08 */ 0xf5c7,    BAD,    BAD, 0xf6db, 0xf6dc, 0xf7d5, 0xf8a7,    BAD,
/* 10 */ 0xa46c, 0xa46d,    BAD, 0xa46e, 0xa4d5, 0xa5a5, 0xc9d3, 0xa672,
/* 18 */ 0xa673,    BAD, 0xa7b7, 0xa7b8, 0xa7b6, 0xa7b5,    BAD, 0xa973,
/* 20 */    BAD,    BAD, 0xcc55, 0xa975, 0xa974, 0xcc56,    BAD,    BAD,
/* 28 */    BAD, 0xabc4,    BAD, 0xae5d, 0xd165,    BAD, 0xd4f0,    BAD,
/* 30 */ 0xb145, 0xb447, 0xd4ef, 0xb446,    BAD, 0xb9e5,    BAD, 0xe17d,
/* 38 */ 0xbec7,    BAD, 0xc0a9, 0xecd7,    BAD, 0xc45e,    BAD, 0xc570
},

/* Row 0x056 */
{
/* 00 */    BAD, 0xc972,    BAD, 0xa5a6, 0xc973, 0xa676,    BAD, 0xa674,
/* 08 */ 0xa675, 0xa677,    BAD, 0xa7ba, 0xa7b9,    BAD, 0xcabc, 0xa7bb,
/* 10 */    BAD,    BAD, 0xcabd, 0xcc57,    BAD, 0xcc58,    BAD, 0xa976,
/* 18 */ 0xa978, 0xa97a, 0xa977, 0xa97b, 0xa979,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xabc8, 0xabc5, 0xabc7, 0xabc9, 0xabc6, 0xd166,
/* 28 */ 0xce77,    BAD,    BAD,    BAD, 0xd168, 0xd167, 0xae63,    BAD,
/* 30 */ 0xae5f,    BAD,    BAD, 0xae60, 0xae62, 0xae64, 0xae61,    BAD,
/* 38 */ 0xae66, 0xae65,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb14a
},

/* Row 0x057 */
{
/* 00 */ 0xd4f2, 0xd4f1, 0xb149,    BAD, 0xb148, 0xb147, 0xb14b, 0xb146,
/* 08 */    BAD,    BAD, 0xd8d5, 0xd8d2, 0xb449, 0xd8d1, 0xd8d6,    BAD,
/* 10 */ 0xb44b, 0xd8d4, 0xb448, 0xb44a, 0xd8d3,    BAD, 0xdd48,    BAD,
/* 18 */ 0xdd49, 0xdd4a,    BAD,    BAD,    BAD,    BAD, 0xb9e6, 0xb9ee,
/* 20 */ 0xe17e, 0xb9e8, 0xb9ec, 0xe1a1, 0xb9ed, 0xb9e9, 0xb9ea, 0xb9e7,
/* 28 */ 0xb9eb, 0xbc66, 0xd8d0, 0xbc67, 0xbc65,    BAD, 0xbc64, 0xe95d,
/* 30 */ 0xbec8, 0xecd8, 0xecd9,    BAD,    BAD, 0xc364, 0xc45f,    BAD,
/* 38 */ 0xa46f,    BAD, 0xa678,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x058 */
{
/* 00 */    BAD, 0xabca,    BAD, 0xd169, 0xae67,    BAD,    BAD, 0xb14e,
/* 08 */ 0xb14d, 0xb14c, 0xb44c, 0xb44d, 0xd8d7, 0xb9ef, 0xbec9, 0xa470,
/* 10 */ 0xc95c, 0xa4d6, 0xc974,    BAD,    BAD, 0xc9d4, 0xa679,    BAD,
/* 18 */    BAD,    BAD, 0xa97c,    BAD,    BAD,    BAD,    BAD, 0xdd4b,
/* 20 */    BAD,    BAD, 0xa471,    BAD, 0xa4d7, 0xc9d5,    BAD,    BAD,
/* 28 */ 0xcabe,    BAD, 0xcabf,    BAD, 0xa7bc,    BAD,    BAD,    BAD,
/* 30 */ 0xd8d8, 0xb44e,    BAD, 0xdd4c,    BAD,    BAD,    BAD, 0xc0aa,
/* 38 */ 0xa472, 0xa4a8, 0xa4d8, 0xc975, 0xa5a7,    BAD, 0xa7c0, 0xa7bf
},

/* Row 0x059 */
{
/* 00 */ 0xa7bd, 0xa7be,    BAD,    BAD, 0xcc59, 0xa97e, 0xa9a1, 0xcc5a,
/* 08 */ 0xa97d,    BAD,    BAD, 0xabce, 0xce78, 0xabcd, 0xabcb, 0xabcc,
/* 10 */ 0xae6a, 0xae68,    BAD,    BAD, 0xd16b, 0xae69, 0xd16a,    BAD,
/* 18 */ 0xae5e, 0xd4f3,    BAD,    BAD, 0xb150, 0xb151,    BAD,    BAD,
/* 20 */ 0xb14f,    BAD, 0xb9f0, 0xe1a2, 0xbc68, 0xbc69,    BAD, 0xe561,
/* 28 */ 0xc0ab, 0xefc2, 0xefc3,    BAD, 0xc4dd, 0xf8a8, 0xc94b, 0xa4d9,
/* 30 */    BAD, 0xa473,    BAD, 0xc977, 0xc976,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xa67a, 0xc9d7, 0xc9d8, 0xc9d6,    BAD, 0xc9d9,    BAD
},

/* Row 0x05a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcac7,    BAD,
/* 08 */ 0xcac2, 0xcac4, 0xcac6, 0xcac3, 0xa7c4, 0xcac0,    BAD, 0xcac1,
/* 10 */ 0xa7c1, 0xa7c2, 0xcac5, 0xcac8, 0xa7c3, 0xcac9,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xcc68,    BAD, 0xcc62,
/* 20 */ 0xcc5d, 0xa9a3, 0xcc65, 0xcc63, 0xcc5c, 0xcc69, 0xcc6c, 0xcc67,
/* 28 */ 0xcc60, 0xa9a5, 0xcc66, 0xa9a6, 0xcc61, 0xcc64, 0xcc5b, 0xcc5f,
/* 30 */ 0xcc6b, 0xa9a7,    BAD, 0xa9a8,    BAD, 0xcc5e, 0xcc6a, 0xa9a2,
/* 38 */ 0xa9a4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x05b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xceab, 0xcea4,
/* 08 */ 0xceaa, 0xcea3, 0xcea5, 0xce7d, 0xce7b,    BAD, 0xceac, 0xcea9,
/* 10 */ 0xce79,    BAD, 0xabd0, 0xcea7, 0xcea8,    BAD, 0xcea6, 0xce7c,
/* 18 */ 0xce7a, 0xabcf, 0xcea2, 0xce7e,    BAD,    BAD, 0xcea1, 0xcead,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xae6f,    BAD, 0xae6e,    BAD, 0xd16c, 0xae6b, 0xd16e,    BAD,
/* 30 */ 0xae70, 0xd16f,    BAD,    BAD, 0xae73,    BAD, 0xae71, 0xd170,
/* 38 */ 0xceae, 0xd172,    BAD, 0xae6d,    BAD, 0xae6c,    BAD, 0xd16d
},

/* Row 0x05c */
{
/* 00 */ 0xd171, 0xae72,    BAD,    BAD,    BAD,    BAD, 0xb153, 0xb152,
/* 08 */    BAD,    BAD,    BAD, 0xd4f5, 0xd4f9, 0xd4fb, 0xb154, 0xd4fe,
/* 10 */    BAD, 0xb158, 0xd541,    BAD, 0xb15a,    BAD, 0xb156, 0xb15e,
/* 18 */    BAD, 0xb15b, 0xd4f7, 0xb155,    BAD, 0xd4f6, 0xd4f4, 0xd543,
/* 20 */ 0xd4f8,    BAD, 0xb157, 0xd542, 0xb15c, 0xd4fd, 0xd4fc, 0xb15d,
/* 28 */ 0xd4fa, 0xb159,    BAD,    BAD,    BAD,    BAD, 0xd544,    BAD,
/* 30 */ 0xd540, 0xd8e7, 0xd8ee, 0xd8e3, 0xb451, 0xd8df, 0xd8ef, 0xd8d9,
/* 38 */ 0xd8ec, 0xd8ea, 0xd8e4,    BAD, 0xd8ed, 0xd8e6,    BAD, 0xd8de
},

/* Row 0x05d */
{
/* 00 */ 0xd8f0, 0xd8dc, 0xd8e9, 0xd8da,    BAD, 0xd8f1,    BAD, 0xb452,
/* 08 */    BAD, 0xd8eb, 0xdd4f, 0xd8dd, 0xb44f,    BAD, 0xd8e1,    BAD,
/* 10 */ 0xb450, 0xd8e0, 0xd8e5,    BAD,    BAD, 0xd8e2,    BAD,    BAD,
/* 18 */    BAD, 0xd8e8,    BAD,    BAD,    BAD,    BAD, 0xdd53,    BAD,
/* 20 */    BAD,    BAD, 0xdd56, 0xdd4e,    BAD, 0xdd50,    BAD, 0xdd55,
/* 28 */ 0xdd54, 0xb743,    BAD, 0xd8db, 0xdd52,    BAD,    BAD, 0xb744,
/* 30 */    BAD, 0xdd4d, 0xdd51,    BAD,    BAD,    BAD,    BAD, 0xe1a9,
/* 38 */    BAD, 0xe1b0, 0xe1a7,    BAD, 0xe1ae, 0xe1a5, 0xe1ad, 0xe1b1
},

/* Row 0x05e */
{
/* 00 */ 0xe1a4, 0xe1a8, 0xe1a3,    BAD, 0xb9f1,    BAD, 0xe1a6, 0xb9f2,
/* 08 */ 0xe1ac, 0xe1ab, 0xe1aa,    BAD,    BAD, 0xe1af,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xe565, 0xe567, 0xbc6b, 0xe568,    BAD, 0xe563,
/* 18 */    BAD, 0xe562, 0xe56c,    BAD, 0xe56a, 0xbc6a, 0xe56d, 0xe564,
/* 20 */ 0xe569, 0xe56b, 0xe566,    BAD,    BAD,    BAD,    BAD, 0xe961,
/* 28 */ 0xe966, 0xe960, 0xe965,    BAD, 0xe95e, 0xe968, 0xe964, 0xe969,
/* 30 */ 0xe963, 0xe95f, 0xe967,    BAD, 0xe96a, 0xe962,    BAD, 0xecda,
/* 38 */ 0xc0af,    BAD, 0xc0ad,    BAD, 0xc0ac, 0xc0ae,    BAD,    BAD
},

/* Row 0x05f */
{
/* 00 */ 0xefc4,    BAD, 0xf172, 0xf1fd,    BAD,    BAD, 0xf444, 0xf445,
/* 08 */    BAD, 0xc460,    BAD, 0xf5c9,    BAD, 0xc4de,    BAD, 0xf5ca,
/* 10 */    BAD, 0xf6de, 0xc572,    BAD, 0xc571, 0xf6dd, 0xc5c9,    BAD,
/* 18 */ 0xf7d6,    BAD,    BAD,    BAD,    BAD, 0xa474, 0xa67b, 0xc9da,
/* 20 */ 0xcaca, 0xa8b5, 0xb15f,    BAD,    BAD, 0xa475, 0xa5aa, 0xa5a9,
/* 28 */ 0xa5a8,    BAD,    BAD, 0xa7c5,    BAD,    BAD, 0xae74,    BAD,
/* 30 */ 0xdd57, 0xa476, 0xa477, 0xa478, 0xa4da,    BAD,    BAD, 0xabd1,
/* 38 */    BAD, 0xceaf,    BAD,    BAD,    BAD, 0xb453, 0xa479, 0xc95d
},

/* Row 0x060 */
{
/* 00 */    BAD,    BAD, 0xa5ab, 0xa5ac, 0xc978,    BAD, 0xa67c,    BAD,
/* 08 */    BAD,    BAD, 0xcacb,    BAD, 0xa7c6,    BAD, 0xcacc,    BAD,
/* 10 */    BAD, 0xa9ae,    BAD,    BAD, 0xcc6e, 0xa9ac, 0xa9ab, 0xcc6d,
/* 18 */ 0xa9a9, 0xcc6f, 0xa9aa, 0xa9ad,    BAD, 0xabd2,    BAD, 0xabd4,
/* 20 */ 0xceb3, 0xceb0, 0xceb1, 0xceb2, 0xceb4, 0xabd3,    BAD,    BAD,
/* 28 */ 0xd174, 0xd173,    BAD, 0xae76,    BAD, 0xae75,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xb162, 0xd546,    BAD, 0xb161, 0xb163,
/* 38 */ 0xb160,    BAD,    BAD,    BAD,    BAD, 0xb455, 0xd545,    BAD
},

/* Row 0x061 */
{
/* 00 */ 0xb456, 0xd8f3,    BAD, 0xb457, 0xd8f2, 0xb454,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xdd5a, 0xdd5c, 0xb745, 0xdd5b, 0xdd59, 0xdd58,
/* 10 */    BAD,    BAD,    BAD, 0xe1b4, 0xb9f7, 0xb9f5,    BAD, 0xb9f6,
/* 18 */ 0xe1b2, 0xe1b3,    BAD, 0xb9f3, 0xe571, 0xe56f,    BAD, 0xbc6d,
/* 20 */ 0xe570, 0xbc6e, 0xbc6c, 0xb9f4,    BAD,    BAD, 0xe96d, 0xe96b,
/* 28 */ 0xe96c, 0xe56e, 0xecdc, 0xc0b0, 0xecdb, 0xefc5, 0xefc6, 0xe96e,
/* 30 */ 0xf1fe,    BAD, 0xa47a, 0xa5ad, 0xa67e, 0xc9db, 0xa67d,    BAD,
/* 38 */ 0xa9af, 0xb746,    BAD, 0xa4db, 0xa5ae, 0xabd5, 0xb458,    BAD
},

/* Row 0x062 */
{
/* 00 */ 0xc979,    BAD, 0xc97a,    BAD, 0xc9dc,    BAD,    BAD, 0xa7c8,
/* 08 */ 0xcad0, 0xcace, 0xa7c9, 0xcacd, 0xcacf, 0xcad1,    BAD, 0xa7c7,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa9b3, 0xa9b4, 0xa9b1,
/* 18 */    BAD,    BAD, 0xa9b0, 0xceb8, 0xa9b2,    BAD,    BAD,    BAD,
/* 20 */ 0xabd6,    BAD, 0xceb7, 0xceb9, 0xceb6, 0xceba, 0xabd7, 0xae79,
/* 28 */ 0xd175,    BAD, 0xd177, 0xae77, 0xd178, 0xae78, 0xd176,    BAD,
/* 30 */ 0xceb5, 0xd547, 0xd54a, 0xd54b, 0xd548, 0xb167, 0xb166, 0xb164,
/* 38 */ 0xb165, 0xd549,    BAD,    BAD,    BAD,    BAD, 0xb168,    BAD
},

/* Row 0x063 */
{
/* 00 */    BAD, 0xb45a, 0xb45b,    BAD, 0xb45c, 0xdd5d, 0xdd5f, 0xdd61,
/* 08 */ 0xb748, 0xb747, 0xb459, 0xdd60, 0xdd5e,    BAD, 0xe1b8,    BAD,
/* 10 */    BAD, 0xe1b6, 0xe1bc, 0xb9f8, 0xe1bd, 0xe1ba, 0xb9f9, 0xe1b7,
/* 18 */ 0xe1b5, 0xe1bb, 0xbc70, 0xe573, 0xe1b9, 0xbc72, 0xe574, 0xbc71,
/* 20 */ 0xbc74, 0xe575, 0xbc6f, 0xbc73,    BAD, 0xe973, 0xe971, 0xe970,
/* 28 */ 0xe972, 0xe96f,    BAD,    BAD, 0xc366,    BAD, 0xf446, 0xf447,
/* 30 */    BAD, 0xf5cb, 0xf6df, 0xc655,    BAD,    BAD, 0xa9b5, 0xa7ca,
/* 38 */    BAD,    BAD, 0xabd8,    BAD,    BAD,    BAD, 0xa47b, 0xa4dc
},

/* Row 0x064 */
{
/* 00 */    BAD, 0xa5af, 0xc9dd,    BAD, 0xa7cb, 0xcad2,    BAD, 0xcebb,
/* 08 */ 0xabd9,    BAD, 0xb9fa, 0xa47c,    BAD,    BAD,    BAD, 0xa6a1,
/* 10 */    BAD,    BAD, 0xb749, 0xa47d, 0xa4dd, 0xa4de,    BAD, 0xa5b1,
/* 18 */ 0xa5b0,    BAD, 0xc9de, 0xa6a2,    BAD, 0xcad3,    BAD, 0xa7cc,
/* 20 */    BAD,    BAD, 0xcc71, 0xcc72, 0xcc73,    BAD, 0xa9b6, 0xa9b7,
/* 28 */ 0xcc70, 0xa9b8,    BAD,    BAD,    BAD, 0xabda, 0xcebc,    BAD,
/* 30 */ 0xd17a, 0xae7a,    BAD, 0xd179,    BAD, 0xb169, 0xd54c, 0xb16a,
/* 38 */ 0xd54d,    BAD,    BAD,    BAD, 0xb45d,    BAD,    BAD,    BAD
},

/* Row 0x065 */
{
/* 00 */ 0xdd62,    BAD,    BAD, 0xe1bf, 0xe1be,    BAD, 0xb9fb,    BAD,
/* 08 */ 0xbc75, 0xe576, 0xbeca, 0xe974, 0xc0b1,    BAD, 0xc573, 0xf7d8,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xcc74,    BAD, 0xcebd, 0xb16b,
/* 18 */ 0xd8f4, 0xb74a,    BAD,    BAD,    BAD, 0xc255,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xa7ce,    BAD, 0xa7cd, 0xabdb,    BAD, 0xd17b,
/* 28 */    BAD, 0xb16d, 0xb343, 0xb16e, 0xb16c, 0xb45e,    BAD, 0xe1c0,
/* 30 */ 0xb9fc, 0xbc76,    BAD, 0xc94c, 0xc9df,    BAD, 0xcad5, 0xa7cf,
/* 38 */ 0xcad4, 0xa7d0,    BAD,    BAD, 0xa9bc, 0xcc77, 0xcc76, 0xa9bb
},

/* Row 0x066 */
{
/* 00 */ 0xa9b9, 0xa9ba, 0xcc75,    BAD,    BAD, 0xabdd, 0xcebe, 0xabe0,
/* 08 */ 0xabdc, 0xabe2, 0xabde, 0xabdf, 0xabe1,    BAD,    BAD,    BAD,
/* 10 */ 0xae7d, 0xae7c, 0xae7b,    BAD,    BAD,    BAD, 0xd54f, 0xb16f,
/* 18 */ 0xb172, 0xb170,    BAD, 0xd54e, 0xb175,    BAD, 0xb171, 0xd550,
/* 20 */ 0xb174, 0xb173,    BAD,    BAD,    BAD, 0xd8f6, 0xd8f5,    BAD,
/* 28 */ 0xb461, 0xb45f, 0xb460, 0xd8f7, 0xb74b, 0xdd64, 0xb74c, 0xdd63,
/* 30 */    BAD,    BAD, 0xe577,    BAD,    BAD, 0xbc78, 0xe1c1, 0xbc77,
/* 38 */    BAD, 0xb9fd,    BAD, 0xecde, 0xe975, 0xc0b2, 0xecdd, 0xf240
},

/* Row 0x067 */
{
/* 00 */ 0xf448, 0xf449,    BAD, 0xa4df,    BAD, 0xa5b2,    BAD,    BAD,
/* 08 */    BAD, 0xc97b,    BAD,    BAD, 0xa7d2, 0xa7d4,    BAD, 0xc9e2,
/* 10 */ 0xcad8, 0xcad7, 0xcad6,    BAD, 0xc9e1, 0xc9e0, 0xa6a4, 0xa7d3,
/* 18 */ 0xa7d1, 0xa6a3,    BAD,    BAD,    BAD, 0xa9bd, 0xcc78,    BAD,
/* 20 */ 0xa9be, 0xcadd,    BAD, 0xcadf, 0xcade, 0xcc79,    BAD,    BAD,
/* 28 */ 0xcada,    BAD, 0xa7d8, 0xa7d6,    BAD, 0xcad9, 0xcadb, 0xcae1,
/* 30 */    BAD, 0xa7d5,    BAD, 0xcadc, 0xcae5, 0xa9c0,    BAD, 0xcae2,
/* 38 */ 0xa7d7,    BAD, 0xcae0, 0xcae3,    BAD, 0xa9bf,    BAD, 0xa9c1
},

/* Row 0x068 */
{
/* 00 */ 0xcae4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xccaf, 0xcca2, 0xcc7e, 0xccae, 0xcca9, 0xabe7, 0xa9c2,
/* 10 */ 0xccaa, 0xccad, 0xabe3, 0xccac, 0xa9c3, 0xa9c8, 0xa9c6, 0xcca3,
/* 18 */    BAD, 0xcc7c, 0xcca5, 0xa9cd, 0xccb0, 0xabe4, 0xcca6,    BAD,
/* 20 */ 0xabe5, 0xa9c9, 0xcca8,    BAD, 0xcecd, 0xabe6, 0xcc7b, 0xa9ca,
/* 28 */ 0xabe8, 0xa9cb, 0xa9c7, 0xa9cc, 0xcca7, 0xcc7a, 0xccab, 0xa9c4,
/* 30 */    BAD,    BAD, 0xcc7d, 0xcca4, 0xcca1, 0xa9c5,    BAD, 0xcebf,
/* 38 */    BAD, 0xcec0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x069 */
{
/* 00 */ 0xceca, 0xd1a1, 0xcecb, 0xabee, 0xcece, 0xcec4, 0xabed, 0xcec6,
/* 08 */    BAD, 0xcec7,    BAD,    BAD, 0xcec9, 0xabe9,    BAD,    BAD,
/* 10 */ 0xaea3,    BAD,    BAD, 0xcec5, 0xcec1, 0xaea4,    BAD,    BAD,
/* 18 */ 0xcecf, 0xae7e, 0xd17d, 0xcec8,    BAD, 0xd17c, 0xcec3, 0xcecc,
/* 20 */    BAD,    BAD, 0xabec, 0xaea1, 0xabf2, 0xaea2, 0xced0, 0xd17e,
/* 28 */ 0xabeb, 0xaea6, 0xabf1, 0xabf0, 0xabef, 0xaea5, 0xced1, 0xaea7,
/* 30 */ 0xabea,    BAD, 0xcec2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb176
},

/* Row 0x06a */
{
/* 00 */ 0xd1a4, 0xd1a6,    BAD, 0xd1a8, 0xaea8, 0xaeae, 0xd553, 0xd1ac,
/* 08 */ 0xd1a3, 0xb178, 0xd551,    BAD, 0xaead, 0xaeab, 0xd1ae,    BAD,
/* 10 */ 0xd552,    BAD, 0xd1a5,    BAD, 0xaeac, 0xd1a9, 0xaeaf, 0xd1ab,
/* 18 */    BAD,    BAD, 0xaeaa, 0xd1aa, 0xd1ad, 0xd1a7,    BAD, 0xaea9,
/* 20 */ 0xb179,    BAD, 0xd1a2, 0xb177,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xb17a,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xd555, 0xd55e, 0xb464,    BAD, 0xb17c, 0xb1a3, 0xb465, 0xd560,
/* 38 */ 0xb1aa, 0xd8f9, 0xd556, 0xb1a2, 0xb1a5, 0xb17e, 0xd554, 0xd562
},

/* Row 0x06b */
{
/* 00 */ 0xd565, 0xd949,    BAD, 0xd563, 0xd8fd, 0xb1a1, 0xb1a8, 0xb1ac,
/* 08 */ 0xd55d, 0xd8f8, 0xd561, 0xb17b, 0xd8fa, 0xd564, 0xd8fc, 0xd559,
/* 10 */    BAD, 0xb462,    BAD, 0xd557, 0xd558, 0xb1a7,    BAD,    BAD,
/* 18 */ 0xb1a6, 0xd55b, 0xb1ab, 0xd55f, 0xb1a4, 0xd55c,    BAD, 0xb1a9,
/* 20 */ 0xb466, 0xb463, 0xd8fb,    BAD, 0xd55a,    BAD, 0xb17d,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xb46b, 0xb46f, 0xd940, 0xb751, 0xb46d, 0xd944, 0xb471, 0xdd65,
/* 38 */ 0xd946, 0xb753, 0xb469, 0xb46c, 0xd947,    BAD, 0xd948, 0xd94e
},

/* Row 0x06c */
{
/* 00 */ 0xb473, 0xb754,    BAD, 0xd94a, 0xd94f, 0xd943, 0xb75e,    BAD,
/* 08 */ 0xb755, 0xb472, 0xd941, 0xd950,    BAD, 0xb75d, 0xb470, 0xb74e,
/* 10 */ 0xd94d,    BAD, 0xb474, 0xd945, 0xd8fe, 0xb46a, 0xd942,    BAD,
/* 18 */ 0xd94b,    BAD, 0xb74d, 0xb752, 0xb467, 0xd94c,    BAD, 0xb750,
/* 20 */    BAD,    BAD,    BAD, 0xb468,    BAD,    BAD,    BAD, 0xb75c,
/* 28 */ 0xe1c3, 0xdd70,    BAD, 0xdd68, 0xe1c2,    BAD, 0xdd6c, 0xdd6e,
/* 30 */    BAD,    BAD, 0xdd6b,    BAD, 0xb75b,    BAD, 0xdd6a, 0xb75f,
/* 38 */    BAD,    BAD,    BAD, 0xe1d2,    BAD,    BAD, 0xb75a, 0xba40
},

/* Row 0x06d */
{
/* 00 */ 0xdd71, 0xe1c4,    BAD,    BAD, 0xb758, 0xdd69, 0xdd6d, 0xb9fe,
/* 08 */ 0xb74f, 0xdd66, 0xdd67, 0xba41, 0xb757, 0xb759, 0xb756, 0xdd6f,
/* 10 */    BAD,    BAD, 0xe1c8, 0xe1c9, 0xe1ce, 0xbc7d, 0xe1d5,    BAD,
/* 18 */ 0xba47,    BAD, 0xba46, 0xe1d0,    BAD, 0xbc7c, 0xe1c5, 0xba45,
/* 20 */    BAD, 0xe1d4, 0xba43, 0xba44,    BAD, 0xe1d1, 0xe5aa, 0xbc7a,
/* 28 */ 0xb46e,    BAD, 0xe1d3, 0xbca3, 0xe1cb,    BAD, 0xbc7b,    BAD,
/* 30 */ 0xbca2, 0xe1c6, 0xe1ca, 0xe1c7, 0xe1cd, 0xba48, 0xbc79, 0xba42,
/* 38 */    BAD, 0xe57a, 0xe1cf,    BAD, 0xbca1,    BAD, 0xbca4,    BAD
},

/* Row 0x06e */
{
/* 00 */ 0xe1cc,    BAD, 0xbc7e, 0xe579,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xe57e, 0xbece, 0xe578, 0xe9a3, 0xe5a9, 0xbca8,    BAD,
/* 10 */ 0xbca6, 0xbecc, 0xe5a6, 0xe5a2, 0xbcac,    BAD, 0xe978,    BAD,
/* 18 */    BAD,    BAD, 0xbcaa, 0xe5a1,    BAD, 0xe976,    BAD, 0xe5a5,
/* 20 */    BAD, 0xe5a8, 0xe57d,    BAD, 0xbcab,    BAD,    BAD, 0xbca5,
/* 28 */ 0xe977, 0xbecd, 0xe5a7, 0xbca7, 0xbca9, 0xe5a4, 0xbcad, 0xe5a3,
/* 30 */ 0xe57c, 0xe57b, 0xbecb, 0xe5ab, 0xe97a, 0xece0, 0xbed0,    BAD,
/* 38 */ 0xe9a2,    BAD, 0xe97e,    BAD, 0xece1,    BAD, 0xbed1, 0xe9a1
},

/* Row 0x06f */
{
/* 00 */    BAD, 0xe97c, 0xc0b4, 0xecdf,    BAD, 0xe979, 0xe97b, 0xc0b5,
/* 08 */ 0xbed3, 0xc0b3, 0xbed2, 0xc0b7, 0xe97d, 0xbecf,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xefcf,    BAD,
/* 18 */ 0xefc7,    BAD,    BAD,    BAD,    BAD,    BAD, 0xece7, 0xefc8,
/* 20 */ 0xece3,    BAD,    BAD, 0xc256, 0xece5, 0xece4, 0xc0b6, 0xece2,
/* 28 */ 0xece6, 0xefd0, 0xefcc, 0xefce,    BAD, 0xefc9, 0xefca,    BAD,
/* 30 */ 0xefcd, 0xefcb, 0xc367,    BAD,    BAD, 0xc36a, 0xc369, 0xc368,
/* 38 */ 0xc461, 0xf44a, 0xc462, 0xf241, 0xc4df, 0xf5cc, 0xc4e0, 0xc574
},

/* Row 0x070 */
{
/* 00 */ 0xc5ca, 0xf7d9,    BAD, 0xf7da, 0xf7db,    BAD,    BAD, 0xf9ba,
/* 08 */ 0xa4e0, 0xc97c, 0xa5b3,    BAD, 0xa6a6, 0xa6a7, 0xa6a5,    BAD,
/* 10 */ 0xa6a8, 0xa7da, 0xa7d9,    BAD, 0xccb1, 0xa9cf, 0xa9ce,    BAD,
/* 18 */    BAD, 0xd1af, 0xb1ad, 0xb1ae,    BAD,    BAD,    BAD, 0xb475,
/* 20 */ 0xdd72, 0xb760, 0xb761, 0xdd74, 0xdd76, 0xdd75,    BAD, 0xe1d7,
/* 28 */    BAD, 0xe1d6, 0xba49, 0xe1d8,    BAD, 0xe5ac, 0xbcae,    BAD,
/* 30 */ 0xbed4,    BAD, 0xc0b8, 0xc257, 0xc0b9,    BAD, 0xa4e1,    BAD,
/* 38 */    BAD,    BAD, 0xcae6,    BAD,    BAD, 0xccb2, 0xa9d1, 0xa9d0
},

/* Row 0x071 */
{
/* 00 */ 0xa9d2, 0xabf3, 0xced2, 0xced3,    BAD,    BAD, 0xd1b0, 0xaeb0,
/* 08 */ 0xb1af, 0xb476, 0xd951, 0xa4e2,    BAD, 0xa47e, 0xa4e3,    BAD,
/* 10 */ 0xc97d, 0xa5b7, 0xa5b6, 0xa5b4, 0xa5b5,    BAD,    BAD,    BAD,
/* 18 */ 0xa6ab, 0xc9e9, 0xc9eb, 0xa6aa, 0xc9e3,    BAD, 0xc9e4,    BAD,
/* 20 */ 0xc9ea, 0xc9e6, 0xc9e8, 0xa6a9, 0xc9e5, 0xc9ec, 0xc9e7,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa7e1, 0xa7ea, 0xa7e8,
/* 30 */ 0xcaf0, 0xcaed, 0xcaf5, 0xa7e6, 0xcaf6,    BAD, 0xa7df, 0xcaf3,
/* 38 */    BAD, 0xa7e5, 0xcaef, 0xcaee, 0xa7e3, 0xcaf4, 0xa7e4, 0xa9d3
},

/* Row 0x072 */
{
/* 00 */ 0xa7de, 0xcaf1,    BAD, 0xcae7, 0xa7db,    BAD, 0xa7ee, 0xcaec,
/* 08 */ 0xcaf2, 0xa7e0, 0xa7e2,    BAD, 0xcae8,    BAD, 0xcae9, 0xcaea,
/* 10 */    BAD, 0xa7ed, 0xa7e7, 0xa7ec, 0xcaeb, 0xa7eb, 0xa7dd, 0xa7dc,
/* 18 */ 0xa7e9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xa9e1, 0xccbe, 0xccb7, 0xa9dc, 0xa9ef, 0xccb3, 0xccba, 0xccbc,
/* 30 */ 0xccbf, 0xa9ea,    BAD, 0xccbb, 0xccb4, 0xa9e8, 0xccb8,    BAD,
/* 38 */ 0xccc0, 0xa9d9,    BAD, 0xccbd, 0xa9e3, 0xa9e2, 0xccb6, 0xa9d7
},

/* Row 0x073 */
{
/* 00 */    BAD,    BAD, 0xa9d8,    BAD, 0xa9d6,    BAD, 0xa9ee, 0xa9e6,
/* 08 */ 0xa9e0, 0xa9d4, 0xccb9, 0xa9df, 0xa9d5, 0xa9e7, 0xa9f0, 0xced4,
/* 10 */ 0xa9e4, 0xccb5, 0xa9da, 0xa9dd, 0xa9de,    BAD, 0xa9ec, 0xa9ed,
/* 18 */ 0xa9eb, 0xa9e5, 0xa9e9, 0xa9db, 0xabf4,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xceda, 0xac41, 0xabf8, 0xabfa, 0xac40,
/* 30 */ 0xcee6, 0xabfd, 0xd1b1, 0xaeb1, 0xac43, 0xced7, 0xcedf, 0xabfe,
/* 38 */ 0xcede, 0xcedb, 0xcee3, 0xcee5, 0xabf7, 0xabfb, 0xac42, 0xaeb3
},

/* Row 0x074 */
{
/* 00 */ 0xcee0, 0xabf9, 0xac45, 0xced9,    BAD,    BAD,    BAD, 0xabfc,
/* 08 */ 0xaeb2, 0xabf6,    BAD, 0xced6, 0xcedd, 0xced5, 0xced8, 0xcedc,
/* 10 */ 0xd1b2, 0xac44,    BAD, 0xcee1, 0xcee2, 0xcee4, 0xabf5,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xaec1, 0xd1be, 0xaebf, 0xaec0, 0xd1b4, 0xd1c4,    BAD, 0xaeb6,
/* 30 */    BAD,    BAD, 0xd566, 0xd1c6, 0xd1c0,    BAD, 0xd1b7,    BAD,
/* 38 */ 0xd1c9, 0xd1ba, 0xaebc, 0xd57d, 0xd1bd, 0xaebe, 0xaeb5,    BAD
},

/* Row 0x075 */
{
/* 00 */ 0xd1cb, 0xd1bf, 0xaeb8, 0xd1b8, 0xd1b5, 0xd1b6, 0xaeb9, 0xd1c5,
/* 08 */ 0xd1cc, 0xaebb, 0xd1bc, 0xd1bb, 0xaec3, 0xaec2, 0xaeb4, 0xaeba,
/* 10 */ 0xaebd, 0xd1c8,    BAD,    BAD, 0xd1c2, 0xaeb7, 0xd1b3, 0xd1ca,
/* 18 */ 0xd1c1, 0xd1c3, 0xd1c7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd567,    BAD, 0xb1b7,
/* 28 */ 0xb1cb, 0xb1ca,    BAD, 0xb1bf,    BAD, 0xd579, 0xd575, 0xd572,
/* 30 */ 0xd5a6, 0xb1ba, 0xb1b2,    BAD,    BAD, 0xd577, 0xb4a8, 0xb1b6,
/* 38 */ 0xd5a1,    BAD, 0xb1cc, 0xb1c9, 0xd57b, 0xd56a,    BAD,    BAD
},

/* Row 0x076 */
{
/* 00 */ 0xb1c8, 0xd5a3, 0xd569, 0xb1bd, 0xb1c1, 0xd5a2,    BAD, 0xd573,
/* 08 */ 0xb1c2, 0xb1bc, 0xd568,    BAD, 0xb478, 0xd5a5, 0xd571, 0xb1c7,
/* 10 */ 0xd574, 0xd5a4, 0xb1c6,    BAD, 0xd952,    BAD, 0xb1b3, 0xd56f,
/* 18 */ 0xb1b8, 0xb1c3,    BAD, 0xb1be, 0xd578, 0xd56e, 0xd56c, 0xd57e,
/* 20 */ 0xb1b0, 0xb1c4, 0xb1b4, 0xb477, 0xd57c, 0xb1b5,    BAD, 0xb1b1,
/* 28 */ 0xb1c0, 0xb1bb, 0xb1b9, 0xd570, 0xb1c5, 0xd56d, 0xd57a, 0xd576,
/* 30 */ 0xd954, 0xd953,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd56b, 0xd964,    BAD
},

/* Row 0x077 */
{
/* 00 */ 0xb47a,    BAD, 0xd96a, 0xd959, 0xd967, 0xdd77, 0xb47d, 0xd96b,
/* 08 */ 0xd96e, 0xb47c, 0xd95c, 0xd96d, 0xd96c, 0xb47e, 0xd955, 0xb479,
/* 10 */ 0xb4a3,    BAD, 0xb4a1, 0xd969,    BAD, 0xd95f, 0xb4a5, 0xd970,
/* 18 */ 0xd968, 0xd971, 0xb4ad, 0xb4ab, 0xd966, 0xd965,    BAD, 0xd963,
/* 20 */ 0xd95d, 0xb4a4,    BAD, 0xb4a2, 0xd1b9, 0xd956,    BAD, 0xddb7,
/* 28 */ 0xd957, 0xb47b, 0xb4aa, 0xdd79,    BAD, 0xb4a6, 0xb4a7, 0xd958,
/* 30 */ 0xd96f, 0xdd78, 0xd960, 0xd95b, 0xb4a9, 0xd961, 0xd95e,    BAD,
/* 38 */    BAD, 0xb4ae,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x078 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb770,    BAD,
/* 08 */    BAD, 0xdd7c, 0xddb1, 0xddb6, 0xddaa, 0xb76c, 0xddbb, 0xb769,
/* 10 */ 0xdd7a,    BAD, 0xdd7b, 0xb762, 0xb76b, 0xdda4, 0xb76e, 0xb76f,
/* 18 */ 0xdda5,    BAD, 0xddb2, 0xddb8, 0xb76a,    BAD, 0xb764, 0xdda3,
/* 20 */ 0xdd7d, 0xddba, 0xdda8, 0xdda9, 0xdd7e, 0xddb4, 0xddab, 0xddb5,
/* 28 */ 0xddad,    BAD, 0xb765, 0xe1d9, 0xb768, 0xb766, 0xddb9, 0xddb0,
/* 30 */ 0xddac,    BAD,    BAD, 0xdda1, 0xba53, 0xddaf, 0xb76d, 0xdda7,
/* 38 */    BAD, 0xdda6,    BAD,    BAD,    BAD, 0xb767, 0xb763, 0xe1ee
},

/* Row 0x079 */
{
/* 00 */ 0xddb3, 0xddae,    BAD, 0xdda2,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe1e9,    BAD, 0xe1da, 0xe1e5,    BAD,
/* 10 */ 0xe1ec, 0xba51, 0xb4ac, 0xe1ea, 0xba4c,    BAD,    BAD,    BAD,
/* 18 */ 0xba4b, 0xe1f1,    BAD, 0xe1db, 0xe1e8, 0xe1dc, 0xe1e7, 0xba4f,
/* 20 */ 0xe1eb, 0xd962,    BAD,    BAD,    BAD, 0xe1f2, 0xe1e3, 0xba52,
/* 28 */ 0xe5ba, 0xbcaf,    BAD, 0xe1f0, 0xe1ef, 0xba54, 0xe5ad, 0xbcb0,
/* 30 */ 0xe5ae,    BAD, 0xe1df, 0xe1e0, 0xe1dd, 0xe1e2, 0xe1de, 0xe1f3,
/* 38 */ 0xba4e, 0xbcb1, 0xba50, 0xba55,    BAD, 0xe1e1,    BAD, 0xe1ed
},

/* Row 0x07a */
{
/* 00 */    BAD,    BAD, 0xe1e6,    BAD,    BAD, 0xe5b1,    BAD, 0xba4a,
/* 08 */ 0xbcb4, 0xe9aa, 0xe5b6, 0xe5b5, 0xe5b7,    BAD,    BAD, 0xe5b4,
/* 10 */ 0xbcb5,    BAD, 0xbcbb, 0xbcb8,    BAD, 0xbcb9, 0xe5af, 0xe5b2,
/* 18 */ 0xe5bc, 0xbcc1, 0xbcbf,    BAD, 0xe5b3, 0xd95a, 0xbcb2, 0xe5b9,
/* 20 */ 0xe5b0,    BAD, 0xbcc2, 0xe5b8, 0xba4d, 0xbcb7, 0xe1e4,    BAD,
/* 28 */    BAD, 0xbcba,    BAD, 0xbcbe, 0xbcc0, 0xbcbd, 0xbcbc,    BAD,
/* 30 */ 0xbcb6, 0xe5bb, 0xbcb3, 0xbcc3,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xbed8, 0xbed9, 0xe9a9, 0xbee2, 0xbedf
},

/* Row 0x07b */
{
/* 00 */    BAD, 0xbed6, 0xbedd, 0xe9ab, 0xbedb, 0xbed5,    BAD, 0xbedc,
/* 08 */    BAD, 0xe9a8, 0xc0bb, 0xbed7,    BAD, 0xbede, 0xc0ba, 0xe9a7,
/* 10 */ 0xe9a6,    BAD, 0xbee0,    BAD, 0xbee1,    BAD, 0xe9a5, 0xe9a4,
/* 18 */ 0xc0bc, 0xe9ae, 0xbeda, 0xe9ac,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xc0bd,    BAD, 0xc0c2, 0xecea, 0xecec,    BAD, 0xc0bf,    BAD,
/* 28 */ 0xeced, 0xece9,    BAD, 0xeceb, 0xc0c0, 0xc0c3,    BAD, 0xece8,
/* 30 */ 0xc0be, 0xc0c1, 0xc259, 0xe9ad, 0xc258,    BAD,    BAD, 0xc25e,
/* 38 */ 0xefd4,    BAD, 0xc25c, 0xc25d, 0xefd7, 0xefd3, 0xc25a, 0xefd1
},

/* Row 0x07c */
{
/* 00 */ 0xc36b, 0xefd5,    BAD, 0xefd6, 0xefd2,    BAD, 0xc25b, 0xf242,
/* 08 */    BAD, 0xf245,    BAD,    BAD, 0xf246, 0xf244, 0xf247, 0xc36c,
/* 10 */ 0xf243,    BAD,    BAD, 0xf44e, 0xc464, 0xf44d, 0xf44c, 0xf44b,
/* 18 */ 0xc463, 0xc465,    BAD, 0xf5cd, 0xc4e2, 0xc4e1,    BAD,    BAD,
/* 20 */ 0xf6e1, 0xf6e0, 0xf6e3, 0xc5cb, 0xc575, 0xf7dd, 0xf6e2,    BAD,
/* 28 */    BAD, 0xf7dc, 0xc5cd, 0xc5cc, 0xc5f3, 0xf8a9, 0xf8ef, 0xa4e4,
/* 30 */    BAD,    BAD, 0xd972, 0xe9af,    BAD,    BAD, 0xa6ac, 0xcaf7,
/* 38 */ 0xa7f1, 0xa7ef,    BAD, 0xa7f0,    BAD, 0xccc1, 0xa9f1, 0xac46
},

/* Row 0x07d */
{
/* 00 */    BAD, 0xcee7,    BAD, 0xcee8,    BAD, 0xac47, 0xd1ce,    BAD,
/* 08 */ 0xaec4, 0xaec5, 0xd1cd,    BAD,    BAD,    BAD,    BAD, 0xb1d3,
/* 10 */    BAD, 0xb1cf,    BAD, 0xd5a7, 0xb1d6, 0xb1d5, 0xb1ce, 0xb1d1,
/* 18 */ 0xb1d4, 0xb1d0,    BAD,    BAD, 0xd976, 0xb1cd, 0xb4af,    BAD,
/* 20 */    BAD,    BAD, 0xb4b1, 0xb4b2, 0xd975, 0xd978, 0xb4b0, 0xd973,
/* 28 */ 0xd977,    BAD, 0xd974,    BAD, 0xb771,    BAD,    BAD, 0xddbc,
/* 30 */    BAD,    BAD, 0xba56, 0xe1f4, 0xbee3, 0xbcc4, 0xe5bd, 0xbcc5,
/* 38 */ 0xbcc6, 0xe5bf, 0xe5be, 0xe5c0, 0xe9b1,    BAD,    BAD, 0xe9b0
},

/* Row 0x07e */
{
/* 00 */ 0xecef, 0xecee, 0xc0c4, 0xc0c5, 0xf248,    BAD,    BAD, 0xa4e5,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xd979,    BAD,    BAD,    BAD,
/* 10 */ 0xb4b4, 0xb4b3, 0xddbd,    BAD, 0xefd8, 0xc4e3, 0xf7de, 0xa4e6,
/* 18 */    BAD, 0xaec6,    BAD, 0xb1d8, 0xb1d7, 0xd97a, 0xd97b, 0xb772,
/* 20 */ 0xe1f5, 0xba57, 0xe9b2,    BAD, 0xa4e7, 0xa5b8,    BAD, 0xa9f2,
/* 28 */ 0xccc2,    BAD, 0xcee9, 0xac48, 0xb1d9,    BAD, 0xd97c, 0xb4b5,
/* 30 */ 0xb773,    BAD, 0xe5c1, 0xe5c2,    BAD,    BAD, 0xecf0, 0xc25f,
/* 38 */ 0xf8f0, 0xa4e8,    BAD, 0xccc3, 0xa9f3, 0xac49,    BAD, 0xceea
},

/* Row 0x07f */
{
/* 00 */    BAD, 0xaec7, 0xd1d2, 0xd1d0, 0xd1d1, 0xaec8, 0xd1cf,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xb1db, 0xb1dc, 0xd5a8, 0xb1dd, 0xb1da,
/* 10 */ 0xd97d,    BAD, 0xd97e, 0xddbe,    BAD,    BAD, 0xba59, 0xba58,
/* 18 */    BAD,    BAD, 0xecf1, 0xefd9,    BAD, 0xf24a, 0xf249, 0xf44f,
/* 20 */    BAD, 0xc95e, 0xac4a,    BAD,    BAD, 0xa4e9, 0xa5b9,    BAD,
/* 28 */ 0xa6ae, 0xa6ad,    BAD,    BAD, 0xa6af, 0xa6b0, 0xc9ee, 0xc9ed,
/* 30 */ 0xcaf8, 0xa7f2, 0xcafb, 0xcafa, 0xcaf9, 0xcafc,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xa9f4, 0xccc9, 0xccc5, 0xccce,    BAD,    BAD
},

/* Row 0x080 */
{
/* 00 */ 0xa9fb,    BAD, 0xa9f9, 0xccca, 0xccc6, 0xcccd, 0xa9f8, 0xaa40,
/* 08 */ 0xccc8, 0xccc4, 0xa9fe, 0xcccb, 0xa9f7, 0xcccc, 0xa9fa, 0xa9fc,
/* 10 */ 0xccd0, 0xcccf, 0xccc7, 0xa9f6, 0xa9f5, 0xa9fd,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xceef, 0xcef5,    BAD, 0xac50,
/* 20 */ 0xac4d, 0xceec, 0xcef1,    BAD, 0xac53, 0xac4b, 0xcef0, 0xac4e,
/* 28 */ 0xac51,    BAD,    BAD, 0xcef3,    BAD, 0xac4c, 0xcef8, 0xac4f,
/* 30 */    BAD, 0xac52, 0xceed, 0xcef2, 0xcef6, 0xceee, 0xceeb,    BAD,
/* 38 */    BAD, 0xcef7, 0xcef4,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x081 */
{
/* 00 */    BAD, 0xaed0, 0xaec9, 0xaecc,    BAD, 0xaecf,    BAD, 0xd1d5,
/* 08 */    BAD, 0xaeca, 0xd1d3,    BAD, 0xaece,    BAD,    BAD, 0xaecb,
/* 10 */    BAD, 0xd1d6, 0xaecd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xd5ac, 0xb1df, 0xd5ab, 0xd5ad, 0xb1de, 0xb1e3, 0xd1d4,
/* 20 */    BAD, 0xd5aa, 0xd5ae,    BAD, 0xb1e0, 0xd5a9, 0xb1e2,    BAD,
/* 28 */ 0xb1e1,    BAD, 0xd9a7,    BAD, 0xd9a2,    BAD, 0xb4b6, 0xb4ba,
/* 30 */ 0xb4b7, 0xd9a5, 0xd9a8,    BAD, 0xb4b8,    BAD, 0xb4b9, 0xb4be,
/* 38 */ 0xddc7, 0xd9a6, 0xb4bc, 0xd9a3, 0xd9a1,    BAD, 0xb4bd,    BAD
},

/* Row 0x082 */
{
/* 00 */ 0xd9a4,    BAD,    BAD,    BAD, 0xb779,    BAD, 0xddbf, 0xb776,
/* 08 */ 0xb777, 0xb775, 0xddc4, 0xddc3, 0xddc0, 0xb77b,    BAD,    BAD,
/* 10 */ 0xddc2, 0xb4bb,    BAD,    BAD, 0xddc6, 0xddc1, 0xb778, 0xb774,
/* 18 */ 0xb77a, 0xddc5,    BAD,    BAD,    BAD, 0xba5c,    BAD, 0xe1f8,
/* 20 */ 0xe1f7, 0xe1f6, 0xba5a,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xba5b, 0xe5c5, 0xe5c8, 0xbcc8,    BAD,    BAD, 0xbcc7, 0xe5c9,
/* 30 */ 0xe5c4, 0xbcca, 0xe5c6,    BAD, 0xbcc9, 0xe5c3,    BAD, 0xe5c7,
/* 38 */ 0xbee9, 0xbee6, 0xe9bb, 0xe9ba,    BAD, 0xe9b9, 0xe9b4,    BAD
},

/* Row 0x083 */
{
/* 00 */ 0xe9b5,    BAD,    BAD,    BAD, 0xbee7,    BAD, 0xbee4, 0xbee8,
/* 08 */ 0xe9b3, 0xbee5, 0xe9b6, 0xe9b7, 0xe9bc,    BAD,    BAD, 0xe9b8,
/* 10 */    BAD,    BAD, 0xecf2,    BAD,    BAD,    BAD, 0xc0c7,    BAD,
/* 18 */ 0xefdc, 0xc0c6, 0xefda, 0xefdb, 0xc260, 0xc36e, 0xf24b,    BAD,
/* 20 */ 0xc36d,    BAD,    BAD, 0xf451, 0xf452,    BAD, 0xc466,    BAD,
/* 28 */ 0xf450, 0xc4e4,    BAD, 0xf7df, 0xc5ce, 0xf8aa, 0xf8ab,    BAD,
/* 30 */ 0xa4ea,    BAD, 0xa6b1, 0xa6b2, 0xa7f3,    BAD, 0xccd1, 0xac54,
/* 38 */ 0xaed1, 0xb1e4,    BAD,    BAD, 0xb0d2,    BAD, 0xb4bf, 0xb4c0
},

/* Row 0x084 */
{
/* 00 */ 0xb3cc, 0xd9a9,    BAD, 0xb77c, 0xe1fa, 0xe1f9,    BAD,    BAD,
/* 08 */ 0xa4eb, 0xa6b3, 0xccd2, 0xaa42,    BAD, 0xaa41,    BAD, 0xcef9,
/* 10 */ 0xcefa,    BAD, 0xd1d7, 0xd1d8, 0xaed2, 0xaed3,    BAD, 0xaed4,
/* 18 */ 0xd5af,    BAD,    BAD, 0xb1e6,    BAD, 0xb4c2,    BAD, 0xb4c1,
/* 20 */ 0xddc8, 0xdf7a, 0xe1fb, 0xe9bd,    BAD,    BAD, 0xc261, 0xc467,
/* 28 */ 0xa4ec,    BAD, 0xa5bc, 0xa5bd, 0xa5bb, 0xa5be, 0xa5ba,    BAD,
/* 30 */    BAD, 0xa6b6,    BAD, 0xc9f6, 0xa6b5, 0xa6b7,    BAD,    BAD,
/* 38 */ 0xc9f1, 0xc9f0, 0xc9f3, 0xc9f2, 0xc9f5, 0xa6b4, 0xc9ef, 0xc9f4
},

/* Row 0x085 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xcafd, 0xa7fd, 0xcafe,
/* 08 */ 0xcb43, 0xa7fc,    BAD, 0xcb47, 0xcb42, 0xcb45, 0xa7f5, 0xa7f6,
/* 10 */ 0xa7f7, 0xa7f8,    BAD, 0xa840,    BAD, 0xcb41, 0xa7fa, 0xa841,
/* 18 */    BAD, 0xcb40, 0xcb46,    BAD, 0xa7f9, 0xcb44, 0xa7fb, 0xa7f4,
/* 20 */ 0xa7fe,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xaa57,    BAD, 0xccd4, 0xaa43,    BAD, 0xaa4d,
/* 30 */ 0xaa4e, 0xaa46, 0xaa58, 0xaa48, 0xccdc, 0xaa53, 0xccd7, 0xaa49,
/* 38 */ 0xcce6, 0xcce7, 0xccdf, 0xccd8, 0xaa56, 0xcce4, 0xaa51, 0xaa4f
},

/* Row 0x086 */
{
/* 00 */    BAD, 0xcce5,    BAD, 0xcce3, 0xccdb, 0xccd3, 0xccda, 0xaa4a,
/* 08 */    BAD, 0xaa50,    BAD, 0xaa44, 0xccde, 0xccdd, 0xccd5,    BAD,
/* 10 */ 0xaa52, 0xcce1, 0xccd6, 0xaa55, 0xcce8, 0xaa45,    BAD, 0xaa4c,
/* 18 */ 0xccd9, 0xcce2, 0xaa54,    BAD, 0xaa47, 0xaa4b,    BAD, 0xcce0,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcf5b, 0xac5c,
/* 30 */ 0xac69,    BAD, 0xcf56, 0xcf4c, 0xac62, 0xcf4a, 0xac5b, 0xcf45,
/* 38 */ 0xac65, 0xcf52, 0xcefe, 0xcf41,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x087 */
{
/* 00 */ 0xcf44, 0xcefb, 0xcf51, 0xcf61, 0xac60, 0xcf46, 0xcf58,    BAD,
/* 08 */ 0xcefd, 0xcf5f, 0xcf60, 0xcf63, 0xcf5a, 0xcf4b, 0xcf53, 0xac66,
/* 10 */ 0xac59, 0xac61, 0xac6d, 0xac56, 0xac58,    BAD,    BAD,    BAD,
/* 18 */ 0xcf43, 0xac6a, 0xac63, 0xcf5d, 0xcf40, 0xac6c, 0xac67, 0xcf49,
/* 20 */    BAD,    BAD, 0xac6b, 0xcf50, 0xcf48, 0xac64, 0xcf5c, 0xcf54,
/* 28 */    BAD, 0xac5e, 0xcf62, 0xcf47, 0xac5a, 0xcf59, 0xcf4f, 0xac5f,
/* 30 */ 0xcf55, 0xac57, 0xcefc, 0xac68, 0xaee3, 0xac5d, 0xcf4e, 0xcf4d,
/* 38 */ 0xcf42,    BAD, 0xcf5e,    BAD, 0xcf57,    BAD,    BAD, 0xac55
},

/* Row 0x088 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xd1ec, 0xaeea, 0xd1ed,    BAD, 0xd1e1, 0xaedf,
/* 18 */ 0xaeeb,    BAD, 0xd1da,    BAD, 0xd1e3, 0xd1eb,    BAD, 0xd1d9,
/* 20 */ 0xd1f4, 0xaed5,    BAD,    BAD,    BAD, 0xd1f3, 0xd1ee,    BAD,
/* 28 */ 0xd1ef, 0xaedd, 0xaee8, 0xd1e5,    BAD, 0xd1e6, 0xd1f0, 0xd1e7,
/* 30 */    BAD, 0xd1e2, 0xd1dc, 0xd1dd, 0xd1ea, 0xd1e4,    BAD,    BAD,
/* 38 */ 0xaed6, 0xaeda, 0xd1f2, 0xd1de, 0xaee6, 0xaee2,    BAD,    BAD
},

/* Row 0x089 */
{
/* 00 */ 0xaee5, 0xaeec, 0xaedb, 0xaee7, 0xd1e9, 0xaee9, 0xaed8,    BAD,
/* 08 */ 0xaed7, 0xd1db,    BAD, 0xd1df, 0xaee0, 0xd1f1, 0xd1e8, 0xd1e0,
/* 10 */ 0xaee4, 0xaee1,    BAD, 0xaed9, 0xaedc,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xd5c4,    BAD, 0xd5b4, 0xd5b5, 0xd5b9,
/* 30 */    BAD, 0xd5c8, 0xd5c5,    BAD, 0xd5be, 0xd5bd, 0xb1ed, 0xd5c1,
/* 38 */ 0xd5d0, 0xd5b0,    BAD, 0xd5d1, 0xd5c3, 0xd5d5, 0xd5c9, 0xb1ec
},

/* Row 0x08a */
{
/* 00 */ 0xd5c7, 0xb1e7, 0xb1fc, 0xb1f2,    BAD, 0xb1f6, 0xb1f5, 0xd5b1,
/* 08 */    BAD, 0xd5ce, 0xd5d4, 0xd5cc, 0xd5d3,    BAD,    BAD, 0xd5c0,
/* 10 */ 0xd5b2, 0xd5d2, 0xd5c2, 0xb1ea, 0xb1f7,    BAD, 0xd5cb, 0xb1f0,
/* 18 */    BAD,    BAD,    BAD, 0xd5ca, 0xd5b3, 0xb1f8,    BAD, 0xb1fa,
/* 20 */ 0xd5cd, 0xb1fb, 0xb1e9, 0xd5ba, 0xd5cf,    BAD,    BAD, 0xb1ef,
/* 28 */ 0xb1f9, 0xd5bc, 0xd5c6, 0xd5b7, 0xd5bb, 0xb1f4, 0xd5b6, 0xb1e8,
/* 30 */ 0xb1f1, 0xb1ee, 0xd5bf, 0xaede, 0xd9c0, 0xb1eb,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x08b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xb1f3,    BAD, 0xd9c3, 0xd9d9,
/* 08 */ 0xd9ce, 0xb4d6,    BAD, 0xb4d1, 0xd9bd, 0xb4d2, 0xd9cd,    BAD,
/* 10 */ 0xd9c6, 0xd9d3, 0xb4ce, 0xd9ab, 0xd9d5, 0xb4c4, 0xd9b3, 0xb4c7,
/* 18 */ 0xb4c6,    BAD, 0xb4d7,    BAD, 0xd9ad, 0xd9cf, 0xd9d0, 0xb4c9,
/* 20 */ 0xb4c5, 0xd9bb,    BAD, 0xb4d0, 0xd9b6,    BAD, 0xd9d1, 0xb4cc,
/* 28 */ 0xd9c9, 0xd9d6, 0xd9b0, 0xd9b5, 0xd9af,    BAD, 0xb4cb, 0xd9c2,
/* 30 */ 0xddde, 0xd9b1, 0xb4cf, 0xd9ba, 0xd9d2, 0xb4ca, 0xd9b7, 0xd9b4,
/* 38 */ 0xd9c5, 0xb4cd, 0xb4c3, 0xb4d9, 0xd9c8, 0xd9c7,    BAD,    BAD
},

/* Row 0x08c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xd9ac, 0xb4c8, 0xd9d4, 0xd9bc,
/* 08 */ 0xd9be,    BAD, 0xd9cb, 0xd9ca, 0xd9aa, 0xb4d3, 0xb4d5, 0xd9b2,
/* 10 */ 0xd9b9, 0xd9c1, 0xb4d4, 0xd9b8, 0xd9c4, 0xd9d7,    BAD, 0xd9cc,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd9d8,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xd9ae,    BAD,    BAD,    BAD,    BAD, 0xddf2,
/* 30 */ 0xb7a6,    BAD, 0xddf0, 0xdddb, 0xdde0, 0xddd9,    BAD, 0xddec,
/* 38 */ 0xddcb, 0xddd2,    BAD, 0xddea, 0xddf4, 0xdddc,    BAD, 0xddcf
},

/* Row 0x08d */
{
/* 00 */ 0xdde2, 0xdde7, 0xddd3,    BAD, 0xdde4, 0xddd0,    BAD,    BAD,
/* 08 */ 0xddd7, 0xddd8, 0xb7a8, 0xddeb, 0xdde9,    BAD, 0xddcc, 0xddee,
/* 10 */    BAD, 0xddef, 0xddf1, 0xb7ac, 0xb7a4,    BAD, 0xd5b8, 0xddd4,
/* 18 */ 0xdde6, 0xddd5, 0xb7a1, 0xb7b1, 0xdded, 0xb7af, 0xb7ab, 0xddca,
/* 20 */ 0xb7a3,    BAD, 0xddcd, 0xb7b0,    BAD, 0xdddd, 0xddc9,    BAD,
/* 28 */ 0xb7a9, 0xdde1, 0xddd1, 0xb7aa, 0xddda, 0xb77e, 0xb4d8, 0xdde3,
/* 30 */ 0xd9bf, 0xddce,    BAD,    BAD, 0xdde8, 0xb7a5, 0xdde5, 0xb7a2,
/* 38 */ 0xdddf, 0xb7ad, 0xddd6, 0xddf3,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x08e */
{
/* 00 */    BAD,    BAD, 0xb7a7, 0xdec6,    BAD,    BAD, 0xb7ae,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe24a, 0xe248,    BAD,
/* 10 */ 0xe25e, 0xe246,    BAD, 0xe258, 0xb77d, 0xba5f, 0xe242, 0xe25d,
/* 18 */    BAD, 0xe247, 0xe255, 0xba64, 0xba5d,    BAD, 0xe25b,    BAD,
/* 20 */ 0xe240, 0xe25a,    BAD, 0xba6f, 0xe251, 0xe261, 0xba6d, 0xe249,
/* 28 */ 0xba5e, 0xe24b, 0xe259, 0xba67, 0xe244, 0xba6b, 0xba61, 0xe24d,
/* 30 */ 0xe243, 0xe1fc,    BAD, 0xe257, 0xba68, 0xe260, 0xe1fd, 0xba65,
/* 38 */    BAD, 0xe253,    BAD, 0xba66, 0xe245, 0xe250, 0xe24c, 0xe24e
},

/* Row 0x08f */
{
/* 00 */    BAD, 0xba60, 0xe25f, 0xba6e, 0xe24f,    BAD, 0xe262,    BAD,
/* 08 */    BAD, 0xe1fe, 0xe254, 0xba63, 0xba6c, 0xba6a, 0xe241, 0xe256,
/* 10 */ 0xba69,    BAD,    BAD, 0xba62, 0xe252,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xe25c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xe5d5,    BAD, 0xe5d1, 0xe5cd, 0xe5e1, 0xe5de,
/* 28 */ 0xbccd,    BAD,    BAD, 0xe5e5, 0xe5d4, 0xbcd8, 0xe5db,    BAD,
/* 30 */    BAD, 0xe5d0, 0xe5da, 0xbcd5, 0xe5ee,    BAD, 0xe5eb, 0xe5dd,
/* 38 */ 0xe5ce,    BAD,    BAD, 0xe5e2, 0xe5e4, 0xbcd1, 0xe5d8, 0xe5d3
},

/* Row 0x090 */
{
/* 00 */ 0xe5ca, 0xbcce, 0xbcd6,    BAD, 0xe5e7, 0xbcd7, 0xe5cb, 0xe5ed,
/* 08 */ 0xe5e0, 0xe5e6, 0xbcd4,    BAD,    BAD, 0xe5e3,    BAD, 0xe5ea,
/* 10 */    BAD, 0xbcd9,    BAD, 0xbcd3, 0xe5dc, 0xe5cf, 0xe5ef, 0xe5cc,
/* 18 */ 0xe5e8, 0xbcd0,    BAD, 0xe5d6,    BAD, 0xe5d7, 0xbccf, 0xbccc,
/* 20 */ 0xe5d2, 0xbcd2,    BAD, 0xbccb,    BAD, 0xe5e9, 0xe5ec, 0xe5d9,
/* 28 */ 0xe9ca,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xe9c2,    BAD, 0xe9be, 0xbef6,    BAD,    BAD,
/* 38 */ 0xbeeb, 0xbef0, 0xbeec, 0xe9cc, 0xe9d7, 0xbeea, 0xe9c4, 0xe9cd
},

/* Row 0x091 */
{
/* 00 */ 0xe5df, 0xe9ce,    BAD,    BAD, 0xbef1,    BAD, 0xe9dd, 0xbef5,
/* 08 */ 0xbef8, 0xe9c0,    BAD, 0xbef4,    BAD, 0xe9db, 0xe9dc, 0xe9d2,
/* 10 */ 0xe9d1, 0xe9c9,    BAD,    BAD, 0xe9d3, 0xe9da, 0xe9d9,    BAD,
/* 18 */ 0xbeef, 0xbeed, 0xe9cb, 0xe9c8,    BAD, 0xe9c5, 0xe9d8, 0xbef7,
/* 20 */ 0xe9d6, 0xbef3, 0xbef2,    BAD, 0xe9d0,    BAD, 0xe9bf, 0xe9c1,
/* 28 */ 0xe9c3, 0xe9d5, 0xe9cf, 0xbeee,    BAD, 0xe9c6,    BAD, 0xe9d4,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9c7,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc0cf, 0xed45
},

/* Row 0x092 */
{
/* 00 */ 0xc0c8, 0xecf5,    BAD, 0xed41, 0xc0ca, 0xed48,    BAD, 0xecfc,
/* 08 */    BAD, 0xecf7,    BAD,    BAD, 0xed49, 0xecf3, 0xecfe,    BAD,
/* 10 */ 0xc0d1, 0xed44, 0xed4a, 0xecfd, 0xc0c9, 0xed40, 0xecf4, 0xc0d0,
/* 18 */    BAD,    BAD, 0xed47, 0xecf9, 0xc0cc,    BAD, 0xecfb, 0xecf8,
/* 20 */ 0xc0d2, 0xecfa, 0xc0cb, 0xc0ce, 0xed43, 0xecf6, 0xed46,    BAD,
/* 28 */ 0xed42,    BAD,    BAD,    BAD, 0xc263, 0xefe7, 0xc268, 0xc269,
/* 30 */    BAD,    BAD,    BAD, 0xc262, 0xefe6,    BAD, 0xefe3, 0xefe4,
/* 38 */ 0xc266, 0xefde, 0xefe2, 0xc265,    BAD, 0xefdf,    BAD,    BAD
},

/* Row 0x093 */
{
/* 00 */    BAD,    BAD, 0xc267, 0xc264,    BAD, 0xefdd, 0xefe1, 0xefe5,
/* 08 */    BAD,    BAD,    BAD, 0xf251, 0xf24e, 0xf257,    BAD, 0xf256,
/* 10 */ 0xf254, 0xf24f,    BAD, 0xc372,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xf250, 0xc371, 0xc0cd, 0xf253, 0xc370, 0xf258, 0xf252,
/* 20 */ 0xf24d, 0xefe0,    BAD,    BAD,    BAD, 0xc36f,    BAD, 0xf24c,
/* 28 */ 0xf456,    BAD, 0xf455, 0xf255, 0xc468,    BAD, 0xf459, 0xf45a,
/* 30 */ 0xf454, 0xf458,    BAD, 0xf453,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xf5d1, 0xf457, 0xc4e7, 0xc4e5, 0xf5cf,    BAD,    BAD,    BAD
},

/* Row 0x094 */
{
/* 00 */ 0xf5d2,    BAD, 0xf5ce, 0xf5d0, 0xc4e6,    BAD,    BAD,    BAD,
/* 08 */ 0xf6e5, 0xf6e6, 0xc576, 0xf6e4,    BAD,    BAD,    BAD, 0xf7e2,
/* 10 */ 0xc5cf, 0xf7e0, 0xf7e1, 0xf8ac,    BAD,    BAD, 0xc656, 0xf8f3,
/* 18 */ 0xf8f1, 0xf8f2, 0xf8f4,    BAD,    BAD,    BAD, 0xf9bb,    BAD,
/* 20 */ 0xa4ed, 0xa6b8,    BAD, 0xaa59,    BAD, 0xcce9,    BAD,    BAD,
/* 28 */ 0xcf64,    BAD,    BAD,    BAD, 0xd1f5, 0xd1f7,    BAD, 0xd1f6,
/* 30 */    BAD, 0xd1f8, 0xb1fd, 0xd5d7, 0xd1f9,    BAD, 0xd5d6, 0xd5d8,
/* 38 */ 0xd5d9, 0xd9da, 0xb4db, 0xd9db, 0xd9dd, 0xb4dc, 0xb4da, 0xd9dc
},

/* Row 0x095 */
{
/* 00 */    BAD, 0xddfa, 0xddf8, 0xddf7,    BAD, 0xddf6, 0xddf5, 0xb7b2,
/* 08 */ 0xddf9, 0xba70, 0xe263, 0xe265, 0xba71, 0xe264, 0xbcdb,    BAD,
/* 10 */ 0xbcda, 0xe5f0,    BAD,    BAD, 0xe9df, 0xe9de, 0xe9e0,    BAD,
/* 18 */    BAD, 0xbef9,    BAD, 0xed4b, 0xc0d3,    BAD, 0xefe8, 0xc26a,
/* 20 */ 0xf259, 0xc577, 0xa4ee, 0xa5bf, 0xa6b9, 0xa842, 0xaa5a, 0xaa5b,
/* 28 */    BAD,    BAD, 0xac6e,    BAD,    BAD, 0xd1fa,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xb7b3,    BAD,    BAD,    BAD, 0xe6d1, 0xbefa,
/* 38 */ 0xc26b, 0xa4ef,    BAD, 0xa6ba,    BAD,    BAD, 0xcceb, 0xaa5c
},

/* Row 0x096 */
{
/* 00 */ 0xccea,    BAD, 0xcf65, 0xac6f, 0xcf66,    BAD, 0xac70,    BAD,
/* 08 */ 0xd1fc, 0xaeee, 0xaeed,    BAD, 0xd5de, 0xd5dc, 0xd5dd, 0xd5db,
/* 10 */    BAD, 0xd5da,    BAD,    BAD, 0xd9de, 0xd9e1, 0xb4de, 0xd9df,
/* 18 */ 0xb4dd, 0xd9e0,    BAD, 0xddfb,    BAD,    BAD, 0xe266, 0xe267,
/* 20 */ 0xe268,    BAD, 0xe5f3, 0xe5f2, 0xbcdc, 0xe5f1, 0xe5f4, 0xe9e1,
/* 28 */    BAD,    BAD, 0xe9e2, 0xe9e3,    BAD, 0xed4c, 0xc0d4, 0xc26c,
/* 30 */ 0xf25a,    BAD, 0xc4e8, 0xc95f,    BAD, 0xac71, 0xcf67, 0xaeef,
/* 38 */    BAD,    BAD, 0xb1fe,    BAD, 0xb4df, 0xd9e2,    BAD, 0xb7b5
},

/* Row 0x097 */
{
/* 00 */ 0xb7b4,    BAD,    BAD, 0xe269, 0xe26a, 0xbcdd, 0xbcde, 0xe9e5,
/* 08 */ 0xe9e4, 0xefe9, 0xf7e3, 0xa4f0, 0xc960, 0xa5c0,    BAD, 0xa843,
/* 10 */ 0xcb48,    BAD, 0xac72, 0xb7b6, 0xa4f1,    BAD, 0xcf68, 0xac73,
/* 18 */ 0xcf69,    BAD, 0xc0d5, 0xa4f2,    BAD,    BAD, 0xccec,    BAD,
/* 20 */ 0xcf6a,    BAD, 0xd242, 0xd241, 0xd1fe,    BAD, 0xd1fd, 0xd243,
/* 28 */ 0xd240,    BAD,    BAD, 0xb240, 0xb241,    BAD,    BAD, 0xb4e0,
/* 30 */ 0xd9e3,    BAD, 0xd9e4, 0xd9e5,    BAD,    BAD,    BAD, 0xde41,
/* 38 */ 0xde42, 0xde40,    BAD, 0xddfd, 0xddfe, 0xb7b7, 0xe26b, 0xe5f7
},

/* Row 0x098 */
{
/* 00 */ 0xe5f6, 0xe5f5, 0xe5f8, 0xe9e7, 0xe9e6, 0xbefb, 0xe9e8,    BAD,
/* 08 */ 0xc0d6, 0xed4d,    BAD, 0xefea, 0xf25b, 0xf6e7,    BAD, 0xa4f3,
/* 10 */ 0xa5c2, 0xa5c1,    BAD, 0xaa5d, 0xc961, 0xc97e, 0xa6bb,    BAD,
/* 18 */ 0xc9f7, 0xcb49, 0xcb4a, 0xaa5e,    BAD, 0xcced,    BAD, 0xac74,
/* 20 */ 0xcf6b, 0xcf6c,    BAD, 0xaef0, 0xaef4, 0xd244, 0xaef3, 0xaef1,
/* 28 */ 0xaef2,    BAD, 0xd5df, 0xb242, 0xb4e3,    BAD, 0xb4e1, 0xb4e2,
/* 30 */ 0xd9e6,    BAD,    BAD, 0xba72, 0xa4f4,    BAD, 0xc9a1,    BAD,
/* 38 */ 0xa5c3,    BAD,    BAD, 0xc9a4,    BAD,    BAD, 0xa5c6, 0xc9a3
},

/* Row 0x099 */
{
/* 00 */ 0xa5c5, 0xa5c4, 0xa844, 0xc9a2,    BAD,    BAD, 0xc9f8,    BAD,
/* 08 */    BAD,    BAD, 0xc9fc, 0xc9fe, 0xca40, 0xa6c5, 0xa6c6, 0xc9fb,
/* 10 */ 0xa6c1,    BAD, 0xc9f9,    BAD, 0xc9fd, 0xa6c2,    BAD, 0xa6bd,
/* 18 */    BAD, 0xa6be,    BAD, 0xa6c4, 0xc9fa, 0xa6bc, 0xa845, 0xa6bf,
/* 20 */ 0xa6c0, 0xa6c3,    BAD,    BAD,    BAD, 0xcb5b, 0xcb59, 0xcb4c,
/* 28 */ 0xa851, 0xcb53, 0xa84c, 0xcb4d,    BAD, 0xcb55,    BAD, 0xcb52,
/* 30 */ 0xa84f, 0xcb51, 0xa856, 0xcb5a, 0xa858,    BAD, 0xa85a,    BAD,
/* 38 */ 0xcb4b,    BAD, 0xa84d, 0xcb5c,    BAD, 0xa854, 0xa857,    BAD
},

/* Row 0x09a */
{
/* 00 */ 0xcd45, 0xa847, 0xa85e, 0xa855, 0xcb4e, 0xa84a, 0xa859, 0xcb56,
/* 08 */ 0xa848, 0xa849, 0xcd43, 0xcb4f, 0xa850, 0xa85b, 0xcb5d, 0xcb50,
/* 10 */ 0xa84e,    BAD, 0xa853, 0xccee, 0xa85c, 0xcb57, 0xa852,    BAD,
/* 18 */ 0xa85d, 0xa846, 0xcb54, 0xa84b, 0xcb58, 0xcd44,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xaa6a, 0xaa7a, 0xccf5, 0xaa71,    BAD,
/* 30 */ 0xcd4b, 0xaa62,    BAD, 0xaa65, 0xcd42,    BAD, 0xccf3, 0xccf7,
/* 38 */ 0xaa6d, 0xaa6f, 0xccfa, 0xaa76, 0xaa68, 0xaa66, 0xaa67, 0xaa75
},

/* Row 0x09b */
{
/* 00 */ 0xcd47, 0xaa70, 0xccf9, 0xccfb, 0xaa6e, 0xaa73, 0xccfc, 0xcd4a,
/* 08 */    BAD, 0xac75, 0xaa79,    BAD, 0xaa63, 0xcd49,    BAD, 0xcd4d,
/* 10 */ 0xccf8, 0xcd4f, 0xcd40, 0xaa6c, 0xccf4, 0xaa6b, 0xaa7d, 0xaa72,
/* 18 */    BAD, 0xccf2, 0xcf75, 0xaa78, 0xaa7c, 0xcd41, 0xcd46,    BAD,
/* 20 */ 0xaa7e, 0xaa77, 0xaa69, 0xaa5f,    BAD, 0xaa64,    BAD, 0xccf6,
/* 28 */ 0xaa60, 0xcd4e,    BAD, 0xccf0, 0xccef, 0xccfd, 0xccf1, 0xaa7b,
/* 30 */ 0xaef5, 0xaa74, 0xccfe, 0xaa61,    BAD, 0xaca6,    BAD,    BAD,
/* 38 */    BAD, 0xcd4c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x09c */
{
/* 00 */ 0xcf7c, 0xcfa1,    BAD, 0xcfa4, 0xcf77,    BAD,    BAD, 0xcfa7,
/* 08 */ 0xcfaa, 0xcfac, 0xcf74, 0xac76, 0xac7b, 0xd249, 0xacad, 0xcfa5,
/* 10 */ 0xcfad, 0xcf7b, 0xcf73,    BAD,    BAD,    BAD, 0xd264, 0xac7e,
/* 18 */ 0xcfa2, 0xcf78, 0xcf7a, 0xaca5,    BAD, 0xcf7d, 0xac7d, 0xcf70,
/* 20 */ 0xcfa8,    BAD, 0xcfab,    BAD,    BAD, 0xac7a,    BAD, 0xaca8,
/* 28 */ 0xcf6d, 0xacaa, 0xac78, 0xacae, 0xcfa9, 0xcf6f, 0xacab, 0xd25e,
/* 30 */ 0xcd48, 0xac7c, 0xac77, 0xcf76, 0xcf6e, 0xacac, 0xaca4, 0xcfa3,
/* 38 */ 0xaca9, 0xaca7, 0xcf79, 0xaca1, 0xcf71, 0xaca2, 0xaca3, 0xcf72
},

/* Row 0x09d */
{
/* 00 */ 0xcfa6, 0xac79, 0xcf7e,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xd24c, 0xaefd, 0xaf43,    BAD,    BAD,    BAD, 0xd255, 0xd25b,
/* 20 */ 0xd257, 0xd24a, 0xd24d, 0xd246, 0xd247, 0xaf4a, 0xaefa, 0xd256,
/* 28 */ 0xd25f, 0xaf45, 0xaef6,    BAD, 0xaf40, 0xd24e, 0xaf42, 0xd24f,
/* 30 */ 0xd259,    BAD,    BAD,    BAD, 0xaf44, 0xd268, 0xd248, 0xaefc,
/* 38 */ 0xaefb, 0xaf48, 0xd245, 0xd266, 0xd25a, 0xd267, 0xd261, 0xd253
},

/* Row 0x09e */
{
/* 00 */ 0xd262,    BAD, 0xd25c, 0xd265, 0xd263, 0xaf49, 0xd254, 0xaef9,
/* 08 */ 0xaef8, 0xaf41, 0xaf47, 0xd260, 0xaf46, 0xd251, 0xb243,    BAD,
/* 10 */ 0xd269, 0xd250, 0xd24b, 0xaefe, 0xaf4b, 0xaef7,    BAD, 0xd258,
/* 18 */ 0xd25d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xb265, 0xd5e1, 0xd5e5,    BAD, 0xb252, 0xb250,
/* 30 */    BAD,    BAD, 0xb247, 0xd5e3, 0xd5e2, 0xb25b,    BAD, 0xd5e8,
/* 38 */ 0xb255,    BAD, 0xd5fa, 0xd647, 0xb244, 0xd5f7, 0xd5f0, 0xb267
},

/* Row 0x09f */
{
/* 00 */ 0xd5e0,    BAD, 0xd5fc,    BAD, 0xb264, 0xb258, 0xb263, 0xb24e,
/* 08 */ 0xd5ec, 0xd5fe, 0xd5f6, 0xb24f, 0xb249, 0xd645,    BAD, 0xd5fd,
/* 10 */ 0xd640, 0xb251, 0xb259, 0xd642, 0xd5ea, 0xd5fb, 0xd5ef, 0xd644,
/* 18 */ 0xb25e, 0xb246, 0xb25c, 0xd5f4, 0xd5f2, 0xd5f3, 0xb253, 0xd5ee,
/* 20 */ 0xd5ed, 0xb248, 0xd5e7, 0xd646, 0xb24a, 0xd5f1, 0xb268,    BAD,
/* 28 */ 0xb262, 0xd5e6, 0xb25f, 0xb25d, 0xb266, 0xd5f8, 0xb261, 0xd252,
/* 30 */ 0xd5f9, 0xb260, 0xd641, 0xb245, 0xd5f5, 0xb257, 0xd5e9, 0xb256,
/* 38 */    BAD, 0xb254, 0xb24c, 0xb24b, 0xd9e7, 0xd643,    BAD,    BAD
},

/* Row 0x0a0 */
{
/* 00 */ 0xd5eb,    BAD,    BAD, 0xd9fc,    BAD, 0xb24d,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xb541, 0xb25a, 0xb4ee, 0xd9f6, 0xb4fc,    BAD, 0xd9ea,
/* 20 */ 0xb4eb, 0xb4e7, 0xda49, 0xb4ed, 0xb4f1, 0xb4ec, 0xb4f5, 0xda4d,
/* 28 */ 0xda44,    BAD,    BAD, 0xd9f1, 0xb4fa, 0xb4f4, 0xd9fd, 0xb4e4,
/* 30 */ 0xda4a, 0xda43, 0xb4e8, 0xd9f7, 0xb4f7, 0xda55, 0xda56,    BAD,
/* 38 */ 0xb4e5, 0xda48, 0xb4f9, 0xd9fb, 0xd9ed, 0xd9ee, 0xb4fd, 0xd9f2
},

/* Row 0x0a1 */
{
/* 00 */ 0xd9f9, 0xd9f3,    BAD, 0xb4fb, 0xb544, 0xd9ef, 0xd9e8, 0xd9e9,
/* 08 */    BAD, 0xd9eb, 0xb4ea, 0xd9f8,    BAD, 0xb4f8, 0xb542,    BAD,
/* 10 */    BAD, 0xd9fa, 0xda53, 0xda4b, 0xb4e6, 0xda51, 0xb4f2,    BAD,
/* 18 */ 0xb4f0,    BAD, 0xda57, 0xb4ef, 0xda41, 0xd9f4, 0xd9fe, 0xb547,
/* 20 */ 0xda45, 0xda42, 0xd9f0, 0xb543, 0xda4f, 0xda4c, 0xda54, 0xb4e9,
/* 28 */ 0xda40, 0xb546,    BAD, 0xda47,    BAD,    BAD, 0xb4f3, 0xb4f6,
/* 30 */    BAD, 0xda46, 0xb545, 0xd9f5, 0xd5e4,    BAD,    BAD, 0xda50,
/* 38 */ 0xda4e, 0xda52,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0a2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xd9ec, 0xb540,    BAD,    BAD,    BAD, 0xde61, 0xde60, 0xde46,
/* 10 */ 0xb7bd,    BAD, 0xde5f, 0xde49, 0xde4a,    BAD, 0xb7c7, 0xde68,
/* 18 */ 0xb7c2, 0xde5e,    BAD, 0xde43, 0xb7c8, 0xb7be, 0xde52, 0xde48,
/* 20 */ 0xde4b, 0xde63, 0xb7b8, 0xde6a, 0xde62, 0xb7c1, 0xde57, 0xb7cc,
/* 28 */    BAD,    BAD, 0xb7cb, 0xb7c5,    BAD,    BAD, 0xde69, 0xb7b9,
/* 30 */ 0xde55, 0xde4c, 0xde59, 0xde65, 0xb7cd,    BAD, 0xb7bb, 0xde54,
/* 38 */    BAD, 0xde4d, 0xb7c4,    BAD, 0xb7c3, 0xde50, 0xde5a, 0xde64
},

/* Row 0x0a3 */
{
/* 00 */ 0xde47, 0xde51, 0xb7bc, 0xde5b, 0xb7c9, 0xb7c0, 0xde4e, 0xb7bf,
/* 08 */ 0xde45, 0xde53, 0xde67, 0xb4fe, 0xbab0, 0xde56, 0xe26c, 0xde58,
/* 10 */ 0xde66, 0xb7c6, 0xde4f, 0xb7ba, 0xb7ca, 0xbcf0, 0xde44,    BAD,
/* 18 */ 0xde5d,    BAD,    BAD,    BAD, 0xde5c,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xe2aa, 0xbaad, 0xe27d, 0xe2a4, 0xbaa2,
/* 30 */    BAD, 0xe26e, 0xbaaf,    BAD, 0xba77, 0xe26d, 0xe2b0, 0xbab1,
/* 38 */ 0xe271, 0xe2a3,    BAD, 0xe273, 0xe2b3, 0xe2af, 0xba75, 0xbaa1
},

/* Row 0x0a4 */
{
/* 00 */ 0xe653, 0xbaae, 0xba7d, 0xe26f,    BAD, 0xe2ae, 0xbaa3, 0xe2ab,
/* 08 */ 0xe2b8, 0xe275, 0xe27e,    BAD,    BAD, 0xe2b6, 0xe2ac, 0xba7c,
/* 10 */    BAD,    BAD, 0xe27c, 0xba76, 0xba74, 0xbaa8,    BAD,    BAD,
/* 18 */ 0xe27a, 0xe277, 0xe278,    BAD, 0xe2b2,    BAD, 0xe2b7, 0xe2b5,
/* 20 */ 0xba7a, 0xe2b9, 0xba7e, 0xbaa7,    BAD, 0xe270, 0xe5fa, 0xe279,
/* 28 */    BAD, 0xba78, 0xbaac, 0xbaa9, 0xba7b, 0xe2a5, 0xe274, 0xbaaa,
/* 30 */ 0xe2a7, 0xbaa4, 0xbaa6, 0xba73,    BAD, 0xe2a9, 0xe2a1, 0xe272,
/* 38 */ 0xbaa5, 0xe2b1, 0xe2b4, 0xe27b, 0xe2a8,    BAD, 0xba79, 0xbcdf
},

/* Row 0x0a5 */
{
/* 00 */ 0xe2a6, 0xe5f9,    BAD, 0xe2ad,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe276, 0xe644,
/* 10 */ 0xe64e, 0xbce2, 0xe64d, 0xe659, 0xbce4, 0xe64b,    BAD, 0xe64f,
/* 18 */ 0xbcef,    BAD, 0xe646, 0xbce7,    BAD, 0xe652, 0xe9f0, 0xbcf3,
/* 20 */ 0xbcf2, 0xe654, 0xe643, 0xe65e, 0xbced,    BAD, 0xbce3, 0xe657,
/* 28 */    BAD, 0xe65b, 0xe660, 0xe655, 0xe649, 0xbce6, 0xbce9, 0xbcf1,
/* 30 */ 0xbcec,    BAD, 0xe64c, 0xe2a2,    BAD,    BAD, 0xe648, 0xe65f,
/* 38 */ 0xbce8,    BAD, 0xbceb, 0xe661, 0xbce0, 0xe656, 0xe5fb, 0xe65c
},

/* Row 0x0a6 */
{
/* 00 */ 0xc0df,    BAD, 0xe64a,    BAD, 0xbce1, 0xe645, 0xbce5, 0xe5fc,
/* 08 */ 0xbaab, 0xe641,    BAD, 0xe65a, 0xe642, 0xe640, 0xbcea,    BAD,
/* 10 */ 0xe658,    BAD, 0xe5fe, 0xe651, 0xe650, 0xe65d, 0xe647, 0xbcee,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe9f3,    BAD,
/* 20 */ 0xbf49, 0xbefe, 0xea40, 0xe9eb, 0xbf41, 0xe9f7, 0xbf48, 0xbf43,
/* 28 */ 0xe9f5, 0xed4f, 0xe9fb, 0xea42, 0xe9fa, 0xe9e9, 0xe9f8, 0xea44,
/* 30 */ 0xea46, 0xbefd, 0xea45, 0xbf44, 0xbf4a,    BAD, 0xbf47,    BAD,
/* 38 */ 0xe9fe, 0xbf46, 0xe9f9,    BAD, 0xe9ed, 0xe9f2,    BAD, 0xe9fd
},

/* Row 0x0a7 */
{
/* 00 */ 0xbf45, 0xbf42, 0xbefc, 0xbf40, 0xe9f1,    BAD, 0xe5fd, 0xe9ec,
/* 08 */ 0xe9ef, 0xea41, 0xe9f4, 0xe9ea, 0xed4e, 0xea43, 0xe9ee, 0xe9fc,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xed51, 0xc0e3,    BAD,    BAD,
/* 18 */ 0xc0d7,    BAD,    BAD, 0xc0db, 0xed53, 0xed59, 0xed57, 0xc0d9,
/* 20 */ 0xc0da, 0xc0e1, 0xed5a, 0xed52, 0xc0dc,    BAD, 0xed56, 0xed55,
/* 28 */ 0xed5b, 0xc0e2,    BAD, 0xc0dd, 0xc0e0, 0xed54, 0xc0e4, 0xc0de,
/* 30 */ 0xc0e5, 0xc0d8, 0xed58,    BAD, 0xed50,    BAD,    BAD, 0xeff7,
/* 38 */    BAD,    BAD, 0xc271, 0xeff4, 0xeff6,    BAD, 0xc26f, 0xeff2
},

/* Row 0x0a8 */
{
/* 00 */ 0xeff3, 0xefee,    BAD,    BAD, 0xe9f6, 0xefef, 0xc270, 0xefeb,
/* 08 */    BAD, 0xc26d, 0xeff8, 0xc26e, 0xefec, 0xefed, 0xeff1, 0xc273,
/* 10 */    BAD, 0xc272,    BAD,    BAD, 0xeff0, 0xc378, 0xf25f, 0xf265,
/* 18 */ 0xc379, 0xf25c, 0xc376, 0xc373, 0xf267, 0xc377,    BAD, 0xc374,
/* 20 */ 0xf25e, 0xf261, 0xf262, 0xf263, 0xf266,    BAD, 0xeff5, 0xf25d,
/* 28 */ 0xc375, 0xf264, 0xf268, 0xf260,    BAD,    BAD,    BAD, 0xf45d,
/* 30 */ 0xc46a, 0xf460, 0xc46b, 0xf468, 0xf45f, 0xf45c,    BAD, 0xf45e,
/* 38 */ 0xf462, 0xf465, 0xf464, 0xf467, 0xf45b,    BAD, 0xc469, 0xf463
},

/* Row 0x0a9 */
{
/* 00 */ 0xf466, 0xf469, 0xf461, 0xf5d3, 0xf5d4, 0xf5d8, 0xf5d9,    BAD,
/* 08 */ 0xf5d6, 0xf5d7, 0xf5d5,    BAD, 0xc4e9,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xc578, 0xf6eb,    BAD,    BAD, 0xf6e8, 0xf6e9, 0xf6ea,
/* 18 */ 0xc579,    BAD, 0xf7e5, 0xf7e4,    BAD, 0xf8af, 0xc5f4, 0xf8ad,
/* 20 */ 0xf8b0, 0xf8ae, 0xf8f5, 0xc657, 0xc665, 0xf9a3, 0xf96c,    BAD,
/* 28 */ 0xf9a2, 0xf9d0, 0xf9d1, 0xa4f5,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xa6c7, 0xca41,    BAD,    BAD, 0xcb5e,    BAD, 0xa85f,    BAD,
/* 38 */ 0xa862,    BAD, 0xcb5f,    BAD, 0xa860, 0xa861,    BAD,    BAD
},

/* Row 0x0aa */
{
/* 00 */    BAD,    BAD, 0xcd58, 0xcd5a, 0xcd55, 0xcd52, 0xcd54,    BAD,
/* 08 */    BAD,    BAD, 0xaaa4,    BAD,    BAD,    BAD, 0xaaa2,    BAD,
/* 10 */    BAD, 0xcd56, 0xaaa3, 0xcd53, 0xcd50, 0xaaa1, 0xcd57,    BAD,
/* 18 */ 0xcd51, 0xaaa5, 0xcd59,    BAD,    BAD,    BAD,    BAD, 0xcfaf,
/* 20 */    BAD, 0xcfb3,    BAD,    BAD, 0xacb7,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xcfb6,    BAD, 0xacaf, 0xacb2, 0xacb4, 0xacb6, 0xacb3,
/* 30 */ 0xcfb2, 0xcfb1,    BAD, 0xacb1, 0xcfb4, 0xcfb5,    BAD, 0xcfae,
/* 38 */ 0xacb5,    BAD, 0xacb0,    BAD,    BAD,    BAD, 0xcfb0,    BAD
},

/* Row 0x0ab */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd277, 0xd278, 0xd279,
/* 08 */ 0xaf50,    BAD, 0xaf4c, 0xd26e,    BAD, 0xd276, 0xd27b, 0xaf51,
/* 10 */    BAD, 0xd26c, 0xd272, 0xd26b, 0xd275,    BAD,    BAD, 0xd271,
/* 18 */ 0xaf4d, 0xaf4f, 0xd27a,    BAD, 0xd26a, 0xd26d, 0xd273,    BAD,
/* 20 */ 0xd274, 0xd27c, 0xd270,    BAD, 0xaf4e,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb26d,
/* 30 */ 0xd64e,    BAD,    BAD, 0xd650, 0xd64c,    BAD, 0xd658, 0xd64a,
/* 38 */ 0xd657, 0xb269, 0xd648, 0xda5b, 0xd652, 0xb26c,    BAD, 0xd653
},

/* Row 0x0ac */
{
/* 00 */ 0xd656,    BAD, 0xd65a,    BAD, 0xd64f,    BAD, 0xd654,    BAD,
/* 08 */    BAD, 0xb26a, 0xb26b, 0xd659, 0xd64d, 0xd649, 0xd65b,    BAD,
/* 10 */ 0xd651,    BAD,    BAD, 0xd655,    BAD,    BAD,    BAD, 0xd64b,
/* 18 */    BAD, 0xb548, 0xb549, 0xda65, 0xb54f,    BAD, 0xda59, 0xda62,
/* 20 */ 0xda58, 0xb54c, 0xda60, 0xda5e,    BAD, 0xda5f, 0xb54a,    BAD,
/* 28 */ 0xda63,    BAD,    BAD,    BAD,    BAD,    BAD, 0xda5c, 0xda5a,
/* 30 */ 0xb54b, 0xda5d, 0xda61,    BAD,    BAD,    BAD, 0xb54d,    BAD,
/* 38 */    BAD,    BAD, 0xda64,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0ad */
{
/* 00 */    BAD, 0xde70, 0xde77, 0xde79, 0xdea1,    BAD, 0xb7da, 0xde6b,
/* 08 */    BAD, 0xb7d2,    BAD, 0xde7a, 0xb7d7, 0xdea2, 0xb7ce,    BAD,
/* 10 */ 0xde7d,    BAD, 0xde6d, 0xde7e, 0xde6c,    BAD, 0xb7dc,    BAD,
/* 18 */ 0xde78, 0xb7cf, 0xdea3,    BAD, 0xb7d4, 0xde71, 0xb7d9, 0xde7c,
/* 20 */ 0xde6f, 0xde76, 0xde72, 0xde6e, 0xb7d1, 0xb7d8, 0xb7d6, 0xb7d3,
/* 28 */ 0xb7db, 0xb7d0, 0xde75,    BAD, 0xb7d5,    BAD, 0xb54e,    BAD,
/* 30 */ 0xde7b,    BAD, 0xde73,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xde74,    BAD,    BAD, 0xe2c1,    BAD, 0xbab4,    BAD,    BAD
},

/* Row 0x0ae */
{
/* 00 */ 0xe2bd, 0xe2c3, 0xe2bf,    BAD, 0xbab6, 0xe2be, 0xe2c2, 0xe2ba,
/* 08 */    BAD, 0xe2bc, 0xbab5,    BAD,    BAD,    BAD,    BAD, 0xe2c0,
/* 10 */ 0xe2bb,    BAD, 0xbab7,    BAD, 0xbab2,    BAD,    BAD, 0xe2c4,
/* 18 */    BAD, 0xbab3, 0xe667, 0xe664, 0xe670, 0xe66a, 0xe66c, 0xbcf4,
/* 20 */ 0xe666, 0xe66e,    BAD,    BAD, 0xe66d, 0xe66b,    BAD, 0xe671,
/* 28 */ 0xbcf7, 0xe668, 0xe66f,    BAD, 0xbcf5,    BAD,    BAD, 0xe663,
/* 30 */ 0xe665, 0xbcf6, 0xe662, 0xe672,    BAD, 0xe669,    BAD,    BAD,
/* 38 */ 0xea4a, 0xbf51,    BAD,    BAD, 0xea55, 0xea53, 0xbf4b, 0xea49
},

/* Row 0x0af */
{
/* 00 */ 0xea4c, 0xea4d, 0xea48, 0xbf55, 0xbf56, 0xea47, 0xea56, 0xea51,
/* 08 */ 0xbf4f, 0xbf4c, 0xea50, 0xea4e,    BAD,    BAD, 0xbf52, 0xea52,
/* 10 */ 0xbf4d,    BAD, 0xbf4e,    BAD, 0xea4f, 0xbf50, 0xea4b,    BAD,
/* 18 */ 0xea54, 0xbf53, 0xea57, 0xea58, 0xbf54,    BAD,    BAD, 0xc0e7,
/* 20 */ 0xc0ee, 0xed5c, 0xed62,    BAD, 0xed60, 0xc0ea, 0xc0e9, 0xc0e6,
/* 28 */ 0xed5e,    BAD,    BAD,    BAD, 0xc0ec, 0xc0eb, 0xc0e8,    BAD,
/* 30 */ 0xed61, 0xed5d, 0xed5f,    BAD, 0xc0ed,    BAD,    BAD,    BAD,
/* 38 */ 0xc277, 0xeffb,    BAD, 0xc274, 0xc275, 0xeffd, 0xc276, 0xeffa
},

/* Row 0x0b0 */
{
/* 00 */    BAD, 0xeff9, 0xf26c, 0xeffc,    BAD, 0xf26d, 0xc37a, 0xf26b,
/* 08 */    BAD,    BAD, 0xf26a,    BAD, 0xf269, 0xc37b,    BAD,    BAD,
/* 10 */ 0xc46c,    BAD,    BAD, 0xf46a, 0xf46b,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xf5dc, 0xf5db, 0xc4ea,    BAD, 0xf5da, 0xf6ec, 0xf6ed,
/* 20 */    BAD,    BAD, 0xf7e6, 0xf8b1,    BAD,    BAD, 0xf8f6, 0xf9bc,
/* 28 */ 0xc679, 0xf9c6, 0xa4f6,    BAD, 0xaaa6, 0xaaa7,    BAD,    BAD,
/* 30 */ 0xacb8,    BAD,    BAD,    BAD,    BAD, 0xc0ef, 0xa4f7,    BAD,
/* 38 */ 0xaaa8, 0xaf52, 0xb7dd, 0xa4f8,    BAD, 0xb26e, 0xbab8, 0xc962
},

/* Row 0x0b1 */
{
/* 00 */    BAD, 0xcfb7, 0xd27d,    BAD, 0xe2c5,    BAD, 0xc0f0, 0xa4f9,
/* 08 */ 0xaaa9, 0xcfb8, 0xcfb9, 0xda66, 0xb550,    BAD,    BAD, 0xdea4,
/* 10 */    BAD,    BAD, 0xb7de, 0xe2c6,    BAD,    BAD, 0xbcf8,    BAD,
/* 18 */ 0xc37c, 0xa4fa, 0xda67, 0xa4fb,    BAD, 0xa6c9, 0xca42, 0xa6c8,
/* 20 */ 0xa865, 0xa864, 0xa863, 0xcb60,    BAD,    BAD,    BAD, 0xaaaa,
/* 28 */    BAD, 0xaaab, 0xcd5b,    BAD, 0xcfba,    BAD, 0xcfbd, 0xacba,
/* 30 */ 0xcfbb,    BAD, 0xacb9, 0xcfbc, 0xacbb,    BAD, 0xd2a2, 0xd2a1,
/* 38 */ 0xd27e, 0xaf53,    BAD, 0xd65d, 0xd65e, 0xb26f, 0xd65c, 0xd65f
},

/* Row 0x0b2 */
{
/* 00 */ 0xb552, 0xb270,    BAD,    BAD, 0xb551, 0xda6b, 0xda6a,    BAD,
/* 08 */ 0xda68, 0xda69,    BAD, 0xda6c, 0xdea6, 0xdea5, 0xdea9,    BAD,
/* 10 */ 0xdea8, 0xdea7, 0xbab9, 0xe2c9,    BAD, 0xe2c8, 0xbaba, 0xe2c7,
/* 18 */ 0xe673,    BAD, 0xe674, 0xbcf9,    BAD, 0xea59, 0xea5a,    BAD,
/* 20 */    BAD, 0xf272, 0xc37d, 0xf271, 0xf270, 0xf26e, 0xf26f, 0xc4eb,
/* 28 */ 0xf46c, 0xf6ee, 0xf8f7,    BAD, 0xa4fc,    BAD, 0xc9a5, 0xa5c7,
/* 30 */ 0xc9a6,    BAD,    BAD,    BAD, 0xca43, 0xca44,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xcb66,    BAD,    BAD, 0xcb62,    BAD, 0xcb61
},

/* Row 0x0b3 */
{
/* 00 */ 0xaaac, 0xcb65, 0xa867, 0xcb63, 0xa866, 0xcb67, 0xcb64,    BAD,
/* 08 */    BAD, 0xcd5f, 0xcfbe, 0xcd5d, 0xcd64,    BAD, 0xaaad,    BAD,
/* 10 */ 0xaab0, 0xcd65, 0xcd61,    BAD, 0xcd62,    BAD, 0xcd5c, 0xaaaf,
/* 18 */ 0xcd5e, 0xaaae, 0xcd63,    BAD, 0xcd60,    BAD,    BAD, 0xcfc2,
/* 20 */ 0xacbd, 0xacbe,    BAD, 0xcfc5, 0xcfbf,    BAD, 0xcfc4,    BAD,
/* 28 */ 0xcfc0, 0xacbc, 0xcfc3, 0xcfc1,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xd2a8, 0xd2a5,    BAD, 0xd2a7, 0xaf58,
/* 38 */ 0xaf57, 0xaf55, 0xd2a4, 0xd2a9, 0xaf54, 0xaf56, 0xd2a6, 0xd667
},

/* Row 0x0b4 */
{
/* 00 */ 0xd2a3, 0xd2aa,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd662,
/* 08 */ 0xd666,    BAD, 0xd665, 0xda6e, 0xda79,    BAD,    BAD, 0xd668,
/* 10 */    BAD, 0xd663, 0xda6d, 0xb274,    BAD,    BAD, 0xb273, 0xd661,
/* 18 */ 0xd664, 0xb275,    BAD, 0xb272, 0xb271, 0xd660, 0xd669,    BAD,
/* 20 */    BAD,    BAD, 0xda70, 0xda77,    BAD, 0xb554, 0xda76, 0xda73,
/* 28 */    BAD, 0xb556,    BAD,    BAD,    BAD, 0xda75,    BAD,    BAD,
/* 30 */ 0xda6f, 0xda71, 0xda74, 0xda72, 0xb555, 0xda78, 0xb553, 0xb7df,
/* 38 */    BAD,    BAD, 0xdead, 0xdeac, 0xdeaa,    BAD, 0xb7e2, 0xb7e1
},

/* Row 0x0b5 */
{
/* 00 */ 0xdeae,    BAD, 0xdeab, 0xe2ca, 0xbabb, 0xb7e0,    BAD,    BAD,
/* 08 */    BAD, 0xdeb0, 0xdeaf,    BAD, 0xe2cd, 0xe2cb, 0xbcfa,    BAD,
/* 10 */ 0xbabc, 0xe2cc, 0xe676,    BAD,    BAD,    BAD,    BAD, 0xbcfb,
/* 18 */ 0xe675, 0xe67e, 0xe67d, 0xe67b,    BAD, 0xe67a, 0xe677, 0xe678,
/* 20 */ 0xe679, 0xe67c, 0xe6a1,    BAD,    BAD, 0xea5f, 0xea5c, 0xea5d,
/* 28 */ 0xbf57, 0xea5b, 0xea61, 0xea60, 0xea5e,    BAD, 0xed64, 0xed65,
/* 30 */ 0xc0f1,    BAD, 0xc0f2, 0xed63,    BAD, 0xc279, 0xeffe, 0xc278,
/* 38 */ 0xc37e,    BAD, 0xc3a1, 0xc46d, 0xf46e, 0xf46d, 0xf5dd, 0xf6ef
},

/* Row 0x0b6 */
{
/* 00 */ 0xc57a, 0xf7e8, 0xf7e7, 0xf7e9, 0xa5c8, 0xcfc6, 0xaf59, 0xb276,
/* 08 */ 0xd66a, 0xa5c9, 0xc9a7, 0xa4fd,    BAD,    BAD, 0xca45,    BAD,
/* 10 */    BAD,    BAD, 0xcb6c, 0xcb6a, 0xcb6b, 0xcb68, 0xa868, 0xcb69,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xcd6d,    BAD, 0xaab3,
/* 20 */ 0xcd6b, 0xcd67, 0xcd6a,    BAD, 0xcd66, 0xaab5, 0xcd69,    BAD,
/* 28 */ 0xaab2, 0xaab1,    BAD, 0xaab4, 0xcd6c, 0xcd68,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xacc2, 0xacc5, 0xcfce, 0xcfcd, 0xcfcc, 0xacbf,
/* 38 */ 0xcfd5, 0xcfcb,    BAD, 0xacc1, 0xd2af,    BAD, 0xcfd2, 0xcfd0
},

/* Row 0x0b7 */
{
/* 00 */ 0xacc4,    BAD, 0xcfc8, 0xcfd3,    BAD, 0xcfca, 0xcfd4, 0xcfd1,
/* 08 */ 0xcfc9,    BAD, 0xacc0, 0xcfd6, 0xcfc7, 0xacc3,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xd2b4, 0xd2ab, 0xd2b6,    BAD, 0xd2ae, 0xd2b9,
/* 18 */ 0xd2ba, 0xd2ac, 0xd2b8, 0xd2b5, 0xd2b3, 0xd2b7, 0xaf5f,    BAD,
/* 20 */ 0xaf5d,    BAD,    BAD, 0xd2b1,    BAD, 0xd2ad,    BAD, 0xd2b0,
/* 28 */ 0xd2bb, 0xd2b2, 0xaf5e, 0xcfcf,    BAD, 0xaf5a, 0xaf5c,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xd678, 0xd66d, 0xd66b,    BAD,
/* 38 */ 0xd66c,    BAD, 0xd673,    BAD, 0xd674, 0xd670, 0xb27b, 0xd675
},

/* Row 0x0b8 */
{
/* 00 */ 0xd672, 0xd66f,    BAD, 0xb279, 0xd66e, 0xb277, 0xb27a, 0xd671,
/* 08 */ 0xd679, 0xaf5b, 0xb278, 0xd677, 0xd676, 0xb27c,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xda7e,    BAD,
/* 18 */    BAD,    BAD, 0xdaa1, 0xb560,    BAD, 0xdaa7,    BAD,    BAD,
/* 20 */ 0xdaa9, 0xdaa2, 0xb55a, 0xdaa6, 0xdaa5, 0xb55b, 0xb561,    BAD,
/* 28 */ 0xb562, 0xdaa8, 0xb558, 0xda7d, 0xda7b, 0xdaa3, 0xda7a, 0xb55f,
/* 30 */ 0xda7c, 0xdaa4, 0xdaaa, 0xb559, 0xb55e, 0xb55c, 0xb55d,    BAD,
/* 38 */    BAD,    BAD, 0xb557,    BAD,    BAD,    BAD,    BAD, 0xb7e9
},

/* Row 0x0b9 */
{
/* 00 */ 0xdeb7, 0xb7e8, 0xdebb,    BAD, 0xdeb1,    BAD, 0xdebc,    BAD,
/* 08 */    BAD,    BAD, 0xdeb2, 0xdeb3,    BAD, 0xdebd, 0xdeba, 0xdeb8,
/* 10 */ 0xdeb9, 0xdeb5, 0xdeb4,    BAD, 0xdebe, 0xb7e5,    BAD, 0xdeb6,
/* 18 */    BAD, 0xb7ea, 0xb7e4, 0xb7eb, 0xb7ec,    BAD, 0xb7e7, 0xb7e6,
/* 20 */    BAD,    BAD, 0xe2ce, 0xbabe, 0xbabd,    BAD,    BAD, 0xe2d3,
/* 28 */    BAD, 0xbcfc, 0xbabf,    BAD,    BAD, 0xbac1, 0xe2d4, 0xb7e3,
/* 30 */ 0xbac0, 0xe2d0, 0xe2d2, 0xe2cf,    BAD, 0xe2d1,    BAD,    BAD,
/* 38 */    BAD, 0xe6ab,    BAD,    BAD, 0xe6aa, 0xe6a7, 0xbd40, 0xea62
},

/* Row 0x0ba */
{
/* 00 */ 0xbd41, 0xe6a6,    BAD, 0xbcfe,    BAD, 0xe6a8, 0xe6a5, 0xe6a2,
/* 08 */ 0xe6a9, 0xe6a3, 0xe6a4, 0xbcfd,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xed69,    BAD, 0xea66,    BAD, 0xea65, 0xea67,    BAD, 0xed66,
/* 18 */ 0xbf5a,    BAD, 0xea63,    BAD, 0xbf58,    BAD, 0xbf5c, 0xbf5b,
/* 20 */ 0xea64, 0xea68,    BAD, 0xbf59,    BAD, 0xed6d, 0xc0f5, 0xc27a,
/* 28 */ 0xc0f6, 0xc0f3, 0xed6a, 0xed68,    BAD, 0xed6b,    BAD, 0xed6e,
/* 30 */ 0xc0f4, 0xed6c, 0xed67,    BAD,    BAD, 0xf042, 0xf045, 0xf275,
/* 38 */ 0xf040,    BAD, 0xf46f, 0xf046,    BAD, 0xc3a2, 0xf044, 0xc27b
},

/* Row 0x0bb */
{
/* 00 */ 0xf041, 0xf043, 0xf047, 0xf276,    BAD, 0xf274,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xc3a3, 0xf273,    BAD,    BAD,    BAD, 0xc46e,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xc4ed, 0xf6f1, 0xc4ec, 0xf6f3,
/* 18 */ 0xf6f0, 0xf6f2, 0xc5d0, 0xf8b2, 0xa5ca, 0xcd6e, 0xd2bc, 0xd2bd,
/* 20 */ 0xb27d, 0xdebf, 0xbf5d, 0xc3a4, 0xc57b, 0xf8b3, 0xa5cb,    BAD,
/* 28 */ 0xcd6f, 0xa260,    BAD,    BAD, 0xcfd7,    BAD, 0xcfd8,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xd2be, 0xd2bf, 0xb27e, 0xb2a1,
/* 38 */    BAD,    BAD,    BAD, 0xdaab,    BAD, 0xdec2, 0xdec1, 0xdec0
},

/* Row 0x0bc */
{
/* 00 */ 0xe2d5,    BAD, 0xe2d6, 0xe2d7, 0xbac2,    BAD,    BAD, 0xe6ad,
/* 08 */ 0xe6ac,    BAD,    BAD, 0xea69, 0xbf5e, 0xbf5f,    BAD, 0xed72,
/* 10 */ 0xed6f, 0xed70, 0xed71, 0xf049, 0xf048, 0xc27c, 0xf277, 0xf5de,
/* 18 */ 0xa5cc,    BAD, 0xacc6,    BAD, 0xb2a2, 0xdec3,    BAD, 0xa5cd,
/* 20 */    BAD, 0xd2c0, 0xb2a3,    BAD,    BAD, 0xb563, 0xb564,    BAD,
/* 28 */ 0xa5ce, 0xa5cf, 0xca46, 0xa86a, 0xa869, 0xacc7, 0xcfd9, 0xdaac,
/* 30 */ 0xa5d0, 0xa5d1, 0xa5d2, 0xa5d3,    BAD,    BAD,    BAD, 0xa86b,
/* 38 */ 0xa86c, 0xcb6e, 0xcb6d,    BAD,    BAD, 0xaab6, 0xcd72, 0xcd70
},

/* Row 0x0bd */
{
/* 00 */ 0xcd71,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcfda,
/* 08 */ 0xcfdb,    BAD,    BAD, 0xaccb, 0xacc9,    BAD, 0xacca, 0xacc8,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xaf60,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xaf64, 0xaf63, 0xd2c1, 0xaf62, 0xaf61,    BAD, 0xd2c2,
/* 20 */    BAD,    BAD, 0xb2a6, 0xd67b, 0xd67a, 0xb2a4, 0xb2a5,    BAD,
/* 28 */    BAD,    BAD, 0xb566, 0xb565, 0xdaae,    BAD,    BAD, 0xdaad,
/* 30 */ 0xb2a7,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb7ed, 0xdec5,
/* 38 */ 0xb7ee, 0xdec4,    BAD,    BAD,    BAD, 0xe2d8, 0xe6ae, 0xbd42
},

/* Row 0x0be */
{
/* 00 */ 0xea6a,    BAD,    BAD,    BAD, 0xed73,    BAD, 0xc3a6, 0xc3a5,
/* 08 */    BAD,    BAD, 0xc57c, 0xa5d4, 0xcd73,    BAD,    BAD, 0xb2a8,
/* 10 */ 0xe2d9, 0xbac3,    BAD,    BAD, 0xcb6f, 0xcb70,    BAD,    BAD,
/* 18 */ 0xcd74, 0xaab8, 0xaab9,    BAD,    BAD, 0xaab7,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xaccf, 0xacd0, 0xaccd, 0xacce,    BAD, 0xcfdc,
/* 28 */    BAD,    BAD, 0xcfdd, 0xaccc,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xd2c3,    BAD, 0xaf68, 0xaf69,    BAD, 0xb2ab, 0xd2c9,    BAD,
/* 38 */ 0xaf6e, 0xaf6c, 0xd2ca, 0xd2c5, 0xaf6b, 0xaf6a, 0xaf65, 0xd2c8
},

/* Row 0x0bf */
{
/* 00 */ 0xd2c7, 0xd2c4, 0xaf6d,    BAD, 0xd2c6, 0xaf66,    BAD, 0xaf67,
/* 08 */    BAD,    BAD, 0xb2ac, 0xd6a1, 0xd6a2, 0xb2ad, 0xd67c, 0xd67e,
/* 10 */ 0xd6a4, 0xd6a3, 0xd67d,    BAD, 0xb2a9, 0xb2aa,    BAD, 0xdab6,
/* 18 */ 0xb56b, 0xb56a, 0xdab0, 0xb568,    BAD, 0xdab3, 0xb56c, 0xdab4,
/* 20 */ 0xb56d, 0xdab1, 0xb567, 0xb569, 0xdab5,    BAD, 0xdab2, 0xdaaf,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xded2,    BAD, 0xdec7,
/* 30 */ 0xb7f0, 0xb7f3, 0xb7f2, 0xb7f7, 0xb7f6, 0xded3, 0xded1, 0xdeca,
/* 38 */ 0xdece, 0xdecd, 0xb7f4, 0xded0, 0xdecc, 0xded4, 0xdecb, 0xb7f5
},

/* Row 0x0c0 */
{
/* 00 */ 0xb7ef, 0xb7f1,    BAD, 0xdec9,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe2db, 0xbac7, 0xe2df, 0xbac6, 0xe2dc, 0xbac5,    BAD, 0xdec8,
/* 10 */ 0xdecf, 0xe2de,    BAD, 0xbac8, 0xe2e0, 0xe2dd, 0xe2da,    BAD,
/* 18 */    BAD, 0xe6b1, 0xe6b5, 0xe6b7, 0xe6b3, 0xe6b2, 0xe6b0, 0xbd45,
/* 20 */ 0xbd43, 0xbd48, 0xbd49, 0xe6b4, 0xbd46, 0xe6af, 0xbd47, 0xbac4,
/* 28 */ 0xe6b6, 0xbd44,    BAD,    BAD,    BAD, 0xea6c,    BAD, 0xea6b,
/* 30 */ 0xea73, 0xea6d, 0xea72, 0xea6f, 0xbf60, 0xea71,    BAD,    BAD,
/* 38 */ 0xbf61,    BAD, 0xbf62,    BAD, 0xea70, 0xea6e,    BAD,    BAD
},

/* Row 0x0c1 */
{
/* 00 */    BAD,    BAD, 0xc0f8, 0xed74,    BAD,    BAD, 0xc0f7, 0xed77,
/* 08 */ 0xed75, 0xed76,    BAD,    BAD, 0xc0f9,    BAD,    BAD,    BAD,
/* 10 */ 0xf04d,    BAD, 0xc2a1, 0xf04e,    BAD,    BAD, 0xc27d, 0xf04f,
/* 18 */ 0xc27e, 0xf04c, 0xf050,    BAD, 0xf04a,    BAD,    BAD, 0xc3a7,
/* 20 */ 0xf278, 0xc3a8, 0xc46f,    BAD, 0xf04b, 0xc470,    BAD,    BAD,
/* 28 */    BAD, 0xc4ee, 0xf5df,    BAD, 0xc57e, 0xf6f4, 0xc57d,    BAD,
/* 30 */ 0xf7ea, 0xc5f5, 0xc5f6,    BAD,    BAD, 0xf9cc,    BAD,    BAD,
/* 38 */ 0xacd1, 0xcfde,    BAD, 0xb56e, 0xb56f, 0xa5d5, 0xa6ca, 0xca47
},

/* Row 0x0c2 */
{
/* 00 */    BAD, 0xcb71, 0xa86d,    BAD, 0xaaba,    BAD, 0xacd2, 0xacd3,
/* 08 */ 0xacd4, 0xd6a6, 0xd2cb, 0xaf6f,    BAD,    BAD, 0xb2ae, 0xd6a5,
/* 10 */    BAD,    BAD, 0xdab8, 0xb571,    BAD, 0xdab7, 0xb570,    BAD,
/* 18 */    BAD, 0xded5, 0xbd4a, 0xe6bb, 0xe6b8, 0xe6b9, 0xe6ba,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xed78,    BAD, 0xf051,    BAD,
/* 28 */    BAD,    BAD, 0xf471, 0xf470,    BAD, 0xf6f5, 0xa5d6, 0xcd75,
/* 30 */ 0xaf70,    BAD,    BAD,    BAD, 0xb572, 0xded6,    BAD,    BAD,
/* 38 */ 0xe2e1,    BAD, 0xbd4b, 0xea74,    BAD, 0xf052, 0xf472, 0xa5d7
},

/* Row 0x0c3 */
{
/* 00 */    BAD,    BAD, 0xaabb, 0xacd7, 0xcfdf, 0xacd8, 0xacd6,    BAD,
/* 08 */ 0xacd5, 0xd2cc, 0xaf71,    BAD,    BAD, 0xaf72, 0xaf73,    BAD,
/* 10 */    BAD,    BAD, 0xb2b0, 0xd6a7, 0xb2af,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xdab9, 0xb2b1, 0xb573, 0xded7, 0xb7f8, 0xb7f9,
/* 20 */    BAD, 0xbac9,    BAD, 0xbaca, 0xbd4c, 0xbf64, 0xea75, 0xbf63,
/* 28 */    BAD, 0xed79, 0xc0fa,    BAD, 0xf053, 0xf473, 0xa5d8, 0xa86e,
/* 30 */ 0xcd78, 0xcd77, 0xaabc, 0xcd76, 0xaabd, 0xcd79,    BAD, 0xcfe5,
/* 38 */ 0xacdb, 0xacda, 0xcfe7, 0xcfe6, 0xacdf,    BAD, 0xacde,    BAD
},

/* Row 0x0c4 */
{
/* 00 */    BAD, 0xacd9,    BAD, 0xcfe1, 0xcfe2, 0xcfe3,    BAD, 0xace0,
/* 08 */ 0xcfe0, 0xacdc, 0xcfe4, 0xacdd,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xd2cf, 0xd2d3, 0xd2d1, 0xd2d0,    BAD, 0xd2d4,    BAD,    BAD,
/* 18 */    BAD, 0xd2d5, 0xd2d6, 0xd2ce,    BAD, 0xd2cd,    BAD, 0xaf75,
/* 20 */ 0xaf76,    BAD, 0xd2d7, 0xd2d2,    BAD, 0xd6b0,    BAD, 0xd2d8,
/* 28 */ 0xaf77, 0xaf74,    BAD,    BAD,    BAD, 0xd6aa,    BAD, 0xd6a9,
/* 30 */    BAD, 0xd6ab, 0xd6ac, 0xd6ae, 0xd6ad, 0xd6b2, 0xb2b5, 0xb2b2,
/* 38 */ 0xb2b6, 0xd6a8, 0xb2b7, 0xd6b1, 0xb2b4, 0xd6af, 0xb2b3,    BAD
},

/* Row 0x0c5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xdabc, 0xdabe, 0xdaba, 0xdabb,
/* 08 */    BAD,    BAD, 0xdabf, 0xdac1, 0xdac2, 0xdabd, 0xdac0, 0xb574,
/* 10 */    BAD,    BAD, 0xdedb,    BAD, 0xdee0, 0xded8, 0xdedc,    BAD,
/* 18 */    BAD, 0xdee1, 0xdedd, 0xb7fa, 0xb843,    BAD, 0xb7fd, 0xded9,
/* 20 */ 0xdeda, 0xbace, 0xb846, 0xb7fe,    BAD, 0xb844, 0xb7fc, 0xdedf,
/* 28 */ 0xb845, 0xdede, 0xb841, 0xb7fb, 0xb842, 0xdee2, 0xe2e6, 0xe2e8,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xb840,    BAD,    BAD, 0xe2e3, 0xbacc, 0xe2e9, 0xbacd
},

/* Row 0x0c6 */
{
/* 00 */ 0xe2e7, 0xe2e2, 0xe2e5, 0xe2ea, 0xbacb, 0xe2e4,    BAD, 0xbd4e,
/* 08 */ 0xe6bf, 0xe6be,    BAD, 0xbd51, 0xbd4f, 0xe6bc, 0xbd4d, 0xe6bd,
/* 10 */    BAD, 0xbd50,    BAD,    BAD,    BAD, 0xea7d,    BAD, 0xeaa1,
/* 18 */    BAD, 0xea7e, 0xea76, 0xea7a, 0xea79, 0xea77, 0xbf66, 0xbf67,
/* 20 */ 0xbf65, 0xea78, 0xea7b, 0xea7c,    BAD, 0xbf68,    BAD, 0xc140,
/* 28 */ 0xeda3,    BAD, 0xc0fc, 0xed7b, 0xc0fe, 0xc141,    BAD,    BAD,
/* 30 */ 0xc0fd, 0xeda2, 0xed7c, 0xc0fb, 0xeda1, 0xed7a, 0xed7e, 0xed7d,
/* 38 */    BAD,    BAD, 0xf055, 0xc2a4, 0xc2a5, 0xc2a2,    BAD, 0xc2a3
},

/* Row 0x0c7 */
{
/* 00 */    BAD,    BAD, 0xf054,    BAD, 0xf27b,    BAD,    BAD, 0xc3a9,
/* 08 */    BAD, 0xf279, 0xf27a,    BAD, 0xf474, 0xf477, 0xf475, 0xf476,
/* 10 */ 0xf5e0,    BAD,    BAD, 0xc4ef, 0xf7eb, 0xf8b4,    BAD, 0xc5f7,
/* 18 */ 0xf8f8, 0xf8f9, 0xc666, 0xa5d9, 0xace1,    BAD, 0xdac3,    BAD,
/* 20 */ 0xdee3,    BAD, 0xa5da, 0xa86f,    BAD, 0xaabe,    BAD, 0xcfe8,
/* 28 */ 0xcfe9, 0xaf78,    BAD,    BAD, 0xdac4, 0xb575, 0xb847, 0xc142,
/* 30 */ 0xeda4, 0xf27c, 0xf478, 0xa5db,    BAD,    BAD,    BAD, 0xcda1,
/* 38 */ 0xcd7a, 0xcd7c, 0xcd7e, 0xcd7d, 0xcd7b, 0xaabf,    BAD,    BAD
},

/* Row 0x0c8 */
{
/* 00 */    BAD,    BAD, 0xace2, 0xcff2,    BAD, 0xcfed, 0xcfea,    BAD,
/* 08 */    BAD, 0xcff1,    BAD,    BAD, 0xace4, 0xace5, 0xcff0, 0xcfef,
/* 10 */ 0xcfee, 0xcfeb, 0xcfec, 0xcff3, 0xace3,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xaf7c,    BAD, 0xafa4,
/* 20 */ 0xafa3, 0xd2e1, 0xd2db, 0xd2d9,    BAD, 0xafa1, 0xd6b9, 0xaf7a,
/* 28 */ 0xd2de, 0xd2e2, 0xd2e4, 0xd2e0, 0xd2da, 0xafa2, 0xd2df, 0xd2dd,
/* 30 */ 0xaf79, 0xd2e5, 0xafa5, 0xd2e3, 0xaf7d, 0xd2dc,    BAD, 0xaf7e,
/* 38 */ 0xaf7b,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0c9 */
{
/* 00 */    BAD,    BAD,    BAD, 0xb2b9,    BAD, 0xd6ba,    BAD,    BAD,
/* 08 */ 0xd6b3, 0xd6b5, 0xd6b7,    BAD, 0xd6b8, 0xd6b6, 0xb2ba,    BAD,
/* 10 */ 0xd6bb,    BAD, 0xd6b4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xdac8, 0xb576, 0xdad0,    BAD,
/* 20 */ 0xdac5,    BAD, 0xdad1,    BAD, 0xdac6, 0xdac7,    BAD,    BAD,
/* 28 */ 0xdacf, 0xdace, 0xdacb, 0xb2b8, 0xb577, 0xdac9, 0xdacc, 0xb578,
/* 30 */ 0xdacd, 0xdaca,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xdeee,    BAD, 0xdef2, 0xb84e,    BAD, 0xe2f0, 0xb851
},

/* Row 0x0ca */
{
/* 00 */ 0xdef0,    BAD,    BAD, 0xdeed, 0xdee8, 0xdeea, 0xdeeb, 0xdee4,
/* 08 */    BAD, 0xb84d,    BAD,    BAD, 0xb84c,    BAD, 0xb848, 0xdee7,
/* 10 */    BAD, 0xb84f,    BAD, 0xb850, 0xdee6, 0xdee9, 0xdef1, 0xb84a,
/* 18 */ 0xb84b, 0xdeef, 0xdee5,    BAD,    BAD,    BAD, 0xe2f2, 0xbad0,
/* 20 */ 0xe2f4, 0xdeec, 0xe2f6, 0xbad4, 0xe2f7, 0xe2f3,    BAD, 0xbad1,
/* 28 */ 0xe2ef, 0xbad3, 0xe2ec, 0xe2f1, 0xe2f5, 0xe2ee,    BAD,    BAD,
/* 30 */ 0xb849,    BAD, 0xe2eb, 0xbad2, 0xe2ed,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xbd54, 0xe6c1, 0xbd58,    BAD, 0xbd56,    BAD
},

/* Row 0x0cb */
{
/* 00 */    BAD, 0xbacf,    BAD, 0xe6c8, 0xe6c9, 0xbd53,    BAD,    BAD,
/* 08 */ 0xe6c7, 0xe6ca, 0xbd55, 0xbd52, 0xe6c3, 0xe6c0, 0xe6c5, 0xe6c2,
/* 10 */ 0xbd59, 0xe6c4,    BAD,    BAD, 0xe6c6, 0xbd57,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xbf6a, 0xeaa8,    BAD, 0xeaa2, 0xeaa6, 0xeaac,
/* 20 */ 0xeaad, 0xeaa9, 0xeaaa, 0xeaa7,    BAD, 0xeaa4,    BAD, 0xbf6c,
/* 28 */ 0xbf69, 0xeaa3, 0xeaa5,    BAD, 0xbf6b, 0xeaab,    BAD, 0xc146,
/* 30 */    BAD,    BAD, 0xedaa, 0xeda5, 0xc145,    BAD,    BAD, 0xc143,
/* 38 */    BAD, 0xedac, 0xc144, 0xeda8, 0xeda9, 0xeda6, 0xedad, 0xf056
},

/* Row 0x0cc */
{
/* 00 */    BAD, 0xc147, 0xeda7,    BAD, 0xedae, 0xedab,    BAD,    BAD,
/* 08 */    BAD, 0xf05a,    BAD,    BAD, 0xf057,    BAD, 0xc2a6,    BAD,
/* 10 */ 0xf05b, 0xf05d, 0xf05c, 0xf058, 0xf059,    BAD,    BAD, 0xf2a3,
/* 18 */    BAD, 0xc3aa,    BAD, 0xf27e, 0xf2a2, 0xf27d, 0xf2a4,    BAD,
/* 20 */    BAD, 0xf2a1,    BAD, 0xf47a, 0xf47d, 0xf479, 0xc471, 0xf47b,
/* 28 */ 0xf47c, 0xf47e, 0xc472, 0xc474, 0xc473, 0xf5e1,    BAD, 0xf5e3,
/* 30 */    BAD, 0xf5e2,    BAD,    BAD,    BAD, 0xf6f6,    BAD,    BAD,
/* 38 */ 0xf8b5, 0xf8fa, 0xa5dc,    BAD,    BAD, 0xcb72, 0xaac0, 0xcda3
},

/* Row 0x0cd */
{
/* 00 */ 0xaac1, 0xaac2, 0xcda2,    BAD, 0xcff8, 0xcff7, 0xace6, 0xace9,
/* 08 */ 0xace8, 0xace7, 0xcff4, 0xcff6, 0xcff5,    BAD,    BAD, 0xd2e8,
/* 10 */ 0xafa7, 0xd2ec, 0xd2eb, 0xd2ea, 0xd2e6, 0xafa6, 0xafaa, 0xafad,
/* 18 */    BAD,    BAD, 0xafae, 0xd2e7, 0xd2e9, 0xafac, 0xafab, 0xafa9,
/* 20 */ 0xafa8, 0xd6c2,    BAD, 0xd6c0, 0xd6bc, 0xb2bb,    BAD, 0xd6bd,
/* 28 */ 0xb2bc, 0xd6be, 0xd6bf, 0xd6c1,    BAD, 0xb2bd,    BAD,    BAD,
/* 30 */ 0xdad5,    BAD, 0xdad4, 0xdad3, 0xdad2,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xdef6, 0xb852,    BAD, 0xdef3, 0xdef5,    BAD, 0xb853
},

/* Row 0x0ce */
{
/* 00 */    BAD, 0xb854, 0xdef4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xe341,    BAD, 0xe2f9, 0xe2fa,    BAD, 0xbad7, 0xbad5, 0xbad6,
/* 10 */ 0xe343,    BAD, 0xe342, 0xe2fe, 0xe2fd, 0xe2fc, 0xe2fb, 0xe340,
/* 18 */ 0xe2f8,    BAD, 0xe6cb, 0xe6d0, 0xe6ce,    BAD,    BAD,    BAD,
/* 20 */ 0xe6cd, 0xe6cc, 0xe6cf,    BAD, 0xeaae,    BAD, 0xbf6d, 0xc148,
/* 28 */ 0xedb0,    BAD, 0xc149, 0xedaf, 0xf05f, 0xf05e, 0xc2a7,    BAD,
/* 30 */ 0xf2a5, 0xc3ab, 0xf4a1, 0xc5a1, 0xf6f7,    BAD, 0xf8b7, 0xf8b6,
/* 38 */ 0xc9a8, 0xacea, 0xaceb, 0xd6c3,    BAD, 0xb856, 0xa5dd, 0xa872
},

/* Row 0x0cf */
{
/* 00 */ 0xa871, 0xa870,    BAD,    BAD,    BAD, 0xcda4,    BAD,    BAD,
/* 08 */ 0xaac4, 0xaac3,    BAD, 0xacee,    BAD, 0xcffa, 0xcffd, 0xcffb,
/* 10 */    BAD, 0xacec, 0xaced,    BAD,    BAD, 0xcff9, 0xcffc,    BAD,
/* 18 */ 0xafb5,    BAD,    BAD,    BAD, 0xd2f3, 0xd2f5, 0xd2f4, 0xafb2,
/* 20 */ 0xd2ef,    BAD,    BAD, 0xafb0, 0xafaf,    BAD, 0xafb3, 0xafb1,
/* 28 */    BAD, 0xafb4, 0xd2f2, 0xd2ed, 0xd2ee, 0xd2f1, 0xd2f0,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd6c6, 0xd6c7,
/* 38 */ 0xd6c5,    BAD, 0xd6c4, 0xb2be,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0d0 */
{
/* 00 */ 0xb57d,    BAD, 0xdad6, 0xdad8, 0xdada, 0xb57c,    BAD,    BAD,
/* 08 */ 0xb57a,    BAD, 0xdad7, 0xb57b, 0xdad9, 0xb579,    BAD,    BAD,
/* 10 */ 0xdf41, 0xdef7, 0xdefa, 0xdefe, 0xb85a, 0xdefc,    BAD, 0xdefb,
/* 18 */ 0xdef8, 0xdef9, 0xb858, 0xdf40, 0xb857,    BAD, 0xb85c, 0xb85b,
/* 20 */ 0xb859,    BAD, 0xdefd,    BAD,    BAD,    BAD, 0xe349,    BAD,
/* 28 */ 0xe348,    BAD,    BAD, 0xe344,    BAD,    BAD, 0xbad8, 0xe347,
/* 30 */ 0xe346, 0xbad9,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbd5e,
/* 38 */    BAD, 0xe6d2,    BAD, 0xbd5f, 0xbd5b, 0xbd5d,    BAD, 0xbd5a
},

/* Row 0x0d1 */
{
/* 00 */ 0xbd5c,    BAD,    BAD,    BAD, 0xeaaf,    BAD, 0xbf70, 0xeab1,
/* 08 */ 0xeab0,    BAD, 0xe345, 0xbf72, 0xbf71, 0xbf6e, 0xbf6f,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xedb5,    BAD, 0xedb3, 0xc14a,
/* 18 */ 0xedb4,    BAD, 0xedb6, 0xedb2, 0xedb1,    BAD,    BAD, 0xf060,
/* 20 */ 0xc2aa, 0xc2a8, 0xc2a9,    BAD,    BAD,    BAD,    BAD, 0xf2a6,
/* 28 */ 0xf2a7, 0xc3ad,    BAD, 0xc3ac, 0xf4a3, 0xf4a4, 0xf4a2,    BAD,
/* 30 */ 0xf6f8, 0xf6f9,    BAD,    BAD, 0xa5de, 0xca48, 0xa873,    BAD,
/* 38 */ 0xcda5, 0xaac6, 0xaac5, 0xcda6,    BAD,    BAD, 0xd040, 0xacef
},

/* Row 0x0d2 */
{
/* 00 */ 0xcffe, 0xacf0,    BAD,    BAD, 0xafb6, 0xd2f8, 0xd2f6, 0xd2fc,
/* 08 */ 0xafb7, 0xd2f7, 0xd2fb, 0xd2f9, 0xd2fa,    BAD,    BAD, 0xd6c8,
/* 10 */ 0xd6ca,    BAD, 0xb2bf,    BAD, 0xd6c9, 0xb2c0, 0xb5a2, 0xb5a1,
/* 18 */ 0xb57e, 0xdadb,    BAD,    BAD,    BAD,    BAD, 0xdf44, 0xb85d,
/* 20 */ 0xb85e,    BAD, 0xdf43, 0xdf42,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe34a, 0xbadb, 0xbada, 0xe34b, 0xe34c,    BAD, 0xbd61, 0xbd60,
/* 30 */    BAD, 0xeab5, 0xe6d3, 0xe6d5, 0xe6d4, 0xeab4, 0xeab2, 0xeab6,
/* 38 */ 0xeab3,    BAD, 0xbf73,    BAD,    BAD,    BAD, 0xedb7, 0xc14b
},

/* Row 0x0d3 */
{
/* 00 */ 0xedb8, 0xedb9,    BAD,    BAD, 0xc2ab, 0xc2ac,    BAD, 0xc475,
/* 08 */    BAD,    BAD, 0xc5d1, 0xa5df,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xd041,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xd2fd, 0xafb8,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb3ba,
/* 20 */ 0xb3b9,    BAD,    BAD, 0xb5a4, 0xdadd, 0xb5a3, 0xdadc,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xdf45,    BAD, 0xbadc, 0xe34d, 0xbadd,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc476, 0xf4a5,
/* 38 */    BAD, 0xa6cb, 0xaac7, 0xcda7,    BAD, 0xacf2,    BAD, 0xacf1
},

/* Row 0x0d4 */
{
/* 00 */ 0xd042, 0xd043,    BAD,    BAD, 0xd340, 0xd342, 0xafb9,    BAD,
/* 08 */ 0xd344, 0xd347, 0xd345,    BAD,    BAD,    BAD, 0xd346, 0xd343,
/* 10 */ 0xd2fe, 0xafba, 0xd348, 0xd341,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xd6d3, 0xb2c6, 0xd6dc, 0xb2c3,    BAD, 0xd6d5, 0xb2c7,    BAD,
/* 20 */ 0xb2c1,    BAD, 0xd6d0, 0xd6dd, 0xd6d1, 0xd6ce, 0xb2c5,    BAD,
/* 28 */ 0xb2c2,    BAD, 0xd6d4, 0xd6d7, 0xb2c4, 0xd6d8, 0xb2c8, 0xd6d9,
/* 30 */ 0xd6cf, 0xd6d6, 0xd6da, 0xd6d2, 0xd6cd, 0xd6cb,    BAD,    BAD,
/* 38 */ 0xd6db,    BAD,    BAD, 0xdadf,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0d5 */
{
/* 00 */ 0xdae4,    BAD,    BAD,    BAD, 0xdae0, 0xdae6, 0xb5a7, 0xd6cc,
/* 08 */ 0xdae1, 0xb5a5, 0xdade, 0xb5ac, 0xdae2, 0xb5ab, 0xdae3, 0xb5ad,
/* 10 */ 0xb5a8, 0xb5ae, 0xb5a9,    BAD, 0xb5aa,    BAD, 0xb5a6,    BAD,
/* 18 */ 0xdae5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xb861, 0xdf50,    BAD, 0xdf53, 0xdf47, 0xdf4c, 0xdf46, 0xb863,
/* 28 */    BAD, 0xdf4a,    BAD,    BAD,    BAD, 0xdf48, 0xb862,    BAD,
/* 30 */ 0xdf4f, 0xdf4e, 0xdf4b, 0xdf4d, 0xdf49, 0xbae1, 0xdf52, 0xb85f,
/* 38 */ 0xdf51,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0d6 */
{
/* 00 */    BAD,    BAD, 0xe35d,    BAD, 0xbae8, 0xe358,    BAD, 0xbae7,
/* 08 */ 0xe34e,    BAD, 0xe350, 0xbae0, 0xe355, 0xe354, 0xe357, 0xbae5,
/* 10 */ 0xe352, 0xe351,    BAD,    BAD, 0xbae4, 0xbadf, 0xe353, 0xbae2,
/* 18 */ 0xe359, 0xe35b,    BAD, 0xe356, 0xe34f, 0xbae3,    BAD,    BAD,
/* 20 */ 0xbd69, 0xbade,    BAD,    BAD, 0xe35c,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe6d9, 0xbd62,    BAD, 0xe6db,
/* 30 */    BAD, 0xbd63,    BAD,    BAD, 0xbd65, 0xe6de,    BAD, 0xe6d6,
/* 38 */ 0xbae6, 0xe6dc,    BAD,    BAD,    BAD,    BAD, 0xe6d8,    BAD
},

/* Row 0x0d7 */
{
/* 00 */ 0xb860, 0xbd68,    BAD,    BAD, 0xbd64,    BAD, 0xbd66, 0xbd67,
/* 08 */    BAD, 0xbf76, 0xe6dd, 0xe6d7, 0xbd6a,    BAD, 0xe6da,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xeac0, 0xeabb,    BAD,    BAD,
/* 18 */ 0xeac5, 0xbf74, 0xeabd, 0xbf78, 0xeac3, 0xeaba, 0xeab7, 0xeac6,
/* 20 */ 0xc151, 0xbf79, 0xeac2, 0xeab8, 0xbf77, 0xeabc, 0xbf7b, 0xeab9,
/* 28 */ 0xeabe, 0xbf7a, 0xeac1, 0xeac4,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xedcb, 0xedcc, 0xedbc, 0xedc3, 0xedc1,    BAD,    BAD, 0xc14f,
/* 38 */ 0xedc8, 0xeabf,    BAD, 0xedbf,    BAD, 0xedc9, 0xc14e, 0xedbe
},

/* Row 0x0d8 */
{
/* 00 */ 0xedbd, 0xedc7, 0xedc4, 0xedc6,    BAD, 0xedba, 0xedca, 0xc14c,
/* 08 */    BAD, 0xedc5, 0xedce, 0xedc2, 0xc150, 0xc14d, 0xedc0, 0xedbb,
/* 10 */ 0xedcd, 0xbf75,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xf063,    BAD,    BAD, 0xf061, 0xf067, 0xc2b0, 0xf065,
/* 20 */ 0xf064, 0xc2b2, 0xf06a, 0xc2b1,    BAD, 0xf06b, 0xf068, 0xc2ae,
/* 28 */ 0xf069, 0xf062, 0xc2af, 0xc2ad, 0xf2ab, 0xf066,    BAD,    BAD,
/* 30 */ 0xf06c,    BAD,    BAD, 0xf2a8,    BAD,    BAD,    BAD, 0xc3b2,
/* 38 */ 0xc3b0, 0xf2aa,    BAD, 0xf2ac, 0xf2a9, 0xc3b1, 0xc3ae, 0xc3af
},

/* Row 0x0d9 */
{
/* 00 */ 0xc3b3,    BAD,    BAD, 0xc478,    BAD, 0xf4aa,    BAD, 0xf4a9,
/* 08 */ 0xf4a7, 0xf4a6, 0xf4a8,    BAD, 0xc477, 0xc479,    BAD,    BAD,
/* 10 */ 0xc4f0,    BAD,    BAD, 0xf5e5, 0xf5e4,    BAD,    BAD, 0xf6fa,
/* 18 */    BAD, 0xf6fc, 0xf6fe, 0xf6fd, 0xf6fb,    BAD,    BAD, 0xc5a3,
/* 20 */ 0xc5a2,    BAD,    BAD, 0xc5d3, 0xc5d2, 0xc5d4, 0xf7ed, 0xf7ec,
/* 28 */    BAD, 0xf8fb, 0xf8b8, 0xf8fc, 0xc658,    BAD, 0xc659, 0xf96d,
/* 30 */    BAD,    BAD, 0xc67e, 0xa6cc,    BAD, 0xcda8,    BAD,    BAD,
/* 38 */ 0xd045, 0xd046, 0xd044,    BAD,    BAD, 0xacf3,    BAD, 0xd047
},

/* Row 0x0da */
{
/* 00 */ 0xd048, 0xd049,    BAD,    BAD, 0xd349, 0xd34f,    BAD,    BAD,
/* 08 */ 0xd34d, 0xafbb, 0xd34b,    BAD, 0xd34c, 0xd34e,    BAD,    BAD,
/* 10 */    BAD, 0xd34a, 0xb2c9,    BAD, 0xd6de, 0xb2cb, 0xd6e0, 0xb2ca,
/* 18 */ 0xd6df,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdae8, 0xb5af,
/* 20 */    BAD, 0xdaea, 0xdae7, 0xd6e1,    BAD, 0xb5b0,    BAD,    BAD,
/* 28 */ 0xdae9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xdf56,
/* 30 */    BAD, 0xb864, 0xdf54, 0xb865, 0xdf55, 0xb866,    BAD,    BAD,
/* 38 */    BAD, 0xbae9, 0xe361, 0xe35e, 0xe360, 0xbaea, 0xbaeb, 0xe35f
},

/* Row 0x0db */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe6df,    BAD,    BAD,
/* 08 */ 0xe6e0,    BAD, 0xbd6b, 0xe6e2, 0xe6e1,    BAD, 0xa261,    BAD,
/* 10 */ 0xeaca, 0xeacb, 0xeac7,    BAD, 0xeac8, 0xbf7c, 0xbf7d, 0xeac9,
/* 18 */    BAD, 0xc157,    BAD,    BAD, 0xc153, 0xc158, 0xc154, 0xc156,
/* 20 */ 0xc152,    BAD, 0xc155,    BAD,    BAD,    BAD,    BAD, 0xc2b3,
/* 28 */ 0xedcf,    BAD, 0xf2ae,    BAD, 0xf2ad,    BAD, 0xf4ab, 0xc47a,
/* 30 */ 0xc47b, 0xf741, 0xf5e6,    BAD, 0xf740,    BAD, 0xf8fd, 0xf9a4,
/* 38 */ 0xa6cd,    BAD,    BAD, 0xa874,    BAD, 0xcda9, 0xaac8,    BAD
},

/* Row 0x0dc */
{
/* 00 */ 0xacf6, 0xd04c, 0xacf4, 0xd04a, 0xacf9, 0xacf5, 0xacfa, 0xacf8,
/* 08 */ 0xd04b, 0xacf7, 0xafbf, 0xafbe, 0xd35a, 0xafc7, 0xd353, 0xd359,
/* 10 */ 0xafc3, 0xd352, 0xd358, 0xd356, 0xafc2, 0xafc4, 0xd355, 0xafbd,
/* 18 */ 0xd354, 0xafc8, 0xafc5, 0xafc9, 0xafc6, 0xd351, 0xd350, 0xd357,
/* 20 */ 0xafc0, 0xafbc, 0xafc1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xd6f0, 0xd6e9,    BAD, 0xb5b5, 0xd6e8,    BAD, 0xb2cf, 0xb2d6,
/* 30 */ 0xb2d3, 0xb2d9, 0xb2d8, 0xb2d4,    BAD, 0xd6e2, 0xd6e5,    BAD,
/* 38 */ 0xd6e4, 0xb2d0, 0xd6e6, 0xd6ef, 0xb2d1, 0xd6e3, 0xd6ec, 0xd6ed
},

/* Row 0x0dd */
{
/* 00 */ 0xb2d2, 0xd6ea, 0xb2d7, 0xb2cd, 0xb2d5, 0xd6e7, 0xb2cc, 0xd6eb,
/* 08 */    BAD,    BAD, 0xd6ee,    BAD,    BAD,    BAD, 0xdafb, 0xdaf2,
/* 10 */ 0xb5b2, 0xdaf9, 0xdaf6, 0xdaee, 0xdaf7, 0xb5b4, 0xdaef,    BAD,
/* 18 */ 0xdaeb,    BAD,    BAD, 0xb86c, 0xdaf4,    BAD, 0xb5b1, 0xdafa,
/* 20 */    BAD, 0xb5b8, 0xb5ba, 0xdaed,    BAD,    BAD, 0xb5b9, 0xdaf0,
/* 28 */ 0xb5b3, 0xdaf8, 0xdaf1, 0xdaf5,    BAD, 0xdaf3, 0xb5b6, 0xdaec,
/* 30 */ 0xb5bb, 0xb2ce, 0xb5b7, 0xb5bc,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xb868, 0xdf5d, 0xdf5f, 0xdf61, 0xdf65,    BAD, 0xdf5b
},

/* Row 0x0de */
{
/* 00 */ 0xdf59, 0xb86a,    BAD, 0xdf60, 0xdf64, 0xdf5c, 0xdf58,    BAD,
/* 08 */ 0xdf57,    BAD,    BAD,    BAD, 0xdf62, 0xdf5a, 0xdf5e, 0xb86b,
/* 10 */    BAD, 0xb869, 0xdf66, 0xb867, 0xdf63,    BAD, 0xe372,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xbaee, 0xe36a, 0xbd78, 0xe374,
/* 20 */ 0xbaf1, 0xe378, 0xbaf7, 0xe365,    BAD,    BAD, 0xe375, 0xe362,
/* 28 */    BAD, 0xe377, 0xe366,    BAD, 0xbafe, 0xbafb, 0xe376, 0xe370,
/* 30 */ 0xbaed, 0xbaf5, 0xbaf4,    BAD, 0xbaf3, 0xbaf9,    BAD, 0xe363,
/* 38 */ 0xbafa, 0xe371, 0xbaf6, 0xbaec, 0xe373, 0xbaef, 0xbaf0, 0xbaf8
},

/* Row 0x0df */
{
/* 00 */ 0xe368, 0xe367, 0xe364,    BAD, 0xe36c, 0xe369, 0xe36d, 0xbafd,
/* 08 */    BAD, 0xe379, 0xbaf2, 0xe36e, 0xe36f,    BAD, 0xe36b,    BAD,
/* 10 */    BAD,    BAD, 0xbafc,    BAD,    BAD,    BAD,    BAD, 0xe6e7,
/* 18 */ 0xbd70, 0xbd79, 0xbd75, 0xe6e4,    BAD, 0xbd72, 0xbd76, 0xe6f0,
/* 20 */ 0xbd6c, 0xe6e8,    BAD, 0xbd74,    BAD,    BAD, 0xe6eb, 0xe6e6,
/* 28 */ 0xbd73, 0xbd77, 0xe6e5,    BAD, 0xbd71,    BAD, 0xe6ef, 0xbd6e,
/* 30 */ 0xe6ee, 0xe6ed, 0xbd7a, 0xe572, 0xbd6d,    BAD, 0xe6ec, 0xe6e3,
/* 38 */    BAD, 0xbd7b, 0xe6ea, 0xbd6f,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0e0 */
{
/* 00 */    BAD,    BAD,    BAD, 0xe6e9,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xbfa2, 0xbfa7, 0xbf7e, 0xead8, 0xeacf, 0xeadb, 0xead3, 0xead9,
/* 10 */ 0xbfa8, 0xbfa1, 0xeacc, 0xead2, 0xeadc, 0xead5, 0xeada, 0xeace,
/* 18 */    BAD,    BAD, 0xead6, 0xbfa3, 0xead4, 0xbfa6, 0xbfa5, 0xead0,
/* 20 */ 0xead1, 0xeacd, 0xead7, 0xbfa4, 0xeade, 0xeadd,    BAD,    BAD,
/* 28 */    BAD, 0xedda, 0xedd6, 0xc15f,    BAD, 0xedd0, 0xc159, 0xc169,
/* 30 */ 0xeddc, 0xc161, 0xc15d, 0xedd3, 0xc164, 0xc167, 0xedde, 0xc15c,
/* 38 */ 0xedd5, 0xc165, 0xede0, 0xeddd, 0xedd1, 0xc160, 0xc15a, 0xc168
},

/* Row 0x0e1 */
{
/* 00 */ 0xedd8, 0xc163, 0xedd2, 0xc15e, 0xeddf, 0xc162, 0xc15b, 0xedd9,
/* 08 */ 0xc166, 0xedd7,    BAD,    BAD, 0xeddb,    BAD,    BAD,    BAD,
/* 10 */ 0xf06e, 0xf074, 0xc2b9, 0xf077, 0xc2b4, 0xc2b5, 0xf06f, 0xf076,
/* 18 */ 0xf071, 0xc2ba, 0xc2b7,    BAD, 0xf06d,    BAD, 0xc2b6, 0xf073,
/* 20 */ 0xf075, 0xc2b8, 0xf072, 0xf070,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xf2b8, 0xc3b7, 0xc3b8, 0xc3b4,    BAD, 0xc3b5,    BAD, 0xf2b4,
/* 30 */ 0xf2b2,    BAD, 0xf2b6, 0xc3ba, 0xf2b7, 0xf2b0, 0xf2af, 0xf2b3,
/* 38 */ 0xf2b1, 0xc3b6, 0xf2b5, 0xf4ac, 0xc47e, 0xc47d, 0xf4ad,    BAD
},

/* Row 0x0e2 */
{
/* 00 */ 0xf4af, 0xf4ae, 0xc4a1,    BAD,    BAD,    BAD, 0xf5eb, 0xf5e8,
/* 08 */ 0xf5e9,    BAD, 0xf5e7, 0xf5ea, 0xc4f2, 0xf5ec,    BAD, 0xc4f1,
/* 10 */    BAD, 0xf742,    BAD, 0xc5d5, 0xc5d7, 0xf7ee, 0xc5d6, 0xf8b9,
/* 18 */ 0xf940, 0xf942, 0xf8fe, 0xf941, 0xc66c,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0e3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa6ce,    BAD,
/* 38 */ 0xacfb, 0xd26f, 0xafca,    BAD,    BAD, 0xb2da, 0xdafc, 0xdafd
},

/* Row 0x0e4 */
{
/* 00 */    BAD,    BAD,    BAD, 0xeadf, 0xc16a, 0xede1,    BAD,    BAD,
/* 08 */ 0xc2bb,    BAD, 0xf2ba, 0xf2b9, 0xc4a2, 0xf5ed,    BAD, 0xf743,
/* 10 */ 0xc5f8, 0xca49,    BAD,    BAD, 0xaac9, 0xa875,    BAD,    BAD,
/* 18 */ 0xd04d,    BAD,    BAD, 0xd360, 0xd35b, 0xd35f, 0xd35d, 0xafcb,
/* 20 */ 0xd35e, 0xd35c,    BAD, 0xd6f1,    BAD, 0xdafe, 0xdb40, 0xdf69,
/* 28 */ 0xdf6a, 0xb86e, 0xb86f, 0xdf68, 0xdf6b, 0xdf67, 0xb86d,    BAD,
/* 30 */ 0xbb40,    BAD, 0xb870, 0xe37a,    BAD, 0xbd7c, 0xe6f1, 0xbd7d,
/* 38 */    BAD, 0xbfa9, 0xeae2, 0xeae0, 0xeae1, 0xede4, 0xede3, 0xede2
},

/* Row 0x0e5 */
{
/* 00 */    BAD,    BAD,    BAD, 0xf2bb,    BAD, 0xc3b9, 0xf2bc, 0xf744,
/* 08 */ 0xc5f9, 0xf8ba, 0xa6cf, 0xaacb, 0xaaca, 0xd04f, 0xacfc,    BAD,
/* 10 */    BAD, 0xd04e, 0xd362,    BAD, 0xafcc, 0xd6f2, 0xd361,    BAD,
/* 18 */    BAD,    BAD, 0xb2dc, 0xd6f5, 0xd6f3, 0xd6f4, 0xb2db,    BAD,
/* 20 */ 0xdb42, 0xdb43, 0xdb41,    BAD, 0xb873, 0xdf6d, 0xdf6c, 0xdf6e,
/* 28 */ 0xb872, 0xb871,    BAD,    BAD, 0xe6f2, 0xe6f4,    BAD, 0xbd7e,
/* 30 */ 0xe6f3, 0xeae3, 0xbfaa, 0xf079,    BAD, 0xf078, 0xc3bb, 0xf2bd,
/* 38 */ 0xc3bd, 0xc3bc, 0xf4b0, 0xf5ee, 0xc4f3, 0xa6d0, 0xd050, 0xacfd
},

/* Row 0x0e6 */
{
/* 00 */ 0xd365, 0xafce, 0xd364, 0xd363,    BAD, 0xafcd,    BAD, 0xd6fb,
/* 08 */    BAD, 0xd6fd, 0xd6f6, 0xd6f7, 0xb2dd, 0xd6f8, 0xb2de, 0xd6fc,
/* 10 */ 0xd6f9, 0xd6fa, 0xb2df,    BAD, 0xb5be, 0xb5bf,    BAD, 0xdb44,
/* 18 */    BAD,    BAD,    BAD, 0xdf6f, 0xdf70,    BAD, 0xe37e, 0xbb43,
/* 20 */ 0xbb41, 0xbb42, 0xe37b, 0xe37c,    BAD, 0xe37d, 0xe6f9,    BAD,
/* 28 */ 0xe6fa, 0xbda1, 0xe6f7, 0xe6f6, 0xe6f8, 0xe6f5, 0xbfad, 0xeae4,
/* 30 */ 0xbfab, 0xbfac, 0xede6, 0xc16b, 0xede5, 0xefa8,    BAD, 0xf07a,
/* 38 */ 0xf07b, 0xc2bc,    BAD, 0xc2bd, 0xc16c, 0xf2be, 0xf2bf, 0xf4b1
},

/* Row 0x0e7 */
{
/* 00 */ 0xc4a3, 0xa6d1,    BAD, 0xa6d2, 0xacfe, 0xaacc, 0xafcf, 0xd051,
/* 08 */    BAD,    BAD,    BAD, 0xb5c0, 0xa6d3, 0xad41, 0xd052, 0xd053,
/* 10 */ 0xad40, 0xad42, 0xa6d4,    BAD, 0xd054, 0xafd1, 0xd366, 0xafd3,
/* 18 */ 0xafd0, 0xafd2,    BAD, 0xd741, 0xb2e0,    BAD, 0xd740, 0xd6fe,
/* 20 */    BAD, 0xdf71,    BAD,    BAD, 0xe3a1,    BAD, 0xbda2,    BAD,
/* 28 */ 0xbfae, 0xeae6, 0xeae5,    BAD, 0xede7,    BAD,    BAD,    BAD,
/* 30 */ 0xf5ef,    BAD,    BAD, 0xa6d5, 0xcb73, 0xcdaa, 0xad43, 0xd055,
/* 38 */    BAD, 0xd368,    BAD,    BAD,    BAD, 0xafd4, 0xd367, 0xafd5
},

/* Row 0x0e8 */
{
/* 00 */    BAD,    BAD,    BAD, 0xd743,    BAD,    BAD, 0xb2e2, 0xd742,
/* 08 */ 0xd744,    BAD, 0xb2e1,    BAD,    BAD,    BAD,    BAD, 0xdb46,
/* 10 */ 0xdb47, 0xdb45, 0xb5c1,    BAD,    BAD,    BAD, 0xb874,    BAD,
/* 18 */ 0xb875,    BAD, 0xbb45,    BAD, 0xe3a3, 0xe3a2, 0xbb44,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xe6fb,    BAD,    BAD, 0xe6fc,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xeae7,    BAD,    BAD, 0xc170,
/* 30 */ 0xc16f, 0xc16d, 0xc16e, 0xc171,    BAD, 0xf07c, 0xc2bf, 0xc2be,
/* 38 */ 0xf2c0, 0xf4b2,    BAD,    BAD,    BAD, 0xc5a5, 0xc5a4, 0xa6d6
},

/* Row 0x0e9 */
{
/* 00 */    BAD,    BAD, 0xd1fb,    BAD, 0xb877, 0xb5c2, 0xb876, 0xbb46,
/* 08 */    BAD, 0xa6d7, 0xc9a9, 0xa6d8, 0xa6d9,    BAD,    BAD, 0xcdab,
/* 10 */ 0xcb76,    BAD, 0xcb77, 0xa877,    BAD, 0xcb74, 0xa876,    BAD,
/* 18 */ 0xa879, 0xcb75, 0xa87b, 0xa87a, 0xcb78, 0xa878,    BAD,    BAD,
/* 20 */    BAD, 0xaad1, 0xaacf, 0xcdad,    BAD, 0xaace,    BAD,    BAD,
/* 28 */    BAD, 0xaad3, 0xaad5, 0xaad2,    BAD, 0xcdb0, 0xcdac, 0xaad6,
/* 30 */    BAD, 0xaad0, 0xa87c,    BAD, 0xaad4, 0xcdaf,    BAD,    BAD,
/* 38 */ 0xcdae,    BAD, 0xaacd,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x0ea */
{
/* 00 */    BAD,    BAD, 0xd05b, 0xad47, 0xad48, 0xd05d,    BAD, 0xd057,
/* 08 */ 0xd05a, 0xd063, 0xd061,    BAD, 0xad49, 0xd067, 0xad4c, 0xd064,
/* 10 */ 0xd05c, 0xd059,    BAD,    BAD, 0xdb49, 0xd062, 0xad44, 0xd065,
/* 18 */ 0xd056, 0xd05f, 0xad46, 0xad4b, 0xd060, 0xad4f, 0xad4d,    BAD,
/* 20 */ 0xd058, 0xad4a,    BAD, 0xd05e, 0xad4e, 0xad45, 0xd066,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xafda,    BAD, 0xafe3,
/* 30 */ 0xafd8, 0xafd6, 0xd36a, 0xafde, 0xafdb, 0xd36c,    BAD,    BAD,
/* 38 */ 0xafdd, 0xd36b, 0xd369, 0xd36e, 0xafe2, 0xafe0, 0xdb48,    BAD
},

/* Row 0x0eb */
{
/* 00 */ 0xd36f, 0xd36d, 0xafd7,    BAD,    BAD, 0xafd9, 0xafdc,    BAD,
/* 08 */ 0xafdf,    BAD, 0xafe1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd74e, 0xb2e4,    BAD,
/* 18 */ 0xd745, 0xd747,    BAD, 0xd748,    BAD, 0xd750, 0xd74c, 0xd74a,
/* 20 */    BAD, 0xd74d, 0xd751, 0xb2e5, 0xb2e9, 0xd746,    BAD, 0xd74f,
/* 28 */    BAD, 0xb2e7,    BAD, 0xb2e6, 0xd74b, 0xd749,    BAD, 0xb2e3,
/* 30 */ 0xb2e8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xb5c8, 0xdb51,    BAD,    BAD, 0xdb4f, 0xb5ca,    BAD
},

/* Row 0x0ec */
{
/* 00 */    BAD,    BAD,    BAD, 0xdb4a, 0xdfa1,    BAD, 0xb5c9, 0xdb4e,
/* 08 */    BAD,    BAD, 0xdb4b, 0xb5c5, 0xb5cb, 0xdb50, 0xb5c7, 0xdb4d,
/* 10 */ 0xbb47, 0xb5c6, 0xdb4c, 0xb5cc, 0xb5c4, 0xb5c3,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xdf77, 0xdf75,    BAD, 0xdf7b,    BAD,
/* 20 */ 0xdf73, 0xdfa2, 0xdf78,    BAD, 0xdf72, 0xb87b, 0xb8a3, 0xdf7d,
/* 28 */    BAD, 0xdf76,    BAD, 0xb87e,    BAD,    BAD, 0xb87c, 0xdf7e,
/* 30 */ 0xb879, 0xb878, 0xdf79, 0xb87d, 0xb5cd,    BAD, 0xdf7c, 0xdf74,
/* 38 */ 0xb87a, 0xb8a1, 0xb8a2,    BAD,    BAD,    BAD,    BAD, 0xbb4c
},

/* Row 0x0ed */
{
/* 00 */ 0xbb48,    BAD, 0xbb4d, 0xe3a6,    BAD,    BAD, 0xe3a5, 0xe3a7,
/* 08 */ 0xbb4a, 0xe3a4, 0xbb4b, 0xe3aa, 0xe3a9, 0xe3a8,    BAD, 0xbb49,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe741,    BAD, 0xe744,
/* 18 */ 0xbda8, 0xe743, 0xbda7, 0xbda3, 0xbda4, 0xbda5, 0xe740, 0xe6fe,
/* 20 */ 0xbda6,    BAD, 0xe742, 0xe6fd,    BAD,    BAD, 0xeae9, 0xeaf3,
/* 28 */ 0xbfb1, 0xbfb0,    BAD, 0xeaed, 0xeaef,    BAD, 0xeaea,    BAD,
/* 30 */ 0xeaee, 0xeae8, 0xeaf1, 0xbfaf, 0xeaf0, 0xeaec,    BAD, 0xeaf2,
/* 38 */    BAD, 0xeaeb, 0xc174, 0xede8, 0xedee, 0xc178, 0xc17a, 0xc177
},

/* Row 0x0ee */
{
/* 00 */ 0xc176,    BAD, 0xc175, 0xc173, 0xede9, 0xedec, 0xc172, 0xeded,
/* 08 */    BAD, 0xc179, 0xedeb,    BAD, 0xedea, 0xc2c0,    BAD, 0xc2c1,
/* 10 */ 0xf0a1, 0xf07d, 0xf07e,    BAD,    BAD, 0xf2c2,    BAD, 0xf2c1,
/* 18 */ 0xc3be, 0xf4b4, 0xc4a4, 0xf4b3,    BAD, 0xf5f0, 0xf745, 0xc5a6,
/* 20 */ 0xf943, 0xf944, 0xc5d8, 0xa6da,    BAD, 0xaad7, 0xdb52, 0xbb4e,
/* 28 */ 0xc17b, 0xedef, 0xa6db,    BAD, 0xafe5, 0xafe4, 0xdb53,    BAD,
/* 30 */    BAD,    BAD, 0xeaf4, 0xa6dc, 0xad50,    BAD,    BAD, 0xdb54,
/* 38 */ 0xdb55, 0xdb56, 0xbb4f, 0xbfb2, 0xa6dd,    BAD, 0xaad8, 0xd068
},

/* Row 0x0ef */
{
/* 00 */ 0xafe6, 0xd370, 0xb2ea,    BAD, 0xdb57, 0xb8a4,    BAD, 0xbb50,
/* 08 */ 0xbfb3, 0xc17c, 0xc2c2, 0xf4b5, 0xa6de, 0xaad9,    BAD,    BAD,
/* 10 */ 0xafe7, 0xd752, 0xb5ce,    BAD, 0xbb51, 0xe3ab, 0xe745,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xa6df, 0xb5cf, 0xdfa3, 0xbb52, 0xa6e0,
/* 20 */ 0xcdb1, 0xd069, 0xad51,    BAD,    BAD, 0xd372,    BAD,    BAD,
/* 28 */ 0xafea,    BAD, 0xafe8, 0xafe9, 0xafeb,    BAD,    BAD, 0xd371,
/* 30 */    BAD,    BAD, 0xd757, 0xd754, 0xd756, 0xb2eb, 0xb2ed, 0xb2ec,
/* 38 */ 0xd753, 0xb2ee, 0xd755,    BAD, 0xdb58, 0xdb59,    BAD, 0xdb5a
},

/* Row 0x0f0 */
{
/* 00 */ 0xdfa6,    BAD, 0xdfa7,    BAD, 0xdfa5, 0xdfa8,    BAD, 0xb8a5,
/* 08 */    BAD, 0xdfa4,    BAD, 0xbb53,    BAD,    BAD, 0xe74a, 0xe746,
/* 10 */ 0xe749, 0xe74b, 0xe748, 0xe747,    BAD, 0xeaf5, 0xeaf6, 0xeaf7,
/* 18 */ 0xbfb4, 0xbfb5, 0xedf1, 0xedf0, 0xedf2,    BAD, 0xf0a3, 0xf0a2,
/* 20 */    BAD, 0xf2c4,    BAD, 0xf2c5, 0xf2c3,    BAD, 0xc4a5,    BAD,
/* 28 */ 0xf4b6, 0xf4b7,    BAD, 0xf746, 0xf7ef, 0xf8bb, 0xa6e1, 0xa87d,
/* 30 */    BAD, 0xc17d, 0xa6e2,    BAD, 0xd758, 0xdb5b,    BAD, 0xc641,
/* 38 */ 0xca4a,    BAD,    BAD,    BAD, 0xca4b, 0xca4d, 0xa6e3, 0xca4e
},

/* Row 0x0f1 */
{
/* 00 */ 0xca4c,    BAD,    BAD, 0xcba2, 0xcba3, 0xcb7b,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xcba1, 0xa8a1,    BAD, 0xa8a2, 0xcb7c, 0xcb7a,
/* 10 */ 0xcb79, 0xcb7d, 0xa87e, 0xcb7e, 0xd06a,    BAD,    BAD,    BAD,
/* 18 */ 0xcdb6, 0xaadc, 0xcdb5, 0xcdb7,    BAD, 0xaadb, 0xcdbc, 0xaadf,
/* 20 */ 0xcdb2, 0xcdc0, 0xcdc6, 0xaae6, 0xcdc3, 0xaae3,    BAD, 0xcdb9,
/* 28 */ 0xcdbf, 0xcdc1,    BAD, 0xcdb4, 0xaae2, 0xaadd, 0xcdba, 0xaae4,
/* 30 */ 0xaae7, 0xaae1,    BAD, 0xaada, 0xcdbe, 0xcdb8, 0xcdc5, 0xaae9,
/* 38 */ 0xaae5, 0xaae0, 0xcdbd, 0xafec, 0xcdbb, 0xaade, 0xaae8,    BAD
},

/* Row 0x0f2 */
{
/* 00 */ 0xcdb3,    BAD, 0xcdc2, 0xcdc4,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xad62, 0xad5c, 0xad64, 0xad61, 0xd071, 0xd074, 0xad5d,
/* 18 */    BAD, 0xd06b,    BAD, 0xad56, 0xad60,    BAD, 0xad63, 0xad65,
/* 20 */ 0xd0a2, 0xd077,    BAD, 0xad55, 0xd0a1, 0xad59, 0xad57, 0xad52,
/* 28 */ 0xd06f,    BAD, 0xd07e, 0xd073, 0xd076, 0xd0a5,    BAD, 0xad66,
/* 30 */ 0xd07d, 0xad5e, 0xd078, 0xd0a4, 0xd075, 0xd079, 0xd07c,    BAD,
/* 38 */    BAD, 0xd06d, 0xd0a3, 0xd07b,    BAD,    BAD, 0xd06c,    BAD
},

/* Row 0x0f3 */
{
/* 00 */ 0xd070, 0xad5f, 0xad5a, 0xad53, 0xad58, 0xad54, 0xad67, 0xd06e,
/* 08 */ 0xd3a5, 0xad5b,    BAD,    BAD, 0xd07a, 0xce41,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3a8, 0xaffa,
/* 18 */    BAD, 0xd376,    BAD, 0xd3a3, 0xd37d,    BAD, 0xd3b2,    BAD,
/* 20 */ 0xd3aa,    BAD, 0xd37e,    BAD, 0xd3a9, 0xd378, 0xd37c, 0xd3b5,
/* 28 */ 0xaffd, 0xd3ad, 0xd3a4, 0xafed, 0xd3b3, 0xd374,    BAD, 0xd3ac,
/* 30 */    BAD, 0xaffc, 0xaff7, 0xd373, 0xaff5, 0xaff4, 0xaff9, 0xd3ab,
/* 38 */ 0xaff1, 0xaff8, 0xd072, 0xdb5c, 0xd3a6,    BAD,    BAD, 0xd37a
},

/* Row 0x0f4 */
{
/* 00 */ 0xaffb, 0xd37b, 0xd3a1, 0xaffe, 0xd375, 0xd3af,    BAD, 0xd3ae,
/* 08 */ 0xd3b6, 0xaff3, 0xaff0, 0xd3b4, 0xd3b0, 0xd3a7, 0xd3a2, 0xaff6,
/* 10 */ 0xaff2, 0xd377, 0xafee, 0xd3b1, 0xafef,    BAD, 0xd379,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xd75e, 0xd760, 0xd765, 0xd779, 0xb2fc,
/* 38 */ 0xb2f2,    BAD, 0xd75d, 0xb2fd, 0xb2fe, 0xd768, 0xd76f, 0xd775
},

/* Row 0x0f5 */
{
/* 00 */    BAD, 0xd762,    BAD, 0xd769,    BAD,    BAD, 0xb340, 0xd777,
/* 08 */ 0xd772, 0xb2fa, 0xb2f8, 0xd76e, 0xd76a, 0xd75c, 0xb2ef, 0xd761,
/* 10 */ 0xd759,    BAD, 0xb2f7, 0xb2f9, 0xd766, 0xd763, 0xb2f4, 0xd773,
/* 18 */ 0xb2f1, 0xd764, 0xd77a, 0xd76c,    BAD, 0xd76b, 0xb2f0,    BAD,
/* 20 */ 0xb2fb,    BAD, 0xb2f3, 0xd75a, 0xd75f, 0xd770, 0xd776, 0xb341,
/* 28 */ 0xd75b, 0xd767, 0xd76d, 0xb2f6,    BAD,    BAD, 0xd778, 0xd771,
/* 30 */ 0xd774,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb2f5,    BAD, 0xdb6c
},

/* Row 0x0f6 */
{
/* 00 */ 0xdb60, 0xb5d7, 0xdb7d, 0xdba7, 0xdbaa, 0xb5d5, 0xdb68, 0xdba3,
/* 08 */ 0xdb69, 0xdb77, 0xb5e2, 0xdb73, 0xb5df,    BAD, 0xdb74, 0xdb5d,
/* 10 */    BAD, 0xdba4,    BAD,    BAD, 0xb5e8, 0xdba1, 0xdb75, 0xdbac,
/* 18 */ 0xdb70, 0xdfc8,    BAD, 0xdbaf, 0xb5e6, 0xdb6e, 0xdb7a, 0xb5e9,
/* 20 */ 0xb5d4, 0xdb72, 0xdbad, 0xdb6b, 0xdb64, 0xdb6f,    BAD, 0xdb63,
/* 28 */ 0xdb61, 0xb5d0, 0xdba5, 0xdb6a, 0xdba8,    BAD, 0xdba9, 0xb5d8,
/* 30 */ 0xb5dd, 0xb5d9, 0xb5e1, 0xdb7e, 0xb5da, 0xdb76, 0xdb66,    BAD,
/* 38 */ 0xb5d2, 0xdb5e, 0xdba2, 0xdbab, 0xdb65, 0xb5e0, 0xdbb0, 0xdb71
},

/* Row 0x0f7 */
{
/* 00 */    BAD, 0xdb6d,    BAD, 0xb5d1, 0xb5e5,    BAD, 0xdb7c, 0xb5e7,
/* 08 */    BAD, 0xdb78, 0xb5dc, 0xb5d6, 0xb5de, 0xb5d3, 0xb5e4, 0xdb79,
/* 10 */ 0xdb67, 0xdb7b, 0xdb62, 0xdba6,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xdbae,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xdb5f,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xdfc7,    BAD, 0xdfdd, 0xb855, 0xdfcc,    BAD, 0xdfca,
/* 30 */ 0xdfb5, 0xb8a9, 0xdfc5, 0xdfd9, 0xdfc1, 0xb8b1, 0xdfd8, 0xdfbf,
/* 38 */ 0xb5e3, 0xdfcf, 0xdfc0, 0xdfd6, 0xb8b0, 0xb8a8,    BAD, 0xdfaa
},

/* Row 0x0f8 */
{
/* 00 */ 0xdfb2,    BAD, 0xdfcb, 0xdfc3, 0xdfdc, 0xdfc6, 0xb8b6, 0xdfd7,
/* 08 */    BAD, 0xb8ad,    BAD, 0xdfc9, 0xdfd1, 0xdfb6, 0xdfd0,    BAD,
/* 10 */ 0xdfe1, 0xdfb1, 0xdfd2,    BAD, 0xdfdf,    BAD, 0xdfab, 0xb5db,
/* 18 */    BAD, 0xdfb9, 0xdfb8, 0xb8af,    BAD, 0xdfbc, 0xdfbe, 0xdfcd,
/* 20 */ 0xdfde, 0xb8b2,    BAD, 0xb8b3,    BAD, 0xdfb0, 0xb8ab, 0xdfb4,
/* 28 */ 0xdfda, 0xb8b4,    BAD, 0xb8ac, 0xb8ae, 0xb8b5, 0xdfe0, 0xdfd3,
/* 30 */ 0xdfce,    BAD,    BAD, 0xdfbb, 0xdfba, 0xb8aa, 0xdfac, 0xb8a7,
/* 38 */ 0xdfc4, 0xdfad, 0xdfc2,    BAD,    BAD, 0xdfb7, 0xdfdb,    BAD
},

/* Row 0x0f9 */
{
/* 00 */    BAD,    BAD, 0xb8a6,    BAD,    BAD,    BAD, 0xdfb3,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdfaf, 0xdfd5, 0xdfae,
/* 10 */ 0xbb60, 0xe3d3,    BAD,    BAD, 0xe3c2,    BAD,    BAD, 0xe3ac,
/* 18 */ 0xe3ca, 0xbb58, 0xe3bb, 0xe3c5, 0xbb5b, 0xe3be, 0xbb59, 0xe3af,
/* 20 */ 0xe3cd, 0xe3ae, 0xe3c1,    BAD, 0xe3ad,    BAD,    BAD, 0xe3bf,
/* 28 */ 0xe3c8, 0xe3c6, 0xe3ba, 0xe3b5, 0xe3b3,    BAD, 0xe3b4, 0xe3c7,
/* 30 */ 0xe3d2, 0xe3bc, 0xbb5a,    BAD, 0xe3b7,    BAD, 0xe3cb,    BAD,
/* 38 */ 0xbb5d, 0xe3b6, 0xe3b0, 0xe3c0, 0xbb61,    BAD,    BAD, 0xbb55
},

/* Row 0x0fa */
{
/* 00 */ 0xbb5e, 0xe3b8, 0xe3b2,    BAD, 0xbb57, 0xdfd4, 0xbb56, 0xe3c3,
/* 08 */    BAD, 0xbb54, 0xbb63, 0xbb5c, 0xe3c4, 0xe3b9, 0xe3b1, 0xe3cc,
/* 10 */ 0xe3bd, 0xbb62, 0xe3d0, 0xbb5f, 0xe3cf,    BAD, 0xe3c9, 0xe3ce,
/* 18 */    BAD,    BAD,    BAD, 0xe3d1,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe773,
/* 28 */ 0xe774, 0xe767, 0xe766, 0xe762, 0xbdb4,    BAD, 0xbdac, 0xe776,
/* 30 */ 0xe775, 0xdfa9, 0xe75f, 0xe763, 0xe75d,    BAD, 0xe770, 0xe761,
/* 38 */    BAD, 0xe777, 0xe75a, 0xe758, 0xe764, 0xe76e, 0xe769, 0xbdb6
},

/* Row 0x0fb */
{
/* 00 */ 0xe74f,    BAD, 0xe76d,    BAD,    BAD,    BAD, 0xbdb7, 0xdfbd,
/* 08 */ 0xe75b, 0xe752, 0xe755, 0xe77b, 0xe75c, 0xe753, 0xe751, 0xe74e,
/* 10 */    BAD, 0xbdb0, 0xe765, 0xbdaf, 0xbdb3, 0xe760, 0xe768, 0xbda9,
/* 18 */ 0xe778, 0xe77c, 0xbdab,    BAD, 0xe757, 0xe76b, 0xe76f, 0xe754,
/* 20 */ 0xe779, 0xbdb2,    BAD, 0xbdb1, 0xe74c, 0xbdb5, 0xe772, 0xe756,
/* 28 */ 0xe76a, 0xe750, 0xe75e, 0xe759, 0xbdad, 0xbdae, 0xe76c, 0xe77d,
/* 30 */ 0xe77a, 0xe771,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xe74d,    BAD, 0xbdaa, 0xeb49,    BAD
},

/* Row 0x0fc */
{
/* 00 */ 0xeb40, 0xeb43,    BAD, 0xbfbb, 0xeb45, 0xeaf9, 0xeb41, 0xeb47,
/* 08 */ 0xbfb8, 0xbfbc, 0xbfb6,    BAD,    BAD, 0xeafb, 0xeb4c,    BAD,
/* 10 */    BAD, 0xeb46,    BAD, 0xeafc, 0xeb55, 0xeb4f, 0xeaf8, 0xee46,
/* 18 */ 0xeafe, 0xbfb7,    BAD, 0xeb4a,    BAD, 0xeb54, 0xbfbf,    BAD,
/* 20 */ 0xeb51, 0xeafd, 0xeb44, 0xeb48, 0xeb42, 0xeb56, 0xeb53, 0xeb50,
/* 28 */ 0xbfb9, 0xbfba, 0xbfbe, 0xeafa, 0xeb57, 0xbfbd, 0xeb4d,    BAD,
/* 30 */    BAD, 0xeb4b,    BAD,    BAD,    BAD, 0xeb4e, 0xee53, 0xee40,
/* 38 */ 0xee45, 0xee52, 0xee44, 0xedfb, 0xee41,    BAD, 0xc1a2,    BAD
},

/* Row 0x0fd */
{
/* 00 */ 0xedf4, 0xee4d, 0xee4f, 0xedf3, 0xc1a1, 0xee51, 0xee49, 0xc1a8,
/* 08 */ 0xee50, 0xee42, 0xc1aa, 0xedf9, 0xeb52, 0xee4a, 0xee47, 0xedf5,
/* 10 */ 0xee55, 0xc1a4,    BAD,    BAD, 0xc1a5, 0xedf7, 0xee48,    BAD,
/* 18 */ 0xee54, 0xee4b, 0xedfd, 0xc1a7, 0xc1a3, 0xee4c, 0xedfe, 0xee56,
/* 20 */ 0xedf8, 0xee43, 0xee4e, 0xedfa, 0xedfc,    BAD, 0xc2cb, 0xedf6,
/* 28 */ 0xc1a9, 0xc2c4, 0xc17e,    BAD,    BAD,    BAD,    BAD, 0xc1a6,
/* 30 */ 0xc2c8, 0xf0b3,    BAD, 0xf0a9, 0xf0a4, 0xf0aa, 0xf0b4, 0xf0b8,
/* 38 */ 0xf0b7, 0xc2ca, 0xc2c9,    BAD,    BAD, 0xf0ab, 0xf0b9, 0xf0ae
},

/* Row 0x0fe */
{
/* 00 */ 0xf0a6,    BAD, 0xf0a8, 0xf0a7, 0xf0ad, 0xf0b2, 0xf0a5, 0xf0ac,
/* 08 */ 0xf0b1, 0xc2c7,    BAD, 0xf0af,    BAD, 0xc2c5, 0xf0b0, 0xc2c3,
/* 10 */ 0xc2c6, 0xf2d5, 0xf0b5,    BAD,    BAD, 0xc3c2,    BAD, 0xf2cd,
/* 18 */ 0xf2d1, 0xf2c9, 0xf2cc,    BAD, 0xf2d4, 0xc3c0, 0xf2d9, 0xf2d2,
/* 20 */    BAD, 0xf2ca, 0xf2da, 0xf2d3, 0xc3c3, 0xc3c4, 0xf2d7,    BAD,
/* 28 */ 0xf2cb, 0xc3bf, 0xc3c1, 0xf2c6, 0xf2ce, 0xf2c8,    BAD, 0xf2d8,
/* 30 */ 0xf2d6, 0xf2c7, 0xf2cf,    BAD,    BAD,    BAD, 0xf4be, 0xc3c5,
/* 38 */ 0xf2d0, 0xc4a7, 0xc4a9, 0xc4a6,    BAD, 0xf4c3, 0xf4bb, 0xf4b9
},

/* Row 0x0ff */
{
/* 00 */ 0xf4bd, 0xf4ba,    BAD,    BAD, 0xf4bf, 0xf4c1, 0xc4aa, 0xc4ac,
/* 08 */    BAD, 0xf4c0, 0xc4ad, 0xc4ab, 0xf4c2,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xc4a8,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc4f4,
/* 18 */ 0xf5f1, 0xf5f7, 0xc4f6, 0xf4bc, 0xf5f6,    BAD, 0xf5fd, 0xf5f4,
/* 20 */ 0xf5fb, 0xf5fa, 0xf4b8, 0xf5f5, 0xf0b6, 0xf5fe, 0xf5f3, 0xf5f8,
/* 28 */    BAD, 0xf5fc, 0xf5f2,    BAD, 0xf74a, 0xc4f5, 0xf5f9,    BAD,
/* 30 */    BAD, 0xf7f4, 0xf74b, 0xf749, 0xf747, 0xf748, 0xf74c,    BAD,
/* 38 */ 0xc5d9, 0xf7f2, 0xf7f0, 0xf7f5, 0xf7f3,    BAD, 0xf7f6, 0xc5da
},

/* Row 0x100 */
{
/* 00 */ 0xf7f1,    BAD,    BAD, 0xf8bc,    BAD,    BAD, 0xf945, 0xf946,
/* 08 */ 0xf947,    BAD,    BAD, 0xf9c7, 0xf9bd, 0xca4f, 0xaaea,    BAD,
/* 10 */ 0xad68,    BAD, 0xd3b8, 0xd3b7, 0xb040, 0xb342, 0xd77c,    BAD,
/* 18 */    BAD, 0xd77b,    BAD, 0xb5ea, 0xb8b8,    BAD, 0xb8b7, 0xb8b9,
/* 20 */    BAD, 0xe3d4, 0xe77e, 0xeb58, 0xeb5a, 0xeb59,    BAD, 0xc1ab,
/* 28 */ 0xee57, 0xf0ba, 0xf9a5, 0xa6e4,    BAD, 0xcdc9, 0xcdca, 0xcdc8,
/* 30 */ 0xcdc7, 0xaaeb,    BAD, 0xd0a9, 0xd0a7,    BAD,    BAD, 0xd0a6,
/* 38 */    BAD, 0xad69, 0xad6b, 0xad6a, 0xd0a8,    BAD,    BAD,    BAD
},

/* Row 0x101 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3c4, 0xd3c1, 0xd3bf,
/* 08 */    BAD,    BAD, 0xb041, 0xd3c2, 0xb046, 0xd3bc, 0xd3cb,    BAD,
/* 10 */ 0xd3cd, 0xd3bd,    BAD, 0xb043, 0xd3ce, 0xd3c9, 0xd3bb, 0xd3c0,
/* 18 */ 0xd3ca, 0xd3c6, 0xd3c3,    BAD, 0xb048, 0xd3cc, 0xd3be,    BAD,
/* 20 */    BAD, 0xd3c7, 0xd3b9, 0xb047, 0xb044, 0xd3c5,    BAD, 0xd3c8,
/* 28 */ 0xd3ba, 0xb045, 0xb042,    BAD,    BAD,    BAD,    BAD, 0xb34c,
/* 30 */ 0xd7a5, 0xb34b,    BAD, 0xd7a8, 0xd7ab, 0xb348, 0xb346, 0xd77e,
/* 38 */ 0xd7a9, 0xd7a7, 0xd7a4, 0xd7ac, 0xd7ad, 0xd7af, 0xd7b0, 0xd77d
},

/* Row 0x102 */
{
/* 00 */ 0xb345, 0xd7a2, 0xd7a1, 0xd7ae, 0xb347, 0xd7a3, 0xb349, 0xb344,
/* 08 */ 0xd7a6, 0xb34d,    BAD, 0xb34a, 0xd7aa,    BAD,    BAD,    BAD,
/* 10 */ 0xb5f1, 0xdbbf,    BAD, 0xdbb4, 0xb5ee,    BAD, 0xdfe7, 0xdbbd,
/* 18 */ 0xdbb1, 0xb5ec, 0xdbb6, 0xb5ef, 0xdbba, 0xdbb8, 0xb5f2, 0xb5eb,
/* 20 */    BAD,    BAD, 0xdbb2, 0xdbb5, 0xb5f0,    BAD, 0xdbb3,    BAD,
/* 28 */ 0xdbbe, 0xdbbc, 0xdbb7, 0xdbb9, 0xdbbb, 0xb5ed,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdfe8, 0xdfee, 0xdfe4,
/* 38 */ 0xdfea, 0xb8ba, 0xdfe6, 0xb8c0,    BAD,    BAD, 0xb8bf,    BAD
},

/* Row 0x103 */
{
/* 00 */ 0xb8be, 0xdfed, 0xb8c1, 0xb8c2, 0xdfe3, 0xdff0, 0xb8c3, 0xb8bd,
/* 08 */ 0xb8bc, 0xdfec, 0xb8c4, 0xdfe2, 0xdfe5, 0xdfef, 0xdfeb,    BAD,
/* 10 */    BAD, 0xe3f4, 0xe3e9, 0xb8bb,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xbb6a, 0xe3dd, 0xe3f2, 0xe3de, 0xbb65,    BAD, 0xe3db,    BAD,
/* 20 */ 0xe3e4, 0xe3dc, 0xbb67, 0xe3d6, 0xe3f1, 0xbb68, 0xe3ee, 0xe3ef,
/* 28 */ 0xe3d7, 0xbb6d, 0xe3e6,    BAD, 0xe3e0, 0xe3e7, 0xe3da,    BAD,
/* 30 */ 0xe3f3, 0xe3eb, 0xe3e5, 0xe3d5, 0xbb69, 0xe3ec,    BAD, 0xbb6c,
/* 38 */ 0xe3f0,    BAD, 0xe3ea, 0xbb66, 0xe3e8,    BAD, 0xe3e2, 0xbb64
},

/* Row 0x104 */
{
/* 00 */ 0xe3d9, 0xe3e1, 0xe3ed, 0xe3df,    BAD,    BAD, 0xe3e3,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xbdc1, 0xdfe9, 0xe7b2, 0xe7bb,
/* 10 */ 0xe7b1, 0xe7ad, 0xe7aa, 0xbdc2, 0xe7a8, 0xbb6b, 0xe7a1, 0xbdc0,
/* 18 */ 0xe7a7, 0xbdbf, 0xe7ac, 0xe7a9, 0xe7b9, 0xe7b4, 0xe7ae, 0xe7b3,
/* 20 */ 0xbdbb, 0xe7ab, 0xe7be, 0xe7a2, 0xe7a3, 0xe7ba, 0xbdbc, 0xe7bf,
/* 28 */ 0xbdbe, 0xe7c0, 0xe7b0, 0xe3d8, 0xe7b6, 0xe7af, 0xe7b8, 0xe7b5,
/* 30 */    BAD,    BAD,    BAD, 0xe7a6, 0xbdb9, 0xe7bd, 0xbdba, 0xe7a4,
/* 38 */ 0xbdbd, 0xeb64, 0xe7b7, 0xe7bc,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x105 */
{
/* 00 */    BAD, 0xeb61, 0xbdb8, 0xbfc0, 0xeb6b, 0xeb67,    BAD, 0xeb65,
/* 08 */ 0xeb60, 0xeb6f,    BAD,    BAD,    BAD, 0xbfc4,    BAD, 0xeb5c,
/* 10 */ 0xeb68, 0xeb69, 0xeb5f, 0xeb5e, 0xeb6c,    BAD, 0xeb62, 0xeb5d,
/* 18 */ 0xeb63,    BAD, 0xeb6e, 0xeb5b, 0xeb6d, 0xeb6a, 0xbfc2, 0xbfc1,
/* 20 */    BAD,    BAD, 0xbfc3, 0xeb66, 0xf0cb,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xee59, 0xc1b1, 0xee5d, 0xee5a, 0xee61, 0xee67,
/* 30 */ 0xee5c,    BAD, 0xee70, 0xc1ae, 0xee6a, 0xee5f, 0xee6b, 0xee66,
/* 38 */ 0xee6d, 0xee5e, 0xc1b3, 0xc1b2, 0xee60, 0xee6e, 0xee58, 0xee6c
},

/* Row 0x106 */
{
/* 00 */ 0xc1ac,    BAD, 0xee64, 0xee63, 0xee68, 0xee5b, 0xc1b0,    BAD,
/* 08 */ 0xc1b4, 0xee62, 0xee69, 0xc1b5, 0xee65,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xc1ad, 0xc1af, 0xf0c7, 0xf0c5,    BAD,    BAD, 0xf0cc,
/* 18 */ 0xf0c9, 0xf0cd,    BAD, 0xf0be, 0xf0c6, 0xf0d1, 0xee6f, 0xf0c2,
/* 20 */ 0xc2cf, 0xe7a5, 0xf0bd, 0xf0ca, 0xf0c4, 0xf0c1, 0xf0bc, 0xf0bb,
/* 28 */ 0xf0d0,    BAD, 0xf0c0, 0xf0bf, 0xc2cd, 0xf0c8,    BAD, 0xc2cc,
/* 30 */    BAD,    BAD, 0xc2ce, 0xf0c3, 0xf0cf,    BAD, 0xf2de, 0xf2df,
/* 38 */    BAD, 0xc3c9, 0xf2dc, 0xc3c6, 0xf2e4,    BAD, 0xc3ca, 0xf2e6
},

/* Row 0x107 */
{
/* 00 */ 0xf2db, 0xf0ce, 0xf2e8, 0xf2dd,    BAD, 0xc3c7, 0xf2e3,    BAD,
/* 08 */ 0xf2e5, 0xf2e0, 0xf2e7, 0xf2e2, 0xf2e1, 0xc3c8,    BAD,    BAD,
/* 10 */ 0xf4c5, 0xf4c6,    BAD, 0xf4c8, 0xc4ae, 0xc4af, 0xf4c9, 0xf4c7,
/* 18 */    BAD, 0xf4c4,    BAD, 0xf642, 0xf645, 0xf641,    BAD, 0xc4fa,
/* 20 */ 0xf643, 0xc4f9, 0xc4f8, 0xc4f7, 0xf644, 0xf751, 0xf74f,    BAD,
/* 28 */ 0xf74e, 0xf640, 0xf750, 0xf646, 0xf74d,    BAD, 0xf7f9, 0xf7d7,
/* 30 */ 0xf7f7, 0xc5db, 0xf7f8, 0xf7fa,    BAD, 0xf8bf, 0xc5fa, 0xf8be,
/* 38 */ 0xf8bd, 0xc5fb,    BAD, 0xc65a, 0xf96e, 0xf9a7, 0xf9a6, 0xf9a8
},

/* Row 0x108 */
{
/* 00 */ 0xa6e5, 0xd0aa,    BAD, 0xd3cf, 0xd3d0,    BAD,    BAD,    BAD,
/* 08 */ 0xdbc0,    BAD, 0xf647, 0xf8c0, 0xa6e6, 0xad6c, 0xd0ab,    BAD,
/* 10 */    BAD,    BAD, 0xd7b1, 0xb34e,    BAD, 0xdbc2, 0xdbc1, 0xb5f3,
/* 18 */    BAD, 0xb8c5, 0xe7c1, 0xbdc3,    BAD, 0xbdc4,    BAD,    BAD,
/* 20 */    BAD, 0xbfc5, 0xc5fc, 0xa6e7,    BAD,    BAD,    BAD, 0xd0ac,
/* 28 */ 0xaaed, 0xd0ae, 0xd0ad, 0xad6d,    BAD, 0xd3d1,    BAD, 0xd3d8,
/* 30 */ 0xb049, 0xd3d6, 0xd3d4,    BAD, 0xd3db, 0xd3d2, 0xd3d3, 0xb04a,
/* 38 */    BAD, 0xb04e,    BAD,    BAD, 0xd3dc, 0xb04d, 0xd3da, 0xd3d7
},

/* Row 0x109 */
{
/* 00 */ 0xd3d5, 0xb04b, 0xb04c, 0xd3d9,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xb350, 0xd7b2,    BAD, 0xb355, 0xd7c2, 0xb354, 0xd7c4,    BAD,
/* 10 */    BAD, 0xd7b8, 0xb352, 0xd7c3,    BAD, 0xd7b3, 0xb353, 0xd7bf,
/* 18 */ 0xd7bb, 0xd7bd, 0xd7b7, 0xd7be,    BAD,    BAD, 0xb34f, 0xd7ba,
/* 20 */    BAD, 0xd7b9, 0xd7b5,    BAD, 0xd7c0,    BAD,    BAD, 0xd7bc,
/* 28 */ 0xd7b4,    BAD, 0xd7b6, 0xb351, 0xd7c1,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xb5f6, 0xdbcd,    BAD,    BAD,    BAD, 0xdbc9, 0xdbcb,
/* 38 */ 0xdbc6, 0xdbc5, 0xdbc3,    BAD, 0xdbca, 0xdbcc, 0xdbc8,    BAD
},

/* Row 0x10a */
{
/* 00 */ 0xdbc7, 0xb5f4, 0xb5f5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xdbcf, 0xb8cd, 0xdff2, 0xdff8, 0xdff3, 0xdff4,    BAD,
/* 10 */ 0xdff9,    BAD, 0xb8cf,    BAD, 0xb8c7, 0xb8ce, 0xdff1, 0xdbc4,
/* 18 */ 0xb8ca, 0xb8c8, 0xdff7, 0xdff6, 0xb8c9, 0xb8cb, 0xdff5, 0xb8c6,
/* 20 */    BAD, 0xb8cc,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe3f6,
/* 28 */ 0xbb74,    BAD,    BAD, 0xe442, 0xe441,    BAD, 0xe3fb, 0xbb76,
/* 30 */ 0xe440, 0xe3f7, 0xe3f8, 0xbb6e, 0xbb70,    BAD, 0xe3fd, 0xe3f5,
/* 38 */ 0xbb72, 0xbb71, 0xe3f9, 0xe3fe, 0xe3fc, 0xbb73, 0xe3fa,    BAD
},

/* Row 0x10b */
{
/* 00 */    BAD, 0xdbce, 0xbb6f,    BAD,    BAD, 0xe7c2, 0xe7c9, 0xbdc6,
/* 08 */    BAD, 0xe7cd, 0xbdca, 0xe7c5, 0xe7c3,    BAD, 0xe7cc,    BAD,
/* 10 */ 0xbdc5, 0xe7cb, 0xbdc7, 0xbdc8, 0xe7c4, 0xbdc9, 0xe7ca, 0xe7c6,
/* 18 */ 0xe7c7, 0xe7c8, 0xbb75,    BAD,    BAD,    BAD, 0xeb70, 0xeb7c,
/* 20 */    BAD, 0xbfca, 0xeb77, 0xeb79,    BAD, 0xbfc8, 0xeb71, 0xeb75,
/* 28 */    BAD, 0xeb78, 0xbfc6, 0xbfc9, 0xeb7b, 0xeb73, 0xeb74, 0xeb7a,
/* 30 */ 0xeb72, 0xeb76, 0xbfc7, 0xee72,    BAD, 0xee71, 0xc1b7, 0xee77,
/* 38 */ 0xc1b9,    BAD,    BAD, 0xc1b6, 0xee73, 0xc1ba, 0xee74,    BAD
},

/* Row 0x10c */
{
/* 00 */    BAD, 0xee75, 0xee78,    BAD, 0xc1b8,    BAD, 0xf0d6,    BAD,
/* 08 */    BAD, 0xf0d9,    BAD, 0xf0d3, 0xf0d5,    BAD,    BAD, 0xf0d4,
/* 10 */ 0xf0d7, 0xf0d8, 0xee76, 0xf0d2,    BAD,    BAD, 0xc3cd, 0xf2ec,
/* 18 */ 0xf2ef, 0xf2f1, 0xf2ea, 0xf2eb, 0xf2ee, 0xf2f0, 0xc3ce, 0xc3cc,
/* 20 */ 0xc3cb, 0xf2ed, 0xf2e9, 0xf4ca, 0xc4b0,    BAD, 0xf4cb,    BAD,
/* 28 */    BAD, 0xf649, 0xc4fb, 0xf64b, 0xc4fc, 0xf648, 0xf64a, 0xc5a8,
/* 30 */    BAD, 0xf752, 0xc5a7, 0xf7fd, 0xf7fc,    BAD, 0xf7fb,    BAD,
/* 38 */    BAD, 0xf948, 0xf949, 0xf94b, 0xf94a,    BAD, 0xca50, 0xa6e8
},

/* Row 0x10d */
{
/* 00 */    BAD, 0xad6e, 0xd7c5, 0xb5f7,    BAD, 0xdffa, 0xc2d0,    BAD,
/* 08 */ 0xf2f2,    BAD,    BAD, 0xa8a3,    BAD,    BAD,    BAD, 0xb357,
/* 10 */    BAD,    BAD,    BAD, 0xb356,    BAD, 0xdbd0, 0xb5f8, 0xdbd2,
/* 18 */ 0xdbd1,    BAD,    BAD, 0xdffb, 0xb8d0, 0xe443, 0xe446, 0xe445,
/* 20 */    BAD, 0xe444, 0xe7ce, 0xe7d0, 0xe7cf,    BAD, 0xbfcc,    BAD,
/* 28 */    BAD,    BAD, 0xbfcb,    BAD, 0xc1bb, 0xee79, 0xee7b, 0xee7a,
/* 30 */    BAD,    BAD, 0xc2d1,    BAD,    BAD,    BAD, 0xf2f4, 0xf2f3,
/* 38 */    BAD, 0xf4cc, 0xc4b1,    BAD,    BAD, 0xc4fd, 0xf754, 0xf753
},

/* Row 0x10e */
{
/* 00 */ 0xc65b,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xa8a4, 0xd0af, 0xad6f, 0xd7c8, 0xd7c6,    BAD,
/* 18 */    BAD, 0xd7c7, 0xdbd4, 0xdbd5, 0xe043, 0xdbd3,    BAD, 0xdffc,
/* 20 */ 0xe041, 0xe040, 0xe042, 0xb8d1, 0xdffe, 0xdffd, 0xe044,    BAD,
/* 28 */ 0xe449, 0xe447,    BAD, 0xe448, 0xe7d3, 0xe7d1,    BAD,    BAD,
/* 30 */ 0xe7d2, 0xeb7d, 0xee7c, 0xee7d, 0xc2d2,    BAD, 0xf2f5, 0xf4cd,
/* 38 */ 0xc4b2,    BAD, 0xf64c, 0xf755, 0xc5a9,    BAD, 0xf7fe, 0xf94c
},

/* Row 0x10f */
{
/* 00 */ 0xa8a5,    BAD, 0xad71, 0xad72, 0xd0b0,    BAD,    BAD, 0xd0b1,
/* 08 */ 0xad70,    BAD, 0xb054,    BAD, 0xb052,    BAD, 0xb051, 0xb058,
/* 10 */ 0xb050, 0xb059, 0xd3dd, 0xb056,    BAD, 0xb053, 0xb057, 0xb055,
/* 18 */ 0xb04f,    BAD,    BAD, 0xb35f,    BAD, 0xb359, 0xd7cc, 0xb35e,
/* 20 */    BAD,    BAD, 0xb360, 0xb35a,    BAD, 0xb35b,    BAD, 0xd7ca,
/* 28 */    BAD,    BAD, 0xb358,    BAD, 0xd7cb, 0xb35d,    BAD,    BAD,
/* 30 */ 0xd7c9, 0xb35c,    BAD,    BAD, 0xb644,    BAD, 0xb646,    BAD,
/* 38 */    BAD, 0xdbd8, 0xb645, 0xb5f9, 0xb5fd,    BAD, 0xb8e4, 0xe049
},

/* Row 0x110 */
{
/* 00 */ 0xdbda, 0xb5fe,    BAD,    BAD, 0xdbdd, 0xdbde, 0xb643,    BAD,
/* 08 */ 0xdbe0,    BAD, 0xdbe2,    BAD, 0xdbe3, 0xdbd7, 0xdbd6, 0xdbe4,
/* 10 */ 0xb642, 0xdbe1, 0xdbdf,    BAD, 0xb640, 0xb5fb, 0xb647, 0xdbdb,
/* 18 */ 0xdbdc, 0xdbd9,    BAD, 0xb641,    BAD,    BAD, 0xb5fc,    BAD,
/* 20 */ 0xb5fa, 0xe048, 0xb8df, 0xb8da,    BAD,    BAD, 0xb8d5,    BAD,
/* 28 */ 0xb8e5, 0xb8d6,    BAD, 0xb8d2, 0xb8e1, 0xb8de, 0xb8e0,    BAD,
/* 30 */ 0xb8d7, 0xb8dc, 0xb8d3, 0xb8d4, 0xe050, 0xe04d, 0xe045, 0xe04a,
/* 38 */    BAD, 0xb8e2, 0xe051, 0xb8e3, 0xb8d9,    BAD,    BAD, 0xe047
},

/* Row 0x111 */
{
/* 00 */    BAD, 0xe04f, 0xe04b, 0xe04e, 0xe04c, 0xb8dd, 0xe046, 0xb8d8,
/* 08 */    BAD,    BAD,    BAD, 0xe44c, 0xbb78, 0xbb7b,    BAD, 0xe44e,
/* 10 */    BAD, 0xbba5, 0xe44d, 0xbb7d,    BAD, 0xbdcf, 0xe44f,    BAD,
/* 18 */ 0xbba4, 0xe44b, 0xbba6,    BAD,    BAD,    BAD, 0xbb79,    BAD,
/* 20 */ 0xb8db, 0xbb7c,    BAD, 0xbb7a, 0xbb7e, 0xbba2, 0xbb77, 0xbba7,
/* 28 */ 0xbba3,    BAD, 0xbba1, 0xe44a,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xbdd6,    BAD, 0xbdd2,    BAD,    BAD,    BAD, 0xbdd9,    BAD,
/* 38 */ 0xe7d6, 0xbdda, 0xe7e2, 0xe7db, 0xbdcb, 0xe7e3, 0xe7dd, 0xbdd5
},

/* Row 0x112 */
{
/* 00 */ 0xe7de,    BAD, 0xbdd4, 0xe7e1, 0xbdce, 0xe7df, 0xe7d5, 0xbdcd,
/* 08 */ 0xebaa, 0xbdd3,    BAD, 0xbdd0,    BAD, 0xbdd8,    BAD, 0xe7d4,
/* 10 */    BAD, 0xe7d8, 0xbdcc, 0xe7d7, 0xe7d9, 0xe7da, 0xbdd7, 0xe7dc,
/* 18 */ 0xe7e0, 0xe7e4,    BAD, 0xbddb, 0xbfd2, 0xeba5, 0xebab, 0xeba8,
/* 20 */ 0xeb7e, 0xebac, 0xeba1,    BAD, 0xeba7,    BAD, 0xbfcd, 0xbfd3,
/* 28 */ 0xebad,    BAD,    BAD, 0xbfcf,    BAD, 0xbfd9, 0xbfd4, 0xebaf,
/* 30 */ 0xeba9, 0xbfd0, 0xeba2, 0xbfda, 0xeba3, 0xeba4, 0xbfdb, 0xbfd8,
/* 38 */ 0xbdd1,    BAD, 0xbfce, 0xebb0, 0xbfdc,    BAD, 0xbfd5, 0xebae
},

/* Row 0x113 */
{
/* 00 */ 0xbfd1, 0xbfd6, 0xbfd7,    BAD, 0xc1c3, 0xeea4, 0xeead, 0xeeaa,
/* 08 */ 0xeeac,    BAD, 0xc1c0, 0xeea5,    BAD, 0xeeab, 0xc1bc, 0xeea7,
/* 10 */ 0xc1c4, 0xeea3, 0xeea8, 0xeeaf, 0xeba6, 0xeea9, 0xeea2, 0xc1bd,
/* 18 */ 0xeea1, 0xc1be, 0xeeb0, 0xc1bf, 0xeeae, 0xc1c2, 0xee7e,    BAD,
/* 20 */ 0xc1c1,    BAD, 0xeea6, 0xf0dc, 0xf0ea, 0xf0e5, 0xf0e7, 0xf0db,
/* 28 */ 0xc2d3,    BAD, 0xf0da, 0xc2d6, 0xc2d5,    BAD, 0xf0e9, 0xf0e1,
/* 30 */ 0xf0de, 0xf0e4,    BAD, 0xf0dd,    BAD, 0xf0df, 0xf0e8, 0xf0e6,
/* 38 */    BAD, 0xc2d4, 0xf0ed, 0xf0eb, 0xf0e2, 0xf0ec, 0xf0e3,    BAD
},

/* Row 0x114 */
{
/* 00 */ 0xf2f9, 0xc3cf, 0xf341,    BAD,    BAD, 0xf64f, 0xc3d6, 0xf0e0,
/* 08 */ 0xf2f7, 0xc3d2, 0xf2f8, 0xf2fd,    BAD,    BAD, 0xc3d4, 0xc3d5,
/* 10 */ 0xf2f6, 0xf340, 0xf342, 0xf2fa, 0xf2fc, 0xf2fe, 0xf2fb, 0xf343,
/* 18 */ 0xc3d1, 0xc3d7, 0xc3d3,    BAD, 0xc3d0, 0xf4d0,    BAD, 0xc4b7,
/* 20 */ 0xf4ce,    BAD,    BAD, 0xf4d2,    BAD, 0xf4d3, 0xc4b5, 0xf4d4,
/* 28 */ 0xf4d1,    BAD, 0xf4cf, 0xc4b8, 0xc4b4, 0xf4d5,    BAD, 0xc4b6,
/* 30 */ 0xc4b3,    BAD,    BAD,    BAD, 0xc4fe,    BAD,    BAD, 0xc540,
/* 38 */ 0xf64e, 0xf64d, 0xf650, 0xf651,    BAD, 0xc541, 0xf756, 0xf75b
},

/* Row 0x115 */
{
/* 00 */ 0xc5aa,    BAD, 0xf758,    BAD, 0xf757, 0xf75a, 0xf759,    BAD,
/* 08 */ 0xf843,    BAD, 0xc5dc, 0xf842, 0xf840,    BAD, 0xf841,    BAD,
/* 10 */    BAD,    BAD, 0xc5fe, 0xc5fd, 0xf8c1, 0xf8c2, 0xc640,    BAD,
/* 18 */ 0xf94d, 0xf94e, 0xc667,    BAD, 0xc66d,    BAD, 0xf9a9, 0xf9c8,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x116 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa8a6,
/* 38 */    BAD, 0xd7cd,    BAD, 0xd7ce, 0xe052, 0xe450, 0xe7e5, 0xc1c6
},

/* Row 0x117 */
{
/* 00 */    BAD, 0xc1c5, 0xf0ee, 0xf344,    BAD, 0xf844, 0xa8a7, 0xd3de,
/* 08 */ 0xb05a, 0xb361, 0xe054, 0xe053, 0xbddc, 0xe7e6, 0xbddd, 0xeeb1,
/* 10 */ 0xc2d7,    BAD,    BAD,    BAD, 0xc676, 0xa8a8, 0xcdcb, 0xd3df,
/* 18 */    BAD,    BAD, 0xb362,    BAD, 0xd7cf, 0xd7d0,    BAD, 0xdbe5,
/* 20 */    BAD, 0xb648, 0xb8e6,    BAD, 0xe056, 0xe055, 0xe057,    BAD,
/* 28 */ 0xe451, 0xe452, 0xbba8, 0xbfdd, 0xbdde, 0xbfde,    BAD, 0xeeb5,
/* 30 */ 0xeeb2, 0xeeb4, 0xeeb3, 0xc1c7,    BAD, 0xf0ef, 0xf346, 0xf345,
/* 38 */ 0xcba4, 0xb05c, 0xb05b, 0xd3e0,    BAD, 0xd7d1,    BAD,    BAD
},

/* Row 0x118 */
{
/* 00 */ 0xdbe7, 0xdbe6, 0xb649,    BAD, 0xe059, 0xe05a, 0xe058,    BAD,
/* 08 */    BAD, 0xb8e8, 0xb8e7,    BAD, 0xbbaa, 0xbba9,    BAD, 0xe7e7,
/* 10 */ 0xebb3, 0xebb1, 0xebb2, 0xbfdf, 0xeeb7, 0xeeb6,    BAD, 0xf0f2,
/* 18 */ 0xf0f1, 0xf0f0, 0xf347,    BAD, 0xf9aa, 0xa8a9, 0xad73,    BAD,
/* 20 */ 0xad74, 0xb05d, 0xb05e, 0xd3e2, 0xd3e1, 0xd7d2,    BAD, 0xb368,
/* 28 */ 0xb366, 0xb363, 0xb367, 0xb365, 0xb364,    BAD,    BAD, 0xb64a,
/* 30 */ 0xdbea,    BAD, 0xb8ed, 0xb64c, 0xb651, 0xdbec, 0xb653, 0xb652,
/* 38 */ 0xb655, 0xdbeb, 0xdbe8, 0xb64f, 0xb64b, 0xb64d, 0xdbe9, 0xb654
},

/* Row 0x119 */
{
/* 00 */ 0xb650, 0xb64e, 0xb8ef, 0xb8ee, 0xb8ec, 0xb8f0,    BAD, 0xb8ea,
/* 08 */ 0xb8eb,    BAD, 0xb8e9,    BAD, 0xe05b,    BAD,    BAD, 0xe454,
/* 10 */    BAD, 0xbbac, 0xbbad, 0xbbab,    BAD, 0xe453,    BAD, 0xe455,
/* 18 */    BAD, 0xe7ea, 0xe7ec,    BAD, 0xbde7, 0xe7ed, 0xbde0, 0xe7e9,
/* 20 */ 0xbddf, 0xbde9, 0xbde5, 0xbde6, 0xbde2, 0xe7e8, 0xbde1, 0xe7ee,
/* 28 */ 0xe7eb,    BAD, 0xbde8,    BAD, 0xbde3, 0xbde4, 0xebb5,    BAD,
/* 30 */ 0xebb7, 0xebb6,    BAD, 0xebb8, 0xbfe0, 0xebb4,    BAD,    BAD,
/* 38 */ 0xc1cb, 0xeeb8, 0xc1c8, 0xc1cc, 0xc1ca, 0xc1c9, 0xf0f3,    BAD
},

/* Row 0x11a */
{
/* 00 */ 0xf0f6,    BAD, 0xf0f5,    BAD, 0xf0f4, 0xc2d8, 0xf348, 0xf349,
/* 08 */ 0xc3d8, 0xf34a, 0xc3d9,    BAD,    BAD, 0xc4ba,    BAD, 0xc4b9,
/* 10 */ 0xf652,    BAD,    BAD, 0xc542, 0xf653, 0xf75c, 0xc5ab, 0xc5ac,
/* 18 */    BAD, 0xf845,    BAD, 0xc642,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x11b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xa8aa,    BAD, 0xb36a, 0xb369,
/* 28 */ 0xe05c, 0xe05d,    BAD, 0xbbae, 0xebb9, 0xbdea, 0xebba, 0xeeb9,
/* 30 */ 0xa8ab,    BAD, 0xd0b2, 0xad76, 0xad75,    BAD, 0xd3e3, 0xb05f,
/* 38 */ 0xd3e4, 0xd7d5,    BAD, 0xd7d4,    BAD, 0xd7d3,    BAD,    BAD
},

/* Row 0x11c */
{
/* 00 */ 0xdbee, 0xb658,    BAD,    BAD, 0xdbed, 0xb657,    BAD,    BAD,
/* 08 */    BAD, 0xdbef, 0xb656,    BAD, 0xe05f, 0xe062, 0xe060, 0xe061,
/* 10 */ 0xe065, 0xe05e, 0xe066, 0xe063, 0xe064, 0xbbb0, 0xe456,    BAD,
/* 18 */    BAD, 0xbbaf,    BAD, 0xe7f2, 0xe7f0,    BAD,    BAD, 0xbdeb,
/* 20 */ 0xe7ef, 0xe7f1,    BAD, 0xbdec,    BAD, 0xebbb,    BAD, 0xebbc,
/* 28 */ 0xc1cd,    BAD, 0xf34c, 0xf34e, 0xf34b, 0xf34d, 0xf4d6, 0xf654,
/* 30 */    BAD,    BAD, 0xf96f, 0xa8ac, 0xad77, 0xd3e5, 0xd3e7, 0xd3e6,
/* 38 */    BAD, 0xd7d8, 0xb36c,    BAD, 0xd7d6,    BAD, 0xb36b, 0xd7d9
},

/* Row 0x11d */
{
/* 00 */    BAD, 0xd7da, 0xd7d7,    BAD,    BAD, 0xdbfb, 0xb660, 0xdbf3,
/* 08 */ 0xdbf9,    BAD,    BAD, 0xb65b, 0xb65e, 0xdbf2, 0xb659, 0xdbf6,
/* 10 */ 0xe06c, 0xb65d,    BAD, 0xdbf1,    BAD, 0xdbf7, 0xdbf4, 0xdbfa,
/* 18 */ 0xdbf0, 0xdbf8, 0xb65c, 0xb65f, 0xdbf5, 0xb65a,    BAD, 0xb8f2,
/* 20 */ 0xe068, 0xb8f1, 0xe06f, 0xe06e, 0xb8f8,    BAD, 0xb8f9, 0xe070,
/* 28 */ 0xb8f3, 0xe06d, 0xb8f7, 0xe072, 0xe069,    BAD, 0xe06b, 0xb8f4,
/* 30 */ 0xe067, 0xe06a, 0xe071, 0xb8f5, 0xe073,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xb8f6,    BAD, 0xbbb1, 0xe45b, 0xe461, 0xe459
},

/* Row 0x11e */
{
/* 00 */ 0xe462,    BAD, 0xe458, 0xe45d, 0xe463, 0xe460, 0xe45f, 0xe45e,
/* 08 */    BAD, 0xe457, 0xe45c,    BAD,    BAD, 0xe45a,    BAD, 0xbdf1,
/* 10 */ 0xbdee, 0xe7fb, 0xe841, 0xe843, 0xe840, 0xe7f8, 0xe7fa, 0xe845,
/* 18 */ 0xe842, 0xe7fc, 0xe846, 0xe7f9, 0xe844, 0xbdef, 0xbdf5, 0xbdf3,
/* 20 */ 0xe7f3, 0xbdf4, 0xbdf0, 0xe7f4, 0xe7f6, 0xe7f5, 0xe7fd, 0xe7fe,
/* 28 */    BAD, 0xbdf2,    BAD, 0xbded,    BAD,    BAD, 0xe7f7,    BAD,
/* 30 */ 0xebc6, 0xbfe2,    BAD, 0xebbd, 0xbfe3, 0xbfe6, 0xebc2,    BAD,
/* 38 */ 0xebbf, 0xbfe5,    BAD,    BAD, 0xebc3, 0xebc4, 0xebbe, 0xebc7
},

/* Row 0x11f */
{
/* 00 */ 0xebc0, 0xebc5, 0xbfe4,    BAD, 0xbfe1, 0xebc1,    BAD, 0xeebf,
/* 08 */ 0xc1d0, 0xc1ce, 0xc1d1, 0xc1cf, 0xeebe, 0xeebb, 0xeeba,    BAD,
/* 10 */ 0xeebd,    BAD,    BAD, 0xeebc, 0xf145, 0xc2de, 0xf0fb, 0xf0fa,
/* 18 */    BAD, 0xc2d9, 0xf141, 0xf140, 0xf0f7, 0xf143, 0xf0fc, 0xc2dd,
/* 20 */ 0xf0f9, 0xf142, 0xf0f8, 0xc2da, 0xc2dc, 0xf0fd, 0xc2db, 0xf0fe,
/* 28 */    BAD, 0xf144, 0xf352,    BAD, 0xc3de, 0xf34f,    BAD, 0xf353,
/* 30 */    BAD,    BAD, 0xc3db, 0xf351, 0xc3e0,    BAD, 0xc3dd,    BAD,
/* 38 */ 0xf350,    BAD, 0xc3df, 0xf354, 0xc3da,    BAD,    BAD,    BAD
},

/* Row 0x120 */
{
/* 00 */    BAD, 0xc4bc, 0xc4be,    BAD, 0xf4d9, 0xc4bd, 0xf4d7, 0xc3dc,
/* 08 */ 0xf4d8, 0xc4bb, 0xc543, 0xc545, 0xf656, 0xc544, 0xf655,    BAD,
/* 10 */ 0xf761, 0xc5ad, 0xf760, 0xc5ae, 0xf75e, 0xf75d, 0xf762, 0xf763,
/* 18 */ 0xf846,    BAD, 0xf75f,    BAD,    BAD, 0xf8c6, 0xf8c3, 0xf8c4,
/* 20 */ 0xf8c5, 0xc65c,    BAD, 0xf951, 0xf950, 0xf94f, 0xf970,    BAD,
/* 28 */ 0xf9be, 0xf9ab, 0xc66e, 0xa8ad, 0xb060,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xb8fa,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xbdf6,    BAD,    BAD, 0xebc8,    BAD,    BAD
},

/* Row 0x121 */
{
/* 00 */ 0xc2df,    BAD, 0xf355,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xf9ac, 0xa8ae, 0xaaee, 0xad79, 0xad78,    BAD, 0xb063,
/* 10 */    BAD, 0xd3e8, 0xb061, 0xd3e9, 0xb062,    BAD,    BAD, 0xd7df,
/* 18 */ 0xd7db,    BAD,    BAD, 0xb36d, 0xd7de, 0xd7dd, 0xd7dc, 0xb36e,
/* 20 */ 0xd7e0, 0xd7e1,    BAD,    BAD,    BAD, 0xdc43, 0xdc41, 0xdc45,
/* 28 */ 0xdc46, 0xdc4c,    BAD, 0xdc48, 0xdc4a,    BAD, 0xdc42, 0xdbfc,
/* 30 */    BAD, 0xdc49,    BAD,    BAD, 0xdc4b, 0xdc44, 0xdc47, 0xdbfd,
/* 38 */ 0xb662, 0xdc40, 0xdbfe, 0xb661, 0xb663,    BAD, 0xb8fd, 0xe075
},

/* Row 0x122 */
{
/* 00 */ 0xe077, 0xe076, 0xe07b, 0xb8fb,    BAD, 0xe078, 0xe074, 0xe079,
/* 08 */ 0xe07a, 0xb8fc, 0xb8fe, 0xe07c,    BAD, 0xe467, 0xe466,    BAD,
/* 10 */ 0xe464, 0xe465, 0xbbb3, 0xbbb5, 0xbbb2, 0xbbb4, 0xe84d, 0xe84e,
/* 18 */ 0xe849,    BAD, 0xe84a, 0xbdf8, 0xbdfd, 0xbdf7, 0xbdfe, 0xbdf9,
/* 20 */ 0xe84b,    BAD,    BAD, 0xe84c, 0xe848, 0xbe40, 0xbdfb,    BAD,
/* 28 */    BAD, 0xbdfa, 0xbdfc,    BAD, 0xe847,    BAD, 0xebca, 0xbfe8,
/* 30 */    BAD,    BAD, 0xebcc, 0xbfea, 0xebcf, 0xebcb, 0xebc9, 0xebce,
/* 38 */ 0xbfe9, 0xebcd,    BAD, 0xbfe7,    BAD,    BAD, 0xc1d3, 0xc1d6
},

/* Row 0x123 */
{
/* 00 */ 0xeec1,    BAD, 0xc1d4, 0xeec0, 0xc1d2, 0xc1d5, 0xf146, 0xf147,
/* 08 */ 0xf148, 0xc2e0,    BAD, 0xf149,    BAD, 0xc2e1, 0xc3e2, 0xf358,
/* 10 */ 0xf359, 0xf357, 0xf356, 0xf35a, 0xc3e1, 0xf4dd, 0xf4db, 0xf4dc,
/* 18 */ 0xf4de, 0xf4da, 0xf4df, 0xf658,    BAD, 0xf659, 0xf657, 0xc546,
/* 20 */ 0xf764, 0xc5af, 0xf765, 0xf848, 0xf847,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x124 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xa8af, 0xb664,    BAD,    BAD, 0xb940,
/* 20 */    BAD,    BAD,    BAD, 0xbbb6,    BAD,    BAD, 0xbfec,    BAD,
/* 28 */ 0xbfeb,    BAD,    BAD,    BAD,    BAD, 0xc3e3, 0xc47c, 0xc547,
/* 30 */ 0xa8b0, 0xb064, 0xb941,    BAD, 0xf35b,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcba6
},

/* Row 0x125 */
{
/* 00 */    BAD,    BAD, 0xa8b1,    BAD, 0xa8b4, 0xa8b3, 0xa8b2,    BAD,
/* 08 */    BAD, 0xcba5,    BAD, 0xcdcd,    BAD, 0xcdcf, 0xaaef,    BAD,
/* 10 */    BAD, 0xaaf1, 0xcdcc, 0xcdce, 0xaaf0, 0xcdd1, 0xcdd0, 0xcdd2,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xd0b6, 0xd0b4, 0xad7c, 0xd0b3, 0xada3, 0xad7e, 0xad7b,    BAD,
/* 28 */ 0xada4,    BAD, 0xad7d, 0xada2,    BAD, 0xada1, 0xd0b5,    BAD,
/* 30 */ 0xad7a,    BAD,    BAD,    BAD, 0xb06a, 0xd3eb, 0xd3f1, 0xb067,
/* 38 */ 0xb06e,    BAD, 0xb069, 0xd3ee, 0xd3f0, 0xb06c, 0xd3ea, 0xd3ed
},

/* Row 0x126 */
{
/* 00 */ 0xb068, 0xb065, 0xd3ec, 0xb06b, 0xd3ef, 0xb06d, 0xb066,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xd7e3, 0xd7e6, 0xb370,    BAD, 0xb37a,
/* 10 */ 0xb376, 0xd7e4,    BAD,    BAD, 0xb37e, 0xb377, 0xb37c, 0xb372,
/* 18 */    BAD, 0xb36f, 0xb371, 0xb37d, 0xd7e5, 0xb375, 0xb378, 0xb374,
/* 20 */ 0xb379, 0xd7e7, 0xb37b, 0xb373, 0xd7e2,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdc4d, 0xb665, 0xdc4f,
/* 30 */    BAD, 0xb667, 0xb669,    BAD, 0xdc4e, 0xb666, 0xb66a,    BAD,
/* 38 */ 0xb668,    BAD,    BAD,    BAD, 0xb947, 0xe0a3, 0xb94f, 0xe07e
},

/* Row 0x127 */
{
/* 00 */    BAD, 0xb950, 0xb945,    BAD, 0xe0a1,    BAD,    BAD, 0xb94a,
/* 08 */    BAD, 0xe0a2, 0xb943, 0xb942,    BAD, 0xb94d, 0xb94c, 0xb94b,
/* 10 */ 0xb949, 0xb94e, 0xe07d, 0xb944, 0xb946, 0xb948,    BAD,    BAD,
/* 18 */ 0xbbb8, 0xbbbb,    BAD, 0xbbbf, 0xbbb9, 0xbbbe, 0xbbbc,    BAD,
/* 20 */ 0xbbb7,    BAD, 0xbbbd, 0xbbba,    BAD,    BAD,    BAD, 0xe852,
/* 28 */ 0xbe43, 0xbe41,    BAD, 0xe853,    BAD, 0xbe44, 0xbe42, 0xe851,
/* 30 */ 0xe850,    BAD, 0xbff0, 0xe84f, 0xbfee, 0xbfed, 0xebd0, 0xbe45,
/* 38 */ 0xbfef, 0xebd1, 0xbff2, 0xebd2, 0xbff1, 0xc1d8, 0xeec3, 0xc1d7
},

/* Row 0x128 */
{
/* 00 */ 0xc1dc, 0xc1da, 0xc1db, 0xc2e3, 0xc1d9, 0xeec2, 0xebd3, 0xc2e2,
/* 08 */ 0xc2e4,    BAD, 0xc3e4, 0xc3e5,    BAD, 0xf4e0,    BAD, 0xc5de,
/* 10 */ 0xc5dd, 0xa8b6,    BAD,    BAD, 0xca55, 0xb06f,    BAD, 0xca52,
/* 18 */ 0xca53, 0xca51,    BAD, 0xca54,    BAD,    BAD, 0xcbaa, 0xcba7,
/* 20 */ 0xcbac, 0xcba8, 0xa8b7, 0xa8ba,    BAD, 0xcba9, 0xa8b9, 0xcbab,
/* 28 */    BAD,    BAD, 0xa8b8,    BAD,    BAD,    BAD,    BAD, 0xcdd5,
/* 30 */ 0xcdd7, 0xaaf4, 0xcdd3, 0xcdd6, 0xcdd4, 0xaaf2, 0xaaf5,    BAD,
/* 38 */ 0xaaf3,    BAD,    BAD,    BAD,    BAD, 0xd0b8, 0xd0bc, 0xd0b9
},

/* Row 0x129 */
{
/* 00 */    BAD, 0xada7,    BAD, 0xada8,    BAD, 0xd0bb,    BAD, 0xd0bd,
/* 08 */ 0xd0bf,    BAD, 0xada5, 0xd0be,    BAD,    BAD, 0xada6,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xd7ee, 0xd0ba, 0xd3f2, 0xd3fb,
/* 18 */ 0xd3f9, 0xd3f4, 0xd3f5, 0xd3fa, 0xd3fc, 0xb071,    BAD, 0xd3f7,
/* 20 */ 0xd3f3, 0xb070, 0xb072, 0xd3f6, 0xd3fd, 0xd3f8,    BAD,    BAD,
/* 28 */ 0xb3a1, 0xd7f1, 0xd7e9, 0xd7ef, 0xd7f0, 0xb3a2,    BAD, 0xd7e8,
/* 30 */ 0xd7ea, 0xd0b7, 0xd7ec, 0xd7ed, 0xd7eb, 0xb66c,    BAD,    BAD,
/* 38 */    BAD, 0xdc56, 0xebd4, 0xdc57, 0xdc54, 0xb3a3, 0xb66e, 0xdc53
},

/* Row 0x12a */
{
/* 00 */ 0xdc59, 0xdc58, 0xb66b, 0xdc5c, 0xdc52, 0xdc5b, 0xdc50, 0xdc5a,
/* 08 */ 0xdc55, 0xb66d,    BAD, 0xe0aa,    BAD, 0xe0a5, 0xe0ab, 0xe0a6,
/* 10 */ 0xe0a4, 0xe0a7, 0xb951,    BAD, 0xe0a9,    BAD, 0xe0a8, 0xb952,
/* 18 */ 0xbbc1, 0xbbc0, 0xe46e, 0xe471, 0xe469, 0xe46d, 0xbbc2, 0xe46c,
/* 20 */ 0xe46a, 0xe470, 0xe46b, 0xe468, 0xe46f,    BAD, 0xe859, 0xbe48,
/* 28 */ 0xf14a, 0xe856, 0xe857, 0xe855, 0xdc51, 0xbe47, 0xe85a, 0xe854,
/* 30 */ 0xbe46, 0xbe49, 0xe858, 0xebd5, 0xbff3, 0xebd6, 0xebd7,    BAD,
/* 38 */ 0xeec4, 0xc1dd, 0xf14b, 0xf14c,    BAD,    BAD, 0xf14d, 0xf35d
},

/* Row 0x12b */
{
/* 00 */ 0xf35c, 0xf4e2,    BAD, 0xf4e1, 0xf65b, 0xf65c, 0xf65a, 0xf766,
/* 08 */ 0xc5b0, 0xa8bb, 0xadaa, 0xada9, 0xb075, 0xb074, 0xd440, 0xd441,
/* 10 */ 0xd3fe,    BAD, 0xb073, 0xd7f5,    BAD, 0xd7f6, 0xd7f2, 0xb3a4,
/* 18 */ 0xd7f3,    BAD, 0xd7f4,    BAD,    BAD,    BAD,    BAD, 0xdc5f,
/* 20 */ 0xdc61, 0xdc5d, 0xdc60, 0xb66f, 0xdc5e, 0xb670,    BAD,    BAD,
/* 28 */ 0xdd73, 0xb955, 0xb954,    BAD, 0xb953,    BAD, 0xe0ac, 0xe0ad,
/* 30 */    BAD,    BAD, 0xe473, 0xe475, 0xbbc6, 0xbbc3,    BAD, 0xbbc5,
/* 38 */ 0xbbc4, 0xe474, 0xe472,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x12c */
{
/* 00 */ 0xe861, 0xe85e, 0xe85f, 0xbe4d, 0xe860, 0xe85b, 0xe85c, 0xbe4a,
/* 08 */    BAD, 0xbe4b, 0xe85d, 0xbe4c,    BAD, 0xebdb,    BAD, 0xebdc,
/* 10 */ 0xebd9, 0xebda, 0xbff4, 0xebd8,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xeec8, 0xeec5, 0xeec7, 0xc1e0, 0xeecb, 0xc1df, 0xeec9,
/* 20 */ 0xeecc, 0xeeca, 0xeec6, 0xc1de,    BAD, 0xf14f,    BAD, 0xf150,
/* 28 */ 0xf14e,    BAD, 0xf152, 0xc2e5, 0xc2e6, 0xf35f, 0xc3e7, 0xf151,
/* 30 */ 0xf35e, 0xc3e6, 0xf4e5, 0xf4e6, 0xc4bf, 0xf4e4,    BAD, 0xf4e3,
/* 38 */    BAD, 0xf65d, 0xc548,    BAD, 0xf849, 0xf8c8, 0xf8c7,    BAD
},

/* Row 0x12d */
{
/* 00 */ 0xc643, 0xc65d, 0xf8c9, 0xf971,    BAD, 0xc66f, 0xa8bc, 0xaaf6,
/* 08 */    BAD, 0xb956,    BAD, 0xc4c0, 0xa8bd, 0xadab, 0xb3a5, 0xb671,
/* 10 */ 0xc2e7, 0xaaf7,    BAD, 0xd0c1, 0xd0c0, 0xd442,    BAD, 0xb078,
/* 18 */ 0xb076, 0xb07a, 0xd444,    BAD, 0xb079, 0xb077,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xd443, 0xb3a8, 0xd7fc,    BAD, 0xb3a7, 0xb3a9,
/* 28 */ 0xd842, 0xb3ab, 0xd7fe, 0xd840, 0xd7f7, 0xb3aa, 0xd843,    BAD,
/* 30 */    BAD, 0xd7f9,    BAD, 0xd7fa, 0xd7f8, 0xb3a6,    BAD, 0xd841,
/* 38 */ 0xd7fb, 0xd7fd,    BAD,    BAD,    BAD, 0xdc6d,    BAD, 0xdc6c
},

/* Row 0x12e */
{
/* 00 */ 0xdc6a, 0xdc62, 0xdc71, 0xdc65, 0xdc6f, 0xdc76, 0xdc6e, 0xb679,
/* 08 */    BAD, 0xb675, 0xdc63,    BAD, 0xdc69, 0xb677,    BAD, 0xdc68,
/* 10 */ 0xb678, 0xb67a, 0xdc6b,    BAD, 0xb672, 0xb673, 0xdc77, 0xdc75,
/* 18 */    BAD, 0xdc74, 0xdc66,    BAD, 0xdc72,    BAD, 0xb676,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xb674, 0xdc73, 0xdc64, 0xdc67, 0xdc70,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xe4ba, 0xe0b7,    BAD,
/* 30 */ 0xe0b0, 0xe0c3, 0xe0cc, 0xe0b3, 0xb961,    BAD, 0xe0c0, 0xb957,
/* 38 */ 0xb959, 0xb965, 0xe0b1,    BAD,    BAD, 0xb95a, 0xb95c, 0xb966
},

/* Row 0x12f */
{
/* 00 */ 0xb95b,    BAD,    BAD,    BAD,    BAD, 0xb964, 0xe0b9,    BAD,
/* 08 */ 0xe0ae, 0xb962, 0xe0b8, 0xb95e, 0xe0ca, 0xb963, 0xe0c8, 0xe0bc,
/* 10 */ 0xe0c6, 0xb960, 0xe0af, 0xe0c9, 0xe0c4,    BAD, 0xe0cb, 0xb958,
/* 18 */    BAD,    BAD, 0xb967, 0xb95d,    BAD,    BAD, 0xe0b5,    BAD,
/* 20 */ 0xe0bd, 0xe0c1,    BAD, 0xe0c5, 0xb95f, 0xe0b4, 0xe0b2, 0xe0be,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe0bb, 0xe0ba,    BAD, 0xe0bf,
/* 30 */ 0xe0c2,    BAD, 0xe0c7,    BAD,    BAD,    BAD, 0xe478,    BAD,
/* 38 */ 0xbbc7, 0xe4a4, 0xe47a, 0xbbcc, 0xbbd0, 0xe4ad, 0xe4b5, 0xe4a6
},

/* Row 0x130 */
{
/* 00 */ 0xbbc8,    BAD, 0xe4aa, 0xe0b6,    BAD, 0xbbc9, 0xe4b1, 0xe4b6,
/* 08 */ 0xe4ae,    BAD, 0xe4b0, 0xe4b9, 0xe4b2, 0xe47e, 0xe4a9,    BAD,
/* 10 */    BAD, 0xbbd1,    BAD, 0xbbcd, 0xe47c, 0xe4ab, 0xbbcb, 0xe4a5,
/* 18 */ 0xbbca, 0xe4b3, 0xe4a2, 0xe479, 0xbbce, 0xe4b8,    BAD,    BAD,
/* 20 */ 0xe47b, 0xe4af, 0xe4ac, 0xe4a7, 0xe477, 0xe476, 0xe4a1, 0xe4b4,
/* 28 */ 0xbbcf, 0xe4b7, 0xe47d, 0xe4a3, 0xbe52,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xbe5a, 0xbe55, 0xe8a4, 0xe8a1, 0xe867, 0xbe50,
/* 38 */    BAD,    BAD,    BAD, 0xbe4f, 0xbe56,    BAD,    BAD,    BAD
},

/* Row 0x131 */
{
/* 00 */ 0xe865, 0xbe54, 0xe871, 0xe863, 0xe864, 0xbe4e, 0xe8a3, 0xbe58,
/* 08 */ 0xe874, 0xe879, 0xe873, 0xebee, 0xe86f, 0xe877, 0xe875, 0xe868,
/* 10 */ 0xe862, 0xe87d, 0xbe57, 0xe87e,    BAD, 0xe878,    BAD, 0xe86d,
/* 18 */ 0xe86b, 0xe866,    BAD,    BAD,    BAD, 0xe86e, 0xe87b, 0xe86a,
/* 20 */ 0xe87a, 0xe8a2,    BAD,    BAD, 0xbe53,    BAD, 0xe876, 0xe87c,
/* 28 */ 0xe872, 0xe86c, 0xbe51,    BAD,    BAD,    BAD, 0xe4a8, 0xe870,
/* 30 */ 0xbe59, 0xe869,    BAD,    BAD,    BAD,    BAD,    BAD, 0xebf4,
/* 38 */ 0xbff7, 0xebf3, 0xebf0, 0xec44, 0xbffb,    BAD, 0xec41, 0xebf8
},

/* Row 0x132 */
{
/* 00 */ 0xec43, 0xebe9, 0xebf6,    BAD, 0xbffd,    BAD, 0xebe1,    BAD,
/* 08 */ 0xebdf, 0xec42,    BAD, 0xec40, 0xebfe, 0xebed, 0xebec, 0xebe2,
/* 10 */ 0xc040,    BAD, 0xebe8, 0xebf2, 0xebfd, 0xc043, 0xec45,    BAD,
/* 18 */ 0xc1e8, 0xc045, 0xbffe, 0xebe6,    BAD, 0xebef, 0xebde, 0xebe0,
/* 20 */ 0xbff5, 0xc042, 0xbffa, 0xebe7, 0xebf7, 0xebf1, 0xc041, 0xebdd,
/* 28 */ 0xc1e3, 0xebf9, 0xebfc, 0xbffc,    BAD, 0xebeb, 0xc044, 0xbff9,
/* 30 */    BAD,    BAD,    BAD, 0xbff8, 0xebf5, 0xebfb, 0xbff6,    BAD,
/* 38 */ 0xebe4, 0xebfa,    BAD,    BAD, 0xebe5,    BAD,    BAD,    BAD
},

/* Row 0x133 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xebea, 0xeed2,
/* 08 */    BAD, 0xeed7, 0xc1e5, 0xc1e7, 0xeedd, 0xc1e1, 0xeeec, 0xeee3,
/* 10 */ 0xeed8, 0xeed9, 0xeee2,    BAD, 0xc1ee, 0xeee1, 0xeed1, 0xeee0,
/* 18 */ 0xeed4, 0xeeed, 0xc1ed, 0xc1eb, 0xeed5,    BAD, 0xeee8,    BAD,
/* 20 */ 0xeeda, 0xeee7,    BAD, 0xeee9, 0xeed0, 0xc1e6,    BAD, 0xeeea,
/* 28 */    BAD,    BAD, 0xeede,    BAD, 0xc1ea, 0xeedb,    BAD,    BAD,
/* 30 */ 0xc1ec, 0xeee4,    BAD,    BAD,    BAD, 0xc1e4, 0xeed6, 0xeee5,
/* 38 */    BAD, 0xeedf, 0xebe3, 0xeee6, 0xeed3,    BAD, 0xc1e9,    BAD
},

/* Row 0x134 */
{
/* 00 */ 0xeeeb,    BAD, 0xc1e2, 0xeece,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xf160, 0xf159, 0xc2e9,    BAD, 0xf154, 0xf163, 0xf15b, 0xeedc,
/* 10 */    BAD, 0xf165, 0xf155,    BAD, 0xc2e8, 0xf15f, 0xc2ea, 0xc2f2,
/* 18 */ 0xc2f0, 0xf161, 0xc2f1, 0xf157,    BAD, 0xf158, 0xf15d, 0xf162,
/* 20 */    BAD, 0xeecd, 0xc2eb, 0xf16a, 0xf167, 0xf16b, 0xf15e, 0xf15a,
/* 28 */ 0xf168, 0xf36a, 0xf15c,    BAD, 0xc2ee,    BAD, 0xc2ed, 0xeecf,
/* 30 */ 0xc2ef, 0xf164, 0xf166, 0xc2ec, 0xf169, 0xf153,    BAD, 0xf156,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x135 */
{
/* 00 */ 0xf373,    BAD, 0xf363, 0xc3eb, 0xf371,    BAD,    BAD, 0xf361,
/* 08 */ 0xc3ec,    BAD, 0xf36c,    BAD, 0xf368, 0xc3f1, 0xf372, 0xf362,
/* 10 */ 0xf365, 0xc3e9, 0xf374,    BAD, 0xf36d, 0xf370, 0xc3ef, 0xc3f4,
/* 18 */ 0xc3f2, 0xf369, 0xf364,    BAD, 0xc3ed, 0xc3ee, 0xf360, 0xc3ea,
/* 20 */    BAD, 0xc3e8, 0xc3f0, 0xf36f, 0xc3f3,    BAD, 0xf36b, 0xf375,
/* 28 */ 0xc3f5,    BAD,    BAD,    BAD, 0xf367,    BAD, 0xf36e,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf4f3, 0xf542, 0xf4f5,
/* 38 */ 0xf4fc, 0xf366, 0xf4fa, 0xf4e9, 0xf540, 0xc4c3, 0xf4ed, 0xf4fe
},

/* Row 0x136 */
{
/* 00 */ 0xf4f4,    BAD,    BAD, 0xc4c2,    BAD,    BAD, 0xf544, 0xf4f6,
/* 08 */    BAD, 0xf4fb, 0xf4fd, 0xf4e7, 0xf541, 0xf4f2, 0xf4f7, 0xf4eb,
/* 10 */ 0xf4ef, 0xf543, 0xf4f9, 0xf4e8, 0xf4ec, 0xf4ee, 0xf4f8,    BAD,
/* 18 */ 0xc4c1, 0xf4f1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xf4ea,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xf4f0, 0xf661, 0xf666, 0xc54f, 0xf668,    BAD, 0xc549,    BAD,
/* 30 */ 0xf664, 0xf66a, 0xc54e, 0xc54a,    BAD, 0xc54b, 0xf660, 0xf667,
/* 38 */ 0xc54d, 0xf665, 0xc54c, 0xf65f, 0xf663, 0xf662,    BAD, 0xf65e
},

/* Row 0x137 */
{
/* 00 */ 0xf669,    BAD,    BAD,    BAD, 0xc5b1, 0xf76d, 0xf770, 0xf76c,
/* 08 */ 0xf76e, 0xf76f, 0xf769, 0xf76a, 0xf767,    BAD,    BAD, 0xf76b,
/* 10 */ 0xf768, 0xc5b2, 0xc5b3,    BAD,    BAD, 0xf84b,    BAD, 0xf84d,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf84c, 0xf84e,    BAD,
/* 20 */ 0xc5e0,    BAD, 0xf84a, 0xc5df, 0xc5e1,    BAD,    BAD,    BAD,
/* 28 */ 0xf8cb, 0xf8cc, 0xc644, 0xf8ca,    BAD, 0xf953, 0xf952, 0xf954,
/* 30 */ 0xc65f, 0xf955, 0xc65e, 0xf956, 0xf972, 0xf975, 0xf974, 0xc668,
/* 38 */ 0xf973,    BAD,    BAD,    BAD, 0xc672, 0xc670, 0xc671, 0xc677
},

/* Row 0x138 */
{
/* 00 */ 0xf9c0, 0xf9c1, 0xf9bf, 0xf9c9,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x139 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xaaf8,
/* 38 */    BAD,    BAD, 0xd844, 0xdc78, 0xe8a5, 0xf376,    BAD,    BAD
},

/* Row 0x13a */
{
/* 00 */ 0xaaf9,    BAD, 0xadac, 0xb07b,    BAD,    BAD, 0xd845,    BAD,
/* 08 */ 0xd846, 0xb3ac,    BAD, 0xb67d, 0xdc7a, 0xdc79, 0xb6a3, 0xb67c,
/* 10 */ 0xdc7b, 0xb67e, 0xb6a2, 0xb6a1, 0xb67b,    BAD,    BAD,    BAD,
/* 18 */ 0xb968,    BAD,    BAD, 0xe0d0, 0xe0ce,    BAD, 0xe0cf, 0xe0cd,
/* 20 */    BAD, 0xbbd2,    BAD, 0xbbd5, 0xbbd7, 0xbbd6,    BAD,    BAD,
/* 28 */ 0xbbd3, 0xbbd4,    BAD, 0xe8a7, 0xe8a6, 0xbe5b, 0xe8a8,    BAD,
/* 30 */ 0xe8a9, 0xbe5c,    BAD,    BAD,    BAD, 0xec4d, 0xec4b, 0xeef3,
/* 38 */    BAD, 0xec49, 0xec4a, 0xc046, 0xec46, 0xec4e, 0xec48, 0xec4c
},

/* Row 0x13b */
{
/* 00 */ 0xeeef,    BAD,    BAD, 0xeef1,    BAD, 0xeef2, 0xc1f3, 0xeeee,
/* 08 */ 0xc1f2, 0xeef0, 0xc1ef, 0xc1f0, 0xc1f1, 0xec47,    BAD,    BAD,
/* 10 */ 0xc2f5, 0xf16e, 0xf16c, 0xf16d, 0xc2f3, 0xc2f6, 0xc2f4,    BAD,
/* 18 */    BAD,    BAD, 0xf377, 0xf378, 0xc3f6,    BAD, 0xf545, 0xf547,
/* 20 */ 0xf546, 0xc4c4, 0xc550, 0xf66d, 0xf66c, 0xf66b,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x13c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xaafa,    BAD, 0xc9aa,    BAD,
/* 20 */ 0xca58, 0xa6e9, 0xca56, 0xca59, 0xca57,    BAD,    BAD,    BAD,
/* 28 */ 0xcbae,    BAD, 0xa8c1,    BAD, 0xa8c2, 0xcbb0, 0xa8bf, 0xcbaf,
/* 30 */ 0xcbad, 0xa8c0, 0xa8be,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xcdd8, 0xcddb, 0xaafd, 0xcdda, 0xcdd9,    BAD, 0xaafc
},

/* Row 0x13d */
{
/* 00 */ 0xaafb,    BAD, 0xab40, 0xcddc, 0xaafe,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xd0c6, 0xadae, 0xadaf, 0xadb0, 0xd0c7, 0xd0c3,
/* 10 */ 0xadad, 0xd0c4,    BAD, 0xd0c5, 0xd0c2,    BAD,    BAD,    BAD,
/* 18 */ 0xb0a4,    BAD,    BAD, 0xb0a1, 0xd445, 0xb0a2, 0xb0a5, 0xd446,
/* 20 */    BAD, 0xb07e, 0xb07c, 0xb07d, 0xb0a3,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xb3ad, 0xd849, 0xb3b5, 0xd848,    BAD, 0xd84b,
/* 30 */ 0xb3b1, 0xd84a, 0xb6ab, 0xb3af, 0xb3b2, 0xb3ae, 0xb3b3, 0xb3b4,
/* 38 */ 0xb3b0,    BAD,    BAD,    BAD, 0xd847, 0xb6a7, 0xdc7d,    BAD
},

/* Row 0x13e */
{
/* 00 */ 0xdca3,    BAD,    BAD, 0xdca2, 0xb6ac, 0xb6a8, 0xb6a9, 0xdc7c,
/* 08 */ 0xdc7e, 0xdca1, 0xb6a4, 0xb6a6,    BAD, 0xb6aa, 0xb6a5,    BAD,
/* 10 */    BAD, 0xe0d3, 0xe0d1, 0xe0d2, 0xb96a, 0xb96b,    BAD, 0xe0d4,
/* 18 */ 0xb969, 0xbbd8,    BAD, 0xbbda, 0xbbd9,    BAD, 0xe4bb,    BAD,
/* 20 */    BAD, 0xe4bc, 0xe8ab,    BAD, 0xe8aa,    BAD,    BAD, 0xc047,
/* 28 */ 0xc048, 0xec4f, 0xc049,    BAD, 0xeef6,    BAD, 0xeef4,    BAD,
/* 30 */ 0xeef5, 0xc1f4,    BAD, 0xf16f, 0xc3f7,    BAD,    BAD,    BAD,
/* 38 */ 0xc1f5, 0xab41,    BAD, 0xb0a6, 0xd447,    BAD,    BAD, 0xd84c
},

/* Row 0x13f */
{
/* 00 */ 0xb3b6, 0xb6ad, 0xdca4, 0xdca6, 0xb6af, 0xb6ae, 0xb6b0, 0xb6b1,
/* 08 */ 0xdca5, 0xb96e, 0xb96f, 0xb96d, 0xbbdb, 0xb96c, 0xe0d5,    BAD,
/* 10 */    BAD,    BAD, 0xbbdc, 0xe8ac, 0xec50, 0xc04a, 0xc1f6, 0xf170,
/* 18 */ 0xf174, 0xc2f9, 0xf171, 0xc2fa, 0xc2f8, 0xf175, 0xc2fb, 0xf173,
/* 20 */    BAD, 0xf379, 0xc2f7, 0xc3f8,    BAD, 0xf8cd,    BAD,    BAD,
/* 28 */ 0xab42, 0xb3b8, 0xb3b7,    BAD,    BAD,    BAD,    BAD, 0xb6b2,
/* 30 */ 0xdca8, 0xdca7, 0xb6b3,    BAD,    BAD, 0xe0d9, 0xb973, 0xb970,
/* 38 */ 0xe0d8, 0xb972, 0xe0d6, 0xb971,    BAD, 0xe0d7,    BAD, 0xe4bd
},

/* Row 0x140 */
{
/* 00 */ 0xbbdd,    BAD, 0xe8af,    BAD, 0xbe5d, 0xe8ad, 0xbe5e, 0xbe5f,
/* 08 */ 0xe8ae, 0xbe60,    BAD, 0xec51,    BAD, 0xc04e, 0xc04b, 0xc050,
/* 10 */ 0xec53, 0xc04c, 0xec52, 0xc04f,    BAD,    BAD, 0xc04d,    BAD,
/* 18 */ 0xeef9, 0xeefb,    BAD,    BAD, 0xc1f7, 0xeefa, 0xc1f8, 0xeef8,
/* 20 */ 0xeef7,    BAD, 0xf177, 0xf176, 0xc2fc, 0xf178, 0xf37e, 0xc3fa,
/* 28 */ 0xf37d, 0xf37a, 0xc3f9, 0xf37b, 0xf37c,    BAD, 0xf548, 0xf549,
/* 30 */ 0xc4c5,    BAD, 0xc553,    BAD,    BAD, 0xf66e,    BAD,    BAD,
/* 38 */ 0xc551, 0xc552, 0xf66f,    BAD,    BAD, 0xc5b4, 0xc5b5, 0xf771
},

/* Row 0x141 */
{
/* 00 */    BAD,    BAD, 0xc645, 0xf8cf, 0xc647,    BAD, 0xf8ce, 0xf8d0,
/* 08 */ 0xc646, 0xf957,    BAD, 0xf9ad,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xab43,    BAD,    BAD,    BAD, 0xb974,    BAD,
/* 18 */ 0xe4be,    BAD, 0xe8b0, 0xc051, 0xc052,    BAD, 0xab44,    BAD,
/* 20 */ 0xbe61, 0xc3fb, 0xadb1,    BAD,    BAD,    BAD, 0xc053,    BAD,
/* 28 */ 0xc5e2, 0xadb2, 0xd84d,    BAD, 0xdca9,    BAD, 0xdcab,    BAD,
/* 30 */ 0xdcaa,    BAD, 0xe0dd, 0xe0da, 0xb975,    BAD, 0xb976, 0xe0db,
/* 38 */ 0xe0dc,    BAD, 0xe4c0, 0xe4c5, 0xbbde, 0xe4bf, 0xe4c1, 0xe4c8
},

/* Row 0x142 */
{
/* 00 */ 0xe4c3, 0xe4c7, 0xe4c4, 0xe4c2, 0xe4c6, 0xbbdf,    BAD,    BAD,
/* 08 */ 0xe8b3,    BAD, 0xe8b1, 0xbe63,    BAD, 0xbe62, 0xe8b2, 0xbe64,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xec56,    BAD,    BAD, 0xec55,
/* 18 */ 0xc054, 0xec54, 0xeefc,    BAD, 0xeefe, 0xef41, 0xef40,    BAD,
/* 20 */ 0xc1f9, 0xeefd, 0xf1a1, 0xc2fd, 0xf17d, 0xf1a2, 0xc2fe,    BAD,
/* 28 */ 0xf17b,    BAD, 0xf17e, 0xf17c, 0xf179, 0xc340, 0xf17a,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xf3a1,    BAD,    BAD, 0xf3a3, 0xf3a2,
/* 38 */    BAD, 0xf54a,    BAD, 0xf54b,    BAD,    BAD,    BAD, 0xf670
},

/* Row 0x143 */
{
/* 00 */    BAD, 0xc5b7,    BAD, 0xc5b6, 0xf84f, 0xf850, 0xc648, 0xf8d1,
/* 08 */    BAD, 0xc669,    BAD, 0xadb3, 0xb6b4, 0xe4ca, 0xe4c9, 0xe8b5,
/* 10 */ 0xe8b4,    BAD,    BAD, 0xc1fa, 0xef43, 0xef42, 0xf1a5, 0xf1a3,
/* 18 */ 0xf1a6, 0xf1a4,    BAD,    BAD, 0xc3fc, 0xf3a4, 0xf3a5, 0xf3a6,
/* 20 */    BAD, 0xf671,    BAD, 0xf772,    BAD, 0xf8d2,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xadb4,    BAD,    BAD,
/* 30 */ 0xec57, 0xef44,    BAD, 0xadb5,    BAD,    BAD, 0xbbe0,    BAD,
/* 38 */ 0xec58, 0xc341, 0xf1a7, 0xc3fd,    BAD, 0xf54c, 0xf54d, 0xc554
},

/* Row 0x144 */
{
/* 00 */ 0xf851, 0xadb6, 0xb3bb, 0xb3bc, 0xd84e, 0xb6b5, 0xb6b6, 0xdcac,
/* 08 */ 0xb6b7,    BAD, 0xb97a,    BAD, 0xb97c, 0xe0df, 0xe0e0, 0xe0de,
/* 10 */ 0xb977, 0xb978, 0xb97b, 0xb979,    BAD,    BAD, 0xe4cb, 0xbbe1,
/* 18 */ 0xbbe2,    BAD,    BAD, 0xe8bc, 0xbe67, 0xe8b7, 0xe8b6,    BAD,
/* 20 */ 0xe8bb, 0xbe65,    BAD,    BAD, 0xc05b,    BAD, 0xe8b8, 0xe8bd,
/* 28 */ 0xe8ba, 0xe8b9,    BAD, 0xbe66,    BAD, 0xc059,    BAD, 0xec5a,
/* 30 */ 0xc055,    BAD, 0xec5b,    BAD,    BAD, 0xec59,    BAD, 0xc058,
/* 38 */ 0xc056, 0xc05a,    BAD, 0xc057,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x145 */
{
/* 00 */    BAD, 0xef45,    BAD, 0xef4a, 0xef46, 0xef49, 0xc1fb,    BAD,
/* 08 */ 0xedd4, 0xef48, 0xef47,    BAD, 0xc344, 0xc342, 0xc345, 0xc343,
/* 10 */ 0xf1a8, 0xf1a9, 0xf1aa, 0xc346,    BAD,    BAD,    BAD, 0xf3aa,
/* 18 */ 0xc440, 0xf3a8,    BAD, 0xc441, 0xf3a7, 0xf3a9, 0xc3fe, 0xf551,
/* 20 */ 0xf54e,    BAD, 0xf54f, 0xf550, 0xf672, 0xc556,    BAD, 0xc555,
/* 28 */    BAD, 0xf774, 0xf773, 0xc5b8,    BAD,    BAD,    BAD, 0xc5e3,
/* 30 */ 0xc649, 0xc660, 0xf958, 0xf9ae, 0xf9af,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x146 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xadb7, 0xdcad,    BAD,    BAD, 0xe0e1, 0xe4cc, 0xe4cd, 0xbbe3,
/* 30 */    BAD, 0xbbe4, 0xe8be, 0xbe68,    BAD,    BAD, 0xc1fc,    BAD,
/* 38 */ 0xf1ab,    BAD, 0xc347, 0xf3ad, 0xc442, 0xf3ac, 0xf3ae, 0xf3ab
},

/* Row 0x147 */
{
/* 00 */ 0xf675, 0xf552, 0xf553,    BAD, 0xc4c6,    BAD, 0xf674,    BAD,
/* 08 */    BAD, 0xf673,    BAD, 0xf775, 0xf9b0,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xadb8,    BAD,    BAD,    BAD, 0xadb9,
/* 20 */    BAD,    BAD, 0xb0a7, 0xd448,    BAD, 0xd84f,    BAD, 0xb6b8,
/* 28 */    BAD, 0xb6bb, 0xb6b9, 0xdcae,    BAD, 0xb6bd,    BAD, 0xb6ba,
/* 30 */    BAD,    BAD, 0xb6bc,    BAD, 0xb97e,    BAD, 0xe0e2,    BAD,
/* 38 */    BAD, 0xe0e3, 0xe8c0,    BAD, 0xb97d, 0xb9a1, 0xb9a2,    BAD
},

/* Row 0x148 */
{
/* 00 */ 0xe4cf,    BAD, 0xe4ce, 0xbbe5,    BAD, 0xbbe6,    BAD, 0xe4d0,
/* 08 */ 0xe8bf, 0xbbe8, 0xbe69,    BAD, 0xbbe7,    BAD,    BAD,    BAD,
/* 10 */ 0xc05c, 0xe8c1, 0xbe6b, 0xbe6a, 0xe8c2, 0xe8c5, 0xe8c3, 0xe8c4,
/* 18 */ 0xbe6c,    BAD, 0xc061, 0xc05f,    BAD,    BAD, 0xc05e, 0xec5d,
/* 20 */    BAD, 0xc060,    BAD,    BAD, 0xec5c, 0xef4b,    BAD, 0xec5e,
/* 28 */ 0xc05d, 0xec5f, 0xef4e, 0xef4c, 0xef4d, 0xef52, 0xc34b, 0xef51,
/* 30 */ 0xef54, 0xef53, 0xef50, 0xef4f,    BAD, 0xc1fd,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xf1ae,    BAD, 0xf1ad, 0xc34a, 0xc348, 0xc349
},

/* Row 0x149 */
{
/* 00 */    BAD, 0xf1ac,    BAD, 0xf3b1,    BAD, 0xc443,    BAD, 0xf3b0,
/* 08 */ 0xf3af, 0xc444,    BAD, 0xf558, 0xf557,    BAD, 0xf555,    BAD,
/* 10 */ 0xf554, 0xc4c8, 0xc4c7, 0xf559, 0xf776, 0xc5b9, 0xf677, 0xc557,
/* 18 */ 0xf676, 0xf556,    BAD, 0xf777, 0xc5e4,    BAD, 0xc661, 0xf959,
/* 20 */    BAD, 0xf9b1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x14a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xadba, 0xd850,
/* 18 */ 0xef55, 0xadbb,    BAD,    BAD, 0xe4d2, 0xe4d1, 0xec60,    BAD,
/* 20 */    BAD, 0xef57,    BAD, 0xef56,    BAD, 0xc34c, 0xf3b2, 0xf3b3,
/* 28 */ 0xc4c9,    BAD,    BAD, 0xf9b2, 0xb0a8, 0xb6bf, 0xb6be, 0xe0e4,
/* 30 */ 0xe0e6, 0xb9a4, 0xe0e5, 0xb9a3, 0xb9a5, 0xe0e7,    BAD,    BAD,
/* 38 */    BAD, 0xe4d4, 0xe4d6, 0xe4d5,    BAD, 0xe4d8,    BAD,    BAD
},

/* Row 0x14b */
{
/* 00 */    BAD, 0xbbe9, 0xe4d7, 0xe4d3,    BAD,    BAD,    BAD, 0xe4d9,
/* 08 */    BAD, 0xe8cc,    BAD, 0xe8cf, 0xe8d1, 0xe8c7, 0xe8cb, 0xe8c8,
/* 10 */ 0xbe6e, 0xbe71, 0xbe73, 0xe8c9, 0xe8ca, 0xbe72, 0xe8cd, 0xe8d0,
/* 18 */ 0xe8ce, 0xbe74,    BAD, 0xbe70, 0xe8c6, 0xbe6d,    BAD, 0xbe6f,
/* 20 */    BAD,    BAD, 0xc063, 0xec66, 0xec64, 0xec63,    BAD, 0xec69,
/* 28 */    BAD, 0xec68, 0xec67,    BAD, 0xec62, 0xc062, 0xec61,    BAD,
/* 30 */ 0xec65, 0xc064,    BAD,    BAD, 0xef5a,    BAD, 0xef5e, 0xef5b,
/* 38 */ 0xef5d, 0xef5c, 0xef59, 0xef5f, 0xef62, 0xef60, 0xef61, 0xc240
},

/* Row 0x14c */
{
/* 00 */    BAD, 0xc1fe, 0xef58, 0xef63, 0xf1b3, 0xf1b6, 0xf1b8, 0xf1b7,
/* 08 */    BAD, 0xf1b1, 0xf1b5, 0xf1b0,    BAD, 0xf1b2, 0xc34d, 0xf1af,
/* 10 */    BAD, 0xf1b4,    BAD,    BAD, 0xf3c0, 0xf3b5, 0xc445,    BAD,
/* 18 */    BAD, 0xc446, 0xf3b4, 0xf3b9, 0xf3bf, 0xf3b7, 0xf3be,    BAD,
/* 20 */ 0xf3bb,    BAD, 0xf3ba, 0xf3bd, 0xf3b8, 0xf3b6,    BAD, 0xf3bc,
/* 28 */    BAD, 0xf560, 0xf55e, 0xc4ca, 0xf55d, 0xf563, 0xf561,    BAD,
/* 30 */ 0xc4cb, 0xf55c, 0xf55a,    BAD, 0xf55b, 0xc4cd, 0xf55f, 0xc4cc,
/* 38 */ 0xf562, 0xf678, 0xf67e,    BAD,    BAD, 0xf679, 0xc55b, 0xf6a1
},

/* Row 0x14d */
{
/* 00 */ 0xc55a, 0xf67d, 0xf67c, 0xc559, 0xf67b, 0xc558, 0xf67a,    BAD,
/* 08 */ 0xf77d, 0xf7a1, 0xf77e,    BAD, 0xf77b, 0xc5bb, 0xf778, 0xf77c,
/* 10 */ 0xf7a3,    BAD, 0xf7a2, 0xf779, 0xf77a, 0xc5ba, 0xf852, 0xc5e7,
/* 18 */    BAD, 0xf853, 0xc5e5, 0xc5e6,    BAD,    BAD, 0xf8d3, 0xc64a,
/* 20 */ 0xf976,    BAD, 0xc66a,    BAD, 0xf9b3, 0xc66b, 0xf9b4, 0xf9b5,
/* 28 */ 0xf9c3, 0xf9c2, 0xc67a, 0xf9cd,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x14e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xb0a9,    BAD,    BAD, 0xe0e9,    BAD, 0xe0e8,    BAD, 0xbbea,
/* 30 */ 0xbbeb, 0xe4da,    BAD, 0xe8d2, 0xec6c,    BAD,    BAD, 0xbe75,
/* 38 */ 0xc065, 0xec6a,    BAD, 0xec6d, 0xc066,    BAD, 0xef64, 0xec6b
},

/* Row 0x14f */
{
/* 00 */ 0xf1b9, 0xc34e, 0xf3c1,    BAD,    BAD,    BAD, 0xf566, 0xf564,
/* 08 */    BAD,    BAD, 0xf565,    BAD,    BAD, 0xf6a2,    BAD, 0xc55c,
/* 10 */ 0xf7a4, 0xc5ea, 0xc5bc, 0xc5e8, 0xc5e9, 0xf8d4, 0xc662,    BAD,
/* 18 */ 0xb0aa,    BAD,    BAD,    BAD, 0xf1ba,    BAD,    BAD, 0xd449,
/* 20 */    BAD, 0xb9a6,    BAD, 0xe4db,    BAD,    BAD, 0xbbec, 0xe4dc,
/* 28 */    BAD,    BAD,    BAD, 0xe8d4, 0xe8d3, 0xc068, 0xbe76, 0xbe77,
/* 30 */    BAD, 0xe8d7, 0xe8d6, 0xe8d5,    BAD,    BAD, 0xec6e, 0xec71,
/* 38 */    BAD, 0xec70, 0xec6f, 0xc067, 0xef68, 0xef66, 0xef65,    BAD
},

/* Row 0x150 */
{
/* 00 */    BAD, 0xef67,    BAD, 0xc34f, 0xf1bc, 0xf1bd, 0xc350,    BAD,
/* 08 */ 0xf1bb,    BAD, 0xf3c3, 0xf3c2, 0xf3c5, 0xc447, 0xf3c4,    BAD,
/* 10 */ 0xf567, 0xf569, 0xf568,    BAD,    BAD, 0xf6a3, 0xf6a6, 0xf6a4,
/* 18 */ 0xf6a5, 0xf7a5, 0xc5bd,    BAD,    BAD,    BAD, 0xf854, 0xf855,
/* 20 */ 0xf856,    BAD, 0xc64b, 0xc663, 0xf9b6, 0xb0ab,    BAD, 0xbe78,
/* 28 */ 0xc069, 0xf1be,    BAD, 0xf7a6,    BAD,    BAD, 0xf9c4, 0xd44a,
/* 30 */    BAD, 0xc67b, 0xb0ac, 0xec72,    BAD, 0xf1bf,    BAD, 0xf3c6,
/* 38 */    BAD,    BAD, 0xf6a7, 0xf7a7, 0xb0ad,    BAD, 0xe4dd, 0xe4de
},

/* Row 0x151 */
{
/* 00 */    BAD, 0xbbed, 0xbbee, 0xe8d9, 0xbe7a, 0xbe79, 0xe8d8,    BAD,
/* 08 */ 0xef69,    BAD, 0xf1c0, 0xf1c2, 0xf1c1, 0xc353, 0xc352, 0xc351,
/* 10 */    BAD, 0xc55e, 0xf6a8,    BAD, 0xc55d, 0xf7a9, 0xf7a8,    BAD,
/* 18 */ 0xc64c, 0xf8d5, 0xb3bd, 0xe0ea,    BAD,    BAD,    BAD, 0xe4e1,
/* 20 */ 0xe4df, 0xe4e0,    BAD,    BAD, 0xe8e2,    BAD, 0xe8dd, 0xe8da,
/* 28 */ 0xe8e1,    BAD,    BAD,    BAD, 0xe8e3,    BAD,    BAD, 0xbe7c,
/* 30 */ 0xe8e0, 0xe8dc,    BAD,    BAD, 0xe8db, 0xe8df, 0xe8de, 0xbe7b,
/* 38 */    BAD,    BAD, 0xec7d, 0xec78, 0xec76, 0xeca1, 0xec77,    BAD
},

/* Row 0x152 */
{
/* 00 */ 0xec73,    BAD, 0xec79,    BAD,    BAD, 0xec74, 0xef72, 0xec75,
/* 08 */ 0xeca2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xec7c, 0xc06a, 0xec7b, 0xec7a,    BAD, 0xec7e,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xef6a, 0xef6d,    BAD,    BAD, 0xef6c,    BAD,
/* 20 */ 0xef74, 0xef6f, 0xef73,    BAD, 0xef71, 0xef70, 0xef6e,    BAD,
/* 28 */ 0xef6b,    BAD, 0xc243, 0xc242,    BAD, 0xc244, 0xc241, 0xef75,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf1c8, 0xf1cb,    BAD,
/* 38 */ 0xf1c9, 0xf1cd,    BAD,    BAD,    BAD, 0xf1ce,    BAD, 0xf1c6
},

/* Row 0x153 */
{
/* 00 */ 0xc358, 0xf1c7,    BAD, 0xf1c5, 0xf1cc,    BAD, 0xf1c4, 0xf1c3,
/* 08 */ 0xc357, 0xc355, 0xc354,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xf1ca, 0xf3cf, 0xf3d5, 0xc44a, 0xf3d0,
/* 18 */    BAD, 0xf3d3, 0xf3d7, 0xc44b, 0xf3d2,    BAD, 0xf3ca,    BAD,
/* 20 */ 0xf3c9, 0xf3d6, 0xf3cd,    BAD, 0xf3cb, 0xf3d4, 0xf3cc, 0xc449,
/* 28 */ 0xc448,    BAD, 0xf3c7, 0xf3c8, 0xf3d1,    BAD,    BAD,    BAD,
/* 30 */ 0xf3ce,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xf56c,
/* 38 */ 0xf56f,    BAD,    BAD,    BAD,    BAD, 0xc356,    BAD,    BAD
},

/* Row 0x154 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf56d, 0xf573, 0xf571,
/* 08 */ 0xf56b, 0xf576,    BAD, 0xf56a,    BAD, 0xc4cf, 0xf572,    BAD,
/* 10 */    BAD,    BAD, 0xf56e, 0xc4ce, 0xf575,    BAD,    BAD, 0xf574,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xf6ab, 0xf6aa,    BAD,    BAD,
/* 20 */    BAD, 0xf6b1,    BAD, 0xf6ad, 0xf6b0, 0xc560,    BAD,    BAD,
/* 28 */ 0xf6ae, 0xf6af,    BAD, 0xf6a9, 0xf6ac, 0xc55f,    BAD,    BAD,
/* 30 */    BAD, 0xc5bf, 0xf7b4, 0xf7af, 0xf7b3,    BAD, 0xf7b6, 0xf7b2,
/* 38 */    BAD, 0xf7ae,    BAD, 0xc5c1, 0xf7b1, 0xf7b5, 0xc5c0, 0xf7ac
},

/* Row 0x155 */
{
/* 00 */ 0xf570, 0xf7b0,    BAD,    BAD, 0xf7ad,    BAD, 0xf7aa,    BAD,
/* 08 */ 0xf7ab, 0xc5be, 0xf85a, 0xf85c, 0xf85f, 0xf85b, 0xf860,    BAD,
/* 10 */ 0xf859,    BAD, 0xf857,    BAD, 0xc5eb, 0xf85d, 0xc5ed, 0xc5ec,
/* 18 */ 0xf858, 0xf85e,    BAD,    BAD,    BAD,    BAD, 0xf8da, 0xc64d,
/* 20 */ 0xf8db,    BAD, 0xf8d9, 0xf8d6,    BAD,    BAD, 0xf8d8, 0xf8d7,
/* 28 */ 0xf95a,    BAD,    BAD,    BAD,    BAD, 0xf95c, 0xf95b,    BAD,
/* 30 */    BAD, 0xf979,    BAD, 0xf978, 0xf977, 0xf97a,    BAD, 0xc673,
/* 38 */ 0xc674, 0xf9ca, 0xf9ce,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x156 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb3be, 0xdcaf, 0xe0ed,
/* 28 */    BAD, 0xb9a7, 0xe0eb,    BAD,    BAD, 0xe0ec,    BAD,    BAD,
/* 30 */    BAD, 0xe4e2, 0xe4e3, 0xbbf1, 0xbbef, 0xe4e4, 0xbbf0, 0xe8e8,
/* 38 */    BAD, 0xe8eb, 0xe8e5, 0xe8ec, 0xe8e4, 0xe8e6,    BAD, 0xe8e7
},

/* Row 0x157 */
{
/* 00 */ 0xe8ea,    BAD,    BAD, 0xbea1, 0xe8ef, 0xe8ee, 0xbe7d, 0xe8e9,
/* 08 */ 0xe8ed, 0xbe7e,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xecac,    BAD, 0xc06f,    BAD, 0xeca7, 0xc06b,    BAD, 0xeca4,
/* 18 */ 0xecaa, 0xecad,    BAD, 0xc070,    BAD, 0xeca9, 0xeca6, 0xecae,
/* 20 */ 0xeca5,    BAD, 0xecab, 0xc06c,    BAD, 0xeca3, 0xc06d,    BAD,
/* 28 */ 0xc06e, 0xeca8,    BAD,    BAD,    BAD, 0xefa9, 0xef7a, 0xef7b,
/* 30 */ 0xef7e, 0xef7c,    BAD, 0xef76,    BAD,    BAD, 0xef79, 0xefa5,
/* 38 */ 0xef7d,    BAD,    BAD, 0xc245,    BAD, 0xefa7, 0xefa4, 0xc246
},

/* Row 0x158 */
{
/* 00 */ 0xefa6, 0xef77, 0xefa2, 0xefa3,    BAD, 0xefa1,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xf1d2, 0xf1d4, 0xf1d7,    BAD,    BAD, 0xf1d1,
/* 10 */    BAD, 0xc359, 0xf1d9, 0xf1d0, 0xf1da,    BAD, 0xf1d6, 0xf1d8,
/* 18 */ 0xf1dc, 0xf1d5, 0xf1dd, 0xf1d3, 0xf1cf, 0xc35a,    BAD, 0xf1db,
/* 20 */ 0xc35b, 0xc44d,    BAD,    BAD,    BAD,    BAD,    BAD, 0xef78,
/* 28 */ 0xf3f1, 0xf3e8, 0xc44f, 0xf3e4, 0xc450,    BAD,    BAD, 0xf3ed,
/* 30 */ 0xf3e7, 0xf3dd, 0xc44e, 0xf3ea, 0xf3e5, 0xf3e6,    BAD, 0xf3d8,
/* 38 */ 0xf3df, 0xf3ee,    BAD, 0xf3eb,    BAD, 0xf3e3,    BAD, 0xf3ef
},

/* Row 0x159 */
{
/* 00 */ 0xf3de, 0xf3d9, 0xf3ec,    BAD, 0xf3db, 0xf3e9, 0xf3e0, 0xf3f0,
/* 08 */ 0xf3dc, 0xc44c, 0xf3da, 0xf3e1, 0xf3e2,    BAD,    BAD,    BAD,
/* 10 */ 0xf57d,    BAD, 0xf57b,    BAD, 0xf5a2,    BAD, 0xf5ae, 0xf5a5,
/* 18 */ 0xf57c, 0xf578, 0xf5a7, 0xf57e, 0xf5a3, 0xf57a, 0xf5aa, 0xf577,
/* 20 */ 0xf5a1, 0xf5a6, 0xf5a8, 0xf5ab, 0xf579,    BAD, 0xf5af, 0xf5b0,
/* 28 */ 0xf5a9, 0xf5ad, 0xf5a4,    BAD, 0xf6c1, 0xf6c4,    BAD, 0xc561,
/* 30 */    BAD, 0xf6c3, 0xf6c8, 0xf6c6, 0xc562, 0xf6bd, 0xf6b3, 0xf6b2,
/* 38 */ 0xc564, 0xf6bf, 0xf6c0, 0xf6bc, 0xf6b4,    BAD, 0xf6b9, 0xf5ac
},

/* Row 0x15a */
{
/* 00 */    BAD, 0xf6b5, 0xc563, 0xf6bb,    BAD, 0xf6ba,    BAD, 0xf6b6,
/* 08 */ 0xf6c2,    BAD, 0xf6b7, 0xf7bb, 0xf6c5, 0xf6c7, 0xf6be, 0xf6b8,
/* 10 */ 0xf7bc, 0xf7be, 0xf7b8, 0xc5c2,    BAD, 0xf7c5, 0xf7c3, 0xc5c3,
/* 18 */ 0xf7c2, 0xf7c1, 0xf7ba, 0xf7b7, 0xf7bd, 0xf7c6, 0xf7b9, 0xf7bf,
/* 20 */    BAD, 0xf869, 0xf86e, 0xf864, 0xf867, 0xc5ee, 0xf86b,    BAD,
/* 28 */ 0xf872, 0xf7c0,    BAD, 0xf865, 0xf86f, 0xf873, 0xf86a, 0xf863,
/* 30 */ 0xf86d,    BAD, 0xf86c, 0xf871, 0xf870, 0xf7c4, 0xf868, 0xf862,
/* 38 */ 0xf866, 0xc64e, 0xc64f, 0xf861,    BAD, 0xf8e6, 0xf8dd, 0xf8e5
},

/* Row 0x15b */
{
/* 00 */ 0xf8e2, 0xf8e3, 0xf8dc, 0xf8df, 0xf8e7, 0xf8e1, 0xf8e0, 0xf8de,
/* 08 */    BAD, 0xf8e4,    BAD, 0xf95d,    BAD, 0xf95e,    BAD, 0xf960,
/* 10 */ 0xf95f, 0xf962, 0xf961, 0xf97c, 0xf97b, 0xf9b7,    BAD, 0xf9b8,
/* 18 */    BAD, 0xf9c5, 0xc678, 0xc67c,    BAD, 0xf9cf, 0xc67d,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x15c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb3bf,    BAD,    BAD,
/* 38 */    BAD, 0xc4d0, 0xf6c9,    BAD, 0xc650, 0xc651,    BAD, 0xb3c0
},

/* Row 0x15d */
{
/* 00 */ 0xe0ee,    BAD, 0xb9a8, 0xe8f0,    BAD,    BAD, 0xecb0, 0xecb1,
/* 08 */ 0xecaf, 0xefab, 0xefaa, 0xc247, 0xf1df, 0xefac, 0xf1de,    BAD,
/* 10 */    BAD, 0xf3f3, 0xc451, 0xc453, 0xf3f2,    BAD,    BAD, 0xc452,
/* 18 */    BAD, 0xf5b1, 0xf5b3, 0xf5b2, 0xf6ca, 0xc565,    BAD, 0xc5ef,
/* 20 */ 0xf8e8, 0xf963,    BAD,    BAD, 0xf9d2, 0xb3c1,    BAD, 0xe4e5,
/* 28 */    BAD, 0xbea2,    BAD,    BAD,    BAD, 0xecb3, 0xecb2,    BAD,
/* 30 */ 0xefad,    BAD,    BAD,    BAD, 0xc454, 0xc4d1, 0xf7c7, 0xf9cb,
/* 38 */    BAD,    BAD,    BAD, 0xb3c2, 0xbbf2,    BAD, 0xbea3,    BAD
},

/* Row 0x15e */
{
/* 00 */ 0xf3f4,    BAD, 0xf874, 0xb6c0,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xefae,    BAD,    BAD,    BAD, 0xc664, 0xb6c1, 0xbea4, 0xc248,
/* 10 */ 0xf875, 0xb6c2,    BAD, 0xe8f1, 0xc072, 0xecb4, 0xecb5,    BAD,
/* 18 */ 0xc071,    BAD, 0xefaf, 0xc24c, 0xc24a, 0xc24b, 0xc249, 0xf1e0,
/* 20 */ 0xc35c,    BAD,    BAD,    BAD, 0xf5b5, 0xf5b4, 0xf5b7, 0xf5b6,
/* 28 */ 0xc4d2,    BAD,    BAD, 0xf6cb,    BAD, 0xf6cd, 0xf6cc, 0xc566,
/* 30 */ 0xf7c8,    BAD, 0xf876, 0xf877, 0xc5f0, 0xf964, 0xf97d, 0xc675,
/* 38 */    BAD, 0xdcb0, 0xecb6, 0xefb0, 0xf3f5, 0xe0ef,    BAD, 0xefb1
},

/* Row 0x15f */
{
/* 00 */ 0xf1e2, 0xf1e1,    BAD,    BAD,    BAD,    BAD, 0xf878, 0xc652,
/* 08 */    BAD, 0xf965, 0xf97e,    BAD,    BAD,    BAD, 0xb9a9, 0xe8f2,
/* 10 */ 0xe8f3,    BAD, 0xecb7, 0xb9aa,    BAD, 0xc35d, 0xf1e3,    BAD,
/* 18 */ 0xf6cf, 0xc567, 0xf6d0, 0xf6ce, 0xf879,    BAD, 0xf8e9,    BAD,
/* 20 */ 0xb9ab,    BAD, 0xefb4, 0xefb3, 0xefb2, 0xf1e4,    BAD,    BAD,
/* 28 */ 0xf1e8, 0xf1e7, 0xf1e6, 0xf1e5, 0xc35e, 0xf3f6, 0xf5b9, 0xc4d3,
/* 30 */ 0xf5b8, 0xf6d1, 0xf7cb, 0xf7ca, 0xc5c4, 0xf7c9, 0xf87c, 0xf87b,
/* 38 */ 0xf87a,    BAD,    BAD, 0xbbf3,    BAD, 0xecb8, 0xc24d,    BAD
},

/* Row 0x160 */
{
/* 00 */ 0xf3f7, 0xf3f8, 0xf7cc, 0xf87d,    BAD,    BAD, 0xf8ea, 0xf966,
/* 08 */ 0xf9b9, 0xf9d4, 0xbbf4, 0xc24e, 0xf1e9, 0xf3f9, 0xf6d2, 0xf87e,
/* 10 */    BAD,    BAD, 0xbea6,    BAD, 0xefb5, 0xf1ea, 0xf3fa, 0xf3fb,
/* 18 */ 0xf3fc, 0xf5be,    BAD, 0xf5ba, 0xc568, 0xf5bd, 0xf5bc, 0xc4d4,
/* 20 */ 0xf5bb, 0xc4d6,    BAD, 0xc4d5, 0xf6d4, 0xf6d3, 0xc569, 0xc56a,
/* 28 */    BAD,    BAD, 0xc5c6, 0xf7cd, 0xc5c5,    BAD, 0xf8a3, 0xf8a4,
/* 30 */ 0xf8a2, 0xf8a1, 0xc654,    BAD, 0xf8eb, 0xf8ec, 0xf8ed, 0xc653,
/* 38 */ 0xf967, 0xf96a, 0xf969, 0xf968,    BAD,    BAD, 0xf9d3,    BAD
},

/* Row 0x161 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc073,    BAD,    BAD,
/* 10 */ 0xc365, 0xf5bf, 0xf6d5,    BAD, 0xc5c7, 0xf7ce,    BAD,    BAD,
/* 18 */ 0xf9d5,    BAD,    BAD,    BAD, 0xc074,    BAD,    BAD,    BAD,
/* 20 */ 0xefb6,    BAD, 0xf7cf,    BAD, 0xf9a1,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x162 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xa3c0, 0xa3c1, 0xa3c2, 0xa3c3, 0xa3c4, 0xa3c5, 0xa3c6,
/* 38 */ 0xa3c7, 0xa3c8, 0xa3c9, 0xa3ca, 0xa3cb, 0xa3cc, 0xa3cd, 0xa3ce
},

/* Row 0x163 */
{
/* 00 */ 0xa3cf, 0xa3d0, 0xa3d1, 0xa3d2, 0xa3d3, 0xa3d4, 0xa3d5, 0xa3d6,
/* 08 */ 0xa3d7, 0xa3d8, 0xa3d9, 0xa3da, 0xa3db, 0xa3dc, 0xa3dd, 0xa3de,
/* 10 */ 0xa3df, 0xa3e0, 0xa3e1, 0xa3e2, 0xa3e3, 0xa3e4, 0xa3e5, 0xa3e6,
/* 18 */ 0xa3e7, 0xa3e8, 0xa3e9, 0xa3ea, 0xa3eb, 0xa3ec, 0xa3ed, 0xa3ee,
/* 20 */ 0xa3ef, 0xa3f0, 0xa3f1, 0xa3f2, 0xa3f3, 0xa3f4, 0xa3f5, 0xa3f6,
/* 28 */ 0xa3f7, 0xa3f8, 0xa3f9, 0xa3fa, 0xa3fb, 0xa3fc, 0xa3fd, 0xa3fe,
/* 30 */ 0xc7fd, 0xc7fe, 0xc840, 0xc841, 0xc842, 0xc843, 0xc844, 0xc845,
/* 38 */ 0xc846, 0xc847, 0xc848, 0xc849, 0xc84a, 0xc84b, 0xc84c, 0xc84d
},

/* Row 0x164 */
{
/* 00 */ 0xc84e, 0xc84f, 0xc850, 0xc851, 0xc852, 0xc853, 0xc854, 0xc855,
/* 08 */ 0xc856, 0xc857, 0xc858, 0xc859, 0xc85a, 0xc85b, 0xc85c, 0xc85d,
/* 10 */ 0xc85e, 0xc85f, 0xc860, 0xc861, 0xc862, 0xc863, 0xc864, 0xc865,
/* 18 */ 0xc866, 0xc867, 0xc868, 0xc869, 0xc86a, 0xc86b, 0xc86c, 0xc86d,
/* 20 */ 0xc86e, 0xc86f, 0xc870, 0xc871, 0xc872, 0xc873, 0xc874, 0xc875,
/* 28 */ 0xc876, 0xc877, 0xc878, 0xc879, 0xc87a, 0xc87b, 0xc87c, 0xc87d,
/* 30 */ 0xc87e, 0xc8a1, 0xc8a2, 0xc8a3, 0xc8a4, 0xc8a5, 0xc8a6, 0xc8a7,
/* 38 */ 0xc8a8, 0xc8a9, 0xc8aa, 0xc8ab, 0xc8ac, 0xc8ad, 0xc8ae, 0xc8af
},

/* Row 0x165 */
{
/* 00 */ 0xc8b0, 0xc8b1, 0xc8b2, 0xc8b3, 0xc8b4, 0xc8b5, 0xc8b6, 0xc8b7,
/* 08 */ 0xc8b8, 0xc8b9, 0xc8ba, 0xc8bb, 0xc8bc, 0xc8bd, 0xc8be, 0xc8bf,
/* 10 */ 0xc8c0, 0xc8c1, 0xc8c2, 0xc8c3, 0xc8c4, 0xc8c5, 0xc8c6, 0xc8c7,
/* 18 */ 0xc8c8, 0xc8c9, 0xc8ca, 0xc8cb, 0xc8cc, 0xc8cd, 0xc8ce, 0xc8cf,
/* 20 */ 0xc8d0, 0xc8d1, 0xc8d2, 0xc8d3, 0xc8d4, 0xc8d5, 0xc8d6, 0xc8d7,
/* 28 */ 0xc8d8, 0xc8d9, 0xc8da, 0xc8db, 0xc8dc, 0xc8dd, 0xc8de, 0xc8df,
/* 30 */ 0xc8e0, 0xc8e1, 0xc8e2, 0xc8e3, 0xc8e4, 0xc8e5, 0xc8e6, 0xc8e7,
/* 38 */ 0xc8e8, 0xc8e9, 0xc8ea, 0xc8eb, 0xc8ec, 0xc8ed, 0xc8ee, 0xc8ef
},

/* Row 0x166 */
{
/* 00 */ 0xc8f0, 0xc8f1, 0xc8f2, 0xc8f3, 0xc8f4, 0xc8f5, 0xc8f6, 0xc8f7,
/* 08 */ 0xc8f8, 0xc8f9, 0xc8fa, 0xc8fb, 0xc8fc, 0xc8fd, 0xc8fe, 0xf9d6,
/* 10 */ 0xf9d7, 0xf9d8, 0xf9d9, 0xf9da, 0xf9db, 0xf9dc, 0xf9dd, 0xf9de,
/* 18 */ 0xf9df, 0xf9e0, 0xf9e1, 0xf9e2, 0xf9e3, 0xf9e4, 0xf9e5, 0xf9e6,
/* 20 */ 0xf9e7, 0xf9e8, 0xf9e9, 0xf9ea, 0xf9eb, 0xf9ec, 0xf9ed, 0xf9ee,
/* 28 */ 0xf9ef, 0xf9f0, 0xf9f1, 0xf9f2, 0xf9f3, 0xf9f4, 0xf9f5, 0xf9f6,
/* 30 */ 0xf9f7, 0xf9f8, 0xf9f9, 0xf9fa, 0xf9fb, 0xf9fc, 0xf9fd, 0xf9fe,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x167 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xa2ce, 0xa2cc, 0xa240, 0xa1fe, 0xa1c5, 0xa1c3, 0xa15a
},

/* Row 0x168 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xc94a, 0xddfc,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x169 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xa14a, 0xa157,    BAD, 0xa159, 0xa15b, 0xa15f, 0xa160, 0xa163,
/* 38 */ 0xa164, 0xa167, 0xa168, 0xa16b, 0xa16c, 0xa16f, 0xa170, 0xa173
},

/* Row 0x16a */
{
/* 00 */ 0xa174, 0xa177, 0xa178, 0xa17b, 0xa17c,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xa1c6, 0xa1c7, 0xa1ca, 0xa1cb, 0xa1c8, 0xa1c9, 0xa15c,
/* 10 */ 0xa14d,    BAD, 0xa14f,    BAD, 0xa151, 0xa152, 0xa153, 0xa154,
/* 18 */    BAD, 0xa17d, 0xa17e, 0xa1a1, 0xa1a2, 0xa1a3, 0xa1a4, 0xa1cc,
/* 20 */ 0xa1cd, 0xa1ce, 0xa1de, 0xa1df, 0xa1e0, 0xa1e1, 0xa1e2,    BAD,
/* 28 */    BAD, 0xa24c, 0xa24d, 0xa24e,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x16b */
{
/* 00 */    BAD, 0xa149,    BAD, 0xa1ad, 0xa243, 0xa248, 0xa1ae,    BAD,
/* 08 */ 0xa15d, 0xa15e, 0xa1af, 0xa1cf, 0xa141, 0xa1d0, 0xa144, 0xa241,
/* 10 */ 0xa2af, 0xa2b0, 0xa2b1, 0xa2b2, 0xa2b3, 0xa2b4, 0xa2b5, 0xa2b6,
/* 18 */ 0xa2b7, 0xa2b8, 0xa147, 0xa146, 0xa1d5, 0xa1d7, 0xa1d6, 0xa148,
/* 20 */ 0xa249, 0xa2cf, 0xa2d0, 0xa2d1, 0xa2d2, 0xa2d3, 0xa2d4, 0xa2d5,
/* 28 */ 0xa2d6, 0xa2d7, 0xa2d8, 0xa2d9, 0xa2da, 0xa2db, 0xa2dc, 0xa2dd,
/* 30 */ 0xa2de, 0xa2df, 0xa2e0, 0xa2e1, 0xa2e2, 0xa2e3, 0xa2e4, 0xa2e5,
/* 38 */ 0xa2e6, 0xa2e7, 0xa2e8,    BAD, 0xa242,    BAD,    BAD, 0xa1c4
},

/* Row 0x16c */
{
/* 00 */    BAD, 0xa2e9, 0xa2ea, 0xa2eb, 0xa2ec, 0xa2ed, 0xa2ee, 0xa2ef,
/* 08 */ 0xa2f0, 0xa2f1, 0xa2f2, 0xa2f3, 0xa2f4, 0xa2f5, 0xa2f6, 0xa2f7,
/* 10 */ 0xa2f8, 0xa2f9, 0xa2fa, 0xa2fb, 0xa2fc, 0xa2fd, 0xa2fe, 0xa340,
/* 18 */ 0xa341, 0xa342, 0xa343, 0xa161, 0xa155, 0xa162,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xa14e,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x16d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xa246, 0xa247,    BAD, 0xa244,    BAD, 0xa1b1,
/* 28 */ 0xc6d8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xa258, 0xa1d3,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa150,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x16e */
{
/* 00 */ 0x8859, 0x8857,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x885d, 0x885b, 0x8866,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x8861, 0x885f,    BAD,    BAD,    BAD, 0xa1d1,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x886a, 0x8868,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x886f, 0x886d, 0x88a7,    BAD, 0x8873, 0x8871,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8877, 0x8875,    BAD,    BAD,    BAD, 0xa1d2,
/* 38 */ 0xc8fb, 0x887b, 0x8879,    BAD, 0x88a2,    BAD,    BAD,    BAD
},

/* Row 0x16f */
{
/* 00 */ 0x8856, 0x8867,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x885a, 0x886c,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x885c, 0x886e,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8870,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x170 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xc8fc, 0x885e, 0x8874,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xc8fa,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8878,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x171 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8858, 0x8869,    BAD,
/* 10 */ 0x8872, 0x8860, 0x8876,    BAD, 0x887a,    BAD, 0x887c,    BAD,
/* 18 */ 0x887d,    BAD, 0x887e,    BAD, 0x88a1,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x172 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xc8f6, 0x886b,    BAD,    BAD, 0xc8f8,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xc8f7,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x88a8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xc8fe,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc8f9,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x173 */
{
/* 00 */    BAD,    BAD,    BAD, 0xc8f5,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xc8fd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x174 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc6d9, 0xa3be,
/* 08 */    BAD, 0xa3bc, 0xa3bd, 0xa3bf,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xa3bb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x175 */
{
/* 00 */ 0x0060, 0xa3bd, 0x005e,    BAD,    BAD, 0xa1c2,    BAD, 0xa3bb,
/* 08 */ 0xc6d8,    BAD,    BAD,    BAD, 0xa3be,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x005f,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x176 */
{
/* 00 */    BAD, 0xc7f9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xc7f3, 0xc7f4, 0xc7f5, 0xc7f6, 0xc7f7, 0xc7f8, 0xc7fa, 0xc7fb,
/* 18 */ 0xc7fc, 0xc7fd, 0xc7fe, 0xc840, 0xc841, 0xc842, 0xc843, 0xc844,
/* 20 */ 0xc845, 0xc846, 0xc847, 0xc848, 0xc849, 0xc84a, 0xc84b, 0xc84c,
/* 28 */ 0xc84d, 0xc84e, 0xc84f, 0xc850, 0xc851, 0xc852, 0xc853, 0xc854,
/* 30 */ 0xc855, 0xc856, 0xc857, 0xc858, 0xc859, 0xc85a, 0xc85c, 0xc85d,
/* 38 */ 0xc85e, 0xc85f, 0xc860, 0xc861, 0xc862, 0xc863, 0xc864, 0xc865
},

/* Row 0x177 */
{
/* 00 */ 0xc866, 0xc867, 0xc868, 0xc869, 0xc86a, 0xc86b, 0xc86c, 0xc86d,
/* 08 */ 0xc86e, 0xc86f, 0xc870, 0xc871, 0xc872, 0xc873, 0xc874, 0xc875,
/* 10 */    BAD, 0xc85b,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x178 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8863, 0x88a4
},

/* Row 0x179 */
{
/* 00 */ 0x8865, 0x88a6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x17a */
{
/* 00 */    BAD,    BAD,    BAD, 0xa24a,    BAD, 0xa1c1,    BAD,    BAD,
/* 08 */    BAD, 0xa24b,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc8d2,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xc8d3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x17b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xa2b9, 0xa2ba, 0xa2bb, 0xa2bc, 0xa2bd, 0xa2be, 0xa2bf, 0xa2c0,
/* 28 */ 0xa2c1, 0xa2c2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xc6b5, 0xc6b6, 0xc6b7, 0xc6b8, 0xc6b9, 0xc6ba, 0xc6bb, 0xc6bc,
/* 38 */ 0xc6bd, 0xc6be,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x17c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xa1f6, 0xa1f4, 0xa1f7, 0xa1f5,    BAD,    BAD, 0xa1f8, 0xa1f9,
/* 18 */ 0xa1fb, 0xa1fa,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xc877, 0xc878,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x17d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc876,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x17e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xc6a1, 0xc6a2, 0xc6a3, 0xc6a4, 0xc6a5, 0xc6a6, 0xc6a7, 0xc6a8,
/* 28 */ 0xc6a9, 0xc6aa,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xc6ab, 0xc6ac, 0xc6ad, 0xc6ae,
/* 38 */ 0xc6af, 0xc6b0, 0xc6b1, 0xc6b2, 0xc6b3, 0xc6b4,    BAD,    BAD
},

/* Row 0x17f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xf9f9, 0xf9f8, 0xf9e6, 0xf9ef, 0xf9dd, 0xf9e8, 0xf9f1, 0xf9df,
/* 18 */ 0xf9ec, 0xf9f5, 0xf9e3, 0xf9ee, 0xf9f7, 0xf9e5, 0xf9e9, 0xf9f2,
/* 20 */ 0xf9e0, 0xf9eb, 0xf9f4, 0xf9e2, 0xf9e7, 0xf9f0, 0xf9de, 0xf9ed,
/* 28 */ 0xf9f6, 0xf9e4, 0xf9ea, 0xf9f3, 0xf9e1, 0xf9fa, 0xf9fb, 0xf9fd,
/* 30 */ 0xf9fc, 0xa2ac, 0xa2ad, 0xa2ae,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x180 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc6e6,    BAD,    BAD
},

/* Row 0x181 */
{
/* 00 */ 0xc8d6,    BAD,    BAD,    BAD, 0xc8d7,    BAD, 0xc8d8, 0xc8d9,
/* 08 */ 0xc8da,    BAD, 0xc8db,    BAD, 0xc8dc, 0xc8dd,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc8de,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xc8df, 0xc8e0,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc8e1,    BAD, 0xc8e2,
/* 28 */    BAD,    BAD, 0xc8e3,    BAD, 0xc8e4,    BAD, 0xc8e5,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc8e6,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xc8e7,    BAD, 0xc8e8,    BAD
},

/* Row 0x182 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc8e9,    BAD,
/* 08 */    BAD,    BAD, 0xc8ea,    BAD, 0xc8eb, 0xc8ec,    BAD, 0xc8ed,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc8ee, 0xc8ef,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc8f0,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xc8f1,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x183 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xc6cd,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x184 */
{
/* 00 */ 0xa140, 0xa142, 0xa143, 0xa1b2,    BAD, 0xc6e0, 0xc6e1, 0xc6e2,
/* 08 */ 0xa171, 0xa172, 0xa16d, 0xa16e, 0xa175, 0xa176, 0xa179, 0xa17a,
/* 10 */ 0xa169, 0xa16a, 0xa245,    BAD, 0xa165, 0xa166,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa1a9, 0xa1aa,    BAD,
/* 20 */    BAD, 0xa2c3, 0xa2c4, 0xa2c5, 0xa2c6, 0xa2c7, 0xa2c8, 0xa2c9,
/* 28 */ 0xa2ca, 0xa2cb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x185 */
{
/* 00 */    BAD, 0xc6e7, 0xc6e8, 0xc6e9, 0xc6ea, 0xc6eb, 0xc6ec, 0xc6ed,
/* 08 */ 0xc6ee, 0xc6ef, 0xc6f0, 0xc6f1, 0xc6f2, 0xc6f3, 0xc6f4, 0xc6f5,
/* 10 */ 0xc6f6, 0xc6f7, 0xc6f8, 0xc6f9, 0xc6fa, 0xc6fb, 0xc6fc, 0xc6fd,
/* 18 */ 0xc6fe, 0xc740, 0xc741, 0xc742, 0xc743, 0xc744, 0xc745, 0xc746,
/* 20 */ 0xc747, 0xc748, 0xc749, 0xc74a, 0xc74b, 0xc74c, 0xc74d, 0xc74e,
/* 28 */ 0xc74f, 0xc750, 0xc751, 0xc752, 0xc753, 0xc754, 0xc755, 0xc756,
/* 30 */ 0xc757, 0xc758, 0xc759, 0xc75a, 0xc75b, 0xc75c, 0xc75d, 0xc75e,
/* 38 */ 0xc75f, 0xc760, 0xc761, 0xc762, 0xc763, 0xc764, 0xc765, 0xc766
},

/* Row 0x186 */
{
/* 00 */ 0xc767, 0xc768, 0xc769, 0xc76a, 0xc76b, 0xc76c, 0xc76d, 0xc76e,
/* 08 */ 0xc76f, 0xc770, 0xc771, 0xc772, 0xc773, 0xc774, 0xc775, 0xc776,
/* 10 */ 0xc777, 0xc778, 0xc779, 0xc77a,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xc8d4, 0xc8d5, 0xc8d4, 0xc8d5, 0xc6dc, 0xc6dd,    BAD,
/* 20 */    BAD, 0xc77b, 0xc77c, 0xc77d, 0xc77e, 0xc7a1, 0xc7a2, 0xc7a3,
/* 28 */ 0xc7a4, 0xc7a5, 0xc7a6, 0xc7a7, 0xc7a8, 0xc7a9, 0xc7aa, 0xc7ab,
/* 30 */ 0xc7ac, 0xc7ad, 0xc7ae, 0xc7af, 0xc7b0, 0xc7b1, 0xc7b2, 0xc7b3,
/* 38 */ 0xc7b4, 0xc7b5, 0xc7b6, 0xc7b7, 0xc7b8, 0xc7b9, 0xc7ba, 0xc7bb
},

/* Row 0x187 */
{
/* 00 */ 0xc7bc, 0xc7bd, 0xc7be, 0xc7bf, 0xc7c0, 0xc7c1, 0xc7c2, 0xc7c3,
/* 08 */ 0xc7c4, 0xc7c5, 0xc7c6, 0xc7c7, 0xc7c8, 0xc7c9, 0xc7ca, 0xc7cb,
/* 10 */ 0xc7cc, 0xc7cd, 0xc7ce, 0xc7cf, 0xc7d0, 0xc7d1, 0xc7d2, 0xc7d3,
/* 18 */ 0xc7d4, 0xc7d5, 0xc7d6, 0xc7d7, 0xc7d8, 0xc7d9, 0xc7da, 0xc7db,
/* 20 */ 0xc7dc, 0xc7dd, 0xc7de, 0xc7df, 0xc7e0, 0xc7e1, 0xc7e2, 0xc7e3,
/* 28 */ 0xc7e4, 0xc7e5, 0xc7e6, 0xc7e7, 0xc7e8, 0xc7e9, 0xc7ea, 0xc7eb,
/* 30 */ 0xc7ec, 0xc7ed, 0xc7ee, 0xc7ef, 0xc7f0, 0xc7f1, 0xc7f2,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xc6e3, 0xc6da, 0xc6db,    BAD
},

/* Row 0x188 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xc8d1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x189 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9277,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x18a */
{
/* 00 */ 0x96df,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x89d5,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x93cd,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x9bdf,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xfa68,    BAD,    BAD, 0x89da, 0x8f59,    BAD
},

/* Row 0x18b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x89db,    BAD,    BAD, 0x8f5d,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x89dc,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96f7,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x8ada,    BAD,    BAD,    BAD
},

/* Row 0x18c */
{
/* 00 */    BAD, 0x8bdc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x97db,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e53,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9daa,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x9bea,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x18d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a6e,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8bc8,    BAD
},

/* Row 0x18e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x89e8,    BAD, 0x89ea,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xfb70,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x89ed,    BAD,    BAD,
/* 30 */ 0x94dd,    BAD, 0x89ee,    BAD,    BAD,    BAD,    BAD, 0x9eb4,
/* 38 */ 0x8ad3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x18f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x92db,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x94db,
/* 18 */ 0x89f9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xfb7a,    BAD,    BAD,    BAD, 0x89fb,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9efc,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x89fc
},

/* Row 0x190 */
{
/* 00 */    BAD, 0x89bf,    BAD,    BAD,    BAD, 0x89fe,    BAD, 0x89e6,
/* 08 */    BAD,    BAD, 0x9d46,    BAD,    BAD,    BAD, 0x9dee,    BAD,
/* 10 */    BAD,    BAD, 0xa07e,    BAD,    BAD,    BAD, 0xa068,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x98e9,    BAD, 0x8b68,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x8dfd, 0x8bbe, 0x9fd9,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x8aeb,    BAD,    BAD, 0x9fd7,    BAD
},

/* Row 0x191 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x8b6a,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x9c5c,    BAD, 0x8bb1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xfb5e,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9df3,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0d0,    BAD,    BAD,
/* 38 */    BAD, 0xfc66,    BAD,    BAD,    BAD,    BAD, 0x92e9,    BAD
},

/* Row 0x192 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9aec,
/* 08 */ 0x8fab, 0xfa48,    BAD,    BAD,    BAD,    BAD, 0x8e45,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9c6f,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9ede,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x193 */
{
/* 00 */    BAD, 0x89ef,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x96e9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ebb,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x94de,    BAD, 0x9eb8,    BAD,    BAD,    BAD,
/* 30 */ 0x97ba, 0xfb65,    BAD,    BAD,    BAD, 0x95d6,    BAD,    BAD,
/* 38 */    BAD, 0x9cbb,    BAD,    BAD, 0x97da,    BAD,    BAD,    BAD
},

/* Row 0x194 */
{
/* 00 */    BAD, 0x8f45,    BAD, 0xfb7d, 0x9158, 0xfe64,    BAD, 0x9856,
/* 08 */ 0x9b4d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x935b, 0x95c7,    BAD, 0x97e7,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9359,    BAD,    BAD,
/* 20 */    BAD, 0x91f5, 0x97b8,    BAD,    BAD, 0xfda2, 0xfbb6,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x92fa,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x195 */
{
/* 00 */    BAD, 0x9357,    BAD, 0x8ba6,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xfbb9,    BAD, 0x97b0,    BAD,    BAD, 0xfdc4,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9ca1,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x91f2, 0x91f9,    BAD, 0x8ff1,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x9745, 0x9853,    BAD,    BAD,
/* 30 */ 0xfe78,    BAD, 0xfbc1, 0x9251,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9dad,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x196 */
{
/* 00 */ 0xfd6c,    BAD,    BAD, 0xfa6b,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x9bc2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a7b,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x197 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b60,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x934b,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x9abd,    BAD,    BAD,    BAD,    BAD, 0x91b7,    BAD
},

/* Row 0x198 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x95b4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xfec5,    BAD,    BAD, 0x9ef0,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x199 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8d64,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9269,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x8d67,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfbea,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfbef,    BAD,
/* 38 */ 0x8d68,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x19a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x93eb,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x19b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xfc42,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x19c */
{
/* 00 */    BAD,    BAD,    BAD, 0x9166,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xfacd,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x93dd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8bcc,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x19d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8d6d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8d6e,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96a8,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xfca6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8d6f
},

/* Row 0x19e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8d70,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xfc64,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x19f */
{
/* 00 */ 0x9060,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x8d74, 0x97c3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x8ad0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9274,    BAD, 0x9bbe,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9cc8,    BAD,    BAD, 0x9cba,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8d78,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1a0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9eb9,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x955a,    BAD,    BAD, 0x91b4,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x8a48,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8d7d,    BAD,    BAD, 0x8a7d,    BAD,    BAD, 0x8ac2,    BAD
},

/* Row 0x1a1 */
{
/* 00 */    BAD, 0xfd4a,    BAD, 0x8da1,    BAD,    BAD, 0x8ad1,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfcb4,
/* 18 */ 0x8b47,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x93a4, 0x9eda,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8a51,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1a2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x8da6,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x9ec5,    BAD,    BAD,    BAD,    BAD, 0xfcc4,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xa078,    BAD, 0x94b5,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfcc2, 0x8a6b,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1a3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8dab,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xfae8,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8dad,    BAD,    BAD
},

/* Row 0x1a4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfc49,    BAD,
/* 20 */ 0x93c1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x906f,    BAD, 0x8db0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x947e,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1a5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x90fa,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9479,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x8db2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xfcee,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x997b,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1a6 */
{
/* 00 */    BAD,    BAD, 0x8db4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x8db7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x91b3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x8dbb, 0x8dba,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x8dbc, 0x9044,    BAD,    BAD,    BAD
},

/* Row 0x1a7 */
{
/* 00 */ 0xfd4c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x93e4,    BAD,
/* 18 */    BAD, 0x93e0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xfd53,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x8dc3,    BAD, 0x9bb8,    BAD
},

/* Row 0x1a8 */
{
/* 00 */    BAD,    BAD, 0xfbf0,    BAD, 0x93e9,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x93f6,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8dc5,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x8dca,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8dcc, 0xfd5d, 0x93b5,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1a9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfd61,    BAD,    BAD,
/* 10 */    BAD, 0x9cf8,    BAD,    BAD,    BAD, 0x9252,    BAD,    BAD,
/* 18 */ 0xa0e8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1aa */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x9ca5,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ab */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x8dd6,    BAD, 0x97c0,    BAD,    BAD,
/* 10 */    BAD, 0xa0de,    BAD,    BAD,    BAD,    BAD, 0x97d2,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xfaa5,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xfda3,    BAD,    BAD,    BAD, 0x8ddb,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ac */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8eaf,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x91b5,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xfd49,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xfdd1,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ad */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8deb,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x97c6,    BAD, 0xfdce,    BAD,
/* 10 */    BAD, 0x90fc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfc59,
/* 20 */    BAD,    BAD, 0x96d6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x97c5, 0x8def,    BAD,    BAD,    BAD,    BAD, 0x97d7,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8df0,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x96a6,    BAD,    BAD
},

/* Row 0x1ae */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfbbf,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x8df3,    BAD,    BAD,    BAD,    BAD, 0x9449,
/* 10 */    BAD, 0x8df5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9872,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8e6b,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xfafd,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f50
},

/* Row 0x1af */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9dcc, 0xfc65,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x996e, 0x94a1,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8f63,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xa0da,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9253,
/* 28 */ 0xfde9,    BAD,    BAD, 0x9db5,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x9879,    BAD,    BAD,    BAD, 0x9d5d,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x8d63, 0x9669,    BAD,    BAD
},

/* Row 0x1b0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9f70,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1b1 */
{
/* 00 */ 0xfc6a,    BAD,    BAD, 0x8ac7,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x89d7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfe4d,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9edd,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1b2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xfefb, 0x98bc, 0xfacc,    BAD,    BAD, 0x95b0,    BAD,    BAD,
/* 30 */    BAD, 0x9464,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x936f,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x94b9
},

/* Row 0x1b3 */
{
/* 00 */    BAD,    BAD, 0x95ec,    BAD,    BAD,    BAD,    BAD, 0x91ee,
/* 08 */    BAD,    BAD, 0x98c3,    BAD, 0x95f6,    BAD,    BAD,    BAD,
/* 10 */ 0x8ffd, 0x98c5,    BAD,    BAD,    BAD,    BAD, 0x9766, 0xfe6e,
/* 18 */    BAD,    BAD, 0x97dd,    BAD,    BAD,    BAD, 0x92d2,    BAD,
/* 20 */    BAD, 0x9761, 0x98cb,    BAD,    BAD,    BAD,    BAD, 0x95f0,
/* 28 */    BAD, 0x975d,    BAD, 0x91e3,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x98cc,    BAD,    BAD, 0x9469, 0x98cd,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x98ce,    BAD, 0x95fc,    BAD,    BAD, 0x94a3
},

/* Row 0x1b4 */
{
/* 00 */ 0x9662,    BAD,    BAD,    BAD, 0xfeb6,    BAD, 0x9463,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x98d0,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1b5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x98d1,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x9475, 0xfae0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9472,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x98d6,    BAD,    BAD,    BAD
},

/* Row 0x1b6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8af0,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1b7 */
{
/* 00 */ 0x98d9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x98db,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x98dd,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x98a8,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a6d,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x8afb, 0x8aae,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1b8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xfbc9,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x98e4,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x98e6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1b9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x98e8,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8a4d,    BAD,    BAD,    BAD, 0x9257,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x95df,    BAD,    BAD, 0xa0ac,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x98eb,    BAD,    BAD,    BAD,    BAD, 0x98ec,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ba */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x98f4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x8ab8,    BAD,    BAD,    BAD, 0x9ee7
},

/* Row 0x1bb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x94bc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xfcd1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9cc6,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9e7e,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1bc */
{
/* 00 */    BAD,    BAD,    BAD, 0x98fe, 0xfde8,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9940,    BAD,    BAD,    BAD,    BAD, 0x94c9,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x94d3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1bd */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9946,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x90c0,    BAD, 0x94d1,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9573
},

/* Row 0x1be */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x93c2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x9948,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1bf */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x994b,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x8e55,    BAD,    BAD,    BAD,    BAD, 0x994e,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x8efe,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8e59,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x94ec,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1c0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x94ef,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1c1 */
{
/* 00 */ 0x8f74,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x9955,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9544,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9956,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1c2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x9959,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x995b,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfa45,    BAD,    BAD,
/* 38 */    BAD, 0x90b7,    BAD,    BAD, 0x9743,    BAD,    BAD,    BAD
},

/* Row 0x1c3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x95cd,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x97c9, 0xfd50,    BAD,    BAD,    BAD
},

/* Row 0x1c4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8eb9,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1c5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x95c6,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1c6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9967,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8ab9,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1c7 */
{
/* 00 */    BAD, 0x8dfc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x8a76,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9d51,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9973,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x9d4f,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1c8 */
{
/* 00 */    BAD, 0x997a, 0x9564,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x99a1,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x99a5,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x99a7,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1c9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8eed,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ca */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x99ad,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x946e,
/* 20 */ 0x8f70,    BAD, 0xfad0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x99b3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa053,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1cb */
{
/* 00 */ 0x965c,    BAD,    BAD,    BAD,    BAD, 0xfd7a,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x97fe,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x92bd,    BAD, 0x97fd,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x8f64,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xfcf7, 0x9562, 0x97cd, 0x9e64,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x924c,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1cc */
{
/* 00 */    BAD,    BAD,    BAD, 0x8ec9, 0x99bc,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9da5,    BAD, 0x8f54,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f7c,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ea2,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f7a,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x97ae,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x96c8,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x99c3,    BAD, 0x90d6,    BAD, 0x9cbe
},

/* Row 0x1cd */
{
/* 00 */    BAD,    BAD,    BAD, 0x8f76,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9470, 0xfb4b,    BAD,    BAD, 0xfdca,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x8ec7,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xa0f9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x8fa9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x99c7,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ce */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x90d7,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1cf */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9edf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1d0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x99ce,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fba,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8feb,    BAD, 0x99cf,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1d1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x8fc2,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x92c9,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1d2 */
{
/* 00 */ 0x97dc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1d3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x95b3,
/* 10 */ 0x9c79,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x95b2,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1d4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8fdb,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x9be3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1d5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e7a,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9bee,    BAD,    BAD,    BAD
},

/* Row 0x1d6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x99de,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfafa,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ee5,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1d7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a52,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x99e1,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8a67,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1d8 */
{
/* 00 */ 0x8bb5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x8aac,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x99e9,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1d9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfbca,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x97de,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1da */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x95d1,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x99f5, 0xfc4a,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1db */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x9ba9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfbdc,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfe56,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x9ea4,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9d49,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1dc */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x95db,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x89c5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x99f8,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9664,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9055,    BAD,    BAD, 0x96d4,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x977c,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x964d,    BAD, 0x97e1,    BAD
},

/* Row 0x1dd */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a48,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9a49,    BAD, 0xfe7d,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x90aa,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9a50,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x9347,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1de */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x8ed8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x90c9,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a55,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1df */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x90bc,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a58,    BAD, 0x8bb8,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1e0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x90d5,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9641,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9a5a,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a5c,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1e1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x97c2,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8abb,    BAD,    BAD,    BAD,
/* 38 */ 0x9baa,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1e2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x90f5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9a60,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9145
},

/* Row 0x1e3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9a63,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x8bb6,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfccf,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1e4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x966b,
/* 30 */ 0x9a6e,    BAD, 0x914f,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x9746,    BAD,    BAD, 0xa0e6,    BAD
},

/* Row 0x1e5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x92d7,    BAD,
/* 10 */ 0x9675,    BAD,    BAD, 0x93d4,    BAD,    BAD, 0x91bb, 0x9679,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a70,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9678, 0x91cd,    BAD
},

/* Row 0x1e6 */
{
/* 00 */ 0x9c4a,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1e7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xa06f,    BAD,    BAD, 0xa06a,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x915f,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x9fa5,    BAD,    BAD, 0x89ba,    BAD
},

/* Row 0x1e8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x9ecd,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a79,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9dce,    BAD,    BAD
},

/* Row 0x1e9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9d73,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96b9,    BAD,
/* 30 */ 0x96bc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9cd1,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ea */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x89b7,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9eee,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfb43,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1eb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9ec9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xfbd3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x91ae,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ec */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9d78,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9d7b,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x1ed */
{
/* 00 */ 0xa440, 0xa442,    BAD, 0xa443, 0x9eb3,    BAD,    BAD, 0xc945,
/* 08 */ 0xa456, 0xa454, 0xa457, 0xa455, 0xc946, 0xa4a3, 0xc94f, 0xc94d,
/* 10 */ 0xa4a2, 0xa4a1,    BAD,    BAD, 0xa542, 0xa541, 0xa540,    BAD,
/* 18 */ 0xa543, 0xa4fe, 0x9eb2,    BAD, 0x9dd6,    BAD, 0xa5e0, 0xa5e1,
/* 20 */    BAD, 0x994f,    BAD,    BAD, 0x89ce,    BAD, 0xa8c3,    BAD,
/* 28 */ 0x8bc0,    BAD, 0x9fc4, 0xa458, 0x8bd4, 0xa4a4, 0xc950,    BAD,
/* 30 */ 0xa4a5, 0xc963, 0xa6ea, 0xcbb1,    BAD,    BAD, 0xc6bf, 0x8bf9,
/* 38 */ 0xa459, 0xa4a6,    BAD, 0xa544, 0xc964, 0x8946,    BAD, 0xc6c0
},

/* Row 0x1ee */
{
/* 00 */    BAD,    BAD, 0xc940, 0xa444,    BAD, 0xa45b,    BAD, 0xc947,
/* 08 */ 0xa45c, 0xfae5,    BAD, 0xa4a7,    BAD, 0xa545, 0xa547, 0xa546,
/* 10 */    BAD,    BAD, 0xa5e2, 0xa5e3,    BAD,    BAD, 0xa8c4,    BAD,
/* 18 */ 0xadbc, 0xa441, 0xc87b, 0x8bc6, 0xc941, 0xa445, 0xa45e, 0xa45d,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0xa5e4, 0x9c57,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xa8c5,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x9afb,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb0ae, 0xd44b
},

/* Row 0x1ef */
{
/* 00 */ 0x89d0, 0x89cf, 0xb6c3, 0xdcb1, 0xdcb2, 0xc6c1, 0xa446, 0x89d1,
/* 08 */ 0xa4a9, 0x89e2,    BAD, 0xa8c6, 0xa447, 0xc948, 0xa45f,    BAD,
/* 10 */    BAD, 0xa4aa, 0xa4ac, 0xc951, 0xa4ad, 0xa4ab,    BAD,    BAD,
/* 18 */ 0x927e, 0xa5e5, 0x9dba, 0xa8c7,    BAD,    BAD, 0xa8c8, 0xab45,
/* 20 */ 0xc6c2, 0xa460, 0xa4ae,    BAD, 0xa5e6, 0xa5e8, 0xa5e7,    BAD,
/* 28 */ 0xa6eb,    BAD,    BAD, 0xa8c9, 0xa8ca, 0xab46, 0xab47,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xadbd,    BAD,    BAD, 0xdcb3, 0xfbf8,
/* 38 */    BAD, 0xf6d6, 0xa448, 0x8bc7, 0x926b,    BAD,    BAD, 0x89d2
},

/* Row 0x1f0 */
{
/* 00 */ 0xa4b0, 0xa4af, 0xc952, 0xa4b1, 0xa4b7,    BAD, 0xa4b2, 0xa4b3,
/* 08 */ 0xc954, 0xc953, 0xa4b5, 0xa4b6,    BAD, 0xa4b4, 0x9fcf,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xa54a, 0xa54b, 0xa54c, 0xa54d,
/* 18 */ 0xa549, 0xa550, 0xc96a,    BAD, 0xc966, 0xc969, 0xa551, 0xa561,
/* 20 */    BAD, 0xc968,    BAD, 0xa54e, 0xa54f, 0xa548,    BAD,    BAD,
/* 28 */ 0xc965, 0xc967, 0x9da9, 0x89d3,    BAD,    BAD, 0x99e2,    BAD,
/* 30 */ 0xa5f5, 0xc9b0, 0xa5f2, 0xa5f6, 0xc9ba, 0xc9ae, 0xa5f3, 0xc9b2,
/* 38 */ 0x9267,    BAD,    BAD, 0xa5f4,    BAD, 0xa5f7,    BAD, 0xa5e9
},

/* Row 0x1f1 */
{
/* 00 */ 0xc9b1, 0xa5f8, 0xc9b5, 0x92a4, 0xc9b9, 0xc9b6,    BAD,    BAD,
/* 08 */ 0xc9b3, 0xa5ea, 0xa5ec, 0xa5f9,    BAD, 0xa5ee, 0xc9ab, 0xa5f1,
/* 10 */ 0xa5ef, 0xa5f0, 0xc9bb, 0xc9b8, 0xc9af, 0xa5ed,    BAD,    BAD,
/* 18 */ 0xc9ac, 0xa5eb, 0x894e,    BAD,    BAD, 0xc9b4,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xc9b7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x894f, 0x9278,    BAD,    BAD, 0xc9ad, 0xca66,    BAD, 0xa742,
/* 30 */ 0xa6f4,    BAD, 0x91b6, 0xca67, 0xa6f1,    BAD, 0xa744, 0x89d4,
/* 38 */ 0xa6f9, 0x9fd2, 0xa6f8, 0xca5b, 0xa6fc, 0xa6f7, 0xca60, 0xca68
},

/* Row 0x1f2 */
{
/* 00 */    BAD, 0xca64, 0x92a7, 0xa6fa,    BAD, 0x95a2, 0xa6fd, 0xa6ee,
/* 08 */ 0xa747, 0xca5d,    BAD, 0x926e, 0xcbbd, 0xa6ec, 0xa743, 0xa6ed,
/* 10 */ 0xa6f5, 0xa6f6, 0xca62, 0xca5e, 0xa6fb, 0xa6f3, 0xca5a, 0xa6ef,
/* 18 */ 0xca65, 0xa745, 0xa748, 0xa6f2, 0xa740, 0xa746, 0xa6f0, 0xca63,
/* 20 */ 0xa741, 0xca69, 0xca5c, 0xa6fe, 0xca5f,    BAD,    BAD, 0xca61,
/* 28 */    BAD, 0xa8d8, 0xcbbf, 0xcbcb, 0xa8d0,    BAD, 0xcbcc, 0xa8cb,
/* 30 */ 0xa8d5,    BAD, 0x96ea, 0xa8ce, 0xcbb9, 0xa8d6, 0xcbb8, 0xcbbc,
/* 38 */ 0xcbc3, 0xcbc1, 0xa8de, 0xa8d9, 0xcbb3, 0xcbb5, 0xa8db, 0xa8cf
},

/* Row 0x1f3 */
{
/* 00 */ 0xcbb6, 0xcbc2, 0xcbc9, 0xa8d4, 0xcbbb, 0xcbb4, 0xa8d3, 0xcbb7,
/* 08 */ 0xa8d7, 0xcbba, 0x926f, 0xa8d2,    BAD, 0xa8cd,    BAD, 0xa8dc,
/* 10 */ 0xcbc4, 0xa8dd, 0xcbc8,    BAD, 0xcbc6, 0xcbca, 0xa8da, 0xcbbe,
/* 18 */ 0xcbb2,    BAD, 0xcbc0, 0xa8d1, 0xcbc5, 0xa8cc, 0xcbc7,    BAD,
/* 20 */    BAD,    BAD, 0x92a3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8950,    BAD,    BAD, 0xfa57,    BAD,    BAD, 0xab56, 0xab4a,
/* 30 */ 0x9866,    BAD, 0xcde0, 0xcde8,    BAD, 0xab49, 0xab51, 0xab5d,
/* 38 */    BAD, 0xcdee, 0xcdec, 0xcde7,    BAD, 0x89d6,    BAD, 0xab4b
},

/* Row 0x1f4 */
{
/* 00 */ 0xcded, 0xcde3, 0xab59, 0xab50, 0xab58, 0xcdde,    BAD, 0xcdea,
/* 08 */ 0x98b2, 0xcde1, 0xab54, 0xcde2, 0x92ab, 0xcddd, 0xab5b, 0xab4e,
/* 10 */ 0xab57, 0xab4d,    BAD, 0xcddf, 0xcde4,    BAD, 0xcdeb, 0xab55,
/* 18 */ 0xab52, 0xcde6, 0xab5a, 0xcde9, 0xcde5, 0xab4f, 0xab5c, 0xab53,
/* 20 */ 0xab4c, 0xab48,    BAD,    BAD, 0x96de, 0x92ac,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xcdef,    BAD, 0xadd7, 0xadc1,
/* 30 */    BAD, 0xadd1, 0x9f6e, 0xadd6, 0xd0d0, 0xd0cf, 0xd0d4, 0xd0d5,
/* 38 */ 0xadc4, 0x8ef2, 0xadcd,    BAD,    BAD, 0x9f6c, 0xadda,    BAD
},

/* Row 0x1f5 */
{
/* 00 */ 0xadce,    BAD,    BAD, 0x89d8,    BAD, 0xd0c9, 0xadc7, 0xd0ca,
/* 08 */ 0xfa59, 0xaddc,    BAD, 0xadd3, 0xadbe, 0xadbf, 0xd0dd, 0xb0bf,
/* 10 */    BAD, 0xadcc, 0xadcb, 0xd0cb, 0xadcf, 0xd45b, 0xadc6, 0xd0d6,
/* 18 */ 0xadd5, 0xadd4, 0xadca, 0xd0ce, 0xd0d7,    BAD, 0xd0c8, 0xadc9,
/* 20 */ 0xd0d8, 0xadd2, 0xd0cc, 0xadc0,    BAD, 0xadc3, 0xadc2, 0xd0d9,
/* 28 */ 0xadd0, 0xadc5, 0xadd9, 0xaddb, 0xd0d3, 0xadd8, 0x92a8, 0xd0db,
/* 30 */ 0xd0cd, 0xd0dc,    BAD, 0xd0d1, 0x9163, 0xd0da,    BAD, 0xd0d2,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xadc8,    BAD,    BAD,    BAD
},

/* Row 0x1f6 */
{
/* 00 */ 0xd463, 0xd457,    BAD, 0xb0b3,    BAD, 0xd45c, 0xd462, 0xb0b2,
/* 08 */ 0xd455, 0xb0b6, 0xd459, 0xd452, 0xb0b4, 0xd456, 0xb0b9, 0xb0be,
/* 10 */    BAD, 0xd467,    BAD, 0xd451,    BAD, 0xb0ba, 0x9f73, 0xd466,
/* 18 */ 0x92ad,    BAD, 0xb0b5, 0xd458, 0xb0b1, 0xd453, 0xd44f, 0xd45d,
/* 20 */ 0xd450, 0xd44e, 0xd45a, 0xd460, 0xd461, 0xb0b7, 0x9be9,    BAD,
/* 28 */ 0xd85b, 0xd45e, 0xd44d, 0xd45f, 0x92a9, 0xb0c1, 0xd464, 0xb0c0,
/* 30 */ 0xd44c,    BAD, 0xd454, 0xd465, 0xb0bc, 0xb0bb, 0xb0b8, 0xb0bd,
/* 38 */    BAD,    BAD, 0xb0af,    BAD,    BAD, 0xb0b0,    BAD,    BAD
},

/* Row 0x1f7 */
{
/* 00 */ 0xb3c8, 0x92aa, 0xd85e, 0xd857,    BAD, 0xb3c5,    BAD, 0xd85f,
/* 08 */ 0x89d9,    BAD,    BAD, 0xd855, 0xd858, 0xb3c4, 0xd859,    BAD,
/* 10 */ 0xfd56, 0xb3c7, 0xd85d,    BAD, 0xd853, 0xd852, 0xb3c9,    BAD,
/* 18 */ 0xb3ca, 0xb3c6, 0xb3cb, 0xd851, 0xd85c, 0xd85a, 0xd854,    BAD,
/* 20 */    BAD,    BAD, 0xb3c3, 0xd856,    BAD,    BAD, 0x9fa8,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xb6ca, 0xb6c4, 0xdcb7, 0xb6cd,
/* 30 */ 0xdcbd, 0xdcc0, 0xb6c6, 0xb6c7, 0xdcba, 0xb6c5, 0xdcc3, 0xb6cb,
/* 38 */ 0xdcc4,    BAD, 0xdcbf, 0xb6cc,    BAD, 0xdcb4, 0xb6c9, 0xdcb5
},

/* Row 0x1f8 */
{
/* 00 */    BAD, 0xdcbe, 0xdcbc,    BAD, 0xdcb8, 0xb6c8, 0xdcb6, 0xb6ce,
/* 08 */ 0xdcbb, 0xdcc2, 0xdcb9, 0xdcc1,    BAD, 0x92a1, 0xb9b6, 0xb9b3,
/* 10 */ 0x90e3, 0xb9b4,    BAD, 0xe0f9, 0xe0f1, 0xb9b2, 0xb9af, 0xe0f2,
/* 18 */    BAD, 0xa0a6, 0xb9b1, 0xe0f5,    BAD, 0xe0f7,    BAD, 0x94ab,
/* 20 */ 0xe0fe, 0xfc72,    BAD, 0xe0fd, 0xe0f8, 0xb9ae, 0xe0f0, 0xb9ac,
/* 28 */ 0xe0f3, 0xb9b7, 0xe0f6,    BAD, 0xe0fa, 0xb9b0, 0xb9ad, 0xe0fc,
/* 30 */ 0xe0fb, 0xb9b5,    BAD, 0xe0f4, 0x97c4, 0xbbf8, 0xe4ec,    BAD,
/* 38 */ 0xe4e9, 0xbbf9,    BAD, 0xbbf7, 0x92ae, 0xe4f0, 0xe4ed, 0xe4e6
},

/* Row 0x1f9 */
{
/* 00 */ 0xbbf6, 0xfa67, 0xbbfa, 0xe4e7, 0xbbf5, 0xbbfd, 0xe4ea, 0xe4eb,
/* 08 */ 0xbbfb, 0xbbfc, 0xe4f1, 0xe4ee, 0xe4ef, 0x92a2, 0xfa69,    BAD,
/* 10 */ 0xbeaa, 0xe8f8, 0xbea7, 0xe8f5, 0xbea9, 0xbeab,    BAD, 0xe8f6,
/* 18 */ 0xbea8,    BAD, 0xe8f7,    BAD, 0xe8f4,    BAD,    BAD, 0xc076,
/* 20 */ 0xecbd, 0xc077, 0xecbb,    BAD, 0xecbc, 0xecba, 0xecb9,    BAD,
/* 28 */    BAD, 0xecbe, 0xc075, 0x9268,    BAD, 0xefb8, 0xefb9,    BAD,
/* 30 */ 0xe4e8, 0xefb7, 0xc078, 0xc35f, 0xf1eb, 0xf1ec,    BAD, 0xc4d7,
/* 38 */ 0xc4d8, 0xf5c1, 0xf5c0, 0xc56c, 0xc56b, 0xf7d0,    BAD, 0xa449
},

/* Row 0x1fa */
{
/* 00 */ 0xa461, 0xa4b9,    BAD, 0xa4b8, 0xa553, 0xa552, 0xa5fc, 0xa5fb,
/* 08 */ 0xa5fd, 0xa5fa,    BAD, 0xa74a, 0xa749, 0xa74b,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xa8e0,    BAD, 0xa8df, 0xa8e1, 0x8951, 0xab5e,
/* 18 */    BAD, 0xa259, 0xd0de, 0xa25a, 0xb0c2, 0xa25c, 0xa25b, 0xd860,
/* 20 */ 0xfa6f, 0xa25d, 0xb9b8, 0xa25e,    BAD, 0xa44a,    BAD, 0xa4ba,
/* 28 */ 0xa5fe, 0xa8e2, 0xfa71, 0xa44b, 0xa4bd, 0xa4bb, 0xa4bc,    BAD,
/* 30 */    BAD, 0xa640,    BAD,    BAD, 0x8952, 0xa74c, 0xa8e4, 0xa8e3,
/* 38 */ 0xa8e5, 0x945a,    BAD,    BAD, 0xaddd,    BAD,    BAD,    BAD
},

/* Row 0x1fb */
{
/* 00 */ 0xbeac,    BAD, 0xc6c3,    BAD,    BAD,    BAD, 0x89dd, 0xc94e,
/* 08 */ 0xc8a2, 0xa554, 0xa555,    BAD,    BAD, 0xa641,    BAD, 0xca6a,
/* 10 */    BAD, 0xab60, 0xab5f, 0xd0e0, 0xd0df, 0xb0c3, 0xc6c4, 0xa4be,
/* 18 */ 0xc955,    BAD, 0x9e52,    BAD, 0x8953,    BAD, 0xcbcd,    BAD,
/* 20 */ 0xab61,    BAD, 0xade0,    BAD, 0xadde, 0xaddf,    BAD, 0x9e55,
/* 28 */ 0x92ba,    BAD, 0xbead, 0xc6c5, 0xa556,    BAD,    BAD,    BAD,
/* 30 */ 0xa642, 0xc9bc, 0xfa7d, 0xfaa8, 0x9a68, 0xfa47, 0xa74d, 0xa74e,
/* 38 */ 0xfa7e, 0xca6b,    BAD,    BAD, 0xcbce, 0xa8e6, 0xcbcf,    BAD
},

/* Row 0x1fc */
{
/* 00 */    BAD,    BAD,    BAD, 0x92bb, 0xd0e2, 0xd0e3, 0xade3, 0xfdb6,
/* 08 */ 0xd0e4, 0xfaa2, 0xd0e1, 0xade4, 0xade2, 0xade1, 0xd0e5, 0xfaa3,
/* 10 */ 0xd468, 0xfaa4, 0x9bb4, 0xfaa6, 0xd861,    BAD,    BAD, 0xdcc5,
/* 18 */ 0xe140,    BAD,    BAD, 0x89df, 0xbbfe, 0xbeae, 0xe8f9, 0xfddb,
/* 20 */ 0xa44c, 0xa45a, 0xfaa9,    BAD, 0x8954,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfaab,    BAD,    BAD,
/* 30 */ 0xb0c4, 0xb3cd,    BAD, 0xb9b9, 0xfc7a, 0xc942, 0xa4bf,    BAD,
/* 38 */ 0xa559, 0xa557, 0xa558,    BAD, 0x89e0, 0xa8e7, 0x9f4f,    BAD
},

/* Row 0x1fd */
{
/* 00 */ 0xa44d, 0xa44e, 0xc87d, 0xa462,    BAD, 0x89e1, 0xa4c0, 0xa4c1,
/* 08 */ 0xa4c2, 0xc9be, 0xa55a, 0xfab0, 0xc96b,    BAD, 0xa646,    BAD,
/* 10 */ 0xc9bf, 0xa644, 0xa645, 0xc9bd,    BAD,    BAD, 0xa647, 0xa643,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xca6c, 0xaaec, 0xca6d, 0x9fcd,
/* 20 */ 0xa0e7, 0xca6e,    BAD,    BAD, 0xa750, 0xa74f, 0xfab1, 0x89a6,
/* 28 */ 0xa753, 0xa751, 0xa752,    BAD,    BAD,    BAD, 0xa8ed,    BAD,
/* 30 */ 0xa8ec, 0xcbd4, 0xcbd1, 0xcbd2, 0x9efa, 0xcbd0, 0xa8ee, 0xa8ea,
/* 38 */ 0xa8e9,    BAD, 0xa8eb, 0xa8e8, 0xfab2,    BAD,    BAD,    BAD
},

/* Row 0x1fe */
{
/* 00 */    BAD, 0xa8ef,    BAD, 0xab63, 0xcdf0,    BAD, 0xcbd3, 0xab68,
/* 08 */    BAD, 0xcdf1, 0xab64, 0xab67, 0xab66, 0xab65, 0xab62,    BAD,
/* 10 */    BAD,    BAD, 0xd0e8,    BAD, 0xade7, 0xd0eb, 0xade5, 0xfab4,
/* 18 */    BAD, 0x92c4, 0xd0e7, 0xade8, 0xade6, 0xade9, 0xd0e9, 0xd0ea,
/* 20 */ 0x9f6f, 0xd0e6, 0xd0ec,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8bb0, 0xb3d1, 0xb0c5, 0xd469, 0xd46b, 0xd46a, 0xd46c, 0xb0c6,
/* 30 */    BAD,    BAD, 0xb3ce, 0x9fac, 0xb3cf, 0xb3d0,    BAD, 0xb6d0,
/* 38 */ 0xdcc7, 0x89e3, 0xdcc6, 0xdcc8, 0xdcc9, 0xb6d1,    BAD, 0xb6cf
},

/* Row 0x1ff */
{
/* 00 */ 0xe141, 0xe142, 0xb9bb, 0xb9ba, 0xe35a,    BAD,    BAD, 0xbc40,
/* 08 */ 0xbc41, 0xbc42, 0xbc44, 0xe4f2, 0xe4f3, 0xbc43,    BAD, 0x9bd3,
/* 10 */ 0x89e4, 0xbeaf,    BAD, 0xbeb0, 0xfab5,    BAD, 0xf1ed, 0xf5c3,
/* 18 */ 0xf5c2, 0xf7d1, 0x9fd5, 0xa44f,    BAD,    BAD,    BAD, 0xa55c,
/* 20 */ 0xa55b, 0x8955,    BAD, 0xa648, 0x92c5,    BAD, 0xc9c0,    BAD,
/* 28 */ 0x8956, 0xa755, 0xa756, 0xa754, 0xa757, 0xca6f, 0xca70,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfab3,    BAD,    BAD,
/* 38 */    BAD, 0xfab6,    BAD, 0xa8f1, 0xcbd5,    BAD, 0xa8f0,    BAD
},

/* Row 0x200 */
{
/* 00 */ 0xcdf2, 0xab6c, 0xcdf3, 0xab6b,    BAD, 0xfab7,    BAD, 0xab69,
/* 08 */    BAD, 0xab6a,    BAD,    BAD, 0x9edc, 0xd0ed,    BAD,    BAD,
/* 10 */ 0xfbc4, 0x9f71, 0xb0c7, 0xd46e,    BAD, 0xb0ca, 0xd46d, 0xb1e5,
/* 18 */ 0xb0c9, 0xb0c8,    BAD, 0xb3d4,    BAD, 0xb3d3, 0xb3d2, 0xb6d2,
/* 20 */ 0xfaba, 0x92c7, 0xb6d5, 0xb6d6, 0xb6d4,    BAD, 0xb6d3,    BAD,
/* 28 */    BAD, 0xe143,    BAD, 0xe144,    BAD,    BAD,    BAD, 0xe4f5,
/* 30 */ 0xbc45, 0xe4f4,    BAD, 0xbeb1, 0xecbf, 0xc079,    BAD, 0xf1ee,
/* 38 */ 0xc455, 0xc6c6, 0xa463, 0xa4c3, 0xc956,    BAD, 0xa4c4, 0xa4c5
},

/* Row 0x201 */
{
/* 00 */    BAD, 0x9a4c,    BAD,    BAD,    BAD, 0xa55d, 0xa55e,    BAD,
/* 08 */ 0xa649, 0xca71, 0xcbd6, 0xcbd7,    BAD, 0xab6d, 0xd0ee, 0xb0cc,
/* 10 */ 0xb0cb, 0xd863, 0xd862,    BAD,    BAD, 0xa450, 0xa4c6, 0xa55f,
/* 18 */    BAD, 0xb0cd, 0xc943,    BAD, 0xc96c, 0xa560,    BAD, 0xc9c2,
/* 20 */ 0xa64b, 0xa64a, 0xc9c1, 0xa758,    BAD,    BAD,    BAD, 0x89e5,
/* 28 */    BAD,    BAD, 0xadea,    BAD, 0x9f7d, 0xd46f,    BAD, 0xb6d7,
/* 30 */ 0xe145, 0xb9bc, 0xa0a9, 0xfac4, 0xe8fa,    BAD,    BAD, 0xf3fd,
/* 38 */ 0xc6c7, 0xa4c7,    BAD, 0x8957, 0xcbd8, 0xcdf4, 0xb0d0, 0xb0ce
},

/* Row 0x202 */
{
/* 00 */ 0xb0cf, 0xa451, 0xfaaa, 0xa464, 0xa2cd, 0xa4ca,    BAD, 0xa4c9,
/* 08 */ 0xa4c8, 0xa563, 0xa562,    BAD, 0xc96d, 0xc9c3, 0x8958,    BAD,
/* 10 */    BAD, 0xa8f5, 0xa8f2, 0xa8f4, 0xa8f3,    BAD,    BAD, 0xab6e,
/* 18 */    BAD,    BAD, 0xb3d5,    BAD, 0xa452, 0x8be3, 0xa4cb, 0x8b61,
/* 20 */ 0xa565, 0xa564,    BAD, 0xca72, 0x9af1,    BAD, 0xa8f6, 0x9eb7,
/* 28 */    BAD, 0xc6c8,    BAD,    BAD, 0xc957, 0xfad1, 0xa567, 0xa566,
/* 30 */ 0xa64c, 0xa64d, 0xca73, 0xa759, 0xfad2, 0xa75a,    BAD, 0xa8f7,
/* 38 */ 0xa8f8, 0xa8f9,    BAD, 0xab6f, 0xcdf5, 0x9eba, 0xfad4, 0xadeb
},

/* Row 0x203 */
{
/* 00 */    BAD,    BAD, 0xc944,    BAD, 0xa4cc,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xc9c4,    BAD,    BAD,    BAD, 0xca74, 0xca75,
/* 10 */    BAD,    BAD, 0xcbd9, 0xfad9, 0xcbda,    BAD, 0xcdf7, 0xcdf6,
/* 18 */ 0xcdf9, 0xcdf8, 0xab70,    BAD, 0xd470, 0xaded, 0xd0ef, 0xadec,
/* 20 */ 0xfadb,    BAD, 0x9ce0,    BAD, 0xd864, 0xb3d6, 0xfbf7, 0xd865,
/* 28 */ 0xfbfa, 0x89e7, 0xa07a, 0xfadc, 0xe146, 0xb9bd, 0xfadd,    BAD,
/* 30 */ 0x89e9,    BAD, 0xbc46,    BAD, 0xf1ef,    BAD, 0xc6c9,    BAD,
/* 38 */    BAD, 0xc958,    BAD, 0xa568,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x204 */
{
/* 00 */    BAD, 0xfae2, 0x89eb, 0xb0d1,    BAD, 0xfae3,    BAD,    BAD,
/* 08 */ 0xa453, 0xa465, 0xa4ce, 0xa4cd, 0x90c8, 0xa4cf,    BAD,    BAD,
/* 10 */ 0x92da, 0x8959, 0x9cf5,    BAD, 0xa8fb,    BAD, 0xa8fa, 0xa8fc,
/* 18 */ 0x895a, 0xfae7, 0x9fa2, 0xab71,    BAD,    BAD,    BAD, 0xadee,
/* 20 */ 0xfaea, 0xe8fb, 0xc24f, 0xa466, 0xa56a, 0xa579, 0xa574,    BAD,
/* 28 */ 0xa56f, 0xa56e, 0xa575, 0xa573, 0xa56c, 0xa57a, 0xa56d, 0xa569,
/* 30 */ 0xa578, 0xa577, 0xa576, 0xa56b,    BAD, 0xa572, 0xfaed, 0x8fad,
/* 38 */ 0xa571,    BAD,    BAD, 0xa57b, 0xa570,    BAD, 0xfb59,    BAD
},

/* Row 0x205 */
{
/* 00 */    BAD, 0xa653,    BAD, 0xa659, 0xa655,    BAD, 0xa65b, 0xc9c5,
/* 08 */ 0xa658, 0xa64e, 0xa651, 0xa654, 0xa650, 0xa657, 0xa65a, 0xa64f,
/* 10 */ 0xa652, 0xa656, 0xa65c, 0xfaef, 0x96ef,    BAD, 0x9dec,    BAD,
/* 18 */ 0xca7e, 0xca7b, 0x9dca, 0xa767, 0xca7c, 0xa75b, 0xa75d, 0xa775,
/* 20 */ 0xa770, 0xfd6d,    BAD, 0x89ec, 0xcaa5, 0xca7d, 0xa75f, 0xa761,
/* 28 */ 0xcaa4, 0xa768, 0xca78, 0xa774, 0xa776, 0xa75c, 0xa76d, 0xfb44,
/* 30 */ 0xca76, 0xa773, 0x9de2, 0xa764,    BAD, 0xa76e, 0xa76f, 0xca77,
/* 38 */ 0xa76c, 0xa76a,    BAD, 0xa76b, 0xa771, 0xcaa1, 0xa75e,    BAD
},

/* Row 0x206 */
{
/* 00 */ 0xa772, 0xcaa3, 0xa766, 0xa763,    BAD, 0xca7a, 0xa762, 0xcaa6,
/* 08 */ 0xa765,    BAD, 0xa769, 0x9ec0,    BAD, 0x9e56, 0xa760, 0xcaa2,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xca79,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xcbeb, 0xcbea, 0xa94f, 0xcbed, 0xcbef, 0xcbe4, 0xcbe7, 0xcbee,
/* 28 */ 0xa950, 0x9f79, 0x9ac7, 0xcbe1, 0xcbe5, 0xfaf4,    BAD, 0xcbe9,
/* 30 */ 0xce49, 0xa94b, 0xce4d, 0xa8fd, 0xcbe6, 0xa8fe, 0xa94c, 0xa945,
/* 38 */ 0xa941,    BAD, 0xcbe2, 0xa944, 0xa949, 0xa952, 0xcbe3, 0xcbdc
},

/* Row 0x207 */
{
/* 00 */ 0xa943, 0xcbdd, 0xcbdf,    BAD, 0xa946, 0x98a1, 0xa948, 0xcbdb,
/* 08 */ 0xcbe0,    BAD,    BAD, 0xa951, 0xa94d, 0xcbe8, 0xa953, 0xfaf8,
/* 10 */ 0xa94a, 0xcbde, 0xa947, 0x89f0, 0x9e47, 0xa942, 0xa940, 0x9df7,
/* 18 */ 0xcbec,    BAD, 0xa94e,    BAD, 0x9fd3,    BAD, 0x9aca,    BAD,
/* 20 */ 0xce48, 0xcdfb, 0xce4b, 0x89f1, 0xfaf9, 0xcdfd, 0xab78, 0xaba8,
/* 28 */ 0xab74, 0xaba7, 0xab7d, 0xaba4, 0xab72, 0xcdfc, 0xce43, 0xaba3,
/* 30 */ 0xce4f, 0xaba5, 0x8e5a, 0xab79, 0x89f2,    BAD, 0xce45, 0xce42,
/* 38 */ 0xab77, 0x89f3, 0xcdfa, 0xaba6, 0xce4a, 0xab7c, 0xce4c, 0xaba9
},

/* Row 0x208 */
{
/* 00 */ 0xab73, 0xab7e, 0xab7b, 0xce40, 0xaba1, 0xce46, 0xce47, 0xab7a,
/* 08 */ 0xaba2, 0xab76,    BAD, 0x925d, 0x8b51, 0x92e0, 0xab75, 0xcdfe,
/* 10 */ 0x89f4,    BAD,    BAD,    BAD,    BAD,    BAD, 0xce44,    BAD,
/* 18 */    BAD,    BAD, 0x9fd4,    BAD,    BAD,    BAD, 0xce4e,    BAD,
/* 20 */ 0xd144, 0xadfb, 0xd0f1, 0x8a79, 0xd0f6, 0xadf4, 0xae40, 0xd0f4,
/* 28 */ 0xadef, 0xadf9, 0xadfe, 0xd0fb,    BAD, 0xadfa, 0xadfd, 0x89f5,
/* 30 */    BAD, 0xd0fe, 0xadf5, 0xd0f5,    BAD,    BAD,    BAD, 0xd142,
/* 38 */ 0xd143,    BAD, 0xadf7, 0xd141, 0xadf3, 0xae43,    BAD, 0xd0f8
},

/* Row 0x209 */
{
/* 00 */    BAD, 0xadf1, 0x97a7, 0xd146, 0xd0f9, 0xd0fd, 0xadf6, 0xae42,
/* 08 */ 0xd0fa, 0xadfc, 0xd140, 0xd147, 0xd4a1, 0x93ba, 0xd145, 0xae44,
/* 10 */ 0xadf0, 0xd0fc, 0xd0f3, 0x9e58, 0xadf8,    BAD,    BAD, 0xd0f2,
/* 18 */ 0x89f6,    BAD, 0xd0f7,    BAD,    BAD,    BAD, 0x9e57,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x89f7,    BAD, 0x8a41, 0xd0f0, 0xae41,
/* 28 */ 0x89f8,    BAD, 0xd477, 0xfaf1, 0xb0e4, 0xd4a7, 0xb0e2, 0xb0df,
/* 30 */ 0xd47c, 0xb0db, 0xd4a2, 0xb0e6, 0xd476, 0xd47b, 0xd47a, 0xadf2,
/* 38 */ 0xb0e1, 0xd4a5,    BAD, 0xd4a8, 0xd473,    BAD, 0xb3e8, 0x89fa
},

/* Row 0x20a */
{
/* 00 */ 0xd4a9, 0xb0e7,    BAD, 0xb0d9, 0xb0d6, 0xd47e, 0xb0d3, 0xfb42,
/* 08 */ 0xd4a6, 0xfabf, 0xb0da, 0xd4aa,    BAD, 0xd474, 0xd4a4, 0xb0dd,
/* 10 */ 0xd475, 0xd478, 0xd47d, 0xfba3,    BAD, 0xb0de, 0xb0dc, 0xb0e8,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xb0e3, 0xfaf7, 0xb0d7, 0xb1d2,
/* 20 */    BAD, 0xb0d8, 0xd479, 0xb0e5, 0xb0e0, 0xd4a3, 0xb0d5,    BAD,
/* 28 */    BAD, 0x9e4e, 0xb0d4, 0x94dc,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x95da, 0x9df8, 0x9f6a,    BAD, 0xd471, 0xd472, 0xd86a,
/* 38 */    BAD, 0x8ab7,    BAD, 0xb3d7, 0xb3da, 0xd875, 0xb3ee, 0xd878
},

/* Row 0x20b */
{
/* 00 */ 0xb3d8, 0xd871, 0xb3de, 0xb3e4, 0xb5bd,    BAD, 0xfb46, 0xb3e2,
/* 08 */ 0xd86e, 0xb3ef, 0xb3db, 0xb3e3, 0xd876, 0xdcd7, 0xd87b, 0xd86f,
/* 10 */ 0x8a46, 0xd866, 0xd873, 0xd86d, 0xb3e1, 0xd879,    BAD,    BAD,
/* 18 */ 0xb3dd, 0xb3f1, 0xb3ea,    BAD, 0xb3df, 0xb3dc,    BAD, 0xb3e7,
/* 20 */    BAD, 0xd87a, 0xd86c, 0xd872, 0xd874, 0xd868, 0xd877, 0xb3d9,
/* 28 */ 0xd867, 0xfb47, 0xb3e0, 0xb3f0, 0xb3ec, 0xd869, 0xb3e6,    BAD,
/* 30 */ 0x9148, 0xb3ed, 0xb3e9, 0xb3e5, 0x92de, 0xd870,    BAD,    BAD,
/* 38 */    BAD, 0x8b53, 0x9df6, 0xb3eb, 0x9bda,    BAD,    BAD, 0xdcd5
},

/* Row 0x20c */
{
/* 00 */ 0xdcd1, 0x9d7e, 0xdce0, 0xdcca, 0xdcd3, 0xb6e5, 0xb6e6, 0xb6de,
/* 08 */ 0xdcdc, 0xb6e8, 0xdccf, 0xdcce, 0xdccc, 0xdcde, 0xb6dc, 0xdcd8,
/* 10 */ 0xdccd, 0xb6df, 0xdcd6, 0xb6da, 0xdcd2, 0xdcd9, 0xdcdb, 0x89fd,
/* 18 */ 0x99e4, 0xdcdf, 0xb6e3, 0xdccb, 0xb6dd, 0xdcd0, 0x9e43, 0xb6d8,
/* 20 */    BAD, 0xb6e4, 0xdcda, 0xb6e0, 0xb6e1, 0xb6e7, 0xb6db, 0xa25f,
/* 28 */ 0xb6d9, 0xdcd4, 0x9de9,    BAD, 0x8f52,    BAD,    BAD, 0xb6e2,
/* 30 */ 0x9df5, 0x9df0, 0xdcdd,    BAD,    BAD, 0x99e7, 0xb9cd, 0xb9c8,
/* 38 */    BAD, 0xe155, 0xe151, 0x8bbd, 0xe14b, 0xb9c2, 0xb9be, 0xe154
},

/* Row 0x20d */
{
/* 00 */ 0xb9bf, 0xe14e, 0xe150,    BAD, 0xe153, 0x9def, 0xb9c4,    BAD,
/* 08 */ 0xb9cb, 0xb9c5,    BAD,    BAD, 0xe149, 0xb9c6, 0xb9c7, 0xe14c,
/* 10 */ 0xb9cc, 0x9fb7, 0xe14a, 0xe14f, 0xb9c3, 0xe148, 0xb9c9, 0xb9c1,
/* 18 */    BAD,    BAD,    BAD, 0xb9c0, 0xe14d, 0xe152, 0x9dd0, 0xb9ca,
/* 20 */ 0x9feb, 0x8da9, 0x9dcf, 0x98e1,    BAD, 0x9de5,    BAD, 0xe147,
/* 28 */    BAD, 0xbc4d, 0xe547,    BAD, 0xe544, 0x9dc8, 0xbc47, 0xbc53,
/* 30 */ 0xbc54,    BAD, 0xbc4a, 0xe542, 0xbc4c, 0xe4f9, 0xbc52, 0xfb4f,
/* 38 */ 0xe546, 0xbc49, 0xe548, 0xbc48,    BAD, 0xe543, 0xe545, 0xbc4b
},

/* Row 0x20e */
{
/* 00 */ 0xe541, 0xe4fa, 0xe4f7, 0x9deb,    BAD, 0xd86b, 0xe4fd,    BAD,
/* 08 */ 0xe4f6, 0xe4fc, 0xe4fb,    BAD, 0xe4f8, 0xfb54, 0xbc4f, 0xfb55,
/* 10 */ 0x9aa2,    BAD, 0x8ad6, 0xbc4e, 0x9a5f,    BAD,    BAD, 0xbc50,
/* 18 */ 0xe4fe, 0xbeb2, 0xe540,    BAD,    BAD, 0x9ef5, 0xe945,    BAD,
/* 20 */ 0xe8fd, 0x8fb7, 0xbebe, 0xe942, 0xbeb6, 0xbeba, 0xe941,    BAD,
/* 28 */ 0xbeb9, 0xbeb5, 0xbeb8, 0xbeb3, 0xbebd, 0xe943, 0xe8fe, 0xbebc,
/* 30 */ 0xe8fc, 0xbebb, 0xe944, 0xe940, 0xbc51,    BAD, 0xbebf, 0xe946,
/* 38 */ 0xbeb7, 0xbeb4, 0x9ad2, 0x9e6a, 0x9ee8,    BAD, 0xecc6, 0xecc8
},

/* Row 0x20f */
{
/* 00 */ 0xc07b, 0xecc9, 0xecc7, 0xecc5, 0xecc4, 0xc07d, 0xecc3, 0xc07e,
/* 08 */    BAD, 0x8bbf, 0x91c2, 0x9d62, 0xecc1, 0xecc2, 0xc07a, 0xc0a1,
/* 10 */ 0xc07c,    BAD, 0x9260, 0xecc0,    BAD, 0xc250,    BAD, 0xefbc,
/* 18 */ 0xefba, 0xefbf, 0xefbd,    BAD, 0xefbb, 0xefbe, 0x925e, 0x91c1,
/* 20 */    BAD, 0x8ac5,    BAD,    BAD, 0x97a3, 0xc360, 0xf1f2, 0xf1f3,
/* 28 */ 0xc456,    BAD, 0xf1f4, 0xf1f0, 0xf1f5, 0xf1f1, 0xc251, 0x8b6c,
/* 30 */    BAD, 0x8d7e, 0xf3fe, 0xf441, 0xc459, 0xf440, 0xc458, 0xc457,
/* 38 */    BAD, 0x9c54,    BAD,    BAD, 0xc45a, 0xf5c5, 0xf5c6, 0x9dbd
},

/* Row 0x210 */
{
/* 00 */ 0xc4da, 0xc4d9, 0xc4db, 0xf5c4,    BAD, 0xf6d8, 0xf6d7,    BAD,
/* 08 */ 0xc56d, 0xc56f, 0xc56e, 0xf6d9, 0xc5c8, 0xf8a6,    BAD,    BAD,
/* 10 */    BAD, 0xc5f1,    BAD, 0xf8a5, 0xf8ee,    BAD, 0x9cc5, 0xc949,
/* 18 */    BAD,    BAD, 0xa57d, 0xa57c,    BAD, 0xa65f, 0xa65e, 0xc9c7,
/* 20 */ 0xa65d, 0xc9c6, 0x895b,    BAD, 0xa779, 0xcaa9,    BAD, 0xcaa8,
/* 28 */    BAD,    BAD, 0xa777, 0xa77a,    BAD, 0xfb5c, 0xcaa7, 0xfb5b,
/* 30 */ 0xa778, 0xfb57,    BAD,    BAD,    BAD,    BAD,    BAD, 0xcbf0,
/* 38 */    BAD, 0xcbf1, 0xa954,    BAD,    BAD, 0x98c7,    BAD, 0xabaa
},

/* Row 0x211 */
{
/* 00 */ 0xfb5a, 0xd148, 0xd149, 0xae45, 0xae46,    BAD,    BAD, 0xd4ac,
/* 08 */ 0xb0e9, 0xb0eb, 0xd4ab, 0xb0ea, 0xd87c, 0xb3f2,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xb6e9, 0xb6ea, 0xdce1, 0x9cee, 0xb9cf,    BAD,
/* 18 */ 0xb9ce,    BAD, 0xe549, 0xe948, 0xe947, 0x92e2, 0xf96b, 0xa467,
/* 20 */ 0xc959,    BAD, 0xc96e, 0xc96f,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xa662, 0xa666, 0xc9c9,    BAD, 0xa664, 0xa663, 0xc9c8, 0xa665,
/* 30 */ 0xa661,    BAD, 0x94a7, 0xa660, 0xc9ca,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xa7a6,    BAD,    BAD, 0xa7a3, 0x9bd4
},

/* Row 0x212 */
{
/* 00 */ 0xa77d, 0xcaaa, 0xfb64, 0xfb76,    BAD, 0xcaab, 0xfb60, 0xa7a1,
/* 08 */    BAD, 0xcaad, 0xa77b, 0xcaae, 0xcaac, 0xa77e, 0xa7a2, 0xa7a5,
/* 10 */ 0xa7a4, 0xa77c, 0xcaaf,    BAD, 0x99e5,    BAD,    BAD, 0x9ac2,
/* 18 */    BAD,    BAD,    BAD, 0x91fb,    BAD,    BAD,    BAD, 0xa073,
/* 20 */    BAD, 0xa959, 0xcbfe,    BAD, 0xa95b,    BAD, 0xa95a, 0x9f72,
/* 28 */ 0xcc40, 0xa958, 0xa957, 0xcbf5,    BAD, 0xcbf4,    BAD, 0xcbf2,
/* 30 */ 0xcbf7, 0xcbf6, 0xcbf3, 0xcbfc, 0xcbfd, 0xcbfa, 0xcbf8, 0xa956,
/* 38 */    BAD,    BAD, 0x9fcc, 0xcbfb, 0xa95c, 0xcc41, 0x98a5, 0x92e8
},

/* Row 0x213 */
{
/* 00 */ 0xcbf9,    BAD, 0xabab, 0xa955,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9bbc,    BAD, 0x96f3, 0xabac, 0xce54, 0x92e7,    BAD, 0xce5a,
/* 10 */ 0xfc67,    BAD,    BAD, 0xabb2, 0xce58, 0xce5e,    BAD, 0xce55,
/* 18 */ 0xce59, 0xce5b, 0xce5d, 0xce57, 0x8b7d, 0xce56, 0xce51, 0xce52,
/* 20 */ 0xabad, 0x9bf4, 0xabaf, 0xabae, 0xce53, 0xce5c,    BAD, 0x9ef7,
/* 28 */    BAD,    BAD, 0x9ec1,    BAD,    BAD,    BAD, 0xabb1,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x996f, 0xce50, 0xd153,    BAD,
/* 38 */ 0xd152, 0xd157, 0xd14e, 0x96f1, 0xd151, 0xd150, 0x8e41, 0xd154
},

/* Row 0x214 */
{
/* 00 */    BAD, 0xd158, 0xae47, 0xae4a, 0x954a,    BAD, 0xd14f, 0xd155,
/* 08 */ 0x97e6,    BAD,    BAD, 0xae49, 0xd14a,    BAD, 0xabb0, 0xd4ba,
/* 10 */ 0xd156,    BAD, 0xd14d,    BAD, 0xae48, 0xd14c,    BAD, 0x96f5,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xd4b1, 0x92e6, 0x9f42, 0xb0ec,
/* 20 */ 0xb0f0, 0xd4c1, 0xd4af, 0xd4bd, 0xb0f1, 0xd4bf, 0xfb67, 0xd4c5,
/* 28 */    BAD, 0xd4c9,    BAD,    BAD, 0xd4c0, 0xd4b4, 0xd4bc, 0x99a9,
/* 30 */ 0xd4ca, 0xd4c8, 0xd4be, 0xd4b9, 0xd4b2, 0xd8a6, 0xd4b0, 0xb0f5,
/* 38 */ 0xd4b7, 0xb0f6, 0xb0f2, 0xd4ad, 0xd4c3, 0xd4b5, 0xfae6,    BAD
},

/* Row 0x215 */
{
/* 00 */ 0xd4b3, 0xd4c6, 0xb0f3, 0xfb69, 0xd4cc, 0xb0ed, 0xb0ef, 0xd4bb,
/* 08 */ 0xd4b6, 0xae4b, 0xb0ee, 0xd4b8, 0xd4c7, 0xd4cb, 0xd4c2,    BAD,
/* 10 */ 0xd4c4,    BAD, 0x97e5,    BAD, 0xd4ae,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xd8a1,    BAD, 0xd8aa, 0xd8a9, 0xb3fa, 0xd8a2,    BAD,
/* 20 */ 0xb3fb, 0xb3f9, 0x967d, 0xd8a4, 0xb3f6, 0xd8a8, 0xfb6c, 0xd8a3,
/* 28 */ 0xd8a5, 0xd87d, 0xb3f4,    BAD, 0xd8b2, 0xd8b1, 0xd8ae, 0xb3f3,
/* 30 */ 0xb3f7, 0xb3f8, 0xd14b, 0xd8ab, 0xb3f5, 0xb0f4, 0xd8ad, 0xd87e,
/* 38 */ 0xd8b0, 0xd8af, 0x99a2, 0xd8b3,    BAD, 0xdcef,    BAD, 0xd8ac
},

/* Row 0x216 */
{
/* 00 */ 0x9abb,    BAD,    BAD,    BAD, 0x9a65,    BAD,    BAD, 0x944e,
/* 08 */ 0xd8a7, 0xdce7, 0xb6f4, 0xb6f7, 0xb6f2, 0xdce6, 0xdcea, 0xdce5,
/* 10 */    BAD, 0xb6ec, 0xb6f6, 0xdce2, 0xb6f0, 0xdce9,    BAD, 0xb6ee,
/* 18 */ 0xb6ed, 0xdcec, 0xb6ef, 0xdcee, 0xfb6e, 0xdceb, 0xb6eb, 0x99df,
/* 20 */    BAD,    BAD, 0xb6f5, 0xdcf0, 0xdce4, 0xdced,    BAD,    BAD,
/* 28 */ 0xdce3, 0x98e3,    BAD, 0xb6f1, 0x9254, 0xb6f3,    BAD, 0xdce8,
/* 30 */    BAD, 0xdcf1, 0x967b, 0x8aaf, 0xe15d, 0xb9d0, 0xe163,    BAD,
/* 38 */    BAD, 0xb9d5, 0xe15f, 0xe166, 0xe157, 0xb9d7, 0xb9d1, 0xe15c
},

/* Row 0x217 */
{
/* 00 */ 0xbc55, 0xe15b, 0xe164, 0xb9d2,    BAD, 0xb9d6, 0xe15a, 0xe160,
/* 08 */ 0xe165, 0xe156, 0xb9d4, 0xe15e,    BAD,    BAD, 0xe162, 0xe168,
/* 10 */ 0xe158, 0xe161,    BAD, 0xb9d3, 0xe167,    BAD,    BAD,    BAD,
/* 18 */ 0xe159, 0x8baf, 0x9ebd,    BAD, 0xbc59, 0xe54b, 0xbc57, 0xbc56,
/* 20 */ 0xe54d, 0xe552,    BAD, 0xe54e,    BAD, 0xe551, 0xbc5c, 0x9ee6,
/* 28 */ 0xbea5, 0xbc5b, 0xfb6f, 0xe54a, 0xe550,    BAD, 0xbc5a, 0xe54f,
/* 30 */ 0x8ee1, 0xe54c,    BAD, 0xbc58,    BAD, 0x9b7d, 0x9c7e,    BAD,
/* 38 */    BAD,    BAD, 0xe94d, 0xf9d9, 0xe94f, 0xe94a, 0xbec1, 0xe94c
},

/* Row 0x218 */
{
/* 00 */    BAD, 0xbec0, 0xe94e,    BAD,    BAD, 0xbec3, 0xe950, 0xbec2,
/* 08 */ 0xe949, 0xe94b,    BAD, 0x92ea,    BAD,    BAD, 0xc0a5, 0xeccc,
/* 10 */    BAD, 0xc0a4, 0xeccd, 0xc0a3, 0xeccb, 0xc0a2, 0xecca,    BAD,
/* 18 */ 0xc253, 0xc252, 0xf1f6, 0xf1f8, 0xfb72, 0xf1f7, 0xc361, 0xc362,
/* 20 */ 0xfb71,    BAD, 0xc363, 0xf442, 0xc45b,    BAD,    BAD, 0xf7d3,
/* 28 */ 0xf7d2, 0xc5f2,    BAD, 0xa468, 0xa4d0,    BAD,    BAD, 0xa7a7,
/* 30 */ 0x895c,    BAD, 0x98f0, 0x96f2, 0xce5f,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xb3fc, 0xb3fd, 0xfb74, 0xdcf2, 0xb9d8, 0xe169, 0xe553
},

/* Row 0x219 */
{
/* 00 */    BAD,    BAD, 0x8bc1, 0xc95a, 0x895d, 0x89de, 0xcab0, 0x895e,
/* 08 */    BAD,    BAD, 0xc6ca,    BAD, 0xcc42, 0xce60, 0xd159, 0xae4c,
/* 10 */    BAD, 0xfe42, 0xf1f9,    BAD, 0xc4dc, 0xa469, 0xa57e, 0xc970,
/* 18 */    BAD, 0xa667, 0xa668,    BAD, 0xa95d,    BAD,    BAD, 0xfb7b,
/* 20 */ 0xb0f7,    BAD, 0xb9da,    BAD, 0xb9db, 0xb9d9,    BAD, 0xa46a,
/* 28 */    BAD, 0xa4d1, 0xa4d3, 0xa4d2, 0xc95b, 0xa4d4, 0xa5a1, 0xc971,
/* 30 */    BAD, 0xa5a2, 0x895f,    BAD, 0x8960,    BAD,    BAD, 0xa669,
/* 38 */ 0xa66a,    BAD,    BAD,    BAD, 0xc9cb,    BAD, 0xa7a8,    BAD
},

/* Row 0x21a */
{
/* 00 */ 0xcab1,    BAD,    BAD,    BAD, 0xa961, 0xcc43,    BAD, 0xa95f,
/* 08 */ 0xa960, 0xa95e, 0xd15a,    BAD,    BAD,    BAD, 0xabb6, 0xabb5,
/* 10 */ 0xabb7, 0xabb4,    BAD, 0xce61, 0xa962, 0xabb3,    BAD, 0xae4d,
/* 18 */ 0xae4e,    BAD, 0xae4f,    BAD, 0xd4cd,    BAD,    BAD,    BAD,
/* 20 */ 0xb3fe, 0xd8b4, 0xb0f8,    BAD,    BAD, 0x9bcd,    BAD, 0xb6f8,
/* 28 */    BAD, 0xb9dd, 0xb9dc, 0xe16a,    BAD, 0xbc5d, 0xbec4,    BAD,
/* 30 */ 0xefc0, 0xf6da, 0xf7d4, 0xa46b, 0xa5a3, 0x9dd3, 0xa5a4, 0xc9d1,
/* 38 */ 0xa66c, 0xa66f,    BAD, 0xc9cf, 0xc9cd, 0xa66e, 0xc9d0, 0xc9d2
},

/* Row 0x21b */
{
/* 00 */ 0xc9cc, 0xa671, 0xa670, 0xa66d, 0xa66b, 0xc9ce,    BAD,    BAD,
/* 08 */    BAD, 0x984c, 0xa7b3,    BAD,    BAD, 0xa7b0, 0xcab6, 0xcab9,
/* 10 */ 0xcab8,    BAD, 0xa7aa, 0xa7b2, 0x9752,    BAD, 0xa7af, 0xcab5,
/* 18 */ 0xcab3, 0xa7ae, 0x95c3,    BAD,    BAD, 0xa7a9, 0xa7ac, 0x9bb6,
/* 20 */ 0xcab4, 0xcabb, 0xcab7, 0xa7ad, 0xa7b1, 0xa7b4, 0xcab2, 0xcaba,
/* 28 */ 0xa7ab,    BAD,    BAD,    BAD, 0x9ab9,    BAD, 0xa967, 0xa96f,
/* 30 */ 0x97b3, 0xcc4f, 0xcc48, 0xa970, 0xcc53, 0xcc44, 0xcc4b, 0x9f74,
/* 38 */ 0x92f1, 0xa966, 0xcc45, 0xa964, 0xcc4c, 0xcc50, 0xa963,    BAD
},

/* Row 0x21c */
{
/* 00 */ 0xcc51, 0xcc4a,    BAD, 0xcc4d, 0x97df, 0xa972, 0xa969, 0xcc54,
/* 08 */ 0xcc52, 0xfba6, 0xa96e, 0xa96c, 0xcc49, 0xa96b, 0xcc47, 0xcc46,
/* 10 */ 0xa96a, 0xa968, 0xa971, 0xa96d, 0xa965,    BAD, 0xcc4e,    BAD,
/* 18 */ 0xabb9, 0xfbab, 0xabc0, 0xce6f, 0xabb8, 0xce67, 0xce63,    BAD,
/* 20 */ 0xce73, 0xce62,    BAD, 0xabbb, 0xce6c, 0xabbe, 0xabc1,    BAD,
/* 28 */ 0xabbc, 0xce70, 0xabbf, 0x9877, 0xae56, 0xce76, 0xce64, 0x9854,
/* 30 */ 0x95c5, 0xce66, 0xce6d, 0xce71, 0xce75, 0xce72, 0xce6b, 0xce6e,
/* 38 */ 0x9d55, 0xfbb2, 0xce68, 0xabc3, 0xce6a, 0xce69, 0xce74, 0xabba
},

/* Row 0x21d */
{
/* 00 */ 0xce65, 0xabc2, 0x957e, 0xabbd,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xae5c, 0xd162, 0x9742, 0xae5b, 0x94e6,    BAD, 0xd160,
/* 10 */    BAD, 0xae50, 0x92f5, 0xae55,    BAD, 0xd15f, 0xd15c, 0xd161,
/* 18 */ 0xae51, 0xd15b,    BAD, 0xae54, 0xae52,    BAD, 0xd163, 0xae53,
/* 20 */ 0xae57, 0x92fd,    BAD, 0xae58, 0xfba2, 0xae5a,    BAD, 0x9c51,
/* 28 */    BAD, 0xae59, 0x94e9, 0x985c, 0x92f0, 0xd15d, 0xd15e,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xd164,    BAD, 0xd4d4, 0xb0f9, 0xd8c2,
/* 38 */ 0xd4d3, 0xd4e6,    BAD,    BAD, 0xb140, 0x944c, 0xd4e4,    BAD
},

/* Row 0x21e */
{
/* 00 */ 0xb0fe, 0xb0fa, 0xd4ed, 0xd4dd, 0xd4e0, 0x916b, 0xb143, 0xd4ea,
/* 08 */ 0xd4e2, 0xb0fb, 0xb144,    BAD, 0xd4e7, 0xd4e5,    BAD,    BAD,
/* 10 */ 0xd4d6, 0xd4eb, 0xd4df, 0xd4da, 0x8b78, 0xd4d0, 0xd4ec, 0xd4dc,
/* 18 */ 0xd4cf, 0x94e2, 0xb142, 0xd4e1, 0xd4ee, 0xd4de, 0xd4d2, 0xd4d7,
/* 20 */ 0xd4ce, 0x984f, 0xb141, 0xfbb5, 0xd4db, 0xd4d8, 0xb0fc, 0xd4d1,
/* 28 */ 0x9271, 0xd4e9, 0xb0fd, 0x9365, 0xd4d9, 0xd4d5, 0x985b,    BAD,
/* 30 */ 0xd4e8, 0x9850,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb440,
/* 38 */ 0xd8bb, 0x97bc, 0xd8b8, 0xd8c9, 0xd8bd, 0xd8ca, 0x92f3, 0xb442
},

/* Row 0x21f */
{
/* 00 */    BAD, 0x9340, 0x984d, 0xd8c6, 0xd8c3,    BAD, 0x9572,    BAD,
/* 08 */ 0xfdef,    BAD, 0xd8c4, 0xd8c7, 0xd8cb,    BAD, 0xd4e3, 0xd8cd,
/* 10 */ 0xdd47, 0xfdc1, 0xb443, 0xd8ce, 0xd8b6, 0xd8c0, 0xfbba, 0xd8c5,
/* 18 */    BAD, 0x92eb, 0xb441, 0xb444, 0xd8cc, 0xd8cf, 0xd8ba, 0xd8b7,
/* 20 */ 0xfc73, 0x97b7, 0xd8b9,    BAD,    BAD, 0xd8be, 0xd8bc, 0xb445,
/* 28 */    BAD, 0xd8c8,    BAD, 0xfbb4, 0xd8bf,    BAD, 0xd8c1, 0xd8b5,
/* 30 */ 0xdcfa, 0xdcf8, 0xb742, 0xb740, 0xdd43, 0xdcf9, 0xdd44, 0xdd40,
/* 38 */ 0xdcf7, 0xdd46, 0xdcf6, 0xdcfd, 0xb6fe, 0xb6fd, 0xb6fc, 0xdcfb
},

/* Row 0x220 */
{
/* 00 */ 0xdd41, 0xb6f9, 0xb741, 0x90a7, 0xdcf4,    BAD, 0xdcfe, 0xdcf3,
/* 08 */ 0xdcfc, 0xb6fa, 0xdd42, 0xdcf5, 0xb6fb, 0xdd45, 0x9741, 0x92f4,
/* 10 */    BAD,    BAD,    BAD, 0xfbbc,    BAD, 0xe16e, 0xb9e2, 0xb9e1,
/* 18 */ 0xb9e3, 0xe17a, 0xe170, 0xe176, 0xe16b, 0xe179, 0xe178, 0xe17c,
/* 20 */ 0xe175, 0xb9de, 0xe174, 0xb9e4, 0x9577, 0xe16d, 0xb9df,    BAD,
/* 28 */ 0xe17b, 0xb9e0, 0xe16f, 0xe172, 0xe177, 0xe171, 0xe16c,    BAD,
/* 30 */ 0x9ee2,    BAD, 0x8f78, 0xe173, 0xe555, 0xbc61, 0xe558, 0xe557,
/* 38 */ 0xe55a, 0xe55c, 0xf9dc, 0xbc5f,    BAD, 0xe556, 0x9672, 0xe554
},

/* Row 0x221 */
{
/* 00 */    BAD, 0xe55d, 0xe55b, 0xe559,    BAD, 0xe55f,    BAD, 0xe55e,
/* 08 */ 0xbc63, 0xbc5e,    BAD, 0xbc60, 0xbc62, 0x9eb5,    BAD, 0xe560,
/* 10 */ 0xe957, 0x964b,    BAD, 0xe956, 0xe955,    BAD, 0xe958, 0xe951,
/* 18 */    BAD, 0xe952, 0xe95a, 0xe953,    BAD, 0xbec5, 0xe95c, 0xa0fa,
/* 20 */ 0xe95b, 0xe954,    BAD, 0xecd1, 0xc0a8, 0xeccf, 0xecd4, 0xecd3,
/* 28 */ 0xe959,    BAD, 0xc0a7, 0x9575, 0xecd2, 0xecce, 0xecd6, 0xecd5,
/* 30 */ 0xc0a6,    BAD, 0xecd0,    BAD, 0xbec6,    BAD,    BAD,    BAD,
/* 38 */ 0xc254,    BAD,    BAD,    BAD, 0xefc1, 0xf1fa, 0xf1fb, 0xf1fc
},

/* Row 0x222 */
{
/* 00 */ 0xc45c, 0x90da,    BAD, 0xc45d, 0x9367, 0xf443, 0xfea4, 0xf5c8,
/* 08 */ 0xf5c7,    BAD, 0x90df, 0xf6db, 0xf6dc, 0xf7d5, 0xf8a7, 0x9354,
/* 10 */ 0xa46c, 0xa46d,    BAD, 0xa46e, 0xa4d5, 0xa5a5, 0xc9d3, 0xa672,
/* 18 */ 0xa673,    BAD, 0xa7b7, 0xa7b8, 0xa7b6, 0xa7b5,    BAD, 0xa973,
/* 20 */    BAD,    BAD, 0xcc55, 0xa975, 0xa974, 0xcc56, 0x8961,    BAD,
/* 28 */ 0x8bb4, 0xabc4,    BAD, 0xae5d, 0xd165, 0x9dc0, 0xd4f0,    BAD,
/* 30 */ 0xb145, 0xb447, 0xd4ef, 0xb446, 0x8e48, 0xb9e5, 0xfbc5, 0xe17d,
/* 38 */ 0xbec7,    BAD, 0xc0a9, 0xecd7, 0xfbc7, 0xc45e,    BAD, 0xc570
},

/* Row 0x223 */
{
/* 00 */ 0xc6cb, 0xc972, 0xfa79, 0xa5a6, 0xc973, 0xa676,    BAD, 0xa674,
/* 08 */ 0xa675, 0xa677,    BAD, 0xa7ba, 0xa7b9,    BAD, 0xcabc, 0xa7bb,
/* 10 */ 0x9e67,    BAD, 0xcabd, 0xcc57,    BAD, 0xcc58,    BAD, 0xa976,
/* 18 */ 0xa978, 0xa97a, 0xa977, 0xa97b, 0xa979, 0xfbd2, 0x8962, 0x8963,
/* 20 */    BAD,    BAD, 0xabc8, 0xabc5, 0xabc7, 0xabc9, 0xabc6, 0xd166,
/* 28 */ 0xce77,    BAD, 0xfc7d,    BAD, 0xd168, 0xd167, 0xae63,    BAD,
/* 30 */ 0xae5f,    BAD,    BAD, 0xae60, 0xae62, 0xae64, 0xae61,    BAD,
/* 38 */ 0xae66, 0xae65,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb14a
},

/* Row 0x224 */
{
/* 00 */ 0xd4f2, 0xd4f1, 0xb149, 0x9f6b, 0xb148, 0xb147, 0xb14b, 0xb146,
/* 08 */    BAD,    BAD, 0xd8d5, 0xd8d2, 0xb449, 0xd8d1, 0xd8d6,    BAD,
/* 10 */ 0xb44b, 0xd8d4, 0xb448, 0xb44a, 0xd8d3, 0xfbcc, 0xdd48, 0xfeae,
/* 18 */ 0xdd49, 0xdd4a,    BAD,    BAD,    BAD,    BAD, 0xb9e6, 0xb9ee,
/* 20 */ 0xe17e, 0xb9e8, 0xb9ec, 0xe1a1, 0xb9ed, 0xb9e9, 0xb9ea, 0xb9e7,
/* 28 */ 0xb9eb, 0xbc66, 0xd8d0, 0xbc67, 0xbc65,    BAD, 0xbc64, 0xe95d,
/* 30 */ 0xbec8, 0xecd8, 0xecd9, 0xfbd1,    BAD, 0xc364, 0xc45f,    BAD,
/* 38 */ 0xa46f,    BAD, 0xa678,    BAD,    BAD,    BAD,    BAD, 0xfb75
},

/* Row 0x225 */
{
/* 00 */    BAD, 0xabca,    BAD, 0xd169, 0xae67, 0xfbd4,    BAD, 0xb14e,
/* 08 */ 0xb14d, 0xb14c, 0xb44c, 0xb44d, 0xd8d7, 0xb9ef, 0xbec9, 0xa470,
/* 10 */ 0xc95c, 0xa4d6, 0xc974, 0xfbd6, 0xfbd8, 0xc9d4, 0xa679,    BAD,
/* 18 */    BAD,    BAD, 0xa97c,    BAD, 0x8b5d,    BAD, 0x934c, 0xdd4b,
/* 20 */ 0x9ae2,    BAD, 0xa471, 0x8bc9, 0xa4d7, 0xc9d5,    BAD,    BAD,
/* 28 */ 0xcabe,    BAD, 0xcabf,    BAD, 0xa7bc,    BAD,    BAD,    BAD,
/* 30 */ 0xd8d8, 0xb44e,    BAD, 0xdd4c,    BAD,    BAD,    BAD, 0xc0aa,
/* 38 */ 0xa472, 0xa4a8, 0xa4d8, 0xc975, 0xa5a7,    BAD, 0xa7c0, 0xa7bf
},

/* Row 0x226 */
{
/* 00 */ 0xa7bd, 0xa7be,    BAD,    BAD, 0xcc59, 0xa97e, 0xa9a1, 0xcc5a,
/* 08 */ 0xa97d, 0xfbdb, 0x9fc9, 0xabce, 0xce78, 0xabcd, 0xabcb, 0xabcc,
/* 10 */ 0xae6a, 0xae68,    BAD, 0x9f44, 0xd16b, 0xae69, 0xd16a,    BAD,
/* 18 */ 0xae5e, 0xd4f3,    BAD,    BAD, 0xb150, 0xb151, 0x98ed,    BAD,
/* 20 */ 0xb14f,    BAD, 0xb9f0, 0xe1a2, 0xbc68, 0xbc69,    BAD, 0xe561,
/* 28 */ 0xc0ab, 0xefc2, 0xefc3,    BAD, 0xc4dd, 0xf8a8, 0xc94b, 0xa4d9,
/* 30 */    BAD, 0xa473,    BAD, 0xc977, 0xc976,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xa67a, 0xc9d7, 0xc9d8, 0xc9d6,    BAD, 0xc9d9,    BAD
},

/* Row 0x227 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfbdd, 0xcac7,    BAD,
/* 08 */ 0xcac2, 0xcac4, 0xcac6, 0xcac3, 0xa7c4, 0xcac0,    BAD, 0xcac1,
/* 10 */ 0xa7c1, 0xa7c2, 0xcac5, 0xcac8, 0xa7c3, 0xcac9,    BAD,    BAD,
/* 18 */    BAD, 0x8df2, 0x8964,    BAD, 0xfdf2, 0xcc68, 0x934d, 0xcc62,
/* 20 */ 0xcc5d, 0xa9a3, 0xcc65, 0xcc63, 0xcc5c, 0xcc69, 0xcc6c, 0xcc67,
/* 28 */ 0xcc60, 0xa9a5, 0xcc66, 0xa9a6, 0xcc61, 0xcc64, 0xcc5b, 0xcc5f,
/* 30 */ 0xcc6b, 0xa9a7,    BAD, 0xa9a8,    BAD, 0xcc5e, 0xcc6a, 0xa9a2,
/* 38 */ 0xa9a4,    BAD, 0xfbe7,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x228 */
{
/* 00 */    BAD, 0xa0f2, 0x9868,    BAD,    BAD,    BAD, 0xceab, 0xcea4,
/* 08 */ 0xceaa, 0xcea3, 0xcea5, 0xce7d, 0xce7b,    BAD, 0xceac, 0xcea9,
/* 10 */ 0xce79, 0x9f58, 0xabd0, 0xcea7, 0xcea8,    BAD, 0xcea6, 0xce7c,
/* 18 */ 0xce7a, 0xabcf, 0xcea2, 0xce7e,    BAD,    BAD, 0xcea1, 0xcead,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8d73,    BAD,    BAD,
/* 28 */ 0xae6f, 0xfbde, 0xae6e,    BAD, 0xd16c, 0xae6b, 0xd16e, 0xfbdf,
/* 30 */ 0xae70, 0xd16f,    BAD,    BAD, 0xae73,    BAD, 0xae71, 0xd170,
/* 38 */ 0xceae, 0xd172,    BAD, 0xae6d,    BAD, 0xae6c,    BAD, 0xd16d
},

/* Row 0x229 */
{
/* 00 */ 0xd171, 0xae72,    BAD,    BAD,    BAD,    BAD, 0xb153, 0xb152,
/* 08 */    BAD,    BAD,    BAD, 0xd4f5, 0xd4f9, 0xd4fb, 0xb154, 0xd4fe,
/* 10 */ 0xfbe3, 0xb158, 0xd541,    BAD, 0xb15a, 0x8da8, 0xb156, 0xb15e,
/* 18 */ 0xfbe4, 0xb15b, 0xd4f7, 0xb155,    BAD, 0xd4f6, 0xd4f4, 0xd543,
/* 20 */ 0xd4f8,    BAD, 0xb157, 0xd542, 0xb15c, 0xd4fd, 0xd4fc, 0xb15d,
/* 28 */ 0xd4fa, 0xb159,    BAD,    BAD, 0x9c75,    BAD, 0xd544, 0x9878,
/* 30 */ 0xd540, 0xd8e7, 0xd8ee, 0xd8e3, 0xb451, 0xd8df, 0xd8ef, 0xd8d9,
/* 38 */ 0xd8ec, 0xd8ea, 0xd8e4,    BAD, 0xd8ed, 0xd8e6, 0x8d60, 0xd8de
},

/* Row 0x22a */
{
/* 00 */ 0xd8f0, 0xd8dc, 0xd8e9, 0xd8da,    BAD, 0xd8f1, 0xfbe5, 0xb452,
/* 08 */ 0x8d61, 0xd8eb, 0xdd4f, 0xd8dd, 0xb44f,    BAD, 0xd8e1,    BAD,
/* 10 */ 0xb450, 0xd8e0, 0xd8e5,    BAD,    BAD, 0xd8e2, 0x8d62, 0xa0a1,
/* 18 */    BAD, 0xd8e8,    BAD, 0x9c40,    BAD,    BAD, 0xdd53,    BAD,
/* 20 */    BAD,    BAD, 0xdd56, 0xdd4e,    BAD, 0xdd50,    BAD, 0xdd55,
/* 28 */ 0xdd54, 0xb743,    BAD, 0xd8db, 0xdd52,    BAD,    BAD, 0xb744,
/* 30 */ 0x98ad, 0xdd4d, 0xdd51,    BAD, 0x9eea,    BAD,    BAD, 0xe1a9,
/* 38 */    BAD, 0xe1b0, 0xe1a7,    BAD, 0xe1ae, 0xe1a5, 0xe1ad, 0xe1b1
},

/* Row 0x22b */
{
/* 00 */ 0xe1a4, 0xe1a8, 0xe1a3,    BAD, 0xb9f1, 0x9ceb, 0xe1a6, 0xb9f2,
/* 08 */ 0xe1ac, 0xe1ab, 0xe1aa, 0xfbe0,    BAD, 0xe1af, 0x9f51,    BAD,
/* 10 */    BAD,    BAD, 0xe565, 0xe567, 0xbc6b, 0xe568,    BAD, 0xe563,
/* 18 */    BAD, 0xe562, 0xe56c,    BAD, 0xe56a, 0xbc6a, 0xe56d, 0xe564,
/* 20 */ 0xe569, 0xe56b, 0xe566,    BAD, 0x8d65,    BAD,    BAD, 0xe961,
/* 28 */ 0xe966, 0xe960, 0xe965, 0x9cf1, 0xe95e, 0xe968, 0xe964, 0xe969,
/* 30 */ 0xe963, 0xe95f, 0xe967,    BAD, 0xe96a, 0xe962, 0xfc58, 0xecda,
/* 38 */ 0xc0af, 0x8d66, 0xc0ad,    BAD, 0xc0ac, 0xc0ae,    BAD,    BAD
},

/* Row 0x22c */
{
/* 00 */ 0xefc4, 0x9654, 0xf172, 0xf1fd,    BAD,    BAD, 0xf444, 0xf445,
/* 08 */    BAD, 0xc460,    BAD, 0xf5c9,    BAD, 0xc4de,    BAD, 0xf5ca,
/* 10 */    BAD, 0xf6de, 0xc572,    BAD, 0xc571, 0xf6dd, 0xc5c9, 0xfbe8,
/* 18 */ 0xf7d6,    BAD,    BAD, 0xc6cc,    BAD, 0xa474, 0xa67b, 0xc9da,
/* 20 */ 0xcaca, 0xa8b5, 0xb15f,    BAD,    BAD, 0xa475, 0xa5aa, 0xa5a9,
/* 28 */ 0xa5a8,    BAD,    BAD, 0xa7c5,    BAD,    BAD, 0xae74,    BAD,
/* 30 */ 0xdd57, 0xa476, 0xa477, 0xa478, 0xa4da, 0x9fce,    BAD, 0xabd1,
/* 38 */    BAD, 0xceaf,    BAD,    BAD,    BAD, 0xb453, 0xa479, 0xc95d
},

/* Row 0x22d */
{
/* 00 */    BAD,    BAD, 0xa5ab, 0xa5ac, 0xc978,    BAD, 0xa67c,    BAD,
/* 08 */    BAD, 0xfbfc, 0xcacb, 0x9ae4, 0xa7c6,    BAD, 0xcacc,    BAD,
/* 10 */    BAD, 0xa9ae, 0x9f75,    BAD, 0xcc6e, 0xa9ac, 0xa9ab, 0xcc6d,
/* 18 */ 0xa9a9, 0xcc6f, 0xa9aa, 0xa9ad,    BAD, 0xabd2,    BAD, 0xabd4,
/* 20 */ 0xceb3, 0xceb0, 0xceb1, 0xceb2, 0xceb4, 0xabd3,    BAD,    BAD,
/* 28 */ 0xd174, 0xd173,    BAD, 0xae76,    BAD, 0xae75, 0xfbf1,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xb162, 0xd546,    BAD, 0xb161, 0xb163,
/* 38 */ 0xb160,    BAD,    BAD,    BAD,    BAD, 0xb455, 0xd545,    BAD
},

/* Row 0x22e */
{
/* 00 */ 0xb456, 0xd8f3, 0x8d69, 0xb457, 0xd8f2, 0xb454,    BAD,    BAD,
/* 08 */ 0x934f,    BAD, 0xdd5a, 0xdd5c, 0xb745, 0xdd5b, 0xdd59, 0xdd58,
/* 10 */    BAD,    BAD,    BAD, 0xe1b4, 0xb9f7, 0xb9f5,    BAD, 0xb9f6,
/* 18 */ 0xe1b2, 0xe1b3,    BAD, 0xb9f3, 0xe571, 0xe56f, 0x934e, 0xbc6d,
/* 20 */ 0xe570, 0xbc6e, 0xbc6c, 0xb9f4,    BAD,    BAD, 0xe96d, 0xe96b,
/* 28 */ 0xe96c, 0xe56e, 0xecdc, 0xc0b0, 0xecdb, 0xefc5, 0xefc6, 0xe96e,
/* 30 */ 0xf1fe,    BAD, 0xa47a, 0xa5ad, 0xa67e, 0xc9db, 0xa67d,    BAD,
/* 38 */ 0xa9af, 0xb746, 0xfbf4, 0xa4db, 0xa5ae, 0xabd5, 0xb458, 0xc6ce
},

/* Row 0x22f */
{
/* 00 */ 0xc979,    BAD, 0xc97a, 0xfbc3, 0xc9dc,    BAD, 0x8965, 0xa7c8,
/* 08 */ 0xcad0, 0xcace, 0xa7c9, 0xcacd, 0xcacf, 0xcad1,    BAD, 0xa7c7,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa9b3, 0xa9b4, 0xa9b1,
/* 18 */    BAD,    BAD, 0xa9b0, 0xceb8, 0xa9b2,    BAD,    BAD,    BAD,
/* 20 */ 0xabd6,    BAD, 0xceb7, 0xceb9, 0xceb6, 0xceba, 0xabd7, 0xae79,
/* 28 */ 0xd175,    BAD, 0xd177, 0xae77, 0xd178, 0xae78, 0xd176,    BAD,
/* 30 */ 0xceb5, 0xd547, 0xd54a, 0xd54b, 0xd548, 0xb167, 0xb166, 0xb164,
/* 38 */ 0xb165, 0xd549,    BAD,    BAD,    BAD, 0x8d6a, 0xb168,    BAD
},

/* Row 0x230 */
{
/* 00 */    BAD, 0xb45a, 0xb45b,    BAD, 0xb45c, 0xdd5d, 0xdd5f, 0xdd61,
/* 08 */ 0xb748, 0xb747, 0xb459, 0xdd60, 0xdd5e, 0x9353, 0xe1b8,    BAD,
/* 10 */ 0x9dfb, 0xe1b6, 0xe1bc, 0xb9f8, 0xe1bd, 0xe1ba, 0xb9f9, 0xe1b7,
/* 18 */ 0xe1b5, 0xe1bb, 0xbc70, 0xe573, 0xe1b9, 0xbc72, 0xe574, 0xbc71,
/* 20 */ 0xbc74, 0xe575, 0xbc6f, 0xbc73,    BAD, 0xe973, 0xe971, 0xe970,
/* 28 */ 0xe972, 0xe96f,    BAD,    BAD, 0xc366,    BAD, 0xf446, 0xf447,
/* 30 */    BAD, 0xf5cb, 0xf6df, 0xc655, 0xfbfd,    BAD, 0xa9b5, 0xa7ca,
/* 38 */ 0x9059, 0xfc40, 0xabd8, 0xfc41, 0xfc43,    BAD, 0xa47b, 0xa4dc
},

/* Row 0x231 */
{
/* 00 */    BAD, 0xa5af, 0xc9dd,    BAD, 0xa7cb, 0xcad2,    BAD, 0xcebb,
/* 08 */ 0xabd9,    BAD, 0xb9fa, 0xa47c, 0x9361, 0xfc46, 0x9362, 0xa6a1,
/* 10 */    BAD,    BAD, 0xb749, 0xa47d, 0xa4dd, 0xa4de,    BAD, 0xa5b1,
/* 18 */ 0xa5b0,    BAD, 0xc9de, 0xa6a2,    BAD, 0xcad3,    BAD, 0xa7cc,
/* 20 */    BAD,    BAD, 0xcc71, 0xcc72, 0xcc73, 0x8d6b, 0xa9b6, 0xa9b7,
/* 28 */ 0xcc70, 0xa9b8,    BAD,    BAD,    BAD, 0xabda, 0xcebc,    BAD,
/* 30 */ 0xd17a, 0xae7a,    BAD, 0xd179,    BAD, 0xb169, 0xd54c, 0xb16a,
/* 38 */ 0xd54d,    BAD, 0xfc4c,    BAD, 0xb45d,    BAD,    BAD,    BAD
},

/* Row 0x232 */
{
/* 00 */ 0xdd62,    BAD,    BAD, 0xe1bf, 0xe1be,    BAD, 0xb9fb,    BAD,
/* 08 */ 0xbc75, 0xe576, 0xbeca, 0xe974, 0xc0b1, 0x95b8, 0xc573, 0xf7d8,
/* 10 */ 0xc6d0, 0x8bca,    BAD,    BAD, 0xcc74,    BAD, 0xcebd, 0xb16b,
/* 18 */ 0xd8f4, 0xb74a,    BAD,    BAD, 0x987a, 0xc255,    BAD,    BAD,
/* 20 */    BAD, 0xc6d1, 0xa7ce, 0xfc51, 0xa7cd, 0xabdb,    BAD, 0xd17b,
/* 28 */    BAD, 0xb16d, 0xb343, 0xb16e, 0xb16c, 0xb45e,    BAD, 0xe1c0,
/* 30 */ 0xb9fc, 0xbc76, 0xfc54, 0xc94c, 0xc9df,    BAD, 0xcad5, 0xa7cf,
/* 38 */ 0xcad4, 0xa7d0,    BAD, 0xfaaf, 0xa9bc, 0xcc77, 0xcc76, 0xa9bb
},

/* Row 0x233 */
{
/* 00 */ 0xa9b9, 0xa9ba, 0xcc75, 0x8d6c,    BAD, 0xabdd, 0xcebe, 0xabe0,
/* 08 */ 0xabdc, 0xabe2, 0xabde, 0xabdf, 0xabe1,    BAD,    BAD,    BAD,
/* 10 */ 0xae7d, 0xae7c, 0xae7b,    BAD,    BAD,    BAD, 0xd54f, 0xb16f,
/* 18 */ 0xb172, 0xb170,    BAD, 0xd54e, 0xb175,    BAD, 0xb171, 0xd550,
/* 20 */ 0xb174, 0xb173,    BAD,    BAD, 0xfa61, 0xd8f6, 0xd8f5, 0xfc57,
/* 28 */ 0xb461, 0xb45f, 0xb460, 0xd8f7, 0xb74b, 0xdd64, 0xb74c, 0xdd63,
/* 30 */    BAD, 0x9b70, 0xe577,    BAD,    BAD, 0xbc78, 0xe1c1, 0xbc77,
/* 38 */    BAD, 0xb9fd, 0xa051, 0xecde, 0xe975, 0xc0b2, 0xecdd, 0xf240
},

/* Row 0x234 */
{
/* 00 */ 0xf448, 0xf449,    BAD, 0xa4df, 0x8bcb, 0xa5b2,    BAD,    BAD,
/* 08 */    BAD, 0xc97b,    BAD,    BAD, 0xa7d2, 0xa7d4,    BAD, 0xc9e2,
/* 10 */ 0xcad8, 0xcad7, 0xcad6,    BAD, 0xc9e1, 0xc9e0, 0xa6a4, 0xa7d3,
/* 18 */ 0xa7d1, 0xa6a3,    BAD, 0x936e,    BAD, 0xa9bd, 0xcc78, 0xfcd5,
/* 20 */ 0xa9be, 0xcadd,    BAD, 0xcadf, 0xcade, 0xcc79,    BAD,    BAD,
/* 28 */ 0xcada,    BAD, 0xa7d8, 0xa7d6,    BAD, 0xcad9, 0xcadb, 0xcae1,
/* 30 */    BAD, 0xa7d5,    BAD, 0xcadc, 0xcae5, 0xa9c0,    BAD, 0xcae2,
/* 38 */ 0xa7d7,    BAD, 0xcae0, 0xcae3,    BAD, 0xa9bf,    BAD, 0xa9c1
},

/* Row 0x235 */
{
/* 00 */ 0xcae4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xccaf, 0xcca2, 0xcc7e, 0xccae, 0xcca9, 0xabe7, 0xa9c2,
/* 10 */ 0xccaa, 0xccad, 0xabe3, 0xccac, 0xa9c3, 0xa9c8, 0xa9c6, 0xcca3,
/* 18 */    BAD, 0xcc7c, 0xcca5, 0xa9cd, 0xccb0, 0xabe4, 0xcca6,    BAD,
/* 20 */ 0xabe5, 0xa9c9, 0xcca8, 0xfca9, 0xcecd, 0xabe6, 0xcc7b, 0xa9ca,
/* 28 */ 0xabe8, 0xa9cb, 0xa9c7, 0xa9cc, 0xcca7, 0xcc7a, 0xccab, 0xa9c4,
/* 30 */    BAD, 0xfc61, 0xcc7d, 0xcca4, 0xcca1, 0xa9c5,    BAD, 0xcebf,
/* 38 */    BAD, 0xcec0,    BAD, 0x8966,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x236 */
{
/* 00 */ 0xceca, 0xd1a1, 0xcecb, 0xabee, 0xcece, 0xcec4, 0xabed, 0xcec6,
/* 08 */    BAD, 0xcec7, 0xfacb,    BAD, 0xcec9, 0xabe9,    BAD,    BAD,
/* 10 */ 0xaea3,    BAD, 0xf9da, 0xcec5, 0xcec1, 0xaea4,    BAD,    BAD,
/* 18 */ 0xcecf, 0xae7e, 0xd17d, 0xcec8,    BAD, 0xd17c, 0xcec3, 0xcecc,
/* 20 */    BAD,    BAD, 0xabec, 0xaea1, 0xabf2, 0xaea2, 0xced0, 0xd17e,
/* 28 */ 0xabeb, 0xaea6, 0xabf1, 0xabf0, 0xabef, 0xaea5, 0xced1, 0xaea7,
/* 30 */ 0xabea,    BAD, 0xcec2,    BAD,    BAD, 0x937a,    BAD, 0xa0e0,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x936b, 0xb176
},

/* Row 0x237 */
{
/* 00 */ 0xd1a4, 0xd1a6,    BAD, 0xd1a8, 0xaea8, 0xaeae, 0xd553, 0xd1ac,
/* 08 */ 0xd1a3, 0xb178, 0xd551,    BAD, 0xaead, 0xaeab, 0xd1ae,    BAD,
/* 10 */ 0xd552,    BAD, 0xd1a5,    BAD, 0xaeac, 0xd1a9, 0xaeaf, 0xd1ab,
/* 18 */    BAD,    BAD, 0xaeaa, 0xd1aa, 0xd1ad, 0xd1a7, 0xfc6b, 0xaea9,
/* 20 */ 0xb179,    BAD, 0xd1a2, 0xb177, 0xa0dc,    BAD,    BAD, 0x9468,
/* 28 */ 0xb17a,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xd555, 0xd55e, 0xb464, 0xfc6d, 0xb17c, 0xb1a3, 0xb465, 0xd560,
/* 38 */ 0xb1aa, 0xd8f9, 0xd556, 0xb1a2, 0xb1a5, 0xb17e, 0xd554, 0xd562
},

/* Row 0x238 */
{
/* 00 */ 0xd565, 0xd949,    BAD, 0xd563, 0xd8fd, 0xb1a1, 0xb1a8, 0xb1ac,
/* 08 */ 0xd55d, 0xd8f8, 0xd561, 0xb17b, 0xd8fa, 0xd564, 0xd8fc, 0xd559,
/* 10 */    BAD, 0xb462,    BAD, 0xd557, 0xd558, 0xb1a7,    BAD, 0x8d71,
/* 18 */ 0xb1a6, 0xd55b, 0xb1ab, 0xd55f, 0xb1a4, 0xd55c, 0xfd64, 0xb1a9,
/* 20 */ 0xb466, 0xb463, 0xd8fb, 0x99ba, 0xd55a,    BAD, 0xb17d, 0x9ad0,
/* 28 */ 0x9a61, 0xa0e5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xb46b, 0xb46f, 0xd940, 0xb751, 0xb46d, 0xd944, 0xb471, 0xdd65,
/* 38 */ 0xd946, 0xb753, 0xb469, 0xb46c, 0xd947, 0xa05b, 0xd948, 0xd94e
},

/* Row 0x239 */
{
/* 00 */ 0xb473, 0xb754,    BAD, 0xd94a, 0xd94f, 0xd943, 0xb75e, 0x96ac,
/* 08 */ 0xb755, 0xb472, 0xd941, 0xd950, 0x9740, 0xb75d, 0xb470, 0xb74e,
/* 10 */ 0xd94d,    BAD, 0xb474, 0xd945, 0xd8fe, 0xb46a, 0xd942,    BAD,
/* 18 */ 0xd94b, 0x9ef1, 0xb74d, 0xb752, 0xb467, 0xd94c,    BAD, 0xb750,
/* 20 */    BAD,    BAD,    BAD, 0xb468,    BAD,    BAD,    BAD, 0xb75c,
/* 28 */ 0xe1c3, 0xdd70,    BAD, 0xdd68, 0xe1c2,    BAD, 0xdd6c, 0xdd6e,
/* 30 */ 0x9f7e,    BAD, 0xdd6b,    BAD, 0xb75b,    BAD, 0xdd6a, 0xb75f,
/* 38 */    BAD,    BAD,    BAD, 0xe1d2,    BAD, 0x8d72, 0xb75a, 0xba40
},

/* Row 0x23a */
{
/* 00 */ 0xdd71, 0xe1c4, 0xfc76,    BAD, 0xb758, 0xdd69, 0xdd6d, 0xb9fe,
/* 08 */ 0xb74f, 0xdd66, 0xdd67, 0xba41, 0xb757, 0xb759, 0xb756, 0xdd6f,
/* 10 */ 0x96a9,    BAD, 0xe1c8, 0xe1c9, 0xe1ce, 0xbc7d, 0xe1d5,    BAD,
/* 18 */ 0xba47, 0xa06e, 0xba46, 0xe1d0, 0xfcaa, 0xbc7c, 0xe1c5, 0xba45,
/* 20 */ 0xfbcd, 0xe1d4, 0xba43, 0xba44, 0xfc74, 0xe1d1, 0xe5aa, 0xbc7a,
/* 28 */ 0xb46e,    BAD, 0xe1d3, 0xbca3, 0xe1cb,    BAD, 0xbc7b, 0xa074,
/* 30 */ 0xbca2, 0xe1c6, 0xe1ca, 0xe1c7, 0xe1cd, 0xba48, 0xbc79, 0xba42,
/* 38 */    BAD, 0xe57a, 0xe1cf,    BAD, 0xbca1, 0xa071, 0xbca4,    BAD
},

/* Row 0x23b */
{
/* 00 */ 0xe1cc, 0xfc79, 0xbc7e, 0xe579,    BAD,    BAD,    BAD, 0xfc7c,
/* 08 */    BAD, 0xe57e, 0xbece, 0xe578, 0xe9a3, 0xe5a9, 0xbca8,    BAD,
/* 10 */ 0xbca6, 0xbecc, 0xe5a6, 0xe5a2, 0xbcac, 0x9c50, 0xe978,    BAD,
/* 18 */ 0x9379, 0x9378, 0xbcaa, 0xe5a1, 0xa0dd, 0xe976,    BAD, 0xe5a5,
/* 20 */    BAD, 0xe5a8, 0xe57d,    BAD, 0xbcab,    BAD,    BAD, 0xbca5,
/* 28 */ 0xe977, 0xbecd, 0xe5a7, 0xbca7, 0xbca9, 0xe5a4, 0xbcad, 0xe5a3,
/* 30 */ 0xe57c, 0xe57b, 0xbecb, 0xe5ab, 0xe97a, 0xece0, 0xbed0, 0x8d75,
/* 38 */ 0xe9a2, 0x8d76, 0xe97e,    BAD, 0xece1,    BAD, 0xbed1, 0xe9a1
},

/* Row 0x23c */
{
/* 00 */ 0x9374, 0xe97c, 0xc0b4, 0xecdf,    BAD, 0xe979, 0xe97b, 0xc0b5,
/* 08 */ 0xbed3, 0xc0b3, 0xbed2, 0xc0b7, 0xe97d, 0xbecf,    BAD, 0x8d77,
/* 10 */ 0xfca5,    BAD,    BAD, 0xfca2,    BAD,    BAD, 0xefcf,    BAD,
/* 18 */ 0xefc7,    BAD, 0x90c3,    BAD,    BAD,    BAD, 0xece7, 0xefc8,
/* 20 */ 0xece3,    BAD, 0xa079, 0xc256, 0xece5, 0xece4, 0xc0b6, 0xece2,
/* 28 */ 0xece6, 0xefd0, 0xefcc, 0xefce,    BAD, 0xefc9, 0xefca,    BAD,
/* 30 */ 0xefcd, 0xefcb, 0xc367,    BAD,    BAD, 0xc36a, 0xc369, 0xc368,
/* 38 */ 0xc461, 0xf44a, 0xc462, 0xf241, 0xc4df, 0xf5cc, 0xc4e0, 0xc574
},

/* Row 0x23d */
{
/* 00 */ 0xc5ca, 0xf7d9,    BAD, 0xf7da, 0xf7db,    BAD,    BAD, 0xf9ba,
/* 08 */ 0xa4e0, 0xc97c, 0xa5b3,    BAD, 0xa6a6, 0xa6a7, 0xa6a5,    BAD,
/* 10 */ 0xa6a8, 0xa7da, 0xa7d9,    BAD, 0xccb1, 0xa9cf, 0xa9ce,    BAD,
/* 18 */    BAD, 0xd1af, 0xb1ad, 0xb1ae,    BAD,    BAD,    BAD, 0xb475,
/* 20 */ 0xdd72, 0xb760, 0xb761, 0xdd74, 0xdd76, 0xdd75,    BAD, 0xe1d7,
/* 28 */    BAD, 0xe1d6, 0xba49, 0xe1d8, 0x8d79, 0xe5ac, 0xbcae,    BAD,
/* 30 */ 0xbed4,    BAD, 0xc0b8, 0xc257, 0xc0b9,    BAD, 0xa4e1, 0x8bfc,
/* 38 */    BAD, 0xa076, 0xcae6,    BAD,    BAD, 0xccb2, 0xa9d1, 0xa9d0
},

/* Row 0x23e */
{
/* 00 */ 0xa9d2, 0xabf3, 0xced2, 0xced3,    BAD,    BAD, 0xd1b0, 0xaeb0,
/* 08 */ 0xb1af, 0xb476, 0xd951, 0xa4e2, 0x8bcd, 0xa47e, 0xa4e3,    BAD,
/* 10 */ 0xc97d, 0xa5b7, 0xa5b6, 0xa5b4, 0xa5b5,    BAD,    BAD,    BAD,
/* 18 */ 0xa6ab, 0xc9e9, 0xc9eb, 0xa6aa, 0xc9e3,    BAD, 0xc9e4,    BAD,
/* 20 */ 0xc9ea, 0xc9e6, 0xc9e8, 0xa6a9, 0xc9e5, 0xc9ec, 0xc9e7,    BAD,
/* 28 */ 0x9f5a,    BAD,    BAD,    BAD,    BAD, 0xa7e1, 0xa7ea, 0xa7e8,
/* 30 */ 0xcaf0, 0xcaed, 0xcaf5, 0xa7e6, 0xcaf6,    BAD, 0xa7df, 0xcaf3,
/* 38 */    BAD, 0xa7e5, 0xcaef, 0xcaee, 0xa7e3, 0xcaf4, 0xa7e4, 0xa9d3
},

/* Row 0x23f */
{
/* 00 */ 0xa7de, 0xcaf1, 0x9ff4, 0xcae7, 0xa7db, 0x9fba, 0xa7ee, 0xcaec,
/* 08 */ 0xcaf2, 0xa7e0, 0xa7e2,    BAD, 0xcae8,    BAD, 0xcae9, 0xcaea,
/* 10 */ 0x8d7a, 0xa7ed, 0xa7e7, 0xa7ec, 0xcaeb, 0xa7eb, 0xa7dd, 0xa7dc,
/* 18 */ 0xa7e9,    BAD,    BAD,    BAD,    BAD, 0x9e45,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x93b0,    BAD, 0xa075,    BAD,
/* 28 */ 0xa9e1, 0xccbe, 0xccb7, 0xa9dc, 0xa9ef, 0xccb3, 0xccba, 0xccbc,
/* 30 */ 0xccbf, 0xa9ea,    BAD, 0xccbb, 0xccb4, 0xa9e8, 0xccb8,    BAD,
/* 38 */ 0xccc0, 0xa9d9,    BAD, 0xccbd, 0xa9e3, 0xa9e2, 0xccb6, 0xa9d7
},

/* Row 0x240 */
{
/* 00 */    BAD,    BAD, 0xa9d8, 0x9b46, 0xa9d6, 0xfcae, 0xa9ee, 0xa9e6,
/* 08 */ 0xa9e0, 0xa9d4, 0xccb9, 0xa9df, 0xa9d5, 0xa9e7, 0xa9f0, 0xced4,
/* 10 */ 0xa9e4, 0xccb5, 0xa9da, 0xa9dd, 0xa9de, 0xfcb0, 0xa9ec, 0xa9ed,
/* 18 */ 0xa9eb, 0xa9e5, 0xa9e9, 0xa9db, 0xabf4,    BAD,    BAD, 0xfa51,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8d7b,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xceda, 0xac41, 0xabf8, 0xabfa, 0xac40,
/* 30 */ 0xcee6, 0xabfd, 0xd1b1, 0xaeb1, 0xac43, 0xced7, 0xcedf, 0xabfe,
/* 38 */ 0xcede, 0xcedb, 0xcee3, 0xcee5, 0xabf7, 0xabfb, 0xac42, 0xaeb3
},

/* Row 0x241 */
{
/* 00 */ 0xcee0, 0xabf9, 0xac45, 0xced9,    BAD,    BAD,    BAD, 0xabfc,
/* 08 */ 0xaeb2, 0xabf6,    BAD, 0xced6, 0xcedd, 0xced5, 0xced8, 0xcedc,
/* 10 */ 0xd1b2, 0xac44,    BAD, 0xcee1, 0xcee2, 0xcee4, 0xabf5,    BAD,
/* 18 */ 0x8d7c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xaec1, 0xd1be, 0xaebf, 0xaec0, 0xd1b4, 0xd1c4, 0x9ed6, 0xaeb6,
/* 30 */    BAD, 0x93ac, 0xd566, 0xd1c6, 0xd1c0, 0x9f5b, 0xd1b7, 0x93a9,
/* 38 */ 0xd1c9, 0xd1ba, 0xaebc, 0xd57d, 0xd1bd, 0xaebe, 0xaeb5,    BAD
},

/* Row 0x242 */
{
/* 00 */ 0xd1cb, 0xd1bf, 0xaeb8, 0xd1b8, 0xd1b5, 0xd1b6, 0xaeb9, 0xd1c5,
/* 08 */ 0xd1cc, 0xaebb, 0xd1bc, 0xd1bb, 0xaec3, 0xaec2, 0xaeb4, 0xaeba,
/* 10 */ 0xaebd, 0xd1c8,    BAD,    BAD, 0xd1c2, 0xaeb7, 0xd1b3, 0xd1ca,
/* 18 */ 0xd1c1, 0xd1c3, 0xd1c7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xa07c, 0xd567,    BAD, 0xb1b7,
/* 28 */ 0xb1cb, 0xb1ca,    BAD, 0xb1bf, 0xfcb2, 0xd579, 0xd575, 0xd572,
/* 30 */ 0xd5a6, 0xb1ba, 0xb1b2,    BAD,    BAD, 0xd577, 0xb4a8, 0xb1b6,
/* 38 */ 0xd5a1, 0x8ac1, 0xb1cc, 0xb1c9, 0xd57b, 0xd56a,    BAD, 0x9fb4
},

/* Row 0x243 */
{
/* 00 */ 0xb1c8, 0xd5a3, 0xd569, 0xb1bd, 0xb1c1, 0xd5a2,    BAD, 0xd573,
/* 08 */ 0xb1c2, 0xb1bc, 0xd568, 0xfcac, 0xb478, 0xd5a5, 0xd571, 0xb1c7,
/* 10 */ 0xd574, 0xd5a4, 0xb1c6,    BAD, 0xd952,    BAD, 0xb1b3, 0xd56f,
/* 18 */ 0xb1b8, 0xb1c3,    BAD, 0xb1be, 0xd578, 0xd56e, 0xd56c, 0xd57e,
/* 20 */ 0xb1b0, 0xb1c4, 0xb1b4, 0xb477, 0xd57c, 0xb1b5,    BAD, 0xb1b1,
/* 28 */ 0xb1c0, 0xb1bb, 0xb1b9, 0xd570, 0xb1c5, 0xd56d, 0xd57a, 0xd576,
/* 30 */ 0xd954, 0xd953,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x9e4c,    BAD,    BAD,    BAD, 0xd56b, 0xd964,    BAD
},

/* Row 0x244 */
{
/* 00 */ 0xb47a, 0x8fc5, 0xd96a, 0xd959, 0xd967, 0xdd77, 0xb47d, 0xd96b,
/* 08 */ 0xd96e, 0xb47c, 0xd95c, 0xd96d, 0xd96c, 0xb47e, 0xd955, 0xb479,
/* 10 */ 0xb4a3, 0x93ad, 0xb4a1, 0xd969,    BAD, 0xd95f, 0xb4a5, 0xd970,
/* 18 */ 0xd968, 0xd971, 0xb4ad, 0xb4ab, 0xd966, 0xd965, 0x9dc3, 0xd963,
/* 20 */ 0xd95d, 0xb4a4, 0x8da2, 0xb4a2, 0xd1b9, 0xd956, 0x9d4a, 0xddb7,
/* 28 */ 0xd957, 0xb47b, 0xb4aa, 0xdd79,    BAD, 0xb4a6, 0xb4a7, 0xd958,
/* 30 */ 0xd96f, 0xdd78, 0xd960, 0xd95b, 0xb4a9, 0xd961, 0xd95e,    BAD,
/* 38 */ 0xfcb6, 0xb4ae,    BAD, 0x8da3, 0x9e4b,    BAD, 0x9e4d,    BAD
},

/* Row 0x245 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb770, 0x8da4,
/* 08 */    BAD, 0xdd7c, 0xddb1, 0xddb6, 0xddaa, 0xb76c, 0xddbb, 0xb769,
/* 10 */ 0xdd7a,    BAD, 0xdd7b, 0xb762, 0xb76b, 0xdda4, 0xb76e, 0xb76f,
/* 18 */ 0xdda5,    BAD, 0xddb2, 0xddb8, 0xb76a,    BAD, 0xb764, 0xdda3,
/* 20 */ 0xdd7d, 0xddba, 0xdda8, 0xdda9, 0xdd7e, 0xddb4, 0xddab, 0xddb5,
/* 28 */ 0xddad,    BAD, 0xb765, 0xe1d9, 0xb768, 0xb766, 0xddb9, 0xddb0,
/* 30 */ 0xddac,    BAD, 0x8afd, 0xdda1, 0xba53, 0xddaf, 0xb76d, 0xdda7,
/* 38 */ 0xfcb5, 0xdda6, 0xfcc3, 0x93b2,    BAD, 0xb767, 0xb763, 0xe1ee
},

/* Row 0x246 */
{
/* 00 */ 0xddb3, 0xddae,    BAD, 0xdda2,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xe1e9,    BAD, 0xe1da, 0xe1e5,    BAD,
/* 10 */ 0xe1ec, 0xba51, 0xb4ac, 0xe1ea, 0xba4c,    BAD,    BAD,    BAD,
/* 18 */ 0xba4b, 0xe1f1, 0x8da5, 0xe1db, 0xe1e8, 0xe1dc, 0xe1e7, 0xba4f,
/* 20 */ 0xe1eb, 0xd962,    BAD,    BAD,    BAD, 0xe1f2, 0xe1e3, 0xba52,
/* 28 */ 0xe5ba, 0xbcaf,    BAD, 0xe1f0, 0xe1ef, 0xba54, 0xe5ad, 0xbcb0,
/* 30 */ 0xe5ae, 0x93a1, 0xe1df, 0xe1e0, 0xe1dd, 0xe1e2, 0xe1de, 0xe1f3,
/* 38 */ 0xba4e, 0xbcb1, 0xba50, 0xba55, 0x8ac6, 0xe1e1,    BAD, 0xe1ed
},

/* Row 0x247 */
{
/* 00 */    BAD,    BAD, 0xe1e6,    BAD,    BAD, 0xe5b1,    BAD, 0xba4a,
/* 08 */ 0xbcb4, 0xe9aa, 0xe5b6, 0xe5b5, 0xe5b7, 0x8a5b,    BAD, 0xe5b4,
/* 10 */ 0xbcb5, 0x894d, 0xbcbb, 0xbcb8,    BAD, 0xbcb9, 0xe5af, 0xe5b2,
/* 18 */ 0xe5bc, 0xbcc1, 0xbcbf,    BAD, 0xe5b3, 0xd95a, 0xbcb2, 0xe5b9,
/* 20 */ 0xe5b0,    BAD, 0xbcc2, 0xe5b8, 0xba4d, 0xbcb7, 0xe1e4,    BAD,
/* 28 */    BAD, 0xbcba,    BAD, 0xbcbe, 0xbcc0, 0xbcbd, 0xbcbc, 0xfed4,
/* 30 */ 0xbcb6, 0xe5bb, 0xbcb3, 0xbcc3, 0x8a78,    BAD, 0x93ab,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xbed8, 0xbed9, 0xe9a9, 0xbee2, 0xbedf
},

/* Row 0x248 */
{
/* 00 */ 0x8da7, 0xbed6, 0xbedd, 0xe9ab, 0xbedb, 0xbed5,    BAD, 0xbedc,
/* 08 */    BAD, 0xe9a8, 0xc0bb, 0xbed7,    BAD, 0xbede, 0xc0ba, 0xe9a7,
/* 10 */ 0xe9a6,    BAD, 0xbee0, 0x9f45, 0xbee1,    BAD, 0xe9a5, 0xe9a4,
/* 18 */ 0xc0bc, 0xe9ae, 0xbeda, 0xe9ac,    BAD, 0x8a56,    BAD,    BAD,
/* 20 */ 0xc0bd, 0xfcbf, 0xc0c2, 0xecea, 0xecec, 0xfcc0, 0xc0bf, 0x8ee6,
/* 28 */ 0xeced, 0xece9, 0x8aa4, 0xeceb, 0xc0c0, 0xc0c3,    BAD, 0xece8,
/* 30 */ 0xc0be, 0xc0c1, 0xc259, 0xe9ad, 0xc258,    BAD,    BAD, 0xc25e,
/* 38 */ 0xefd4,    BAD, 0xc25c, 0xc25d, 0xefd7, 0xefd3, 0xc25a, 0xefd1
},

/* Row 0x249 */
{
/* 00 */ 0xc36b, 0xefd5,    BAD, 0xefd6, 0xefd2,    BAD, 0xc25b, 0xf242,
/* 08 */    BAD, 0xf245, 0x8943,    BAD, 0xf246, 0xf244, 0xf247, 0xc36c,
/* 10 */ 0xf243, 0x93f3,    BAD, 0xf44e, 0xc464, 0xf44d, 0xf44c, 0xf44b,
/* 18 */ 0xc463, 0xc465,    BAD, 0xf5cd, 0xc4e2, 0xc4e1, 0xfcab, 0x9ea2,
/* 20 */ 0xf6e1, 0xf6e0, 0xf6e3, 0xc5cb, 0xc575, 0xf7dd, 0xf6e2,    BAD,
/* 28 */    BAD, 0xf7dc, 0xc5cd, 0xc5cc, 0xc5f3, 0xf8a9, 0xf8ef, 0xa4e4,
/* 30 */ 0x9dc7,    BAD, 0xd972, 0xe9af, 0xc6d2, 0x8bce, 0xa6ac, 0xcaf7,
/* 38 */ 0xa7f1, 0xa7ef,    BAD, 0xa7f0,    BAD, 0xccc1, 0xa9f1, 0xac46
},

/* Row 0x24a */
{
/* 00 */    BAD, 0xcee7,    BAD, 0xcee8,    BAD, 0xac47, 0xd1ce,    BAD,
/* 08 */ 0xaec4, 0xaec5, 0xd1cd,    BAD,    BAD, 0xfcc5,    BAD, 0xb1d3,
/* 10 */    BAD, 0xb1cf,    BAD, 0xd5a7, 0xb1d6, 0xb1d5, 0xb1ce, 0xb1d1,
/* 18 */ 0xb1d4, 0xb1d0,    BAD,    BAD, 0xd976, 0xb1cd, 0xb4af, 0xfccb,
/* 20 */    BAD,    BAD, 0xb4b1, 0xb4b2, 0xd975, 0xd978, 0xb4b0, 0xd973,
/* 28 */ 0xd977,    BAD, 0xd974, 0x93b3, 0xb771, 0xfcca,    BAD, 0xddbc,
/* 30 */    BAD,    BAD, 0xba56, 0xe1f4, 0xbee3, 0xbcc4, 0xe5bd, 0xbcc5,
/* 38 */ 0xbcc6, 0xe5bf, 0xe5be, 0xe5c0, 0xe9b1,    BAD,    BAD, 0xe9b0
},

/* Row 0x24b */
{
/* 00 */ 0xecef, 0xecee, 0xc0c4, 0xc0c5, 0xf248, 0xfcc9, 0x8dac, 0xa4e5,
/* 08 */ 0xfbc6, 0x8967,    BAD,    BAD, 0xd979,    BAD,    BAD,    BAD,
/* 10 */ 0xb4b4, 0xb4b3, 0xddbd,    BAD, 0xefd8, 0xc4e3, 0xf7de, 0xa4e6,
/* 18 */    BAD, 0xaec6,    BAD, 0xb1d8, 0xb1d7, 0xd97a, 0xd97b, 0xb772,
/* 20 */ 0xe1f5, 0xba57, 0xe9b2,    BAD, 0xa4e7, 0xa5b8,    BAD, 0xa9f2,
/* 28 */ 0xccc2,    BAD, 0xcee9, 0xac48, 0xb1d9,    BAD, 0xd97c, 0xb4b5,
/* 30 */ 0xb773,    BAD, 0xe5c1, 0xe5c2,    BAD, 0xfccd, 0xecf0, 0xc25f,
/* 38 */ 0xf8f0, 0xa4e8,    BAD, 0xccc3, 0xa9f3, 0xac49, 0x9cf3, 0xceea
},

/* Row 0x24c */
{
/* 00 */    BAD, 0xaec7, 0xd1d2, 0xd1d0, 0xd1d1, 0xaec8, 0xd1cf,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xb1db, 0xb1dc, 0xd5a8, 0xb1dd, 0xb1da,
/* 10 */ 0xd97d, 0xfcd0, 0xd97e, 0xddbe, 0x95bb,    BAD, 0xba59, 0xba58,
/* 18 */    BAD,    BAD, 0xecf1, 0xefd9,    BAD, 0xf24a, 0xf249, 0xf44f,
/* 20 */ 0xfcd3, 0xc95e, 0xac4a, 0xfcd4,    BAD, 0xa4e9, 0xa5b9,    BAD,
/* 28 */ 0xa6ae, 0xa6ad,    BAD,    BAD, 0xa6af, 0xa6b0, 0xc9ee, 0xc9ed,
/* 30 */ 0xcaf8, 0xa7f2, 0xcafb, 0xcafa, 0xcaf9, 0xcafc,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xa9f4, 0xccc9, 0xccc5, 0xccce,    BAD, 0x8dae
},

/* Row 0x24d */
{
/* 00 */ 0xa9fb,    BAD, 0xa9f9, 0xccca, 0xccc6, 0xcccd, 0xa9f8, 0xaa40,
/* 08 */ 0xccc8, 0xccc4, 0xa9fe, 0xcccb, 0xa9f7, 0xcccc, 0xa9fa, 0xa9fc,
/* 10 */ 0xccd0, 0xcccf, 0xccc7, 0xa9f6, 0xa9f5, 0xa9fd,    BAD,    BAD,
/* 18 */ 0xfcd7,    BAD,    BAD,    BAD, 0xceef, 0xcef5, 0x93db, 0xac50,
/* 20 */ 0xac4d, 0xceec, 0xcef1, 0xfe63, 0xac53, 0xac4b, 0xcef0, 0xac4e,
/* 28 */ 0xac51,    BAD,    BAD, 0xcef3,    BAD, 0xac4c, 0xcef8, 0xac4f,
/* 30 */ 0x93d5, 0xac52, 0xceed, 0xcef2, 0xcef6, 0xceee, 0xceeb,    BAD,
/* 38 */    BAD, 0xcef7, 0xcef4,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x24e */
{
/* 00 */    BAD, 0xaed0, 0xaec9, 0xaecc, 0xfcda, 0xaecf,    BAD, 0xd1d5,
/* 08 */ 0x9b71, 0xaeca, 0xd1d3, 0xfcdd, 0xaece,    BAD,    BAD, 0xaecb,
/* 10 */    BAD, 0xd1d6, 0xaecd, 0x8daf,    BAD,    BAD,    BAD, 0xfaf2,
/* 18 */    BAD, 0xd5ac, 0xb1df, 0xd5ab, 0xd5ad, 0xb1de, 0xb1e3, 0xd1d4,
/* 20 */    BAD, 0xd5aa, 0xd5ae, 0x93d8, 0xb1e0, 0xd5a9, 0xb1e2, 0xfcdf,
/* 28 */ 0xb1e1,    BAD, 0xd9a7, 0x93d3, 0xd9a2,    BAD, 0xb4b6, 0xb4ba,
/* 30 */ 0xb4b7, 0xd9a5, 0xd9a8, 0xfce1, 0xb4b8,    BAD, 0xb4b9, 0xb4be,
/* 38 */ 0xddc7, 0xd9a6, 0xb4bc, 0xd9a3, 0xd9a1, 0x8e76, 0xb4bd,    BAD
},

/* Row 0x24f */
{
/* 00 */ 0xd9a4,    BAD,    BAD,    BAD, 0xb779, 0xfc62, 0xddbf, 0xb776,
/* 08 */ 0xb777, 0xb775, 0xddc4, 0xddc3, 0xddc0, 0xb77b, 0x93d1,    BAD,
/* 10 */ 0xddc2, 0xb4bb, 0x8db1,    BAD, 0xddc6, 0xddc1, 0xb778, 0xb774,
/* 18 */ 0xb77a, 0xddc5, 0x9859,    BAD,    BAD, 0xba5c,    BAD, 0xe1f8,
/* 20 */ 0xe1f7, 0xe1f6, 0xba5a,    BAD, 0xfb52,    BAD,    BAD,    BAD,
/* 28 */ 0xba5b, 0xe5c5, 0xe5c8, 0xbcc8,    BAD, 0xfb53, 0xbcc7, 0xe5c9,
/* 30 */ 0xe5c4, 0xbcca, 0xe5c6, 0xfb4d, 0xbcc9, 0xe5c3, 0x9cbf, 0xe5c7,
/* 38 */ 0xbee9, 0xbee6, 0xe9bb, 0xe9ba,    BAD, 0xe9b9, 0xe9b4, 0x9b72
},

/* Row 0x250 */
{
/* 00 */ 0xe9b5,    BAD,    BAD,    BAD, 0xbee7,    BAD, 0xbee4, 0xbee8,
/* 08 */ 0xe9b3, 0xbee5, 0xe9b6, 0xe9b7, 0xe9bc, 0xfb50, 0x93be, 0xe9b8,
/* 10 */    BAD,    BAD, 0xecf2,    BAD,    BAD,    BAD, 0xc0c7,    BAD,
/* 18 */ 0xefdc, 0xc0c6, 0xefda, 0xefdb, 0xc260, 0xc36e, 0xf24b,    BAD,
/* 20 */ 0xc36d,    BAD,    BAD, 0xf451, 0xf452,    BAD, 0xc466,    BAD,
/* 28 */ 0xf450, 0xc4e4,    BAD, 0xf7df, 0xc5ce, 0xf8aa, 0xf8ab,    BAD,
/* 30 */ 0xa4ea, 0x9df1, 0xa6b1, 0xa6b2, 0xa7f3,    BAD, 0xccd1, 0xac54,
/* 38 */ 0xaed1, 0xb1e4,    BAD,    BAD, 0xb0d2,    BAD, 0xb4bf, 0xb4c0
},

/* Row 0x251 */
{
/* 00 */ 0xb3cc, 0xd9a9, 0xfceb, 0xb77c, 0xe1fa, 0xe1f9,    BAD,    BAD,
/* 08 */ 0xa4eb, 0xa6b3, 0xccd2, 0xaa42, 0xa0bb, 0xaa41, 0x9b7e, 0xcef9,
/* 10 */ 0xcefa,    BAD, 0xd1d7, 0xd1d8, 0xaed2, 0xaed3, 0x8db3, 0xaed4,
/* 18 */ 0xd5af,    BAD,    BAD, 0xb1e6,    BAD, 0xb4c2, 0x9ae8, 0xb4c1,
/* 20 */ 0xddc8, 0xdf7a, 0xe1fb, 0xe9bd,    BAD, 0x8edc, 0xc261, 0xc467,
/* 28 */ 0xa4ec,    BAD, 0xa5bc, 0xa5bd, 0xa5bb, 0xa5be, 0xa5ba,    BAD,
/* 30 */    BAD, 0xa6b6,    BAD, 0xc9f6, 0xa6b5, 0xa6b7, 0x9cf9,    BAD,
/* 38 */ 0xc9f1, 0xc9f0, 0xc9f3, 0xc9f2, 0xc9f5, 0xa6b4, 0xc9ef, 0xc9f4
},

/* Row 0x252 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xfa50, 0xcafd, 0xa7fd, 0xcafe,
/* 08 */ 0xcb43, 0xa7fc,    BAD, 0xcb47, 0xcb42, 0xcb45, 0xa7f5, 0xa7f6,
/* 10 */ 0xa7f7, 0xa7f8,    BAD, 0xa840,    BAD, 0xcb41, 0xa7fa, 0xa841,
/* 18 */    BAD, 0xcb40, 0xcb46,    BAD, 0xa7f9, 0xcb44, 0xa7fb, 0xa7f4,
/* 20 */ 0xa7fe, 0x98e7, 0xfcf3,    BAD,    BAD,    BAD,    BAD, 0xfcf2,
/* 28 */    BAD,    BAD, 0xaa57,    BAD, 0xccd4, 0xaa43,    BAD, 0xaa4d,
/* 30 */ 0xaa4e, 0xaa46, 0xaa58, 0xaa48, 0xccdc, 0xaa53, 0xccd7, 0xaa49,
/* 38 */ 0xcce6, 0xcce7, 0xccdf, 0xccd8, 0xaa56, 0xcce4, 0xaa51, 0xaa4f
},

/* Row 0x253 */
{
/* 00 */    BAD, 0xcce5,    BAD, 0xcce3, 0xccdb, 0xccd3, 0xccda, 0xaa4a,
/* 08 */    BAD, 0xaa50,    BAD, 0xaa44, 0xccde, 0xccdd, 0xccd5, 0x93e5,
/* 10 */ 0xaa52, 0xcce1, 0xccd6, 0xaa55, 0xcce8, 0xaa45,    BAD, 0xaa4c,
/* 18 */ 0xccd9, 0xcce2, 0xaa54,    BAD, 0xaa47, 0xaa4b,    BAD, 0xcce0,
/* 20 */ 0x9a59,    BAD,    BAD,    BAD, 0x8db5,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xfd4d,    BAD, 0xcf5b, 0xac5c,
/* 30 */ 0xac69, 0xfd5e, 0xcf56, 0xcf4c, 0xac62, 0xcf4a, 0xac5b, 0xcf45,
/* 38 */ 0xac65, 0xcf52, 0xcefe, 0xcf41,    BAD,    BAD,    BAD, 0x8f7d
},

/* Row 0x254 */
{
/* 00 */ 0xcf44, 0xcefb, 0xcf51, 0xcf61, 0xac60, 0xcf46, 0xcf58,    BAD,
/* 08 */ 0xcefd, 0xcf5f, 0xcf60, 0xcf63, 0xcf5a, 0xcf4b, 0xcf53, 0xac66,
/* 10 */ 0xac59, 0xac61, 0xac6d, 0xac56, 0xac58,    BAD, 0x9547, 0xfcf6,
/* 18 */ 0xcf43, 0xac6a, 0xac63, 0xcf5d, 0xcf40, 0xac6c, 0xac67, 0xcf49,
/* 20 */    BAD,    BAD, 0xac6b, 0xcf50, 0xcf48, 0xac64, 0xcf5c, 0xcf54,
/* 28 */    BAD, 0xac5e, 0xcf62, 0xcf47, 0xac5a, 0xcf59, 0xcf4f, 0xac5f,
/* 30 */ 0xcf55, 0xac57, 0xcefc, 0xac68, 0xaee3, 0xac5d, 0xcf4e, 0xcf4d,
/* 38 */ 0xcf42, 0x9250, 0xcf5e,    BAD, 0xcf57,    BAD, 0x8968, 0xac55
},

/* Row 0x255 */
{
/* 00 */ 0x8db6, 0xfcfb, 0xa07d, 0x98fc, 0x8969,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfe4f,    BAD,    BAD,
/* 10 */ 0x9256,    BAD, 0xd1ec, 0xaeea, 0xd1ed,    BAD, 0xd1e1, 0xaedf,
/* 18 */ 0xaeeb,    BAD, 0xd1da, 0xfac9, 0xd1e3, 0xd1eb, 0x93e8, 0xd1d9,
/* 20 */ 0xd1f4, 0xaed5, 0xfcf8,    BAD,    BAD, 0xd1f3, 0xd1ee,    BAD,
/* 28 */ 0xd1ef, 0xaedd, 0xaee8, 0xd1e5,    BAD, 0xd1e6, 0xd1f0, 0xd1e7,
/* 30 */    BAD, 0xd1e2, 0xd1dc, 0xd1dd, 0xd1ea, 0xd1e4, 0x9ce3, 0xfda9,
/* 38 */ 0xaed6, 0xaeda, 0xd1f2, 0xd1de, 0xaee6, 0xaee2, 0xfc44,    BAD
},

/* Row 0x256 */
{
/* 00 */ 0xaee5, 0xaeec, 0xaedb, 0xaee7, 0xd1e9, 0xaee9, 0xaed8, 0x9640,
/* 08 */ 0xaed7, 0xd1db, 0x8db8, 0xd1df, 0xaee0, 0xd1f1, 0xd1e8, 0xd1e0,
/* 10 */ 0xaee4, 0xaee1,    BAD, 0xaed9, 0xaedc, 0x9b4a, 0x8fb9,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfcfe,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x896a,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xd5c4,    BAD, 0xd5b4, 0xd5b5, 0xd5b9,
/* 30 */    BAD, 0xd5c8, 0xd5c5,    BAD, 0xd5be, 0xd5bd, 0xb1ed, 0xd5c1,
/* 38 */ 0xd5d0, 0xd5b0,    BAD, 0xd5d1, 0xd5c3, 0xd5d5, 0xd5c9, 0xb1ec
},

/* Row 0x257 */
{
/* 00 */ 0xd5c7, 0xb1e7, 0xb1fc, 0xb1f2, 0x8db9, 0xb1f6, 0xb1f5, 0xd5b1,
/* 08 */ 0x917e, 0xd5ce, 0xd5d4, 0xd5cc, 0xd5d3,    BAD,    BAD, 0xd5c0,
/* 10 */ 0xd5b2, 0xd5d2, 0xd5c2, 0xb1ea, 0xb1f7,    BAD, 0xd5cb, 0xb1f0,
/* 18 */ 0x93f4,    BAD,    BAD, 0xd5ca, 0xd5b3, 0xb1f8,    BAD, 0xb1fa,
/* 20 */ 0xd5cd, 0xb1fb, 0xb1e9, 0xd5ba, 0xd5cf,    BAD, 0xfb7c, 0xb1ef,
/* 28 */ 0xb1f9, 0xd5bc, 0xd5c6, 0xd5b7, 0xd5bb, 0xb1f4, 0xd5b6, 0xb1e8,
/* 30 */ 0xb1f1, 0xb1ee, 0xd5bf, 0xaede, 0xd9c0, 0xb1eb, 0x93e7,    BAD,
/* 38 */    BAD, 0x97ef,    BAD,    BAD,    BAD, 0xfe4a,    BAD,    BAD
},

/* Row 0x258 */
{
/* 00 */    BAD,    BAD,    BAD, 0xfd45, 0xb1f3, 0x96a5, 0xd9c3, 0xd9d9,
/* 08 */ 0xd9ce, 0xb4d6, 0xfee0, 0xb4d1, 0xd9bd, 0xb4d2, 0xd9cd,    BAD,
/* 10 */ 0xd9c6, 0xd9d3, 0xb4ce, 0xd9ab, 0xd9d5, 0xb4c4, 0xd9b3, 0xb4c7,
/* 18 */ 0xb4c6,    BAD, 0xb4d7,    BAD, 0xd9ad, 0xd9cf, 0xd9d0, 0xb4c9,
/* 20 */ 0xb4c5, 0xd9bb,    BAD, 0xb4d0, 0xd9b6,    BAD, 0xd9d1, 0xb4cc,
/* 28 */ 0xd9c9, 0xd9d6, 0xd9b0, 0xd9b5, 0xd9af,    BAD, 0xb4cb, 0xd9c2,
/* 30 */ 0xddde, 0xd9b1, 0xb4cf, 0xd9ba, 0xd9d2, 0xb4ca, 0xd9b7, 0xd9b4,
/* 38 */ 0xd9c5, 0xb4cd, 0xb4c3, 0xb4d9, 0xd9c8, 0xd9c7,    BAD,    BAD
},

/* Row 0x259 */
{
/* 00 */ 0xfd48, 0xfd47, 0xfef2, 0xfe6a, 0xd9ac, 0xb4c8, 0xd9d4, 0xd9bc,
/* 08 */ 0xd9be, 0x8dbd, 0xd9cb, 0xd9ca, 0xd9aa, 0xb4d3, 0xb4d5, 0xd9b2,
/* 10 */ 0xd9b9, 0xd9c1, 0xb4d4, 0xd9b8, 0xd9c4, 0xd9d7,    BAD, 0xd9cc,
/* 18 */ 0x9ba1,    BAD, 0x9ab7, 0x8efc,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd9d8,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xd9ae,    BAD, 0x9fa1,    BAD,    BAD, 0xddf2,
/* 30 */ 0xb7a6,    BAD, 0xddf0, 0xdddb, 0xdde0, 0xddd9, 0xfd51, 0xddec,
/* 38 */ 0xddcb, 0xddd2,    BAD, 0xddea, 0xddf4, 0xdddc, 0xfaad, 0xddcf
},

/* Row 0x25a */
{
/* 00 */ 0xdde2, 0xdde7, 0xddd3, 0x8dbe, 0xdde4, 0xddd0, 0x89a4,    BAD,
/* 08 */ 0xddd7, 0xddd8, 0xb7a8, 0xddeb, 0xdde9,    BAD, 0xddcc, 0xddee,
/* 10 */    BAD, 0xddef, 0xddf1, 0xb7ac, 0xb7a4, 0x9ad9, 0xd5b8, 0xddd4,
/* 18 */ 0xdde6, 0xddd5, 0xb7a1, 0xb7b1, 0xdded, 0xb7af, 0xb7ab, 0xddca,
/* 20 */ 0xb7a3, 0xfd4e, 0xddcd, 0xb7b0, 0x8dc0, 0xdddd, 0xddc9, 0x97f0,
/* 28 */ 0xb7a9, 0xdde1, 0xddd1, 0xb7aa, 0xddda, 0xb77e, 0xb4d8, 0xdde3,
/* 30 */ 0xd9bf, 0xddce, 0x93b4, 0xfd44, 0xdde8, 0xb7a5, 0xdde5, 0xb7a2,
/* 38 */ 0xdddf, 0xb7ad, 0xddd6, 0xddf3,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x25b */
{
/* 00 */ 0x9fa7,    BAD, 0xb7a7, 0xdec6,    BAD, 0x8dc2, 0xb7ae,    BAD,
/* 08 */    BAD,    BAD, 0x99b6,    BAD,    BAD, 0xe24a, 0xe248,    BAD,
/* 10 */ 0xe25e, 0xe246,    BAD, 0xe258, 0xb77d, 0xba5f, 0xe242, 0xe25d,
/* 18 */ 0xfd52, 0xe247, 0xe255, 0xba64, 0xba5d,    BAD, 0xe25b, 0x8dc1,
/* 20 */ 0xe240, 0xe25a, 0x8e46, 0xba6f, 0xe251, 0xe261, 0xba6d, 0xe249,
/* 28 */ 0xba5e, 0xe24b, 0xe259, 0xba67, 0xe244, 0xba6b, 0xba61, 0xe24d,
/* 30 */ 0xe243, 0xe1fc, 0xa0d1, 0xe257, 0xba68, 0xe260, 0xe1fd, 0xba65,
/* 38 */    BAD, 0xe253,    BAD, 0xba66, 0xe245, 0xe250, 0xe24c, 0xe24e
},

/* Row 0x25c */
{
/* 00 */ 0x9fca, 0xba60, 0xe25f, 0xba6e, 0xe24f,    BAD, 0xe262,    BAD,
/* 08 */    BAD, 0xe1fe, 0xe254, 0xba63, 0xba6c, 0xba6a, 0xe241, 0xe256,
/* 10 */ 0xba69, 0x92cf,    BAD, 0xba62, 0xe252, 0x9cf4, 0x8dc4,    BAD,
/* 18 */    BAD, 0xe25c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xfd41, 0xe5d5,    BAD, 0xe5d1, 0xe5cd, 0xe5e1, 0xe5de,
/* 28 */ 0xbccd, 0x9b4c,    BAD, 0xe5e5, 0xe5d4, 0xbcd8, 0xe5db,    BAD,
/* 30 */    BAD, 0xe5d0, 0xe5da, 0xbcd5, 0xe5ee,    BAD, 0xe5eb, 0xe5dd,
/* 38 */ 0xe5ce, 0xfd57, 0xfcef, 0xe5e2, 0xe5e4, 0xbcd1, 0xe5d8, 0xe5d3
},

/* Row 0x25d */
{
/* 00 */ 0xe5ca, 0xbcce, 0xbcd6, 0x9cde, 0xe5e7, 0xbcd7, 0xe5cb, 0xe5ed,
/* 08 */ 0xe5e0, 0xe5e6, 0xbcd4, 0xfd42, 0x986c, 0xe5e3,    BAD, 0xe5ea,
/* 10 */    BAD, 0xbcd9,    BAD, 0xbcd3, 0xe5dc, 0xe5cf, 0xe5ef, 0xe5cc,
/* 18 */ 0xe5e8, 0xbcd0, 0x97f9, 0xe5d6, 0x9558, 0xe5d7, 0xbccf, 0xbccc,
/* 20 */ 0xe5d2, 0xbcd2,    BAD, 0xbccb,    BAD, 0xe5e9, 0xe5ec, 0xe5d9,
/* 28 */ 0xe9ca,    BAD,    BAD, 0x985e, 0xfe7b, 0x94cd,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xe9c2, 0x93ee, 0xe9be, 0xbef6,    BAD,    BAD,
/* 38 */ 0xbeeb, 0xbef0, 0xbeec, 0xe9cc, 0xe9d7, 0xbeea, 0xe9c4, 0xe9cd
},

/* Row 0x25e */
{
/* 00 */ 0xe5df, 0xe9ce,    BAD,    BAD, 0xbef1, 0xfd5a, 0xe9dd, 0xbef5,
/* 08 */ 0xbef8, 0xe9c0,    BAD, 0xbef4, 0x93f5, 0xe9db, 0xe9dc, 0xe9d2,
/* 10 */ 0xe9d1, 0xe9c9, 0x93ef, 0x8eea, 0xe9d3, 0xe9da, 0xe9d9, 0x8f5b,
/* 18 */ 0xbeef, 0xbeed, 0xe9cb, 0xe9c8,    BAD, 0xe9c5, 0xe9d8, 0xbef7,
/* 20 */ 0xe9d6, 0xbef3, 0xbef2,    BAD, 0xe9d0, 0x8dc6, 0xe9bf, 0xe9c1,
/* 28 */ 0xe9c3, 0xe9d5, 0xe9cf, 0xbeee,    BAD, 0xe9c6,    BAD, 0xe9d4,
/* 30 */    BAD, 0x8dc8,    BAD,    BAD, 0x8dc7,    BAD, 0xe9c7,    BAD,
/* 38 */    BAD,    BAD, 0x93f7,    BAD,    BAD,    BAD, 0xc0cf, 0xed45
},

/* Row 0x25f */
{
/* 00 */ 0xc0c8, 0xecf5, 0x8dc9, 0xed41, 0xc0ca, 0xed48,    BAD, 0xecfc,
/* 08 */    BAD, 0xecf7, 0xfbf2,    BAD, 0xed49, 0xecf3, 0xecfe, 0x9670,
/* 10 */ 0xc0d1, 0xed44, 0xed4a, 0xecfd, 0xc0c9, 0xed40, 0xecf4, 0xc0d0,
/* 18 */    BAD, 0x8dcb, 0xed47, 0xecf9, 0xc0cc, 0xfd5c, 0xecfb, 0xecf8,
/* 20 */ 0xc0d2, 0xecfa, 0xc0cb, 0xc0ce, 0xed43, 0xecf6, 0xed46, 0x8f65,
/* 28 */ 0xed42,    BAD,    BAD, 0x8dcd, 0xc263, 0xefe7, 0xc268, 0xc269,
/* 30 */    BAD, 0x9da8, 0x94f9, 0xc262, 0xefe6, 0x8dce, 0xefe3, 0xefe4,
/* 38 */ 0xc266, 0xefde, 0xefe2, 0xc265,    BAD, 0xefdf, 0x93ea,    BAD
},

/* Row 0x260 */
{
/* 00 */    BAD,    BAD, 0xc267, 0xc264,    BAD, 0xefdd, 0xefe1, 0xefe5,
/* 08 */ 0xfd5f, 0x93f0, 0x9fb6, 0xf251, 0xf24e, 0xf257,    BAD, 0xf256,
/* 10 */ 0xf254, 0xf24f,    BAD, 0xc372, 0x8dcf,    BAD,    BAD,    BAD,
/* 18 */ 0x9763, 0xf250, 0xc371, 0xc0cd, 0xf253, 0xc370, 0xf258, 0xf252,
/* 20 */ 0xf24d, 0xefe0,    BAD,    BAD,    BAD, 0xc36f,    BAD, 0xf24c,
/* 28 */ 0xf456,    BAD, 0xf455, 0xf255, 0xc468,    BAD, 0xf459, 0xf45a,
/* 30 */ 0xf454, 0xf458,    BAD, 0xf453,    BAD,    BAD, 0x8dd0,    BAD,
/* 38 */ 0xf5d1, 0xf457, 0xc4e7, 0xc4e5, 0xf5cf,    BAD,    BAD,    BAD
},

/* Row 0x261 */
{
/* 00 */ 0xf5d2,    BAD, 0xf5ce, 0xf5d0, 0xc4e6, 0x93f1,    BAD,    BAD,
/* 08 */ 0xf6e5, 0xf6e6, 0xc576, 0xf6e4,    BAD,    BAD,    BAD, 0xf7e2,
/* 10 */ 0xc5cf, 0xf7e0, 0xf7e1, 0xf8ac,    BAD,    BAD, 0xc656, 0xf8f3,
/* 18 */ 0xf8f1, 0xf8f2, 0xf8f4,    BAD,    BAD, 0xfd62, 0xf9bb,    BAD,
/* 20 */ 0xa4ed, 0xa6b8,    BAD, 0xaa59,    BAD, 0xcce9,    BAD,    BAD,
/* 28 */ 0xcf64,    BAD,    BAD,    BAD, 0xd1f5, 0xd1f7,    BAD, 0xd1f6,
/* 30 */    BAD, 0xd1f8, 0xb1fd, 0xd5d7, 0xd1f9, 0xfd65, 0xd5d6, 0xd5d8,
/* 38 */ 0xd5d9, 0xd9da, 0xb4db, 0xd9db, 0xd9dd, 0xb4dc, 0xb4da, 0xd9dc
},

/* Row 0x262 */
{
/* 00 */    BAD, 0xddfa, 0xddf8, 0xddf7,    BAD, 0xddf6, 0xddf5, 0xb7b2,
/* 08 */ 0xddf9, 0xba70, 0xe263, 0xe265, 0xba71, 0xe264, 0xbcdb,    BAD,
/* 10 */ 0xbcda, 0xe5f0, 0x9fdb,    BAD, 0xe9df, 0xe9de, 0xe9e0, 0x93f8,
/* 18 */    BAD, 0xbef9,    BAD, 0xed4b, 0xc0d3,    BAD, 0xefe8, 0xc26a,
/* 20 */ 0xf259, 0xc577, 0xa4ee, 0xa5bf, 0xa6b9, 0xa842, 0xaa5a, 0xaa5b,
/* 28 */    BAD,    BAD, 0xac6e,    BAD,    BAD, 0xd1fa,    BAD, 0x8bf7,
/* 30 */    BAD,    BAD, 0xb7b3,    BAD, 0xfd66,    BAD, 0xe6d1, 0xbefa,
/* 38 */ 0xc26b, 0xa4ef, 0x8bcf, 0xa6ba,    BAD,    BAD, 0xcceb, 0xaa5c
},

/* Row 0x263 */
{
/* 00 */ 0xccea, 0x8dd1, 0xcf65, 0xac6f, 0xcf66,    BAD, 0xac70,    BAD,
/* 08 */ 0xd1fc, 0xaeee, 0xaeed,    BAD, 0xd5de, 0xd5dc, 0xd5dd, 0xd5db,
/* 10 */    BAD, 0xd5da,    BAD,    BAD, 0xd9de, 0xd9e1, 0xb4de, 0xd9df,
/* 18 */ 0xb4dd, 0xd9e0,    BAD, 0xddfb,    BAD,    BAD, 0xe266, 0xe267,
/* 20 */ 0xe268,    BAD, 0xe5f3, 0xe5f2, 0xbcdc, 0xe5f1, 0xe5f4, 0xe9e1,
/* 28 */    BAD,    BAD, 0xe9e2, 0xe9e3,    BAD, 0xed4c, 0xc0d4, 0xc26c,
/* 30 */ 0xf25a,    BAD, 0xc4e8, 0xc95f,    BAD, 0xac71, 0xcf67, 0xaeef,
/* 38 */    BAD,    BAD, 0xb1fe,    BAD, 0xb4df, 0xd9e2,    BAD, 0xb7b5
},

/* Row 0x264 */
{
/* 00 */ 0xb7b4, 0x8dd2,    BAD, 0xe269, 0xe26a, 0xbcdd, 0xbcde, 0xe9e5,
/* 08 */ 0xe9e4, 0xefe9, 0xf7e3, 0xa4f0, 0xc960, 0xa5c0,    BAD, 0xa843,
/* 10 */ 0xcb48,    BAD, 0xac72, 0xb7b6, 0xa4f1,    BAD, 0xcf68, 0xac73,
/* 18 */ 0xcf69,    BAD, 0xc0d5, 0xa4f2, 0xfd71,    BAD, 0xccec,    BAD,
/* 20 */ 0xcf6a, 0xfd6f, 0xd242, 0xd241, 0xd1fe,    BAD, 0xd1fd, 0xd243,
/* 28 */ 0xd240,    BAD, 0x8dd3, 0xb240, 0xb241,    BAD,    BAD, 0xb4e0,
/* 30 */ 0xd9e3,    BAD, 0xd9e4, 0xd9e5,    BAD,    BAD,    BAD, 0xde41,
/* 38 */ 0xde42, 0xde40, 0x9fe7, 0xddfd, 0xddfe, 0xb7b7, 0xe26b, 0xe5f7
},

/* Row 0x265 */
{
/* 00 */ 0xe5f6, 0xe5f5, 0xe5f8, 0xe9e7, 0xe9e6, 0xbefb, 0xe9e8,    BAD,
/* 08 */ 0xc0d6, 0xed4d,    BAD, 0xefea, 0xf25b, 0xf6e7,    BAD, 0xa4f3,
/* 10 */ 0xa5c2, 0xa5c1,    BAD, 0xaa5d, 0xc961, 0xc97e, 0xa6bb,    BAD,
/* 18 */ 0xc9f7, 0xcb49, 0xcb4a, 0xaa5e, 0x90bd, 0xcced,    BAD, 0xac74,
/* 20 */ 0xcf6b, 0xcf6c,    BAD, 0xaef0, 0xaef4, 0xd244, 0xaef3, 0xaef1,
/* 28 */ 0xaef2,    BAD, 0xd5df, 0xb242, 0xb4e3,    BAD, 0xb4e1, 0xb4e2,
/* 30 */ 0xd9e6, 0x9fd0,    BAD, 0xba72, 0xa4f4, 0x8bd0, 0xc9a1, 0xfd72,
/* 38 */ 0xa5c3, 0x9cae, 0x8bd1, 0xc9a4,    BAD, 0x8adb, 0xa5c6, 0xc9a3
},

/* Row 0x266 */
{
/* 00 */ 0xa5c5, 0xa5c4, 0xa844, 0xc9a2,    BAD,    BAD, 0xc9f8,    BAD,
/* 08 */    BAD, 0xfae4, 0xc9fc, 0xc9fe, 0xca40, 0xa6c5, 0xa6c6, 0xc9fb,
/* 10 */ 0xa6c1,    BAD, 0xc9f9,    BAD, 0xc9fd, 0xa6c2,    BAD, 0xa6bd,
/* 18 */ 0x95ce, 0xa6be, 0xfd76, 0xa6c4, 0xc9fa, 0xa6bc, 0xa845, 0xa6bf,
/* 20 */ 0xa6c0, 0xa6c3,    BAD,    BAD,    BAD, 0xcb5b, 0xcb59, 0xcb4c,
/* 28 */ 0xa851, 0xcb53, 0xa84c, 0xcb4d,    BAD, 0xcb55, 0xfb62, 0xcb52,
/* 30 */ 0xa84f, 0xcb51, 0xa856, 0xcb5a, 0xa858, 0x8dd4, 0xa85a,    BAD,
/* 38 */ 0xcb4b, 0xfd78, 0xa84d, 0xcb5c,    BAD, 0xa854, 0xa857, 0x8ee3
},

/* Row 0x267 */
{
/* 00 */ 0xcd45, 0xa847, 0xa85e, 0xa855, 0xcb4e, 0xa84a, 0xa859, 0xcb56,
/* 08 */ 0xa848, 0xa849, 0xcd43, 0xcb4f, 0xa850, 0xa85b, 0xcb5d, 0xcb50,
/* 10 */ 0xa84e,    BAD, 0xa853, 0xccee, 0xa85c, 0xcb57, 0xa852,    BAD,
/* 18 */ 0xa85d, 0xa846, 0xcb54, 0xa84b, 0xcb58, 0xcd44,    BAD, 0x9076,
/* 20 */    BAD,    BAD, 0x98c6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x8dd5, 0xaa6a, 0xaa7a, 0xccf5, 0xaa71, 0x97d1,
/* 30 */ 0xcd4b, 0xaa62, 0x9eb6, 0xaa65, 0xcd42,    BAD, 0xccf3, 0xccf7,
/* 38 */ 0xaa6d, 0xaa6f, 0xccfa, 0xaa76, 0xaa68, 0xaa66, 0xaa67, 0xaa75
},

/* Row 0x268 */
{
/* 00 */ 0xcd47, 0xaa70, 0xccf9, 0xccfb, 0xaa6e, 0xaa73, 0xccfc, 0xcd4a,
/* 08 */    BAD, 0xac75, 0xaa79, 0xfac7, 0xaa63, 0xcd49, 0xa042, 0xcd4d,
/* 10 */ 0xccf8, 0xcd4f, 0xcd40, 0xaa6c, 0xccf4, 0xaa6b, 0xaa7d, 0xaa72,
/* 18 */    BAD, 0xccf2, 0xcf75, 0xaa78, 0xaa7c, 0xcd41, 0xcd46, 0x9873,
/* 20 */ 0xaa7e, 0xaa77, 0xaa69, 0xaa5f,    BAD, 0xaa64,    BAD, 0xccf6,
/* 28 */ 0xaa60, 0xcd4e, 0x9ffc, 0xccf0, 0xccef, 0xccfd, 0xccf1, 0xaa7b,
/* 30 */ 0xaef5, 0xaa74, 0xccfe, 0xaa61,    BAD, 0xaca6,    BAD,    BAD,
/* 38 */    BAD, 0xcd4c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x269 */
{
/* 00 */ 0xcf7c, 0xcfa1, 0x8dd7, 0xcfa4, 0xcf77, 0x92fb, 0x8dd8, 0xcfa7,
/* 08 */ 0xcfaa, 0xcfac, 0xcf74, 0xac76, 0xac7b, 0xd249, 0xacad, 0xcfa5,
/* 10 */ 0xcfad, 0xcf7b, 0xcf73,    BAD,    BAD,    BAD, 0xd264, 0xac7e,
/* 18 */ 0xcfa2, 0xcf78, 0xcf7a, 0xaca5,    BAD, 0xcf7d, 0xac7d, 0xcf70,
/* 20 */ 0xcfa8,    BAD, 0xcfab,    BAD, 0x944f, 0xac7a, 0x8dd9, 0xaca8,
/* 28 */ 0xcf6d, 0xacaa, 0xac78, 0xacae, 0xcfa9, 0xcf6f, 0xacab, 0xd25e,
/* 30 */ 0xcd48, 0xac7c, 0xac77, 0xcf76, 0xcf6e, 0xacac, 0xaca4, 0xcfa3,
/* 38 */ 0xaca9, 0xaca7, 0xcf79, 0xaca1, 0xcf71, 0xaca2, 0xaca3, 0xcf72
},

/* Row 0x26a */
{
/* 00 */ 0xcfa6, 0xac79, 0xcf7e,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x896b,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x97ce,
/* 18 */ 0xd24c, 0xaefd, 0xaf43, 0xfaf3, 0xfdae,    BAD, 0xd255, 0xd25b,
/* 20 */ 0xd257, 0xd24a, 0xd24d, 0xd246, 0xd247, 0xaf4a, 0xaefa, 0xd256,
/* 28 */ 0xd25f, 0xaf45, 0xaef6,    BAD, 0xaf40, 0xd24e, 0xaf42, 0xd24f,
/* 30 */ 0xd259, 0xfbaf, 0x92b7,    BAD, 0xaf44, 0xd268, 0xd248, 0xaefc,
/* 38 */ 0xaefb, 0xaf48, 0xd245, 0xd266, 0xd25a, 0xd267, 0xd261, 0xd253
},

/* Row 0x26b */
{
/* 00 */ 0xd262, 0x8dda, 0xd25c, 0xd265, 0xd263, 0xaf49, 0xd254, 0xaef9,
/* 08 */ 0xaef8, 0xaf41, 0xaf47, 0xd260, 0xaf46, 0xd251, 0xb243, 0x9c5a,
/* 10 */ 0xd269, 0xd250, 0xd24b, 0xaefe, 0xaf4b, 0xaef7, 0xfdad, 0xd258,
/* 18 */ 0xd25d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x8ddc, 0x9444,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xb265, 0xd5e1, 0xd5e5,    BAD, 0xb252, 0xb250,
/* 30 */    BAD, 0x8ddd, 0xb247, 0xd5e3, 0xd5e2, 0xb25b,    BAD, 0xd5e8,
/* 38 */ 0xb255, 0xa0d6, 0xd5fa, 0xd647, 0xb244, 0xd5f7, 0xd5f0, 0xb267
},

/* Row 0x26c */
{
/* 00 */ 0xd5eb,    BAD, 0x97d5, 0xd9fc, 0x944a, 0xb24d,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x944d,    BAD,    BAD,    BAD,    BAD, 0x97cb,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8dde,    BAD,    BAD,
/* 18 */ 0x8ddf, 0xb541, 0xb25a, 0xb4ee, 0xd9f6, 0xb4fc,    BAD, 0xd9ea,
/* 20 */ 0xb4eb, 0xb4e7, 0xda49, 0xb4ed, 0xb4f1, 0xb4ec, 0xb4f5, 0xda4d,
/* 28 */ 0xda44, 0x8de0, 0xfef9, 0xd9f1, 0xb4fa, 0xb4f4, 0xd9fd, 0xb4e4,
/* 30 */ 0xda4a, 0xda43, 0xb4e8, 0xd9f7, 0xb4f7, 0xda55, 0xda56,    BAD,
/* 38 */ 0xb4e5, 0xda48, 0xb4f9, 0xd9fb, 0xd9ed, 0xd9ee, 0xb4fd, 0xd9f2
},

/* Row 0x26d */
{
/* 00 */ 0xd9f9, 0xd9f3,    BAD, 0xb4fb, 0xb544, 0xd9ef, 0xd9e8, 0xd9e9,
/* 08 */    BAD, 0xd9eb, 0xb4ea, 0xd9f8,    BAD, 0xb4f8, 0xb542, 0xfdc0,
/* 10 */ 0xfcf9, 0xd9fa, 0xda53, 0xda4b, 0xb4e6, 0xda51, 0xb4f2,    BAD,
/* 18 */ 0xb4f0, 0xfb7e, 0xda57, 0xb4ef, 0xda41, 0xd9f4, 0xd9fe, 0xb547,
/* 20 */ 0xda45, 0xda42, 0xd9f0, 0xb543, 0xda4f, 0xda4c, 0xda54, 0xb4e9,
/* 28 */ 0xda40, 0xb546,    BAD, 0xda47,    BAD,    BAD, 0xb4f3, 0xb4f6,
/* 30 */    BAD, 0xda46, 0xb545, 0xd9f5, 0xd5e4,    BAD, 0x92b3, 0xda50,
/* 38 */ 0xda4e, 0xda52,    BAD,    BAD, 0xfdaf,    BAD,    BAD,    BAD
},

/* Row 0x26e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8de1,    BAD,
/* 08 */ 0xd9ec, 0xb540,    BAD, 0x95d3,    BAD, 0xde61, 0xde60, 0xde46,
/* 10 */ 0xb7bd,    BAD, 0xde5f, 0xde49, 0xde4a,    BAD, 0xb7c7, 0xde68,
/* 18 */ 0xb7c2, 0xde5e, 0x89c1, 0xde43, 0xb7c8, 0xb7be, 0xde52, 0xde48,
/* 20 */ 0xde4b, 0xde63, 0xb7b8, 0xde6a, 0xde62, 0xb7c1, 0xde57, 0xb7cc,
/* 28 */    BAD,    BAD, 0xb7cb, 0xb7c5,    BAD,    BAD, 0xde69, 0xb7b9,
/* 30 */ 0xde55, 0xde4c, 0xde59, 0xde65, 0xb7cd, 0xfd68, 0xb7bb, 0xde54,
/* 38 */ 0x9cb7, 0xde4d, 0xb7c4, 0x8de3, 0xb7c3, 0xde50, 0xde5a, 0xde64
},

/* Row 0x26f */
{
/* 00 */ 0xde47, 0xde51, 0xb7bc, 0xde5b, 0xb7c9, 0xb7c0, 0xde4e, 0xb7bf,
/* 08 */ 0xde45, 0xde53, 0xde67, 0xb4fe, 0xbab0, 0xde56, 0xe26c, 0xde58,
/* 10 */ 0xde66, 0xb7c6, 0xde4f, 0xb7ba, 0xb7ca, 0xbcf0, 0xde44,    BAD,
/* 18 */ 0xde5d, 0xfac0, 0x8de5, 0xfa64, 0xde5c, 0x8947,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x8de4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8de7, 0x8de8,    BAD, 0xe2aa, 0xbaad, 0xe27d, 0xe2a4, 0xbaa2,
/* 30 */    BAD, 0xe26e, 0xbaaf,    BAD, 0xba77, 0xe26d, 0xe2b0, 0xbab1,
/* 38 */ 0xe271, 0xe2a3, 0xfdc7, 0xe273, 0xe2b3, 0xe2af, 0xba75, 0xbaa1
},

/* Row 0x270 */
{
/* 00 */ 0xe653, 0xbaae, 0xba7d, 0xe26f, 0xfdb0, 0xe2ae, 0xbaa3, 0xe2ab,
/* 08 */ 0xe2b8, 0xe275, 0xe27e, 0x9445, 0x97d6, 0xe2b6, 0xe2ac, 0xba7c,
/* 10 */    BAD,    BAD, 0xe27c, 0xba76, 0xba74, 0xbaa8, 0xfcc6, 0x9844,
/* 18 */ 0xe27a, 0xe277, 0xe278,    BAD, 0xe2b2,    BAD, 0xe2b7, 0xe2b5,
/* 20 */ 0xba7a, 0xe2b9, 0xba7e, 0xbaa7, 0x8de9, 0xe270, 0xe5fa, 0xe279,
/* 28 */    BAD, 0xba78, 0xbaac, 0xbaa9, 0xba7b, 0xe2a5, 0xe274, 0xbaaa,
/* 30 */ 0xe2a7, 0xbaa4, 0xbaa6, 0xba73, 0x8dea, 0xe2a9, 0xe2a1, 0xe272,
/* 38 */ 0xbaa5, 0xe2b1, 0xe2b4, 0xe27b, 0xe2a8, 0xfe50, 0xba79, 0xbcdf
},

/* Row 0x271 */
{
/* 00 */ 0xe2a6, 0xe5f9,    BAD, 0xe2ad, 0xfdcc,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xe276, 0xe644,
/* 10 */ 0xe64e, 0xbce2, 0xe64d, 0xe659, 0xbce4, 0xe64b, 0x9da7, 0xe64f,
/* 18 */ 0xbcef,    BAD, 0xe646, 0xbce7, 0xfdcd, 0xe652, 0xe9f0, 0xbcf3,
/* 20 */ 0xbcf2, 0xe654, 0xe643, 0xe65e, 0xbced,    BAD, 0xbce3, 0xe657,
/* 28 */    BAD, 0xe65b, 0xe660, 0xe655, 0xe649, 0xbce6, 0xbce9, 0xbcf1,
/* 30 */ 0xbcec,    BAD, 0xe64c, 0xe2a2, 0xfdcf,    BAD, 0xe648, 0xe65f,
/* 38 */ 0xbce8, 0x95d2, 0xbceb, 0xe661, 0xbce0, 0xe656, 0xe5fb, 0xe65c
},

/* Row 0x272 */
{
/* 00 */ 0xc0df, 0x8ded, 0xe64a,    BAD, 0xbce1, 0xe645, 0xbce5, 0xe5fc,
/* 08 */ 0xbaab, 0xe641, 0xfcba, 0xe65a, 0xe642, 0xe640, 0xbcea,    BAD,
/* 10 */ 0xe658,    BAD, 0xe5fe, 0xe651, 0xe650, 0xe65d, 0xe647, 0xbcee,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfdc5, 0xe9f3, 0xfdd2,
/* 20 */ 0xbf49, 0xbefe, 0xea40, 0xe9eb, 0xbf41, 0xe9f7, 0xbf48, 0xbf43,
/* 28 */ 0xe9f5, 0xed4f, 0xe9fb, 0xea42, 0xe9fa, 0xe9e9, 0xe9f8, 0xea44,
/* 30 */ 0xea46, 0xbefd, 0xea45, 0xbf44, 0xbf4a, 0x9cdc, 0xbf47,    BAD,
/* 38 */ 0xe9fe, 0xbf46, 0xe9f9, 0x95cf, 0xe9ed, 0xe9f2, 0x8dee, 0xe9fd
},

/* Row 0x273 */
{
/* 00 */ 0xbf45, 0xbf42, 0xbefc, 0xbf40, 0xe9f1,    BAD, 0xe5fd, 0xe9ec,
/* 08 */ 0xe9ef, 0xea41, 0xe9f4, 0xe9ea, 0xed4e, 0xea43, 0xe9ee, 0xe9fc,
/* 10 */    BAD,    BAD,    BAD, 0xfdd4, 0xed51, 0xc0e3,    BAD,    BAD,
/* 18 */ 0xc0d7, 0x96ec, 0x96eb, 0xc0db, 0xed53, 0xed59, 0xed57, 0xc0d9,
/* 20 */ 0xc0da, 0xc0e1, 0xed5a, 0xed52, 0xc0dc,    BAD, 0xed56, 0xed55,
/* 28 */ 0xed5b, 0xc0e2,    BAD, 0xc0dd, 0xc0e0, 0xed54, 0xc0e4, 0xc0de,
/* 30 */ 0xc0e5, 0xc0d8, 0xed58,    BAD, 0xed50,    BAD, 0x90b6, 0xeff7,
/* 38 */ 0xfdc3,    BAD, 0xc271, 0xeff4, 0xeff6,    BAD, 0xc26f, 0xeff2
},

/* Row 0x274 */
{
/* 00 */ 0xeff3, 0xefee,    BAD, 0x98ab, 0xe9f6, 0xefef, 0xc270, 0xefeb,
/* 08 */    BAD, 0xc26d, 0xeff8, 0xc26e, 0xefec, 0xefed, 0xeff1, 0xc273,
/* 10 */    BAD, 0xc272,    BAD,    BAD, 0xeff0, 0xc378, 0xf25f, 0xf265,
/* 18 */ 0xc379, 0xf25c, 0xc376, 0xc373, 0xf267, 0xc377, 0x96ee, 0xc374,
/* 20 */ 0xf25e, 0xf261, 0xf262, 0xf263, 0xf266,    BAD, 0xeff5, 0xf25d,
/* 28 */ 0xc375, 0xf264, 0xf268, 0xf260, 0x8df4,    BAD,    BAD, 0xf45d,
/* 30 */ 0xc46a, 0xf460, 0xc46b, 0xf468, 0xf45f, 0xf45c,    BAD, 0xf45e,
/* 38 */ 0xf462, 0xf465, 0xf464, 0xf467, 0xf45b,    BAD, 0xc469, 0xf463
},

/* Row 0x275 */
{
/* 00 */ 0xf466, 0xf469, 0xf461, 0xf5d3, 0xf5d4, 0xf5d8, 0xf5d9,    BAD,
/* 08 */ 0xf5d6, 0xf5d7, 0xf5d5, 0xfde0, 0xc4e9,    BAD,    BAD,    BAD,
/* 10 */ 0x8df6, 0xc578, 0xf6eb,    BAD, 0x8df7, 0xf6e8, 0xf6e9, 0xf6ea,
/* 18 */ 0xc579,    BAD, 0xf7e5, 0xf7e4, 0x8ffa, 0xf8af, 0xc5f4, 0xf8ad,
/* 20 */ 0xf8b0, 0xf8ae, 0xf8f5, 0xc657, 0xc665, 0xf9a3, 0xf96c, 0x97d0,
/* 28 */ 0xf9a2, 0xf9d0, 0xf9d1, 0xa4f5, 0x8bd2,    BAD,    BAD, 0x8df8,
/* 30 */ 0xa6c7, 0xca41,    BAD,    BAD, 0xcb5e, 0x90d9, 0xa85f,    BAD,
/* 38 */ 0xa862, 0xfaf0, 0xcb5f,    BAD, 0xa860, 0xa861, 0xfde1, 0x8df9
},

/* Row 0x276 */
{
/* 00 */    BAD, 0xfde3, 0xcd58, 0xcd5a, 0xcd55, 0xcd52, 0xcd54,    BAD,
/* 08 */    BAD, 0x8dfa, 0xaaa4, 0xfb63,    BAD,    BAD, 0xaaa2, 0x90a6,
/* 10 */    BAD, 0xcd56, 0xaaa3, 0xcd53, 0xcd50, 0xaaa1, 0xcd57,    BAD,
/* 18 */ 0xcd51, 0xaaa5, 0xcd59,    BAD,    BAD,    BAD,    BAD, 0xcfaf,
/* 20 */ 0x9970, 0xcfb3,    BAD, 0x91eb, 0xacb7, 0x9770, 0x986f, 0xfde2,
/* 28 */    BAD, 0xcfb6,    BAD, 0xacaf, 0xacb2, 0xacb4, 0xacb6, 0xacb3,
/* 30 */ 0xcfb2, 0xcfb1,    BAD, 0xacb1, 0xcfb4, 0xcfb5,    BAD, 0xcfae,
/* 38 */ 0xacb5, 0x98f2, 0xacb0, 0x9afc, 0x896c, 0xfdfd, 0xcfb0,    BAD
},

/* Row 0x277 */
{
/* 00 */ 0x995e,    BAD,    BAD,    BAD, 0x95bd, 0xd277, 0xd278, 0xd279,
/* 08 */ 0xaf50,    BAD, 0xaf4c, 0xd26e, 0xfde4, 0xd276, 0xd27b, 0xaf51,
/* 10 */ 0x91e6, 0xd26c, 0xd272, 0xd26b, 0xd275, 0xfde5, 0xfde6, 0xd271,
/* 18 */ 0xaf4d, 0xaf4f, 0xd27a,    BAD, 0xd26a, 0xd26d, 0xd273, 0xfde7,
/* 20 */ 0xd274, 0xd27c, 0xd270,    BAD, 0xaf4e,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xb26d,
/* 30 */ 0xd64e, 0x9454,    BAD, 0xd650, 0xd64c, 0x99b8, 0xd658, 0xd64a,
/* 38 */ 0xd657, 0xb269, 0xd648, 0xda5b, 0xd652, 0xb26c, 0x97e9, 0xd653
},

/* Row 0x278 */
{
/* 00 */ 0xd656,    BAD, 0xd65a,    BAD, 0xd64f, 0x9346, 0xd654,    BAD,
/* 08 */    BAD, 0xb26a, 0xb26b, 0xd659, 0xd64d, 0xd649, 0xd65b,    BAD,
/* 10 */ 0xd651,    BAD,    BAD, 0xd655,    BAD,    BAD,    BAD, 0xd64b,
/* 18 */    BAD, 0xb548, 0xb549, 0xda65, 0xb54f, 0x9863, 0xda59, 0xda62,
/* 20 */ 0xda58, 0xb54c, 0xda60, 0xda5e,    BAD, 0xda5f, 0xb54a,    BAD,
/* 28 */ 0xda63, 0x95bc,    BAD, 0xfded, 0xfdf7,    BAD, 0xda5c, 0xda5a,
/* 30 */ 0xb54b, 0xda5d, 0xda61, 0x9870, 0x96f6, 0x8ea9, 0xb54d,    BAD,
/* 38 */    BAD,    BAD, 0xda64, 0x9451,    BAD,    BAD, 0x8e43,    BAD
},

/* Row 0x279 */
{
/* 00 */ 0x8b5a, 0xde70, 0xde77, 0xde79, 0xdea1, 0xfdee, 0xb7da, 0xde6b,
/* 08 */    BAD, 0xb7d2, 0xfdf0, 0xde7a, 0xb7d7, 0xdea2, 0xb7ce, 0xfdf4,
/* 10 */ 0xde7d, 0x9bf5, 0xde6d, 0xde7e, 0xde6c,    BAD, 0xb7dc,    BAD,
/* 18 */ 0xde78, 0xb7cf, 0xdea3,    BAD, 0xb7d4, 0xde71, 0xb7d9, 0xde7c,
/* 20 */ 0xde6f, 0xde76, 0xde72, 0xde6e, 0xb7d1, 0xb7d8, 0xb7d6, 0xb7d3,
/* 28 */ 0xb7db, 0xb7d0, 0xde75, 0x977e, 0xb7d5,    BAD, 0xb54e,    BAD,
/* 30 */ 0xde7b, 0x9bd5, 0xde73, 0x9ac3,    BAD, 0x97c8, 0xa0db, 0x91d0,
/* 38 */ 0xde74,    BAD, 0x9fe4, 0xe2c1, 0x8fdd, 0xbab4, 0x91e9,    BAD
},

/* Row 0x27a */
{
/* 00 */ 0xe2bd, 0xe2c3, 0xe2bf,    BAD, 0xbab6, 0xe2be, 0xe2c2, 0xe2ba,
/* 08 */ 0x98e0, 0xe2bc, 0xbab5,    BAD, 0x92ca,    BAD, 0x9857, 0xe2c0,
/* 10 */ 0xe2bb,    BAD, 0xbab7,    BAD, 0xbab2,    BAD, 0xfdeb, 0xe2c4,
/* 18 */ 0x9b49, 0xbab3, 0xe667, 0xe664, 0xe670, 0xe66a, 0xe66c, 0xbcf4,
/* 20 */ 0xe666, 0xe66e, 0x9d76, 0x9eaf, 0xe66d, 0xe66b,    BAD, 0xe671,
/* 28 */ 0xbcf7, 0xe668, 0xe66f,    BAD, 0xbcf5, 0x9ccc,    BAD, 0xe663,
/* 30 */ 0xe665, 0xbcf6, 0xe662, 0xe672, 0xfdea, 0xe669,    BAD, 0x8df1,
/* 38 */ 0xea4a, 0xbf51, 0xfdfb,    BAD, 0xea55, 0xea53, 0xbf4b, 0xea49
},

/* Row 0x27b */
{
/* 00 */ 0xea4c, 0xea4d, 0xea48, 0xbf55, 0xbf56, 0xea47, 0xea56, 0xea51,
/* 08 */ 0xbf4f, 0xbf4c, 0xea50, 0xea4e,    BAD,    BAD, 0xbf52, 0xea52,
/* 10 */ 0xbf4d, 0x8e53, 0xbf4e,    BAD, 0xea4f, 0xbf50, 0xea4b,    BAD,
/* 18 */ 0xea54, 0xbf53, 0xea57, 0xea58, 0xbf54, 0xfacf,    BAD, 0xc0e7,
/* 20 */ 0xc0ee, 0xed5c, 0xed62,    BAD, 0xed60, 0xc0ea, 0xc0e9, 0xc0e6,
/* 28 */ 0xed5e,    BAD,    BAD, 0x96f9, 0xc0ec, 0xc0eb, 0xc0e8,    BAD,
/* 30 */ 0xed61, 0xed5d, 0xed5f,    BAD, 0xc0ed, 0x98bf, 0x9e49,    BAD,
/* 38 */ 0xc277, 0xeffb,    BAD, 0xc274, 0xc275, 0xeffd, 0xc276, 0xeffa
},

/* Row 0x27c */
{
/* 00 */    BAD, 0xeff9, 0xf26c, 0xeffc,    BAD, 0xf26d, 0xc37a, 0xf26b,
/* 08 */    BAD, 0x9bca, 0xf26a,    BAD, 0xf269, 0xc37b, 0xfdfe, 0x92dc,
/* 10 */ 0xc46c,    BAD,    BAD, 0xf46a, 0xf46b, 0xfe41, 0x91cc, 0x91e2,
/* 18 */    BAD, 0xf5dc, 0xf5db, 0xc4ea,    BAD, 0xf5da, 0xf6ec, 0xf6ed,
/* 20 */    BAD,    BAD, 0xf7e6, 0xf8b1, 0xfe44,    BAD, 0xf8f6, 0xf9bc,
/* 28 */ 0xc679, 0xf9c6, 0xa4f6, 0x8bd3, 0xaaa6, 0xaaa7, 0xfe47,    BAD,
/* 30 */ 0xacb8,    BAD,    BAD,    BAD,    BAD, 0xc0ef, 0xa4f7,    BAD,
/* 38 */ 0xaaa8, 0xaf52, 0xb7dd, 0xa4f8,    BAD, 0xb26e, 0xbab8, 0xc962
},

/* Row 0x27d */
{
/* 00 */ 0xfe48, 0xcfb7, 0xd27d,    BAD, 0xe2c5,    BAD, 0xc0f0, 0xa4f9,
/* 08 */ 0xaaa9, 0xcfb8, 0xcfb9, 0xda66, 0xb550,    BAD,    BAD, 0xdea4,
/* 10 */ 0x9455,    BAD, 0xb7de, 0xe2c6,    BAD, 0xfe4b, 0xbcf8, 0xfe4c,
/* 18 */ 0xc37c, 0xa4fa, 0xda67, 0xa4fb, 0x8dbf, 0xa6c9, 0xca42, 0xa6c8,
/* 20 */ 0xa865, 0xa864, 0xa863, 0xcb60,    BAD,    BAD, 0x9e78, 0xaaaa,
/* 28 */    BAD, 0xaaab, 0xcd5b,    BAD, 0xcfba,    BAD, 0xcfbd, 0xacba,
/* 30 */ 0xcfbb,    BAD, 0xacb9, 0xcfbc, 0xacbb,    BAD, 0xd2a2, 0xd2a1,
/* 38 */ 0xd27e, 0xaf53,    BAD, 0xd65d, 0xd65e, 0xb26f, 0xd65c, 0xd65f
},

/* Row 0x27e */
{
/* 00 */ 0xb552, 0xb270, 0xfe51,    BAD, 0xb551, 0xda6b, 0xda6a, 0x9456,
/* 08 */ 0xda68, 0xda69,    BAD, 0xda6c, 0xdea6, 0xdea5, 0xdea9, 0x9d61,
/* 10 */ 0xdea8, 0xdea7, 0xbab9, 0xe2c9, 0x9457, 0xe2c8, 0xbaba, 0xe2c7,
/* 18 */ 0xe673,    BAD, 0xe674, 0xbcf9,    BAD, 0xea59, 0xea5a, 0x9966,
/* 20 */    BAD, 0xf272, 0xc37d, 0xf271, 0xf270, 0xf26e, 0xf26f, 0xc4eb,
/* 28 */ 0xf46c, 0xf6ee, 0xf8f7,    BAD, 0xa4fc, 0x8bd5, 0xc9a5, 0xa5c7,
/* 30 */ 0xc9a6,    BAD, 0xa069,    BAD, 0xca43, 0xca44,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xcb66,    BAD,    BAD, 0xcb62,    BAD, 0xcb61
},

/* Row 0x27f */
{
/* 00 */ 0xaaac, 0xcb65, 0xa867, 0xcb63, 0xa866, 0xcb67, 0xcb64,    BAD,
/* 08 */    BAD, 0xcd5f, 0xcfbe, 0xcd5d, 0xcd64, 0x98b4, 0xaaad,    BAD,
/* 10 */ 0xaab0, 0xcd65, 0xcd61,    BAD, 0xcd62,    BAD, 0xcd5c, 0xaaaf,
/* 18 */ 0xcd5e, 0xaaae, 0xcd63,    BAD, 0xcd60,    BAD,    BAD, 0xcfc2,
/* 20 */ 0xacbd, 0xacbe, 0xa049, 0xcfc5, 0xcfbf,    BAD, 0xcfc4,    BAD,
/* 28 */ 0xcfc0, 0xacbc, 0xcfc3, 0xcfc1,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xd2a8, 0xd2a5,    BAD, 0xd2a7, 0xaf58,
/* 38 */ 0xaf57, 0xaf55, 0xd2a4, 0xd2a9, 0xaf54, 0xaf56, 0xd2a6, 0xd667
},

/* Row 0x280 */
{
/* 00 */ 0xd2a3, 0xd2aa, 0xa04c,    BAD, 0x9e65,    BAD,    BAD, 0xd662,
/* 08 */ 0xd666,    BAD, 0xd665, 0xda6e, 0xda79,    BAD,    BAD, 0xd668,
/* 10 */ 0x98b5, 0xd663, 0xda6d, 0xb274,    BAD,    BAD, 0xb273, 0xd661,
/* 18 */ 0xd664, 0xb275,    BAD, 0xb272, 0xb271, 0xd660, 0xd669,    BAD,
/* 20 */    BAD,    BAD, 0xda70, 0xda77,    BAD, 0xb554, 0xda76, 0xda73,
/* 28 */ 0xfe58, 0xb556, 0x9975, 0xfe53, 0xa065, 0xda75, 0xfe59,    BAD,
/* 30 */ 0xda6f, 0xda71, 0xda74, 0xda72, 0xb555, 0xda78, 0xb553, 0xb7df,
/* 38 */ 0x98b7, 0x98b8, 0xdead, 0xdeac, 0xdeaa,    BAD, 0xb7e2, 0xb7e1
},

/* Row 0x281 */
{
/* 00 */ 0xdeae, 0x98ba, 0xdeab, 0xe2ca, 0xbabb, 0xb7e0,    BAD,    BAD,
/* 08 */ 0x98bb, 0xdeb0, 0xdeaf,    BAD, 0xe2cd, 0xe2cb, 0xbcfa, 0x9fbc,
/* 10 */ 0xbabc, 0xe2cc, 0xe676,    BAD,    BAD,    BAD,    BAD, 0xbcfb,
/* 18 */ 0xe675, 0xe67e, 0xe67d, 0xe67b,    BAD, 0xe67a, 0xe677, 0xe678,
/* 20 */ 0xe679, 0xe67c, 0xe6a1,    BAD,    BAD, 0xea5f, 0xea5c, 0xea5d,
/* 28 */ 0xbf57, 0xea5b, 0xea61, 0xea60, 0xea5e,    BAD, 0xed64, 0xed65,
/* 30 */ 0xc0f1, 0xa04a, 0xc0f2, 0xed63, 0x9ec7, 0xc279, 0xeffe, 0xc278,
/* 38 */ 0xc37e,    BAD, 0xc3a1, 0xc46d, 0xf46e, 0xf46d, 0xf5dd, 0xf6ef
},

/* Row 0x282 */
{
/* 00 */ 0xc57a, 0xf7e8, 0xf7e7, 0xf7e9, 0xa5c8, 0xcfc6, 0xaf59, 0xb276,
/* 08 */ 0xd66a, 0xa5c9, 0xc9a7, 0xa4fd,    BAD,    BAD, 0xca45, 0x98ae,
/* 10 */    BAD,    BAD, 0xcb6c, 0xcb6a, 0xcb6b, 0xcb68, 0xa868, 0xcb69,
/* 18 */ 0x92d6,    BAD,    BAD,    BAD, 0xfae1, 0xcd6d, 0x91d4, 0xaab3,
/* 20 */ 0xcd6b, 0xcd67, 0xcd6a,    BAD, 0xcd66, 0xaab5, 0xcd69, 0xfade,
/* 28 */ 0xaab2, 0xaab1, 0xfe5b, 0xaab4, 0xcd6c, 0xcd68,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xacc2, 0xacc5, 0xcfce, 0xcfcd, 0xcfcc, 0xacbf,
/* 38 */ 0xcfd5, 0xcfcb,    BAD, 0xacc1, 0xd2af,    BAD, 0xcfd2, 0xcfd0
},

/* Row 0x283 */
{
/* 00 */ 0xacc4,    BAD, 0xcfc8, 0xcfd3,    BAD, 0xcfca, 0xcfd4, 0xcfd1,
/* 08 */ 0xcfc9, 0xfe5e, 0xacc0, 0xcfd6, 0xcfc7, 0xacc3, 0xfbd7, 0xfe5a,
/* 10 */ 0x94c5,    BAD, 0xd2b4, 0xd2ab, 0xd2b6, 0xfaca, 0xd2ae, 0xd2b9,
/* 18 */ 0xd2ba, 0xd2ac, 0xd2b8, 0xd2b5, 0xd2b3, 0xd2b7, 0xaf5f,    BAD,
/* 20 */ 0xaf5d, 0x98c1, 0x975c, 0xd2b1, 0xfe74, 0xd2ad, 0x9773, 0xd2b0,
/* 28 */ 0xd2bb, 0xd2b2, 0xaf5e, 0xcfcf,    BAD, 0xaf5a, 0xaf5c, 0xfa46,
/* 30 */    BAD,    BAD,    BAD, 0x9764, 0xd678, 0xd66d, 0xd66b, 0xfe68,
/* 38 */ 0xd66c, 0x964e, 0xd673, 0x9765, 0xd674, 0xd670, 0xb27b, 0xd675
},

/* Row 0x284 */
{
/* 00 */ 0xd672, 0xd66f,    BAD, 0xb279, 0xd66e, 0xb277, 0xb27a, 0xd671,
/* 08 */ 0xd679, 0xaf5b, 0xb278, 0xd677, 0xd676, 0xb27c,    BAD,    BAD,
/* 10 */    BAD, 0x89a1, 0x95fa,    BAD, 0x92d4, 0xfe69, 0xda7e, 0xfb45,
/* 18 */    BAD, 0x98c8, 0xdaa1, 0xb560, 0x90ef, 0xdaa7, 0x98c9, 0x98ca,
/* 20 */ 0xdaa9, 0xdaa2, 0xb55a, 0xdaa6, 0xdaa5, 0xb55b, 0xb561,    BAD,
/* 28 */ 0xb562, 0xdaa8, 0xb558, 0xda7d, 0xda7b, 0xdaa3, 0xda7a, 0xb55f,
/* 30 */ 0xda7c, 0xdaa4, 0xdaaa, 0xb559, 0xb55e, 0xb55c, 0xb55d, 0x946d,
/* 38 */ 0x94b7, 0xfe6c, 0xb557,    BAD, 0x946b,    BAD,    BAD, 0xb7e9
},

/* Row 0x285 */
{
/* 00 */ 0xdeb7, 0xb7e8, 0xdebb, 0x92fc, 0xdeb1, 0x95eb, 0xdebc, 0xfe73,
/* 08 */ 0x976e, 0xfe5f, 0xdeb2, 0xdeb3,    BAD, 0xdebd, 0xdeba, 0xdeb8,
/* 10 */ 0xdeb9, 0xdeb5, 0xdeb4, 0xfdbd, 0xdebe, 0xb7e5, 0x92d5, 0xdeb6,
/* 18 */    BAD, 0xb7ea, 0xb7e4, 0xb7eb, 0xb7ec, 0xfeb9, 0xb7e7, 0xb7e6,
/* 20 */ 0xfe71,    BAD, 0xe2ce, 0xbabe, 0xbabd, 0xfbbb,    BAD, 0xe2d3,
/* 28 */ 0x947a, 0xbcfc, 0xbabf, 0x95fb, 0xfe77, 0xbac1, 0xe2d4, 0xb7e3,
/* 30 */ 0xbac0, 0xe2d0, 0xe2d2, 0xe2cf, 0xfe79, 0xe2d1, 0xfe75,    BAD,
/* 38 */    BAD, 0xe6ab, 0x945d,    BAD, 0xe6aa, 0xe6a7, 0xbd40, 0xea62
},

/* Row 0x286 */
{
/* 00 */ 0xbd41, 0xe6a6, 0xfe7c, 0xbcfe,    BAD, 0xe6a8, 0xe6a5, 0xe6a2,
/* 08 */ 0xe6a9, 0xe6a3, 0xe6a4, 0xbcfd, 0x9344, 0x8ea6,    BAD,    BAD,
/* 10 */ 0xed69,    BAD, 0xea66,    BAD, 0xea65, 0xea67,    BAD, 0xed66,
/* 18 */ 0xbf5a, 0x92d3, 0xea63, 0x94b8, 0xbf58,    BAD, 0xbf5c, 0xbf5b,
/* 20 */ 0xea64, 0xea68,    BAD, 0xbf59, 0xfc71, 0xed6d, 0xc0f5, 0xc27a,
/* 28 */ 0xc0f6, 0xc0f3, 0xed6a, 0xed68,    BAD, 0xed6b,    BAD, 0xed6e,
/* 30 */ 0xc0f4, 0xed6c, 0xed67,    BAD, 0x975e, 0xf042, 0xf045, 0xf275,
/* 38 */ 0xf040,    BAD, 0xf46f, 0xf046,    BAD, 0xc3a2, 0xf044, 0xc27b
},

/* Row 0x287 */
{
/* 00 */ 0xf041, 0xf043, 0xf047, 0xf276,    BAD, 0xf274,    BAD,    BAD,
/* 08 */ 0xfea7,    BAD, 0xc3a3, 0xf273, 0x946a,    BAD,    BAD, 0xc46e,
/* 10 */ 0x93e3,    BAD,    BAD, 0x98cf, 0xc4ed, 0xf6f1, 0xc4ec, 0xf6f3,
/* 18 */ 0xf6f0, 0xf6f2, 0xc5d0, 0xf8b2, 0xa5ca, 0xcd6e, 0xd2bc, 0xd2bd,
/* 20 */ 0xb27d, 0xdebf, 0xbf5d, 0xc3a4, 0xc57b, 0xf8b3, 0xa5cb, 0xa0d9,
/* 28 */ 0xcd6f, 0xa260,    BAD,    BAD, 0xcfd7,    BAD, 0xcfd8,    BAD,
/* 30 */ 0xa0bf, 0xa04d, 0xa0b8,    BAD, 0xd2be, 0xd2bf, 0xb27e, 0xb2a1,
/* 38 */ 0xa0ce,    BAD,    BAD, 0xdaab,    BAD, 0xdec2, 0xdec1, 0xdec0
},

/* Row 0x288 */
{
/* 00 */ 0xe2d5,    BAD, 0xe2d6, 0xe2d7, 0xbac2, 0xa0b7,    BAD, 0xe6ad,
/* 08 */ 0xe6ac,    BAD,    BAD, 0xea69, 0xbf5e, 0xbf5f, 0xfea9, 0xed72,
/* 10 */ 0xed6f, 0xed70, 0xed71, 0xf049, 0xf048, 0xc27c, 0xf277, 0xf5de,
/* 18 */ 0xa5cc, 0x89c3, 0xacc6,    BAD, 0xb2a2, 0xdec3, 0xfeab, 0xa5cd,
/* 20 */    BAD, 0xd2c0, 0xb2a3,    BAD,    BAD, 0xb563, 0xb564,    BAD,
/* 28 */ 0xa5ce, 0xa5cf, 0xca46, 0xa86a, 0xa869, 0xacc7, 0xcfd9, 0xdaac,
/* 30 */ 0xa5d0, 0xa5d1, 0xa5d2, 0xa5d3, 0x9df4, 0x896d,    BAD, 0xa86b,
/* 38 */ 0xa86c, 0xcb6e, 0xcb6d, 0x9c7b,    BAD, 0xaab6, 0xcd72, 0xcd70
},

/* Row 0x289 */
{
/* 00 */ 0xcd71,    BAD, 0x98d2,    BAD,    BAD,    BAD, 0x9fa9, 0xcfda,
/* 08 */ 0xcfdb,    BAD, 0xfeb2, 0xaccb, 0xacc9, 0xfeb1, 0xacca, 0xacc8,
/* 10 */    BAD, 0x97d9,    BAD, 0xa0c4, 0xaf60, 0x9476,    BAD,    BAD,
/* 18 */    BAD, 0xaf64, 0xaf63, 0xd2c1, 0xaf62, 0xaf61,    BAD, 0xd2c2,
/* 20 */ 0x9978,    BAD, 0xb2a6, 0xd67b, 0xd67a, 0xb2a4, 0xb2a5, 0xfeb3,
/* 28 */    BAD,    BAD, 0xb566, 0xb565, 0xdaae, 0x98d3, 0xfeb4, 0xdaad,
/* 30 */ 0xb2a7,    BAD, 0x98d4,    BAD,    BAD,    BAD, 0xb7ed, 0xdec5,
/* 38 */ 0xb7ee, 0xdec4, 0x9fb9,    BAD,    BAD, 0xe2d8, 0xe6ae, 0xbd42
},

/* Row 0x28a */
{
/* 00 */ 0xea6a,    BAD,    BAD, 0x9471, 0xed73,    BAD, 0xc3a6, 0xc3a5,
/* 08 */    BAD,    BAD, 0xc57c, 0xa5d4, 0xcd73, 0x98d5, 0xfeb8, 0xb2a8,
/* 10 */ 0xe2d9, 0xbac3, 0xc6d4,    BAD, 0xcb6f, 0xcb70,    BAD,    BAD,
/* 18 */ 0xcd74, 0xaab8, 0xaab9,    BAD,    BAD, 0xaab7, 0xfeba,    BAD,
/* 20 */    BAD,    BAD, 0xaccf, 0xacd0, 0xaccd, 0xacce,    BAD, 0xcfdc,
/* 28 */    BAD,    BAD, 0xcfdd, 0xaccc,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xd2c3, 0x9e5c, 0xaf68, 0xaf69, 0xfebb, 0xb2ab, 0xd2c9,    BAD,
/* 38 */ 0xaf6e, 0xaf6c, 0xd2ca, 0xd2c5, 0xaf6b, 0xaf6a, 0xaf65, 0xd2c8
},

/* Row 0x28b */
{
/* 00 */ 0xd2c7, 0xd2c4, 0xaf6d, 0xa044, 0xd2c6, 0xaf66,    BAD, 0xaf67,
/* 08 */ 0x98d7,    BAD, 0xb2ac, 0xd6a1, 0xd6a2, 0xb2ad, 0xd67c, 0xd67e,
/* 10 */ 0xd6a4, 0xd6a3, 0xd67d,    BAD, 0xb2a9, 0xb2aa,    BAD, 0xdab6,
/* 18 */ 0xb56b, 0xb56a, 0xdab0, 0xb568, 0x98d8, 0xdab3, 0xb56c, 0xdab4,
/* 20 */ 0xb56d, 0xdab1, 0xb567, 0xb569, 0xdab5,    BAD, 0xdab2, 0xdaaf,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xded2,    BAD, 0xdec7,
/* 30 */ 0xb7f0, 0xb7f3, 0xb7f2, 0xb7f7, 0xb7f6, 0xded3, 0xded1, 0xdeca,
/* 38 */ 0xdece, 0xdecd, 0xb7f4, 0xded0, 0xdecc, 0xded4, 0xdecb, 0xb7f5
},

/* Row 0x28c */
{
/* 00 */ 0xb7ef, 0xb7f1, 0xfebc, 0xdec9,    BAD,    BAD,    BAD, 0x9ffe,
/* 08 */ 0xe2db, 0xbac7, 0xe2df, 0xbac6, 0xe2dc, 0xbac5,    BAD, 0xdec8,
/* 10 */ 0xdecf, 0xe2de,    BAD, 0xbac8, 0xe2e0, 0xe2dd, 0xe2da,    BAD,
/* 18 */    BAD, 0xe6b1, 0xe6b5, 0xe6b7, 0xe6b3, 0xe6b2, 0xe6b0, 0xbd45,
/* 20 */ 0xbd43, 0xbd48, 0xbd49, 0xe6b4, 0xbd46, 0xe6af, 0xbd47, 0xbac4,
/* 28 */ 0xe6b6, 0xbd44,    BAD,    BAD, 0xfebd, 0xea6c,    BAD, 0xea6b,
/* 30 */ 0xea73, 0xea6d, 0xea72, 0xea6f, 0xbf60, 0xea71,    BAD,    BAD,
/* 38 */ 0xbf61,    BAD, 0xbf62, 0x9ddd, 0xea70, 0xea6e,    BAD,    BAD
},

/* Row 0x28d */
{
/* 00 */ 0x9ee1,    BAD, 0xc0f8, 0xed74,    BAD,    BAD, 0xc0f7, 0xed77,
/* 08 */ 0xed75, 0xed76,    BAD,    BAD, 0xc0f9, 0x98da, 0x9ddf, 0xfebf,
/* 10 */ 0xf04d, 0xfebe, 0xc2a1, 0xf04e, 0x9eeb,    BAD, 0xc27d, 0xf04f,
/* 18 */ 0xc27e, 0xf04c, 0xf050,    BAD, 0xf04a,    BAD,    BAD, 0xc3a7,
/* 20 */ 0xf278, 0xc3a8, 0xc46f,    BAD, 0xf04b, 0xc470, 0x9e59, 0xa05c,
/* 28 */    BAD, 0xc4ee, 0xf5df,    BAD, 0xc57e, 0xf6f4, 0xc57d, 0xfec0,
/* 30 */ 0xf7ea, 0xc5f5, 0xc5f6, 0x9477, 0x98dc, 0xf9cc, 0xfec1,    BAD,
/* 38 */ 0xacd1, 0xcfde, 0x98de, 0xb56e, 0xb56f, 0xa5d5, 0xa6ca, 0xca47
},

/* Row 0x28e */
{
/* 00 */    BAD, 0xcb71, 0xa86d,    BAD, 0xaaba,    BAD, 0xacd2, 0xacd3,
/* 08 */ 0xacd4, 0xd6a6, 0xd2cb, 0xaf6f,    BAD,    BAD, 0xb2ae, 0xd6a5,
/* 10 */ 0xfec3,    BAD, 0xdab8, 0xb571,    BAD, 0xdab7, 0xb570,    BAD,
/* 18 */    BAD, 0xded5, 0xbd4a, 0xe6bb, 0xe6b8, 0xe6b9, 0xe6ba,    BAD,
/* 20 */    BAD, 0xfec8,    BAD,    BAD, 0xed78, 0xfec9, 0xf051,    BAD,
/* 28 */    BAD,    BAD, 0xf471, 0xf470,    BAD, 0xf6f5, 0xa5d6, 0xcd75,
/* 30 */ 0xaf70,    BAD,    BAD,    BAD, 0xb572, 0xded6,    BAD, 0xfeca,
/* 38 */ 0xe2e1,    BAD, 0xbd4b, 0xea74,    BAD, 0xf052, 0xf472, 0xa5d7
},

/* Row 0x28f */
{
/* 00 */    BAD,    BAD, 0xaabb, 0xacd7, 0xcfdf, 0xacd8, 0xacd6,    BAD,
/* 08 */ 0xacd5, 0xd2cc, 0xaf71,    BAD, 0xfecb, 0xaf72, 0xaf73,    BAD,
/* 10 */    BAD,    BAD, 0xb2b0, 0xd6a7, 0xb2af,    BAD, 0x9fc2,    BAD,
/* 18 */    BAD,    BAD, 0xdab9, 0xb2b1, 0xb573, 0xded7, 0xb7f8, 0xb7f9,
/* 20 */    BAD, 0xbac9,    BAD, 0xbaca, 0xbd4c, 0xbf64, 0xea75, 0xbf63,
/* 28 */    BAD, 0xed79, 0xc0fa,    BAD, 0xf053, 0xf473, 0xa5d8, 0xa86e,
/* 30 */ 0xcd78, 0xcd77, 0xaabc, 0xcd76, 0xaabd, 0xcd79,    BAD, 0xcfe5,
/* 38 */ 0xacdb, 0xacda, 0xcfe7, 0xcfe6, 0xacdf,    BAD, 0xacde,    BAD
},

/* Row 0x290 */
{
/* 00 */    BAD, 0xacd9,    BAD, 0xcfe1, 0xcfe2, 0xcfe3,    BAD, 0xace0,
/* 08 */ 0xcfe0, 0xacdc, 0xcfe4, 0xacdd, 0x98c4,    BAD, 0x94b0, 0x94b1,
/* 10 */ 0xd2cf, 0xd2d3, 0xd2d1, 0xd2d0,    BAD, 0xd2d4,    BAD,    BAD,
/* 18 */    BAD, 0xd2d5, 0xd2d6, 0xd2ce,    BAD, 0xd2cd, 0xfed1, 0xaf75,
/* 20 */ 0xaf76,    BAD, 0xd2d7, 0xd2d2, 0xa0c1, 0xd6b0, 0xfed2, 0xd2d8,
/* 28 */ 0xaf77, 0xaf74,    BAD, 0xa0cd,    BAD, 0xd6aa,    BAD, 0xd6a9,
/* 30 */    BAD, 0xd6ab, 0xd6ac, 0xd6ae, 0xd6ad, 0xd6b2, 0xb2b5, 0xb2b2,
/* 38 */ 0xb2b6, 0xd6a8, 0xb2b7, 0xd6b1, 0xb2b4, 0xd6af, 0xb2b3,    BAD
},

/* Row 0x291 */
{
/* 00 */ 0xfed3,    BAD,    BAD, 0x98e5, 0xdabc, 0xdabe, 0xdaba, 0xdabb,
/* 08 */    BAD,    BAD, 0xdabf, 0xdac1, 0xdac2, 0xdabd, 0xdac0, 0xb574,
/* 10 */    BAD,    BAD, 0xdedb,    BAD, 0xdee0, 0xded8, 0xdedc,    BAD,
/* 18 */ 0xfed6, 0xdee1, 0xdedd, 0xb7fa, 0xb843,    BAD, 0xb7fd, 0xded9,
/* 20 */ 0xdeda, 0xbace, 0xb846, 0xb7fe,    BAD, 0xb844, 0xb7fc, 0xdedf,
/* 28 */ 0xb845, 0xdede, 0xb841, 0xb7fb, 0xb842, 0xdee2, 0xe2e6, 0xe2e8,
/* 30 */    BAD,    BAD, 0x91e4,    BAD,    BAD,    BAD,    BAD, 0x8fc7,
/* 38 */ 0x94ae, 0xb840, 0x8a4f, 0x94b2, 0xe2e3, 0xbacc, 0xe2e9, 0xbacd
},

/* Row 0x292 */
{
/* 00 */ 0xe2e7, 0xe2e2, 0xe2e5, 0xe2ea, 0xbacb, 0xe2e4,    BAD, 0xbd4e,
/* 08 */ 0xe6bf, 0xe6be,    BAD, 0xbd51, 0xbd4f, 0xe6bc, 0xbd4d, 0xe6bd,
/* 10 */    BAD, 0xbd50,    BAD, 0x8fd4,    BAD, 0xea7d,    BAD, 0xeaa1,
/* 18 */ 0x98ea, 0xea7e, 0xea76, 0xea7a, 0xea79, 0xea77, 0xbf66, 0xbf67,
/* 20 */ 0xbf65, 0xea78, 0xea7b, 0xea7c,    BAD, 0xbf68,    BAD, 0xc140,
/* 28 */ 0xeda3,    BAD, 0xc0fc, 0xed7b, 0xc0fe, 0xc141,    BAD, 0xfed8,
/* 30 */ 0xc0fd, 0xeda2, 0xed7c, 0xc0fb, 0xeda1, 0xed7a, 0xed7e, 0xed7d,
/* 38 */    BAD, 0x9de0, 0xf055, 0xc2a4, 0xc2a5, 0xc2a2, 0x98ee, 0xc2a3
},

/* Row 0x293 */
{
/* 00 */    BAD,    BAD, 0xf054, 0x95c4, 0xf27b, 0xfce8,    BAD, 0xc3a9,
/* 08 */    BAD, 0xf279, 0xf27a, 0x98ef, 0xf474, 0xf477, 0xf475, 0xf476,
/* 10 */ 0xf5e0,    BAD,    BAD, 0xc4ef, 0xf7eb, 0xf8b4,    BAD, 0xc5f7,
/* 18 */ 0xf8f8, 0xf8f9, 0xc666, 0xa5d9, 0xace1,    BAD, 0xdac3,    BAD,
/* 20 */ 0xdee3,    BAD, 0xa5da, 0xa86f,    BAD, 0xaabe, 0xfad8, 0xcfe8,
/* 28 */ 0xcfe9, 0xaf78,    BAD,    BAD, 0xdac4, 0xb575, 0xb847, 0xc142,
/* 30 */ 0xeda4, 0xf27c, 0xf478, 0xa5db, 0xfedc,    BAD,    BAD, 0xcda1,
/* 38 */ 0xcd7a, 0xcd7c, 0xcd7e, 0xcd7d, 0xcd7b, 0xaabf, 0xa0ae,    BAD
},

/* Row 0x294 */
{
/* 00 */    BAD,    BAD, 0xace2, 0xcff2,    BAD, 0xcfed, 0xcfea,    BAD,
/* 08 */ 0x9d4c, 0xcff1,    BAD,    BAD, 0xace4, 0xace5, 0xcff0, 0xcfef,
/* 10 */ 0xcfee, 0xcfeb, 0xcfec, 0xcff3, 0xace3,    BAD,    BAD,    BAD,
/* 18 */ 0x98f1,    BAD,    BAD,    BAD, 0x98f3, 0xaf7c, 0x94c1, 0xafa4,
/* 20 */ 0xafa3, 0xd2e1, 0xd2db, 0xd2d9,    BAD, 0xafa1, 0xd6b9, 0xaf7a,
/* 28 */ 0xd2de, 0xd2e2, 0xd2e4, 0xd2e0, 0xd2da, 0xafa2, 0xd2df, 0xd2dd,
/* 30 */ 0xaf79, 0xd2e5, 0xafa5, 0xd2e3, 0xaf7d, 0xd2dc,    BAD, 0xaf7e,
/* 38 */ 0xaf7b, 0x98f5,    BAD,    BAD, 0xfa4f, 0x96e2,    BAD,    BAD
},

/* Row 0x295 */
{
/* 00 */    BAD,    BAD, 0x9450, 0xb2b9, 0x96a2, 0xd6ba,    BAD, 0x98f6,
/* 08 */ 0xd6b3, 0xd6b5, 0xd6b7, 0x96e5, 0xd6b8, 0xd6b6, 0xb2ba,    BAD,
/* 10 */ 0xd6bb, 0x98f7, 0xd6b4, 0xa046, 0x96e3,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xdac8, 0xb576, 0xdad0,    BAD,
/* 20 */ 0xdac5,    BAD, 0xdad1,    BAD, 0xdac6, 0xdac7, 0x98f8,    BAD,
/* 28 */ 0xdacf, 0xdace, 0xdacb, 0xb2b8, 0xb577, 0xdac9, 0xdacc, 0xb578,
/* 30 */ 0xdacd, 0xdaca,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xdeee, 0x9ee4, 0xdef2, 0xb84e,    BAD, 0xe2f0, 0xb851
},

/* Row 0x296 */
{
/* 00 */ 0xdef0, 0xf9d6,    BAD, 0xdeed, 0xdee8, 0xdeea, 0xdeeb, 0xdee4,
/* 08 */ 0x94c3, 0xb84d,    BAD,    BAD, 0xb84c, 0x94c2, 0xb848, 0xdee7,
/* 10 */    BAD, 0xb84f,    BAD, 0xb850, 0xdee6, 0xdee9, 0xdef1, 0xb84a,
/* 18 */ 0xb84b, 0xdeef, 0xdee5,    BAD,    BAD,    BAD, 0xe2f2, 0xbad0,
/* 20 */ 0xe2f4, 0xdeec, 0xe2f6, 0xbad4, 0xe2f7, 0xe2f3,    BAD, 0xbad1,
/* 28 */ 0xe2ef, 0xbad3, 0xe2ec, 0xe2f1, 0xe2f5, 0xe2ee,    BAD, 0xfee1,
/* 30 */ 0xb849, 0xfee9, 0xe2eb, 0xbad2, 0xe2ed,    BAD, 0x96e4,    BAD,
/* 38 */ 0x89ac, 0x96db, 0xbd54, 0xe6c1, 0xbd58,    BAD, 0xbd56,    BAD
},

/* Row 0x297 */
{
/* 00 */    BAD, 0xbacf,    BAD, 0xe6c8, 0xe6c9, 0xbd53,    BAD, 0xfee2,
/* 08 */ 0xe6c7, 0xe6ca, 0xbd55, 0xbd52, 0xe6c3, 0xe6c0, 0xe6c5, 0xe6c2,
/* 10 */ 0xbd59, 0xe6c4, 0x94c4, 0xfee3, 0xe6c6, 0xbd57,    BAD, 0xfee7,
/* 18 */ 0x9ffb,    BAD, 0xbf6a, 0xeaa8,    BAD, 0xeaa2, 0xeaa6, 0xeaac,
/* 20 */ 0xeaad, 0xeaa9, 0xeaaa, 0xeaa7,    BAD, 0xeaa4,    BAD, 0xbf6c,
/* 28 */ 0xbf69, 0xeaa3, 0xeaa5,    BAD, 0xbf6b, 0xeaab, 0x93c9, 0xc146,
/* 30 */ 0x94e8, 0xfb56, 0xedaa, 0xeda5, 0xc145, 0x90c5,    BAD, 0xc143,
/* 38 */    BAD, 0xedac, 0xc144, 0xeda8, 0xeda9, 0xeda6, 0xedad, 0xf056
},

/* Row 0x298 */
{
/* 00 */    BAD, 0xc147, 0xeda7,    BAD, 0xedae, 0xedab, 0xa0a8,    BAD,
/* 08 */    BAD, 0xf05a,    BAD,    BAD, 0xf057,    BAD, 0xc2a6,    BAD,
/* 10 */ 0xf05b, 0xf05d, 0xf05c, 0xf058, 0xf059,    BAD,    BAD, 0xf2a3,
/* 18 */    BAD, 0xc3aa,    BAD, 0xf27e, 0xf2a2, 0xf27d, 0xf2a4,    BAD,
/* 20 */    BAD, 0xf2a1,    BAD, 0xf47a, 0xf47d, 0xf479, 0xc471, 0xf47b,
/* 28 */ 0xf47c, 0xf47e, 0xc472, 0xc474, 0xc473, 0xf5e1, 0xfee5, 0xf5e3,
/* 30 */    BAD, 0xf5e2, 0x98fd, 0x98fb, 0xfee8, 0xf6f6, 0x8ebf,    BAD,
/* 38 */ 0xf8b5, 0xf8fa, 0xa5dc, 0x8bd8, 0xfef7, 0xcb72, 0xaac0, 0xcda3
},

/* Row 0x299 */
{
/* 00 */ 0xaac1, 0xaac2, 0xcda2,    BAD, 0xcff8, 0xcff7, 0xace6, 0xace9,
/* 08 */ 0xace8, 0xace7, 0xcff4, 0xcff6, 0xcff5,    BAD,    BAD, 0xd2e8,
/* 10 */ 0xafa7, 0xd2ec, 0xd2eb, 0xd2ea, 0xd2e6, 0xafa6, 0xafaa, 0xafad,
/* 18 */ 0x8f68, 0x94c6, 0xafae, 0xd2e7, 0xd2e9, 0xafac, 0xafab, 0xafa9,
/* 20 */ 0xafa8, 0xd6c2, 0x9dea, 0xd6c0, 0xd6bc, 0xb2bb,    BAD, 0xd6bd,
/* 28 */ 0xb2bc, 0xd6be, 0xd6bf, 0xd6c1,    BAD, 0xb2bd,    BAD,    BAD,
/* 30 */ 0xdad5, 0xfc69, 0xdad4, 0xdad3, 0xdad2,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xdef6, 0xb852,    BAD, 0xdef3, 0xdef5, 0x9cda, 0xb853
},

/* Row 0x29a */
{
/* 00 */ 0xfef3, 0xb854, 0xdef4, 0x9c72,    BAD,    BAD, 0xfef0, 0x89c9,
/* 08 */ 0xe341,    BAD, 0xe2f9, 0xe2fa,    BAD, 0xbad7, 0xbad5, 0xbad6,
/* 10 */ 0xe343, 0x9941, 0xe342, 0xe2fe, 0xe2fd, 0xe2fc, 0xe2fb, 0xe340,
/* 18 */ 0xe2f8, 0x9942, 0xe6cb, 0xe6d0, 0xe6ce, 0xfef5,    BAD, 0x91d7,
/* 20 */ 0xe6cd, 0xe6cc, 0xe6cf,    BAD, 0xeaae, 0x94cc, 0xbf6d, 0xc148,
/* 28 */ 0xedb0, 0xfef8, 0xc149, 0xedaf, 0xf05f, 0xf05e, 0xc2a7,    BAD,
/* 30 */ 0xf2a5, 0xc3ab, 0xf4a1, 0xc5a1, 0xf6f7,    BAD, 0xf8b7, 0xf8b6,
/* 38 */ 0xc9a8, 0xacea, 0xaceb, 0xd6c3,    BAD, 0xb856, 0xa5dd, 0xa872
},

/* Row 0x29b */
{
/* 00 */ 0xa871, 0xa870,    BAD,    BAD, 0x97a8, 0xcda4, 0xfefc,    BAD,
/* 08 */ 0xaac4, 0xaac3,    BAD, 0xacee, 0xfdbf, 0xcffa, 0xcffd, 0xcffb,
/* 10 */    BAD, 0xacec, 0xaced,    BAD, 0xfefe, 0xcff9, 0xcffc,    BAD,
/* 18 */ 0xafb5,    BAD,    BAD,    BAD, 0xd2f3, 0xd2f5, 0xd2f4, 0xafb2,
/* 20 */ 0xd2ef,    BAD, 0x96d1, 0xafb0, 0xafaf,    BAD, 0xafb3, 0xafb1,
/* 28 */    BAD, 0xafb4, 0xd2f2, 0xd2ed, 0xd2ee, 0xd2f1, 0xd2f0,    BAD,
/* 30 */    BAD, 0x94d5,    BAD,    BAD, 0x94d0,    BAD, 0xd6c6, 0xd6c7,
/* 38 */ 0xd6c5,    BAD, 0xd6c4, 0xb2be,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x29c */
{
/* 00 */ 0xb57d,    BAD, 0xdad6, 0xdad8, 0xdada, 0xb57c, 0x9944,    BAD,
/* 08 */ 0xb57a,    BAD, 0xdad7, 0xb57b, 0xdad9, 0xb579,    BAD,    BAD,
/* 10 */ 0xdf41, 0xdef7, 0xdefa, 0xdefe, 0xb85a, 0xdefc,    BAD, 0xdefb,
/* 18 */ 0xdef8, 0xdef9, 0xb858, 0xdf40, 0xb857,    BAD, 0xb85c, 0xb85b,
/* 20 */ 0xb859,    BAD, 0xdefd,    BAD,    BAD,    BAD, 0xe349,    BAD,
/* 28 */ 0xe348,    BAD,    BAD, 0xe344,    BAD, 0xa0b3, 0xbad8, 0xe347,
/* 30 */ 0xe346, 0xbad9,    BAD,    BAD,    BAD,    BAD,    BAD, 0xbd5e,
/* 38 */    BAD, 0xe6d2, 0x94cf, 0xbd5f, 0xbd5b, 0xbd5d, 0x9ffa, 0xbd5a
},

/* Row 0x29d */
{
/* 00 */ 0xbd5c,    BAD,    BAD, 0x91e5, 0xeaaf, 0x9c6a, 0xbf70, 0xeab1,
/* 08 */ 0xeab0, 0x8e49, 0xe345, 0xbf72, 0xbf71, 0xbf6e, 0xbf6f,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xedb5,    BAD, 0xedb3, 0xc14a,
/* 18 */ 0xedb4,    BAD, 0xedb6, 0xedb2, 0xedb1,    BAD,    BAD, 0xf060,
/* 20 */ 0xc2aa, 0xc2a8, 0xc2a9,    BAD,    BAD, 0x8e4c,    BAD, 0xf2a6,
/* 28 */ 0xf2a7, 0xc3ad,    BAD, 0xc3ac, 0xf4a3, 0xf4a4, 0xf4a2,    BAD,
/* 30 */ 0xf6f8, 0xf6f9,    BAD,    BAD, 0xa5de, 0xca48, 0xa873,    BAD,
/* 38 */ 0xcda5, 0xaac6, 0xaac5, 0xcda6,    BAD, 0x8e4d, 0xd040, 0xacef
},

/* Row 0x29e */
{
/* 00 */ 0xcffe, 0xacf0,    BAD, 0x9a73, 0xafb6, 0xd2f8, 0xd2f6, 0xd2fc,
/* 08 */ 0xafb7, 0xd2f7, 0xd2fb, 0xd2f9, 0xd2fa,    BAD,    BAD, 0xd6c8,
/* 10 */ 0xd6ca, 0x9947, 0xb2bf,    BAD, 0xd6c9, 0xb2c0, 0xb5a2, 0xb5a1,
/* 18 */ 0xb57e, 0xdadb,    BAD,    BAD,    BAD,    BAD, 0xdf44, 0xb85d,
/* 20 */ 0xb85e,    BAD, 0xdf43, 0xdf42,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xe34a, 0xbadb, 0xbada, 0xe34b, 0xe34c,    BAD, 0xbd61, 0xbd60,
/* 30 */ 0x8e50, 0xeab5, 0xe6d3, 0xe6d5, 0xe6d4, 0xeab4, 0xeab2, 0xeab6,
/* 38 */ 0xeab3,    BAD, 0xbf73, 0x8e4f, 0x9949,    BAD, 0xedb7, 0xc14b
},

/* Row 0x29f */
{
/* 00 */ 0xedb8, 0xedb9, 0x8e51, 0x8e52, 0xc2ab, 0xc2ac,    BAD, 0xc475,
/* 08 */ 0x9ab2, 0x89a5, 0xc5d1, 0xa5df,    BAD,    BAD,    BAD, 0x994c,
/* 10 */    BAD, 0xd041,    BAD, 0x9ff8,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xd2fd, 0xafb8, 0x8e56, 0x994d, 0x91ca, 0x8e57,    BAD, 0xb3ba,
/* 20 */ 0xb3b9,    BAD, 0x94e1, 0xb5a4, 0xdadd, 0xb5a3, 0xdadc, 0x9047,
/* 28 */    BAD, 0x8fd8, 0x8e58, 0xdf45,    BAD, 0xbadc, 0xe34d, 0xbadd,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xc476, 0xf4a5,
/* 38 */    BAD, 0xa6cb, 0xaac7, 0xcda7,    BAD, 0xacf2, 0x94eb, 0xacf1
},

/* Row 0x2a0 */
{
/* 00 */ 0xd042, 0xd043,    BAD,    BAD, 0xd340, 0xd342, 0xafb9,    BAD,
/* 08 */ 0xd344, 0xd347, 0xd345, 0x8e5c, 0x9553,    BAD, 0xd346, 0xd343,
/* 10 */ 0xd2fe, 0xafba, 0xd348, 0xd341, 0x9fe5,    BAD,    BAD,    BAD,
/* 18 */ 0xd6d3, 0xb2c6, 0xd6dc, 0xb2c3,    BAD, 0xd6d5, 0xb2c7, 0x9f56,
/* 20 */ 0xb2c1,    BAD, 0xd6d0, 0xd6dd, 0xd6d1, 0xd6ce, 0xb2c5, 0x954f,
/* 28 */ 0xb2c2, 0x8e5e, 0xd6d4, 0xd6d7, 0xb2c4, 0xd6d8, 0xb2c8, 0xd6d9,
/* 30 */ 0xd6cf, 0xd6d6, 0xd6da, 0xd6d2, 0xd6cd, 0xd6cb,    BAD,    BAD,
/* 38 */ 0xd6db, 0x996a,    BAD, 0xdadf,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2a1 */
{
/* 00 */ 0xdae4,    BAD, 0x9c64, 0x9cd9, 0xdae0, 0xdae6, 0xb5a7, 0xd6cc,
/* 08 */ 0xdae1, 0xb5a5, 0xdade, 0xb5ac, 0xdae2, 0xb5ab, 0xdae3, 0xb5ad,
/* 10 */ 0xb5a8, 0xb5ae, 0xb5a9,    BAD, 0xb5aa, 0x8e5d, 0xb5a6,    BAD,
/* 18 */ 0xdae5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xb861, 0xdf50, 0x9950, 0xdf53, 0xdf47, 0xdf4c, 0xdf46, 0xb863,
/* 28 */    BAD, 0xdf4a,    BAD,    BAD, 0x9951, 0xdf48, 0xb862, 0x8e62,
/* 30 */ 0xdf4f, 0xdf4e, 0xdf4b, 0xdf4d, 0xdf49, 0xbae1, 0xdf52, 0xb85f,
/* 38 */ 0xdf51,    BAD,    BAD, 0x9952,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2a2 */
{
/* 00 */    BAD,    BAD, 0xe35d,    BAD, 0xbae8, 0xe358,    BAD, 0xbae7,
/* 08 */ 0xe34e,    BAD, 0xe350, 0xbae0, 0xe355, 0xe354, 0xe357, 0xbae5,
/* 10 */ 0xe352, 0xe351, 0x8e68,    BAD, 0xbae4, 0xbadf, 0xe353, 0xbae2,
/* 18 */ 0xe359, 0xe35b,    BAD, 0xe356, 0xe34f, 0xbae3,    BAD,    BAD,
/* 20 */ 0xbd69, 0xbade, 0x8e61, 0x9f59, 0xe35c,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xe6d9, 0xbd62,    BAD, 0xe6db,
/* 30 */    BAD, 0xbd63, 0x8bb3,    BAD, 0xbd65, 0xe6de,    BAD, 0xe6d6,
/* 38 */ 0xbae6, 0xe6dc,    BAD,    BAD,    BAD,    BAD, 0xe6d8,    BAD
},

/* Row 0x2a3 */
{
/* 00 */ 0xb860, 0xbd68,    BAD,    BAD, 0xbd64,    BAD, 0xbd66, 0xbd67,
/* 08 */    BAD, 0xbf76, 0xe6dd, 0xe6d7, 0xbd6a,    BAD, 0xe6da, 0x9f5d,
/* 10 */ 0x8e66,    BAD,    BAD,    BAD, 0xeac0, 0xeabb,    BAD,    BAD,
/* 18 */ 0xeac5, 0xbf74, 0xeabd, 0xbf78, 0xeac3, 0xeaba, 0xeab7, 0xeac6,
/* 20 */ 0xc151, 0xbf79, 0xeac2, 0xeab8, 0xbf77, 0xeabc, 0xbf7b, 0xeab9,
/* 28 */ 0xeabe, 0xbf7a, 0xeac1, 0xeac4,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xedcb, 0xedcc, 0xedbc, 0xedc3, 0xedc1,    BAD,    BAD, 0xc14f,
/* 38 */ 0xedc8, 0xeabf, 0x8e6e, 0xedbf, 0x9f64, 0xedc9, 0xc14e, 0xedbe
},

/* Row 0x2a4 */
{
/* 00 */ 0xedbd, 0xedc7, 0xedc4, 0xedc6,    BAD, 0xedba, 0xedca, 0xc14c,
/* 08 */    BAD, 0xedc5, 0xedce, 0xedc2, 0xc150, 0xc14d, 0xedc0, 0xedbb,
/* 10 */ 0xedcd, 0xbf75, 0x9953,    BAD,    BAD, 0xfab8,    BAD,    BAD,
/* 18 */    BAD, 0xf063,    BAD, 0x9954, 0xf061, 0xf067, 0xc2b0, 0xf065,
/* 20 */ 0xf064, 0xc2b2, 0xf06a, 0xc2b1,    BAD, 0xf06b, 0xf068, 0xc2ae,
/* 28 */ 0xf069, 0xf062, 0xc2af, 0xc2ad, 0xf2ab, 0xf066,    BAD,    BAD,
/* 30 */ 0xf06c,    BAD,    BAD, 0xf2a8,    BAD, 0x8e70,    BAD, 0xc3b2,
/* 38 */ 0xc3b0, 0xf2aa,    BAD, 0xf2ac, 0xf2a9, 0xc3b1, 0xc3ae, 0xc3af
},

/* Row 0x2a5 */
{
/* 00 */ 0xc3b3,    BAD, 0x9f61, 0xc478, 0x8e72, 0xf4aa,    BAD, 0xf4a9,
/* 08 */ 0xf4a7, 0xf4a6, 0xf4a8,    BAD, 0xc477, 0xc479,    BAD,    BAD,
/* 10 */ 0xc4f0, 0xa06b,    BAD, 0xf5e5, 0xf5e4,    BAD, 0x9f40, 0xf6fa,
/* 18 */    BAD, 0xf6fc, 0xf6fe, 0xf6fd, 0xf6fb, 0x94ed,    BAD, 0xc5a3,
/* 20 */ 0xc5a2,    BAD,    BAD, 0xc5d3, 0xc5d2, 0xc5d4, 0xf7ed, 0xf7ec,
/* 28 */    BAD, 0xf8fb, 0xf8b8, 0xf8fc, 0xc658, 0x94ee, 0xc659, 0xf96d,
/* 30 */ 0x9fbd,    BAD, 0xc67e, 0xa6cc, 0x8e7b, 0xcda8,    BAD,    BAD,
/* 38 */ 0xd045, 0xd046, 0xd044, 0x9957, 0x94f7, 0xacf3, 0x9f5f, 0xd047
},

/* Row 0x2a6 */
{
/* 00 */ 0xd048, 0xd049,    BAD, 0x8e73, 0xd349, 0xd34f, 0x9f62,    BAD,
/* 08 */ 0xd34d, 0xafbb, 0xd34b,    BAD, 0xd34c, 0xd34e, 0x94f6,    BAD,
/* 10 */    BAD, 0xd34a, 0xb2c9,    BAD, 0xd6de, 0xb2cb, 0xd6e0, 0xb2ca,
/* 18 */ 0xd6df,    BAD,    BAD,    BAD, 0x9958,    BAD, 0xdae8, 0xb5af,
/* 20 */    BAD, 0xdaea, 0xdae7, 0xd6e1,    BAD, 0xb5b0, 0x8e75, 0xf9db,
/* 28 */ 0xdae9,    BAD,    BAD,    BAD, 0x9072,    BAD, 0x94f8, 0xdf56,
/* 30 */    BAD, 0xb864, 0xdf54, 0xb865, 0xdf55, 0xb866,    BAD,    BAD,
/* 38 */ 0x995a, 0xbae9, 0xe361, 0xe35e, 0xe360, 0xbaea, 0xbaeb, 0xe35f
},

/* Row 0x2a7 */
{
/* 00 */    BAD,    BAD, 0xa0b0,    BAD,    BAD, 0xe6df,    BAD, 0x8e79,
/* 08 */ 0xe6e0, 0x8e78, 0xbd6b, 0xe6e2, 0xe6e1, 0x94f3, 0xa261,    BAD,
/* 10 */ 0xeaca, 0xeacb, 0xeac7, 0x98af, 0xeac8, 0xbf7c, 0xbf7d, 0xeac9,
/* 18 */    BAD, 0xc157, 0xa0b2,    BAD, 0xc153, 0xc158, 0xc154, 0xc156,
/* 20 */ 0xc152,    BAD, 0xc155,    BAD,    BAD,    BAD, 0x8e7a, 0xc2b3,
/* 28 */ 0xedcf,    BAD, 0xf2ae,    BAD, 0xf2ad, 0x995c, 0xf4ab, 0xc47a,
/* 30 */ 0xc47b, 0xf741, 0xf5e6, 0x8e7c, 0xf740, 0x8e7d, 0xf8fd, 0xf9a4,
/* 38 */ 0xa6cd, 0x8bd9,    BAD, 0xa874, 0x89a2, 0xcda9, 0xaac8,    BAD
},

/* Row 0x2a8 */
{
/* 00 */ 0xacf6, 0xd04c, 0xacf4, 0xd04a, 0xacf9, 0xacf5, 0xacfa, 0xacf8,
/* 08 */ 0xd04b, 0xacf7, 0xafbf, 0xafbe, 0xd35a, 0xafc7, 0xd353, 0xd359,
/* 10 */ 0xafc3, 0xd352, 0xd358, 0xd356, 0xafc2, 0xafc4, 0xd355, 0xafbd,
/* 18 */ 0xd354, 0xafc8, 0xafc5, 0xafc9, 0xafc6, 0xd351, 0xd350, 0xd357,
/* 20 */ 0xafc0, 0xafbc, 0xafc1,    BAD,    BAD, 0x9ed7,    BAD,    BAD,
/* 28 */ 0xd6f0, 0xd6e9,    BAD, 0xb5b5, 0xd6e8,    BAD, 0xb2cf, 0xb2d6,
/* 30 */ 0xb2d3, 0xb2d9, 0xb2d8, 0xb2d4,    BAD, 0xd6e2, 0xd6e5,    BAD,
/* 38 */ 0xd6e4, 0xb2d0, 0xd6e6, 0xd6ef, 0xb2d1, 0xd6e3, 0xd6ec, 0xd6ed
},

/* Row 0x2a9 */
{
/* 00 */ 0xb2d2, 0xd6ea, 0xb2d7, 0xb2cd, 0xb2d5, 0xd6e7, 0xb2cc, 0xd6eb,
/* 08 */    BAD,    BAD, 0xd6ee,    BAD,    BAD, 0xa0b6, 0xdafb, 0xdaf2,
/* 10 */ 0xb5b2, 0xdaf9, 0xdaf6, 0xdaee, 0xdaf7, 0xb5b4, 0xdaef,    BAD,
/* 18 */ 0xdaeb,    BAD, 0x9e42, 0xb86c, 0xdaf4, 0x8ea4, 0xb5b1, 0xdafa,
/* 20 */    BAD, 0xb5b8, 0xb5ba, 0xdaed,    BAD,    BAD, 0xb5b9, 0xdaf0,
/* 28 */ 0xb5b3, 0xdaf8, 0xdaf1, 0xdaf5,    BAD, 0xdaf3, 0xb5b6, 0xdaec,
/* 30 */ 0xb5bb, 0xb2ce, 0xb5b7, 0xb5bc,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xb868, 0xdf5d, 0xdf5f, 0xdf61, 0xdf65,    BAD, 0xdf5b
},

/* Row 0x2aa */
{
/* 00 */ 0xdf59, 0xb86a,    BAD, 0xdf60, 0xdf64, 0xdf5c, 0xdf58,    BAD,
/* 08 */ 0xdf57, 0x8ea7,    BAD,    BAD, 0xdf62, 0xdf5a, 0xdf5e, 0xb86b,
/* 10 */    BAD, 0xb869, 0xdf66, 0xb867, 0xdf63,    BAD, 0xe372, 0x9542,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xbaee, 0xe36a, 0xbd78, 0xe374,
/* 20 */ 0xbaf1, 0xe378, 0xbaf7, 0xe365, 0x987d,    BAD, 0xe375, 0xe362,
/* 28 */ 0x9755, 0xe377, 0xe366, 0x8ea8, 0xbafe, 0xbafb, 0xe376, 0xe370,
/* 30 */ 0xbaed, 0xbaf5, 0xbaf4, 0x8eaa, 0xbaf3, 0xbaf9,    BAD, 0xe363,
/* 38 */ 0xbafa, 0xe371, 0xbaf6, 0xbaec, 0xe373, 0xbaef, 0xbaf0, 0xbaf8
},

/* Row 0x2ab */
{
/* 00 */ 0xe368, 0xe367, 0xe364,    BAD, 0xe36c, 0xe369, 0xe36d, 0xbafd,
/* 08 */    BAD, 0xe379, 0xbaf2, 0xe36e, 0xe36f, 0x89a3, 0xe36b, 0x9960,
/* 10 */ 0x9962,    BAD, 0xbafc, 0x94fc, 0x9961,    BAD,    BAD, 0xe6e7,
/* 18 */ 0xbd70, 0xbd79, 0xbd75, 0xe6e4, 0x94fa, 0xbd72, 0xbd76, 0xe6f0,
/* 20 */ 0xbd6c, 0xe6e8,    BAD, 0xbd74, 0x8eae, 0x8eb2, 0xe6eb, 0xe6e6,
/* 28 */ 0xbd73, 0xbd77, 0xe6e5,    BAD, 0xbd71,    BAD, 0xe6ef, 0xbd6e,
/* 30 */ 0xe6ee, 0xe6ed, 0xbd7a, 0xe572, 0xbd6d, 0x8eb0, 0xe6ec, 0xe6e3,
/* 38 */    BAD, 0xbd7b, 0xe6ea, 0xbd6f,    BAD, 0x9963, 0x97aa,    BAD
},

/* Row 0x2ac */
{
/* 00 */    BAD,    BAD,    BAD, 0xe6e9,    BAD,    BAD,    BAD, 0x94fb,
/* 08 */ 0xbfa2, 0xbfa7, 0xbf7e, 0xead8, 0xeacf, 0xeadb, 0xead3, 0xead9,
/* 10 */ 0xbfa8, 0xbfa1, 0xeacc, 0xead2, 0xeadc, 0xead5, 0xeada, 0xeace,
/* 18 */    BAD,    BAD, 0xead6, 0xbfa3, 0xead4, 0xbfa6, 0xbfa5, 0xead0,
/* 20 */ 0xead1, 0xeacd, 0xead7, 0xbfa4, 0xeade, 0xeadd,    BAD, 0x8ebb,
/* 28 */    BAD, 0xedda, 0xedd6, 0xc15f,    BAD, 0xedd0, 0xc159, 0xc169,
/* 30 */ 0xeddc, 0xc161, 0xc15d, 0xedd3, 0xc164, 0xc167, 0xedde, 0xc15c,
/* 38 */ 0xedd5, 0xc165, 0xede0, 0xeddd, 0xedd1, 0xc160, 0xc15a, 0xc168
},

/* Row 0x2ad */
{
/* 00 */ 0xedd8, 0xc163, 0xedd2, 0xc15e, 0xeddf, 0xc162, 0xc15b, 0xedd9,
/* 08 */ 0xc166, 0xedd7,    BAD,    BAD, 0xeddb,    BAD,    BAD,    BAD,
/* 10 */ 0xf06e, 0xf074, 0xc2b9, 0xf077, 0xc2b4, 0xc2b5, 0xf06f, 0xf076,
/* 18 */ 0xf071, 0xc2ba, 0xc2b7,    BAD, 0xf06d,    BAD, 0xc2b6, 0xf073,
/* 20 */ 0xf075, 0xc2b8, 0xf072, 0xf070,    BAD, 0x9876,    BAD, 0x8ea1,
/* 28 */ 0xf2b8, 0xc3b7, 0xc3b8, 0xc3b4,    BAD, 0xc3b5, 0x8eb7, 0xf2b4,
/* 30 */ 0xf2b2,    BAD, 0xf2b6, 0xc3ba, 0xf2b7, 0xf2b0, 0xf2af, 0xf2b3,
/* 38 */ 0xf2b1, 0xc3b6, 0xf2b5, 0xf4ac, 0xc47e, 0xc47d, 0xf4ad, 0x9da6
},

/* Row 0x2ae */
{
/* 00 */ 0xf4af, 0xf4ae, 0xc4a1,    BAD,    BAD,    BAD, 0xf5eb, 0xf5e8,
/* 08 */ 0xf5e9,    BAD, 0xf5e7, 0xf5ea, 0xc4f2, 0xf5ec, 0x9eb0, 0xc4f1,
/* 10 */    BAD, 0xf742, 0x8eb8, 0xc5d5, 0xc5d7, 0xf7ee, 0xc5d6, 0xf8b9,
/* 18 */ 0xf940, 0xf942, 0xf8fe, 0xf941, 0xc66c,    BAD,    BAD, 0x9d70,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x896e,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x896f,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8970,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2af */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8971,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8972,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8973,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2b0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8974,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa6ce, 0x8975,
/* 38 */ 0xacfb, 0xd26f, 0xafca,    BAD,    BAD, 0xb2da, 0xdafc, 0xdafd
},

/* Row 0x2b1 */
{
/* 00 */ 0x8ebc, 0x8ebd,    BAD, 0xeadf, 0xc16a, 0xede1,    BAD, 0x8ebe,
/* 08 */ 0xc2bb, 0x9dd1, 0xf2ba, 0xf2b9, 0xc4a2, 0xf5ed, 0x94fd, 0xf743,
/* 10 */ 0xc5f8, 0xca49, 0x8bd7, 0x8bda, 0xaac9, 0xa875,    BAD,    BAD,
/* 18 */ 0xd04d,    BAD,    BAD, 0xd360, 0xd35b, 0xd35f, 0xd35d, 0xafcb,
/* 20 */ 0xd35e, 0xd35c,    BAD, 0xd6f1,    BAD, 0xdafe, 0xdb40, 0xdf69,
/* 28 */ 0xdf6a, 0xb86e, 0xb86f, 0xdf68, 0xdf6b, 0xdf67, 0xb86d,    BAD,
/* 30 */ 0xbb40, 0xa0e2, 0xb870, 0xe37a,    BAD, 0xbd7c, 0xe6f1, 0xbd7d,
/* 38 */ 0x9fe9, 0xbfa9, 0xeae2, 0xeae0, 0xeae1, 0xede4, 0xede3, 0xede2
},

/* Row 0x2b2 */
{
/* 00 */    BAD,    BAD,    BAD, 0xf2bb,    BAD, 0xc3b9, 0xf2bc, 0xf744,
/* 08 */ 0xc5f9, 0xf8ba, 0xa6cf, 0xaacb, 0xaaca, 0xd04f, 0xacfc, 0xfda8,
/* 10 */    BAD, 0xd04e, 0xd362, 0x8ae7, 0xafcc, 0xd6f2, 0xd361, 0x8ec2,
/* 18 */    BAD,    BAD, 0xb2dc, 0xd6f5, 0xd6f3, 0xd6f4, 0xb2db,    BAD,
/* 20 */ 0xdb42, 0xdb43, 0xdb41, 0x8ec4, 0xb873, 0xdf6d, 0xdf6c, 0xdf6e,
/* 28 */ 0xb872, 0xb871,    BAD,    BAD, 0xe6f2, 0xe6f4, 0x9964, 0xbd7e,
/* 30 */ 0xe6f3, 0xeae3, 0xbfaa, 0xf079, 0x9965, 0xf078, 0xc3bb, 0xf2bd,
/* 38 */ 0xc3bd, 0xc3bc, 0xf4b0, 0xf5ee, 0xc4f3, 0xa6d0, 0xd050, 0xacfd
},

/* Row 0x2b3 */
{
/* 00 */ 0xd365, 0xafce, 0xd364, 0xd363,    BAD, 0xafcd,    BAD, 0xd6fb,
/* 08 */    BAD, 0xd6fd, 0xd6f6, 0xd6f7, 0xb2dd, 0xd6f8, 0xb2de, 0xd6fc,
/* 10 */ 0xd6f9, 0xd6fa, 0xb2df,    BAD, 0xb5be, 0xb5bf,    BAD, 0xdb44,
/* 18 */    BAD,    BAD,    BAD, 0xdf6f, 0xdf70, 0x954e, 0xe37e, 0xbb43,
/* 20 */ 0xbb41, 0xbb42, 0xe37b, 0xe37c,    BAD, 0xe37d, 0xe6f9, 0x98b3,
/* 28 */ 0xe6fa, 0xbda1, 0xe6f7, 0xe6f6, 0xe6f8, 0xe6f5, 0xbfad, 0xeae4,
/* 30 */ 0xbfab, 0xbfac, 0xede6, 0xc16b, 0xede5, 0xefa8,    BAD, 0xf07a,
/* 38 */ 0xf07b, 0xc2bc, 0x8ecb, 0xc2bd, 0xc16c, 0xf2be, 0xf2bf, 0xf4b1
},

/* Row 0x2b4 */
{
/* 00 */ 0xc4a3, 0xa6d1, 0x8bdf, 0xa6d2, 0xacfe, 0xaacc, 0xafcf, 0xd051,
/* 08 */ 0x8ece,    BAD,    BAD, 0xb5c0, 0xa6d3, 0xad41, 0xd052, 0xd053,
/* 10 */ 0xad40, 0xad42, 0xa6d4,    BAD, 0xd054, 0xafd1, 0xd366, 0xafd3,
/* 18 */ 0xafd0, 0xafd2,    BAD, 0xd741, 0xb2e0, 0x8ecf, 0xd740, 0xd6fe,
/* 20 */ 0x9968, 0xdf71,    BAD,    BAD, 0xe3a1, 0x9969, 0xbda2,    BAD,
/* 28 */ 0xbfae, 0xeae6, 0xeae5,    BAD, 0xede7,    BAD, 0x996b, 0x8ed1,
/* 30 */ 0xf5ef, 0x996c,    BAD, 0xa6d5, 0xcb73, 0xcdaa, 0xad43, 0xd055,
/* 38 */    BAD, 0xd368,    BAD, 0x8ed4, 0x8ed5, 0xafd4, 0xd367, 0xafd5
},

/* Row 0x2b5 */
{
/* 00 */    BAD,    BAD,    BAD, 0xd743,    BAD,    BAD, 0xb2e2, 0xd742,
/* 08 */ 0xd744,    BAD, 0xb2e1,    BAD,    BAD,    BAD,    BAD, 0xdb46,
/* 10 */ 0xdb47, 0xdb45, 0xb5c1,    BAD, 0x996d,    BAD, 0xb874,    BAD,
/* 18 */ 0xb875,    BAD, 0xbb45, 0xa0be, 0xe3a3, 0xe3a2, 0xbb44,    BAD,
/* 20 */    BAD, 0x8ed6, 0xa0bc, 0xa0b5, 0xe6fb,    BAD, 0xa0b4, 0xe6fc,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0xeae7,    BAD,    BAD, 0xc170,
/* 30 */ 0xc16f, 0xc16d, 0xc16e, 0xc171,    BAD, 0xf07c, 0xc2bf, 0xc2be,
/* 38 */ 0xf2c0, 0xf4b2,    BAD,    BAD,    BAD, 0xc5a5, 0xc5a4, 0xa6d6
},

/* Row 0x2b6 */
{
/* 00 */ 0x8be0,    BAD, 0xd1fb,    BAD, 0xb877, 0xb5c2, 0xb876, 0xbb46,
/* 08 */    BAD, 0xa6d7, 0xc9a9, 0xa6d8, 0xa6d9,    BAD,    BAD, 0xcdab,
/* 10 */ 0xcb76,    BAD, 0xcb77, 0xa877,    BAD, 0xcb74, 0xa876,    BAD,
/* 18 */ 0xa879, 0xcb75, 0xa87b, 0xa87a, 0xcb78, 0xa878,    BAD, 0x89b5,
/* 20 */    BAD, 0xaad1, 0xaacf, 0xcdad,    BAD, 0xaace,    BAD, 0x8edd,
/* 28 */    BAD, 0xaad3, 0xaad5, 0xaad2,    BAD, 0xcdb0, 0xcdac, 0xaad6,
/* 30 */    BAD, 0xaad0, 0xa87c,    BAD, 0xaad4, 0xcdaf, 0x9e5d, 0x9971,
/* 38 */ 0xcdae,    BAD, 0xaacd,    BAD, 0x89ae, 0x9de8,    BAD,    BAD
},

/* Row 0x2b7 */
{
/* 00 */    BAD,    BAD, 0xd05b, 0xad47, 0xad48, 0xd05d, 0x9565, 0xd057,
/* 08 */ 0xd05a, 0xd063, 0xd061,    BAD, 0xad49, 0xd067, 0xad4c, 0xd064,
/* 10 */ 0xd05c, 0xd059,    BAD,    BAD, 0xdb49, 0xd062, 0xad44, 0xd065,
/* 18 */ 0xd056, 0xd05f, 0xad46, 0xad4b, 0xd060, 0xad4f, 0xad4d,    BAD,
/* 20 */ 0xd058, 0xad4a,    BAD, 0xd05e, 0xad4e, 0xad45, 0xd066,    BAD,
/* 28 */    BAD, 0x9972,    BAD,    BAD, 0x8b5c, 0xafda,    BAD, 0xafe3,
/* 30 */ 0xafd8, 0xafd6, 0xd36a, 0xafde, 0xafdb, 0xd36c, 0x89b1,    BAD,
/* 38 */ 0xafdd, 0xd36b, 0xd369, 0xd36e, 0xafe2, 0xafe0, 0xdb48,    BAD
},

/* Row 0x2b8 */
{
/* 00 */ 0xd36f, 0xd36d, 0xafd7, 0xa0c0,    BAD, 0xafd9, 0xafdc, 0x8edf,
/* 08 */ 0xafdf, 0x9566, 0xafe1,    BAD, 0x9974,    BAD, 0x9976,    BAD,
/* 10 */    BAD,    BAD, 0x9977,    BAD, 0x9979, 0xd74e, 0xb2e4, 0x9dda,
/* 18 */ 0xd745, 0xd747, 0x8ee0, 0xd748,    BAD, 0xd750, 0xd74c, 0xd74a,
/* 20 */    BAD, 0xd74d, 0xd751, 0xb2e5, 0xb2e9, 0xd746,    BAD, 0xd74f,
/* 28 */    BAD, 0xb2e7, 0x935c, 0xb2e6, 0xd74b, 0xd749,    BAD, 0xb2e3,
/* 30 */ 0xb2e8,    BAD, 0x9de6,    BAD, 0x8b5f,    BAD,    BAD, 0x9563,
/* 38 */    BAD, 0xb5c8, 0xdb51,    BAD,    BAD, 0xdb4f, 0xb5ca,    BAD
},

/* Row 0x2b9 */
{
/* 00 */    BAD,    BAD, 0x9567, 0xdb4a, 0xdfa1,    BAD, 0xb5c9, 0xdb4e,
/* 08 */ 0x9de3,    BAD, 0xdb4b, 0xb5c5, 0xb5cb, 0xdb50, 0xb5c7, 0xdb4d,
/* 10 */ 0xbb47, 0xb5c6, 0xdb4c, 0xb5cc, 0xb5c4, 0xb5c3, 0x997c,    BAD,
/* 18 */    BAD, 0x997d, 0x997e, 0xdf77, 0xdf75,    BAD, 0xdf7b,    BAD,
/* 20 */ 0xdf73, 0xdfa2, 0xdf78,    BAD, 0xdf72, 0xb87b, 0xb8a3, 0xdf7d,
/* 28 */    BAD, 0xdf76,    BAD, 0xb87e,    BAD, 0x8b5b, 0xb87c, 0xdf7e,
/* 30 */ 0xb879, 0xb878, 0xdf79, 0xb87d, 0xb5cd,    BAD, 0xdf7c, 0xdf74,
/* 38 */ 0xb87a, 0xb8a1, 0xb8a2,    BAD, 0x99a3,    BAD,    BAD, 0xbb4c
},

/* Row 0x2ba */
{
/* 00 */ 0xbb48,    BAD, 0xbb4d, 0xe3a6, 0x99a4,    BAD, 0xe3a5, 0xe3a7,
/* 08 */ 0xbb4a, 0xe3a4, 0xbb4b, 0xe3aa, 0xe3a9, 0xe3a8,    BAD, 0xbb49,
/* 10 */    BAD,    BAD,    BAD, 0x99a6,    BAD, 0xe741,    BAD, 0xe744,
/* 18 */ 0xbda8, 0xe743, 0xbda7, 0xbda3, 0xbda4, 0xbda5, 0xe740, 0xe6fe,
/* 20 */ 0xbda6,    BAD, 0xe742, 0xe6fd,    BAD, 0x99a8, 0xeae9, 0xeaf3,
/* 28 */ 0xbfb1, 0xbfb0, 0x8abe, 0xeaed, 0xeaef,    BAD, 0xeaea,    BAD,
/* 30 */ 0xeaee, 0xeae8, 0xeaf1, 0xbfaf, 0xeaf0, 0xeaec, 0x9e61, 0xeaf2,
/* 38 */    BAD, 0xeaeb, 0xc174, 0xede8, 0xedee, 0xc178, 0xc17a, 0xc177
},

/* Row 0x2bb */
{
/* 00 */ 0xc176, 0x99aa, 0xc175, 0xc173, 0xede9, 0xedec, 0xc172, 0xeded,
/* 08 */ 0xa0c8, 0xc179, 0xedeb,    BAD, 0xedea, 0xc2c0,    BAD, 0xc2c1,
/* 10 */ 0xf0a1, 0xf07d, 0xf07e,    BAD,    BAD, 0xf2c2,    BAD, 0xf2c1,
/* 18 */ 0xc3be, 0xf4b4, 0xc4a4, 0xf4b3,    BAD, 0xf5f0, 0xf745, 0xc5a6,
/* 20 */ 0xf943, 0xf944, 0xc5d8, 0xa6da, 0x99ab, 0xaad7, 0xdb52, 0xbb4e,
/* 28 */ 0xc17b, 0xedef, 0xa6db,    BAD, 0xafe5, 0xafe4, 0xdb53, 0xfec4,
/* 30 */    BAD,    BAD, 0xeaf4, 0xa6dc, 0xad50,    BAD, 0x98c2, 0xdb54,
/* 38 */ 0xdb55, 0xdb56, 0xbb4f, 0xbfb2, 0xa6dd,    BAD, 0xaad8, 0xd068
},

/* Row 0x2bc */
{
/* 00 */ 0xafe6, 0xd370, 0xb2ea,    BAD, 0xdb57, 0xb8a4,    BAD, 0xbb50,
/* 08 */ 0xbfb3, 0xc17c, 0xc2c2, 0xf4b5, 0xa6de, 0xaad9,    BAD,    BAD,
/* 10 */ 0xafe7, 0xd752, 0xb5ce,    BAD, 0xbb51, 0xe3ab, 0xe745,    BAD,
/* 18 */ 0x8ee8,    BAD, 0xa0ba, 0xa6df, 0xb5cf, 0xdfa3, 0xbb52, 0xa6e0,
/* 20 */ 0xcdb1, 0xd069, 0xad51,    BAD,    BAD, 0xd372, 0xfd77,    BAD,
/* 28 */ 0xafea, 0x8eee, 0xafe8, 0xafe9, 0xafeb, 0x9ebf,    BAD, 0xd371,
/* 30 */    BAD,    BAD, 0xd757, 0xd754, 0xd756, 0xb2eb, 0xb2ed, 0xb2ec,
/* 38 */ 0xd753, 0xb2ee, 0xd755,    BAD, 0xdb58, 0xdb59, 0x89c2, 0xdb5a
},

/* Row 0x2bd */
{
/* 00 */ 0xdfa6,    BAD, 0xdfa7,    BAD, 0xdfa5, 0xdfa8,    BAD, 0xb8a5,
/* 08 */    BAD, 0xdfa4,    BAD, 0xbb53,    BAD,    BAD, 0xe74a, 0xe746,
/* 10 */ 0xe749, 0xe74b, 0xe748, 0xe747, 0x99ac, 0xeaf5, 0xeaf6, 0xeaf7,
/* 18 */ 0xbfb4, 0xbfb5, 0xedf1, 0xedf0, 0xedf2,    BAD, 0xf0a3, 0xf0a2,
/* 20 */    BAD, 0xf2c4, 0x956b, 0xf2c5, 0xf2c3, 0x956c, 0xc4a5,    BAD,
/* 28 */ 0xf4b6, 0xf4b7,    BAD, 0xf746, 0xf7ef, 0xf8bb, 0xa6e1, 0xa87d,
/* 30 */    BAD, 0xc17d, 0xa6e2,    BAD, 0xd758, 0xdb5b, 0x99af, 0xc641,
/* 38 */ 0xca4a, 0x994a, 0x8976, 0x8f48, 0xca4b, 0xca4d, 0xa6e3, 0xca4e
},

/* Row 0x2be */
{
/* 00 */ 0xca4c,    BAD,    BAD, 0xcba2, 0xcba3, 0xcb7b,    BAD, 0xfbee,
/* 08 */    BAD,    BAD, 0xcba1, 0xa8a1,    BAD, 0xa8a2, 0xcb7c, 0xcb7a,
/* 10 */ 0xcb79, 0xcb7d, 0xa87e, 0xcb7e, 0xd06a,    BAD,    BAD,    BAD,
/* 18 */ 0xcdb6, 0xaadc, 0xcdb5, 0xcdb7,    BAD, 0xaadb, 0xcdbc, 0xaadf,
/* 20 */ 0xcdb2, 0xcdc0, 0xcdc6, 0xaae6, 0xcdc3, 0xaae3, 0x99ae, 0xcdb9,
/* 28 */ 0xcdbf, 0xcdc1, 0x8efb, 0xcdb4, 0xaae2, 0xaadd, 0xcdba, 0xaae4,
/* 30 */ 0xaae7, 0xaae1,    BAD, 0xaada, 0xcdbe, 0xcdb8, 0xcdc5, 0xaae9,
/* 38 */ 0xaae5, 0xaae0, 0xcdbd, 0xafec, 0xcdbb, 0xaade, 0xaae8,    BAD
},

/* Row 0x2bf */
{
/* 00 */ 0xcdb3,    BAD, 0xcdc2, 0xcdc4, 0x8b52,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x99b0,    BAD,    BAD,    BAD,    BAD, 0x8977,
/* 10 */ 0x8f41, 0xad62, 0xad5c, 0xad64, 0xad61, 0xd071, 0xd074, 0xad5d,
/* 18 */ 0x99b1, 0xd06b,    BAD, 0xad56, 0xad60,    BAD, 0xad63, 0xad65,
/* 20 */ 0xd0a2, 0xd077, 0x8f49, 0xad55, 0xd0a1, 0xad59, 0xad57, 0xad52,
/* 28 */ 0xd06f,    BAD, 0xd07e, 0xd073, 0xd076, 0xd0a5, 0xfa4d, 0xad66,
/* 30 */ 0xd07d, 0xad5e, 0xd078, 0xd0a4, 0xd075, 0xd079, 0xd07c, 0x9de4,
/* 38 */    BAD, 0xd06d, 0xd0a3, 0xd07b, 0xfbe9, 0x9b54, 0xd06c, 0x99b2
},

/* Row 0x2c0 */
{
/* 00 */ 0xd070, 0xad5f, 0xad5a, 0xad53, 0xad58, 0xad54, 0xad67, 0xd06e,
/* 08 */ 0xd3a5, 0xad5b,    BAD, 0x9e68, 0xd07a, 0xce41,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3a8, 0xaffa,
/* 18 */ 0x8f4a, 0xd376, 0x8f42, 0xd3a3, 0xd37d, 0x8f51, 0xd3b2,    BAD,
/* 20 */ 0xd3aa,    BAD, 0xd37e,    BAD, 0xd3a9, 0xd378, 0xd37c, 0xd3b5,
/* 28 */ 0xaffd, 0xd3ad, 0xd3a4, 0xafed, 0xd3b3, 0xd374,    BAD, 0xd3ac,
/* 30 */    BAD, 0xaffc, 0xaff7, 0xd373, 0xaff5, 0xaff4, 0xaff9, 0xd3ab,
/* 38 */ 0xaff1, 0xaff8, 0xd072, 0xdb5c, 0xd3a6, 0x9846,    BAD, 0xd37a
},

/* Row 0x2c1 */
{
/* 00 */ 0xaffb, 0xd37b, 0xd3a1, 0xaffe, 0xd375, 0xd3af,    BAD, 0xd3ae,
/* 08 */ 0xd3b6, 0xaff3, 0xaff0, 0xd3b4, 0xd3b0, 0xd3a7, 0xd3a2, 0xaff6,
/* 10 */ 0xaff2, 0xd377, 0xafee, 0xd3b1, 0xafef,    BAD, 0xd379, 0x99b4,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x8ef5, 0xfd55,    BAD,    BAD, 0x9ccd,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8978,
/* 30 */    BAD,    BAD,    BAD, 0xd75e, 0xd760, 0xd765, 0xd779, 0xb2fc,
/* 38 */ 0xb2f2,    BAD, 0xd75d, 0xb2fd, 0xb2fe, 0xd768, 0xd76f, 0xd775
},

/* Row 0x2c2 */
{
/* 00 */    BAD, 0xd762,    BAD, 0xd769,    BAD, 0x8f53, 0xb340, 0xd777,
/* 08 */ 0xd772, 0xb2fa, 0xb2f8, 0xd76e, 0xd76a, 0xd75c, 0xb2ef, 0xd761,
/* 10 */ 0xd759, 0x8f6f, 0xb2f7, 0xb2f9, 0xd766, 0xd763, 0xb2f4, 0xd773,
/* 18 */ 0xb2f1, 0xd764, 0xd77a, 0xd76c, 0x8e63, 0xd76b, 0xb2f0,    BAD,
/* 20 */ 0xb2fb,    BAD, 0xb2f3, 0xd75a, 0xd75f, 0xd770, 0xd776, 0xb341,
/* 28 */ 0xd75b, 0xd767, 0xd76d, 0xb2f6, 0x8f56,    BAD, 0xd778, 0xd771,
/* 30 */ 0xd774,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xfe76,    BAD,    BAD,    BAD, 0xb2f5, 0x9fc6, 0xdb6c
},

/* Row 0x2c3 */
{
/* 00 */ 0xdb60, 0xb5d7, 0xdb7d, 0xdba7, 0xdbaa, 0xb5d5, 0xdb68, 0xdba3,
/* 08 */ 0xdb69, 0xdb77, 0xb5e2, 0xdb73, 0xb5df, 0xfaac, 0xdb74, 0xdb5d,
/* 10 */    BAD, 0xdba4,    BAD, 0x8f58, 0xb5e8, 0xdba1, 0xdb75, 0xdbac,
/* 18 */ 0xdb70, 0xdfc8,    BAD, 0xdbaf, 0xb5e6, 0xdb6e, 0xdb7a, 0xb5e9,
/* 20 */ 0xb5d4, 0xdb72, 0xdbad, 0xdb6b, 0xdb64, 0xdb6f,    BAD, 0xdb63,
/* 28 */ 0xdb61, 0xb5d0, 0xdba5, 0xdb6a, 0xdba8, 0x9848, 0xdba9, 0xb5d8,
/* 30 */ 0xb5dd, 0xb5d9, 0xb5e1, 0xdb7e, 0xb5da, 0xdb76, 0xdb66,    BAD,
/* 38 */ 0xb5d2, 0xdb5e, 0xdba2, 0xdbab, 0xdb65, 0xb5e0, 0xdbb0, 0xdb71
},

/* Row 0x2c4 */
{
/* 00 */    BAD, 0xdb6d,    BAD, 0xb5d1, 0xb5e5, 0x99b7, 0xdb7c, 0xb5e7,
/* 08 */    BAD, 0xdb78, 0xb5dc, 0xb5d6, 0xb5de, 0xb5d3, 0xb5e4, 0xdb79,
/* 10 */ 0xdb67, 0xdb7b, 0xdb62, 0xdba6, 0x9665,    BAD, 0xfa6c,    BAD,
/* 18 */ 0x9de7,    BAD,    BAD, 0xdbae, 0x9e62,    BAD,    BAD,    BAD,
/* 20 */ 0x96cc, 0x8e67,    BAD, 0xdb5f, 0xfc75,    BAD, 0x987e,    BAD,
/* 28 */    BAD, 0xdfc7,    BAD, 0xdfdd, 0xb855, 0xdfcc, 0xfdb9, 0xdfca,
/* 30 */ 0xdfb5, 0xb8a9, 0xdfc5, 0xdfd9, 0xdfc1, 0xb8b1, 0xdfd8, 0xdfbf,
/* 38 */ 0xb5e3, 0xdfcf, 0xdfc0, 0xdfd6, 0xb8b0, 0xb8a8, 0x97fc, 0xdfaa
},

/* Row 0x2c5 */
{
/* 00 */ 0xdfb2,    BAD, 0xdfcb, 0xdfc3, 0xdfdc, 0xdfc6, 0xb8b6, 0xdfd7,
/* 08 */ 0x98f9, 0xb8ad, 0x8f66, 0xdfc9, 0xdfd1, 0xdfb6, 0xdfd0,    BAD,
/* 10 */ 0xdfe1, 0xdfb1, 0xdfd2, 0x956e, 0xdfdf, 0x9245, 0xdfab, 0xb5db,
/* 18 */ 0x8f60, 0xdfb9, 0xdfb8, 0xb8af, 0x9ed1, 0xdfbc, 0xdfbe, 0xdfcd,
/* 20 */ 0xdfde, 0xb8b2, 0xfecd, 0xb8b3, 0x99b9, 0xdfb0, 0xb8ab, 0xdfb4,
/* 28 */ 0xdfda, 0xb8b4,    BAD, 0xb8ac, 0xb8ae, 0xb8b5, 0xdfe0, 0xdfd3,
/* 30 */ 0xdfce, 0x8f62, 0x974c, 0xdfbb, 0xdfba, 0xb8aa, 0xdfac, 0xb8a7,
/* 38 */ 0xdfc4, 0xdfad, 0xdfc2,    BAD,    BAD, 0xdfb7, 0xdfdb, 0x91c7
},

/* Row 0x2c6 */
{
/* 00 */ 0x955f,    BAD, 0xb8a6,    BAD,    BAD,    BAD, 0xdfb3,    BAD,
/* 08 */ 0x99bb,    BAD,    BAD,    BAD,    BAD, 0xdfaf, 0xdfd5, 0xdfae,
/* 10 */ 0xbb60, 0xe3d3, 0x8e6d, 0x8f71, 0xe3c2,    BAD, 0x94cb, 0xe3ac,
/* 18 */ 0xe3ca, 0xbb58, 0xe3bb, 0xe3c5, 0xbb5b, 0xe3be, 0xbb59, 0xe3af,
/* 20 */ 0xe3cd, 0xe3ae, 0xe3c1, 0x95b1, 0xe3ad,    BAD,    BAD, 0xe3bf,
/* 28 */ 0xe3c8, 0xe3c6, 0xe3ba, 0xe3b5, 0xe3b3, 0x9af2, 0xe3b4, 0xe3c7,
/* 30 */ 0xe3d2, 0xe3bc, 0xbb5a,    BAD, 0xe3b7,    BAD, 0xe3cb,    BAD,
/* 38 */ 0xbb5d, 0xe3b6, 0xe3b0, 0xe3c0, 0xbb61, 0x96c3, 0x99bd, 0xbb55
},

/* Row 0x2c7 */
{
/* 00 */ 0xbb5e, 0xe3b8, 0xe3b2,    BAD, 0xbb57, 0xdfd4, 0xbb56, 0xe3c3,
/* 08 */    BAD, 0xbb54, 0xbb63, 0xbb5c, 0xe3c4, 0xe3b9, 0xe3b1, 0xe3cc,
/* 10 */ 0xe3bd, 0xbb62, 0xe3d0, 0xbb5f, 0xe3cf,    BAD, 0xe3c9, 0xe3ce,
/* 18 */    BAD,    BAD, 0xa0cf, 0xe3d1,    BAD,    BAD, 0x8f6d,    BAD,
/* 20 */    BAD, 0x99be, 0x8ef4,    BAD, 0x8f72, 0x95e4,    BAD, 0xe773,
/* 28 */ 0xe774, 0xe767, 0xe766, 0xe762, 0xbdb4,    BAD, 0xbdac, 0xe776,
/* 30 */ 0xe775, 0xdfa9, 0xe75f, 0xe763, 0xe75d,    BAD, 0xe770, 0xe761,
/* 38 */ 0x99bf, 0xe777, 0xe75a, 0xe758, 0xe764, 0xe76e, 0xe769, 0xbdb6
},

/* Row 0x2c8 */
{
/* 00 */ 0xe74f,    BAD, 0xe76d, 0x9242,    BAD, 0xfba5, 0xbdb7, 0xdfbd,
/* 08 */ 0xe75b, 0xe752, 0xe755, 0xe77b, 0xe75c, 0xe753, 0xe751, 0xe74e,
/* 10 */ 0x99c0, 0xbdb0, 0xe765, 0xbdaf, 0xbdb3, 0xe760, 0xe768, 0xbda9,
/* 18 */ 0xe778, 0xe77c, 0xbdab,    BAD, 0xe757, 0xe76b, 0xe76f, 0xe754,
/* 20 */ 0xe779, 0xbdb2,    BAD, 0xbdb1, 0xe74c, 0xbdb5, 0xe772, 0xe756,
/* 28 */ 0xe76a, 0xe750, 0xe75e, 0xe759, 0xbdad, 0xbdae, 0xe76c, 0xe77d,
/* 30 */ 0xe77a, 0xe771,    BAD, 0xfdb4, 0x8f77,    BAD,    BAD,    BAD,
/* 38 */ 0x99c1,    BAD,    BAD, 0xe74d,    BAD, 0xbdaa, 0xeb49,    BAD
},

/* Row 0x2c9 */
{
/* 00 */ 0xeb40, 0xeb43, 0xfab9, 0xbfbb, 0xeb45, 0xeaf9, 0xeb41, 0xeb47,
/* 08 */ 0xbfb8, 0xbfbc, 0xbfb6, 0x8f40, 0xfa44, 0xeafb, 0xeb4c,    BAD,
/* 10 */    BAD, 0xeb46, 0x99c2, 0xeafc, 0xeb55, 0xeb4f, 0xeaf8, 0xee46,
/* 18 */ 0xeafe, 0xbfb7, 0x8f5c, 0xeb4a,    BAD, 0xeb54, 0xbfbf,    BAD,
/* 20 */ 0xeb51, 0xeafd, 0xeb44, 0xeb48, 0xeb42, 0xeb56, 0xeb53, 0xeb50,
/* 28 */ 0xbfb9, 0xbfba, 0xbfbe, 0xeafa, 0xeb57, 0xbfbd, 0xeb4d, 0x99c4,
/* 30 */ 0x99c5, 0xeb4b,    BAD, 0x8f7b,    BAD, 0xeb4e, 0xee53, 0xee40,
/* 38 */ 0xee45, 0xee52, 0xee44, 0xedfb, 0xee41,    BAD, 0xc1a2,    BAD
},

/* Row 0x2ca */
{
/* 00 */ 0xf0a6, 0x8fa3, 0xf0a8, 0xf0a7, 0xf0ad, 0xf0b2, 0xf0a5, 0xf0ac,
/* 08 */ 0xf0b1, 0xc2c7,    BAD, 0xf0af,    BAD, 0xc2c5, 0xf0b0, 0xc2c3,
/* 10 */ 0xc2c6, 0xf2d5, 0xf0b5,    BAD,    BAD, 0xc3c2,    BAD, 0xf2cd,
/* 18 */ 0xf2d1, 0xf2c9, 0xf2cc,    BAD, 0xf2d4, 0xc3c0, 0xf2d9, 0xf2d2,
/* 20 */ 0x99c6, 0xf2ca, 0xf2da, 0xf2d3, 0xc3c3, 0xc3c4, 0xf2d7,    BAD,
/* 28 */ 0xf2cb, 0xc3bf, 0xc3c1, 0xf2c6, 0xf2ce, 0xf2c8, 0x96cd, 0xf2d8,
/* 30 */ 0xf2d6, 0xf2c7, 0xf2cf,    BAD,    BAD,    BAD, 0xf4be, 0xc3c5,
/* 38 */ 0xf2d0, 0xc4a7, 0xc4a9, 0xc4a6, 0x96c7, 0xf4c3, 0xf4bb, 0xf4b9
},

/* Row 0x2cb */
{
/* 00 */ 0xf4bd, 0xf4ba, 0x8fa5,    BAD, 0xf4bf, 0xf4c1, 0xc4aa, 0xc4ac,
/* 08 */    BAD, 0xf4c0, 0xc4ad, 0xc4ab, 0xf4c2, 0xfabb,    BAD,    BAD,
/* 10 */ 0x9570, 0xc4a8,    BAD,    BAD, 0x9368,    BAD, 0x8f7e, 0xc4f4,
/* 18 */ 0xf5f1, 0xf5f7, 0xc4f6, 0xf4bc, 0xf5f6,    BAD, 0xf5fd, 0xf5f4,
/* 20 */ 0xf5fb, 0xf5fa, 0xf4b8, 0xf5f5, 0xf0b6, 0xf5fe, 0xf5f3, 0xf5f8,
/* 28 */ 0x8faa, 0xf5fc, 0xf5f2,    BAD, 0xf74a, 0xc4f5, 0xf5f9, 0xa050,
/* 30 */    BAD, 0xf7f4, 0xf74b, 0xf749, 0xf747, 0xf748, 0xf74c,    BAD,
/* 38 */ 0xc5d9, 0xf7f2, 0xf7f0, 0xf7f5, 0xf7f3,    BAD, 0xf7f6, 0xc5da
},

/* Row 0x2cc */
{
/* 00 */ 0xf7f1,    BAD, 0x90d3, 0xf8bc,    BAD, 0x9556, 0xf945, 0xf946,
/* 08 */ 0xf947,    BAD,    BAD, 0xf9c7, 0xf9bd, 0xca4f, 0xaaea,    BAD,
/* 10 */ 0xad68,    BAD, 0xd3b8, 0xd3b7, 0xb040, 0xb342, 0xd77c,    BAD,
/* 18 */    BAD, 0xd77b,    BAD, 0xb5ea, 0xb8b8,    BAD, 0xb8b7, 0xb8b9,
/* 20 */    BAD, 0xe3d4, 0xe77e, 0xeb58, 0xeb5a, 0xeb59,    BAD, 0xc1ab,
/* 28 */ 0xee57, 0xf0ba, 0xf9a5, 0xa6e4, 0x8fb8, 0xcdc9, 0xcdca, 0xcdc8,
/* 30 */ 0xcdc7, 0xaaeb, 0x99c8, 0xd0a9, 0xd0a7,    BAD,    BAD, 0xd0a6,
/* 38 */    BAD, 0xad69, 0xad6b, 0xad6a, 0xd0a8,    BAD, 0x8faf,    BAD
},

/* Row 0x2cd */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xd3c4, 0xd3c1, 0xd3bf,
/* 08 */    BAD,    BAD, 0xb041, 0xd3c2, 0xb046, 0xd3bc, 0xd3cb,    BAD,
/* 10 */ 0xd3cd, 0xd3bd, 0x99c9, 0xb043, 0xd3ce, 0xd3c9, 0xd3bb, 0xd3c0,
/* 18 */ 0xd3ca, 0xd3c6, 0xd3c3,    BAD, 0xb048, 0xd3cc, 0xd3be,    BAD,
/* 20 */ 0x9579, 0xd3c7, 0xd3b9, 0xb047, 0xb044, 0xd3c5,    BAD, 0xd3c8,
/* 28 */ 0xd3ba, 0xb045, 0xb042,    BAD,    BAD, 0x9f49,    BAD, 0xb34c,
/* 30 */ 0xd7a5, 0xb34b, 0x99ca, 0xd7a8, 0xd7ab, 0xb348, 0xb346, 0xd77e,
/* 38 */ 0xd7a9, 0xd7a7, 0xd7a4, 0xd7ac, 0xd7ad, 0xd7af, 0xd7b0, 0xd77d
},

/* Row 0x2ce */
{
/* 00 */ 0xb345, 0xd7a2, 0xd7a1, 0xd7ae, 0xb347, 0xd7a3, 0xb349, 0xb344,
/* 08 */ 0xd7a6, 0xb34d,    BAD, 0xb34a, 0xd7aa,    BAD,    BAD,    BAD,
/* 10 */ 0xb5f1, 0xdbbf,    BAD, 0xdbb4, 0xb5ee,    BAD, 0xdfe7, 0xdbbd,
/* 18 */ 0xdbb1, 0xb5ec, 0xdbb6, 0xb5ef, 0xdbba, 0xdbb8, 0xb5f2, 0xb5eb,
/* 20 */    BAD,    BAD, 0xdbb2, 0xdbb5, 0xb5f0,    BAD, 0xdbb3,    BAD,
/* 28 */ 0xdbbe, 0xdbbc, 0xdbb7, 0xdbb9, 0xdbbb, 0xb5ed,    BAD, 0x99cb,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdfe8, 0xdfee, 0xdfe4,
/* 38 */ 0xdfea, 0xb8ba, 0xdfe6, 0xb8c0,    BAD,    BAD, 0xb8bf,    BAD
},

/* Row 0x2cf */
{
/* 00 */ 0xb8be, 0xdfed, 0xb8c1, 0xb8c2, 0xdfe3, 0xdff0, 0xb8c3, 0xb8bd,
/* 08 */ 0xb8bc, 0xdfec, 0xb8c4, 0xdfe2, 0xdfe5, 0xdfef, 0xdfeb,    BAD,
/* 10 */    BAD, 0xe3f4, 0xe3e9, 0xb8bb,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xbb6a, 0xe3dd, 0xe3f2, 0xe3de, 0xbb65,    BAD, 0xe3db,    BAD,
/* 20 */ 0xe3e4, 0xe3dc, 0xbb67, 0xe3d6, 0xe3f1, 0xbb68, 0xe3ee, 0xe3ef,
/* 28 */ 0x957a, 0xbb6d, 0xe3e6,    BAD, 0xe3e0, 0xe3e7, 0xe3da,    BAD,
/* 30 */ 0xe3f3, 0xe3eb, 0xe3e5, 0xe3d5, 0xbb69, 0xe3ec,    BAD, 0xbb6c,
/* 38 */ 0xe3f0,    BAD, 0xe3ea, 0xbb66, 0xe3e8,    BAD, 0xe3e2, 0xbb64
},

/* Row 0x2d0 */
{
/* 00 */ 0xe3d9, 0xe3e1, 0xe3ed, 0xe3df,    BAD,    BAD, 0xe3e3,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xbdc1, 0xdfe9, 0xe7b2, 0xe7bb,
/* 10 */ 0xe7b1, 0xe7ad, 0xe7aa, 0xbdc2, 0xe7a8, 0xbb6b, 0xe7a1, 0xbdc0,
/* 18 */ 0xe7a7, 0xbdbf, 0xe7ac, 0xe7a9, 0xe7b9, 0xe7b4, 0xe7ae, 0xe7b3,
/* 20 */ 0xbdbb, 0xe7ab, 0xe7be, 0xe7a2, 0xe7a3, 0xe7ba, 0xbdbc, 0xe7bf,
/* 28 */ 0xbdbe, 0xe7c0, 0xe7b0, 0xe3d8, 0xe7b6, 0xe7af, 0xe7b8, 0xe7b5,
/* 30 */ 0x9dd5, 0x8fb0,    BAD, 0xe7a6, 0xbdb9, 0xe7bd, 0xbdba, 0xe7a4,
/* 38 */ 0xbdbd, 0xeb64, 0xe7b7, 0xe7bc,    BAD, 0xfa7a,    BAD,    BAD
},

/* Row 0x2d1 */
{
/* 00 */    BAD, 0xeb61, 0xbdb8, 0xbfc0, 0xeb6b, 0xeb67, 0x9e5f, 0xeb65,
/* 08 */ 0xeb60, 0xeb6f,    BAD, 0x99cd, 0xa0c9, 0xbfc4,    BAD, 0xeb5c,
/* 10 */ 0xeb68, 0xeb69, 0xeb5f, 0xeb5e, 0xeb6c,    BAD, 0xeb62, 0xeb5d,
/* 18 */ 0xeb63,    BAD, 0xeb6e, 0xeb5b, 0xeb6d, 0xeb6a, 0xbfc2, 0xbfc1,
/* 20 */    BAD,    BAD, 0xbfc3, 0xeb66, 0xf0cb, 0x9adb,    BAD,    BAD,
/* 28 */    BAD, 0xa0c6, 0xee59, 0xc1b1, 0xee5d, 0xee5a, 0xee61, 0xee67,
/* 30 */ 0xee5c, 0x8fb4, 0xee70, 0xc1ae, 0xee6a, 0xee5f, 0xee6b, 0xee66,
/* 38 */ 0xee6d, 0xee5e, 0xc1b3, 0xc1b2, 0xee60, 0xee6e, 0xee58, 0xee6c
},

/* Row 0x2d2 */
{
/* 00 */ 0xc1ac, 0xa0d7, 0xee64, 0xee63, 0xee68, 0xee5b, 0xc1b0,    BAD,
/* 08 */ 0xc1b4, 0xee62, 0xee69, 0xc1b5, 0xee65,    BAD, 0xa0c7,    BAD,
/* 10 */    BAD, 0xc1ad, 0xc1af, 0xf0c7, 0xf0c5,    BAD, 0xa043, 0xf0cc,
/* 18 */ 0xf0c9, 0xf0cd, 0x8fb5, 0xf0be, 0xf0c6, 0xf0d1, 0xee6f, 0xf0c2,
/* 20 */ 0xc2cf, 0xe7a5, 0xf0bd, 0xf0ca, 0xf0c4, 0xf0c1, 0xf0bc, 0xf0bb,
/* 28 */ 0xf0d0,    BAD, 0xf0c0, 0xf0bf, 0xc2cd, 0xf0c8, 0x8fb2, 0xc2cc,
/* 30 */    BAD,    BAD, 0xc2ce, 0xf0c3, 0xf0cf, 0xa061, 0xf2de, 0xf2df,
/* 38 */    BAD, 0xc3c9, 0xf2dc, 0xc3c6, 0xf2e4,    BAD, 0xc3ca, 0xf2e6
},

/* Row 0x2d3 */
{
/* 00 */ 0xf2db, 0xf0ce, 0xf2e8, 0xf2dd, 0x9e5e, 0xc3c7, 0xf2e3,    BAD,
/* 08 */ 0xf2e5, 0xf2e0, 0xf2e7, 0xf2e2, 0xf2e1, 0xc3c8,    BAD, 0x8fb6,
/* 10 */ 0xf4c5, 0xf4c6,    BAD, 0xf4c8, 0xc4ae, 0xc4af, 0xf4c9, 0xf4c7,
/* 18 */ 0x9fe8, 0xf4c4,    BAD, 0xf642, 0xf645, 0xf641,    BAD, 0xc4fa,
/* 20 */ 0xf643, 0xc4f9, 0xc4f8, 0xc4f7, 0xf644, 0xf751, 0xf74f, 0x9cb2,
/* 28 */ 0xf74e, 0xf640, 0xf750, 0xf646, 0xf74d, 0x957c, 0xf7f9, 0xf7d7,
/* 30 */ 0xf7f7, 0xc5db, 0xf7f8, 0xf7fa,    BAD, 0xf8bf, 0xc5fa, 0xf8be,
/* 38 */ 0xf8bd, 0xc5fb,    BAD, 0xc65a, 0xf96e, 0xf9a7, 0xf9a6, 0xf9a8
},

/* Row 0x2d4 */
{
/* 00 */ 0xa6e5, 0xd0aa, 0x9fc7, 0xd3cf, 0xd3d0, 0x8fbb, 0x8fbc,    BAD,
/* 08 */ 0xdbc0,    BAD, 0xf647, 0xf8c0, 0xa6e6, 0xad6c, 0xd0ab, 0x8fec,
/* 10 */    BAD,    BAD, 0xd7b1, 0xb34e,    BAD, 0xdbc2, 0xdbc1, 0xb5f3,
/* 18 */    BAD, 0xb8c5, 0xe7c1, 0xbdc3,    BAD, 0xbdc4, 0x8fc0,    BAD,
/* 20 */ 0x936a, 0xbfc5, 0xc5fc, 0xa6e7, 0x8be4, 0x9c7c,    BAD, 0xd0ac,
/* 28 */ 0xaaed, 0xd0ae, 0xd0ad, 0xad6d,    BAD, 0xd3d1, 0x95a1, 0xd3d8,
/* 30 */ 0xb049, 0xd3d6, 0xd3d4,    BAD, 0xd3db, 0xd3d2, 0xd3d3, 0xb04a,
/* 38 */    BAD, 0xb04e,    BAD,    BAD, 0xd3dc, 0xb04d, 0xd3da, 0xd3d7
},

/* Row 0x2d5 */
{
/* 00 */ 0xd3d5, 0xb04b, 0xb04c, 0xd3d9, 0xfeec,    BAD,    BAD, 0x95a3,
/* 08 */ 0xb350, 0xd7b2,    BAD, 0xb355, 0xd7c2, 0xb354, 0xd7c4,    BAD,
/* 10 */    BAD, 0xd7b8, 0xb352, 0xd7c3,    BAD, 0xd7b3, 0xb353, 0xd7bf,
/* 18 */ 0xd7bb, 0xd7bd, 0xd7b7, 0xd7be, 0x8fc1,    BAD, 0xb34f, 0xd7ba,
/* 20 */ 0xa052, 0xd7b9, 0xd7b5,    BAD, 0xd7c0,    BAD,    BAD, 0xd7bc,
/* 28 */ 0xd7b4,    BAD, 0xd7b6, 0xb351, 0xd7c1,    BAD, 0x99d0,    BAD,
/* 30 */    BAD, 0xb5f6, 0xdbcd,    BAD, 0x8fc3, 0x8fc4, 0xdbc9, 0xdbcb,
/* 38 */ 0xdbc6, 0xdbc5, 0xdbc3,    BAD, 0xdbca, 0xdbcc, 0xdbc8, 0x95a4
},

/* Row 0x2d6 */
{
/* 00 */ 0xdbc7, 0xb5f4, 0xb5f5,    BAD,    BAD, 0x8fc6,    BAD, 0x9e60,
/* 08 */    BAD, 0xdbcf, 0xb8cd, 0xdff2, 0xdff8, 0xdff3, 0xdff4, 0xf9d8,
/* 10 */ 0xdff9,    BAD, 0xb8cf,    BAD, 0xb8c7, 0xb8ce, 0xdff1, 0xdbc4,
/* 18 */ 0xb8ca, 0xb8c8, 0xdff7, 0xdff6, 0xb8c9, 0xb8cb, 0xdff5, 0xb8c6,
/* 20 */    BAD, 0xb8cc,    BAD,    BAD,    BAD,    BAD, 0x95a5, 0xe3f6,
/* 28 */ 0xbb74,    BAD,    BAD, 0xe442, 0xe441,    BAD, 0xe3fb, 0xbb76,
/* 30 */ 0xe440, 0xe3f7, 0xe3f8, 0xbb6e, 0xbb70, 0x9cb3, 0xe3fd, 0xe3f5,
/* 38 */ 0xbb72, 0xbb71, 0xe3f9, 0xe3fe, 0xe3fc, 0xbb73, 0xe3fa, 0x99d1
},

/* Row 0x2d7 */
{
/* 00 */ 0xfef1, 0xdbce, 0xbb6f,    BAD,    BAD, 0xe7c2, 0xe7c9, 0xbdc6,
/* 08 */    BAD, 0xe7cd, 0xbdca, 0xe7c5, 0xe7c3,    BAD, 0xe7cc,    BAD,
/* 10 */ 0xbdc5, 0xe7cb, 0xbdc7, 0xbdc8, 0xe7c4, 0xbdc9, 0xe7ca, 0xe7c6,
/* 18 */ 0xe7c7, 0xe7c8, 0xbb75,    BAD,    BAD,    BAD, 0xeb70, 0xeb7c,
/* 20 */    BAD, 0xbfca, 0xeb77, 0xeb79, 0x99d2, 0xbfc8, 0xeb71, 0xeb75,
/* 28 */    BAD, 0xeb78, 0xbfc6, 0xbfc9, 0xeb7b, 0xeb73, 0xeb74, 0xeb7a,
/* 30 */ 0xeb72, 0xeb76, 0xbfc7, 0xee72,    BAD, 0xee71, 0xc1b7, 0xee77,
/* 38 */ 0xc1b9,    BAD,    BAD, 0xc1b6, 0xee73, 0xc1ba, 0xee74,    BAD
},

/* Row 0x2d8 */
{
/* 00 */    BAD, 0xee75, 0xee78, 0x9cc2, 0xc1b8,    BAD, 0xf0d6, 0x99d3,
/* 08 */    BAD, 0xf0d9,    BAD, 0xf0d3, 0xf0d5, 0x95a7,    BAD, 0xf0d4,
/* 10 */ 0xf0d7, 0xf0d8, 0xee76, 0xf0d2, 0x95a9,    BAD, 0xc3cd, 0xf2ec,
/* 18 */ 0xf2ef, 0xf2f1, 0xf2ea, 0xf2eb, 0xf2ee, 0xf2f0, 0xc3ce, 0xc3cc,
/* 20 */ 0xc3cb, 0xf2ed, 0xf2e9, 0xf4ca, 0xc4b0, 0x95a6, 0xf4cb,    BAD,
/* 28 */    BAD, 0xf649, 0xc4fb, 0xf64b, 0xc4fc, 0xf648, 0xf64a, 0xc5a8,
/* 30 */    BAD, 0xf752, 0xc5a7, 0xf7fd, 0xf7fc,    BAD, 0xf7fb, 0x9c5d,
/* 38 */    BAD, 0xf948, 0xf949, 0xf94b, 0xf94a,    BAD, 0xca50, 0xa6e8
},

/* Row 0x2d9 */
{
/* 00 */ 0x98e2, 0xad6e, 0xd7c5, 0xb5f7,    BAD, 0xdffa, 0xc2d0, 0x8fc9,
/* 08 */ 0xf2f2, 0xa0c2, 0x8fca, 0xa8a3,    BAD,    BAD,    BAD, 0xb357,
/* 10 */    BAD, 0x99d4,    BAD, 0xb356, 0xa0b9, 0xdbd0, 0xb5f8, 0xdbd2,
/* 18 */ 0xdbd1,    BAD,    BAD, 0xdffb, 0xb8d0, 0xe443, 0xe446, 0xe445,
/* 20 */    BAD, 0xe444, 0xe7ce, 0xe7d0, 0xe7cf, 0x9b58, 0xbfcc, 0x8fcd,
/* 28 */    BAD, 0xa0d4, 0xbfcb,    BAD, 0xc1bb, 0xee79, 0xee7b, 0xee7a,
/* 30 */    BAD,    BAD, 0xc2d1,    BAD,    BAD,    BAD, 0xf2f4, 0xf2f3,
/* 38 */    BAD, 0xf4cc, 0xc4b1,    BAD, 0x8fce, 0xc4fd, 0xf754, 0xf753
},

/* Row 0x2da */
{
/* 00 */ 0xc65b, 0x8be5,    BAD,    BAD,    BAD,    BAD, 0x8979,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xa8a4, 0xd0af, 0xad6f, 0xd7c8, 0xd7c6,    BAD,
/* 18 */    BAD, 0xd7c7, 0xdbd4, 0xdbd5, 0xe043, 0xdbd3,    BAD, 0xdffc,
/* 20 */ 0xe041, 0xe040, 0xe042, 0xb8d1, 0xdffe, 0xdffd, 0xe044, 0x8fd0,
/* 28 */ 0xe449, 0xe447,    BAD, 0xe448, 0xe7d3, 0xe7d1,    BAD,    BAD,
/* 30 */ 0xe7d2, 0xeb7d, 0xee7c, 0xee7d, 0xc2d2,    BAD, 0xf2f5, 0xf4cd,
/* 38 */ 0xc4b2,    BAD, 0xf64c, 0xf755, 0xc5a9,    BAD, 0xf7fe, 0xf94c
},

/* Row 0x2db */
{
/* 00 */ 0xa8a5,    BAD, 0xad71, 0xad72, 0xd0b0,    BAD,    BAD, 0xd0b1,
/* 08 */ 0xad70,    BAD, 0xb054,    BAD, 0xb052,    BAD, 0xb051, 0xb058,
/* 10 */ 0xb050, 0xb059, 0xd3dd, 0xb056,    BAD, 0xb053, 0xb057, 0xb055,
/* 18 */ 0xb04f,    BAD,    BAD, 0xb35f, 0x95b6, 0xb359, 0xd7cc, 0xb35e,
/* 20 */    BAD,    BAD, 0xb360, 0xb35a,    BAD, 0xb35b,    BAD, 0xd7ca,
/* 28 */    BAD, 0x99d6, 0xb358, 0x95e5, 0xd7cb, 0xb35d,    BAD,    BAD,
/* 30 */ 0xd7c9, 0xb35c,    BAD,    BAD, 0xb644,    BAD, 0xb646,    BAD,
/* 38 */ 0x99d7, 0xdbd8, 0xb645, 0xb5f9, 0xb5fd, 0x95b5, 0xb8e4, 0xe049
},

/* Row 0x2dc */
{
/* 00 */ 0xdbda, 0xb5fe,    BAD,    BAD, 0xdbdd, 0xdbde, 0xb643,    BAD,
/* 08 */ 0xdbe0, 0xa0ca, 0xdbe2,    BAD, 0xdbe3, 0xdbd7, 0xdbd6, 0xdbe4,
/* 10 */ 0xb642, 0xdbe1, 0xdbdf,    BAD, 0xb640, 0xb5fb, 0xb647, 0xdbdb,
/* 18 */ 0xdbdc, 0xdbd9,    BAD, 0xb641,    BAD,    BAD, 0xb5fc,    BAD,
/* 20 */ 0xb5fa, 0xe048, 0xb8df, 0xb8da,    BAD,    BAD, 0xb8d5, 0x9ffd,
/* 28 */ 0xb8e5, 0xb8d6,    BAD, 0xb8d2, 0xb8e1, 0xb8de, 0xb8e0,    BAD,
/* 30 */ 0xb8d7, 0xb8dc, 0xb8d3, 0xb8d4, 0xe050, 0xe04d, 0xe045, 0xe04a,
/* 38 */    BAD, 0xb8e2, 0xe051, 0xb8e3, 0xb8d9,    BAD, 0xa058, 0xe047
},

/* Row 0x2dd */
{
/* 00 */    BAD, 0xe04f, 0xe04b, 0xe04e, 0xe04c, 0xb8dd, 0xe046, 0xb8d8,
/* 08 */    BAD,    BAD,    BAD, 0xe44c, 0xbb78, 0xbb7b,    BAD, 0xe44e,
/* 10 */ 0x8fd6, 0xbba5, 0xe44d, 0xbb7d, 0x99d8, 0xbdcf, 0xe44f,    BAD,
/* 18 */ 0xbba4, 0xe44b, 0xbba6,    BAD, 0x8fd3,    BAD, 0xbb79,    BAD,
/* 20 */ 0xb8db, 0xbb7c,    BAD, 0xbb7a, 0xbb7e, 0xbba2, 0xbb77, 0xbba7,
/* 28 */ 0xbba3, 0x8fe5, 0xbba1, 0xe44a,    BAD,    BAD,    BAD, 0x8fe9,
/* 30 */ 0xbdd6,    BAD, 0xbdd2,    BAD, 0x99d9,    BAD, 0xbdd9,    BAD,
/* 38 */ 0xe7d6, 0xbdda, 0xe7e2, 0xe7db, 0xbdcb, 0xe7e3, 0xe7dd, 0xbdd5
},

/* Row 0x2de */
{
/* 00 */ 0xe7de,    BAD, 0xbdd4, 0xe7e1, 0xbdce, 0xe7df, 0xe7d5, 0xbdcd,
/* 08 */ 0xebaa, 0xbdd3,    BAD, 0xbdd0,    BAD, 0xbdd8,    BAD, 0xe7d4,
/* 10 */    BAD, 0xe7d8, 0xbdcc, 0xe7d7, 0xe7d9, 0xe7da, 0xbdd7, 0xe7dc,
/* 18 */ 0xe7e0, 0xe7e4, 0x927c, 0xbddb, 0xbfd2, 0xeba5, 0xebab, 0xeba8,
/* 20 */ 0xeb7e, 0xebac, 0xeba1,    BAD, 0xeba7,    BAD, 0xbfcd, 0xbfd3,
/* 28 */ 0xebad,    BAD, 0x9c45, 0xbfcf,    BAD, 0xbfd9, 0xbfd4, 0xebaf,
/* 30 */ 0xeba9, 0xbfd0, 0xeba2, 0xbfda, 0xeba3, 0xeba4, 0xbfdb, 0xbfd8,
/* 38 */ 0xbdd1,    BAD, 0xbfce, 0xebb0, 0xbfdc,    BAD, 0xbfd5, 0xebae
},

/* Row 0x2df */
{
/* 00 */ 0xbfd1, 0xbfd6, 0xbfd7,    BAD, 0xc1c3, 0xeea4, 0xeead, 0xeeaa,
/* 08 */ 0xeeac,    BAD, 0xc1c0, 0xeea5, 0x8fde, 0xeeab, 0xc1bc, 0xeea7,
/* 10 */ 0xc1c4, 0xeea3, 0xeea8, 0xeeaf, 0xeba6, 0xeea9, 0xeea2, 0xc1bd,
/* 18 */ 0xeea1, 0xc1be, 0xeeb0, 0xc1bf, 0xeeae, 0xc1c2, 0xee7e, 0x8fdf,
/* 20 */ 0xc1c1,    BAD, 0xeea6, 0xf0dc, 0xf0ea, 0xf0e5, 0xf0e7, 0xf0db,
/* 28 */ 0xc2d3,    BAD, 0xf0da, 0xc2d6, 0xc2d5, 0xa04b, 0xf0e9, 0xf0e1,
/* 30 */ 0xf0de, 0xf0e4,    BAD, 0xf0dd,    BAD, 0xf0df, 0xf0e8, 0xf0e6,
/* 38 */    BAD, 0xc2d4, 0xf0ed, 0xf0eb, 0xf0e2, 0xf0ec, 0xf0e3, 0x8fe2
},

/* Row 0x2e0 */
{
/* 00 */ 0xf2f9, 0xc3cf, 0xf341, 0xa0cc,    BAD, 0xf64f, 0xc3d6, 0xf0e0,
/* 08 */ 0xf2f7, 0xc3d2, 0xf2f8, 0xf2fd, 0x8fe3, 0x8fe4, 0xc3d4, 0xc3d5,
/* 10 */ 0xf2f6, 0xf340, 0xf342, 0xf2fa, 0xf2fc, 0xf2fe, 0xf2fb, 0xf343,
/* 18 */ 0xc3d1, 0xc3d7, 0xc3d3,    BAD, 0xc3d0, 0xf4d0, 0x9bc4, 0xc4b7,
/* 20 */ 0xf4ce,    BAD, 0x9bfc, 0xf4d2,    BAD, 0xf4d3, 0xc4b5, 0xf4d4,
/* 28 */ 0xf4d1, 0x964c, 0xf4cf, 0xc4b8, 0xc4b4, 0xf4d5,    BAD, 0xc4b6,
/* 30 */ 0xc4b3,    BAD,    BAD,    BAD, 0xc4fe,    BAD,    BAD, 0xc540,
/* 38 */ 0xf64e, 0xf64d, 0xf650, 0xf651,    BAD, 0xc541, 0xf756, 0xf75b
},

/* Row 0x2e1 */
{
/* 00 */ 0xc5aa, 0x9af6, 0xf758,    BAD, 0xf757, 0xf75a, 0xf759,    BAD,
/* 08 */ 0xf843,    BAD, 0xc5dc, 0xf842, 0xf840,    BAD, 0xf841,    BAD,
/* 10 */ 0x8fe7,    BAD, 0xc5fe, 0xc5fd, 0xf8c1, 0xf8c2, 0xc640,    BAD,
/* 18 */ 0xf94d, 0xf94e, 0xc667, 0x8fe8, 0xc66d,    BAD, 0xf9a9, 0xf9c8,
/* 20 */ 0x8be7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x897a,    BAD
},

/* Row 0x2e2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x897b,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2e3 */
{
/* 00 */    BAD, 0xc1c5, 0xf0ee, 0xf344,    BAD, 0xf844, 0xa8a7, 0xd3de,
/* 08 */ 0xb05a, 0xb361, 0xe054, 0xe053, 0xbddc, 0xe7e6, 0xbddd, 0xeeb1,
/* 10 */ 0xc2d7, 0x99da,    BAD,    BAD, 0xc676, 0xa8a8, 0xcdcb, 0xd3df,
/* 18 */    BAD,    BAD, 0xb362,    BAD, 0xd7cf, 0xd7d0,    BAD, 0xdbe5,
/* 20 */    BAD, 0xb648, 0xb8e6,    BAD, 0xe056, 0xe055, 0xe057,    BAD,
/* 28 */ 0xe451, 0xe452, 0xbba8, 0xbfdd, 0xbdde, 0xbfde,    BAD, 0xeeb5,
/* 30 */ 0xeeb2, 0xeeb4, 0xeeb3, 0xc1c7,    BAD, 0xf0ef, 0xf346, 0xf345,
/* 38 */ 0xcba4, 0xb05c, 0xb05b, 0xd3e0,    BAD, 0xd7d1,    BAD,    BAD
},

/* Row 0x2e4 */
{
/* 00 */ 0xdbe7, 0xdbe6, 0xb649,    BAD, 0xe059, 0xe05a, 0xe058,    BAD,
/* 08 */    BAD, 0xb8e8, 0xb8e7,    BAD, 0xbbaa, 0xbba9,    BAD, 0xe7e7,
/* 10 */ 0xebb3, 0xebb1, 0xebb2, 0xbfdf, 0xeeb7, 0xeeb6,    BAD, 0xf0f2,
/* 18 */ 0xf0f1, 0xf0f0, 0xf347, 0x8fed, 0xf9aa, 0xa8a9, 0xad73, 0x95c0,
/* 20 */ 0xad74, 0xb05d, 0xb05e, 0xd3e2, 0xd3e1, 0xd7d2,    BAD, 0xb368,
/* 28 */ 0xb366, 0xb363, 0xb367, 0xb365, 0xb364, 0xa0cb,    BAD, 0xb64a,
/* 30 */ 0xdbea,    BAD, 0xb8ed, 0xb64c, 0xb651, 0xdbec, 0xb653, 0xb652,
/* 38 */ 0xb655, 0xdbeb, 0xdbe8, 0xb64f, 0xb64b, 0xb64d, 0xdbe9, 0xb654
},

/* Row 0x2e5 */
{
/* 00 */ 0xb650, 0xb64e, 0xb8ef, 0xb8ee, 0xb8ec, 0xb8f0,    BAD, 0xb8ea,
/* 08 */ 0xb8eb,    BAD, 0xb8e9,    BAD, 0xe05b, 0x9e48,    BAD, 0xe454,
/* 10 */    BAD, 0xbbac, 0xbbad, 0xbbab, 0x99db, 0xe453, 0x8ff3, 0xe455,
/* 18 */    BAD, 0xe7ea, 0xe7ec, 0x8ff9, 0xbde7, 0xe7ed, 0xbde0, 0xe7e9,
/* 20 */ 0xbddf, 0xbde9, 0xbde5, 0xbde6, 0xbde2, 0xe7e8, 0xbde1, 0xe7ee,
/* 28 */ 0xe7eb, 0x95c1, 0xbde8, 0xa04e, 0xbde3, 0xbde4, 0xebb5,    BAD,
/* 30 */ 0xebb7, 0xebb6, 0x99dc, 0xebb8, 0xbfe0, 0xebb4,    BAD, 0xa064,
/* 38 */ 0xc1cb, 0xeeb8, 0xc1c8, 0xc1cc, 0xc1ca, 0xc1c9, 0xf0f3,    BAD
},

/* Row 0x2e6 */
{
/* 00 */ 0xf0f6,    BAD, 0xf0f5, 0x8ff7, 0xf0f4, 0xc2d8, 0xf348, 0xf349,
/* 08 */ 0xc3d8, 0xf34a, 0xc3d9, 0x89b0, 0xa048, 0xc4ba,    BAD, 0xc4b9,
/* 10 */ 0xf652, 0x8ffb, 0x8ff6, 0xc542, 0xf653, 0xf75c, 0xc5ab, 0xc5ac,
/* 18 */ 0x9ddc, 0xf845,    BAD, 0xc642, 0x99dd, 0x8be8,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2e7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xa8aa,    BAD, 0xb36a, 0xb369,
/* 28 */ 0xe05c, 0xe05d,    BAD, 0xbbae, 0xebb9, 0xbdea, 0xebba, 0xeeb9,
/* 30 */ 0xa8ab,    BAD, 0xd0b2, 0xad76, 0xad75,    BAD, 0xd3e3, 0xb05f,
/* 38 */ 0xd3e4, 0xd7d5, 0x92c1, 0xd7d4,    BAD, 0xd7d3,    BAD,    BAD
},

/* Row 0x2e8 */
{
/* 00 */ 0xdbee, 0xb658, 0x9fd6,    BAD, 0xdbed, 0xb657,    BAD,    BAD,
/* 08 */    BAD, 0xdbef, 0xb656,    BAD, 0xe05f, 0xe062, 0xe060, 0xe061,
/* 10 */ 0xe065, 0xe05e, 0xe066, 0xe063, 0xe064, 0xbbb0, 0xe456,    BAD,
/* 18 */    BAD, 0xbbaf,    BAD, 0xe7f2, 0xe7f0,    BAD,    BAD, 0xbdeb,
/* 20 */ 0xe7ef, 0xe7f1,    BAD, 0xbdec,    BAD, 0xebbb, 0xa0d2, 0xebbc,
/* 28 */ 0xc1cd, 0x9040, 0xf34c, 0xf34e, 0xf34b, 0xf34d, 0xf4d6, 0xf654,
/* 30 */    BAD,    BAD, 0xf96f, 0xa8ac, 0xad77, 0xd3e5, 0xd3e7, 0xd3e6,
/* 38 */    BAD, 0xd7d8, 0xb36c,    BAD, 0xd7d6,    BAD, 0xb36b, 0xd7d9
},

/* Row 0x2e9 */
{
/* 00 */ 0x8ac4, 0xd7da, 0xd7d7, 0x99e0,    BAD, 0xdbfb, 0xb660, 0xdbf3,
/* 08 */ 0xdbf9,    BAD,    BAD, 0xb65b, 0xb65e, 0xdbf2, 0xb659, 0xdbf6,
/* 10 */ 0xe06c, 0xb65d,    BAD, 0xdbf1, 0x9ff0, 0xdbf7, 0xdbf4, 0xdbfa,
/* 18 */ 0xdbf0, 0xdbf8, 0xb65c, 0xb65f, 0xdbf5, 0xb65a,    BAD, 0xb8f2,
/* 20 */ 0xe068, 0xb8f1, 0xe06f, 0xe06e, 0xb8f8,    BAD, 0xb8f9, 0xe070,
/* 28 */ 0xb8f3, 0xe06d, 0xb8f7, 0xe072, 0xe069,    BAD, 0xe06b, 0xb8f4,
/* 30 */ 0xe067, 0xe06a, 0xe071, 0xb8f5, 0xe073,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xb8f6,    BAD, 0xbbb1, 0xe45b, 0xe461, 0xe459
},

/* Row 0x2ea */
{
/* 00 */ 0xe462, 0x9ff3, 0xe458, 0xe45d, 0xe463, 0xe460, 0xe45f, 0xe45e,
/* 08 */    BAD, 0xe457, 0xe45c,    BAD,    BAD, 0xe45a, 0x9dbf, 0xbdf1,
/* 10 */ 0xbdee, 0xe7fb, 0xe841, 0xe843, 0xe840, 0xe7f8, 0xe7fa, 0xe845,
/* 18 */ 0xe842, 0xe7fc, 0xe846, 0xe7f9, 0xe844, 0xbdef, 0xbdf5, 0xbdf3,
/* 20 */ 0xe7f3, 0xbdf4, 0xbdf0, 0xe7f4, 0xe7f6, 0xe7f5, 0xe7fd, 0xe7fe,
/* 28 */ 0x9ff6, 0xbdf2, 0x95c8, 0xbded,    BAD, 0x9e5a, 0xe7f7,    BAD,
/* 30 */ 0xebc6, 0xbfe2,    BAD, 0xebbd, 0xbfe3, 0xbfe6, 0xebc2,    BAD,
/* 38 */ 0xebbf, 0xbfe5, 0x99e3,    BAD, 0xebc3, 0xebc4, 0xebbe, 0xebc7
},

/* Row 0x2eb */
{
/* 00 */ 0xebc0, 0xebc5, 0xbfe4,    BAD, 0xbfe1, 0xebc1, 0x8a4a, 0xeebf,
/* 08 */ 0xc1d0, 0xc1ce, 0xc1d1, 0xc1cf, 0xeebe, 0xeebb, 0xeeba, 0x9ff1,
/* 10 */ 0xeebd,    BAD,    BAD, 0xeebc, 0xf145, 0xc2de, 0xf0fb, 0xf0fa,
/* 18 */    BAD, 0xc2d9, 0xf141, 0xf140, 0xf0f7, 0xf143, 0xf0fc, 0xc2dd,
/* 20 */ 0xf0f9, 0xf142, 0xf0f8, 0xc2da, 0xc2dc, 0xf0fd, 0xc2db, 0xf0fe,
/* 28 */ 0x8aa7, 0xf144, 0xf352,    BAD, 0xc3de, 0xf34f,    BAD, 0xf353,
/* 30 */    BAD, 0x99e6, 0xc3db, 0xf351, 0xc3e0, 0x9ff7, 0xc3dd, 0x9fed,
/* 38 */ 0xf350,    BAD, 0xc3df, 0xf354, 0xc3da,    BAD, 0x8a5c,    BAD
},

/* Row 0x2ec */
{
/* 00 */ 0x9dae, 0xc4bc, 0xc4be,    BAD, 0xf4d9, 0xc4bd, 0xf4d7, 0xc3dc,
/* 08 */ 0xf4d8, 0xc4bb, 0xc543, 0xc545, 0xf656, 0xc544, 0xf655,    BAD,
/* 10 */ 0xf761, 0xc5ad, 0xf760, 0xc5ae, 0xf75e, 0xf75d, 0xf762, 0xf763,
/* 18 */ 0xf846,    BAD, 0xf75f,    BAD,    BAD, 0xf8c6, 0xf8c3, 0xf8c4,
/* 20 */ 0xf8c5, 0xc65c,    BAD, 0xf951, 0xf950, 0xf94f, 0xf970, 0x95c9,
/* 28 */ 0xf9be, 0xf9ab, 0xc66e, 0xa8ad, 0xb060, 0x9048,    BAD,    BAD,
/* 30 */ 0x99e8,    BAD, 0xb8fa,    BAD,    BAD,    BAD, 0x9049,    BAD,
/* 38 */    BAD,    BAD, 0xbdf6,    BAD, 0x90b1, 0xebc8,    BAD,    BAD
},

/* Row 0x2ed */
{
/* 00 */ 0xc2df,    BAD, 0xf355, 0x904a,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xf9ac, 0xa8ae, 0xaaee, 0xad79, 0xad78, 0x99ea, 0xb063,
/* 10 */    BAD, 0xd3e8, 0xb061, 0xd3e9, 0xb062,    BAD,    BAD, 0xd7df,
/* 18 */ 0xd7db,    BAD, 0x9bd1, 0xb36d, 0xd7de, 0xd7dd, 0xd7dc, 0xb36e,
/* 20 */ 0xd7e0, 0xd7e1, 0x99eb,    BAD, 0x99ec, 0xdc43, 0xdc41, 0xdc45,
/* 28 */ 0xdc46, 0xdc4c,    BAD, 0xdc48, 0xdc4a, 0x99ed, 0xdc42, 0xdbfc,
/* 30 */    BAD, 0xdc49, 0x99ee,    BAD, 0xdc4b, 0xdc44, 0xdc47, 0xdbfd,
/* 38 */ 0xb662, 0xdc40, 0xdbfe, 0xb661, 0xb663,    BAD, 0xb8fd, 0xe075
},

/* Row 0x2ee */
{
/* 00 */ 0xe077, 0xe076, 0xe07b, 0xb8fb,    BAD, 0xe078, 0xe074, 0xe079,
/* 08 */ 0xe07a, 0xb8fc, 0xb8fe, 0xe07c,    BAD, 0xe467, 0xe466,    BAD,
/* 10 */ 0xe464, 0xe465, 0xbbb3, 0xbbb5, 0xbbb2, 0xbbb4, 0xe84d, 0xe84e,
/* 18 */ 0xe849, 0x904c, 0xe84a, 0xbdf8, 0xbdfd, 0xbdf7, 0xbdfe, 0xbdf9,
/* 20 */ 0xe84b,    BAD,    BAD, 0xe84c, 0xe848, 0xbe40, 0xbdfb,    BAD,
/* 28 */    BAD, 0xbdfa, 0xbdfc,    BAD, 0xe847, 0x904d, 0xebca, 0xbfe8,
/* 30 */ 0x95cb,    BAD, 0xebcc, 0xbfea, 0xebcf, 0xebcb, 0xebc9, 0xebce,
/* 38 */ 0xbfe9, 0xebcd,    BAD, 0xbfe7,    BAD,    BAD, 0xc1d3, 0xc1d6
},

/* Row 0x2ef */
{
/* 00 */ 0xeec1, 0x97e2, 0xc1d4, 0xeec0, 0xc1d2, 0xc1d5, 0xf146, 0xf147,
/* 08 */ 0xf148, 0xc2e0, 0x95cc, 0xf149,    BAD, 0xc2e1, 0xc3e2, 0xf358,
/* 10 */ 0xf359, 0xf357, 0xf356, 0xf35a, 0xc3e1, 0xf4dd, 0xf4db, 0xf4dc,
/* 18 */ 0xf4de, 0xf4da, 0xf4df, 0xf658, 0x9f78, 0xf659, 0xf657, 0xc546,
/* 20 */ 0xf764, 0xc5af, 0xf765, 0xf848, 0xf847,    BAD, 0x897c, 0x897d,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x897e,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x2f0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x995d,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xa8af, 0xb664,    BAD,    BAD, 0xb940,
/* 20 */ 0x9b5a,    BAD,    BAD, 0xbbb6,    BAD, 0x9050, 0xbfec,    BAD,
/* 28 */ 0xbfeb,    BAD,    BAD,    BAD,    BAD, 0xc3e3, 0xc47c, 0xc547,
/* 30 */ 0xa8b0, 0xb064, 0xb941, 0x9054, 0xf35b, 0xc6d6, 0x9aa8, 0x99ef,
/* 38 */ 0xfeeb, 0x9da3, 0x9da1, 0x9943, 0x9945,    BAD, 0x9d7d, 0xcba6
},

/* Row 0x2f1 */
{
/* 00 */    BAD, 0x99f0, 0xa8b1,    BAD, 0xa8b4, 0xa8b3, 0xa8b2,    BAD,
/* 08 */    BAD, 0xcba5, 0x99f1, 0xcdcd, 0x99f2, 0xcdcf, 0xaaef,    BAD,
/* 10 */ 0x9d60, 0xaaf1, 0xcdcc, 0xcdce, 0xaaf0, 0xcdd1, 0xcdd0, 0xcdd2,
/* 18 */    BAD,    BAD, 0xa0a3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xd0b6, 0xd0b4, 0xad7c, 0xd0b3, 0xada3, 0xad7e, 0xad7b,    BAD,
/* 28 */ 0xada4,    BAD, 0xad7d, 0xada2,    BAD, 0xada1, 0xd0b5,    BAD,
/* 30 */ 0xad7a,    BAD,    BAD,    BAD, 0xb06a, 0xd3eb, 0xd3f1, 0xb067,
/* 38 */ 0xb06e, 0x905b, 0xb069, 0xd3ee, 0xd3f0, 0xb06c, 0xd3ea, 0xd3ed
},

/* Row 0x2f2 */
{
/* 00 */ 0xb068, 0xb065, 0xd3ec, 0xb06b, 0xd3ef, 0xb06d, 0xb066,    BAD,
/* 08 */ 0x9edb,    BAD,    BAD, 0xd7e3, 0xd7e6, 0xb370,    BAD, 0xb37a,
/* 10 */ 0xb376, 0xd7e4, 0x9d79,    BAD, 0xb37e, 0xb377, 0xb37c, 0xb372,
/* 18 */    BAD, 0xb36f, 0xb371, 0xb37d, 0xd7e5, 0xb375, 0xb378, 0xb374,
/* 20 */ 0xb379, 0xd7e7, 0xb37b, 0xb373, 0xd7e2,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xdc4d, 0xb665, 0xdc4f,
/* 30 */    BAD, 0xb667, 0xb669, 0x99f3, 0xdc4e, 0xb666, 0xb66a, 0x9062,
/* 38 */ 0xb668,    BAD,    BAD,    BAD, 0xb947, 0xe0a3, 0xb94f, 0xe07e
},

/* Row 0x2f3 */
{
/* 00 */    BAD, 0xb950, 0xb945,    BAD, 0xe0a1,    BAD,    BAD, 0xb94a,
/* 08 */    BAD, 0xe0a2, 0xb943, 0xb942, 0x9f55, 0xb94d, 0xb94c, 0xb94b,
/* 10 */ 0xb949, 0xb94e, 0xe07d, 0xb944, 0xb946, 0xb948, 0x9bf9,    BAD,
/* 18 */ 0xbbb8, 0xbbbb,    BAD, 0xbbbf, 0xbbb9, 0xbbbe, 0xbbbc,    BAD,
/* 20 */ 0xbbb7, 0x9065, 0xbbbd, 0xbbba, 0x96e0,    BAD,    BAD, 0xe852,
/* 28 */ 0xbe43, 0xbe41,    BAD, 0xe853, 0x98be, 0xbe44, 0xbe42, 0xe851,
/* 30 */ 0xe850,    BAD, 0xbff0, 0xe84f, 0xbfee, 0xbfed, 0xebd0, 0xbe45,
/* 38 */ 0xbfef, 0xebd1, 0xbff2, 0xebd2, 0xbff1, 0xc1d8, 0xeec3, 0xc1d7
},

/* Row 0x2f4 */
{
/* 00 */ 0xc1dc, 0xc1da, 0xc1db, 0xc2e3, 0xc1d9, 0xeec2, 0xebd3, 0xc2e2,
/* 08 */ 0xc2e4,    BAD, 0xc3e4, 0xc3e5,    BAD, 0xf4e0,    BAD, 0xc5de,
/* 10 */ 0xc5dd, 0xa8b6,    BAD,    BAD, 0xca55, 0xb06f,    BAD, 0xca52,
/* 18 */ 0xca53, 0xca51,    BAD, 0xca54,    BAD,    BAD, 0xcbaa, 0xcba7,
/* 20 */ 0xcbac, 0xcba8, 0xa8b7, 0xa8ba,    BAD, 0xcba9, 0xa8b9, 0xcbab,
/* 28 */ 0x9068,    BAD, 0xa8b8,    BAD,    BAD,    BAD, 0x906c, 0xcdd5,
/* 30 */ 0xcdd7, 0xaaf4, 0xcdd3, 0xcdd6, 0xcdd4, 0xaaf2, 0xaaf5,    BAD,
/* 38 */ 0xaaf3,    BAD,    BAD, 0x95d8,    BAD, 0xd0b8, 0xd0bc, 0xd0b9
},

/* Row 0x2f5 */
{
/* 00 */    BAD, 0xada7,    BAD, 0xada8, 0x906a, 0xd0bb,    BAD, 0xd0bd,
/* 08 */ 0xd0bf,    BAD, 0xada5, 0xd0be,    BAD,    BAD, 0xada6,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xd7ee, 0xd0ba, 0xd3f2, 0xd3fb,
/* 18 */ 0xd3f9, 0xd3f4, 0xd3f5, 0xd3fa, 0xd3fc, 0xb071,    BAD, 0xd3f7,
/* 20 */ 0xd3f3, 0xb070, 0xb072, 0xd3f6, 0xd3fd, 0xd3f8,    BAD,    BAD,
/* 28 */ 0xb3a1, 0xd7f1, 0xd7e9, 0xd7ef, 0xd7f0, 0xb3a2,    BAD, 0xd7e8,
/* 30 */ 0xd7ea, 0xd0b7, 0xd7ec, 0xd7ed, 0xd7eb, 0xb66c,    BAD,    BAD,
/* 38 */    BAD, 0xdc56, 0xebd4, 0xdc57, 0xdc54, 0xb3a3, 0xb66e, 0xdc53
},

/* Row 0x2f6 */
{
/* 00 */ 0xf35c, 0xf4e2,    BAD, 0xf4e1, 0xf65b, 0xf65c, 0xf65a, 0xf766,
/* 08 */ 0xc5b0, 0xa8bb, 0xadaa, 0xada9, 0xb075, 0xb074, 0xd440, 0xd441,
/* 10 */ 0xd3fe, 0x9fb2, 0xb073, 0xd7f5,    BAD, 0xd7f6, 0xd7f2, 0xb3a4,
/* 18 */ 0xd7f3, 0x9fae, 0xd7f4,    BAD, 0x9fb0,    BAD, 0x89ad, 0xdc5f,
/* 20 */ 0xdc61, 0xdc5d, 0xdc60, 0xb66f, 0xdc5e, 0xb670,    BAD, 0x906e,
/* 28 */ 0xdd73, 0xb955, 0xb954,    BAD, 0xb953,    BAD, 0xe0ac, 0xe0ad,
/* 30 */ 0x9e71,    BAD, 0xe473, 0xe475, 0xbbc6, 0xbbc3, 0x9e4a, 0xbbc5,
/* 38 */ 0xbbc4, 0xe474, 0xe472,    BAD, 0x9fdc,    BAD,    BAD,    BAD
},

/* Row 0x2f7 */
{
/* 00 */ 0xe861, 0xe85e, 0xe85f, 0xbe4d, 0xe860, 0xe85b, 0xe85c, 0xbe4a,
/* 08 */    BAD, 0xbe4b, 0xe85d, 0xbe4c, 0x89ab, 0xebdb, 0x9fb8, 0xebdc,
/* 10 */ 0xebd9, 0xebda, 0xbff4, 0xebd8,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xeec8, 0xeec5, 0xeec7, 0xc1e0, 0xeecb, 0xc1df, 0xeec9,
/* 20 */ 0xeecc, 0xeeca, 0xeec6, 0xc1de,    BAD, 0xf14f,    BAD, 0xf150,
/* 28 */ 0xf14e, 0x9070, 0xf152, 0xc2e5, 0xc2e6, 0xf35f, 0xc3e7, 0xf151,
/* 30 */ 0xf35e, 0xc3e6, 0xf4e5, 0xf4e6, 0xc4bf, 0xf4e4, 0x8b63, 0xf4e3,
/* 38 */    BAD, 0xf65d, 0xc548, 0x95dc, 0xf849, 0xf8c8, 0xf8c7,    BAD
},

/* Row 0x2f8 */
{
/* 00 */ 0xc643, 0xc65d, 0xf8c9, 0xf971, 0x9071, 0xc66f, 0xa8bc, 0xaaf6,
/* 08 */    BAD, 0xb956,    BAD, 0xc4c0, 0xa8bd, 0xadab, 0xb3a5, 0xb671,
/* 10 */ 0xc2e7, 0xaaf7,    BAD, 0xd0c1, 0xd0c0, 0xd442, 0xfc5e, 0xb078,
/* 18 */ 0xb076, 0xb07a, 0xd444,    BAD, 0xb079, 0xb077,    BAD, 0x8949,
/* 20 */    BAD,    BAD, 0xd443, 0xb3a8, 0xd7fc, 0x965b, 0xb3a7, 0xb3a9,
/* 28 */ 0xd842, 0xb3ab, 0xd7fe, 0xd840, 0xd7f7, 0xb3aa, 0xd843,    BAD,
/* 30 */    BAD, 0xd7f9,    BAD, 0xd7fa, 0xd7f8, 0xb3a6,    BAD, 0xd841,
/* 38 */ 0xd7fb, 0xd7fd, 0x94a6,    BAD,    BAD, 0xdc6d, 0x8fd5, 0xdc6c
},

/* Row 0x2f9 */
{
/* 00 */ 0xdc6a, 0xdc62, 0xdc71, 0xdc65, 0xdc6f, 0xdc76, 0xdc6e, 0xb679,
/* 08 */ 0x9e73, 0xb675, 0xdc63,    BAD, 0xdc69, 0xb677, 0x9075, 0xdc68,
/* 10 */ 0xb678, 0xb67a, 0xdc6b, 0x99f7, 0xb672, 0xb673, 0xdc77, 0xdc75,
/* 18 */    BAD, 0xdc74, 0xdc66,    BAD, 0xdc72,    BAD, 0xb676,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xb674, 0xdc73, 0xdc64, 0xdc67, 0xdc70,
/* 28 */ 0x99f9,    BAD, 0x9663, 0x95b9,    BAD, 0xe4ba, 0xe0b7,    BAD,
/* 30 */ 0xe0b0, 0xe0c3, 0xe0cc, 0xe0b3, 0xb961, 0x94d4, 0xe0c0, 0xb957,
/* 38 */ 0xb959, 0xb965, 0xe0b1,    BAD, 0xfcfa, 0xb95a, 0xb95c, 0xb966
},

/* Row 0x2fa */
{
/* 00 */ 0xb95b, 0x9077,    BAD,    BAD, 0x90ab, 0xb964, 0xe0b9,    BAD,
/* 08 */ 0xe0ae, 0xb962, 0xe0b8, 0xb95e, 0xe0ca, 0xb963, 0xe0c8, 0xe0bc,
/* 10 */ 0xe0c6, 0xb960, 0xe0af, 0xe0c9, 0xe0c4, 0x9d4d, 0xe0cb, 0xb958,
/* 18 */ 0x99fa,    BAD, 0xb967, 0xb95d,    BAD, 0x92e3, 0xe0b5, 0x97bb,
/* 20 */ 0xe0bd, 0xe0c1, 0x9078, 0xe0c5, 0xb95f, 0xe0b4, 0xe0b2, 0xe0be,
/* 28 */    BAD,    BAD,    BAD, 0x99fb, 0xe0bb, 0xe0ba, 0x97e0, 0xe0bf,
/* 30 */ 0xe0c2,    BAD, 0xe0c7,    BAD,    BAD,    BAD, 0xe478, 0x96dc,
/* 38 */ 0xbbc7, 0xe4a4, 0xe47a, 0xbbcc, 0xbbd0, 0xe4ad, 0xe4b5, 0xe4a6
},

/* Row 0x2fb */
{
/* 00 */ 0xbbc8, 0x9ca8, 0xe4aa, 0xe0b6, 0x9772, 0xbbc9, 0xe4b1, 0xe4b6,
/* 08 */ 0xe4ae, 0x9440, 0xe4b0, 0xe4b9, 0xe4b2, 0xe47e, 0xe4a9, 0x92f2,
/* 10 */    BAD, 0xbbd1,    BAD, 0xbbcd, 0xe47c, 0xe4ab, 0xbbcb, 0xe4a5,
/* 18 */ 0xbbca, 0xe4b3, 0xe4a2, 0xe479, 0xbbce, 0xe4b8,    BAD,    BAD,
/* 20 */ 0xe47b, 0xe4af, 0xe4ac, 0xe4a7, 0xe477, 0xe476, 0xe4a1, 0xe4b4,
/* 28 */ 0xbbcf, 0xe4b7, 0xe47d, 0xe4a3, 0xbe52,    BAD, 0x99fd,    BAD,
/* 30 */    BAD, 0x99fc, 0xbe5a, 0xbe55, 0xe8a4, 0xe8a1, 0xe867, 0xbe50,
/* 38 */    BAD, 0xf9d7, 0x964a, 0xbe4f, 0xbe56,    BAD, 0x96d8, 0x99fe
},

/* Row 0x2fc */
{
/* 00 */ 0xe865, 0xbe54, 0xe871, 0xe863, 0xe864, 0xbe4e, 0xe8a3, 0xbe58,
/* 08 */ 0xe874, 0xe879, 0xe873, 0xebee, 0xe86f, 0xe877, 0xe875, 0xe868,
/* 10 */ 0xe862, 0xe87d, 0xbe57, 0xe87e, 0x904b, 0xe878,    BAD, 0xe86d,
/* 18 */ 0xe86b, 0xe866,    BAD, 0xfa41,    BAD, 0xe86e, 0xe87b, 0xe86a,
/* 20 */ 0xe87a, 0xe8a2,    BAD, 0x9a40, 0xbe53, 0x975b, 0xe876, 0xe87c,
/* 28 */ 0xe872, 0xe86c, 0xbe51, 0x9a41, 0x91dd,    BAD, 0xe4a8, 0xe870,
/* 30 */ 0xbe59, 0xe869, 0x93fc, 0x9a42, 0x9a43,    BAD, 0x9659, 0xebf4,
/* 38 */ 0xbff7, 0xebf3, 0xebf0, 0xec44, 0xbffb, 0x9a44, 0xec41, 0xebf8
},

/* Row 0x2fd */
{
/* 00 */ 0xec43, 0xebe9, 0xebf6, 0x9051, 0xbffd,    BAD, 0xebe1, 0x94bf,
/* 08 */ 0xebdf, 0xec42,    BAD, 0xec40, 0xebfe, 0xebed, 0xebec, 0xebe2,
/* 10 */ 0xc040,    BAD, 0xebe8, 0xebf2, 0xebfd, 0xc043, 0xec45,    BAD,
/* 18 */ 0xc1e8, 0xc045, 0xbffe, 0xebe6,    BAD, 0xebef, 0xebde, 0xebe0,
/* 20 */ 0xbff5, 0xc042, 0xbffa, 0xebe7, 0xebf7, 0xebf1, 0xc041, 0xebdd,
/* 28 */ 0xc1e3, 0xebf9, 0xebfc, 0xbffc, 0x90a2, 0xebeb, 0xc044, 0xbff9,
/* 30 */ 0x9cab, 0x9776,    BAD, 0xbff8, 0xebf5, 0xebfb, 0xbff6,    BAD,
/* 38 */ 0xebe4, 0xebfa,    BAD,    BAD, 0xebe5,    BAD,    BAD,    BAD
},

/* Row 0x2fe */
{
/* 00 */ 0xfc55, 0xfe45, 0x94a8, 0x9a45, 0xfa4b, 0x9de1, 0xebea, 0xeed2,
/* 08 */ 0x96d9, 0xeed7, 0xc1e5, 0xc1e7, 0xeedd, 0xc1e1, 0xeeec, 0xeee3,
/* 10 */ 0xeed8, 0xeed9, 0xeee2,    BAD, 0xc1ee, 0xeee1, 0xeed1, 0xeee0,
/* 18 */ 0xeed4, 0xeeed, 0xc1ed, 0xc1eb, 0xeed5,    BAD, 0xeee8, 0x9774,
/* 20 */ 0xeeda, 0xeee7, 0xfdf5, 0xeee9, 0xeed0, 0xc1e6, 0x92e5, 0xeeea,
/* 28 */ 0x9645, 0x91da, 0xeede, 0x90a3, 0xc1ea, 0xeedb, 0xa05f,    BAD,
/* 30 */ 0xc1ec, 0xeee4,    BAD, 0x90af, 0x97bf, 0xc1e4, 0xeed6, 0xeee5,
/* 38 */ 0x914c, 0xeedf, 0xebe3, 0xeee6, 0xeed3, 0x967a, 0xc1e9,    BAD
},

/* Row 0x2ff */
{
/* 00 */ 0xeeeb, 0x91de, 0xc1e2, 0xeece, 0x9a46, 0xfeb0, 0x9779, 0x946c,
/* 08 */ 0xf160, 0xf159, 0xc2e9,    BAD, 0xf154, 0xf163, 0xf15b, 0xeedc,
/* 10 */ 0x9858, 0xf165, 0xf155,    BAD, 0xc2e8, 0xf15f, 0xc2ea, 0xc2f2,
/* 18 */ 0xc2f0, 0xf161, 0xc2f1, 0xf157, 0x9266, 0xf158, 0xf15d, 0xf162,
/* 20 */ 0x93fb, 0xeecd, 0xc2eb, 0xf16a, 0xf167, 0xf16b, 0xf15e, 0xf15a,
/* 28 */ 0xf168, 0xf36a, 0xf15c,    BAD, 0xc2ee, 0x9a47, 0xc2ed, 0xeecf,
/* 30 */ 0xc2ef, 0xf164, 0xf166, 0xc2ec, 0xf169, 0xf153,    BAD, 0xf156,
/* 38 */ 0x9749,    BAD,    BAD, 0x9748,    BAD, 0x934a,    BAD, 0x9ce2
},

/* Row 0x300 */
{
/* 00 */ 0xf373,    BAD, 0xf363, 0xc3eb, 0xf371,    BAD, 0x9264, 0xf361,
/* 08 */ 0xc3ec,    BAD, 0xf36c, 0x91df, 0xf368, 0xc3f1, 0xf372, 0xf362,
/* 10 */ 0xf365, 0xc3e9, 0xf374, 0xfb79, 0xf36d, 0xf370, 0xc3ef, 0xc3f4,
/* 18 */ 0xc3f2, 0xf369, 0xf364, 0x96d7, 0xc3ed, 0xc3ee, 0xf360, 0xc3ea,
/* 20 */ 0x9343, 0xc3e8, 0xc3f0, 0xf36f, 0xc3f3,    BAD, 0xf36b, 0xf375,
/* 28 */ 0xc3f5,    BAD,    BAD,    BAD, 0xf367,    BAD, 0xf36e,    BAD,
/* 30 */ 0xfdcb, 0xfe7a,    BAD, 0x91db,    BAD, 0xf4f3, 0xf542, 0xf4f5,
/* 38 */ 0xf4fc, 0xf366, 0xf4fa, 0xf4e9, 0xf540, 0xc4c3, 0xf4ed, 0xf4fe
},

/* Row 0x301 */
{
/* 00 */ 0xf4f4, 0x97af,    BAD, 0xc4c2, 0x95dd,    BAD, 0xf544, 0xf4f6,
/* 08 */ 0x9348, 0xf4fb, 0xf4fd, 0xf4e7, 0xf541, 0xf4f2, 0xf4f7, 0xf4eb,
/* 10 */ 0xf4ef, 0xf543, 0xf4f9, 0xf4e8, 0xf4ec, 0xf4ee, 0xf4f8, 0x9a4b,
/* 18 */ 0xc4c1, 0xf4f1,    BAD, 0xfc45,    BAD, 0x9a4d,    BAD,    BAD,
/* 20 */ 0xf4ea,    BAD,    BAD,    BAD, 0x91bc, 0x90e2, 0x90b4, 0x95e1,
/* 28 */ 0xf4f0, 0xf661, 0xf666, 0xc54f, 0xf668, 0x9a4e, 0xc549,    BAD,
/* 30 */ 0xf664, 0xf66a, 0xc54e, 0xc54a,    BAD, 0xc54b, 0xf660, 0xf667,
/* 38 */ 0xc54d, 0xf665, 0xc54c, 0xf65f, 0xf663, 0xf662, 0x9a4f, 0xf65e
},

/* Row 0x302 */
{
/* 00 */ 0xf669,    BAD, 0xfe40, 0xfe43, 0xc5b1, 0xf76d, 0xf770, 0xf76c,
/* 08 */ 0xf76e, 0xf76f, 0xf769, 0xf76a, 0xf767, 0x96dd,    BAD, 0xf76b,
/* 10 */ 0xf768, 0xc5b2, 0xc5b3,    BAD, 0x9a51, 0xf84b,    BAD, 0xf84d,
/* 18 */ 0x96a7,    BAD,    BAD, 0x90b0,    BAD, 0xf84c, 0xf84e,    BAD,
/* 20 */ 0xc5e0,    BAD, 0xf84a, 0xc5df, 0xc5e1, 0x9c4e,    BAD, 0x9443,
/* 28 */ 0xf8cb, 0xf8cc, 0xc644, 0xf8ca, 0x8eba, 0xf953, 0xf952, 0xf954,
/* 30 */ 0xc65f, 0xf955, 0xc65e, 0xf956, 0xf972, 0xf975, 0xf974, 0xc668,
/* 38 */ 0xf973, 0x9a52,    BAD, 0xfcc1, 0xc672, 0xc670, 0xc671, 0xc677
},

/* Row 0x303 */
{
/* 00 */ 0xf9c0, 0xf9c1, 0xf9bf, 0xf9c9,    BAD, 0x8be9,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9caf,
/* 20 */    BAD,    BAD, 0x8bfd,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x304 */
{
/* 00 */    BAD, 0x9abc,    BAD, 0x9ab8,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9aae,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9aa7,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x305 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9a53,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x306 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9d74,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xaaf8,
/* 38 */ 0x8bea,    BAD, 0xd844, 0xdc78, 0xe8a5, 0xf376,    BAD, 0x8beb
},

/* Row 0x307 */
{
/* 00 */ 0xaaf9,    BAD, 0xadac, 0xb07b,    BAD, 0x90b2, 0xd845,    BAD,
/* 08 */ 0xd846, 0xb3ac,    BAD, 0xb67d, 0xdc7a, 0xdc79, 0xb6a3, 0xb67c,
/* 10 */ 0xdc7b, 0xb67e, 0xb6a2, 0xb6a1, 0xb67b,    BAD, 0x95e9, 0x95e8,
/* 18 */ 0xb968, 0x95e6,    BAD, 0xe0d0, 0xe0ce,    BAD, 0xe0cf, 0xe0cd,
/* 20 */ 0x90b5, 0xbbd2, 0x9a54, 0xbbd5, 0xbbd7, 0xbbd6, 0x90b3, 0x95e7,
/* 28 */ 0xbbd3, 0xbbd4, 0x8b50, 0xe8a7, 0xe8a6, 0xbe5b, 0xe8a8,    BAD,
/* 30 */ 0xe8a9, 0xbe5c,    BAD,    BAD,    BAD, 0xec4d, 0xec4b, 0xeef3,
/* 38 */    BAD, 0xec49, 0xec4a, 0xc046, 0xec46, 0xec4e, 0xec48, 0xec4c
},

/* Row 0x308 */
{
/* 00 */ 0xeeef,    BAD,    BAD, 0xeef1,    BAD, 0xeef2, 0xc1f3, 0xeeee,
/* 08 */ 0xc1f2, 0xeef0, 0xc1ef, 0xc1f0, 0xc1f1, 0xec47,    BAD,    BAD,
/* 10 */ 0xc2f5, 0xf16e, 0xf16c, 0xf16d, 0xc2f3, 0xc2f6, 0xc2f4,    BAD,
/* 18 */    BAD,    BAD, 0xf377, 0xf378, 0xc3f6,    BAD, 0xf545, 0xf547,
/* 20 */ 0xf546, 0xc4c4, 0xc550, 0xf66d, 0xf66c, 0xf66b,    BAD,    BAD,
/* 28 */ 0x8bec,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9a56,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x309 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xaafa, 0x8bfb, 0xc9aa,    BAD,
/* 20 */ 0xca58, 0xa6e9, 0xca56, 0xca59, 0xca57,    BAD,    BAD,    BAD,
/* 28 */ 0xcbae,    BAD, 0xa8c1,    BAD, 0xa8c2, 0xcbb0, 0xa8bf, 0xcbaf,
/* 30 */ 0xcbad, 0xa8c0, 0xa8be, 0x9a57,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xa0aa, 0xcdd8, 0xcddb, 0xaafd, 0xcdda, 0xcdd9,    BAD, 0xaafc
},

/* Row 0x30a */
{
/* 00 */ 0xaafb, 0x9fa6, 0xab40, 0xcddc, 0xaafe, 0x99cc,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xd0c6, 0xadae, 0xadaf, 0xadb0, 0xd0c7, 0xd0c3,
/* 10 */ 0xadad, 0xd0c4,    BAD, 0xd0c5, 0xd0c2,    BAD, 0x9c59,    BAD,
/* 18 */ 0xb0a4,    BAD,    BAD, 0xb0a1, 0xd445, 0xb0a2, 0xb0a5, 0xd446,
/* 20 */    BAD, 0xb07e, 0xb07c, 0xb07d, 0xb0a3,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x99b5, 0xb3ad, 0xd849, 0xb3b5, 0xd848,    BAD, 0xd84b,
/* 30 */ 0xb3b1, 0xd84a, 0xb6ab, 0xb3af, 0xb3b2, 0xb3ae, 0xb3b3, 0xb3b4,
/* 38 */ 0xb3b0,    BAD,    BAD, 0x90be, 0xd847, 0xb6a7, 0xdc7d,    BAD
},

/* Row 0x30b */
{
/* 00 */ 0xdca3, 0x9faf,    BAD, 0xdca2, 0xb6ac, 0xb6a8, 0xb6a9, 0xdc7c,
/* 08 */ 0xdc7e, 0xdca1, 0xb6a4, 0xb6a6,    BAD, 0xb6aa, 0xb6a5, 0x95f2,
/* 10 */    BAD, 0xe0d3, 0xe0d1, 0xe0d2, 0xb96a, 0xb96b, 0x90bf, 0xe0d4,
/* 18 */ 0xb969, 0xbbd8,    BAD, 0xbbda, 0xbbd9,    BAD, 0xe4bb,    BAD,
/* 20 */    BAD, 0xe4bc, 0xe8ab, 0x90c1, 0xe8aa, 0xfee4,    BAD, 0xc047,
/* 28 */ 0xc048, 0xec4f, 0xc049,    BAD, 0xeef6,    BAD, 0xeef4,    BAD,
/* 30 */ 0xeef5, 0xc1f4,    BAD, 0xf16f, 0xc3f7,    BAD, 0x90c4,    BAD,
/* 38 */ 0xc1f5, 0xab41,    BAD, 0xb0a6, 0xd447, 0x90c7,    BAD, 0xd84c
},

/* Row 0x30c */
{
/* 00 */ 0xb3b6, 0xb6ad, 0xdca4, 0xdca6, 0xb6af, 0xb6ae, 0xb6b0, 0xb6b1,
/* 08 */ 0xdca5, 0xb96e, 0xb96f, 0xb96d, 0xbbdb, 0xb96c, 0xe0d5,    BAD,
/* 10 */    BAD,    BAD, 0xbbdc, 0xe8ac, 0xec50, 0xc04a, 0xc1f6, 0xf170,
/* 18 */ 0xf174, 0xc2f9, 0xf171, 0xc2fa, 0xc2f8, 0xf175, 0xc2fb, 0xf173,
/* 20 */    BAD, 0xf379, 0xc2f7, 0xc3f8,    BAD, 0xf8cd,    BAD,    BAD,
/* 28 */ 0xab42, 0xb3b8, 0xb3b7,    BAD,    BAD,    BAD,    BAD, 0xb6b2,
/* 30 */ 0xdca8, 0xdca7, 0xb6b3,    BAD, 0x92e4, 0xe0d9, 0xb973, 0xb970,
/* 38 */ 0xe0d8, 0xb972, 0xe0d6, 0xb971,    BAD, 0xe0d7,    BAD, 0xe4bd
},

/* Row 0x30d */
{
/* 00 */ 0xbbdd,    BAD, 0xe8af, 0x9f52, 0xbe5d, 0xe8ad, 0xbe5e, 0xbe5f,
/* 08 */ 0xe8ae, 0xbe60,    BAD, 0xec51,    BAD, 0xc04e, 0xc04b, 0xc050,
/* 10 */ 0xec53, 0xc04c, 0xec52, 0xc04f,    BAD,    BAD, 0xc04d,    BAD,
/* 18 */ 0xeef9, 0xeefb,    BAD, 0x90db, 0xc1f7, 0xeefa, 0xc1f8, 0xeef8,
/* 20 */ 0xeef7, 0xa066, 0xf177, 0xf176, 0xc2fc, 0xf178, 0xf37e, 0xc3fa,
/* 28 */ 0xf37d, 0xf37a, 0xc3f9, 0xf37b, 0xf37c,    BAD, 0xf548, 0xf549,
/* 30 */ 0xc4c5, 0x90d2, 0xc553,    BAD,    BAD, 0xf66e, 0x90d4,    BAD,
/* 38 */ 0xc551, 0xc552, 0xf66f,    BAD,    BAD, 0xc5b4, 0xc5b5, 0xf771
},

/* Row 0x30e */
{
/* 00 */ 0x9a5b, 0x95fd, 0xc645, 0xf8cf, 0xc647,    BAD, 0xf8ce, 0xf8d0,
/* 08 */ 0xc646, 0xf957,    BAD, 0xf9ad,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x8bc4, 0xab43,    BAD,    BAD,    BAD, 0xb974, 0x90de,
/* 18 */ 0xe4be,    BAD, 0xe8b0, 0xc051, 0xc052, 0x9ce4, 0xab44, 0x90e1,
/* 20 */ 0xbe61, 0xc3fb, 0xadb1,    BAD,    BAD,    BAD, 0xc053,    BAD,
/* 28 */ 0xc5e2, 0xadb2, 0xd84d,    BAD, 0xdca9, 0x9e46, 0xdcab,    BAD,
/* 30 */ 0xdcaa, 0x9651, 0xe0dd, 0xe0da, 0xb975,    BAD, 0xb976, 0xe0db,
/* 38 */ 0xe0dc,    BAD, 0xe4c0, 0xe4c5, 0xbbde, 0xe4bf, 0xe4c1, 0xe4c8
},

/* Row 0x30f */
{
/* 00 */ 0xe4c3, 0xe4c7, 0xe4c4, 0xe4c2, 0xe4c6, 0xbbdf,    BAD, 0xfb58,
/* 08 */ 0xe8b3, 0x90e6, 0xe8b1, 0xbe63,    BAD, 0xbe62, 0xe8b2, 0xbe64,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xec56,    BAD,    BAD, 0xec55,
/* 18 */ 0xc054, 0xec54, 0xeefc, 0x9650, 0xeefe, 0xef41, 0xef40, 0x90e7,
/* 20 */ 0xc1f9, 0xeefd, 0xf1a1, 0xc2fd, 0xf17d, 0xf1a2, 0xc2fe,    BAD,
/* 28 */ 0xf17b,    BAD, 0xf17e, 0xf17c, 0xf179, 0xc340, 0xf17a,    BAD,
/* 30 */    BAD, 0x90e8, 0x9a5d, 0xf3a1, 0x9f7a,    BAD, 0xf3a3, 0xf3a2,
/* 38 */ 0x9b5c, 0xf54a, 0x9f7c, 0xf54b,    BAD, 0xfc52, 0x90e9, 0xf670
},

/* Row 0x310 */
{
/* 00 */ 0x90ea, 0xc5b7, 0x9a5e, 0xc5b6, 0xf84f, 0xf850, 0xc648, 0xf8d1,
/* 08 */ 0x9f76, 0xc669,    BAD, 0xadb3, 0xb6b4, 0xe4ca, 0xe4c9, 0xe8b5,
/* 10 */ 0xe8b4,    BAD, 0x90eb, 0xc1fa, 0xef43, 0xef42, 0xf1a5, 0xf1a3,
/* 18 */ 0xf1a6, 0xf1a4,    BAD,    BAD, 0xc3fc, 0xf3a4, 0xf3a5, 0xf3a6,
/* 20 */ 0x90ec, 0xf671,    BAD, 0xf772,    BAD, 0xf8d2, 0x8bee,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xadb4, 0x90ee,    BAD,
/* 30 */ 0xec57, 0xef44, 0x91c6, 0xadb5,    BAD, 0x90f2, 0xbbe0,    BAD,
/* 38 */ 0xec58, 0xc341, 0xf1a7, 0xc3fd,    BAD, 0xf54c, 0xf54d, 0xc554
},

/* Row 0x311 */
{
/* 00 */ 0xf851, 0xadb6, 0xb3bb, 0xb3bc, 0xd84e, 0xb6b5, 0xb6b6, 0xdcac,
/* 08 */ 0xb6b7,    BAD, 0xb97a,    BAD, 0xb97c, 0xe0df, 0xe0e0, 0xe0de,
/* 10 */ 0xb977, 0xb978, 0xb97b, 0xb979, 0xfcbc, 0x8a74, 0xe4cb, 0xbbe1,
/* 18 */ 0xbbe2,    BAD,    BAD, 0xe8bc, 0xbe67, 0xe8b7, 0xe8b6, 0x9657,
/* 20 */ 0xe8bb, 0xbe65,    BAD, 0x9cef, 0xc05b,    BAD, 0xe8b8, 0xe8bd,
/* 28 */ 0xe8ba, 0xe8b9,    BAD, 0xbe66,    BAD, 0xc059, 0x9fdf, 0xec5a,
/* 30 */ 0xc055,    BAD, 0xec5b, 0x90f7, 0x90f6, 0xec59,    BAD, 0xc058,
/* 38 */ 0xc056, 0xc05a,    BAD, 0xc057,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x312 */
{
/* 00 */    BAD, 0xef45,    BAD, 0xef4a, 0xef46, 0xef49, 0xc1fb, 0x9b5e,
/* 08 */ 0xedd4, 0xef48, 0xef47, 0x90f8, 0xc344, 0xc342, 0xc345, 0xc343,
/* 10 */ 0xf1a8, 0xf1a9, 0xf1aa, 0xc346,    BAD,    BAD,    BAD, 0xf3aa,
/* 18 */ 0xc440, 0xf3a8,    BAD, 0xc441, 0xf3a7, 0xf3a9, 0xc3fe, 0xf551,
/* 20 */ 0xf54e,    BAD, 0xf54f, 0xf550, 0xf672, 0xc556, 0x90f9, 0xc555,
/* 28 */    BAD, 0xf774, 0xf773, 0xc5b8, 0xfa6a,    BAD,    BAD, 0xc5e3,
/* 30 */ 0xc649, 0xc660, 0xf958, 0xf9ae, 0xf9af, 0x8bef,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x313 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xadb7, 0xdcad,    BAD,    BAD, 0xe0e1, 0xe4cc, 0xe4cd, 0xbbe3,
/* 30 */    BAD, 0xbbe4, 0xe8be, 0xbe68, 0x9fe0,    BAD, 0xc1fc, 0x9142,
/* 38 */ 0xf1ab, 0x9a62, 0xc347, 0xf3ad, 0xc442, 0xf3ac, 0xf3ae, 0xf3ab
},

/* Row 0x314 */
{
/* 00 */ 0xf675, 0xf552, 0xf553, 0x9569, 0xc4c6,    BAD, 0xf674, 0x9144,
/* 08 */ 0x9143, 0xf673, 0x9141, 0xf775, 0xf9b0,    BAD, 0x8bf0,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xadb8, 0x9660,    BAD, 0x8bf1, 0xadb9,
/* 20 */ 0x99f6, 0x9149, 0xb0a7, 0xd448,    BAD, 0xd84f, 0x914a, 0xb6b8,
/* 28 */    BAD, 0xb6bb, 0xb6b9, 0xdcae, 0x914b, 0xb6bd,    BAD, 0xb6ba,
/* 30 */    BAD, 0x9a64, 0xb6bc,    BAD, 0xb97e, 0x8abf, 0xe0e2,    BAD,
/* 38 */    BAD, 0xe0e3, 0xe8c0,    BAD, 0xb97d, 0xb9a1, 0xb9a2,    BAD
},

/* Row 0x315 */
{
/* 00 */ 0xe4cf,    BAD, 0xe4ce, 0xbbe5,    BAD, 0xbbe6,    BAD, 0xe4d0,
/* 08 */ 0xe8bf, 0xbbe8, 0xbe69,    BAD, 0xbbe7,    BAD, 0x9a66,    BAD,
/* 10 */ 0xc05c, 0xe8c1, 0xbe6b, 0xbe6a, 0xe8c2, 0xe8c5, 0xe8c3, 0xe8c4,
/* 18 */ 0xbe6c, 0x9a67, 0xc061, 0xc05f, 0x9a69,    BAD, 0xc05e, 0xec5d,
/* 20 */    BAD, 0xc060,    BAD,    BAD, 0xec5c, 0xef4b,    BAD, 0xec5e,
/* 28 */ 0xc05d, 0xec5f, 0xef4e, 0xef4c, 0xef4d, 0xef52, 0xc34b, 0xef51,
/* 30 */ 0xef54, 0xef53, 0xef50, 0xef4f,    BAD, 0xc1fd,    BAD, 0x9a6a,
/* 38 */ 0x9652, 0x914d, 0xf1ae, 0x9666, 0xf1ad, 0xc34a, 0xc348, 0xc349
},

/* Row 0x316 */
{
/* 00 */ 0x9f7b, 0xf1ac, 0x9a6b, 0xf3b1,    BAD, 0xc443,    BAD, 0xf3b0,
/* 08 */ 0xf3af, 0xc444, 0xa06c, 0xf558, 0xf557, 0x9667, 0xf555,    BAD,
/* 10 */ 0xf554, 0xc4c8, 0xc4c7, 0xf559, 0xf776, 0xc5b9, 0xf677, 0xc557,
/* 18 */ 0xf676, 0xf556,    BAD, 0xf777, 0xc5e4, 0x9a6c, 0xc661, 0xf959,
/* 20 */    BAD, 0xf9b1, 0x9a6d, 0x8bf2,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x317 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xadba, 0xd850,
/* 18 */ 0xef55, 0xadbb,    BAD, 0x966a, 0xe4d2, 0xe4d1, 0xec60,    BAD,
/* 20 */    BAD, 0xef57,    BAD, 0xef56, 0xfcea, 0xc34c, 0xf3b2, 0xf3b3,
/* 28 */ 0xc4c9,    BAD, 0x966c, 0xf9b2, 0xb0a8, 0xb6bf, 0xb6be, 0xe0e4,
/* 30 */ 0xe0e6, 0xb9a4, 0xe0e5, 0xb9a3, 0xb9a5, 0xe0e7,    BAD,    BAD,
/* 38 */ 0x91c4, 0xe4d4, 0xe4d6, 0xe4d5, 0x9677, 0xe4d8,    BAD,    BAD
},

/* Row 0x318 */
{
/* 00 */    BAD, 0xbbe9, 0xe4d7, 0xe4d3, 0x99f4, 0x9a6f,    BAD, 0xe4d9,
/* 08 */    BAD, 0xe8cc,    BAD, 0xe8cf, 0xe8d1, 0xe8c7, 0xe8cb, 0xe8c8,
/* 10 */ 0xbe6e, 0xbe71, 0xbe73, 0xe8c9, 0xe8ca, 0xbe72, 0xe8cd, 0xe8d0,
/* 18 */ 0xe8ce, 0xbe74, 0x9fab, 0xbe70, 0xe8c6, 0xbe6d,    BAD, 0xbe6f,
/* 20 */    BAD, 0x8ec1, 0xc063, 0xec66, 0xec64, 0xec63, 0x9555, 0xec69,
/* 28 */    BAD, 0xec68, 0xec67,    BAD, 0xec62, 0xc062, 0xec61,    BAD,
/* 30 */ 0xec65, 0xc064,    BAD,    BAD, 0xef5a, 0x9152, 0xef5e, 0xef5b,
/* 38 */ 0xef5d, 0xef5c, 0xef59, 0xef5f, 0xef62, 0xef60, 0xef61, 0xc240
},

/* Row 0x319 */
{
/* 00 */    BAD, 0xc1fe, 0xef58, 0xef63, 0xf1b3, 0xf1b6, 0xf1b8, 0xf1b7,
/* 08 */    BAD, 0xf1b1, 0xf1b5, 0xf1b0, 0x9153, 0xf1b2, 0xc34d, 0xf1af,
/* 10 */ 0x9155, 0xf1b4,    BAD,    BAD, 0xf3c0, 0xf3b5, 0xc445,    BAD,
/* 18 */    BAD, 0xc446, 0xf3b4, 0xf3b9, 0xf3bf, 0xf3b7, 0xf3be, 0x955d,
/* 20 */ 0xf3bb, 0x9671, 0xf3ba, 0xf3bd, 0xf3b8, 0xf3b6, 0x9c6d, 0xf3bc,
/* 28 */    BAD, 0xf560, 0xf55e, 0xc4ca, 0xf55d, 0xf563, 0xf561, 0x9673,
/* 30 */ 0xc4cb, 0xf55c, 0xf55a,    BAD, 0xf55b, 0xc4cd, 0xf55f, 0xc4cc,
/* 38 */ 0xf562, 0xf678, 0xf67e, 0x9154, 0x9a71, 0xf679, 0xc55b, 0xf6a1
},

/* Row 0x31a */
{
/* 00 */ 0xc55a, 0xf67d, 0xf67c, 0xc559, 0xf67b, 0xc558, 0xf67a,    BAD,
/* 08 */ 0xf77d, 0xf7a1, 0xf77e,    BAD, 0xf77b, 0xc5bb, 0xf778, 0xf77c,
/* 10 */ 0xf7a3,    BAD, 0xf7a2, 0xf779, 0xf77a, 0xc5ba, 0xf852, 0xc5e7,
/* 18 */ 0x9156, 0xf853, 0xc5e5, 0xc5e6, 0x966d,    BAD, 0xf8d3, 0xc64a,
/* 20 */ 0xf976,    BAD, 0xc66a, 0x9557, 0xf9b3, 0xc66b, 0xf9b4, 0xf9b5,
/* 28 */ 0xf9c3, 0xf9c2, 0xc67a, 0xf9cd, 0x89c6,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x31b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x89c7,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xb0a9,    BAD,    BAD, 0xe0e9,    BAD, 0xe0e8,    BAD, 0xbbea,
/* 30 */ 0xbbeb, 0xe4da, 0x8a6a, 0xe8d2, 0xec6c,    BAD, 0x8b57, 0xbe75,
/* 38 */ 0xc065, 0xec6a, 0x9fe1, 0xec6d, 0xc066, 0x9b5f, 0xef64, 0xec6b
},

/* Row 0x31c */
{
/* 00 */ 0xf1b9, 0xc34e, 0xf3c1,    BAD,    BAD,    BAD, 0xf566, 0xf564,
/* 08 */    BAD,    BAD, 0xf565,    BAD,    BAD, 0xf6a2,    BAD, 0xc55c,
/* 10 */ 0xf7a4, 0xc5ea, 0xc5bc, 0xc5e8, 0xc5e9, 0xf8d4, 0xc662, 0xa05d,
/* 18 */ 0xb0aa,    BAD,    BAD,    BAD, 0xf1ba,    BAD,    BAD, 0xd449,
/* 20 */ 0x915b, 0xb9a6, 0x915c, 0xe4db,    BAD,    BAD, 0xbbec, 0xe4dc,
/* 28 */    BAD,    BAD,    BAD, 0xe8d4, 0xe8d3, 0xc068, 0xbe76, 0xbe77,
/* 30 */    BAD, 0xe8d7, 0xe8d6, 0xe8d5, 0x915e,    BAD, 0xec6e, 0xec71,
/* 38 */    BAD, 0xec70, 0xec6f, 0xc067, 0xef68, 0xef66, 0xef65, 0x9f5c
},

/* Row 0x31d */
{
/* 00 */    BAD, 0xef67, 0x9f57, 0xc34f, 0xf1bc, 0xf1bd, 0xc350,    BAD,
/* 08 */ 0xf1bb, 0x9f65, 0xf3c3, 0xf3c2, 0xf3c5, 0xc447, 0xf3c4, 0x9a72,
/* 10 */ 0xf567, 0xf569, 0xf568,    BAD, 0x9160, 0xf6a3, 0xf6a6, 0xf6a4,
/* 18 */ 0xf6a5, 0xf7a5, 0xc5bd,    BAD,    BAD,    BAD, 0xf854, 0xf855,
/* 20 */ 0xf856,    BAD, 0xc64b, 0xc663, 0xf9b6, 0xb0ab,    BAD, 0xbe78,
/* 28 */ 0xc069, 0xf1be, 0x9f5e, 0xf7a6,    BAD, 0x9161, 0xf9c4, 0xd44a,
/* 30 */    BAD, 0xc67b, 0xb0ac, 0xec72, 0x9164, 0xf1bf,    BAD, 0xf3c6,
/* 38 */    BAD, 0x9f41, 0xf6a7, 0xf7a7, 0xb0ad,    BAD, 0xe4dd, 0xe4de
},

/* Row 0x31e */
{
/* 00 */ 0x9169, 0xbbed, 0xbbee, 0xe8d9, 0xbe7a, 0xbe79, 0xe8d8,    BAD,
/* 08 */ 0xef69,    BAD, 0xf1c0, 0xf1c2, 0xf1c1, 0xc353, 0xc352, 0xc351,
/* 10 */ 0x9168, 0xc55e, 0xf6a8,    BAD, 0xc55d, 0xf7a9, 0xf7a8,    BAD,
/* 18 */ 0xc64c, 0xf8d5, 0xb3bd, 0xe0ea,    BAD,    BAD,    BAD, 0xe4e1,
/* 20 */ 0xe4df, 0xe4e0,    BAD,    BAD, 0xe8e2,    BAD, 0xe8dd, 0xe8da,
/* 28 */ 0xe8e1, 0x9a74,    BAD,    BAD, 0xe8e3,    BAD,    BAD, 0xbe7c,
/* 30 */ 0xe8e0, 0xe8dc,    BAD,    BAD, 0xe8db, 0xe8df, 0xe8de, 0xbe7b,
/* 38 */    BAD,    BAD, 0xec7d, 0xec78, 0xec76, 0xeca1, 0xec77, 0x96b2
},

/* Row 0x31f */
{
/* 00 */ 0xec73, 0x9a75, 0xec79, 0xfda5,    BAD, 0xec74, 0xef72, 0xec75,
/* 08 */ 0xeca2,    BAD,    BAD, 0x9ee9,    BAD, 0x8bba, 0x916d, 0xa060,
/* 10 */ 0xec7c, 0xc06a, 0xec7b, 0xec7a,    BAD, 0xec7e,    BAD, 0x9fde,
/* 18 */    BAD,    BAD, 0xef6a, 0xef6d,    BAD, 0x9fc3, 0xef6c, 0x96b5,
/* 20 */ 0xef74, 0xef6f, 0xef73,    BAD, 0xef71, 0xef70, 0xef6e,    BAD,
/* 28 */ 0xef6b,    BAD, 0xc243, 0xc242,    BAD, 0xc244, 0xc241, 0xef75,
/* 30 */ 0xa067,    BAD,    BAD,    BAD,    BAD, 0xf1c8, 0xf1cb,    BAD,
/* 38 */ 0xf1c9, 0xf1cd,    BAD,    BAD,    BAD, 0xf1ce,    BAD, 0xf1c6
},

/* Row 0x320 */
{
/* 00 */ 0xc358, 0xf1c7,    BAD, 0xf1c5, 0xf1cc,    BAD, 0xf1c4, 0xf1c3,
/* 08 */ 0xc357, 0xc355, 0xc354,    BAD,    BAD,    BAD,    BAD, 0x96b3,
/* 10 */    BAD,    BAD,    BAD, 0xf1ca, 0xf3cf, 0xf3d5, 0xc44a, 0xf3d0,
/* 18 */    BAD, 0xf3d3, 0xf3d7, 0xc44b, 0xf3d2, 0x9a76, 0xf3ca,    BAD,
/* 20 */ 0xf3c9, 0xf3d6, 0xf3cd,    BAD, 0xf3cb, 0xf3d4, 0xf3cc, 0xc449,
/* 28 */ 0xc448, 0x95d5, 0xf3c7, 0xf3c8, 0xf3d1, 0x9eca,    BAD,    BAD,
/* 30 */ 0xf3ce, 0x9a77,    BAD,    BAD, 0x9a78,    BAD,    BAD, 0xf56c,
/* 38 */ 0xf56f,    BAD,    BAD,    BAD,    BAD, 0xc356,    BAD, 0x9170
},

/* Row 0x321 */
{
/* 00 */    BAD,    BAD, 0x916f,    BAD,    BAD, 0xf56d, 0xf573, 0xf571,
/* 08 */ 0xf56b, 0xf576, 0x9fa3, 0xf56a, 0x9171, 0xc4cf, 0xf572,    BAD,
/* 10 */ 0x96b1,    BAD, 0xf56e, 0xc4ce, 0xf575, 0x9f63,    BAD, 0xf574,
/* 18 */    BAD,    BAD,    BAD, 0x9f67, 0xf6ab, 0xf6aa,    BAD, 0x8bb9,
/* 20 */ 0x9a7a, 0xf6b1,    BAD, 0xf6ad, 0xf6b0, 0xc560, 0x8b56,    BAD,
/* 28 */ 0xf6ae, 0xf6af,    BAD, 0xf6a9, 0xf6ac, 0xc55f,    BAD, 0x9ada,
/* 30 */    BAD, 0xc5bf, 0xf7b4, 0xf7af, 0xf7b3, 0x96b0, 0xf7b6, 0xf7b2,
/* 38 */    BAD, 0xf7ae, 0x9a7e, 0xc5c1, 0xf7b1, 0xf7b5, 0xc5c0, 0xf7ac
},

/* Row 0x322 */
{
/* 00 */ 0xf570, 0xf7b0,    BAD,    BAD, 0xf7ad, 0x9dde, 0xf7aa,    BAD,
/* 08 */ 0xf7ab, 0xc5be, 0xf85a, 0xf85c, 0xf85f, 0xf85b, 0xf860, 0x96ad,
/* 10 */ 0xf859,    BAD, 0xf857, 0x96ae, 0xc5eb, 0xf85d, 0xc5ed, 0xc5ec,
/* 18 */ 0xf858, 0xf85e,    BAD,    BAD,    BAD, 0x9ea1, 0xf8da, 0xc64d,
/* 20 */ 0xf8db,    BAD, 0xf8d9, 0xf8d6,    BAD,    BAD, 0xf8d8, 0xf8d7,
/* 28 */ 0xf95a,    BAD,    BAD,    BAD,    BAD, 0xf95c, 0xf95b,    BAD,
/* 30 */    BAD, 0xf979, 0x9e50, 0xf978, 0xf977, 0xf97a,    BAD, 0xc673,
/* 38 */ 0xc674, 0xf9ca, 0xf9ce, 0x96af, 0x8bf4,    BAD,    BAD,    BAD
},

/* Row 0x323 */
{
/* 00 */ 0xe8ea,    BAD, 0x9fa4, 0xbea1, 0xe8ef, 0xe8ee, 0xbe7d, 0xe8e9,
/* 08 */ 0xe8ed, 0xbe7e,    BAD,    BAD, 0x96bd,    BAD,    BAD,    BAD,
/* 10 */ 0xecac,    BAD, 0xc06f,    BAD, 0xeca7, 0xc06b, 0x96f4, 0xeca4,
/* 18 */ 0xecaa, 0xecad,    BAD, 0xc070,    BAD, 0xeca9, 0xeca6, 0xecae,
/* 20 */ 0xeca5, 0x96b8, 0xecab, 0xc06c,    BAD, 0xeca3, 0xc06d,    BAD,
/* 28 */ 0xc06e, 0xeca8,    BAD,    BAD,    BAD, 0xefa9, 0xef7a, 0xef7b,
/* 30 */ 0xef7e, 0xef7c,    BAD, 0xef76, 0xfaa1,    BAD, 0xef79, 0xefa5,
/* 38 */ 0xef7d, 0x91a7,    BAD, 0xc245,    BAD, 0xefa7, 0xefa4, 0xc246
},

/* Row 0x324 */
{
/* 00 */ 0xefa6, 0xef77, 0xefa2, 0xefa3, 0xa05e, 0xefa1,    BAD,    BAD,
/* 08 */    BAD, 0x9a7d, 0xf1d2, 0xf1d4, 0xf1d7,    BAD, 0x8948, 0xf1d1,
/* 10 */ 0x9eb1, 0xc359, 0xf1d9, 0xf1d0, 0xf1da,    BAD, 0xf1d6, 0xf1d8,
/* 18 */ 0xf1dc, 0xf1d5, 0xf1dd, 0xf1d3, 0xf1cf, 0xc35a, 0x9ddb, 0xf1db,
/* 20 */ 0xc35b, 0xc44d,    BAD,    BAD,    BAD,    BAD,    BAD, 0xef78,
/* 28 */ 0xf3f1, 0xf3e8, 0xc44f, 0xf3e4, 0xc450, 0x95bf, 0x8a73, 0xf3ed,
/* 30 */ 0xf3e7, 0xf3dd, 0xc44e, 0xf3ea, 0xf3e5, 0xf3e6,    BAD, 0xf3d8,
/* 38 */ 0xf3df, 0xf3ee,    BAD, 0xf3eb, 0x9efe, 0xf3e3, 0x917a, 0xf3ef
},

/* Row 0x325 */
{
/* 00 */ 0xf3de, 0xf3d9, 0xf3ec, 0x917b, 0xf3db, 0xf3e9, 0xf3e0, 0xf3f0,
/* 08 */ 0xf3dc, 0xc44c, 0xf3da, 0xf3e1, 0xf3e2,    BAD,    BAD,    BAD,
/* 10 */ 0xf57d,    BAD, 0xf57b, 0x9aa3, 0xf5a2,    BAD, 0xf5ae, 0xf5a5,
/* 18 */ 0xf57c, 0xf578, 0xf5a7, 0xf57e, 0xf5a3, 0xf57a, 0xf5aa, 0xf577,
/* 20 */ 0xf5a1, 0xf5a6, 0xf5a8, 0xf5ab, 0xf579, 0x96c2, 0xf5af, 0xf5b0,
/* 28 */ 0xf5a9, 0xf5ad, 0xf5a4, 0x9f77, 0xf6c1, 0xf6c4,    BAD, 0xc561,
/* 30 */    BAD, 0xf6c3, 0xf6c8, 0xf6c6, 0xc562, 0xf6bd, 0xf6b3, 0xf6b2,
/* 38 */ 0xc564, 0xf6bf, 0xf6c0, 0xf6bc, 0xf6b4, 0x9aa4, 0xf6b9, 0xf5ac
},

/* Row 0x326 */
{
/* 00 */ 0x9aa5, 0xf6b5, 0xc563, 0xf6bb, 0x91a1, 0xf6ba,    BAD, 0xf6b6,
/* 08 */ 0xf6c2, 0x89b8, 0xf6b7, 0xf7bb, 0xf6c5, 0xf6c7, 0xf6be, 0xf6b8,
/* 10 */ 0xf7bc, 0xf7be, 0xf7b8, 0xc5c2, 0x9173, 0xf7c5, 0xf7c3, 0xc5c3,
/* 18 */ 0xf7c2, 0xf7c1, 0xf7ba, 0xf7b7, 0xf7bd, 0xf7c6, 0xf7b9, 0xf7bf,
/* 20 */    BAD, 0xf869, 0xf86e, 0xf864, 0xf867, 0xc5ee, 0xf86b,    BAD,
/* 28 */ 0xf872, 0xf7c0,    BAD, 0xf865, 0xf86f, 0xf873, 0xf86a, 0xf863,
/* 30 */ 0xf86d,    BAD, 0xf86c, 0xf871, 0xf870, 0xf7c4, 0xf868, 0xf862,
/* 38 */ 0xf866, 0xc64e, 0xc64f, 0xf861, 0x9aa6, 0xf8e6, 0xf8dd, 0xf8e5
},

/* Row 0x327 */
{
/* 00 */ 0xf8e2, 0xf8e3, 0xf8dc, 0xf8df, 0xf8e7, 0xf8e1, 0xf8e0, 0xf8de,
/* 08 */    BAD, 0xf8e4, 0x89bd, 0xf95d, 0x89b9, 0xf95e, 0x917d, 0xf960,
/* 10 */ 0xf95f, 0xf962, 0xf961, 0xf97c, 0xf97b, 0xf9b7,    BAD, 0xf9b8,
/* 18 */ 0x96bb, 0xf9c5, 0xc678, 0xc67c, 0x9ff2, 0xf9cf, 0xc67d, 0x8bf5,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x328 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xb3bf,    BAD,    BAD,
/* 38 */    BAD, 0xc4d0, 0xf6c9, 0x9aa9, 0xc650, 0xc651,    BAD, 0xb3c0
},

/* Row 0x329 */
{
/* 00 */ 0xe0ee, 0x9f54, 0xb9a8, 0xe8f0, 0x9fe3, 0x9eed, 0xecb0, 0xecb1,
/* 08 */ 0xecaf, 0xefab, 0xefaa, 0xc247, 0xf1df, 0xefac, 0xf1de,    BAD,
/* 10 */ 0x91aa, 0xf3f3, 0xc451, 0xc453, 0xf3f2, 0x91ab, 0xa070, 0xc452,
/* 18 */ 0x9f6d, 0xf5b1, 0xf5b3, 0xf5b2, 0xf6ca, 0xc565, 0x91ac, 0xc5ef,
/* 20 */ 0xf8e8, 0xf963, 0x91ad,    BAD, 0xf9d2, 0xb3c1, 0xa0fd, 0xe4e5,
/* 28 */ 0x9fe2, 0xbea2, 0x91af, 0x9e41, 0x9aaa, 0xecb3, 0xecb2, 0x91b0,
/* 30 */ 0xefad, 0x9aab,    BAD,    BAD, 0xc454, 0xc4d1, 0xf7c7, 0xf9cb,
/* 38 */    BAD,    BAD,    BAD, 0xb3c2, 0xbbf2, 0x9aac, 0xbea3, 0x9a4a
},

/* Row 0x32a */
{
/* 00 */ 0xf3f4, 0x91b2, 0xf874, 0xb6c0, 0x8bf6,    BAD, 0x9aad, 0x89b6,
/* 08 */ 0xefae,    BAD,    BAD,    BAD, 0xc664, 0xb6c1, 0xbea4, 0xc248,
/* 10 */ 0xf875, 0xb6c2,    BAD, 0xe8f1, 0xc072, 0xecb4, 0xecb5,    BAD,
/* 18 */ 0xc071,    BAD, 0xefaf, 0xc24c, 0xc24a, 0xc24b, 0xc249, 0xf1e0,
/* 20 */ 0xc35c,    BAD, 0x9aaf,    BAD, 0xf5b5, 0xf5b4, 0xf5b7, 0xf5b6,
/* 28 */ 0xc4d2,    BAD,    BAD, 0xf6cb,    BAD, 0xf6cd, 0xf6cc, 0xc566,
/* 30 */ 0xf7c8, 0x9ab0, 0xf876, 0xf877, 0xc5f0, 0xf964, 0xf97d, 0xc675,
/* 38 */ 0x9ab1, 0xdcb0, 0xecb6, 0xefb0, 0xf3f5, 0xe0ef, 0x9aa1, 0xefb1
},

/* Row 0x32b */
{
/* 00 */ 0xf1e2, 0xf1e1, 0x91b9,    BAD,    BAD,    BAD, 0xf878, 0xc652,
/* 08 */ 0x91ba, 0xf965, 0xf97e,    BAD,    BAD,    BAD, 0xb9a9, 0xe8f2,
/* 10 */ 0xe8f3,    BAD, 0xecb7, 0xb9aa,    BAD, 0xc35d, 0xf1e3, 0x91be,
/* 18 */ 0xf6cf, 0xc567, 0xf6d0, 0xf6ce, 0xf879,    BAD, 0xf8e9,    BAD,
/* 20 */ 0xb9ab,    BAD, 0xefb4, 0xefb3, 0xefb2, 0xf1e4, 0xa041, 0x8bb7,
/* 28 */ 0xf1e8, 0xf1e7, 0xf1e6, 0xf1e5, 0xc35e, 0xf3f6, 0xf5b9, 0xc4d3,
/* 30 */ 0xf5b8, 0xf6d1, 0xf7cb, 0xf7ca, 0xc5c4, 0xf7c9, 0xf87c, 0xf87b,
/* 38 */ 0xf87a, 0x91c0,    BAD, 0xbbf3,    BAD, 0xecb8, 0xc24d,    BAD
},

/* Row 0x32c */
{
/* 00 */ 0xf3f7, 0xf3f8, 0xf7cc, 0xf87d, 0x9ab3, 0x91c3, 0xf8ea, 0xf966,
/* 08 */ 0xf9b9, 0xf9d4, 0xbbf4, 0xc24e, 0xf1e9, 0xf3f9, 0xf6d2, 0xf87e,
/* 10 */ 0xa0fc,    BAD, 0xbea6, 0x9fee, 0xefb5, 0xf1ea, 0xf3fa, 0xf3fb,
/* 18 */ 0xf3fc, 0xf5be, 0x9f69, 0xf5ba, 0xc568, 0xf5bd, 0xf5bc, 0xc4d4,
/* 20 */ 0xf5bb, 0xc4d6, 0x91c8, 0xc4d5, 0xf6d4, 0xf6d3, 0xc569, 0xc56a,
/* 28 */    BAD, 0x91c9, 0xc5c6, 0xf7cd, 0xc5c5,    BAD, 0xf8a3, 0xf8a4,
/* 30 */ 0xf8a2, 0xf8a1, 0xc654,    BAD, 0xf8eb, 0xf8ec, 0xf8ed, 0xc653,
/* 38 */ 0xf967, 0xf96a, 0xf969, 0xf968,    BAD,    BAD, 0xf9d3, 0x8de6
},

/* Row 0x32d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc073, 0x91cb,    BAD,
/* 10 */ 0xc365, 0xf5bf, 0xf6d5,    BAD, 0xc5c7, 0xf7ce,    BAD,    BAD,
/* 18 */ 0xf9d5, 0x89c8,    BAD,    BAD, 0x8bf8,    BAD,    BAD, 0x8daa,
/* 20 */ 0xefb6,    BAD, 0xf7cf,    BAD, 0xf9a1, 0x9fdd,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x32e */
{
/* 00 */    BAD,    BAD,    BAD, 0xfa43,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xfa58,    BAD,    BAD, 0xfa5b,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfa6d,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xfa78,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x32f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xfaae,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xfabc,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x330 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xfaf6,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xfafb, 0xfafc,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x331 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfb68,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xfb73,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xfbb7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xfbbe,    BAD,    BAD,    BAD, 0xfbc2,    BAD,    BAD
},

/* Row 0x332 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfbcb,    BAD,
/* 08 */    BAD, 0xfbce, 0xfbcf,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xfbf5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x333 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xfc56,    BAD,    BAD,    BAD, 0xfc5a,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfc63,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xfc6e,    BAD, 0xfc70,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xfc77,    BAD,    BAD,    BAD, 0xfc7b,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x334 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfcb7,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xfce3,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x335 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xfcf4, 0xfcf5,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfd40,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfd58,
/* 30 */    BAD,    BAD, 0xfd5b,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xfd63,    BAD,    BAD,    BAD, 0xfd67,    BAD
},

/* Row 0x336 */
{
/* 00 */    BAD,    BAD, 0xfd6b,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xfd74,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xfda4,    BAD,    BAD, 0xfda7,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfdb2,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x337 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfdd0,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0xfdd5,    BAD,    BAD,    BAD, 0xfdd9,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xfdf6,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xfe46,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x338 */
{
/* 00 */    BAD,    BAD, 0xfe4e,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xfe5c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xfe67,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xfe6d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xfe7e,    BAD,    BAD,    BAD,    BAD, 0xfea5,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x339 */
{
/* 00 */    BAD, 0xfeaf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xfeb7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xfec2,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xfed0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xfed9, 0xfeda,    BAD,    BAD,    BAD,
/* 30 */ 0xfede, 0xfedf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x33a */
{
/* 00 */ 0xfeee,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x8e40,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8e54,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x8e5f,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x33b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8e74,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x8eb3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x33c */
{
/* 00 */    BAD, 0x8ed2, 0x8ed3,    BAD,    BAD,    BAD, 0x8ed7,    BAD,
/* 08 */    BAD, 0x8eda,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8ee5,    BAD, 0x8ee7,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8eef,    BAD,
/* 20 */ 0x8ef1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8f46,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x8f4d,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x33d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f5f,    BAD, 0x8f61,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f67,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x8f73,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f79,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x8fa4,    BAD, 0x8fa6,    BAD, 0x8fa8,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x33e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fda,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fea,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x33f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8ffc,    BAD,    BAD,    BAD,    BAD, 0x9042,    BAD,    BAD,
/* 10 */ 0x9045,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x905c,
/* 28 */ 0x905d, 0x905e,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9069,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x340 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x90a1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x90b8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x341 */
{
/* 00 */    BAD, 0x90d8,    BAD,    BAD,    BAD,    BAD, 0x90dd,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x90f4,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x342 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9176,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x917c,    BAD,    BAD,    BAD,
/* 28 */ 0x91a2,    BAD,    BAD,    BAD,    BAD,    BAD, 0x91a8, 0x91a9,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x343 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x91e7,    BAD,    BAD,
/* 30 */ 0x91ea,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x91f4,    BAD,    BAD, 0x91f7,    BAD,    BAD
},

/* Row 0x344 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x91fe,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x9246,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x9255,    BAD,    BAD,    BAD, 0x9259,    BAD,
/* 20 */ 0x925b,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9261,    BAD,
/* 28 */    BAD,    BAD, 0x9265,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x345 */
{
/* 00 */    BAD,    BAD, 0x927d,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x92a5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x92b5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x92ce,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x346 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x92f6,    BAD,    BAD, 0x92f9,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x347 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9364,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x9372,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x937e,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x93aa,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x93bd,    BAD,    BAD
},

/* Row 0x348 */
{
/* 00 */ 0x93c0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x93ce,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x93d7,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x93de,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x349 */
{
/* 00 */ 0x9441,    BAD,    BAD,    BAD,    BAD, 0x9446,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x945f, 0x9460,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x34a */
{
/* 00 */    BAD, 0x94a4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x94b6,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x94c8,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x94e0,    BAD,    BAD
},

/* Row 0x34b */
{
/* 00 */    BAD, 0x94e4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x94f5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9541,    BAD,    BAD,
/* 20 */    BAD, 0x9545,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x954c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9559,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x955e,    BAD,    BAD, 0x9561,    BAD,    BAD
},

/* Row 0x34c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x9574,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x957b,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x95ac,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x95ba,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x34d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x95e0,    BAD,    BAD, 0x95e3,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x95ee, 0x95ef,    BAD,    BAD,    BAD, 0x95f3,    BAD,    BAD,
/* 30 */    BAD, 0x95f7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x9642, 0x9643,    BAD,    BAD,    BAD
},

/* Row 0x34e */
{
/* 00 */ 0x9647,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x9653,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x965a,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9668,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x966f,    BAD,    BAD,    BAD,    BAD, 0x9674,    BAD, 0x9676,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x34f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x96b6,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x96be, 0x96bf,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x96c4,    BAD, 0x96c6,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x96ce,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x350 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96f0,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96f8,
/* 10 */    BAD, 0x96fa,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x974b,    BAD,    BAD, 0x974e,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x351 */
{
/* 00 */    BAD,    BAD, 0x976c, 0x976d,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9777,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x97a1, 0x97a2,    BAD,
/* 18 */    BAD, 0x97a5, 0x97a6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x97ad,    BAD,    BAD,    BAD, 0x97b1,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x97ca,    BAD
},

/* Row 0x352 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x97e3,
/* 18 */ 0x97e4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x97eb,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x97f1,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x97f7,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9841,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x353 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x985d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9874,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x987b, 0x987c,
/* 30 */    BAD,    BAD,    BAD, 0x98a2,    BAD,    BAD,    BAD, 0x98a6,
/* 38 */    BAD,    BAD, 0x98a9, 0x98aa,    BAD, 0x98ac,    BAD,    BAD
},

/* Row 0x354 */
{
/* 00 */    BAD,    BAD, 0x98b1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x98c0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x355 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x98fa,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x356 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9a7c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ab4
},

/* Row 0x357 */
{
/* 00 */ 0x9ab5, 0x9ab6,    BAD,    BAD,    BAD, 0x9aba,    BAD,    BAD,
/* 08 */    BAD, 0x9abe, 0x9abf, 0x9ac0, 0x9ac1,    BAD,    BAD, 0x9ac4,
/* 10 */ 0x9ac5, 0x9ac6,    BAD, 0x9ac8, 0x9ac9,    BAD, 0x9acb, 0x9acc,
/* 18 */    BAD, 0x9ace, 0x9acf,    BAD, 0x9ad1,    BAD, 0x9ad3, 0x9ad4,
/* 20 */ 0x9ad5, 0x9ad6, 0x9ad7, 0x9ad8,    BAD,    BAD,    BAD, 0x9adc,
/* 28 */    BAD, 0x9ade, 0x9adf,    BAD, 0x9ae1,    BAD, 0x9ae3,    BAD,
/* 30 */ 0x9ae5, 0x9ae6,    BAD,    BAD,    BAD, 0x9aea, 0x9aeb,    BAD,
/* 38 */ 0x9aed, 0x9aee, 0x9aef, 0x9af0,    BAD,    BAD,    BAD, 0x9af4
},

/* Row 0x358 */
{
/* 00 */ 0x9af5,    BAD, 0x9af7, 0x9af8, 0x9af9, 0x9afa,    BAD,    BAD,
/* 08 */ 0x9afd, 0x9afe, 0x9b40, 0x9b41, 0x9b42, 0x9b43, 0x9b44, 0x9b45,
/* 10 */    BAD,    BAD, 0x9b48,    BAD,    BAD, 0x9b4b,    BAD,    BAD,
/* 18 */    BAD, 0x9b4f, 0x9b50, 0x9b51, 0x9b52, 0x9b53,    BAD, 0x9b55,
/* 20 */ 0x9b56,    BAD,    BAD, 0x9b59,    BAD, 0x9b5b,    BAD, 0x9b5d,
/* 28 */    BAD,    BAD, 0x9b60,    BAD, 0x9b62, 0x9b63, 0x9b64,    BAD,
/* 30 */ 0x9b66, 0x9b67, 0x9b68, 0x9b69, 0x9b6a, 0x9b6b, 0x9b6c, 0x9b6d,
/* 38 */ 0x9b6e, 0x9b6f,    BAD,    BAD,    BAD, 0x9b73, 0x9b74, 0x9b75
},

/* Row 0x359 */
{
/* 00 */    BAD,    BAD,    BAD, 0x9b79, 0x9b7a,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x9ba2,    BAD,    BAD, 0x9ba5, 0x9ba6,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x9bab,    BAD, 0x9bad, 0x9bae,    BAD,
/* 18 */ 0x9bb0,    BAD, 0x9bb2, 0x9bb3,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x9bba, 0x9bbb,    BAD, 0x9bbd,    BAD, 0x9bbf,
/* 28 */ 0x9bc0, 0x9bc1,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9bc7,
/* 30 */ 0x9bc8, 0x9bc9,    BAD, 0x9bcb,    BAD,    BAD, 0x9bce, 0x9bcf,
/* 38 */    BAD,    BAD, 0x9bd2,    BAD,    BAD,    BAD, 0x9bd6, 0x9bd7
},

/* Row 0x35a */
{
/* 00 */ 0x9bd8,    BAD,    BAD, 0x9bdb,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9be0,    BAD, 0x9be2,    BAD, 0x9be4,    BAD,    BAD,    BAD,
/* 10 */ 0x9be8,    BAD,    BAD, 0x9beb,    BAD, 0x9bed,    BAD,    BAD,
/* 18 */    BAD, 0x9bf1,    BAD, 0x9bf3,    BAD,    BAD,    BAD, 0x9bf7,
/* 20 */    BAD,    BAD, 0x9bfa,    BAD,    BAD, 0x9bfd, 0x9bfe,    BAD,
/* 28 */    BAD,    BAD, 0x9c43, 0x9c44,    BAD,    BAD, 0x9c47,    BAD,
/* 30 */    BAD,    BAD, 0x9c4b, 0x9c4c,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9c56,    BAD, 0x9c58
},

/* Row 0x35b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9c5e,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x9c63,    BAD, 0x9c65,    BAD, 0x9c67,    BAD,
/* 10 */ 0x9c69,    BAD,    BAD,    BAD,    BAD, 0x9c6e,    BAD, 0x9c70,
/* 18 */ 0x9c71,    BAD, 0x9c73, 0x9c74,    BAD, 0x9c76,    BAD, 0x9c78,
/* 20 */    BAD, 0x9c7a,    BAD,    BAD, 0x9c7d,    BAD,    BAD,    BAD,
/* 28 */ 0x9ca3, 0x9ca4,    BAD, 0x9ca6, 0x9ca7,    BAD,    BAD, 0x9caa,
/* 30 */    BAD,    BAD, 0x9cad,    BAD,    BAD, 0x9cb0,    BAD,    BAD,
/* 38 */    BAD, 0x9cb4, 0x9cb5,    BAD,    BAD,    BAD, 0x9cb9,    BAD
},

/* Row 0x35c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9cc3, 0x9cc4,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9cca,
/* 10 */    BAD,    BAD,    BAD, 0x9cce,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9cd4, 0x9cd5, 0x9cd6, 0x9cd7,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9cdf,    BAD, 0x9ce1,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x9ce6,    BAD,    BAD,    BAD, 0x9cea,
/* 30 */    BAD,    BAD, 0x9ced,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9cfa
},

/* Row 0x35d */
{
/* 00 */    BAD,    BAD,    BAD, 0x9cfe, 0x9d40, 0x9d41, 0x9d42, 0x9d43,
/* 08 */ 0x9d44, 0x9d45,    BAD, 0x9d47,    BAD,    BAD,    BAD, 0x9d4b,
/* 10 */    BAD,    BAD, 0x9d4e,    BAD, 0x9d50,    BAD, 0x9d52, 0x9d53,
/* 18 */ 0x9d54,    BAD, 0x9d56,    BAD, 0x9d58, 0x9d59,    BAD,    BAD,
/* 20 */ 0x9d5c,    BAD, 0x9d5e, 0x9d5f,    BAD,    BAD,    BAD, 0x9d63,
/* 28 */    BAD, 0x9d65, 0x9d66, 0x9d67, 0x9d68, 0x9d69,    BAD, 0x9d6b,
/* 30 */ 0x9d6c,    BAD, 0x9d6e, 0x9d6f,    BAD, 0x9d71,    BAD,    BAD,
/* 38 */    BAD, 0x9d75,    BAD, 0x9d77,    BAD,    BAD, 0x9d7a,    BAD
},

/* Row 0x35e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x9da2,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9dac,    BAD,
/* 10 */    BAD,    BAD, 0x9db0,    BAD,    BAD, 0x9db3,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9dcd,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9dd4,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x35f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ded,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9dfa,    BAD,    BAD,    BAD,
/* 20 */ 0x9dfe, 0x9e40,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x9e4f,    BAD, 0x9e51,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9e5b,    BAD,    BAD,    BAD
},

/* Row 0x360 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9e70,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e7c,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9ea5,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9eaa,    BAD,    BAD, 0x9ead,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x9ebc,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x361 */
{
/* 00 */    BAD, 0x9ec2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ed0,
/* 10 */    BAD,    BAD, 0x9ed3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ee0,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x9eec,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x9ef9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x362 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x9f46, 0x9f47,    BAD,    BAD,
/* 08 */ 0x9f4a,    BAD,    BAD, 0x9f4d,    BAD,    BAD, 0x9f50,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x363 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9fb3,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x9fbe,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9fd1,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x364 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9fec,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x365 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0a4,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xa0b1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x366 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0ec,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xa0f7,    BAD,    BAD,    BAD, 0xa0fb,    BAD,    BAD, 0xa0fe,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x367 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8840, 0x8841, 0x8842, 0x8843, 0x8844,
/* 08 */ 0x8845, 0x8846, 0x8847, 0x8848, 0x8849, 0x884a, 0x884b, 0x884c,
/* 10 */ 0x884d, 0x884e, 0x884f, 0x8850, 0x8851, 0x8852, 0x8853, 0x8854,
/* 18 */ 0x8855,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8862,    BAD, 0x8864,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x368 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x88a3,    BAD, 0x88a5,    BAD,
/* 08 */    BAD,    BAD, 0x88a9, 0x88aa,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x369 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x8941,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x36a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x89b2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x89bb,    BAD,    BAD, 0x89be,    BAD,    BAD,    BAD
},

/* Row 0x36b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x89ca,    BAD,    BAD, 0x89cd,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a40,    BAD,    BAD
},

/* Row 0x36c */
{
/* 00 */    BAD, 0x8a44, 0x8a45,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x8a4c,    BAD,    BAD,    BAD, 0x8a50,    BAD,    BAD,
/* 10 */ 0x8a53,    BAD,    BAD,    BAD, 0x8a57,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x8a5d, 0x8a5e, 0x8a5f, 0x8a60,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x8a65,    BAD,    BAD, 0x8a68, 0x8a69,    BAD,
/* 28 */    BAD, 0x8a6c,    BAD,    BAD,    BAD, 0x8a70, 0x8a71, 0x8a72,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a7a,
/* 38 */ 0x8a7b,    BAD,    BAD,    BAD, 0x8aa1, 0x8aa2, 0x8aa3,    BAD
},

/* Row 0x36d */
{
/* 00 */ 0x8aa5,    BAD,    BAD,    BAD,    BAD, 0x8aaa,    BAD,    BAD,
/* 08 */ 0x8aad,    BAD,    BAD, 0x8ab0,    BAD, 0x8ab2,    BAD, 0x8ab4,
/* 10 */ 0x8ab5, 0x8ab6,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8abc,
/* 18 */ 0x8abd,    BAD,    BAD, 0x8ac0,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x8ac9,    BAD,    BAD, 0x8acc,
/* 28 */    BAD,    BAD, 0x8acf,    BAD,    BAD, 0x8ad2,    BAD, 0x8ad4,
/* 30 */    BAD,    BAD,    BAD, 0x8ad8, 0x8ad9,    BAD,    BAD, 0x8adc,
/* 38 */    BAD,    BAD, 0x8adf, 0x8ae0, 0x8ae1, 0x8ae2,    BAD,    BAD
},

/* Row 0x36e */
{
/* 00 */ 0x8ae5, 0x8ae6,    BAD, 0x8ae8,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8aed,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8af3, 0x8af4,
/* 10 */    BAD,    BAD, 0x8af7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x8b48,    BAD,    BAD, 0x8b4b,    BAD, 0x8b4d,
/* 28 */ 0x8b4e, 0x8b4f,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x8b59,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x36f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x8baa, 0x8bab,    BAD, 0x8bad, 0x8bae,    BAD,
/* 28 */    BAD,    BAD, 0x8bb2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8bc2, 0x8bc3,    BAD, 0x8bc5,    BAD,    BAD
},

/* Row 0x370 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8bd6,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8bdb,    BAD,    BAD, 0x8bde,    BAD,
/* 18 */    BAD, 0x8be1, 0x8be2,    BAD,    BAD,    BAD, 0x8be6,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8bed,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x8bf3,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8bfa,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x371 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x8dfe,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x372 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xc879, 0xc87a,    BAD,
/* 28 */ 0xc87c,    BAD, 0xc87e, 0xc8a1,    BAD, 0xc8a3, 0xc8a4,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x373 */
{
/* 00 */    BAD, 0xa149, 0xc8d0, 0xa1ad, 0xa243, 0xa248, 0xa1ae, 0xc8cf,
/* 08 */ 0xa15d, 0xa15e, 0xa1af, 0xa1cf, 0xa141, 0xa1d0, 0xa144, 0xa241,
/* 10 */ 0xa2af, 0xa2b0, 0xa2b1, 0xa2b2, 0xa2b3, 0xa2b4, 0xa2b5, 0xa2b6,
/* 18 */ 0xa2b7, 0xa2b8, 0xa147, 0xa146, 0xa1d5, 0xa1d7, 0xa1d6, 0xa148,
/* 20 */ 0xa249, 0xa2cf, 0xa2d0, 0xa2d1, 0xa2d2, 0xa2d3, 0xa2d4, 0xa2d5,
/* 28 */ 0xa2d6, 0xa2d7, 0xa2d8, 0xa2d9, 0xa2da, 0xa2db, 0xa2dc, 0xa2dd,
/* 30 */ 0xa2de, 0xa2df, 0xa2e0, 0xa2e1, 0xa2e2, 0xa2e3, 0xa2e4, 0xa2e5,
/* 38 */ 0xa2e6, 0xa2e7, 0xa2e8, 0xc6e4, 0xa242, 0xc6e5,    BAD, 0xa1c4
},

/* Row 0x374 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xc8cd,    BAD, 0xc8ce,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xf9fe,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x375 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9375,    BAD
},

/* Row 0x376 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9376,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9548,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8ec6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x377 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0f6,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x378 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0xfcad,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x379 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x9272,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x37a */
{
/* 00 */    BAD, 0xfc47,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x94df,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x37b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x98a4,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x37c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x94e7,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x90cb, 0x927b,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x37d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x94d8,    BAD,    BAD,    BAD,    BAD, 0xfc5f,    BAD,
/* 20 */ 0xfa54,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96da
},

/* Row 0x37e */
{
/* 00 */ 0x9279,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfa74,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x37f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x9275,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8dfb,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x380 */
{
/* 00 */    BAD, 0x8a49,    BAD,    BAD,    BAD, 0x92df, 0x9b7c, 0xfa63,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfa60, 0x926d
},

/* Row 0x381 */
{
/* 00 */ 0xfa62,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x976b,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfd6a,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x382 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xfd54,    BAD, 0x9273,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x97d8,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9fbb,    BAD,    BAD,    BAD
},

/* Row 0x383 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x9342, 0x9276,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfa65,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x384 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x926c,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x385 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfa6e,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x92c0, 0x92bf,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x92be,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x386 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x8ab3,    BAD, 0x9775,    BAD
},

/* Row 0x387 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfa40,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x388 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfa76,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfbd0,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xfa7b,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x389 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x89cc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfa42,
/* 20 */ 0x92bc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x945c,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x38a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9bb5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x98a7, 0x97a4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x90fd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x38b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x92c3,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x38c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x9bd0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x38d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x9550,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x38e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x92c6,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x38f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9546,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x390 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xfac2,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x9ec3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x391 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9c66,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x392 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x9053,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x393 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x97c1,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x394 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfae9,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x9262,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x395 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x92e1,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xfac6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfa72
},

/* Row 0x396 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x92cc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x397 */
{
/* 00 */    BAD, 0x9df9, 0x8a43, 0x8aa6,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x9acd,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfaee,
/* 38 */ 0x9bcc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x398 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9d7c,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x399 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x995f,
/* 10 */    BAD,    BAD,    BAD, 0xfbf6, 0x9fc5, 0x8a59, 0x8b6b,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x39a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a64, 0x8af2,
/* 08 */ 0x8af8, 0x9dd8,    BAD,    BAD, 0x94d6, 0xfafe, 0xfba7,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b43, 0x8b44
},

/* Row 0x39b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e54,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x39c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x8aca, 0x9ea8,    BAD,    BAD, 0x9263, 0x9add, 0x8b65,
/* 10 */ 0x8b6f, 0x8b7e,    BAD,    BAD,    BAD,    BAD, 0x8f43,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x92d0,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x39d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9dbe,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfcde, 0x9dfd, 0x8b66,
/* 38 */ 0x8b70, 0x8b75, 0x8ae4, 0x8ba4,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x39e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x8aef, 0x8af6, 0x9e76,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ee3,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x39f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x9cb1, 0x9e77, 0x8b64, 0x8b67,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3a0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ae0, 0x8b4a,    BAD,
/* 30 */ 0x8af1, 0x8ad7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0xa0ab,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3a1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8aee,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8afe,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8a58, 0x8ba3, 0x8ba7,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3a2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9dd7, 0x9e7d, 0x9ea7, 0x9eab,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3a3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b79, 0x8b7a,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3a4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a7e,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e44, 0x9ae7, 0x8a7c,
/* 38 */ 0x8b71,    BAD,    BAD, 0x9ae9,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3a5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xfb4e,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3a6 */
{
/* 00 */ 0x8af9, 0x9e63,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b49,
/* 08 */ 0x8ace, 0x8b6e,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8a5a, 0x8b7b, 0x8b7c,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3a7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8afa,    BAD,    BAD
},

/* Row 0x3a8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x8b72,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3a9 */
{
/* 00 */ 0x8ba8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9eae,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3aa */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9e72,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3ab */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfb5f,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x90ba,    BAD,    BAD,    BAD
},

/* Row 0x3ac */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9ef6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x97ed,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3ad */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9af3,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0ee,    BAD
},

/* Row 0x3ae */
{
/* 00 */    BAD,    BAD, 0x967c, 0x9345, 0x986e, 0xfa56,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0xfc4b,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3af */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x97c7,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3b0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ccb, 0x9240,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ce8,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x91fd,    BAD
},

/* Row 0x3b1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x97e8,    BAD, 0xfb6a, 0x8b74,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3b2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfdc8,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9241,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3b3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x96a1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ef3,    BAD,    BAD
},

/* Row 0x3b4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfad6,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3b5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x9cc7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xfad7,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfba1,    BAD
},

/* Row 0x3b6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x8ec5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3b7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0xfba4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3b8 */
{
/* 00 */ 0x91fa, 0xfedb, 0x97ab,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x9147,    BAD, 0xfbb1,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x94d2, 0xfe61,
/* 28 */ 0xface,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x92ed, 0x91f3, 0x93c6,    BAD, 0x935a,    BAD
},

/* Row 0x3b9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x92ef,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfac8,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9847, 0x9366, 0x9855,    BAD,    BAD,    BAD
},

/* Row 0x3ba */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96e6,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x9f43, 0x9faa, 0x94da, 0x92ee,
/* 30 */ 0xfcaf, 0xfbfb,    BAD, 0x8ef9, 0x91f6,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3bb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0x9cb6, 0xfbad, 0x984e, 0x8f44, 0x96fd,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3bc */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9769, 0x95d4, 0x984b, 0xfbaa,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9daf, 0x9dc5,    BAD,
/* 38 */ 0x91f1, 0x8eb1, 0x97a9, 0xfbac, 0xfcb8,    BAD,    BAD,    BAD
},

/* Row 0x3bd */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xfbb0, 0xfcd2, 0x93cb,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8bac, 0xa055,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3be */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x95be,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ee9,    BAD,
/* 20 */    BAD, 0x92f8, 0x97be, 0x916c, 0x94aa,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x9dc6,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3bf */
{
/* 00 */    BAD,    BAD,    BAD, 0x97b5, 0x92b8, 0x91ef,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfea6, 0x9760,
/* 20 */ 0x9358, 0x9576, 0x8fac,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x91ec, 0x97b4
},

/* Row 0x3c0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x974a, 0xfb49,
/* 18 */ 0x9578, 0x93bc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x91d6,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3c1 */
{
/* 00 */    BAD,    BAD,    BAD, 0x9355, 0x9356, 0x9851,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x8ff8, 0xfbc0, 0x93f2,    BAD,    BAD, 0x90d0,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9363,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x91a5,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3c2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xa0ed,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9351,    BAD,    BAD,    BAD
},

/* Row 0x3c3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xfea8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9350,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3c4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xfa4c,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x92f7,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3c5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xfead,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3c6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xfbd5,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3c7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x9e79,    BAD,    BAD, 0xfbd9,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3c8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0a7,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3c9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x935e,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3ca */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x89cb,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9f53,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xfbe1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3cb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfbe2,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3cc */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9074,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xfbe6,    BAD,    BAD,    BAD,
/* 28 */ 0x9bb7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3cd */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9b47,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3ce */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xfc5b,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3cf */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9cfd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3d0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0xfbec,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3d1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x9ba8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3d2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ad5,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xfa73,    BAD,    BAD,    BAD
},

/* Row 0x3d3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0xfd59,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3d4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xfbed,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9ca9,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3d5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x8aa8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3d6 */
{
/* 00 */    BAD,    BAD,    BAD, 0x9bc3,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3d7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9b4e,    BAD,    BAD,    BAD
},

/* Row 0x3d8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x95d0,    BAD,    BAD,    BAD, 0x905f,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3d9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x97ee,    BAD,    BAD
},

/* Row 0x3da */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xfc4e,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3db */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ec6,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xfc50,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3dc */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xfd73,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3dd */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0xfa5e,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xa059,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0xfa75,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3de */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ca2,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9370,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9371,    BAD
},

/* Row 0x3df */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x9377, 0xfeef,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x936d,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3e0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xfc5d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3e1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8afc,    BAD,
/* 18 */ 0xfb41,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3e2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9e6b, 0x94e3, 0x8ee2,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3e3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x9c4d,    BAD,    BAD,    BAD, 0x96a3,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3e4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ac3,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3e5 */
{
/* 00 */    BAD, 0x96aa,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xfc68, 0x8b6d,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3e6 */
{
/* 00 */    BAD,    BAD,    BAD, 0x8ae9,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3e7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfca1,
/* 20 */ 0x936c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3e8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfe70,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3e9 */
{
/* 00 */    BAD, 0xfca8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfce9,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3ea */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x8aea,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3eb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x96ab,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3ec */
{
/* 00 */ 0xfca7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3ed */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8acb,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9b57,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3ee */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x93a5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3ef */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x93a3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3f0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b42,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3f1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9750, 0x8fb3,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3f2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x8b45,    BAD,    BAD,    BAD, 0x8b46,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3f3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x937b,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x93b1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3f4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a47,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3f5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x937c,
/* 08 */ 0x9b65,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3f6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x93af,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3f7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x9ea3,    BAD,    BAD, 0xfaec, 0x8b77,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3f8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfcb1,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfcbb,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3f9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x93a8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3fa */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x97ec,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3fb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0xfdc2,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9167, 0xfccc,    BAD
},

/* Row 0x3fc */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x93b6,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x90e4,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x90e5,    BAD,    BAD,    BAD
},

/* Row 0x3fd */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x9ef2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x3fe */
{
/* 00 */    BAD,    BAD,    BAD, 0x93ca,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8bbc,    BAD,    BAD
},

/* Row 0x3ff */
{
/* 00 */    BAD,    BAD, 0x93cf,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0xfcdb, 0xfcdc,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x400 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xfce6, 0x96e7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfcd8,
/* 38 */ 0xfcd9, 0xfda6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x401 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x95f1,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ce9,
/* 30 */    BAD, 0xfce4, 0x94af, 0xfa77, 0x93cc,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x402 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x905a,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x403 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x93bf, 0xfb51,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x93b9, 0xfed7, 0x93b7,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x404 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x93d9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x93bb, 0x93da,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x405 */
{
/* 00 */ 0x98a3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x90d1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x406 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xfa70,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x407 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfcfc,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8b40, 0xa07b,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x93e2,    BAD
},

/* Row 0x408 */
{
/* 00 */ 0xfcd6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x409 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x93a6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x935f,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x40a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x97f2,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x40b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x8ef8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x40c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x8f47,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x40d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x92b4,    BAD,    BAD,
/* 18 */    BAD, 0x91ed,    BAD,    BAD, 0x96d2,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x40e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfd46, 0x8f4f, 0x9549,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x40f */
{
/* 00 */ 0xfa5c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xfd4b,    BAD,    BAD,    BAD
},

/* Row 0x410 */
{
/* 00 */ 0x96d3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0f5,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x411 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9243,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x97fa,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9dd9,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x412 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x97f4,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x924d,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x413 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x9ed5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9cc9,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9258
},

/* Row 0x414 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ec8,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x415 */
{
/* 00 */    BAD, 0x94b4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x93e1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x93df,    BAD,    BAD,    BAD
},

/* Row 0x416 */
{
/* 00 */    BAD,    BAD, 0xfcf0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x93ec, 0x97f6, 0x96cf,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x417 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0xfd69,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9352,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x418 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xfd6e,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x419 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xfa7c, 0x93fa, 0x907c,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9db7,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x41a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0e9,
/* 08 */ 0xfa4e, 0xfda1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9e74, 0x9fbf, 0x9ecb, 0x9bb9
},

/* Row 0x41b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x97b9,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x41c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ed2, 0x9753,
/* 38 */ 0x96a4, 0x8fbe, 0x94d9, 0x9058, 0xfd79, 0xfd7b,    BAD,    BAD
},

/* Row 0x41d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8efa,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x41e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x9ed9, 0x97d4, 0x90bb, 0xfdbc,
/* 30 */ 0xfdc6, 0x9248,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x41f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9dc1, 0x92b9, 0x92a6, 0x8f4b,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x92b6
},

/* Row 0x420 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ed8,
/* 38 */ 0x945e, 0x985f, 0x94ce, 0x924a, 0xfd70,    BAD,    BAD,    BAD
},

/* Row 0x421 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9467,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x422 */
{
/* 00 */    BAD, 0x8dec,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9448
},

/* Row 0x423 */
{
/* 00 */ 0xfac1, 0x9cf7, 0xfdbe,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfc7e,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x424 */
{
/* 00 */ 0x93f9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xfaeb, 0xfac3, 0x97d3, 0x95f9, 0x9c48,
/* 30 */ 0x8e6a,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x425 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0xa0d8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0xfdd7, 0xfb4a, 0x9baf, 0x944b, 0xfdc9,    BAD,    BAD
},

/* Row 0x426 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8eac,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x427 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x925a, 0xfcbd, 0x92d9,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x428 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x92dd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x429 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x96ba,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfdda
},

/* Row 0x42a */
{
/* 00 */ 0xfdde,    BAD,    BAD,    BAD, 0xfdd3,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfdd6, 0xfddc, 0xfddd,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x90fe,    BAD,    BAD, 0xfea1,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9cd8,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x42b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9e6d, 0xfd7c, 0xfb61,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x42c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0xfe60,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9852,    BAD,    BAD,    BAD
},

/* Row 0x42d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x964f,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x42e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x916e,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x986d,    BAD,
/* 18 */    BAD, 0x9864,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9453, 0xfdec,
/* 38 */ 0xfb78,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x42f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x985a,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x430 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x93d0, 0x9862,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x974f,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x431 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x9452,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x432 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x91d2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x97ea, 0xfb6b, 0x91b1, 0xfdf3,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x433 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x92cb,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9bb1,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xfcec,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x986b,    BAD,    BAD
},

/* Row 0x434 */
{
/* 00 */    BAD, 0x9751,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9871,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x9ef3,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x91e8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x435 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfb4c, 0x926a,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x436 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0xfdf8, 0x9861,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x437 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x93ed,
/* 08 */ 0x9744,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x91e1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x438 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9869,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8a62,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x439 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9c55,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x43a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8e77,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x43b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x93e6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x43c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x93a2,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x43d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x94b3,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x43e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x937d,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x43f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e66,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9459,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x440 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9458,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x441 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0xfe54,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x442 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x94a5,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x95ed
},

/* Row 0x443 */
{
/* 00 */ 0xfd7e, 0xfbeb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xfd7d,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x976f, 0x9461,
/* 18 */    BAD, 0x9fc1,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x95d7,
/* 30 */    BAD,    BAD,    BAD, 0xfa52,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9f68, 0x9be7
},

/* Row 0x444 */
{
/* 00 */ 0xfcce, 0x96e8, 0xfa49,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x954d, 0x9ef8,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xfe49, 0x91ce, 0x9771,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfdb1
},

/* Row 0x445 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9cf2, 0x93b8, 0x9043, 0x9759, 0x94d7, 0xfe66, 0x947d, 0xfc6f,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ef7,
/* 28 */    BAD,    BAD,    BAD, 0x947c, 0x92cd, 0x97b2,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfe65,
/* 38 */ 0x967e, 0x9758, 0x9b77, 0x91cf,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x446 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96d5, 0xfcb3,
/* 20 */    BAD,    BAD,    BAD, 0x93ae,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9c46, 0x955b,
/* 38 */ 0x91d1, 0x94f4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x447 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xfced, 0xfdfa, 0xfcc8, 0xfe62, 0x91fc, 0xfe6b, 0xfdf9,
/* 28 */ 0xfcc7, 0x914e, 0x9cb8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9767,    BAD
},

/* Row 0x448 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x94a2, 0x9875,
/* 10 */ 0x97ac, 0x91d3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8eeb, 0x976a, 0x965e,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ff9,
/* 38 */ 0x95f8, 0xfea2, 0x8fe6,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x449 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x9da4, 0x9768, 0x8eec, 0x94bd,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x945b, 0x9cf6, 0xfaa7, 0x9bd9,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD, 0xfa5d, 0x9656, 0x9762,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x94ba, 0xa04f, 0x92d8,    BAD,    BAD,    BAD
},

/* Row 0x44a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x94bb,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x90cf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9465,
/* 20 */    BAD,    BAD, 0x9f4c,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x44b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ebe,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x44c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfb6d,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x44d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x95ca,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x44e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9dc2, 0x97f8,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x44f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9473,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x450 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9474,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x451 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8a4b,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x452 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x8a55, 0x8b69,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x453 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x8b76,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x454 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0f8,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x455 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x98df,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x456 */
{
/* 00 */    BAD,    BAD, 0xfeb5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96fb,
/* 18 */    BAD,    BAD, 0x9bfb,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9ece,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x457 */
{
/* 00 */    BAD,    BAD, 0x9e7b,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x458 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfece,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x459 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9dfc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfecf, 0x8ba5,    BAD
},

/* Row 0x45a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x8aec,    BAD,    BAD, 0xfce0, 0x94ad,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x45b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xfed5, 0x94ac,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x45c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a6f,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x8ba9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x45d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9dcb,    BAD, 0xfce7,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x45e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x93c8,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x91f0,
/* 30 */ 0x8fe0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x45f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x90ed,    BAD, 0x9bdc,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x460 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x93c7, 0x9249, 0x96e1,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fe1, 0x9be5,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x461 */
{
/* 00 */    BAD, 0x94c0,    BAD,    BAD, 0x93c3,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x93c5,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x9079,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x462 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x977b,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x907e,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xfee6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x463 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9db8,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x464 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x9270,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x465 */
{
/* 00 */    BAD,    BAD,    BAD, 0x95a8,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x466 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x98b9,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x467 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9140,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfcbe,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9157,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x468 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xfadf,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x469 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9be6,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x8e44, 0x9c4f,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x46a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfef4,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x93dc,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x46b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x8e4a,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x46c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9db9,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x46d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x8e4e,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x46e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x94e5,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9bf0,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x46f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9551,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x470 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x8bbb,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x471 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x94f0, 0x8e64,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x472 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x94ea,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x473 */
{
/* 00 */    BAD, 0x8e5b,    BAD,    BAD,    BAD,    BAD, 0x9bf2,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x474 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x9dc9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8e6c,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x475 */
{
/* 00 */ 0x8f75, 0x8e71,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8e60,    BAD
},

/* Row 0x476 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xfdd8,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x477 */
{
/* 00 */    BAD,    BAD,    BAD, 0x9552,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x478 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9554,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x479 */
{
/* 00 */    BAD, 0x9dbb, 0x9543, 0x92fe,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x94f2,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x94f1,    BAD,    BAD,    BAD
},

/* Row 0x47a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0ea,
/* 18 */ 0x9dd2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x47b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x91f8,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x47c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9462, 0x9ba4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x47d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x8ead,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x47e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x96d0,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x47f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9757, 0x8a77,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x480 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x8eb5,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x481 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xa06d, 0x8eb6, 0x9756, 0x9540,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x482 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0f3, 0x94be,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x483 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfddf,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x484 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x9dbc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x94fe,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x485 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x8ec0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x486 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x8ec3,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x487 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9649,    BAD
},

/* Row 0x488 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x90cc, 0x9c60, 0x954b,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x489 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x8ecc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x8ee4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x48a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x9c49,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x48b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8b5e,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x48c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x955c,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x48d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ed9,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x48e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9db4,
/* 30 */    BAD, 0x925f,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x48f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x8edb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x490 */
{
/* 00 */    BAD, 0x9754,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x491 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x9ed4, 0x9568,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x492 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xa0c3,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x493 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9c61,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9c5f,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x494 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0xfc4d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x9e69,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x495 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfec7,    BAD,
/* 10 */    BAD, 0xfec6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x496 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x9165,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ce7,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x497 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x8a54,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x9c6c,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x498 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfe5d,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x499 */
{
/* 00 */    BAD,    BAD, 0x956a,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD, 0x956d, 0x8ef0,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x49a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD, 0x8ef6,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0xfbda,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x49b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x8b4c, 0xfd75, 0x9bdd, 0xfaf5,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x49c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8f6a, 0x8f4e,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0xfa55,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x49d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9c41,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x49e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x925c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x49f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfb66, 0x8e65
},

/* Row 0x4a0 */
{
/* 00 */ 0x9849, 0xfba8, 0x9842,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x97fb,
/* 38 */ 0x90ca,    BAD,    BAD,    BAD,    BAD, 0x9c5b,    BAD,    BAD
},

/* Row 0x4a1 */
{
/* 00 */ 0x974d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4a2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x9f4b, 0x9fb5, 0x93d2, 0xfdaa, 0x9840, 0x9146,
/* 28 */ 0x9867, 0xfa5a, 0xfba9,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4a3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0xfcfd, 0xfdab, 0x91bd, 0x8f4c, 0x96c9, 0x8f55, 0xfbae, 0x956f,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4a4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xa0f0,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x946f, 0xfdac,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x96cb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4a5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa056,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4a6 */
{
/* 00 */    BAD,    BAD, 0x8f5e, 0x8f6c, 0x8ea3, 0xfbb3,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfc53,    BAD,
/* 30 */    BAD,    BAD, 0xfdb3,    BAD,    BAD,    BAD,    BAD, 0x8f6b,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4a7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x96ca,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4a8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0x9e6f, 0xa0c5, 0xfc78, 0x8e42, 0x8f5a, 0x90c2, 0x8ea5, 0x9061,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4a9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x924f,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4aa */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x9373, 0xfdb5,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4ab */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfecc,
/* 20 */    BAD, 0xfbbd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4ac */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9843, 0x96c5,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4ad */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x89bc,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4ae */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x924b, 0x984a,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4af */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0f1, 0x9efb, 0x9cd2,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4b0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fa7,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0xfc5c,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4b1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9845,    BAD,    BAD, 0x9046,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfefa, 0x9560,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4b2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9f48, 0x9247,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x90fb,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4b3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD, 0x9571,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4b4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9cac,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4b5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x8fae,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4b6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x957d,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4b7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x97b6,    BAD, 0xa0bd,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4b8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x8fbd,    BAD,    BAD,    BAD, 0x8fbf,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9369, 0x9ba7,    BAD
},

/* Row 0x4b9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0xfeea,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0x9be1,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x8b41,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4ba */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9db6, 0xa0eb, 0x9ba3,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4bb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8ba1,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4bc */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fc8,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x894c, 0x9860,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4bd */
{
/* 00 */    BAD, 0x94c7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b58,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4be */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x95ab, 0x95aa,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4bf */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x93d6,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4c0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x8fd1,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4c1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x99d5,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4c2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfbc8,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4c3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x8fd7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4c4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fd2, 0x9064,    BAD
},

/* Row 0x4c5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x98b6,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4c6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x98bd,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8fdc, 0xfef6, 0x8fd9,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4c7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x97f3,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4c8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x9bf8,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4c9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9e6c,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4ca */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD, 0x8ff2, 0x8fee,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x9e6e,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4cb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fef,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x8ff4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ff5,    BAD,    BAD
},

/* Row 0x4cc */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x95c2,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4cd */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x986a,    BAD, 0x97cf,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4ce */
{
/* 00 */    BAD,    BAD, 0x9041,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9cdb,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4cf */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b62, 0x8a4e,    BAD
},

/* Row 0x4d0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x8a66,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x9cfb,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4d1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9cfc,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4d2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ce5,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4d3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8b73,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4d4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x8a61,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4d5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ba2,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD, 0x9df2,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4d6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD, 0x8eca,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4d7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x904e,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ff5,    BAD,    BAD
},

/* Row 0x4d8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x904f,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4d9 */
{
/* 00 */    BAD,    BAD, 0xfbfe,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4da */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9063, 0x9057,    BAD,    BAD
},

/* Row 0x4db */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x9066,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4dc */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0xfce5,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4dd */
{
/* 00 */ 0x9162,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x9067,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fa1,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD, 0x8fa2,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4de */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9d48, 0xfad3,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4df */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */ 0x90b9,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x906b,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4e0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0xfe57,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xfe55,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4e1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x9073,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4e2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x9bef, 0x9cf0,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x91e0,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x91d8,    BAD
},

/* Row 0x4e3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD, 0x9646,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x9360,    BAD, 0xfa53, 0x9cd3,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0xfb40,    BAD,    BAD,    BAD
},

/* Row 0x4e4 */
{
/* 00 */ 0x8de2,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0x9442,    BAD, 0x9056,    BAD,
/* 20 */    BAD, 0x9865,    BAD,    BAD, 0xfa4a,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x95af, 0x975a, 0x9349, 0x9747,    BAD,    BAD,    BAD
},

/* Row 0x4e5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xa0f4,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9778,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8fcf,    BAD,    BAD,
/* 28 */    BAD, 0xfc60,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4e6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD, 0x91dc, 0x9661, 0x92ec, 0x935d,
/* 08 */ 0x8ede, 0x96fe, 0xfd4f, 0x95de,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x98b0, 0xa040,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4e7 */
{
/* 00 */    BAD, 0x97bd, 0x977d, 0x97f5,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD, 0x9bac, 0xfada, 0x92c2,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4e8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x907b,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x93fe, 0x947b,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfabe, 0xfd43,
/* 20 */ 0x90c6, 0x90a4, 0x90a8, 0x94a9,    BAD, 0x90a9,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4e9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x907d,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0xfdba, 0x93c4,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0xfeed, 0x9dab, 0xa0e3,    BAD, 0x9648,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4ea */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD, 0x8aa9,    BAD, 0x9bc5,    BAD,
/* 10 */ 0x965d,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x975f, 0x965f, 0x966e, 0xfb5d,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x9db1,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4eb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0xfea3,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x9db2,    BAD,    BAD, 0x95ae, 0xfca3,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4ec */
{
/* 00 */    BAD,    BAD, 0xa0a2,    BAD,    BAD, 0x9655,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9341,
/* 18 */    BAD, 0x95ad, 0x91d5,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x977a,
/* 28 */ 0xfdfc, 0x8e47, 0x93fd, 0x90a5, 0x90ac,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x90ae
},

/* Row 0x4ed */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x95e2,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9466,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x91b8,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x9cec,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD, 0x90ad,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4ee */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x8ae3,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4ef */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD, 0x95ea,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4f0 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x91d9,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4f1 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x95f5, 0x95f4,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4f2 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xfe72, 0x927a,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4f3 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0xfeac,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4f4 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD, 0x91c5,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x90cd,
/* 30 */ 0x95fe, 0x9159,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4f5 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x97cc, 0x90ce,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4f6 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfefd,    BAD,    BAD,
/* 10 */ 0x9d5b,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4f7 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD, 0xfd60,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x9ccf,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4f8 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD, 0x90e0,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4f9 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x90f3,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x90f0,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4fa */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */ 0x95b7,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4fb */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD, 0x8e4b, 0x9658,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4fc */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9ecf,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4fd */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9d64,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4fe */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9150,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x4ff */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD, 0x9cc1,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x500 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x93a7,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x501 */
{
/* 00 */    BAD,    BAD,    BAD, 0xa0ef,    BAD, 0x9151,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96c1,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x502 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0xfca4,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD, 0x9d6a,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x503 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x924e,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x504 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x915d,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9d6d,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x505 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x915a,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x506 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9cc0,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x507 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x916a,    BAD
},

/* Row 0x508 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD, 0x9ea6,    BAD,    BAD,    BAD
},

/* Row 0x509 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x96b4,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x50a */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */ 0x9172,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x50b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD, 0x9ec8,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x50c */
{
/* 00 */    BAD,    BAD,    BAD, 0x8b55,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x50d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9d72,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */ 0x9ecc,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x50e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9174,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x50f */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD, 0x9177,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x96c0,    BAD,    BAD,    BAD,    BAD,
/* 38 */ 0x8fb1,    BAD,    BAD,    BAD,    BAD,    BAD, 0x96b7,    BAD
},

/* Row 0x510 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD, 0x9178,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x511 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */ 0xfb77,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x512 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD, 0x9175, 0x91a3,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x513 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9179,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x514 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */ 0x91a4,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD, 0x91a6,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x515 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9052,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD, 0xa045,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x516 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9cdd,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x517 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x8940,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x518 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD, 0x9478,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x519 */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD, 0x9e75,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x51a */
{
/* 00 */ 0xa047,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x51b */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0xfc48,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x51c */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD, 0x9c52,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x51d */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8efd,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
},

/* Row 0x51e */
{
/* 00 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 08 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 10 */    BAD,    BAD,    BAD,    BAD, 0x8ff0,    BAD,    BAD,    BAD,
/* 18 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 20 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 28 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 30 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,
/* 38 */    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD,    BAD
}
};

#else /* USE_OUR_MB_WC_DATA_TABLES */
/*
 * Data tables for use by the character conversion routines.
 *
 * NOTE: These tables should not be manually edited.
 * These tables were generated by the cs_cnv_test
 * program that can be run in the NT regression test
 * environment.  The program is given an input file (via
 * stdin) which is one of the *_input_files under the
 * w:/common directory.  The program writes its output to stdout.
 * The tables below come directly from the program's output.
 * See the w:/sqlutils/cs_cnv_test directory for the source for the
 * cs_cnv_test program.
 */
static const unsigned short Our_MS_BIG5_tableF[] = {
0x3000,0xff0c,0x3001,0x3002,0xff0e,0x2027,0xff1b,0xff1a,
0xff1f,0xff01,0xfe30,0x2026,0x2025,0xfe50,0xfe51,0xfe52,
0x00b7,0xfe54,0xfe55,0xfe56,0xfe57,0xff5c,0x2013,0xfe31,
0x2014,0xfe33,0x2574,0xfe34,0xfe4f,0xff08,0xff09,0xfe35,
0xfe36,0xff5b,0xff5d,0xfe37,0xfe38,0x3014,0x3015,0xfe39,
0xfe3a,0x3010,0x3011,0xfe3b,0xfe3c,0x300a,0x300b,0xfe3d,
0xfe3e,0x3008,0x3009,0xfe3f,0xfe40,0x300c,0x300d,0xfe41,
0xfe42,0x300e,0x300f,0xfe43,0xfe44,0xfe59,0xfe5a,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xfe5b,0xfe5c,0xfe5d,0xfe5e,0x2018,0x2019,0x201c,
0x201d,0x301d,0x301e,0x2035,0x2032,0xff03,0xff06,0xff0a,
0x203b,0x00a7,0x3003,0x25cb,0x25cf,0x25b3,0x25b2,0x25ce,
0x2606,0x2605,0x25c7,0x25c6,0x25a1,0x25a0,0x25bd,0x25bc,
0x32a3,0x2105,0x00af,0xffe3,0xff3f,0x02cd,0xfe49,0xfe4a,
0xfe4d,0xfe4e,0xfe4b,0xfe4c,0xfe5f,0xfe60,0xfe61,0xff0b,
0xff0d,0x00d7,0x00f7,0x00b1,0x221a,0xff1c,0xff1e,0xff1d,
0x2266,0x2267,0x2260,0x221e,0x2252,0x2261,0xfe62,0xfe63,
0xfe64,0xfe65,0xfe66,0xff5e,0x2229,0x222a,0x22a5,0x2220,
0x221f,0x22bf,0x33d2,0x33d1,0x222b,0x222e,0x2235,0x2234,
0x2640,0x2642,0x2295,0x2299,0x2191,0x2193,0x2190,0x2192,
0x2196,0x2197,0x2199,0x2198,0x2225,0x2223,0xff0f,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xff3c,0x2215,0xfe68,0xff04,0xffe5,0x3012,0xffe0,0xffe1,
0xff05,0xff20,0x2103,0x2109,0xfe69,0xfe6a,0xfe6b,0x33d5,
0x339c,0x339d,0x339e,0x33ce,0x33a1,0x338e,0x338f,0x33c4,
0x00b0,0x5159,0x515b,0x515e,0x515d,0x5161,0x5163,0x55e7,
0x74e9,0x7cce,0x2581,0x2582,0x2583,0x2584,0x2585,0x2586,
0x2587,0x2588,0x258f,0x258e,0x258d,0x258c,0x258b,0x258a,
0x2589,0x253c,0x2534,0x252c,0x2524,0x251c,0x2594,0x2500,
0x2502,0x2595,0x250c,0x2510,0x2514,0x2518,0x256d,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x256e,0x2570,0x256f,0x2550,0x255e,0x256a,0x2561,
0x25e2,0x25e3,0x25e5,0x25e4,0x2571,0x2572,0x2573,0xff10,
0xff11,0xff12,0xff13,0xff14,0xff15,0xff16,0xff17,0xff18,
0xff19,0x2160,0x2161,0x2162,0x2163,0x2164,0x2165,0x2166,
0x2167,0x2168,0x2169,0x3021,0x3022,0x3023,0x3024,0x3025,
0x3026,0x3027,0x3028,0x3029,0x5341,0x5344,0x5345,0xff21,
0xff22,0xff23,0xff24,0xff25,0xff26,0xff27,0xff28,0xff29,
0xff2a,0xff2b,0xff2c,0xff2d,0xff2e,0xff2f,0xff30,0xff31,
0xff32,0xff33,0xff34,0xff35,0xff36,0xff37,0xff38,0xff39,
0xff3a,0xff41,0xff42,0xff43,0xff44,0xff45,0xff46,0xff47,
0xff48,0xff49,0xff4a,0xff4b,0xff4c,0xff4d,0xff4e,0xff4f,
0xff50,0xff51,0xff52,0xff53,0xff54,0xff55,0xff56,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xff57,0xff58,0xff59,0xff5a,0x0391,0x0392,0x0393,0x0394,
0x0395,0x0396,0x0397,0x0398,0x0399,0x039a,0x039b,0x039c,
0x039d,0x039e,0x039f,0x03a0,0x03a1,0x03a3,0x03a4,0x03a5,
0x03a6,0x03a7,0x03a8,0x03a9,0x03b1,0x03b2,0x03b3,0x03b4,
0x03b5,0x03b6,0x03b7,0x03b8,0x03b9,0x03ba,0x03bb,0x03bc,
0x03bd,0x03be,0x03bf,0x03c0,0x03c1,0x03c3,0x03c4,0x03c5,
0x03c6,0x03c7,0x03c8,0x03c9,0x3105,0x3106,0x3107,0x3108,
0x3109,0x310a,0x310b,0x310c,0x310d,0x310e,0x310f,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x3110,0x3111,0x3112,0x3113,0x3114,0x3115,0x3116,
0x3117,0x3118,0x3119,0x311a,0x311b,0x311c,0x311d,0x311e,
0x311f,0x3120,0x3121,0x3122,0x3123,0x3124,0x3125,0x3126,
0x3127,0x3128,0x3129,0x02d9,0x02c9,0x02ca,0x02c7,0x02cb,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x20ac,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x4e00,0x4e59,0x4e01,0x4e03,0x4e43,0x4e5d,0x4e86,0x4e8c,
0x4eba,0x513f,0x5165,0x516b,0x51e0,0x5200,0x5201,0x529b,
0x5315,0x5341,0x535c,0x53c8,0x4e09,0x4e0b,0x4e08,0x4e0a,
0x4e2b,0x4e38,0x51e1,0x4e45,0x4e48,0x4e5f,0x4e5e,0x4e8e,
0x4ea1,0x5140,0x5203,0x52fa,0x5343,0x53c9,0x53e3,0x571f,
0x58eb,0x5915,0x5927,0x5973,0x5b50,0x5b51,0x5b53,0x5bf8,
0x5c0f,0x5c22,0x5c38,0x5c71,0x5ddd,0x5de5,0x5df1,0x5df2,
0x5df3,0x5dfe,0x5e72,0x5efe,0x5f0b,0x5f13,0x624d,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x4e11,0x4e10,0x4e0d,0x4e2d,0x4e30,0x4e39,0x4e4b,
0x5c39,0x4e88,0x4e91,0x4e95,0x4e92,0x4e94,0x4ea2,0x4ec1,
0x4ec0,0x4ec3,0x4ec6,0x4ec7,0x4ecd,0x4eca,0x4ecb,0x4ec4,
0x5143,0x5141,0x5167,0x516d,0x516e,0x516c,0x5197,0x51f6,
0x5206,0x5207,0x5208,0x52fb,0x52fe,0x52ff,0x5316,0x5339,
0x5348,0x5347,0x5345,0x535e,0x5384,0x53cb,0x53ca,0x53cd,
0x58ec,0x5929,0x592b,0x592a,0x592d,0x5b54,0x5c11,0x5c24,
0x5c3a,0x5c6f,0x5df4,0x5e7b,0x5eff,0x5f14,0x5f15,0x5fc3,
0x6208,0x6236,0x624b,0x624e,0x652f,0x6587,0x6597,0x65a4,
0x65b9,0x65e5,0x66f0,0x6708,0x6728,0x6b20,0x6b62,0x6b79,
0x6bcb,0x6bd4,0x6bdb,0x6c0f,0x6c34,0x706b,0x722a,0x7236,
0x723b,0x7247,0x7259,0x725b,0x72ac,0x738b,0x4e19,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x4e16,0x4e15,0x4e14,0x4e18,0x4e3b,0x4e4d,0x4e4f,0x4e4e,
0x4ee5,0x4ed8,0x4ed4,0x4ed5,0x4ed6,0x4ed7,0x4ee3,0x4ee4,
0x4ed9,0x4ede,0x5145,0x5144,0x5189,0x518a,0x51ac,0x51f9,
0x51fa,0x51f8,0x520a,0x52a0,0x529f,0x5305,0x5306,0x5317,
0x531d,0x4edf,0x534a,0x5349,0x5361,0x5360,0x536f,0x536e,
0x53bb,0x53ef,0x53e4,0x53f3,0x53ec,0x53ee,0x53e9,0x53e8,
0x53fc,0x53f8,0x53f5,0x53eb,0x53e6,0x53ea,0x53f2,0x53f1,
0x53f0,0x53e5,0x53ed,0x53fb,0x56db,0x56da,0x5916,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x592e,0x5931,0x5974,0x5976,0x5b55,0x5b83,0x5c3c,
0x5de8,0x5de7,0x5de6,0x5e02,0x5e03,0x5e73,0x5e7c,0x5f01,
0x5f18,0x5f17,0x5fc5,0x620a,0x6253,0x6254,0x6252,0x6251,
0x65a5,0x65e6,0x672e,0x672c,0x672a,0x672b,0x672d,0x6b63,
0x6bcd,0x6c11,0x6c10,0x6c38,0x6c41,0x6c40,0x6c3e,0x72af,
0x7384,0x7389,0x74dc,0x74e6,0x7518,0x751f,0x7528,0x7529,
0x7530,0x7531,0x7532,0x7533,0x758b,0x767d,0x76ae,0x76bf,
0x76ee,0x77db,0x77e2,0x77f3,0x793a,0x79be,0x7a74,0x7acb,
0x4e1e,0x4e1f,0x4e52,0x4e53,0x4e69,0x4e99,0x4ea4,0x4ea6,
0x4ea5,0x4eff,0x4f09,0x4f19,0x4f0a,0x4f15,0x4f0d,0x4f10,
0x4f11,0x4f0f,0x4ef2,0x4ef6,0x4efb,0x4ef0,0x4ef3,0x4efd,
0x4f01,0x4f0b,0x5149,0x5147,0x5146,0x5148,0x5168,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5171,0x518d,0x51b0,0x5217,0x5211,0x5212,0x520e,0x5216,
0x52a3,0x5308,0x5321,0x5320,0x5370,0x5371,0x5409,0x540f,
0x540c,0x540a,0x5410,0x5401,0x540b,0x5404,0x5411,0x540d,
0x5408,0x5403,0x540e,0x5406,0x5412,0x56e0,0x56de,0x56dd,
0x5733,0x5730,0x5728,0x572d,0x572c,0x572f,0x5729,0x5919,
0x591a,0x5937,0x5938,0x5984,0x5978,0x5983,0x597d,0x5979,
0x5982,0x5981,0x5b57,0x5b58,0x5b87,0x5b88,0x5b85,0x5b89,
0x5bfa,0x5c16,0x5c79,0x5dde,0x5e06,0x5e76,0x5e74,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x5f0f,0x5f1b,0x5fd9,0x5fd6,0x620e,0x620c,0x620d,
0x6210,0x6263,0x625b,0x6258,0x6536,0x65e9,0x65e8,0x65ec,
0x65ed,0x66f2,0x66f3,0x6709,0x673d,0x6734,0x6731,0x6735,
0x6b21,0x6b64,0x6b7b,0x6c16,0x6c5d,0x6c57,0x6c59,0x6c5f,
0x6c60,0x6c50,0x6c55,0x6c61,0x6c5b,0x6c4d,0x6c4e,0x7070,
0x725f,0x725d,0x767e,0x7af9,0x7c73,0x7cf8,0x7f36,0x7f8a,
0x7fbd,0x8001,0x8003,0x800c,0x8012,0x8033,0x807f,0x8089,
0x808b,0x808c,0x81e3,0x81ea,0x81f3,0x81fc,0x820c,0x821b,
0x821f,0x826e,0x8272,0x827e,0x866b,0x8840,0x884c,0x8863,
0x897f,0x9621,0x4e32,0x4ea8,0x4f4d,0x4f4f,0x4f47,0x4f57,
0x4f5e,0x4f34,0x4f5b,0x4f55,0x4f30,0x4f50,0x4f51,0x4f3d,
0x4f3a,0x4f38,0x4f43,0x4f54,0x4f3c,0x4f46,0x4f63,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x4f5c,0x4f60,0x4f2f,0x4f4e,0x4f36,0x4f59,0x4f5d,0x4f48,
0x4f5a,0x514c,0x514b,0x514d,0x5175,0x51b6,0x51b7,0x5225,
0x5224,0x5229,0x522a,0x5228,0x52ab,0x52a9,0x52aa,0x52ac,
0x5323,0x5373,0x5375,0x541d,0x542d,0x541e,0x543e,0x5426,
0x544e,0x5427,0x5446,0x5443,0x5433,0x5448,0x5442,0x541b,
0x5429,0x544a,0x5439,0x543b,0x5438,0x542e,0x5435,0x5436,
0x5420,0x543c,0x5440,0x5431,0x542b,0x541f,0x542c,0x56ea,
0x56f0,0x56e4,0x56eb,0x574a,0x5751,0x5740,0x574d,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x5747,0x574e,0x573e,0x5750,0x574f,0x573b,0x58ef,
0x593e,0x599d,0x5992,0x59a8,0x599e,0x59a3,0x5999,0x5996,
0x598d,0x59a4,0x5993,0x598a,0x59a5,0x5b5d,0x5b5c,0x5b5a,
0x5b5b,0x5b8c,0x5b8b,0x5b8f,0x5c2c,0x5c40,0x5c41,0x5c3f,
0x5c3e,0x5c90,0x5c91,0x5c94,0x5c8c,0x5deb,0x5e0c,0x5e8f,
0x5e87,0x5e8a,0x5ef7,0x5f04,0x5f1f,0x5f64,0x5f62,0x5f77,
0x5f79,0x5fd8,0x5fcc,0x5fd7,0x5fcd,0x5ff1,0x5feb,0x5ff8,
0x5fea,0x6212,0x6211,0x6284,0x6297,0x6296,0x6280,0x6276,
0x6289,0x626d,0x628a,0x627c,0x627e,0x6279,0x6273,0x6292,
0x626f,0x6298,0x626e,0x6295,0x6293,0x6291,0x6286,0x6539,
0x653b,0x6538,0x65f1,0x66f4,0x675f,0x674e,0x674f,0x6750,
0x6751,0x675c,0x6756,0x675e,0x6749,0x6746,0x6760,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6753,0x6757,0x6b65,0x6bcf,0x6c42,0x6c5e,0x6c99,0x6c81,
0x6c88,0x6c89,0x6c85,0x6c9b,0x6c6a,0x6c7a,0x6c90,0x6c70,
0x6c8c,0x6c68,0x6c96,0x6c92,0x6c7d,0x6c83,0x6c72,0x6c7e,
0x6c74,0x6c86,0x6c76,0x6c8d,0x6c94,0x6c98,0x6c82,0x7076,
0x707c,0x707d,0x7078,0x7262,0x7261,0x7260,0x72c4,0x72c2,
0x7396,0x752c,0x752b,0x7537,0x7538,0x7682,0x76ef,0x77e3,
0x79c1,0x79c0,0x79bf,0x7a76,0x7cfb,0x7f55,0x8096,0x8093,
0x809d,0x8098,0x809b,0x809a,0x80b2,0x826f,0x8292,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x828b,0x828d,0x898b,0x89d2,0x8a00,0x8c37,0x8c46,
0x8c55,0x8c9d,0x8d64,0x8d70,0x8db3,0x8eab,0x8eca,0x8f9b,
0x8fb0,0x8fc2,0x8fc6,0x8fc5,0x8fc4,0x5de1,0x9091,0x90a2,
0x90aa,0x90a6,0x90a3,0x9149,0x91c6,0x91cc,0x9632,0x962e,
0x9631,0x962a,0x962c,0x4e26,0x4e56,0x4e73,0x4e8b,0x4e9b,
0x4e9e,0x4eab,0x4eac,0x4f6f,0x4f9d,0x4f8d,0x4f73,0x4f7f,
0x4f6c,0x4f9b,0x4f8b,0x4f86,0x4f83,0x4f70,0x4f75,0x4f88,
0x4f69,0x4f7b,0x4f96,0x4f7e,0x4f8f,0x4f91,0x4f7a,0x5154,
0x5152,0x5155,0x5169,0x5177,0x5176,0x5178,0x51bd,0x51fd,
0x523b,0x5238,0x5237,0x523a,0x5230,0x522e,0x5236,0x5241,
0x52be,0x52bb,0x5352,0x5354,0x5353,0x5351,0x5366,0x5377,
0x5378,0x5379,0x53d6,0x53d4,0x53d7,0x5473,0x5475,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5496,0x5478,0x5495,0x5480,0x547b,0x5477,0x5484,0x5492,
0x5486,0x547c,0x5490,0x5471,0x5476,0x548c,0x549a,0x5462,
0x5468,0x548b,0x547d,0x548e,0x56fa,0x5783,0x5777,0x576a,
0x5769,0x5761,0x5766,0x5764,0x577c,0x591c,0x5949,0x5947,
0x5948,0x5944,0x5954,0x59be,0x59bb,0x59d4,0x59b9,0x59ae,
0x59d1,0x59c6,0x59d0,0x59cd,0x59cb,0x59d3,0x59ca,0x59af,
0x59b3,0x59d2,0x59c5,0x5b5f,0x5b64,0x5b63,0x5b97,0x5b9a,
0x5b98,0x5b9c,0x5b99,0x5b9b,0x5c1a,0x5c48,0x5c45,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x5c46,0x5cb7,0x5ca1,0x5cb8,0x5ca9,0x5cab,0x5cb1,
0x5cb3,0x5e18,0x5e1a,0x5e16,0x5e15,0x5e1b,0x5e11,0x5e78,
0x5e9a,0x5e97,0x5e9c,0x5e95,0x5e96,0x5ef6,0x5f26,0x5f27,
0x5f29,0x5f80,0x5f81,0x5f7f,0x5f7c,0x5fdd,0x5fe0,0x5ffd,
0x5ff5,0x5fff,0x600f,0x6014,0x602f,0x6035,0x6016,0x602a,
0x6015,0x6021,0x6027,0x6029,0x602b,0x601b,0x6216,0x6215,
0x623f,0x623e,0x6240,0x627f,0x62c9,0x62cc,0x62c4,0x62bf,
0x62c2,0x62b9,0x62d2,0x62db,0x62ab,0x62d3,0x62d4,0x62cb,
0x62c8,0x62a8,0x62bd,0x62bc,0x62d0,0x62d9,0x62c7,0x62cd,
0x62b5,0x62da,0x62b1,0x62d8,0x62d6,0x62d7,0x62c6,0x62ac,
0x62ce,0x653e,0x65a7,0x65bc,0x65fa,0x6614,0x6613,0x660c,
0x6606,0x6602,0x660e,0x6600,0x660f,0x6615,0x660a,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6607,0x670d,0x670b,0x676d,0x678b,0x6795,0x6771,0x679c,
0x6773,0x6777,0x6787,0x679d,0x6797,0x676f,0x6770,0x677f,
0x6789,0x677e,0x6790,0x6775,0x679a,0x6793,0x677c,0x676a,
0x6772,0x6b23,0x6b66,0x6b67,0x6b7f,0x6c13,0x6c1b,0x6ce3,
0x6ce8,0x6cf3,0x6cb1,0x6ccc,0x6ce5,0x6cb3,0x6cbd,0x6cbe,
0x6cbc,0x6ce2,0x6cab,0x6cd5,0x6cd3,0x6cb8,0x6cc4,0x6cb9,
0x6cc1,0x6cae,0x6cd7,0x6cc5,0x6cf1,0x6cbf,0x6cbb,0x6ce1,
0x6cdb,0x6cca,0x6cac,0x6cef,0x6cdc,0x6cd6,0x6ce0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x7095,0x708e,0x7092,0x708a,0x7099,0x722c,0x722d,
0x7238,0x7248,0x7267,0x7269,0x72c0,0x72ce,0x72d9,0x72d7,
0x72d0,0x73a9,0x73a8,0x739f,0x73ab,0x73a5,0x753d,0x759d,
0x7599,0x759a,0x7684,0x76c2,0x76f2,0x76f4,0x77e5,0x77fd,
0x793e,0x7940,0x7941,0x79c9,0x79c8,0x7a7a,0x7a79,0x7afa,
0x7cfe,0x7f54,0x7f8c,0x7f8b,0x8005,0x80ba,0x80a5,0x80a2,
0x80b1,0x80a1,0x80ab,0x80a9,0x80b4,0x80aa,0x80af,0x81e5,
0x81fe,0x820d,0x82b3,0x829d,0x8299,0x82ad,0x82bd,0x829f,
0x82b9,0x82b1,0x82ac,0x82a5,0x82af,0x82b8,0x82a3,0x82b0,
0x82be,0x82b7,0x864e,0x8671,0x521d,0x8868,0x8ecb,0x8fce,
0x8fd4,0x8fd1,0x90b5,0x90b8,0x90b1,0x90b6,0x91c7,0x91d1,
0x9577,0x9580,0x961c,0x9640,0x963f,0x963b,0x9644,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9642,0x96b9,0x96e8,0x9752,0x975e,0x4e9f,0x4ead,0x4eae,
0x4fe1,0x4fb5,0x4faf,0x4fbf,0x4fe0,0x4fd1,0x4fcf,0x4fdd,
0x4fc3,0x4fb6,0x4fd8,0x4fdf,0x4fca,0x4fd7,0x4fae,0x4fd0,
0x4fc4,0x4fc2,0x4fda,0x4fce,0x4fde,0x4fb7,0x5157,0x5192,
0x5191,0x51a0,0x524e,0x5243,0x524a,0x524d,0x524c,0x524b,
0x5247,0x52c7,0x52c9,0x52c3,0x52c1,0x530d,0x5357,0x537b,
0x539a,0x53db,0x54ac,0x54c0,0x54a8,0x54ce,0x54c9,0x54b8,
0x54a6,0x54b3,0x54c7,0x54c2,0x54bd,0x54aa,0x54c1,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x54c4,0x54c8,0x54af,0x54ab,0x54b1,0x54bb,0x54a9,
0x54a7,0x54bf,0x56ff,0x5782,0x578b,0x57a0,0x57a3,0x57a2,
0x57ce,0x57ae,0x5793,0x5955,0x5951,0x594f,0x594e,0x5950,
0x59dc,0x59d8,0x59ff,0x59e3,0x59e8,0x5a03,0x59e5,0x59ea,
0x59da,0x59e6,0x5a01,0x59fb,0x5b69,0x5ba3,0x5ba6,0x5ba4,
0x5ba2,0x5ba5,0x5c01,0x5c4e,0x5c4f,0x5c4d,0x5c4b,0x5cd9,
0x5cd2,0x5df7,0x5e1d,0x5e25,0x5e1f,0x5e7d,0x5ea0,0x5ea6,
0x5efa,0x5f08,0x5f2d,0x5f65,0x5f88,0x5f85,0x5f8a,0x5f8b,
0x5f87,0x5f8c,0x5f89,0x6012,0x601d,0x6020,0x6025,0x600e,
0x6028,0x604d,0x6070,0x6068,0x6062,0x6046,0x6043,0x606c,
0x606b,0x606a,0x6064,0x6241,0x62dc,0x6316,0x6309,0x62fc,
0x62ed,0x6301,0x62ee,0x62fd,0x6307,0x62f1,0x62f7,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x62ef,0x62ec,0x62fe,0x62f4,0x6311,0x6302,0x653f,0x6545,
0x65ab,0x65bd,0x65e2,0x6625,0x662d,0x6620,0x6627,0x662f,
0x661f,0x6628,0x6631,0x6624,0x66f7,0x67ff,0x67d3,0x67f1,
0x67d4,0x67d0,0x67ec,0x67b6,0x67af,0x67f5,0x67e9,0x67ef,
0x67c4,0x67d1,0x67b4,0x67da,0x67e5,0x67b8,0x67cf,0x67de,
0x67f3,0x67b0,0x67d9,0x67e2,0x67dd,0x67d2,0x6b6a,0x6b83,
0x6b86,0x6bb5,0x6bd2,0x6bd7,0x6c1f,0x6cc9,0x6d0b,0x6d32,
0x6d2a,0x6d41,0x6d25,0x6d0c,0x6d31,0x6d1e,0x6d17,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x6d3b,0x6d3d,0x6d3e,0x6d36,0x6d1b,0x6cf5,0x6d39,
0x6d27,0x6d38,0x6d29,0x6d2e,0x6d35,0x6d0e,0x6d2b,0x70ab,
0x70ba,0x70b3,0x70ac,0x70af,0x70ad,0x70b8,0x70ae,0x70a4,
0x7230,0x7272,0x726f,0x7274,0x72e9,0x72e0,0x72e1,0x73b7,
0x73ca,0x73bb,0x73b2,0x73cd,0x73c0,0x73b3,0x751a,0x752d,
0x754f,0x754c,0x754e,0x754b,0x75ab,0x75a4,0x75a5,0x75a2,
0x75a3,0x7678,0x7686,0x7687,0x7688,0x76c8,0x76c6,0x76c3,
0x76c5,0x7701,0x76f9,0x76f8,0x7709,0x770b,0x76fe,0x76fc,
0x7707,0x77dc,0x7802,0x7814,0x780c,0x780d,0x7946,0x7949,
0x7948,0x7947,0x79b9,0x79ba,0x79d1,0x79d2,0x79cb,0x7a7f,
0x7a81,0x7aff,0x7afd,0x7c7d,0x7d02,0x7d05,0x7d00,0x7d09,
0x7d07,0x7d04,0x7d06,0x7f38,0x7f8e,0x7fbf,0x8004,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8010,0x800d,0x8011,0x8036,0x80d6,0x80e5,0x80da,0x80c3,
0x80c4,0x80cc,0x80e1,0x80db,0x80ce,0x80de,0x80e4,0x80dd,
0x81f4,0x8222,0x82e7,0x8303,0x8305,0x82e3,0x82db,0x82e6,
0x8304,0x82e5,0x8302,0x8309,0x82d2,0x82d7,0x82f1,0x8301,
0x82dc,0x82d4,0x82d1,0x82de,0x82d3,0x82df,0x82ef,0x8306,
0x8650,0x8679,0x867b,0x867a,0x884d,0x886b,0x8981,0x89d4,
0x8a08,0x8a02,0x8a03,0x8c9e,0x8ca0,0x8d74,0x8d73,0x8db4,
0x8ecd,0x8ecc,0x8ff0,0x8fe6,0x8fe2,0x8fea,0x8fe5,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8fed,0x8feb,0x8fe4,0x8fe8,0x90ca,0x90ce,0x90c1,
0x90c3,0x914b,0x914a,0x91cd,0x9582,0x9650,0x964b,0x964c,
0x964d,0x9762,0x9769,0x97cb,0x97ed,0x97f3,0x9801,0x98a8,
0x98db,0x98df,0x9996,0x9999,0x4e58,0x4eb3,0x500c,0x500d,
0x5023,0x4fef,0x5026,0x5025,0x4ff8,0x5029,0x5016,0x5006,
0x503c,0x501f,0x501a,0x5012,0x5011,0x4ffa,0x5000,0x5014,
0x5028,0x4ff1,0x5021,0x500b,0x5019,0x5018,0x4ff3,0x4fee,
0x502d,0x502a,0x4ffe,0x502b,0x5009,0x517c,0x51a4,0x51a5,
0x51a2,0x51cd,0x51cc,0x51c6,0x51cb,0x5256,0x525c,0x5254,
0x525b,0x525d,0x532a,0x537f,0x539f,0x539d,0x53df,0x54e8,
0x5510,0x5501,0x5537,0x54fc,0x54e5,0x54f2,0x5506,0x54fa,
0x5514,0x54e9,0x54ed,0x54e1,0x5509,0x54ee,0x54ea,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x54e6,0x5527,0x5507,0x54fd,0x550f,0x5703,0x5704,0x57c2,
0x57d4,0x57cb,0x57c3,0x5809,0x590f,0x5957,0x5958,0x595a,
0x5a11,0x5a18,0x5a1c,0x5a1f,0x5a1b,0x5a13,0x59ec,0x5a20,
0x5a23,0x5a29,0x5a25,0x5a0c,0x5a09,0x5b6b,0x5c58,0x5bb0,
0x5bb3,0x5bb6,0x5bb4,0x5bae,0x5bb5,0x5bb9,0x5bb8,0x5c04,
0x5c51,0x5c55,0x5c50,0x5ced,0x5cfd,0x5cfb,0x5cea,0x5ce8,
0x5cf0,0x5cf6,0x5d01,0x5cf4,0x5dee,0x5e2d,0x5e2b,0x5eab,
0x5ead,0x5ea7,0x5f31,0x5f92,0x5f91,0x5f90,0x6059,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x6063,0x6065,0x6050,0x6055,0x606d,0x6069,0x606f,
0x6084,0x609f,0x609a,0x608d,0x6094,0x608c,0x6085,0x6096,
0x6247,0x62f3,0x6308,0x62ff,0x634e,0x633e,0x632f,0x6355,
0x6342,0x6346,0x634f,0x6349,0x633a,0x6350,0x633d,0x632a,
0x632b,0x6328,0x634d,0x634c,0x6548,0x6549,0x6599,0x65c1,
0x65c5,0x6642,0x6649,0x664f,0x6643,0x6652,0x664c,0x6645,
0x6641,0x66f8,0x6714,0x6715,0x6717,0x6821,0x6838,0x6848,
0x6846,0x6853,0x6839,0x6842,0x6854,0x6829,0x68b3,0x6817,
0x684c,0x6851,0x683d,0x67f4,0x6850,0x6840,0x683c,0x6843,
0x682a,0x6845,0x6813,0x6818,0x6841,0x6b8a,0x6b89,0x6bb7,
0x6c23,0x6c27,0x6c28,0x6c26,0x6c24,0x6cf0,0x6d6a,0x6d95,
0x6d88,0x6d87,0x6d66,0x6d78,0x6d77,0x6d59,0x6d93,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6d6c,0x6d89,0x6d6e,0x6d5a,0x6d74,0x6d69,0x6d8c,0x6d8a,
0x6d79,0x6d85,0x6d65,0x6d94,0x70ca,0x70d8,0x70e4,0x70d9,
0x70c8,0x70cf,0x7239,0x7279,0x72fc,0x72f9,0x72fd,0x72f8,
0x72f7,0x7386,0x73ed,0x7409,0x73ee,0x73e0,0x73ea,0x73de,
0x7554,0x755d,0x755c,0x755a,0x7559,0x75be,0x75c5,0x75c7,
0x75b2,0x75b3,0x75bd,0x75bc,0x75b9,0x75c2,0x75b8,0x768b,
0x76b0,0x76ca,0x76cd,0x76ce,0x7729,0x771f,0x7720,0x7728,
0x77e9,0x7830,0x7827,0x7838,0x781d,0x7834,0x7837,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x7825,0x782d,0x7820,0x781f,0x7832,0x7955,0x7950,
0x7960,0x795f,0x7956,0x795e,0x795d,0x7957,0x795a,0x79e4,
0x79e3,0x79e7,0x79df,0x79e6,0x79e9,0x79d8,0x7a84,0x7a88,
0x7ad9,0x7b06,0x7b11,0x7c89,0x7d21,0x7d17,0x7d0b,0x7d0a,
0x7d20,0x7d22,0x7d14,0x7d10,0x7d15,0x7d1a,0x7d1c,0x7d0d,
0x7d19,0x7d1b,0x7f3a,0x7f5f,0x7f94,0x7fc5,0x7fc1,0x8006,
0x8018,0x8015,0x8019,0x8017,0x803d,0x803f,0x80f1,0x8102,
0x80f0,0x8105,0x80ed,0x80f4,0x8106,0x80f8,0x80f3,0x8108,
0x80fd,0x810a,0x80fc,0x80ef,0x81ed,0x81ec,0x8200,0x8210,
0x822a,0x822b,0x8228,0x822c,0x82bb,0x832b,0x8352,0x8354,
0x834a,0x8338,0x8350,0x8349,0x8335,0x8334,0x834f,0x8332,
0x8339,0x8336,0x8317,0x8340,0x8331,0x8328,0x8343,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8654,0x868a,0x86aa,0x8693,0x86a4,0x86a9,0x868c,0x86a3,
0x869c,0x8870,0x8877,0x8881,0x8882,0x887d,0x8879,0x8a18,
0x8a10,0x8a0e,0x8a0c,0x8a15,0x8a0a,0x8a17,0x8a13,0x8a16,
0x8a0f,0x8a11,0x8c48,0x8c7a,0x8c79,0x8ca1,0x8ca2,0x8d77,
0x8eac,0x8ed2,0x8ed4,0x8ecf,0x8fb1,0x9001,0x9006,0x8ff7,
0x9000,0x8ffa,0x8ff4,0x9003,0x8ffd,0x9005,0x8ff8,0x9095,
0x90e1,0x90dd,0x90e2,0x9152,0x914d,0x914c,0x91d8,0x91dd,
0x91d7,0x91dc,0x91d9,0x9583,0x9662,0x9663,0x9661,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x965b,0x965d,0x9664,0x9658,0x965e,0x96bb,0x98e2,
0x99ac,0x9aa8,0x9ad8,0x9b25,0x9b32,0x9b3c,0x4e7e,0x507a,
0x507d,0x505c,0x5047,0x5043,0x504c,0x505a,0x5049,0x5065,
0x5076,0x504e,0x5055,0x5075,0x5074,0x5077,0x504f,0x500f,
0x506f,0x506d,0x515c,0x5195,0x51f0,0x526a,0x526f,0x52d2,
0x52d9,0x52d8,0x52d5,0x5310,0x530f,0x5319,0x533f,0x5340,
0x533e,0x53c3,0x66fc,0x5546,0x556a,0x5566,0x5544,0x555e,
0x5561,0x5543,0x554a,0x5531,0x5556,0x554f,0x5555,0x552f,
0x5564,0x5538,0x552e,0x555c,0x552c,0x5563,0x5533,0x5541,
0x5557,0x5708,0x570b,0x5709,0x57df,0x5805,0x580a,0x5806,
0x57e0,0x57e4,0x57fa,0x5802,0x5835,0x57f7,0x57f9,0x5920,
0x5962,0x5a36,0x5a41,0x5a49,0x5a66,0x5a6a,0x5a40,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5a3c,0x5a62,0x5a5a,0x5a46,0x5a4a,0x5b70,0x5bc7,0x5bc5,
0x5bc4,0x5bc2,0x5bbf,0x5bc6,0x5c09,0x5c08,0x5c07,0x5c60,
0x5c5c,0x5c5d,0x5d07,0x5d06,0x5d0e,0x5d1b,0x5d16,0x5d22,
0x5d11,0x5d29,0x5d14,0x5d19,0x5d24,0x5d27,0x5d17,0x5de2,
0x5e38,0x5e36,0x5e33,0x5e37,0x5eb7,0x5eb8,0x5eb6,0x5eb5,
0x5ebe,0x5f35,0x5f37,0x5f57,0x5f6c,0x5f69,0x5f6b,0x5f97,
0x5f99,0x5f9e,0x5f98,0x5fa1,0x5fa0,0x5f9c,0x607f,0x60a3,
0x6089,0x60a0,0x60a8,0x60cb,0x60b4,0x60e6,0x60bd,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x60c5,0x60bb,0x60b5,0x60dc,0x60bc,0x60d8,0x60d5,
0x60c6,0x60df,0x60b8,0x60da,0x60c7,0x621a,0x621b,0x6248,
0x63a0,0x63a7,0x6372,0x6396,0x63a2,0x63a5,0x6377,0x6367,
0x6398,0x63aa,0x6371,0x63a9,0x6389,0x6383,0x639b,0x636b,
0x63a8,0x6384,0x6388,0x6399,0x63a1,0x63ac,0x6392,0x638f,
0x6380,0x637b,0x6369,0x6368,0x637a,0x655d,0x6556,0x6551,
0x6559,0x6557,0x555f,0x654f,0x6558,0x6555,0x6554,0x659c,
0x659b,0x65ac,0x65cf,0x65cb,0x65cc,0x65ce,0x665d,0x665a,
0x6664,0x6668,0x6666,0x665e,0x66f9,0x52d7,0x671b,0x6881,
0x68af,0x68a2,0x6893,0x68b5,0x687f,0x6876,0x68b1,0x68a7,
0x6897,0x68b0,0x6883,0x68c4,0x68ad,0x6886,0x6885,0x6894,
0x689d,0x68a8,0x689f,0x68a1,0x6882,0x6b32,0x6bba,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6beb,0x6bec,0x6c2b,0x6d8e,0x6dbc,0x6df3,0x6dd9,0x6db2,
0x6de1,0x6dcc,0x6de4,0x6dfb,0x6dfa,0x6e05,0x6dc7,0x6dcb,
0x6daf,0x6dd1,0x6dae,0x6dde,0x6df9,0x6db8,0x6df7,0x6df5,
0x6dc5,0x6dd2,0x6e1a,0x6db5,0x6dda,0x6deb,0x6dd8,0x6dea,
0x6df1,0x6dee,0x6de8,0x6dc6,0x6dc4,0x6daa,0x6dec,0x6dbf,
0x6de6,0x70f9,0x7109,0x710a,0x70fd,0x70ef,0x723d,0x727d,
0x7281,0x731c,0x731b,0x7316,0x7313,0x7319,0x7387,0x7405,
0x740a,0x7403,0x7406,0x73fe,0x740d,0x74e0,0x74f6,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x74f7,0x751c,0x7522,0x7565,0x7566,0x7562,0x7570,
0x758f,0x75d4,0x75d5,0x75b5,0x75ca,0x75cd,0x768e,0x76d4,
0x76d2,0x76db,0x7737,0x773e,0x773c,0x7736,0x7738,0x773a,
0x786b,0x7843,0x784e,0x7965,0x7968,0x796d,0x79fb,0x7a92,
0x7a95,0x7b20,0x7b28,0x7b1b,0x7b2c,0x7b26,0x7b19,0x7b1e,
0x7b2e,0x7c92,0x7c97,0x7c95,0x7d46,0x7d43,0x7d71,0x7d2e,
0x7d39,0x7d3c,0x7d40,0x7d30,0x7d33,0x7d44,0x7d2f,0x7d42,
0x7d32,0x7d31,0x7f3d,0x7f9e,0x7f9a,0x7fcc,0x7fce,0x7fd2,
0x801c,0x804a,0x8046,0x812f,0x8116,0x8123,0x812b,0x8129,
0x8130,0x8124,0x8202,0x8235,0x8237,0x8236,0x8239,0x838e,
0x839e,0x8398,0x8378,0x83a2,0x8396,0x83bd,0x83ab,0x8392,
0x838a,0x8393,0x8389,0x83a0,0x8377,0x837b,0x837c,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8386,0x83a7,0x8655,0x5f6a,0x86c7,0x86c0,0x86b6,0x86c4,
0x86b5,0x86c6,0x86cb,0x86b1,0x86af,0x86c9,0x8853,0x889e,
0x8888,0x88ab,0x8892,0x8896,0x888d,0x888b,0x8993,0x898f,
0x8a2a,0x8a1d,0x8a23,0x8a25,0x8a31,0x8a2d,0x8a1f,0x8a1b,
0x8a22,0x8c49,0x8c5a,0x8ca9,0x8cac,0x8cab,0x8ca8,0x8caa,
0x8ca7,0x8d67,0x8d66,0x8dbe,0x8dba,0x8edb,0x8edf,0x9019,
0x900d,0x901a,0x9017,0x9023,0x901f,0x901d,0x9010,0x9015,
0x901e,0x9020,0x900f,0x9022,0x9016,0x901b,0x9014,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x90e8,0x90ed,0x90fd,0x9157,0x91ce,0x91f5,0x91e6,
0x91e3,0x91e7,0x91ed,0x91e9,0x9589,0x966a,0x9675,0x9673,
0x9678,0x9670,0x9674,0x9676,0x9677,0x966c,0x96c0,0x96ea,
0x96e9,0x7ae0,0x7adf,0x9802,0x9803,0x9b5a,0x9ce5,0x9e75,
0x9e7f,0x9ea5,0x9ebb,0x50a2,0x508d,0x5085,0x5099,0x5091,
0x5080,0x5096,0x5098,0x509a,0x6700,0x51f1,0x5272,0x5274,
0x5275,0x5269,0x52de,0x52dd,0x52db,0x535a,0x53a5,0x557b,
0x5580,0x55a7,0x557c,0x558a,0x559d,0x5598,0x5582,0x559c,
0x55aa,0x5594,0x5587,0x558b,0x5583,0x55b3,0x55ae,0x559f,
0x553e,0x55b2,0x559a,0x55bb,0x55ac,0x55b1,0x557e,0x5589,
0x55ab,0x5599,0x570d,0x582f,0x582a,0x5834,0x5824,0x5830,
0x5831,0x5821,0x581d,0x5820,0x58f9,0x58fa,0x5960,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5a77,0x5a9a,0x5a7f,0x5a92,0x5a9b,0x5aa7,0x5b73,0x5b71,
0x5bd2,0x5bcc,0x5bd3,0x5bd0,0x5c0a,0x5c0b,0x5c31,0x5d4c,
0x5d50,0x5d34,0x5d47,0x5dfd,0x5e45,0x5e3d,0x5e40,0x5e43,
0x5e7e,0x5eca,0x5ec1,0x5ec2,0x5ec4,0x5f3c,0x5f6d,0x5fa9,
0x5faa,0x5fa8,0x60d1,0x60e1,0x60b2,0x60b6,0x60e0,0x611c,
0x6123,0x60fa,0x6115,0x60f0,0x60fb,0x60f4,0x6168,0x60f1,
0x610e,0x60f6,0x6109,0x6100,0x6112,0x621f,0x6249,0x63a3,
0x638c,0x63cf,0x63c0,0x63e9,0x63c9,0x63c6,0x63cd,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x63d2,0x63e3,0x63d0,0x63e1,0x63d6,0x63ed,0x63ee,
0x6376,0x63f4,0x63ea,0x63db,0x6452,0x63da,0x63f9,0x655e,
0x6566,0x6562,0x6563,0x6591,0x6590,0x65af,0x666e,0x6670,
0x6674,0x6676,0x666f,0x6691,0x667a,0x667e,0x6677,0x66fe,
0x66ff,0x671f,0x671d,0x68fa,0x68d5,0x68e0,0x68d8,0x68d7,
0x6905,0x68df,0x68f5,0x68ee,0x68e7,0x68f9,0x68d2,0x68f2,
0x68e3,0x68cb,0x68cd,0x690d,0x6912,0x690e,0x68c9,0x68da,
0x696e,0x68fb,0x6b3e,0x6b3a,0x6b3d,0x6b98,0x6b96,0x6bbc,
0x6bef,0x6c2e,0x6c2f,0x6c2c,0x6e2f,0x6e38,0x6e54,0x6e21,
0x6e32,0x6e67,0x6e4a,0x6e20,0x6e25,0x6e23,0x6e1b,0x6e5b,
0x6e58,0x6e24,0x6e56,0x6e6e,0x6e2d,0x6e26,0x6e6f,0x6e34,
0x6e4d,0x6e3a,0x6e2c,0x6e43,0x6e1d,0x6e3e,0x6ecb,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6e89,0x6e19,0x6e4e,0x6e63,0x6e44,0x6e72,0x6e69,0x6e5f,
0x7119,0x711a,0x7126,0x7130,0x7121,0x7136,0x716e,0x711c,
0x724c,0x7284,0x7280,0x7336,0x7325,0x7334,0x7329,0x743a,
0x742a,0x7433,0x7422,0x7425,0x7435,0x7436,0x7434,0x742f,
0x741b,0x7426,0x7428,0x7525,0x7526,0x756b,0x756a,0x75e2,
0x75db,0x75e3,0x75d9,0x75d8,0x75de,0x75e0,0x767b,0x767c,
0x7696,0x7693,0x76b4,0x76dc,0x774f,0x77ed,0x785d,0x786c,
0x786f,0x7a0d,0x7a08,0x7a0b,0x7a05,0x7a00,0x7a98,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x7a97,0x7a96,0x7ae5,0x7ae3,0x7b49,0x7b56,0x7b46,
0x7b50,0x7b52,0x7b54,0x7b4d,0x7b4b,0x7b4f,0x7b51,0x7c9f,
0x7ca5,0x7d5e,0x7d50,0x7d68,0x7d55,0x7d2b,0x7d6e,0x7d72,
0x7d61,0x7d66,0x7d62,0x7d70,0x7d73,0x5584,0x7fd4,0x7fd5,
0x800b,0x8052,0x8085,0x8155,0x8154,0x814b,0x8151,0x814e,
0x8139,0x8146,0x813e,0x814c,0x8153,0x8174,0x8212,0x821c,
0x83e9,0x8403,0x83f8,0x840d,0x83e0,0x83c5,0x840b,0x83c1,
0x83ef,0x83f1,0x83f4,0x8457,0x840a,0x83f0,0x840c,0x83cc,
0x83fd,0x83f2,0x83ca,0x8438,0x840e,0x8404,0x83dc,0x8407,
0x83d4,0x83df,0x865b,0x86df,0x86d9,0x86ed,0x86d4,0x86db,
0x86e4,0x86d0,0x86de,0x8857,0x88c1,0x88c2,0x88b1,0x8983,
0x8996,0x8a3b,0x8a60,0x8a55,0x8a5e,0x8a3c,0x8a41,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8a54,0x8a5b,0x8a50,0x8a46,0x8a34,0x8a3a,0x8a36,0x8a56,
0x8c61,0x8c82,0x8caf,0x8cbc,0x8cb3,0x8cbd,0x8cc1,0x8cbb,
0x8cc0,0x8cb4,0x8cb7,0x8cb6,0x8cbf,0x8cb8,0x8d8a,0x8d85,
0x8d81,0x8dce,0x8ddd,0x8dcb,0x8dda,0x8dd1,0x8dcc,0x8ddb,
0x8dc6,0x8efb,0x8ef8,0x8efc,0x8f9c,0x902e,0x9035,0x9031,
0x9038,0x9032,0x9036,0x9102,0x90f5,0x9109,0x90fe,0x9163,
0x9165,0x91cf,0x9214,0x9215,0x9223,0x9209,0x921e,0x920d,
0x9210,0x9207,0x9211,0x9594,0x958f,0x958b,0x9591,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9593,0x9592,0x958e,0x968a,0x968e,0x968b,0x967d,
0x9685,0x9686,0x968d,0x9672,0x9684,0x96c1,0x96c5,0x96c4,
0x96c6,0x96c7,0x96ef,0x96f2,0x97cc,0x9805,0x9806,0x9808,
0x98e7,0x98ea,0x98ef,0x98e9,0x98f2,0x98ed,0x99ae,0x99ad,
0x9ec3,0x9ecd,0x9ed1,0x4e82,0x50ad,0x50b5,0x50b2,0x50b3,
0x50c5,0x50be,0x50ac,0x50b7,0x50bb,0x50af,0x50c7,0x527f,
0x5277,0x527d,0x52df,0x52e6,0x52e4,0x52e2,0x52e3,0x532f,
0x55df,0x55e8,0x55d3,0x55e6,0x55ce,0x55dc,0x55c7,0x55d1,
0x55e3,0x55e4,0x55ef,0x55da,0x55e1,0x55c5,0x55c6,0x55e5,
0x55c9,0x5712,0x5713,0x585e,0x5851,0x5858,0x5857,0x585a,
0x5854,0x586b,0x584c,0x586d,0x584a,0x5862,0x5852,0x584b,
0x5967,0x5ac1,0x5ac9,0x5acc,0x5abe,0x5abd,0x5abc,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5ab3,0x5ac2,0x5ab2,0x5d69,0x5d6f,0x5e4c,0x5e79,0x5ec9,
0x5ec8,0x5f12,0x5f59,0x5fac,0x5fae,0x611a,0x610f,0x6148,
0x611f,0x60f3,0x611b,0x60f9,0x6101,0x6108,0x614e,0x614c,
0x6144,0x614d,0x613e,0x6134,0x6127,0x610d,0x6106,0x6137,
0x6221,0x6222,0x6413,0x643e,0x641e,0x642a,0x642d,0x643d,
0x642c,0x640f,0x641c,0x6414,0x640d,0x6436,0x6416,0x6417,
0x6406,0x656c,0x659f,0x65b0,0x6697,0x6689,0x6687,0x6688,
0x6696,0x6684,0x6698,0x668d,0x6703,0x6994,0x696d,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x695a,0x6977,0x6960,0x6954,0x6975,0x6930,0x6982,
0x694a,0x6968,0x696b,0x695e,0x6953,0x6979,0x6986,0x695d,
0x6963,0x695b,0x6b47,0x6b72,0x6bc0,0x6bbf,0x6bd3,0x6bfd,
0x6ea2,0x6eaf,0x6ed3,0x6eb6,0x6ec2,0x6e90,0x6e9d,0x6ec7,
0x6ec5,0x6ea5,0x6e98,0x6ebc,0x6eba,0x6eab,0x6ed1,0x6e96,
0x6e9c,0x6ec4,0x6ed4,0x6eaa,0x6ea7,0x6eb4,0x714e,0x7159,
0x7169,0x7164,0x7149,0x7167,0x715c,0x716c,0x7166,0x714c,
0x7165,0x715e,0x7146,0x7168,0x7156,0x723a,0x7252,0x7337,
0x7345,0x733f,0x733e,0x746f,0x745a,0x7455,0x745f,0x745e,
0x7441,0x743f,0x7459,0x745b,0x745c,0x7576,0x7578,0x7600,
0x75f0,0x7601,0x75f2,0x75f1,0x75fa,0x75ff,0x75f4,0x75f3,
0x76de,0x76df,0x775b,0x776b,0x7766,0x775e,0x7763,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x7779,0x776a,0x776c,0x775c,0x7765,0x7768,0x7762,0x77ee,
0x788e,0x78b0,0x7897,0x7898,0x788c,0x7889,0x787c,0x7891,
0x7893,0x787f,0x797a,0x797f,0x7981,0x842c,0x79bd,0x7a1c,
0x7a1a,0x7a20,0x7a14,0x7a1f,0x7a1e,0x7a9f,0x7aa0,0x7b77,
0x7bc0,0x7b60,0x7b6e,0x7b67,0x7cb1,0x7cb3,0x7cb5,0x7d93,
0x7d79,0x7d91,0x7d81,0x7d8f,0x7d5b,0x7f6e,0x7f69,0x7f6a,
0x7f72,0x7fa9,0x7fa8,0x7fa4,0x8056,0x8058,0x8086,0x8084,
0x8171,0x8170,0x8178,0x8165,0x816e,0x8173,0x816b,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8179,0x817a,0x8166,0x8205,0x8247,0x8482,0x8477,
0x843d,0x8431,0x8475,0x8466,0x846b,0x8449,0x846c,0x845b,
0x843c,0x8435,0x8461,0x8463,0x8469,0x846d,0x8446,0x865e,
0x865c,0x865f,0x86f9,0x8713,0x8708,0x8707,0x8700,0x86fe,
0x86fb,0x8702,0x8703,0x8706,0x870a,0x8859,0x88df,0x88d4,
0x88d9,0x88dc,0x88d8,0x88dd,0x88e1,0x88ca,0x88d5,0x88d2,
0x899c,0x89e3,0x8a6b,0x8a72,0x8a73,0x8a66,0x8a69,0x8a70,
0x8a87,0x8a7c,0x8a63,0x8aa0,0x8a71,0x8a85,0x8a6d,0x8a62,
0x8a6e,0x8a6c,0x8a79,0x8a7b,0x8a3e,0x8a68,0x8c62,0x8c8a,
0x8c89,0x8cca,0x8cc7,0x8cc8,0x8cc4,0x8cb2,0x8cc3,0x8cc2,
0x8cc5,0x8de1,0x8ddf,0x8de8,0x8def,0x8df3,0x8dfa,0x8dea,
0x8de4,0x8de6,0x8eb2,0x8f03,0x8f09,0x8efe,0x8f0a,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8f9f,0x8fb2,0x904b,0x904a,0x9053,0x9042,0x9054,0x903c,
0x9055,0x9050,0x9047,0x904f,0x904e,0x904d,0x9051,0x903e,
0x9041,0x9112,0x9117,0x916c,0x916a,0x9169,0x91c9,0x9237,
0x9257,0x9238,0x923d,0x9240,0x923e,0x925b,0x924b,0x9264,
0x9251,0x9234,0x9249,0x924d,0x9245,0x9239,0x923f,0x925a,
0x9598,0x9698,0x9694,0x9695,0x96cd,0x96cb,0x96c9,0x96ca,
0x96f7,0x96fb,0x96f9,0x96f6,0x9756,0x9774,0x9776,0x9810,
0x9811,0x9813,0x980a,0x9812,0x980c,0x98fc,0x98f4,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x98fd,0x98fe,0x99b3,0x99b1,0x99b4,0x9ae1,0x9ce9,
0x9e82,0x9f0e,0x9f13,0x9f20,0x50e7,0x50ee,0x50e5,0x50d6,
0x50ed,0x50da,0x50d5,0x50cf,0x50d1,0x50f1,0x50ce,0x50e9,
0x5162,0x51f3,0x5283,0x5282,0x5331,0x53ad,0x55fe,0x5600,
0x561b,0x5617,0x55fd,0x5614,0x5606,0x5609,0x560d,0x560e,
0x55f7,0x5616,0x561f,0x5608,0x5610,0x55f6,0x5718,0x5716,
0x5875,0x587e,0x5883,0x5893,0x588a,0x5879,0x5885,0x587d,
0x58fd,0x5925,0x5922,0x5924,0x596a,0x5969,0x5ae1,0x5ae6,
0x5ae9,0x5ad7,0x5ad6,0x5ad8,0x5ae3,0x5b75,0x5bde,0x5be7,
0x5be1,0x5be5,0x5be6,0x5be8,0x5be2,0x5be4,0x5bdf,0x5c0d,
0x5c62,0x5d84,0x5d87,0x5e5b,0x5e63,0x5e55,0x5e57,0x5e54,
0x5ed3,0x5ed6,0x5f0a,0x5f46,0x5f70,0x5fb9,0x6147,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x613f,0x614b,0x6177,0x6162,0x6163,0x615f,0x615a,0x6158,
0x6175,0x622a,0x6487,0x6458,0x6454,0x64a4,0x6478,0x645f,
0x647a,0x6451,0x6467,0x6434,0x646d,0x647b,0x6572,0x65a1,
0x65d7,0x65d6,0x66a2,0x66a8,0x669d,0x699c,0x69a8,0x6995,
0x69c1,0x69ae,0x69d3,0x69cb,0x699b,0x69b7,0x69bb,0x69ab,
0x69b4,0x69d0,0x69cd,0x69ad,0x69cc,0x69a6,0x69c3,0x69a3,
0x6b49,0x6b4c,0x6c33,0x6f33,0x6f14,0x6efe,0x6f13,0x6ef4,
0x6f29,0x6f3e,0x6f20,0x6f2c,0x6f0f,0x6f02,0x6f22,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x6eff,0x6eef,0x6f06,0x6f31,0x6f38,0x6f32,0x6f23,
0x6f15,0x6f2b,0x6f2f,0x6f88,0x6f2a,0x6eec,0x6f01,0x6ef2,
0x6ecc,0x6ef7,0x7194,0x7199,0x717d,0x718a,0x7184,0x7192,
0x723e,0x7292,0x7296,0x7344,0x7350,0x7464,0x7463,0x746a,
0x7470,0x746d,0x7504,0x7591,0x7627,0x760d,0x760b,0x7609,
0x7613,0x76e1,0x76e3,0x7784,0x777d,0x777f,0x7761,0x78c1,
0x789f,0x78a7,0x78b3,0x78a9,0x78a3,0x798e,0x798f,0x798d,
0x7a2e,0x7a31,0x7aaa,0x7aa9,0x7aed,0x7aef,0x7ba1,0x7b95,
0x7b8b,0x7b75,0x7b97,0x7b9d,0x7b94,0x7b8f,0x7bb8,0x7b87,
0x7b84,0x7cb9,0x7cbd,0x7cbe,0x7dbb,0x7db0,0x7d9c,0x7dbd,
0x7dbe,0x7da0,0x7dca,0x7db4,0x7db2,0x7db1,0x7dba,0x7da2,
0x7dbf,0x7db5,0x7db8,0x7dad,0x7dd2,0x7dc7,0x7dac,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x7f70,0x7fe0,0x7fe1,0x7fdf,0x805e,0x805a,0x8087,0x8150,
0x8180,0x818f,0x8188,0x818a,0x817f,0x8182,0x81e7,0x81fa,
0x8207,0x8214,0x821e,0x824b,0x84c9,0x84bf,0x84c6,0x84c4,
0x8499,0x849e,0x84b2,0x849c,0x84cb,0x84b8,0x84c0,0x84d3,
0x8490,0x84bc,0x84d1,0x84ca,0x873f,0x871c,0x873b,0x8722,
0x8725,0x8734,0x8718,0x8755,0x8737,0x8729,0x88f3,0x8902,
0x88f4,0x88f9,0x88f8,0x88fd,0x88e8,0x891a,0x88ef,0x8aa6,
0x8a8c,0x8a9e,0x8aa3,0x8a8d,0x8aa1,0x8a93,0x8aa4,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8aaa,0x8aa5,0x8aa8,0x8a98,0x8a91,0x8a9a,0x8aa7,
0x8c6a,0x8c8d,0x8c8c,0x8cd3,0x8cd1,0x8cd2,0x8d6b,0x8d99,
0x8d95,0x8dfc,0x8f14,0x8f12,0x8f15,0x8f13,0x8fa3,0x9060,
0x9058,0x905c,0x9063,0x9059,0x905e,0x9062,0x905d,0x905b,
0x9119,0x9118,0x911e,0x9175,0x9178,0x9177,0x9174,0x9278,
0x9280,0x9285,0x9298,0x9296,0x927b,0x9293,0x929c,0x92a8,
0x927c,0x9291,0x95a1,0x95a8,0x95a9,0x95a3,0x95a5,0x95a4,
0x9699,0x969c,0x969b,0x96cc,0x96d2,0x9700,0x977c,0x9785,
0x97f6,0x9817,0x9818,0x98af,0x98b1,0x9903,0x9905,0x990c,
0x9909,0x99c1,0x9aaf,0x9ab0,0x9ae6,0x9b41,0x9b42,0x9cf4,
0x9cf6,0x9cf3,0x9ebc,0x9f3b,0x9f4a,0x5104,0x5100,0x50fb,
0x50f5,0x50f9,0x5102,0x5108,0x5109,0x5105,0x51dc,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5287,0x5288,0x5289,0x528d,0x528a,0x52f0,0x53b2,0x562e,
0x563b,0x5639,0x5632,0x563f,0x5634,0x5629,0x5653,0x564e,
0x5657,0x5674,0x5636,0x562f,0x5630,0x5880,0x589f,0x589e,
0x58b3,0x589c,0x58ae,0x58a9,0x58a6,0x596d,0x5b09,0x5afb,
0x5b0b,0x5af5,0x5b0c,0x5b08,0x5bee,0x5bec,0x5be9,0x5beb,
0x5c64,0x5c65,0x5d9d,0x5d94,0x5e62,0x5e5f,0x5e61,0x5ee2,
0x5eda,0x5edf,0x5edd,0x5ee3,0x5ee0,0x5f48,0x5f71,0x5fb7,
0x5fb5,0x6176,0x6167,0x616e,0x615d,0x6155,0x6182,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x617c,0x6170,0x616b,0x617e,0x61a7,0x6190,0x61ab,
0x618e,0x61ac,0x619a,0x61a4,0x6194,0x61ae,0x622e,0x6469,
0x646f,0x6479,0x649e,0x64b2,0x6488,0x6490,0x64b0,0x64a5,
0x6493,0x6495,0x64a9,0x6492,0x64ae,0x64ad,0x64ab,0x649a,
0x64ac,0x6499,0x64a2,0x64b3,0x6575,0x6577,0x6578,0x66ae,
0x66ab,0x66b4,0x66b1,0x6a23,0x6a1f,0x69e8,0x6a01,0x6a1e,
0x6a19,0x69fd,0x6a21,0x6a13,0x6a0a,0x69f3,0x6a02,0x6a05,
0x69ed,0x6a11,0x6b50,0x6b4e,0x6ba4,0x6bc5,0x6bc6,0x6f3f,
0x6f7c,0x6f84,0x6f51,0x6f66,0x6f54,0x6f86,0x6f6d,0x6f5b,
0x6f78,0x6f6e,0x6f8e,0x6f7a,0x6f70,0x6f64,0x6f97,0x6f58,
0x6ed5,0x6f6f,0x6f60,0x6f5f,0x719f,0x71ac,0x71b1,0x71a8,
0x7256,0x729b,0x734e,0x7357,0x7469,0x748b,0x7483,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x747e,0x7480,0x757f,0x7620,0x7629,0x761f,0x7624,0x7626,
0x7621,0x7622,0x769a,0x76ba,0x76e4,0x778e,0x7787,0x778c,
0x7791,0x778b,0x78cb,0x78c5,0x78ba,0x78ca,0x78be,0x78d5,
0x78bc,0x78d0,0x7a3f,0x7a3c,0x7a40,0x7a3d,0x7a37,0x7a3b,
0x7aaf,0x7aae,0x7bad,0x7bb1,0x7bc4,0x7bb4,0x7bc6,0x7bc7,
0x7bc1,0x7ba0,0x7bcc,0x7cca,0x7de0,0x7df4,0x7def,0x7dfb,
0x7dd8,0x7dec,0x7ddd,0x7de8,0x7de3,0x7dda,0x7dde,0x7de9,
0x7d9e,0x7dd9,0x7df2,0x7df9,0x7f75,0x7f77,0x7faf,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x7fe9,0x8026,0x819b,0x819c,0x819d,0x81a0,0x819a,
0x8198,0x8517,0x853d,0x851a,0x84ee,0x852c,0x852d,0x8513,
0x8511,0x8523,0x8521,0x8514,0x84ec,0x8525,0x84ff,0x8506,
0x8782,0x8774,0x8776,0x8760,0x8766,0x8778,0x8768,0x8759,
0x8757,0x874c,0x8753,0x885b,0x885d,0x8910,0x8907,0x8912,
0x8913,0x8915,0x890a,0x8abc,0x8ad2,0x8ac7,0x8ac4,0x8a95,
0x8acb,0x8af8,0x8ab2,0x8ac9,0x8ac2,0x8abf,0x8ab0,0x8ad6,
0x8acd,0x8ab6,0x8ab9,0x8adb,0x8c4c,0x8c4e,0x8c6c,0x8ce0,
0x8cde,0x8ce6,0x8ce4,0x8cec,0x8ced,0x8ce2,0x8ce3,0x8cdc,
0x8cea,0x8ce1,0x8d6d,0x8d9f,0x8da3,0x8e2b,0x8e10,0x8e1d,
0x8e22,0x8e0f,0x8e29,0x8e1f,0x8e21,0x8e1e,0x8eba,0x8f1d,
0x8f1b,0x8f1f,0x8f29,0x8f26,0x8f2a,0x8f1c,0x8f1e,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8f25,0x9069,0x906e,0x9068,0x906d,0x9077,0x9130,0x912d,
0x9127,0x9131,0x9187,0x9189,0x918b,0x9183,0x92c5,0x92bb,
0x92b7,0x92ea,0x92ac,0x92e4,0x92c1,0x92b3,0x92bc,0x92d2,
0x92c7,0x92f0,0x92b2,0x95ad,0x95b1,0x9704,0x9706,0x9707,
0x9709,0x9760,0x978d,0x978b,0x978f,0x9821,0x982b,0x981c,
0x98b3,0x990a,0x9913,0x9912,0x9918,0x99dd,0x99d0,0x99df,
0x99db,0x99d1,0x99d5,0x99d2,0x99d9,0x9ab7,0x9aee,0x9aef,
0x9b27,0x9b45,0x9b44,0x9b77,0x9b6f,0x9d06,0x9d09,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9d03,0x9ea9,0x9ebe,0x9ece,0x58a8,0x9f52,0x5112,
0x5118,0x5114,0x5110,0x5115,0x5180,0x51aa,0x51dd,0x5291,
0x5293,0x52f3,0x5659,0x566b,0x5679,0x5669,0x5664,0x5678,
0x566a,0x5668,0x5665,0x5671,0x566f,0x566c,0x5662,0x5676,
0x58c1,0x58be,0x58c7,0x58c5,0x596e,0x5b1d,0x5b34,0x5b78,
0x5bf0,0x5c0e,0x5f4a,0x61b2,0x6191,0x61a9,0x618a,0x61cd,
0x61b6,0x61be,0x61ca,0x61c8,0x6230,0x64c5,0x64c1,0x64cb,
0x64bb,0x64bc,0x64da,0x64c4,0x64c7,0x64c2,0x64cd,0x64bf,
0x64d2,0x64d4,0x64be,0x6574,0x66c6,0x66c9,0x66b9,0x66c4,
0x66c7,0x66b8,0x6a3d,0x6a38,0x6a3a,0x6a59,0x6a6b,0x6a58,
0x6a39,0x6a44,0x6a62,0x6a61,0x6a4b,0x6a47,0x6a35,0x6a5f,
0x6a48,0x6b59,0x6b77,0x6c05,0x6fc2,0x6fb1,0x6fa1,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6fc3,0x6fa4,0x6fc1,0x6fa7,0x6fb3,0x6fc0,0x6fb9,0x6fb6,
0x6fa6,0x6fa0,0x6fb4,0x71be,0x71c9,0x71d0,0x71d2,0x71c8,
0x71d5,0x71b9,0x71ce,0x71d9,0x71dc,0x71c3,0x71c4,0x7368,
0x749c,0x74a3,0x7498,0x749f,0x749e,0x74e2,0x750c,0x750d,
0x7634,0x7638,0x763a,0x76e7,0x76e5,0x77a0,0x779e,0x779f,
0x77a5,0x78e8,0x78da,0x78ec,0x78e7,0x79a6,0x7a4d,0x7a4e,
0x7a46,0x7a4c,0x7a4b,0x7aba,0x7bd9,0x7c11,0x7bc9,0x7be4,
0x7bdb,0x7be1,0x7be9,0x7be6,0x7cd5,0x7cd6,0x7e0a,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x7e11,0x7e08,0x7e1b,0x7e23,0x7e1e,0x7e1d,0x7e09,
0x7e10,0x7f79,0x7fb2,0x7ff0,0x7ff1,0x7fee,0x8028,0x81b3,
0x81a9,0x81a8,0x81fb,0x8208,0x8258,0x8259,0x854a,0x8559,
0x8548,0x8568,0x8569,0x8543,0x8549,0x856d,0x856a,0x855e,
0x8783,0x879f,0x879e,0x87a2,0x878d,0x8861,0x892a,0x8932,
0x8925,0x892b,0x8921,0x89aa,0x89a6,0x8ae6,0x8afa,0x8aeb,
0x8af1,0x8b00,0x8adc,0x8ae7,0x8aee,0x8afe,0x8b01,0x8b02,
0x8af7,0x8aed,0x8af3,0x8af6,0x8afc,0x8c6b,0x8c6d,0x8c93,
0x8cf4,0x8e44,0x8e31,0x8e34,0x8e42,0x8e39,0x8e35,0x8f3b,
0x8f2f,0x8f38,0x8f33,0x8fa8,0x8fa6,0x9075,0x9074,0x9078,
0x9072,0x907c,0x907a,0x9134,0x9192,0x9320,0x9336,0x92f8,
0x9333,0x932f,0x9322,0x92fc,0x932b,0x9304,0x931a,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9310,0x9326,0x9321,0x9315,0x932e,0x9319,0x95bb,0x96a7,
0x96a8,0x96aa,0x96d5,0x970e,0x9711,0x9716,0x970d,0x9713,
0x970f,0x975b,0x975c,0x9766,0x9798,0x9830,0x9838,0x983b,
0x9837,0x982d,0x9839,0x9824,0x9910,0x9928,0x991e,0x991b,
0x9921,0x991a,0x99ed,0x99e2,0x99f1,0x9ab8,0x9abc,0x9afb,
0x9aed,0x9b28,0x9b91,0x9d15,0x9d23,0x9d26,0x9d28,0x9d12,
0x9d1b,0x9ed8,0x9ed4,0x9f8d,0x9f9c,0x512a,0x511f,0x5121,
0x5132,0x52f5,0x568e,0x5680,0x5690,0x5685,0x5687,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x568f,0x58d5,0x58d3,0x58d1,0x58ce,0x5b30,0x5b2a,
0x5b24,0x5b7a,0x5c37,0x5c68,0x5dbc,0x5dba,0x5dbd,0x5db8,
0x5e6b,0x5f4c,0x5fbd,0x61c9,0x61c2,0x61c7,0x61e6,0x61cb,
0x6232,0x6234,0x64ce,0x64ca,0x64d8,0x64e0,0x64f0,0x64e6,
0x64ec,0x64f1,0x64e2,0x64ed,0x6582,0x6583,0x66d9,0x66d6,
0x6a80,0x6a94,0x6a84,0x6aa2,0x6a9c,0x6adb,0x6aa3,0x6a7e,
0x6a97,0x6a90,0x6aa0,0x6b5c,0x6bae,0x6bda,0x6c08,0x6fd8,
0x6ff1,0x6fdf,0x6fe0,0x6fdb,0x6fe4,0x6feb,0x6fef,0x6f80,
0x6fec,0x6fe1,0x6fe9,0x6fd5,0x6fee,0x6ff0,0x71e7,0x71df,
0x71ee,0x71e6,0x71e5,0x71ed,0x71ec,0x71f4,0x71e0,0x7235,
0x7246,0x7370,0x7372,0x74a9,0x74b0,0x74a6,0x74a8,0x7646,
0x7642,0x764c,0x76ea,0x77b3,0x77aa,0x77b0,0x77ac,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x77a7,0x77ad,0x77ef,0x78f7,0x78fa,0x78f4,0x78ef,0x7901,
0x79a7,0x79aa,0x7a57,0x7abf,0x7c07,0x7c0d,0x7bfe,0x7bf7,
0x7c0c,0x7be0,0x7ce0,0x7cdc,0x7cde,0x7ce2,0x7cdf,0x7cd9,
0x7cdd,0x7e2e,0x7e3e,0x7e46,0x7e37,0x7e32,0x7e43,0x7e2b,
0x7e3d,0x7e31,0x7e45,0x7e41,0x7e34,0x7e39,0x7e48,0x7e35,
0x7e3f,0x7e2f,0x7f44,0x7ff3,0x7ffc,0x8071,0x8072,0x8070,
0x806f,0x8073,0x81c6,0x81c3,0x81ba,0x81c2,0x81c0,0x81bf,
0x81bd,0x81c9,0x81be,0x81e8,0x8209,0x8271,0x85aa,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8584,0x857e,0x859c,0x8591,0x8594,0x85af,0x859b,
0x8587,0x85a8,0x858a,0x8667,0x87c0,0x87d1,0x87b3,0x87d2,
0x87c6,0x87ab,0x87bb,0x87ba,0x87c8,0x87cb,0x893b,0x8936,
0x8944,0x8938,0x893d,0x89ac,0x8b0e,0x8b17,0x8b19,0x8b1b,
0x8b0a,0x8b20,0x8b1d,0x8b04,0x8b10,0x8c41,0x8c3f,0x8c73,
0x8cfa,0x8cfd,0x8cfc,0x8cf8,0x8cfb,0x8da8,0x8e49,0x8e4b,
0x8e48,0x8e4a,0x8f44,0x8f3e,0x8f42,0x8f45,0x8f3f,0x907f,
0x907d,0x9084,0x9081,0x9082,0x9080,0x9139,0x91a3,0x919e,
0x919c,0x934d,0x9382,0x9328,0x9375,0x934a,0x9365,0x934b,
0x9318,0x937e,0x936c,0x935b,0x9370,0x935a,0x9354,0x95ca,
0x95cb,0x95cc,0x95c8,0x95c6,0x96b1,0x96b8,0x96d6,0x971c,
0x971e,0x97a0,0x97d3,0x9846,0x98b6,0x9935,0x9a01,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x99ff,0x9bae,0x9bab,0x9baa,0x9bad,0x9d3b,0x9d3f,0x9e8b,
0x9ecf,0x9ede,0x9edc,0x9edd,0x9edb,0x9f3e,0x9f4b,0x53e2,
0x5695,0x56ae,0x58d9,0x58d8,0x5b38,0x5f5d,0x61e3,0x6233,
0x64f4,0x64f2,0x64fe,0x6506,0x64fa,0x64fb,0x64f7,0x65b7,
0x66dc,0x6726,0x6ab3,0x6aac,0x6ac3,0x6abb,0x6ab8,0x6ac2,
0x6aae,0x6aaf,0x6b5f,0x6b78,0x6baf,0x7009,0x700b,0x6ffe,
0x7006,0x6ffa,0x7011,0x700f,0x71fb,0x71fc,0x71fe,0x71f8,
0x7377,0x7375,0x74a7,0x74bf,0x7515,0x7656,0x7658,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x7652,0x77bd,0x77bf,0x77bb,0x77bc,0x790e,0x79ae,
0x7a61,0x7a62,0x7a60,0x7ac4,0x7ac5,0x7c2b,0x7c27,0x7c2a,
0x7c1e,0x7c23,0x7c21,0x7ce7,0x7e54,0x7e55,0x7e5e,0x7e5a,
0x7e61,0x7e52,0x7e59,0x7f48,0x7ff9,0x7ffb,0x8077,0x8076,
0x81cd,0x81cf,0x820a,0x85cf,0x85a9,0x85cd,0x85d0,0x85c9,
0x85b0,0x85ba,0x85b9,0x85a6,0x87ef,0x87ec,0x87f2,0x87e0,
0x8986,0x89b2,0x89f4,0x8b28,0x8b39,0x8b2c,0x8b2b,0x8c50,
0x8d05,0x8e59,0x8e63,0x8e66,0x8e64,0x8e5f,0x8e55,0x8ec0,
0x8f49,0x8f4d,0x9087,0x9083,0x9088,0x91ab,0x91ac,0x91d0,
0x9394,0x938a,0x9396,0x93a2,0x93b3,0x93ae,0x93ac,0x93b0,
0x9398,0x939a,0x9397,0x95d4,0x95d6,0x95d0,0x95d5,0x96e2,
0x96dc,0x96d9,0x96db,0x96de,0x9724,0x97a3,0x97a6,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x97ad,0x97f9,0x984d,0x984f,0x984c,0x984e,0x9853,0x98ba,
0x993e,0x993f,0x993d,0x992e,0x99a5,0x9a0e,0x9ac1,0x9b03,
0x9b06,0x9b4f,0x9b4e,0x9b4d,0x9bca,0x9bc9,0x9bfd,0x9bc8,
0x9bc0,0x9d51,0x9d5d,0x9d60,0x9ee0,0x9f15,0x9f2c,0x5133,
0x56a5,0x58de,0x58df,0x58e2,0x5bf5,0x9f90,0x5eec,0x61f2,
0x61f7,0x61f6,0x61f5,0x6500,0x650f,0x66e0,0x66dd,0x6ae5,
0x6add,0x6ada,0x6ad3,0x701b,0x701f,0x7028,0x701a,0x701d,
0x7015,0x7018,0x7206,0x720d,0x7258,0x72a2,0x7378,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x737a,0x74bd,0x74ca,0x74e3,0x7587,0x7586,0x765f,
0x7661,0x77c7,0x7919,0x79b1,0x7a6b,0x7a69,0x7c3e,0x7c3f,
0x7c38,0x7c3d,0x7c37,0x7c40,0x7e6b,0x7e6d,0x7e79,0x7e69,
0x7e6a,0x7f85,0x7e73,0x7fb6,0x7fb9,0x7fb8,0x81d8,0x85e9,
0x85dd,0x85ea,0x85d5,0x85e4,0x85e5,0x85f7,0x87fb,0x8805,
0x880d,0x87f9,0x87fe,0x8960,0x895f,0x8956,0x895e,0x8b41,
0x8b5c,0x8b58,0x8b49,0x8b5a,0x8b4e,0x8b4f,0x8b46,0x8b59,
0x8d08,0x8d0a,0x8e7c,0x8e72,0x8e87,0x8e76,0x8e6c,0x8e7a,
0x8e74,0x8f54,0x8f4e,0x8fad,0x908a,0x908b,0x91b1,0x91ae,
0x93e1,0x93d1,0x93df,0x93c3,0x93c8,0x93dc,0x93dd,0x93d6,
0x93e2,0x93cd,0x93d8,0x93e4,0x93d7,0x93e8,0x95dc,0x96b4,
0x96e3,0x972a,0x9727,0x9761,0x97dc,0x97fb,0x985e,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x9858,0x985b,0x98bc,0x9945,0x9949,0x9a16,0x9a19,0x9b0d,
0x9be8,0x9be7,0x9bd6,0x9bdb,0x9d89,0x9d61,0x9d72,0x9d6a,
0x9d6c,0x9e92,0x9e97,0x9e93,0x9eb4,0x52f8,0x56a8,0x56b7,
0x56b6,0x56b4,0x56bc,0x58e4,0x5b40,0x5b43,0x5b7d,0x5bf6,
0x5dc9,0x61f8,0x61fa,0x6518,0x6514,0x6519,0x66e6,0x6727,
0x6aec,0x703e,0x7030,0x7032,0x7210,0x737b,0x74cf,0x7662,
0x7665,0x7926,0x792a,0x792c,0x792b,0x7ac7,0x7af6,0x7c4c,
0x7c43,0x7c4d,0x7cef,0x7cf0,0x8fae,0x7e7d,0x7e7c,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x7e82,0x7f4c,0x8000,0x81da,0x8266,0x85fb,0x85f9,
0x8611,0x85fa,0x8606,0x860b,0x8607,0x860a,0x8814,0x8815,
0x8964,0x89ba,0x89f8,0x8b70,0x8b6c,0x8b66,0x8b6f,0x8b5f,
0x8b6b,0x8d0f,0x8d0d,0x8e89,0x8e81,0x8e85,0x8e82,0x91b4,
0x91cb,0x9418,0x9403,0x93fd,0x95e1,0x9730,0x98c4,0x9952,
0x9951,0x99a8,0x9a2b,0x9a30,0x9a37,0x9a35,0x9c13,0x9c0d,
0x9e79,0x9eb5,0x9ee8,0x9f2f,0x9f5f,0x9f63,0x9f61,0x5137,
0x5138,0x56c1,0x56c0,0x56c2,0x5914,0x5c6c,0x5dcd,0x61fc,
0x61fe,0x651d,0x651c,0x6595,0x66e9,0x6afb,0x6b04,0x6afa,
0x6bb2,0x704c,0x721b,0x72a7,0x74d6,0x74d4,0x7669,0x77d3,
0x7c50,0x7e8f,0x7e8c,0x7fbc,0x8617,0x862d,0x861a,0x8823,
0x8822,0x8821,0x881f,0x896a,0x896c,0x89bd,0x8b74,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8b77,0x8b7d,0x8d13,0x8e8a,0x8e8d,0x8e8b,0x8f5f,0x8faf,
0x91ba,0x942e,0x9433,0x9435,0x943a,0x9438,0x9432,0x942b,
0x95e2,0x9738,0x9739,0x9732,0x97ff,0x9867,0x9865,0x9957,
0x9a45,0x9a43,0x9a40,0x9a3e,0x9acf,0x9b54,0x9b51,0x9c2d,
0x9c25,0x9daf,0x9db4,0x9dc2,0x9db8,0x9e9d,0x9eef,0x9f19,
0x9f5c,0x9f66,0x9f67,0x513c,0x513b,0x56c8,0x56ca,0x56c9,
0x5b7f,0x5dd4,0x5dd2,0x5f4e,0x61ff,0x6524,0x6b0a,0x6b61,
0x7051,0x7058,0x7380,0x74e4,0x758a,0x766e,0x766c,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x79b3,0x7c60,0x7c5f,0x807e,0x807d,0x81df,0x8972,
0x896f,0x89fc,0x8b80,0x8d16,0x8d17,0x8e91,0x8e93,0x8f61,
0x9148,0x9444,0x9451,0x9452,0x973d,0x973e,0x97c3,0x97c1,
0x986b,0x9955,0x9a55,0x9a4d,0x9ad2,0x9b1a,0x9c49,0x9c31,
0x9c3e,0x9c3b,0x9dd3,0x9dd7,0x9f34,0x9f6c,0x9f6a,0x9f94,
0x56cc,0x5dd6,0x6200,0x6523,0x652b,0x652a,0x66ec,0x6b10,
0x74da,0x7aca,0x7c64,0x7c63,0x7c65,0x7e93,0x7e96,0x7e94,
0x81e2,0x8638,0x863f,0x8831,0x8b8a,0x9090,0x908f,0x9463,
0x9460,0x9464,0x9768,0x986f,0x995c,0x9a5a,0x9a5b,0x9a57,
0x9ad3,0x9ad4,0x9ad1,0x9c54,0x9c57,0x9c56,0x9de5,0x9e9f,
0x9ef4,0x56d1,0x58e9,0x652c,0x705e,0x7671,0x7672,0x77d7,
0x7f50,0x7f88,0x8836,0x8839,0x8862,0x8b93,0x8b92,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8b96,0x8277,0x8d1b,0x91c0,0x946a,0x9742,0x9748,0x9744,
0x97c6,0x9870,0x9a5f,0x9b22,0x9b58,0x9c5f,0x9df9,0x9dfa,
0x9e7c,0x9e7d,0x9f07,0x9f77,0x9f72,0x5ef3,0x6b16,0x7063,
0x7c6c,0x7c6e,0x883b,0x89c0,0x8ea1,0x91c1,0x9472,0x9470,
0x9871,0x995e,0x9ad6,0x9b23,0x9ecc,0x7064,0x77da,0x8b9a,
0x9477,0x97c9,0x9a62,0x9a65,0x7e9c,0x8b9c,0x8eaa,0x91c5,
0x947d,0x947e,0x947c,0x9c77,0x9c78,0x9ef7,0x8c54,0x947f,
0x9e1a,0x7228,0x9a6a,0x9b31,0x9e1b,0x9e1e,0x7c72,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x4e42,0x4e5c,0x51f5,0x531a,0x5382,0x4e07,0x4e0c,0x4e47,
0x4e8d,0x56d7,0xfa0c,0x5c6e,0x5f73,0x4e0f,0x5187,0x4e0e,
0x4e2e,0x4e93,0x4ec2,0x4ec9,0x4ec8,0x5198,0x52fc,0x536c,
0x53b9,0x5720,0x5903,0x592c,0x5c10,0x5dff,0x65e1,0x6bb3,
0x6bcc,0x6c14,0x723f,0x4e31,0x4e3c,0x4ee8,0x4edc,0x4ee9,
0x4ee1,0x4edd,0x4eda,0x520c,0x531c,0x534c,0x5722,0x5723,
0x5917,0x592f,0x5b81,0x5b84,0x5c12,0x5c3b,0x5c74,0x5c73,
0x5e04,0x5e80,0x5e82,0x5fc9,0x6209,0x6250,0x6c15,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x6c36,0x6c43,0x6c3f,0x6c3b,0x72ae,0x72b0,0x738a,
0x79b8,0x808a,0x961e,0x4f0e,0x4f18,0x4f2c,0x4ef5,0x4f14,
0x4ef1,0x4f00,0x4ef7,0x4f08,0x4f1d,0x4f02,0x4f05,0x4f22,
0x4f13,0x4f04,0x4ef4,0x4f12,0x51b1,0x5213,0x5209,0x5210,
0x52a6,0x5322,0x531f,0x534d,0x538a,0x5407,0x56e1,0x56df,
0x572e,0x572a,0x5734,0x593c,0x5980,0x597c,0x5985,0x597b,
0x597e,0x5977,0x597f,0x5b56,0x5c15,0x5c25,0x5c7c,0x5c7a,
0x5c7b,0x5c7e,0x5ddf,0x5e75,0x5e84,0x5f02,0x5f1a,0x5f74,
0x5fd5,0x5fd4,0x5fcf,0x625c,0x625e,0x6264,0x6261,0x6266,
0x6262,0x6259,0x6260,0x625a,0x6265,0x65ef,0x65ee,0x673e,
0x6739,0x6738,0x673b,0x673a,0x673f,0x673c,0x6733,0x6c18,
0x6c46,0x6c52,0x6c5c,0x6c4f,0x6c4a,0x6c54,0x6c4b,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6c4c,0x7071,0x725e,0x72b4,0x72b5,0x738e,0x752a,0x767f,
0x7a75,0x7f51,0x8278,0x827c,0x8280,0x827d,0x827f,0x864d,
0x897e,0x9099,0x9097,0x9098,0x909b,0x9094,0x9622,0x9624,
0x9620,0x9623,0x4f56,0x4f3b,0x4f62,0x4f49,0x4f53,0x4f64,
0x4f3e,0x4f67,0x4f52,0x4f5f,0x4f41,0x4f58,0x4f2d,0x4f33,
0x4f3f,0x4f61,0x518f,0x51b9,0x521c,0x521e,0x5221,0x52ad,
0x52ae,0x5309,0x5363,0x5372,0x538e,0x538f,0x5430,0x5437,
0x542a,0x5454,0x5445,0x5419,0x541c,0x5425,0x5418,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x543d,0x544f,0x5441,0x5428,0x5424,0x5447,0x56ee,
0x56e7,0x56e5,0x5741,0x5745,0x574c,0x5749,0x574b,0x5752,
0x5906,0x5940,0x59a6,0x5998,0x59a0,0x5997,0x598e,0x59a2,
0x5990,0x598f,0x59a7,0x59a1,0x5b8e,0x5b92,0x5c28,0x5c2a,
0x5c8d,0x5c8f,0x5c88,0x5c8b,0x5c89,0x5c92,0x5c8a,0x5c86,
0x5c93,0x5c95,0x5de0,0x5e0a,0x5e0e,0x5e8b,0x5e89,0x5e8c,
0x5e88,0x5e8d,0x5f05,0x5f1d,0x5f78,0x5f76,0x5fd2,0x5fd1,
0x5fd0,0x5fed,0x5fe8,0x5fee,0x5ff3,0x5fe1,0x5fe4,0x5fe3,
0x5ffa,0x5fef,0x5ff7,0x5ffb,0x6000,0x5ff4,0x623a,0x6283,
0x628c,0x628e,0x628f,0x6294,0x6287,0x6271,0x627b,0x627a,
0x6270,0x6281,0x6288,0x6277,0x627d,0x6272,0x6274,0x6537,
0x65f0,0x65f4,0x65f3,0x65f2,0x65f5,0x6745,0x6747,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6759,0x6755,0x674c,0x6748,0x675d,0x674d,0x675a,0x674b,
0x6bd0,0x6c19,0x6c1a,0x6c78,0x6c67,0x6c6b,0x6c84,0x6c8b,
0x6c8f,0x6c71,0x6c6f,0x6c69,0x6c9a,0x6c6d,0x6c87,0x6c95,
0x6c9c,0x6c66,0x6c73,0x6c65,0x6c7b,0x6c8e,0x7074,0x707a,
0x7263,0x72bf,0x72bd,0x72c3,0x72c6,0x72c1,0x72ba,0x72c5,
0x7395,0x7397,0x7393,0x7394,0x7392,0x753a,0x7539,0x7594,
0x7595,0x7681,0x793d,0x8034,0x8095,0x8099,0x8090,0x8092,
0x809c,0x8290,0x828f,0x8285,0x828e,0x8291,0x8293,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x828a,0x8283,0x8284,0x8c78,0x8fc9,0x8fbf,0x909f,
0x90a1,0x90a5,0x909e,0x90a7,0x90a0,0x9630,0x9628,0x962f,
0x962d,0x4e33,0x4f98,0x4f7c,0x4f85,0x4f7d,0x4f80,0x4f87,
0x4f76,0x4f74,0x4f89,0x4f84,0x4f77,0x4f4c,0x4f97,0x4f6a,
0x4f9a,0x4f79,0x4f81,0x4f78,0x4f90,0x4f9c,0x4f94,0x4f9e,
0x4f92,0x4f82,0x4f95,0x4f6b,0x4f6e,0x519e,0x51bc,0x51be,
0x5235,0x5232,0x5233,0x5246,0x5231,0x52bc,0x530a,0x530b,
0x533c,0x5392,0x5394,0x5487,0x547f,0x5481,0x5491,0x5482,
0x5488,0x546b,0x547a,0x547e,0x5465,0x546c,0x5474,0x5466,
0x548d,0x546f,0x5461,0x5460,0x5498,0x5463,0x5467,0x5464,
0x56f7,0x56f9,0x576f,0x5772,0x576d,0x576b,0x5771,0x5770,
0x5776,0x5780,0x5775,0x577b,0x5773,0x5774,0x5762,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5768,0x577d,0x590c,0x5945,0x59b5,0x59ba,0x59cf,0x59ce,
0x59b2,0x59cc,0x59c1,0x59b6,0x59bc,0x59c3,0x59d6,0x59b1,
0x59bd,0x59c0,0x59c8,0x59b4,0x59c7,0x5b62,0x5b65,0x5b93,
0x5b95,0x5c44,0x5c47,0x5cae,0x5ca4,0x5ca0,0x5cb5,0x5caf,
0x5ca8,0x5cac,0x5c9f,0x5ca3,0x5cad,0x5ca2,0x5caa,0x5ca7,
0x5c9d,0x5ca5,0x5cb6,0x5cb0,0x5ca6,0x5e17,0x5e14,0x5e19,
0x5f28,0x5f22,0x5f23,0x5f24,0x5f54,0x5f82,0x5f7e,0x5f7d,
0x5fde,0x5fe5,0x602d,0x6026,0x6019,0x6032,0x600b,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x6034,0x600a,0x6017,0x6033,0x601a,0x601e,0x602c,
0x6022,0x600d,0x6010,0x602e,0x6013,0x6011,0x600c,0x6009,
0x601c,0x6214,0x623d,0x62ad,0x62b4,0x62d1,0x62be,0x62aa,
0x62b6,0x62ca,0x62ae,0x62b3,0x62af,0x62bb,0x62a9,0x62b0,
0x62b8,0x653d,0x65a8,0x65bb,0x6609,0x65fc,0x6604,0x6612,
0x6608,0x65fb,0x6603,0x660b,0x660d,0x6605,0x65fd,0x6611,
0x6610,0x66f6,0x670a,0x6785,0x676c,0x678e,0x6792,0x6776,
0x677b,0x6798,0x6786,0x6784,0x6774,0x678d,0x678c,0x677a,
0x679f,0x6791,0x6799,0x6783,0x677d,0x6781,0x6778,0x6779,
0x6794,0x6b25,0x6b80,0x6b7e,0x6bde,0x6c1d,0x6c93,0x6cec,
0x6ceb,0x6cee,0x6cd9,0x6cb6,0x6cd4,0x6cad,0x6ce7,0x6cb7,
0x6cd0,0x6cc2,0x6cba,0x6cc3,0x6cc6,0x6ced,0x6cf2,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6cd2,0x6cdd,0x6cb4,0x6c8a,0x6c9d,0x6c80,0x6cde,0x6cc0,
0x6d30,0x6ccd,0x6cc7,0x6cb0,0x6cf9,0x6ccf,0x6ce9,0x6cd1,
0x7094,0x7098,0x7085,0x7093,0x7086,0x7084,0x7091,0x7096,
0x7082,0x709a,0x7083,0x726a,0x72d6,0x72cb,0x72d8,0x72c9,
0x72dc,0x72d2,0x72d4,0x72da,0x72cc,0x72d1,0x73a4,0x73a1,
0x73ad,0x73a6,0x73a2,0x73a0,0x73ac,0x739d,0x74dd,0x74e8,
0x753f,0x7540,0x753e,0x758c,0x7598,0x76af,0x76f3,0x76f1,
0x76f0,0x76f5,0x77f8,0x77fc,0x77f9,0x77fb,0x77fa,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x77f7,0x7942,0x793f,0x79c5,0x7a78,0x7a7b,0x7afb,
0x7c75,0x7cfd,0x8035,0x808f,0x80ae,0x80a3,0x80b8,0x80b5,
0x80ad,0x8220,0x82a0,0x82c0,0x82ab,0x829a,0x8298,0x829b,
0x82b5,0x82a7,0x82ae,0x82bc,0x829e,0x82ba,0x82b4,0x82a8,
0x82a1,0x82a9,0x82c2,0x82a4,0x82c3,0x82b6,0x82a2,0x8670,
0x866f,0x866d,0x866e,0x8c56,0x8fd2,0x8fcb,0x8fd3,0x8fcd,
0x8fd6,0x8fd5,0x8fd7,0x90b2,0x90b4,0x90af,0x90b3,0x90b0,
0x9639,0x963d,0x963c,0x963a,0x9643,0x4fcd,0x4fc5,0x4fd3,
0x4fb2,0x4fc9,0x4fcb,0x4fc1,0x4fd4,0x4fdc,0x4fd9,0x4fbb,
0x4fb3,0x4fdb,0x4fc7,0x4fd6,0x4fba,0x4fc0,0x4fb9,0x4fec,
0x5244,0x5249,0x52c0,0x52c2,0x533d,0x537c,0x5397,0x5396,
0x5399,0x5398,0x54ba,0x54a1,0x54ad,0x54a5,0x54cf,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x54c3,0x830d,0x54b7,0x54ae,0x54d6,0x54b6,0x54c5,0x54c6,
0x54a0,0x5470,0x54bc,0x54a2,0x54be,0x5472,0x54de,0x54b0,
0x57b5,0x579e,0x579f,0x57a4,0x578c,0x5797,0x579d,0x579b,
0x5794,0x5798,0x578f,0x5799,0x57a5,0x579a,0x5795,0x58f4,
0x590d,0x5953,0x59e1,0x59de,0x59ee,0x5a00,0x59f1,0x59dd,
0x59fa,0x59fd,0x59fc,0x59f6,0x59e4,0x59f2,0x59f7,0x59db,
0x59e9,0x59f3,0x59f5,0x59e0,0x59fe,0x59f4,0x59ed,0x5ba8,
0x5c4c,0x5cd0,0x5cd8,0x5ccc,0x5cd7,0x5ccb,0x5cdb,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x5cde,0x5cda,0x5cc9,0x5cc7,0x5cca,0x5cd6,0x5cd3,
0x5cd4,0x5ccf,0x5cc8,0x5cc6,0x5cce,0x5cdf,0x5cf8,0x5df9,
0x5e21,0x5e22,0x5e23,0x5e20,0x5e24,0x5eb0,0x5ea4,0x5ea2,
0x5e9b,0x5ea3,0x5ea5,0x5f07,0x5f2e,0x5f56,0x5f86,0x6037,
0x6039,0x6054,0x6072,0x605e,0x6045,0x6053,0x6047,0x6049,
0x605b,0x604c,0x6040,0x6042,0x605f,0x6024,0x6044,0x6058,
0x6066,0x606e,0x6242,0x6243,0x62cf,0x630d,0x630b,0x62f5,
0x630e,0x6303,0x62eb,0x62f9,0x630f,0x630c,0x62f8,0x62f6,
0x6300,0x6313,0x6314,0x62fa,0x6315,0x62fb,0x62f0,0x6541,
0x6543,0x65aa,0x65bf,0x6636,0x6621,0x6632,0x6635,0x661c,
0x6626,0x6622,0x6633,0x662b,0x663a,0x661d,0x6634,0x6639,
0x662e,0x670f,0x6710,0x67c1,0x67f2,0x67c8,0x67ba,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x67dc,0x67bb,0x67f8,0x67d8,0x67c0,0x67b7,0x67c5,0x67eb,
0x67e4,0x67df,0x67b5,0x67cd,0x67b3,0x67f7,0x67f6,0x67ee,
0x67e3,0x67c2,0x67b9,0x67ce,0x67e7,0x67f0,0x67b2,0x67fc,
0x67c6,0x67ed,0x67cc,0x67ae,0x67e6,0x67db,0x67fa,0x67c9,
0x67ca,0x67c3,0x67ea,0x67cb,0x6b28,0x6b82,0x6b84,0x6bb6,
0x6bd6,0x6bd8,0x6be0,0x6c20,0x6c21,0x6d28,0x6d34,0x6d2d,
0x6d1f,0x6d3c,0x6d3f,0x6d12,0x6d0a,0x6cda,0x6d33,0x6d04,
0x6d19,0x6d3a,0x6d1a,0x6d11,0x6d00,0x6d1d,0x6d42,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x6d01,0x6d18,0x6d37,0x6d03,0x6d0f,0x6d40,0x6d07,
0x6d20,0x6d2c,0x6d08,0x6d22,0x6d09,0x6d10,0x70b7,0x709f,
0x70be,0x70b1,0x70b0,0x70a1,0x70b4,0x70b5,0x70a9,0x7241,
0x7249,0x724a,0x726c,0x7270,0x7273,0x726e,0x72ca,0x72e4,
0x72e8,0x72eb,0x72df,0x72ea,0x72e6,0x72e3,0x7385,0x73cc,
0x73c2,0x73c8,0x73c5,0x73b9,0x73b6,0x73b5,0x73b4,0x73eb,
0x73bf,0x73c7,0x73be,0x73c3,0x73c6,0x73b8,0x73cb,0x74ec,
0x74ee,0x752e,0x7547,0x7548,0x75a7,0x75aa,0x7679,0x76c4,
0x7708,0x7703,0x7704,0x7705,0x770a,0x76f7,0x76fb,0x76fa,
0x77e7,0x77e8,0x7806,0x7811,0x7812,0x7805,0x7810,0x780f,
0x780e,0x7809,0x7803,0x7813,0x794a,0x794c,0x794b,0x7945,
0x7944,0x79d5,0x79cd,0x79cf,0x79d6,0x79ce,0x7a80,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x7a7e,0x7ad1,0x7b00,0x7b01,0x7c7a,0x7c78,0x7c79,0x7c7f,
0x7c80,0x7c81,0x7d03,0x7d08,0x7d01,0x7f58,0x7f91,0x7f8d,
0x7fbe,0x8007,0x800e,0x800f,0x8014,0x8037,0x80d8,0x80c7,
0x80e0,0x80d1,0x80c8,0x80c2,0x80d0,0x80c5,0x80e3,0x80d9,
0x80dc,0x80ca,0x80d5,0x80c9,0x80cf,0x80d7,0x80e6,0x80cd,
0x81ff,0x8221,0x8294,0x82d9,0x82fe,0x82f9,0x8307,0x82e8,
0x8300,0x82d5,0x833a,0x82eb,0x82d6,0x82f4,0x82ec,0x82e1,
0x82f2,0x82f5,0x830c,0x82fb,0x82f6,0x82f0,0x82ea,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x82e4,0x82e0,0x82fa,0x82f3,0x82ed,0x8677,0x8674,
0x867c,0x8673,0x8841,0x884e,0x8867,0x886a,0x8869,0x89d3,
0x8a04,0x8a07,0x8d72,0x8fe3,0x8fe1,0x8fee,0x8fe0,0x90f1,
0x90bd,0x90bf,0x90d5,0x90c5,0x90be,0x90c7,0x90cb,0x90c8,
0x91d4,0x91d3,0x9654,0x964f,0x9651,0x9653,0x964a,0x964e,
0x501e,0x5005,0x5007,0x5013,0x5022,0x5030,0x501b,0x4ff5,
0x4ff4,0x5033,0x5037,0x502c,0x4ff6,0x4ff7,0x5017,0x501c,
0x5020,0x5027,0x5035,0x502f,0x5031,0x500e,0x515a,0x5194,
0x5193,0x51ca,0x51c4,0x51c5,0x51c8,0x51ce,0x5261,0x525a,
0x5252,0x525e,0x525f,0x5255,0x5262,0x52cd,0x530e,0x539e,
0x5526,0x54e2,0x5517,0x5512,0x54e7,0x54f3,0x54e4,0x551a,
0x54ff,0x5504,0x5508,0x54eb,0x5511,0x5505,0x54f1,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x550a,0x54fb,0x54f7,0x54f8,0x54e0,0x550e,0x5503,0x550b,
0x5701,0x5702,0x57cc,0x5832,0x57d5,0x57d2,0x57ba,0x57c6,
0x57bd,0x57bc,0x57b8,0x57b6,0x57bf,0x57c7,0x57d0,0x57b9,
0x57c1,0x590e,0x594a,0x5a19,0x5a16,0x5a2d,0x5a2e,0x5a15,
0x5a0f,0x5a17,0x5a0a,0x5a1e,0x5a33,0x5b6c,0x5ba7,0x5bad,
0x5bac,0x5c03,0x5c56,0x5c54,0x5cec,0x5cff,0x5cee,0x5cf1,
0x5cf7,0x5d00,0x5cf9,0x5e29,0x5e28,0x5ea8,0x5eae,0x5eaa,
0x5eac,0x5f33,0x5f30,0x5f67,0x605d,0x605a,0x6067,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x6041,0x60a2,0x6088,0x6080,0x6092,0x6081,0x609d,
0x6083,0x6095,0x609b,0x6097,0x6087,0x609c,0x608e,0x6219,
0x6246,0x62f2,0x6310,0x6356,0x632c,0x6344,0x6345,0x6336,
0x6343,0x63e4,0x6339,0x634b,0x634a,0x633c,0x6329,0x6341,
0x6334,0x6358,0x6354,0x6359,0x632d,0x6347,0x6333,0x635a,
0x6351,0x6338,0x6357,0x6340,0x6348,0x654a,0x6546,0x65c6,
0x65c3,0x65c4,0x65c2,0x664a,0x665f,0x6647,0x6651,0x6712,
0x6713,0x681f,0x681a,0x6849,0x6832,0x6833,0x683b,0x684b,
0x684f,0x6816,0x6831,0x681c,0x6835,0x682b,0x682d,0x682f,
0x684e,0x6844,0x6834,0x681d,0x6812,0x6814,0x6826,0x6828,
0x682e,0x684d,0x683a,0x6825,0x6820,0x6b2c,0x6b2f,0x6b2d,
0x6b31,0x6b34,0x6b6d,0x8082,0x6b88,0x6be6,0x6be4,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6be8,0x6be3,0x6be2,0x6be7,0x6c25,0x6d7a,0x6d63,0x6d64,
0x6d76,0x6d0d,0x6d61,0x6d92,0x6d58,0x6d62,0x6d6d,0x6d6f,
0x6d91,0x6d8d,0x6def,0x6d7f,0x6d86,0x6d5e,0x6d67,0x6d60,
0x6d97,0x6d70,0x6d7c,0x6d5f,0x6d82,0x6d98,0x6d2f,0x6d68,
0x6d8b,0x6d7e,0x6d80,0x6d84,0x6d16,0x6d83,0x6d7b,0x6d7d,
0x6d75,0x6d90,0x70dc,0x70d3,0x70d1,0x70dd,0x70cb,0x7f39,
0x70e2,0x70d7,0x70d2,0x70de,0x70e0,0x70d4,0x70cd,0x70c5,
0x70c6,0x70c7,0x70da,0x70ce,0x70e1,0x7242,0x7278,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x7277,0x7276,0x7300,0x72fa,0x72f4,0x72fe,0x72f6,
0x72f3,0x72fb,0x7301,0x73d3,0x73d9,0x73e5,0x73d6,0x73bc,
0x73e7,0x73e3,0x73e9,0x73dc,0x73d2,0x73db,0x73d4,0x73dd,
0x73da,0x73d7,0x73d8,0x73e8,0x74de,0x74df,0x74f4,0x74f5,
0x7521,0x755b,0x755f,0x75b0,0x75c1,0x75bb,0x75c4,0x75c0,
0x75bf,0x75b6,0x75ba,0x768a,0x76c9,0x771d,0x771b,0x7710,
0x7713,0x7712,0x7723,0x7711,0x7715,0x7719,0x771a,0x7722,
0x7727,0x7823,0x782c,0x7822,0x7835,0x782f,0x7828,0x782e,
0x782b,0x7821,0x7829,0x7833,0x782a,0x7831,0x7954,0x795b,
0x794f,0x795c,0x7953,0x7952,0x7951,0x79eb,0x79ec,0x79e0,
0x79ee,0x79ed,0x79ea,0x79dc,0x79de,0x79dd,0x7a86,0x7a89,
0x7a85,0x7a8b,0x7a8c,0x7a8a,0x7a87,0x7ad8,0x7b10,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x7b04,0x7b13,0x7b05,0x7b0f,0x7b08,0x7b0a,0x7b0e,0x7b09,
0x7b12,0x7c84,0x7c91,0x7c8a,0x7c8c,0x7c88,0x7c8d,0x7c85,
0x7d1e,0x7d1d,0x7d11,0x7d0e,0x7d18,0x7d16,0x7d13,0x7d1f,
0x7d12,0x7d0f,0x7d0c,0x7f5c,0x7f61,0x7f5e,0x7f60,0x7f5d,
0x7f5b,0x7f96,0x7f92,0x7fc3,0x7fc2,0x7fc0,0x8016,0x803e,
0x8039,0x80fa,0x80f2,0x80f9,0x80f5,0x8101,0x80fb,0x8100,
0x8201,0x822f,0x8225,0x8333,0x832d,0x8344,0x8319,0x8351,
0x8325,0x8356,0x833f,0x8341,0x8326,0x831c,0x8322,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8342,0x834e,0x831b,0x832a,0x8308,0x833c,0x834d,
0x8316,0x8324,0x8320,0x8337,0x832f,0x8329,0x8347,0x8345,
0x834c,0x8353,0x831e,0x832c,0x834b,0x8327,0x8348,0x8653,
0x8652,0x86a2,0x86a8,0x8696,0x868d,0x8691,0x869e,0x8687,
0x8697,0x8686,0x868b,0x869a,0x8685,0x86a5,0x8699,0x86a1,
0x86a7,0x8695,0x8698,0x868e,0x869d,0x8690,0x8694,0x8843,
0x8844,0x886d,0x8875,0x8876,0x8872,0x8880,0x8871,0x887f,
0x886f,0x8883,0x887e,0x8874,0x887c,0x8a12,0x8c47,0x8c57,
0x8c7b,0x8ca4,0x8ca3,0x8d76,0x8d78,0x8db5,0x8db7,0x8db6,
0x8ed1,0x8ed3,0x8ffe,0x8ff5,0x9002,0x8fff,0x8ffb,0x9004,
0x8ffc,0x8ff6,0x90d6,0x90e0,0x90d9,0x90da,0x90e3,0x90df,
0x90e5,0x90d8,0x90db,0x90d7,0x90dc,0x90e4,0x9150,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x914e,0x914f,0x91d5,0x91e2,0x91da,0x965c,0x965f,0x96bc,
0x98e3,0x9adf,0x9b2f,0x4e7f,0x5070,0x506a,0x5061,0x505e,
0x5060,0x5053,0x504b,0x505d,0x5072,0x5048,0x504d,0x5041,
0x505b,0x504a,0x5062,0x5015,0x5045,0x505f,0x5069,0x506b,
0x5063,0x5064,0x5046,0x5040,0x506e,0x5073,0x5057,0x5051,
0x51d0,0x526b,0x526d,0x526c,0x526e,0x52d6,0x52d3,0x532d,
0x539c,0x5575,0x5576,0x553c,0x554d,0x5550,0x5534,0x552a,
0x5551,0x5562,0x5536,0x5535,0x5530,0x5552,0x5545,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x550c,0x5532,0x5565,0x554e,0x5539,0x5548,0x552d,
0x553b,0x5540,0x554b,0x570a,0x5707,0x57fb,0x5814,0x57e2,
0x57f6,0x57dc,0x57f4,0x5800,0x57ed,0x57fd,0x5808,0x57f8,
0x580b,0x57f3,0x57cf,0x5807,0x57ee,0x57e3,0x57f2,0x57e5,
0x57ec,0x57e1,0x580e,0x57fc,0x5810,0x57e7,0x5801,0x580c,
0x57f1,0x57e9,0x57f0,0x580d,0x5804,0x595c,0x5a60,0x5a58,
0x5a55,0x5a67,0x5a5e,0x5a38,0x5a35,0x5a6d,0x5a50,0x5a5f,
0x5a65,0x5a6c,0x5a53,0x5a64,0x5a57,0x5a43,0x5a5d,0x5a52,
0x5a44,0x5a5b,0x5a48,0x5a8e,0x5a3e,0x5a4d,0x5a39,0x5a4c,
0x5a70,0x5a69,0x5a47,0x5a51,0x5a56,0x5a42,0x5a5c,0x5b72,
0x5b6e,0x5bc1,0x5bc0,0x5c59,0x5d1e,0x5d0b,0x5d1d,0x5d1a,
0x5d20,0x5d0c,0x5d28,0x5d0d,0x5d26,0x5d25,0x5d0f,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5d30,0x5d12,0x5d23,0x5d1f,0x5d2e,0x5e3e,0x5e34,0x5eb1,
0x5eb4,0x5eb9,0x5eb2,0x5eb3,0x5f36,0x5f38,0x5f9b,0x5f96,
0x5f9f,0x608a,0x6090,0x6086,0x60be,0x60b0,0x60ba,0x60d3,
0x60d4,0x60cf,0x60e4,0x60d9,0x60dd,0x60c8,0x60b1,0x60db,
0x60b7,0x60ca,0x60bf,0x60c3,0x60cd,0x60c0,0x6332,0x6365,
0x638a,0x6382,0x637d,0x63bd,0x639e,0x63ad,0x639d,0x6397,
0x63ab,0x638e,0x636f,0x6387,0x6390,0x636e,0x63af,0x6375,
0x639c,0x636d,0x63ae,0x637c,0x63a4,0x633b,0x639f,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x6378,0x6385,0x6381,0x6391,0x638d,0x6370,0x6553,
0x65cd,0x6665,0x6661,0x665b,0x6659,0x665c,0x6662,0x6718,
0x6879,0x6887,0x6890,0x689c,0x686d,0x686e,0x68ae,0x68ab,
0x6956,0x686f,0x68a3,0x68ac,0x68a9,0x6875,0x6874,0x68b2,
0x688f,0x6877,0x6892,0x687c,0x686b,0x6872,0x68aa,0x6880,
0x6871,0x687e,0x689b,0x6896,0x688b,0x68a0,0x6889,0x68a4,
0x6878,0x687b,0x6891,0x688c,0x688a,0x687d,0x6b36,0x6b33,
0x6b37,0x6b38,0x6b91,0x6b8f,0x6b8d,0x6b8e,0x6b8c,0x6c2a,
0x6dc0,0x6dab,0x6db4,0x6db3,0x6e74,0x6dac,0x6de9,0x6de2,
0x6db7,0x6df6,0x6dd4,0x6e00,0x6dc8,0x6de0,0x6ddf,0x6dd6,
0x6dbe,0x6de5,0x6ddc,0x6ddd,0x6ddb,0x6df4,0x6dca,0x6dbd,
0x6ded,0x6df0,0x6dba,0x6dd5,0x6dc2,0x6dcf,0x6dc9,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6dd0,0x6df2,0x6dd3,0x6dfd,0x6dd7,0x6dcd,0x6de3,0x6dbb,
0x70fa,0x710d,0x70f7,0x7117,0x70f4,0x710c,0x70f0,0x7104,
0x70f3,0x7110,0x70fc,0x70ff,0x7106,0x7113,0x7100,0x70f8,
0x70f6,0x710b,0x7102,0x710e,0x727e,0x727b,0x727c,0x727f,
0x731d,0x7317,0x7307,0x7311,0x7318,0x730a,0x7308,0x72ff,
0x730f,0x731e,0x7388,0x73f6,0x73f8,0x73f5,0x7404,0x7401,
0x73fd,0x7407,0x7400,0x73fa,0x73fc,0x73ff,0x740c,0x740b,
0x73f4,0x7408,0x7564,0x7563,0x75ce,0x75d2,0x75cf,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x75cb,0x75cc,0x75d1,0x75d0,0x768f,0x7689,0x76d3,
0x7739,0x772f,0x772d,0x7731,0x7732,0x7734,0x7733,0x773d,
0x7725,0x773b,0x7735,0x7848,0x7852,0x7849,0x784d,0x784a,
0x784c,0x7826,0x7845,0x7850,0x7964,0x7967,0x7969,0x796a,
0x7963,0x796b,0x7961,0x79bb,0x79fa,0x79f8,0x79f6,0x79f7,
0x7a8f,0x7a94,0x7a90,0x7b35,0x7b47,0x7b34,0x7b25,0x7b30,
0x7b22,0x7b24,0x7b33,0x7b18,0x7b2a,0x7b1d,0x7b31,0x7b2b,
0x7b2d,0x7b2f,0x7b32,0x7b38,0x7b1a,0x7b23,0x7c94,0x7c98,
0x7c96,0x7ca3,0x7d35,0x7d3d,0x7d38,0x7d36,0x7d3a,0x7d45,
0x7d2c,0x7d29,0x7d41,0x7d47,0x7d3e,0x7d3f,0x7d4a,0x7d3b,
0x7d28,0x7f63,0x7f95,0x7f9c,0x7f9d,0x7f9b,0x7fca,0x7fcb,
0x7fcd,0x7fd0,0x7fd1,0x7fc7,0x7fcf,0x7fc9,0x801f,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x801e,0x801b,0x8047,0x8043,0x8048,0x8118,0x8125,0x8119,
0x811b,0x812d,0x811f,0x812c,0x811e,0x8121,0x8115,0x8127,
0x811d,0x8122,0x8211,0x8238,0x8233,0x823a,0x8234,0x8232,
0x8274,0x8390,0x83a3,0x83a8,0x838d,0x837a,0x8373,0x83a4,
0x8374,0x838f,0x8381,0x8395,0x8399,0x8375,0x8394,0x83a9,
0x837d,0x8383,0x838c,0x839d,0x839b,0x83aa,0x838b,0x837e,
0x83a5,0x83af,0x8388,0x8397,0x83b0,0x837f,0x83a6,0x8387,
0x83ae,0x8376,0x839a,0x8659,0x8656,0x86bf,0x86b7,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x86c2,0x86c1,0x86c5,0x86ba,0x86b0,0x86c8,0x86b9,
0x86b3,0x86b8,0x86cc,0x86b4,0x86bb,0x86bc,0x86c3,0x86bd,
0x86be,0x8852,0x8889,0x8895,0x88a8,0x88a2,0x88aa,0x889a,
0x8891,0x88a1,0x889f,0x8898,0x88a7,0x8899,0x889b,0x8897,
0x88a4,0x88ac,0x888c,0x8893,0x888e,0x8982,0x89d6,0x89d9,
0x89d5,0x8a30,0x8a27,0x8a2c,0x8a1e,0x8c39,0x8c3b,0x8c5c,
0x8c5d,0x8c7d,0x8ca5,0x8d7d,0x8d7b,0x8d79,0x8dbc,0x8dc2,
0x8db9,0x8dbf,0x8dc1,0x8ed8,0x8ede,0x8edd,0x8edc,0x8ed7,
0x8ee0,0x8ee1,0x9024,0x900b,0x9011,0x901c,0x900c,0x9021,
0x90ef,0x90ea,0x90f0,0x90f4,0x90f2,0x90f3,0x90d4,0x90eb,
0x90ec,0x90e9,0x9156,0x9158,0x915a,0x9153,0x9155,0x91ec,
0x91f4,0x91f1,0x91f3,0x91f8,0x91e4,0x91f9,0x91ea,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x91eb,0x91f7,0x91e8,0x91ee,0x957a,0x9586,0x9588,0x967c,
0x966d,0x966b,0x9671,0x966f,0x96bf,0x976a,0x9804,0x98e5,
0x9997,0x509b,0x5095,0x5094,0x509e,0x508b,0x50a3,0x5083,
0x508c,0x508e,0x509d,0x5068,0x509c,0x5092,0x5082,0x5087,
0x515f,0x51d4,0x5312,0x5311,0x53a4,0x53a7,0x5591,0x55a8,
0x55a5,0x55ad,0x5577,0x5645,0x55a2,0x5593,0x5588,0x558f,
0x55b5,0x5581,0x55a3,0x5592,0x55a4,0x557d,0x558c,0x55a6,
0x557f,0x5595,0x55a1,0x558e,0x570c,0x5829,0x5837,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x5819,0x581e,0x5827,0x5823,0x5828,0x57f5,0x5848,
0x5825,0x581c,0x581b,0x5833,0x583f,0x5836,0x582e,0x5839,
0x5838,0x582d,0x582c,0x583b,0x5961,0x5aaf,0x5a94,0x5a9f,
0x5a7a,0x5aa2,0x5a9e,0x5a78,0x5aa6,0x5a7c,0x5aa5,0x5aac,
0x5a95,0x5aae,0x5a37,0x5a84,0x5a8a,0x5a97,0x5a83,0x5a8b,
0x5aa9,0x5a7b,0x5a7d,0x5a8c,0x5a9c,0x5a8f,0x5a93,0x5a9d,
0x5bea,0x5bcd,0x5bcb,0x5bd4,0x5bd1,0x5bca,0x5bce,0x5c0c,
0x5c30,0x5d37,0x5d43,0x5d6b,0x5d41,0x5d4b,0x5d3f,0x5d35,
0x5d51,0x5d4e,0x5d55,0x5d33,0x5d3a,0x5d52,0x5d3d,0x5d31,
0x5d59,0x5d42,0x5d39,0x5d49,0x5d38,0x5d3c,0x5d32,0x5d36,
0x5d40,0x5d45,0x5e44,0x5e41,0x5f58,0x5fa6,0x5fa5,0x5fab,
0x60c9,0x60b9,0x60cc,0x60e2,0x60ce,0x60c4,0x6114,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x60f2,0x610a,0x6116,0x6105,0x60f5,0x6113,0x60f8,0x60fc,
0x60fe,0x60c1,0x6103,0x6118,0x611d,0x6110,0x60ff,0x6104,
0x610b,0x624a,0x6394,0x63b1,0x63b0,0x63ce,0x63e5,0x63e8,
0x63ef,0x63c3,0x649d,0x63f3,0x63ca,0x63e0,0x63f6,0x63d5,
0x63f2,0x63f5,0x6461,0x63df,0x63be,0x63dd,0x63dc,0x63c4,
0x63d8,0x63d3,0x63c2,0x63c7,0x63cc,0x63cb,0x63c8,0x63f0,
0x63d7,0x63d9,0x6532,0x6567,0x656a,0x6564,0x655c,0x6568,
0x6565,0x658c,0x659d,0x659e,0x65ae,0x65d0,0x65d2,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x667c,0x666c,0x667b,0x6680,0x6671,0x6679,0x666a,
0x6672,0x6701,0x690c,0x68d3,0x6904,0x68dc,0x692a,0x68ec,
0x68ea,0x68f1,0x690f,0x68d6,0x68f7,0x68eb,0x68e4,0x68f6,
0x6913,0x6910,0x68f3,0x68e1,0x6907,0x68cc,0x6908,0x6970,
0x68b4,0x6911,0x68ef,0x68c6,0x6914,0x68f8,0x68d0,0x68fd,
0x68fc,0x68e8,0x690b,0x690a,0x6917,0x68ce,0x68c8,0x68dd,
0x68de,0x68e6,0x68f4,0x68d1,0x6906,0x68d4,0x68e9,0x6915,
0x6925,0x68c7,0x6b39,0x6b3b,0x6b3f,0x6b3c,0x6b94,0x6b97,
0x6b99,0x6b95,0x6bbd,0x6bf0,0x6bf2,0x6bf3,0x6c30,0x6dfc,
0x6e46,0x6e47,0x6e1f,0x6e49,0x6e88,0x6e3c,0x6e3d,0x6e45,
0x6e62,0x6e2b,0x6e3f,0x6e41,0x6e5d,0x6e73,0x6e1c,0x6e33,
0x6e4b,0x6e40,0x6e51,0x6e3b,0x6e03,0x6e2e,0x6e5e,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6e68,0x6e5c,0x6e61,0x6e31,0x6e28,0x6e60,0x6e71,0x6e6b,
0x6e39,0x6e22,0x6e30,0x6e53,0x6e65,0x6e27,0x6e78,0x6e64,
0x6e77,0x6e55,0x6e79,0x6e52,0x6e66,0x6e35,0x6e36,0x6e5a,
0x7120,0x711e,0x712f,0x70fb,0x712e,0x7131,0x7123,0x7125,
0x7122,0x7132,0x711f,0x7128,0x713a,0x711b,0x724b,0x725a,
0x7288,0x7289,0x7286,0x7285,0x728b,0x7312,0x730b,0x7330,
0x7322,0x7331,0x7333,0x7327,0x7332,0x732d,0x7326,0x7323,
0x7335,0x730c,0x742e,0x742c,0x7430,0x742b,0x7416,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x741a,0x7421,0x742d,0x7431,0x7424,0x7423,0x741d,
0x7429,0x7420,0x7432,0x74fb,0x752f,0x756f,0x756c,0x75e7,
0x75da,0x75e1,0x75e6,0x75dd,0x75df,0x75e4,0x75d7,0x7695,
0x7692,0x76da,0x7746,0x7747,0x7744,0x774d,0x7745,0x774a,
0x774e,0x774b,0x774c,0x77de,0x77ec,0x7860,0x7864,0x7865,
0x785c,0x786d,0x7871,0x786a,0x786e,0x7870,0x7869,0x7868,
0x785e,0x7862,0x7974,0x7973,0x7972,0x7970,0x7a02,0x7a0a,
0x7a03,0x7a0c,0x7a04,0x7a99,0x7ae6,0x7ae4,0x7b4a,0x7b3b,
0x7b44,0x7b48,0x7b4c,0x7b4e,0x7b40,0x7b58,0x7b45,0x7ca2,
0x7c9e,0x7ca8,0x7ca1,0x7d58,0x7d6f,0x7d63,0x7d53,0x7d56,
0x7d67,0x7d6a,0x7d4f,0x7d6d,0x7d5c,0x7d6b,0x7d52,0x7d54,
0x7d69,0x7d51,0x7d5f,0x7d4e,0x7f3e,0x7f3f,0x7f65,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x7f66,0x7fa2,0x7fa0,0x7fa1,0x7fd7,0x8051,0x804f,0x8050,
0x80fe,0x80d4,0x8143,0x814a,0x8152,0x814f,0x8147,0x813d,
0x814d,0x813a,0x81e6,0x81ee,0x81f7,0x81f8,0x81f9,0x8204,
0x823c,0x823d,0x823f,0x8275,0x833b,0x83cf,0x83f9,0x8423,
0x83c0,0x83e8,0x8412,0x83e7,0x83e4,0x83fc,0x83f6,0x8410,
0x83c6,0x83c8,0x83eb,0x83e3,0x83bf,0x8401,0x83dd,0x83e5,
0x83d8,0x83ff,0x83e1,0x83cb,0x83ce,0x83d6,0x83f5,0x83c9,
0x8409,0x840f,0x83de,0x8411,0x8406,0x83c2,0x83f3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x83d5,0x83fa,0x83c7,0x83d1,0x83ea,0x8413,0x83c3,
0x83ec,0x83ee,0x83c4,0x83fb,0x83d7,0x83e2,0x841b,0x83db,
0x83fe,0x86d8,0x86e2,0x86e6,0x86d3,0x86e3,0x86da,0x86ea,
0x86dd,0x86eb,0x86dc,0x86ec,0x86e9,0x86d7,0x86e8,0x86d1,
0x8848,0x8856,0x8855,0x88ba,0x88d7,0x88b9,0x88b8,0x88c0,
0x88be,0x88b6,0x88bc,0x88b7,0x88bd,0x88b2,0x8901,0x88c9,
0x8995,0x8998,0x8997,0x89dd,0x89da,0x89db,0x8a4e,0x8a4d,
0x8a39,0x8a59,0x8a40,0x8a57,0x8a58,0x8a44,0x8a45,0x8a52,
0x8a48,0x8a51,0x8a4a,0x8a4c,0x8a4f,0x8c5f,0x8c81,0x8c80,
0x8cba,0x8cbe,0x8cb0,0x8cb9,0x8cb5,0x8d84,0x8d80,0x8d89,
0x8dd8,0x8dd3,0x8dcd,0x8dc7,0x8dd6,0x8ddc,0x8dcf,0x8dd5,
0x8dd9,0x8dc8,0x8dd7,0x8dc5,0x8eef,0x8ef7,0x8efa,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8ef9,0x8ee6,0x8eee,0x8ee5,0x8ef5,0x8ee7,0x8ee8,0x8ef6,
0x8eeb,0x8ef1,0x8eec,0x8ef4,0x8ee9,0x902d,0x9034,0x902f,
0x9106,0x912c,0x9104,0x90ff,0x90fc,0x9108,0x90f9,0x90fb,
0x9101,0x9100,0x9107,0x9105,0x9103,0x9161,0x9164,0x915f,
0x9162,0x9160,0x9201,0x920a,0x9225,0x9203,0x921a,0x9226,
0x920f,0x920c,0x9200,0x9212,0x91ff,0x91fd,0x9206,0x9204,
0x9227,0x9202,0x921c,0x9224,0x9219,0x9217,0x9205,0x9216,
0x957b,0x958d,0x958c,0x9590,0x9687,0x967e,0x9688,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9689,0x9683,0x9680,0x96c2,0x96c8,0x96c3,0x96f1,
0x96f0,0x976c,0x9770,0x976e,0x9807,0x98a9,0x98eb,0x9ce6,
0x9ef9,0x4e83,0x4e84,0x4eb6,0x50bd,0x50bf,0x50c6,0x50ae,
0x50c4,0x50ca,0x50b4,0x50c8,0x50c2,0x50b0,0x50c1,0x50ba,
0x50b1,0x50cb,0x50c9,0x50b6,0x50b8,0x51d7,0x527a,0x5278,
0x527b,0x527c,0x55c3,0x55db,0x55cc,0x55d0,0x55cb,0x55ca,
0x55dd,0x55c0,0x55d4,0x55c4,0x55e9,0x55bf,0x55d2,0x558d,
0x55cf,0x55d5,0x55e2,0x55d6,0x55c8,0x55f2,0x55cd,0x55d9,
0x55c2,0x5714,0x5853,0x5868,0x5864,0x584f,0x584d,0x5849,
0x586f,0x5855,0x584e,0x585d,0x5859,0x5865,0x585b,0x583d,
0x5863,0x5871,0x58fc,0x5ac7,0x5ac4,0x5acb,0x5aba,0x5ab8,
0x5ab1,0x5ab5,0x5ab0,0x5abf,0x5ac8,0x5abb,0x5ac6,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5ab7,0x5ac0,0x5aca,0x5ab4,0x5ab6,0x5acd,0x5ab9,0x5a90,
0x5bd6,0x5bd8,0x5bd9,0x5c1f,0x5c33,0x5d71,0x5d63,0x5d4a,
0x5d65,0x5d72,0x5d6c,0x5d5e,0x5d68,0x5d67,0x5d62,0x5df0,
0x5e4f,0x5e4e,0x5e4a,0x5e4d,0x5e4b,0x5ec5,0x5ecc,0x5ec6,
0x5ecb,0x5ec7,0x5f40,0x5faf,0x5fad,0x60f7,0x6149,0x614a,
0x612b,0x6145,0x6136,0x6132,0x612e,0x6146,0x612f,0x614f,
0x6129,0x6140,0x6220,0x9168,0x6223,0x6225,0x6224,0x63c5,
0x63f1,0x63eb,0x6410,0x6412,0x6409,0x6420,0x6424,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x6433,0x6443,0x641f,0x6415,0x6418,0x6439,0x6437,
0x6422,0x6423,0x640c,0x6426,0x6430,0x6428,0x6441,0x6435,
0x642f,0x640a,0x641a,0x6440,0x6425,0x6427,0x640b,0x63e7,
0x641b,0x642e,0x6421,0x640e,0x656f,0x6592,0x65d3,0x6686,
0x668c,0x6695,0x6690,0x668b,0x668a,0x6699,0x6694,0x6678,
0x6720,0x6966,0x695f,0x6938,0x694e,0x6962,0x6971,0x693f,
0x6945,0x696a,0x6939,0x6942,0x6957,0x6959,0x697a,0x6948,
0x6949,0x6935,0x696c,0x6933,0x693d,0x6965,0x68f0,0x6978,
0x6934,0x6969,0x6940,0x696f,0x6944,0x6976,0x6958,0x6941,
0x6974,0x694c,0x693b,0x694b,0x6937,0x695c,0x694f,0x6951,
0x6932,0x6952,0x692f,0x697b,0x693c,0x6b46,0x6b45,0x6b43,
0x6b42,0x6b48,0x6b41,0x6b9b,0xfa0d,0x6bfb,0x6bfc,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6bf9,0x6bf7,0x6bf8,0x6e9b,0x6ed6,0x6ec8,0x6e8f,0x6ec0,
0x6e9f,0x6e93,0x6e94,0x6ea0,0x6eb1,0x6eb9,0x6ec6,0x6ed2,
0x6ebd,0x6ec1,0x6e9e,0x6ec9,0x6eb7,0x6eb0,0x6ecd,0x6ea6,
0x6ecf,0x6eb2,0x6ebe,0x6ec3,0x6edc,0x6ed8,0x6e99,0x6e92,
0x6e8e,0x6e8d,0x6ea4,0x6ea1,0x6ebf,0x6eb3,0x6ed0,0x6eca,
0x6e97,0x6eae,0x6ea3,0x7147,0x7154,0x7152,0x7163,0x7160,
0x7141,0x715d,0x7162,0x7172,0x7178,0x716a,0x7161,0x7142,
0x7158,0x7143,0x714b,0x7170,0x715f,0x7150,0x7153,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x7144,0x714d,0x715a,0x724f,0x728d,0x728c,0x7291,
0x7290,0x728e,0x733c,0x7342,0x733b,0x733a,0x7340,0x734a,
0x7349,0x7444,0x744a,0x744b,0x7452,0x7451,0x7457,0x7440,
0x744f,0x7450,0x744e,0x7442,0x7446,0x744d,0x7454,0x74e1,
0x74ff,0x74fe,0x74fd,0x751d,0x7579,0x7577,0x6983,0x75ef,
0x760f,0x7603,0x75f7,0x75fe,0x75fc,0x75f9,0x75f8,0x7610,
0x75fb,0x75f6,0x75ed,0x75f5,0x75fd,0x7699,0x76b5,0x76dd,
0x7755,0x775f,0x7760,0x7752,0x7756,0x775a,0x7769,0x7767,
0x7754,0x7759,0x776d,0x77e0,0x7887,0x789a,0x7894,0x788f,
0x7884,0x7895,0x7885,0x7886,0x78a1,0x7883,0x7879,0x7899,
0x7880,0x7896,0x787b,0x797c,0x7982,0x797d,0x7979,0x7a11,
0x7a18,0x7a19,0x7a12,0x7a17,0x7a15,0x7a22,0x7a13,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x7a1b,0x7a10,0x7aa3,0x7aa2,0x7a9e,0x7aeb,0x7b66,0x7b64,
0x7b6d,0x7b74,0x7b69,0x7b72,0x7b65,0x7b73,0x7b71,0x7b70,
0x7b61,0x7b78,0x7b76,0x7b63,0x7cb2,0x7cb4,0x7caf,0x7d88,
0x7d86,0x7d80,0x7d8d,0x7d7f,0x7d85,0x7d7a,0x7d8e,0x7d7b,
0x7d83,0x7d7c,0x7d8c,0x7d94,0x7d84,0x7d7d,0x7d92,0x7f6d,
0x7f6b,0x7f67,0x7f68,0x7f6c,0x7fa6,0x7fa5,0x7fa7,0x7fdb,
0x7fdc,0x8021,0x8164,0x8160,0x8177,0x815c,0x8169,0x815b,
0x8162,0x8172,0x6721,0x815e,0x8176,0x8167,0x816f,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8144,0x8161,0x821d,0x8249,0x8244,0x8240,0x8242,
0x8245,0x84f1,0x843f,0x8456,0x8476,0x8479,0x848f,0x848d,
0x8465,0x8451,0x8440,0x8486,0x8467,0x8430,0x844d,0x847d,
0x845a,0x8459,0x8474,0x8473,0x845d,0x8507,0x845e,0x8437,
0x843a,0x8434,0x847a,0x8443,0x8478,0x8432,0x8445,0x8429,
0x83d9,0x844b,0x842f,0x8442,0x842d,0x845f,0x8470,0x8439,
0x844e,0x844c,0x8452,0x846f,0x84c5,0x848e,0x843b,0x8447,
0x8436,0x8433,0x8468,0x847e,0x8444,0x842b,0x8460,0x8454,
0x846e,0x8450,0x870b,0x8704,0x86f7,0x870c,0x86fa,0x86d6,
0x86f5,0x874d,0x86f8,0x870e,0x8709,0x8701,0x86f6,0x870d,
0x8705,0x88d6,0x88cb,0x88cd,0x88ce,0x88de,0x88db,0x88da,
0x88cc,0x88d0,0x8985,0x899b,0x89df,0x89e5,0x89e4,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x89e1,0x89e0,0x89e2,0x89dc,0x89e6,0x8a76,0x8a86,0x8a7f,
0x8a61,0x8a3f,0x8a77,0x8a82,0x8a84,0x8a75,0x8a83,0x8a81,
0x8a74,0x8a7a,0x8c3c,0x8c4b,0x8c4a,0x8c65,0x8c64,0x8c66,
0x8c86,0x8c84,0x8c85,0x8ccc,0x8d68,0x8d69,0x8d91,0x8d8c,
0x8d8e,0x8d8f,0x8d8d,0x8d93,0x8d94,0x8d90,0x8d92,0x8df0,
0x8de0,0x8dec,0x8df1,0x8dee,0x8dd0,0x8de9,0x8de3,0x8de2,
0x8de7,0x8df2,0x8deb,0x8df4,0x8f06,0x8eff,0x8f01,0x8f00,
0x8f05,0x8f07,0x8f08,0x8f02,0x8f0b,0x9052,0x903f,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9044,0x9049,0x903d,0x9110,0x910d,0x910f,0x9111,
0x9116,0x9114,0x910b,0x910e,0x916e,0x916f,0x9248,0x9252,
0x9230,0x923a,0x9266,0x9233,0x9265,0x925e,0x9283,0x922e,
0x924a,0x9246,0x926d,0x926c,0x924f,0x9260,0x9267,0x926f,
0x9236,0x9261,0x9270,0x9231,0x9254,0x9263,0x9250,0x9272,
0x924e,0x9253,0x924c,0x9256,0x9232,0x959f,0x959c,0x959e,
0x959b,0x9692,0x9693,0x9691,0x9697,0x96ce,0x96fa,0x96fd,
0x96f8,0x96f5,0x9773,0x9777,0x9778,0x9772,0x980f,0x980d,
0x980e,0x98ac,0x98f6,0x98f9,0x99af,0x99b2,0x99b0,0x99b5,
0x9aad,0x9aab,0x9b5b,0x9cea,0x9ced,0x9ce7,0x9e80,0x9efd,
0x50e6,0x50d4,0x50d7,0x50e8,0x50f3,0x50db,0x50ea,0x50dd,
0x50e4,0x50d3,0x50ec,0x50f0,0x50ef,0x50e3,0x50e0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x51d8,0x5280,0x5281,0x52e9,0x52eb,0x5330,0x53ac,0x5627,
0x5615,0x560c,0x5612,0x55fc,0x560f,0x561c,0x5601,0x5613,
0x5602,0x55fa,0x561d,0x5604,0x55ff,0x55f9,0x5889,0x587c,
0x5890,0x5898,0x5886,0x5881,0x587f,0x5874,0x588b,0x587a,
0x5887,0x5891,0x588e,0x5876,0x5882,0x5888,0x587b,0x5894,
0x588f,0x58fe,0x596b,0x5adc,0x5aee,0x5ae5,0x5ad5,0x5aea,
0x5ada,0x5aed,0x5aeb,0x5af3,0x5ae2,0x5ae0,0x5adb,0x5aec,
0x5ade,0x5add,0x5ad9,0x5ae8,0x5adf,0x5b77,0x5be0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x5be3,0x5c63,0x5d82,0x5d80,0x5d7d,0x5d86,0x5d7a,
0x5d81,0x5d77,0x5d8a,0x5d89,0x5d88,0x5d7e,0x5d7c,0x5d8d,
0x5d79,0x5d7f,0x5e58,0x5e59,0x5e53,0x5ed8,0x5ed1,0x5ed7,
0x5ece,0x5edc,0x5ed5,0x5ed9,0x5ed2,0x5ed4,0x5f44,0x5f43,
0x5f6f,0x5fb6,0x612c,0x6128,0x6141,0x615e,0x6171,0x6173,
0x6152,0x6153,0x6172,0x616c,0x6180,0x6174,0x6154,0x617a,
0x615b,0x6165,0x613b,0x616a,0x6161,0x6156,0x6229,0x6227,
0x622b,0x642b,0x644d,0x645b,0x645d,0x6474,0x6476,0x6472,
0x6473,0x647d,0x6475,0x6466,0x64a6,0x644e,0x6482,0x645e,
0x645c,0x644b,0x6453,0x6460,0x6450,0x647f,0x643f,0x646c,
0x646b,0x6459,0x6465,0x6477,0x6573,0x65a0,0x66a1,0x66a0,
0x669f,0x6705,0x6704,0x6722,0x69b1,0x69b6,0x69c9,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x69a0,0x69ce,0x6996,0x69b0,0x69ac,0x69bc,0x6991,0x6999,
0x698e,0x69a7,0x698d,0x69a9,0x69be,0x69af,0x69bf,0x69c4,
0x69bd,0x69a4,0x69d4,0x69b9,0x69ca,0x699a,0x69cf,0x69b3,
0x6993,0x69aa,0x69a1,0x699e,0x69d9,0x6997,0x6990,0x69c2,
0x69b5,0x69a5,0x69c6,0x6b4a,0x6b4d,0x6b4b,0x6b9e,0x6b9f,
0x6ba0,0x6bc3,0x6bc4,0x6bfe,0x6ece,0x6ef5,0x6ef1,0x6f03,
0x6f25,0x6ef8,0x6f37,0x6efb,0x6f2e,0x6f09,0x6f4e,0x6f19,
0x6f1a,0x6f27,0x6f18,0x6f3b,0x6f12,0x6eed,0x6f0a,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x6f36,0x6f73,0x6ef9,0x6eee,0x6f2d,0x6f40,0x6f30,
0x6f3c,0x6f35,0x6eeb,0x6f07,0x6f0e,0x6f43,0x6f05,0x6efd,
0x6ef6,0x6f39,0x6f1c,0x6efc,0x6f3a,0x6f1f,0x6f0d,0x6f1e,
0x6f08,0x6f21,0x7187,0x7190,0x7189,0x7180,0x7185,0x7182,
0x718f,0x717b,0x7186,0x7181,0x7197,0x7244,0x7253,0x7297,
0x7295,0x7293,0x7343,0x734d,0x7351,0x734c,0x7462,0x7473,
0x7471,0x7475,0x7472,0x7467,0x746e,0x7500,0x7502,0x7503,
0x757d,0x7590,0x7616,0x7608,0x760c,0x7615,0x7611,0x760a,
0x7614,0x76b8,0x7781,0x777c,0x7785,0x7782,0x776e,0x7780,
0x776f,0x777e,0x7783,0x78b2,0x78aa,0x78b4,0x78ad,0x78a8,
0x787e,0x78ab,0x789e,0x78a5,0x78a0,0x78ac,0x78a2,0x78a4,
0x7998,0x798a,0x798b,0x7996,0x7995,0x7994,0x7993,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x7997,0x7988,0x7992,0x7990,0x7a2b,0x7a4a,0x7a30,0x7a2f,
0x7a28,0x7a26,0x7aa8,0x7aab,0x7aac,0x7aee,0x7b88,0x7b9c,
0x7b8a,0x7b91,0x7b90,0x7b96,0x7b8d,0x7b8c,0x7b9b,0x7b8e,
0x7b85,0x7b98,0x5284,0x7b99,0x7ba4,0x7b82,0x7cbb,0x7cbf,
0x7cbc,0x7cba,0x7da7,0x7db7,0x7dc2,0x7da3,0x7daa,0x7dc1,
0x7dc0,0x7dc5,0x7d9d,0x7dce,0x7dc4,0x7dc6,0x7dcb,0x7dcc,
0x7daf,0x7db9,0x7d96,0x7dbc,0x7d9f,0x7da6,0x7dae,0x7da9,
0x7da1,0x7dc9,0x7f73,0x7fe2,0x7fe3,0x7fe5,0x7fde,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8024,0x805d,0x805c,0x8189,0x8186,0x8183,0x8187,
0x818d,0x818c,0x818b,0x8215,0x8497,0x84a4,0x84a1,0x849f,
0x84ba,0x84ce,0x84c2,0x84ac,0x84ae,0x84ab,0x84b9,0x84b4,
0x84c1,0x84cd,0x84aa,0x849a,0x84b1,0x84d0,0x849d,0x84a7,
0x84bb,0x84a2,0x8494,0x84c7,0x84cc,0x849b,0x84a9,0x84af,
0x84a8,0x84d6,0x8498,0x84b6,0x84cf,0x84a0,0x84d7,0x84d4,
0x84d2,0x84db,0x84b0,0x8491,0x8661,0x8733,0x8723,0x8728,
0x876b,0x8740,0x872e,0x871e,0x8721,0x8719,0x871b,0x8743,
0x872c,0x8741,0x873e,0x8746,0x8720,0x8732,0x872a,0x872d,
0x873c,0x8712,0x873a,0x8731,0x8735,0x8742,0x8726,0x8727,
0x8738,0x8724,0x871a,0x8730,0x8711,0x88f7,0x88e7,0x88f1,
0x88f2,0x88fa,0x88fe,0x88ee,0x88fc,0x88f6,0x88fb,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x88f0,0x88ec,0x88eb,0x899d,0x89a1,0x899f,0x899e,0x89e9,
0x89eb,0x89e8,0x8aab,0x8a99,0x8a8b,0x8a92,0x8a8f,0x8a96,
0x8c3d,0x8c68,0x8c69,0x8cd5,0x8ccf,0x8cd7,0x8d96,0x8e09,
0x8e02,0x8dff,0x8e0d,0x8dfd,0x8e0a,0x8e03,0x8e07,0x8e06,
0x8e05,0x8dfe,0x8e00,0x8e04,0x8f10,0x8f11,0x8f0e,0x8f0d,
0x9123,0x911c,0x9120,0x9122,0x911f,0x911d,0x911a,0x9124,
0x9121,0x911b,0x917a,0x9172,0x9179,0x9173,0x92a5,0x92a4,
0x9276,0x929b,0x927a,0x92a0,0x9294,0x92aa,0x928d,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x92a6,0x929a,0x92ab,0x9279,0x9297,0x927f,0x92a3,
0x92ee,0x928e,0x9282,0x9295,0x92a2,0x927d,0x9288,0x92a1,
0x928a,0x9286,0x928c,0x9299,0x92a7,0x927e,0x9287,0x92a9,
0x929d,0x928b,0x922d,0x969e,0x96a1,0x96ff,0x9758,0x977d,
0x977a,0x977e,0x9783,0x9780,0x9782,0x977b,0x9784,0x9781,
0x977f,0x97ce,0x97cd,0x9816,0x98ad,0x98ae,0x9902,0x9900,
0x9907,0x999d,0x999c,0x99c3,0x99b9,0x99bb,0x99ba,0x99c2,
0x99bd,0x99c7,0x9ab1,0x9ae3,0x9ae7,0x9b3e,0x9b3f,0x9b60,
0x9b61,0x9b5f,0x9cf1,0x9cf2,0x9cf5,0x9ea7,0x50ff,0x5103,
0x5130,0x50f8,0x5106,0x5107,0x50f6,0x50fe,0x510b,0x510c,
0x50fd,0x510a,0x528b,0x528c,0x52f1,0x52ef,0x5648,0x5642,
0x564c,0x5635,0x5641,0x564a,0x5649,0x5646,0x5658,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x565a,0x5640,0x5633,0x563d,0x562c,0x563e,0x5638,0x562a,
0x563a,0x571a,0x58ab,0x589d,0x58b1,0x58a0,0x58a3,0x58af,
0x58ac,0x58a5,0x58a1,0x58ff,0x5aff,0x5af4,0x5afd,0x5af7,
0x5af6,0x5b03,0x5af8,0x5b02,0x5af9,0x5b01,0x5b07,0x5b05,
0x5b0f,0x5c67,0x5d99,0x5d97,0x5d9f,0x5d92,0x5da2,0x5d93,
0x5d95,0x5da0,0x5d9c,0x5da1,0x5d9a,0x5d9e,0x5e69,0x5e5d,
0x5e60,0x5e5c,0x7df3,0x5edb,0x5ede,0x5ee1,0x5f49,0x5fb2,
0x618b,0x6183,0x6179,0x61b1,0x61b0,0x61a2,0x6189,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x619b,0x6193,0x61af,0x61ad,0x619f,0x6192,0x61aa,
0x61a1,0x618d,0x6166,0x61b3,0x622d,0x646e,0x6470,0x6496,
0x64a0,0x6485,0x6497,0x649c,0x648f,0x648b,0x648a,0x648c,
0x64a3,0x649f,0x6468,0x64b1,0x6498,0x6576,0x657a,0x6579,
0x657b,0x65b2,0x65b3,0x66b5,0x66b0,0x66a9,0x66b2,0x66b7,
0x66aa,0x66af,0x6a00,0x6a06,0x6a17,0x69e5,0x69f8,0x6a15,
0x69f1,0x69e4,0x6a20,0x69ff,0x69ec,0x69e2,0x6a1b,0x6a1d,
0x69fe,0x6a27,0x69f2,0x69ee,0x6a14,0x69f7,0x69e7,0x6a40,
0x6a08,0x69e6,0x69fb,0x6a0d,0x69fc,0x69eb,0x6a09,0x6a04,
0x6a18,0x6a25,0x6a0f,0x69f6,0x6a26,0x6a07,0x69f4,0x6a16,
0x6b51,0x6ba5,0x6ba3,0x6ba2,0x6ba6,0x6c01,0x6c00,0x6bff,
0x6c02,0x6f41,0x6f26,0x6f7e,0x6f87,0x6fc6,0x6f92,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6f8d,0x6f89,0x6f8c,0x6f62,0x6f4f,0x6f85,0x6f5a,0x6f96,
0x6f76,0x6f6c,0x6f82,0x6f55,0x6f72,0x6f52,0x6f50,0x6f57,
0x6f94,0x6f93,0x6f5d,0x6f00,0x6f61,0x6f6b,0x6f7d,0x6f67,
0x6f90,0x6f53,0x6f8b,0x6f69,0x6f7f,0x6f95,0x6f63,0x6f77,
0x6f6a,0x6f7b,0x71b2,0x71af,0x719b,0x71b0,0x71a0,0x719a,
0x71a9,0x71b5,0x719d,0x71a5,0x719e,0x71a4,0x71a1,0x71aa,
0x719c,0x71a7,0x71b3,0x7298,0x729a,0x7358,0x7352,0x735e,
0x735f,0x7360,0x735d,0x735b,0x7361,0x735a,0x7359,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x7362,0x7487,0x7489,0x748a,0x7486,0x7481,0x747d,
0x7485,0x7488,0x747c,0x7479,0x7508,0x7507,0x757e,0x7625,
0x761e,0x7619,0x761d,0x761c,0x7623,0x761a,0x7628,0x761b,
0x769c,0x769d,0x769e,0x769b,0x778d,0x778f,0x7789,0x7788,
0x78cd,0x78bb,0x78cf,0x78cc,0x78d1,0x78ce,0x78d4,0x78c8,
0x78c3,0x78c4,0x78c9,0x799a,0x79a1,0x79a0,0x799c,0x79a2,
0x799b,0x6b76,0x7a39,0x7ab2,0x7ab4,0x7ab3,0x7bb7,0x7bcb,
0x7bbe,0x7bac,0x7bce,0x7baf,0x7bb9,0x7bca,0x7bb5,0x7cc5,
0x7cc8,0x7ccc,0x7ccb,0x7df7,0x7ddb,0x7dea,0x7de7,0x7dd7,
0x7de1,0x7e03,0x7dfa,0x7de6,0x7df6,0x7df1,0x7df0,0x7dee,
0x7ddf,0x7f76,0x7fac,0x7fb0,0x7fad,0x7fed,0x7feb,0x7fea,
0x7fec,0x7fe6,0x7fe8,0x8064,0x8067,0x81a3,0x819f,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x819e,0x8195,0x81a2,0x8199,0x8197,0x8216,0x824f,0x8253,
0x8252,0x8250,0x824e,0x8251,0x8524,0x853b,0x850f,0x8500,
0x8529,0x850e,0x8509,0x850d,0x851f,0x850a,0x8527,0x851c,
0x84fb,0x852b,0x84fa,0x8508,0x850c,0x84f4,0x852a,0x84f2,
0x8515,0x84f7,0x84eb,0x84f3,0x84fc,0x8512,0x84ea,0x84e9,
0x8516,0x84fe,0x8528,0x851d,0x852e,0x8502,0x84fd,0x851e,
0x84f6,0x8531,0x8526,0x84e7,0x84e8,0x84f0,0x84ef,0x84f9,
0x8518,0x8520,0x8530,0x850b,0x8519,0x852f,0x8662,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8756,0x8763,0x8764,0x8777,0x87e1,0x8773,0x8758,
0x8754,0x875b,0x8752,0x8761,0x875a,0x8751,0x875e,0x876d,
0x876a,0x8750,0x874e,0x875f,0x875d,0x876f,0x876c,0x877a,
0x876e,0x875c,0x8765,0x874f,0x877b,0x8775,0x8762,0x8767,
0x8769,0x885a,0x8905,0x890c,0x8914,0x890b,0x8917,0x8918,
0x8919,0x8906,0x8916,0x8911,0x890e,0x8909,0x89a2,0x89a4,
0x89a3,0x89ed,0x89f0,0x89ec,0x8acf,0x8ac6,0x8ab8,0x8ad3,
0x8ad1,0x8ad4,0x8ad5,0x8abb,0x8ad7,0x8abe,0x8ac0,0x8ac5,
0x8ad8,0x8ac3,0x8aba,0x8abd,0x8ad9,0x8c3e,0x8c4d,0x8c8f,
0x8ce5,0x8cdf,0x8cd9,0x8ce8,0x8cda,0x8cdd,0x8ce7,0x8da0,
0x8d9c,0x8da1,0x8d9b,0x8e20,0x8e23,0x8e25,0x8e24,0x8e2e,
0x8e15,0x8e1b,0x8e16,0x8e11,0x8e19,0x8e26,0x8e27,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8e14,0x8e12,0x8e18,0x8e13,0x8e1c,0x8e17,0x8e1a,0x8f2c,
0x8f24,0x8f18,0x8f1a,0x8f20,0x8f23,0x8f16,0x8f17,0x9073,
0x9070,0x906f,0x9067,0x906b,0x912f,0x912b,0x9129,0x912a,
0x9132,0x9126,0x912e,0x9185,0x9186,0x918a,0x9181,0x9182,
0x9184,0x9180,0x92d0,0x92c3,0x92c4,0x92c0,0x92d9,0x92b6,
0x92cf,0x92f1,0x92df,0x92d8,0x92e9,0x92d7,0x92dd,0x92cc,
0x92ef,0x92c2,0x92e8,0x92ca,0x92c8,0x92ce,0x92e6,0x92cd,
0x92d5,0x92c9,0x92e0,0x92de,0x92e7,0x92d1,0x92d3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x92b5,0x92e1,0x92c6,0x92b4,0x957c,0x95ac,0x95ab,
0x95ae,0x95b0,0x96a4,0x96a2,0x96d3,0x9705,0x9708,0x9702,
0x975a,0x978a,0x978e,0x9788,0x97d0,0x97cf,0x981e,0x981d,
0x9826,0x9829,0x9828,0x9820,0x981b,0x9827,0x98b2,0x9908,
0x98fa,0x9911,0x9914,0x9916,0x9917,0x9915,0x99dc,0x99cd,
0x99cf,0x99d3,0x99d4,0x99ce,0x99c9,0x99d6,0x99d8,0x99cb,
0x99d7,0x99cc,0x9ab3,0x9aec,0x9aeb,0x9af3,0x9af2,0x9af1,
0x9b46,0x9b43,0x9b67,0x9b74,0x9b71,0x9b66,0x9b76,0x9b75,
0x9b70,0x9b68,0x9b64,0x9b6c,0x9cfc,0x9cfa,0x9cfd,0x9cff,
0x9cf7,0x9d07,0x9d00,0x9cf9,0x9cfb,0x9d08,0x9d05,0x9d04,
0x9e83,0x9ed3,0x9f0f,0x9f10,0x511c,0x5113,0x5117,0x511a,
0x5111,0x51de,0x5334,0x53e1,0x5670,0x5660,0x566e,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5673,0x5666,0x5663,0x566d,0x5672,0x565e,0x5677,0x571c,
0x571b,0x58c8,0x58bd,0x58c9,0x58bf,0x58ba,0x58c2,0x58bc,
0x58c6,0x5b17,0x5b19,0x5b1b,0x5b21,0x5b14,0x5b13,0x5b10,
0x5b16,0x5b28,0x5b1a,0x5b20,0x5b1e,0x5bef,0x5dac,0x5db1,
0x5da9,0x5da7,0x5db5,0x5db0,0x5dae,0x5daa,0x5da8,0x5db2,
0x5dad,0x5daf,0x5db4,0x5e67,0x5e68,0x5e66,0x5e6f,0x5ee9,
0x5ee7,0x5ee6,0x5ee8,0x5ee5,0x5f4b,0x5fbc,0x619d,0x61a8,
0x6196,0x61c5,0x61b4,0x61c6,0x61c1,0x61cc,0x61ba,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x61bf,0x61b8,0x618c,0x64d7,0x64d6,0x64d0,0x64cf,
0x64c9,0x64bd,0x6489,0x64c3,0x64db,0x64f3,0x64d9,0x6533,
0x657f,0x657c,0x65a2,0x66c8,0x66be,0x66c0,0x66ca,0x66cb,
0x66cf,0x66bd,0x66bb,0x66ba,0x66cc,0x6723,0x6a34,0x6a66,
0x6a49,0x6a67,0x6a32,0x6a68,0x6a3e,0x6a5d,0x6a6d,0x6a76,
0x6a5b,0x6a51,0x6a28,0x6a5a,0x6a3b,0x6a3f,0x6a41,0x6a6a,
0x6a64,0x6a50,0x6a4f,0x6a54,0x6a6f,0x6a69,0x6a60,0x6a3c,
0x6a5e,0x6a56,0x6a55,0x6a4d,0x6a4e,0x6a46,0x6b55,0x6b54,
0x6b56,0x6ba7,0x6baa,0x6bab,0x6bc8,0x6bc7,0x6c04,0x6c03,
0x6c06,0x6fad,0x6fcb,0x6fa3,0x6fc7,0x6fbc,0x6fce,0x6fc8,
0x6f5e,0x6fc4,0x6fbd,0x6f9e,0x6fca,0x6fa8,0x7004,0x6fa5,
0x6fae,0x6fba,0x6fac,0x6faa,0x6fcf,0x6fbf,0x6fb8,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6fa2,0x6fc9,0x6fab,0x6fcd,0x6faf,0x6fb2,0x6fb0,0x71c5,
0x71c2,0x71bf,0x71b8,0x71d6,0x71c0,0x71c1,0x71cb,0x71d4,
0x71ca,0x71c7,0x71cf,0x71bd,0x71d8,0x71bc,0x71c6,0x71da,
0x71db,0x729d,0x729e,0x7369,0x7366,0x7367,0x736c,0x7365,
0x736b,0x736a,0x747f,0x749a,0x74a0,0x7494,0x7492,0x7495,
0x74a1,0x750b,0x7580,0x762f,0x762d,0x7631,0x763d,0x7633,
0x763c,0x7635,0x7632,0x7630,0x76bb,0x76e6,0x779a,0x779d,
0x77a1,0x779c,0x779b,0x77a2,0x77a3,0x7795,0x7799,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x7797,0x78dd,0x78e9,0x78e5,0x78ea,0x78de,0x78e3,
0x78db,0x78e1,0x78e2,0x78ed,0x78df,0x78e0,0x79a4,0x7a44,
0x7a48,0x7a47,0x7ab6,0x7ab8,0x7ab5,0x7ab1,0x7ab7,0x7bde,
0x7be3,0x7be7,0x7bdd,0x7bd5,0x7be5,0x7bda,0x7be8,0x7bf9,
0x7bd4,0x7bea,0x7be2,0x7bdc,0x7beb,0x7bd8,0x7bdf,0x7cd2,
0x7cd4,0x7cd7,0x7cd0,0x7cd1,0x7e12,0x7e21,0x7e17,0x7e0c,
0x7e1f,0x7e20,0x7e13,0x7e0e,0x7e1c,0x7e15,0x7e1a,0x7e22,
0x7e0b,0x7e0f,0x7e16,0x7e0d,0x7e14,0x7e25,0x7e24,0x7f43,
0x7f7b,0x7f7c,0x7f7a,0x7fb1,0x7fef,0x802a,0x8029,0x806c,
0x81b1,0x81a6,0x81ae,0x81b9,0x81b5,0x81ab,0x81b0,0x81ac,
0x81b4,0x81b2,0x81b7,0x81a7,0x81f2,0x8255,0x8256,0x8257,
0x8556,0x8545,0x856b,0x854d,0x8553,0x8561,0x8558,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8540,0x8546,0x8564,0x8541,0x8562,0x8544,0x8551,0x8547,
0x8563,0x853e,0x855b,0x8571,0x854e,0x856e,0x8575,0x8555,
0x8567,0x8560,0x858c,0x8566,0x855d,0x8554,0x8565,0x856c,
0x8663,0x8665,0x8664,0x879b,0x878f,0x8797,0x8793,0x8792,
0x8788,0x8781,0x8796,0x8798,0x8779,0x8787,0x87a3,0x8785,
0x8790,0x8791,0x879d,0x8784,0x8794,0x879c,0x879a,0x8789,
0x891e,0x8926,0x8930,0x892d,0x892e,0x8927,0x8931,0x8922,
0x8929,0x8923,0x892f,0x892c,0x891f,0x89f1,0x8ae0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8ae2,0x8af2,0x8af4,0x8af5,0x8add,0x8b14,0x8ae4,
0x8adf,0x8af0,0x8ac8,0x8ade,0x8ae1,0x8ae8,0x8aff,0x8aef,
0x8afb,0x8c91,0x8c92,0x8c90,0x8cf5,0x8cee,0x8cf1,0x8cf0,
0x8cf3,0x8d6c,0x8d6e,0x8da5,0x8da7,0x8e33,0x8e3e,0x8e38,
0x8e40,0x8e45,0x8e36,0x8e3c,0x8e3d,0x8e41,0x8e30,0x8e3f,
0x8ebd,0x8f36,0x8f2e,0x8f35,0x8f32,0x8f39,0x8f37,0x8f34,
0x9076,0x9079,0x907b,0x9086,0x90fa,0x9133,0x9135,0x9136,
0x9193,0x9190,0x9191,0x918d,0x918f,0x9327,0x931e,0x9308,
0x931f,0x9306,0x930f,0x937a,0x9338,0x933c,0x931b,0x9323,
0x9312,0x9301,0x9346,0x932d,0x930e,0x930d,0x92cb,0x931d,
0x92fa,0x9325,0x9313,0x92f9,0x92f7,0x9334,0x9302,0x9324,
0x92ff,0x9329,0x9339,0x9335,0x932a,0x9314,0x930c,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x930b,0x92fe,0x9309,0x9300,0x92fb,0x9316,0x95bc,0x95cd,
0x95be,0x95b9,0x95ba,0x95b6,0x95bf,0x95b5,0x95bd,0x96a9,
0x96d4,0x970b,0x9712,0x9710,0x9799,0x9797,0x9794,0x97f0,
0x97f8,0x9835,0x982f,0x9832,0x9924,0x991f,0x9927,0x9929,
0x999e,0x99ee,0x99ec,0x99e5,0x99e4,0x99f0,0x99e3,0x99ea,
0x99e9,0x99e7,0x9ab9,0x9abf,0x9ab4,0x9abb,0x9af6,0x9afa,
0x9af9,0x9af7,0x9b33,0x9b80,0x9b85,0x9b87,0x9b7c,0x9b7e,
0x9b7b,0x9b82,0x9b93,0x9b92,0x9b90,0x9b7a,0x9b95,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9b7d,0x9b88,0x9d25,0x9d17,0x9d20,0x9d1e,0x9d14,
0x9d29,0x9d1d,0x9d18,0x9d22,0x9d10,0x9d19,0x9d1f,0x9e88,
0x9e86,0x9e87,0x9eae,0x9ead,0x9ed5,0x9ed6,0x9efa,0x9f12,
0x9f3d,0x5126,0x5125,0x5122,0x5124,0x5120,0x5129,0x52f4,
0x5693,0x568c,0x568d,0x5686,0x5684,0x5683,0x567e,0x5682,
0x567f,0x5681,0x58d6,0x58d4,0x58cf,0x58d2,0x5b2d,0x5b25,
0x5b32,0x5b23,0x5b2c,0x5b27,0x5b26,0x5b2f,0x5b2e,0x5b7b,
0x5bf1,0x5bf2,0x5db7,0x5e6c,0x5e6a,0x5fbe,0x5fbb,0x61c3,
0x61b5,0x61bc,0x61e7,0x61e0,0x61e5,0x61e4,0x61e8,0x61de,
0x64ef,0x64e9,0x64e3,0x64eb,0x64e4,0x64e8,0x6581,0x6580,
0x65b6,0x65da,0x66d2,0x6a8d,0x6a96,0x6a81,0x6aa5,0x6a89,
0x6a9f,0x6a9b,0x6aa1,0x6a9e,0x6a87,0x6a93,0x6a8e,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x6a95,0x6a83,0x6aa8,0x6aa4,0x6a91,0x6a7f,0x6aa6,0x6a9a,
0x6a85,0x6a8c,0x6a92,0x6b5b,0x6bad,0x6c09,0x6fcc,0x6fa9,
0x6ff4,0x6fd4,0x6fe3,0x6fdc,0x6fed,0x6fe7,0x6fe6,0x6fde,
0x6ff2,0x6fdd,0x6fe2,0x6fe8,0x71e1,0x71f1,0x71e8,0x71f2,
0x71e4,0x71f0,0x71e2,0x7373,0x736e,0x736f,0x7497,0x74b2,
0x74ab,0x7490,0x74aa,0x74ad,0x74b1,0x74a5,0x74af,0x7510,
0x7511,0x7512,0x750f,0x7584,0x7643,0x7648,0x7649,0x7647,
0x76a4,0x76e9,0x77b5,0x77ab,0x77b2,0x77b7,0x77b6,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x77b4,0x77b1,0x77a8,0x77f0,0x78f3,0x78fd,0x7902,
0x78fb,0x78fc,0x78f2,0x7905,0x78f9,0x78fe,0x7904,0x79ab,
0x79a8,0x7a5c,0x7a5b,0x7a56,0x7a58,0x7a54,0x7a5a,0x7abe,
0x7ac0,0x7ac1,0x7c05,0x7c0f,0x7bf2,0x7c00,0x7bff,0x7bfb,
0x7c0e,0x7bf4,0x7c0b,0x7bf3,0x7c02,0x7c09,0x7c03,0x7c01,
0x7bf8,0x7bfd,0x7c06,0x7bf0,0x7bf1,0x7c10,0x7c0a,0x7ce8,
0x7e2d,0x7e3c,0x7e42,0x7e33,0x9848,0x7e38,0x7e2a,0x7e49,
0x7e40,0x7e47,0x7e29,0x7e4c,0x7e30,0x7e3b,0x7e36,0x7e44,
0x7e3a,0x7f45,0x7f7f,0x7f7e,0x7f7d,0x7ff4,0x7ff2,0x802c,
0x81bb,0x81c4,0x81cc,0x81ca,0x81c5,0x81c7,0x81bc,0x81e9,
0x825b,0x825a,0x825c,0x8583,0x8580,0x858f,0x85a7,0x8595,
0x85a0,0x858b,0x85a3,0x857b,0x85a4,0x859a,0x859e,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8577,0x857c,0x8589,0x85a1,0x857a,0x8578,0x8557,0x858e,
0x8596,0x8586,0x858d,0x8599,0x859d,0x8581,0x85a2,0x8582,
0x8588,0x8585,0x8579,0x8576,0x8598,0x8590,0x859f,0x8668,
0x87be,0x87aa,0x87ad,0x87c5,0x87b0,0x87ac,0x87b9,0x87b5,
0x87bc,0x87ae,0x87c9,0x87c3,0x87c2,0x87cc,0x87b7,0x87af,
0x87c4,0x87ca,0x87b4,0x87b6,0x87bf,0x87b8,0x87bd,0x87de,
0x87b2,0x8935,0x8933,0x893c,0x893e,0x8941,0x8952,0x8937,
0x8942,0x89ad,0x89af,0x89ae,0x89f2,0x89f3,0x8b1e,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x8b18,0x8b16,0x8b11,0x8b05,0x8b0b,0x8b22,0x8b0f,
0x8b12,0x8b15,0x8b07,0x8b0d,0x8b08,0x8b06,0x8b1c,0x8b13,
0x8b1a,0x8c4f,0x8c70,0x8c72,0x8c71,0x8c6f,0x8c95,0x8c94,
0x8cf9,0x8d6f,0x8e4e,0x8e4d,0x8e53,0x8e50,0x8e4c,0x8e47,
0x8f43,0x8f40,0x9085,0x907e,0x9138,0x919a,0x91a2,0x919b,
0x9199,0x919f,0x91a1,0x919d,0x91a0,0x93a1,0x9383,0x93af,
0x9364,0x9356,0x9347,0x937c,0x9358,0x935c,0x9376,0x9349,
0x9350,0x9351,0x9360,0x936d,0x938f,0x934c,0x936a,0x9379,
0x9357,0x9355,0x9352,0x934f,0x9371,0x9377,0x937b,0x9361,
0x935e,0x9363,0x9367,0x9380,0x934e,0x9359,0x95c7,0x95c0,
0x95c9,0x95c3,0x95c5,0x95b7,0x96ae,0x96b0,0x96ac,0x9720,
0x971f,0x9718,0x971d,0x9719,0x979a,0x97a1,0x979c,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x979e,0x979d,0x97d5,0x97d4,0x97f1,0x9841,0x9844,0x984a,
0x9849,0x9845,0x9843,0x9925,0x992b,0x992c,0x992a,0x9933,
0x9932,0x992f,0x992d,0x9931,0x9930,0x9998,0x99a3,0x99a1,
0x9a02,0x99fa,0x99f4,0x99f7,0x99f9,0x99f8,0x99f6,0x99fb,
0x99fd,0x99fe,0x99fc,0x9a03,0x9abe,0x9afe,0x9afd,0x9b01,
0x9afc,0x9b48,0x9b9a,0x9ba8,0x9b9e,0x9b9b,0x9ba6,0x9ba1,
0x9ba5,0x9ba4,0x9b86,0x9ba2,0x9ba0,0x9baf,0x9d33,0x9d41,
0x9d67,0x9d36,0x9d2e,0x9d2f,0x9d31,0x9d38,0x9d30,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9d45,0x9d42,0x9d43,0x9d3e,0x9d37,0x9d40,0x9d3d,
0x7ff5,0x9d2d,0x9e8a,0x9e89,0x9e8d,0x9eb0,0x9ec8,0x9eda,
0x9efb,0x9eff,0x9f24,0x9f23,0x9f22,0x9f54,0x9fa0,0x5131,
0x512d,0x512e,0x5698,0x569c,0x5697,0x569a,0x569d,0x5699,
0x5970,0x5b3c,0x5c69,0x5c6a,0x5dc0,0x5e6d,0x5e6e,0x61d8,
0x61df,0x61ed,0x61ee,0x61f1,0x61ea,0x61f0,0x61eb,0x61d6,
0x61e9,0x64ff,0x6504,0x64fd,0x64f8,0x6501,0x6503,0x64fc,
0x6594,0x65db,0x66da,0x66db,0x66d8,0x6ac5,0x6ab9,0x6abd,
0x6ae1,0x6ac6,0x6aba,0x6ab6,0x6ab7,0x6ac7,0x6ab4,0x6aad,
0x6b5e,0x6bc9,0x6c0b,0x7007,0x700c,0x700d,0x7001,0x7005,
0x7014,0x700e,0x6fff,0x7000,0x6ffb,0x7026,0x6ffc,0x6ff7,
0x700a,0x7201,0x71ff,0x71f9,0x7203,0x71fd,0x7376,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x74b8,0x74c0,0x74b5,0x74c1,0x74be,0x74b6,0x74bb,0x74c2,
0x7514,0x7513,0x765c,0x7664,0x7659,0x7650,0x7653,0x7657,
0x765a,0x76a6,0x76bd,0x76ec,0x77c2,0x77ba,0x78ff,0x790c,
0x7913,0x7914,0x7909,0x7910,0x7912,0x7911,0x79ad,0x79ac,
0x7a5f,0x7c1c,0x7c29,0x7c19,0x7c20,0x7c1f,0x7c2d,0x7c1d,
0x7c26,0x7c28,0x7c22,0x7c25,0x7c30,0x7e5c,0x7e50,0x7e56,
0x7e63,0x7e58,0x7e62,0x7e5f,0x7e51,0x7e60,0x7e57,0x7e53,
0x7fb5,0x7fb3,0x7ff7,0x7ff8,0x8075,0x81d1,0x81d2,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x81d0,0x825f,0x825e,0x85b4,0x85c6,0x85c0,0x85c3,
0x85c2,0x85b3,0x85b5,0x85bd,0x85c7,0x85c4,0x85bf,0x85cb,
0x85ce,0x85c8,0x85c5,0x85b1,0x85b6,0x85d2,0x8624,0x85b8,
0x85b7,0x85be,0x8669,0x87e7,0x87e6,0x87e2,0x87db,0x87eb,
0x87ea,0x87e5,0x87df,0x87f3,0x87e4,0x87d4,0x87dc,0x87d3,
0x87ed,0x87d8,0x87e3,0x87a4,0x87d7,0x87d9,0x8801,0x87f4,
0x87e8,0x87dd,0x8953,0x894b,0x894f,0x894c,0x8946,0x8950,
0x8951,0x8949,0x8b2a,0x8b27,0x8b23,0x8b33,0x8b30,0x8b35,
0x8b47,0x8b2f,0x8b3c,0x8b3e,0x8b31,0x8b25,0x8b37,0x8b26,
0x8b36,0x8b2e,0x8b24,0x8b3b,0x8b3d,0x8b3a,0x8c42,0x8c75,
0x8c99,0x8c98,0x8c97,0x8cfe,0x8d04,0x8d02,0x8d00,0x8e5c,
0x8e62,0x8e60,0x8e57,0x8e56,0x8e5e,0x8e65,0x8e67,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8e5b,0x8e5a,0x8e61,0x8e5d,0x8e69,0x8e54,0x8f46,0x8f47,
0x8f48,0x8f4b,0x9128,0x913a,0x913b,0x913e,0x91a8,0x91a5,
0x91a7,0x91af,0x91aa,0x93b5,0x938c,0x9392,0x93b7,0x939b,
0x939d,0x9389,0x93a7,0x938e,0x93aa,0x939e,0x93a6,0x9395,
0x9388,0x9399,0x939f,0x938d,0x93b1,0x9391,0x93b2,0x93a4,
0x93a8,0x93b4,0x93a3,0x93a5,0x95d2,0x95d3,0x95d1,0x96b3,
0x96d7,0x96da,0x5dc2,0x96df,0x96d8,0x96dd,0x9723,0x9722,
0x9725,0x97ac,0x97ae,0x97a8,0x97ab,0x97a4,0x97aa,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x97a2,0x97a5,0x97d7,0x97d9,0x97d6,0x97d8,0x97fa,
0x9850,0x9851,0x9852,0x98b8,0x9941,0x993c,0x993a,0x9a0f,
0x9a0b,0x9a09,0x9a0d,0x9a04,0x9a11,0x9a0a,0x9a05,0x9a07,
0x9a06,0x9ac0,0x9adc,0x9b08,0x9b04,0x9b05,0x9b29,0x9b35,
0x9b4a,0x9b4c,0x9b4b,0x9bc7,0x9bc6,0x9bc3,0x9bbf,0x9bc1,
0x9bb5,0x9bb8,0x9bd3,0x9bb6,0x9bc4,0x9bb9,0x9bbd,0x9d5c,
0x9d53,0x9d4f,0x9d4a,0x9d5b,0x9d4b,0x9d59,0x9d56,0x9d4c,
0x9d57,0x9d52,0x9d54,0x9d5f,0x9d58,0x9d5a,0x9e8e,0x9e8c,
0x9edf,0x9f01,0x9f00,0x9f16,0x9f25,0x9f2b,0x9f2a,0x9f29,
0x9f28,0x9f4c,0x9f55,0x5134,0x5135,0x5296,0x52f7,0x53b4,
0x56ab,0x56ad,0x56a6,0x56a7,0x56aa,0x56ac,0x58da,0x58dd,
0x58db,0x5912,0x5b3d,0x5b3e,0x5b3f,0x5dc3,0x5e70,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x5fbf,0x61fb,0x6507,0x6510,0x650d,0x6509,0x650c,0x650e,
0x6584,0x65de,0x65dd,0x66de,0x6ae7,0x6ae0,0x6acc,0x6ad1,
0x6ad9,0x6acb,0x6adf,0x6adc,0x6ad0,0x6aeb,0x6acf,0x6acd,
0x6ade,0x6b60,0x6bb0,0x6c0c,0x7019,0x7027,0x7020,0x7016,
0x702b,0x7021,0x7022,0x7023,0x7029,0x7017,0x7024,0x701c,
0x702a,0x720c,0x720a,0x7207,0x7202,0x7205,0x72a5,0x72a6,
0x72a4,0x72a3,0x72a1,0x74cb,0x74c5,0x74b7,0x74c3,0x7516,
0x7660,0x77c9,0x77ca,0x77c4,0x77f1,0x791d,0x791b,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x7921,0x791c,0x7917,0x791e,0x79b0,0x7a67,0x7a68,
0x7c33,0x7c3c,0x7c39,0x7c2c,0x7c3b,0x7cec,0x7cea,0x7e76,
0x7e75,0x7e78,0x7e70,0x7e77,0x7e6f,0x7e7a,0x7e72,0x7e74,
0x7e68,0x7f4b,0x7f4a,0x7f83,0x7f86,0x7fb7,0x7ffd,0x7ffe,
0x8078,0x81d7,0x81d5,0x8264,0x8261,0x8263,0x85eb,0x85f1,
0x85ed,0x85d9,0x85e1,0x85e8,0x85da,0x85d7,0x85ec,0x85f2,
0x85f8,0x85d8,0x85df,0x85e3,0x85dc,0x85d1,0x85f0,0x85e6,
0x85ef,0x85de,0x85e2,0x8800,0x87fa,0x8803,0x87f6,0x87f7,
0x8809,0x880c,0x880b,0x8806,0x87fc,0x8808,0x87ff,0x880a,
0x8802,0x8962,0x895a,0x895b,0x8957,0x8961,0x895c,0x8958,
0x895d,0x8959,0x8988,0x89b7,0x89b6,0x89f6,0x8b50,0x8b48,
0x8b4a,0x8b40,0x8b53,0x8b56,0x8b54,0x8b4b,0x8b55,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8b51,0x8b42,0x8b52,0x8b57,0x8c43,0x8c77,0x8c76,0x8c9a,
0x8d06,0x8d07,0x8d09,0x8dac,0x8daa,0x8dad,0x8dab,0x8e6d,
0x8e78,0x8e73,0x8e6a,0x8e6f,0x8e7b,0x8ec2,0x8f52,0x8f51,
0x8f4f,0x8f50,0x8f53,0x8fb4,0x9140,0x913f,0x91b0,0x91ad,
0x93de,0x93c7,0x93cf,0x93c2,0x93da,0x93d0,0x93f9,0x93ec,
0x93cc,0x93d9,0x93a9,0x93e6,0x93ca,0x93d4,0x93ee,0x93e3,
0x93d5,0x93c4,0x93ce,0x93c0,0x93d2,0x93e7,0x957d,0x95da,
0x95db,0x96e1,0x9729,0x972b,0x972c,0x9728,0x9726,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x97b3,0x97b7,0x97b6,0x97dd,0x97de,0x97df,0x985c,
0x9859,0x985d,0x9857,0x98bf,0x98bd,0x98bb,0x98be,0x9948,
0x9947,0x9943,0x99a6,0x99a7,0x9a1a,0x9a15,0x9a25,0x9a1d,
0x9a24,0x9a1b,0x9a22,0x9a20,0x9a27,0x9a23,0x9a1e,0x9a1c,
0x9a14,0x9ac2,0x9b0b,0x9b0a,0x9b0e,0x9b0c,0x9b37,0x9bea,
0x9beb,0x9be0,0x9bde,0x9be4,0x9be6,0x9be2,0x9bf0,0x9bd4,
0x9bd7,0x9bec,0x9bdc,0x9bd9,0x9be5,0x9bd5,0x9be1,0x9bda,
0x9d77,0x9d81,0x9d8a,0x9d84,0x9d88,0x9d71,0x9d80,0x9d78,
0x9d86,0x9d8b,0x9d8c,0x9d7d,0x9d6b,0x9d74,0x9d75,0x9d70,
0x9d69,0x9d85,0x9d73,0x9d7b,0x9d82,0x9d6f,0x9d79,0x9d7f,
0x9d87,0x9d68,0x9e94,0x9e91,0x9ec0,0x9efc,0x9f2d,0x9f40,
0x9f41,0x9f4d,0x9f56,0x9f57,0x9f58,0x5337,0x56b2,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x56b5,0x56b3,0x58e3,0x5b45,0x5dc6,0x5dc7,0x5eee,0x5eef,
0x5fc0,0x5fc1,0x61f9,0x6517,0x6516,0x6515,0x6513,0x65df,
0x66e8,0x66e3,0x66e4,0x6af3,0x6af0,0x6aea,0x6ae8,0x6af9,
0x6af1,0x6aee,0x6aef,0x703c,0x7035,0x702f,0x7037,0x7034,
0x7031,0x7042,0x7038,0x703f,0x703a,0x7039,0x7040,0x703b,
0x7033,0x7041,0x7213,0x7214,0x72a8,0x737d,0x737c,0x74ba,
0x76ab,0x76aa,0x76be,0x76ed,0x77cc,0x77ce,0x77cf,0x77cd,
0x77f2,0x7925,0x7923,0x7927,0x7928,0x7924,0x7929,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x79b2,0x7a6e,0x7a6c,0x7a6d,0x7af7,0x7c49,0x7c48,
0x7c4a,0x7c47,0x7c45,0x7cee,0x7e7b,0x7e7e,0x7e81,0x7e80,
0x7fba,0x7fff,0x8079,0x81db,0x81d9,0x820b,0x8268,0x8269,
0x8622,0x85ff,0x8601,0x85fe,0x861b,0x8600,0x85f6,0x8604,
0x8609,0x8605,0x860c,0x85fd,0x8819,0x8810,0x8811,0x8817,
0x8813,0x8816,0x8963,0x8966,0x89b9,0x89f7,0x8b60,0x8b6a,
0x8b5d,0x8b68,0x8b63,0x8b65,0x8b67,0x8b6d,0x8dae,0x8e86,
0x8e88,0x8e84,0x8f59,0x8f56,0x8f57,0x8f55,0x8f58,0x8f5a,
0x908d,0x9143,0x9141,0x91b7,0x91b5,0x91b2,0x91b3,0x940b,
0x9413,0x93fb,0x9420,0x940f,0x9414,0x93fe,0x9415,0x9410,
0x9428,0x9419,0x940d,0x93f5,0x9400,0x93f7,0x9407,0x940e,
0x9416,0x9412,0x93fa,0x9409,0x93f8,0x940a,0x93ff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x93fc,0x940c,0x93f6,0x9411,0x9406,0x95de,0x95e0,0x95df,
0x972e,0x972f,0x97b9,0x97bb,0x97fd,0x97fe,0x9860,0x9862,
0x9863,0x985f,0x98c1,0x98c2,0x9950,0x994e,0x9959,0x994c,
0x994b,0x9953,0x9a32,0x9a34,0x9a31,0x9a2c,0x9a2a,0x9a36,
0x9a29,0x9a2e,0x9a38,0x9a2d,0x9ac7,0x9aca,0x9ac6,0x9b10,
0x9b12,0x9b11,0x9c0b,0x9c08,0x9bf7,0x9c05,0x9c12,0x9bf8,
0x9c40,0x9c07,0x9c0e,0x9c06,0x9c17,0x9c14,0x9c09,0x9d9f,
0x9d99,0x9da4,0x9d9d,0x9d92,0x9d98,0x9d90,0x9d9b,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9da0,0x9d94,0x9d9c,0x9daa,0x9d97,0x9da1,0x9d9a,
0x9da2,0x9da8,0x9d9e,0x9da3,0x9dbf,0x9da9,0x9d96,0x9da6,
0x9da7,0x9e99,0x9e9b,0x9e9a,0x9ee5,0x9ee4,0x9ee7,0x9ee6,
0x9f30,0x9f2e,0x9f5b,0x9f60,0x9f5e,0x9f5d,0x9f59,0x9f91,
0x513a,0x5139,0x5298,0x5297,0x56c3,0x56bd,0x56be,0x5b48,
0x5b47,0x5dcb,0x5dcf,0x5ef1,0x61fd,0x651b,0x6b02,0x6afc,
0x6b03,0x6af8,0x6b00,0x7043,0x7044,0x704a,0x7048,0x7049,
0x7045,0x7046,0x721d,0x721a,0x7219,0x737e,0x7517,0x766a,
0x77d0,0x792d,0x7931,0x792f,0x7c54,0x7c53,0x7cf2,0x7e8a,
0x7e87,0x7e88,0x7e8b,0x7e86,0x7e8d,0x7f4d,0x7fbb,0x8030,
0x81dd,0x8618,0x862a,0x8626,0x861f,0x8623,0x861c,0x8619,
0x8627,0x862e,0x8621,0x8620,0x8629,0x861e,0x8625,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8829,0x881d,0x881b,0x8820,0x8824,0x881c,0x882b,0x884a,
0x896d,0x8969,0x896e,0x896b,0x89fa,0x8b79,0x8b78,0x8b45,
0x8b7a,0x8b7b,0x8d10,0x8d14,0x8daf,0x8e8e,0x8e8c,0x8f5e,
0x8f5b,0x8f5d,0x9146,0x9144,0x9145,0x91b9,0x943f,0x943b,
0x9436,0x9429,0x943d,0x943c,0x9430,0x9439,0x942a,0x9437,
0x942c,0x9440,0x9431,0x95e5,0x95e4,0x95e3,0x9735,0x973a,
0x97bf,0x97e1,0x9864,0x98c9,0x98c6,0x98c0,0x9958,0x9956,
0x9a39,0x9a3d,0x9a46,0x9a44,0x9a42,0x9a41,0x9a3a,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9a3f,0x9acd,0x9b15,0x9b17,0x9b18,0x9b16,0x9b3a,
0x9b52,0x9c2b,0x9c1d,0x9c1c,0x9c2c,0x9c23,0x9c28,0x9c29,
0x9c24,0x9c21,0x9db7,0x9db6,0x9dbc,0x9dc1,0x9dc7,0x9dca,
0x9dcf,0x9dbe,0x9dc5,0x9dc3,0x9dbb,0x9db5,0x9dce,0x9db9,
0x9dba,0x9dac,0x9dc8,0x9db1,0x9dad,0x9dcc,0x9db3,0x9dcd,
0x9db2,0x9e7a,0x9e9c,0x9eeb,0x9eee,0x9eed,0x9f1b,0x9f18,
0x9f1a,0x9f31,0x9f4e,0x9f65,0x9f64,0x9f92,0x4eb9,0x56c6,
0x56c5,0x56cb,0x5971,0x5b4b,0x5b4c,0x5dd5,0x5dd1,0x5ef2,
0x6521,0x6520,0x6526,0x6522,0x6b0b,0x6b08,0x6b09,0x6c0d,
0x7055,0x7056,0x7057,0x7052,0x721e,0x721f,0x72a9,0x737f,
0x74d8,0x74d5,0x74d9,0x74d7,0x766d,0x76ad,0x7935,0x79b4,
0x7a70,0x7a71,0x7c57,0x7c5c,0x7c59,0x7c5b,0x7c5a,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x7cf4,0x7cf1,0x7e91,0x7f4f,0x7f87,0x81de,0x826b,0x8634,
0x8635,0x8633,0x862c,0x8632,0x8636,0x882c,0x8828,0x8826,
0x882a,0x8825,0x8971,0x89bf,0x89be,0x89fb,0x8b7e,0x8b84,
0x8b82,0x8b86,0x8b85,0x8b7f,0x8d15,0x8e95,0x8e94,0x8e9a,
0x8e92,0x8e90,0x8e96,0x8e97,0x8f60,0x8f62,0x9147,0x944c,
0x9450,0x944a,0x944b,0x944f,0x9447,0x9445,0x9448,0x9449,
0x9446,0x973f,0x97e3,0x986a,0x9869,0x98cb,0x9954,0x995b,
0x9a4e,0x9a53,0x9a54,0x9a4c,0x9a4f,0x9a48,0x9a4a,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9a49,0x9a52,0x9a50,0x9ad0,0x9b19,0x9b2b,0x9b3b,
0x9b56,0x9b55,0x9c46,0x9c48,0x9c3f,0x9c44,0x9c39,0x9c33,
0x9c41,0x9c3c,0x9c37,0x9c34,0x9c32,0x9c3d,0x9c36,0x9ddb,
0x9dd2,0x9dde,0x9dda,0x9dcb,0x9dd0,0x9ddc,0x9dd1,0x9ddf,
0x9de9,0x9dd9,0x9dd8,0x9dd6,0x9df5,0x9dd5,0x9ddd,0x9eb6,
0x9ef0,0x9f35,0x9f33,0x9f32,0x9f42,0x9f6b,0x9f95,0x9fa2,
0x513d,0x5299,0x58e8,0x58e7,0x5972,0x5b4d,0x5dd8,0x882f,
0x5f4f,0x6201,0x6203,0x6204,0x6529,0x6525,0x6596,0x66eb,
0x6b11,0x6b12,0x6b0f,0x6bca,0x705b,0x705a,0x7222,0x7382,
0x7381,0x7383,0x7670,0x77d4,0x7c67,0x7c66,0x7e95,0x826c,
0x863a,0x8640,0x8639,0x863c,0x8631,0x863b,0x863e,0x8830,
0x8832,0x882e,0x8833,0x8976,0x8974,0x8973,0x89fe,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x8b8c,0x8b8e,0x8b8b,0x8b88,0x8c45,0x8d19,0x8e98,0x8f64,
0x8f63,0x91bc,0x9462,0x9455,0x945d,0x9457,0x945e,0x97c4,
0x97c5,0x9800,0x9a56,0x9a59,0x9b1e,0x9b1f,0x9b20,0x9c52,
0x9c58,0x9c50,0x9c4a,0x9c4d,0x9c4b,0x9c55,0x9c59,0x9c4c,
0x9c4e,0x9dfb,0x9df7,0x9def,0x9de3,0x9deb,0x9df8,0x9de4,
0x9df6,0x9de1,0x9dee,0x9de6,0x9df2,0x9df0,0x9de2,0x9dec,
0x9df4,0x9df3,0x9de8,0x9ded,0x9ec2,0x9ed0,0x9ef2,0x9ef3,
0x9f06,0x9f1c,0x9f38,0x9f37,0x9f36,0x9f43,0x9f4f,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9f71,0x9f70,0x9f6e,0x9f6f,0x56d3,0x56cd,0x5b4e,
0x5c6d,0x652d,0x66ed,0x66ee,0x6b13,0x705f,0x7061,0x705d,
0x7060,0x7223,0x74db,0x74e5,0x77d5,0x7938,0x79b7,0x79b6,
0x7c6a,0x7e97,0x7f89,0x826d,0x8643,0x8838,0x8837,0x8835,
0x884b,0x8b94,0x8b95,0x8e9e,0x8e9f,0x8ea0,0x8e9d,0x91be,
0x91bd,0x91c2,0x946b,0x9468,0x9469,0x96e5,0x9746,0x9743,
0x9747,0x97c7,0x97e5,0x9a5e,0x9ad5,0x9b59,0x9c63,0x9c67,
0x9c66,0x9c62,0x9c5e,0x9c60,0x9e02,0x9dfe,0x9e07,0x9e03,
0x9e06,0x9e05,0x9e00,0x9e01,0x9e09,0x9dff,0x9dfd,0x9e04,
0x9ea0,0x9f1e,0x9f46,0x9f74,0x9f75,0x9f76,0x56d4,0x652e,
0x65b8,0x6b18,0x6b19,0x6b17,0x6b1a,0x7062,0x7226,0x72aa,
0x77d8,0x77d9,0x7939,0x7c69,0x7c6b,0x7cf6,0x7e9a,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0x7e98,0x7e9b,0x7e99,0x81e0,0x81e1,0x8646,0x8647,0x8648,
0x8979,0x897a,0x897c,0x897b,0x89ff,0x8b98,0x8b99,0x8ea5,
0x8ea4,0x8ea3,0x946e,0x946d,0x946f,0x9471,0x9473,0x9749,
0x9872,0x995f,0x9c68,0x9c6e,0x9c6d,0x9e0b,0x9e0d,0x9e10,
0x9e0f,0x9e12,0x9e11,0x9ea1,0x9ef5,0x9f09,0x9f47,0x9f78,
0x9f7b,0x9f7a,0x9f79,0x571e,0x7066,0x7c6f,0x883c,0x8db2,
0x8ea6,0x91c3,0x9474,0x9478,0x9476,0x9475,0x9a60,0x9c74,
0x9c73,0x9c71,0x9c75,0x9e14,0x9e13,0x9ef6,0x9f0a,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0x9fa4,0x7068,0x7065,0x7cf7,0x866a,0x883e,0x883d,
0x883f,0x8b9e,0x8c9c,0x8ea9,0x8ec9,0x974b,0x9873,0x9874,
0x98cc,0x9961,0x99ab,0x9a64,0x9a66,0x9a67,0x9b24,0x9e15,
0x9e17,0x9f48,0x6207,0x6b1e,0x7227,0x864c,0x8ea8,0x9482,
0x9480,0x9481,0x9a69,0x9a68,0x9b2e,0x9e19,0x7229,0x864b,
0x8b9f,0x9483,0x9c79,0x9eb7,0x7675,0x9a6b,0x9c7a,0x9e1d,
0x7069,0x706a,0x9ea4,0x9f7e,0x9f49,0x9f98,0x7881,0x92b9,
0x88cf,0x58bb,0x6052,0x7ca7,0x5afa,0x2554,0x2566,0x2557,
0x2560,0x256c,0x2563,0x255a,0x2569,0x255d,0x2552,0x2564,
0x2555,0x255e,0x256a,0x2561,0x2558,0x2567,0x255b,0x2553,
0x2565,0x2556,0x255f,0x256b,0x2562,0x2559,0x2568,0x255c,
0x2551,0x2550,0x256d,0x256e,0x2570,0x256f,0x2593,0xffff
};
static const unsigned short Our_MS_BIG5_tableB[] = {
0x0000,0x0001,0x0002,0x0003,0x0004,0x0005,0x0006,0x0007,
0x0008,0x0009,0x000a,0x000b,0x000c,0x000d,0x000e,0x000f,
0x0010,0x0011,0x0012,0x0013,0x0014,0x0015,0x0016,0x0017,
0x0018,0x0019,0x001a,0x001b,0x001c,0x001d,0x001e,0x001f,
0x0020,0x0021,0x0022,0x0023,0x0024,0x0025,0x0026,0x0027,
0x0028,0x0029,0x002a,0x002b,0x002c,0x002d,0x002e,0x002f,
0x0030,0x0031,0x0032,0x0033,0x0034,0x0035,0x0036,0x0037,
0x0038,0x0039,0x003a,0x003b,0x003c,0x003d,0x003e,0x003f,
0x0040,0x0041,0x0042,0x0043,0x0044,0x0045,0x0046,0x0047,
0x0048,0x0049,0x004a,0x004b,0x004c,0x004d,0x004e,0x004f,
0x0050,0x0051,0x0052,0x0053,0x0054,0x0055,0x0056,0x0057,
0x0058,0x0059,0x005a,0x005b,0x005c,0x005d,0x005e,0x005f,
0x0060,0x0061,0x0062,0x0063,0x0064,0x0065,0x0066,0x0067,
0x0068,0x0069,0x006a,0x006b,0x006c,0x006d,0x006e,0x006f,
0x0070,0x0071,0x0072,0x0073,0x0074,0x0075,0x0076,0x0077,
0x0078,0x0079,0x007a,0x007b,0x007c,0x007d,0x007e,0x007f,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa1b1,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa1c2,
0xa258,0xa1d3,0xffff,0xffff,0xffff,0xffff,0xffff,0xa150,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa1d1,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa1d2,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa3be,
0xffff,0xa3bc,0xa3bd,0xa3bf,0xffff,0xa1c5,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xa3bb,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xa344,0xa345,0xa346,0xa347,0xa348,0xa349,0xa34a,
0xa34b,0xa34c,0xa34d,0xa34e,0xa34f,0xa350,0xa351,0xa352,
0xa353,0xa354,0xffff,0xa355,0xa356,0xa357,0xa358,0xa359,
0xa35a,0xa35b,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xa35c,0xa35d,0xa35e,0xa35f,0xa360,0xa361,0xa362,
0xa363,0xa364,0xa365,0xa366,0xa367,0xa368,0xa369,0xa36a,
0xa36b,0xa36c,0xffff,0xa36d,0xa36e,0xa36f,0xa370,0xa371,
0xa372,0xa373,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa156,0xa158,0xffff,0xffff,0xffff,
0xa1a5,0xa1a6,0xffff,0xffff,0xa1a7,0xa1a8,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa14c,0xa14b,0xa145,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xa1ac,0xffff,0xffff,0xa1ab,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa1b0,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa3e1,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa24a,0xffff,0xa1c1,0xffff,0xffff,
0xffff,0xa24b,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa2b9,0xa2ba,0xa2bb,0xa2bc,0xa2bd,0xa2be,0xa2bf,0xa2c0,
0xa2c1,0xa2c2,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa1f6,0xa1f4,0xa1f7,0xa1f5,0xffff,0xffff,0xa1f8,0xa1f9,
0xa1fb,0xa1fa,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa241,0xffff,0xffff,
0xffff,0xffff,0xa1d4,0xffff,0xffff,0xffff,0xa1db,0xa1e8,
0xa1e7,0xffff,0xffff,0xa1fd,0xffff,0xa1fc,0xffff,0xffff,
0xffff,0xa1e4,0xa1e5,0xa1ec,0xffff,0xffff,0xa1ed,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa1ef,0xa1ee,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xa1dc,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa1da,0xa1dd,0xffff,0xffff,0xffff,0xffff,0xa1d8,0xa1d9,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa1f2,0xffff,0xffff,
0xffff,0xa1f3,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa1e6,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa1e9,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa277,0xffff,0xa278,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa27a,0xffff,0xffff,0xffff,
0xa27b,0xffff,0xffff,0xffff,0xa27c,0xffff,0xffff,0xffff,
0xa27d,0xffff,0xffff,0xffff,0xa275,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa274,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa273,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa272,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa271,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa2a4,0xf9f8,0xf9e6,0xf9ef,0xf9dd,0xf9e8,0xf9f1,0xf9df,
0xf9ec,0xf9f5,0xf9e3,0xf9ee,0xf9f7,0xf9e5,0xa2a5,0xf9f2,
0xf9e0,0xa2a7,0xf9f4,0xf9e2,0xf9e7,0xf9f0,0xf9de,0xf9ed,
0xf9f6,0xf9e4,0xa2a6,0xf9f3,0xf9e1,0xa27e,0xa2a1,0xa2a3,
0xa2a2,0xa2ac,0xa2ad,0xa2ae,0xa15a,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xa262,0xa263,0xa264,0xa265,0xa266,0xa267,0xa268,
0xa269,0xa270,0xa26f,0xa26e,0xa26d,0xa26c,0xa26b,0xa26a,
0xffff,0xffff,0xffff,0xf9fe,0xa276,0xa279,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa1bd,0xa1bc,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xa1b6,0xa1b5,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa1bf,0xa1be,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa1bb,0xa1ba,
0xffff,0xffff,0xffff,0xa1b3,0xffff,0xffff,0xa1b7,0xa1b4,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xa2a8,0xa2a9,0xa2ab,0xa2aa,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa1b9,0xa1b8,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa1f0,0xffff,0xa1f1,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa140,0xa142,0xa143,0xa1b2,0xffff,0xffff,0xffff,0xffff,
0xa171,0xa172,0xa16d,0xa16e,0xa175,0xa176,0xa179,0xa17a,
0xa169,0xa16a,0xa245,0xffff,0xa165,0xa166,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa1a9,0xa1aa,0xffff,
0xffff,0xa2c3,0xa2c4,0xa2c5,0xa2c6,0xa2c7,0xa2c8,0xa2c9,
0xa2ca,0xa2cb,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa374,0xa375,0xa376,
0xa377,0xa378,0xa379,0xa37a,0xa37b,0xa37c,0xa37d,0xa37e,
0xa3a1,0xa3a2,0xa3a3,0xa3a4,0xa3a5,0xa3a6,0xa3a7,0xa3a8,
0xa3a9,0xa3aa,0xa3ab,0xa3ac,0xa3ad,0xa3ae,0xa3af,0xa3b0,
0xa3b1,0xa3b2,0xa3b3,0xa3b4,0xa3b5,0xa3b6,0xa3b7,0xa3b8,
0xa3b9,0xa3ba,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa1c0,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa255,0xa256,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa250,0xa251,0xa252,0xffff,
0xffff,0xa254,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa257,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa253,0xffff,
0xffff,0xa1eb,0xa1ea,0xffff,0xffff,0xa24f,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa440,0xa442,0xffff,0xa443,0xffff,0xffff,0xffff,0xc945,
0xa456,0xa454,0xa457,0xa455,0xc946,0xa4a3,0xc94f,0xc94d,
0xa4a2,0xa4a1,0xffff,0xffff,0xa542,0xa541,0xa540,0xffff,
0xa543,0xa4fe,0xffff,0xffff,0xffff,0xffff,0xa5e0,0xa5e1,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa8c3,0xffff,
0xffff,0xffff,0xffff,0xa458,0xffff,0xa4a4,0xc950,0xffff,
0xa4a5,0xc963,0xa6ea,0xcbb1,0xffff,0xffff,0xffff,0xffff,
0xa459,0xa4a6,0xffff,0xa544,0xc964,0xffff,0xffff,0xffff,
0xffff,0xffff,0xc940,0xa444,0xffff,0xa45b,0xffff,0xc947,
0xa45c,0xffff,0xffff,0xa4a7,0xffff,0xa545,0xa547,0xa546,
0xffff,0xffff,0xa5e2,0xa5e3,0xffff,0xffff,0xa8c4,0xffff,
0xadbc,0xa441,0xffff,0xffff,0xc941,0xa445,0xa45e,0xa45d,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xa5e4,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa8c5,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xb0ae,0xd44b,
0xffff,0xffff,0xb6c3,0xdcb1,0xdcb2,0xffff,0xa446,0xffff,
0xa4a9,0xffff,0xffff,0xa8c6,0xa447,0xc948,0xa45f,0xffff,
0xffff,0xa4aa,0xa4ac,0xc951,0xa4ad,0xa4ab,0xffff,0xffff,
0xffff,0xa5e5,0xffff,0xa8c7,0xffff,0xffff,0xa8c8,0xab45,
0xffff,0xa460,0xa4ae,0xffff,0xa5e6,0xa5e8,0xa5e7,0xffff,
0xa6eb,0xffff,0xffff,0xa8c9,0xa8ca,0xab46,0xab47,0xffff,
0xffff,0xffff,0xffff,0xadbd,0xffff,0xffff,0xdcb3,0xffff,
0xffff,0xf6d6,0xa448,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa4b0,0xa4af,0xc952,0xa4b1,0xa4b7,0xffff,0xa4b2,0xa4b3,
0xc954,0xc953,0xa4b5,0xa4b6,0xffff,0xa4b4,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa54a,0xa54b,0xa54c,0xa54d,
0xa549,0xa550,0xc96a,0xffff,0xc966,0xc969,0xa551,0xa561,
0xffff,0xc968,0xffff,0xa54e,0xa54f,0xa548,0xffff,0xffff,
0xc965,0xc967,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa5f5,0xc9b0,0xa5f2,0xa5f6,0xc9ba,0xc9ae,0xa5f3,0xc9b2,
0xffff,0xffff,0xffff,0xa5f4,0xffff,0xa5f7,0xffff,0xa5e9,
0xc9b1,0xa5f8,0xc9b5,0xffff,0xc9b9,0xc9b6,0xffff,0xffff,
0xc9b3,0xa5ea,0xa5ec,0xa5f9,0xffff,0xa5ee,0xc9ab,0xa5f1,
0xa5ef,0xa5f0,0xc9bb,0xc9b8,0xc9af,0xa5ed,0xffff,0xffff,
0xc9ac,0xa5eb,0xffff,0xffff,0xffff,0xc9b4,0xffff,0xffff,
0xffff,0xffff,0xc9b7,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xc9ad,0xca66,0xffff,0xa742,
0xa6f4,0xffff,0xffff,0xca67,0xa6f1,0xffff,0xa744,0xffff,
0xa6f9,0xffff,0xa6f8,0xca5b,0xa6fc,0xa6f7,0xca60,0xca68,
0xffff,0xca64,0xffff,0xa6fa,0xffff,0xffff,0xa6fd,0xa6ee,
0xa747,0xca5d,0xffff,0xffff,0xcbbd,0xa6ec,0xa743,0xa6ed,
0xa6f5,0xa6f6,0xca62,0xca5e,0xa6fb,0xa6f3,0xca5a,0xa6ef,
0xca65,0xa745,0xa748,0xa6f2,0xa740,0xa746,0xa6f0,0xca63,
0xa741,0xca69,0xca5c,0xa6fe,0xca5f,0xffff,0xffff,0xca61,
0xffff,0xa8d8,0xcbbf,0xcbcb,0xa8d0,0xffff,0xcbcc,0xa8cb,
0xa8d5,0xffff,0xffff,0xa8ce,0xcbb9,0xa8d6,0xcbb8,0xcbbc,
0xcbc3,0xcbc1,0xa8de,0xa8d9,0xcbb3,0xcbb5,0xa8db,0xa8cf,
0xcbb6,0xcbc2,0xcbc9,0xa8d4,0xcbbb,0xcbb4,0xa8d3,0xcbb7,
0xa8d7,0xcbba,0xffff,0xa8d2,0xffff,0xa8cd,0xffff,0xa8dc,
0xcbc4,0xa8dd,0xcbc8,0xffff,0xcbc6,0xcbca,0xa8da,0xcbbe,
0xcbb2,0xffff,0xcbc0,0xa8d1,0xcbc5,0xa8cc,0xcbc7,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xab56,0xab4a,
0xffff,0xffff,0xcde0,0xcde8,0xffff,0xab49,0xab51,0xab5d,
0xffff,0xcdee,0xcdec,0xcde7,0xffff,0xffff,0xffff,0xab4b,
0xcded,0xcde3,0xab59,0xab50,0xab58,0xcdde,0xffff,0xcdea,
0xffff,0xcde1,0xab54,0xcde2,0xffff,0xcddd,0xab5b,0xab4e,
0xab57,0xab4d,0xffff,0xcddf,0xcde4,0xffff,0xcdeb,0xab55,
0xab52,0xcde6,0xab5a,0xcde9,0xcde5,0xab4f,0xab5c,0xab53,
0xab4c,0xab48,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xcdef,0xffff,0xadd7,0xadc1,
0xffff,0xadd1,0xffff,0xadd6,0xd0d0,0xd0cf,0xd0d4,0xd0d5,
0xadc4,0xffff,0xadcd,0xffff,0xffff,0xffff,0xadda,0xffff,
0xadce,0xffff,0xffff,0xffff,0xffff,0xd0c9,0xadc7,0xd0ca,
0xffff,0xaddc,0xffff,0xadd3,0xadbe,0xadbf,0xd0dd,0xb0bf,
0xffff,0xadcc,0xadcb,0xd0cb,0xadcf,0xd45b,0xadc6,0xd0d6,
0xadd5,0xadd4,0xadca,0xd0ce,0xd0d7,0xffff,0xd0c8,0xadc9,
0xd0d8,0xadd2,0xd0cc,0xadc0,0xffff,0xadc3,0xadc2,0xd0d9,
0xadd0,0xadc5,0xadd9,0xaddb,0xd0d3,0xadd8,0xffff,0xd0db,
0xd0cd,0xd0dc,0xffff,0xd0d1,0xffff,0xd0da,0xffff,0xd0d2,
0xffff,0xffff,0xffff,0xffff,0xadc8,0xffff,0xffff,0xffff,
0xd463,0xd457,0xffff,0xb0b3,0xffff,0xd45c,0xd462,0xb0b2,
0xd455,0xb0b6,0xd459,0xd452,0xb0b4,0xd456,0xb0b9,0xb0be,
0xffff,0xd467,0xffff,0xd451,0xffff,0xb0ba,0xffff,0xd466,
0xffff,0xffff,0xb0b5,0xd458,0xb0b1,0xd453,0xd44f,0xd45d,
0xd450,0xd44e,0xd45a,0xd460,0xd461,0xb0b7,0xffff,0xffff,
0xd85b,0xd45e,0xd44d,0xd45f,0xffff,0xb0c1,0xd464,0xb0c0,
0xd44c,0xffff,0xd454,0xd465,0xb0bc,0xb0bb,0xb0b8,0xb0bd,
0xffff,0xffff,0xb0af,0xffff,0xffff,0xb0b0,0xffff,0xffff,
0xb3c8,0xffff,0xd85e,0xd857,0xffff,0xb3c5,0xffff,0xd85f,
0xffff,0xffff,0xffff,0xd855,0xd858,0xb3c4,0xd859,0xffff,
0xffff,0xb3c7,0xd85d,0xffff,0xd853,0xd852,0xb3c9,0xffff,
0xb3ca,0xb3c6,0xb3cb,0xd851,0xd85c,0xd85a,0xd854,0xffff,
0xffff,0xffff,0xb3c3,0xd856,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xb6ca,0xb6c4,0xdcb7,0xb6cd,
0xdcbd,0xdcc0,0xb6c6,0xb6c7,0xdcba,0xb6c5,0xdcc3,0xb6cb,
0xdcc4,0xffff,0xdcbf,0xb6cc,0xffff,0xdcb4,0xb6c9,0xdcb5,
0xffff,0xdcbe,0xdcbc,0xffff,0xdcb8,0xb6c8,0xdcb6,0xb6ce,
0xdcbb,0xdcc2,0xdcb9,0xdcc1,0xffff,0xffff,0xb9b6,0xb9b3,
0xffff,0xb9b4,0xffff,0xe0f9,0xe0f1,0xb9b2,0xb9af,0xe0f2,
0xffff,0xffff,0xb9b1,0xe0f5,0xffff,0xe0f7,0xffff,0xffff,
0xe0fe,0xffff,0xffff,0xe0fd,0xe0f8,0xb9ae,0xe0f0,0xb9ac,
0xe0f3,0xb9b7,0xe0f6,0xffff,0xe0fa,0xb9b0,0xb9ad,0xe0fc,
0xe0fb,0xb9b5,0xffff,0xe0f4,0xffff,0xbbf8,0xe4ec,0xffff,
0xe4e9,0xbbf9,0xffff,0xbbf7,0xffff,0xe4f0,0xe4ed,0xe4e6,
0xbbf6,0xffff,0xbbfa,0xe4e7,0xbbf5,0xbbfd,0xe4ea,0xe4eb,
0xbbfb,0xbbfc,0xe4f1,0xe4ee,0xe4ef,0xffff,0xffff,0xffff,
0xbeaa,0xe8f8,0xbea7,0xe8f5,0xbea9,0xbeab,0xffff,0xe8f6,
0xbea8,0xffff,0xe8f7,0xffff,0xe8f4,0xffff,0xffff,0xc076,
0xecbd,0xc077,0xecbb,0xffff,0xecbc,0xecba,0xecb9,0xffff,
0xffff,0xecbe,0xc075,0xffff,0xffff,0xefb8,0xefb9,0xffff,
0xe4e8,0xefb7,0xc078,0xc35f,0xf1eb,0xf1ec,0xffff,0xc4d7,
0xc4d8,0xf5c1,0xf5c0,0xc56c,0xc56b,0xf7d0,0xffff,0xa449,
0xa461,0xa4b9,0xffff,0xa4b8,0xa553,0xa552,0xa5fc,0xa5fb,
0xa5fd,0xa5fa,0xffff,0xa74a,0xa749,0xa74b,0xffff,0xffff,
0xffff,0xffff,0xa8e0,0xffff,0xa8df,0xa8e1,0xffff,0xab5e,
0xffff,0xa259,0xd0de,0xa25a,0xb0c2,0xa25c,0xa25b,0xd860,
0xffff,0xa25d,0xb9b8,0xa25e,0xffff,0xa44a,0xffff,0xa4ba,
0xa5fe,0xa8e2,0xffff,0xa44b,0xa4bd,0xa4bb,0xa4bc,0xffff,
0xffff,0xa640,0xffff,0xffff,0xffff,0xa74c,0xa8e4,0xa8e3,
0xa8e5,0xffff,0xffff,0xffff,0xaddd,0xffff,0xffff,0xffff,
0xbeac,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xc94e,
0xffff,0xa554,0xa555,0xffff,0xffff,0xa641,0xffff,0xca6a,
0xffff,0xab60,0xab5f,0xd0e0,0xd0df,0xb0c3,0xffff,0xa4be,
0xc955,0xffff,0xffff,0xffff,0xffff,0xffff,0xcbcd,0xffff,
0xab61,0xffff,0xade0,0xffff,0xadde,0xaddf,0xffff,0xffff,
0xffff,0xffff,0xbead,0xffff,0xa556,0xffff,0xffff,0xffff,
0xa642,0xc9bc,0xffff,0xffff,0xffff,0xffff,0xa74d,0xa74e,
0xffff,0xca6b,0xffff,0xffff,0xcbce,0xa8e6,0xcbcf,0xffff,
0xffff,0xffff,0xffff,0xffff,0xd0e2,0xd0e3,0xade3,0xffff,
0xd0e4,0xffff,0xd0e1,0xade4,0xade2,0xade1,0xd0e5,0xffff,
0xd468,0xffff,0xffff,0xffff,0xd861,0xffff,0xffff,0xdcc5,
0xe140,0xffff,0xffff,0xffff,0xbbfe,0xbeae,0xe8f9,0xffff,
0xa44c,0xa45a,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xb0c4,0xb3cd,0xffff,0xb9b9,0xffff,0xc942,0xa4bf,0xffff,
0xa559,0xa557,0xa558,0xffff,0xffff,0xa8e7,0xffff,0xffff,
0xa44d,0xa44e,0xffff,0xa462,0xffff,0xffff,0xa4c0,0xa4c1,
0xa4c2,0xc9be,0xa55a,0xffff,0xc96b,0xffff,0xa646,0xffff,
0xc9bf,0xa644,0xa645,0xc9bd,0xffff,0xffff,0xa647,0xa643,
0xffff,0xffff,0xffff,0xffff,0xca6c,0xaaec,0xca6d,0xffff,
0xffff,0xca6e,0xffff,0xffff,0xa750,0xa74f,0xffff,0xffff,
0xa753,0xa751,0xa752,0xffff,0xffff,0xffff,0xa8ed,0xffff,
0xa8ec,0xcbd4,0xcbd1,0xcbd2,0xffff,0xcbd0,0xa8ee,0xa8ea,
0xa8e9,0xffff,0xa8eb,0xa8e8,0xffff,0xffff,0xffff,0xffff,
0xffff,0xa8ef,0xffff,0xab63,0xcdf0,0xffff,0xcbd3,0xab68,
0xffff,0xcdf1,0xab64,0xab67,0xab66,0xab65,0xab62,0xffff,
0xffff,0xffff,0xd0e8,0xffff,0xade7,0xd0eb,0xade5,0xffff,
0xffff,0xffff,0xd0e7,0xade8,0xade6,0xade9,0xd0e9,0xd0ea,
0xffff,0xd0e6,0xd0ec,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xb3d1,0xb0c5,0xd469,0xd46b,0xd46a,0xd46c,0xb0c6,
0xffff,0xffff,0xb3ce,0xffff,0xb3cf,0xb3d0,0xffff,0xb6d0,
0xdcc7,0xffff,0xdcc6,0xdcc8,0xdcc9,0xb6d1,0xffff,0xb6cf,
0xe141,0xe142,0xb9bb,0xb9ba,0xe35a,0xffff,0xffff,0xbc40,
0xbc41,0xbc42,0xbc44,0xe4f2,0xe4f3,0xbc43,0xffff,0xffff,
0xffff,0xbeaf,0xffff,0xbeb0,0xffff,0xffff,0xf1ed,0xf5c3,
0xf5c2,0xf7d1,0xffff,0xa44f,0xffff,0xffff,0xffff,0xa55c,
0xa55b,0xffff,0xffff,0xa648,0xffff,0xffff,0xc9c0,0xffff,
0xffff,0xa755,0xa756,0xa754,0xa757,0xca6f,0xca70,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa8f1,0xcbd5,0xffff,0xa8f0,0xffff,
0xcdf2,0xab6c,0xcdf3,0xab6b,0xffff,0xffff,0xffff,0xab69,
0xffff,0xab6a,0xffff,0xffff,0xffff,0xd0ed,0xffff,0xffff,
0xffff,0xffff,0xb0c7,0xd46e,0xffff,0xb0ca,0xd46d,0xb1e5,
0xb0c9,0xb0c8,0xffff,0xb3d4,0xffff,0xb3d3,0xb3d2,0xb6d2,
0xffff,0xffff,0xb6d5,0xb6d6,0xb6d4,0xffff,0xb6d3,0xffff,
0xffff,0xe143,0xffff,0xe144,0xffff,0xffff,0xffff,0xe4f5,
0xbc45,0xe4f4,0xffff,0xbeb1,0xecbf,0xc079,0xffff,0xf1ee,
0xc455,0xffff,0xa463,0xa4c3,0xc956,0xffff,0xa4c4,0xa4c5,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa55d,0xa55e,0xffff,
0xa649,0xca71,0xcbd6,0xcbd7,0xffff,0xab6d,0xd0ee,0xb0cc,
0xb0cb,0xd863,0xd862,0xffff,0xffff,0xa450,0xa4c6,0xa55f,
0xffff,0xb0cd,0xc943,0xffff,0xc96c,0xa560,0xffff,0xc9c2,
0xa64b,0xa64a,0xc9c1,0xa758,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xadea,0xffff,0xffff,0xd46f,0xffff,0xb6d7,
0xe145,0xb9bc,0xffff,0xffff,0xe8fa,0xffff,0xffff,0xf3fd,
0xffff,0xa4c7,0xffff,0xffff,0xcbd8,0xcdf4,0xb0d0,0xb0ce,
0xb0cf,0xa451,0xffff,0xa464,0xa2cd,0xa4ca,0xffff,0xa4c9,
0xa4c8,0xa563,0xa562,0xffff,0xc96d,0xc9c3,0xffff,0xffff,
0xffff,0xa8f5,0xa8f2,0xa8f4,0xa8f3,0xffff,0xffff,0xab6e,
0xffff,0xffff,0xb3d5,0xffff,0xa452,0xffff,0xa4cb,0xffff,
0xa565,0xa564,0xffff,0xca72,0xffff,0xffff,0xa8f6,0xffff,
0xffff,0xffff,0xffff,0xffff,0xc957,0xffff,0xa567,0xa566,
0xa64c,0xa64d,0xca73,0xa759,0xffff,0xa75a,0xffff,0xa8f7,
0xa8f8,0xa8f9,0xffff,0xab6f,0xcdf5,0xffff,0xffff,0xadeb,
0xffff,0xffff,0xc944,0xffff,0xa4cc,0xffff,0xffff,0xffff,
0xffff,0xffff,0xc9c4,0xffff,0xffff,0xffff,0xca74,0xca75,
0xffff,0xffff,0xcbd9,0xffff,0xcbda,0xffff,0xcdf7,0xcdf6,
0xcdf9,0xcdf8,0xab70,0xffff,0xd470,0xaded,0xd0ef,0xadec,
0xffff,0xffff,0xffff,0xffff,0xd864,0xb3d6,0xffff,0xd865,
0xffff,0xffff,0xffff,0xffff,0xe146,0xb9bd,0xffff,0xffff,
0xffff,0xffff,0xbc46,0xffff,0xf1ef,0xffff,0xffff,0xffff,
0xffff,0xc958,0xffff,0xa568,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xb0d1,0xffff,0xffff,0xffff,0xffff,
0xa453,0xa465,0xa4ce,0xa4cd,0xffff,0xa4cf,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa8fb,0xffff,0xa8fa,0xa8fc,
0xffff,0xffff,0xffff,0xab71,0xffff,0xffff,0xffff,0xadee,
0xffff,0xe8fb,0xc24f,0xa466,0xa56a,0xa579,0xa574,0xffff,
0xa56f,0xa56e,0xa575,0xa573,0xa56c,0xa57a,0xa56d,0xa569,
0xa578,0xa577,0xa576,0xa56b,0xffff,0xa572,0xffff,0xffff,
0xa571,0xffff,0xffff,0xa57b,0xa570,0xffff,0xffff,0xffff,
0xffff,0xa653,0xffff,0xa659,0xa655,0xffff,0xa65b,0xc9c5,
0xa658,0xa64e,0xa651,0xa654,0xa650,0xa657,0xa65a,0xa64f,
0xa652,0xa656,0xa65c,0xffff,0xffff,0xffff,0xffff,0xffff,
0xca7e,0xca7b,0xffff,0xa767,0xca7c,0xa75b,0xa75d,0xa775,
0xa770,0xffff,0xffff,0xffff,0xcaa5,0xca7d,0xa75f,0xa761,
0xcaa4,0xa768,0xca78,0xa774,0xa776,0xa75c,0xa76d,0xffff,
0xca76,0xa773,0xffff,0xa764,0xffff,0xa76e,0xa76f,0xca77,
0xa76c,0xa76a,0xffff,0xa76b,0xa771,0xcaa1,0xa75e,0xffff,
0xa772,0xcaa3,0xa766,0xa763,0xffff,0xca7a,0xa762,0xcaa6,
0xa765,0xffff,0xa769,0xffff,0xffff,0xffff,0xa760,0xcaa2,
0xffff,0xffff,0xffff,0xffff,0xca79,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xcbeb,0xcbea,0xa94f,0xcbed,0xcbef,0xcbe4,0xcbe7,0xcbee,
0xa950,0xffff,0xffff,0xcbe1,0xcbe5,0xffff,0xffff,0xcbe9,
0xce49,0xa94b,0xce4d,0xa8fd,0xcbe6,0xa8fe,0xa94c,0xa945,
0xa941,0xffff,0xcbe2,0xa944,0xa949,0xa952,0xcbe3,0xcbdc,
0xa943,0xcbdd,0xcbdf,0xffff,0xa946,0xffff,0xa948,0xcbdb,
0xcbe0,0xffff,0xffff,0xa951,0xa94d,0xcbe8,0xa953,0xffff,
0xa94a,0xcbde,0xa947,0xffff,0xffff,0xa942,0xa940,0xffff,
0xcbec,0xffff,0xa94e,0xffff,0xffff,0xffff,0xffff,0xffff,
0xce48,0xcdfb,0xce4b,0xffff,0xffff,0xcdfd,0xab78,0xaba8,
0xab74,0xaba7,0xab7d,0xaba4,0xab72,0xcdfc,0xce43,0xaba3,
0xce4f,0xaba5,0xffff,0xab79,0xffff,0xffff,0xce45,0xce42,
0xab77,0xffff,0xcdfa,0xaba6,0xce4a,0xab7c,0xce4c,0xaba9,
0xab73,0xab7e,0xab7b,0xce40,0xaba1,0xce46,0xce47,0xab7a,
0xaba2,0xab76,0xffff,0xffff,0xffff,0xffff,0xab75,0xcdfe,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xce44,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xce4e,0xffff,
0xd144,0xadfb,0xd0f1,0xffff,0xd0f6,0xadf4,0xae40,0xd0f4,
0xadef,0xadf9,0xadfe,0xd0fb,0xffff,0xadfa,0xadfd,0xffff,
0xffff,0xd0fe,0xadf5,0xd0f5,0xffff,0xffff,0xffff,0xd142,
0xd143,0xffff,0xadf7,0xd141,0xadf3,0xae43,0xffff,0xd0f8,
0xffff,0xadf1,0xffff,0xd146,0xd0f9,0xd0fd,0xadf6,0xae42,
0xd0fa,0xadfc,0xd140,0xd147,0xd4a1,0xffff,0xd145,0xae44,
0xadf0,0xd0fc,0xd0f3,0xffff,0xadf8,0xffff,0xffff,0xd0f2,
0xffff,0xffff,0xd0f7,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xd0f0,0xae41,
0xffff,0xffff,0xd477,0xffff,0xb0e4,0xd4a7,0xb0e2,0xb0df,
0xd47c,0xb0db,0xd4a2,0xb0e6,0xd476,0xd47b,0xd47a,0xadf2,
0xb0e1,0xd4a5,0xffff,0xd4a8,0xd473,0xffff,0xb3e8,0xffff,
0xd4a9,0xb0e7,0xffff,0xb0d9,0xb0d6,0xd47e,0xb0d3,0xffff,
0xd4a6,0xffff,0xb0da,0xd4aa,0xffff,0xd474,0xd4a4,0xb0dd,
0xd475,0xd478,0xd47d,0xffff,0xffff,0xb0de,0xb0dc,0xb0e8,
0xffff,0xffff,0xffff,0xffff,0xb0e3,0xffff,0xb0d7,0xb1d2,
0xffff,0xb0d8,0xd479,0xb0e5,0xb0e0,0xd4a3,0xb0d5,0xffff,
0xffff,0xffff,0xb0d4,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xd471,0xd472,0xd86a,
0xffff,0xffff,0xffff,0xb3d7,0xb3da,0xd875,0xb3ee,0xd878,
0xb3d8,0xd871,0xb3de,0xb3e4,0xb5bd,0xffff,0xffff,0xb3e2,
0xd86e,0xb3ef,0xb3db,0xb3e3,0xd876,0xdcd7,0xd87b,0xd86f,
0xffff,0xd866,0xd873,0xd86d,0xb3e1,0xd879,0xffff,0xffff,
0xb3dd,0xb3f1,0xb3ea,0xffff,0xb3df,0xb3dc,0xffff,0xb3e7,
0xffff,0xd87a,0xd86c,0xd872,0xd874,0xd868,0xd877,0xb3d9,
0xd867,0xffff,0xb3e0,0xb3f0,0xb3ec,0xd869,0xb3e6,0xffff,
0xffff,0xb3ed,0xb3e9,0xb3e5,0xffff,0xd870,0xffff,0xffff,
0xffff,0xffff,0xffff,0xb3eb,0xffff,0xffff,0xffff,0xdcd5,
0xdcd1,0xffff,0xdce0,0xdcca,0xdcd3,0xb6e5,0xb6e6,0xb6de,
0xdcdc,0xb6e8,0xdccf,0xdcce,0xdccc,0xdcde,0xb6dc,0xdcd8,
0xdccd,0xb6df,0xdcd6,0xb6da,0xdcd2,0xdcd9,0xdcdb,0xffff,
0xffff,0xdcdf,0xb6e3,0xdccb,0xb6dd,0xdcd0,0xffff,0xb6d8,
0xffff,0xb6e4,0xdcda,0xb6e0,0xb6e1,0xb6e7,0xb6db,0xa25f,
0xb6d9,0xdcd4,0xffff,0xffff,0xffff,0xffff,0xffff,0xb6e2,
0xffff,0xffff,0xdcdd,0xffff,0xffff,0xffff,0xb9cd,0xb9c8,
0xffff,0xe155,0xe151,0xffff,0xe14b,0xb9c2,0xb9be,0xe154,
0xb9bf,0xe14e,0xe150,0xffff,0xe153,0xffff,0xb9c4,0xffff,
0xb9cb,0xb9c5,0xffff,0xffff,0xe149,0xb9c6,0xb9c7,0xe14c,
0xb9cc,0xffff,0xe14a,0xe14f,0xb9c3,0xe148,0xb9c9,0xb9c1,
0xffff,0xffff,0xffff,0xb9c0,0xe14d,0xe152,0xffff,0xb9ca,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe147,
0xffff,0xbc4d,0xe547,0xffff,0xe544,0xffff,0xbc47,0xbc53,
0xbc54,0xffff,0xbc4a,0xe542,0xbc4c,0xe4f9,0xbc52,0xffff,
0xe546,0xbc49,0xe548,0xbc48,0xffff,0xe543,0xe545,0xbc4b,
0xe541,0xe4fa,0xe4f7,0xffff,0xffff,0xd86b,0xe4fd,0xffff,
0xe4f6,0xe4fc,0xe4fb,0xffff,0xe4f8,0xffff,0xbc4f,0xffff,
0xffff,0xffff,0xffff,0xbc4e,0xffff,0xffff,0xffff,0xbc50,
0xe4fe,0xbeb2,0xe540,0xffff,0xffff,0xffff,0xe945,0xffff,
0xe8fd,0xffff,0xbebe,0xe942,0xbeb6,0xbeba,0xe941,0xffff,
0xbeb9,0xbeb5,0xbeb8,0xbeb3,0xbebd,0xe943,0xe8fe,0xbebc,
0xe8fc,0xbebb,0xe944,0xe940,0xbc51,0xffff,0xbebf,0xe946,
0xbeb7,0xbeb4,0xffff,0xffff,0xffff,0xffff,0xecc6,0xecc8,
0xc07b,0xecc9,0xecc7,0xecc5,0xecc4,0xc07d,0xecc3,0xc07e,
0xffff,0xffff,0xffff,0xffff,0xecc1,0xecc2,0xc07a,0xc0a1,
0xc07c,0xffff,0xffff,0xecc0,0xffff,0xc250,0xffff,0xefbc,
0xefba,0xefbf,0xefbd,0xffff,0xefbb,0xefbe,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xc360,0xf1f2,0xf1f3,
0xc456,0xffff,0xf1f4,0xf1f0,0xf1f5,0xf1f1,0xc251,0xffff,
0xffff,0xffff,0xf3fe,0xf441,0xc459,0xf440,0xc458,0xc457,
0xffff,0xffff,0xffff,0xffff,0xc45a,0xf5c5,0xf5c6,0xffff,
0xc4da,0xc4d9,0xc4db,0xf5c4,0xffff,0xf6d8,0xf6d7,0xffff,
0xc56d,0xc56f,0xc56e,0xf6d9,0xc5c8,0xf8a6,0xffff,0xffff,
0xffff,0xc5f1,0xffff,0xf8a5,0xf8ee,0xffff,0xffff,0xc949,
0xffff,0xffff,0xa57d,0xa57c,0xffff,0xa65f,0xa65e,0xc9c7,
0xa65d,0xc9c6,0xffff,0xffff,0xa779,0xcaa9,0xffff,0xcaa8,
0xffff,0xffff,0xa777,0xa77a,0xffff,0xffff,0xcaa7,0xffff,
0xa778,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xcbf0,
0xffff,0xcbf1,0xa954,0xffff,0xffff,0xffff,0xffff,0xabaa,
0xffff,0xd148,0xd149,0xae45,0xae46,0xffff,0xffff,0xd4ac,
0xb0e9,0xb0eb,0xd4ab,0xb0ea,0xd87c,0xb3f2,0xffff,0xffff,
0xffff,0xffff,0xb6e9,0xb6ea,0xdce1,0xffff,0xb9cf,0xffff,
0xb9ce,0xffff,0xe549,0xe948,0xe947,0xffff,0xf96b,0xa467,
0xc959,0xffff,0xc96e,0xc96f,0xffff,0xffff,0xffff,0xffff,
0xa662,0xa666,0xc9c9,0xffff,0xa664,0xa663,0xc9c8,0xa665,
0xa661,0xffff,0xffff,0xa660,0xc9ca,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa7a6,0xffff,0xffff,0xa7a3,0xffff,
0xa77d,0xcaaa,0xffff,0xffff,0xffff,0xcaab,0xffff,0xa7a1,
0xffff,0xcaad,0xa77b,0xcaae,0xcaac,0xa77e,0xa7a2,0xa7a5,
0xa7a4,0xa77c,0xcaaf,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xa959,0xcbfe,0xffff,0xa95b,0xffff,0xa95a,0xffff,
0xcc40,0xa958,0xa957,0xcbf5,0xffff,0xcbf4,0xffff,0xcbf2,
0xcbf7,0xcbf6,0xcbf3,0xcbfc,0xcbfd,0xcbfa,0xcbf8,0xa956,
0xffff,0xffff,0xffff,0xcbfb,0xa95c,0xcc41,0xffff,0xffff,
0xcbf9,0xffff,0xabab,0xa955,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xabac,0xce54,0xffff,0xffff,0xce5a,
0xffff,0xffff,0xffff,0xabb2,0xce58,0xce5e,0xffff,0xce55,
0xce59,0xce5b,0xce5d,0xce57,0xffff,0xce56,0xce51,0xce52,
0xabad,0xffff,0xabaf,0xabae,0xce53,0xce5c,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xabb1,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xce50,0xd153,0xffff,
0xd152,0xd157,0xd14e,0xffff,0xd151,0xd150,0xffff,0xd154,
0xffff,0xd158,0xae47,0xae4a,0xffff,0xffff,0xd14f,0xd155,
0xffff,0xffff,0xffff,0xae49,0xd14a,0xffff,0xabb0,0xd4ba,
0xd156,0xffff,0xd14d,0xffff,0xae48,0xd14c,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xd4b1,0xffff,0xffff,0xb0ec,
0xb0f0,0xd4c1,0xd4af,0xd4bd,0xb0f1,0xd4bf,0xffff,0xd4c5,
0xffff,0xd4c9,0xffff,0xffff,0xd4c0,0xd4b4,0xd4bc,0xffff,
0xd4ca,0xd4c8,0xd4be,0xd4b9,0xd4b2,0xd8a6,0xd4b0,0xb0f5,
0xd4b7,0xb0f6,0xb0f2,0xd4ad,0xd4c3,0xd4b5,0xffff,0xffff,
0xd4b3,0xd4c6,0xb0f3,0xffff,0xd4cc,0xb0ed,0xb0ef,0xd4bb,
0xd4b6,0xae4b,0xb0ee,0xd4b8,0xd4c7,0xd4cb,0xd4c2,0xffff,
0xd4c4,0xffff,0xffff,0xffff,0xd4ae,0xffff,0xffff,0xffff,
0xffff,0xd8a1,0xffff,0xd8aa,0xd8a9,0xb3fa,0xd8a2,0xffff,
0xb3fb,0xb3f9,0xffff,0xd8a4,0xb3f6,0xd8a8,0xffff,0xd8a3,
0xd8a5,0xd87d,0xb3f4,0xffff,0xd8b2,0xd8b1,0xd8ae,0xb3f3,
0xb3f7,0xb3f8,0xd14b,0xd8ab,0xb3f5,0xb0f4,0xd8ad,0xd87e,
0xd8b0,0xd8af,0xffff,0xd8b3,0xffff,0xdcef,0xffff,0xd8ac,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd8a7,0xdce7,0xb6f4,0xb6f7,0xb6f2,0xdce6,0xdcea,0xdce5,
0xffff,0xb6ec,0xb6f6,0xdce2,0xb6f0,0xdce9,0xffff,0xb6ee,
0xb6ed,0xdcec,0xb6ef,0xdcee,0xffff,0xdceb,0xb6eb,0xffff,
0xffff,0xffff,0xb6f5,0xdcf0,0xdce4,0xdced,0xffff,0xffff,
0xdce3,0xffff,0xffff,0xb6f1,0xffff,0xb6f3,0xffff,0xdce8,
0xffff,0xdcf1,0xffff,0xffff,0xe15d,0xb9d0,0xe163,0xffff,
0xffff,0xb9d5,0xe15f,0xe166,0xe157,0xb9d7,0xb9d1,0xe15c,
0xbc55,0xe15b,0xe164,0xb9d2,0xffff,0xb9d6,0xe15a,0xe160,
0xe165,0xe156,0xb9d4,0xe15e,0xffff,0xffff,0xe162,0xe168,
0xe158,0xe161,0xffff,0xb9d3,0xe167,0xffff,0xffff,0xffff,
0xe159,0xffff,0xffff,0xffff,0xbc59,0xe54b,0xbc57,0xbc56,
0xe54d,0xe552,0xffff,0xe54e,0xffff,0xe551,0xbc5c,0xffff,
0xbea5,0xbc5b,0xffff,0xe54a,0xe550,0xffff,0xbc5a,0xe54f,
0xffff,0xe54c,0xffff,0xbc58,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe94d,0xf9d9,0xe94f,0xe94a,0xbec1,0xe94c,
0xffff,0xbec0,0xe94e,0xffff,0xffff,0xbec3,0xe950,0xbec2,
0xe949,0xe94b,0xffff,0xffff,0xffff,0xffff,0xc0a5,0xeccc,
0xffff,0xc0a4,0xeccd,0xc0a3,0xeccb,0xc0a2,0xecca,0xffff,
0xc253,0xc252,0xf1f6,0xf1f8,0xffff,0xf1f7,0xc361,0xc362,
0xffff,0xffff,0xc363,0xf442,0xc45b,0xffff,0xffff,0xf7d3,
0xf7d2,0xc5f2,0xffff,0xa468,0xa4d0,0xffff,0xffff,0xa7a7,
0xffff,0xffff,0xffff,0xffff,0xce5f,0xffff,0xffff,0xffff,
0xffff,0xb3fc,0xb3fd,0xffff,0xdcf2,0xb9d8,0xe169,0xe553,
0xffff,0xffff,0xffff,0xc95a,0xffff,0xffff,0xcab0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xcc42,0xce60,0xd159,0xae4c,
0xffff,0xffff,0xf1f9,0xffff,0xc4dc,0xa469,0xa57e,0xc970,
0xffff,0xa667,0xa668,0xffff,0xa95d,0xffff,0xffff,0xffff,
0xb0f7,0xffff,0xb9da,0xffff,0xb9db,0xb9d9,0xffff,0xa46a,
0xffff,0xa4d1,0xa4d3,0xa4d2,0xc95b,0xa4d4,0xa5a1,0xc971,
0xffff,0xa5a2,0xffff,0xffff,0xffff,0xffff,0xffff,0xa669,
0xa66a,0xffff,0xffff,0xffff,0xc9cb,0xffff,0xa7a8,0xffff,
0xcab1,0xffff,0xffff,0xffff,0xa961,0xcc43,0xffff,0xa95f,
0xa960,0xa95e,0xd15a,0xffff,0xffff,0xffff,0xabb6,0xabb5,
0xabb7,0xabb4,0xffff,0xce61,0xa962,0xabb3,0xffff,0xae4d,
0xae4e,0xffff,0xae4f,0xffff,0xd4cd,0xffff,0xffff,0xffff,
0xb3fe,0xd8b4,0xb0f8,0xffff,0xffff,0xffff,0xffff,0xb6f8,
0xffff,0xb9dd,0xb9dc,0xe16a,0xffff,0xbc5d,0xbec4,0xffff,
0xefc0,0xf6da,0xf7d4,0xa46b,0xa5a3,0xffff,0xa5a4,0xc9d1,
0xa66c,0xa66f,0xffff,0xc9cf,0xc9cd,0xa66e,0xc9d0,0xc9d2,
0xc9cc,0xa671,0xa670,0xa66d,0xa66b,0xc9ce,0xffff,0xffff,
0xffff,0xffff,0xa7b3,0xffff,0xffff,0xa7b0,0xcab6,0xcab9,
0xcab8,0xffff,0xa7aa,0xa7b2,0xffff,0xffff,0xa7af,0xcab5,
0xcab3,0xa7ae,0xffff,0xffff,0xffff,0xa7a9,0xa7ac,0xffff,
0xcab4,0xcabb,0xcab7,0xa7ad,0xa7b1,0xa7b4,0xcab2,0xcaba,
0xa7ab,0xffff,0xffff,0xffff,0xffff,0xffff,0xa967,0xa96f,
0xffff,0xcc4f,0xcc48,0xa970,0xcc53,0xcc44,0xcc4b,0xffff,
0xffff,0xa966,0xcc45,0xa964,0xcc4c,0xcc50,0xa963,0xffff,
0xcc51,0xcc4a,0xffff,0xcc4d,0xffff,0xa972,0xa969,0xcc54,
0xcc52,0xffff,0xa96e,0xa96c,0xcc49,0xa96b,0xcc47,0xcc46,
0xa96a,0xa968,0xa971,0xa96d,0xa965,0xffff,0xcc4e,0xffff,
0xabb9,0xffff,0xabc0,0xce6f,0xabb8,0xce67,0xce63,0xffff,
0xce73,0xce62,0xffff,0xabbb,0xce6c,0xabbe,0xabc1,0xffff,
0xabbc,0xce70,0xabbf,0xffff,0xae56,0xce76,0xce64,0xffff,
0xffff,0xce66,0xce6d,0xce71,0xce75,0xce72,0xce6b,0xce6e,
0xffff,0xffff,0xce68,0xabc3,0xce6a,0xce69,0xce74,0xabba,
0xce65,0xabc2,0xffff,0xabbd,0xffff,0xffff,0xffff,0xffff,
0xffff,0xae5c,0xd162,0xffff,0xae5b,0xffff,0xffff,0xd160,
0xffff,0xae50,0xffff,0xae55,0xffff,0xd15f,0xd15c,0xd161,
0xae51,0xd15b,0xffff,0xae54,0xae52,0xffff,0xd163,0xae53,
0xae57,0xffff,0xffff,0xae58,0xffff,0xae5a,0xffff,0xffff,
0xffff,0xae59,0xffff,0xffff,0xffff,0xd15d,0xd15e,0xffff,
0xffff,0xffff,0xffff,0xd164,0xffff,0xd4d4,0xb0f9,0xd8c2,
0xd4d3,0xd4e6,0xffff,0xffff,0xb140,0xffff,0xd4e4,0xffff,
0xb0fe,0xb0fa,0xd4ed,0xd4dd,0xd4e0,0xffff,0xb143,0xd4ea,
0xd4e2,0xb0fb,0xb144,0xffff,0xd4e7,0xd4e5,0xffff,0xffff,
0xd4d6,0xd4eb,0xd4df,0xd4da,0xffff,0xd4d0,0xd4ec,0xd4dc,
0xd4cf,0xffff,0xb142,0xd4e1,0xd4ee,0xd4de,0xd4d2,0xd4d7,
0xd4ce,0xffff,0xb141,0xffff,0xd4db,0xd4d8,0xb0fc,0xd4d1,
0xffff,0xd4e9,0xb0fd,0xffff,0xd4d9,0xd4d5,0xffff,0xffff,
0xd4e8,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xb440,
0xd8bb,0xffff,0xd8b8,0xd8c9,0xd8bd,0xd8ca,0xffff,0xb442,
0xffff,0xffff,0xffff,0xd8c6,0xd8c3,0xffff,0xffff,0xffff,
0xffff,0xffff,0xd8c4,0xd8c7,0xd8cb,0xffff,0xd4e3,0xd8cd,
0xdd47,0xffff,0xb443,0xd8ce,0xd8b6,0xd8c0,0xffff,0xd8c5,
0xffff,0xffff,0xb441,0xb444,0xd8cc,0xd8cf,0xd8ba,0xd8b7,
0xffff,0xffff,0xd8b9,0xffff,0xffff,0xd8be,0xd8bc,0xb445,
0xffff,0xd8c8,0xffff,0xffff,0xd8bf,0xffff,0xd8c1,0xd8b5,
0xdcfa,0xdcf8,0xb742,0xb740,0xdd43,0xdcf9,0xdd44,0xdd40,
0xdcf7,0xdd46,0xdcf6,0xdcfd,0xb6fe,0xb6fd,0xb6fc,0xdcfb,
0xdd41,0xb6f9,0xb741,0xffff,0xdcf4,0xffff,0xdcfe,0xdcf3,
0xdcfc,0xb6fa,0xdd42,0xdcf5,0xb6fb,0xdd45,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe16e,0xb9e2,0xb9e1,
0xb9e3,0xe17a,0xe170,0xe176,0xe16b,0xe179,0xe178,0xe17c,
0xe175,0xb9de,0xe174,0xb9e4,0xffff,0xe16d,0xb9df,0xffff,
0xe17b,0xb9e0,0xe16f,0xe172,0xe177,0xe171,0xe16c,0xffff,
0xffff,0xffff,0xffff,0xe173,0xe555,0xbc61,0xe558,0xe557,
0xe55a,0xe55c,0xf9dc,0xbc5f,0xffff,0xe556,0xffff,0xe554,
0xffff,0xe55d,0xe55b,0xe559,0xffff,0xe55f,0xffff,0xe55e,
0xbc63,0xbc5e,0xffff,0xbc60,0xbc62,0xffff,0xffff,0xe560,
0xe957,0xffff,0xffff,0xe956,0xe955,0xffff,0xe958,0xe951,
0xffff,0xe952,0xe95a,0xe953,0xffff,0xbec5,0xe95c,0xffff,
0xe95b,0xe954,0xffff,0xecd1,0xc0a8,0xeccf,0xecd4,0xecd3,
0xe959,0xffff,0xc0a7,0xffff,0xecd2,0xecce,0xecd6,0xecd5,
0xc0a6,0xffff,0xecd0,0xffff,0xbec6,0xffff,0xffff,0xffff,
0xc254,0xffff,0xffff,0xffff,0xefc1,0xf1fa,0xf1fb,0xf1fc,
0xc45c,0xffff,0xffff,0xc45d,0xffff,0xf443,0xffff,0xf5c8,
0xf5c7,0xffff,0xffff,0xf6db,0xf6dc,0xf7d5,0xf8a7,0xffff,
0xa46c,0xa46d,0xffff,0xa46e,0xa4d5,0xa5a5,0xc9d3,0xa672,
0xa673,0xffff,0xa7b7,0xa7b8,0xa7b6,0xa7b5,0xffff,0xa973,
0xffff,0xffff,0xcc55,0xa975,0xa974,0xcc56,0xffff,0xffff,
0xffff,0xabc4,0xffff,0xae5d,0xd165,0xffff,0xd4f0,0xffff,
0xb145,0xb447,0xd4ef,0xb446,0xffff,0xb9e5,0xffff,0xe17d,
0xbec7,0xffff,0xc0a9,0xecd7,0xffff,0xc45e,0xffff,0xc570,
0xffff,0xc972,0xffff,0xa5a6,0xc973,0xa676,0xffff,0xa674,
0xa675,0xa677,0xffff,0xa7ba,0xa7b9,0xffff,0xcabc,0xa7bb,
0xffff,0xffff,0xcabd,0xcc57,0xffff,0xcc58,0xffff,0xa976,
0xa978,0xa97a,0xa977,0xa97b,0xa979,0xffff,0xffff,0xffff,
0xffff,0xffff,0xabc8,0xabc5,0xabc7,0xabc9,0xabc6,0xd166,
0xce77,0xffff,0xffff,0xffff,0xd168,0xd167,0xae63,0xffff,
0xae5f,0xffff,0xffff,0xae60,0xae62,0xae64,0xae61,0xffff,
0xae66,0xae65,0xffff,0xffff,0xffff,0xffff,0xffff,0xb14a,
0xd4f2,0xd4f1,0xb149,0xffff,0xb148,0xb147,0xb14b,0xb146,
0xffff,0xffff,0xd8d5,0xd8d2,0xb449,0xd8d1,0xd8d6,0xffff,
0xb44b,0xd8d4,0xb448,0xb44a,0xd8d3,0xffff,0xdd48,0xffff,
0xdd49,0xdd4a,0xffff,0xffff,0xffff,0xffff,0xb9e6,0xb9ee,
0xe17e,0xb9e8,0xb9ec,0xe1a1,0xb9ed,0xb9e9,0xb9ea,0xb9e7,
0xb9eb,0xbc66,0xd8d0,0xbc67,0xbc65,0xffff,0xbc64,0xe95d,
0xbec8,0xecd8,0xecd9,0xffff,0xffff,0xc364,0xc45f,0xffff,
0xa46f,0xffff,0xa678,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xabca,0xffff,0xd169,0xae67,0xffff,0xffff,0xb14e,
0xb14d,0xb14c,0xb44c,0xb44d,0xd8d7,0xb9ef,0xbec9,0xa470,
0xc95c,0xa4d6,0xc974,0xffff,0xffff,0xc9d4,0xa679,0xffff,
0xffff,0xffff,0xa97c,0xffff,0xffff,0xffff,0xffff,0xdd4b,
0xffff,0xffff,0xa471,0xffff,0xa4d7,0xc9d5,0xffff,0xffff,
0xcabe,0xffff,0xcabf,0xffff,0xa7bc,0xffff,0xffff,0xffff,
0xd8d8,0xb44e,0xffff,0xdd4c,0xffff,0xffff,0xffff,0xc0aa,
0xa472,0xa4a8,0xa4d8,0xc975,0xa5a7,0xffff,0xa7c0,0xa7bf,
0xa7bd,0xa7be,0xffff,0xffff,0xcc59,0xa97e,0xa9a1,0xcc5a,
0xa97d,0xffff,0xffff,0xabce,0xce78,0xabcd,0xabcb,0xabcc,
0xae6a,0xae68,0xffff,0xffff,0xd16b,0xae69,0xd16a,0xffff,
0xae5e,0xd4f3,0xffff,0xffff,0xb150,0xb151,0xffff,0xffff,
0xb14f,0xffff,0xb9f0,0xe1a2,0xbc68,0xbc69,0xffff,0xe561,
0xc0ab,0xefc2,0xefc3,0xffff,0xc4dd,0xf8a8,0xc94b,0xa4d9,
0xffff,0xa473,0xffff,0xc977,0xc976,0xffff,0xffff,0xffff,
0xffff,0xa67a,0xc9d7,0xc9d8,0xc9d6,0xffff,0xc9d9,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xcac7,0xffff,
0xcac2,0xcac4,0xcac6,0xcac3,0xa7c4,0xcac0,0xffff,0xcac1,
0xa7c1,0xa7c2,0xcac5,0xcac8,0xa7c3,0xcac9,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xcc68,0xffff,0xcc62,
0xcc5d,0xa9a3,0xcc65,0xcc63,0xcc5c,0xcc69,0xcc6c,0xcc67,
0xcc60,0xa9a5,0xcc66,0xa9a6,0xcc61,0xcc64,0xcc5b,0xcc5f,
0xcc6b,0xa9a7,0xffff,0xa9a8,0xffff,0xcc5e,0xcc6a,0xa9a2,
0xa9a4,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xceab,0xcea4,
0xceaa,0xcea3,0xcea5,0xce7d,0xce7b,0xffff,0xceac,0xcea9,
0xce79,0xffff,0xabd0,0xcea7,0xcea8,0xffff,0xcea6,0xce7c,
0xce7a,0xabcf,0xcea2,0xce7e,0xffff,0xffff,0xcea1,0xcead,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xae6f,0xffff,0xae6e,0xffff,0xd16c,0xae6b,0xd16e,0xffff,
0xae70,0xd16f,0xffff,0xffff,0xae73,0xffff,0xae71,0xd170,
0xceae,0xd172,0xffff,0xae6d,0xffff,0xae6c,0xffff,0xd16d,
0xd171,0xae72,0xffff,0xffff,0xffff,0xffff,0xb153,0xb152,
0xffff,0xffff,0xffff,0xd4f5,0xd4f9,0xd4fb,0xb154,0xd4fe,
0xffff,0xb158,0xd541,0xffff,0xb15a,0xffff,0xb156,0xb15e,
0xffff,0xb15b,0xd4f7,0xb155,0xffff,0xd4f6,0xd4f4,0xd543,
0xd4f8,0xffff,0xb157,0xd542,0xb15c,0xd4fd,0xd4fc,0xb15d,
0xd4fa,0xb159,0xffff,0xffff,0xffff,0xffff,0xd544,0xffff,
0xd540,0xd8e7,0xd8ee,0xd8e3,0xb451,0xd8df,0xd8ef,0xd8d9,
0xd8ec,0xd8ea,0xd8e4,0xffff,0xd8ed,0xd8e6,0xffff,0xd8de,
0xd8f0,0xd8dc,0xd8e9,0xd8da,0xffff,0xd8f1,0xffff,0xb452,
0xffff,0xd8eb,0xdd4f,0xd8dd,0xb44f,0xffff,0xd8e1,0xffff,
0xb450,0xd8e0,0xd8e5,0xffff,0xffff,0xd8e2,0xffff,0xffff,
0xffff,0xd8e8,0xffff,0xffff,0xffff,0xffff,0xdd53,0xffff,
0xffff,0xffff,0xdd56,0xdd4e,0xffff,0xdd50,0xffff,0xdd55,
0xdd54,0xb743,0xffff,0xd8db,0xdd52,0xffff,0xffff,0xb744,
0xffff,0xdd4d,0xdd51,0xffff,0xffff,0xffff,0xffff,0xe1a9,
0xffff,0xe1b0,0xe1a7,0xffff,0xe1ae,0xe1a5,0xe1ad,0xe1b1,
0xe1a4,0xe1a8,0xe1a3,0xffff,0xb9f1,0xffff,0xe1a6,0xb9f2,
0xe1ac,0xe1ab,0xe1aa,0xffff,0xffff,0xe1af,0xffff,0xffff,
0xffff,0xffff,0xe565,0xe567,0xbc6b,0xe568,0xffff,0xe563,
0xffff,0xe562,0xe56c,0xffff,0xe56a,0xbc6a,0xe56d,0xe564,
0xe569,0xe56b,0xe566,0xffff,0xffff,0xffff,0xffff,0xe961,
0xe966,0xe960,0xe965,0xffff,0xe95e,0xe968,0xe964,0xe969,
0xe963,0xe95f,0xe967,0xffff,0xe96a,0xe962,0xffff,0xecda,
0xc0af,0xffff,0xc0ad,0xffff,0xc0ac,0xc0ae,0xffff,0xffff,
0xefc4,0xffff,0xf172,0xf1fd,0xffff,0xffff,0xf444,0xf445,
0xffff,0xc460,0xffff,0xf5c9,0xffff,0xc4de,0xffff,0xf5ca,
0xffff,0xf6de,0xc572,0xffff,0xc571,0xf6dd,0xc5c9,0xffff,
0xf7d6,0xffff,0xffff,0xffff,0xffff,0xa474,0xa67b,0xc9da,
0xcaca,0xa8b5,0xb15f,0xffff,0xffff,0xa475,0xa5aa,0xa5a9,
0xa5a8,0xffff,0xffff,0xa7c5,0xffff,0xffff,0xae74,0xffff,
0xdd57,0xa476,0xa477,0xa478,0xa4da,0xffff,0xffff,0xabd1,
0xffff,0xceaf,0xffff,0xffff,0xffff,0xb453,0xa479,0xc95d,
0xffff,0xffff,0xa5ab,0xa5ac,0xc978,0xffff,0xa67c,0xffff,
0xffff,0xffff,0xcacb,0xffff,0xa7c6,0xffff,0xcacc,0xffff,
0xffff,0xa9ae,0xffff,0xffff,0xcc6e,0xa9ac,0xa9ab,0xcc6d,
0xa9a9,0xcc6f,0xa9aa,0xa9ad,0xffff,0xabd2,0xffff,0xabd4,
0xceb3,0xceb0,0xceb1,0xceb2,0xceb4,0xabd3,0xffff,0xffff,
0xd174,0xd173,0xffff,0xae76,0xffff,0xae75,0xffff,0xffff,
0xffff,0xffff,0xffff,0xb162,0xd546,0xffff,0xb161,0xb163,
0xb160,0xffff,0xffff,0xffff,0xffff,0xb455,0xd545,0xffff,
0xb456,0xd8f3,0xffff,0xb457,0xd8f2,0xb454,0xffff,0xffff,
0xffff,0xffff,0xdd5a,0xdd5c,0xb745,0xdd5b,0xdd59,0xdd58,
0xffff,0xffff,0xffff,0xe1b4,0xb9f7,0xb9f5,0xffff,0xb9f6,
0xe1b2,0xe1b3,0xffff,0xb9f3,0xe571,0xe56f,0xffff,0xbc6d,
0xe570,0xbc6e,0xbc6c,0xb9f4,0xffff,0xffff,0xe96d,0xe96b,
0xe96c,0xe56e,0xecdc,0xc0b0,0xecdb,0xefc5,0xefc6,0xe96e,
0xf1fe,0xffff,0xa47a,0xa5ad,0xa67e,0xc9db,0xa67d,0xffff,
0xa9af,0xb746,0xffff,0xa4db,0xa5ae,0xabd5,0xb458,0xffff,
0xc979,0xffff,0xc97a,0xffff,0xc9dc,0xffff,0xffff,0xa7c8,
0xcad0,0xcace,0xa7c9,0xcacd,0xcacf,0xcad1,0xffff,0xa7c7,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa9b3,0xa9b4,0xa9b1,
0xffff,0xffff,0xa9b0,0xceb8,0xa9b2,0xffff,0xffff,0xffff,
0xabd6,0xffff,0xceb7,0xceb9,0xceb6,0xceba,0xabd7,0xae79,
0xd175,0xffff,0xd177,0xae77,0xd178,0xae78,0xd176,0xffff,
0xceb5,0xd547,0xd54a,0xd54b,0xd548,0xb167,0xb166,0xb164,
0xb165,0xd549,0xffff,0xffff,0xffff,0xffff,0xb168,0xffff,
0xffff,0xb45a,0xb45b,0xffff,0xb45c,0xdd5d,0xdd5f,0xdd61,
0xb748,0xb747,0xb459,0xdd60,0xdd5e,0xffff,0xe1b8,0xffff,
0xffff,0xe1b6,0xe1bc,0xb9f8,0xe1bd,0xe1ba,0xb9f9,0xe1b7,
0xe1b5,0xe1bb,0xbc70,0xe573,0xe1b9,0xbc72,0xe574,0xbc71,
0xbc74,0xe575,0xbc6f,0xbc73,0xffff,0xe973,0xe971,0xe970,
0xe972,0xe96f,0xffff,0xffff,0xc366,0xffff,0xf446,0xf447,
0xffff,0xf5cb,0xf6df,0xc655,0xffff,0xffff,0xa9b5,0xa7ca,
0xffff,0xffff,0xabd8,0xffff,0xffff,0xffff,0xa47b,0xa4dc,
0xffff,0xa5af,0xc9dd,0xffff,0xa7cb,0xcad2,0xffff,0xcebb,
0xabd9,0xffff,0xb9fa,0xa47c,0xffff,0xffff,0xffff,0xa6a1,
0xffff,0xffff,0xb749,0xa47d,0xa4dd,0xa4de,0xffff,0xa5b1,
0xa5b0,0xffff,0xc9de,0xa6a2,0xffff,0xcad3,0xffff,0xa7cc,
0xffff,0xffff,0xcc71,0xcc72,0xcc73,0xffff,0xa9b6,0xa9b7,
0xcc70,0xa9b8,0xffff,0xffff,0xffff,0xabda,0xcebc,0xffff,
0xd17a,0xae7a,0xffff,0xd179,0xffff,0xb169,0xd54c,0xb16a,
0xd54d,0xffff,0xffff,0xffff,0xb45d,0xffff,0xffff,0xffff,
0xdd62,0xffff,0xffff,0xe1bf,0xe1be,0xffff,0xb9fb,0xffff,
0xbc75,0xe576,0xbeca,0xe974,0xc0b1,0xffff,0xc573,0xf7d8,
0xffff,0xffff,0xffff,0xffff,0xcc74,0xffff,0xcebd,0xb16b,
0xd8f4,0xb74a,0xffff,0xffff,0xffff,0xc255,0xffff,0xffff,
0xffff,0xffff,0xa7ce,0xffff,0xa7cd,0xabdb,0xffff,0xd17b,
0xffff,0xb16d,0xb343,0xb16e,0xb16c,0xb45e,0xffff,0xe1c0,
0xb9fc,0xbc76,0xffff,0xc94c,0xc9df,0xffff,0xcad5,0xa7cf,
0xcad4,0xa7d0,0xffff,0xffff,0xa9bc,0xcc77,0xcc76,0xa9bb,
0xa9b9,0xa9ba,0xcc75,0xffff,0xffff,0xabdd,0xcebe,0xabe0,
0xabdc,0xabe2,0xabde,0xabdf,0xabe1,0xffff,0xffff,0xffff,
0xae7d,0xae7c,0xae7b,0xffff,0xffff,0xffff,0xd54f,0xb16f,
0xb172,0xb170,0xffff,0xd54e,0xb175,0xffff,0xb171,0xd550,
0xb174,0xb173,0xffff,0xffff,0xffff,0xd8f6,0xd8f5,0xffff,
0xb461,0xb45f,0xb460,0xd8f7,0xb74b,0xdd64,0xb74c,0xdd63,
0xffff,0xffff,0xe577,0xffff,0xffff,0xbc78,0xe1c1,0xbc77,
0xffff,0xb9fd,0xffff,0xecde,0xe975,0xc0b2,0xecdd,0xf240,
0xf448,0xf449,0xffff,0xa4df,0xffff,0xa5b2,0xffff,0xffff,
0xffff,0xc97b,0xffff,0xffff,0xa7d2,0xa7d4,0xffff,0xc9e2,
0xcad8,0xcad7,0xcad6,0xffff,0xc9e1,0xc9e0,0xa6a4,0xa7d3,
0xa7d1,0xa6a3,0xffff,0xffff,0xffff,0xa9bd,0xcc78,0xffff,
0xa9be,0xcadd,0xffff,0xcadf,0xcade,0xcc79,0xffff,0xffff,
0xcada,0xffff,0xa7d8,0xa7d6,0xffff,0xcad9,0xcadb,0xcae1,
0xffff,0xa7d5,0xffff,0xcadc,0xcae5,0xa9c0,0xffff,0xcae2,
0xa7d7,0xffff,0xcae0,0xcae3,0xffff,0xa9bf,0xffff,0xa9c1,
0xcae4,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xccaf,0xcca2,0xcc7e,0xccae,0xcca9,0xabe7,0xa9c2,
0xccaa,0xccad,0xabe3,0xccac,0xa9c3,0xa9c8,0xa9c6,0xcca3,
0xffff,0xcc7c,0xcca5,0xa9cd,0xccb0,0xabe4,0xcca6,0xffff,
0xabe5,0xa9c9,0xcca8,0xffff,0xcecd,0xabe6,0xcc7b,0xa9ca,
0xabe8,0xa9cb,0xa9c7,0xa9cc,0xcca7,0xcc7a,0xccab,0xa9c4,
0xffff,0xffff,0xcc7d,0xcca4,0xcca1,0xa9c5,0xffff,0xcebf,
0xffff,0xcec0,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xceca,0xd1a1,0xcecb,0xabee,0xcece,0xcec4,0xabed,0xcec6,
0xffff,0xcec7,0xffff,0xffff,0xcec9,0xabe9,0xffff,0xffff,
0xaea3,0xffff,0xf9da,0xcec5,0xcec1,0xaea4,0xffff,0xffff,
0xcecf,0xae7e,0xd17d,0xcec8,0xffff,0xd17c,0xcec3,0xcecc,
0xffff,0xffff,0xabec,0xaea1,0xabf2,0xaea2,0xced0,0xd17e,
0xabeb,0xaea6,0xabf1,0xabf0,0xabef,0xaea5,0xced1,0xaea7,
0xabea,0xffff,0xcec2,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xb176,
0xd1a4,0xd1a6,0xffff,0xd1a8,0xaea8,0xaeae,0xd553,0xd1ac,
0xd1a3,0xb178,0xd551,0xffff,0xaead,0xaeab,0xd1ae,0xffff,
0xd552,0xffff,0xd1a5,0xffff,0xaeac,0xd1a9,0xaeaf,0xd1ab,
0xffff,0xffff,0xaeaa,0xd1aa,0xd1ad,0xd1a7,0xffff,0xaea9,
0xb179,0xffff,0xd1a2,0xb177,0xffff,0xffff,0xffff,0xffff,
0xb17a,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd555,0xd55e,0xb464,0xffff,0xb17c,0xb1a3,0xb465,0xd560,
0xb1aa,0xd8f9,0xd556,0xb1a2,0xb1a5,0xb17e,0xd554,0xd562,
0xd565,0xd949,0xffff,0xd563,0xd8fd,0xb1a1,0xb1a8,0xb1ac,
0xd55d,0xd8f8,0xd561,0xb17b,0xd8fa,0xd564,0xd8fc,0xd559,
0xffff,0xb462,0xffff,0xd557,0xd558,0xb1a7,0xffff,0xffff,
0xb1a6,0xd55b,0xb1ab,0xd55f,0xb1a4,0xd55c,0xffff,0xb1a9,
0xb466,0xb463,0xd8fb,0xffff,0xd55a,0xffff,0xb17d,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xb46b,0xb46f,0xd940,0xb751,0xb46d,0xd944,0xb471,0xdd65,
0xd946,0xb753,0xb469,0xb46c,0xd947,0xffff,0xd948,0xd94e,
0xb473,0xb754,0xffff,0xd94a,0xd94f,0xd943,0xb75e,0xffff,
0xb755,0xb472,0xd941,0xd950,0xffff,0xb75d,0xb470,0xb74e,
0xd94d,0xffff,0xb474,0xd945,0xd8fe,0xb46a,0xd942,0xffff,
0xd94b,0xffff,0xb74d,0xb752,0xb467,0xd94c,0xffff,0xb750,
0xffff,0xffff,0xffff,0xb468,0xffff,0xffff,0xffff,0xb75c,
0xe1c3,0xdd70,0xffff,0xdd68,0xe1c2,0xffff,0xdd6c,0xdd6e,
0xffff,0xffff,0xdd6b,0xffff,0xb75b,0xffff,0xdd6a,0xb75f,
0xffff,0xffff,0xffff,0xe1d2,0xffff,0xffff,0xb75a,0xba40,
0xdd71,0xe1c4,0xffff,0xffff,0xb758,0xdd69,0xdd6d,0xb9fe,
0xb74f,0xdd66,0xdd67,0xba41,0xb757,0xb759,0xb756,0xdd6f,
0xffff,0xffff,0xe1c8,0xe1c9,0xe1ce,0xbc7d,0xe1d5,0xffff,
0xba47,0xffff,0xba46,0xe1d0,0xffff,0xbc7c,0xe1c5,0xba45,
0xffff,0xe1d4,0xba43,0xba44,0xffff,0xe1d1,0xe5aa,0xbc7a,
0xb46e,0xffff,0xe1d3,0xbca3,0xe1cb,0xffff,0xbc7b,0xffff,
0xbca2,0xe1c6,0xe1ca,0xe1c7,0xe1cd,0xba48,0xbc79,0xba42,
0xffff,0xe57a,0xe1cf,0xffff,0xbca1,0xffff,0xbca4,0xffff,
0xe1cc,0xffff,0xbc7e,0xe579,0xffff,0xffff,0xffff,0xffff,
0xffff,0xe57e,0xbece,0xe578,0xe9a3,0xe5a9,0xbca8,0xffff,
0xbca6,0xbecc,0xe5a6,0xe5a2,0xbcac,0xffff,0xe978,0xffff,
0xffff,0xffff,0xbcaa,0xe5a1,0xffff,0xe976,0xffff,0xe5a5,
0xffff,0xe5a8,0xe57d,0xffff,0xbcab,0xffff,0xffff,0xbca5,
0xe977,0xbecd,0xe5a7,0xbca7,0xbca9,0xe5a4,0xbcad,0xe5a3,
0xe57c,0xe57b,0xbecb,0xe5ab,0xe97a,0xece0,0xbed0,0xffff,
0xe9a2,0xffff,0xe97e,0xffff,0xece1,0xffff,0xbed1,0xe9a1,
0xffff,0xe97c,0xc0b4,0xecdf,0xffff,0xe979,0xe97b,0xc0b5,
0xbed3,0xc0b3,0xbed2,0xc0b7,0xe97d,0xbecf,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xefcf,0xffff,
0xefc7,0xffff,0xffff,0xffff,0xffff,0xffff,0xece7,0xefc8,
0xece3,0xffff,0xffff,0xc256,0xece5,0xece4,0xc0b6,0xece2,
0xece6,0xefd0,0xefcc,0xefce,0xffff,0xefc9,0xefca,0xffff,
0xefcd,0xefcb,0xc367,0xffff,0xffff,0xc36a,0xc369,0xc368,
0xc461,0xf44a,0xc462,0xf241,0xc4df,0xf5cc,0xc4e0,0xc574,
0xc5ca,0xf7d9,0xffff,0xf7da,0xf7db,0xffff,0xffff,0xf9ba,
0xa4e0,0xc97c,0xa5b3,0xffff,0xa6a6,0xa6a7,0xa6a5,0xffff,
0xa6a8,0xa7da,0xa7d9,0xffff,0xccb1,0xa9cf,0xa9ce,0xffff,
0xffff,0xd1af,0xb1ad,0xb1ae,0xffff,0xffff,0xffff,0xb475,
0xdd72,0xb760,0xb761,0xdd74,0xdd76,0xdd75,0xffff,0xe1d7,
0xffff,0xe1d6,0xba49,0xe1d8,0xffff,0xe5ac,0xbcae,0xffff,
0xbed4,0xffff,0xc0b8,0xc257,0xc0b9,0xffff,0xa4e1,0xffff,
0xffff,0xffff,0xcae6,0xffff,0xffff,0xccb2,0xa9d1,0xa9d0,
0xa9d2,0xabf3,0xced2,0xced3,0xffff,0xffff,0xd1b0,0xaeb0,
0xb1af,0xb476,0xd951,0xa4e2,0xffff,0xa47e,0xa4e3,0xffff,
0xc97d,0xa5b7,0xa5b6,0xa5b4,0xa5b5,0xffff,0xffff,0xffff,
0xa6ab,0xc9e9,0xc9eb,0xa6aa,0xc9e3,0xffff,0xc9e4,0xffff,
0xc9ea,0xc9e6,0xc9e8,0xa6a9,0xc9e5,0xc9ec,0xc9e7,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xa7e1,0xa7ea,0xa7e8,
0xcaf0,0xcaed,0xcaf5,0xa7e6,0xcaf6,0xffff,0xa7df,0xcaf3,
0xffff,0xa7e5,0xcaef,0xcaee,0xa7e3,0xcaf4,0xa7e4,0xa9d3,
0xa7de,0xcaf1,0xffff,0xcae7,0xa7db,0xffff,0xa7ee,0xcaec,
0xcaf2,0xa7e0,0xa7e2,0xffff,0xcae8,0xffff,0xcae9,0xcaea,
0xffff,0xa7ed,0xa7e7,0xa7ec,0xcaeb,0xa7eb,0xa7dd,0xa7dc,
0xa7e9,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa9e1,0xccbe,0xccb7,0xa9dc,0xa9ef,0xccb3,0xccba,0xccbc,
0xccbf,0xa9ea,0xffff,0xccbb,0xccb4,0xa9e8,0xccb8,0xffff,
0xccc0,0xa9d9,0xffff,0xccbd,0xa9e3,0xa9e2,0xccb6,0xa9d7,
0xffff,0xffff,0xa9d8,0xffff,0xa9d6,0xffff,0xa9ee,0xa9e6,
0xa9e0,0xa9d4,0xccb9,0xa9df,0xa9d5,0xa9e7,0xa9f0,0xced4,
0xa9e4,0xccb5,0xa9da,0xa9dd,0xa9de,0xffff,0xa9ec,0xa9ed,
0xa9eb,0xa9e5,0xa9e9,0xa9db,0xabf4,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xceda,0xac41,0xabf8,0xabfa,0xac40,
0xcee6,0xabfd,0xd1b1,0xaeb1,0xac43,0xced7,0xcedf,0xabfe,
0xcede,0xcedb,0xcee3,0xcee5,0xabf7,0xabfb,0xac42,0xaeb3,
0xcee0,0xabf9,0xac45,0xced9,0xffff,0xffff,0xffff,0xabfc,
0xaeb2,0xabf6,0xffff,0xced6,0xcedd,0xced5,0xced8,0xcedc,
0xd1b2,0xac44,0xffff,0xcee1,0xcee2,0xcee4,0xabf5,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xaec1,0xd1be,0xaebf,0xaec0,0xd1b4,0xd1c4,0xffff,0xaeb6,
0xffff,0xffff,0xd566,0xd1c6,0xd1c0,0xffff,0xd1b7,0xffff,
0xd1c9,0xd1ba,0xaebc,0xd57d,0xd1bd,0xaebe,0xaeb5,0xffff,
0xd1cb,0xd1bf,0xaeb8,0xd1b8,0xd1b5,0xd1b6,0xaeb9,0xd1c5,
0xd1cc,0xaebb,0xd1bc,0xd1bb,0xaec3,0xaec2,0xaeb4,0xaeba,
0xaebd,0xd1c8,0xffff,0xffff,0xd1c2,0xaeb7,0xd1b3,0xd1ca,
0xd1c1,0xd1c3,0xd1c7,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xd567,0xffff,0xb1b7,
0xb1cb,0xb1ca,0xffff,0xb1bf,0xffff,0xd579,0xd575,0xd572,
0xd5a6,0xb1ba,0xb1b2,0xffff,0xffff,0xd577,0xb4a8,0xb1b6,
0xd5a1,0xffff,0xb1cc,0xb1c9,0xd57b,0xd56a,0xffff,0xffff,
0xb1c8,0xd5a3,0xd569,0xb1bd,0xb1c1,0xd5a2,0xffff,0xd573,
0xb1c2,0xb1bc,0xd568,0xffff,0xb478,0xd5a5,0xd571,0xb1c7,
0xd574,0xd5a4,0xb1c6,0xffff,0xd952,0xffff,0xb1b3,0xd56f,
0xb1b8,0xb1c3,0xffff,0xb1be,0xd578,0xd56e,0xd56c,0xd57e,
0xb1b0,0xb1c4,0xb1b4,0xb477,0xd57c,0xb1b5,0xffff,0xb1b1,
0xb1c0,0xb1bb,0xb1b9,0xd570,0xb1c5,0xd56d,0xd57a,0xd576,
0xd954,0xd953,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xd56b,0xd964,0xffff,
0xb47a,0xffff,0xd96a,0xd959,0xd967,0xdd77,0xb47d,0xd96b,
0xd96e,0xb47c,0xd95c,0xd96d,0xd96c,0xb47e,0xd955,0xb479,
0xb4a3,0xffff,0xb4a1,0xd969,0xffff,0xd95f,0xb4a5,0xd970,
0xd968,0xd971,0xb4ad,0xb4ab,0xd966,0xd965,0xffff,0xd963,
0xd95d,0xb4a4,0xffff,0xb4a2,0xd1b9,0xd956,0xffff,0xddb7,
0xd957,0xb47b,0xb4aa,0xdd79,0xffff,0xb4a6,0xb4a7,0xd958,
0xd96f,0xdd78,0xd960,0xd95b,0xb4a9,0xd961,0xd95e,0xffff,
0xffff,0xb4ae,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xb770,0xffff,
0xffff,0xdd7c,0xddb1,0xddb6,0xddaa,0xb76c,0xddbb,0xb769,
0xdd7a,0xffff,0xdd7b,0xb762,0xb76b,0xdda4,0xb76e,0xb76f,
0xdda5,0xffff,0xddb2,0xddb8,0xb76a,0xffff,0xb764,0xdda3,
0xdd7d,0xddba,0xdda8,0xdda9,0xdd7e,0xddb4,0xddab,0xddb5,
0xddad,0xffff,0xb765,0xe1d9,0xb768,0xb766,0xddb9,0xddb0,
0xddac,0xffff,0xffff,0xdda1,0xba53,0xddaf,0xb76d,0xdda7,
0xffff,0xdda6,0xffff,0xffff,0xffff,0xb767,0xb763,0xe1ee,
0xddb3,0xddae,0xffff,0xdda2,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe1e9,0xffff,0xe1da,0xe1e5,0xffff,
0xe1ec,0xba51,0xb4ac,0xe1ea,0xba4c,0xffff,0xffff,0xffff,
0xba4b,0xe1f1,0xffff,0xe1db,0xe1e8,0xe1dc,0xe1e7,0xba4f,
0xe1eb,0xd962,0xffff,0xffff,0xffff,0xe1f2,0xe1e3,0xba52,
0xe5ba,0xbcaf,0xffff,0xe1f0,0xe1ef,0xba54,0xe5ad,0xbcb0,
0xe5ae,0xffff,0xe1df,0xe1e0,0xe1dd,0xe1e2,0xe1de,0xe1f3,
0xba4e,0xbcb1,0xba50,0xba55,0xffff,0xe1e1,0xffff,0xe1ed,
0xffff,0xffff,0xe1e6,0xffff,0xffff,0xe5b1,0xffff,0xba4a,
0xbcb4,0xe9aa,0xe5b6,0xe5b5,0xe5b7,0xffff,0xffff,0xe5b4,
0xbcb5,0xffff,0xbcbb,0xbcb8,0xffff,0xbcb9,0xe5af,0xe5b2,
0xe5bc,0xbcc1,0xbcbf,0xffff,0xe5b3,0xd95a,0xbcb2,0xe5b9,
0xe5b0,0xffff,0xbcc2,0xe5b8,0xba4d,0xbcb7,0xe1e4,0xffff,
0xffff,0xbcba,0xffff,0xbcbe,0xbcc0,0xbcbd,0xbcbc,0xffff,
0xbcb6,0xe5bb,0xbcb3,0xbcc3,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xbed8,0xbed9,0xe9a9,0xbee2,0xbedf,
0xffff,0xbed6,0xbedd,0xe9ab,0xbedb,0xbed5,0xffff,0xbedc,
0xffff,0xe9a8,0xc0bb,0xbed7,0xffff,0xbede,0xc0ba,0xe9a7,
0xe9a6,0xffff,0xbee0,0xffff,0xbee1,0xffff,0xe9a5,0xe9a4,
0xc0bc,0xe9ae,0xbeda,0xe9ac,0xffff,0xffff,0xffff,0xffff,
0xc0bd,0xffff,0xc0c2,0xecea,0xecec,0xffff,0xc0bf,0xffff,
0xeced,0xece9,0xffff,0xeceb,0xc0c0,0xc0c3,0xffff,0xece8,
0xc0be,0xc0c1,0xc259,0xe9ad,0xc258,0xffff,0xffff,0xc25e,
0xefd4,0xffff,0xc25c,0xc25d,0xefd7,0xefd3,0xc25a,0xefd1,
0xc36b,0xefd5,0xffff,0xefd6,0xefd2,0xffff,0xc25b,0xf242,
0xffff,0xf245,0xffff,0xffff,0xf246,0xf244,0xf247,0xc36c,
0xf243,0xffff,0xffff,0xf44e,0xc464,0xf44d,0xf44c,0xf44b,
0xc463,0xc465,0xffff,0xf5cd,0xc4e2,0xc4e1,0xffff,0xffff,
0xf6e1,0xf6e0,0xf6e3,0xc5cb,0xc575,0xf7dd,0xf6e2,0xffff,
0xffff,0xf7dc,0xc5cd,0xc5cc,0xc5f3,0xf8a9,0xf8ef,0xa4e4,
0xffff,0xffff,0xd972,0xe9af,0xffff,0xffff,0xa6ac,0xcaf7,
0xa7f1,0xa7ef,0xffff,0xa7f0,0xffff,0xccc1,0xa9f1,0xac46,
0xffff,0xcee7,0xffff,0xcee8,0xffff,0xac47,0xd1ce,0xffff,
0xaec4,0xaec5,0xd1cd,0xffff,0xffff,0xffff,0xffff,0xb1d3,
0xffff,0xb1cf,0xffff,0xd5a7,0xb1d6,0xb1d5,0xb1ce,0xb1d1,
0xb1d4,0xb1d0,0xffff,0xffff,0xd976,0xb1cd,0xb4af,0xffff,
0xffff,0xffff,0xb4b1,0xb4b2,0xd975,0xd978,0xb4b0,0xd973,
0xd977,0xffff,0xd974,0xffff,0xb771,0xffff,0xffff,0xddbc,
0xffff,0xffff,0xba56,0xe1f4,0xbee3,0xbcc4,0xe5bd,0xbcc5,
0xbcc6,0xe5bf,0xe5be,0xe5c0,0xe9b1,0xffff,0xffff,0xe9b0,
0xecef,0xecee,0xc0c4,0xc0c5,0xf248,0xffff,0xffff,0xa4e5,
0xffff,0xffff,0xffff,0xffff,0xd979,0xffff,0xffff,0xffff,
0xb4b4,0xb4b3,0xddbd,0xffff,0xefd8,0xc4e3,0xf7de,0xa4e6,
0xffff,0xaec6,0xffff,0xb1d8,0xb1d7,0xd97a,0xd97b,0xb772,
0xe1f5,0xba57,0xe9b2,0xffff,0xa4e7,0xa5b8,0xffff,0xa9f2,
0xccc2,0xffff,0xcee9,0xac48,0xb1d9,0xffff,0xd97c,0xb4b5,
0xb773,0xffff,0xe5c1,0xe5c2,0xffff,0xffff,0xecf0,0xc25f,
0xf8f0,0xa4e8,0xffff,0xccc3,0xa9f3,0xac49,0xffff,0xceea,
0xffff,0xaec7,0xd1d2,0xd1d0,0xd1d1,0xaec8,0xd1cf,0xffff,
0xffff,0xffff,0xffff,0xb1db,0xb1dc,0xd5a8,0xb1dd,0xb1da,
0xd97d,0xffff,0xd97e,0xddbe,0xffff,0xffff,0xba59,0xba58,
0xffff,0xffff,0xecf1,0xefd9,0xffff,0xf24a,0xf249,0xf44f,
0xffff,0xc95e,0xac4a,0xffff,0xffff,0xa4e9,0xa5b9,0xffff,
0xa6ae,0xa6ad,0xffff,0xffff,0xa6af,0xa6b0,0xc9ee,0xc9ed,
0xcaf8,0xa7f2,0xcafb,0xcafa,0xcaf9,0xcafc,0xffff,0xffff,
0xffff,0xffff,0xa9f4,0xccc9,0xccc5,0xccce,0xffff,0xffff,
0xa9fb,0xffff,0xa9f9,0xccca,0xccc6,0xcccd,0xa9f8,0xaa40,
0xccc8,0xccc4,0xa9fe,0xcccb,0xa9f7,0xcccc,0xa9fa,0xa9fc,
0xccd0,0xcccf,0xccc7,0xa9f6,0xa9f5,0xa9fd,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xceef,0xcef5,0xffff,0xac50,
0xac4d,0xceec,0xcef1,0xffff,0xac53,0xac4b,0xcef0,0xac4e,
0xac51,0xffff,0xffff,0xcef3,0xffff,0xac4c,0xcef8,0xac4f,
0xffff,0xac52,0xceed,0xcef2,0xcef6,0xceee,0xceeb,0xffff,
0xffff,0xcef7,0xcef4,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xaed0,0xaec9,0xaecc,0xffff,0xaecf,0xffff,0xd1d5,
0xffff,0xaeca,0xd1d3,0xffff,0xaece,0xffff,0xffff,0xaecb,
0xffff,0xd1d6,0xaecd,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xd5ac,0xb1df,0xd5ab,0xd5ad,0xb1de,0xb1e3,0xd1d4,
0xffff,0xd5aa,0xd5ae,0xffff,0xb1e0,0xd5a9,0xb1e2,0xffff,
0xb1e1,0xffff,0xd9a7,0xffff,0xd9a2,0xffff,0xb4b6,0xb4ba,
0xb4b7,0xd9a5,0xd9a8,0xffff,0xb4b8,0xffff,0xb4b9,0xb4be,
0xddc7,0xd9a6,0xb4bc,0xd9a3,0xd9a1,0xffff,0xb4bd,0xffff,
0xd9a4,0xffff,0xffff,0xffff,0xb779,0xffff,0xddbf,0xb776,
0xb777,0xb775,0xddc4,0xddc3,0xddc0,0xb77b,0xffff,0xffff,
0xddc2,0xb4bb,0xffff,0xffff,0xddc6,0xddc1,0xb778,0xb774,
0xb77a,0xddc5,0xffff,0xffff,0xffff,0xba5c,0xffff,0xe1f8,
0xe1f7,0xe1f6,0xba5a,0xffff,0xffff,0xffff,0xffff,0xffff,
0xba5b,0xe5c5,0xe5c8,0xbcc8,0xffff,0xffff,0xbcc7,0xe5c9,
0xe5c4,0xbcca,0xe5c6,0xffff,0xbcc9,0xe5c3,0xffff,0xe5c7,
0xbee9,0xbee6,0xe9bb,0xe9ba,0xffff,0xe9b9,0xe9b4,0xffff,
0xe9b5,0xffff,0xffff,0xffff,0xbee7,0xffff,0xbee4,0xbee8,
0xe9b3,0xbee5,0xe9b6,0xe9b7,0xe9bc,0xffff,0xffff,0xe9b8,
0xffff,0xffff,0xecf2,0xffff,0xffff,0xffff,0xc0c7,0xffff,
0xefdc,0xc0c6,0xefda,0xefdb,0xc260,0xc36e,0xf24b,0xffff,
0xc36d,0xffff,0xffff,0xf451,0xf452,0xffff,0xc466,0xffff,
0xf450,0xc4e4,0xffff,0xf7df,0xc5ce,0xf8aa,0xf8ab,0xffff,
0xa4ea,0xffff,0xa6b1,0xa6b2,0xa7f3,0xffff,0xccd1,0xac54,
0xaed1,0xb1e4,0xffff,0xffff,0xb0d2,0xffff,0xb4bf,0xb4c0,
0xb3cc,0xd9a9,0xffff,0xb77c,0xe1fa,0xe1f9,0xffff,0xffff,
0xa4eb,0xa6b3,0xccd2,0xaa42,0xffff,0xaa41,0xffff,0xcef9,
0xcefa,0xffff,0xd1d7,0xd1d8,0xaed2,0xaed3,0xffff,0xaed4,
0xd5af,0xffff,0xffff,0xb1e6,0xffff,0xb4c2,0xffff,0xb4c1,
0xddc8,0xdf7a,0xe1fb,0xe9bd,0xffff,0xffff,0xc261,0xc467,
0xa4ec,0xffff,0xa5bc,0xa5bd,0xa5bb,0xa5be,0xa5ba,0xffff,
0xffff,0xa6b6,0xffff,0xc9f6,0xa6b5,0xa6b7,0xffff,0xffff,
0xc9f1,0xc9f0,0xc9f3,0xc9f2,0xc9f5,0xa6b4,0xc9ef,0xc9f4,
0xffff,0xffff,0xffff,0xffff,0xffff,0xcafd,0xa7fd,0xcafe,
0xcb43,0xa7fc,0xffff,0xcb47,0xcb42,0xcb45,0xa7f5,0xa7f6,
0xa7f7,0xa7f8,0xffff,0xa840,0xffff,0xcb41,0xa7fa,0xa841,
0xffff,0xcb40,0xcb46,0xffff,0xa7f9,0xcb44,0xa7fb,0xa7f4,
0xa7fe,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xaa57,0xffff,0xccd4,0xaa43,0xffff,0xaa4d,
0xaa4e,0xaa46,0xaa58,0xaa48,0xccdc,0xaa53,0xccd7,0xaa49,
0xcce6,0xcce7,0xccdf,0xccd8,0xaa56,0xcce4,0xaa51,0xaa4f,
0xffff,0xcce5,0xffff,0xcce3,0xccdb,0xccd3,0xccda,0xaa4a,
0xffff,0xaa50,0xffff,0xaa44,0xccde,0xccdd,0xccd5,0xffff,
0xaa52,0xcce1,0xccd6,0xaa55,0xcce8,0xaa45,0xffff,0xaa4c,
0xccd9,0xcce2,0xaa54,0xffff,0xaa47,0xaa4b,0xffff,0xcce0,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xcf5b,0xac5c,
0xac69,0xffff,0xcf56,0xcf4c,0xac62,0xcf4a,0xac5b,0xcf45,
0xac65,0xcf52,0xcefe,0xcf41,0xffff,0xffff,0xffff,0xffff,
0xcf44,0xcefb,0xcf51,0xcf61,0xac60,0xcf46,0xcf58,0xffff,
0xcefd,0xcf5f,0xcf60,0xcf63,0xcf5a,0xcf4b,0xcf53,0xac66,
0xac59,0xac61,0xac6d,0xac56,0xac58,0xffff,0xffff,0xffff,
0xcf43,0xac6a,0xac63,0xcf5d,0xcf40,0xac6c,0xac67,0xcf49,
0xffff,0xffff,0xac6b,0xcf50,0xcf48,0xac64,0xcf5c,0xcf54,
0xffff,0xac5e,0xcf62,0xcf47,0xac5a,0xcf59,0xcf4f,0xac5f,
0xcf55,0xac57,0xcefc,0xac68,0xaee3,0xac5d,0xcf4e,0xcf4d,
0xcf42,0xffff,0xcf5e,0xffff,0xcf57,0xffff,0xffff,0xac55,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xd1ec,0xaeea,0xd1ed,0xffff,0xd1e1,0xaedf,
0xaeeb,0xffff,0xd1da,0xffff,0xd1e3,0xd1eb,0xffff,0xd1d9,
0xd1f4,0xaed5,0xffff,0xffff,0xffff,0xd1f3,0xd1ee,0xffff,
0xd1ef,0xaedd,0xaee8,0xd1e5,0xffff,0xd1e6,0xd1f0,0xd1e7,
0xffff,0xd1e2,0xd1dc,0xd1dd,0xd1ea,0xd1e4,0xffff,0xffff,
0xaed6,0xaeda,0xd1f2,0xd1de,0xaee6,0xaee2,0xffff,0xffff,
0xaee5,0xaeec,0xaedb,0xaee7,0xd1e9,0xaee9,0xaed8,0xffff,
0xaed7,0xd1db,0xffff,0xd1df,0xaee0,0xd1f1,0xd1e8,0xd1e0,
0xaee4,0xaee1,0xffff,0xaed9,0xaedc,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xd5c4,0xffff,0xd5b4,0xd5b5,0xd5b9,
0xffff,0xd5c8,0xd5c5,0xffff,0xd5be,0xd5bd,0xb1ed,0xd5c1,
0xd5d0,0xd5b0,0xffff,0xd5d1,0xd5c3,0xd5d5,0xd5c9,0xb1ec,
0xd5c7,0xb1e7,0xb1fc,0xb1f2,0xffff,0xb1f6,0xb1f5,0xd5b1,
0xffff,0xd5ce,0xd5d4,0xd5cc,0xd5d3,0xffff,0xffff,0xd5c0,
0xd5b2,0xd5d2,0xd5c2,0xb1ea,0xb1f7,0xffff,0xd5cb,0xb1f0,
0xffff,0xffff,0xffff,0xd5ca,0xd5b3,0xb1f8,0xffff,0xb1fa,
0xd5cd,0xb1fb,0xb1e9,0xd5ba,0xd5cf,0xffff,0xffff,0xb1ef,
0xb1f9,0xd5bc,0xd5c6,0xd5b7,0xd5bb,0xb1f4,0xd5b6,0xb1e8,
0xb1f1,0xb1ee,0xd5bf,0xaede,0xd9c0,0xb1eb,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xb1f3,0xffff,0xd9c3,0xd9d9,
0xd9ce,0xb4d6,0xffff,0xb4d1,0xd9bd,0xb4d2,0xd9cd,0xffff,
0xd9c6,0xd9d3,0xb4ce,0xd9ab,0xd9d5,0xb4c4,0xd9b3,0xb4c7,
0xb4c6,0xffff,0xb4d7,0xffff,0xd9ad,0xd9cf,0xd9d0,0xb4c9,
0xb4c5,0xd9bb,0xffff,0xb4d0,0xd9b6,0xffff,0xd9d1,0xb4cc,
0xd9c9,0xd9d6,0xd9b0,0xd9b5,0xd9af,0xffff,0xb4cb,0xd9c2,
0xddde,0xd9b1,0xb4cf,0xd9ba,0xd9d2,0xb4ca,0xd9b7,0xd9b4,
0xd9c5,0xb4cd,0xb4c3,0xb4d9,0xd9c8,0xd9c7,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xd9ac,0xb4c8,0xd9d4,0xd9bc,
0xd9be,0xffff,0xd9cb,0xd9ca,0xd9aa,0xb4d3,0xb4d5,0xd9b2,
0xd9b9,0xd9c1,0xb4d4,0xd9b8,0xd9c4,0xd9d7,0xffff,0xd9cc,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xd9d8,0xffff,0xffff,
0xffff,0xffff,0xd9ae,0xffff,0xffff,0xffff,0xffff,0xddf2,
0xb7a6,0xffff,0xddf0,0xdddb,0xdde0,0xddd9,0xffff,0xddec,
0xddcb,0xddd2,0xffff,0xddea,0xddf4,0xdddc,0xffff,0xddcf,
0xdde2,0xdde7,0xddd3,0xffff,0xdde4,0xddd0,0xffff,0xffff,
0xddd7,0xddd8,0xb7a8,0xddeb,0xdde9,0xffff,0xddcc,0xddee,
0xffff,0xddef,0xddf1,0xb7ac,0xb7a4,0xffff,0xd5b8,0xddd4,
0xdde6,0xddd5,0xb7a1,0xb7b1,0xdded,0xb7af,0xb7ab,0xddca,
0xb7a3,0xffff,0xddcd,0xb7b0,0xffff,0xdddd,0xddc9,0xffff,
0xb7a9,0xdde1,0xddd1,0xb7aa,0xddda,0xb77e,0xb4d8,0xdde3,
0xd9bf,0xddce,0xffff,0xffff,0xdde8,0xb7a5,0xdde5,0xb7a2,
0xdddf,0xb7ad,0xddd6,0xddf3,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xb7a7,0xdec6,0xffff,0xffff,0xb7ae,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe24a,0xe248,0xffff,
0xe25e,0xe246,0xffff,0xe258,0xb77d,0xba5f,0xe242,0xe25d,
0xffff,0xe247,0xe255,0xba64,0xba5d,0xffff,0xe25b,0xffff,
0xe240,0xe25a,0xffff,0xba6f,0xe251,0xe261,0xba6d,0xe249,
0xba5e,0xe24b,0xe259,0xba67,0xe244,0xba6b,0xba61,0xe24d,
0xe243,0xe1fc,0xffff,0xe257,0xba68,0xe260,0xe1fd,0xba65,
0xffff,0xe253,0xffff,0xba66,0xe245,0xe250,0xe24c,0xe24e,
0xffff,0xba60,0xe25f,0xba6e,0xe24f,0xffff,0xe262,0xffff,
0xffff,0xe1fe,0xe254,0xba63,0xba6c,0xba6a,0xe241,0xe256,
0xba69,0xffff,0xffff,0xba62,0xe252,0xffff,0xffff,0xffff,
0xffff,0xe25c,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe5d5,0xffff,0xe5d1,0xe5cd,0xe5e1,0xe5de,
0xbccd,0xffff,0xffff,0xe5e5,0xe5d4,0xbcd8,0xe5db,0xffff,
0xffff,0xe5d0,0xe5da,0xbcd5,0xe5ee,0xffff,0xe5eb,0xe5dd,
0xe5ce,0xffff,0xffff,0xe5e2,0xe5e4,0xbcd1,0xe5d8,0xe5d3,
0xe5ca,0xbcce,0xbcd6,0xffff,0xe5e7,0xbcd7,0xe5cb,0xe5ed,
0xe5e0,0xe5e6,0xbcd4,0xffff,0xffff,0xe5e3,0xffff,0xe5ea,
0xffff,0xbcd9,0xffff,0xbcd3,0xe5dc,0xe5cf,0xe5ef,0xe5cc,
0xe5e8,0xbcd0,0xffff,0xe5d6,0xffff,0xe5d7,0xbccf,0xbccc,
0xe5d2,0xbcd2,0xffff,0xbccb,0xffff,0xe5e9,0xe5ec,0xe5d9,
0xe9ca,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe9c2,0xffff,0xe9be,0xbef6,0xffff,0xffff,
0xbeeb,0xbef0,0xbeec,0xe9cc,0xe9d7,0xbeea,0xe9c4,0xe9cd,
0xe5df,0xe9ce,0xffff,0xffff,0xbef1,0xffff,0xe9dd,0xbef5,
0xbef8,0xe9c0,0xffff,0xbef4,0xffff,0xe9db,0xe9dc,0xe9d2,
0xe9d1,0xe9c9,0xffff,0xffff,0xe9d3,0xe9da,0xe9d9,0xffff,
0xbeef,0xbeed,0xe9cb,0xe9c8,0xffff,0xe9c5,0xe9d8,0xbef7,
0xe9d6,0xbef3,0xbef2,0xffff,0xe9d0,0xffff,0xe9bf,0xe9c1,
0xe9c3,0xe9d5,0xe9cf,0xbeee,0xffff,0xe9c6,0xffff,0xe9d4,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe9c7,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xc0cf,0xed45,
0xc0c8,0xecf5,0xffff,0xed41,0xc0ca,0xed48,0xffff,0xecfc,
0xffff,0xecf7,0xffff,0xffff,0xed49,0xecf3,0xecfe,0xffff,
0xc0d1,0xed44,0xed4a,0xecfd,0xc0c9,0xed40,0xecf4,0xc0d0,
0xffff,0xffff,0xed47,0xecf9,0xc0cc,0xffff,0xecfb,0xecf8,
0xc0d2,0xecfa,0xc0cb,0xc0ce,0xed43,0xecf6,0xed46,0xffff,
0xed42,0xffff,0xffff,0xffff,0xc263,0xefe7,0xc268,0xc269,
0xffff,0xffff,0xffff,0xc262,0xefe6,0xffff,0xefe3,0xefe4,
0xc266,0xefde,0xefe2,0xc265,0xffff,0xefdf,0xffff,0xffff,
0xffff,0xffff,0xc267,0xc264,0xffff,0xefdd,0xefe1,0xefe5,
0xffff,0xffff,0xffff,0xf251,0xf24e,0xf257,0xffff,0xf256,
0xf254,0xf24f,0xffff,0xc372,0xffff,0xffff,0xffff,0xffff,
0xffff,0xf250,0xc371,0xc0cd,0xf253,0xc370,0xf258,0xf252,
0xf24d,0xefe0,0xffff,0xffff,0xffff,0xc36f,0xffff,0xf24c,
0xf456,0xffff,0xf455,0xf255,0xc468,0xffff,0xf459,0xf45a,
0xf454,0xf458,0xffff,0xf453,0xffff,0xffff,0xffff,0xffff,
0xf5d1,0xf457,0xc4e7,0xc4e5,0xf5cf,0xffff,0xffff,0xffff,
0xf5d2,0xffff,0xf5ce,0xf5d0,0xc4e6,0xffff,0xffff,0xffff,
0xf6e5,0xf6e6,0xc576,0xf6e4,0xffff,0xffff,0xffff,0xf7e2,
0xc5cf,0xf7e0,0xf7e1,0xf8ac,0xffff,0xffff,0xc656,0xf8f3,
0xf8f1,0xf8f2,0xf8f4,0xffff,0xffff,0xffff,0xf9bb,0xffff,
0xa4ed,0xa6b8,0xffff,0xaa59,0xffff,0xcce9,0xffff,0xffff,
0xcf64,0xffff,0xffff,0xffff,0xd1f5,0xd1f7,0xffff,0xd1f6,
0xffff,0xd1f8,0xb1fd,0xd5d7,0xd1f9,0xffff,0xd5d6,0xd5d8,
0xd5d9,0xd9da,0xb4db,0xd9db,0xd9dd,0xb4dc,0xb4da,0xd9dc,
0xffff,0xddfa,0xddf8,0xddf7,0xffff,0xddf6,0xddf5,0xb7b2,
0xddf9,0xba70,0xe263,0xe265,0xba71,0xe264,0xbcdb,0xffff,
0xbcda,0xe5f0,0xffff,0xffff,0xe9df,0xe9de,0xe9e0,0xffff,
0xffff,0xbef9,0xffff,0xed4b,0xc0d3,0xffff,0xefe8,0xc26a,
0xf259,0xc577,0xa4ee,0xa5bf,0xa6b9,0xa842,0xaa5a,0xaa5b,
0xffff,0xffff,0xac6e,0xffff,0xffff,0xd1fa,0xffff,0xffff,
0xffff,0xffff,0xb7b3,0xffff,0xffff,0xffff,0xe6d1,0xbefa,
0xc26b,0xa4ef,0xffff,0xa6ba,0xffff,0xffff,0xcceb,0xaa5c,
0xccea,0xffff,0xcf65,0xac6f,0xcf66,0xffff,0xac70,0xffff,
0xd1fc,0xaeee,0xaeed,0xffff,0xd5de,0xd5dc,0xd5dd,0xd5db,
0xffff,0xd5da,0xffff,0xffff,0xd9de,0xd9e1,0xb4de,0xd9df,
0xb4dd,0xd9e0,0xffff,0xddfb,0xffff,0xffff,0xe266,0xe267,
0xe268,0xffff,0xe5f3,0xe5f2,0xbcdc,0xe5f1,0xe5f4,0xe9e1,
0xffff,0xffff,0xe9e2,0xe9e3,0xffff,0xed4c,0xc0d4,0xc26c,
0xf25a,0xffff,0xc4e8,0xc95f,0xffff,0xac71,0xcf67,0xaeef,
0xffff,0xffff,0xb1fe,0xffff,0xb4df,0xd9e2,0xffff,0xb7b5,
0xb7b4,0xffff,0xffff,0xe269,0xe26a,0xbcdd,0xbcde,0xe9e5,
0xe9e4,0xefe9,0xf7e3,0xa4f0,0xc960,0xa5c0,0xffff,0xa843,
0xcb48,0xffff,0xac72,0xb7b6,0xa4f1,0xffff,0xcf68,0xac73,
0xcf69,0xffff,0xc0d5,0xa4f2,0xffff,0xffff,0xccec,0xffff,
0xcf6a,0xffff,0xd242,0xd241,0xd1fe,0xffff,0xd1fd,0xd243,
0xd240,0xffff,0xffff,0xb240,0xb241,0xffff,0xffff,0xb4e0,
0xd9e3,0xffff,0xd9e4,0xd9e5,0xffff,0xffff,0xffff,0xde41,
0xde42,0xde40,0xffff,0xddfd,0xddfe,0xb7b7,0xe26b,0xe5f7,
0xe5f6,0xe5f5,0xe5f8,0xe9e7,0xe9e6,0xbefb,0xe9e8,0xffff,
0xc0d6,0xed4d,0xffff,0xefea,0xf25b,0xf6e7,0xffff,0xa4f3,
0xa5c2,0xa5c1,0xffff,0xaa5d,0xc961,0xc97e,0xa6bb,0xffff,
0xc9f7,0xcb49,0xcb4a,0xaa5e,0xffff,0xcced,0xffff,0xac74,
0xcf6b,0xcf6c,0xffff,0xaef0,0xaef4,0xd244,0xaef3,0xaef1,
0xaef2,0xffff,0xd5df,0xb242,0xb4e3,0xffff,0xb4e1,0xb4e2,
0xd9e6,0xffff,0xffff,0xba72,0xa4f4,0xffff,0xc9a1,0xffff,
0xa5c3,0xffff,0xffff,0xc9a4,0xffff,0xffff,0xa5c6,0xc9a3,
0xa5c5,0xa5c4,0xa844,0xc9a2,0xffff,0xffff,0xc9f8,0xffff,
0xffff,0xffff,0xc9fc,0xc9fe,0xca40,0xa6c5,0xa6c6,0xc9fb,
0xa6c1,0xffff,0xc9f9,0xffff,0xc9fd,0xa6c2,0xffff,0xa6bd,
0xffff,0xa6be,0xffff,0xa6c4,0xc9fa,0xa6bc,0xa845,0xa6bf,
0xa6c0,0xa6c3,0xffff,0xffff,0xffff,0xcb5b,0xcb59,0xcb4c,
0xa851,0xcb53,0xa84c,0xcb4d,0xffff,0xcb55,0xffff,0xcb52,
0xa84f,0xcb51,0xa856,0xcb5a,0xa858,0xffff,0xa85a,0xffff,
0xcb4b,0xffff,0xa84d,0xcb5c,0xffff,0xa854,0xa857,0xffff,
0xcd45,0xa847,0xa85e,0xa855,0xcb4e,0xa84a,0xa859,0xcb56,
0xa848,0xa849,0xcd43,0xcb4f,0xa850,0xa85b,0xcb5d,0xcb50,
0xa84e,0xffff,0xa853,0xccee,0xa85c,0xcb57,0xa852,0xffff,
0xa85d,0xa846,0xcb54,0xa84b,0xcb58,0xcd44,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xaa6a,0xaa7a,0xccf5,0xaa71,0xffff,
0xcd4b,0xaa62,0xffff,0xaa65,0xcd42,0xffff,0xccf3,0xccf7,
0xaa6d,0xaa6f,0xccfa,0xaa76,0xaa68,0xaa66,0xaa67,0xaa75,
0xcd47,0xaa70,0xccf9,0xccfb,0xaa6e,0xaa73,0xccfc,0xcd4a,
0xffff,0xac75,0xaa79,0xffff,0xaa63,0xcd49,0xffff,0xcd4d,
0xccf8,0xcd4f,0xcd40,0xaa6c,0xccf4,0xaa6b,0xaa7d,0xaa72,
0xffff,0xccf2,0xcf75,0xaa78,0xaa7c,0xcd41,0xcd46,0xffff,
0xaa7e,0xaa77,0xaa69,0xaa5f,0xffff,0xaa64,0xffff,0xccf6,
0xaa60,0xcd4e,0xffff,0xccf0,0xccef,0xccfd,0xccf1,0xaa7b,
0xaef5,0xaa74,0xccfe,0xaa61,0xffff,0xaca6,0xffff,0xffff,
0xffff,0xcd4c,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xcf7c,0xcfa1,0xffff,0xcfa4,0xcf77,0xffff,0xffff,0xcfa7,
0xcfaa,0xcfac,0xcf74,0xac76,0xac7b,0xd249,0xacad,0xcfa5,
0xcfad,0xcf7b,0xcf73,0xffff,0xffff,0xffff,0xd264,0xac7e,
0xcfa2,0xcf78,0xcf7a,0xaca5,0xffff,0xcf7d,0xac7d,0xcf70,
0xcfa8,0xffff,0xcfab,0xffff,0xffff,0xac7a,0xffff,0xaca8,
0xcf6d,0xacaa,0xac78,0xacae,0xcfa9,0xcf6f,0xacab,0xd25e,
0xcd48,0xac7c,0xac77,0xcf76,0xcf6e,0xacac,0xaca4,0xcfa3,
0xaca9,0xaca7,0xcf79,0xaca1,0xcf71,0xaca2,0xaca3,0xcf72,
0xcfa6,0xac79,0xcf7e,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd24c,0xaefd,0xaf43,0xffff,0xffff,0xffff,0xd255,0xd25b,
0xd257,0xd24a,0xd24d,0xd246,0xd247,0xaf4a,0xaefa,0xd256,
0xd25f,0xaf45,0xaef6,0xffff,0xaf40,0xd24e,0xaf42,0xd24f,
0xd259,0xffff,0xffff,0xffff,0xaf44,0xd268,0xd248,0xaefc,
0xaefb,0xaf48,0xd245,0xd266,0xd25a,0xd267,0xd261,0xd253,
0xd262,0xffff,0xd25c,0xd265,0xd263,0xaf49,0xd254,0xaef9,
0xaef8,0xaf41,0xaf47,0xd260,0xaf46,0xd251,0xb243,0xffff,
0xd269,0xd250,0xd24b,0xaefe,0xaf4b,0xaef7,0xffff,0xd258,
0xd25d,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xb265,0xd5e1,0xd5e5,0xffff,0xb252,0xb250,
0xffff,0xffff,0xb247,0xd5e3,0xd5e2,0xb25b,0xffff,0xd5e8,
0xb255,0xffff,0xd5fa,0xd647,0xb244,0xd5f7,0xd5f0,0xb267,
0xd5e0,0xffff,0xd5fc,0xffff,0xb264,0xb258,0xb263,0xb24e,
0xd5ec,0xd5fe,0xd5f6,0xb24f,0xb249,0xd645,0xffff,0xd5fd,
0xd640,0xb251,0xb259,0xd642,0xd5ea,0xd5fb,0xd5ef,0xd644,
0xb25e,0xb246,0xb25c,0xd5f4,0xd5f2,0xd5f3,0xb253,0xd5ee,
0xd5ed,0xb248,0xd5e7,0xd646,0xb24a,0xd5f1,0xb268,0xffff,
0xb262,0xd5e6,0xb25f,0xb25d,0xb266,0xd5f8,0xb261,0xd252,
0xd5f9,0xb260,0xd641,0xb245,0xd5f5,0xb257,0xd5e9,0xb256,
0xffff,0xb254,0xb24c,0xb24b,0xd9e7,0xd643,0xffff,0xffff,
0xd5eb,0xffff,0xffff,0xd9fc,0xffff,0xb24d,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xb541,0xb25a,0xb4ee,0xd9f6,0xb4fc,0xffff,0xd9ea,
0xb4eb,0xb4e7,0xda49,0xb4ed,0xb4f1,0xb4ec,0xb4f5,0xda4d,
0xda44,0xffff,0xffff,0xd9f1,0xb4fa,0xb4f4,0xd9fd,0xb4e4,
0xda4a,0xda43,0xb4e8,0xd9f7,0xb4f7,0xda55,0xda56,0xffff,
0xb4e5,0xda48,0xb4f9,0xd9fb,0xd9ed,0xd9ee,0xb4fd,0xd9f2,
0xd9f9,0xd9f3,0xffff,0xb4fb,0xb544,0xd9ef,0xd9e8,0xd9e9,
0xffff,0xd9eb,0xb4ea,0xd9f8,0xffff,0xb4f8,0xb542,0xffff,
0xffff,0xd9fa,0xda53,0xda4b,0xb4e6,0xda51,0xb4f2,0xffff,
0xb4f0,0xffff,0xda57,0xb4ef,0xda41,0xd9f4,0xd9fe,0xb547,
0xda45,0xda42,0xd9f0,0xb543,0xda4f,0xda4c,0xda54,0xb4e9,
0xda40,0xb546,0xffff,0xda47,0xffff,0xffff,0xb4f3,0xb4f6,
0xffff,0xda46,0xb545,0xd9f5,0xd5e4,0xffff,0xffff,0xda50,
0xda4e,0xda52,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd9ec,0xb540,0xffff,0xffff,0xffff,0xde61,0xde60,0xde46,
0xb7bd,0xffff,0xde5f,0xde49,0xde4a,0xffff,0xb7c7,0xde68,
0xb7c2,0xde5e,0xffff,0xde43,0xb7c8,0xb7be,0xde52,0xde48,
0xde4b,0xde63,0xb7b8,0xde6a,0xde62,0xb7c1,0xde57,0xb7cc,
0xffff,0xffff,0xb7cb,0xb7c5,0xffff,0xffff,0xde69,0xb7b9,
0xde55,0xde4c,0xde59,0xde65,0xb7cd,0xffff,0xb7bb,0xde54,
0xffff,0xde4d,0xb7c4,0xffff,0xb7c3,0xde50,0xde5a,0xde64,
0xde47,0xde51,0xb7bc,0xde5b,0xb7c9,0xb7c0,0xde4e,0xb7bf,
0xde45,0xde53,0xde67,0xb4fe,0xbab0,0xde56,0xe26c,0xde58,
0xde66,0xb7c6,0xde4f,0xb7ba,0xb7ca,0xbcf0,0xde44,0xffff,
0xde5d,0xffff,0xffff,0xffff,0xde5c,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe2aa,0xbaad,0xe27d,0xe2a4,0xbaa2,
0xffff,0xe26e,0xbaaf,0xffff,0xba77,0xe26d,0xe2b0,0xbab1,
0xe271,0xe2a3,0xffff,0xe273,0xe2b3,0xe2af,0xba75,0xbaa1,
0xe653,0xbaae,0xba7d,0xe26f,0xffff,0xe2ae,0xbaa3,0xe2ab,
0xe2b8,0xe275,0xe27e,0xffff,0xffff,0xe2b6,0xe2ac,0xba7c,
0xffff,0xffff,0xe27c,0xba76,0xba74,0xbaa8,0xffff,0xffff,
0xe27a,0xe277,0xe278,0xffff,0xe2b2,0xffff,0xe2b7,0xe2b5,
0xba7a,0xe2b9,0xba7e,0xbaa7,0xffff,0xe270,0xe5fa,0xe279,
0xffff,0xba78,0xbaac,0xbaa9,0xba7b,0xe2a5,0xe274,0xbaaa,
0xe2a7,0xbaa4,0xbaa6,0xba73,0xffff,0xe2a9,0xe2a1,0xe272,
0xbaa5,0xe2b1,0xe2b4,0xe27b,0xe2a8,0xffff,0xba79,0xbcdf,
0xe2a6,0xe5f9,0xffff,0xe2ad,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe276,0xe644,
0xe64e,0xbce2,0xe64d,0xe659,0xbce4,0xe64b,0xffff,0xe64f,
0xbcef,0xffff,0xe646,0xbce7,0xffff,0xe652,0xe9f0,0xbcf3,
0xbcf2,0xe654,0xe643,0xe65e,0xbced,0xffff,0xbce3,0xe657,
0xffff,0xe65b,0xe660,0xe655,0xe649,0xbce6,0xbce9,0xbcf1,
0xbcec,0xffff,0xe64c,0xe2a2,0xffff,0xffff,0xe648,0xe65f,
0xbce8,0xffff,0xbceb,0xe661,0xbce0,0xe656,0xe5fb,0xe65c,
0xc0df,0xffff,0xe64a,0xffff,0xbce1,0xe645,0xbce5,0xe5fc,
0xbaab,0xe641,0xffff,0xe65a,0xe642,0xe640,0xbcea,0xffff,
0xe658,0xffff,0xe5fe,0xe651,0xe650,0xe65d,0xe647,0xbcee,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe9f3,0xffff,
0xbf49,0xbefe,0xea40,0xe9eb,0xbf41,0xe9f7,0xbf48,0xbf43,
0xe9f5,0xed4f,0xe9fb,0xea42,0xe9fa,0xe9e9,0xe9f8,0xea44,
0xea46,0xbefd,0xea45,0xbf44,0xbf4a,0xffff,0xbf47,0xffff,
0xe9fe,0xbf46,0xe9f9,0xffff,0xe9ed,0xe9f2,0xffff,0xe9fd,
0xbf45,0xbf42,0xbefc,0xbf40,0xe9f1,0xffff,0xe5fd,0xe9ec,
0xe9ef,0xea41,0xe9f4,0xe9ea,0xed4e,0xea43,0xe9ee,0xe9fc,
0xffff,0xffff,0xffff,0xffff,0xed51,0xc0e3,0xffff,0xffff,
0xc0d7,0xffff,0xffff,0xc0db,0xed53,0xed59,0xed57,0xc0d9,
0xc0da,0xc0e1,0xed5a,0xed52,0xc0dc,0xffff,0xed56,0xed55,
0xed5b,0xc0e2,0xffff,0xc0dd,0xc0e0,0xed54,0xc0e4,0xc0de,
0xc0e5,0xc0d8,0xed58,0xffff,0xed50,0xffff,0xffff,0xeff7,
0xffff,0xffff,0xc271,0xeff4,0xeff6,0xffff,0xc26f,0xeff2,
0xeff3,0xefee,0xffff,0xffff,0xe9f6,0xefef,0xc270,0xefeb,
0xffff,0xc26d,0xeff8,0xc26e,0xefec,0xefed,0xeff1,0xc273,
0xffff,0xc272,0xffff,0xffff,0xeff0,0xc378,0xf25f,0xf265,
0xc379,0xf25c,0xc376,0xc373,0xf267,0xc377,0xffff,0xc374,
0xf25e,0xf261,0xf262,0xf263,0xf266,0xffff,0xeff5,0xf25d,
0xc375,0xf264,0xf268,0xf260,0xffff,0xffff,0xffff,0xf45d,
0xc46a,0xf460,0xc46b,0xf468,0xf45f,0xf45c,0xffff,0xf45e,
0xf462,0xf465,0xf464,0xf467,0xf45b,0xffff,0xc469,0xf463,
0xf466,0xf469,0xf461,0xf5d3,0xf5d4,0xf5d8,0xf5d9,0xffff,
0xf5d6,0xf5d7,0xf5d5,0xffff,0xc4e9,0xffff,0xffff,0xffff,
0xffff,0xc578,0xf6eb,0xffff,0xffff,0xf6e8,0xf6e9,0xf6ea,
0xc579,0xffff,0xf7e5,0xf7e4,0xffff,0xf8af,0xc5f4,0xf8ad,
0xf8b0,0xf8ae,0xf8f5,0xc657,0xc665,0xf9a3,0xf96c,0xffff,
0xf9a2,0xf9d0,0xf9d1,0xa4f5,0xffff,0xffff,0xffff,0xffff,
0xa6c7,0xca41,0xffff,0xffff,0xcb5e,0xffff,0xa85f,0xffff,
0xa862,0xffff,0xcb5f,0xffff,0xa860,0xa861,0xffff,0xffff,
0xffff,0xffff,0xcd58,0xcd5a,0xcd55,0xcd52,0xcd54,0xffff,
0xffff,0xffff,0xaaa4,0xffff,0xffff,0xffff,0xaaa2,0xffff,
0xffff,0xcd56,0xaaa3,0xcd53,0xcd50,0xaaa1,0xcd57,0xffff,
0xcd51,0xaaa5,0xcd59,0xffff,0xffff,0xffff,0xffff,0xcfaf,
0xffff,0xcfb3,0xffff,0xffff,0xacb7,0xffff,0xffff,0xffff,
0xffff,0xcfb6,0xffff,0xacaf,0xacb2,0xacb4,0xacb6,0xacb3,
0xcfb2,0xcfb1,0xffff,0xacb1,0xcfb4,0xcfb5,0xffff,0xcfae,
0xacb5,0xffff,0xacb0,0xffff,0xffff,0xffff,0xcfb0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xd277,0xd278,0xd279,
0xaf50,0xffff,0xaf4c,0xd26e,0xffff,0xd276,0xd27b,0xaf51,
0xffff,0xd26c,0xd272,0xd26b,0xd275,0xffff,0xffff,0xd271,
0xaf4d,0xaf4f,0xd27a,0xffff,0xd26a,0xd26d,0xd273,0xffff,
0xd274,0xd27c,0xd270,0xffff,0xaf4e,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xb26d,
0xd64e,0xffff,0xffff,0xd650,0xd64c,0xffff,0xd658,0xd64a,
0xd657,0xb269,0xd648,0xda5b,0xd652,0xb26c,0xffff,0xd653,
0xd656,0xffff,0xd65a,0xffff,0xd64f,0xffff,0xd654,0xffff,
0xffff,0xb26a,0xb26b,0xd659,0xd64d,0xd649,0xd65b,0xffff,
0xd651,0xffff,0xffff,0xd655,0xffff,0xffff,0xffff,0xd64b,
0xffff,0xb548,0xb549,0xda65,0xb54f,0xffff,0xda59,0xda62,
0xda58,0xb54c,0xda60,0xda5e,0xffff,0xda5f,0xb54a,0xffff,
0xda63,0xffff,0xffff,0xffff,0xffff,0xffff,0xda5c,0xda5a,
0xb54b,0xda5d,0xda61,0xffff,0xffff,0xffff,0xb54d,0xffff,
0xffff,0xffff,0xda64,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xde70,0xde77,0xde79,0xdea1,0xffff,0xb7da,0xde6b,
0xffff,0xb7d2,0xffff,0xde7a,0xb7d7,0xdea2,0xb7ce,0xffff,
0xde7d,0xffff,0xde6d,0xde7e,0xde6c,0xffff,0xb7dc,0xffff,
0xde78,0xb7cf,0xdea3,0xffff,0xb7d4,0xde71,0xb7d9,0xde7c,
0xde6f,0xde76,0xde72,0xde6e,0xb7d1,0xb7d8,0xb7d6,0xb7d3,
0xb7db,0xb7d0,0xde75,0xffff,0xb7d5,0xffff,0xb54e,0xffff,
0xde7b,0xffff,0xde73,0xffff,0xffff,0xffff,0xffff,0xffff,
0xde74,0xffff,0xffff,0xe2c1,0xffff,0xbab4,0xffff,0xffff,
0xe2bd,0xe2c3,0xe2bf,0xffff,0xbab6,0xe2be,0xe2c2,0xe2ba,
0xffff,0xe2bc,0xbab5,0xffff,0xffff,0xffff,0xffff,0xe2c0,
0xe2bb,0xffff,0xbab7,0xffff,0xbab2,0xffff,0xffff,0xe2c4,
0xffff,0xbab3,0xe667,0xe664,0xe670,0xe66a,0xe66c,0xbcf4,
0xe666,0xe66e,0xffff,0xffff,0xe66d,0xe66b,0xffff,0xe671,
0xbcf7,0xe668,0xe66f,0xffff,0xbcf5,0xffff,0xffff,0xe663,
0xe665,0xbcf6,0xe662,0xe672,0xffff,0xe669,0xffff,0xffff,
0xea4a,0xbf51,0xffff,0xffff,0xea55,0xea53,0xbf4b,0xea49,
0xea4c,0xea4d,0xea48,0xbf55,0xbf56,0xea47,0xea56,0xea51,
0xbf4f,0xbf4c,0xea50,0xea4e,0xffff,0xffff,0xbf52,0xea52,
0xbf4d,0xffff,0xbf4e,0xffff,0xea4f,0xbf50,0xea4b,0xffff,
0xea54,0xbf53,0xea57,0xea58,0xbf54,0xffff,0xffff,0xc0e7,
0xc0ee,0xed5c,0xed62,0xffff,0xed60,0xc0ea,0xc0e9,0xc0e6,
0xed5e,0xffff,0xffff,0xffff,0xc0ec,0xc0eb,0xc0e8,0xffff,
0xed61,0xed5d,0xed5f,0xffff,0xc0ed,0xffff,0xffff,0xffff,
0xc277,0xeffb,0xffff,0xc274,0xc275,0xeffd,0xc276,0xeffa,
0xffff,0xeff9,0xf26c,0xeffc,0xffff,0xf26d,0xc37a,0xf26b,
0xffff,0xffff,0xf26a,0xffff,0xf269,0xc37b,0xffff,0xffff,
0xc46c,0xffff,0xffff,0xf46a,0xf46b,0xffff,0xffff,0xffff,
0xffff,0xf5dc,0xf5db,0xc4ea,0xffff,0xf5da,0xf6ec,0xf6ed,
0xffff,0xffff,0xf7e6,0xf8b1,0xffff,0xffff,0xf8f6,0xf9bc,
0xc679,0xf9c6,0xa4f6,0xffff,0xaaa6,0xaaa7,0xffff,0xffff,
0xacb8,0xffff,0xffff,0xffff,0xffff,0xc0ef,0xa4f7,0xffff,
0xaaa8,0xaf52,0xb7dd,0xa4f8,0xffff,0xb26e,0xbab8,0xc962,
0xffff,0xcfb7,0xd27d,0xffff,0xe2c5,0xffff,0xc0f0,0xa4f9,
0xaaa9,0xcfb8,0xcfb9,0xda66,0xb550,0xffff,0xffff,0xdea4,
0xffff,0xffff,0xb7de,0xe2c6,0xffff,0xffff,0xbcf8,0xffff,
0xc37c,0xa4fa,0xda67,0xa4fb,0xffff,0xa6c9,0xca42,0xa6c8,
0xa865,0xa864,0xa863,0xcb60,0xffff,0xffff,0xffff,0xaaaa,
0xffff,0xaaab,0xcd5b,0xffff,0xcfba,0xffff,0xcfbd,0xacba,
0xcfbb,0xffff,0xacb9,0xcfbc,0xacbb,0xffff,0xd2a2,0xd2a1,
0xd27e,0xaf53,0xffff,0xd65d,0xd65e,0xb26f,0xd65c,0xd65f,
0xb552,0xb270,0xffff,0xffff,0xb551,0xda6b,0xda6a,0xffff,
0xda68,0xda69,0xffff,0xda6c,0xdea6,0xdea5,0xdea9,0xffff,
0xdea8,0xdea7,0xbab9,0xe2c9,0xffff,0xe2c8,0xbaba,0xe2c7,
0xe673,0xffff,0xe674,0xbcf9,0xffff,0xea59,0xea5a,0xffff,
0xffff,0xf272,0xc37d,0xf271,0xf270,0xf26e,0xf26f,0xc4eb,
0xf46c,0xf6ee,0xf8f7,0xffff,0xa4fc,0xffff,0xc9a5,0xa5c7,
0xc9a6,0xffff,0xffff,0xffff,0xca43,0xca44,0xffff,0xffff,
0xffff,0xffff,0xcb66,0xffff,0xffff,0xcb62,0xffff,0xcb61,
0xaaac,0xcb65,0xa867,0xcb63,0xa866,0xcb67,0xcb64,0xffff,
0xffff,0xcd5f,0xcfbe,0xcd5d,0xcd64,0xffff,0xaaad,0xffff,
0xaab0,0xcd65,0xcd61,0xffff,0xcd62,0xffff,0xcd5c,0xaaaf,
0xcd5e,0xaaae,0xcd63,0xffff,0xcd60,0xffff,0xffff,0xcfc2,
0xacbd,0xacbe,0xffff,0xcfc5,0xcfbf,0xffff,0xcfc4,0xffff,
0xcfc0,0xacbc,0xcfc3,0xcfc1,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xd2a8,0xd2a5,0xffff,0xd2a7,0xaf58,
0xaf57,0xaf55,0xd2a4,0xd2a9,0xaf54,0xaf56,0xd2a6,0xd667,
0xd2a3,0xd2aa,0xffff,0xffff,0xffff,0xffff,0xffff,0xd662,
0xd666,0xffff,0xd665,0xda6e,0xda79,0xffff,0xffff,0xd668,
0xffff,0xd663,0xda6d,0xb274,0xffff,0xffff,0xb273,0xd661,
0xd664,0xb275,0xffff,0xb272,0xb271,0xd660,0xd669,0xffff,
0xffff,0xffff,0xda70,0xda77,0xffff,0xb554,0xda76,0xda73,
0xffff,0xb556,0xffff,0xffff,0xffff,0xda75,0xffff,0xffff,
0xda6f,0xda71,0xda74,0xda72,0xb555,0xda78,0xb553,0xb7df,
0xffff,0xffff,0xdead,0xdeac,0xdeaa,0xffff,0xb7e2,0xb7e1,
0xdeae,0xffff,0xdeab,0xe2ca,0xbabb,0xb7e0,0xffff,0xffff,
0xffff,0xdeb0,0xdeaf,0xffff,0xe2cd,0xe2cb,0xbcfa,0xffff,
0xbabc,0xe2cc,0xe676,0xffff,0xffff,0xffff,0xffff,0xbcfb,
0xe675,0xe67e,0xe67d,0xe67b,0xffff,0xe67a,0xe677,0xe678,
0xe679,0xe67c,0xe6a1,0xffff,0xffff,0xea5f,0xea5c,0xea5d,
0xbf57,0xea5b,0xea61,0xea60,0xea5e,0xffff,0xed64,0xed65,
0xc0f1,0xffff,0xc0f2,0xed63,0xffff,0xc279,0xeffe,0xc278,
0xc37e,0xffff,0xc3a1,0xc46d,0xf46e,0xf46d,0xf5dd,0xf6ef,
0xc57a,0xf7e8,0xf7e7,0xf7e9,0xa5c8,0xcfc6,0xaf59,0xb276,
0xd66a,0xa5c9,0xc9a7,0xa4fd,0xffff,0xffff,0xca45,0xffff,
0xffff,0xffff,0xcb6c,0xcb6a,0xcb6b,0xcb68,0xa868,0xcb69,
0xffff,0xffff,0xffff,0xffff,0xffff,0xcd6d,0xffff,0xaab3,
0xcd6b,0xcd67,0xcd6a,0xffff,0xcd66,0xaab5,0xcd69,0xffff,
0xaab2,0xaab1,0xffff,0xaab4,0xcd6c,0xcd68,0xffff,0xffff,
0xffff,0xffff,0xacc2,0xacc5,0xcfce,0xcfcd,0xcfcc,0xacbf,
0xcfd5,0xcfcb,0xffff,0xacc1,0xd2af,0xffff,0xcfd2,0xcfd0,
0xacc4,0xffff,0xcfc8,0xcfd3,0xffff,0xcfca,0xcfd4,0xcfd1,
0xcfc9,0xffff,0xacc0,0xcfd6,0xcfc7,0xacc3,0xffff,0xffff,
0xffff,0xffff,0xd2b4,0xd2ab,0xd2b6,0xffff,0xd2ae,0xd2b9,
0xd2ba,0xd2ac,0xd2b8,0xd2b5,0xd2b3,0xd2b7,0xaf5f,0xffff,
0xaf5d,0xffff,0xffff,0xd2b1,0xffff,0xd2ad,0xffff,0xd2b0,
0xd2bb,0xd2b2,0xaf5e,0xcfcf,0xffff,0xaf5a,0xaf5c,0xffff,
0xffff,0xffff,0xffff,0xffff,0xd678,0xd66d,0xd66b,0xffff,
0xd66c,0xffff,0xd673,0xffff,0xd674,0xd670,0xb27b,0xd675,
0xd672,0xd66f,0xffff,0xb279,0xd66e,0xb277,0xb27a,0xd671,
0xd679,0xaf5b,0xb278,0xd677,0xd676,0xb27c,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xda7e,0xffff,
0xffff,0xffff,0xdaa1,0xb560,0xffff,0xdaa7,0xffff,0xffff,
0xdaa9,0xdaa2,0xb55a,0xdaa6,0xdaa5,0xb55b,0xb561,0xffff,
0xb562,0xdaa8,0xb558,0xda7d,0xda7b,0xdaa3,0xda7a,0xb55f,
0xda7c,0xdaa4,0xdaaa,0xb559,0xb55e,0xb55c,0xb55d,0xffff,
0xffff,0xffff,0xb557,0xffff,0xffff,0xffff,0xffff,0xb7e9,
0xdeb7,0xb7e8,0xdebb,0xffff,0xdeb1,0xffff,0xdebc,0xffff,
0xffff,0xffff,0xdeb2,0xdeb3,0xffff,0xdebd,0xdeba,0xdeb8,
0xdeb9,0xdeb5,0xdeb4,0xffff,0xdebe,0xb7e5,0xffff,0xdeb6,
0xffff,0xb7ea,0xb7e4,0xb7eb,0xb7ec,0xffff,0xb7e7,0xb7e6,
0xffff,0xffff,0xe2ce,0xbabe,0xbabd,0xffff,0xffff,0xe2d3,
0xffff,0xbcfc,0xbabf,0xffff,0xffff,0xbac1,0xe2d4,0xb7e3,
0xbac0,0xe2d0,0xe2d2,0xe2cf,0xffff,0xe2d1,0xffff,0xffff,
0xffff,0xe6ab,0xffff,0xffff,0xe6aa,0xe6a7,0xbd40,0xea62,
0xbd41,0xe6a6,0xffff,0xbcfe,0xffff,0xe6a8,0xe6a5,0xe6a2,
0xe6a9,0xe6a3,0xe6a4,0xbcfd,0xffff,0xffff,0xffff,0xffff,
0xed69,0xffff,0xea66,0xffff,0xea65,0xea67,0xffff,0xed66,
0xbf5a,0xffff,0xea63,0xffff,0xbf58,0xffff,0xbf5c,0xbf5b,
0xea64,0xea68,0xffff,0xbf59,0xffff,0xed6d,0xc0f5,0xc27a,
0xc0f6,0xc0f3,0xed6a,0xed68,0xffff,0xed6b,0xffff,0xed6e,
0xc0f4,0xed6c,0xed67,0xffff,0xffff,0xf042,0xf045,0xf275,
0xf040,0xffff,0xf46f,0xf046,0xffff,0xc3a2,0xf044,0xc27b,
0xf041,0xf043,0xf047,0xf276,0xffff,0xf274,0xffff,0xffff,
0xffff,0xffff,0xc3a3,0xf273,0xffff,0xffff,0xffff,0xc46e,
0xffff,0xffff,0xffff,0xffff,0xc4ed,0xf6f1,0xc4ec,0xf6f3,
0xf6f0,0xf6f2,0xc5d0,0xf8b2,0xa5ca,0xcd6e,0xd2bc,0xd2bd,
0xb27d,0xdebf,0xbf5d,0xc3a4,0xc57b,0xf8b3,0xa5cb,0xffff,
0xcd6f,0xa260,0xffff,0xffff,0xcfd7,0xffff,0xcfd8,0xffff,
0xffff,0xffff,0xffff,0xffff,0xd2be,0xd2bf,0xb27e,0xb2a1,
0xffff,0xffff,0xffff,0xdaab,0xffff,0xdec2,0xdec1,0xdec0,
0xe2d5,0xffff,0xe2d6,0xe2d7,0xbac2,0xffff,0xffff,0xe6ad,
0xe6ac,0xffff,0xffff,0xea69,0xbf5e,0xbf5f,0xffff,0xed72,
0xed6f,0xed70,0xed71,0xf049,0xf048,0xc27c,0xf277,0xf5de,
0xa5cc,0xffff,0xacc6,0xffff,0xb2a2,0xdec3,0xffff,0xa5cd,
0xffff,0xd2c0,0xb2a3,0xffff,0xffff,0xb563,0xb564,0xffff,
0xa5ce,0xa5cf,0xca46,0xa86a,0xa869,0xacc7,0xcfd9,0xdaac,
0xa5d0,0xa5d1,0xa5d2,0xa5d3,0xffff,0xffff,0xffff,0xa86b,
0xa86c,0xcb6e,0xcb6d,0xffff,0xffff,0xaab6,0xcd72,0xcd70,
0xcd71,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xcfda,
0xcfdb,0xffff,0xffff,0xaccb,0xacc9,0xffff,0xacca,0xacc8,
0xffff,0xffff,0xffff,0xffff,0xaf60,0xffff,0xffff,0xffff,
0xffff,0xaf64,0xaf63,0xd2c1,0xaf62,0xaf61,0xffff,0xd2c2,
0xffff,0xffff,0xb2a6,0xd67b,0xd67a,0xb2a4,0xb2a5,0xffff,
0xffff,0xffff,0xb566,0xb565,0xdaae,0xffff,0xffff,0xdaad,
0xb2a7,0xffff,0xffff,0xffff,0xffff,0xffff,0xb7ed,0xdec5,
0xb7ee,0xdec4,0xffff,0xffff,0xffff,0xe2d8,0xe6ae,0xbd42,
0xea6a,0xffff,0xffff,0xffff,0xed73,0xffff,0xc3a6,0xc3a5,
0xffff,0xffff,0xc57c,0xa5d4,0xcd73,0xffff,0xffff,0xb2a8,
0xe2d9,0xbac3,0xffff,0xffff,0xcb6f,0xcb70,0xffff,0xffff,
0xcd74,0xaab8,0xaab9,0xffff,0xffff,0xaab7,0xffff,0xffff,
0xffff,0xffff,0xaccf,0xacd0,0xaccd,0xacce,0xffff,0xcfdc,
0xffff,0xffff,0xcfdd,0xaccc,0xffff,0xffff,0xffff,0xffff,
0xd2c3,0xffff,0xaf68,0xaf69,0xffff,0xb2ab,0xd2c9,0xffff,
0xaf6e,0xaf6c,0xd2ca,0xd2c5,0xaf6b,0xaf6a,0xaf65,0xd2c8,
0xd2c7,0xd2c4,0xaf6d,0xffff,0xd2c6,0xaf66,0xffff,0xaf67,
0xffff,0xffff,0xb2ac,0xd6a1,0xd6a2,0xb2ad,0xd67c,0xd67e,
0xd6a4,0xd6a3,0xd67d,0xffff,0xb2a9,0xb2aa,0xffff,0xdab6,
0xb56b,0xb56a,0xdab0,0xb568,0xffff,0xdab3,0xb56c,0xdab4,
0xb56d,0xdab1,0xb567,0xb569,0xdab5,0xffff,0xdab2,0xdaaf,
0xffff,0xffff,0xffff,0xffff,0xffff,0xded2,0xffff,0xdec7,
0xb7f0,0xb7f3,0xb7f2,0xb7f7,0xb7f6,0xded3,0xded1,0xdeca,
0xdece,0xdecd,0xb7f4,0xded0,0xdecc,0xded4,0xdecb,0xb7f5,
0xb7ef,0xb7f1,0xffff,0xdec9,0xffff,0xffff,0xffff,0xffff,
0xe2db,0xbac7,0xe2df,0xbac6,0xe2dc,0xbac5,0xffff,0xdec8,
0xdecf,0xe2de,0xffff,0xbac8,0xe2e0,0xe2dd,0xe2da,0xffff,
0xffff,0xe6b1,0xe6b5,0xe6b7,0xe6b3,0xe6b2,0xe6b0,0xbd45,
0xbd43,0xbd48,0xbd49,0xe6b4,0xbd46,0xe6af,0xbd47,0xbac4,
0xe6b6,0xbd44,0xffff,0xffff,0xffff,0xea6c,0xffff,0xea6b,
0xea73,0xea6d,0xea72,0xea6f,0xbf60,0xea71,0xffff,0xffff,
0xbf61,0xffff,0xbf62,0xffff,0xea70,0xea6e,0xffff,0xffff,
0xffff,0xffff,0xc0f8,0xed74,0xffff,0xffff,0xc0f7,0xed77,
0xed75,0xed76,0xffff,0xffff,0xc0f9,0xffff,0xffff,0xffff,
0xf04d,0xffff,0xc2a1,0xf04e,0xffff,0xffff,0xc27d,0xf04f,
0xc27e,0xf04c,0xf050,0xffff,0xf04a,0xffff,0xffff,0xc3a7,
0xf278,0xc3a8,0xc46f,0xffff,0xf04b,0xc470,0xffff,0xffff,
0xffff,0xc4ee,0xf5df,0xffff,0xc57e,0xf6f4,0xc57d,0xffff,
0xf7ea,0xc5f5,0xc5f6,0xffff,0xffff,0xf9cc,0xffff,0xffff,
0xacd1,0xcfde,0xffff,0xb56e,0xb56f,0xa5d5,0xa6ca,0xca47,
0xffff,0xcb71,0xa86d,0xffff,0xaaba,0xffff,0xacd2,0xacd3,
0xacd4,0xd6a6,0xd2cb,0xaf6f,0xffff,0xffff,0xb2ae,0xd6a5,
0xffff,0xffff,0xdab8,0xb571,0xffff,0xdab7,0xb570,0xffff,
0xffff,0xded5,0xbd4a,0xe6bb,0xe6b8,0xe6b9,0xe6ba,0xffff,
0xffff,0xffff,0xffff,0xffff,0xed78,0xffff,0xf051,0xffff,
0xffff,0xffff,0xf471,0xf470,0xffff,0xf6f5,0xa5d6,0xcd75,
0xaf70,0xffff,0xffff,0xffff,0xb572,0xded6,0xffff,0xffff,
0xe2e1,0xffff,0xbd4b,0xea74,0xffff,0xf052,0xf472,0xa5d7,
0xffff,0xffff,0xaabb,0xacd7,0xcfdf,0xacd8,0xacd6,0xffff,
0xacd5,0xd2cc,0xaf71,0xffff,0xffff,0xaf72,0xaf73,0xffff,
0xffff,0xffff,0xb2b0,0xd6a7,0xb2af,0xffff,0xffff,0xffff,
0xffff,0xffff,0xdab9,0xb2b1,0xb573,0xded7,0xb7f8,0xb7f9,
0xffff,0xbac9,0xffff,0xbaca,0xbd4c,0xbf64,0xea75,0xbf63,
0xffff,0xed79,0xc0fa,0xffff,0xf053,0xf473,0xa5d8,0xa86e,
0xcd78,0xcd77,0xaabc,0xcd76,0xaabd,0xcd79,0xffff,0xcfe5,
0xacdb,0xacda,0xcfe7,0xcfe6,0xacdf,0xffff,0xacde,0xffff,
0xffff,0xacd9,0xffff,0xcfe1,0xcfe2,0xcfe3,0xffff,0xace0,
0xcfe0,0xacdc,0xcfe4,0xacdd,0xffff,0xffff,0xffff,0xffff,
0xd2cf,0xd2d3,0xd2d1,0xd2d0,0xffff,0xd2d4,0xffff,0xffff,
0xffff,0xd2d5,0xd2d6,0xd2ce,0xffff,0xd2cd,0xffff,0xaf75,
0xaf76,0xffff,0xd2d7,0xd2d2,0xffff,0xd6b0,0xffff,0xd2d8,
0xaf77,0xaf74,0xffff,0xffff,0xffff,0xd6aa,0xffff,0xd6a9,
0xffff,0xd6ab,0xd6ac,0xd6ae,0xd6ad,0xd6b2,0xb2b5,0xb2b2,
0xb2b6,0xd6a8,0xb2b7,0xd6b1,0xb2b4,0xd6af,0xb2b3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xdabc,0xdabe,0xdaba,0xdabb,
0xffff,0xffff,0xdabf,0xdac1,0xdac2,0xdabd,0xdac0,0xb574,
0xffff,0xffff,0xdedb,0xffff,0xdee0,0xded8,0xdedc,0xffff,
0xffff,0xdee1,0xdedd,0xb7fa,0xb843,0xffff,0xb7fd,0xded9,
0xdeda,0xbace,0xb846,0xb7fe,0xffff,0xb844,0xb7fc,0xdedf,
0xb845,0xdede,0xb841,0xb7fb,0xb842,0xdee2,0xe2e6,0xe2e8,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xb840,0xffff,0xffff,0xe2e3,0xbacc,0xe2e9,0xbacd,
0xe2e7,0xe2e2,0xe2e5,0xe2ea,0xbacb,0xe2e4,0xffff,0xbd4e,
0xe6bf,0xe6be,0xffff,0xbd51,0xbd4f,0xe6bc,0xbd4d,0xe6bd,
0xffff,0xbd50,0xffff,0xffff,0xffff,0xea7d,0xffff,0xeaa1,
0xffff,0xea7e,0xea76,0xea7a,0xea79,0xea77,0xbf66,0xbf67,
0xbf65,0xea78,0xea7b,0xea7c,0xffff,0xbf68,0xffff,0xc140,
0xeda3,0xffff,0xc0fc,0xed7b,0xc0fe,0xc141,0xffff,0xffff,
0xc0fd,0xeda2,0xed7c,0xc0fb,0xeda1,0xed7a,0xed7e,0xed7d,
0xffff,0xffff,0xf055,0xc2a4,0xc2a5,0xc2a2,0xffff,0xc2a3,
0xffff,0xffff,0xf054,0xffff,0xf27b,0xffff,0xffff,0xc3a9,
0xffff,0xf279,0xf27a,0xffff,0xf474,0xf477,0xf475,0xf476,
0xf5e0,0xffff,0xffff,0xc4ef,0xf7eb,0xf8b4,0xffff,0xc5f7,
0xf8f8,0xf8f9,0xc666,0xa5d9,0xace1,0xffff,0xdac3,0xffff,
0xdee3,0xffff,0xa5da,0xa86f,0xffff,0xaabe,0xffff,0xcfe8,
0xcfe9,0xaf78,0xffff,0xffff,0xdac4,0xb575,0xb847,0xc142,
0xeda4,0xf27c,0xf478,0xa5db,0xffff,0xffff,0xffff,0xcda1,
0xcd7a,0xcd7c,0xcd7e,0xcd7d,0xcd7b,0xaabf,0xffff,0xffff,
0xffff,0xffff,0xace2,0xcff2,0xffff,0xcfed,0xcfea,0xffff,
0xffff,0xcff1,0xffff,0xffff,0xace4,0xace5,0xcff0,0xcfef,
0xcfee,0xcfeb,0xcfec,0xcff3,0xace3,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xaf7c,0xffff,0xafa4,
0xafa3,0xd2e1,0xd2db,0xd2d9,0xffff,0xafa1,0xd6b9,0xaf7a,
0xd2de,0xd2e2,0xd2e4,0xd2e0,0xd2da,0xafa2,0xd2df,0xd2dd,
0xaf79,0xd2e5,0xafa5,0xd2e3,0xaf7d,0xd2dc,0xffff,0xaf7e,
0xaf7b,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xb2b9,0xffff,0xd6ba,0xffff,0xffff,
0xd6b3,0xd6b5,0xd6b7,0xffff,0xd6b8,0xd6b6,0xb2ba,0xffff,
0xd6bb,0xffff,0xd6b4,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xdac8,0xb576,0xdad0,0xffff,
0xdac5,0xffff,0xdad1,0xffff,0xdac6,0xdac7,0xffff,0xffff,
0xdacf,0xdace,0xdacb,0xb2b8,0xb577,0xdac9,0xdacc,0xb578,
0xdacd,0xdaca,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xdeee,0xffff,0xdef2,0xb84e,0xffff,0xe2f0,0xb851,
0xdef0,0xf9d6,0xffff,0xdeed,0xdee8,0xdeea,0xdeeb,0xdee4,
0xffff,0xb84d,0xffff,0xffff,0xb84c,0xffff,0xb848,0xdee7,
0xffff,0xb84f,0xffff,0xb850,0xdee6,0xdee9,0xdef1,0xb84a,
0xb84b,0xdeef,0xdee5,0xffff,0xffff,0xffff,0xe2f2,0xbad0,
0xe2f4,0xdeec,0xe2f6,0xbad4,0xe2f7,0xe2f3,0xffff,0xbad1,
0xe2ef,0xbad3,0xe2ec,0xe2f1,0xe2f5,0xe2ee,0xffff,0xffff,
0xb849,0xffff,0xe2eb,0xbad2,0xe2ed,0xffff,0xffff,0xffff,
0xffff,0xffff,0xbd54,0xe6c1,0xbd58,0xffff,0xbd56,0xffff,
0xffff,0xbacf,0xffff,0xe6c8,0xe6c9,0xbd53,0xffff,0xffff,
0xe6c7,0xe6ca,0xbd55,0xbd52,0xe6c3,0xe6c0,0xe6c5,0xe6c2,
0xbd59,0xe6c4,0xffff,0xffff,0xe6c6,0xbd57,0xffff,0xffff,
0xffff,0xffff,0xbf6a,0xeaa8,0xffff,0xeaa2,0xeaa6,0xeaac,
0xeaad,0xeaa9,0xeaaa,0xeaa7,0xffff,0xeaa4,0xffff,0xbf6c,
0xbf69,0xeaa3,0xeaa5,0xffff,0xbf6b,0xeaab,0xffff,0xc146,
0xffff,0xffff,0xedaa,0xeda5,0xc145,0xffff,0xffff,0xc143,
0xffff,0xedac,0xc144,0xeda8,0xeda9,0xeda6,0xedad,0xf056,
0xffff,0xc147,0xeda7,0xffff,0xedae,0xedab,0xffff,0xffff,
0xffff,0xf05a,0xffff,0xffff,0xf057,0xffff,0xc2a6,0xffff,
0xf05b,0xf05d,0xf05c,0xf058,0xf059,0xffff,0xffff,0xf2a3,
0xffff,0xc3aa,0xffff,0xf27e,0xf2a2,0xf27d,0xf2a4,0xffff,
0xffff,0xf2a1,0xffff,0xf47a,0xf47d,0xf479,0xc471,0xf47b,
0xf47c,0xf47e,0xc472,0xc474,0xc473,0xf5e1,0xffff,0xf5e3,
0xffff,0xf5e2,0xffff,0xffff,0xffff,0xf6f6,0xffff,0xffff,
0xf8b5,0xf8fa,0xa5dc,0xffff,0xffff,0xcb72,0xaac0,0xcda3,
0xaac1,0xaac2,0xcda2,0xffff,0xcff8,0xcff7,0xace6,0xace9,
0xace8,0xace7,0xcff4,0xcff6,0xcff5,0xffff,0xffff,0xd2e8,
0xafa7,0xd2ec,0xd2eb,0xd2ea,0xd2e6,0xafa6,0xafaa,0xafad,
0xffff,0xffff,0xafae,0xd2e7,0xd2e9,0xafac,0xafab,0xafa9,
0xafa8,0xd6c2,0xffff,0xd6c0,0xd6bc,0xb2bb,0xffff,0xd6bd,
0xb2bc,0xd6be,0xd6bf,0xd6c1,0xffff,0xb2bd,0xffff,0xffff,
0xdad5,0xffff,0xdad4,0xdad3,0xdad2,0xffff,0xffff,0xffff,
0xffff,0xdef6,0xb852,0xffff,0xdef3,0xdef5,0xffff,0xb853,
0xffff,0xb854,0xdef4,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe341,0xffff,0xe2f9,0xe2fa,0xffff,0xbad7,0xbad5,0xbad6,
0xe343,0xffff,0xe342,0xe2fe,0xe2fd,0xe2fc,0xe2fb,0xe340,
0xe2f8,0xffff,0xe6cb,0xe6d0,0xe6ce,0xffff,0xffff,0xffff,
0xe6cd,0xe6cc,0xe6cf,0xffff,0xeaae,0xffff,0xbf6d,0xc148,
0xedb0,0xffff,0xc149,0xedaf,0xf05f,0xf05e,0xc2a7,0xffff,
0xf2a5,0xc3ab,0xf4a1,0xc5a1,0xf6f7,0xffff,0xf8b7,0xf8b6,
0xc9a8,0xacea,0xaceb,0xd6c3,0xffff,0xb856,0xa5dd,0xa872,
0xa871,0xa870,0xffff,0xffff,0xffff,0xcda4,0xffff,0xffff,
0xaac4,0xaac3,0xffff,0xacee,0xffff,0xcffa,0xcffd,0xcffb,
0xffff,0xacec,0xaced,0xffff,0xffff,0xcff9,0xcffc,0xffff,
0xafb5,0xffff,0xffff,0xffff,0xd2f3,0xd2f5,0xd2f4,0xafb2,
0xd2ef,0xffff,0xffff,0xafb0,0xafaf,0xffff,0xafb3,0xafb1,
0xffff,0xafb4,0xd2f2,0xd2ed,0xd2ee,0xd2f1,0xd2f0,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xd6c6,0xd6c7,
0xd6c5,0xffff,0xd6c4,0xb2be,0xffff,0xffff,0xffff,0xffff,
0xb57d,0xffff,0xdad6,0xdad8,0xdada,0xb57c,0xffff,0xffff,
0xb57a,0xffff,0xdad7,0xb57b,0xdad9,0xb579,0xffff,0xffff,
0xdf41,0xdef7,0xdefa,0xdefe,0xb85a,0xdefc,0xffff,0xdefb,
0xdef8,0xdef9,0xb858,0xdf40,0xb857,0xffff,0xb85c,0xb85b,
0xb859,0xffff,0xdefd,0xffff,0xffff,0xffff,0xe349,0xffff,
0xe348,0xffff,0xffff,0xe344,0xffff,0xffff,0xbad8,0xe347,
0xe346,0xbad9,0xffff,0xffff,0xffff,0xffff,0xffff,0xbd5e,
0xffff,0xe6d2,0xffff,0xbd5f,0xbd5b,0xbd5d,0xffff,0xbd5a,
0xbd5c,0xffff,0xffff,0xffff,0xeaaf,0xffff,0xbf70,0xeab1,
0xeab0,0xffff,0xe345,0xbf72,0xbf71,0xbf6e,0xbf6f,0xffff,
0xffff,0xffff,0xffff,0xffff,0xedb5,0xffff,0xedb3,0xc14a,
0xedb4,0xffff,0xedb6,0xedb2,0xedb1,0xffff,0xffff,0xf060,
0xc2aa,0xc2a8,0xc2a9,0xffff,0xffff,0xffff,0xffff,0xf2a6,
0xf2a7,0xc3ad,0xffff,0xc3ac,0xf4a3,0xf4a4,0xf4a2,0xffff,
0xf6f8,0xf6f9,0xffff,0xffff,0xa5de,0xca48,0xa873,0xffff,
0xcda5,0xaac6,0xaac5,0xcda6,0xffff,0xffff,0xd040,0xacef,
0xcffe,0xacf0,0xffff,0xffff,0xafb6,0xd2f8,0xd2f6,0xd2fc,
0xafb7,0xd2f7,0xd2fb,0xd2f9,0xd2fa,0xffff,0xffff,0xd6c8,
0xd6ca,0xffff,0xb2bf,0xffff,0xd6c9,0xb2c0,0xb5a2,0xb5a1,
0xb57e,0xdadb,0xffff,0xffff,0xffff,0xffff,0xdf44,0xb85d,
0xb85e,0xffff,0xdf43,0xdf42,0xffff,0xffff,0xffff,0xffff,
0xe34a,0xbadb,0xbada,0xe34b,0xe34c,0xffff,0xbd61,0xbd60,
0xffff,0xeab5,0xe6d3,0xe6d5,0xe6d4,0xeab4,0xeab2,0xeab6,
0xeab3,0xffff,0xbf73,0xffff,0xffff,0xffff,0xedb7,0xc14b,
0xedb8,0xedb9,0xffff,0xffff,0xc2ab,0xc2ac,0xffff,0xc475,
0xffff,0xffff,0xc5d1,0xa5df,0xffff,0xffff,0xffff,0xffff,
0xffff,0xd041,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd2fd,0xafb8,0xffff,0xffff,0xffff,0xffff,0xffff,0xb3ba,
0xb3b9,0xffff,0xffff,0xb5a4,0xdadd,0xb5a3,0xdadc,0xffff,
0xffff,0xffff,0xffff,0xdf45,0xffff,0xbadc,0xe34d,0xbadd,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xc476,0xf4a5,
0xffff,0xa6cb,0xaac7,0xcda7,0xffff,0xacf2,0xffff,0xacf1,
0xd042,0xd043,0xffff,0xffff,0xd340,0xd342,0xafb9,0xffff,
0xd344,0xd347,0xd345,0xffff,0xffff,0xffff,0xd346,0xd343,
0xd2fe,0xafba,0xd348,0xd341,0xffff,0xffff,0xffff,0xffff,
0xd6d3,0xb2c6,0xd6dc,0xb2c3,0xffff,0xd6d5,0xb2c7,0xffff,
0xb2c1,0xffff,0xd6d0,0xd6dd,0xd6d1,0xd6ce,0xb2c5,0xffff,
0xb2c2,0xffff,0xd6d4,0xd6d7,0xb2c4,0xd6d8,0xb2c8,0xd6d9,
0xd6cf,0xd6d6,0xd6da,0xd6d2,0xd6cd,0xd6cb,0xffff,0xffff,
0xd6db,0xffff,0xffff,0xdadf,0xffff,0xffff,0xffff,0xffff,
0xdae4,0xffff,0xffff,0xffff,0xdae0,0xdae6,0xb5a7,0xd6cc,
0xdae1,0xb5a5,0xdade,0xb5ac,0xdae2,0xb5ab,0xdae3,0xb5ad,
0xb5a8,0xb5ae,0xb5a9,0xffff,0xb5aa,0xffff,0xb5a6,0xffff,
0xdae5,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xb861,0xdf50,0xffff,0xdf53,0xdf47,0xdf4c,0xdf46,0xb863,
0xffff,0xdf4a,0xffff,0xffff,0xffff,0xdf48,0xb862,0xffff,
0xdf4f,0xdf4e,0xdf4b,0xdf4d,0xdf49,0xbae1,0xdf52,0xb85f,
0xdf51,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xe35d,0xffff,0xbae8,0xe358,0xffff,0xbae7,
0xe34e,0xffff,0xe350,0xbae0,0xe355,0xe354,0xe357,0xbae5,
0xe352,0xe351,0xffff,0xffff,0xbae4,0xbadf,0xe353,0xbae2,
0xe359,0xe35b,0xffff,0xe356,0xe34f,0xbae3,0xffff,0xffff,
0xbd69,0xbade,0xffff,0xffff,0xe35c,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe6d9,0xbd62,0xffff,0xe6db,
0xffff,0xbd63,0xffff,0xffff,0xbd65,0xe6de,0xffff,0xe6d6,
0xbae6,0xe6dc,0xffff,0xffff,0xffff,0xffff,0xe6d8,0xffff,
0xb860,0xbd68,0xffff,0xffff,0xbd64,0xffff,0xbd66,0xbd67,
0xffff,0xbf76,0xe6dd,0xe6d7,0xbd6a,0xffff,0xe6da,0xffff,
0xffff,0xffff,0xffff,0xffff,0xeac0,0xeabb,0xffff,0xffff,
0xeac5,0xbf74,0xeabd,0xbf78,0xeac3,0xeaba,0xeab7,0xeac6,
0xc151,0xbf79,0xeac2,0xeab8,0xbf77,0xeabc,0xbf7b,0xeab9,
0xeabe,0xbf7a,0xeac1,0xeac4,0xffff,0xffff,0xffff,0xffff,
0xedcb,0xedcc,0xedbc,0xedc3,0xedc1,0xffff,0xffff,0xc14f,
0xedc8,0xeabf,0xffff,0xedbf,0xffff,0xedc9,0xc14e,0xedbe,
0xedbd,0xedc7,0xedc4,0xedc6,0xffff,0xedba,0xedca,0xc14c,
0xffff,0xedc5,0xedce,0xedc2,0xc150,0xc14d,0xedc0,0xedbb,
0xedcd,0xbf75,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xf063,0xffff,0xffff,0xf061,0xf067,0xc2b0,0xf065,
0xf064,0xc2b2,0xf06a,0xc2b1,0xffff,0xf06b,0xf068,0xc2ae,
0xf069,0xf062,0xc2af,0xc2ad,0xf2ab,0xf066,0xffff,0xffff,
0xf06c,0xffff,0xffff,0xf2a8,0xffff,0xffff,0xffff,0xc3b2,
0xc3b0,0xf2aa,0xffff,0xf2ac,0xf2a9,0xc3b1,0xc3ae,0xc3af,
0xc3b3,0xffff,0xffff,0xc478,0xffff,0xf4aa,0xffff,0xf4a9,
0xf4a7,0xf4a6,0xf4a8,0xffff,0xc477,0xc479,0xffff,0xffff,
0xc4f0,0xffff,0xffff,0xf5e5,0xf5e4,0xffff,0xffff,0xf6fa,
0xffff,0xf6fc,0xf6fe,0xf6fd,0xf6fb,0xffff,0xffff,0xc5a3,
0xc5a2,0xffff,0xffff,0xc5d3,0xc5d2,0xc5d4,0xf7ed,0xf7ec,
0xffff,0xf8fb,0xf8b8,0xf8fc,0xc658,0xffff,0xc659,0xf96d,
0xffff,0xffff,0xc67e,0xa6cc,0xffff,0xcda8,0xffff,0xffff,
0xd045,0xd046,0xd044,0xffff,0xffff,0xacf3,0xffff,0xd047,
0xd048,0xd049,0xffff,0xffff,0xd349,0xd34f,0xffff,0xffff,
0xd34d,0xafbb,0xd34b,0xffff,0xd34c,0xd34e,0xffff,0xffff,
0xffff,0xd34a,0xb2c9,0xffff,0xd6de,0xb2cb,0xd6e0,0xb2ca,
0xd6df,0xffff,0xffff,0xffff,0xffff,0xffff,0xdae8,0xb5af,
0xffff,0xdaea,0xdae7,0xd6e1,0xffff,0xb5b0,0xffff,0xf9db,
0xdae9,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xdf56,
0xffff,0xb864,0xdf54,0xb865,0xdf55,0xb866,0xffff,0xffff,
0xffff,0xbae9,0xe361,0xe35e,0xe360,0xbaea,0xbaeb,0xe35f,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe6df,0xffff,0xffff,
0xe6e0,0xffff,0xbd6b,0xe6e2,0xe6e1,0xffff,0xa261,0xffff,
0xeaca,0xeacb,0xeac7,0xffff,0xeac8,0xbf7c,0xbf7d,0xeac9,
0xffff,0xc157,0xffff,0xffff,0xc153,0xc158,0xc154,0xc156,
0xc152,0xffff,0xc155,0xffff,0xffff,0xffff,0xffff,0xc2b3,
0xedcf,0xffff,0xf2ae,0xffff,0xf2ad,0xffff,0xf4ab,0xc47a,
0xc47b,0xf741,0xf5e6,0xffff,0xf740,0xffff,0xf8fd,0xf9a4,
0xa6cd,0xffff,0xffff,0xa874,0xffff,0xcda9,0xaac8,0xffff,
0xacf6,0xd04c,0xacf4,0xd04a,0xacf9,0xacf5,0xacfa,0xacf8,
0xd04b,0xacf7,0xafbf,0xafbe,0xd35a,0xafc7,0xd353,0xd359,
0xafc3,0xd352,0xd358,0xd356,0xafc2,0xafc4,0xd355,0xafbd,
0xd354,0xafc8,0xafc5,0xafc9,0xafc6,0xd351,0xd350,0xd357,
0xafc0,0xafbc,0xafc1,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd6f0,0xd6e9,0xffff,0xb5b5,0xd6e8,0xffff,0xb2cf,0xb2d6,
0xb2d3,0xb2d9,0xb2d8,0xb2d4,0xffff,0xd6e2,0xd6e5,0xffff,
0xd6e4,0xb2d0,0xd6e6,0xd6ef,0xb2d1,0xd6e3,0xd6ec,0xd6ed,
0xb2d2,0xd6ea,0xb2d7,0xb2cd,0xb2d5,0xd6e7,0xb2cc,0xd6eb,
0xffff,0xffff,0xd6ee,0xffff,0xffff,0xffff,0xdafb,0xdaf2,
0xb5b2,0xdaf9,0xdaf6,0xdaee,0xdaf7,0xb5b4,0xdaef,0xffff,
0xdaeb,0xffff,0xffff,0xb86c,0xdaf4,0xffff,0xb5b1,0xdafa,
0xffff,0xb5b8,0xb5ba,0xdaed,0xffff,0xffff,0xb5b9,0xdaf0,
0xb5b3,0xdaf8,0xdaf1,0xdaf5,0xffff,0xdaf3,0xb5b6,0xdaec,
0xb5bb,0xb2ce,0xb5b7,0xb5bc,0xffff,0xffff,0xffff,0xffff,
0xffff,0xb868,0xdf5d,0xdf5f,0xdf61,0xdf65,0xffff,0xdf5b,
0xdf59,0xb86a,0xffff,0xdf60,0xdf64,0xdf5c,0xdf58,0xffff,
0xdf57,0xffff,0xffff,0xffff,0xdf62,0xdf5a,0xdf5e,0xb86b,
0xffff,0xb869,0xdf66,0xb867,0xdf63,0xffff,0xe372,0xffff,
0xffff,0xffff,0xffff,0xffff,0xbaee,0xe36a,0xbd78,0xe374,
0xbaf1,0xe378,0xbaf7,0xe365,0xffff,0xffff,0xe375,0xe362,
0xffff,0xe377,0xe366,0xffff,0xbafe,0xbafb,0xe376,0xe370,
0xbaed,0xbaf5,0xbaf4,0xffff,0xbaf3,0xbaf9,0xffff,0xe363,
0xbafa,0xe371,0xbaf6,0xbaec,0xe373,0xbaef,0xbaf0,0xbaf8,
0xe368,0xe367,0xe364,0xffff,0xe36c,0xe369,0xe36d,0xbafd,
0xffff,0xe379,0xbaf2,0xe36e,0xe36f,0xffff,0xe36b,0xffff,
0xffff,0xffff,0xbafc,0xffff,0xffff,0xffff,0xffff,0xe6e7,
0xbd70,0xbd79,0xbd75,0xe6e4,0xffff,0xbd72,0xbd76,0xe6f0,
0xbd6c,0xe6e8,0xffff,0xbd74,0xffff,0xffff,0xe6eb,0xe6e6,
0xbd73,0xbd77,0xe6e5,0xffff,0xbd71,0xffff,0xe6ef,0xbd6e,
0xe6ee,0xe6ed,0xbd7a,0xe572,0xbd6d,0xffff,0xe6ec,0xe6e3,
0xffff,0xbd7b,0xe6ea,0xbd6f,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe6e9,0xffff,0xffff,0xffff,0xffff,
0xbfa2,0xbfa7,0xbf7e,0xead8,0xeacf,0xeadb,0xead3,0xead9,
0xbfa8,0xbfa1,0xeacc,0xead2,0xeadc,0xead5,0xeada,0xeace,
0xffff,0xffff,0xead6,0xbfa3,0xead4,0xbfa6,0xbfa5,0xead0,
0xead1,0xeacd,0xead7,0xbfa4,0xeade,0xeadd,0xffff,0xffff,
0xffff,0xedda,0xedd6,0xc15f,0xffff,0xedd0,0xc159,0xc169,
0xeddc,0xc161,0xc15d,0xedd3,0xc164,0xc167,0xedde,0xc15c,
0xedd5,0xc165,0xede0,0xeddd,0xedd1,0xc160,0xc15a,0xc168,
0xedd8,0xc163,0xedd2,0xc15e,0xeddf,0xc162,0xc15b,0xedd9,
0xc166,0xedd7,0xffff,0xffff,0xeddb,0xffff,0xffff,0xffff,
0xf06e,0xf074,0xc2b9,0xf077,0xc2b4,0xc2b5,0xf06f,0xf076,
0xf071,0xc2ba,0xc2b7,0xffff,0xf06d,0xffff,0xc2b6,0xf073,
0xf075,0xc2b8,0xf072,0xf070,0xffff,0xffff,0xffff,0xffff,
0xf2b8,0xc3b7,0xc3b8,0xc3b4,0xffff,0xc3b5,0xffff,0xf2b4,
0xf2b2,0xffff,0xf2b6,0xc3ba,0xf2b7,0xf2b0,0xf2af,0xf2b3,
0xf2b1,0xc3b6,0xf2b5,0xf4ac,0xc47e,0xc47d,0xf4ad,0xffff,
0xf4af,0xf4ae,0xc4a1,0xffff,0xffff,0xffff,0xf5eb,0xf5e8,
0xf5e9,0xffff,0xf5e7,0xf5ea,0xc4f2,0xf5ec,0xffff,0xc4f1,
0xffff,0xf742,0xffff,0xc5d5,0xc5d7,0xf7ee,0xc5d6,0xf8b9,
0xf940,0xf942,0xf8fe,0xf941,0xc66c,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa6ce,0xffff,
0xacfb,0xd26f,0xafca,0xffff,0xffff,0xb2da,0xdafc,0xdafd,
0xffff,0xffff,0xffff,0xeadf,0xc16a,0xede1,0xffff,0xffff,
0xc2bb,0xffff,0xf2ba,0xf2b9,0xc4a2,0xf5ed,0xffff,0xf743,
0xc5f8,0xca49,0xffff,0xffff,0xaac9,0xa875,0xffff,0xffff,
0xd04d,0xffff,0xffff,0xd360,0xd35b,0xd35f,0xd35d,0xafcb,
0xd35e,0xd35c,0xffff,0xd6f1,0xffff,0xdafe,0xdb40,0xdf69,
0xdf6a,0xb86e,0xb86f,0xdf68,0xdf6b,0xdf67,0xb86d,0xffff,
0xbb40,0xffff,0xb870,0xe37a,0xffff,0xbd7c,0xe6f1,0xbd7d,
0xffff,0xbfa9,0xeae2,0xeae0,0xeae1,0xede4,0xede3,0xede2,
0xffff,0xffff,0xffff,0xf2bb,0xffff,0xc3b9,0xf2bc,0xf744,
0xc5f9,0xf8ba,0xa6cf,0xaacb,0xaaca,0xd04f,0xacfc,0xffff,
0xffff,0xd04e,0xd362,0xffff,0xafcc,0xd6f2,0xd361,0xffff,
0xffff,0xffff,0xb2dc,0xd6f5,0xd6f3,0xd6f4,0xb2db,0xffff,
0xdb42,0xdb43,0xdb41,0xffff,0xb873,0xdf6d,0xdf6c,0xdf6e,
0xb872,0xb871,0xffff,0xffff,0xe6f2,0xe6f4,0xffff,0xbd7e,
0xe6f3,0xeae3,0xbfaa,0xf079,0xffff,0xf078,0xc3bb,0xf2bd,
0xc3bd,0xc3bc,0xf4b0,0xf5ee,0xc4f3,0xa6d0,0xd050,0xacfd,
0xd365,0xafce,0xd364,0xd363,0xffff,0xafcd,0xffff,0xd6fb,
0xffff,0xd6fd,0xd6f6,0xd6f7,0xb2dd,0xd6f8,0xb2de,0xd6fc,
0xd6f9,0xd6fa,0xb2df,0xffff,0xb5be,0xb5bf,0xffff,0xdb44,
0xffff,0xffff,0xffff,0xdf6f,0xdf70,0xffff,0xe37e,0xbb43,
0xbb41,0xbb42,0xe37b,0xe37c,0xffff,0xe37d,0xe6f9,0xffff,
0xe6fa,0xbda1,0xe6f7,0xe6f6,0xe6f8,0xe6f5,0xbfad,0xeae4,
0xbfab,0xbfac,0xede6,0xc16b,0xede5,0xefa8,0xffff,0xf07a,
0xf07b,0xc2bc,0xffff,0xc2bd,0xc16c,0xf2be,0xf2bf,0xf4b1,
0xc4a3,0xa6d1,0xffff,0xa6d2,0xacfe,0xaacc,0xafcf,0xd051,
0xffff,0xffff,0xffff,0xb5c0,0xa6d3,0xad41,0xd052,0xd053,
0xad40,0xad42,0xa6d4,0xffff,0xd054,0xafd1,0xd366,0xafd3,
0xafd0,0xafd2,0xffff,0xd741,0xb2e0,0xffff,0xd740,0xd6fe,
0xffff,0xdf71,0xffff,0xffff,0xe3a1,0xffff,0xbda2,0xffff,
0xbfae,0xeae6,0xeae5,0xffff,0xede7,0xffff,0xffff,0xffff,
0xf5ef,0xffff,0xffff,0xa6d5,0xcb73,0xcdaa,0xad43,0xd055,
0xffff,0xd368,0xffff,0xffff,0xffff,0xafd4,0xd367,0xafd5,
0xffff,0xffff,0xffff,0xd743,0xffff,0xffff,0xb2e2,0xd742,
0xd744,0xffff,0xb2e1,0xffff,0xffff,0xffff,0xffff,0xdb46,
0xdb47,0xdb45,0xb5c1,0xffff,0xffff,0xffff,0xb874,0xffff,
0xb875,0xffff,0xbb45,0xffff,0xe3a3,0xe3a2,0xbb44,0xffff,
0xffff,0xffff,0xffff,0xffff,0xe6fb,0xffff,0xffff,0xe6fc,
0xffff,0xffff,0xffff,0xffff,0xeae7,0xffff,0xffff,0xc170,
0xc16f,0xc16d,0xc16e,0xc171,0xffff,0xf07c,0xc2bf,0xc2be,
0xf2c0,0xf4b2,0xffff,0xffff,0xffff,0xc5a5,0xc5a4,0xa6d6,
0xffff,0xffff,0xd1fb,0xffff,0xb877,0xb5c2,0xb876,0xbb46,
0xffff,0xa6d7,0xc9a9,0xa6d8,0xa6d9,0xffff,0xffff,0xcdab,
0xcb76,0xffff,0xcb77,0xa877,0xffff,0xcb74,0xa876,0xffff,
0xa879,0xcb75,0xa87b,0xa87a,0xcb78,0xa878,0xffff,0xffff,
0xffff,0xaad1,0xaacf,0xcdad,0xffff,0xaace,0xffff,0xffff,
0xffff,0xaad3,0xaad5,0xaad2,0xffff,0xcdb0,0xcdac,0xaad6,
0xffff,0xaad0,0xa87c,0xffff,0xaad4,0xcdaf,0xffff,0xffff,
0xcdae,0xffff,0xaacd,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xd05b,0xad47,0xad48,0xd05d,0xffff,0xd057,
0xd05a,0xd063,0xd061,0xffff,0xad49,0xd067,0xad4c,0xd064,
0xd05c,0xd059,0xffff,0xffff,0xdb49,0xd062,0xad44,0xd065,
0xd056,0xd05f,0xad46,0xad4b,0xd060,0xad4f,0xad4d,0xffff,
0xd058,0xad4a,0xffff,0xd05e,0xad4e,0xad45,0xd066,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xafda,0xffff,0xafe3,
0xafd8,0xafd6,0xd36a,0xafde,0xafdb,0xd36c,0xffff,0xffff,
0xafdd,0xd36b,0xd369,0xd36e,0xafe2,0xafe0,0xdb48,0xffff,
0xd36f,0xd36d,0xafd7,0xffff,0xffff,0xafd9,0xafdc,0xffff,
0xafdf,0xffff,0xafe1,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xd74e,0xb2e4,0xffff,
0xd745,0xd747,0xffff,0xd748,0xffff,0xd750,0xd74c,0xd74a,
0xffff,0xd74d,0xd751,0xb2e5,0xb2e9,0xd746,0xffff,0xd74f,
0xffff,0xb2e7,0xffff,0xb2e6,0xd74b,0xd749,0xffff,0xb2e3,
0xb2e8,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xb5c8,0xdb51,0xffff,0xffff,0xdb4f,0xb5ca,0xffff,
0xffff,0xffff,0xffff,0xdb4a,0xdfa1,0xffff,0xb5c9,0xdb4e,
0xffff,0xffff,0xdb4b,0xb5c5,0xb5cb,0xdb50,0xb5c7,0xdb4d,
0xbb47,0xb5c6,0xdb4c,0xb5cc,0xb5c4,0xb5c3,0xffff,0xffff,
0xffff,0xffff,0xffff,0xdf77,0xdf75,0xffff,0xdf7b,0xffff,
0xdf73,0xdfa2,0xdf78,0xffff,0xdf72,0xb87b,0xb8a3,0xdf7d,
0xffff,0xdf76,0xffff,0xb87e,0xffff,0xffff,0xb87c,0xdf7e,
0xb879,0xb878,0xdf79,0xb87d,0xb5cd,0xffff,0xdf7c,0xdf74,
0xb87a,0xb8a1,0xb8a2,0xffff,0xffff,0xffff,0xffff,0xbb4c,
0xbb48,0xffff,0xbb4d,0xe3a6,0xffff,0xffff,0xe3a5,0xe3a7,
0xbb4a,0xe3a4,0xbb4b,0xe3aa,0xe3a9,0xe3a8,0xffff,0xbb49,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe741,0xffff,0xe744,
0xbda8,0xe743,0xbda7,0xbda3,0xbda4,0xbda5,0xe740,0xe6fe,
0xbda6,0xffff,0xe742,0xe6fd,0xffff,0xffff,0xeae9,0xeaf3,
0xbfb1,0xbfb0,0xffff,0xeaed,0xeaef,0xffff,0xeaea,0xffff,
0xeaee,0xeae8,0xeaf1,0xbfaf,0xeaf0,0xeaec,0xffff,0xeaf2,
0xffff,0xeaeb,0xc174,0xede8,0xedee,0xc178,0xc17a,0xc177,
0xc176,0xffff,0xc175,0xc173,0xede9,0xedec,0xc172,0xeded,
0xffff,0xc179,0xedeb,0xffff,0xedea,0xc2c0,0xffff,0xc2c1,
0xf0a1,0xf07d,0xf07e,0xffff,0xffff,0xf2c2,0xffff,0xf2c1,
0xc3be,0xf4b4,0xc4a4,0xf4b3,0xffff,0xf5f0,0xf745,0xc5a6,
0xf943,0xf944,0xc5d8,0xa6da,0xffff,0xaad7,0xdb52,0xbb4e,
0xc17b,0xedef,0xa6db,0xffff,0xafe5,0xafe4,0xdb53,0xffff,
0xffff,0xffff,0xeaf4,0xa6dc,0xad50,0xffff,0xffff,0xdb54,
0xdb55,0xdb56,0xbb4f,0xbfb2,0xa6dd,0xffff,0xaad8,0xd068,
0xafe6,0xd370,0xb2ea,0xffff,0xdb57,0xb8a4,0xffff,0xbb50,
0xbfb3,0xc17c,0xc2c2,0xf4b5,0xa6de,0xaad9,0xffff,0xffff,
0xafe7,0xd752,0xb5ce,0xffff,0xbb51,0xe3ab,0xe745,0xffff,
0xffff,0xffff,0xffff,0xa6df,0xb5cf,0xdfa3,0xbb52,0xa6e0,
0xcdb1,0xd069,0xad51,0xffff,0xffff,0xd372,0xffff,0xffff,
0xafea,0xffff,0xafe8,0xafe9,0xafeb,0xffff,0xffff,0xd371,
0xffff,0xffff,0xd757,0xd754,0xd756,0xb2eb,0xb2ed,0xb2ec,
0xd753,0xb2ee,0xd755,0xffff,0xdb58,0xdb59,0xffff,0xdb5a,
0xdfa6,0xffff,0xdfa7,0xffff,0xdfa5,0xdfa8,0xffff,0xb8a5,
0xffff,0xdfa4,0xffff,0xbb53,0xffff,0xffff,0xe74a,0xe746,
0xe749,0xe74b,0xe748,0xe747,0xffff,0xeaf5,0xeaf6,0xeaf7,
0xbfb4,0xbfb5,0xedf1,0xedf0,0xedf2,0xffff,0xf0a3,0xf0a2,
0xffff,0xf2c4,0xffff,0xf2c5,0xf2c3,0xffff,0xc4a5,0xffff,
0xf4b6,0xf4b7,0xffff,0xf746,0xf7ef,0xf8bb,0xa6e1,0xa87d,
0xffff,0xc17d,0xa6e2,0xffff,0xd758,0xdb5b,0xffff,0xc641,
0xca4a,0xffff,0xffff,0xffff,0xca4b,0xca4d,0xa6e3,0xca4e,
0xca4c,0xffff,0xffff,0xcba2,0xcba3,0xcb7b,0xffff,0xffff,
0xffff,0xffff,0xcba1,0xa8a1,0xffff,0xa8a2,0xcb7c,0xcb7a,
0xcb79,0xcb7d,0xa87e,0xcb7e,0xd06a,0xffff,0xffff,0xffff,
0xcdb6,0xaadc,0xcdb5,0xcdb7,0xffff,0xaadb,0xcdbc,0xaadf,
0xcdb2,0xcdc0,0xcdc6,0xaae6,0xcdc3,0xaae3,0xffff,0xcdb9,
0xcdbf,0xcdc1,0xffff,0xcdb4,0xaae2,0xaadd,0xcdba,0xaae4,
0xaae7,0xaae1,0xffff,0xaada,0xcdbe,0xcdb8,0xcdc5,0xaae9,
0xaae5,0xaae0,0xcdbd,0xafec,0xcdbb,0xaade,0xaae8,0xffff,
0xcdb3,0xffff,0xcdc2,0xcdc4,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xad62,0xad5c,0xad64,0xad61,0xd071,0xd074,0xad5d,
0xffff,0xd06b,0xffff,0xad56,0xad60,0xffff,0xad63,0xad65,
0xd0a2,0xd077,0xffff,0xad55,0xd0a1,0xad59,0xad57,0xad52,
0xd06f,0xffff,0xd07e,0xd073,0xd076,0xd0a5,0xffff,0xad66,
0xd07d,0xad5e,0xd078,0xd0a4,0xd075,0xd079,0xd07c,0xffff,
0xffff,0xd06d,0xd0a3,0xd07b,0xffff,0xffff,0xd06c,0xffff,
0xd070,0xad5f,0xad5a,0xad53,0xad58,0xad54,0xad67,0xd06e,
0xd3a5,0xad5b,0xffff,0xffff,0xd07a,0xce41,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xd3a8,0xaffa,
0xffff,0xd376,0xffff,0xd3a3,0xd37d,0xffff,0xd3b2,0xffff,
0xd3aa,0xffff,0xd37e,0xffff,0xd3a9,0xd378,0xd37c,0xd3b5,
0xaffd,0xd3ad,0xd3a4,0xafed,0xd3b3,0xd374,0xffff,0xd3ac,
0xffff,0xaffc,0xaff7,0xd373,0xaff5,0xaff4,0xaff9,0xd3ab,
0xaff1,0xaff8,0xd072,0xdb5c,0xd3a6,0xffff,0xffff,0xd37a,
0xaffb,0xd37b,0xd3a1,0xaffe,0xd375,0xd3af,0xffff,0xd3ae,
0xd3b6,0xaff3,0xaff0,0xd3b4,0xd3b0,0xd3a7,0xd3a2,0xaff6,
0xaff2,0xd377,0xafee,0xd3b1,0xafef,0xffff,0xd379,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xd75e,0xd760,0xd765,0xd779,0xb2fc,
0xb2f2,0xffff,0xd75d,0xb2fd,0xb2fe,0xd768,0xd76f,0xd775,
0xffff,0xd762,0xffff,0xd769,0xffff,0xffff,0xb340,0xd777,
0xd772,0xb2fa,0xb2f8,0xd76e,0xd76a,0xd75c,0xb2ef,0xd761,
0xd759,0xffff,0xb2f7,0xb2f9,0xd766,0xd763,0xb2f4,0xd773,
0xb2f1,0xd764,0xd77a,0xd76c,0xffff,0xd76b,0xb2f0,0xffff,
0xb2fb,0xffff,0xb2f3,0xd75a,0xd75f,0xd770,0xd776,0xb341,
0xd75b,0xd767,0xd76d,0xb2f6,0xffff,0xffff,0xd778,0xd771,
0xd774,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xb2f5,0xffff,0xdb6c,
0xdb60,0xb5d7,0xdb7d,0xdba7,0xdbaa,0xb5d5,0xdb68,0xdba3,
0xdb69,0xdb77,0xb5e2,0xdb73,0xb5df,0xffff,0xdb74,0xdb5d,
0xffff,0xdba4,0xffff,0xffff,0xb5e8,0xdba1,0xdb75,0xdbac,
0xdb70,0xdfc8,0xffff,0xdbaf,0xb5e6,0xdb6e,0xdb7a,0xb5e9,
0xb5d4,0xdb72,0xdbad,0xdb6b,0xdb64,0xdb6f,0xffff,0xdb63,
0xdb61,0xb5d0,0xdba5,0xdb6a,0xdba8,0xffff,0xdba9,0xb5d8,
0xb5dd,0xb5d9,0xb5e1,0xdb7e,0xb5da,0xdb76,0xdb66,0xffff,
0xb5d2,0xdb5e,0xdba2,0xdbab,0xdb65,0xb5e0,0xdbb0,0xdb71,
0xffff,0xdb6d,0xffff,0xb5d1,0xb5e5,0xffff,0xdb7c,0xb5e7,
0xffff,0xdb78,0xb5dc,0xb5d6,0xb5de,0xb5d3,0xb5e4,0xdb79,
0xdb67,0xdb7b,0xdb62,0xdba6,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xdbae,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xdb5f,0xffff,0xffff,0xffff,0xffff,
0xffff,0xdfc7,0xffff,0xdfdd,0xb855,0xdfcc,0xffff,0xdfca,
0xdfb5,0xb8a9,0xdfc5,0xdfd9,0xdfc1,0xb8b1,0xdfd8,0xdfbf,
0xb5e3,0xdfcf,0xdfc0,0xdfd6,0xb8b0,0xb8a8,0xffff,0xdfaa,
0xdfb2,0xffff,0xdfcb,0xdfc3,0xdfdc,0xdfc6,0xb8b6,0xdfd7,
0xffff,0xb8ad,0xffff,0xdfc9,0xdfd1,0xdfb6,0xdfd0,0xffff,
0xdfe1,0xdfb1,0xdfd2,0xffff,0xdfdf,0xffff,0xdfab,0xb5db,
0xffff,0xdfb9,0xdfb8,0xb8af,0xffff,0xdfbc,0xdfbe,0xdfcd,
0xdfde,0xb8b2,0xffff,0xb8b3,0xffff,0xdfb0,0xb8ab,0xdfb4,
0xdfda,0xb8b4,0xffff,0xb8ac,0xb8ae,0xb8b5,0xdfe0,0xdfd3,
0xdfce,0xffff,0xffff,0xdfbb,0xdfba,0xb8aa,0xdfac,0xb8a7,
0xdfc4,0xdfad,0xdfc2,0xffff,0xffff,0xdfb7,0xdfdb,0xffff,
0xffff,0xffff,0xb8a6,0xffff,0xffff,0xffff,0xdfb3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xdfaf,0xdfd5,0xdfae,
0xbb60,0xe3d3,0xffff,0xffff,0xe3c2,0xffff,0xffff,0xe3ac,
0xe3ca,0xbb58,0xe3bb,0xe3c5,0xbb5b,0xe3be,0xbb59,0xe3af,
0xe3cd,0xe3ae,0xe3c1,0xffff,0xe3ad,0xffff,0xffff,0xe3bf,
0xe3c8,0xe3c6,0xe3ba,0xe3b5,0xe3b3,0xffff,0xe3b4,0xe3c7,
0xe3d2,0xe3bc,0xbb5a,0xffff,0xe3b7,0xffff,0xe3cb,0xffff,
0xbb5d,0xe3b6,0xe3b0,0xe3c0,0xbb61,0xffff,0xffff,0xbb55,
0xbb5e,0xe3b8,0xe3b2,0xffff,0xbb57,0xdfd4,0xbb56,0xe3c3,
0xffff,0xbb54,0xbb63,0xbb5c,0xe3c4,0xe3b9,0xe3b1,0xe3cc,
0xe3bd,0xbb62,0xe3d0,0xbb5f,0xe3cf,0xffff,0xe3c9,0xe3ce,
0xffff,0xffff,0xffff,0xe3d1,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xe773,
0xe774,0xe767,0xe766,0xe762,0xbdb4,0xffff,0xbdac,0xe776,
0xe775,0xdfa9,0xe75f,0xe763,0xe75d,0xffff,0xe770,0xe761,
0xffff,0xe777,0xe75a,0xe758,0xe764,0xe76e,0xe769,0xbdb6,
0xe74f,0xffff,0xe76d,0xffff,0xffff,0xffff,0xbdb7,0xdfbd,
0xe75b,0xe752,0xe755,0xe77b,0xe75c,0xe753,0xe751,0xe74e,
0xffff,0xbdb0,0xe765,0xbdaf,0xbdb3,0xe760,0xe768,0xbda9,
0xe778,0xe77c,0xbdab,0xffff,0xe757,0xe76b,0xe76f,0xe754,
0xe779,0xbdb2,0xffff,0xbdb1,0xe74c,0xbdb5,0xe772,0xe756,
0xe76a,0xe750,0xe75e,0xe759,0xbdad,0xbdae,0xe76c,0xe77d,
0xe77a,0xe771,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xe74d,0xffff,0xbdaa,0xeb49,0xffff,
0xeb40,0xeb43,0xffff,0xbfbb,0xeb45,0xeaf9,0xeb41,0xeb47,
0xbfb8,0xbfbc,0xbfb6,0xffff,0xffff,0xeafb,0xeb4c,0xffff,
0xffff,0xeb46,0xffff,0xeafc,0xeb55,0xeb4f,0xeaf8,0xee46,
0xeafe,0xbfb7,0xffff,0xeb4a,0xffff,0xeb54,0xbfbf,0xffff,
0xeb51,0xeafd,0xeb44,0xeb48,0xeb42,0xeb56,0xeb53,0xeb50,
0xbfb9,0xbfba,0xbfbe,0xeafa,0xeb57,0xbfbd,0xeb4d,0xffff,
0xffff,0xeb4b,0xffff,0xffff,0xffff,0xeb4e,0xee53,0xee40,
0xee45,0xee52,0xee44,0xedfb,0xee41,0xffff,0xc1a2,0xffff,
0xedf4,0xee4d,0xee4f,0xedf3,0xc1a1,0xee51,0xee49,0xc1a8,
0xee50,0xee42,0xc1aa,0xedf9,0xeb52,0xee4a,0xee47,0xedf5,
0xee55,0xc1a4,0xffff,0xffff,0xc1a5,0xedf7,0xee48,0xffff,
0xee54,0xee4b,0xedfd,0xc1a7,0xc1a3,0xee4c,0xedfe,0xee56,
0xedf8,0xee43,0xee4e,0xedfa,0xedfc,0xffff,0xc2cb,0xedf6,
0xc1a9,0xc2c4,0xc17e,0xffff,0xffff,0xffff,0xffff,0xc1a6,
0xc2c8,0xf0b3,0xffff,0xf0a9,0xf0a4,0xf0aa,0xf0b4,0xf0b8,
0xf0b7,0xc2ca,0xc2c9,0xffff,0xffff,0xf0ab,0xf0b9,0xf0ae,
0xf0a6,0xffff,0xf0a8,0xf0a7,0xf0ad,0xf0b2,0xf0a5,0xf0ac,
0xf0b1,0xc2c7,0xffff,0xf0af,0xffff,0xc2c5,0xf0b0,0xc2c3,
0xc2c6,0xf2d5,0xf0b5,0xffff,0xffff,0xc3c2,0xffff,0xf2cd,
0xf2d1,0xf2c9,0xf2cc,0xffff,0xf2d4,0xc3c0,0xf2d9,0xf2d2,
0xffff,0xf2ca,0xf2da,0xf2d3,0xc3c3,0xc3c4,0xf2d7,0xffff,
0xf2cb,0xc3bf,0xc3c1,0xf2c6,0xf2ce,0xf2c8,0xffff,0xf2d8,
0xf2d6,0xf2c7,0xf2cf,0xffff,0xffff,0xffff,0xf4be,0xc3c5,
0xf2d0,0xc4a7,0xc4a9,0xc4a6,0xffff,0xf4c3,0xf4bb,0xf4b9,
0xf4bd,0xf4ba,0xffff,0xffff,0xf4bf,0xf4c1,0xc4aa,0xc4ac,
0xffff,0xf4c0,0xc4ad,0xc4ab,0xf4c2,0xffff,0xffff,0xffff,
0xffff,0xc4a8,0xffff,0xffff,0xffff,0xffff,0xffff,0xc4f4,
0xf5f1,0xf5f7,0xc4f6,0xf4bc,0xf5f6,0xffff,0xf5fd,0xf5f4,
0xf5fb,0xf5fa,0xf4b8,0xf5f5,0xf0b6,0xf5fe,0xf5f3,0xf5f8,
0xffff,0xf5fc,0xf5f2,0xffff,0xf74a,0xc4f5,0xf5f9,0xffff,
0xffff,0xf7f4,0xf74b,0xf749,0xf747,0xf748,0xf74c,0xffff,
0xc5d9,0xf7f2,0xf7f0,0xf7f5,0xf7f3,0xffff,0xf7f6,0xc5da,
0xf7f1,0xffff,0xffff,0xf8bc,0xffff,0xffff,0xf945,0xf946,
0xf947,0xffff,0xffff,0xf9c7,0xf9bd,0xca4f,0xaaea,0xffff,
0xad68,0xffff,0xd3b8,0xd3b7,0xb040,0xb342,0xd77c,0xffff,
0xffff,0xd77b,0xffff,0xb5ea,0xb8b8,0xffff,0xb8b7,0xb8b9,
0xffff,0xe3d4,0xe77e,0xeb58,0xeb5a,0xeb59,0xffff,0xc1ab,
0xee57,0xf0ba,0xf9a5,0xa6e4,0xffff,0xcdc9,0xcdca,0xcdc8,
0xcdc7,0xaaeb,0xffff,0xd0a9,0xd0a7,0xffff,0xffff,0xd0a6,
0xffff,0xad69,0xad6b,0xad6a,0xd0a8,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xd3c4,0xd3c1,0xd3bf,
0xffff,0xffff,0xb041,0xd3c2,0xb046,0xd3bc,0xd3cb,0xffff,
0xd3cd,0xd3bd,0xffff,0xb043,0xd3ce,0xd3c9,0xd3bb,0xd3c0,
0xd3ca,0xd3c6,0xd3c3,0xffff,0xb048,0xd3cc,0xd3be,0xffff,
0xffff,0xd3c7,0xd3b9,0xb047,0xb044,0xd3c5,0xffff,0xd3c8,
0xd3ba,0xb045,0xb042,0xffff,0xffff,0xffff,0xffff,0xb34c,
0xd7a5,0xb34b,0xffff,0xd7a8,0xd7ab,0xb348,0xb346,0xd77e,
0xd7a9,0xd7a7,0xd7a4,0xd7ac,0xd7ad,0xd7af,0xd7b0,0xd77d,
0xb345,0xd7a2,0xd7a1,0xd7ae,0xb347,0xd7a3,0xb349,0xb344,
0xd7a6,0xb34d,0xffff,0xb34a,0xd7aa,0xffff,0xffff,0xffff,
0xb5f1,0xdbbf,0xffff,0xdbb4,0xb5ee,0xffff,0xdfe7,0xdbbd,
0xdbb1,0xb5ec,0xdbb6,0xb5ef,0xdbba,0xdbb8,0xb5f2,0xb5eb,
0xffff,0xffff,0xdbb2,0xdbb5,0xb5f0,0xffff,0xdbb3,0xffff,
0xdbbe,0xdbbc,0xdbb7,0xdbb9,0xdbbb,0xb5ed,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xdfe8,0xdfee,0xdfe4,
0xdfea,0xb8ba,0xdfe6,0xb8c0,0xffff,0xffff,0xb8bf,0xffff,
0xb8be,0xdfed,0xb8c1,0xb8c2,0xdfe3,0xdff0,0xb8c3,0xb8bd,
0xb8bc,0xdfec,0xb8c4,0xdfe2,0xdfe5,0xdfef,0xdfeb,0xffff,
0xffff,0xe3f4,0xe3e9,0xb8bb,0xffff,0xffff,0xffff,0xffff,
0xbb6a,0xe3dd,0xe3f2,0xe3de,0xbb65,0xffff,0xe3db,0xffff,
0xe3e4,0xe3dc,0xbb67,0xe3d6,0xe3f1,0xbb68,0xe3ee,0xe3ef,
0xe3d7,0xbb6d,0xe3e6,0xffff,0xe3e0,0xe3e7,0xe3da,0xffff,
0xe3f3,0xe3eb,0xe3e5,0xe3d5,0xbb69,0xe3ec,0xffff,0xbb6c,
0xe3f0,0xffff,0xe3ea,0xbb66,0xe3e8,0xffff,0xe3e2,0xbb64,
0xe3d9,0xe3e1,0xe3ed,0xe3df,0xffff,0xffff,0xe3e3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xbdc1,0xdfe9,0xe7b2,0xe7bb,
0xe7b1,0xe7ad,0xe7aa,0xbdc2,0xe7a8,0xbb6b,0xe7a1,0xbdc0,
0xe7a7,0xbdbf,0xe7ac,0xe7a9,0xe7b9,0xe7b4,0xe7ae,0xe7b3,
0xbdbb,0xe7ab,0xe7be,0xe7a2,0xe7a3,0xe7ba,0xbdbc,0xe7bf,
0xbdbe,0xe7c0,0xe7b0,0xe3d8,0xe7b6,0xe7af,0xe7b8,0xe7b5,
0xffff,0xffff,0xffff,0xe7a6,0xbdb9,0xe7bd,0xbdba,0xe7a4,
0xbdbd,0xeb64,0xe7b7,0xe7bc,0xffff,0xffff,0xffff,0xffff,
0xffff,0xeb61,0xbdb8,0xbfc0,0xeb6b,0xeb67,0xffff,0xeb65,
0xeb60,0xeb6f,0xffff,0xffff,0xffff,0xbfc4,0xffff,0xeb5c,
0xeb68,0xeb69,0xeb5f,0xeb5e,0xeb6c,0xffff,0xeb62,0xeb5d,
0xeb63,0xffff,0xeb6e,0xeb5b,0xeb6d,0xeb6a,0xbfc2,0xbfc1,
0xffff,0xffff,0xbfc3,0xeb66,0xf0cb,0xffff,0xffff,0xffff,
0xffff,0xffff,0xee59,0xc1b1,0xee5d,0xee5a,0xee61,0xee67,
0xee5c,0xffff,0xee70,0xc1ae,0xee6a,0xee5f,0xee6b,0xee66,
0xee6d,0xee5e,0xc1b3,0xc1b2,0xee60,0xee6e,0xee58,0xee6c,
0xc1ac,0xffff,0xee64,0xee63,0xee68,0xee5b,0xc1b0,0xffff,
0xc1b4,0xee62,0xee69,0xc1b5,0xee65,0xffff,0xffff,0xffff,
0xffff,0xc1ad,0xc1af,0xf0c7,0xf0c5,0xffff,0xffff,0xf0cc,
0xf0c9,0xf0cd,0xffff,0xf0be,0xf0c6,0xf0d1,0xee6f,0xf0c2,
0xc2cf,0xe7a5,0xf0bd,0xf0ca,0xf0c4,0xf0c1,0xf0bc,0xf0bb,
0xf0d0,0xffff,0xf0c0,0xf0bf,0xc2cd,0xf0c8,0xffff,0xc2cc,
0xffff,0xffff,0xc2ce,0xf0c3,0xf0cf,0xffff,0xf2de,0xf2df,
0xffff,0xc3c9,0xf2dc,0xc3c6,0xf2e4,0xffff,0xc3ca,0xf2e6,
0xf2db,0xf0ce,0xf2e8,0xf2dd,0xffff,0xc3c7,0xf2e3,0xffff,
0xf2e5,0xf2e0,0xf2e7,0xf2e2,0xf2e1,0xc3c8,0xffff,0xffff,
0xf4c5,0xf4c6,0xffff,0xf4c8,0xc4ae,0xc4af,0xf4c9,0xf4c7,
0xffff,0xf4c4,0xffff,0xf642,0xf645,0xf641,0xffff,0xc4fa,
0xf643,0xc4f9,0xc4f8,0xc4f7,0xf644,0xf751,0xf74f,0xffff,
0xf74e,0xf640,0xf750,0xf646,0xf74d,0xffff,0xf7f9,0xf7d7,
0xf7f7,0xc5db,0xf7f8,0xf7fa,0xffff,0xf8bf,0xc5fa,0xf8be,
0xf8bd,0xc5fb,0xffff,0xc65a,0xf96e,0xf9a7,0xf9a6,0xf9a8,
0xa6e5,0xd0aa,0xffff,0xd3cf,0xd3d0,0xffff,0xffff,0xffff,
0xdbc0,0xffff,0xf647,0xf8c0,0xa6e6,0xad6c,0xd0ab,0xffff,
0xffff,0xffff,0xd7b1,0xb34e,0xffff,0xdbc2,0xdbc1,0xb5f3,
0xffff,0xb8c5,0xe7c1,0xbdc3,0xffff,0xbdc4,0xffff,0xffff,
0xffff,0xbfc5,0xc5fc,0xa6e7,0xffff,0xffff,0xffff,0xd0ac,
0xaaed,0xd0ae,0xd0ad,0xad6d,0xffff,0xd3d1,0xffff,0xd3d8,
0xb049,0xd3d6,0xd3d4,0xffff,0xd3db,0xd3d2,0xd3d3,0xb04a,
0xffff,0xb04e,0xffff,0xffff,0xd3dc,0xb04d,0xd3da,0xd3d7,
0xd3d5,0xb04b,0xb04c,0xd3d9,0xffff,0xffff,0xffff,0xffff,
0xb350,0xd7b2,0xffff,0xb355,0xd7c2,0xb354,0xd7c4,0xffff,
0xffff,0xd7b8,0xb352,0xd7c3,0xffff,0xd7b3,0xb353,0xd7bf,
0xd7bb,0xd7bd,0xd7b7,0xd7be,0xffff,0xffff,0xb34f,0xd7ba,
0xffff,0xd7b9,0xd7b5,0xffff,0xd7c0,0xffff,0xffff,0xd7bc,
0xd7b4,0xffff,0xd7b6,0xb351,0xd7c1,0xffff,0xffff,0xffff,
0xffff,0xb5f6,0xdbcd,0xffff,0xffff,0xffff,0xdbc9,0xdbcb,
0xdbc6,0xdbc5,0xdbc3,0xffff,0xdbca,0xdbcc,0xdbc8,0xffff,
0xdbc7,0xb5f4,0xb5f5,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xdbcf,0xb8cd,0xdff2,0xdff8,0xdff3,0xdff4,0xf9d8,
0xdff9,0xffff,0xb8cf,0xffff,0xb8c7,0xb8ce,0xdff1,0xdbc4,
0xb8ca,0xb8c8,0xdff7,0xdff6,0xb8c9,0xb8cb,0xdff5,0xb8c6,
0xffff,0xb8cc,0xffff,0xffff,0xffff,0xffff,0xffff,0xe3f6,
0xbb74,0xffff,0xffff,0xe442,0xe441,0xffff,0xe3fb,0xbb76,
0xe440,0xe3f7,0xe3f8,0xbb6e,0xbb70,0xffff,0xe3fd,0xe3f5,
0xbb72,0xbb71,0xe3f9,0xe3fe,0xe3fc,0xbb73,0xe3fa,0xffff,
0xffff,0xdbce,0xbb6f,0xffff,0xffff,0xe7c2,0xe7c9,0xbdc6,
0xffff,0xe7cd,0xbdca,0xe7c5,0xe7c3,0xffff,0xe7cc,0xffff,
0xbdc5,0xe7cb,0xbdc7,0xbdc8,0xe7c4,0xbdc9,0xe7ca,0xe7c6,
0xe7c7,0xe7c8,0xbb75,0xffff,0xffff,0xffff,0xeb70,0xeb7c,
0xffff,0xbfca,0xeb77,0xeb79,0xffff,0xbfc8,0xeb71,0xeb75,
0xffff,0xeb78,0xbfc6,0xbfc9,0xeb7b,0xeb73,0xeb74,0xeb7a,
0xeb72,0xeb76,0xbfc7,0xee72,0xffff,0xee71,0xc1b7,0xee77,
0xc1b9,0xffff,0xffff,0xc1b6,0xee73,0xc1ba,0xee74,0xffff,
0xffff,0xee75,0xee78,0xffff,0xc1b8,0xffff,0xf0d6,0xffff,
0xffff,0xf0d9,0xffff,0xf0d3,0xf0d5,0xffff,0xffff,0xf0d4,
0xf0d7,0xf0d8,0xee76,0xf0d2,0xffff,0xffff,0xc3cd,0xf2ec,
0xf2ef,0xf2f1,0xf2ea,0xf2eb,0xf2ee,0xf2f0,0xc3ce,0xc3cc,
0xc3cb,0xf2ed,0xf2e9,0xf4ca,0xc4b0,0xffff,0xf4cb,0xffff,
0xffff,0xf649,0xc4fb,0xf64b,0xc4fc,0xf648,0xf64a,0xc5a8,
0xffff,0xf752,0xc5a7,0xf7fd,0xf7fc,0xffff,0xf7fb,0xffff,
0xffff,0xf948,0xf949,0xf94b,0xf94a,0xffff,0xca50,0xa6e8,
0xffff,0xad6e,0xd7c5,0xb5f7,0xffff,0xdffa,0xc2d0,0xffff,
0xf2f2,0xffff,0xffff,0xa8a3,0xffff,0xffff,0xffff,0xb357,
0xffff,0xffff,0xffff,0xb356,0xffff,0xdbd0,0xb5f8,0xdbd2,
0xdbd1,0xffff,0xffff,0xdffb,0xb8d0,0xe443,0xe446,0xe445,
0xffff,0xe444,0xe7ce,0xe7d0,0xe7cf,0xffff,0xbfcc,0xffff,
0xffff,0xffff,0xbfcb,0xffff,0xc1bb,0xee79,0xee7b,0xee7a,
0xffff,0xffff,0xc2d1,0xffff,0xffff,0xffff,0xf2f4,0xf2f3,
0xffff,0xf4cc,0xc4b1,0xffff,0xffff,0xc4fd,0xf754,0xf753,
0xc65b,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xa8a4,0xd0af,0xad6f,0xd7c8,0xd7c6,0xffff,
0xffff,0xd7c7,0xdbd4,0xdbd5,0xe043,0xdbd3,0xffff,0xdffc,
0xe041,0xe040,0xe042,0xb8d1,0xdffe,0xdffd,0xe044,0xffff,
0xe449,0xe447,0xffff,0xe448,0xe7d3,0xe7d1,0xffff,0xffff,
0xe7d2,0xeb7d,0xee7c,0xee7d,0xc2d2,0xffff,0xf2f5,0xf4cd,
0xc4b2,0xffff,0xf64c,0xf755,0xc5a9,0xffff,0xf7fe,0xf94c,
0xa8a5,0xffff,0xad71,0xad72,0xd0b0,0xffff,0xffff,0xd0b1,
0xad70,0xffff,0xb054,0xffff,0xb052,0xffff,0xb051,0xb058,
0xb050,0xb059,0xd3dd,0xb056,0xffff,0xb053,0xb057,0xb055,
0xb04f,0xffff,0xffff,0xb35f,0xffff,0xb359,0xd7cc,0xb35e,
0xffff,0xffff,0xb360,0xb35a,0xffff,0xb35b,0xffff,0xd7ca,
0xffff,0xffff,0xb358,0xffff,0xd7cb,0xb35d,0xffff,0xffff,
0xd7c9,0xb35c,0xffff,0xffff,0xb644,0xffff,0xb646,0xffff,
0xffff,0xdbd8,0xb645,0xb5f9,0xb5fd,0xffff,0xb8e4,0xe049,
0xdbda,0xb5fe,0xffff,0xffff,0xdbdd,0xdbde,0xb643,0xffff,
0xdbe0,0xffff,0xdbe2,0xffff,0xdbe3,0xdbd7,0xdbd6,0xdbe4,
0xb642,0xdbe1,0xdbdf,0xffff,0xb640,0xb5fb,0xb647,0xdbdb,
0xdbdc,0xdbd9,0xffff,0xb641,0xffff,0xffff,0xb5fc,0xffff,
0xb5fa,0xe048,0xb8df,0xb8da,0xffff,0xffff,0xb8d5,0xffff,
0xb8e5,0xb8d6,0xffff,0xb8d2,0xb8e1,0xb8de,0xb8e0,0xffff,
0xb8d7,0xb8dc,0xb8d3,0xb8d4,0xe050,0xe04d,0xe045,0xe04a,
0xffff,0xb8e2,0xe051,0xb8e3,0xb8d9,0xffff,0xffff,0xe047,
0xffff,0xe04f,0xe04b,0xe04e,0xe04c,0xb8dd,0xe046,0xb8d8,
0xffff,0xffff,0xffff,0xe44c,0xbb78,0xbb7b,0xffff,0xe44e,
0xffff,0xbba5,0xe44d,0xbb7d,0xffff,0xbdcf,0xe44f,0xffff,
0xbba4,0xe44b,0xbba6,0xffff,0xffff,0xffff,0xbb79,0xffff,
0xb8db,0xbb7c,0xffff,0xbb7a,0xbb7e,0xbba2,0xbb77,0xbba7,
0xbba3,0xffff,0xbba1,0xe44a,0xffff,0xffff,0xffff,0xffff,
0xbdd6,0xffff,0xbdd2,0xffff,0xffff,0xffff,0xbdd9,0xffff,
0xe7d6,0xbdda,0xe7e2,0xe7db,0xbdcb,0xe7e3,0xe7dd,0xbdd5,
0xe7de,0xffff,0xbdd4,0xe7e1,0xbdce,0xe7df,0xe7d5,0xbdcd,
0xebaa,0xbdd3,0xffff,0xbdd0,0xffff,0xbdd8,0xffff,0xe7d4,
0xffff,0xe7d8,0xbdcc,0xe7d7,0xe7d9,0xe7da,0xbdd7,0xe7dc,
0xe7e0,0xe7e4,0xffff,0xbddb,0xbfd2,0xeba5,0xebab,0xeba8,
0xeb7e,0xebac,0xeba1,0xffff,0xeba7,0xffff,0xbfcd,0xbfd3,
0xebad,0xffff,0xffff,0xbfcf,0xffff,0xbfd9,0xbfd4,0xebaf,
0xeba9,0xbfd0,0xeba2,0xbfda,0xeba3,0xeba4,0xbfdb,0xbfd8,
0xbdd1,0xffff,0xbfce,0xebb0,0xbfdc,0xffff,0xbfd5,0xebae,
0xbfd1,0xbfd6,0xbfd7,0xffff,0xc1c3,0xeea4,0xeead,0xeeaa,
0xeeac,0xffff,0xc1c0,0xeea5,0xffff,0xeeab,0xc1bc,0xeea7,
0xc1c4,0xeea3,0xeea8,0xeeaf,0xeba6,0xeea9,0xeea2,0xc1bd,
0xeea1,0xc1be,0xeeb0,0xc1bf,0xeeae,0xc1c2,0xee7e,0xffff,
0xc1c1,0xffff,0xeea6,0xf0dc,0xf0ea,0xf0e5,0xf0e7,0xf0db,
0xc2d3,0xffff,0xf0da,0xc2d6,0xc2d5,0xffff,0xf0e9,0xf0e1,
0xf0de,0xf0e4,0xffff,0xf0dd,0xffff,0xf0df,0xf0e8,0xf0e6,
0xffff,0xc2d4,0xf0ed,0xf0eb,0xf0e2,0xf0ec,0xf0e3,0xffff,
0xf2f9,0xc3cf,0xf341,0xffff,0xffff,0xf64f,0xc3d6,0xf0e0,
0xf2f7,0xc3d2,0xf2f8,0xf2fd,0xffff,0xffff,0xc3d4,0xc3d5,
0xf2f6,0xf340,0xf342,0xf2fa,0xf2fc,0xf2fe,0xf2fb,0xf343,
0xc3d1,0xc3d7,0xc3d3,0xffff,0xc3d0,0xf4d0,0xffff,0xc4b7,
0xf4ce,0xffff,0xffff,0xf4d2,0xffff,0xf4d3,0xc4b5,0xf4d4,
0xf4d1,0xffff,0xf4cf,0xc4b8,0xc4b4,0xf4d5,0xffff,0xc4b6,
0xc4b3,0xffff,0xffff,0xffff,0xc4fe,0xffff,0xffff,0xc540,
0xf64e,0xf64d,0xf650,0xf651,0xffff,0xc541,0xf756,0xf75b,
0xc5aa,0xffff,0xf758,0xffff,0xf757,0xf75a,0xf759,0xffff,
0xf843,0xffff,0xc5dc,0xf842,0xf840,0xffff,0xf841,0xffff,
0xffff,0xffff,0xc5fe,0xc5fd,0xf8c1,0xf8c2,0xc640,0xffff,
0xf94d,0xf94e,0xc667,0xffff,0xc66d,0xffff,0xf9a9,0xf9c8,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xa8a6,
0xffff,0xd7cd,0xffff,0xd7ce,0xe052,0xe450,0xe7e5,0xc1c6,
0xffff,0xc1c5,0xf0ee,0xf344,0xffff,0xf844,0xa8a7,0xd3de,
0xb05a,0xb361,0xe054,0xe053,0xbddc,0xe7e6,0xbddd,0xeeb1,
0xc2d7,0xffff,0xffff,0xffff,0xc676,0xa8a8,0xcdcb,0xd3df,
0xffff,0xffff,0xb362,0xffff,0xd7cf,0xd7d0,0xffff,0xdbe5,
0xffff,0xb648,0xb8e6,0xffff,0xe056,0xe055,0xe057,0xffff,
0xe451,0xe452,0xbba8,0xbfdd,0xbdde,0xbfde,0xffff,0xeeb5,
0xeeb2,0xeeb4,0xeeb3,0xc1c7,0xffff,0xf0ef,0xf346,0xf345,
0xcba4,0xb05c,0xb05b,0xd3e0,0xffff,0xd7d1,0xffff,0xffff,
0xdbe7,0xdbe6,0xb649,0xffff,0xe059,0xe05a,0xe058,0xffff,
0xffff,0xb8e8,0xb8e7,0xffff,0xbbaa,0xbba9,0xffff,0xe7e7,
0xebb3,0xebb1,0xebb2,0xbfdf,0xeeb7,0xeeb6,0xffff,0xf0f2,
0xf0f1,0xf0f0,0xf347,0xffff,0xf9aa,0xa8a9,0xad73,0xffff,
0xad74,0xb05d,0xb05e,0xd3e2,0xd3e1,0xd7d2,0xffff,0xb368,
0xb366,0xb363,0xb367,0xb365,0xb364,0xffff,0xffff,0xb64a,
0xdbea,0xffff,0xb8ed,0xb64c,0xb651,0xdbec,0xb653,0xb652,
0xb655,0xdbeb,0xdbe8,0xb64f,0xb64b,0xb64d,0xdbe9,0xb654,
0xb650,0xb64e,0xb8ef,0xb8ee,0xb8ec,0xb8f0,0xffff,0xb8ea,
0xb8eb,0xffff,0xb8e9,0xffff,0xe05b,0xffff,0xffff,0xe454,
0xffff,0xbbac,0xbbad,0xbbab,0xffff,0xe453,0xffff,0xe455,
0xffff,0xe7ea,0xe7ec,0xffff,0xbde7,0xe7ed,0xbde0,0xe7e9,
0xbddf,0xbde9,0xbde5,0xbde6,0xbde2,0xe7e8,0xbde1,0xe7ee,
0xe7eb,0xffff,0xbde8,0xffff,0xbde3,0xbde4,0xebb5,0xffff,
0xebb7,0xebb6,0xffff,0xebb8,0xbfe0,0xebb4,0xffff,0xffff,
0xc1cb,0xeeb8,0xc1c8,0xc1cc,0xc1ca,0xc1c9,0xf0f3,0xffff,
0xf0f6,0xffff,0xf0f5,0xffff,0xf0f4,0xc2d8,0xf348,0xf349,
0xc3d8,0xf34a,0xc3d9,0xffff,0xffff,0xc4ba,0xffff,0xc4b9,
0xf652,0xffff,0xffff,0xc542,0xf653,0xf75c,0xc5ab,0xc5ac,
0xffff,0xf845,0xffff,0xc642,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xa8aa,0xffff,0xb36a,0xb369,
0xe05c,0xe05d,0xffff,0xbbae,0xebb9,0xbdea,0xebba,0xeeb9,
0xa8ab,0xffff,0xd0b2,0xad76,0xad75,0xffff,0xd3e3,0xb05f,
0xd3e4,0xd7d5,0xffff,0xd7d4,0xffff,0xd7d3,0xffff,0xffff,
0xdbee,0xb658,0xffff,0xffff,0xdbed,0xb657,0xffff,0xffff,
0xffff,0xdbef,0xb656,0xffff,0xe05f,0xe062,0xe060,0xe061,
0xe065,0xe05e,0xe066,0xe063,0xe064,0xbbb0,0xe456,0xffff,
0xffff,0xbbaf,0xffff,0xe7f2,0xe7f0,0xffff,0xffff,0xbdeb,
0xe7ef,0xe7f1,0xffff,0xbdec,0xffff,0xebbb,0xffff,0xebbc,
0xc1cd,0xffff,0xf34c,0xf34e,0xf34b,0xf34d,0xf4d6,0xf654,
0xffff,0xffff,0xf96f,0xa8ac,0xad77,0xd3e5,0xd3e7,0xd3e6,
0xffff,0xd7d8,0xb36c,0xffff,0xd7d6,0xffff,0xb36b,0xd7d9,
0xffff,0xd7da,0xd7d7,0xffff,0xffff,0xdbfb,0xb660,0xdbf3,
0xdbf9,0xffff,0xffff,0xb65b,0xb65e,0xdbf2,0xb659,0xdbf6,
0xe06c,0xb65d,0xffff,0xdbf1,0xffff,0xdbf7,0xdbf4,0xdbfa,
0xdbf0,0xdbf8,0xb65c,0xb65f,0xdbf5,0xb65a,0xffff,0xb8f2,
0xe068,0xb8f1,0xe06f,0xe06e,0xb8f8,0xffff,0xb8f9,0xe070,
0xb8f3,0xe06d,0xb8f7,0xe072,0xe069,0xffff,0xe06b,0xb8f4,
0xe067,0xe06a,0xe071,0xb8f5,0xe073,0xffff,0xffff,0xffff,
0xffff,0xffff,0xb8f6,0xffff,0xbbb1,0xe45b,0xe461,0xe459,
0xe462,0xffff,0xe458,0xe45d,0xe463,0xe460,0xe45f,0xe45e,
0xffff,0xe457,0xe45c,0xffff,0xffff,0xe45a,0xffff,0xbdf1,
0xbdee,0xe7fb,0xe841,0xe843,0xe840,0xe7f8,0xe7fa,0xe845,
0xe842,0xe7fc,0xe846,0xe7f9,0xe844,0xbdef,0xbdf5,0xbdf3,
0xe7f3,0xbdf4,0xbdf0,0xe7f4,0xe7f6,0xe7f5,0xe7fd,0xe7fe,
0xffff,0xbdf2,0xffff,0xbded,0xffff,0xffff,0xe7f7,0xffff,
0xebc6,0xbfe2,0xffff,0xebbd,0xbfe3,0xbfe6,0xebc2,0xffff,
0xebbf,0xbfe5,0xffff,0xffff,0xebc3,0xebc4,0xebbe,0xebc7,
0xebc0,0xebc5,0xbfe4,0xffff,0xbfe1,0xebc1,0xffff,0xeebf,
0xc1d0,0xc1ce,0xc1d1,0xc1cf,0xeebe,0xeebb,0xeeba,0xffff,
0xeebd,0xffff,0xffff,0xeebc,0xf145,0xc2de,0xf0fb,0xf0fa,
0xffff,0xc2d9,0xf141,0xf140,0xf0f7,0xf143,0xf0fc,0xc2dd,
0xf0f9,0xf142,0xf0f8,0xc2da,0xc2dc,0xf0fd,0xc2db,0xf0fe,
0xffff,0xf144,0xf352,0xffff,0xc3de,0xf34f,0xffff,0xf353,
0xffff,0xffff,0xc3db,0xf351,0xc3e0,0xffff,0xc3dd,0xffff,
0xf350,0xffff,0xc3df,0xf354,0xc3da,0xffff,0xffff,0xffff,
0xffff,0xc4bc,0xc4be,0xffff,0xf4d9,0xc4bd,0xf4d7,0xc3dc,
0xf4d8,0xc4bb,0xc543,0xc545,0xf656,0xc544,0xf655,0xffff,
0xf761,0xc5ad,0xf760,0xc5ae,0xf75e,0xf75d,0xf762,0xf763,
0xf846,0xffff,0xf75f,0xffff,0xffff,0xf8c6,0xf8c3,0xf8c4,
0xf8c5,0xc65c,0xffff,0xf951,0xf950,0xf94f,0xf970,0xffff,
0xf9be,0xf9ab,0xc66e,0xa8ad,0xb060,0xffff,0xffff,0xffff,
0xffff,0xffff,0xb8fa,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xbdf6,0xffff,0xffff,0xebc8,0xffff,0xffff,
0xc2df,0xffff,0xf355,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xf9ac,0xa8ae,0xaaee,0xad79,0xad78,0xffff,0xb063,
0xffff,0xd3e8,0xb061,0xd3e9,0xb062,0xffff,0xffff,0xd7df,
0xd7db,0xffff,0xffff,0xb36d,0xd7de,0xd7dd,0xd7dc,0xb36e,
0xd7e0,0xd7e1,0xffff,0xffff,0xffff,0xdc43,0xdc41,0xdc45,
0xdc46,0xdc4c,0xffff,0xdc48,0xdc4a,0xffff,0xdc42,0xdbfc,
0xffff,0xdc49,0xffff,0xffff,0xdc4b,0xdc44,0xdc47,0xdbfd,
0xb662,0xdc40,0xdbfe,0xb661,0xb663,0xffff,0xb8fd,0xe075,
0xe077,0xe076,0xe07b,0xb8fb,0xffff,0xe078,0xe074,0xe079,
0xe07a,0xb8fc,0xb8fe,0xe07c,0xffff,0xe467,0xe466,0xffff,
0xe464,0xe465,0xbbb3,0xbbb5,0xbbb2,0xbbb4,0xe84d,0xe84e,
0xe849,0xffff,0xe84a,0xbdf8,0xbdfd,0xbdf7,0xbdfe,0xbdf9,
0xe84b,0xffff,0xffff,0xe84c,0xe848,0xbe40,0xbdfb,0xffff,
0xffff,0xbdfa,0xbdfc,0xffff,0xe847,0xffff,0xebca,0xbfe8,
0xffff,0xffff,0xebcc,0xbfea,0xebcf,0xebcb,0xebc9,0xebce,
0xbfe9,0xebcd,0xffff,0xbfe7,0xffff,0xffff,0xc1d3,0xc1d6,
0xeec1,0xffff,0xc1d4,0xeec0,0xc1d2,0xc1d5,0xf146,0xf147,
0xf148,0xc2e0,0xffff,0xf149,0xffff,0xc2e1,0xc3e2,0xf358,
0xf359,0xf357,0xf356,0xf35a,0xc3e1,0xf4dd,0xf4db,0xf4dc,
0xf4de,0xf4da,0xf4df,0xf658,0xffff,0xf659,0xf657,0xc546,
0xf764,0xc5af,0xf765,0xf848,0xf847,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xa8af,0xb664,0xffff,0xffff,0xb940,
0xffff,0xffff,0xffff,0xbbb6,0xffff,0xffff,0xbfec,0xffff,
0xbfeb,0xffff,0xffff,0xffff,0xffff,0xc3e3,0xc47c,0xc547,
0xa8b0,0xb064,0xb941,0xffff,0xf35b,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xcba6,
0xffff,0xffff,0xa8b1,0xffff,0xa8b4,0xa8b3,0xa8b2,0xffff,
0xffff,0xcba5,0xffff,0xcdcd,0xffff,0xcdcf,0xaaef,0xffff,
0xffff,0xaaf1,0xcdcc,0xcdce,0xaaf0,0xcdd1,0xcdd0,0xcdd2,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xd0b6,0xd0b4,0xad7c,0xd0b3,0xada3,0xad7e,0xad7b,0xffff,
0xada4,0xffff,0xad7d,0xada2,0xffff,0xada1,0xd0b5,0xffff,
0xad7a,0xffff,0xffff,0xffff,0xb06a,0xd3eb,0xd3f1,0xb067,
0xb06e,0xffff,0xb069,0xd3ee,0xd3f0,0xb06c,0xd3ea,0xd3ed,
0xb068,0xb065,0xd3ec,0xb06b,0xd3ef,0xb06d,0xb066,0xffff,
0xffff,0xffff,0xffff,0xd7e3,0xd7e6,0xb370,0xffff,0xb37a,
0xb376,0xd7e4,0xffff,0xffff,0xb37e,0xb377,0xb37c,0xb372,
0xffff,0xb36f,0xb371,0xb37d,0xd7e5,0xb375,0xb378,0xb374,
0xb379,0xd7e7,0xb37b,0xb373,0xd7e2,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xdc4d,0xb665,0xdc4f,
0xffff,0xb667,0xb669,0xffff,0xdc4e,0xb666,0xb66a,0xffff,
0xb668,0xffff,0xffff,0xffff,0xb947,0xe0a3,0xb94f,0xe07e,
0xffff,0xb950,0xb945,0xffff,0xe0a1,0xffff,0xffff,0xb94a,
0xffff,0xe0a2,0xb943,0xb942,0xffff,0xb94d,0xb94c,0xb94b,
0xb949,0xb94e,0xe07d,0xb944,0xb946,0xb948,0xffff,0xffff,
0xbbb8,0xbbbb,0xffff,0xbbbf,0xbbb9,0xbbbe,0xbbbc,0xffff,
0xbbb7,0xffff,0xbbbd,0xbbba,0xffff,0xffff,0xffff,0xe852,
0xbe43,0xbe41,0xffff,0xe853,0xffff,0xbe44,0xbe42,0xe851,
0xe850,0xffff,0xbff0,0xe84f,0xbfee,0xbfed,0xebd0,0xbe45,
0xbfef,0xebd1,0xbff2,0xebd2,0xbff1,0xc1d8,0xeec3,0xc1d7,
0xc1dc,0xc1da,0xc1db,0xc2e3,0xc1d9,0xeec2,0xebd3,0xc2e2,
0xc2e4,0xffff,0xc3e4,0xc3e5,0xffff,0xf4e0,0xffff,0xc5de,
0xc5dd,0xa8b6,0xffff,0xffff,0xca55,0xb06f,0xffff,0xca52,
0xca53,0xca51,0xffff,0xca54,0xffff,0xffff,0xcbaa,0xcba7,
0xcbac,0xcba8,0xa8b7,0xa8ba,0xffff,0xcba9,0xa8b9,0xcbab,
0xffff,0xffff,0xa8b8,0xffff,0xffff,0xffff,0xffff,0xcdd5,
0xcdd7,0xaaf4,0xcdd3,0xcdd6,0xcdd4,0xaaf2,0xaaf5,0xffff,
0xaaf3,0xffff,0xffff,0xffff,0xffff,0xd0b8,0xd0bc,0xd0b9,
0xffff,0xada7,0xffff,0xada8,0xffff,0xd0bb,0xffff,0xd0bd,
0xd0bf,0xffff,0xada5,0xd0be,0xffff,0xffff,0xada6,0xffff,
0xffff,0xffff,0xffff,0xffff,0xd7ee,0xd0ba,0xd3f2,0xd3fb,
0xd3f9,0xd3f4,0xd3f5,0xd3fa,0xd3fc,0xb071,0xffff,0xd3f7,
0xd3f3,0xb070,0xb072,0xd3f6,0xd3fd,0xd3f8,0xffff,0xffff,
0xb3a1,0xd7f1,0xd7e9,0xd7ef,0xd7f0,0xb3a2,0xffff,0xd7e8,
0xd7ea,0xd0b7,0xd7ec,0xd7ed,0xd7eb,0xb66c,0xffff,0xffff,
0xffff,0xdc56,0xebd4,0xdc57,0xdc54,0xb3a3,0xb66e,0xdc53,
0xdc59,0xdc58,0xb66b,0xdc5c,0xdc52,0xdc5b,0xdc50,0xdc5a,
0xdc55,0xb66d,0xffff,0xe0aa,0xffff,0xe0a5,0xe0ab,0xe0a6,
0xe0a4,0xe0a7,0xb951,0xffff,0xe0a9,0xffff,0xe0a8,0xb952,
0xbbc1,0xbbc0,0xe46e,0xe471,0xe469,0xe46d,0xbbc2,0xe46c,
0xe46a,0xe470,0xe46b,0xe468,0xe46f,0xffff,0xe859,0xbe48,
0xf14a,0xe856,0xe857,0xe855,0xdc51,0xbe47,0xe85a,0xe854,
0xbe46,0xbe49,0xe858,0xebd5,0xbff3,0xebd6,0xebd7,0xffff,
0xeec4,0xc1dd,0xf14b,0xf14c,0xffff,0xffff,0xf14d,0xf35d,
0xf35c,0xf4e2,0xffff,0xf4e1,0xf65b,0xf65c,0xf65a,0xf766,
0xc5b0,0xa8bb,0xadaa,0xada9,0xb075,0xb074,0xd440,0xd441,
0xd3fe,0xffff,0xb073,0xd7f5,0xffff,0xd7f6,0xd7f2,0xb3a4,
0xd7f3,0xffff,0xd7f4,0xffff,0xffff,0xffff,0xffff,0xdc5f,
0xdc61,0xdc5d,0xdc60,0xb66f,0xdc5e,0xb670,0xffff,0xffff,
0xdd73,0xb955,0xb954,0xffff,0xb953,0xffff,0xe0ac,0xe0ad,
0xffff,0xffff,0xe473,0xe475,0xbbc6,0xbbc3,0xffff,0xbbc5,
0xbbc4,0xe474,0xe472,0xffff,0xffff,0xffff,0xffff,0xffff,
0xe861,0xe85e,0xe85f,0xbe4d,0xe860,0xe85b,0xe85c,0xbe4a,
0xffff,0xbe4b,0xe85d,0xbe4c,0xffff,0xebdb,0xffff,0xebdc,
0xebd9,0xebda,0xbff4,0xebd8,0xffff,0xffff,0xffff,0xffff,
0xffff,0xeec8,0xeec5,0xeec7,0xc1e0,0xeecb,0xc1df,0xeec9,
0xeecc,0xeeca,0xeec6,0xc1de,0xffff,0xf14f,0xffff,0xf150,
0xf14e,0xffff,0xf152,0xc2e5,0xc2e6,0xf35f,0xc3e7,0xf151,
0xf35e,0xc3e6,0xf4e5,0xf4e6,0xc4bf,0xf4e4,0xffff,0xf4e3,
0xffff,0xf65d,0xc548,0xffff,0xf849,0xf8c8,0xf8c7,0xffff,
0xc643,0xc65d,0xf8c9,0xf971,0xffff,0xc66f,0xa8bc,0xaaf6,
0xffff,0xb956,0xffff,0xc4c0,0xa8bd,0xadab,0xb3a5,0xb671,
0xc2e7,0xaaf7,0xffff,0xd0c1,0xd0c0,0xd442,0xffff,0xb078,
0xb076,0xb07a,0xd444,0xffff,0xb079,0xb077,0xffff,0xffff,
0xffff,0xffff,0xd443,0xb3a8,0xd7fc,0xffff,0xb3a7,0xb3a9,
0xd842,0xb3ab,0xd7fe,0xd840,0xd7f7,0xb3aa,0xd843,0xffff,
0xffff,0xd7f9,0xffff,0xd7fa,0xd7f8,0xb3a6,0xffff,0xd841,
0xd7fb,0xd7fd,0xffff,0xffff,0xffff,0xdc6d,0xffff,0xdc6c,
0xdc6a,0xdc62,0xdc71,0xdc65,0xdc6f,0xdc76,0xdc6e,0xb679,
0xffff,0xb675,0xdc63,0xffff,0xdc69,0xb677,0xffff,0xdc68,
0xb678,0xb67a,0xdc6b,0xffff,0xb672,0xb673,0xdc77,0xdc75,
0xffff,0xdc74,0xdc66,0xffff,0xdc72,0xffff,0xb676,0xffff,
0xffff,0xffff,0xffff,0xb674,0xdc73,0xdc64,0xdc67,0xdc70,
0xffff,0xffff,0xffff,0xffff,0xffff,0xe4ba,0xe0b7,0xffff,
0xe0b0,0xe0c3,0xe0cc,0xe0b3,0xb961,0xffff,0xe0c0,0xb957,
0xb959,0xb965,0xe0b1,0xffff,0xffff,0xb95a,0xb95c,0xb966,
0xb95b,0xffff,0xffff,0xffff,0xffff,0xb964,0xe0b9,0xffff,
0xe0ae,0xb962,0xe0b8,0xb95e,0xe0ca,0xb963,0xe0c8,0xe0bc,
0xe0c6,0xb960,0xe0af,0xe0c9,0xe0c4,0xffff,0xe0cb,0xb958,
0xffff,0xffff,0xb967,0xb95d,0xffff,0xffff,0xe0b5,0xffff,
0xe0bd,0xe0c1,0xffff,0xe0c5,0xb95f,0xe0b4,0xe0b2,0xe0be,
0xffff,0xffff,0xffff,0xffff,0xe0bb,0xe0ba,0xffff,0xe0bf,
0xe0c2,0xffff,0xe0c7,0xffff,0xffff,0xffff,0xe478,0xffff,
0xbbc7,0xe4a4,0xe47a,0xbbcc,0xbbd0,0xe4ad,0xe4b5,0xe4a6,
0xbbc8,0xffff,0xe4aa,0xe0b6,0xffff,0xbbc9,0xe4b1,0xe4b6,
0xe4ae,0xffff,0xe4b0,0xe4b9,0xe4b2,0xe47e,0xe4a9,0xffff,
0xffff,0xbbd1,0xffff,0xbbcd,0xe47c,0xe4ab,0xbbcb,0xe4a5,
0xbbca,0xe4b3,0xe4a2,0xe479,0xbbce,0xe4b8,0xffff,0xffff,
0xe47b,0xe4af,0xe4ac,0xe4a7,0xe477,0xe476,0xe4a1,0xe4b4,
0xbbcf,0xe4b7,0xe47d,0xe4a3,0xbe52,0xffff,0xffff,0xffff,
0xffff,0xffff,0xbe5a,0xbe55,0xe8a4,0xe8a1,0xe867,0xbe50,
0xffff,0xf9d7,0xffff,0xbe4f,0xbe56,0xffff,0xffff,0xffff,
0xe865,0xbe54,0xe871,0xe863,0xe864,0xbe4e,0xe8a3,0xbe58,
0xe874,0xe879,0xe873,0xebee,0xe86f,0xe877,0xe875,0xe868,
0xe862,0xe87d,0xbe57,0xe87e,0xffff,0xe878,0xffff,0xe86d,
0xe86b,0xe866,0xffff,0xffff,0xffff,0xe86e,0xe87b,0xe86a,
0xe87a,0xe8a2,0xffff,0xffff,0xbe53,0xffff,0xe876,0xe87c,
0xe872,0xe86c,0xbe51,0xffff,0xffff,0xffff,0xe4a8,0xe870,
0xbe59,0xe869,0xffff,0xffff,0xffff,0xffff,0xffff,0xebf4,
0xbff7,0xebf3,0xebf0,0xec44,0xbffb,0xffff,0xec41,0xebf8,
0xec43,0xebe9,0xebf6,0xffff,0xbffd,0xffff,0xebe1,0xffff,
0xebdf,0xec42,0xffff,0xec40,0xebfe,0xebed,0xebec,0xebe2,
0xc040,0xffff,0xebe8,0xebf2,0xebfd,0xc043,0xec45,0xffff,
0xc1e8,0xc045,0xbffe,0xebe6,0xffff,0xebef,0xebde,0xebe0,
0xbff5,0xc042,0xbffa,0xebe7,0xebf7,0xebf1,0xc041,0xebdd,
0xc1e3,0xebf9,0xebfc,0xbffc,0xffff,0xebeb,0xc044,0xbff9,
0xffff,0xffff,0xffff,0xbff8,0xebf5,0xebfb,0xbff6,0xffff,
0xebe4,0xebfa,0xffff,0xffff,0xebe5,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xebea,0xeed2,
0xffff,0xeed7,0xc1e5,0xc1e7,0xeedd,0xc1e1,0xeeec,0xeee3,
0xeed8,0xeed9,0xeee2,0xffff,0xc1ee,0xeee1,0xeed1,0xeee0,
0xeed4,0xeeed,0xc1ed,0xc1eb,0xeed5,0xffff,0xeee8,0xffff,
0xeeda,0xeee7,0xffff,0xeee9,0xeed0,0xc1e6,0xffff,0xeeea,
0xffff,0xffff,0xeede,0xffff,0xc1ea,0xeedb,0xffff,0xffff,
0xc1ec,0xeee4,0xffff,0xffff,0xffff,0xc1e4,0xeed6,0xeee5,
0xffff,0xeedf,0xebe3,0xeee6,0xeed3,0xffff,0xc1e9,0xffff,
0xeeeb,0xffff,0xc1e2,0xeece,0xffff,0xffff,0xffff,0xffff,
0xf160,0xf159,0xc2e9,0xffff,0xf154,0xf163,0xf15b,0xeedc,
0xffff,0xf165,0xf155,0xffff,0xc2e8,0xf15f,0xc2ea,0xc2f2,
0xc2f0,0xf161,0xc2f1,0xf157,0xffff,0xf158,0xf15d,0xf162,
0xffff,0xeecd,0xc2eb,0xf16a,0xf167,0xf16b,0xf15e,0xf15a,
0xf168,0xf36a,0xf15c,0xffff,0xc2ee,0xffff,0xc2ed,0xeecf,
0xc2ef,0xf164,0xf166,0xc2ec,0xf169,0xf153,0xffff,0xf156,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xf373,0xffff,0xf363,0xc3eb,0xf371,0xffff,0xffff,0xf361,
0xc3ec,0xffff,0xf36c,0xffff,0xf368,0xc3f1,0xf372,0xf362,
0xf365,0xc3e9,0xf374,0xffff,0xf36d,0xf370,0xc3ef,0xc3f4,
0xc3f2,0xf369,0xf364,0xffff,0xc3ed,0xc3ee,0xf360,0xc3ea,
0xffff,0xc3e8,0xc3f0,0xf36f,0xc3f3,0xffff,0xf36b,0xf375,
0xc3f5,0xffff,0xffff,0xffff,0xf367,0xffff,0xf36e,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xf4f3,0xf542,0xf4f5,
0xf4fc,0xf366,0xf4fa,0xf4e9,0xf540,0xc4c3,0xf4ed,0xf4fe,
0xf4f4,0xffff,0xffff,0xc4c2,0xffff,0xffff,0xf544,0xf4f6,
0xffff,0xf4fb,0xf4fd,0xf4e7,0xf541,0xf4f2,0xf4f7,0xf4eb,
0xf4ef,0xf543,0xf4f9,0xf4e8,0xf4ec,0xf4ee,0xf4f8,0xffff,
0xc4c1,0xf4f1,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xf4ea,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xf4f0,0xf661,0xf666,0xc54f,0xf668,0xffff,0xc549,0xffff,
0xf664,0xf66a,0xc54e,0xc54a,0xffff,0xc54b,0xf660,0xf667,
0xc54d,0xf665,0xc54c,0xf65f,0xf663,0xf662,0xffff,0xf65e,
0xf669,0xffff,0xffff,0xffff,0xc5b1,0xf76d,0xf770,0xf76c,
0xf76e,0xf76f,0xf769,0xf76a,0xf767,0xffff,0xffff,0xf76b,
0xf768,0xc5b2,0xc5b3,0xffff,0xffff,0xf84b,0xffff,0xf84d,
0xffff,0xffff,0xffff,0xffff,0xffff,0xf84c,0xf84e,0xffff,
0xc5e0,0xffff,0xf84a,0xc5df,0xc5e1,0xffff,0xffff,0xffff,
0xf8cb,0xf8cc,0xc644,0xf8ca,0xffff,0xf953,0xf952,0xf954,
0xc65f,0xf955,0xc65e,0xf956,0xf972,0xf975,0xf974,0xc668,
0xf973,0xffff,0xffff,0xffff,0xc672,0xc670,0xc671,0xc677,
0xf9c0,0xf9c1,0xf9bf,0xf9c9,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xaaf8,
0xffff,0xffff,0xd844,0xdc78,0xe8a5,0xf376,0xffff,0xffff,
0xaaf9,0xffff,0xadac,0xb07b,0xffff,0xffff,0xd845,0xffff,
0xd846,0xb3ac,0xffff,0xb67d,0xdc7a,0xdc79,0xb6a3,0xb67c,
0xdc7b,0xb67e,0xb6a2,0xb6a1,0xb67b,0xffff,0xffff,0xffff,
0xb968,0xffff,0xffff,0xe0d0,0xe0ce,0xffff,0xe0cf,0xe0cd,
0xffff,0xbbd2,0xffff,0xbbd5,0xbbd7,0xbbd6,0xffff,0xffff,
0xbbd3,0xbbd4,0xffff,0xe8a7,0xe8a6,0xbe5b,0xe8a8,0xffff,
0xe8a9,0xbe5c,0xffff,0xffff,0xffff,0xec4d,0xec4b,0xeef3,
0xffff,0xec49,0xec4a,0xc046,0xec46,0xec4e,0xec48,0xec4c,
0xeeef,0xffff,0xffff,0xeef1,0xffff,0xeef2,0xc1f3,0xeeee,
0xc1f2,0xeef0,0xc1ef,0xc1f0,0xc1f1,0xec47,0xffff,0xffff,
0xc2f5,0xf16e,0xf16c,0xf16d,0xc2f3,0xc2f6,0xc2f4,0xffff,
0xffff,0xffff,0xf377,0xf378,0xc3f6,0xffff,0xf545,0xf547,
0xf546,0xc4c4,0xc550,0xf66d,0xf66c,0xf66b,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xaafa,0xffff,0xc9aa,0xffff,
0xca58,0xa6e9,0xca56,0xca59,0xca57,0xffff,0xffff,0xffff,
0xcbae,0xffff,0xa8c1,0xffff,0xa8c2,0xcbb0,0xa8bf,0xcbaf,
0xcbad,0xa8c0,0xa8be,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xcdd8,0xcddb,0xaafd,0xcdda,0xcdd9,0xffff,0xaafc,
0xaafb,0xffff,0xab40,0xcddc,0xaafe,0xffff,0xffff,0xffff,
0xffff,0xffff,0xd0c6,0xadae,0xadaf,0xadb0,0xd0c7,0xd0c3,
0xadad,0xd0c4,0xffff,0xd0c5,0xd0c2,0xffff,0xffff,0xffff,
0xb0a4,0xffff,0xffff,0xb0a1,0xd445,0xb0a2,0xb0a5,0xd446,
0xffff,0xb07e,0xb07c,0xb07d,0xb0a3,0xffff,0xffff,0xffff,
0xffff,0xffff,0xb3ad,0xd849,0xb3b5,0xd848,0xffff,0xd84b,
0xb3b1,0xd84a,0xb6ab,0xb3af,0xb3b2,0xb3ae,0xb3b3,0xb3b4,
0xb3b0,0xffff,0xffff,0xffff,0xd847,0xb6a7,0xdc7d,0xffff,
0xdca3,0xffff,0xffff,0xdca2,0xb6ac,0xb6a8,0xb6a9,0xdc7c,
0xdc7e,0xdca1,0xb6a4,0xb6a6,0xffff,0xb6aa,0xb6a5,0xffff,
0xffff,0xe0d3,0xe0d1,0xe0d2,0xb96a,0xb96b,0xffff,0xe0d4,
0xb969,0xbbd8,0xffff,0xbbda,0xbbd9,0xffff,0xe4bb,0xffff,
0xffff,0xe4bc,0xe8ab,0xffff,0xe8aa,0xffff,0xffff,0xc047,
0xc048,0xec4f,0xc049,0xffff,0xeef6,0xffff,0xeef4,0xffff,
0xeef5,0xc1f4,0xffff,0xf16f,0xc3f7,0xffff,0xffff,0xffff,
0xc1f5,0xab41,0xffff,0xb0a6,0xd447,0xffff,0xffff,0xd84c,
0xb3b6,0xb6ad,0xdca4,0xdca6,0xb6af,0xb6ae,0xb6b0,0xb6b1,
0xdca5,0xb96e,0xb96f,0xb96d,0xbbdb,0xb96c,0xe0d5,0xffff,
0xffff,0xffff,0xbbdc,0xe8ac,0xec50,0xc04a,0xc1f6,0xf170,
0xf174,0xc2f9,0xf171,0xc2fa,0xc2f8,0xf175,0xc2fb,0xf173,
0xffff,0xf379,0xc2f7,0xc3f8,0xffff,0xf8cd,0xffff,0xffff,
0xab42,0xb3b8,0xb3b7,0xffff,0xffff,0xffff,0xffff,0xb6b2,
0xdca8,0xdca7,0xb6b3,0xffff,0xffff,0xe0d9,0xb973,0xb970,
0xe0d8,0xb972,0xe0d6,0xb971,0xffff,0xe0d7,0xffff,0xe4bd,
0xbbdd,0xffff,0xe8af,0xffff,0xbe5d,0xe8ad,0xbe5e,0xbe5f,
0xe8ae,0xbe60,0xffff,0xec51,0xffff,0xc04e,0xc04b,0xc050,
0xec53,0xc04c,0xec52,0xc04f,0xffff,0xffff,0xc04d,0xffff,
0xeef9,0xeefb,0xffff,0xffff,0xc1f7,0xeefa,0xc1f8,0xeef8,
0xeef7,0xffff,0xf177,0xf176,0xc2fc,0xf178,0xf37e,0xc3fa,
0xf37d,0xf37a,0xc3f9,0xf37b,0xf37c,0xffff,0xf548,0xf549,
0xc4c5,0xffff,0xc553,0xffff,0xffff,0xf66e,0xffff,0xffff,
0xc551,0xc552,0xf66f,0xffff,0xffff,0xc5b4,0xc5b5,0xf771,
0xffff,0xffff,0xc645,0xf8cf,0xc647,0xffff,0xf8ce,0xf8d0,
0xc646,0xf957,0xffff,0xf9ad,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xab43,0xffff,0xffff,0xffff,0xb974,0xffff,
0xe4be,0xffff,0xe8b0,0xc051,0xc052,0xffff,0xab44,0xffff,
0xbe61,0xc3fb,0xadb1,0xffff,0xffff,0xffff,0xc053,0xffff,
0xc5e2,0xadb2,0xd84d,0xffff,0xdca9,0xffff,0xdcab,0xffff,
0xdcaa,0xffff,0xe0dd,0xe0da,0xb975,0xffff,0xb976,0xe0db,
0xe0dc,0xffff,0xe4c0,0xe4c5,0xbbde,0xe4bf,0xe4c1,0xe4c8,
0xe4c3,0xe4c7,0xe4c4,0xe4c2,0xe4c6,0xbbdf,0xffff,0xffff,
0xe8b3,0xffff,0xe8b1,0xbe63,0xffff,0xbe62,0xe8b2,0xbe64,
0xffff,0xffff,0xffff,0xffff,0xec56,0xffff,0xffff,0xec55,
0xc054,0xec54,0xeefc,0xffff,0xeefe,0xef41,0xef40,0xffff,
0xc1f9,0xeefd,0xf1a1,0xc2fd,0xf17d,0xf1a2,0xc2fe,0xffff,
0xf17b,0xffff,0xf17e,0xf17c,0xf179,0xc340,0xf17a,0xffff,
0xffff,0xffff,0xffff,0xf3a1,0xffff,0xffff,0xf3a3,0xf3a2,
0xffff,0xf54a,0xffff,0xf54b,0xffff,0xffff,0xffff,0xf670,
0xffff,0xc5b7,0xffff,0xc5b6,0xf84f,0xf850,0xc648,0xf8d1,
0xffff,0xc669,0xffff,0xadb3,0xb6b4,0xe4ca,0xe4c9,0xe8b5,
0xe8b4,0xffff,0xffff,0xc1fa,0xef43,0xef42,0xf1a5,0xf1a3,
0xf1a6,0xf1a4,0xffff,0xffff,0xc3fc,0xf3a4,0xf3a5,0xf3a6,
0xffff,0xf671,0xffff,0xf772,0xffff,0xf8d2,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xadb4,0xffff,0xffff,
0xec57,0xef44,0xffff,0xadb5,0xffff,0xffff,0xbbe0,0xffff,
0xec58,0xc341,0xf1a7,0xc3fd,0xffff,0xf54c,0xf54d,0xc554,
0xf851,0xadb6,0xb3bb,0xb3bc,0xd84e,0xb6b5,0xb6b6,0xdcac,
0xb6b7,0xffff,0xb97a,0xffff,0xb97c,0xe0df,0xe0e0,0xe0de,
0xb977,0xb978,0xb97b,0xb979,0xffff,0xffff,0xe4cb,0xbbe1,
0xbbe2,0xffff,0xffff,0xe8bc,0xbe67,0xe8b7,0xe8b6,0xffff,
0xe8bb,0xbe65,0xffff,0xffff,0xc05b,0xffff,0xe8b8,0xe8bd,
0xe8ba,0xe8b9,0xffff,0xbe66,0xffff,0xc059,0xffff,0xec5a,
0xc055,0xffff,0xec5b,0xffff,0xffff,0xec59,0xffff,0xc058,
0xc056,0xc05a,0xffff,0xc057,0xffff,0xffff,0xffff,0xffff,
0xffff,0xef45,0xffff,0xef4a,0xef46,0xef49,0xc1fb,0xffff,
0xedd4,0xef48,0xef47,0xffff,0xc344,0xc342,0xc345,0xc343,
0xf1a8,0xf1a9,0xf1aa,0xc346,0xffff,0xffff,0xffff,0xf3aa,
0xc440,0xf3a8,0xffff,0xc441,0xf3a7,0xf3a9,0xc3fe,0xf551,
0xf54e,0xffff,0xf54f,0xf550,0xf672,0xc556,0xffff,0xc555,
0xffff,0xf774,0xf773,0xc5b8,0xffff,0xffff,0xffff,0xc5e3,
0xc649,0xc660,0xf958,0xf9ae,0xf9af,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xadb7,0xdcad,0xffff,0xffff,0xe0e1,0xe4cc,0xe4cd,0xbbe3,
0xffff,0xbbe4,0xe8be,0xbe68,0xffff,0xffff,0xc1fc,0xffff,
0xf1ab,0xffff,0xc347,0xf3ad,0xc442,0xf3ac,0xf3ae,0xf3ab,
0xf675,0xf552,0xf553,0xffff,0xc4c6,0xffff,0xf674,0xffff,
0xffff,0xf673,0xffff,0xf775,0xf9b0,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xadb8,0xffff,0xffff,0xffff,0xadb9,
0xffff,0xffff,0xb0a7,0xd448,0xffff,0xd84f,0xffff,0xb6b8,
0xffff,0xb6bb,0xb6b9,0xdcae,0xffff,0xb6bd,0xffff,0xb6ba,
0xffff,0xffff,0xb6bc,0xffff,0xb97e,0xffff,0xe0e2,0xffff,
0xffff,0xe0e3,0xe8c0,0xffff,0xb97d,0xb9a1,0xb9a2,0xffff,
0xe4cf,0xffff,0xe4ce,0xbbe5,0xffff,0xbbe6,0xffff,0xe4d0,
0xe8bf,0xbbe8,0xbe69,0xffff,0xbbe7,0xffff,0xffff,0xffff,
0xc05c,0xe8c1,0xbe6b,0xbe6a,0xe8c2,0xe8c5,0xe8c3,0xe8c4,
0xbe6c,0xffff,0xc061,0xc05f,0xffff,0xffff,0xc05e,0xec5d,
0xffff,0xc060,0xffff,0xffff,0xec5c,0xef4b,0xffff,0xec5e,
0xc05d,0xec5f,0xef4e,0xef4c,0xef4d,0xef52,0xc34b,0xef51,
0xef54,0xef53,0xef50,0xef4f,0xffff,0xc1fd,0xffff,0xffff,
0xffff,0xffff,0xf1ae,0xffff,0xf1ad,0xc34a,0xc348,0xc349,
0xffff,0xf1ac,0xffff,0xf3b1,0xffff,0xc443,0xffff,0xf3b0,
0xf3af,0xc444,0xffff,0xf558,0xf557,0xffff,0xf555,0xffff,
0xf554,0xc4c8,0xc4c7,0xf559,0xf776,0xc5b9,0xf677,0xc557,
0xf676,0xf556,0xffff,0xf777,0xc5e4,0xffff,0xc661,0xf959,
0xffff,0xf9b1,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xadba,0xd850,
0xef55,0xadbb,0xffff,0xffff,0xe4d2,0xe4d1,0xec60,0xffff,
0xffff,0xef57,0xffff,0xef56,0xffff,0xc34c,0xf3b2,0xf3b3,
0xc4c9,0xffff,0xffff,0xf9b2,0xb0a8,0xb6bf,0xb6be,0xe0e4,
0xe0e6,0xb9a4,0xe0e5,0xb9a3,0xb9a5,0xe0e7,0xffff,0xffff,
0xffff,0xe4d4,0xe4d6,0xe4d5,0xffff,0xe4d8,0xffff,0xffff,
0xffff,0xbbe9,0xe4d7,0xe4d3,0xffff,0xffff,0xffff,0xe4d9,
0xffff,0xe8cc,0xffff,0xe8cf,0xe8d1,0xe8c7,0xe8cb,0xe8c8,
0xbe6e,0xbe71,0xbe73,0xe8c9,0xe8ca,0xbe72,0xe8cd,0xe8d0,
0xe8ce,0xbe74,0xffff,0xbe70,0xe8c6,0xbe6d,0xffff,0xbe6f,
0xffff,0xffff,0xc063,0xec66,0xec64,0xec63,0xffff,0xec69,
0xffff,0xec68,0xec67,0xffff,0xec62,0xc062,0xec61,0xffff,
0xec65,0xc064,0xffff,0xffff,0xef5a,0xffff,0xef5e,0xef5b,
0xef5d,0xef5c,0xef59,0xef5f,0xef62,0xef60,0xef61,0xc240,
0xffff,0xc1fe,0xef58,0xef63,0xf1b3,0xf1b6,0xf1b8,0xf1b7,
0xffff,0xf1b1,0xf1b5,0xf1b0,0xffff,0xf1b2,0xc34d,0xf1af,
0xffff,0xf1b4,0xffff,0xffff,0xf3c0,0xf3b5,0xc445,0xffff,
0xffff,0xc446,0xf3b4,0xf3b9,0xf3bf,0xf3b7,0xf3be,0xffff,
0xf3bb,0xffff,0xf3ba,0xf3bd,0xf3b8,0xf3b6,0xffff,0xf3bc,
0xffff,0xf560,0xf55e,0xc4ca,0xf55d,0xf563,0xf561,0xffff,
0xc4cb,0xf55c,0xf55a,0xffff,0xf55b,0xc4cd,0xf55f,0xc4cc,
0xf562,0xf678,0xf67e,0xffff,0xffff,0xf679,0xc55b,0xf6a1,
0xc55a,0xf67d,0xf67c,0xc559,0xf67b,0xc558,0xf67a,0xffff,
0xf77d,0xf7a1,0xf77e,0xffff,0xf77b,0xc5bb,0xf778,0xf77c,
0xf7a3,0xffff,0xf7a2,0xf779,0xf77a,0xc5ba,0xf852,0xc5e7,
0xffff,0xf853,0xc5e5,0xc5e6,0xffff,0xffff,0xf8d3,0xc64a,
0xf976,0xffff,0xc66a,0xffff,0xf9b3,0xc66b,0xf9b4,0xf9b5,
0xf9c3,0xf9c2,0xc67a,0xf9cd,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xb0a9,0xffff,0xffff,0xe0e9,0xffff,0xe0e8,0xffff,0xbbea,
0xbbeb,0xe4da,0xffff,0xe8d2,0xec6c,0xffff,0xffff,0xbe75,
0xc065,0xec6a,0xffff,0xec6d,0xc066,0xffff,0xef64,0xec6b,
0xf1b9,0xc34e,0xf3c1,0xffff,0xffff,0xffff,0xf566,0xf564,
0xffff,0xffff,0xf565,0xffff,0xffff,0xf6a2,0xffff,0xc55c,
0xf7a4,0xc5ea,0xc5bc,0xc5e8,0xc5e9,0xf8d4,0xc662,0xffff,
0xb0aa,0xffff,0xffff,0xffff,0xf1ba,0xffff,0xffff,0xd449,
0xffff,0xb9a6,0xffff,0xe4db,0xffff,0xffff,0xbbec,0xe4dc,
0xffff,0xffff,0xffff,0xe8d4,0xe8d3,0xc068,0xbe76,0xbe77,
0xffff,0xe8d7,0xe8d6,0xe8d5,0xffff,0xffff,0xec6e,0xec71,
0xffff,0xec70,0xec6f,0xc067,0xef68,0xef66,0xef65,0xffff,
0xffff,0xef67,0xffff,0xc34f,0xf1bc,0xf1bd,0xc350,0xffff,
0xf1bb,0xffff,0xf3c3,0xf3c2,0xf3c5,0xc447,0xf3c4,0xffff,
0xf567,0xf569,0xf568,0xffff,0xffff,0xf6a3,0xf6a6,0xf6a4,
0xf6a5,0xf7a5,0xc5bd,0xffff,0xffff,0xffff,0xf854,0xf855,
0xf856,0xffff,0xc64b,0xc663,0xf9b6,0xb0ab,0xffff,0xbe78,
0xc069,0xf1be,0xffff,0xf7a6,0xffff,0xffff,0xf9c4,0xd44a,
0xffff,0xc67b,0xb0ac,0xec72,0xffff,0xf1bf,0xffff,0xf3c6,
0xffff,0xffff,0xf6a7,0xf7a7,0xb0ad,0xffff,0xe4dd,0xe4de,
0xffff,0xbbed,0xbbee,0xe8d9,0xbe7a,0xbe79,0xe8d8,0xffff,
0xef69,0xffff,0xf1c0,0xf1c2,0xf1c1,0xc353,0xc352,0xc351,
0xffff,0xc55e,0xf6a8,0xffff,0xc55d,0xf7a9,0xf7a8,0xffff,
0xc64c,0xf8d5,0xb3bd,0xe0ea,0xffff,0xffff,0xffff,0xe4e1,
0xe4df,0xe4e0,0xffff,0xffff,0xe8e2,0xffff,0xe8dd,0xe8da,
0xe8e1,0xffff,0xffff,0xffff,0xe8e3,0xffff,0xffff,0xbe7c,
0xe8e0,0xe8dc,0xffff,0xffff,0xe8db,0xe8df,0xe8de,0xbe7b,
0xffff,0xffff,0xec7d,0xec78,0xec76,0xeca1,0xec77,0xffff,
0xec73,0xffff,0xec79,0xffff,0xffff,0xec74,0xef72,0xec75,
0xeca2,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xec7c,0xc06a,0xec7b,0xec7a,0xffff,0xec7e,0xffff,0xffff,
0xffff,0xffff,0xef6a,0xef6d,0xffff,0xffff,0xef6c,0xffff,
0xef74,0xef6f,0xef73,0xffff,0xef71,0xef70,0xef6e,0xffff,
0xef6b,0xffff,0xc243,0xc242,0xffff,0xc244,0xc241,0xef75,
0xffff,0xffff,0xffff,0xffff,0xffff,0xf1c8,0xf1cb,0xffff,
0xf1c9,0xf1cd,0xffff,0xffff,0xffff,0xf1ce,0xffff,0xf1c6,
0xc358,0xf1c7,0xffff,0xf1c5,0xf1cc,0xffff,0xf1c4,0xf1c3,
0xc357,0xc355,0xc354,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xf1ca,0xf3cf,0xf3d5,0xc44a,0xf3d0,
0xffff,0xf3d3,0xf3d7,0xc44b,0xf3d2,0xffff,0xf3ca,0xffff,
0xf3c9,0xf3d6,0xf3cd,0xffff,0xf3cb,0xf3d4,0xf3cc,0xc449,
0xc448,0xffff,0xf3c7,0xf3c8,0xf3d1,0xffff,0xffff,0xffff,
0xf3ce,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xf56c,
0xf56f,0xffff,0xffff,0xffff,0xffff,0xc356,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xf56d,0xf573,0xf571,
0xf56b,0xf576,0xffff,0xf56a,0xffff,0xc4cf,0xf572,0xffff,
0xffff,0xffff,0xf56e,0xc4ce,0xf575,0xffff,0xffff,0xf574,
0xffff,0xffff,0xffff,0xffff,0xf6ab,0xf6aa,0xffff,0xffff,
0xffff,0xf6b1,0xffff,0xf6ad,0xf6b0,0xc560,0xffff,0xffff,
0xf6ae,0xf6af,0xffff,0xf6a9,0xf6ac,0xc55f,0xffff,0xffff,
0xffff,0xc5bf,0xf7b4,0xf7af,0xf7b3,0xffff,0xf7b6,0xf7b2,
0xffff,0xf7ae,0xffff,0xc5c1,0xf7b1,0xf7b5,0xc5c0,0xf7ac,
0xf570,0xf7b0,0xffff,0xffff,0xf7ad,0xffff,0xf7aa,0xffff,
0xf7ab,0xc5be,0xf85a,0xf85c,0xf85f,0xf85b,0xf860,0xffff,
0xf859,0xffff,0xf857,0xffff,0xc5eb,0xf85d,0xc5ed,0xc5ec,
0xf858,0xf85e,0xffff,0xffff,0xffff,0xffff,0xf8da,0xc64d,
0xf8db,0xffff,0xf8d9,0xf8d6,0xffff,0xffff,0xf8d8,0xf8d7,
0xf95a,0xffff,0xffff,0xffff,0xffff,0xf95c,0xf95b,0xffff,
0xffff,0xf979,0xffff,0xf978,0xf977,0xf97a,0xffff,0xc673,
0xc674,0xf9ca,0xf9ce,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xb3be,0xdcaf,0xe0ed,
0xffff,0xb9a7,0xe0eb,0xffff,0xffff,0xe0ec,0xffff,0xffff,
0xffff,0xe4e2,0xe4e3,0xbbf1,0xbbef,0xe4e4,0xbbf0,0xe8e8,
0xffff,0xe8eb,0xe8e5,0xe8ec,0xe8e4,0xe8e6,0xffff,0xe8e7,
0xe8ea,0xffff,0xffff,0xbea1,0xe8ef,0xe8ee,0xbe7d,0xe8e9,
0xe8ed,0xbe7e,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xecac,0xffff,0xc06f,0xffff,0xeca7,0xc06b,0xffff,0xeca4,
0xecaa,0xecad,0xffff,0xc070,0xffff,0xeca9,0xeca6,0xecae,
0xeca5,0xffff,0xecab,0xc06c,0xffff,0xeca3,0xc06d,0xffff,
0xc06e,0xeca8,0xffff,0xffff,0xffff,0xefa9,0xef7a,0xef7b,
0xef7e,0xef7c,0xffff,0xef76,0xffff,0xffff,0xef79,0xefa5,
0xef7d,0xffff,0xffff,0xc245,0xffff,0xefa7,0xefa4,0xc246,
0xefa6,0xef77,0xefa2,0xefa3,0xffff,0xefa1,0xffff,0xffff,
0xffff,0xffff,0xf1d2,0xf1d4,0xf1d7,0xffff,0xffff,0xf1d1,
0xffff,0xc359,0xf1d9,0xf1d0,0xf1da,0xffff,0xf1d6,0xf1d8,
0xf1dc,0xf1d5,0xf1dd,0xf1d3,0xf1cf,0xc35a,0xffff,0xf1db,
0xc35b,0xc44d,0xffff,0xffff,0xffff,0xffff,0xffff,0xef78,
0xf3f1,0xf3e8,0xc44f,0xf3e4,0xc450,0xffff,0xffff,0xf3ed,
0xf3e7,0xf3dd,0xc44e,0xf3ea,0xf3e5,0xf3e6,0xffff,0xf3d8,
0xf3df,0xf3ee,0xffff,0xf3eb,0xffff,0xf3e3,0xffff,0xf3ef,
0xf3de,0xf3d9,0xf3ec,0xffff,0xf3db,0xf3e9,0xf3e0,0xf3f0,
0xf3dc,0xc44c,0xf3da,0xf3e1,0xf3e2,0xffff,0xffff,0xffff,
0xf57d,0xffff,0xf57b,0xffff,0xf5a2,0xffff,0xf5ae,0xf5a5,
0xf57c,0xf578,0xf5a7,0xf57e,0xf5a3,0xf57a,0xf5aa,0xf577,
0xf5a1,0xf5a6,0xf5a8,0xf5ab,0xf579,0xffff,0xf5af,0xf5b0,
0xf5a9,0xf5ad,0xf5a4,0xffff,0xf6c1,0xf6c4,0xffff,0xc561,
0xffff,0xf6c3,0xf6c8,0xf6c6,0xc562,0xf6bd,0xf6b3,0xf6b2,
0xc564,0xf6bf,0xf6c0,0xf6bc,0xf6b4,0xffff,0xf6b9,0xf5ac,
0xffff,0xf6b5,0xc563,0xf6bb,0xffff,0xf6ba,0xffff,0xf6b6,
0xf6c2,0xffff,0xf6b7,0xf7bb,0xf6c5,0xf6c7,0xf6be,0xf6b8,
0xf7bc,0xf7be,0xf7b8,0xc5c2,0xffff,0xf7c5,0xf7c3,0xc5c3,
0xf7c2,0xf7c1,0xf7ba,0xf7b7,0xf7bd,0xf7c6,0xf7b9,0xf7bf,
0xffff,0xf869,0xf86e,0xf864,0xf867,0xc5ee,0xf86b,0xffff,
0xf872,0xf7c0,0xffff,0xf865,0xf86f,0xf873,0xf86a,0xf863,
0xf86d,0xffff,0xf86c,0xf871,0xf870,0xf7c4,0xf868,0xf862,
0xf866,0xc64e,0xc64f,0xf861,0xffff,0xf8e6,0xf8dd,0xf8e5,
0xf8e2,0xf8e3,0xf8dc,0xf8df,0xf8e7,0xf8e1,0xf8e0,0xf8de,
0xffff,0xf8e4,0xffff,0xf95d,0xffff,0xf95e,0xffff,0xf960,
0xf95f,0xf962,0xf961,0xf97c,0xf97b,0xf9b7,0xffff,0xf9b8,
0xffff,0xf9c5,0xc678,0xc67c,0xffff,0xf9cf,0xc67d,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xb3bf,0xffff,0xffff,
0xffff,0xc4d0,0xf6c9,0xffff,0xc650,0xc651,0xffff,0xb3c0,
0xe0ee,0xffff,0xb9a8,0xe8f0,0xffff,0xffff,0xecb0,0xecb1,
0xecaf,0xefab,0xefaa,0xc247,0xf1df,0xefac,0xf1de,0xffff,
0xffff,0xf3f3,0xc451,0xc453,0xf3f2,0xffff,0xffff,0xc452,
0xffff,0xf5b1,0xf5b3,0xf5b2,0xf6ca,0xc565,0xffff,0xc5ef,
0xf8e8,0xf963,0xffff,0xffff,0xf9d2,0xb3c1,0xffff,0xe4e5,
0xffff,0xbea2,0xffff,0xffff,0xffff,0xecb3,0xecb2,0xffff,
0xefad,0xffff,0xffff,0xffff,0xc454,0xc4d1,0xf7c7,0xf9cb,
0xffff,0xffff,0xffff,0xb3c2,0xbbf2,0xffff,0xbea3,0xffff,
0xf3f4,0xffff,0xf874,0xb6c0,0xffff,0xffff,0xffff,0xffff,
0xefae,0xffff,0xffff,0xffff,0xc664,0xb6c1,0xbea4,0xc248,
0xf875,0xb6c2,0xffff,0xe8f1,0xc072,0xecb4,0xecb5,0xffff,
0xc071,0xffff,0xefaf,0xc24c,0xc24a,0xc24b,0xc249,0xf1e0,
0xc35c,0xffff,0xffff,0xffff,0xf5b5,0xf5b4,0xf5b7,0xf5b6,
0xc4d2,0xffff,0xffff,0xf6cb,0xffff,0xf6cd,0xf6cc,0xc566,
0xf7c8,0xffff,0xf876,0xf877,0xc5f0,0xf964,0xf97d,0xc675,
0xffff,0xdcb0,0xecb6,0xefb0,0xf3f5,0xe0ef,0xffff,0xefb1,
0xf1e2,0xf1e1,0xffff,0xffff,0xffff,0xffff,0xf878,0xc652,
0xffff,0xf965,0xf97e,0xffff,0xffff,0xffff,0xb9a9,0xe8f2,
0xe8f3,0xffff,0xecb7,0xb9aa,0xffff,0xc35d,0xf1e3,0xffff,
0xf6cf,0xc567,0xf6d0,0xf6ce,0xf879,0xffff,0xf8e9,0xffff,
0xb9ab,0xffff,0xefb4,0xefb3,0xefb2,0xf1e4,0xffff,0xffff,
0xf1e8,0xf1e7,0xf1e6,0xf1e5,0xc35e,0xf3f6,0xf5b9,0xc4d3,
0xf5b8,0xf6d1,0xf7cb,0xf7ca,0xc5c4,0xf7c9,0xf87c,0xf87b,
0xf87a,0xffff,0xffff,0xbbf3,0xffff,0xecb8,0xc24d,0xffff,
0xf3f7,0xf3f8,0xf7cc,0xf87d,0xffff,0xffff,0xf8ea,0xf966,
0xf9b9,0xf9d4,0xbbf4,0xc24e,0xf1e9,0xf3f9,0xf6d2,0xf87e,
0xffff,0xffff,0xbea6,0xffff,0xefb5,0xf1ea,0xf3fa,0xf3fb,
0xf3fc,0xf5be,0xffff,0xf5ba,0xc568,0xf5bd,0xf5bc,0xc4d4,
0xf5bb,0xc4d6,0xffff,0xc4d5,0xf6d4,0xf6d3,0xc569,0xc56a,
0xffff,0xffff,0xc5c6,0xf7cd,0xc5c5,0xffff,0xf8a3,0xf8a4,
0xf8a2,0xf8a1,0xc654,0xffff,0xf8eb,0xf8ec,0xf8ed,0xc653,
0xf967,0xf96a,0xf969,0xf968,0xffff,0xffff,0xf9d3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xc073,0xffff,0xffff,
0xc365,0xf5bf,0xf6d5,0xffff,0xc5c7,0xf7ce,0xffff,0xffff,
0xf9d5,0xffff,0xffff,0xffff,0xc074,0xffff,0xffff,0xffff,
0xefb6,0xffff,0xf7cf,0xffff,0xf9a1,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xc94a,0xddfc,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa14a,0xa157,0xffff,0xa159,0xa15b,0xa15f,0xa160,0xa163,
0xa164,0xa167,0xa168,0xa16b,0xa16c,0xa16f,0xa170,0xa173,
0xa174,0xa177,0xa178,0xa17b,0xa17c,0xffff,0xffff,0xffff,
0xffff,0xa1c6,0xa1c7,0xa1ca,0xa1cb,0xa1c8,0xa1c9,0xa15c,
0xa14d,0xa14e,0xa14f,0xffff,0xa151,0xa152,0xa153,0xa154,
0xffff,0xa17d,0xa17e,0xa1a1,0xa1a2,0xa1a3,0xa1a4,0xa1cc,
0xa1cd,0xa1ce,0xa1de,0xa1df,0xa1e0,0xa1e1,0xa1e2,0xffff,
0xa242,0xa24c,0xa24d,0xa24e,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xa149,0xffff,0xa1ad,0xa243,0xa248,0xa1ae,0xffff,
0xa15d,0xa15e,0xa1af,0xa1cf,0xa141,0xa1d0,0xa144,0xa1fe,
0xa2af,0xa2b0,0xa2b1,0xa2b2,0xa2b3,0xa2b4,0xa2b5,0xa2b6,
0xa2b7,0xa2b8,0xa147,0xa146,0xa1d5,0xa1d7,0xa1d6,0xa148,
0xa249,0xa2cf,0xa2d0,0xa2d1,0xa2d2,0xa2d3,0xa2d4,0xa2d5,
0xa2d6,0xa2d7,0xa2d8,0xa2d9,0xa2da,0xa2db,0xa2dc,0xa2dd,
0xa2de,0xa2df,0xa2e0,0xa2e1,0xa2e2,0xa2e3,0xa2e4,0xa2e5,
0xa2e6,0xa2e7,0xa2e8,0xffff,0xa240,0xffff,0xffff,0xa1c4,
0xffff,0xa2e9,0xa2ea,0xa2eb,0xa2ec,0xa2ed,0xa2ee,0xa2ef,
0xa2f0,0xa2f1,0xa2f2,0xa2f3,0xa2f4,0xa2f5,0xa2f6,0xa2f7,
0xa2f8,0xa2f9,0xa2fa,0xa2fb,0xa2fc,0xa2fd,0xa2fe,0xa340,
0xa341,0xa342,0xa343,0xa161,0xa155,0xa162,0xa1e3,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xa246,0xa247,0xffff,0xa1c3,0xffff,0xa244,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff
};
#endif /* USE_OUR_MB_WC_DATA_TABLES */
